#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 4326
#define LARGE_STATE_COUNT 1527
#define SYMBOL_COUNT 190
#define ALIAS_COUNT 1
#define TOKEN_COUNT 89
#define EXTERNAL_TOKEN_COUNT 10
#define FIELD_COUNT 7
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 29

enum {
  sym_identifier = 1,
  anon_sym_function = 2,
  anon_sym_end = 3,
  anon_sym_abstract = 4,
  anon_sym_type = 5,
  anon_sym_primitive = 6,
  aux_sym_primitive_definition_token1 = 7,
  anon_sym_mutable = 8,
  anon_sym_struct = 9,
  anon_sym_module = 10,
  anon_sym_macro = 11,
  anon_sym_LPAREN = 12,
  anon_sym_COMMA = 13,
  anon_sym_RPAREN = 14,
  anon_sym_SEMI = 15,
  anon_sym_EQ = 16,
  anon_sym_DOT_DOT_DOT = 17,
  anon_sym_COLON_COLON = 18,
  anon_sym_LBRACE = 19,
  anon_sym_RBRACE = 20,
  anon_sym_LT_COLON = 21,
  anon_sym_if = 22,
  anon_sym_elseif = 23,
  anon_sym_else = 24,
  anon_sym_try = 25,
  anon_sym_catch = 26,
  anon_sym_finally = 27,
  anon_sym_for = 28,
  anon_sym_while = 29,
  sym_break_statement = 30,
  sym_continue_statement = 31,
  anon_sym_return = 32,
  anon_sym_let = 33,
  anon_sym_const = 34,
  anon_sym_quote = 35,
  anon_sym_using = 36,
  anon_sym_import = 37,
  anon_sym_COLON = 38,
  anon_sym_DOT = 39,
  anon_sym_export = 40,
  anon_sym_COLON2 = 41,
  anon_sym_LBRACK = 42,
  anon_sym_RBRACK = 43,
  anon_sym_begin = 44,
  anon_sym_do = 45,
  anon_sym_SQUOTE = 46,
  anon_sym_PLUS = 47,
  anon_sym_LT_PIPE = 48,
  anon_sym_PIPE_GT = 49,
  anon_sym_in = 50,
  anon_sym_isa = 51,
  anon_sym_PIPE_PIPE = 52,
  anon_sym_AMP_AMP = 53,
  anon_sym_QMARK = 54,
  anon_sym_EQ_GT = 55,
  anon_sym_LBRACK2 = 56,
  anon_sym_ = 57,
  anon_sym_DASH_GT = 58,
  anon_sym_DOLLAR = 59,
  anon_sym_AT = 60,
  aux_sym_integer_literal_token1 = 61,
  aux_sym_integer_literal_token2 = 62,
  aux_sym_integer_literal_token3 = 63,
  sym_float_literal = 64,
  sym_escape_sequence = 65,
  aux_sym_character_literal_token1 = 66,
  sym__unary_operator = 67,
  sym__power_operator = 68,
  sym__bitshift_operator = 69,
  sym__rational_operator = 70,
  sym__times_operator = 71,
  sym__plus_operator = 72,
  sym__dotty_operator = 73,
  sym__comparison_operator = 74,
  sym__arrow_operator = 75,
  sym__assign_operator = 76,
  anon_sym_LF = 77,
  sym_line_comment = 78,
  sym_block_comment = 79,
  sym__immediate_paren = 80,
  sym__string_start = 81,
  sym__command_start = 82,
  sym__immediate_string_start = 83,
  sym__immediate_command_start = 84,
  sym__string_end = 85,
  sym__command_end = 86,
  sym__string_content = 87,
  sym__string_content_no_interp = 88,
  sym_source_file = 89,
  sym__expression_list = 90,
  sym_function_definition = 91,
  sym_abstract_definition = 92,
  sym_primitive_definition = 93,
  sym_struct_definition = 94,
  sym_module_definition = 95,
  sym_macro_definition = 96,
  sym_parameter_list = 97,
  sym_keyword_parameters = 98,
  sym_optional_parameter = 99,
  sym_spread_parameter = 100,
  sym_typed_parameter = 101,
  sym_type_parameter_list = 102,
  sym_constrained_parameter = 103,
  sym_subtype_clause = 104,
  sym_if_statement = 105,
  sym_elseif_clause = 106,
  sym_else_clause = 107,
  sym_try_statement = 108,
  sym_catch_clause = 109,
  sym_finally_clause = 110,
  sym_for_statement = 111,
  sym_while_statement = 112,
  sym_return_statement = 113,
  sym_let_statement = 114,
  sym_const_statement = 115,
  sym_variable_declaration = 116,
  sym_quote_statement = 117,
  sym_import_statement = 118,
  sym_selected_import = 119,
  sym_scoped_identifier = 120,
  sym_export_statement = 121,
  sym__expression = 122,
  sym__primary_expression = 123,
  sym_bare_tuple_expression = 124,
  sym_operator = 125,
  sym_parenthesized_expression = 126,
  sym_field_expression = 127,
  sym_subscript_expression = 128,
  sym_typed_expression = 129,
  sym_parameterized_identifier = 130,
  sym_type_argument_list = 131,
  sym_compound_expression = 132,
  sym_call_expression = 133,
  sym_broadcast_call_expression = 134,
  sym_macro_expression = 135,
  sym_macro_argument_list = 136,
  sym_argument_list = 137,
  sym_do_clause = 138,
  sym_named_field = 139,
  sym_spread_expression = 140,
  sym_assignment_expression = 141,
  sym_unary_expression = 142,
  sym_binary_expression = 143,
  sym_ternary_expression = 144,
  sym_pair_expression = 145,
  sym_tuple_expression = 146,
  sym_array_expression = 147,
  sym_matrix_expression = 148,
  sym_matrix_row = 149,
  sym_generator_expression = 150,
  sym_array_comprehension_expression = 151,
  sym__comprehension_clause = 152,
  sym_if_clause = 153,
  sym_for_clause = 154,
  sym_for_binding = 155,
  sym_function_expression = 156,
  sym_range_expression = 157,
  sym_coefficient_expression = 158,
  sym_quote_expression = 159,
  sym_interpolation_expression = 160,
  sym_macro_identifier = 161,
  sym__literal = 162,
  sym_integer_literal = 163,
  sym_character_literal = 164,
  sym_string_literal = 165,
  sym_command_literal = 166,
  sym_prefixed_string_literal = 167,
  sym_prefixed_command_literal = 168,
  sym_string_interpolation = 169,
  aux_sym__expression_list_repeat1 = 170,
  aux_sym_parameter_list_repeat1 = 171,
  aux_sym_type_parameter_list_repeat1 = 172,
  aux_sym_if_statement_repeat1 = 173,
  aux_sym_for_statement_repeat1 = 174,
  aux_sym_let_statement_repeat1 = 175,
  aux_sym_import_statement_repeat1 = 176,
  aux_sym_selected_import_repeat1 = 177,
  aux_sym_export_statement_repeat1 = 178,
  aux_sym_bare_tuple_expression_repeat1 = 179,
  aux_sym_subscript_expression_repeat1 = 180,
  aux_sym_type_argument_list_repeat1 = 181,
  aux_sym_macro_argument_list_repeat1 = 182,
  aux_sym_argument_list_repeat1 = 183,
  aux_sym_argument_list_repeat2 = 184,
  aux_sym_tuple_expression_repeat1 = 185,
  aux_sym_matrix_expression_repeat1 = 186,
  aux_sym__comprehension_clause_repeat1 = 187,
  aux_sym_string_literal_repeat1 = 188,
  aux_sym_prefixed_string_literal_repeat1 = 189,
  alias_sym_named_argument = 190,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_function] = "function",
  [anon_sym_end] = "end",
  [anon_sym_abstract] = "abstract",
  [anon_sym_type] = "type",
  [anon_sym_primitive] = "primitive",
  [aux_sym_primitive_definition_token1] = "primitive_definition_token1",
  [anon_sym_mutable] = "mutable",
  [anon_sym_struct] = "struct",
  [anon_sym_module] = "module",
  [anon_sym_macro] = "macro",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LT_COLON] = "<:",
  [anon_sym_if] = "if",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_for] = "for",
  [anon_sym_while] = "while",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_return] = "return",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_quote] = "quote",
  [anon_sym_using] = "using",
  [anon_sym_import] = "import",
  [anon_sym_COLON] = ":",
  [anon_sym_DOT] = ".",
  [anon_sym_export] = "export",
  [anon_sym_COLON2] = ":",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_begin] = "begin",
  [anon_sym_do] = "do",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_PLUS] = "operator",
  [anon_sym_LT_PIPE] = "operator",
  [anon_sym_PIPE_GT] = "operator",
  [anon_sym_in] = "in",
  [anon_sym_isa] = "operator",
  [anon_sym_PIPE_PIPE] = "operator",
  [anon_sym_AMP_AMP] = "operator",
  [anon_sym_QMARK] = "\?",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_] = "∈",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_AT] = "@",
  [aux_sym_integer_literal_token1] = "integer_literal_token1",
  [aux_sym_integer_literal_token2] = "integer_literal_token2",
  [aux_sym_integer_literal_token3] = "integer_literal_token3",
  [sym_float_literal] = "float_literal",
  [sym_escape_sequence] = "escape_sequence",
  [aux_sym_character_literal_token1] = "character_literal_token1",
  [sym__unary_operator] = "_unary_operator",
  [sym__power_operator] = "_power_operator",
  [sym__bitshift_operator] = "_bitshift_operator",
  [sym__rational_operator] = "_rational_operator",
  [sym__times_operator] = "_times_operator",
  [sym__plus_operator] = "_plus_operator",
  [sym__dotty_operator] = "_dotty_operator",
  [sym__comparison_operator] = "_comparison_operator",
  [sym__arrow_operator] = "operator",
  [sym__assign_operator] = "operator",
  [anon_sym_LF] = "\n",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym__immediate_paren] = "_immediate_paren",
  [sym__string_start] = "_string_start",
  [sym__command_start] = "_command_start",
  [sym__immediate_string_start] = "_immediate_string_start",
  [sym__immediate_command_start] = "_immediate_command_start",
  [sym__string_end] = "_string_end",
  [sym__command_end] = "_command_end",
  [sym__string_content] = "_string_content",
  [sym__string_content_no_interp] = "_string_content_no_interp",
  [sym_source_file] = "source_file",
  [sym__expression_list] = "_expression_list",
  [sym_function_definition] = "function_definition",
  [sym_abstract_definition] = "abstract_definition",
  [sym_primitive_definition] = "primitive_definition",
  [sym_struct_definition] = "struct_definition",
  [sym_module_definition] = "module_definition",
  [sym_macro_definition] = "macro_definition",
  [sym_parameter_list] = "parameter_list",
  [sym_keyword_parameters] = "keyword_parameters",
  [sym_optional_parameter] = "optional_parameter",
  [sym_spread_parameter] = "spread_parameter",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_constrained_parameter] = "constrained_parameter",
  [sym_subtype_clause] = "subtype_clause",
  [sym_if_statement] = "if_statement",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_return_statement] = "return_statement",
  [sym_let_statement] = "let_statement",
  [sym_const_statement] = "const_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_quote_statement] = "quote_statement",
  [sym_import_statement] = "import_statement",
  [sym_selected_import] = "selected_import",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_export_statement] = "export_statement",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_bare_tuple_expression] = "bare_tuple_expression",
  [sym_operator] = "operator",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_field_expression] = "field_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_typed_expression] = "typed_expression",
  [sym_parameterized_identifier] = "parameterized_identifier",
  [sym_type_argument_list] = "type_argument_list",
  [sym_compound_expression] = "compound_expression",
  [sym_call_expression] = "call_expression",
  [sym_broadcast_call_expression] = "broadcast_call_expression",
  [sym_macro_expression] = "macro_expression",
  [sym_macro_argument_list] = "macro_argument_list",
  [sym_argument_list] = "argument_list",
  [sym_do_clause] = "do_clause",
  [sym_named_field] = "named_field",
  [sym_spread_expression] = "spread_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_pair_expression] = "pair_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_array_expression] = "array_expression",
  [sym_matrix_expression] = "matrix_expression",
  [sym_matrix_row] = "matrix_row",
  [sym_generator_expression] = "generator_expression",
  [sym_array_comprehension_expression] = "array_comprehension_expression",
  [sym__comprehension_clause] = "_comprehension_clause",
  [sym_if_clause] = "if_clause",
  [sym_for_clause] = "for_clause",
  [sym_for_binding] = "for_binding",
  [sym_function_expression] = "function_expression",
  [sym_range_expression] = "range_expression",
  [sym_coefficient_expression] = "coefficient_expression",
  [sym_quote_expression] = "quote_expression",
  [sym_interpolation_expression] = "interpolation_expression",
  [sym_macro_identifier] = "macro_identifier",
  [sym__literal] = "_literal",
  [sym_integer_literal] = "integer_literal",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_command_literal] = "command_literal",
  [sym_prefixed_string_literal] = "prefixed_string_literal",
  [sym_prefixed_command_literal] = "prefixed_command_literal",
  [sym_string_interpolation] = "string_interpolation",
  [aux_sym__expression_list_repeat1] = "_expression_list_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_let_statement_repeat1] = "let_statement_repeat1",
  [aux_sym_import_statement_repeat1] = "import_statement_repeat1",
  [aux_sym_selected_import_repeat1] = "selected_import_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_bare_tuple_expression_repeat1] = "bare_tuple_expression_repeat1",
  [aux_sym_subscript_expression_repeat1] = "subscript_expression_repeat1",
  [aux_sym_type_argument_list_repeat1] = "type_argument_list_repeat1",
  [aux_sym_macro_argument_list_repeat1] = "macro_argument_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_argument_list_repeat2] = "argument_list_repeat2",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_matrix_expression_repeat1] = "matrix_expression_repeat1",
  [aux_sym__comprehension_clause_repeat1] = "_comprehension_clause_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_prefixed_string_literal_repeat1] = "prefixed_string_literal_repeat1",
  [alias_sym_named_argument] = "named_argument",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_primitive] = anon_sym_primitive,
  [aux_sym_primitive_definition_token1] = aux_sym_primitive_definition_token1,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_macro] = anon_sym_macro,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LT_COLON] = anon_sym_LT_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_while] = anon_sym_while,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_COLON2] = anon_sym_COLON,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_PLUS] = sym_operator,
  [anon_sym_LT_PIPE] = sym_operator,
  [anon_sym_PIPE_GT] = sym_operator,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_isa] = sym_operator,
  [anon_sym_PIPE_PIPE] = sym_operator,
  [anon_sym_AMP_AMP] = sym_operator,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LBRACK2] = anon_sym_LBRACK,
  [anon_sym_] = anon_sym_,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_AT] = anon_sym_AT,
  [aux_sym_integer_literal_token1] = aux_sym_integer_literal_token1,
  [aux_sym_integer_literal_token2] = aux_sym_integer_literal_token2,
  [aux_sym_integer_literal_token3] = aux_sym_integer_literal_token3,
  [sym_float_literal] = sym_float_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [aux_sym_character_literal_token1] = aux_sym_character_literal_token1,
  [sym__unary_operator] = sym__unary_operator,
  [sym__power_operator] = sym__power_operator,
  [sym__bitshift_operator] = sym__bitshift_operator,
  [sym__rational_operator] = sym__rational_operator,
  [sym__times_operator] = sym__times_operator,
  [sym__plus_operator] = sym__plus_operator,
  [sym__dotty_operator] = sym__dotty_operator,
  [sym__comparison_operator] = sym__comparison_operator,
  [sym__arrow_operator] = sym_operator,
  [sym__assign_operator] = sym_operator,
  [anon_sym_LF] = anon_sym_LF,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym__immediate_paren] = sym__immediate_paren,
  [sym__string_start] = sym__string_start,
  [sym__command_start] = sym__command_start,
  [sym__immediate_string_start] = sym__immediate_string_start,
  [sym__immediate_command_start] = sym__immediate_command_start,
  [sym__string_end] = sym__string_end,
  [sym__command_end] = sym__command_end,
  [sym__string_content] = sym__string_content,
  [sym__string_content_no_interp] = sym__string_content_no_interp,
  [sym_source_file] = sym_source_file,
  [sym__expression_list] = sym__expression_list,
  [sym_function_definition] = sym_function_definition,
  [sym_abstract_definition] = sym_abstract_definition,
  [sym_primitive_definition] = sym_primitive_definition,
  [sym_struct_definition] = sym_struct_definition,
  [sym_module_definition] = sym_module_definition,
  [sym_macro_definition] = sym_macro_definition,
  [sym_parameter_list] = sym_parameter_list,
  [sym_keyword_parameters] = sym_keyword_parameters,
  [sym_optional_parameter] = sym_optional_parameter,
  [sym_spread_parameter] = sym_spread_parameter,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_constrained_parameter] = sym_constrained_parameter,
  [sym_subtype_clause] = sym_subtype_clause,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_let_statement] = sym_let_statement,
  [sym_const_statement] = sym_const_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_quote_statement] = sym_quote_statement,
  [sym_import_statement] = sym_import_statement,
  [sym_selected_import] = sym_selected_import,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_export_statement] = sym_export_statement,
  [sym__expression] = sym__expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_bare_tuple_expression] = sym_bare_tuple_expression,
  [sym_operator] = sym_operator,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_typed_expression] = sym_typed_expression,
  [sym_parameterized_identifier] = sym_parameterized_identifier,
  [sym_type_argument_list] = sym_type_argument_list,
  [sym_compound_expression] = sym_compound_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_broadcast_call_expression] = sym_broadcast_call_expression,
  [sym_macro_expression] = sym_macro_expression,
  [sym_macro_argument_list] = sym_macro_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_do_clause] = sym_do_clause,
  [sym_named_field] = sym_named_field,
  [sym_spread_expression] = sym_spread_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_pair_expression] = sym_pair_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_array_expression] = sym_array_expression,
  [sym_matrix_expression] = sym_matrix_expression,
  [sym_matrix_row] = sym_matrix_row,
  [sym_generator_expression] = sym_generator_expression,
  [sym_array_comprehension_expression] = sym_array_comprehension_expression,
  [sym__comprehension_clause] = sym__comprehension_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_for_clause] = sym_for_clause,
  [sym_for_binding] = sym_for_binding,
  [sym_function_expression] = sym_function_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_coefficient_expression] = sym_coefficient_expression,
  [sym_quote_expression] = sym_quote_expression,
  [sym_interpolation_expression] = sym_interpolation_expression,
  [sym_macro_identifier] = sym_macro_identifier,
  [sym__literal] = sym__literal,
  [sym_integer_literal] = sym_integer_literal,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_command_literal] = sym_command_literal,
  [sym_prefixed_string_literal] = sym_prefixed_string_literal,
  [sym_prefixed_command_literal] = sym_prefixed_command_literal,
  [sym_string_interpolation] = sym_string_interpolation,
  [aux_sym__expression_list_repeat1] = aux_sym__expression_list_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_let_statement_repeat1] = aux_sym_let_statement_repeat1,
  [aux_sym_import_statement_repeat1] = aux_sym_import_statement_repeat1,
  [aux_sym_selected_import_repeat1] = aux_sym_selected_import_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_bare_tuple_expression_repeat1] = aux_sym_bare_tuple_expression_repeat1,
  [aux_sym_subscript_expression_repeat1] = aux_sym_subscript_expression_repeat1,
  [aux_sym_type_argument_list_repeat1] = aux_sym_type_argument_list_repeat1,
  [aux_sym_macro_argument_list_repeat1] = aux_sym_macro_argument_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_argument_list_repeat2] = aux_sym_argument_list_repeat2,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_matrix_expression_repeat1] = aux_sym_matrix_expression_repeat1,
  [aux_sym__comprehension_clause_repeat1] = aux_sym__comprehension_clause_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_prefixed_string_literal_repeat1] = aux_sym_prefixed_string_literal_repeat1,
  [alias_sym_named_argument] = alias_sym_named_argument,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_primitive] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_primitive_definition_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_PIPE] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_GT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isa] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_integer_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_character_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__unary_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__power_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__bitshift_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__rational_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__times_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__plus_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__dotty_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__comparison_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__assign_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = false,
    .named = true,
  },
  [sym__command_start] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_string_start] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_command_start] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = false,
    .named = true,
  },
  [sym__command_end] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content_no_interp] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_list] = {
    .visible = false,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_module_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_subtype_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_let_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_const_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_quote_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_selected_import] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_bare_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameterized_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_broadcast_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_do_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_named_field] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pair_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix_row] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_comprehension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_coefficient_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_quote_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_command_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_command_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_interpolation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_let_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_selected_import_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bare_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_matrix_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefixed_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_named_argument] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_condition = 2,
  field_name = 3,
  field_parameters = 4,
  field_prefix = 5,
  field_type_parameters = 6,
  field_value = 7,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_condition] = "condition",
  [field_name] = "name",
  [field_parameters] = "parameters",
  [field_prefix] = "prefix",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [4] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 2},
  [8] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 2},
  [10] = {.index = 8, .length = 2},
  [11] = {.index = 10, .length = 3},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 5, .length = 1},
  [14] = {.index = 15, .length = 2},
  [15] = {.index = 17, .length = 3},
  [17] = {.index = 20, .length = 2},
  [18] = {.index = 13, .length = 2},
  [19] = {.index = 5, .length = 1},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 24, .length = 3},
  [23] = {.index = 13, .length = 2},
  [24] = {.index = 27, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_condition, 1},
  [2] =
    {field_prefix, 0},
  [3] =
    {field_name, 1},
    {field_parameters, 2},
  [5] =
    {field_name, 2},
  [6] =
    {field_name, 1},
    {field_type_parameters, 2},
  [8] =
    {field_alternative, 2},
    {field_condition, 1},
  [10] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [13] =
    {field_name, 2},
    {field_type_parameters, 3},
  [15] =
    {field_alternative, 3},
    {field_condition, 1},
  [17] =
    {field_alternative, 2},
    {field_alternative, 3},
    {field_condition, 1},
  [20] =
    {field_name, 0},
    {field_value, 2},
  [22] =
    {field_alternative, 4},
    {field_condition, 1},
  [24] =
    {field_alternative, 3},
    {field_alternative, 4},
    {field_condition, 1},
  [27] =
    {field_alternative, 4},
    {field_alternative, 5},
    {field_condition, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_operator,
  },
  [2] = {
    [0] = sym_integer_literal,
  },
  [3] = {
    [1] = sym_operator,
  },
  [13] = {
    [3] = sym_integer_literal,
  },
  [16] = {
    [1] = alias_sym_named_argument,
  },
  [18] = {
    [4] = sym_integer_literal,
  },
  [19] = {
    [4] = sym_integer_literal,
  },
  [22] = {
    [2] = alias_sym_named_argument,
  },
  [23] = {
    [5] = sym_integer_literal,
  },
  [25] = {
    [3] = alias_sym_named_argument,
  },
  [26] = {
    [1] = alias_sym_named_argument,
    [3] = alias_sym_named_argument,
  },
  [27] = {
    [4] = alias_sym_named_argument,
  },
  [28] = {
    [1] = alias_sym_named_argument,
    [4] = alias_sym_named_argument,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_named_field, 2,
    sym_named_field,
    alias_sym_named_argument,
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6917
    ? (c < 3024
      ? (c < 2392
        ? (c < 1568
          ? (c < 895
            ? (c < 710
              ? (c < 181
                ? (c < 'a'
                  ? (c >= 'A' && c <= '_')
                  : (c <= 'z' || c == 170))
                : (c <= 181 || (c < 192
                  ? c == 186
                  : c <= 705)))
              : (c <= 721 || (c < 880
                ? (c < 748
                  ? (c >= 736 && c <= 740)
                  : (c <= 748 || c == 750))
                : (c <= 884 || (c < 890
                  ? (c >= 886 && c <= 887)
                  : c <= 893)))))
            : (c <= 895 || (c < 1162
              ? (c < 910
                ? (c < 904
                  ? c == 902
                  : (c <= 906 || c == 908))
                : (c <= 929 || (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)))
              : (c <= 1327 || (c < 1376
                ? (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)
                : (c <= 1416 || (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : c <= 1522)))))))
          : (c <= 1610 || (c < 2042
            ? (c < 1791
              ? (c < 1765
                ? (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : (c <= 1747 || c == 1749))
                : (c <= 1766 || (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : c <= 1788)))
              : (c <= 1791 || (c < 1969
                ? (c < 1810
                  ? c == 1808
                  : (c <= 1839 || (c >= 1869 && c <= 1957)))
                : (c <= 1969 || (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : c <= 2037)))))
            : (c <= 2042 || (c < 2160
              ? (c < 2088
                ? (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : (c <= 2074 || c == 2084))
                : (c <= 2088 || (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)))
              : (c <= 2183 || (c < 2308
                ? (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)
                : (c <= 2361 || (c < 2384
                  ? c == 2365
                  : c <= 2384)))))))))
        : (c <= 2401 || (c < 2730
          ? (c < 2565
            ? (c < 2486
              ? (c < 2451
                ? (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : (c <= 2444 || (c >= 2447 && c <= 2448)))
                : (c <= 2472 || (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : c <= 2482)))
              : (c <= 2489 || (c < 2527
                ? (c < 2510
                  ? c == 2493
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : c <= 2556)))))
            : (c <= 2570 || (c < 2649
              ? (c < 2610
                ? (c < 2579
                  ? (c >= 2575 && c <= 2576)
                  : (c <= 2600 || (c >= 2602 && c <= 2608)))
                : (c <= 2611 || (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)))
              : (c <= 2652 || (c < 2693
                ? (c < 2674
                  ? c == 2654
                  : c <= 2676)
                : (c <= 2701 || (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : c <= 2728)))))))
          : (c <= 2736 || (c < 2908
            ? (c < 2821
              ? (c < 2768
                ? (c < 2741
                  ? (c >= 2738 && c <= 2739)
                  : (c <= 2745 || c == 2749))
                : (c <= 2768 || (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : c <= 2809)))
              : (c <= 2828 || (c < 2866
                ? (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))
                : (c <= 2867 || (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : c <= 2877)))))
            : (c <= 2909 || (c < 2969
              ? (c < 2949
                ? (c < 2929
                  ? (c >= 2911 && c <= 2913)
                  : (c <= 2929 || c == 2947))
                : (c <= 2954 || (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)))
              : (c <= 2970 || (c < 2979
                ? (c < 2974
                  ? c == 2972
                  : c <= 2975)
                : (c <= 2980 || (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : c <= 3001)))))))))))
      : (c <= 3024 || (c < 4193
        ? (c < 3461
          ? (c < 3253
            ? (c < 3165
              ? (c < 3114
                ? (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))
                : (c <= 3129 || (c < 3160
                  ? c == 3133
                  : c <= 3162)))
              : (c <= 3165 || (c < 3214
                ? (c < 3200
                  ? (c >= 3168 && c <= 3169)
                  : (c <= 3200 || (c >= 3205 && c <= 3212)))
                : (c <= 3216 || (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : c <= 3251)))))
            : (c <= 3257 || (c < 3346
              ? (c < 3313
                ? (c < 3293
                  ? c == 3261
                  : (c <= 3294 || (c >= 3296 && c <= 3297)))
                : (c <= 3314 || (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)))
              : (c <= 3386 || (c < 3412
                ? (c < 3406
                  ? c == 3389
                  : c <= 3406)
                : (c <= 3414 || (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : c <= 3455)))))))
          : (c <= 3478 || (c < 3762
            ? (c < 3648
              ? (c < 3520
                ? (c < 3507
                  ? (c >= 3482 && c <= 3505)
                  : (c <= 3515 || c == 3517))
                : (c <= 3526 || (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : c <= 3635)))
              : (c <= 3654 || (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))))
            : (c <= 3763 || (c < 3913
              ? (c < 3804
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3807 || (c < 3904
                  ? c == 3840
                  : c <= 3911)))
              : (c <= 3948 || (c < 4159
                ? (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)
                : (c <= 4159 || (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : c <= 4189)))))))))
        : (c <= 4193 || (c < 5112
          ? (c < 4704
            ? (c < 4301
              ? (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : c <= 4295)))
              : (c <= 4301 || (c < 4688
                ? (c < 4348
                  ? (c >= 4304 && c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))
                : (c <= 4694 || (c < 4698
                  ? c == 4696
                  : c <= 4701)))))
            : (c <= 4744 || (c < 4808
              ? (c < 4792
                ? (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : (c <= 4784 || (c >= 4786 && c <= 4789)))
                : (c <= 4798 || (c < 4802
                  ? c == 4800
                  : c <= 4805)))
              : (c <= 4822 || (c < 4888
                ? (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))))))
          : (c <= 5117 || (c < 6176
            ? (c < 5919
              ? (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5870 && c <= 5880)
                  : c <= 5905)))
              : (c <= 5937 || (c < 6016
                ? (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))
                : (c <= 6067 || (c < 6108
                  ? c == 6103
                  : c <= 6108)))))
            : (c <= 6264 || (c < 6512
              ? (c < 6320
                ? (c < 6279
                  ? (c >= 6272 && c <= 6276)
                  : (c <= 6312 || c == 6314))
                : (c <= 6389 || (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)))
              : (c <= 6516 || (c < 6656
                ? (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)
                : (c <= 6678 || (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : c <= 6823)))))))))))))
    : (c <= 6963 || (c < 43261
      ? (c < 11499
        ? (c < 8126
          ? (c < 7418
            ? (c < 7258
              ? (c < 7098
                ? (c < 7043
                  ? (c >= 6981 && c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : c <= 7247)))
              : (c <= 7293 || (c < 7401
                ? (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : (c <= 7354 || (c >= 7357 && c <= 7359)))
                : (c <= 7404 || (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : c <= 7414)))))
            : (c <= 7418 || (c < 8025
              ? (c < 7968
                ? (c < 7680
                  ? (c >= 7424 && c <= 7615)
                  : (c <= 7957 || (c >= 7960 && c <= 7965)))
                : (c <= 8005 || (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)))
              : (c <= 8025 || (c < 8031
                ? (c < 8029
                  ? c == 8027
                  : c <= 8029)
                : (c <= 8061 || (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : c <= 8124)))))))
          : (c <= 8126 || (c < 8469
            ? (c < 8182
              ? (c < 8150
                ? (c < 8134
                  ? (c >= 8130 && c <= 8132)
                  : (c <= 8140 || (c >= 8144 && c <= 8147)))
                : (c <= 8155 || (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : c <= 8180)))
              : (c <= 8188 || (c < 8450
                ? (c < 8319
                  ? c == 8305
                  : (c <= 8319 || (c >= 8336 && c <= 8348)))
                : (c <= 8450 || (c < 8458
                  ? c == 8455
                  : c <= 8467)))))
            : (c <= 8469 || (c < 8508
              ? (c < 8488
                ? (c < 8484
                  ? (c >= 8473 && c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)))
              : (c <= 8511 || (c < 8544
                ? (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)
                : (c <= 8584 || (c < 11264
                  ? c == 8711
                  : c <= 11492)))))))))
        : (c <= 11502 || (c < 12704
          ? (c < 11728
            ? (c < 11648
              ? (c < 11565
                ? (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : c <= 11631)))
              : (c <= 11670 || (c < 11704
                ? (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : c <= 11726)))))
            : (c <= 11734 || (c < 12353
              ? (c < 12321
                ? (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : (c <= 11823 || (c >= 12293 && c <= 12295)))
                : (c <= 12329 || (c < 12344
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)))
              : (c <= 12438 || (c < 12540
                ? (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)
                : (c <= 12543 || (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)))))))
          : (c <= 12735 || (c < 42786
            ? (c < 42240
              ? (c < 19968
                ? (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : (c <= 13312 || c == 19903))
                : (c <= 19968 || (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : c <= 42237)))
              : (c <= 42508 || (c < 42623
                ? (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42775
                  ? (c >= 42656 && c <= 42735)
                  : c <= 42783)))))
            : (c <= 42888 || (c < 43015
              ? (c < 42965
                ? (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : c <= 43013)))
              : (c <= 43018 || (c < 43138
                ? (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)
                : (c <= 43187 || (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : c <= 43259)))))))))))
      : (c <= 43262 || (c < 65345
        ? (c < 43816
          ? (c < 43646
            ? (c < 43494
              ? (c < 43396
                ? (c < 43312
                  ? (c >= 43274 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43488
                  ? c == 43471
                  : c <= 43492)))
              : (c <= 43503 || (c < 43588
                ? (c < 43520
                  ? (c >= 43514 && c <= 43518)
                  : (c <= 43560 || (c >= 43584 && c <= 43586)))
                : (c <= 43595 || (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : c <= 43642)))))
            : (c <= 43695 || (c < 43744
              ? (c < 43712
                ? (c < 43701
                  ? c == 43697
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43739
                  ? c == 43714
                  : c <= 43741)))
              : (c <= 43754 || (c < 43785
                ? (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)
                : (c <= 43790 || (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)))))))
          : (c <= 43822 || (c < 64298
            ? (c < 55243
              ? (c < 44032
                ? (c < 43868
                  ? (c >= 43824 && c <= 43866)
                  : (c <= 43881 || (c >= 43888 && c <= 44002)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : c <= 55238)))
              : (c <= 55291 || (c < 64275
                ? (c < 64112
                  ? (c >= 63744 && c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))
                : (c <= 64279 || (c < 64287
                  ? c == 64285
                  : c <= 64296)))))
            : (c <= 64310 || (c < 64848
              ? (c < 64323
                ? (c < 64318
                  ? (c >= 64312 && c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)))
              : (c <= 64911 || (c < 65136
                ? (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)
                : (c <= 65140 || (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)))))))))
        : (c <= 65370 || (c < 66864
          ? (c < 66176
            ? (c < 65549
              ? (c < 65490
                ? (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65536
                  ? (c >= 65498 && c <= 65500)
                  : c <= 65547)))
              : (c <= 65574 || (c < 65616
                ? (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))
                : (c <= 65629 || (c < 65856
                  ? (c >= 65664 && c <= 65786)
                  : c <= 65908)))))
            : (c <= 66204 || (c < 66504
              ? (c < 66384
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66378)))
                : (c <= 66421 || (c < 66464
                  ? (c >= 66432 && c <= 66461)
                  : c <= 66499)))
              : (c <= 66511 || (c < 66736
                ? (c < 66560
                  ? (c >= 66513 && c <= 66517)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6917
    ? (c < 3024
      ? (c < 2392
        ? (c < 1568
          ? (c < 890
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= 'A' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 705 || (c < 750
                ? (c < 736
                  ? (c >= 710 && c <= 721)
                  : (c <= 740 || c == 748))
                : (c <= 750 || (c < 886
                  ? (c >= 880 && c <= 884)
                  : c <= 887)))))
            : (c <= 893 || (c < 1015
              ? (c < 908
                ? (c < 902
                  ? c == 895
                  : (c <= 902 || (c >= 904 && c <= 906)))
                : (c <= 908 || (c < 931
                  ? (c >= 910 && c <= 929)
                  : c <= 1013)))
              : (c <= 1153 || (c < 1376
                ? (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : c <= 1522)))))))
          : (c <= 1610 || (c < 2042
            ? (c < 1791
              ? (c < 1765
                ? (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : (c <= 1747 || c == 1749))
                : (c <= 1766 || (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : c <= 1788)))
              : (c <= 1791 || (c < 1969
                ? (c < 1810
                  ? c == 1808
                  : (c <= 1839 || (c >= 1869 && c <= 1957)))
                : (c <= 1969 || (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : c <= 2037)))))
            : (c <= 2042 || (c < 2160
              ? (c < 2088
                ? (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : (c <= 2074 || c == 2084))
                : (c <= 2088 || (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)))
              : (c <= 2183 || (c < 2308
                ? (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)
                : (c <= 2361 || (c < 2384
                  ? c == 2365
                  : c <= 2384)))))))))
        : (c <= 2401 || (c < 2730
          ? (c < 2565
            ? (c < 2486
              ? (c < 2451
                ? (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : (c <= 2444 || (c >= 2447 && c <= 2448)))
                : (c <= 2472 || (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : c <= 2482)))
              : (c <= 2489 || (c < 2527
                ? (c < 2510
                  ? c == 2493
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : c <= 2556)))))
            : (c <= 2570 || (c < 2649
              ? (c < 2610
                ? (c < 2579
                  ? (c >= 2575 && c <= 2576)
                  : (c <= 2600 || (c >= 2602 && c <= 2608)))
                : (c <= 2611 || (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)))
              : (c <= 2652 || (c < 2693
                ? (c < 2674
                  ? c == 2654
                  : c <= 2676)
                : (c <= 2701 || (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : c <= 2728)))))))
          : (c <= 2736 || (c < 2908
            ? (c < 2821
              ? (c < 2768
                ? (c < 2741
                  ? (c >= 2738 && c <= 2739)
                  : (c <= 2745 || c == 2749))
                : (c <= 2768 || (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : c <= 2809)))
              : (c <= 2828 || (c < 2866
                ? (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))
                : (c <= 2867 || (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : c <= 2877)))))
            : (c <= 2909 || (c < 2969
              ? (c < 2949
                ? (c < 2929
                  ? (c >= 2911 && c <= 2913)
                  : (c <= 2929 || c == 2947))
                : (c <= 2954 || (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)))
              : (c <= 2970 || (c < 2979
                ? (c < 2974
                  ? c == 2972
                  : c <= 2975)
                : (c <= 2980 || (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : c <= 3001)))))))))))
      : (c <= 3024 || (c < 4193
        ? (c < 3461
          ? (c < 3253
            ? (c < 3165
              ? (c < 3114
                ? (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))
                : (c <= 3129 || (c < 3160
                  ? c == 3133
                  : c <= 3162)))
              : (c <= 3165 || (c < 3214
                ? (c < 3200
                  ? (c >= 3168 && c <= 3169)
                  : (c <= 3200 || (c >= 3205 && c <= 3212)))
                : (c <= 3216 || (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : c <= 3251)))))
            : (c <= 3257 || (c < 3346
              ? (c < 3313
                ? (c < 3293
                  ? c == 3261
                  : (c <= 3294 || (c >= 3296 && c <= 3297)))
                : (c <= 3314 || (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)))
              : (c <= 3386 || (c < 3412
                ? (c < 3406
                  ? c == 3389
                  : c <= 3406)
                : (c <= 3414 || (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : c <= 3455)))))))
          : (c <= 3478 || (c < 3762
            ? (c < 3648
              ? (c < 3520
                ? (c < 3507
                  ? (c >= 3482 && c <= 3505)
                  : (c <= 3515 || c == 3517))
                : (c <= 3526 || (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : c <= 3635)))
              : (c <= 3654 || (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))))
            : (c <= 3763 || (c < 3913
              ? (c < 3804
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3807 || (c < 3904
                  ? c == 3840
                  : c <= 3911)))
              : (c <= 3948 || (c < 4159
                ? (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)
                : (c <= 4159 || (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : c <= 4189)))))))))
        : (c <= 4193 || (c < 5112
          ? (c < 4704
            ? (c < 4301
              ? (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : c <= 4295)))
              : (c <= 4301 || (c < 4688
                ? (c < 4348
                  ? (c >= 4304 && c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))
                : (c <= 4694 || (c < 4698
                  ? c == 4696
                  : c <= 4701)))))
            : (c <= 4744 || (c < 4808
              ? (c < 4792
                ? (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : (c <= 4784 || (c >= 4786 && c <= 4789)))
                : (c <= 4798 || (c < 4802
                  ? c == 4800
                  : c <= 4805)))
              : (c <= 4822 || (c < 4888
                ? (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))))))
          : (c <= 5117 || (c < 6176
            ? (c < 5919
              ? (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5870 && c <= 5880)
                  : c <= 5905)))
              : (c <= 5937 || (c < 6016
                ? (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))
                : (c <= 6067 || (c < 6108
                  ? c == 6103
                  : c <= 6108)))))
            : (c <= 6264 || (c < 6512
              ? (c < 6320
                ? (c < 6279
                  ? (c >= 6272 && c <= 6276)
                  : (c <= 6312 || c == 6314))
                : (c <= 6389 || (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)))
              : (c <= 6516 || (c < 6656
                ? (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)
                : (c <= 6678 || (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : c <= 6823)))))))))))))
    : (c <= 6963 || (c < 43261
      ? (c < 11499
        ? (c < 8126
          ? (c < 7418
            ? (c < 7258
              ? (c < 7098
                ? (c < 7043
                  ? (c >= 6981 && c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : c <= 7247)))
              : (c <= 7293 || (c < 7401
                ? (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : (c <= 7354 || (c >= 7357 && c <= 7359)))
                : (c <= 7404 || (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : c <= 7414)))))
            : (c <= 7418 || (c < 8025
              ? (c < 7968
                ? (c < 7680
                  ? (c >= 7424 && c <= 7615)
                  : (c <= 7957 || (c >= 7960 && c <= 7965)))
                : (c <= 8005 || (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)))
              : (c <= 8025 || (c < 8031
                ? (c < 8029
                  ? c == 8027
                  : c <= 8029)
                : (c <= 8061 || (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : c <= 8124)))))))
          : (c <= 8126 || (c < 8469
            ? (c < 8182
              ? (c < 8150
                ? (c < 8134
                  ? (c >= 8130 && c <= 8132)
                  : (c <= 8140 || (c >= 8144 && c <= 8147)))
                : (c <= 8155 || (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : c <= 8180)))
              : (c <= 8188 || (c < 8450
                ? (c < 8319
                  ? c == 8305
                  : (c <= 8319 || (c >= 8336 && c <= 8348)))
                : (c <= 8450 || (c < 8458
                  ? c == 8455
                  : c <= 8467)))))
            : (c <= 8469 || (c < 8508
              ? (c < 8488
                ? (c < 8484
                  ? (c >= 8473 && c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)))
              : (c <= 8511 || (c < 8544
                ? (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)
                : (c <= 8584 || (c < 11264
                  ? c == 8711
                  : c <= 11492)))))))))
        : (c <= 11502 || (c < 12704
          ? (c < 11728
            ? (c < 11648
              ? (c < 11565
                ? (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : c <= 11631)))
              : (c <= 11670 || (c < 11704
                ? (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : c <= 11726)))))
            : (c <= 11734 || (c < 12353
              ? (c < 12321
                ? (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : (c <= 11823 || (c >= 12293 && c <= 12295)))
                : (c <= 12329 || (c < 12344
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)))
              : (c <= 12438 || (c < 12540
                ? (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)
                : (c <= 12543 || (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)))))))
          : (c <= 12735 || (c < 42786
            ? (c < 42240
              ? (c < 19968
                ? (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : (c <= 13312 || c == 19903))
                : (c <= 19968 || (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : c <= 42237)))
              : (c <= 42508 || (c < 42623
                ? (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42775
                  ? (c >= 42656 && c <= 42735)
                  : c <= 42783)))))
            : (c <= 42888 || (c < 43015
              ? (c < 42965
                ? (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : c <= 43013)))
              : (c <= 43018 || (c < 43138
                ? (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)
                : (c <= 43187 || (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : c <= 43259)))))))))))
      : (c <= 43262 || (c < 65345
        ? (c < 43816
          ? (c < 43646
            ? (c < 43494
              ? (c < 43396
                ? (c < 43312
                  ? (c >= 43274 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43488
                  ? c == 43471
                  : c <= 43492)))
              : (c <= 43503 || (c < 43588
                ? (c < 43520
                  ? (c >= 43514 && c <= 43518)
                  : (c <= 43560 || (c >= 43584 && c <= 43586)))
                : (c <= 43595 || (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : c <= 43642)))))
            : (c <= 43695 || (c < 43744
              ? (c < 43712
                ? (c < 43701
                  ? c == 43697
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43739
                  ? c == 43714
                  : c <= 43741)))
              : (c <= 43754 || (c < 43785
                ? (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)
                : (c <= 43790 || (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)))))))
          : (c <= 43822 || (c < 64298
            ? (c < 55243
              ? (c < 44032
                ? (c < 43868
                  ? (c >= 43824 && c <= 43866)
                  : (c <= 43881 || (c >= 43888 && c <= 44002)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : c <= 55238)))
              : (c <= 55291 || (c < 64275
                ? (c < 64112
                  ? (c >= 63744 && c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))
                : (c <= 64279 || (c < 64287
                  ? c == 64285
                  : c <= 64296)))))
            : (c <= 64310 || (c < 64848
              ? (c < 64323
                ? (c < 64318
                  ? (c >= 64312 && c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)))
              : (c <= 64911 || (c < 65136
                ? (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)
                : (c <= 65140 || (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)))))))))
        : (c <= 65370 || (c < 66864
          ? (c < 66176
            ? (c < 65549
              ? (c < 65490
                ? (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65536
                  ? (c >= 65498 && c <= 65500)
                  : c <= 65547)))
              : (c <= 65574 || (c < 65616
                ? (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))
                : (c <= 65629 || (c < 65856
                  ? (c >= 65664 && c <= 65786)
                  : c <= 65908)))))
            : (c <= 66204 || (c < 66504
              ? (c < 66384
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66378)))
                : (c <= 66421 || (c < 66464
                  ? (c >= 66432 && c <= 66461)
                  : c <= 66499)))
              : (c <= 66511 || (c < 66736
                ? (c < 66560
                  ? (c >= 66513 && c <= 66517)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6823
    ? (c < 2984
      ? (c < 2365
        ? (c < 1488
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= 'A' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1329
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : (c <= 1153 || (c >= 1162 && c <= 1327)))
                : (c <= 1366 || (c < 1376
                  ? c == 1369
                  : c <= 1416)))))))
          : (c <= 1514 || (c < 1994
            ? (c < 1774
              ? (c < 1649
                ? (c < 1568
                  ? (c >= 1519 && c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1765
                  ? c == 1749
                  : c <= 1766)))
              : (c <= 1775 || (c < 1810
                ? (c < 1791
                  ? (c >= 1786 && c <= 1788)
                  : (c <= 1791 || c == 1808))
                : (c <= 1839 || (c < 1969
                  ? (c >= 1869 && c <= 1957)
                  : c <= 1969)))))
            : (c <= 2026 || (c < 2112
              ? (c < 2074
                ? (c < 2042
                  ? (c >= 2036 && c <= 2037)
                  : (c <= 2042 || (c >= 2048 && c <= 2069)))
                : (c <= 2074 || (c < 2088
                  ? c == 2084
                  : c <= 2088)))
              : (c <= 2136 || (c < 2185
                ? (c < 2160
                  ? (c >= 2144 && c <= 2154)
                  : c <= 2183)
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2544
            ? (c < 2474
              ? (c < 2437
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2654
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)
                : (c <= 2654 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2869
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2835
                ? (c < 2821
                  ? c == 2809
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))
                : (c <= 2856 || (c < 2866
                  ? (c >= 2858 && c <= 2864)
                  : c <= 2867)))))
            : (c <= 2873 || (c < 2958
              ? (c < 2929
                ? (c < 2908
                  ? c == 2877
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2949
                  ? c == 2947
                  : c <= 2954)))
              : (c <= 2960 || (c < 2972
                ? (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)
                : (c <= 2972 || (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : c <= 2980)))))))))))
      : (c <= 2986 || (c < 4186
        ? (c < 3450
          ? (c < 3218
            ? (c < 3133
              ? (c < 3086
                ? (c < 3024
                  ? (c >= 2990 && c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : c <= 3129)))
              : (c <= 3133 || (c < 3200
                ? (c < 3165
                  ? (c >= 3160 && c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3332
              ? (c < 3293
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : (c <= 3257 || c == 3261))
                : (c <= 3294 || (c < 3313
                  ? (c >= 3296 && c <= 3297)
                  : c <= 3314)))
              : (c <= 3340 || (c < 3406
                ? (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : (c <= 3386 || c == 3389))
                : (c <= 3406 || (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : c <= 3425)))))))
          : (c <= 3455 || (c < 3751
            ? (c < 3634
              ? (c < 3517
                ? (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : c <= 3632)))
              : (c <= 3635 || (c < 3718
                ? (c < 3713
                  ? (c >= 3648 && c <= 3654)
                  : (c <= 3714 || c == 3716))
                : (c <= 3722 || (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)))))
            : (c <= 3760 || (c < 3904
              ? (c < 3782
                ? (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))
                : (c <= 3782 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))
              : (c <= 3911 || (c < 4096
                ? (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)
                : (c <= 4138 || (c < 4176
                  ? c == 4159
                  : c <= 4181)))))))))
        : (c <= 4189 || (c < 5024
          ? (c < 4698
            ? (c < 4295
              ? (c < 4213
                ? (c < 4197
                  ? c == 4193
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))
                : (c <= 4225 || (c < 4256
                  ? c == 4238
                  : c <= 4293)))
              : (c <= 4295 || (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))))
            : (c <= 4701 || (c < 4802
              ? (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))
              : (c <= 4805 || (c < 4882
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)
                : (c <= 4885 || (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : c <= 5007)))))))
          : (c <= 5109 || (c < 6108
            ? (c < 5888
              ? (c < 5761
                ? (c < 5121
                  ? (c >= 5112 && c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))
                : (c <= 5786 || (c < 5870
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))
              : (c <= 5905 || (c < 5998
                ? (c < 5952
                  ? (c >= 5919 && c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : c <= 6103)))))
            : (c <= 6108 || (c < 6480
              ? (c < 6314
                ? (c < 6272
                  ? (c >= 6176 && c <= 6264)
                  : (c <= 6276 || (c >= 6279 && c <= 6312)))
                : (c <= 6314 || (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : c <= 6430)))
              : (c <= 6509 || (c < 6576
                ? (c < 6528
                  ? (c >= 6512 && c <= 6516)
                  : c <= 6571)
                : (c <= 6601 || (c < 6688
                  ? (c >= 6656 && c <= 6678)
                  : c <= 6740)))))))))))))
    : (c <= 6823 || (c < 43261
      ? (c < 11499
        ? (c < 8126
          ? (c < 7413
            ? (c < 7245
              ? (c < 7086
                ? (c < 6981
                  ? (c >= 6917 && c <= 6963)
                  : (c <= 6988 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7168
                  ? (c >= 7098 && c <= 7141)
                  : c <= 7203)))
              : (c <= 7247 || (c < 7357
                ? (c < 7296
                  ? (c >= 7258 && c <= 7293)
                  : (c <= 7304 || (c >= 7312 && c <= 7354)))
                : (c <= 7359 || (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : c <= 7411)))))
            : (c <= 7414 || (c < 8016
              ? (c < 7960
                ? (c < 7424
                  ? c == 7418
                  : (c <= 7615 || (c >= 7680 && c <= 7957)))
                : (c <= 7965 || (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : c <= 8013)))
              : (c <= 8023 || (c < 8031
                ? (c < 8027
                  ? c == 8025
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : c <= 8124)))))))
          : (c <= 8126 || (c < 8469
            ? (c < 8182
              ? (c < 8150
                ? (c < 8134
                  ? (c >= 8130 && c <= 8132)
                  : (c <= 8140 || (c >= 8144 && c <= 8147)))
                : (c <= 8155 || (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : c <= 8180)))
              : (c <= 8188 || (c < 8450
                ? (c < 8319
                  ? c == 8305
                  : (c <= 8319 || (c >= 8336 && c <= 8348)))
                : (c <= 8450 || (c < 8458
                  ? c == 8455
                  : c <= 8467)))))
            : (c <= 8469 || (c < 8508
              ? (c < 8488
                ? (c < 8484
                  ? (c >= 8473 && c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)))
              : (c <= 8511 || (c < 8544
                ? (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)
                : (c <= 8584 || (c < 11264
                  ? c == 8711
                  : c <= 11492)))))))))
        : (c <= 11502 || (c < 12704
          ? (c < 11728
            ? (c < 11648
              ? (c < 11565
                ? (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : c <= 11631)))
              : (c <= 11670 || (c < 11704
                ? (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : c <= 11726)))))
            : (c <= 11734 || (c < 12353
              ? (c < 12321
                ? (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : (c <= 11823 || (c >= 12293 && c <= 12295)))
                : (c <= 12329 || (c < 12344
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)))
              : (c <= 12438 || (c < 12540
                ? (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)
                : (c <= 12543 || (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)))))))
          : (c <= 12735 || (c < 42786
            ? (c < 42240
              ? (c < 19968
                ? (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : (c <= 13312 || c == 19903))
                : (c <= 19968 || (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : c <= 42237)))
              : (c <= 42508 || (c < 42623
                ? (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42775
                  ? (c >= 42656 && c <= 42735)
                  : c <= 42783)))))
            : (c <= 42888 || (c < 43015
              ? (c < 42965
                ? (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : c <= 43013)))
              : (c <= 43018 || (c < 43138
                ? (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)
                : (c <= 43187 || (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : c <= 43259)))))))))))
      : (c <= 43262 || (c < 65345
        ? (c < 43816
          ? (c < 43646
            ? (c < 43494
              ? (c < 43396
                ? (c < 43312
                  ? (c >= 43274 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43488
                  ? c == 43471
                  : c <= 43492)))
              : (c <= 43503 || (c < 43588
                ? (c < 43520
                  ? (c >= 43514 && c <= 43518)
                  : (c <= 43560 || (c >= 43584 && c <= 43586)))
                : (c <= 43595 || (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : c <= 43642)))))
            : (c <= 43695 || (c < 43744
              ? (c < 43712
                ? (c < 43701
                  ? c == 43697
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43739
                  ? c == 43714
                  : c <= 43741)))
              : (c <= 43754 || (c < 43785
                ? (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)
                : (c <= 43790 || (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)))))))
          : (c <= 43822 || (c < 64298
            ? (c < 55243
              ? (c < 44032
                ? (c < 43868
                  ? (c >= 43824 && c <= 43866)
                  : (c <= 43881 || (c >= 43888 && c <= 44002)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : c <= 55238)))
              : (c <= 55291 || (c < 64275
                ? (c < 64112
                  ? (c >= 63744 && c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))
                : (c <= 64279 || (c < 64287
                  ? c == 64285
                  : c <= 64296)))))
            : (c <= 64310 || (c < 64848
              ? (c < 64323
                ? (c < 64318
                  ? (c >= 64312 && c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)))
              : (c <= 64911 || (c < 65136
                ? (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)
                : (c <= 65140 || (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)))))))))
        : (c <= 65370 || (c < 66864
          ? (c < 66176
            ? (c < 65549
              ? (c < 65490
                ? (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65536
                  ? (c >= 65498 && c <= 65500)
                  : c <= 65547)))
              : (c <= 65574 || (c < 65616
                ? (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))
                : (c <= 65629 || (c < 65856
                  ? (c >= 65664 && c <= 65786)
                  : c <= 65908)))))
            : (c <= 66204 || (c < 66504
              ? (c < 66384
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66378)))
                : (c <= 66421 || (c < 66464
                  ? (c >= 66432 && c <= 66461)
                  : c <= 66499)))
              : (c <= 66511 || (c < 66736
                ? (c < 66560
                  ? (c >= 66513 && c <= 66517)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 6823
    ? (c < 2990
      ? (c < 2384
        ? (c < 1519
          ? (c < 886
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= 'A' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 748
                ? (c < 710
                  ? (c >= 216 && c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))
                : (c <= 748 || (c < 880
                  ? c == 750
                  : c <= 884)))))
            : (c <= 887 || (c < 931
              ? (c < 904
                ? (c < 895
                  ? (c >= 890 && c <= 893)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 910
                  ? c == 908
                  : c <= 929)))
              : (c <= 1013 || (c < 1369
                ? (c < 1162
                  ? (c >= 1015 && c <= 1153)
                  : (c <= 1327 || (c >= 1329 && c <= 1366)))
                : (c <= 1369 || (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : c <= 1514)))))))
          : (c <= 1522 || (c < 2036
            ? (c < 1786
              ? (c < 1749
                ? (c < 1646
                  ? (c >= 1568 && c <= 1610)
                  : (c <= 1647 || (c >= 1649 && c <= 1747)))
                : (c <= 1749 || (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : c <= 1775)))
              : (c <= 1788 || (c < 1869
                ? (c < 1808
                  ? c == 1791
                  : (c <= 1808 || (c >= 1810 && c <= 1839)))
                : (c <= 1957 || (c < 1994
                  ? c == 1969
                  : c <= 2026)))))
            : (c <= 2037 || (c < 2144
              ? (c < 2084
                ? (c < 2048
                  ? c == 2042
                  : (c <= 2069 || c == 2074))
                : (c <= 2084 || (c < 2112
                  ? c == 2088
                  : c <= 2136)))
              : (c <= 2154 || (c < 2208
                ? (c < 2185
                  ? (c >= 2160 && c <= 2183)
                  : c <= 2190)
                : (c <= 2249 || (c < 2365
                  ? (c >= 2308 && c <= 2361)
                  : c <= 2365)))))))))
        : (c <= 2384 || (c < 2707
          ? (c < 2556
            ? (c < 2482
              ? (c < 2447
                ? (c < 2417
                  ? (c >= 2392 && c <= 2401)
                  : (c <= 2432 || (c >= 2437 && c <= 2444)))
                : (c <= 2448 || (c < 2474
                  ? (c >= 2451 && c <= 2472)
                  : c <= 2480)))
              : (c <= 2482 || (c < 2524
                ? (c < 2493
                  ? (c >= 2486 && c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2544
                  ? (c >= 2527 && c <= 2529)
                  : c <= 2545)))))
            : (c <= 2556 || (c < 2616
              ? (c < 2602
                ? (c < 2575
                  ? (c >= 2565 && c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))
                : (c <= 2608 || (c < 2613
                  ? (c >= 2610 && c <= 2611)
                  : c <= 2614)))
              : (c <= 2617 || (c < 2674
                ? (c < 2654
                  ? (c >= 2649 && c <= 2652)
                  : c <= 2654)
                : (c <= 2676 || (c < 2703
                  ? (c >= 2693 && c <= 2701)
                  : c <= 2705)))))))
          : (c <= 2728 || (c < 2877
            ? (c < 2809
              ? (c < 2749
                ? (c < 2738
                  ? (c >= 2730 && c <= 2736)
                  : (c <= 2739 || (c >= 2741 && c <= 2745)))
                : (c <= 2749 || (c < 2784
                  ? c == 2768
                  : c <= 2785)))
              : (c <= 2809 || (c < 2858
                ? (c < 2831
                  ? (c >= 2821 && c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))
                : (c <= 2864 || (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : c <= 2873)))))
            : (c <= 2877 || (c < 2962
              ? (c < 2947
                ? (c < 2911
                  ? (c >= 2908 && c <= 2909)
                  : (c <= 2913 || c == 2929))
                : (c <= 2947 || (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : c <= 2960)))
              : (c <= 2965 || (c < 2974
                ? (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)
                : (c <= 2975 || (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : c <= 2986)))))))))))
      : (c <= 3001 || (c < 4186
        ? (c < 3450
          ? (c < 3242
            ? (c < 3160
              ? (c < 3090
                ? (c < 3077
                  ? c == 3024
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))
                : (c <= 3112 || (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : c <= 3133)))
              : (c <= 3162 || (c < 3205
                ? (c < 3168
                  ? c == 3165
                  : (c <= 3169 || c == 3200))
                : (c <= 3212 || (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : c <= 3240)))))
            : (c <= 3251 || (c < 3342
              ? (c < 3296
                ? (c < 3261
                  ? (c >= 3253 && c <= 3257)
                  : (c <= 3261 || (c >= 3293 && c <= 3294)))
                : (c <= 3297 || (c < 3332
                  ? (c >= 3313 && c <= 3314)
                  : c <= 3340)))
              : (c <= 3344 || (c < 3406
                ? (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)
                : (c <= 3406 || (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : c <= 3425)))))))
          : (c <= 3455 || (c < 3751
            ? (c < 3634
              ? (c < 3517
                ? (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : c <= 3632)))
              : (c <= 3635 || (c < 3718
                ? (c < 3713
                  ? (c >= 3648 && c <= 3654)
                  : (c <= 3714 || c == 3716))
                : (c <= 3722 || (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)))))
            : (c <= 3760 || (c < 3904
              ? (c < 3782
                ? (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))
                : (c <= 3782 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))
              : (c <= 3911 || (c < 4096
                ? (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)
                : (c <= 4138 || (c < 4176
                  ? c == 4159
                  : c <= 4181)))))))))
        : (c <= 4189 || (c < 5024
          ? (c < 4698
            ? (c < 4295
              ? (c < 4213
                ? (c < 4197
                  ? c == 4193
                  : (c <= 4198 || (c >= 4206 && c <= 4208)))
                : (c <= 4225 || (c < 4256
                  ? c == 4238
                  : c <= 4293)))
              : (c <= 4295 || (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))))
            : (c <= 4701 || (c < 4802
              ? (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))
              : (c <= 4805 || (c < 4882
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)
                : (c <= 4885 || (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : c <= 5007)))))))
          : (c <= 5109 || (c < 6108
            ? (c < 5888
              ? (c < 5761
                ? (c < 5121
                  ? (c >= 5112 && c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))
                : (c <= 5786 || (c < 5870
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))
              : (c <= 5905 || (c < 5998
                ? (c < 5952
                  ? (c >= 5919 && c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : c <= 6103)))))
            : (c <= 6108 || (c < 6480
              ? (c < 6314
                ? (c < 6272
                  ? (c >= 6176 && c <= 6264)
                  : (c <= 6276 || (c >= 6279 && c <= 6312)))
                : (c <= 6314 || (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : c <= 6430)))
              : (c <= 6509 || (c < 6576
                ? (c < 6528
                  ? (c >= 6512 && c <= 6516)
                  : c <= 6571)
                : (c <= 6601 || (c < 6688
                  ? (c >= 6656 && c <= 6678)
                  : c <= 6740)))))))))))))
    : (c <= 6823 || (c < 43261
      ? (c < 11499
        ? (c < 8126
          ? (c < 7413
            ? (c < 7245
              ? (c < 7086
                ? (c < 6981
                  ? (c >= 6917 && c <= 6963)
                  : (c <= 6988 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7168
                  ? (c >= 7098 && c <= 7141)
                  : c <= 7203)))
              : (c <= 7247 || (c < 7357
                ? (c < 7296
                  ? (c >= 7258 && c <= 7293)
                  : (c <= 7304 || (c >= 7312 && c <= 7354)))
                : (c <= 7359 || (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : c <= 7411)))))
            : (c <= 7414 || (c < 8016
              ? (c < 7960
                ? (c < 7424
                  ? c == 7418
                  : (c <= 7615 || (c >= 7680 && c <= 7957)))
                : (c <= 7965 || (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : c <= 8013)))
              : (c <= 8023 || (c < 8031
                ? (c < 8027
                  ? c == 8025
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : c <= 8124)))))))
          : (c <= 8126 || (c < 8469
            ? (c < 8182
              ? (c < 8150
                ? (c < 8134
                  ? (c >= 8130 && c <= 8132)
                  : (c <= 8140 || (c >= 8144 && c <= 8147)))
                : (c <= 8155 || (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : c <= 8180)))
              : (c <= 8188 || (c < 8450
                ? (c < 8319
                  ? c == 8305
                  : (c <= 8319 || (c >= 8336 && c <= 8348)))
                : (c <= 8450 || (c < 8458
                  ? c == 8455
                  : c <= 8467)))))
            : (c <= 8469 || (c < 8508
              ? (c < 8488
                ? (c < 8484
                  ? (c >= 8473 && c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)))
              : (c <= 8511 || (c < 8544
                ? (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)
                : (c <= 8584 || (c < 11264
                  ? c == 8711
                  : c <= 11492)))))))))
        : (c <= 11502 || (c < 12704
          ? (c < 11728
            ? (c < 11648
              ? (c < 11565
                ? (c < 11520
                  ? (c >= 11506 && c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : c <= 11631)))
              : (c <= 11670 || (c < 11704
                ? (c < 11688
                  ? (c >= 11680 && c <= 11686)
                  : (c <= 11694 || (c >= 11696 && c <= 11702)))
                : (c <= 11710 || (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : c <= 11726)))))
            : (c <= 11734 || (c < 12353
              ? (c < 12321
                ? (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : (c <= 11823 || (c >= 12293 && c <= 12295)))
                : (c <= 12329 || (c < 12344
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)))
              : (c <= 12438 || (c < 12540
                ? (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)
                : (c <= 12543 || (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)))))))
          : (c <= 12735 || (c < 42786
            ? (c < 42240
              ? (c < 19968
                ? (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : (c <= 13312 || c == 19903))
                : (c <= 19968 || (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : c <= 42237)))
              : (c <= 42508 || (c < 42623
                ? (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42775
                  ? (c >= 42656 && c <= 42735)
                  : c <= 42783)))))
            : (c <= 42888 || (c < 43015
              ? (c < 42965
                ? (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : c <= 43013)))
              : (c <= 43018 || (c < 43138
                ? (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)
                : (c <= 43187 || (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : c <= 43259)))))))))))
      : (c <= 43262 || (c < 65345
        ? (c < 43816
          ? (c < 43646
            ? (c < 43494
              ? (c < 43396
                ? (c < 43312
                  ? (c >= 43274 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43488
                  ? c == 43471
                  : c <= 43492)))
              : (c <= 43503 || (c < 43588
                ? (c < 43520
                  ? (c >= 43514 && c <= 43518)
                  : (c <= 43560 || (c >= 43584 && c <= 43586)))
                : (c <= 43595 || (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : c <= 43642)))))
            : (c <= 43695 || (c < 43744
              ? (c < 43712
                ? (c < 43701
                  ? c == 43697
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43739
                  ? c == 43714
                  : c <= 43741)))
              : (c <= 43754 || (c < 43785
                ? (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)
                : (c <= 43790 || (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)))))))
          : (c <= 43822 || (c < 64298
            ? (c < 55243
              ? (c < 44032
                ? (c < 43868
                  ? (c >= 43824 && c <= 43866)
                  : (c <= 43881 || (c >= 43888 && c <= 44002)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : c <= 55238)))
              : (c <= 55291 || (c < 64275
                ? (c < 64112
                  ? (c >= 63744 && c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))
                : (c <= 64279 || (c < 64287
                  ? c == 64285
                  : c <= 64296)))))
            : (c <= 64310 || (c < 64848
              ? (c < 64323
                ? (c < 64318
                  ? (c >= 64312 && c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)))
              : (c <= 64911 || (c < 65136
                ? (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)
                : (c <= 65140 || (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)))))))))
        : (c <= 65370 || (c < 66864
          ? (c < 66176
            ? (c < 65549
              ? (c < 65490
                ? (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65536
                  ? (c >= 65498 && c <= 65500)
                  : c <= 65547)))
              : (c <= 65574 || (c < 65616
                ? (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))
                : (c <= 65629 || (c < 65856
                  ? (c >= 65664 && c <= 65786)
                  : c <= 65908)))))
            : (c <= 66204 || (c < 66504
              ? (c < 66384
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66378)))
                : (c <= 66421 || (c < 66464
                  ? (c >= 66432 && c <= 66461)
                  : c <= 66499)))
              : (c <= 66511 || (c < 66736
                ? (c < 66560
                  ? (c >= 66513 && c <= 66517)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 8768
    ? (c < 8617
      ? (c < 177
        ? (c < '$'
          ? (c < '\r'
            ? (c < '\t'
              ? c == 0
              : c <= '\n')
            : (c <= '\r' || (c < '"'
              ? c == ' '
              : c <= '"')))
          : (c <= '/' || (c < '`'
            ? (c < '['
              ? (c >= ':' && c <= '>')
              : c <= '^')
            : (c <= '`' || (c >= '{' && c <= '}')))))
        : (c <= 177 || (c < 8592
          ? (c < 8230
            ? (c < 247
              ? c == 215
              : c <= 247)
            : (c <= 8230 || (c < 8523
              ? c == 8285
              : c <= 8523)))
          : (c <= 8596 || (c < 8610
            ? (c < 8608
              ? (c >= 8602 && c <= 8606)
              : c <= 8608)
            : (c <= 8612 || c == 8614))))))
      : (c <= 8620 || (c < 8672
        ? (c < 8649
          ? (c < 8640
            ? (c < 8636
              ? c == 8622
              : c <= 8637)
            : (c <= 8641 || (c < 8646
              ? c == 8644
              : c <= 8647)))
          : (c <= 8649 || (c < 8660
            ? (c < 8658
              ? (c >= 8651 && c <= 8656)
              : c <= 8658)
            : (c <= 8660 || (c >= 8666 && c <= 8669)))))
        : (c <= 8672 || (c < 8733
          ? (c < 8712
            ? (c < 8692
              ? c == 8674
              : c <= 8703)
            : (c <= 8717 || (c < 8727
              ? (c >= 8723 && c <= 8724)
              : c <= 8729)))
          : (c <= 8733 || (c < 8762
            ? (c < 8759
              ? (c >= 8740 && c <= 8746)
              : c <= 8760)
            : (c <= 8763 || (c >= 8765 && c <= 8766)))))))))
    : (c <= 8843 || (c < 10679
      ? (c < 9655
        ? (c < 8880
          ? (c < 8873
            ? (c < 8862
              ? (c >= 8845 && c <= 8860)
              : c <= 8867)
            : (c <= 8873 || (c < 8878
              ? c == 8876
              : c <= 8878)))
          : (c <= 8887 || (c < 8905
            ? (c < 8900
              ? (c >= 8891 && c <= 8893)
              : c <= 8903)
            : (c <= 8915 || (c >= 8917 && c <= 8959)))))
        : (c <= 9655 || (c < 10229
          ? (c < 10193
            ? (c < 10184
              ? c == 10178
              : c <= 10185)
            : (c <= 10194 || (c < 10224
              ? (c >= 10197 && c <= 10199)
              : c <= 10225)))
          : (c <= 10231 || (c < 10525
            ? (c < 10496
              ? (c >= 10233 && c <= 10239)
              : c <= 10520)
            : (c <= 10528 || (c >= 10564 && c <= 10608)))))))
      : (c <= 10680 || (c < 10800
        ? (c < 10742
          ? (c < 10721
            ? (c < 10686
              ? c == 10684
              : c <= 10689)
            : (c <= 10721 || (c < 10740
              ? (c >= 10723 && c <= 10725)
              : c <= 10740)))
          : (c <= 10743 || (c < 10781
            ? (c < 10759
              ? (c >= 10746 && c <= 10747)
              : c <= 10760)
            : (c <= 10781 || (c >= 10786 && c <= 10798)))))
        : (c <= 10813 || (c < 10971
          ? (c < 10842
            ? (c < 10826
              ? (c >= 10816 && c <= 10821)
              : c <= 10840)
            : (c <= 10851 || (c < 10858
              ? (c >= 10854 && c <= 10855)
              : c <= 10969)))
          : (c <= 10971 || (c < 11079
            ? (c < 11056
              ? (c >= 10999 && c <= 11002)
              : c <= 11076)
            : (c <= 11084 || (c >= 65513 && c <= 65516)))))))))));
}

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < '`'
    ? (c < '\''
      ? (c < '$'
        ? c == '"'
        : c <= '$')
      : (c <= '\'' || c == '\\'))
    : (c <= 'b' || (c < 'r'
      ? (c < 'n'
        ? c == 'f'
        : c <= 'n')
      : (c <= 'r' || (c >= 't' && c <= 'v')))));
}

static inline bool aux_sym_character_literal_token1_character_set_1(int32_t c) {
  return (c < 10197
    ? (c < 8845
      ? (c < 8727
        ? (c < 215
          ? (c < '*'
            ? c == '%'
            : c <= '*')
          : (c <= 215 || (c < 8523
            ? c == 247
            : c <= 8523)))
        : (c <= 8729 || (c < 8745
          ? (c < 8743
            ? c == 8740
            : c <= 8743)
          : (c <= 8745 || c == 8768))))
      : (c <= 8845 || (c < 8905
        ? (c < 8864
          ? (c < 8855
            ? c == 8851
            : c <= 8859)
          : (c <= 8865 || (c < 8900
            ? c == 8892
            : c <= 8903)))
        : (c <= 8908 || (c < 9655
          ? (c < 8914
            ? c == 8911
            : c <= 8914)
          : (c <= 9655 || c == 10193))))))
    : (c <= 10199 || (c < 10827
      ? (c < 10781
        ? (c < 10686
          ? (c < 10684
            ? c == 10680
            : c <= 10684)
          : (c <= 10687 || (c < 10759
            ? (c >= 10742 && c <= 10743)
            : c <= 10759)))
        : (c <= 10781 || (c < 10816
          ? (c < 10811
            ? (c >= 10800 && c <= 10808)
            : c <= 10813)
          : (c <= 10816 || (c >= 10819 && c <= 10820)))))
      : (c <= 10827 || (c < 10840
        ? (c < 10835
          ? (c < 10833
            ? (c >= 10829 && c <= 10830)
            : c <= 10833)
          : (c <= 10835 || c == 10837))
        : (c <= 10840 || (c < 10846
          ? (c < 10844
            ? c == 10842
            : c <= 10844)
          : (c <= 10848 || c == 10971))))))));
}

static inline bool sym__power_operator_character_set_1(int32_t c) {
  return (c < 10577
    ? (c < 10504
      ? (c < 8595
        ? (c < 8593
          ? c == '^'
          : c <= 8593)
        : (c <= 8595 || (c < 10224
          ? c == 8693
          : c <= 10225)))
      : (c <= 10507 || (c < 10572
        ? (c < 10569
          ? (c >= 10514 && c <= 10515)
          : c <= 10569)
        : (c <= 10573 || c == 10575))))
    : (c <= 10577 || (c < 10595
      ? (c < 10588
        ? (c < 10584
          ? (c >= 10580 && c <= 10581)
          : c <= 10585)
        : (c <= 10589 || (c >= 10592 && c <= 10593)))
      : (c <= 10595 || (c < 65514
        ? (c < 10606
          ? c == 10597
          : c <= 10607)
        : (c <= 65514 || c == 65516))))));
}

static inline bool sym__times_operator_character_set_1(int32_t c) {
  return (c < 9655
    ? (c < 8851
      ? (c < 8740
        ? (c < 8523
          ? c == 215
          : (c <= 8523 || (c >= 8727 && c <= 8729)))
        : (c <= 8740 || (c < 8768
          ? (c >= 8743 && c <= 8745)
          : (c <= 8768 || c == 8845))))
      : (c <= 8859 || (c < 8905
        ? (c < 8892
          ? (c >= 8864 && c <= 8865)
          : (c <= 8892 || (c >= 8900 && c <= 8903)))
        : (c <= 8908 || (c < 8914
          ? c == 8911
          : c <= 8914)))))
    : (c <= 9655 || (c < 10759
      ? (c < 10684
        ? (c < 10197
          ? c == 10193
          : (c <= 10199 || c == 10680))
        : (c <= 10684 || (c < 10742
          ? (c >= 10686 && c <= 10687)
          : c <= 10743)))
      : (c <= 10759 || (c < 10827
        ? (c < 10800
          ? c == 10781
          : (c <= 10813 || (c >= 10816 && c <= 10820)))
        : (c <= 10840 || (c < 10971
          ? (c >= 10842 && c <= 10848)
          : c <= 10971)))))));
}

static inline bool sym__times_operator_character_set_2(int32_t c) {
  return (c < 10193
    ? (c < 8768
      ? (c < 8523
        ? (c < '\\'
          ? (c < '*'
            ? c == '%'
            : c <= '*')
          : (c <= '\\' || (c < 247
            ? c == 215
            : c <= 247)))
        : (c <= 8523 || (c < 8743
          ? (c < 8740
            ? (c >= 8727 && c <= 8729)
            : c <= 8740)
          : (c <= 8743 || c == 8745))))
      : (c <= 8768 || (c < 8900
        ? (c < 8855
          ? (c < 8851
            ? c == 8845
            : c <= 8851)
          : (c <= 8859 || (c < 8892
            ? (c >= 8864 && c <= 8865)
            : c <= 8892)))
        : (c <= 8903 || (c < 8914
          ? (c < 8911
            ? (c >= 8905 && c <= 8908)
            : c <= 8911)
          : (c <= 8914 || c == 9655))))))
    : (c <= 10193 || (c < 10819
      ? (c < 10759
        ? (c < 10684
          ? (c < 10680
            ? (c >= 10197 && c <= 10199)
            : c <= 10680)
          : (c <= 10684 || (c < 10742
            ? (c >= 10686 && c <= 10687)
            : c <= 10743)))
        : (c <= 10759 || (c < 10811
          ? (c < 10800
            ? c == 10781
            : c <= 10808)
          : (c <= 10813 || c == 10816))))
      : (c <= 10820 || (c < 10840
        ? (c < 10833
          ? (c < 10829
            ? c == 10827
            : c <= 10830)
          : (c <= 10833 || (c < 10837
            ? c == 10835
            : c <= 10837)))
        : (c <= 10840 || (c < 10846
          ? (c < 10844
            ? c == 10842
            : c <= 10844)
          : (c <= 10848 || c == 10971))))))));
}

static inline bool sym__times_operator_character_set_3(int32_t c) {
  return (c < 10193
    ? (c < 8768
      ? (c < 8523
        ? (c < '\\'
          ? (c < '*'
            ? (c >= '%' && c <= '&')
            : c <= '*')
          : (c <= '\\' || (c < 247
            ? c == 215
            : c <= 247)))
        : (c <= 8523 || (c < 8743
          ? (c < 8740
            ? (c >= 8727 && c <= 8729)
            : c <= 8740)
          : (c <= 8743 || c == 8745))))
      : (c <= 8768 || (c < 8900
        ? (c < 8855
          ? (c < 8851
            ? c == 8845
            : c <= 8851)
          : (c <= 8859 || (c < 8892
            ? (c >= 8864 && c <= 8865)
            : c <= 8892)))
        : (c <= 8903 || (c < 8914
          ? (c < 8911
            ? (c >= 8905 && c <= 8908)
            : c <= 8911)
          : (c <= 8914 || c == 9655))))))
    : (c <= 10193 || (c < 10819
      ? (c < 10759
        ? (c < 10684
          ? (c < 10680
            ? (c >= 10197 && c <= 10199)
            : c <= 10680)
          : (c <= 10684 || (c < 10742
            ? (c >= 10686 && c <= 10687)
            : c <= 10743)))
        : (c <= 10759 || (c < 10811
          ? (c < 10800
            ? c == 10781
            : c <= 10808)
          : (c <= 10813 || c == 10816))))
      : (c <= 10820 || (c < 10840
        ? (c < 10833
          ? (c < 10829
            ? c == 10827
            : c <= 10830)
          : (c <= 10833 || (c < 10837
            ? c == 10835
            : c <= 10837)))
        : (c <= 10840 || (c < 10846
          ? (c < 10844
            ? c == 10842
            : c <= 10844)
          : (c <= 10848 || c == 10971))))))));
}

static inline bool sym__times_operator_character_set_4(int32_t c) {
  return (c < 8911
    ? (c < 8743
      ? (c < 247
        ? (c < '\\'
          ? (c < '*'
            ? (c >= '%' && c <= '&')
            : c <= '*')
          : (c <= '\\' || c == 215))
        : (c <= 247 || (c < 8727
          ? c == 8523
          : (c <= 8729 || c == 8740))))
      : (c <= 8745 || (c < 8864
        ? (c < 8845
          ? c == 8768
          : (c <= 8845 || (c >= 8851 && c <= 8859)))
        : (c <= 8865 || (c < 8900
          ? c == 8892
          : (c <= 8903 || (c >= 8905 && c <= 8908)))))))
    : (c <= 8911 || (c < 10742
      ? (c < 10197
        ? (c < 9655
          ? c == 8914
          : (c <= 9655 || c == 10193))
        : (c <= 10199 || (c < 10684
          ? c == 10680
          : (c <= 10684 || (c >= 10686 && c <= 10687)))))
      : (c <= 10743 || (c < 10816
        ? (c < 10781
          ? c == 10759
          : (c <= 10781 || (c >= 10800 && c <= 10813)))
        : (c <= 10820 || (c < 10842
          ? (c >= 10827 && c <= 10840)
          : (c <= 10848 || c == 10971))))))));
}

static inline bool sym__times_operator_character_set_5(int32_t c) {
  return (c < 8911
    ? (c < 8743
      ? (c < 247
        ? (c < '\\'
          ? (c < '*'
            ? c == '%'
            : c <= '*')
          : (c <= '\\' || c == 215))
        : (c <= 247 || (c < 8727
          ? c == 8523
          : (c <= 8729 || c == 8740))))
      : (c <= 8745 || (c < 8864
        ? (c < 8845
          ? c == 8768
          : (c <= 8845 || (c >= 8851 && c <= 8859)))
        : (c <= 8865 || (c < 8900
          ? c == 8892
          : (c <= 8903 || (c >= 8905 && c <= 8908)))))))
    : (c <= 8911 || (c < 10742
      ? (c < 10197
        ? (c < 9655
          ? c == 8914
          : (c <= 9655 || c == 10193))
        : (c <= 10199 || (c < 10684
          ? c == 10680
          : (c <= 10684 || (c >= 10686 && c <= 10687)))))
      : (c <= 10743 || (c < 10816
        ? (c < 10781
          ? c == 10759
          : (c <= 10781 || (c >= 10800 && c <= 10813)))
        : (c <= 10820 || (c < 10842
          ? (c >= 10827 && c <= 10840)
          : (c <= 10848 || c == 10971))))))));
}

static inline bool sym__plus_operator_character_set_1(int32_t c) {
  return (c < 10760
    ? (c < 8846
      ? (c < 8746
        ? (c < 8723
          ? c == 177
          : (c <= 8724 || c == 8744))
        : (c <= 8746 || (c < 8783
          ? c == 8760
          : c <= 8783)))
      : (c <= 8846 || (c < 8910
        ? (c < 8862
          ? (c >= 8852 && c <= 8854)
          : (c <= 8863 || c == 8893))
        : (c <= 8910 || (c < 10746
          ? c == 8915
          : c <= 10747)))))
    : (c <= 10760 || (c < 10831
      ? (c < 10821
        ? (c < 10809
          ? (c >= 10786 && c <= 10798)
          : (c <= 10810 || (c >= 10817 && c <= 10818)))
        : (c <= 10821 || (c < 10828
          ? c == 10826
          : c <= 10828)))
      : (c <= 10832 || (c < 10843
        ? (c < 10836
          ? c == 10834
          : (c <= 10836 || (c >= 10838 && c <= 10839)))
        : (c <= 10843 || (c < 10849
          ? c == 10845
          : c <= 10851)))))));
}

static inline bool sym__plus_operator_character_set_2(int32_t c) {
  return (c < 8910
    ? (c < 8783
      ? (c < 8744
        ? (c < 8723
          ? c == 177
          : c <= 8724)
        : (c <= 8746 || c == 8760))
      : (c <= 8783 || (c < 8862
        ? (c < 8852
          ? c == 8846
          : c <= 8854)
        : (c <= 8863 || (c >= 8891 && c <= 8893)))))
    : (c <= 8910 || (c < 10809
      ? (c < 10760
        ? (c < 10746
          ? c == 8915
          : c <= 10747)
        : (c <= 10760 || (c >= 10786 && c <= 10798)))
      : (c <= 10810 || (c < 10826
        ? (c >= 10817 && c <= 10821)
        : (c <= 10839 || (c >= 10843 && c <= 10851)))))));
}

static inline bool sym__plus_operator_character_set_3(int32_t c) {
  return (c < 8891
    ? (c < 8760
      ? (c < 8723
        ? (c < 177
          ? c == '|'
          : c <= 177)
        : (c <= 8724 || (c >= 8744 && c <= 8746)))
      : (c <= 8760 || (c < 8852
        ? (c < 8846
          ? c == 8783
          : c <= 8846)
        : (c <= 8854 || (c >= 8862 && c <= 8863)))))
    : (c <= 8893 || (c < 10786
      ? (c < 10746
        ? (c < 8915
          ? c == 8910
          : c <= 8915)
        : (c <= 10747 || c == 10760))
      : (c <= 10798 || (c < 10826
        ? (c < 10817
          ? (c >= 10809 && c <= 10810)
          : c <= 10821)
        : (c <= 10839 || (c >= 10843 && c <= 10851)))))));
}

static inline bool sym__plus_operator_character_set_4(int32_t c) {
  return (c < 10746
    ? (c < 8783
      ? (c < 8723
        ? (c < '|'
          ? c == '$'
          : (c <= '|' || c == 177))
        : (c <= 8724 || (c < 8746
          ? c == 8744
          : (c <= 8746 || c == 8760))))
      : (c <= 8783 || (c < 8891
        ? (c < 8852
          ? c == 8846
          : (c <= 8854 || (c >= 8862 && c <= 8863)))
        : (c <= 8891 || (c < 8910
          ? c == 8893
          : (c <= 8910 || c == 8915))))))
    : (c <= 10747 || (c < 10831
      ? (c < 10817
        ? (c < 10786
          ? c == 10760
          : (c <= 10798 || (c >= 10809 && c <= 10810)))
        : (c <= 10818 || (c < 10826
          ? c == 10821
          : (c <= 10826 || c == 10828))))
      : (c <= 10832 || (c < 10843
        ? (c < 10836
          ? c == 10834
          : (c <= 10836 || (c >= 10838 && c <= 10839)))
        : (c <= 10843 || (c < 10849
          ? c == 10845
          : c <= 10851)))))));
}

static inline bool sym__plus_operator_character_set_5(int32_t c) {
  return (c < 10746
    ? (c < 8846
      ? (c < 8744
        ? (c < 177
          ? c == '$'
          : (c <= 177 || (c >= 8723 && c <= 8724)))
        : (c <= 8744 || (c < 8760
          ? c == 8746
          : (c <= 8760 || c == 8783))))
      : (c <= 8846 || (c < 8893
        ? (c < 8862
          ? (c >= 8852 && c <= 8854)
          : (c <= 8863 || c == 8891))
        : (c <= 8893 || (c < 8915
          ? c == 8910
          : c <= 8915)))))
    : (c <= 10747 || (c < 10831
      ? (c < 10817
        ? (c < 10786
          ? c == 10760
          : (c <= 10798 || (c >= 10809 && c <= 10810)))
        : (c <= 10818 || (c < 10826
          ? c == 10821
          : (c <= 10826 || c == 10828))))
      : (c <= 10832 || (c < 10843
        ? (c < 10836
          ? c == 10834
          : (c <= 10836 || (c >= 10838 && c <= 10839)))
        : (c <= 10843 || (c < 10849
          ? c == 10845
          : c <= 10851)))))));
}

static inline bool sym__plus_operator_character_set_6(int32_t c) {
  return (c < 8891
    ? (c < 8760
      ? (c < 177
        ? (c < '|'
          ? c == '-'
          : c <= '|')
        : (c <= 177 || (c < 8744
          ? (c >= 8723 && c <= 8724)
          : c <= 8746)))
      : (c <= 8760 || (c < 8852
        ? (c < 8846
          ? c == 8783
          : c <= 8846)
        : (c <= 8854 || (c >= 8862 && c <= 8863)))))
    : (c <= 8893 || (c < 10786
      ? (c < 10746
        ? (c < 8915
          ? c == 8910
          : c <= 8915)
        : (c <= 10747 || c == 10760))
      : (c <= 10798 || (c < 10826
        ? (c < 10817
          ? (c >= 10809 && c <= 10810)
          : c <= 10821)
        : (c <= 10839 || (c >= 10843 && c <= 10851)))))));
}

static inline bool sym__comparison_operator_character_set_1(int32_t c) {
  return (c < 8880
    ? (c < 8771
      ? (c < 8759
        ? (c < 8733
          ? (c >= 8713 && c <= 8717)
          : (c <= 8733 || (c >= 8741 && c <= 8742)))
        : (c <= 8759 || (c < 8765
          ? (c >= 8762 && c <= 8763)
          : (c <= 8766 || c == 8769))))
      : (c <= 8787 || (c < 8873
        ? (c < 8847
          ? (c >= 8790 && c <= 8843)
          : (c <= 8860 || (c >= 8866 && c <= 8867)))
        : (c <= 8873 || (c < 8878
          ? c == 8876
          : c <= 8878)))))
    : (c <= 8887 || (c < 10688
      ? (c < 10184
        ? (c < 8917
          ? (c >= 8909 && c <= 8913)
          : (c <= 8959 || c == 10178))
        : (c <= 10185 || (c < 10679
          ? c == 10194
          : c <= 10679)))
      : (c <= 10689 || (c < 10858
        ? (c < 10723
          ? c == 10721
          : (c <= 10725 || (c >= 10854 && c <= 10855)))
        : (c <= 10867 || (c < 10999
          ? (c >= 10869 && c <= 10969)
          : c <= 11002)))))));
}

static inline bool sym__comparison_operator_character_set_2(int32_t c) {
  return (c < 8880
    ? (c < 8771
      ? (c < 8759
        ? (c < 8733
          ? (c >= 8712 && c <= 8717)
          : (c <= 8733 || (c >= 8741 && c <= 8742)))
        : (c <= 8759 || (c < 8765
          ? (c >= 8762 && c <= 8763)
          : (c <= 8766 || c == 8769))))
      : (c <= 8787 || (c < 8873
        ? (c < 8847
          ? (c >= 8790 && c <= 8843)
          : (c <= 8860 || (c >= 8866 && c <= 8867)))
        : (c <= 8873 || (c < 8878
          ? c == 8876
          : c <= 8878)))))
    : (c <= 8887 || (c < 10688
      ? (c < 10184
        ? (c < 8917
          ? (c >= 8909 && c <= 8913)
          : (c <= 8959 || c == 10178))
        : (c <= 10185 || (c < 10679
          ? c == 10194
          : c <= 10679)))
      : (c <= 10689 || (c < 10858
        ? (c < 10723
          ? c == 10721
          : (c <= 10725 || (c >= 10854 && c <= 10855)))
        : (c <= 10867 || (c < 10999
          ? (c >= 10869 && c <= 10969)
          : c <= 11002)))))));
}

static inline bool sym__comparison_operator_character_set_3(int32_t c) {
  return (c < 8880
    ? (c < 8769
      ? (c < 8759
        ? (c < 8733
          ? (c >= 8712 && c <= 8717)
          : (c <= 8733 || (c >= 8741 && c <= 8742)))
        : (c <= 8759 || (c < 8765
          ? (c >= 8762 && c <= 8763)
          : c <= 8766)))
      : (c <= 8769 || (c < 8873
        ? (c < 8847
          ? (c >= 8771 && c <= 8843)
          : (c <= 8860 || (c >= 8866 && c <= 8867)))
        : (c <= 8873 || (c < 8878
          ? c == 8876
          : c <= 8878)))))
    : (c <= 8887 || (c < 10688
      ? (c < 10184
        ? (c < 8917
          ? (c >= 8909 && c <= 8913)
          : (c <= 8959 || c == 10178))
        : (c <= 10185 || (c < 10679
          ? c == 10194
          : c <= 10679)))
      : (c <= 10689 || (c < 10854
        ? (c < 10723
          ? c == 10721
          : c <= 10725)
        : (c <= 10855 || (c < 10999
          ? (c >= 10858 && c <= 10969)
          : c <= 11002)))))));
}

static inline bool sym__arrow_operator_character_set_1(int32_t c) {
  return (c < 10229
    ? (c < 8644
      ? (c < 8610
        ? (c < 8596
          ? (c < 8594
            ? c == 8592
            : c <= 8594)
          : (c <= 8596 || (c < 8608
            ? (c >= 8602 && c <= 8606)
            : c <= 8608)))
        : (c <= 8612 || (c < 8622
          ? (c < 8617
            ? c == 8614
            : c <= 8620)
          : (c <= 8622 || (c < 8640
            ? (c >= 8636 && c <= 8637)
            : c <= 8641)))))
      : (c <= 8644 || (c < 8666
        ? (c < 8651
          ? (c < 8649
            ? (c >= 8646 && c <= 8647)
            : c <= 8649)
          : (c <= 8656 || (c < 8660
            ? c == 8658
            : c <= 8660)))
        : (c <= 8669 || (c < 8692
          ? (c < 8674
            ? c == 8672
            : c <= 8674)
          : (c <= 8692 || (c >= 8694 && c <= 8703)))))))
    : (c <= 10231 || (c < 10586
      ? (c < 10564
        ? (c < 10508
          ? (c < 10496
            ? (c >= 10233 && c <= 10239)
            : c <= 10503)
          : (c <= 10513 || (c < 10525
            ? (c >= 10516 && c <= 10520)
            : c <= 10528)))
        : (c <= 10568 || (c < 10576
          ? (c < 10574
            ? (c >= 10570 && c <= 10571)
            : c <= 10574)
          : (c <= 10576 || (c < 10582
            ? (c >= 10578 && c <= 10579)
            : c <= 10583)))))
      : (c <= 10587 || (c < 10740
        ? (c < 10596
          ? (c < 10594
            ? (c >= 10590 && c <= 10591)
            : c <= 10594)
          : (c <= 10596 || (c < 10608
            ? (c >= 10598 && c <= 10605)
            : c <= 10608)))
        : (c <= 10740 || (c < 65513
          ? (c < 11079
            ? (c >= 11056 && c <= 11076)
            : c <= 11084)
          : (c <= 65513 || c == 65515))))))));
}

static inline bool sym__arrow_operator_character_set_2(int32_t c) {
  return (c < 8660
    ? (c < 8636
      ? (c < 8610
        ? (c < 8602
          ? (c >= 8592 && c <= 8596)
          : (c <= 8606 || c == 8608))
        : (c <= 8612 || (c < 8617
          ? c == 8614
          : (c <= 8620 || c == 8622))))
      : (c <= 8637 || (c < 8649
        ? (c < 8644
          ? (c >= 8640 && c <= 8641)
          : (c <= 8644 || (c >= 8646 && c <= 8647)))
        : (c <= 8649 || (c < 8658
          ? (c >= 8651 && c <= 8656)
          : c <= 8658)))))
    : (c <= 8660 || (c < 10496
      ? (c < 8692
        ? (c < 8672
          ? (c >= 8666 && c <= 8669)
          : (c <= 8672 || c == 8674))
        : (c <= 8703 || (c < 10233
          ? (c >= 10229 && c <= 10231)
          : c <= 10239)))
      : (c <= 10520 || (c < 11056
        ? (c < 10564
          ? (c >= 10525 && c <= 10528)
          : (c <= 10608 || c == 10740))
        : (c <= 11076 || (c < 65513
          ? (c >= 11079 && c <= 11084)
          : c <= 65515)))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(94);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(171);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(189);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (lookahead == 8712) ADVANCE(133);
      if (sym__comparison_operator_character_set_1(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(92)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(110);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(172);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(172);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(212);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(220);
      if (lookahead == '!') ADVANCE(161);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '$') ADVANCE(135);
      if (aux_sym_character_literal_token1_character_set_1(lookahead)) ADVANCE(153);
      if (lookahead == '&') ADVANCE(157);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == '-') ADVANCE(158);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(159);
      if (lookahead == '=') ADVANCE(162);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(190);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(153);
      if (lookahead == '|') ADVANCE(163);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(153);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(153);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(153);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(153);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(153);
      if (lookahead == 8770) ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(154);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      if (lookahead != 0) ADVANCE(153);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(171);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(171);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 20:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 21:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(169);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(110);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 22:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(172);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 23:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_2(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(172);
      if (lookahead == '.') ADVANCE(114);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(191);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 24:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == '<') ADVANCE(206);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 25:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_4(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_4(lookahead)) ADVANCE(183);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == '<') ADVANCE(212);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 26:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_4(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_4(lookahead)) ADVANCE(183);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(115);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '<') ADVANCE(212);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(214);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 27:
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(188);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(168);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(218);
      if (lookahead == '>') ADVANCE(210);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 28:
      if (lookahead == '!') ADVANCE(174);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(211);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 29:
      if (lookahead == '!') ADVANCE(174);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.' ||
          lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(211);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 30:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 31:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(31)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 32:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(196);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(33)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 33:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(196);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(33)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 34:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(35)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 35:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(35)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 36:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_5(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_5(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(194);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(37)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 37:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_5(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_5(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(194);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(37)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 38:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_5(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_5(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(197);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(39)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 39:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_5(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_5(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(197);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(39)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 40:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_5(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_5(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(194);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(40)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 41:
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (sym__plus_operator_character_set_5(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_5(lookahead)) ADVANCE(183);
      if (lookahead == '&') ADVANCE(184);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(194);
      if (lookahead == '.') ADVANCE(117);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == ':') ADVANCE(110);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(205);
      if (lookahead == '=') ADVANCE(57);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == '|') ADVANCE(200);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(40)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 42:
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(69);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == 8712) ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(43)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(138);
      END_STATE();
    case 43:
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '.') ADVANCE(112);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '\\') ADVANCE(69);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == 8712) ADVANCE(133);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(43)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(138);
      END_STATE();
    case 44:
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(54);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '&') ADVANCE(54);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(54);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '.') ADVANCE(46);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead == ':') ADVANCE(52);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(53);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(59);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '^') ADVANCE(54);
      if (lookahead == '|') ADVANCE(54);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 247) ADVANCE(54);
      if (lookahead == 8891) ADVANCE(54);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(44)
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(138);
      END_STATE();
    case 45:
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '\\') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(153);
      END_STATE();
    case 46:
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '&') ADVANCE(54);
      if (lookahead == '*') ADVANCE(54);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead == '<') ADVANCE(53);
      if (lookahead == '=' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == '>') ADVANCE(59);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '^') ADVANCE(54);
      if (lookahead == '|') ADVANCE(54);
      if (lookahead == 247) ADVANCE(54);
      if (lookahead == 8891) ADVANCE(54);
      END_STATE();
    case 47:
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '&') ADVANCE(54);
      if (lookahead == '*') ADVANCE(54);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead == '<') ADVANCE(53);
      if (lookahead == '=' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == '>') ADVANCE(59);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '^') ADVANCE(54);
      if (lookahead == '|') ADVANCE(54);
      if (lookahead == 247) ADVANCE(54);
      if (lookahead == 8891) ADVANCE(54);
      END_STATE();
    case 48:
      if (lookahead == '-') ADVANCE(216);
      END_STATE();
    case 49:
      if (lookahead == '.') ADVANCE(105);
      END_STATE();
    case 50:
      if (lookahead == '.') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(141);
      END_STATE();
    case 51:
      if (lookahead == '/') ADVANCE(54);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 52:
      if (lookahead == ':') ADVANCE(106);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 53:
      if (lookahead == '<') ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 55:
      if (lookahead == '=') ADVANCE(217);
      if (lookahead == '>') ADVANCE(54);
      END_STATE();
    case 56:
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 57:
      if (lookahead == '=') ADVANCE(209);
      if (lookahead == '>') ADVANCE(131);
      END_STATE();
    case 58:
      if (lookahead == '>') ADVANCE(215);
      END_STATE();
    case 59:
      if (lookahead == '>') ADVANCE(55);
      END_STATE();
    case 60:
      if (lookahead == '_') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 61:
      if (lookahead == '_') ADVANCE(61);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(139);
      END_STATE();
    case 62:
      if (lookahead == '_') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(140);
      END_STATE();
    case 63:
      if (lookahead == '_') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(141);
      END_STATE();
    case 64:
      if (lookahead == '_') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 65:
      if (lookahead == '_') ADVANCE(66);
      if (lookahead == 'p') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '_') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 67:
      if (lookahead == '_') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 69:
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(145);
      END_STATE();
    case 70:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 71:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(139);
      END_STATE();
    case 72:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(140);
      END_STATE();
    case 73:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 74:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(145);
      END_STATE();
    case 75:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(152);
      END_STATE();
    case 76:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(65);
      END_STATE();
    case 77:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 78:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(171);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(79)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 79:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(171);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(79)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 80:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(83)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 81:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(82)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 82:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(82)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 83:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(83)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 84:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(170);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(84)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 85:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(86)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 86:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(86)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 87:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(88)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 88:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(195);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(88)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 89:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(196);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '[') ADVANCE(121);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(90)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 90:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(198);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(196);
      if (lookahead == '.') ADVANCE(116);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_3(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(90)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      END_STATE();
    case 91:
      if (eof) ADVANCE(94);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(54);
      if (lookahead == '%') ADVANCE(54);
      if (lookahead == '&') ADVANCE(54);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(54);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(54);
      if (lookahead == '.') ADVANCE(47);
      if (lookahead == '/') ADVANCE(51);
      if (lookahead == ':') ADVANCE(54);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(53);
      if (lookahead == '=') ADVANCE(102);
      if (lookahead == '>') ADVANCE(59);
      if (lookahead == '\\') ADVANCE(54);
      if (lookahead == '^') ADVANCE(54);
      if (lookahead == '|') ADVANCE(54);
      if (lookahead == '~' ||
          lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 247) ADVANCE(54);
      if (lookahead == 8891) ADVANCE(54);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(91)
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(138);
      END_STATE();
    case 92:
      if (eof) ADVANCE(94);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(136);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(171);
      if (lookahead == '.') ADVANCE(113);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(120);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(204);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(213);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == '\\') ADVANCE(189);
      if (lookahead == ']') ADVANCE(122);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(199);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '~') ADVANCE(166);
      if (lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (lookahead == 8712) ADVANCE(133);
      if (sym__comparison_operator_character_set_1(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(92)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 93:
      if (eof) ADVANCE(94);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '#') ADVANCE(221);
      if (lookahead == '$') ADVANCE(135);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == ')') ADVANCE(100);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == ',') ADVANCE(99);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(118);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(212);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(214);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (lookahead == ']') ADVANCE(122);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(93)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(138);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_primitive_definition_token1);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '_') ADVANCE(60);
      if (lookahead == 'b') ADVANCE(71);
      if (lookahead == 'o') ADVANCE(72);
      if (lookahead == 'x') ADVANCE(50);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_primitive_definition_token1);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '_') ADVANCE(60);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_primitive_definition_token1);
      if (lookahead == '_') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(97);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(209);
      if (lookahead == '>') ADVANCE(131);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT_COLON);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(106);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(106);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!') ADVANCE(174);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(188);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(168);
      if (lookahead == '-') ADVANCE(173);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(218);
      if (lookahead == '>') ADVANCE(210);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(198);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!') ADVANCE(174);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(211);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!') ADVANCE(174);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.' ||
          lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(211);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!') ADVANCE(56);
      if (lookahead == '%') ADVANCE(188);
      if (lookahead == '&') ADVANCE(188);
      if (lookahead == '*') ADVANCE(188);
      if (lookahead == '+') ADVANCE(193);
      if (lookahead == '-') ADVANCE(198);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(186);
      if (lookahead == '<') ADVANCE(207);
      if (lookahead == '=') ADVANCE(218);
      if (lookahead == '>') ADVANCE(210);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead == '^') ADVANCE(176);
      if (lookahead == '|') ADVANCE(198);
      if (sym__plus_operator_character_set_1(lookahead)) ADVANCE(191);
      if (sym__times_operator_character_set_1(lookahead)) ADVANCE(183);
      if (lookahead == 247) ADVANCE(188);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_1(lookahead)) ADVANCE(215);
      if ((8593 <= lookahead && lookahead <= 8595) ||
          lookahead == 8693 ||
          lookahead == 10224 ||
          lookahead == 10225 ||
          (10504 <= lookahead && lookahead <= 10515) ||
          (10569 <= lookahead && lookahead <= 10607) ||
          (65514 <= lookahead && lookahead <= 65516)) ADVANCE(175);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (lookahead == 8788 ||
          lookahead == 8789 ||
          lookahead == 10868) ADVANCE(217);
      if (lookahead == 8891) ADVANCE(198);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '!') ADVANCE(56);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '+') ADVANCE(192);
      if (sym__plus_operator_character_set_6(lookahead)) ADVANCE(191);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(211);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(106);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(106);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(191);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(191);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT_PIPE);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PIPE_GT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_identifier);
      if (!sym_identifier_character_set_5(lookahead)) ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_integer_literal_token1);
      if (lookahead == '_') ADVANCE(61);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_integer_literal_token2);
      if (lookahead == '_') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_integer_literal_token3);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '_') ADVANCE(63);
      if (lookahead == 'p') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(64);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_float_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(145);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(146);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(145);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(148);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(150);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(151);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '\n') ADVANCE(220);
      if (lookahead == '!') ADVANCE(161);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '$') ADVANCE(135);
      if (aux_sym_character_literal_token1_character_set_1(lookahead)) ADVANCE(153);
      if (lookahead == '&') ADVANCE(157);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '+') ADVANCE(124);
      if (lookahead == '-') ADVANCE(158);
      if (lookahead == '.') ADVANCE(155);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '0') ADVANCE(95);
      if (lookahead == ':') ADVANCE(119);
      if (lookahead == ';') ADVANCE(101);
      if (lookahead == '<') ADVANCE(159);
      if (lookahead == '=') ADVANCE(162);
      if (lookahead == '>') ADVANCE(164);
      if (lookahead == '?') ADVANCE(130);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(132);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(153);
      if (lookahead == '|') ADVANCE(163);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(153);
      if (sym__plus_operator_character_set_2(lookahead)) ADVANCE(153);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(153);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(153);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(153);
      if (lookahead == 8770) ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(154);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(96);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(138);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '!') ADVANCE(174);
      if (sym__times_operator_character_set_3(lookahead)) ADVANCE(183);
      if (lookahead == '+') ADVANCE(167);
      if (lookahead == '-') ADVANCE(166);
      if (lookahead == '.') ADVANCE(202);
      if (lookahead == '/') ADVANCE(187);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(56);
      if (lookahead == '>') ADVANCE(211);
      if (sym__power_operator_character_set_1(lookahead)) ADVANCE(175);
      if (sym__plus_operator_character_set_3(lookahead)) ADVANCE(191);
      if (lookahead == '~' ||
          lookahead == 172 ||
          (8730 <= lookahead && lookahead <= 8732)) ADVANCE(166);
      if (lookahead == 8230 ||
          lookahead == 8285 ||
          (8942 <= lookahead && lookahead <= 8945)) ADVANCE(201);
      if (sym__arrow_operator_character_set_2(lookahead)) ADVANCE(215);
      if (sym__comparison_operator_character_set_2(lookahead)) ADVANCE(203);
      if (lookahead == 8770) ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(142);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '&') ADVANCE(129);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '-') ADVANCE(58);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == ':') ADVANCE(109);
      if (lookahead == '<') ADVANCE(177);
      if (lookahead == '=') ADVANCE(203);
      if (lookahead == '|') ADVANCE(126);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '/') ADVANCE(181);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '=') ADVANCE(209);
      if (lookahead == '>') ADVANCE(131);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '|') ADVANCE(128);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == ':' ||
          lookahead == '=') ADVANCE(203);
      if (lookahead == '>') ADVANCE(180);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(221);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__unary_operator);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '+') ADVANCE(191);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '+') ADVANCE(191);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '-') ADVANCE(58);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '=') ADVANCE(217);
      if (lookahead == '>') ADVANCE(134);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '>') ADVANCE(134);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym__power_operator);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym__power_operator);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym__bitshift_operator);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '=') ADVANCE(217);
      if (lookahead == '>') ADVANCE(178);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '>') ADVANCE(177);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym__rational_operator);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym__rational_operator);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym__times_operator);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '&') ADVANCE(129);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '&') ADVANCE(129);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '/') ADVANCE(181);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '=') ADVANCE(217);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(145);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(145);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym__plus_operator);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '+') ADVANCE(191);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '+') ADVANCE(191);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '-') ADVANCE(58);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '=') ADVANCE(217);
      if (lookahead == '>') ADVANCE(134);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '-') ADVANCE(58);
      if (lookahead == '>') ADVANCE(134);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '=') ADVANCE(217);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '=') ADVANCE(217);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '|') ADVANCE(128);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '>') ADVANCE(127);
      if (lookahead == '|') ADVANCE(128);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(sym__dotty_operator);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(sym__dotty_operator);
      if (lookahead == '.') ADVANCE(105);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(sym__comparison_operator);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == ':') ADVANCE(109);
      if (lookahead == '<') ADVANCE(178);
      if (lookahead == '=') ADVANCE(203);
      if (lookahead == '|') ADVANCE(126);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == ':') ADVANCE(109);
      if (lookahead == '<') ADVANCE(177);
      if (lookahead == '=') ADVANCE(203);
      if (lookahead == '|') ADVANCE(126);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':') ADVANCE(109);
      if (lookahead == '<') ADVANCE(177);
      if (lookahead == '=') ADVANCE(203);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '<') ADVANCE(178);
      if (lookahead == '=') ADVANCE(203);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '<') ADVANCE(177);
      if (lookahead == '=') ADVANCE(203);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '=') ADVANCE(203);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '=') ADVANCE(203);
      if (lookahead == '>') ADVANCE(179);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '=') ADVANCE(203);
      if (lookahead == '>') ADVANCE(180);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':' ||
          lookahead == '=') ADVANCE(203);
      if (lookahead == '<') ADVANCE(177);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':' ||
          lookahead == '=') ADVANCE(203);
      if (lookahead == '>') ADVANCE(179);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':' ||
          lookahead == '=') ADVANCE(203);
      if (lookahead == '>') ADVANCE(180);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym__arrow_operator);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym__arrow_operator);
      if (lookahead == '>') ADVANCE(215);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym__assign_operator);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym__assign_operator);
      if (lookahead == '=') ADVANCE(209);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(219);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(220);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(154);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(221);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'p') ADVANCE(10);
      if (lookahead == 'q') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'w') ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(17);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(18);
      if (lookahead == 'r') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(23);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'x') ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'i') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      if (lookahead == 'u') ADVANCE(28);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(29);
      if (lookahead == 'm') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      if (lookahead == 's') ADVANCE(32);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      if (lookahead == 'u') ADVANCE(36);
      END_STATE();
    case 10:
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 11:
      if (lookahead == 'u') ADVANCE(38);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 13:
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 'y') ADVANCE(42);
      END_STATE();
    case 15:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(44);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 18:
      if (lookahead == 'g') ADVANCE(46);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(48);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(49);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(50);
      END_STATE();
    case 24:
      if (lookahead == 'd') ADVANCE(51);
      END_STATE();
    case 25:
      if (lookahead == 'p') ADVANCE(52);
      END_STATE();
    case 26:
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 27:
      if (lookahead == 'r') ADVANCE(54);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(55);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 30:
      if (lookahead == 'p') ADVANCE(56);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(57);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 34:
      if (lookahead == 'c') ADVANCE(59);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(60);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 37:
      if (lookahead == 'i') ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(64);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(65);
      END_STATE();
    case 41:
      if (lookahead == 'y') ADVANCE(66);
      END_STATE();
    case 42:
      if (lookahead == 'p') ADVANCE(67);
      END_STATE();
    case 43:
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(72);
      END_STATE();
    case 48:
      if (lookahead == 'c') ADVANCE(73);
      END_STATE();
    case 49:
      if (lookahead == 's') ADVANCE(74);
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 53:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 55:
      if (lookahead == 'c') ADVANCE(79);
      END_STATE();
    case 56:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_isa);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 59:
      if (lookahead == 'r') ADVANCE(81);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 61:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 62:
      if (lookahead == 'm') ADVANCE(84);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(85);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 65:
      if (lookahead == 'u') ADVANCE(87);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(88);
      END_STATE();
    case 68:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(90);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(91);
      END_STATE();
    case 71:
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 72:
      if (lookahead == 'k') ADVANCE(93);
      END_STATE();
    case 73:
      if (lookahead == 'h') ADVANCE(94);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(97);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(98);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(99);
      END_STATE();
    case 79:
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(101);
      END_STATE();
    case 81:
      if (lookahead == 'o') ADVANCE(102);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(103);
      END_STATE();
    case 83:
      if (lookahead == 'b') ADVANCE(104);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(105);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(107);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(108);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 89:
      if (lookahead == 'g') ADVANCE(109);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(110);
      END_STATE();
    case 91:
      if (lookahead == 'a') ADVANCE(111);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(112);
      END_STATE();
    case 97:
      if (lookahead == 'f') ADVANCE(113);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(115);
      END_STATE();
    case 100:
      if (lookahead == 'i') ADVANCE(116);
      END_STATE();
    case 101:
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_macro);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 104:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 107:
      if (lookahead == 'n') ADVANCE(121);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 111:
      if (lookahead == 'c') ADVANCE(123);
      END_STATE();
    case 112:
      if (lookahead == 'u') ADVANCE(124);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 115:
      if (lookahead == 'y') ADVANCE(125);
      END_STATE();
    case 116:
      if (lookahead == 'o') ADVANCE(126);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 126:
      if (lookahead == 'n') ADVANCE(131);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 128:
      if (lookahead == 'v') ADVANCE(132);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_primitive);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 93, .external_lex_state = 2},
  [2] = {.lex_state = 78, .external_lex_state = 3},
  [3] = {.lex_state = 84, .external_lex_state = 4},
  [4] = {.lex_state = 84, .external_lex_state = 4},
  [5] = {.lex_state = 84, .external_lex_state = 2},
  [6] = {.lex_state = 84, .external_lex_state = 2},
  [7] = {.lex_state = 84, .external_lex_state = 2},
  [8] = {.lex_state = 84, .external_lex_state = 2},
  [9] = {.lex_state = 84, .external_lex_state = 4},
  [10] = {.lex_state = 84, .external_lex_state = 4},
  [11] = {.lex_state = 1, .external_lex_state = 2},
  [12] = {.lex_state = 16, .external_lex_state = 4},
  [13] = {.lex_state = 1, .external_lex_state = 2},
  [14] = {.lex_state = 1, .external_lex_state = 2},
  [15] = {.lex_state = 1, .external_lex_state = 2},
  [16] = {.lex_state = 1, .external_lex_state = 2},
  [17] = {.lex_state = 1, .external_lex_state = 2},
  [18] = {.lex_state = 16, .external_lex_state = 4},
  [19] = {.lex_state = 1, .external_lex_state = 2},
  [20] = {.lex_state = 84, .external_lex_state = 2},
  [21] = {.lex_state = 1, .external_lex_state = 2},
  [22] = {.lex_state = 84, .external_lex_state = 2},
  [23] = {.lex_state = 84, .external_lex_state = 4},
  [24] = {.lex_state = 84, .external_lex_state = 4},
  [25] = {.lex_state = 16, .external_lex_state = 4},
  [26] = {.lex_state = 84, .external_lex_state = 4},
  [27] = {.lex_state = 84, .external_lex_state = 4},
  [28] = {.lex_state = 17, .external_lex_state = 4},
  [29] = {.lex_state = 16, .external_lex_state = 2},
  [30] = {.lex_state = 84, .external_lex_state = 4},
  [31] = {.lex_state = 16, .external_lex_state = 2},
  [32] = {.lex_state = 16, .external_lex_state = 2},
  [33] = {.lex_state = 1, .external_lex_state = 4},
  [34] = {.lex_state = 84, .external_lex_state = 4},
  [35] = {.lex_state = 84, .external_lex_state = 4},
  [36] = {.lex_state = 84, .external_lex_state = 4},
  [37] = {.lex_state = 17, .external_lex_state = 4},
  [38] = {.lex_state = 16, .external_lex_state = 2},
  [39] = {.lex_state = 16, .external_lex_state = 4},
  [40] = {.lex_state = 84, .external_lex_state = 4},
  [41] = {.lex_state = 84, .external_lex_state = 2},
  [42] = {.lex_state = 1, .external_lex_state = 4},
  [43] = {.lex_state = 16, .external_lex_state = 2},
  [44] = {.lex_state = 16, .external_lex_state = 2},
  [45] = {.lex_state = 1, .external_lex_state = 2},
  [46] = {.lex_state = 17, .external_lex_state = 2},
  [47] = {.lex_state = 84, .external_lex_state = 2},
  [48] = {.lex_state = 1, .external_lex_state = 2},
  [49] = {.lex_state = 84, .external_lex_state = 4},
  [50] = {.lex_state = 17, .external_lex_state = 2},
  [51] = {.lex_state = 17, .external_lex_state = 4},
  [52] = {.lex_state = 17, .external_lex_state = 4},
  [53] = {.lex_state = 84, .external_lex_state = 4},
  [54] = {.lex_state = 84, .external_lex_state = 2},
  [55] = {.lex_state = 84, .external_lex_state = 2},
  [56] = {.lex_state = 1, .external_lex_state = 2},
  [57] = {.lex_state = 1, .external_lex_state = 2},
  [58] = {.lex_state = 17, .external_lex_state = 2},
  [59] = {.lex_state = 84, .external_lex_state = 2},
  [60] = {.lex_state = 17, .external_lex_state = 2},
  [61] = {.lex_state = 1, .external_lex_state = 4},
  [62] = {.lex_state = 17, .external_lex_state = 4},
  [63] = {.lex_state = 1, .external_lex_state = 2},
  [64] = {.lex_state = 17, .external_lex_state = 2},
  [65] = {.lex_state = 17, .external_lex_state = 4},
  [66] = {.lex_state = 1, .external_lex_state = 4},
  [67] = {.lex_state = 1, .external_lex_state = 2},
  [68] = {.lex_state = 1, .external_lex_state = 2},
  [69] = {.lex_state = 1, .external_lex_state = 2},
  [70] = {.lex_state = 1, .external_lex_state = 2},
  [71] = {.lex_state = 1, .external_lex_state = 2},
  [72] = {.lex_state = 1, .external_lex_state = 2},
  [73] = {.lex_state = 1, .external_lex_state = 2},
  [74] = {.lex_state = 1, .external_lex_state = 2},
  [75] = {.lex_state = 84, .external_lex_state = 2},
  [76] = {.lex_state = 17, .external_lex_state = 2},
  [77] = {.lex_state = 84, .external_lex_state = 2},
  [78] = {.lex_state = 1, .external_lex_state = 2},
  [79] = {.lex_state = 1, .external_lex_state = 2},
  [80] = {.lex_state = 17, .external_lex_state = 2},
  [81] = {.lex_state = 1, .external_lex_state = 2},
  [82] = {.lex_state = 17, .external_lex_state = 2},
  [83] = {.lex_state = 17, .external_lex_state = 4},
  [84] = {.lex_state = 17, .external_lex_state = 2},
  [85] = {.lex_state = 17, .external_lex_state = 4},
  [86] = {.lex_state = 17, .external_lex_state = 2},
  [87] = {.lex_state = 93, .external_lex_state = 2},
  [88] = {.lex_state = 93, .external_lex_state = 2},
  [89] = {.lex_state = 93, .external_lex_state = 2},
  [90] = {.lex_state = 93, .external_lex_state = 2},
  [91] = {.lex_state = 93, .external_lex_state = 2},
  [92] = {.lex_state = 93, .external_lex_state = 2},
  [93] = {.lex_state = 93, .external_lex_state = 2},
  [94] = {.lex_state = 93, .external_lex_state = 2},
  [95] = {.lex_state = 93, .external_lex_state = 2},
  [96] = {.lex_state = 93, .external_lex_state = 2},
  [97] = {.lex_state = 93, .external_lex_state = 2},
  [98] = {.lex_state = 93, .external_lex_state = 2},
  [99] = {.lex_state = 93, .external_lex_state = 2},
  [100] = {.lex_state = 93, .external_lex_state = 2},
  [101] = {.lex_state = 93, .external_lex_state = 2},
  [102] = {.lex_state = 93, .external_lex_state = 2},
  [103] = {.lex_state = 8, .external_lex_state = 2},
  [104] = {.lex_state = 93, .external_lex_state = 2},
  [105] = {.lex_state = 24, .external_lex_state = 2},
  [106] = {.lex_state = 8, .external_lex_state = 2},
  [107] = {.lex_state = 93, .external_lex_state = 2},
  [108] = {.lex_state = 24, .external_lex_state = 2},
  [109] = {.lex_state = 8, .external_lex_state = 2},
  [110] = {.lex_state = 24, .external_lex_state = 2},
  [111] = {.lex_state = 93, .external_lex_state = 2},
  [112] = {.lex_state = 93, .external_lex_state = 2},
  [113] = {.lex_state = 93, .external_lex_state = 2},
  [114] = {.lex_state = 24, .external_lex_state = 2},
  [115] = {.lex_state = 8, .external_lex_state = 2},
  [116] = {.lex_state = 8, .external_lex_state = 2},
  [117] = {.lex_state = 8, .external_lex_state = 2},
  [118] = {.lex_state = 8, .external_lex_state = 2},
  [119] = {.lex_state = 24, .external_lex_state = 2},
  [120] = {.lex_state = 8, .external_lex_state = 2},
  [121] = {.lex_state = 8, .external_lex_state = 2},
  [122] = {.lex_state = 8, .external_lex_state = 2},
  [123] = {.lex_state = 8, .external_lex_state = 2},
  [124] = {.lex_state = 8, .external_lex_state = 2},
  [125] = {.lex_state = 24, .external_lex_state = 2},
  [126] = {.lex_state = 24, .external_lex_state = 2},
  [127] = {.lex_state = 8, .external_lex_state = 2},
  [128] = {.lex_state = 8, .external_lex_state = 2},
  [129] = {.lex_state = 8, .external_lex_state = 2},
  [130] = {.lex_state = 93, .external_lex_state = 2},
  [131] = {.lex_state = 8, .external_lex_state = 2},
  [132] = {.lex_state = 24, .external_lex_state = 2},
  [133] = {.lex_state = 8, .external_lex_state = 2},
  [134] = {.lex_state = 8, .external_lex_state = 2},
  [135] = {.lex_state = 93, .external_lex_state = 2},
  [136] = {.lex_state = 24, .external_lex_state = 2},
  [137] = {.lex_state = 8, .external_lex_state = 2},
  [138] = {.lex_state = 8, .external_lex_state = 2},
  [139] = {.lex_state = 8, .external_lex_state = 2},
  [140] = {.lex_state = 8, .external_lex_state = 2},
  [141] = {.lex_state = 8, .external_lex_state = 2},
  [142] = {.lex_state = 8, .external_lex_state = 2},
  [143] = {.lex_state = 8, .external_lex_state = 2},
  [144] = {.lex_state = 93, .external_lex_state = 2},
  [145] = {.lex_state = 8, .external_lex_state = 2},
  [146] = {.lex_state = 24, .external_lex_state = 2},
  [147] = {.lex_state = 24, .external_lex_state = 2},
  [148] = {.lex_state = 8, .external_lex_state = 2},
  [149] = {.lex_state = 93, .external_lex_state = 2},
  [150] = {.lex_state = 93, .external_lex_state = 2},
  [151] = {.lex_state = 8, .external_lex_state = 2},
  [152] = {.lex_state = 24, .external_lex_state = 2},
  [153] = {.lex_state = 8, .external_lex_state = 2},
  [154] = {.lex_state = 24, .external_lex_state = 2},
  [155] = {.lex_state = 24, .external_lex_state = 2},
  [156] = {.lex_state = 24, .external_lex_state = 2},
  [157] = {.lex_state = 8, .external_lex_state = 2},
  [158] = {.lex_state = 8, .external_lex_state = 2},
  [159] = {.lex_state = 24, .external_lex_state = 2},
  [160] = {.lex_state = 8, .external_lex_state = 2},
  [161] = {.lex_state = 8, .external_lex_state = 2},
  [162] = {.lex_state = 24, .external_lex_state = 2},
  [163] = {.lex_state = 24, .external_lex_state = 2},
  [164] = {.lex_state = 24, .external_lex_state = 2},
  [165] = {.lex_state = 24, .external_lex_state = 2},
  [166] = {.lex_state = 24, .external_lex_state = 2},
  [167] = {.lex_state = 24, .external_lex_state = 2},
  [168] = {.lex_state = 24, .external_lex_state = 2},
  [169] = {.lex_state = 24, .external_lex_state = 2},
  [170] = {.lex_state = 24, .external_lex_state = 2},
  [171] = {.lex_state = 93, .external_lex_state = 2},
  [172] = {.lex_state = 24, .external_lex_state = 2},
  [173] = {.lex_state = 24, .external_lex_state = 2},
  [174] = {.lex_state = 8, .external_lex_state = 2},
  [175] = {.lex_state = 24, .external_lex_state = 2},
  [176] = {.lex_state = 24, .external_lex_state = 2},
  [177] = {.lex_state = 24, .external_lex_state = 2},
  [178] = {.lex_state = 24, .external_lex_state = 2},
  [179] = {.lex_state = 93, .external_lex_state = 2},
  [180] = {.lex_state = 24, .external_lex_state = 2},
  [181] = {.lex_state = 93, .external_lex_state = 2},
  [182] = {.lex_state = 93, .external_lex_state = 2},
  [183] = {.lex_state = 93, .external_lex_state = 2},
  [184] = {.lex_state = 93, .external_lex_state = 2},
  [185] = {.lex_state = 93, .external_lex_state = 2},
  [186] = {.lex_state = 93, .external_lex_state = 2},
  [187] = {.lex_state = 93, .external_lex_state = 2},
  [188] = {.lex_state = 93, .external_lex_state = 2},
  [189] = {.lex_state = 93, .external_lex_state = 2},
  [190] = {.lex_state = 93, .external_lex_state = 2},
  [191] = {.lex_state = 93, .external_lex_state = 2},
  [192] = {.lex_state = 93, .external_lex_state = 2},
  [193] = {.lex_state = 93, .external_lex_state = 2},
  [194] = {.lex_state = 93, .external_lex_state = 2},
  [195] = {.lex_state = 93, .external_lex_state = 2},
  [196] = {.lex_state = 93, .external_lex_state = 2},
  [197] = {.lex_state = 93, .external_lex_state = 2},
  [198] = {.lex_state = 93, .external_lex_state = 2},
  [199] = {.lex_state = 93, .external_lex_state = 2},
  [200] = {.lex_state = 93, .external_lex_state = 2},
  [201] = {.lex_state = 93, .external_lex_state = 2},
  [202] = {.lex_state = 93, .external_lex_state = 2},
  [203] = {.lex_state = 93, .external_lex_state = 2},
  [204] = {.lex_state = 93, .external_lex_state = 2},
  [205] = {.lex_state = 93, .external_lex_state = 2},
  [206] = {.lex_state = 93, .external_lex_state = 2},
  [207] = {.lex_state = 93, .external_lex_state = 2},
  [208] = {.lex_state = 93, .external_lex_state = 2},
  [209] = {.lex_state = 93, .external_lex_state = 2},
  [210] = {.lex_state = 93, .external_lex_state = 2},
  [211] = {.lex_state = 93, .external_lex_state = 2},
  [212] = {.lex_state = 93, .external_lex_state = 2},
  [213] = {.lex_state = 93, .external_lex_state = 2},
  [214] = {.lex_state = 93, .external_lex_state = 2},
  [215] = {.lex_state = 93, .external_lex_state = 2},
  [216] = {.lex_state = 93, .external_lex_state = 2},
  [217] = {.lex_state = 93, .external_lex_state = 2},
  [218] = {.lex_state = 93, .external_lex_state = 2},
  [219] = {.lex_state = 93, .external_lex_state = 2},
  [220] = {.lex_state = 93, .external_lex_state = 2},
  [221] = {.lex_state = 93, .external_lex_state = 2},
  [222] = {.lex_state = 93, .external_lex_state = 2},
  [223] = {.lex_state = 93, .external_lex_state = 2},
  [224] = {.lex_state = 93, .external_lex_state = 2},
  [225] = {.lex_state = 93, .external_lex_state = 2},
  [226] = {.lex_state = 93, .external_lex_state = 2},
  [227] = {.lex_state = 93, .external_lex_state = 2},
  [228] = {.lex_state = 93, .external_lex_state = 2},
  [229] = {.lex_state = 93, .external_lex_state = 2},
  [230] = {.lex_state = 93, .external_lex_state = 2},
  [231] = {.lex_state = 93, .external_lex_state = 2},
  [232] = {.lex_state = 93, .external_lex_state = 2},
  [233] = {.lex_state = 93, .external_lex_state = 2},
  [234] = {.lex_state = 93, .external_lex_state = 2},
  [235] = {.lex_state = 93, .external_lex_state = 2},
  [236] = {.lex_state = 93, .external_lex_state = 2},
  [237] = {.lex_state = 93, .external_lex_state = 2},
  [238] = {.lex_state = 93, .external_lex_state = 2},
  [239] = {.lex_state = 93, .external_lex_state = 2},
  [240] = {.lex_state = 93, .external_lex_state = 2},
  [241] = {.lex_state = 93, .external_lex_state = 2},
  [242] = {.lex_state = 93, .external_lex_state = 2},
  [243] = {.lex_state = 93, .external_lex_state = 2},
  [244] = {.lex_state = 93, .external_lex_state = 2},
  [245] = {.lex_state = 93, .external_lex_state = 2},
  [246] = {.lex_state = 93, .external_lex_state = 2},
  [247] = {.lex_state = 93, .external_lex_state = 2},
  [248] = {.lex_state = 93, .external_lex_state = 2},
  [249] = {.lex_state = 93, .external_lex_state = 2},
  [250] = {.lex_state = 93, .external_lex_state = 2},
  [251] = {.lex_state = 93, .external_lex_state = 2},
  [252] = {.lex_state = 93, .external_lex_state = 2},
  [253] = {.lex_state = 93, .external_lex_state = 2},
  [254] = {.lex_state = 93, .external_lex_state = 2},
  [255] = {.lex_state = 93, .external_lex_state = 2},
  [256] = {.lex_state = 93, .external_lex_state = 2},
  [257] = {.lex_state = 93, .external_lex_state = 2},
  [258] = {.lex_state = 93, .external_lex_state = 2},
  [259] = {.lex_state = 93, .external_lex_state = 2},
  [260] = {.lex_state = 93, .external_lex_state = 2},
  [261] = {.lex_state = 93, .external_lex_state = 2},
  [262] = {.lex_state = 93, .external_lex_state = 2},
  [263] = {.lex_state = 93, .external_lex_state = 2},
  [264] = {.lex_state = 93, .external_lex_state = 2},
  [265] = {.lex_state = 93, .external_lex_state = 2},
  [266] = {.lex_state = 93, .external_lex_state = 2},
  [267] = {.lex_state = 93, .external_lex_state = 2},
  [268] = {.lex_state = 93, .external_lex_state = 2},
  [269] = {.lex_state = 93, .external_lex_state = 2},
  [270] = {.lex_state = 93, .external_lex_state = 2},
  [271] = {.lex_state = 93, .external_lex_state = 2},
  [272] = {.lex_state = 93, .external_lex_state = 2},
  [273] = {.lex_state = 93, .external_lex_state = 2},
  [274] = {.lex_state = 93, .external_lex_state = 2},
  [275] = {.lex_state = 93, .external_lex_state = 2},
  [276] = {.lex_state = 93, .external_lex_state = 2},
  [277] = {.lex_state = 93, .external_lex_state = 2},
  [278] = {.lex_state = 93, .external_lex_state = 2},
  [279] = {.lex_state = 93, .external_lex_state = 2},
  [280] = {.lex_state = 93, .external_lex_state = 2},
  [281] = {.lex_state = 93, .external_lex_state = 2},
  [282] = {.lex_state = 93, .external_lex_state = 2},
  [283] = {.lex_state = 93, .external_lex_state = 2},
  [284] = {.lex_state = 93, .external_lex_state = 2},
  [285] = {.lex_state = 93, .external_lex_state = 2},
  [286] = {.lex_state = 93, .external_lex_state = 2},
  [287] = {.lex_state = 93, .external_lex_state = 2},
  [288] = {.lex_state = 93, .external_lex_state = 2},
  [289] = {.lex_state = 93, .external_lex_state = 2},
  [290] = {.lex_state = 93, .external_lex_state = 2},
  [291] = {.lex_state = 93, .external_lex_state = 2},
  [292] = {.lex_state = 93, .external_lex_state = 2},
  [293] = {.lex_state = 93, .external_lex_state = 2},
  [294] = {.lex_state = 93, .external_lex_state = 2},
  [295] = {.lex_state = 93, .external_lex_state = 2},
  [296] = {.lex_state = 93, .external_lex_state = 2},
  [297] = {.lex_state = 93, .external_lex_state = 2},
  [298] = {.lex_state = 93, .external_lex_state = 2},
  [299] = {.lex_state = 93, .external_lex_state = 2},
  [300] = {.lex_state = 93, .external_lex_state = 2},
  [301] = {.lex_state = 93, .external_lex_state = 2},
  [302] = {.lex_state = 93, .external_lex_state = 2},
  [303] = {.lex_state = 93, .external_lex_state = 2},
  [304] = {.lex_state = 93, .external_lex_state = 2},
  [305] = {.lex_state = 93, .external_lex_state = 2},
  [306] = {.lex_state = 93, .external_lex_state = 2},
  [307] = {.lex_state = 93, .external_lex_state = 2},
  [308] = {.lex_state = 93, .external_lex_state = 2},
  [309] = {.lex_state = 93, .external_lex_state = 2},
  [310] = {.lex_state = 93, .external_lex_state = 2},
  [311] = {.lex_state = 93, .external_lex_state = 2},
  [312] = {.lex_state = 93, .external_lex_state = 2},
  [313] = {.lex_state = 93, .external_lex_state = 2},
  [314] = {.lex_state = 93, .external_lex_state = 2},
  [315] = {.lex_state = 93, .external_lex_state = 2},
  [316] = {.lex_state = 93, .external_lex_state = 2},
  [317] = {.lex_state = 93, .external_lex_state = 2},
  [318] = {.lex_state = 93, .external_lex_state = 2},
  [319] = {.lex_state = 93, .external_lex_state = 2},
  [320] = {.lex_state = 93, .external_lex_state = 2},
  [321] = {.lex_state = 93, .external_lex_state = 2},
  [322] = {.lex_state = 93, .external_lex_state = 2},
  [323] = {.lex_state = 93, .external_lex_state = 2},
  [324] = {.lex_state = 93, .external_lex_state = 2},
  [325] = {.lex_state = 93, .external_lex_state = 2},
  [326] = {.lex_state = 93, .external_lex_state = 2},
  [327] = {.lex_state = 93, .external_lex_state = 2},
  [328] = {.lex_state = 93, .external_lex_state = 2},
  [329] = {.lex_state = 93, .external_lex_state = 2},
  [330] = {.lex_state = 93, .external_lex_state = 2},
  [331] = {.lex_state = 93, .external_lex_state = 2},
  [332] = {.lex_state = 93, .external_lex_state = 2},
  [333] = {.lex_state = 93, .external_lex_state = 2},
  [334] = {.lex_state = 93, .external_lex_state = 2},
  [335] = {.lex_state = 93, .external_lex_state = 2},
  [336] = {.lex_state = 93, .external_lex_state = 2},
  [337] = {.lex_state = 93, .external_lex_state = 2},
  [338] = {.lex_state = 93, .external_lex_state = 2},
  [339] = {.lex_state = 93, .external_lex_state = 2},
  [340] = {.lex_state = 93, .external_lex_state = 2},
  [341] = {.lex_state = 93, .external_lex_state = 2},
  [342] = {.lex_state = 93, .external_lex_state = 2},
  [343] = {.lex_state = 93, .external_lex_state = 2},
  [344] = {.lex_state = 93, .external_lex_state = 2},
  [345] = {.lex_state = 93, .external_lex_state = 2},
  [346] = {.lex_state = 93, .external_lex_state = 2},
  [347] = {.lex_state = 93, .external_lex_state = 2},
  [348] = {.lex_state = 93, .external_lex_state = 2},
  [349] = {.lex_state = 93, .external_lex_state = 2},
  [350] = {.lex_state = 93, .external_lex_state = 2},
  [351] = {.lex_state = 93, .external_lex_state = 2},
  [352] = {.lex_state = 93, .external_lex_state = 2},
  [353] = {.lex_state = 93, .external_lex_state = 2},
  [354] = {.lex_state = 93, .external_lex_state = 2},
  [355] = {.lex_state = 93, .external_lex_state = 2},
  [356] = {.lex_state = 93, .external_lex_state = 2},
  [357] = {.lex_state = 93, .external_lex_state = 2},
  [358] = {.lex_state = 93, .external_lex_state = 2},
  [359] = {.lex_state = 93, .external_lex_state = 2},
  [360] = {.lex_state = 93, .external_lex_state = 2},
  [361] = {.lex_state = 93, .external_lex_state = 2},
  [362] = {.lex_state = 93, .external_lex_state = 2},
  [363] = {.lex_state = 93, .external_lex_state = 2},
  [364] = {.lex_state = 93, .external_lex_state = 2},
  [365] = {.lex_state = 93, .external_lex_state = 2},
  [366] = {.lex_state = 93, .external_lex_state = 2},
  [367] = {.lex_state = 93, .external_lex_state = 2},
  [368] = {.lex_state = 93, .external_lex_state = 2},
  [369] = {.lex_state = 93, .external_lex_state = 2},
  [370] = {.lex_state = 93, .external_lex_state = 2},
  [371] = {.lex_state = 93, .external_lex_state = 2},
  [372] = {.lex_state = 93, .external_lex_state = 2},
  [373] = {.lex_state = 93, .external_lex_state = 2},
  [374] = {.lex_state = 93, .external_lex_state = 2},
  [375] = {.lex_state = 93, .external_lex_state = 2},
  [376] = {.lex_state = 93, .external_lex_state = 2},
  [377] = {.lex_state = 93, .external_lex_state = 2},
  [378] = {.lex_state = 93, .external_lex_state = 2},
  [379] = {.lex_state = 93, .external_lex_state = 2},
  [380] = {.lex_state = 93, .external_lex_state = 2},
  [381] = {.lex_state = 93, .external_lex_state = 2},
  [382] = {.lex_state = 93, .external_lex_state = 2},
  [383] = {.lex_state = 93, .external_lex_state = 2},
  [384] = {.lex_state = 93, .external_lex_state = 2},
  [385] = {.lex_state = 93, .external_lex_state = 2},
  [386] = {.lex_state = 93, .external_lex_state = 2},
  [387] = {.lex_state = 93, .external_lex_state = 2},
  [388] = {.lex_state = 93, .external_lex_state = 2},
  [389] = {.lex_state = 93, .external_lex_state = 2},
  [390] = {.lex_state = 93, .external_lex_state = 2},
  [391] = {.lex_state = 93, .external_lex_state = 2},
  [392] = {.lex_state = 93, .external_lex_state = 2},
  [393] = {.lex_state = 93, .external_lex_state = 2},
  [394] = {.lex_state = 93, .external_lex_state = 2},
  [395] = {.lex_state = 93, .external_lex_state = 2},
  [396] = {.lex_state = 93, .external_lex_state = 2},
  [397] = {.lex_state = 93, .external_lex_state = 2},
  [398] = {.lex_state = 93, .external_lex_state = 2},
  [399] = {.lex_state = 93, .external_lex_state = 2},
  [400] = {.lex_state = 93, .external_lex_state = 2},
  [401] = {.lex_state = 93, .external_lex_state = 2},
  [402] = {.lex_state = 93, .external_lex_state = 2},
  [403] = {.lex_state = 93, .external_lex_state = 2},
  [404] = {.lex_state = 93, .external_lex_state = 2},
  [405] = {.lex_state = 93, .external_lex_state = 2},
  [406] = {.lex_state = 93, .external_lex_state = 2},
  [407] = {.lex_state = 93, .external_lex_state = 2},
  [408] = {.lex_state = 93, .external_lex_state = 2},
  [409] = {.lex_state = 93, .external_lex_state = 2},
  [410] = {.lex_state = 93, .external_lex_state = 2},
  [411] = {.lex_state = 93, .external_lex_state = 2},
  [412] = {.lex_state = 93, .external_lex_state = 2},
  [413] = {.lex_state = 93, .external_lex_state = 2},
  [414] = {.lex_state = 93, .external_lex_state = 2},
  [415] = {.lex_state = 93, .external_lex_state = 2},
  [416] = {.lex_state = 93, .external_lex_state = 2},
  [417] = {.lex_state = 93, .external_lex_state = 2},
  [418] = {.lex_state = 93, .external_lex_state = 2},
  [419] = {.lex_state = 93, .external_lex_state = 2},
  [420] = {.lex_state = 93, .external_lex_state = 2},
  [421] = {.lex_state = 93, .external_lex_state = 2},
  [422] = {.lex_state = 93, .external_lex_state = 2},
  [423] = {.lex_state = 93, .external_lex_state = 2},
  [424] = {.lex_state = 93, .external_lex_state = 2},
  [425] = {.lex_state = 93, .external_lex_state = 2},
  [426] = {.lex_state = 93, .external_lex_state = 2},
  [427] = {.lex_state = 93, .external_lex_state = 2},
  [428] = {.lex_state = 93, .external_lex_state = 2},
  [429] = {.lex_state = 93, .external_lex_state = 2},
  [430] = {.lex_state = 93, .external_lex_state = 2},
  [431] = {.lex_state = 93, .external_lex_state = 2},
  [432] = {.lex_state = 93, .external_lex_state = 2},
  [433] = {.lex_state = 93, .external_lex_state = 2},
  [434] = {.lex_state = 93, .external_lex_state = 2},
  [435] = {.lex_state = 93, .external_lex_state = 2},
  [436] = {.lex_state = 93, .external_lex_state = 2},
  [437] = {.lex_state = 93, .external_lex_state = 2},
  [438] = {.lex_state = 93, .external_lex_state = 2},
  [439] = {.lex_state = 93, .external_lex_state = 2},
  [440] = {.lex_state = 93, .external_lex_state = 2},
  [441] = {.lex_state = 93, .external_lex_state = 2},
  [442] = {.lex_state = 93, .external_lex_state = 2},
  [443] = {.lex_state = 93, .external_lex_state = 2},
  [444] = {.lex_state = 93, .external_lex_state = 2},
  [445] = {.lex_state = 93, .external_lex_state = 2},
  [446] = {.lex_state = 93, .external_lex_state = 2},
  [447] = {.lex_state = 93, .external_lex_state = 2},
  [448] = {.lex_state = 93, .external_lex_state = 2},
  [449] = {.lex_state = 93, .external_lex_state = 2},
  [450] = {.lex_state = 93, .external_lex_state = 2},
  [451] = {.lex_state = 93, .external_lex_state = 2},
  [452] = {.lex_state = 93, .external_lex_state = 2},
  [453] = {.lex_state = 93, .external_lex_state = 2},
  [454] = {.lex_state = 93, .external_lex_state = 2},
  [455] = {.lex_state = 93, .external_lex_state = 2},
  [456] = {.lex_state = 93, .external_lex_state = 2},
  [457] = {.lex_state = 93, .external_lex_state = 2},
  [458] = {.lex_state = 93, .external_lex_state = 2},
  [459] = {.lex_state = 93, .external_lex_state = 2},
  [460] = {.lex_state = 93, .external_lex_state = 2},
  [461] = {.lex_state = 93, .external_lex_state = 2},
  [462] = {.lex_state = 93, .external_lex_state = 2},
  [463] = {.lex_state = 93, .external_lex_state = 2},
  [464] = {.lex_state = 93, .external_lex_state = 2},
  [465] = {.lex_state = 93, .external_lex_state = 2},
  [466] = {.lex_state = 93, .external_lex_state = 2},
  [467] = {.lex_state = 93, .external_lex_state = 2},
  [468] = {.lex_state = 93, .external_lex_state = 2},
  [469] = {.lex_state = 93, .external_lex_state = 2},
  [470] = {.lex_state = 93, .external_lex_state = 2},
  [471] = {.lex_state = 93, .external_lex_state = 2},
  [472] = {.lex_state = 93, .external_lex_state = 2},
  [473] = {.lex_state = 93, .external_lex_state = 2},
  [474] = {.lex_state = 93, .external_lex_state = 2},
  [475] = {.lex_state = 93, .external_lex_state = 2},
  [476] = {.lex_state = 93, .external_lex_state = 2},
  [477] = {.lex_state = 93, .external_lex_state = 2},
  [478] = {.lex_state = 93, .external_lex_state = 2},
  [479] = {.lex_state = 93, .external_lex_state = 2},
  [480] = {.lex_state = 93, .external_lex_state = 2},
  [481] = {.lex_state = 93, .external_lex_state = 2},
  [482] = {.lex_state = 93, .external_lex_state = 2},
  [483] = {.lex_state = 93, .external_lex_state = 2},
  [484] = {.lex_state = 93, .external_lex_state = 2},
  [485] = {.lex_state = 93, .external_lex_state = 2},
  [486] = {.lex_state = 93, .external_lex_state = 2},
  [487] = {.lex_state = 93, .external_lex_state = 2},
  [488] = {.lex_state = 93, .external_lex_state = 2},
  [489] = {.lex_state = 93, .external_lex_state = 2},
  [490] = {.lex_state = 93, .external_lex_state = 2},
  [491] = {.lex_state = 93, .external_lex_state = 2},
  [492] = {.lex_state = 93, .external_lex_state = 2},
  [493] = {.lex_state = 93, .external_lex_state = 2},
  [494] = {.lex_state = 93, .external_lex_state = 2},
  [495] = {.lex_state = 93, .external_lex_state = 2},
  [496] = {.lex_state = 93, .external_lex_state = 2},
  [497] = {.lex_state = 93, .external_lex_state = 2},
  [498] = {.lex_state = 93, .external_lex_state = 2},
  [499] = {.lex_state = 93, .external_lex_state = 2},
  [500] = {.lex_state = 93, .external_lex_state = 2},
  [501] = {.lex_state = 93, .external_lex_state = 2},
  [502] = {.lex_state = 93, .external_lex_state = 2},
  [503] = {.lex_state = 93, .external_lex_state = 2},
  [504] = {.lex_state = 93, .external_lex_state = 2},
  [505] = {.lex_state = 93, .external_lex_state = 2},
  [506] = {.lex_state = 93, .external_lex_state = 2},
  [507] = {.lex_state = 93, .external_lex_state = 2},
  [508] = {.lex_state = 93, .external_lex_state = 2},
  [509] = {.lex_state = 93, .external_lex_state = 2},
  [510] = {.lex_state = 93, .external_lex_state = 2},
  [511] = {.lex_state = 93, .external_lex_state = 2},
  [512] = {.lex_state = 93, .external_lex_state = 2},
  [513] = {.lex_state = 93, .external_lex_state = 2},
  [514] = {.lex_state = 93, .external_lex_state = 2},
  [515] = {.lex_state = 93, .external_lex_state = 2},
  [516] = {.lex_state = 93, .external_lex_state = 2},
  [517] = {.lex_state = 93, .external_lex_state = 2},
  [518] = {.lex_state = 93, .external_lex_state = 2},
  [519] = {.lex_state = 93, .external_lex_state = 2},
  [520] = {.lex_state = 93, .external_lex_state = 2},
  [521] = {.lex_state = 93, .external_lex_state = 2},
  [522] = {.lex_state = 93, .external_lex_state = 2},
  [523] = {.lex_state = 93, .external_lex_state = 2},
  [524] = {.lex_state = 93, .external_lex_state = 2},
  [525] = {.lex_state = 93, .external_lex_state = 2},
  [526] = {.lex_state = 93, .external_lex_state = 2},
  [527] = {.lex_state = 93, .external_lex_state = 2},
  [528] = {.lex_state = 93, .external_lex_state = 2},
  [529] = {.lex_state = 93, .external_lex_state = 2},
  [530] = {.lex_state = 93, .external_lex_state = 2},
  [531] = {.lex_state = 93, .external_lex_state = 2},
  [532] = {.lex_state = 93, .external_lex_state = 2},
  [533] = {.lex_state = 93, .external_lex_state = 2},
  [534] = {.lex_state = 93, .external_lex_state = 2},
  [535] = {.lex_state = 93, .external_lex_state = 2},
  [536] = {.lex_state = 93, .external_lex_state = 2},
  [537] = {.lex_state = 93, .external_lex_state = 2},
  [538] = {.lex_state = 93, .external_lex_state = 2},
  [539] = {.lex_state = 93, .external_lex_state = 2},
  [540] = {.lex_state = 93, .external_lex_state = 2},
  [541] = {.lex_state = 93, .external_lex_state = 2},
  [542] = {.lex_state = 93, .external_lex_state = 2},
  [543] = {.lex_state = 93, .external_lex_state = 2},
  [544] = {.lex_state = 93, .external_lex_state = 2},
  [545] = {.lex_state = 93, .external_lex_state = 2},
  [546] = {.lex_state = 93, .external_lex_state = 2},
  [547] = {.lex_state = 93, .external_lex_state = 2},
  [548] = {.lex_state = 93, .external_lex_state = 2},
  [549] = {.lex_state = 93, .external_lex_state = 2},
  [550] = {.lex_state = 93, .external_lex_state = 2},
  [551] = {.lex_state = 93, .external_lex_state = 2},
  [552] = {.lex_state = 93, .external_lex_state = 2},
  [553] = {.lex_state = 93, .external_lex_state = 2},
  [554] = {.lex_state = 93, .external_lex_state = 2},
  [555] = {.lex_state = 93, .external_lex_state = 2},
  [556] = {.lex_state = 93, .external_lex_state = 2},
  [557] = {.lex_state = 93, .external_lex_state = 2},
  [558] = {.lex_state = 93, .external_lex_state = 2},
  [559] = {.lex_state = 93, .external_lex_state = 2},
  [560] = {.lex_state = 93, .external_lex_state = 2},
  [561] = {.lex_state = 93, .external_lex_state = 2},
  [562] = {.lex_state = 93, .external_lex_state = 2},
  [563] = {.lex_state = 93, .external_lex_state = 2},
  [564] = {.lex_state = 93, .external_lex_state = 2},
  [565] = {.lex_state = 93, .external_lex_state = 2},
  [566] = {.lex_state = 93, .external_lex_state = 2},
  [567] = {.lex_state = 93, .external_lex_state = 2},
  [568] = {.lex_state = 93, .external_lex_state = 2},
  [569] = {.lex_state = 93, .external_lex_state = 2},
  [570] = {.lex_state = 93, .external_lex_state = 2},
  [571] = {.lex_state = 93, .external_lex_state = 2},
  [572] = {.lex_state = 93, .external_lex_state = 2},
  [573] = {.lex_state = 93, .external_lex_state = 2},
  [574] = {.lex_state = 93, .external_lex_state = 2},
  [575] = {.lex_state = 93, .external_lex_state = 2},
  [576] = {.lex_state = 93, .external_lex_state = 2},
  [577] = {.lex_state = 93, .external_lex_state = 2},
  [578] = {.lex_state = 93, .external_lex_state = 2},
  [579] = {.lex_state = 93, .external_lex_state = 2},
  [580] = {.lex_state = 93, .external_lex_state = 2},
  [581] = {.lex_state = 93, .external_lex_state = 2},
  [582] = {.lex_state = 93, .external_lex_state = 2},
  [583] = {.lex_state = 93, .external_lex_state = 2},
  [584] = {.lex_state = 93, .external_lex_state = 2},
  [585] = {.lex_state = 93, .external_lex_state = 2},
  [586] = {.lex_state = 93, .external_lex_state = 2},
  [587] = {.lex_state = 93, .external_lex_state = 2},
  [588] = {.lex_state = 93, .external_lex_state = 2},
  [589] = {.lex_state = 93, .external_lex_state = 2},
  [590] = {.lex_state = 93, .external_lex_state = 2},
  [591] = {.lex_state = 93, .external_lex_state = 2},
  [592] = {.lex_state = 93, .external_lex_state = 2},
  [593] = {.lex_state = 93, .external_lex_state = 2},
  [594] = {.lex_state = 93, .external_lex_state = 2},
  [595] = {.lex_state = 93, .external_lex_state = 2},
  [596] = {.lex_state = 93, .external_lex_state = 2},
  [597] = {.lex_state = 93, .external_lex_state = 2},
  [598] = {.lex_state = 93, .external_lex_state = 2},
  [599] = {.lex_state = 93, .external_lex_state = 2},
  [600] = {.lex_state = 93, .external_lex_state = 2},
  [601] = {.lex_state = 93, .external_lex_state = 2},
  [602] = {.lex_state = 93, .external_lex_state = 2},
  [603] = {.lex_state = 93, .external_lex_state = 2},
  [604] = {.lex_state = 93, .external_lex_state = 2},
  [605] = {.lex_state = 93, .external_lex_state = 2},
  [606] = {.lex_state = 93, .external_lex_state = 2},
  [607] = {.lex_state = 93, .external_lex_state = 2},
  [608] = {.lex_state = 93, .external_lex_state = 2},
  [609] = {.lex_state = 93, .external_lex_state = 2},
  [610] = {.lex_state = 93, .external_lex_state = 2},
  [611] = {.lex_state = 93, .external_lex_state = 2},
  [612] = {.lex_state = 93, .external_lex_state = 2},
  [613] = {.lex_state = 93, .external_lex_state = 2},
  [614] = {.lex_state = 93, .external_lex_state = 2},
  [615] = {.lex_state = 93, .external_lex_state = 2},
  [616] = {.lex_state = 93, .external_lex_state = 2},
  [617] = {.lex_state = 93, .external_lex_state = 2},
  [618] = {.lex_state = 93, .external_lex_state = 2},
  [619] = {.lex_state = 93, .external_lex_state = 2},
  [620] = {.lex_state = 93, .external_lex_state = 2},
  [621] = {.lex_state = 93, .external_lex_state = 2},
  [622] = {.lex_state = 93, .external_lex_state = 2},
  [623] = {.lex_state = 93, .external_lex_state = 2},
  [624] = {.lex_state = 93, .external_lex_state = 2},
  [625] = {.lex_state = 93, .external_lex_state = 2},
  [626] = {.lex_state = 93, .external_lex_state = 2},
  [627] = {.lex_state = 93, .external_lex_state = 2},
  [628] = {.lex_state = 93, .external_lex_state = 2},
  [629] = {.lex_state = 93, .external_lex_state = 2},
  [630] = {.lex_state = 93, .external_lex_state = 2},
  [631] = {.lex_state = 93, .external_lex_state = 2},
  [632] = {.lex_state = 93, .external_lex_state = 2},
  [633] = {.lex_state = 93, .external_lex_state = 2},
  [634] = {.lex_state = 93, .external_lex_state = 2},
  [635] = {.lex_state = 93, .external_lex_state = 2},
  [636] = {.lex_state = 93, .external_lex_state = 2},
  [637] = {.lex_state = 93, .external_lex_state = 2},
  [638] = {.lex_state = 93, .external_lex_state = 2},
  [639] = {.lex_state = 93, .external_lex_state = 2},
  [640] = {.lex_state = 93, .external_lex_state = 2},
  [641] = {.lex_state = 93, .external_lex_state = 2},
  [642] = {.lex_state = 93, .external_lex_state = 2},
  [643] = {.lex_state = 93, .external_lex_state = 2},
  [644] = {.lex_state = 93, .external_lex_state = 2},
  [645] = {.lex_state = 93, .external_lex_state = 2},
  [646] = {.lex_state = 93, .external_lex_state = 2},
  [647] = {.lex_state = 93, .external_lex_state = 2},
  [648] = {.lex_state = 93, .external_lex_state = 2},
  [649] = {.lex_state = 93, .external_lex_state = 2},
  [650] = {.lex_state = 93, .external_lex_state = 2},
  [651] = {.lex_state = 93, .external_lex_state = 2},
  [652] = {.lex_state = 93, .external_lex_state = 2},
  [653] = {.lex_state = 93, .external_lex_state = 2},
  [654] = {.lex_state = 93, .external_lex_state = 2},
  [655] = {.lex_state = 93, .external_lex_state = 2},
  [656] = {.lex_state = 93, .external_lex_state = 2},
  [657] = {.lex_state = 93, .external_lex_state = 2},
  [658] = {.lex_state = 93, .external_lex_state = 2},
  [659] = {.lex_state = 93, .external_lex_state = 2},
  [660] = {.lex_state = 93, .external_lex_state = 2},
  [661] = {.lex_state = 93, .external_lex_state = 2},
  [662] = {.lex_state = 93, .external_lex_state = 2},
  [663] = {.lex_state = 93, .external_lex_state = 2},
  [664] = {.lex_state = 93, .external_lex_state = 2},
  [665] = {.lex_state = 93, .external_lex_state = 2},
  [666] = {.lex_state = 93, .external_lex_state = 2},
  [667] = {.lex_state = 93, .external_lex_state = 2},
  [668] = {.lex_state = 93, .external_lex_state = 2},
  [669] = {.lex_state = 93, .external_lex_state = 2},
  [670] = {.lex_state = 93, .external_lex_state = 2},
  [671] = {.lex_state = 93, .external_lex_state = 2},
  [672] = {.lex_state = 93, .external_lex_state = 2},
  [673] = {.lex_state = 93, .external_lex_state = 2},
  [674] = {.lex_state = 93, .external_lex_state = 2},
  [675] = {.lex_state = 93, .external_lex_state = 2},
  [676] = {.lex_state = 93, .external_lex_state = 2},
  [677] = {.lex_state = 93, .external_lex_state = 2},
  [678] = {.lex_state = 93, .external_lex_state = 2},
  [679] = {.lex_state = 93, .external_lex_state = 2},
  [680] = {.lex_state = 93, .external_lex_state = 2},
  [681] = {.lex_state = 93, .external_lex_state = 2},
  [682] = {.lex_state = 93, .external_lex_state = 2},
  [683] = {.lex_state = 93, .external_lex_state = 2},
  [684] = {.lex_state = 93, .external_lex_state = 2},
  [685] = {.lex_state = 93, .external_lex_state = 2},
  [686] = {.lex_state = 93, .external_lex_state = 2},
  [687] = {.lex_state = 93, .external_lex_state = 2},
  [688] = {.lex_state = 93, .external_lex_state = 2},
  [689] = {.lex_state = 93, .external_lex_state = 2},
  [690] = {.lex_state = 93, .external_lex_state = 2},
  [691] = {.lex_state = 93, .external_lex_state = 2},
  [692] = {.lex_state = 93, .external_lex_state = 2},
  [693] = {.lex_state = 93, .external_lex_state = 2},
  [694] = {.lex_state = 93, .external_lex_state = 2},
  [695] = {.lex_state = 93, .external_lex_state = 2},
  [696] = {.lex_state = 93, .external_lex_state = 2},
  [697] = {.lex_state = 93, .external_lex_state = 2},
  [698] = {.lex_state = 93, .external_lex_state = 2},
  [699] = {.lex_state = 93, .external_lex_state = 2},
  [700] = {.lex_state = 93, .external_lex_state = 2},
  [701] = {.lex_state = 93, .external_lex_state = 2},
  [702] = {.lex_state = 93, .external_lex_state = 2},
  [703] = {.lex_state = 93, .external_lex_state = 2},
  [704] = {.lex_state = 93, .external_lex_state = 2},
  [705] = {.lex_state = 93, .external_lex_state = 2},
  [706] = {.lex_state = 93, .external_lex_state = 2},
  [707] = {.lex_state = 93, .external_lex_state = 2},
  [708] = {.lex_state = 93, .external_lex_state = 2},
  [709] = {.lex_state = 93, .external_lex_state = 2},
  [710] = {.lex_state = 93, .external_lex_state = 2},
  [711] = {.lex_state = 93, .external_lex_state = 2},
  [712] = {.lex_state = 93, .external_lex_state = 2},
  [713] = {.lex_state = 93, .external_lex_state = 2},
  [714] = {.lex_state = 93, .external_lex_state = 2},
  [715] = {.lex_state = 93, .external_lex_state = 2},
  [716] = {.lex_state = 93, .external_lex_state = 2},
  [717] = {.lex_state = 93, .external_lex_state = 2},
  [718] = {.lex_state = 93, .external_lex_state = 2},
  [719] = {.lex_state = 93, .external_lex_state = 2},
  [720] = {.lex_state = 93, .external_lex_state = 2},
  [721] = {.lex_state = 93, .external_lex_state = 2},
  [722] = {.lex_state = 93, .external_lex_state = 2},
  [723] = {.lex_state = 93, .external_lex_state = 2},
  [724] = {.lex_state = 93, .external_lex_state = 2},
  [725] = {.lex_state = 93, .external_lex_state = 2},
  [726] = {.lex_state = 93, .external_lex_state = 2},
  [727] = {.lex_state = 93, .external_lex_state = 2},
  [728] = {.lex_state = 93, .external_lex_state = 2},
  [729] = {.lex_state = 93, .external_lex_state = 2},
  [730] = {.lex_state = 93, .external_lex_state = 2},
  [731] = {.lex_state = 93, .external_lex_state = 2},
  [732] = {.lex_state = 93, .external_lex_state = 2},
  [733] = {.lex_state = 93, .external_lex_state = 2},
  [734] = {.lex_state = 93, .external_lex_state = 2},
  [735] = {.lex_state = 93, .external_lex_state = 2},
  [736] = {.lex_state = 93, .external_lex_state = 2},
  [737] = {.lex_state = 93, .external_lex_state = 2},
  [738] = {.lex_state = 93, .external_lex_state = 2},
  [739] = {.lex_state = 93, .external_lex_state = 2},
  [740] = {.lex_state = 93, .external_lex_state = 2},
  [741] = {.lex_state = 93, .external_lex_state = 2},
  [742] = {.lex_state = 93, .external_lex_state = 2},
  [743] = {.lex_state = 93, .external_lex_state = 2},
  [744] = {.lex_state = 93, .external_lex_state = 2},
  [745] = {.lex_state = 93, .external_lex_state = 2},
  [746] = {.lex_state = 93, .external_lex_state = 2},
  [747] = {.lex_state = 93, .external_lex_state = 2},
  [748] = {.lex_state = 93, .external_lex_state = 2},
  [749] = {.lex_state = 93, .external_lex_state = 2},
  [750] = {.lex_state = 93, .external_lex_state = 2},
  [751] = {.lex_state = 93, .external_lex_state = 2},
  [752] = {.lex_state = 93, .external_lex_state = 2},
  [753] = {.lex_state = 93, .external_lex_state = 2},
  [754] = {.lex_state = 93, .external_lex_state = 2},
  [755] = {.lex_state = 93, .external_lex_state = 2},
  [756] = {.lex_state = 93, .external_lex_state = 2},
  [757] = {.lex_state = 93, .external_lex_state = 2},
  [758] = {.lex_state = 93, .external_lex_state = 2},
  [759] = {.lex_state = 93, .external_lex_state = 2},
  [760] = {.lex_state = 93, .external_lex_state = 2},
  [761] = {.lex_state = 93, .external_lex_state = 2},
  [762] = {.lex_state = 93, .external_lex_state = 2},
  [763] = {.lex_state = 93, .external_lex_state = 2},
  [764] = {.lex_state = 93, .external_lex_state = 2},
  [765] = {.lex_state = 93, .external_lex_state = 2},
  [766] = {.lex_state = 93, .external_lex_state = 2},
  [767] = {.lex_state = 93, .external_lex_state = 2},
  [768] = {.lex_state = 93, .external_lex_state = 2},
  [769] = {.lex_state = 93, .external_lex_state = 2},
  [770] = {.lex_state = 93, .external_lex_state = 2},
  [771] = {.lex_state = 93, .external_lex_state = 2},
  [772] = {.lex_state = 93, .external_lex_state = 2},
  [773] = {.lex_state = 93, .external_lex_state = 2},
  [774] = {.lex_state = 93, .external_lex_state = 2},
  [775] = {.lex_state = 93, .external_lex_state = 2},
  [776] = {.lex_state = 93, .external_lex_state = 2},
  [777] = {.lex_state = 93, .external_lex_state = 2},
  [778] = {.lex_state = 93, .external_lex_state = 2},
  [779] = {.lex_state = 93, .external_lex_state = 2},
  [780] = {.lex_state = 93, .external_lex_state = 2},
  [781] = {.lex_state = 93, .external_lex_state = 2},
  [782] = {.lex_state = 93, .external_lex_state = 2},
  [783] = {.lex_state = 93, .external_lex_state = 2},
  [784] = {.lex_state = 93, .external_lex_state = 2},
  [785] = {.lex_state = 93, .external_lex_state = 2},
  [786] = {.lex_state = 93, .external_lex_state = 2},
  [787] = {.lex_state = 93, .external_lex_state = 2},
  [788] = {.lex_state = 93, .external_lex_state = 2},
  [789] = {.lex_state = 93, .external_lex_state = 2},
  [790] = {.lex_state = 93, .external_lex_state = 2},
  [791] = {.lex_state = 93, .external_lex_state = 2},
  [792] = {.lex_state = 93, .external_lex_state = 2},
  [793] = {.lex_state = 93, .external_lex_state = 2},
  [794] = {.lex_state = 93, .external_lex_state = 2},
  [795] = {.lex_state = 93, .external_lex_state = 2},
  [796] = {.lex_state = 93, .external_lex_state = 2},
  [797] = {.lex_state = 93, .external_lex_state = 2},
  [798] = {.lex_state = 93, .external_lex_state = 2},
  [799] = {.lex_state = 93, .external_lex_state = 2},
  [800] = {.lex_state = 93, .external_lex_state = 2},
  [801] = {.lex_state = 93, .external_lex_state = 2},
  [802] = {.lex_state = 93, .external_lex_state = 2},
  [803] = {.lex_state = 93, .external_lex_state = 2},
  [804] = {.lex_state = 93, .external_lex_state = 2},
  [805] = {.lex_state = 93, .external_lex_state = 2},
  [806] = {.lex_state = 93, .external_lex_state = 2},
  [807] = {.lex_state = 93, .external_lex_state = 2},
  [808] = {.lex_state = 93, .external_lex_state = 2},
  [809] = {.lex_state = 93, .external_lex_state = 2},
  [810] = {.lex_state = 93, .external_lex_state = 2},
  [811] = {.lex_state = 93, .external_lex_state = 2},
  [812] = {.lex_state = 93, .external_lex_state = 2},
  [813] = {.lex_state = 93, .external_lex_state = 2},
  [814] = {.lex_state = 78, .external_lex_state = 3},
  [815] = {.lex_state = 81, .external_lex_state = 3},
  [816] = {.lex_state = 10, .external_lex_state = 3},
  [817] = {.lex_state = 81, .external_lex_state = 4},
  [818] = {.lex_state = 81, .external_lex_state = 4},
  [819] = {.lex_state = 81, .external_lex_state = 4},
  [820] = {.lex_state = 81, .external_lex_state = 4},
  [821] = {.lex_state = 81, .external_lex_state = 4},
  [822] = {.lex_state = 81, .external_lex_state = 4},
  [823] = {.lex_state = 81, .external_lex_state = 4},
  [824] = {.lex_state = 81, .external_lex_state = 4},
  [825] = {.lex_state = 81, .external_lex_state = 4},
  [826] = {.lex_state = 81, .external_lex_state = 4},
  [827] = {.lex_state = 81, .external_lex_state = 4},
  [828] = {.lex_state = 81, .external_lex_state = 4},
  [829] = {.lex_state = 81, .external_lex_state = 4},
  [830] = {.lex_state = 81, .external_lex_state = 4},
  [831] = {.lex_state = 81, .external_lex_state = 4},
  [832] = {.lex_state = 81, .external_lex_state = 4},
  [833] = {.lex_state = 81, .external_lex_state = 4},
  [834] = {.lex_state = 81, .external_lex_state = 4},
  [835] = {.lex_state = 81, .external_lex_state = 4},
  [836] = {.lex_state = 81, .external_lex_state = 4},
  [837] = {.lex_state = 81, .external_lex_state = 4},
  [838] = {.lex_state = 81, .external_lex_state = 4},
  [839] = {.lex_state = 81, .external_lex_state = 4},
  [840] = {.lex_state = 81, .external_lex_state = 4},
  [841] = {.lex_state = 81, .external_lex_state = 4},
  [842] = {.lex_state = 81, .external_lex_state = 4},
  [843] = {.lex_state = 81, .external_lex_state = 4},
  [844] = {.lex_state = 13, .external_lex_state = 3},
  [845] = {.lex_state = 78, .external_lex_state = 4},
  [846] = {.lex_state = 81, .external_lex_state = 4},
  [847] = {.lex_state = 81, .external_lex_state = 4},
  [848] = {.lex_state = 81, .external_lex_state = 4},
  [849] = {.lex_state = 6, .external_lex_state = 3},
  [850] = {.lex_state = 81, .external_lex_state = 4},
  [851] = {.lex_state = 81, .external_lex_state = 4},
  [852] = {.lex_state = 81, .external_lex_state = 4},
  [853] = {.lex_state = 81, .external_lex_state = 4},
  [854] = {.lex_state = 81, .external_lex_state = 4},
  [855] = {.lex_state = 81, .external_lex_state = 4},
  [856] = {.lex_state = 81, .external_lex_state = 4},
  [857] = {.lex_state = 78, .external_lex_state = 3},
  [858] = {.lex_state = 80, .external_lex_state = 2},
  [859] = {.lex_state = 81, .external_lex_state = 4},
  [860] = {.lex_state = 81, .external_lex_state = 4},
  [861] = {.lex_state = 81, .external_lex_state = 4},
  [862] = {.lex_state = 81, .external_lex_state = 4},
  [863] = {.lex_state = 81, .external_lex_state = 4},
  [864] = {.lex_state = 81, .external_lex_state = 4},
  [865] = {.lex_state = 81, .external_lex_state = 4},
  [866] = {.lex_state = 81, .external_lex_state = 4},
  [867] = {.lex_state = 81, .external_lex_state = 4},
  [868] = {.lex_state = 81, .external_lex_state = 4},
  [869] = {.lex_state = 22, .external_lex_state = 3},
  [870] = {.lex_state = 81, .external_lex_state = 4},
  [871] = {.lex_state = 81, .external_lex_state = 4},
  [872] = {.lex_state = 81, .external_lex_state = 4},
  [873] = {.lex_state = 81, .external_lex_state = 4},
  [874] = {.lex_state = 6, .external_lex_state = 3},
  [875] = {.lex_state = 81, .external_lex_state = 2},
  [876] = {.lex_state = 81, .external_lex_state = 3},
  [877] = {.lex_state = 80, .external_lex_state = 2},
  [878] = {.lex_state = 18, .external_lex_state = 3},
  [879] = {.lex_state = 2, .external_lex_state = 3},
  [880] = {.lex_state = 80, .external_lex_state = 2},
  [881] = {.lex_state = 13, .external_lex_state = 4},
  [882] = {.lex_state = 80, .external_lex_state = 2},
  [883] = {.lex_state = 13, .external_lex_state = 4},
  [884] = {.lex_state = 13, .external_lex_state = 4},
  [885] = {.lex_state = 81, .external_lex_state = 2},
  [886] = {.lex_state = 13, .external_lex_state = 4},
  [887] = {.lex_state = 13, .external_lex_state = 4},
  [888] = {.lex_state = 84, .external_lex_state = 2},
  [889] = {.lex_state = 13, .external_lex_state = 4},
  [890] = {.lex_state = 13, .external_lex_state = 4},
  [891] = {.lex_state = 81, .external_lex_state = 2},
  [892] = {.lex_state = 13, .external_lex_state = 4},
  [893] = {.lex_state = 13, .external_lex_state = 4},
  [894] = {.lex_state = 81, .external_lex_state = 2},
  [895] = {.lex_state = 84, .external_lex_state = 4},
  [896] = {.lex_state = 84, .external_lex_state = 2},
  [897] = {.lex_state = 84, .external_lex_state = 2},
  [898] = {.lex_state = 13, .external_lex_state = 4},
  [899] = {.lex_state = 13, .external_lex_state = 4},
  [900] = {.lex_state = 81, .external_lex_state = 2},
  [901] = {.lex_state = 81, .external_lex_state = 2},
  [902] = {.lex_state = 81, .external_lex_state = 2},
  [903] = {.lex_state = 13, .external_lex_state = 4},
  [904] = {.lex_state = 81, .external_lex_state = 2},
  [905] = {.lex_state = 13, .external_lex_state = 4},
  [906] = {.lex_state = 13, .external_lex_state = 4},
  [907] = {.lex_state = 13, .external_lex_state = 4},
  [908] = {.lex_state = 13, .external_lex_state = 4},
  [909] = {.lex_state = 84, .external_lex_state = 2},
  [910] = {.lex_state = 81, .external_lex_state = 2},
  [911] = {.lex_state = 81, .external_lex_state = 2},
  [912] = {.lex_state = 13, .external_lex_state = 4},
  [913] = {.lex_state = 10, .external_lex_state = 4},
  [914] = {.lex_state = 13, .external_lex_state = 4},
  [915] = {.lex_state = 13, .external_lex_state = 4},
  [916] = {.lex_state = 81, .external_lex_state = 2},
  [917] = {.lex_state = 84, .external_lex_state = 2},
  [918] = {.lex_state = 84, .external_lex_state = 4},
  [919] = {.lex_state = 84, .external_lex_state = 4},
  [920] = {.lex_state = 84, .external_lex_state = 2},
  [921] = {.lex_state = 13, .external_lex_state = 4},
  [922] = {.lex_state = 84, .external_lex_state = 2},
  [923] = {.lex_state = 84, .external_lex_state = 2},
  [924] = {.lex_state = 84, .external_lex_state = 2},
  [925] = {.lex_state = 84, .external_lex_state = 2},
  [926] = {.lex_state = 13, .external_lex_state = 4},
  [927] = {.lex_state = 13, .external_lex_state = 4},
  [928] = {.lex_state = 13, .external_lex_state = 4},
  [929] = {.lex_state = 84, .external_lex_state = 2},
  [930] = {.lex_state = 22, .external_lex_state = 3},
  [931] = {.lex_state = 13, .external_lex_state = 4},
  [932] = {.lex_state = 84, .external_lex_state = 2},
  [933] = {.lex_state = 84, .external_lex_state = 2},
  [934] = {.lex_state = 84, .external_lex_state = 2},
  [935] = {.lex_state = 13, .external_lex_state = 4},
  [936] = {.lex_state = 13, .external_lex_state = 4},
  [937] = {.lex_state = 81, .external_lex_state = 2},
  [938] = {.lex_state = 84, .external_lex_state = 2},
  [939] = {.lex_state = 81, .external_lex_state = 2},
  [940] = {.lex_state = 13, .external_lex_state = 4},
  [941] = {.lex_state = 84, .external_lex_state = 2},
  [942] = {.lex_state = 84, .external_lex_state = 4},
  [943] = {.lex_state = 84, .external_lex_state = 2},
  [944] = {.lex_state = 84, .external_lex_state = 2},
  [945] = {.lex_state = 84, .external_lex_state = 2},
  [946] = {.lex_state = 84, .external_lex_state = 2},
  [947] = {.lex_state = 84, .external_lex_state = 2},
  [948] = {.lex_state = 13, .external_lex_state = 4},
  [949] = {.lex_state = 84, .external_lex_state = 2},
  [950] = {.lex_state = 84, .external_lex_state = 2},
  [951] = {.lex_state = 84, .external_lex_state = 2},
  [952] = {.lex_state = 13, .external_lex_state = 4},
  [953] = {.lex_state = 84, .external_lex_state = 2},
  [954] = {.lex_state = 84, .external_lex_state = 2},
  [955] = {.lex_state = 84, .external_lex_state = 2},
  [956] = {.lex_state = 84, .external_lex_state = 2},
  [957] = {.lex_state = 84, .external_lex_state = 2},
  [958] = {.lex_state = 84, .external_lex_state = 2},
  [959] = {.lex_state = 84, .external_lex_state = 2},
  [960] = {.lex_state = 84, .external_lex_state = 2},
  [961] = {.lex_state = 84, .external_lex_state = 2},
  [962] = {.lex_state = 84, .external_lex_state = 2},
  [963] = {.lex_state = 84, .external_lex_state = 2},
  [964] = {.lex_state = 84, .external_lex_state = 2},
  [965] = {.lex_state = 84, .external_lex_state = 2},
  [966] = {.lex_state = 84, .external_lex_state = 2},
  [967] = {.lex_state = 84, .external_lex_state = 2},
  [968] = {.lex_state = 84, .external_lex_state = 2},
  [969] = {.lex_state = 84, .external_lex_state = 2},
  [970] = {.lex_state = 84, .external_lex_state = 2},
  [971] = {.lex_state = 84, .external_lex_state = 2},
  [972] = {.lex_state = 84, .external_lex_state = 2},
  [973] = {.lex_state = 84, .external_lex_state = 2},
  [974] = {.lex_state = 84, .external_lex_state = 2},
  [975] = {.lex_state = 84, .external_lex_state = 2},
  [976] = {.lex_state = 84, .external_lex_state = 2},
  [977] = {.lex_state = 13, .external_lex_state = 4},
  [978] = {.lex_state = 13, .external_lex_state = 4},
  [979] = {.lex_state = 84, .external_lex_state = 2},
  [980] = {.lex_state = 84, .external_lex_state = 2},
  [981] = {.lex_state = 84, .external_lex_state = 2},
  [982] = {.lex_state = 84, .external_lex_state = 2},
  [983] = {.lex_state = 84, .external_lex_state = 2},
  [984] = {.lex_state = 84, .external_lex_state = 2},
  [985] = {.lex_state = 84, .external_lex_state = 2},
  [986] = {.lex_state = 84, .external_lex_state = 2},
  [987] = {.lex_state = 81, .external_lex_state = 4},
  [988] = {.lex_state = 84, .external_lex_state = 2},
  [989] = {.lex_state = 84, .external_lex_state = 2},
  [990] = {.lex_state = 84, .external_lex_state = 2},
  [991] = {.lex_state = 84, .external_lex_state = 2},
  [992] = {.lex_state = 84, .external_lex_state = 2},
  [993] = {.lex_state = 84, .external_lex_state = 2},
  [994] = {.lex_state = 84, .external_lex_state = 2},
  [995] = {.lex_state = 84, .external_lex_state = 2},
  [996] = {.lex_state = 84, .external_lex_state = 2},
  [997] = {.lex_state = 18, .external_lex_state = 4},
  [998] = {.lex_state = 84, .external_lex_state = 2},
  [999] = {.lex_state = 84, .external_lex_state = 2},
  [1000] = {.lex_state = 84, .external_lex_state = 2},
  [1001] = {.lex_state = 84, .external_lex_state = 2},
  [1002] = {.lex_state = 84, .external_lex_state = 2},
  [1003] = {.lex_state = 84, .external_lex_state = 2},
  [1004] = {.lex_state = 84, .external_lex_state = 2},
  [1005] = {.lex_state = 84, .external_lex_state = 2},
  [1006] = {.lex_state = 84, .external_lex_state = 2},
  [1007] = {.lex_state = 84, .external_lex_state = 2},
  [1008] = {.lex_state = 84, .external_lex_state = 2},
  [1009] = {.lex_state = 84, .external_lex_state = 2},
  [1010] = {.lex_state = 84, .external_lex_state = 2},
  [1011] = {.lex_state = 84, .external_lex_state = 2},
  [1012] = {.lex_state = 81, .external_lex_state = 4},
  [1013] = {.lex_state = 84, .external_lex_state = 2},
  [1014] = {.lex_state = 84, .external_lex_state = 2},
  [1015] = {.lex_state = 13, .external_lex_state = 4},
  [1016] = {.lex_state = 84, .external_lex_state = 2},
  [1017] = {.lex_state = 2, .external_lex_state = 4},
  [1018] = {.lex_state = 84, .external_lex_state = 2},
  [1019] = {.lex_state = 84, .external_lex_state = 2},
  [1020] = {.lex_state = 84, .external_lex_state = 2},
  [1021] = {.lex_state = 84, .external_lex_state = 2},
  [1022] = {.lex_state = 84, .external_lex_state = 2},
  [1023] = {.lex_state = 84, .external_lex_state = 2},
  [1024] = {.lex_state = 84, .external_lex_state = 2},
  [1025] = {.lex_state = 84, .external_lex_state = 2},
  [1026] = {.lex_state = 84, .external_lex_state = 2},
  [1027] = {.lex_state = 84, .external_lex_state = 2},
  [1028] = {.lex_state = 13, .external_lex_state = 4},
  [1029] = {.lex_state = 84, .external_lex_state = 2},
  [1030] = {.lex_state = 84, .external_lex_state = 2},
  [1031] = {.lex_state = 84, .external_lex_state = 2},
  [1032] = {.lex_state = 84, .external_lex_state = 2},
  [1033] = {.lex_state = 13, .external_lex_state = 4},
  [1034] = {.lex_state = 84, .external_lex_state = 2},
  [1035] = {.lex_state = 84, .external_lex_state = 2},
  [1036] = {.lex_state = 84, .external_lex_state = 2},
  [1037] = {.lex_state = 84, .external_lex_state = 2},
  [1038] = {.lex_state = 84, .external_lex_state = 2},
  [1039] = {.lex_state = 84, .external_lex_state = 2},
  [1040] = {.lex_state = 84, .external_lex_state = 2},
  [1041] = {.lex_state = 13, .external_lex_state = 4},
  [1042] = {.lex_state = 13, .external_lex_state = 4},
  [1043] = {.lex_state = 18, .external_lex_state = 4},
  [1044] = {.lex_state = 13, .external_lex_state = 4},
  [1045] = {.lex_state = 84, .external_lex_state = 2},
  [1046] = {.lex_state = 2, .external_lex_state = 4},
  [1047] = {.lex_state = 13, .external_lex_state = 4},
  [1048] = {.lex_state = 13, .external_lex_state = 4},
  [1049] = {.lex_state = 13, .external_lex_state = 4},
  [1050] = {.lex_state = 13, .external_lex_state = 4},
  [1051] = {.lex_state = 13, .external_lex_state = 4},
  [1052] = {.lex_state = 84, .external_lex_state = 2},
  [1053] = {.lex_state = 84, .external_lex_state = 2},
  [1054] = {.lex_state = 84, .external_lex_state = 2},
  [1055] = {.lex_state = 84, .external_lex_state = 2},
  [1056] = {.lex_state = 13, .external_lex_state = 4},
  [1057] = {.lex_state = 84, .external_lex_state = 2},
  [1058] = {.lex_state = 84, .external_lex_state = 2},
  [1059] = {.lex_state = 84, .external_lex_state = 2},
  [1060] = {.lex_state = 84, .external_lex_state = 2},
  [1061] = {.lex_state = 84, .external_lex_state = 2},
  [1062] = {.lex_state = 84, .external_lex_state = 2},
  [1063] = {.lex_state = 84, .external_lex_state = 2},
  [1064] = {.lex_state = 13, .external_lex_state = 4},
  [1065] = {.lex_state = 13, .external_lex_state = 4},
  [1066] = {.lex_state = 13, .external_lex_state = 4},
  [1067] = {.lex_state = 84, .external_lex_state = 2},
  [1068] = {.lex_state = 84, .external_lex_state = 2},
  [1069] = {.lex_state = 84, .external_lex_state = 2},
  [1070] = {.lex_state = 84, .external_lex_state = 2},
  [1071] = {.lex_state = 13, .external_lex_state = 4},
  [1072] = {.lex_state = 84, .external_lex_state = 2},
  [1073] = {.lex_state = 84, .external_lex_state = 2},
  [1074] = {.lex_state = 13, .external_lex_state = 4},
  [1075] = {.lex_state = 84, .external_lex_state = 2},
  [1076] = {.lex_state = 84, .external_lex_state = 2},
  [1077] = {.lex_state = 84, .external_lex_state = 2},
  [1078] = {.lex_state = 13, .external_lex_state = 4},
  [1079] = {.lex_state = 84, .external_lex_state = 2},
  [1080] = {.lex_state = 84, .external_lex_state = 2},
  [1081] = {.lex_state = 84, .external_lex_state = 2},
  [1082] = {.lex_state = 84, .external_lex_state = 2},
  [1083] = {.lex_state = 84, .external_lex_state = 2},
  [1084] = {.lex_state = 84, .external_lex_state = 2},
  [1085] = {.lex_state = 13, .external_lex_state = 4},
  [1086] = {.lex_state = 84, .external_lex_state = 2},
  [1087] = {.lex_state = 12, .external_lex_state = 2},
  [1088] = {.lex_state = 18, .external_lex_state = 4},
  [1089] = {.lex_state = 84, .external_lex_state = 2},
  [1090] = {.lex_state = 2, .external_lex_state = 4},
  [1091] = {.lex_state = 84, .external_lex_state = 2},
  [1092] = {.lex_state = 84, .external_lex_state = 2},
  [1093] = {.lex_state = 84, .external_lex_state = 2},
  [1094] = {.lex_state = 84, .external_lex_state = 2},
  [1095] = {.lex_state = 13, .external_lex_state = 4},
  [1096] = {.lex_state = 81, .external_lex_state = 4},
  [1097] = {.lex_state = 84, .external_lex_state = 2},
  [1098] = {.lex_state = 2, .external_lex_state = 4},
  [1099] = {.lex_state = 81, .external_lex_state = 4},
  [1100] = {.lex_state = 13, .external_lex_state = 2},
  [1101] = {.lex_state = 13, .external_lex_state = 2},
  [1102] = {.lex_state = 6, .external_lex_state = 4},
  [1103] = {.lex_state = 18, .external_lex_state = 4},
  [1104] = {.lex_state = 18, .external_lex_state = 4},
  [1105] = {.lex_state = 81, .external_lex_state = 4},
  [1106] = {.lex_state = 18, .external_lex_state = 4},
  [1107] = {.lex_state = 18, .external_lex_state = 4},
  [1108] = {.lex_state = 18, .external_lex_state = 4},
  [1109] = {.lex_state = 18, .external_lex_state = 4},
  [1110] = {.lex_state = 18, .external_lex_state = 4},
  [1111] = {.lex_state = 18, .external_lex_state = 4},
  [1112] = {.lex_state = 18, .external_lex_state = 4},
  [1113] = {.lex_state = 18, .external_lex_state = 4},
  [1114] = {.lex_state = 18, .external_lex_state = 4},
  [1115] = {.lex_state = 18, .external_lex_state = 4},
  [1116] = {.lex_state = 18, .external_lex_state = 4},
  [1117] = {.lex_state = 78, .external_lex_state = 4},
  [1118] = {.lex_state = 18, .external_lex_state = 4},
  [1119] = {.lex_state = 18, .external_lex_state = 4},
  [1120] = {.lex_state = 18, .external_lex_state = 4},
  [1121] = {.lex_state = 18, .external_lex_state = 4},
  [1122] = {.lex_state = 18, .external_lex_state = 4},
  [1123] = {.lex_state = 18, .external_lex_state = 4},
  [1124] = {.lex_state = 18, .external_lex_state = 4},
  [1125] = {.lex_state = 2, .external_lex_state = 4},
  [1126] = {.lex_state = 2, .external_lex_state = 4},
  [1127] = {.lex_state = 18, .external_lex_state = 4},
  [1128] = {.lex_state = 2, .external_lex_state = 4},
  [1129] = {.lex_state = 2, .external_lex_state = 4},
  [1130] = {.lex_state = 18, .external_lex_state = 4},
  [1131] = {.lex_state = 2, .external_lex_state = 4},
  [1132] = {.lex_state = 2, .external_lex_state = 4},
  [1133] = {.lex_state = 2, .external_lex_state = 4},
  [1134] = {.lex_state = 12, .external_lex_state = 2},
  [1135] = {.lex_state = 2, .external_lex_state = 4},
  [1136] = {.lex_state = 12, .external_lex_state = 2},
  [1137] = {.lex_state = 2, .external_lex_state = 4},
  [1138] = {.lex_state = 2, .external_lex_state = 4},
  [1139] = {.lex_state = 12, .external_lex_state = 2},
  [1140] = {.lex_state = 2, .external_lex_state = 4},
  [1141] = {.lex_state = 2, .external_lex_state = 4},
  [1142] = {.lex_state = 22, .external_lex_state = 4},
  [1143] = {.lex_state = 2, .external_lex_state = 4},
  [1144] = {.lex_state = 81, .external_lex_state = 4},
  [1145] = {.lex_state = 2, .external_lex_state = 4},
  [1146] = {.lex_state = 2, .external_lex_state = 4},
  [1147] = {.lex_state = 2, .external_lex_state = 4},
  [1148] = {.lex_state = 2, .external_lex_state = 4},
  [1149] = {.lex_state = 81, .external_lex_state = 4},
  [1150] = {.lex_state = 81, .external_lex_state = 4},
  [1151] = {.lex_state = 2, .external_lex_state = 4},
  [1152] = {.lex_state = 2, .external_lex_state = 4},
  [1153] = {.lex_state = 2, .external_lex_state = 4},
  [1154] = {.lex_state = 81, .external_lex_state = 4},
  [1155] = {.lex_state = 81, .external_lex_state = 4},
  [1156] = {.lex_state = 18, .external_lex_state = 4},
  [1157] = {.lex_state = 2, .external_lex_state = 4},
  [1158] = {.lex_state = 2, .external_lex_state = 4},
  [1159] = {.lex_state = 81, .external_lex_state = 4},
  [1160] = {.lex_state = 81, .external_lex_state = 4},
  [1161] = {.lex_state = 81, .external_lex_state = 4},
  [1162] = {.lex_state = 81, .external_lex_state = 4},
  [1163] = {.lex_state = 81, .external_lex_state = 4},
  [1164] = {.lex_state = 81, .external_lex_state = 4},
  [1165] = {.lex_state = 81, .external_lex_state = 4},
  [1166] = {.lex_state = 18, .external_lex_state = 4},
  [1167] = {.lex_state = 81, .external_lex_state = 4},
  [1168] = {.lex_state = 81, .external_lex_state = 4},
  [1169] = {.lex_state = 81, .external_lex_state = 4},
  [1170] = {.lex_state = 81, .external_lex_state = 4},
  [1171] = {.lex_state = 81, .external_lex_state = 4},
  [1172] = {.lex_state = 81, .external_lex_state = 4},
  [1173] = {.lex_state = 2, .external_lex_state = 4},
  [1174] = {.lex_state = 81, .external_lex_state = 4},
  [1175] = {.lex_state = 81, .external_lex_state = 4},
  [1176] = {.lex_state = 81, .external_lex_state = 4},
  [1177] = {.lex_state = 81, .external_lex_state = 4},
  [1178] = {.lex_state = 13, .external_lex_state = 2},
  [1179] = {.lex_state = 2, .external_lex_state = 4},
  [1180] = {.lex_state = 18, .external_lex_state = 4},
  [1181] = {.lex_state = 18, .external_lex_state = 4},
  [1182] = {.lex_state = 18, .external_lex_state = 4},
  [1183] = {.lex_state = 18, .external_lex_state = 4},
  [1184] = {.lex_state = 18, .external_lex_state = 4},
  [1185] = {.lex_state = 18, .external_lex_state = 4},
  [1186] = {.lex_state = 18, .external_lex_state = 4},
  [1187] = {.lex_state = 18, .external_lex_state = 4},
  [1188] = {.lex_state = 16, .external_lex_state = 2},
  [1189] = {.lex_state = 81, .external_lex_state = 4},
  [1190] = {.lex_state = 81, .external_lex_state = 4},
  [1191] = {.lex_state = 81, .external_lex_state = 4},
  [1192] = {.lex_state = 16, .external_lex_state = 2},
  [1193] = {.lex_state = 18, .external_lex_state = 4},
  [1194] = {.lex_state = 18, .external_lex_state = 4},
  [1195] = {.lex_state = 81, .external_lex_state = 4},
  [1196] = {.lex_state = 81, .external_lex_state = 4},
  [1197] = {.lex_state = 18, .external_lex_state = 4},
  [1198] = {.lex_state = 18, .external_lex_state = 4},
  [1199] = {.lex_state = 13, .external_lex_state = 2},
  [1200] = {.lex_state = 18, .external_lex_state = 4},
  [1201] = {.lex_state = 18, .external_lex_state = 4},
  [1202] = {.lex_state = 16, .external_lex_state = 2},
  [1203] = {.lex_state = 2, .external_lex_state = 4},
  [1204] = {.lex_state = 18, .external_lex_state = 4},
  [1205] = {.lex_state = 81, .external_lex_state = 4},
  [1206] = {.lex_state = 81, .external_lex_state = 4},
  [1207] = {.lex_state = 18, .external_lex_state = 4},
  [1208] = {.lex_state = 84, .external_lex_state = 2},
  [1209] = {.lex_state = 18, .external_lex_state = 4},
  [1210] = {.lex_state = 18, .external_lex_state = 4},
  [1211] = {.lex_state = 18, .external_lex_state = 4},
  [1212] = {.lex_state = 16, .external_lex_state = 2},
  [1213] = {.lex_state = 5, .external_lex_state = 2},
  [1214] = {.lex_state = 2, .external_lex_state = 4},
  [1215] = {.lex_state = 2, .external_lex_state = 4},
  [1216] = {.lex_state = 81, .external_lex_state = 4},
  [1217] = {.lex_state = 81, .external_lex_state = 4},
  [1218] = {.lex_state = 16, .external_lex_state = 2},
  [1219] = {.lex_state = 18, .external_lex_state = 4},
  [1220] = {.lex_state = 13, .external_lex_state = 2},
  [1221] = {.lex_state = 18, .external_lex_state = 4},
  [1222] = {.lex_state = 16, .external_lex_state = 2},
  [1223] = {.lex_state = 18, .external_lex_state = 4},
  [1224] = {.lex_state = 16, .external_lex_state = 4},
  [1225] = {.lex_state = 13, .external_lex_state = 2},
  [1226] = {.lex_state = 21, .external_lex_state = 2},
  [1227] = {.lex_state = 2, .external_lex_state = 4},
  [1228] = {.lex_state = 13, .external_lex_state = 2},
  [1229] = {.lex_state = 81, .external_lex_state = 4},
  [1230] = {.lex_state = 84, .external_lex_state = 2},
  [1231] = {.lex_state = 81, .external_lex_state = 4},
  [1232] = {.lex_state = 16, .external_lex_state = 2},
  [1233] = {.lex_state = 80, .external_lex_state = 2},
  [1234] = {.lex_state = 18, .external_lex_state = 4},
  [1235] = {.lex_state = 16, .external_lex_state = 2},
  [1236] = {.lex_state = 16, .external_lex_state = 2},
  [1237] = {.lex_state = 18, .external_lex_state = 4},
  [1238] = {.lex_state = 16, .external_lex_state = 2},
  [1239] = {.lex_state = 2, .external_lex_state = 4},
  [1240] = {.lex_state = 16, .external_lex_state = 4},
  [1241] = {.lex_state = 16, .external_lex_state = 4},
  [1242] = {.lex_state = 16, .external_lex_state = 2},
  [1243] = {.lex_state = 81, .external_lex_state = 4},
  [1244] = {.lex_state = 2, .external_lex_state = 4},
  [1245] = {.lex_state = 16, .external_lex_state = 2},
  [1246] = {.lex_state = 2, .external_lex_state = 4},
  [1247] = {.lex_state = 2, .external_lex_state = 4},
  [1248] = {.lex_state = 81, .external_lex_state = 4},
  [1249] = {.lex_state = 2, .external_lex_state = 4},
  [1250] = {.lex_state = 81, .external_lex_state = 4},
  [1251] = {.lex_state = 2, .external_lex_state = 4},
  [1252] = {.lex_state = 2, .external_lex_state = 4},
  [1253] = {.lex_state = 81, .external_lex_state = 4},
  [1254] = {.lex_state = 13, .external_lex_state = 2},
  [1255] = {.lex_state = 13, .external_lex_state = 2},
  [1256] = {.lex_state = 13, .external_lex_state = 2},
  [1257] = {.lex_state = 16, .external_lex_state = 2},
  [1258] = {.lex_state = 16, .external_lex_state = 2},
  [1259] = {.lex_state = 81, .external_lex_state = 4},
  [1260] = {.lex_state = 81, .external_lex_state = 4},
  [1261] = {.lex_state = 2, .external_lex_state = 4},
  [1262] = {.lex_state = 16, .external_lex_state = 2},
  [1263] = {.lex_state = 81, .external_lex_state = 4},
  [1264] = {.lex_state = 16, .external_lex_state = 4},
  [1265] = {.lex_state = 2, .external_lex_state = 4},
  [1266] = {.lex_state = 16, .external_lex_state = 2},
  [1267] = {.lex_state = 81, .external_lex_state = 4},
  [1268] = {.lex_state = 16, .external_lex_state = 2},
  [1269] = {.lex_state = 81, .external_lex_state = 4},
  [1270] = {.lex_state = 81, .external_lex_state = 4},
  [1271] = {.lex_state = 81, .external_lex_state = 4},
  [1272] = {.lex_state = 2, .external_lex_state = 4},
  [1273] = {.lex_state = 81, .external_lex_state = 4},
  [1274] = {.lex_state = 16, .external_lex_state = 2},
  [1275] = {.lex_state = 2, .external_lex_state = 4},
  [1276] = {.lex_state = 2, .external_lex_state = 4},
  [1277] = {.lex_state = 2, .external_lex_state = 4},
  [1278] = {.lex_state = 2, .external_lex_state = 4},
  [1279] = {.lex_state = 84, .external_lex_state = 2},
  [1280] = {.lex_state = 2, .external_lex_state = 4},
  [1281] = {.lex_state = 2, .external_lex_state = 4},
  [1282] = {.lex_state = 16, .external_lex_state = 2},
  [1283] = {.lex_state = 13, .external_lex_state = 2},
  [1284] = {.lex_state = 13, .external_lex_state = 2},
  [1285] = {.lex_state = 84, .external_lex_state = 2},
  [1286] = {.lex_state = 2, .external_lex_state = 4},
  [1287] = {.lex_state = 2, .external_lex_state = 4},
  [1288] = {.lex_state = 2, .external_lex_state = 4},
  [1289] = {.lex_state = 81, .external_lex_state = 4},
  [1290] = {.lex_state = 13, .external_lex_state = 2},
  [1291] = {.lex_state = 16, .external_lex_state = 2},
  [1292] = {.lex_state = 16, .external_lex_state = 2},
  [1293] = {.lex_state = 16, .external_lex_state = 2},
  [1294] = {.lex_state = 16, .external_lex_state = 2},
  [1295] = {.lex_state = 16, .external_lex_state = 2},
  [1296] = {.lex_state = 16, .external_lex_state = 2},
  [1297] = {.lex_state = 16, .external_lex_state = 2},
  [1298] = {.lex_state = 16, .external_lex_state = 2},
  [1299] = {.lex_state = 16, .external_lex_state = 2},
  [1300] = {.lex_state = 16, .external_lex_state = 2},
  [1301] = {.lex_state = 16, .external_lex_state = 2},
  [1302] = {.lex_state = 16, .external_lex_state = 2},
  [1303] = {.lex_state = 16, .external_lex_state = 2},
  [1304] = {.lex_state = 16, .external_lex_state = 2},
  [1305] = {.lex_state = 16, .external_lex_state = 2},
  [1306] = {.lex_state = 5, .external_lex_state = 2},
  [1307] = {.lex_state = 16, .external_lex_state = 2},
  [1308] = {.lex_state = 16, .external_lex_state = 2},
  [1309] = {.lex_state = 5, .external_lex_state = 2},
  [1310] = {.lex_state = 16, .external_lex_state = 2},
  [1311] = {.lex_state = 16, .external_lex_state = 2},
  [1312] = {.lex_state = 16, .external_lex_state = 2},
  [1313] = {.lex_state = 16, .external_lex_state = 2},
  [1314] = {.lex_state = 16, .external_lex_state = 2},
  [1315] = {.lex_state = 16, .external_lex_state = 2},
  [1316] = {.lex_state = 16, .external_lex_state = 2},
  [1317] = {.lex_state = 16, .external_lex_state = 2},
  [1318] = {.lex_state = 16, .external_lex_state = 2},
  [1319] = {.lex_state = 16, .external_lex_state = 2},
  [1320] = {.lex_state = 16, .external_lex_state = 2},
  [1321] = {.lex_state = 16, .external_lex_state = 2},
  [1322] = {.lex_state = 16, .external_lex_state = 2},
  [1323] = {.lex_state = 16, .external_lex_state = 2},
  [1324] = {.lex_state = 16, .external_lex_state = 2},
  [1325] = {.lex_state = 16, .external_lex_state = 2},
  [1326] = {.lex_state = 16, .external_lex_state = 2},
  [1327] = {.lex_state = 16, .external_lex_state = 2},
  [1328] = {.lex_state = 16, .external_lex_state = 2},
  [1329] = {.lex_state = 16, .external_lex_state = 2},
  [1330] = {.lex_state = 16, .external_lex_state = 2},
  [1331] = {.lex_state = 16, .external_lex_state = 2},
  [1332] = {.lex_state = 16, .external_lex_state = 2},
  [1333] = {.lex_state = 16, .external_lex_state = 2},
  [1334] = {.lex_state = 16, .external_lex_state = 2},
  [1335] = {.lex_state = 16, .external_lex_state = 2},
  [1336] = {.lex_state = 16, .external_lex_state = 2},
  [1337] = {.lex_state = 16, .external_lex_state = 2},
  [1338] = {.lex_state = 16, .external_lex_state = 2},
  [1339] = {.lex_state = 16, .external_lex_state = 2},
  [1340] = {.lex_state = 16, .external_lex_state = 2},
  [1341] = {.lex_state = 16, .external_lex_state = 2},
  [1342] = {.lex_state = 16, .external_lex_state = 2},
  [1343] = {.lex_state = 16, .external_lex_state = 2},
  [1344] = {.lex_state = 16, .external_lex_state = 2},
  [1345] = {.lex_state = 16, .external_lex_state = 2},
  [1346] = {.lex_state = 16, .external_lex_state = 2},
  [1347] = {.lex_state = 16, .external_lex_state = 2},
  [1348] = {.lex_state = 16, .external_lex_state = 2},
  [1349] = {.lex_state = 16, .external_lex_state = 2},
  [1350] = {.lex_state = 16, .external_lex_state = 2},
  [1351] = {.lex_state = 16, .external_lex_state = 2},
  [1352] = {.lex_state = 16, .external_lex_state = 2},
  [1353] = {.lex_state = 16, .external_lex_state = 2},
  [1354] = {.lex_state = 16, .external_lex_state = 2},
  [1355] = {.lex_state = 16, .external_lex_state = 2},
  [1356] = {.lex_state = 16, .external_lex_state = 2},
  [1357] = {.lex_state = 16, .external_lex_state = 2},
  [1358] = {.lex_state = 16, .external_lex_state = 2},
  [1359] = {.lex_state = 16, .external_lex_state = 2},
  [1360] = {.lex_state = 16, .external_lex_state = 2},
  [1361] = {.lex_state = 16, .external_lex_state = 2},
  [1362] = {.lex_state = 16, .external_lex_state = 2},
  [1363] = {.lex_state = 16, .external_lex_state = 2},
  [1364] = {.lex_state = 16, .external_lex_state = 2},
  [1365] = {.lex_state = 16, .external_lex_state = 2},
  [1366] = {.lex_state = 16, .external_lex_state = 2},
  [1367] = {.lex_state = 16, .external_lex_state = 2},
  [1368] = {.lex_state = 16, .external_lex_state = 2},
  [1369] = {.lex_state = 16, .external_lex_state = 2},
  [1370] = {.lex_state = 16, .external_lex_state = 2},
  [1371] = {.lex_state = 16, .external_lex_state = 2},
  [1372] = {.lex_state = 16, .external_lex_state = 2},
  [1373] = {.lex_state = 5, .external_lex_state = 2},
  [1374] = {.lex_state = 16, .external_lex_state = 2},
  [1375] = {.lex_state = 16, .external_lex_state = 2},
  [1376] = {.lex_state = 16, .external_lex_state = 2},
  [1377] = {.lex_state = 80, .external_lex_state = 2},
  [1378] = {.lex_state = 80, .external_lex_state = 2},
  [1379] = {.lex_state = 16, .external_lex_state = 2},
  [1380] = {.lex_state = 16, .external_lex_state = 2},
  [1381] = {.lex_state = 16, .external_lex_state = 2},
  [1382] = {.lex_state = 16, .external_lex_state = 2},
  [1383] = {.lex_state = 16, .external_lex_state = 2},
  [1384] = {.lex_state = 16, .external_lex_state = 2},
  [1385] = {.lex_state = 16, .external_lex_state = 2},
  [1386] = {.lex_state = 16, .external_lex_state = 2},
  [1387] = {.lex_state = 2, .external_lex_state = 2},
  [1388] = {.lex_state = 16, .external_lex_state = 2},
  [1389] = {.lex_state = 16, .external_lex_state = 2},
  [1390] = {.lex_state = 16, .external_lex_state = 2},
  [1391] = {.lex_state = 16, .external_lex_state = 2},
  [1392] = {.lex_state = 16, .external_lex_state = 2},
  [1393] = {.lex_state = 16, .external_lex_state = 2},
  [1394] = {.lex_state = 18, .external_lex_state = 2},
  [1395] = {.lex_state = 18, .external_lex_state = 2},
  [1396] = {.lex_state = 16, .external_lex_state = 2},
  [1397] = {.lex_state = 16, .external_lex_state = 2},
  [1398] = {.lex_state = 16, .external_lex_state = 2},
  [1399] = {.lex_state = 16, .external_lex_state = 2},
  [1400] = {.lex_state = 2, .external_lex_state = 2},
  [1401] = {.lex_state = 16, .external_lex_state = 2},
  [1402] = {.lex_state = 16, .external_lex_state = 2},
  [1403] = {.lex_state = 16, .external_lex_state = 2},
  [1404] = {.lex_state = 16, .external_lex_state = 2},
  [1405] = {.lex_state = 16, .external_lex_state = 2},
  [1406] = {.lex_state = 16, .external_lex_state = 2},
  [1407] = {.lex_state = 16, .external_lex_state = 2},
  [1408] = {.lex_state = 16, .external_lex_state = 2},
  [1409] = {.lex_state = 16, .external_lex_state = 2},
  [1410] = {.lex_state = 16, .external_lex_state = 2},
  [1411] = {.lex_state = 16, .external_lex_state = 2},
  [1412] = {.lex_state = 16, .external_lex_state = 2},
  [1413] = {.lex_state = 84, .external_lex_state = 2},
  [1414] = {.lex_state = 16, .external_lex_state = 2},
  [1415] = {.lex_state = 16, .external_lex_state = 2},
  [1416] = {.lex_state = 81, .external_lex_state = 2},
  [1417] = {.lex_state = 16, .external_lex_state = 2},
  [1418] = {.lex_state = 84, .external_lex_state = 2},
  [1419] = {.lex_state = 16, .external_lex_state = 2},
  [1420] = {.lex_state = 16, .external_lex_state = 2},
  [1421] = {.lex_state = 81, .external_lex_state = 2},
  [1422] = {.lex_state = 16, .external_lex_state = 2},
  [1423] = {.lex_state = 16, .external_lex_state = 2},
  [1424] = {.lex_state = 16, .external_lex_state = 2},
  [1425] = {.lex_state = 80, .external_lex_state = 2},
  [1426] = {.lex_state = 16, .external_lex_state = 2},
  [1427] = {.lex_state = 16, .external_lex_state = 2},
  [1428] = {.lex_state = 21, .external_lex_state = 2},
  [1429] = {.lex_state = 21, .external_lex_state = 2},
  [1430] = {.lex_state = 21, .external_lex_state = 2},
  [1431] = {.lex_state = 1, .external_lex_state = 2},
  [1432] = {.lex_state = 17, .external_lex_state = 2},
  [1433] = {.lex_state = 2, .external_lex_state = 2},
  [1434] = {.lex_state = 1, .external_lex_state = 4},
  [1435] = {.lex_state = 2, .external_lex_state = 2},
  [1436] = {.lex_state = 2, .external_lex_state = 2},
  [1437] = {.lex_state = 2, .external_lex_state = 2},
  [1438] = {.lex_state = 1, .external_lex_state = 2},
  [1439] = {.lex_state = 1, .external_lex_state = 2},
  [1440] = {.lex_state = 1, .external_lex_state = 2},
  [1441] = {.lex_state = 2, .external_lex_state = 2},
  [1442] = {.lex_state = 2, .external_lex_state = 2},
  [1443] = {.lex_state = 1, .external_lex_state = 2},
  [1444] = {.lex_state = 1, .external_lex_state = 2},
  [1445] = {.lex_state = 1, .external_lex_state = 2},
  [1446] = {.lex_state = 2, .external_lex_state = 2},
  [1447] = {.lex_state = 2, .external_lex_state = 2},
  [1448] = {.lex_state = 2, .external_lex_state = 2},
  [1449] = {.lex_state = 1, .external_lex_state = 2},
  [1450] = {.lex_state = 1, .external_lex_state = 2},
  [1451] = {.lex_state = 1, .external_lex_state = 2},
  [1452] = {.lex_state = 84, .external_lex_state = 2},
  [1453] = {.lex_state = 2, .external_lex_state = 2},
  [1454] = {.lex_state = 2, .external_lex_state = 2},
  [1455] = {.lex_state = 84, .external_lex_state = 2},
  [1456] = {.lex_state = 1, .external_lex_state = 2},
  [1457] = {.lex_state = 1, .external_lex_state = 2},
  [1458] = {.lex_state = 84, .external_lex_state = 2},
  [1459] = {.lex_state = 18, .external_lex_state = 2},
  [1460] = {.lex_state = 1, .external_lex_state = 4},
  [1461] = {.lex_state = 17, .external_lex_state = 4},
  [1462] = {.lex_state = 18, .external_lex_state = 2},
  [1463] = {.lex_state = 18, .external_lex_state = 2},
  [1464] = {.lex_state = 18, .external_lex_state = 2},
  [1465] = {.lex_state = 84, .external_lex_state = 2},
  [1466] = {.lex_state = 17, .external_lex_state = 2},
  [1467] = {.lex_state = 1, .external_lex_state = 2},
  [1468] = {.lex_state = 17, .external_lex_state = 2},
  [1469] = {.lex_state = 1, .external_lex_state = 2},
  [1470] = {.lex_state = 17, .external_lex_state = 2},
  [1471] = {.lex_state = 17, .external_lex_state = 2},
  [1472] = {.lex_state = 1, .external_lex_state = 4},
  [1473] = {.lex_state = 1, .external_lex_state = 4},
  [1474] = {.lex_state = 18, .external_lex_state = 2},
  [1475] = {.lex_state = 18, .external_lex_state = 2},
  [1476] = {.lex_state = 17, .external_lex_state = 2},
  [1477] = {.lex_state = 17, .external_lex_state = 2},
  [1478] = {.lex_state = 17, .external_lex_state = 2},
  [1479] = {.lex_state = 18, .external_lex_state = 2},
  [1480] = {.lex_state = 18, .external_lex_state = 2},
  [1481] = {.lex_state = 18, .external_lex_state = 2},
  [1482] = {.lex_state = 1, .external_lex_state = 2},
  [1483] = {.lex_state = 17, .external_lex_state = 2},
  [1484] = {.lex_state = 17, .external_lex_state = 2},
  [1485] = {.lex_state = 18, .external_lex_state = 2},
  [1486] = {.lex_state = 18, .external_lex_state = 2},
  [1487] = {.lex_state = 17, .external_lex_state = 2},
  [1488] = {.lex_state = 17, .external_lex_state = 2},
  [1489] = {.lex_state = 17, .external_lex_state = 2},
  [1490] = {.lex_state = 81, .external_lex_state = 2},
  [1491] = {.lex_state = 17, .external_lex_state = 4},
  [1492] = {.lex_state = 84, .external_lex_state = 4},
  [1493] = {.lex_state = 84, .external_lex_state = 2},
  [1494] = {.lex_state = 81, .external_lex_state = 2},
  [1495] = {.lex_state = 81, .external_lex_state = 2},
  [1496] = {.lex_state = 81, .external_lex_state = 2},
  [1497] = {.lex_state = 84, .external_lex_state = 2},
  [1498] = {.lex_state = 17, .external_lex_state = 2},
  [1499] = {.lex_state = 84, .external_lex_state = 2},
  [1500] = {.lex_state = 84, .external_lex_state = 2},
  [1501] = {.lex_state = 84, .external_lex_state = 2},
  [1502] = {.lex_state = 17, .external_lex_state = 4},
  [1503] = {.lex_state = 17, .external_lex_state = 4},
  [1504] = {.lex_state = 84, .external_lex_state = 2},
  [1505] = {.lex_state = 81, .external_lex_state = 2},
  [1506] = {.lex_state = 81, .external_lex_state = 2},
  [1507] = {.lex_state = 17, .external_lex_state = 2},
  [1508] = {.lex_state = 84, .external_lex_state = 2},
  [1509] = {.lex_state = 84, .external_lex_state = 4},
  [1510] = {.lex_state = 84, .external_lex_state = 4},
  [1511] = {.lex_state = 84, .external_lex_state = 2},
  [1512] = {.lex_state = 84, .external_lex_state = 2},
  [1513] = {.lex_state = 81, .external_lex_state = 2},
  [1514] = {.lex_state = 81, .external_lex_state = 2},
  [1515] = {.lex_state = 81, .external_lex_state = 2},
  [1516] = {.lex_state = 9, .external_lex_state = 2},
  [1517] = {.lex_state = 1, .external_lex_state = 2},
  [1518] = {.lex_state = 17, .external_lex_state = 2},
  [1519] = {.lex_state = 84, .external_lex_state = 2},
  [1520] = {.lex_state = 84, .external_lex_state = 2},
  [1521] = {.lex_state = 84, .external_lex_state = 2},
  [1522] = {.lex_state = 81, .external_lex_state = 2},
  [1523] = {.lex_state = 81, .external_lex_state = 2},
  [1524] = {.lex_state = 84, .external_lex_state = 2},
  [1525] = {.lex_state = 84, .external_lex_state = 2},
  [1526] = {.lex_state = 84, .external_lex_state = 4},
  [1527] = {.lex_state = 84, .external_lex_state = 2},
  [1528] = {.lex_state = 17, .external_lex_state = 2},
  [1529] = {.lex_state = 17, .external_lex_state = 2},
  [1530] = {.lex_state = 84, .external_lex_state = 2},
  [1531] = {.lex_state = 1, .external_lex_state = 2},
  [1532] = {.lex_state = 1, .external_lex_state = 2},
  [1533] = {.lex_state = 1, .external_lex_state = 2},
  [1534] = {.lex_state = 1, .external_lex_state = 2},
  [1535] = {.lex_state = 1, .external_lex_state = 2},
  [1536] = {.lex_state = 1, .external_lex_state = 2},
  [1537] = {.lex_state = 1, .external_lex_state = 2},
  [1538] = {.lex_state = 1, .external_lex_state = 2},
  [1539] = {.lex_state = 1, .external_lex_state = 2},
  [1540] = {.lex_state = 84, .external_lex_state = 2},
  [1541] = {.lex_state = 1, .external_lex_state = 2},
  [1542] = {.lex_state = 1, .external_lex_state = 2},
  [1543] = {.lex_state = 1, .external_lex_state = 2},
  [1544] = {.lex_state = 1, .external_lex_state = 2},
  [1545] = {.lex_state = 1, .external_lex_state = 2},
  [1546] = {.lex_state = 1, .external_lex_state = 2},
  [1547] = {.lex_state = 1, .external_lex_state = 2},
  [1548] = {.lex_state = 84, .external_lex_state = 2},
  [1549] = {.lex_state = 84, .external_lex_state = 2},
  [1550] = {.lex_state = 84, .external_lex_state = 2},
  [1551] = {.lex_state = 1, .external_lex_state = 2},
  [1552] = {.lex_state = 1, .external_lex_state = 2},
  [1553] = {.lex_state = 1, .external_lex_state = 2},
  [1554] = {.lex_state = 1, .external_lex_state = 2},
  [1555] = {.lex_state = 17, .external_lex_state = 2},
  [1556] = {.lex_state = 84, .external_lex_state = 2},
  [1557] = {.lex_state = 84, .external_lex_state = 2},
  [1558] = {.lex_state = 84, .external_lex_state = 2},
  [1559] = {.lex_state = 84, .external_lex_state = 2},
  [1560] = {.lex_state = 84, .external_lex_state = 2},
  [1561] = {.lex_state = 84, .external_lex_state = 2},
  [1562] = {.lex_state = 84, .external_lex_state = 2},
  [1563] = {.lex_state = 84, .external_lex_state = 2},
  [1564] = {.lex_state = 84, .external_lex_state = 2},
  [1565] = {.lex_state = 84, .external_lex_state = 2},
  [1566] = {.lex_state = 84, .external_lex_state = 2},
  [1567] = {.lex_state = 84, .external_lex_state = 2},
  [1568] = {.lex_state = 1, .external_lex_state = 2},
  [1569] = {.lex_state = 1, .external_lex_state = 2},
  [1570] = {.lex_state = 1, .external_lex_state = 2},
  [1571] = {.lex_state = 17, .external_lex_state = 2},
  [1572] = {.lex_state = 1, .external_lex_state = 2},
  [1573] = {.lex_state = 84, .external_lex_state = 2},
  [1574] = {.lex_state = 84, .external_lex_state = 2},
  [1575] = {.lex_state = 84, .external_lex_state = 2},
  [1576] = {.lex_state = 84, .external_lex_state = 2},
  [1577] = {.lex_state = 84, .external_lex_state = 2},
  [1578] = {.lex_state = 84, .external_lex_state = 2},
  [1579] = {.lex_state = 84, .external_lex_state = 2},
  [1580] = {.lex_state = 84, .external_lex_state = 2},
  [1581] = {.lex_state = 84, .external_lex_state = 2},
  [1582] = {.lex_state = 17, .external_lex_state = 2},
  [1583] = {.lex_state = 17, .external_lex_state = 2},
  [1584] = {.lex_state = 84, .external_lex_state = 2},
  [1585] = {.lex_state = 84, .external_lex_state = 2},
  [1586] = {.lex_state = 84, .external_lex_state = 2},
  [1587] = {.lex_state = 84, .external_lex_state = 2},
  [1588] = {.lex_state = 84, .external_lex_state = 2},
  [1589] = {.lex_state = 84, .external_lex_state = 2},
  [1590] = {.lex_state = 84, .external_lex_state = 2},
  [1591] = {.lex_state = 84, .external_lex_state = 2},
  [1592] = {.lex_state = 1, .external_lex_state = 2},
  [1593] = {.lex_state = 84, .external_lex_state = 2},
  [1594] = {.lex_state = 84, .external_lex_state = 2},
  [1595] = {.lex_state = 84, .external_lex_state = 2},
  [1596] = {.lex_state = 84, .external_lex_state = 2},
  [1597] = {.lex_state = 84, .external_lex_state = 2},
  [1598] = {.lex_state = 84, .external_lex_state = 2},
  [1599] = {.lex_state = 17, .external_lex_state = 2},
  [1600] = {.lex_state = 17, .external_lex_state = 2},
  [1601] = {.lex_state = 17, .external_lex_state = 2},
  [1602] = {.lex_state = 84, .external_lex_state = 2},
  [1603] = {.lex_state = 84, .external_lex_state = 2},
  [1604] = {.lex_state = 84, .external_lex_state = 2},
  [1605] = {.lex_state = 17, .external_lex_state = 2},
  [1606] = {.lex_state = 17, .external_lex_state = 2},
  [1607] = {.lex_state = 17, .external_lex_state = 2},
  [1608] = {.lex_state = 17, .external_lex_state = 2},
  [1609] = {.lex_state = 17, .external_lex_state = 2},
  [1610] = {.lex_state = 17, .external_lex_state = 2},
  [1611] = {.lex_state = 17, .external_lex_state = 2},
  [1612] = {.lex_state = 17, .external_lex_state = 2},
  [1613] = {.lex_state = 17, .external_lex_state = 2},
  [1614] = {.lex_state = 17, .external_lex_state = 2},
  [1615] = {.lex_state = 17, .external_lex_state = 2},
  [1616] = {.lex_state = 17, .external_lex_state = 2},
  [1617] = {.lex_state = 17, .external_lex_state = 2},
  [1618] = {.lex_state = 17, .external_lex_state = 2},
  [1619] = {.lex_state = 17, .external_lex_state = 2},
  [1620] = {.lex_state = 17, .external_lex_state = 2},
  [1621] = {.lex_state = 17, .external_lex_state = 2},
  [1622] = {.lex_state = 17, .external_lex_state = 2},
  [1623] = {.lex_state = 84, .external_lex_state = 2},
  [1624] = {.lex_state = 84, .external_lex_state = 2},
  [1625] = {.lex_state = 84, .external_lex_state = 2},
  [1626] = {.lex_state = 84, .external_lex_state = 2},
  [1627] = {.lex_state = 84, .external_lex_state = 2},
  [1628] = {.lex_state = 84, .external_lex_state = 2},
  [1629] = {.lex_state = 84, .external_lex_state = 2},
  [1630] = {.lex_state = 84, .external_lex_state = 2},
  [1631] = {.lex_state = 84, .external_lex_state = 2},
  [1632] = {.lex_state = 84, .external_lex_state = 2},
  [1633] = {.lex_state = 1, .external_lex_state = 2},
  [1634] = {.lex_state = 84, .external_lex_state = 2},
  [1635] = {.lex_state = 84, .external_lex_state = 2},
  [1636] = {.lex_state = 84, .external_lex_state = 2},
  [1637] = {.lex_state = 84, .external_lex_state = 2},
  [1638] = {.lex_state = 84, .external_lex_state = 2},
  [1639] = {.lex_state = 84, .external_lex_state = 2},
  [1640] = {.lex_state = 1, .external_lex_state = 2},
  [1641] = {.lex_state = 84, .external_lex_state = 2},
  [1642] = {.lex_state = 17, .external_lex_state = 2},
  [1643] = {.lex_state = 17, .external_lex_state = 2},
  [1644] = {.lex_state = 17, .external_lex_state = 2},
  [1645] = {.lex_state = 17, .external_lex_state = 2},
  [1646] = {.lex_state = 17, .external_lex_state = 2},
  [1647] = {.lex_state = 17, .external_lex_state = 2},
  [1648] = {.lex_state = 84, .external_lex_state = 2},
  [1649] = {.lex_state = 17, .external_lex_state = 2},
  [1650] = {.lex_state = 17, .external_lex_state = 2},
  [1651] = {.lex_state = 84, .external_lex_state = 2},
  [1652] = {.lex_state = 17, .external_lex_state = 2},
  [1653] = {.lex_state = 1, .external_lex_state = 2},
  [1654] = {.lex_state = 1, .external_lex_state = 2},
  [1655] = {.lex_state = 16, .external_lex_state = 2},
  [1656] = {.lex_state = 17, .external_lex_state = 2},
  [1657] = {.lex_state = 17, .external_lex_state = 2},
  [1658] = {.lex_state = 17, .external_lex_state = 2},
  [1659] = {.lex_state = 17, .external_lex_state = 2},
  [1660] = {.lex_state = 84, .external_lex_state = 2},
  [1661] = {.lex_state = 17, .external_lex_state = 2},
  [1662] = {.lex_state = 1, .external_lex_state = 2},
  [1663] = {.lex_state = 84, .external_lex_state = 2},
  [1664] = {.lex_state = 84, .external_lex_state = 2},
  [1665] = {.lex_state = 84, .external_lex_state = 2},
  [1666] = {.lex_state = 84, .external_lex_state = 2},
  [1667] = {.lex_state = 84, .external_lex_state = 2},
  [1668] = {.lex_state = 84, .external_lex_state = 2},
  [1669] = {.lex_state = 84, .external_lex_state = 2},
  [1670] = {.lex_state = 84, .external_lex_state = 2},
  [1671] = {.lex_state = 17, .external_lex_state = 2},
  [1672] = {.lex_state = 84, .external_lex_state = 2},
  [1673] = {.lex_state = 84, .external_lex_state = 2},
  [1674] = {.lex_state = 84, .external_lex_state = 2},
  [1675] = {.lex_state = 84, .external_lex_state = 2},
  [1676] = {.lex_state = 84, .external_lex_state = 2},
  [1677] = {.lex_state = 84, .external_lex_state = 2},
  [1678] = {.lex_state = 84, .external_lex_state = 2},
  [1679] = {.lex_state = 84, .external_lex_state = 2},
  [1680] = {.lex_state = 17, .external_lex_state = 2},
  [1681] = {.lex_state = 84, .external_lex_state = 2},
  [1682] = {.lex_state = 84, .external_lex_state = 2},
  [1683] = {.lex_state = 17, .external_lex_state = 2},
  [1684] = {.lex_state = 1, .external_lex_state = 2},
  [1685] = {.lex_state = 17, .external_lex_state = 2},
  [1686] = {.lex_state = 84, .external_lex_state = 2},
  [1687] = {.lex_state = 84, .external_lex_state = 2},
  [1688] = {.lex_state = 84, .external_lex_state = 2},
  [1689] = {.lex_state = 1, .external_lex_state = 2},
  [1690] = {.lex_state = 84, .external_lex_state = 2},
  [1691] = {.lex_state = 84, .external_lex_state = 2},
  [1692] = {.lex_state = 84, .external_lex_state = 2},
  [1693] = {.lex_state = 1, .external_lex_state = 2},
  [1694] = {.lex_state = 1, .external_lex_state = 2},
  [1695] = {.lex_state = 1, .external_lex_state = 2},
  [1696] = {.lex_state = 17, .external_lex_state = 2},
  [1697] = {.lex_state = 84, .external_lex_state = 2},
  [1698] = {.lex_state = 84, .external_lex_state = 2},
  [1699] = {.lex_state = 84, .external_lex_state = 2},
  [1700] = {.lex_state = 84, .external_lex_state = 2},
  [1701] = {.lex_state = 84, .external_lex_state = 2},
  [1702] = {.lex_state = 84, .external_lex_state = 2},
  [1703] = {.lex_state = 84, .external_lex_state = 2},
  [1704] = {.lex_state = 84, .external_lex_state = 2},
  [1705] = {.lex_state = 1, .external_lex_state = 2},
  [1706] = {.lex_state = 1, .external_lex_state = 2},
  [1707] = {.lex_state = 1, .external_lex_state = 2},
  [1708] = {.lex_state = 84, .external_lex_state = 2},
  [1709] = {.lex_state = 1, .external_lex_state = 2},
  [1710] = {.lex_state = 17, .external_lex_state = 2},
  [1711] = {.lex_state = 1, .external_lex_state = 2},
  [1712] = {.lex_state = 1, .external_lex_state = 2},
  [1713] = {.lex_state = 84, .external_lex_state = 2},
  [1714] = {.lex_state = 17, .external_lex_state = 2},
  [1715] = {.lex_state = 17, .external_lex_state = 2},
  [1716] = {.lex_state = 17, .external_lex_state = 2},
  [1717] = {.lex_state = 17, .external_lex_state = 2},
  [1718] = {.lex_state = 17, .external_lex_state = 2},
  [1719] = {.lex_state = 17, .external_lex_state = 2},
  [1720] = {.lex_state = 17, .external_lex_state = 2},
  [1721] = {.lex_state = 17, .external_lex_state = 2},
  [1722] = {.lex_state = 1, .external_lex_state = 2},
  [1723] = {.lex_state = 17, .external_lex_state = 2},
  [1724] = {.lex_state = 84, .external_lex_state = 2},
  [1725] = {.lex_state = 17, .external_lex_state = 2},
  [1726] = {.lex_state = 17, .external_lex_state = 2},
  [1727] = {.lex_state = 17, .external_lex_state = 2},
  [1728] = {.lex_state = 17, .external_lex_state = 2},
  [1729] = {.lex_state = 17, .external_lex_state = 2},
  [1730] = {.lex_state = 17, .external_lex_state = 2},
  [1731] = {.lex_state = 17, .external_lex_state = 2},
  [1732] = {.lex_state = 17, .external_lex_state = 2},
  [1733] = {.lex_state = 17, .external_lex_state = 2},
  [1734] = {.lex_state = 1, .external_lex_state = 2},
  [1735] = {.lex_state = 1, .external_lex_state = 2},
  [1736] = {.lex_state = 17, .external_lex_state = 2},
  [1737] = {.lex_state = 17, .external_lex_state = 2},
  [1738] = {.lex_state = 17, .external_lex_state = 2},
  [1739] = {.lex_state = 17, .external_lex_state = 2},
  [1740] = {.lex_state = 17, .external_lex_state = 2},
  [1741] = {.lex_state = 17, .external_lex_state = 2},
  [1742] = {.lex_state = 17, .external_lex_state = 2},
  [1743] = {.lex_state = 17, .external_lex_state = 2},
  [1744] = {.lex_state = 17, .external_lex_state = 2},
  [1745] = {.lex_state = 17, .external_lex_state = 2},
  [1746] = {.lex_state = 17, .external_lex_state = 2},
  [1747] = {.lex_state = 17, .external_lex_state = 2},
  [1748] = {.lex_state = 17, .external_lex_state = 2},
  [1749] = {.lex_state = 17, .external_lex_state = 2},
  [1750] = {.lex_state = 17, .external_lex_state = 2},
  [1751] = {.lex_state = 17, .external_lex_state = 2},
  [1752] = {.lex_state = 1, .external_lex_state = 2},
  [1753] = {.lex_state = 84, .external_lex_state = 2},
  [1754] = {.lex_state = 84, .external_lex_state = 2},
  [1755] = {.lex_state = 17, .external_lex_state = 2},
  [1756] = {.lex_state = 84, .external_lex_state = 2},
  [1757] = {.lex_state = 1, .external_lex_state = 2},
  [1758] = {.lex_state = 84, .external_lex_state = 2},
  [1759] = {.lex_state = 84, .external_lex_state = 2},
  [1760] = {.lex_state = 1, .external_lex_state = 2},
  [1761] = {.lex_state = 1, .external_lex_state = 2},
  [1762] = {.lex_state = 1, .external_lex_state = 2},
  [1763] = {.lex_state = 17, .external_lex_state = 2},
  [1764] = {.lex_state = 84, .external_lex_state = 2},
  [1765] = {.lex_state = 1, .external_lex_state = 2},
  [1766] = {.lex_state = 17, .external_lex_state = 2},
  [1767] = {.lex_state = 84, .external_lex_state = 2},
  [1768] = {.lex_state = 17, .external_lex_state = 2},
  [1769] = {.lex_state = 1, .external_lex_state = 2},
  [1770] = {.lex_state = 84, .external_lex_state = 2},
  [1771] = {.lex_state = 1, .external_lex_state = 2},
  [1772] = {.lex_state = 17, .external_lex_state = 2},
  [1773] = {.lex_state = 17, .external_lex_state = 2},
  [1774] = {.lex_state = 17, .external_lex_state = 2},
  [1775] = {.lex_state = 17, .external_lex_state = 2},
  [1776] = {.lex_state = 17, .external_lex_state = 2},
  [1777] = {.lex_state = 17, .external_lex_state = 2},
  [1778] = {.lex_state = 17, .external_lex_state = 2},
  [1779] = {.lex_state = 17, .external_lex_state = 2},
  [1780] = {.lex_state = 17, .external_lex_state = 2},
  [1781] = {.lex_state = 17, .external_lex_state = 2},
  [1782] = {.lex_state = 1, .external_lex_state = 2},
  [1783] = {.lex_state = 1, .external_lex_state = 2},
  [1784] = {.lex_state = 1, .external_lex_state = 2},
  [1785] = {.lex_state = 17, .external_lex_state = 2},
  [1786] = {.lex_state = 17, .external_lex_state = 2},
  [1787] = {.lex_state = 17, .external_lex_state = 2},
  [1788] = {.lex_state = 84, .external_lex_state = 2},
  [1789] = {.lex_state = 1, .external_lex_state = 2},
  [1790] = {.lex_state = 17, .external_lex_state = 2},
  [1791] = {.lex_state = 17, .external_lex_state = 2},
  [1792] = {.lex_state = 84, .external_lex_state = 2},
  [1793] = {.lex_state = 1, .external_lex_state = 2},
  [1794] = {.lex_state = 1, .external_lex_state = 2},
  [1795] = {.lex_state = 1, .external_lex_state = 2},
  [1796] = {.lex_state = 1, .external_lex_state = 2},
  [1797] = {.lex_state = 1, .external_lex_state = 2},
  [1798] = {.lex_state = 17, .external_lex_state = 2},
  [1799] = {.lex_state = 1, .external_lex_state = 2},
  [1800] = {.lex_state = 1, .external_lex_state = 2},
  [1801] = {.lex_state = 1, .external_lex_state = 2},
  [1802] = {.lex_state = 1, .external_lex_state = 2},
  [1803] = {.lex_state = 1, .external_lex_state = 2},
  [1804] = {.lex_state = 1, .external_lex_state = 2},
  [1805] = {.lex_state = 1, .external_lex_state = 2},
  [1806] = {.lex_state = 1, .external_lex_state = 2},
  [1807] = {.lex_state = 1, .external_lex_state = 2},
  [1808] = {.lex_state = 17, .external_lex_state = 2},
  [1809] = {.lex_state = 1, .external_lex_state = 2},
  [1810] = {.lex_state = 17, .external_lex_state = 2},
  [1811] = {.lex_state = 84, .external_lex_state = 2},
  [1812] = {.lex_state = 1, .external_lex_state = 2},
  [1813] = {.lex_state = 84, .external_lex_state = 2},
  [1814] = {.lex_state = 17, .external_lex_state = 2},
  [1815] = {.lex_state = 84, .external_lex_state = 2},
  [1816] = {.lex_state = 84, .external_lex_state = 2},
  [1817] = {.lex_state = 17, .external_lex_state = 2},
  [1818] = {.lex_state = 1, .external_lex_state = 2},
  [1819] = {.lex_state = 17, .external_lex_state = 2},
  [1820] = {.lex_state = 17, .external_lex_state = 2},
  [1821] = {.lex_state = 17, .external_lex_state = 2},
  [1822] = {.lex_state = 17, .external_lex_state = 2},
  [1823] = {.lex_state = 17, .external_lex_state = 2},
  [1824] = {.lex_state = 17, .external_lex_state = 2},
  [1825] = {.lex_state = 17, .external_lex_state = 2},
  [1826] = {.lex_state = 1, .external_lex_state = 2},
  [1827] = {.lex_state = 1, .external_lex_state = 2},
  [1828] = {.lex_state = 84, .external_lex_state = 2},
  [1829] = {.lex_state = 17, .external_lex_state = 2},
  [1830] = {.lex_state = 1, .external_lex_state = 2},
  [1831] = {.lex_state = 84, .external_lex_state = 2},
  [1832] = {.lex_state = 17, .external_lex_state = 2},
  [1833] = {.lex_state = 17, .external_lex_state = 2},
  [1834] = {.lex_state = 1, .external_lex_state = 2},
  [1835] = {.lex_state = 17, .external_lex_state = 2},
  [1836] = {.lex_state = 84, .external_lex_state = 2},
  [1837] = {.lex_state = 1, .external_lex_state = 2},
  [1838] = {.lex_state = 17, .external_lex_state = 2},
  [1839] = {.lex_state = 17, .external_lex_state = 2},
  [1840] = {.lex_state = 1, .external_lex_state = 2},
  [1841] = {.lex_state = 17, .external_lex_state = 2},
  [1842] = {.lex_state = 17, .external_lex_state = 2},
  [1843] = {.lex_state = 1, .external_lex_state = 2},
  [1844] = {.lex_state = 84, .external_lex_state = 2},
  [1845] = {.lex_state = 17, .external_lex_state = 2},
  [1846] = {.lex_state = 84, .external_lex_state = 2},
  [1847] = {.lex_state = 17, .external_lex_state = 2},
  [1848] = {.lex_state = 17, .external_lex_state = 2},
  [1849] = {.lex_state = 1, .external_lex_state = 2},
  [1850] = {.lex_state = 1, .external_lex_state = 2},
  [1851] = {.lex_state = 1, .external_lex_state = 2},
  [1852] = {.lex_state = 1, .external_lex_state = 2},
  [1853] = {.lex_state = 1, .external_lex_state = 2},
  [1854] = {.lex_state = 1, .external_lex_state = 2},
  [1855] = {.lex_state = 17, .external_lex_state = 2},
  [1856] = {.lex_state = 1, .external_lex_state = 2},
  [1857] = {.lex_state = 17, .external_lex_state = 2},
  [1858] = {.lex_state = 17, .external_lex_state = 2},
  [1859] = {.lex_state = 1, .external_lex_state = 2},
  [1860] = {.lex_state = 84, .external_lex_state = 2},
  [1861] = {.lex_state = 1, .external_lex_state = 2},
  [1862] = {.lex_state = 1, .external_lex_state = 2},
  [1863] = {.lex_state = 1, .external_lex_state = 2},
  [1864] = {.lex_state = 84, .external_lex_state = 2},
  [1865] = {.lex_state = 1, .external_lex_state = 2},
  [1866] = {.lex_state = 1, .external_lex_state = 2},
  [1867] = {.lex_state = 17, .external_lex_state = 2},
  [1868] = {.lex_state = 1, .external_lex_state = 2},
  [1869] = {.lex_state = 1, .external_lex_state = 2},
  [1870] = {.lex_state = 1, .external_lex_state = 2},
  [1871] = {.lex_state = 1, .external_lex_state = 2},
  [1872] = {.lex_state = 1, .external_lex_state = 2},
  [1873] = {.lex_state = 1, .external_lex_state = 2},
  [1874] = {.lex_state = 1, .external_lex_state = 2},
  [1875] = {.lex_state = 1, .external_lex_state = 2},
  [1876] = {.lex_state = 1, .external_lex_state = 2},
  [1877] = {.lex_state = 1, .external_lex_state = 2},
  [1878] = {.lex_state = 1, .external_lex_state = 2},
  [1879] = {.lex_state = 1, .external_lex_state = 2},
  [1880] = {.lex_state = 1, .external_lex_state = 2},
  [1881] = {.lex_state = 1, .external_lex_state = 2},
  [1882] = {.lex_state = 1, .external_lex_state = 2},
  [1883] = {.lex_state = 1, .external_lex_state = 2},
  [1884] = {.lex_state = 1, .external_lex_state = 2},
  [1885] = {.lex_state = 1, .external_lex_state = 2},
  [1886] = {.lex_state = 1, .external_lex_state = 2},
  [1887] = {.lex_state = 1, .external_lex_state = 2},
  [1888] = {.lex_state = 1, .external_lex_state = 2},
  [1889] = {.lex_state = 1, .external_lex_state = 2},
  [1890] = {.lex_state = 1, .external_lex_state = 2},
  [1891] = {.lex_state = 1, .external_lex_state = 2},
  [1892] = {.lex_state = 1, .external_lex_state = 2},
  [1893] = {.lex_state = 1, .external_lex_state = 2},
  [1894] = {.lex_state = 1, .external_lex_state = 2},
  [1895] = {.lex_state = 1, .external_lex_state = 2},
  [1896] = {.lex_state = 1, .external_lex_state = 2},
  [1897] = {.lex_state = 1, .external_lex_state = 2},
  [1898] = {.lex_state = 1, .external_lex_state = 2},
  [1899] = {.lex_state = 1, .external_lex_state = 2},
  [1900] = {.lex_state = 1, .external_lex_state = 2},
  [1901] = {.lex_state = 1, .external_lex_state = 2},
  [1902] = {.lex_state = 1, .external_lex_state = 2},
  [1903] = {.lex_state = 1, .external_lex_state = 2},
  [1904] = {.lex_state = 1, .external_lex_state = 2},
  [1905] = {.lex_state = 1, .external_lex_state = 2},
  [1906] = {.lex_state = 1, .external_lex_state = 2},
  [1907] = {.lex_state = 1, .external_lex_state = 2},
  [1908] = {.lex_state = 1, .external_lex_state = 2},
  [1909] = {.lex_state = 1, .external_lex_state = 2},
  [1910] = {.lex_state = 1, .external_lex_state = 2},
  [1911] = {.lex_state = 17, .external_lex_state = 2},
  [1912] = {.lex_state = 17, .external_lex_state = 2},
  [1913] = {.lex_state = 17, .external_lex_state = 2},
  [1914] = {.lex_state = 17, .external_lex_state = 2},
  [1915] = {.lex_state = 17, .external_lex_state = 2},
  [1916] = {.lex_state = 17, .external_lex_state = 2},
  [1917] = {.lex_state = 17, .external_lex_state = 2},
  [1918] = {.lex_state = 17, .external_lex_state = 2},
  [1919] = {.lex_state = 17, .external_lex_state = 2},
  [1920] = {.lex_state = 17, .external_lex_state = 2},
  [1921] = {.lex_state = 17, .external_lex_state = 2},
  [1922] = {.lex_state = 17, .external_lex_state = 2},
  [1923] = {.lex_state = 17, .external_lex_state = 2},
  [1924] = {.lex_state = 17, .external_lex_state = 2},
  [1925] = {.lex_state = 17, .external_lex_state = 2},
  [1926] = {.lex_state = 17, .external_lex_state = 2},
  [1927] = {.lex_state = 17, .external_lex_state = 2},
  [1928] = {.lex_state = 17, .external_lex_state = 2},
  [1929] = {.lex_state = 8, .external_lex_state = 2},
  [1930] = {.lex_state = 8, .external_lex_state = 2},
  [1931] = {.lex_state = 8, .external_lex_state = 2},
  [1932] = {.lex_state = 8, .external_lex_state = 2},
  [1933] = {.lex_state = 8, .external_lex_state = 2},
  [1934] = {.lex_state = 24, .external_lex_state = 2},
  [1935] = {.lex_state = 24, .external_lex_state = 2},
  [1936] = {.lex_state = 93, .external_lex_state = 2},
  [1937] = {.lex_state = 93, .external_lex_state = 2},
  [1938] = {.lex_state = 93, .external_lex_state = 2},
  [1939] = {.lex_state = 93, .external_lex_state = 2},
  [1940] = {.lex_state = 85, .external_lex_state = 5},
  [1941] = {.lex_state = 89, .external_lex_state = 5},
  [1942] = {.lex_state = 32, .external_lex_state = 5},
  [1943] = {.lex_state = 85, .external_lex_state = 6},
  [1944] = {.lex_state = 30, .external_lex_state = 5},
  [1945] = {.lex_state = 85, .external_lex_state = 6},
  [1946] = {.lex_state = 85, .external_lex_state = 6},
  [1947] = {.lex_state = 89, .external_lex_state = 5},
  [1948] = {.lex_state = 89, .external_lex_state = 6},
  [1949] = {.lex_state = 85, .external_lex_state = 6},
  [1950] = {.lex_state = 85, .external_lex_state = 6},
  [1951] = {.lex_state = 85, .external_lex_state = 6},
  [1952] = {.lex_state = 85, .external_lex_state = 6},
  [1953] = {.lex_state = 85, .external_lex_state = 6},
  [1954] = {.lex_state = 85, .external_lex_state = 6},
  [1955] = {.lex_state = 85, .external_lex_state = 6},
  [1956] = {.lex_state = 85, .external_lex_state = 6},
  [1957] = {.lex_state = 85, .external_lex_state = 6},
  [1958] = {.lex_state = 85, .external_lex_state = 6},
  [1959] = {.lex_state = 85, .external_lex_state = 6},
  [1960] = {.lex_state = 85, .external_lex_state = 6},
  [1961] = {.lex_state = 85, .external_lex_state = 6},
  [1962] = {.lex_state = 85, .external_lex_state = 6},
  [1963] = {.lex_state = 85, .external_lex_state = 6},
  [1964] = {.lex_state = 85, .external_lex_state = 6},
  [1965] = {.lex_state = 85, .external_lex_state = 6},
  [1966] = {.lex_state = 85, .external_lex_state = 6},
  [1967] = {.lex_state = 85, .external_lex_state = 6},
  [1968] = {.lex_state = 85, .external_lex_state = 6},
  [1969] = {.lex_state = 85, .external_lex_state = 6},
  [1970] = {.lex_state = 85, .external_lex_state = 6},
  [1971] = {.lex_state = 38, .external_lex_state = 5},
  [1972] = {.lex_state = 85, .external_lex_state = 6},
  [1973] = {.lex_state = 85, .external_lex_state = 6},
  [1974] = {.lex_state = 25, .external_lex_state = 2},
  [1975] = {.lex_state = 85, .external_lex_state = 6},
  [1976] = {.lex_state = 85, .external_lex_state = 6},
  [1977] = {.lex_state = 85, .external_lex_state = 6},
  [1978] = {.lex_state = 85, .external_lex_state = 6},
  [1979] = {.lex_state = 85, .external_lex_state = 6},
  [1980] = {.lex_state = 85, .external_lex_state = 6},
  [1981] = {.lex_state = 85, .external_lex_state = 6},
  [1982] = {.lex_state = 85, .external_lex_state = 6},
  [1983] = {.lex_state = 85, .external_lex_state = 6},
  [1984] = {.lex_state = 85, .external_lex_state = 6},
  [1985] = {.lex_state = 25, .external_lex_state = 2},
  [1986] = {.lex_state = 25, .external_lex_state = 2},
  [1987] = {.lex_state = 85, .external_lex_state = 6},
  [1988] = {.lex_state = 85, .external_lex_state = 6},
  [1989] = {.lex_state = 85, .external_lex_state = 6},
  [1990] = {.lex_state = 85, .external_lex_state = 6},
  [1991] = {.lex_state = 85, .external_lex_state = 6},
  [1992] = {.lex_state = 85, .external_lex_state = 6},
  [1993] = {.lex_state = 85, .external_lex_state = 6},
  [1994] = {.lex_state = 85, .external_lex_state = 6},
  [1995] = {.lex_state = 85, .external_lex_state = 6},
  [1996] = {.lex_state = 30, .external_lex_state = 6},
  [1997] = {.lex_state = 85, .external_lex_state = 6},
  [1998] = {.lex_state = 85, .external_lex_state = 6},
  [1999] = {.lex_state = 25, .external_lex_state = 2},
  [2000] = {.lex_state = 85, .external_lex_state = 6},
  [2001] = {.lex_state = 85, .external_lex_state = 7},
  [2002] = {.lex_state = 30, .external_lex_state = 6},
  [2003] = {.lex_state = 85, .external_lex_state = 7},
  [2004] = {.lex_state = 85, .external_lex_state = 6},
  [2005] = {.lex_state = 25, .external_lex_state = 2},
  [2006] = {.lex_state = 30, .external_lex_state = 6},
  [2007] = {.lex_state = 36, .external_lex_state = 5},
  [2008] = {.lex_state = 25, .external_lex_state = 2},
  [2009] = {.lex_state = 85, .external_lex_state = 6},
  [2010] = {.lex_state = 25, .external_lex_state = 2},
  [2011] = {.lex_state = 25, .external_lex_state = 2},
  [2012] = {.lex_state = 25, .external_lex_state = 2},
  [2013] = {.lex_state = 87, .external_lex_state = 7},
  [2014] = {.lex_state = 30, .external_lex_state = 7},
  [2015] = {.lex_state = 87, .external_lex_state = 7},
  [2016] = {.lex_state = 30, .external_lex_state = 7},
  [2017] = {.lex_state = 30, .external_lex_state = 6},
  [2018] = {.lex_state = 30, .external_lex_state = 6},
  [2019] = {.lex_state = 30, .external_lex_state = 6},
  [2020] = {.lex_state = 30, .external_lex_state = 6},
  [2021] = {.lex_state = 30, .external_lex_state = 6},
  [2022] = {.lex_state = 30, .external_lex_state = 6},
  [2023] = {.lex_state = 30, .external_lex_state = 6},
  [2024] = {.lex_state = 30, .external_lex_state = 6},
  [2025] = {.lex_state = 30, .external_lex_state = 6},
  [2026] = {.lex_state = 30, .external_lex_state = 6},
  [2027] = {.lex_state = 30, .external_lex_state = 6},
  [2028] = {.lex_state = 32, .external_lex_state = 6},
  [2029] = {.lex_state = 30, .external_lex_state = 6},
  [2030] = {.lex_state = 30, .external_lex_state = 6},
  [2031] = {.lex_state = 30, .external_lex_state = 6},
  [2032] = {.lex_state = 30, .external_lex_state = 6},
  [2033] = {.lex_state = 30, .external_lex_state = 6},
  [2034] = {.lex_state = 30, .external_lex_state = 6},
  [2035] = {.lex_state = 30, .external_lex_state = 6},
  [2036] = {.lex_state = 30, .external_lex_state = 6},
  [2037] = {.lex_state = 30, .external_lex_state = 6},
  [2038] = {.lex_state = 30, .external_lex_state = 6},
  [2039] = {.lex_state = 30, .external_lex_state = 6},
  [2040] = {.lex_state = 30, .external_lex_state = 6},
  [2041] = {.lex_state = 87, .external_lex_state = 7},
  [2042] = {.lex_state = 30, .external_lex_state = 6},
  [2043] = {.lex_state = 87, .external_lex_state = 7},
  [2044] = {.lex_state = 85, .external_lex_state = 6},
  [2045] = {.lex_state = 85, .external_lex_state = 7},
  [2046] = {.lex_state = 30, .external_lex_state = 6},
  [2047] = {.lex_state = 85, .external_lex_state = 7},
  [2048] = {.lex_state = 85, .external_lex_state = 7},
  [2049] = {.lex_state = 30, .external_lex_state = 6},
  [2050] = {.lex_state = 30, .external_lex_state = 6},
  [2051] = {.lex_state = 30, .external_lex_state = 6},
  [2052] = {.lex_state = 85, .external_lex_state = 7},
  [2053] = {.lex_state = 30, .external_lex_state = 6},
  [2054] = {.lex_state = 85, .external_lex_state = 7},
  [2055] = {.lex_state = 30, .external_lex_state = 6},
  [2056] = {.lex_state = 30, .external_lex_state = 6},
  [2057] = {.lex_state = 85, .external_lex_state = 6},
  [2058] = {.lex_state = 30, .external_lex_state = 6},
  [2059] = {.lex_state = 85, .external_lex_state = 7},
  [2060] = {.lex_state = 30, .external_lex_state = 6},
  [2061] = {.lex_state = 85, .external_lex_state = 7},
  [2062] = {.lex_state = 30, .external_lex_state = 6},
  [2063] = {.lex_state = 30, .external_lex_state = 6},
  [2064] = {.lex_state = 85, .external_lex_state = 7},
  [2065] = {.lex_state = 85, .external_lex_state = 7},
  [2066] = {.lex_state = 30, .external_lex_state = 6},
  [2067] = {.lex_state = 85, .external_lex_state = 7},
  [2068] = {.lex_state = 85, .external_lex_state = 7},
  [2069] = {.lex_state = 30, .external_lex_state = 6},
  [2070] = {.lex_state = 85, .external_lex_state = 7},
  [2071] = {.lex_state = 36, .external_lex_state = 6},
  [2072] = {.lex_state = 85, .external_lex_state = 7},
  [2073] = {.lex_state = 89, .external_lex_state = 5},
  [2074] = {.lex_state = 36, .external_lex_state = 6},
  [2075] = {.lex_state = 89, .external_lex_state = 5},
  [2076] = {.lex_state = 30, .external_lex_state = 6},
  [2077] = {.lex_state = 85, .external_lex_state = 7},
  [2078] = {.lex_state = 30, .external_lex_state = 6},
  [2079] = {.lex_state = 30, .external_lex_state = 6},
  [2080] = {.lex_state = 30, .external_lex_state = 6},
  [2081] = {.lex_state = 85, .external_lex_state = 7},
  [2082] = {.lex_state = 85, .external_lex_state = 7},
  [2083] = {.lex_state = 34, .external_lex_state = 7},
  [2084] = {.lex_state = 30, .external_lex_state = 6},
  [2085] = {.lex_state = 30, .external_lex_state = 6},
  [2086] = {.lex_state = 30, .external_lex_state = 6},
  [2087] = {.lex_state = 85, .external_lex_state = 7},
  [2088] = {.lex_state = 85, .external_lex_state = 7},
  [2089] = {.lex_state = 36, .external_lex_state = 6},
  [2090] = {.lex_state = 30, .external_lex_state = 6},
  [2091] = {.lex_state = 30, .external_lex_state = 6},
  [2092] = {.lex_state = 30, .external_lex_state = 6},
  [2093] = {.lex_state = 85, .external_lex_state = 7},
  [2094] = {.lex_state = 85, .external_lex_state = 7},
  [2095] = {.lex_state = 38, .external_lex_state = 5},
  [2096] = {.lex_state = 30, .external_lex_state = 6},
  [2097] = {.lex_state = 85, .external_lex_state = 7},
  [2098] = {.lex_state = 85, .external_lex_state = 7},
  [2099] = {.lex_state = 85, .external_lex_state = 7},
  [2100] = {.lex_state = 85, .external_lex_state = 7},
  [2101] = {.lex_state = 85, .external_lex_state = 7},
  [2102] = {.lex_state = 85, .external_lex_state = 7},
  [2103] = {.lex_state = 85, .external_lex_state = 7},
  [2104] = {.lex_state = 85, .external_lex_state = 7},
  [2105] = {.lex_state = 85, .external_lex_state = 7},
  [2106] = {.lex_state = 85, .external_lex_state = 7},
  [2107] = {.lex_state = 85, .external_lex_state = 7},
  [2108] = {.lex_state = 85, .external_lex_state = 7},
  [2109] = {.lex_state = 85, .external_lex_state = 7},
  [2110] = {.lex_state = 85, .external_lex_state = 7},
  [2111] = {.lex_state = 85, .external_lex_state = 7},
  [2112] = {.lex_state = 85, .external_lex_state = 7},
  [2113] = {.lex_state = 85, .external_lex_state = 7},
  [2114] = {.lex_state = 85, .external_lex_state = 7},
  [2115] = {.lex_state = 85, .external_lex_state = 7},
  [2116] = {.lex_state = 85, .external_lex_state = 7},
  [2117] = {.lex_state = 85, .external_lex_state = 7},
  [2118] = {.lex_state = 85, .external_lex_state = 7},
  [2119] = {.lex_state = 85, .external_lex_state = 7},
  [2120] = {.lex_state = 85, .external_lex_state = 7},
  [2121] = {.lex_state = 85, .external_lex_state = 7},
  [2122] = {.lex_state = 85, .external_lex_state = 7},
  [2123] = {.lex_state = 85, .external_lex_state = 7},
  [2124] = {.lex_state = 85, .external_lex_state = 7},
  [2125] = {.lex_state = 34, .external_lex_state = 7},
  [2126] = {.lex_state = 85, .external_lex_state = 7},
  [2127] = {.lex_state = 85, .external_lex_state = 7},
  [2128] = {.lex_state = 34, .external_lex_state = 7},
  [2129] = {.lex_state = 85, .external_lex_state = 7},
  [2130] = {.lex_state = 85, .external_lex_state = 7},
  [2131] = {.lex_state = 85, .external_lex_state = 7},
  [2132] = {.lex_state = 85, .external_lex_state = 7},
  [2133] = {.lex_state = 85, .external_lex_state = 7},
  [2134] = {.lex_state = 85, .external_lex_state = 7},
  [2135] = {.lex_state = 85, .external_lex_state = 7},
  [2136] = {.lex_state = 85, .external_lex_state = 7},
  [2137] = {.lex_state = 85, .external_lex_state = 7},
  [2138] = {.lex_state = 85, .external_lex_state = 7},
  [2139] = {.lex_state = 85, .external_lex_state = 7},
  [2140] = {.lex_state = 85, .external_lex_state = 7},
  [2141] = {.lex_state = 85, .external_lex_state = 7},
  [2142] = {.lex_state = 85, .external_lex_state = 7},
  [2143] = {.lex_state = 85, .external_lex_state = 7},
  [2144] = {.lex_state = 85, .external_lex_state = 7},
  [2145] = {.lex_state = 34, .external_lex_state = 7},
  [2146] = {.lex_state = 85, .external_lex_state = 7},
  [2147] = {.lex_state = 85, .external_lex_state = 7},
  [2148] = {.lex_state = 85, .external_lex_state = 7},
  [2149] = {.lex_state = 85, .external_lex_state = 7},
  [2150] = {.lex_state = 85, .external_lex_state = 7},
  [2151] = {.lex_state = 85, .external_lex_state = 7},
  [2152] = {.lex_state = 85, .external_lex_state = 7},
  [2153] = {.lex_state = 85, .external_lex_state = 7},
  [2154] = {.lex_state = 36, .external_lex_state = 6},
  [2155] = {.lex_state = 85, .external_lex_state = 7},
  [2156] = {.lex_state = 85, .external_lex_state = 7},
  [2157] = {.lex_state = 85, .external_lex_state = 7},
  [2158] = {.lex_state = 85, .external_lex_state = 7},
  [2159] = {.lex_state = 85, .external_lex_state = 7},
  [2160] = {.lex_state = 85, .external_lex_state = 7},
  [2161] = {.lex_state = 85, .external_lex_state = 7},
  [2162] = {.lex_state = 38, .external_lex_state = 6},
  [2163] = {.lex_state = 85, .external_lex_state = 7},
  [2164] = {.lex_state = 85, .external_lex_state = 7},
  [2165] = {.lex_state = 85, .external_lex_state = 7},
  [2166] = {.lex_state = 36, .external_lex_state = 6},
  [2167] = {.lex_state = 85, .external_lex_state = 7},
  [2168] = {.lex_state = 85, .external_lex_state = 7},
  [2169] = {.lex_state = 85, .external_lex_state = 7},
  [2170] = {.lex_state = 85, .external_lex_state = 7},
  [2171] = {.lex_state = 85, .external_lex_state = 7},
  [2172] = {.lex_state = 85, .external_lex_state = 7},
  [2173] = {.lex_state = 85, .external_lex_state = 7},
  [2174] = {.lex_state = 85, .external_lex_state = 7},
  [2175] = {.lex_state = 85, .external_lex_state = 7},
  [2176] = {.lex_state = 85, .external_lex_state = 7},
  [2177] = {.lex_state = 85, .external_lex_state = 7},
  [2178] = {.lex_state = 85, .external_lex_state = 7},
  [2179] = {.lex_state = 85, .external_lex_state = 7},
  [2180] = {.lex_state = 85, .external_lex_state = 7},
  [2181] = {.lex_state = 85, .external_lex_state = 7},
  [2182] = {.lex_state = 38, .external_lex_state = 5},
  [2183] = {.lex_state = 85, .external_lex_state = 7},
  [2184] = {.lex_state = 85, .external_lex_state = 7},
  [2185] = {.lex_state = 85, .external_lex_state = 7},
  [2186] = {.lex_state = 85, .external_lex_state = 7},
  [2187] = {.lex_state = 85, .external_lex_state = 7},
  [2188] = {.lex_state = 85, .external_lex_state = 7},
  [2189] = {.lex_state = 85, .external_lex_state = 7},
  [2190] = {.lex_state = 85, .external_lex_state = 7},
  [2191] = {.lex_state = 85, .external_lex_state = 7},
  [2192] = {.lex_state = 85, .external_lex_state = 7},
  [2193] = {.lex_state = 85, .external_lex_state = 7},
  [2194] = {.lex_state = 85, .external_lex_state = 7},
  [2195] = {.lex_state = 85, .external_lex_state = 7},
  [2196] = {.lex_state = 36, .external_lex_state = 7},
  [2197] = {.lex_state = 85, .external_lex_state = 7},
  [2198] = {.lex_state = 85, .external_lex_state = 7},
  [2199] = {.lex_state = 85, .external_lex_state = 7},
  [2200] = {.lex_state = 85, .external_lex_state = 7},
  [2201] = {.lex_state = 85, .external_lex_state = 7},
  [2202] = {.lex_state = 85, .external_lex_state = 7},
  [2203] = {.lex_state = 85, .external_lex_state = 7},
  [2204] = {.lex_state = 85, .external_lex_state = 7},
  [2205] = {.lex_state = 85, .external_lex_state = 7},
  [2206] = {.lex_state = 85, .external_lex_state = 7},
  [2207] = {.lex_state = 85, .external_lex_state = 7},
  [2208] = {.lex_state = 36, .external_lex_state = 7},
  [2209] = {.lex_state = 85, .external_lex_state = 7},
  [2210] = {.lex_state = 85, .external_lex_state = 7},
  [2211] = {.lex_state = 85, .external_lex_state = 7},
  [2212] = {.lex_state = 36, .external_lex_state = 6},
  [2213] = {.lex_state = 36, .external_lex_state = 6},
  [2214] = {.lex_state = 36, .external_lex_state = 6},
  [2215] = {.lex_state = 36, .external_lex_state = 6},
  [2216] = {.lex_state = 36, .external_lex_state = 6},
  [2217] = {.lex_state = 36, .external_lex_state = 6},
  [2218] = {.lex_state = 36, .external_lex_state = 6},
  [2219] = {.lex_state = 85, .external_lex_state = 7},
  [2220] = {.lex_state = 36, .external_lex_state = 6},
  [2221] = {.lex_state = 85, .external_lex_state = 7},
  [2222] = {.lex_state = 36, .external_lex_state = 6},
  [2223] = {.lex_state = 36, .external_lex_state = 6},
  [2224] = {.lex_state = 36, .external_lex_state = 6},
  [2225] = {.lex_state = 36, .external_lex_state = 6},
  [2226] = {.lex_state = 36, .external_lex_state = 6},
  [2227] = {.lex_state = 36, .external_lex_state = 6},
  [2228] = {.lex_state = 36, .external_lex_state = 6},
  [2229] = {.lex_state = 36, .external_lex_state = 6},
  [2230] = {.lex_state = 36, .external_lex_state = 6},
  [2231] = {.lex_state = 36, .external_lex_state = 6},
  [2232] = {.lex_state = 36, .external_lex_state = 6},
  [2233] = {.lex_state = 36, .external_lex_state = 6},
  [2234] = {.lex_state = 36, .external_lex_state = 6},
  [2235] = {.lex_state = 36, .external_lex_state = 6},
  [2236] = {.lex_state = 36, .external_lex_state = 6},
  [2237] = {.lex_state = 36, .external_lex_state = 6},
  [2238] = {.lex_state = 36, .external_lex_state = 6},
  [2239] = {.lex_state = 36, .external_lex_state = 6},
  [2240] = {.lex_state = 36, .external_lex_state = 6},
  [2241] = {.lex_state = 36, .external_lex_state = 6},
  [2242] = {.lex_state = 36, .external_lex_state = 6},
  [2243] = {.lex_state = 36, .external_lex_state = 6},
  [2244] = {.lex_state = 30, .external_lex_state = 7},
  [2245] = {.lex_state = 36, .external_lex_state = 6},
  [2246] = {.lex_state = 85, .external_lex_state = 7},
  [2247] = {.lex_state = 36, .external_lex_state = 6},
  [2248] = {.lex_state = 36, .external_lex_state = 6},
  [2249] = {.lex_state = 36, .external_lex_state = 6},
  [2250] = {.lex_state = 36, .external_lex_state = 6},
  [2251] = {.lex_state = 36, .external_lex_state = 6},
  [2252] = {.lex_state = 36, .external_lex_state = 6},
  [2253] = {.lex_state = 36, .external_lex_state = 6},
  [2254] = {.lex_state = 36, .external_lex_state = 6},
  [2255] = {.lex_state = 36, .external_lex_state = 6},
  [2256] = {.lex_state = 36, .external_lex_state = 6},
  [2257] = {.lex_state = 36, .external_lex_state = 6},
  [2258] = {.lex_state = 85, .external_lex_state = 7},
  [2259] = {.lex_state = 85, .external_lex_state = 7},
  [2260] = {.lex_state = 36, .external_lex_state = 6},
  [2261] = {.lex_state = 85, .external_lex_state = 7},
  [2262] = {.lex_state = 41, .external_lex_state = 7},
  [2263] = {.lex_state = 36, .external_lex_state = 6},
  [2264] = {.lex_state = 85, .external_lex_state = 7},
  [2265] = {.lex_state = 85, .external_lex_state = 7},
  [2266] = {.lex_state = 30, .external_lex_state = 6},
  [2267] = {.lex_state = 30, .external_lex_state = 7},
  [2268] = {.lex_state = 30, .external_lex_state = 7},
  [2269] = {.lex_state = 85, .external_lex_state = 7},
  [2270] = {.lex_state = 85, .external_lex_state = 7},
  [2271] = {.lex_state = 30, .external_lex_state = 6},
  [2272] = {.lex_state = 85, .external_lex_state = 7},
  [2273] = {.lex_state = 30, .external_lex_state = 7},
  [2274] = {.lex_state = 30, .external_lex_state = 7},
  [2275] = {.lex_state = 30, .external_lex_state = 7},
  [2276] = {.lex_state = 85, .external_lex_state = 7},
  [2277] = {.lex_state = 30, .external_lex_state = 7},
  [2278] = {.lex_state = 85, .external_lex_state = 7},
  [2279] = {.lex_state = 85, .external_lex_state = 7},
  [2280] = {.lex_state = 30, .external_lex_state = 7},
  [2281] = {.lex_state = 85, .external_lex_state = 7},
  [2282] = {.lex_state = 30, .external_lex_state = 7},
  [2283] = {.lex_state = 85, .external_lex_state = 7},
  [2284] = {.lex_state = 85, .external_lex_state = 7},
  [2285] = {.lex_state = 85, .external_lex_state = 7},
  [2286] = {.lex_state = 30, .external_lex_state = 7},
  [2287] = {.lex_state = 30, .external_lex_state = 7},
  [2288] = {.lex_state = 85, .external_lex_state = 7},
  [2289] = {.lex_state = 30, .external_lex_state = 7},
  [2290] = {.lex_state = 30, .external_lex_state = 7},
  [2291] = {.lex_state = 85, .external_lex_state = 7},
  [2292] = {.lex_state = 30, .external_lex_state = 7},
  [2293] = {.lex_state = 85, .external_lex_state = 7},
  [2294] = {.lex_state = 30, .external_lex_state = 7},
  [2295] = {.lex_state = 85, .external_lex_state = 7},
  [2296] = {.lex_state = 30, .external_lex_state = 7},
  [2297] = {.lex_state = 85, .external_lex_state = 7},
  [2298] = {.lex_state = 85, .external_lex_state = 7},
  [2299] = {.lex_state = 85, .external_lex_state = 7},
  [2300] = {.lex_state = 85, .external_lex_state = 7},
  [2301] = {.lex_state = 85, .external_lex_state = 7},
  [2302] = {.lex_state = 30, .external_lex_state = 7},
  [2303] = {.lex_state = 30, .external_lex_state = 7},
  [2304] = {.lex_state = 36, .external_lex_state = 6},
  [2305] = {.lex_state = 85, .external_lex_state = 7},
  [2306] = {.lex_state = 30, .external_lex_state = 7},
  [2307] = {.lex_state = 30, .external_lex_state = 7},
  [2308] = {.lex_state = 85, .external_lex_state = 7},
  [2309] = {.lex_state = 30, .external_lex_state = 7},
  [2310] = {.lex_state = 36, .external_lex_state = 6},
  [2311] = {.lex_state = 30, .external_lex_state = 7},
  [2312] = {.lex_state = 85, .external_lex_state = 7},
  [2313] = {.lex_state = 85, .external_lex_state = 7},
  [2314] = {.lex_state = 30, .external_lex_state = 7},
  [2315] = {.lex_state = 30, .external_lex_state = 7},
  [2316] = {.lex_state = 30, .external_lex_state = 7},
  [2317] = {.lex_state = 30, .external_lex_state = 7},
  [2318] = {.lex_state = 30, .external_lex_state = 7},
  [2319] = {.lex_state = 30, .external_lex_state = 7},
  [2320] = {.lex_state = 85, .external_lex_state = 7},
  [2321] = {.lex_state = 30, .external_lex_state = 7},
  [2322] = {.lex_state = 30, .external_lex_state = 7},
  [2323] = {.lex_state = 30, .external_lex_state = 7},
  [2324] = {.lex_state = 30, .external_lex_state = 7},
  [2325] = {.lex_state = 30, .external_lex_state = 7},
  [2326] = {.lex_state = 30, .external_lex_state = 7},
  [2327] = {.lex_state = 30, .external_lex_state = 7},
  [2328] = {.lex_state = 30, .external_lex_state = 7},
  [2329] = {.lex_state = 30, .external_lex_state = 7},
  [2330] = {.lex_state = 30, .external_lex_state = 7},
  [2331] = {.lex_state = 30, .external_lex_state = 7},
  [2332] = {.lex_state = 30, .external_lex_state = 7},
  [2333] = {.lex_state = 30, .external_lex_state = 7},
  [2334] = {.lex_state = 30, .external_lex_state = 7},
  [2335] = {.lex_state = 41, .external_lex_state = 7},
  [2336] = {.lex_state = 30, .external_lex_state = 7},
  [2337] = {.lex_state = 30, .external_lex_state = 7},
  [2338] = {.lex_state = 30, .external_lex_state = 7},
  [2339] = {.lex_state = 30, .external_lex_state = 7},
  [2340] = {.lex_state = 30, .external_lex_state = 7},
  [2341] = {.lex_state = 30, .external_lex_state = 7},
  [2342] = {.lex_state = 30, .external_lex_state = 7},
  [2343] = {.lex_state = 30, .external_lex_state = 7},
  [2344] = {.lex_state = 30, .external_lex_state = 7},
  [2345] = {.lex_state = 30, .external_lex_state = 7},
  [2346] = {.lex_state = 30, .external_lex_state = 7},
  [2347] = {.lex_state = 30, .external_lex_state = 7},
  [2348] = {.lex_state = 30, .external_lex_state = 7},
  [2349] = {.lex_state = 30, .external_lex_state = 7},
  [2350] = {.lex_state = 30, .external_lex_state = 7},
  [2351] = {.lex_state = 30, .external_lex_state = 7},
  [2352] = {.lex_state = 30, .external_lex_state = 7},
  [2353] = {.lex_state = 30, .external_lex_state = 7},
  [2354] = {.lex_state = 30, .external_lex_state = 7},
  [2355] = {.lex_state = 30, .external_lex_state = 7},
  [2356] = {.lex_state = 30, .external_lex_state = 7},
  [2357] = {.lex_state = 30, .external_lex_state = 7},
  [2358] = {.lex_state = 30, .external_lex_state = 7},
  [2359] = {.lex_state = 30, .external_lex_state = 7},
  [2360] = {.lex_state = 30, .external_lex_state = 7},
  [2361] = {.lex_state = 30, .external_lex_state = 7},
  [2362] = {.lex_state = 30, .external_lex_state = 7},
  [2363] = {.lex_state = 30, .external_lex_state = 7},
  [2364] = {.lex_state = 30, .external_lex_state = 7},
  [2365] = {.lex_state = 30, .external_lex_state = 7},
  [2366] = {.lex_state = 30, .external_lex_state = 7},
  [2367] = {.lex_state = 30, .external_lex_state = 7},
  [2368] = {.lex_state = 30, .external_lex_state = 7},
  [2369] = {.lex_state = 30, .external_lex_state = 7},
  [2370] = {.lex_state = 30, .external_lex_state = 7},
  [2371] = {.lex_state = 30, .external_lex_state = 7},
  [2372] = {.lex_state = 30, .external_lex_state = 7},
  [2373] = {.lex_state = 30, .external_lex_state = 7},
  [2374] = {.lex_state = 30, .external_lex_state = 7},
  [2375] = {.lex_state = 30, .external_lex_state = 7},
  [2376] = {.lex_state = 30, .external_lex_state = 7},
  [2377] = {.lex_state = 30, .external_lex_state = 7},
  [2378] = {.lex_state = 30, .external_lex_state = 7},
  [2379] = {.lex_state = 30, .external_lex_state = 7},
  [2380] = {.lex_state = 30, .external_lex_state = 7},
  [2381] = {.lex_state = 30, .external_lex_state = 7},
  [2382] = {.lex_state = 30, .external_lex_state = 7},
  [2383] = {.lex_state = 30, .external_lex_state = 7},
  [2384] = {.lex_state = 30, .external_lex_state = 7},
  [2385] = {.lex_state = 30, .external_lex_state = 7},
  [2386] = {.lex_state = 30, .external_lex_state = 7},
  [2387] = {.lex_state = 30, .external_lex_state = 7},
  [2388] = {.lex_state = 30, .external_lex_state = 7},
  [2389] = {.lex_state = 30, .external_lex_state = 7},
  [2390] = {.lex_state = 30, .external_lex_state = 7},
  [2391] = {.lex_state = 30, .external_lex_state = 7},
  [2392] = {.lex_state = 30, .external_lex_state = 7},
  [2393] = {.lex_state = 30, .external_lex_state = 7},
  [2394] = {.lex_state = 30, .external_lex_state = 7},
  [2395] = {.lex_state = 30, .external_lex_state = 7},
  [2396] = {.lex_state = 30, .external_lex_state = 7},
  [2397] = {.lex_state = 30, .external_lex_state = 7},
  [2398] = {.lex_state = 30, .external_lex_state = 7},
  [2399] = {.lex_state = 30, .external_lex_state = 7},
  [2400] = {.lex_state = 30, .external_lex_state = 7},
  [2401] = {.lex_state = 30, .external_lex_state = 7},
  [2402] = {.lex_state = 30, .external_lex_state = 7},
  [2403] = {.lex_state = 30, .external_lex_state = 7},
  [2404] = {.lex_state = 30, .external_lex_state = 7},
  [2405] = {.lex_state = 30, .external_lex_state = 7},
  [2406] = {.lex_state = 30, .external_lex_state = 7},
  [2407] = {.lex_state = 30, .external_lex_state = 7},
  [2408] = {.lex_state = 30, .external_lex_state = 7},
  [2409] = {.lex_state = 30, .external_lex_state = 7},
  [2410] = {.lex_state = 30, .external_lex_state = 7},
  [2411] = {.lex_state = 30, .external_lex_state = 7},
  [2412] = {.lex_state = 30, .external_lex_state = 7},
  [2413] = {.lex_state = 30, .external_lex_state = 7},
  [2414] = {.lex_state = 41, .external_lex_state = 7},
  [2415] = {.lex_state = 30, .external_lex_state = 7},
  [2416] = {.lex_state = 30, .external_lex_state = 7},
  [2417] = {.lex_state = 30, .external_lex_state = 7},
  [2418] = {.lex_state = 30, .external_lex_state = 7},
  [2419] = {.lex_state = 30, .external_lex_state = 7},
  [2420] = {.lex_state = 30, .external_lex_state = 7},
  [2421] = {.lex_state = 30, .external_lex_state = 7},
  [2422] = {.lex_state = 30, .external_lex_state = 7},
  [2423] = {.lex_state = 30, .external_lex_state = 7},
  [2424] = {.lex_state = 30, .external_lex_state = 7},
  [2425] = {.lex_state = 30, .external_lex_state = 7},
  [2426] = {.lex_state = 41, .external_lex_state = 7},
  [2427] = {.lex_state = 30, .external_lex_state = 7},
  [2428] = {.lex_state = 30, .external_lex_state = 7},
  [2429] = {.lex_state = 30, .external_lex_state = 7},
  [2430] = {.lex_state = 30, .external_lex_state = 7},
  [2431] = {.lex_state = 30, .external_lex_state = 7},
  [2432] = {.lex_state = 30, .external_lex_state = 7},
  [2433] = {.lex_state = 30, .external_lex_state = 7},
  [2434] = {.lex_state = 30, .external_lex_state = 7},
  [2435] = {.lex_state = 30, .external_lex_state = 7},
  [2436] = {.lex_state = 30, .external_lex_state = 7},
  [2437] = {.lex_state = 30, .external_lex_state = 7},
  [2438] = {.lex_state = 30, .external_lex_state = 7},
  [2439] = {.lex_state = 30, .external_lex_state = 7},
  [2440] = {.lex_state = 30, .external_lex_state = 7},
  [2441] = {.lex_state = 30, .external_lex_state = 7},
  [2442] = {.lex_state = 30, .external_lex_state = 7},
  [2443] = {.lex_state = 30, .external_lex_state = 7},
  [2444] = {.lex_state = 30, .external_lex_state = 7},
  [2445] = {.lex_state = 30, .external_lex_state = 7},
  [2446] = {.lex_state = 36, .external_lex_state = 7},
  [2447] = {.lex_state = 36, .external_lex_state = 7},
  [2448] = {.lex_state = 36, .external_lex_state = 7},
  [2449] = {.lex_state = 36, .external_lex_state = 7},
  [2450] = {.lex_state = 36, .external_lex_state = 7},
  [2451] = {.lex_state = 36, .external_lex_state = 6},
  [2452] = {.lex_state = 36, .external_lex_state = 7},
  [2453] = {.lex_state = 36, .external_lex_state = 7},
  [2454] = {.lex_state = 30, .external_lex_state = 7},
  [2455] = {.lex_state = 30, .external_lex_state = 7},
  [2456] = {.lex_state = 36, .external_lex_state = 7},
  [2457] = {.lex_state = 85, .external_lex_state = 7},
  [2458] = {.lex_state = 36, .external_lex_state = 7},
  [2459] = {.lex_state = 36, .external_lex_state = 7},
  [2460] = {.lex_state = 36, .external_lex_state = 7},
  [2461] = {.lex_state = 36, .external_lex_state = 7},
  [2462] = {.lex_state = 36, .external_lex_state = 7},
  [2463] = {.lex_state = 36, .external_lex_state = 7},
  [2464] = {.lex_state = 36, .external_lex_state = 7},
  [2465] = {.lex_state = 36, .external_lex_state = 7},
  [2466] = {.lex_state = 36, .external_lex_state = 7},
  [2467] = {.lex_state = 36, .external_lex_state = 7},
  [2468] = {.lex_state = 85, .external_lex_state = 7},
  [2469] = {.lex_state = 36, .external_lex_state = 6},
  [2470] = {.lex_state = 36, .external_lex_state = 7},
  [2471] = {.lex_state = 36, .external_lex_state = 7},
  [2472] = {.lex_state = 36, .external_lex_state = 7},
  [2473] = {.lex_state = 36, .external_lex_state = 7},
  [2474] = {.lex_state = 36, .external_lex_state = 7},
  [2475] = {.lex_state = 36, .external_lex_state = 7},
  [2476] = {.lex_state = 36, .external_lex_state = 7},
  [2477] = {.lex_state = 36, .external_lex_state = 7},
  [2478] = {.lex_state = 36, .external_lex_state = 7},
  [2479] = {.lex_state = 36, .external_lex_state = 7},
  [2480] = {.lex_state = 36, .external_lex_state = 7},
  [2481] = {.lex_state = 36, .external_lex_state = 7},
  [2482] = {.lex_state = 36, .external_lex_state = 7},
  [2483] = {.lex_state = 36, .external_lex_state = 7},
  [2484] = {.lex_state = 36, .external_lex_state = 7},
  [2485] = {.lex_state = 36, .external_lex_state = 7},
  [2486] = {.lex_state = 36, .external_lex_state = 7},
  [2487] = {.lex_state = 36, .external_lex_state = 7},
  [2488] = {.lex_state = 36, .external_lex_state = 7},
  [2489] = {.lex_state = 36, .external_lex_state = 7},
  [2490] = {.lex_state = 36, .external_lex_state = 7},
  [2491] = {.lex_state = 36, .external_lex_state = 7},
  [2492] = {.lex_state = 36, .external_lex_state = 7},
  [2493] = {.lex_state = 36, .external_lex_state = 7},
  [2494] = {.lex_state = 36, .external_lex_state = 7},
  [2495] = {.lex_state = 36, .external_lex_state = 7},
  [2496] = {.lex_state = 85, .external_lex_state = 7},
  [2497] = {.lex_state = 36, .external_lex_state = 7},
  [2498] = {.lex_state = 36, .external_lex_state = 7},
  [2499] = {.lex_state = 36, .external_lex_state = 7},
  [2500] = {.lex_state = 36, .external_lex_state = 7},
  [2501] = {.lex_state = 36, .external_lex_state = 7},
  [2502] = {.lex_state = 36, .external_lex_state = 7},
  [2503] = {.lex_state = 36, .external_lex_state = 7},
  [2504] = {.lex_state = 36, .external_lex_state = 7},
  [2505] = {.lex_state = 36, .external_lex_state = 7},
  [2506] = {.lex_state = 36, .external_lex_state = 7},
  [2507] = {.lex_state = 36, .external_lex_state = 7},
  [2508] = {.lex_state = 36, .external_lex_state = 7},
  [2509] = {.lex_state = 36, .external_lex_state = 7},
  [2510] = {.lex_state = 36, .external_lex_state = 7},
  [2511] = {.lex_state = 36, .external_lex_state = 7},
  [2512] = {.lex_state = 36, .external_lex_state = 7},
  [2513] = {.lex_state = 36, .external_lex_state = 7},
  [2514] = {.lex_state = 36, .external_lex_state = 7},
  [2515] = {.lex_state = 36, .external_lex_state = 7},
  [2516] = {.lex_state = 36, .external_lex_state = 7},
  [2517] = {.lex_state = 36, .external_lex_state = 7},
  [2518] = {.lex_state = 36, .external_lex_state = 7},
  [2519] = {.lex_state = 36, .external_lex_state = 7},
  [2520] = {.lex_state = 36, .external_lex_state = 7},
  [2521] = {.lex_state = 36, .external_lex_state = 7},
  [2522] = {.lex_state = 36, .external_lex_state = 7},
  [2523] = {.lex_state = 36, .external_lex_state = 7},
  [2524] = {.lex_state = 36, .external_lex_state = 7},
  [2525] = {.lex_state = 36, .external_lex_state = 7},
  [2526] = {.lex_state = 36, .external_lex_state = 7},
  [2527] = {.lex_state = 36, .external_lex_state = 7},
  [2528] = {.lex_state = 36, .external_lex_state = 7},
  [2529] = {.lex_state = 36, .external_lex_state = 7},
  [2530] = {.lex_state = 36, .external_lex_state = 7},
  [2531] = {.lex_state = 36, .external_lex_state = 7},
  [2532] = {.lex_state = 36, .external_lex_state = 7},
  [2533] = {.lex_state = 36, .external_lex_state = 7},
  [2534] = {.lex_state = 36, .external_lex_state = 7},
  [2535] = {.lex_state = 36, .external_lex_state = 7},
  [2536] = {.lex_state = 36, .external_lex_state = 7},
  [2537] = {.lex_state = 36, .external_lex_state = 7},
  [2538] = {.lex_state = 36, .external_lex_state = 7},
  [2539] = {.lex_state = 36, .external_lex_state = 7},
  [2540] = {.lex_state = 36, .external_lex_state = 7},
  [2541] = {.lex_state = 36, .external_lex_state = 7},
  [2542] = {.lex_state = 36, .external_lex_state = 7},
  [2543] = {.lex_state = 36, .external_lex_state = 7},
  [2544] = {.lex_state = 36, .external_lex_state = 7},
  [2545] = {.lex_state = 36, .external_lex_state = 7},
  [2546] = {.lex_state = 36, .external_lex_state = 7},
  [2547] = {.lex_state = 36, .external_lex_state = 7},
  [2548] = {.lex_state = 36, .external_lex_state = 7},
  [2549] = {.lex_state = 36, .external_lex_state = 7},
  [2550] = {.lex_state = 36, .external_lex_state = 7},
  [2551] = {.lex_state = 36, .external_lex_state = 7},
  [2552] = {.lex_state = 36, .external_lex_state = 7},
  [2553] = {.lex_state = 36, .external_lex_state = 7},
  [2554] = {.lex_state = 36, .external_lex_state = 7},
  [2555] = {.lex_state = 36, .external_lex_state = 7},
  [2556] = {.lex_state = 36, .external_lex_state = 7},
  [2557] = {.lex_state = 36, .external_lex_state = 7},
  [2558] = {.lex_state = 36, .external_lex_state = 7},
  [2559] = {.lex_state = 36, .external_lex_state = 7},
  [2560] = {.lex_state = 36, .external_lex_state = 7},
  [2561] = {.lex_state = 36, .external_lex_state = 7},
  [2562] = {.lex_state = 36, .external_lex_state = 7},
  [2563] = {.lex_state = 36, .external_lex_state = 7},
  [2564] = {.lex_state = 36, .external_lex_state = 7},
  [2565] = {.lex_state = 36, .external_lex_state = 7},
  [2566] = {.lex_state = 36, .external_lex_state = 7},
  [2567] = {.lex_state = 36, .external_lex_state = 7},
  [2568] = {.lex_state = 36, .external_lex_state = 7},
  [2569] = {.lex_state = 36, .external_lex_state = 7},
  [2570] = {.lex_state = 36, .external_lex_state = 7},
  [2571] = {.lex_state = 36, .external_lex_state = 7},
  [2572] = {.lex_state = 36, .external_lex_state = 7},
  [2573] = {.lex_state = 36, .external_lex_state = 7},
  [2574] = {.lex_state = 36, .external_lex_state = 7},
  [2575] = {.lex_state = 36, .external_lex_state = 7},
  [2576] = {.lex_state = 36, .external_lex_state = 7},
  [2577] = {.lex_state = 36, .external_lex_state = 7},
  [2578] = {.lex_state = 36, .external_lex_state = 7},
  [2579] = {.lex_state = 36, .external_lex_state = 7},
  [2580] = {.lex_state = 36, .external_lex_state = 7},
  [2581] = {.lex_state = 36, .external_lex_state = 7},
  [2582] = {.lex_state = 36, .external_lex_state = 7},
  [2583] = {.lex_state = 36, .external_lex_state = 7},
  [2584] = {.lex_state = 36, .external_lex_state = 7},
  [2585] = {.lex_state = 36, .external_lex_state = 7},
  [2586] = {.lex_state = 36, .external_lex_state = 7},
  [2587] = {.lex_state = 36, .external_lex_state = 7},
  [2588] = {.lex_state = 36, .external_lex_state = 7},
  [2589] = {.lex_state = 36, .external_lex_state = 7},
  [2590] = {.lex_state = 36, .external_lex_state = 7},
  [2591] = {.lex_state = 36, .external_lex_state = 7},
  [2592] = {.lex_state = 36, .external_lex_state = 7},
  [2593] = {.lex_state = 36, .external_lex_state = 7},
  [2594] = {.lex_state = 36, .external_lex_state = 7},
  [2595] = {.lex_state = 36, .external_lex_state = 7},
  [2596] = {.lex_state = 36, .external_lex_state = 7},
  [2597] = {.lex_state = 30, .external_lex_state = 7},
  [2598] = {.lex_state = 85, .external_lex_state = 7},
  [2599] = {.lex_state = 36, .external_lex_state = 7},
  [2600] = {.lex_state = 36, .external_lex_state = 7},
  [2601] = {.lex_state = 85, .external_lex_state = 7},
  [2602] = {.lex_state = 85, .external_lex_state = 7},
  [2603] = {.lex_state = 85, .external_lex_state = 7},
  [2604] = {.lex_state = 85, .external_lex_state = 7},
  [2605] = {.lex_state = 36, .external_lex_state = 7},
  [2606] = {.lex_state = 36, .external_lex_state = 7},
  [2607] = {.lex_state = 36, .external_lex_state = 7},
  [2608] = {.lex_state = 36, .external_lex_state = 7},
  [2609] = {.lex_state = 85, .external_lex_state = 7},
  [2610] = {.lex_state = 85, .external_lex_state = 7},
  [2611] = {.lex_state = 85, .external_lex_state = 7},
  [2612] = {.lex_state = 85, .external_lex_state = 7},
  [2613] = {.lex_state = 85, .external_lex_state = 7},
  [2614] = {.lex_state = 36, .external_lex_state = 7},
  [2615] = {.lex_state = 36, .external_lex_state = 7},
  [2616] = {.lex_state = 36, .external_lex_state = 7},
  [2617] = {.lex_state = 85, .external_lex_state = 7},
  [2618] = {.lex_state = 85, .external_lex_state = 7},
  [2619] = {.lex_state = 85, .external_lex_state = 7},
  [2620] = {.lex_state = 85, .external_lex_state = 7},
  [2621] = {.lex_state = 85, .external_lex_state = 7},
  [2622] = {.lex_state = 85, .external_lex_state = 7},
  [2623] = {.lex_state = 85, .external_lex_state = 7},
  [2624] = {.lex_state = 85, .external_lex_state = 7},
  [2625] = {.lex_state = 85, .external_lex_state = 7},
  [2626] = {.lex_state = 36, .external_lex_state = 7},
  [2627] = {.lex_state = 85, .external_lex_state = 7},
  [2628] = {.lex_state = 85, .external_lex_state = 7},
  [2629] = {.lex_state = 85, .external_lex_state = 7},
  [2630] = {.lex_state = 36, .external_lex_state = 7},
  [2631] = {.lex_state = 85, .external_lex_state = 7},
  [2632] = {.lex_state = 36, .external_lex_state = 7},
  [2633] = {.lex_state = 85, .external_lex_state = 7},
  [2634] = {.lex_state = 36, .external_lex_state = 7},
  [2635] = {.lex_state = 85, .external_lex_state = 7},
  [2636] = {.lex_state = 36, .external_lex_state = 7},
  [2637] = {.lex_state = 36, .external_lex_state = 7},
  [2638] = {.lex_state = 85, .external_lex_state = 7},
  [2639] = {.lex_state = 36, .external_lex_state = 7},
  [2640] = {.lex_state = 85, .external_lex_state = 7},
  [2641] = {.lex_state = 85, .external_lex_state = 7},
  [2642] = {.lex_state = 36, .external_lex_state = 7},
  [2643] = {.lex_state = 85, .external_lex_state = 7},
  [2644] = {.lex_state = 85, .external_lex_state = 7},
  [2645] = {.lex_state = 85, .external_lex_state = 7},
  [2646] = {.lex_state = 85, .external_lex_state = 7},
  [2647] = {.lex_state = 85, .external_lex_state = 7},
  [2648] = {.lex_state = 36, .external_lex_state = 7},
  [2649] = {.lex_state = 85, .external_lex_state = 7},
  [2650] = {.lex_state = 36, .external_lex_state = 7},
  [2651] = {.lex_state = 36, .external_lex_state = 7},
  [2652] = {.lex_state = 85, .external_lex_state = 7},
  [2653] = {.lex_state = 85, .external_lex_state = 7},
  [2654] = {.lex_state = 85, .external_lex_state = 7},
  [2655] = {.lex_state = 85, .external_lex_state = 7},
  [2656] = {.lex_state = 85, .external_lex_state = 7},
  [2657] = {.lex_state = 85, .external_lex_state = 7},
  [2658] = {.lex_state = 85, .external_lex_state = 7},
  [2659] = {.lex_state = 85, .external_lex_state = 7},
  [2660] = {.lex_state = 85, .external_lex_state = 7},
  [2661] = {.lex_state = 85, .external_lex_state = 7},
  [2662] = {.lex_state = 85, .external_lex_state = 7},
  [2663] = {.lex_state = 36, .external_lex_state = 7},
  [2664] = {.lex_state = 85, .external_lex_state = 7},
  [2665] = {.lex_state = 85, .external_lex_state = 7},
  [2666] = {.lex_state = 36, .external_lex_state = 7},
  [2667] = {.lex_state = 85, .external_lex_state = 7},
  [2668] = {.lex_state = 36, .external_lex_state = 7},
  [2669] = {.lex_state = 36, .external_lex_state = 7},
  [2670] = {.lex_state = 36, .external_lex_state = 7},
  [2671] = {.lex_state = 85, .external_lex_state = 7},
  [2672] = {.lex_state = 30, .external_lex_state = 7},
  [2673] = {.lex_state = 30, .external_lex_state = 7},
  [2674] = {.lex_state = 36, .external_lex_state = 7},
  [2675] = {.lex_state = 30, .external_lex_state = 7},
  [2676] = {.lex_state = 30, .external_lex_state = 7},
  [2677] = {.lex_state = 30, .external_lex_state = 7},
  [2678] = {.lex_state = 30, .external_lex_state = 7},
  [2679] = {.lex_state = 30, .external_lex_state = 7},
  [2680] = {.lex_state = 30, .external_lex_state = 7},
  [2681] = {.lex_state = 30, .external_lex_state = 7},
  [2682] = {.lex_state = 36, .external_lex_state = 7},
  [2683] = {.lex_state = 36, .external_lex_state = 7},
  [2684] = {.lex_state = 36, .external_lex_state = 7},
  [2685] = {.lex_state = 36, .external_lex_state = 7},
  [2686] = {.lex_state = 36, .external_lex_state = 7},
  [2687] = {.lex_state = 36, .external_lex_state = 7},
  [2688] = {.lex_state = 36, .external_lex_state = 7},
  [2689] = {.lex_state = 36, .external_lex_state = 7},
  [2690] = {.lex_state = 36, .external_lex_state = 7},
  [2691] = {.lex_state = 36, .external_lex_state = 7},
  [2692] = {.lex_state = 36, .external_lex_state = 7},
  [2693] = {.lex_state = 36, .external_lex_state = 7},
  [2694] = {.lex_state = 36, .external_lex_state = 7},
  [2695] = {.lex_state = 36, .external_lex_state = 7},
  [2696] = {.lex_state = 36, .external_lex_state = 7},
  [2697] = {.lex_state = 36, .external_lex_state = 7},
  [2698] = {.lex_state = 36, .external_lex_state = 7},
  [2699] = {.lex_state = 36, .external_lex_state = 7},
  [2700] = {.lex_state = 36, .external_lex_state = 7},
  [2701] = {.lex_state = 36, .external_lex_state = 7},
  [2702] = {.lex_state = 36, .external_lex_state = 7},
  [2703] = {.lex_state = 36, .external_lex_state = 7},
  [2704] = {.lex_state = 36, .external_lex_state = 7},
  [2705] = {.lex_state = 36, .external_lex_state = 7},
  [2706] = {.lex_state = 36, .external_lex_state = 7},
  [2707] = {.lex_state = 36, .external_lex_state = 7},
  [2708] = {.lex_state = 36, .external_lex_state = 7},
  [2709] = {.lex_state = 36, .external_lex_state = 7},
  [2710] = {.lex_state = 36, .external_lex_state = 7},
  [2711] = {.lex_state = 36, .external_lex_state = 7},
  [2712] = {.lex_state = 36, .external_lex_state = 7},
  [2713] = {.lex_state = 36, .external_lex_state = 7},
  [2714] = {.lex_state = 36, .external_lex_state = 7},
  [2715] = {.lex_state = 36, .external_lex_state = 7},
  [2716] = {.lex_state = 36, .external_lex_state = 7},
  [2717] = {.lex_state = 36, .external_lex_state = 7},
  [2718] = {.lex_state = 36, .external_lex_state = 7},
  [2719] = {.lex_state = 36, .external_lex_state = 7},
  [2720] = {.lex_state = 36, .external_lex_state = 7},
  [2721] = {.lex_state = 36, .external_lex_state = 7},
  [2722] = {.lex_state = 36, .external_lex_state = 7},
  [2723] = {.lex_state = 36, .external_lex_state = 7},
  [2724] = {.lex_state = 36, .external_lex_state = 7},
  [2725] = {.lex_state = 36, .external_lex_state = 7},
  [2726] = {.lex_state = 36, .external_lex_state = 7},
  [2727] = {.lex_state = 36, .external_lex_state = 7},
  [2728] = {.lex_state = 36, .external_lex_state = 7},
  [2729] = {.lex_state = 36, .external_lex_state = 7},
  [2730] = {.lex_state = 36, .external_lex_state = 7},
  [2731] = {.lex_state = 36, .external_lex_state = 7},
  [2732] = {.lex_state = 36, .external_lex_state = 7},
  [2733] = {.lex_state = 91, .external_lex_state = 7},
  [2734] = {.lex_state = 91, .external_lex_state = 7},
  [2735] = {.lex_state = 42, .external_lex_state = 5},
  [2736] = {.lex_state = 26, .external_lex_state = 7},
  [2737] = {.lex_state = 26, .external_lex_state = 7},
  [2738] = {.lex_state = 26, .external_lex_state = 7},
  [2739] = {.lex_state = 26, .external_lex_state = 7},
  [2740] = {.lex_state = 26, .external_lex_state = 7},
  [2741] = {.lex_state = 26, .external_lex_state = 7},
  [2742] = {.lex_state = 26, .external_lex_state = 7},
  [2743] = {.lex_state = 26, .external_lex_state = 7},
  [2744] = {.lex_state = 26, .external_lex_state = 7},
  [2745] = {.lex_state = 26, .external_lex_state = 7},
  [2746] = {.lex_state = 26, .external_lex_state = 7},
  [2747] = {.lex_state = 26, .external_lex_state = 7},
  [2748] = {.lex_state = 91, .external_lex_state = 7},
  [2749] = {.lex_state = 26, .external_lex_state = 7},
  [2750] = {.lex_state = 25, .external_lex_state = 7},
  [2751] = {.lex_state = 25, .external_lex_state = 7},
  [2752] = {.lex_state = 25, .external_lex_state = 7},
  [2753] = {.lex_state = 25, .external_lex_state = 7},
  [2754] = {.lex_state = 91, .external_lex_state = 7},
  [2755] = {.lex_state = 25, .external_lex_state = 7},
  [2756] = {.lex_state = 25, .external_lex_state = 7},
  [2757] = {.lex_state = 91, .external_lex_state = 7},
  [2758] = {.lex_state = 25, .external_lex_state = 7},
  [2759] = {.lex_state = 25, .external_lex_state = 7},
  [2760] = {.lex_state = 78, .external_lex_state = 7},
  [2761] = {.lex_state = 78, .external_lex_state = 7},
  [2762] = {.lex_state = 78, .external_lex_state = 7},
  [2763] = {.lex_state = 78, .external_lex_state = 7},
  [2764] = {.lex_state = 44, .external_lex_state = 7},
  [2765] = {.lex_state = 42, .external_lex_state = 6},
  [2766] = {.lex_state = 91, .external_lex_state = 7},
  [2767] = {.lex_state = 91, .external_lex_state = 7},
  [2768] = {.lex_state = 42, .external_lex_state = 6},
  [2769] = {.lex_state = 42, .external_lex_state = 6},
  [2770] = {.lex_state = 0, .external_lex_state = 7},
  [2771] = {.lex_state = 0, .external_lex_state = 7},
  [2772] = {.lex_state = 42, .external_lex_state = 6},
  [2773] = {.lex_state = 0, .external_lex_state = 7},
  [2774] = {.lex_state = 0, .external_lex_state = 7},
  [2775] = {.lex_state = 42, .external_lex_state = 8},
  [2776] = {.lex_state = 42, .external_lex_state = 9},
  [2777] = {.lex_state = 42, .external_lex_state = 8},
  [2778] = {.lex_state = 44, .external_lex_state = 7},
  [2779] = {.lex_state = 42, .external_lex_state = 8},
  [2780] = {.lex_state = 42, .external_lex_state = 9},
  [2781] = {.lex_state = 42, .external_lex_state = 8},
  [2782] = {.lex_state = 42, .external_lex_state = 9},
  [2783] = {.lex_state = 42, .external_lex_state = 9},
  [2784] = {.lex_state = 42, .external_lex_state = 8},
  [2785] = {.lex_state = 42, .external_lex_state = 9},
  [2786] = {.lex_state = 42, .external_lex_state = 8},
  [2787] = {.lex_state = 42, .external_lex_state = 9},
  [2788] = {.lex_state = 42, .external_lex_state = 9},
  [2789] = {.lex_state = 42, .external_lex_state = 8},
  [2790] = {.lex_state = 42, .external_lex_state = 8},
  [2791] = {.lex_state = 42, .external_lex_state = 9},
  [2792] = {.lex_state = 42, .external_lex_state = 7},
  [2793] = {.lex_state = 0, .external_lex_state = 7},
  [2794] = {.lex_state = 0, .external_lex_state = 7},
  [2795] = {.lex_state = 0, .external_lex_state = 7},
  [2796] = {.lex_state = 42, .external_lex_state = 8},
  [2797] = {.lex_state = 0, .external_lex_state = 7},
  [2798] = {.lex_state = 0, .external_lex_state = 7},
  [2799] = {.lex_state = 0, .external_lex_state = 7},
  [2800] = {.lex_state = 42, .external_lex_state = 7},
  [2801] = {.lex_state = 0, .external_lex_state = 7},
  [2802] = {.lex_state = 42, .external_lex_state = 8},
  [2803] = {.lex_state = 42, .external_lex_state = 9},
  [2804] = {.lex_state = 42, .external_lex_state = 9},
  [2805] = {.lex_state = 0, .external_lex_state = 7},
  [2806] = {.lex_state = 0, .external_lex_state = 7},
  [2807] = {.lex_state = 0, .external_lex_state = 7},
  [2808] = {.lex_state = 0, .external_lex_state = 7},
  [2809] = {.lex_state = 0, .external_lex_state = 7},
  [2810] = {.lex_state = 0, .external_lex_state = 7},
  [2811] = {.lex_state = 0, .external_lex_state = 7},
  [2812] = {.lex_state = 0, .external_lex_state = 7},
  [2813] = {.lex_state = 0, .external_lex_state = 7},
  [2814] = {.lex_state = 0, .external_lex_state = 7},
  [2815] = {.lex_state = 44, .external_lex_state = 7},
  [2816] = {.lex_state = 0, .external_lex_state = 7},
  [2817] = {.lex_state = 0, .external_lex_state = 7},
  [2818] = {.lex_state = 0, .external_lex_state = 7},
  [2819] = {.lex_state = 0, .external_lex_state = 7},
  [2820] = {.lex_state = 0, .external_lex_state = 7},
  [2821] = {.lex_state = 42, .external_lex_state = 9},
  [2822] = {.lex_state = 0, .external_lex_state = 7},
  [2823] = {.lex_state = 0, .external_lex_state = 7},
  [2824] = {.lex_state = 0, .external_lex_state = 7},
  [2825] = {.lex_state = 0, .external_lex_state = 7},
  [2826] = {.lex_state = 0, .external_lex_state = 7},
  [2827] = {.lex_state = 42, .external_lex_state = 8},
  [2828] = {.lex_state = 42, .external_lex_state = 9},
  [2829] = {.lex_state = 0, .external_lex_state = 7},
  [2830] = {.lex_state = 42, .external_lex_state = 8},
  [2831] = {.lex_state = 0, .external_lex_state = 7},
  [2832] = {.lex_state = 0, .external_lex_state = 7},
  [2833] = {.lex_state = 42, .external_lex_state = 8},
  [2834] = {.lex_state = 0, .external_lex_state = 7},
  [2835] = {.lex_state = 42, .external_lex_state = 9},
  [2836] = {.lex_state = 91, .external_lex_state = 7},
  [2837] = {.lex_state = 42, .external_lex_state = 9},
  [2838] = {.lex_state = 0, .external_lex_state = 7},
  [2839] = {.lex_state = 0, .external_lex_state = 7},
  [2840] = {.lex_state = 0, .external_lex_state = 7},
  [2841] = {.lex_state = 0, .external_lex_state = 7},
  [2842] = {.lex_state = 42, .external_lex_state = 8},
  [2843] = {.lex_state = 0, .external_lex_state = 7},
  [2844] = {.lex_state = 0, .external_lex_state = 7},
  [2845] = {.lex_state = 0, .external_lex_state = 7},
  [2846] = {.lex_state = 42, .external_lex_state = 9},
  [2847] = {.lex_state = 0, .external_lex_state = 7},
  [2848] = {.lex_state = 0, .external_lex_state = 7},
  [2849] = {.lex_state = 0, .external_lex_state = 7},
  [2850] = {.lex_state = 42, .external_lex_state = 8},
  [2851] = {.lex_state = 0, .external_lex_state = 7},
  [2852] = {.lex_state = 42, .external_lex_state = 8},
  [2853] = {.lex_state = 42, .external_lex_state = 9},
  [2854] = {.lex_state = 42, .external_lex_state = 9},
  [2855] = {.lex_state = 42, .external_lex_state = 8},
  [2856] = {.lex_state = 0, .external_lex_state = 7},
  [2857] = {.lex_state = 44, .external_lex_state = 7},
  [2858] = {.lex_state = 0, .external_lex_state = 7},
  [2859] = {.lex_state = 0, .external_lex_state = 7},
  [2860] = {.lex_state = 0, .external_lex_state = 7},
  [2861] = {.lex_state = 0, .external_lex_state = 7},
  [2862] = {.lex_state = 42, .external_lex_state = 6},
  [2863] = {.lex_state = 0, .external_lex_state = 7},
  [2864] = {.lex_state = 0, .external_lex_state = 7},
  [2865] = {.lex_state = 42, .external_lex_state = 6},
  [2866] = {.lex_state = 32, .external_lex_state = 7},
  [2867] = {.lex_state = 32, .external_lex_state = 7},
  [2868] = {.lex_state = 0, .external_lex_state = 7},
  [2869] = {.lex_state = 44, .external_lex_state = 7},
  [2870] = {.lex_state = 32, .external_lex_state = 7},
  [2871] = {.lex_state = 32, .external_lex_state = 7},
  [2872] = {.lex_state = 0, .external_lex_state = 7},
  [2873] = {.lex_state = 91, .external_lex_state = 7},
  [2874] = {.lex_state = 0, .external_lex_state = 7},
  [2875] = {.lex_state = 0, .external_lex_state = 7},
  [2876] = {.lex_state = 0, .external_lex_state = 7},
  [2877] = {.lex_state = 42, .external_lex_state = 6},
  [2878] = {.lex_state = 0, .external_lex_state = 7},
  [2879] = {.lex_state = 32, .external_lex_state = 7},
  [2880] = {.lex_state = 0, .external_lex_state = 7},
  [2881] = {.lex_state = 42, .external_lex_state = 6},
  [2882] = {.lex_state = 91, .external_lex_state = 7},
  [2883] = {.lex_state = 42, .external_lex_state = 6},
  [2884] = {.lex_state = 42, .external_lex_state = 6},
  [2885] = {.lex_state = 0, .external_lex_state = 7},
  [2886] = {.lex_state = 0, .external_lex_state = 7},
  [2887] = {.lex_state = 0, .external_lex_state = 7},
  [2888] = {.lex_state = 42, .external_lex_state = 6},
  [2889] = {.lex_state = 32, .external_lex_state = 7},
  [2890] = {.lex_state = 42, .external_lex_state = 6},
  [2891] = {.lex_state = 32, .external_lex_state = 7},
  [2892] = {.lex_state = 0, .external_lex_state = 7},
  [2893] = {.lex_state = 0, .external_lex_state = 7},
  [2894] = {.lex_state = 0, .external_lex_state = 7},
  [2895] = {.lex_state = 32, .external_lex_state = 7},
  [2896] = {.lex_state = 42, .external_lex_state = 6},
  [2897] = {.lex_state = 42, .external_lex_state = 6},
  [2898] = {.lex_state = 0, .external_lex_state = 7},
  [2899] = {.lex_state = 0, .external_lex_state = 7},
  [2900] = {.lex_state = 42, .external_lex_state = 6},
  [2901] = {.lex_state = 0, .external_lex_state = 7},
  [2902] = {.lex_state = 0, .external_lex_state = 10},
  [2903] = {.lex_state = 0, .external_lex_state = 7},
  [2904] = {.lex_state = 0, .external_lex_state = 11},
  [2905] = {.lex_state = 0, .external_lex_state = 10},
  [2906] = {.lex_state = 0, .external_lex_state = 7},
  [2907] = {.lex_state = 0, .external_lex_state = 11},
  [2908] = {.lex_state = 0, .external_lex_state = 10},
  [2909] = {.lex_state = 0, .external_lex_state = 11},
  [2910] = {.lex_state = 42, .external_lex_state = 7},
  [2911] = {.lex_state = 42, .external_lex_state = 7},
  [2912] = {.lex_state = 42, .external_lex_state = 7},
  [2913] = {.lex_state = 0, .external_lex_state = 7},
  [2914] = {.lex_state = 0, .external_lex_state = 7},
  [2915] = {.lex_state = 42, .external_lex_state = 7},
  [2916] = {.lex_state = 0, .external_lex_state = 7},
  [2917] = {.lex_state = 0, .external_lex_state = 7},
  [2918] = {.lex_state = 0, .external_lex_state = 10},
  [2919] = {.lex_state = 0, .external_lex_state = 11},
  [2920] = {.lex_state = 0, .external_lex_state = 7},
  [2921] = {.lex_state = 0, .external_lex_state = 10},
  [2922] = {.lex_state = 0, .external_lex_state = 7},
  [2923] = {.lex_state = 42, .external_lex_state = 8},
  [2924] = {.lex_state = 0, .external_lex_state = 11},
  [2925] = {.lex_state = 0, .external_lex_state = 10},
  [2926] = {.lex_state = 0, .external_lex_state = 11},
  [2927] = {.lex_state = 0, .external_lex_state = 10},
  [2928] = {.lex_state = 0, .external_lex_state = 7},
  [2929] = {.lex_state = 0, .external_lex_state = 7},
  [2930] = {.lex_state = 0, .external_lex_state = 7},
  [2931] = {.lex_state = 42, .external_lex_state = 7},
  [2932] = {.lex_state = 0, .external_lex_state = 11},
  [2933] = {.lex_state = 0, .external_lex_state = 10},
  [2934] = {.lex_state = 42, .external_lex_state = 7},
  [2935] = {.lex_state = 0, .external_lex_state = 11},
  [2936] = {.lex_state = 0, .external_lex_state = 7},
  [2937] = {.lex_state = 42, .external_lex_state = 7},
  [2938] = {.lex_state = 0, .external_lex_state = 7},
  [2939] = {.lex_state = 0, .external_lex_state = 7},
  [2940] = {.lex_state = 0, .external_lex_state = 7},
  [2941] = {.lex_state = 0, .external_lex_state = 7},
  [2942] = {.lex_state = 0, .external_lex_state = 7},
  [2943] = {.lex_state = 0, .external_lex_state = 7},
  [2944] = {.lex_state = 0, .external_lex_state = 7},
  [2945] = {.lex_state = 0, .external_lex_state = 7},
  [2946] = {.lex_state = 42, .external_lex_state = 7},
  [2947] = {.lex_state = 0, .external_lex_state = 7},
  [2948] = {.lex_state = 42, .external_lex_state = 7},
  [2949] = {.lex_state = 0, .external_lex_state = 7},
  [2950] = {.lex_state = 0, .external_lex_state = 7},
  [2951] = {.lex_state = 0, .external_lex_state = 7},
  [2952] = {.lex_state = 42, .external_lex_state = 8},
  [2953] = {.lex_state = 32, .external_lex_state = 7},
  [2954] = {.lex_state = 78, .external_lex_state = 7},
  [2955] = {.lex_state = 0, .external_lex_state = 7},
  [2956] = {.lex_state = 0, .external_lex_state = 7},
  [2957] = {.lex_state = 42, .external_lex_state = 7},
  [2958] = {.lex_state = 0, .external_lex_state = 7},
  [2959] = {.lex_state = 0, .external_lex_state = 7},
  [2960] = {.lex_state = 42, .external_lex_state = 7},
  [2961] = {.lex_state = 0, .external_lex_state = 7},
  [2962] = {.lex_state = 0, .external_lex_state = 7},
  [2963] = {.lex_state = 0, .external_lex_state = 7},
  [2964] = {.lex_state = 0, .external_lex_state = 7},
  [2965] = {.lex_state = 0, .external_lex_state = 10},
  [2966] = {.lex_state = 0, .external_lex_state = 10},
  [2967] = {.lex_state = 0, .external_lex_state = 11},
  [2968] = {.lex_state = 0, .external_lex_state = 7},
  [2969] = {.lex_state = 0, .external_lex_state = 7},
  [2970] = {.lex_state = 42, .external_lex_state = 6},
  [2971] = {.lex_state = 0, .external_lex_state = 7},
  [2972] = {.lex_state = 0, .external_lex_state = 7},
  [2973] = {.lex_state = 0, .external_lex_state = 7},
  [2974] = {.lex_state = 0, .external_lex_state = 7},
  [2975] = {.lex_state = 0, .external_lex_state = 7},
  [2976] = {.lex_state = 0, .external_lex_state = 11},
  [2977] = {.lex_state = 0, .external_lex_state = 7},
  [2978] = {.lex_state = 0, .external_lex_state = 7},
  [2979] = {.lex_state = 42, .external_lex_state = 7},
  [2980] = {.lex_state = 42, .external_lex_state = 6},
  [2981] = {.lex_state = 0, .external_lex_state = 11},
  [2982] = {.lex_state = 0, .external_lex_state = 10},
  [2983] = {.lex_state = 0, .external_lex_state = 7},
  [2984] = {.lex_state = 0, .external_lex_state = 11},
  [2985] = {.lex_state = 42, .external_lex_state = 9},
  [2986] = {.lex_state = 0, .external_lex_state = 10},
  [2987] = {.lex_state = 42, .external_lex_state = 7},
  [2988] = {.lex_state = 0, .external_lex_state = 7},
  [2989] = {.lex_state = 0, .external_lex_state = 7},
  [2990] = {.lex_state = 0, .external_lex_state = 7},
  [2991] = {.lex_state = 0, .external_lex_state = 7},
  [2992] = {.lex_state = 0, .external_lex_state = 7},
  [2993] = {.lex_state = 42, .external_lex_state = 7},
  [2994] = {.lex_state = 0, .external_lex_state = 7},
  [2995] = {.lex_state = 0, .external_lex_state = 7},
  [2996] = {.lex_state = 0, .external_lex_state = 7},
  [2997] = {.lex_state = 42, .external_lex_state = 7},
  [2998] = {.lex_state = 0, .external_lex_state = 7},
  [2999] = {.lex_state = 0, .external_lex_state = 7},
  [3000] = {.lex_state = 0, .external_lex_state = 7},
  [3001] = {.lex_state = 0, .external_lex_state = 7},
  [3002] = {.lex_state = 0, .external_lex_state = 7},
  [3003] = {.lex_state = 0, .external_lex_state = 7},
  [3004] = {.lex_state = 0, .external_lex_state = 7},
  [3005] = {.lex_state = 0, .external_lex_state = 7},
  [3006] = {.lex_state = 0, .external_lex_state = 10},
  [3007] = {.lex_state = 32, .external_lex_state = 7},
  [3008] = {.lex_state = 0, .external_lex_state = 7},
  [3009] = {.lex_state = 78, .external_lex_state = 7},
  [3010] = {.lex_state = 42, .external_lex_state = 7},
  [3011] = {.lex_state = 0, .external_lex_state = 11},
  [3012] = {.lex_state = 0, .external_lex_state = 11},
  [3013] = {.lex_state = 0, .external_lex_state = 10},
  [3014] = {.lex_state = 0, .external_lex_state = 7},
  [3015] = {.lex_state = 0, .external_lex_state = 7},
  [3016] = {.lex_state = 42, .external_lex_state = 9},
  [3017] = {.lex_state = 0, .external_lex_state = 7},
  [3018] = {.lex_state = 0, .external_lex_state = 7},
  [3019] = {.lex_state = 0, .external_lex_state = 7},
  [3020] = {.lex_state = 0, .external_lex_state = 7},
  [3021] = {.lex_state = 0, .external_lex_state = 7},
  [3022] = {.lex_state = 0, .external_lex_state = 11},
  [3023] = {.lex_state = 0, .external_lex_state = 7},
  [3024] = {.lex_state = 0, .external_lex_state = 10},
  [3025] = {.lex_state = 0, .external_lex_state = 11},
  [3026] = {.lex_state = 0, .external_lex_state = 7},
  [3027] = {.lex_state = 42, .external_lex_state = 7},
  [3028] = {.lex_state = 0, .external_lex_state = 7},
  [3029] = {.lex_state = 0, .external_lex_state = 10},
  [3030] = {.lex_state = 78, .external_lex_state = 7},
  [3031] = {.lex_state = 0, .external_lex_state = 7},
  [3032] = {.lex_state = 42, .external_lex_state = 6},
  [3033] = {.lex_state = 0, .external_lex_state = 7},
  [3034] = {.lex_state = 42, .external_lex_state = 7},
  [3035] = {.lex_state = 0, .external_lex_state = 7},
  [3036] = {.lex_state = 42, .external_lex_state = 6},
  [3037] = {.lex_state = 42, .external_lex_state = 6},
  [3038] = {.lex_state = 0, .external_lex_state = 7},
  [3039] = {.lex_state = 0, .external_lex_state = 7},
  [3040] = {.lex_state = 42, .external_lex_state = 6},
  [3041] = {.lex_state = 42, .external_lex_state = 6},
  [3042] = {.lex_state = 42, .external_lex_state = 6},
  [3043] = {.lex_state = 42, .external_lex_state = 6},
  [3044] = {.lex_state = 42, .external_lex_state = 6},
  [3045] = {.lex_state = 42, .external_lex_state = 6},
  [3046] = {.lex_state = 0, .external_lex_state = 7},
  [3047] = {.lex_state = 42, .external_lex_state = 6},
  [3048] = {.lex_state = 42, .external_lex_state = 6},
  [3049] = {.lex_state = 42, .external_lex_state = 6},
  [3050] = {.lex_state = 42, .external_lex_state = 6},
  [3051] = {.lex_state = 42, .external_lex_state = 6},
  [3052] = {.lex_state = 42, .external_lex_state = 6},
  [3053] = {.lex_state = 42, .external_lex_state = 6},
  [3054] = {.lex_state = 42, .external_lex_state = 6},
  [3055] = {.lex_state = 0, .external_lex_state = 7},
  [3056] = {.lex_state = 42, .external_lex_state = 6},
  [3057] = {.lex_state = 0, .external_lex_state = 10},
  [3058] = {.lex_state = 0, .external_lex_state = 11},
  [3059] = {.lex_state = 42, .external_lex_state = 6},
  [3060] = {.lex_state = 42, .external_lex_state = 6},
  [3061] = {.lex_state = 42, .external_lex_state = 6},
  [3062] = {.lex_state = 42, .external_lex_state = 6},
  [3063] = {.lex_state = 0, .external_lex_state = 7},
  [3064] = {.lex_state = 0, .external_lex_state = 7},
  [3065] = {.lex_state = 0, .external_lex_state = 7},
  [3066] = {.lex_state = 0, .external_lex_state = 7},
  [3067] = {.lex_state = 0, .external_lex_state = 7},
  [3068] = {.lex_state = 0, .external_lex_state = 7},
  [3069] = {.lex_state = 0, .external_lex_state = 7},
  [3070] = {.lex_state = 0, .external_lex_state = 7},
  [3071] = {.lex_state = 0, .external_lex_state = 7},
  [3072] = {.lex_state = 0, .external_lex_state = 7},
  [3073] = {.lex_state = 0, .external_lex_state = 7},
  [3074] = {.lex_state = 0, .external_lex_state = 7},
  [3075] = {.lex_state = 0, .external_lex_state = 7},
  [3076] = {.lex_state = 0, .external_lex_state = 7},
  [3077] = {.lex_state = 0, .external_lex_state = 7},
  [3078] = {.lex_state = 0, .external_lex_state = 7},
  [3079] = {.lex_state = 0, .external_lex_state = 7},
  [3080] = {.lex_state = 0, .external_lex_state = 7},
  [3081] = {.lex_state = 0, .external_lex_state = 7},
  [3082] = {.lex_state = 0, .external_lex_state = 7},
  [3083] = {.lex_state = 0, .external_lex_state = 7},
  [3084] = {.lex_state = 0, .external_lex_state = 7},
  [3085] = {.lex_state = 0, .external_lex_state = 7},
  [3086] = {.lex_state = 0, .external_lex_state = 7},
  [3087] = {.lex_state = 0, .external_lex_state = 7},
  [3088] = {.lex_state = 0, .external_lex_state = 7},
  [3089] = {.lex_state = 0, .external_lex_state = 7},
  [3090] = {.lex_state = 0, .external_lex_state = 7},
  [3091] = {.lex_state = 0, .external_lex_state = 7},
  [3092] = {.lex_state = 0, .external_lex_state = 7},
  [3093] = {.lex_state = 0, .external_lex_state = 7},
  [3094] = {.lex_state = 0, .external_lex_state = 7},
  [3095] = {.lex_state = 0, .external_lex_state = 7},
  [3096] = {.lex_state = 0, .external_lex_state = 7},
  [3097] = {.lex_state = 0, .external_lex_state = 7},
  [3098] = {.lex_state = 0, .external_lex_state = 7},
  [3099] = {.lex_state = 0, .external_lex_state = 7},
  [3100] = {.lex_state = 0, .external_lex_state = 7},
  [3101] = {.lex_state = 0, .external_lex_state = 7},
  [3102] = {.lex_state = 0, .external_lex_state = 7},
  [3103] = {.lex_state = 0, .external_lex_state = 7},
  [3104] = {.lex_state = 0, .external_lex_state = 7},
  [3105] = {.lex_state = 0, .external_lex_state = 7},
  [3106] = {.lex_state = 32, .external_lex_state = 7},
  [3107] = {.lex_state = 0, .external_lex_state = 7},
  [3108] = {.lex_state = 0, .external_lex_state = 7},
  [3109] = {.lex_state = 0, .external_lex_state = 7},
  [3110] = {.lex_state = 0, .external_lex_state = 7},
  [3111] = {.lex_state = 0, .external_lex_state = 7},
  [3112] = {.lex_state = 0, .external_lex_state = 7},
  [3113] = {.lex_state = 0, .external_lex_state = 7},
  [3114] = {.lex_state = 0, .external_lex_state = 7},
  [3115] = {.lex_state = 0, .external_lex_state = 7},
  [3116] = {.lex_state = 0, .external_lex_state = 7},
  [3117] = {.lex_state = 0, .external_lex_state = 7},
  [3118] = {.lex_state = 0, .external_lex_state = 7},
  [3119] = {.lex_state = 0, .external_lex_state = 7},
  [3120] = {.lex_state = 0, .external_lex_state = 7},
  [3121] = {.lex_state = 0, .external_lex_state = 7},
  [3122] = {.lex_state = 0, .external_lex_state = 7},
  [3123] = {.lex_state = 0, .external_lex_state = 7},
  [3124] = {.lex_state = 0, .external_lex_state = 7},
  [3125] = {.lex_state = 0, .external_lex_state = 7},
  [3126] = {.lex_state = 0, .external_lex_state = 7},
  [3127] = {.lex_state = 0, .external_lex_state = 7},
  [3128] = {.lex_state = 0, .external_lex_state = 7},
  [3129] = {.lex_state = 0, .external_lex_state = 7},
  [3130] = {.lex_state = 42, .external_lex_state = 7},
  [3131] = {.lex_state = 0, .external_lex_state = 7},
  [3132] = {.lex_state = 0, .external_lex_state = 7},
  [3133] = {.lex_state = 0, .external_lex_state = 7},
  [3134] = {.lex_state = 0, .external_lex_state = 7},
  [3135] = {.lex_state = 0, .external_lex_state = 7},
  [3136] = {.lex_state = 0, .external_lex_state = 7},
  [3137] = {.lex_state = 0, .external_lex_state = 7},
  [3138] = {.lex_state = 0, .external_lex_state = 7},
  [3139] = {.lex_state = 0, .external_lex_state = 7},
  [3140] = {.lex_state = 0, .external_lex_state = 7},
  [3141] = {.lex_state = 0, .external_lex_state = 7},
  [3142] = {.lex_state = 0, .external_lex_state = 7},
  [3143] = {.lex_state = 0, .external_lex_state = 7},
  [3144] = {.lex_state = 0, .external_lex_state = 7},
  [3145] = {.lex_state = 0, .external_lex_state = 7},
  [3146] = {.lex_state = 0, .external_lex_state = 7},
  [3147] = {.lex_state = 0, .external_lex_state = 7},
  [3148] = {.lex_state = 32, .external_lex_state = 7},
  [3149] = {.lex_state = 0, .external_lex_state = 7},
  [3150] = {.lex_state = 0, .external_lex_state = 7},
  [3151] = {.lex_state = 0, .external_lex_state = 7},
  [3152] = {.lex_state = 0, .external_lex_state = 7},
  [3153] = {.lex_state = 0, .external_lex_state = 7},
  [3154] = {.lex_state = 0, .external_lex_state = 7},
  [3155] = {.lex_state = 0, .external_lex_state = 7},
  [3156] = {.lex_state = 0, .external_lex_state = 7},
  [3157] = {.lex_state = 0, .external_lex_state = 7},
  [3158] = {.lex_state = 0, .external_lex_state = 7},
  [3159] = {.lex_state = 0, .external_lex_state = 7},
  [3160] = {.lex_state = 0, .external_lex_state = 7},
  [3161] = {.lex_state = 0, .external_lex_state = 7},
  [3162] = {.lex_state = 0, .external_lex_state = 7},
  [3163] = {.lex_state = 0, .external_lex_state = 7},
  [3164] = {.lex_state = 0, .external_lex_state = 7},
  [3165] = {.lex_state = 0, .external_lex_state = 7},
  [3166] = {.lex_state = 0, .external_lex_state = 7},
  [3167] = {.lex_state = 0, .external_lex_state = 7},
  [3168] = {.lex_state = 0, .external_lex_state = 7},
  [3169] = {.lex_state = 0, .external_lex_state = 7},
  [3170] = {.lex_state = 0, .external_lex_state = 7},
  [3171] = {.lex_state = 0, .external_lex_state = 7},
  [3172] = {.lex_state = 0, .external_lex_state = 7},
  [3173] = {.lex_state = 0, .external_lex_state = 7},
  [3174] = {.lex_state = 0, .external_lex_state = 7},
  [3175] = {.lex_state = 0, .external_lex_state = 7},
  [3176] = {.lex_state = 0, .external_lex_state = 7},
  [3177] = {.lex_state = 0, .external_lex_state = 7},
  [3178] = {.lex_state = 42, .external_lex_state = 6},
  [3179] = {.lex_state = 0, .external_lex_state = 7},
  [3180] = {.lex_state = 0, .external_lex_state = 7},
  [3181] = {.lex_state = 0, .external_lex_state = 7},
  [3182] = {.lex_state = 0, .external_lex_state = 7},
  [3183] = {.lex_state = 0, .external_lex_state = 7},
  [3184] = {.lex_state = 0, .external_lex_state = 7},
  [3185] = {.lex_state = 0, .external_lex_state = 7},
  [3186] = {.lex_state = 42, .external_lex_state = 7},
  [3187] = {.lex_state = 0, .external_lex_state = 7},
  [3188] = {.lex_state = 0, .external_lex_state = 7},
  [3189] = {.lex_state = 0, .external_lex_state = 7},
  [3190] = {.lex_state = 0, .external_lex_state = 7},
  [3191] = {.lex_state = 0, .external_lex_state = 7},
  [3192] = {.lex_state = 0, .external_lex_state = 7},
  [3193] = {.lex_state = 32, .external_lex_state = 7},
  [3194] = {.lex_state = 0, .external_lex_state = 7},
  [3195] = {.lex_state = 0, .external_lex_state = 7},
  [3196] = {.lex_state = 0, .external_lex_state = 7},
  [3197] = {.lex_state = 0, .external_lex_state = 7},
  [3198] = {.lex_state = 0, .external_lex_state = 7},
  [3199] = {.lex_state = 0, .external_lex_state = 7},
  [3200] = {.lex_state = 0, .external_lex_state = 7},
  [3201] = {.lex_state = 0, .external_lex_state = 7},
  [3202] = {.lex_state = 0, .external_lex_state = 7},
  [3203] = {.lex_state = 0, .external_lex_state = 7},
  [3204] = {.lex_state = 0, .external_lex_state = 7},
  [3205] = {.lex_state = 0, .external_lex_state = 7},
  [3206] = {.lex_state = 0, .external_lex_state = 7},
  [3207] = {.lex_state = 0, .external_lex_state = 7},
  [3208] = {.lex_state = 0, .external_lex_state = 7},
  [3209] = {.lex_state = 0, .external_lex_state = 7},
  [3210] = {.lex_state = 0, .external_lex_state = 7},
  [3211] = {.lex_state = 0, .external_lex_state = 7},
  [3212] = {.lex_state = 0, .external_lex_state = 7},
  [3213] = {.lex_state = 0, .external_lex_state = 7},
  [3214] = {.lex_state = 0, .external_lex_state = 7},
  [3215] = {.lex_state = 0, .external_lex_state = 7},
  [3216] = {.lex_state = 0, .external_lex_state = 7},
  [3217] = {.lex_state = 0, .external_lex_state = 7},
  [3218] = {.lex_state = 0, .external_lex_state = 7},
  [3219] = {.lex_state = 0, .external_lex_state = 7},
  [3220] = {.lex_state = 0, .external_lex_state = 7},
  [3221] = {.lex_state = 0, .external_lex_state = 7},
  [3222] = {.lex_state = 0, .external_lex_state = 7},
  [3223] = {.lex_state = 0, .external_lex_state = 7},
  [3224] = {.lex_state = 0, .external_lex_state = 7},
  [3225] = {.lex_state = 0, .external_lex_state = 7},
  [3226] = {.lex_state = 0, .external_lex_state = 7},
  [3227] = {.lex_state = 0, .external_lex_state = 7},
  [3228] = {.lex_state = 0, .external_lex_state = 7},
  [3229] = {.lex_state = 0, .external_lex_state = 7},
  [3230] = {.lex_state = 0, .external_lex_state = 7},
  [3231] = {.lex_state = 0, .external_lex_state = 7},
  [3232] = {.lex_state = 0, .external_lex_state = 7},
  [3233] = {.lex_state = 0, .external_lex_state = 7},
  [3234] = {.lex_state = 32, .external_lex_state = 7},
  [3235] = {.lex_state = 0, .external_lex_state = 7},
  [3236] = {.lex_state = 0, .external_lex_state = 7},
  [3237] = {.lex_state = 0, .external_lex_state = 7},
  [3238] = {.lex_state = 0, .external_lex_state = 7},
  [3239] = {.lex_state = 0, .external_lex_state = 7},
  [3240] = {.lex_state = 0, .external_lex_state = 7},
  [3241] = {.lex_state = 0, .external_lex_state = 7},
  [3242] = {.lex_state = 0, .external_lex_state = 7},
  [3243] = {.lex_state = 0, .external_lex_state = 7},
  [3244] = {.lex_state = 42, .external_lex_state = 6},
  [3245] = {.lex_state = 0, .external_lex_state = 7},
  [3246] = {.lex_state = 0, .external_lex_state = 7},
  [3247] = {.lex_state = 0, .external_lex_state = 7},
  [3248] = {.lex_state = 0, .external_lex_state = 7},
  [3249] = {.lex_state = 0, .external_lex_state = 7},
  [3250] = {.lex_state = 0, .external_lex_state = 7},
  [3251] = {.lex_state = 0, .external_lex_state = 7},
  [3252] = {.lex_state = 0, .external_lex_state = 7},
  [3253] = {.lex_state = 0, .external_lex_state = 7},
  [3254] = {.lex_state = 0, .external_lex_state = 7},
  [3255] = {.lex_state = 0, .external_lex_state = 7},
  [3256] = {.lex_state = 0, .external_lex_state = 7},
  [3257] = {.lex_state = 0, .external_lex_state = 7},
  [3258] = {.lex_state = 0, .external_lex_state = 7},
  [3259] = {.lex_state = 0, .external_lex_state = 7},
  [3260] = {.lex_state = 0, .external_lex_state = 7},
  [3261] = {.lex_state = 0, .external_lex_state = 7},
  [3262] = {.lex_state = 0, .external_lex_state = 7},
  [3263] = {.lex_state = 0, .external_lex_state = 7},
  [3264] = {.lex_state = 0, .external_lex_state = 7},
  [3265] = {.lex_state = 32, .external_lex_state = 7},
  [3266] = {.lex_state = 0, .external_lex_state = 7},
  [3267] = {.lex_state = 0, .external_lex_state = 7},
  [3268] = {.lex_state = 0, .external_lex_state = 7},
  [3269] = {.lex_state = 0, .external_lex_state = 7},
  [3270] = {.lex_state = 0, .external_lex_state = 7},
  [3271] = {.lex_state = 0, .external_lex_state = 7},
  [3272] = {.lex_state = 0, .external_lex_state = 7},
  [3273] = {.lex_state = 0, .external_lex_state = 7},
  [3274] = {.lex_state = 0, .external_lex_state = 7},
  [3275] = {.lex_state = 0, .external_lex_state = 7},
  [3276] = {.lex_state = 0, .external_lex_state = 7},
  [3277] = {.lex_state = 0, .external_lex_state = 7},
  [3278] = {.lex_state = 0, .external_lex_state = 7},
  [3279] = {.lex_state = 0, .external_lex_state = 7},
  [3280] = {.lex_state = 0, .external_lex_state = 7},
  [3281] = {.lex_state = 0, .external_lex_state = 7},
  [3282] = {.lex_state = 0, .external_lex_state = 7},
  [3283] = {.lex_state = 0, .external_lex_state = 7},
  [3284] = {.lex_state = 0, .external_lex_state = 7},
  [3285] = {.lex_state = 0, .external_lex_state = 7},
  [3286] = {.lex_state = 0, .external_lex_state = 7},
  [3287] = {.lex_state = 32, .external_lex_state = 7},
  [3288] = {.lex_state = 0, .external_lex_state = 7},
  [3289] = {.lex_state = 0, .external_lex_state = 7},
  [3290] = {.lex_state = 0, .external_lex_state = 7},
  [3291] = {.lex_state = 0, .external_lex_state = 7},
  [3292] = {.lex_state = 0, .external_lex_state = 7},
  [3293] = {.lex_state = 0, .external_lex_state = 7},
  [3294] = {.lex_state = 0, .external_lex_state = 7},
  [3295] = {.lex_state = 0, .external_lex_state = 7},
  [3296] = {.lex_state = 0, .external_lex_state = 7},
  [3297] = {.lex_state = 0, .external_lex_state = 7},
  [3298] = {.lex_state = 0, .external_lex_state = 7},
  [3299] = {.lex_state = 0, .external_lex_state = 7},
  [3300] = {.lex_state = 0, .external_lex_state = 7},
  [3301] = {.lex_state = 0, .external_lex_state = 7},
  [3302] = {.lex_state = 0, .external_lex_state = 7},
  [3303] = {.lex_state = 0, .external_lex_state = 7},
  [3304] = {.lex_state = 42, .external_lex_state = 6},
  [3305] = {.lex_state = 0, .external_lex_state = 7},
  [3306] = {.lex_state = 0, .external_lex_state = 7},
  [3307] = {.lex_state = 0, .external_lex_state = 7},
  [3308] = {.lex_state = 0, .external_lex_state = 7},
  [3309] = {.lex_state = 0, .external_lex_state = 7},
  [3310] = {.lex_state = 0, .external_lex_state = 7},
  [3311] = {.lex_state = 0, .external_lex_state = 7},
  [3312] = {.lex_state = 0, .external_lex_state = 7},
  [3313] = {.lex_state = 0, .external_lex_state = 7},
  [3314] = {.lex_state = 0, .external_lex_state = 7},
  [3315] = {.lex_state = 0, .external_lex_state = 7},
  [3316] = {.lex_state = 42, .external_lex_state = 6},
  [3317] = {.lex_state = 0, .external_lex_state = 7},
  [3318] = {.lex_state = 32, .external_lex_state = 7},
  [3319] = {.lex_state = 32, .external_lex_state = 7},
  [3320] = {.lex_state = 42, .external_lex_state = 6},
  [3321] = {.lex_state = 0, .external_lex_state = 7},
  [3322] = {.lex_state = 42, .external_lex_state = 7},
  [3323] = {.lex_state = 0, .external_lex_state = 7},
  [3324] = {.lex_state = 0, .external_lex_state = 7},
  [3325] = {.lex_state = 0, .external_lex_state = 7},
  [3326] = {.lex_state = 0, .external_lex_state = 7},
  [3327] = {.lex_state = 0, .external_lex_state = 7},
  [3328] = {.lex_state = 0, .external_lex_state = 7},
  [3329] = {.lex_state = 42, .external_lex_state = 7},
  [3330] = {.lex_state = 0, .external_lex_state = 7},
  [3331] = {.lex_state = 0, .external_lex_state = 7},
  [3332] = {.lex_state = 0, .external_lex_state = 7},
  [3333] = {.lex_state = 0, .external_lex_state = 7},
  [3334] = {.lex_state = 44, .external_lex_state = 7},
  [3335] = {.lex_state = 0, .external_lex_state = 7},
  [3336] = {.lex_state = 0, .external_lex_state = 7},
  [3337] = {.lex_state = 0, .external_lex_state = 7},
  [3338] = {.lex_state = 0, .external_lex_state = 7},
  [3339] = {.lex_state = 0, .external_lex_state = 7},
  [3340] = {.lex_state = 0, .external_lex_state = 7},
  [3341] = {.lex_state = 0, .external_lex_state = 7},
  [3342] = {.lex_state = 0, .external_lex_state = 7},
  [3343] = {.lex_state = 42, .external_lex_state = 7},
  [3344] = {.lex_state = 0, .external_lex_state = 7},
  [3345] = {.lex_state = 0, .external_lex_state = 7},
  [3346] = {.lex_state = 0, .external_lex_state = 7},
  [3347] = {.lex_state = 0, .external_lex_state = 7},
  [3348] = {.lex_state = 0, .external_lex_state = 7},
  [3349] = {.lex_state = 0, .external_lex_state = 7},
  [3350] = {.lex_state = 0, .external_lex_state = 7},
  [3351] = {.lex_state = 0, .external_lex_state = 7},
  [3352] = {.lex_state = 0, .external_lex_state = 7},
  [3353] = {.lex_state = 0, .external_lex_state = 7},
  [3354] = {.lex_state = 0, .external_lex_state = 7},
  [3355] = {.lex_state = 0, .external_lex_state = 7},
  [3356] = {.lex_state = 0, .external_lex_state = 7},
  [3357] = {.lex_state = 0, .external_lex_state = 7},
  [3358] = {.lex_state = 42, .external_lex_state = 6},
  [3359] = {.lex_state = 42, .external_lex_state = 7},
  [3360] = {.lex_state = 0, .external_lex_state = 7},
  [3361] = {.lex_state = 0, .external_lex_state = 7},
  [3362] = {.lex_state = 0, .external_lex_state = 7},
  [3363] = {.lex_state = 0, .external_lex_state = 7},
  [3364] = {.lex_state = 0, .external_lex_state = 7},
  [3365] = {.lex_state = 0, .external_lex_state = 7},
  [3366] = {.lex_state = 0, .external_lex_state = 7},
  [3367] = {.lex_state = 0, .external_lex_state = 7},
  [3368] = {.lex_state = 0, .external_lex_state = 7},
  [3369] = {.lex_state = 0, .external_lex_state = 7},
  [3370] = {.lex_state = 0, .external_lex_state = 7},
  [3371] = {.lex_state = 0, .external_lex_state = 7},
  [3372] = {.lex_state = 0, .external_lex_state = 7},
  [3373] = {.lex_state = 0, .external_lex_state = 7},
  [3374] = {.lex_state = 0, .external_lex_state = 7},
  [3375] = {.lex_state = 0, .external_lex_state = 7},
  [3376] = {.lex_state = 0, .external_lex_state = 7},
  [3377] = {.lex_state = 0, .external_lex_state = 7},
  [3378] = {.lex_state = 0, .external_lex_state = 7},
  [3379] = {.lex_state = 0, .external_lex_state = 7},
  [3380] = {.lex_state = 0, .external_lex_state = 7},
  [3381] = {.lex_state = 0, .external_lex_state = 7},
  [3382] = {.lex_state = 0, .external_lex_state = 7},
  [3383] = {.lex_state = 0, .external_lex_state = 7},
  [3384] = {.lex_state = 0, .external_lex_state = 7},
  [3385] = {.lex_state = 0, .external_lex_state = 7},
  [3386] = {.lex_state = 0, .external_lex_state = 7},
  [3387] = {.lex_state = 42, .external_lex_state = 6},
  [3388] = {.lex_state = 0, .external_lex_state = 7},
  [3389] = {.lex_state = 0, .external_lex_state = 7},
  [3390] = {.lex_state = 0, .external_lex_state = 7},
  [3391] = {.lex_state = 0, .external_lex_state = 7},
  [3392] = {.lex_state = 42, .external_lex_state = 6},
  [3393] = {.lex_state = 42, .external_lex_state = 6},
  [3394] = {.lex_state = 0, .external_lex_state = 7},
  [3395] = {.lex_state = 0, .external_lex_state = 7},
  [3396] = {.lex_state = 0, .external_lex_state = 7},
  [3397] = {.lex_state = 0, .external_lex_state = 7},
  [3398] = {.lex_state = 42, .external_lex_state = 6},
  [3399] = {.lex_state = 0, .external_lex_state = 7},
  [3400] = {.lex_state = 0, .external_lex_state = 7},
  [3401] = {.lex_state = 0, .external_lex_state = 7},
  [3402] = {.lex_state = 42, .external_lex_state = 6},
  [3403] = {.lex_state = 0, .external_lex_state = 7},
  [3404] = {.lex_state = 42, .external_lex_state = 6},
  [3405] = {.lex_state = 0, .external_lex_state = 7},
  [3406] = {.lex_state = 0, .external_lex_state = 7},
  [3407] = {.lex_state = 42, .external_lex_state = 6},
  [3408] = {.lex_state = 0, .external_lex_state = 7},
  [3409] = {.lex_state = 42, .external_lex_state = 6},
  [3410] = {.lex_state = 0, .external_lex_state = 7},
  [3411] = {.lex_state = 0, .external_lex_state = 7},
  [3412] = {.lex_state = 0, .external_lex_state = 7},
  [3413] = {.lex_state = 0, .external_lex_state = 7},
  [3414] = {.lex_state = 42, .external_lex_state = 6},
  [3415] = {.lex_state = 0, .external_lex_state = 7},
  [3416] = {.lex_state = 0, .external_lex_state = 7},
  [3417] = {.lex_state = 0, .external_lex_state = 7},
  [3418] = {.lex_state = 0, .external_lex_state = 7},
  [3419] = {.lex_state = 0, .external_lex_state = 7},
  [3420] = {.lex_state = 0, .external_lex_state = 7},
  [3421] = {.lex_state = 0, .external_lex_state = 7},
  [3422] = {.lex_state = 0, .external_lex_state = 7},
  [3423] = {.lex_state = 42, .external_lex_state = 6},
  [3424] = {.lex_state = 42, .external_lex_state = 6},
  [3425] = {.lex_state = 42, .external_lex_state = 6},
  [3426] = {.lex_state = 0, .external_lex_state = 7},
  [3427] = {.lex_state = 0, .external_lex_state = 7},
  [3428] = {.lex_state = 42, .external_lex_state = 6},
  [3429] = {.lex_state = 0, .external_lex_state = 7},
  [3430] = {.lex_state = 0, .external_lex_state = 7},
  [3431] = {.lex_state = 0, .external_lex_state = 7},
  [3432] = {.lex_state = 0, .external_lex_state = 7},
  [3433] = {.lex_state = 42, .external_lex_state = 6},
  [3434] = {.lex_state = 0, .external_lex_state = 7},
  [3435] = {.lex_state = 0, .external_lex_state = 7},
  [3436] = {.lex_state = 0, .external_lex_state = 7},
  [3437] = {.lex_state = 0, .external_lex_state = 7},
  [3438] = {.lex_state = 0, .external_lex_state = 7},
  [3439] = {.lex_state = 0, .external_lex_state = 7},
  [3440] = {.lex_state = 0, .external_lex_state = 7},
  [3441] = {.lex_state = 0, .external_lex_state = 7},
  [3442] = {.lex_state = 0, .external_lex_state = 7},
  [3443] = {.lex_state = 0, .external_lex_state = 7},
  [3444] = {.lex_state = 0, .external_lex_state = 7},
  [3445] = {.lex_state = 0, .external_lex_state = 7},
  [3446] = {.lex_state = 0, .external_lex_state = 7},
  [3447] = {.lex_state = 0, .external_lex_state = 7},
  [3448] = {.lex_state = 0, .external_lex_state = 7},
  [3449] = {.lex_state = 0, .external_lex_state = 7},
  [3450] = {.lex_state = 0, .external_lex_state = 7},
  [3451] = {.lex_state = 0, .external_lex_state = 7},
  [3452] = {.lex_state = 0, .external_lex_state = 7},
  [3453] = {.lex_state = 0, .external_lex_state = 7},
  [3454] = {.lex_state = 0, .external_lex_state = 7},
  [3455] = {.lex_state = 0, .external_lex_state = 7},
  [3456] = {.lex_state = 0, .external_lex_state = 7},
  [3457] = {.lex_state = 0, .external_lex_state = 7},
  [3458] = {.lex_state = 0, .external_lex_state = 7},
  [3459] = {.lex_state = 0, .external_lex_state = 7},
  [3460] = {.lex_state = 0, .external_lex_state = 7},
  [3461] = {.lex_state = 0, .external_lex_state = 7},
  [3462] = {.lex_state = 0, .external_lex_state = 7},
  [3463] = {.lex_state = 0, .external_lex_state = 7},
  [3464] = {.lex_state = 0, .external_lex_state = 7},
  [3465] = {.lex_state = 0, .external_lex_state = 7},
  [3466] = {.lex_state = 0, .external_lex_state = 7},
  [3467] = {.lex_state = 0, .external_lex_state = 7},
  [3468] = {.lex_state = 0, .external_lex_state = 7},
  [3469] = {.lex_state = 0, .external_lex_state = 7},
  [3470] = {.lex_state = 0, .external_lex_state = 7},
  [3471] = {.lex_state = 0, .external_lex_state = 7},
  [3472] = {.lex_state = 0, .external_lex_state = 7},
  [3473] = {.lex_state = 0, .external_lex_state = 7},
  [3474] = {.lex_state = 0, .external_lex_state = 7},
  [3475] = {.lex_state = 0, .external_lex_state = 7},
  [3476] = {.lex_state = 0, .external_lex_state = 7},
  [3477] = {.lex_state = 0, .external_lex_state = 7},
  [3478] = {.lex_state = 0, .external_lex_state = 7},
  [3479] = {.lex_state = 0, .external_lex_state = 7},
  [3480] = {.lex_state = 0, .external_lex_state = 7},
  [3481] = {.lex_state = 0, .external_lex_state = 7},
  [3482] = {.lex_state = 0, .external_lex_state = 7},
  [3483] = {.lex_state = 0, .external_lex_state = 7},
  [3484] = {.lex_state = 0, .external_lex_state = 7},
  [3485] = {.lex_state = 0, .external_lex_state = 7},
  [3486] = {.lex_state = 0, .external_lex_state = 7},
  [3487] = {.lex_state = 0, .external_lex_state = 7},
  [3488] = {.lex_state = 0, .external_lex_state = 7},
  [3489] = {.lex_state = 0, .external_lex_state = 7},
  [3490] = {.lex_state = 0, .external_lex_state = 7},
  [3491] = {.lex_state = 0, .external_lex_state = 7},
  [3492] = {.lex_state = 0, .external_lex_state = 7},
  [3493] = {.lex_state = 0, .external_lex_state = 7},
  [3494] = {.lex_state = 0, .external_lex_state = 7},
  [3495] = {.lex_state = 0, .external_lex_state = 7},
  [3496] = {.lex_state = 0, .external_lex_state = 7},
  [3497] = {.lex_state = 0, .external_lex_state = 7},
  [3498] = {.lex_state = 0, .external_lex_state = 7},
  [3499] = {.lex_state = 0, .external_lex_state = 7},
  [3500] = {.lex_state = 0, .external_lex_state = 7},
  [3501] = {.lex_state = 0, .external_lex_state = 7},
  [3502] = {.lex_state = 0, .external_lex_state = 7},
  [3503] = {.lex_state = 0, .external_lex_state = 7},
  [3504] = {.lex_state = 0, .external_lex_state = 7},
  [3505] = {.lex_state = 0, .external_lex_state = 7},
  [3506] = {.lex_state = 0, .external_lex_state = 7},
  [3507] = {.lex_state = 0, .external_lex_state = 7},
  [3508] = {.lex_state = 0, .external_lex_state = 7},
  [3509] = {.lex_state = 0, .external_lex_state = 7},
  [3510] = {.lex_state = 0, .external_lex_state = 7},
  [3511] = {.lex_state = 0, .external_lex_state = 7},
  [3512] = {.lex_state = 0, .external_lex_state = 7},
  [3513] = {.lex_state = 0, .external_lex_state = 7},
  [3514] = {.lex_state = 0, .external_lex_state = 7},
  [3515] = {.lex_state = 0, .external_lex_state = 7},
  [3516] = {.lex_state = 0, .external_lex_state = 7},
  [3517] = {.lex_state = 0, .external_lex_state = 7},
  [3518] = {.lex_state = 0, .external_lex_state = 7},
  [3519] = {.lex_state = 0, .external_lex_state = 7},
  [3520] = {.lex_state = 0, .external_lex_state = 7},
  [3521] = {.lex_state = 0, .external_lex_state = 7},
  [3522] = {.lex_state = 0, .external_lex_state = 7},
  [3523] = {.lex_state = 0, .external_lex_state = 7},
  [3524] = {.lex_state = 0, .external_lex_state = 7},
  [3525] = {.lex_state = 0, .external_lex_state = 7},
  [3526] = {.lex_state = 0, .external_lex_state = 7},
  [3527] = {.lex_state = 0, .external_lex_state = 7},
  [3528] = {.lex_state = 0, .external_lex_state = 7},
  [3529] = {.lex_state = 0, .external_lex_state = 7},
  [3530] = {.lex_state = 0, .external_lex_state = 7},
  [3531] = {.lex_state = 0, .external_lex_state = 7},
  [3532] = {.lex_state = 0, .external_lex_state = 7},
  [3533] = {.lex_state = 0, .external_lex_state = 7},
  [3534] = {.lex_state = 0, .external_lex_state = 7},
  [3535] = {.lex_state = 0, .external_lex_state = 7},
  [3536] = {.lex_state = 0, .external_lex_state = 7},
  [3537] = {.lex_state = 0, .external_lex_state = 7},
  [3538] = {.lex_state = 0, .external_lex_state = 7},
  [3539] = {.lex_state = 0, .external_lex_state = 7},
  [3540] = {.lex_state = 0, .external_lex_state = 7},
  [3541] = {.lex_state = 0, .external_lex_state = 7},
  [3542] = {.lex_state = 0, .external_lex_state = 7},
  [3543] = {.lex_state = 0, .external_lex_state = 7},
  [3544] = {.lex_state = 0, .external_lex_state = 7},
  [3545] = {.lex_state = 0, .external_lex_state = 7},
  [3546] = {.lex_state = 0, .external_lex_state = 7},
  [3547] = {.lex_state = 0, .external_lex_state = 7},
  [3548] = {.lex_state = 0, .external_lex_state = 7},
  [3549] = {.lex_state = 0, .external_lex_state = 7},
  [3550] = {.lex_state = 0, .external_lex_state = 7},
  [3551] = {.lex_state = 0, .external_lex_state = 7},
  [3552] = {.lex_state = 0, .external_lex_state = 7},
  [3553] = {.lex_state = 0, .external_lex_state = 7},
  [3554] = {.lex_state = 0, .external_lex_state = 7},
  [3555] = {.lex_state = 0, .external_lex_state = 7},
  [3556] = {.lex_state = 0, .external_lex_state = 7},
  [3557] = {.lex_state = 42, .external_lex_state = 6},
  [3558] = {.lex_state = 0, .external_lex_state = 7},
  [3559] = {.lex_state = 0, .external_lex_state = 7},
  [3560] = {.lex_state = 0, .external_lex_state = 7},
  [3561] = {.lex_state = 0, .external_lex_state = 7},
  [3562] = {.lex_state = 0, .external_lex_state = 7},
  [3563] = {.lex_state = 0, .external_lex_state = 7},
  [3564] = {.lex_state = 0, .external_lex_state = 7},
  [3565] = {.lex_state = 0, .external_lex_state = 7},
  [3566] = {.lex_state = 0, .external_lex_state = 7},
  [3567] = {.lex_state = 0, .external_lex_state = 7},
  [3568] = {.lex_state = 0, .external_lex_state = 7},
  [3569] = {.lex_state = 0, .external_lex_state = 7},
  [3570] = {.lex_state = 0, .external_lex_state = 7},
  [3571] = {.lex_state = 0, .external_lex_state = 7},
  [3572] = {.lex_state = 0, .external_lex_state = 7},
  [3573] = {.lex_state = 0, .external_lex_state = 7},
  [3574] = {.lex_state = 0, .external_lex_state = 7},
  [3575] = {.lex_state = 0, .external_lex_state = 7},
  [3576] = {.lex_state = 0, .external_lex_state = 7},
  [3577] = {.lex_state = 0, .external_lex_state = 7},
  [3578] = {.lex_state = 0, .external_lex_state = 7},
  [3579] = {.lex_state = 0, .external_lex_state = 7},
  [3580] = {.lex_state = 0, .external_lex_state = 7},
  [3581] = {.lex_state = 0, .external_lex_state = 7},
  [3582] = {.lex_state = 0, .external_lex_state = 7},
  [3583] = {.lex_state = 0, .external_lex_state = 7},
  [3584] = {.lex_state = 0, .external_lex_state = 7},
  [3585] = {.lex_state = 0, .external_lex_state = 6},
  [3586] = {.lex_state = 0, .external_lex_state = 7},
  [3587] = {.lex_state = 0, .external_lex_state = 7},
  [3588] = {.lex_state = 0, .external_lex_state = 7},
  [3589] = {.lex_state = 0, .external_lex_state = 7},
  [3590] = {.lex_state = 0, .external_lex_state = 7},
  [3591] = {.lex_state = 0, .external_lex_state = 7},
  [3592] = {.lex_state = 0, .external_lex_state = 7},
  [3593] = {.lex_state = 0, .external_lex_state = 7},
  [3594] = {.lex_state = 0, .external_lex_state = 7},
  [3595] = {.lex_state = 0, .external_lex_state = 7},
  [3596] = {.lex_state = 0, .external_lex_state = 7},
  [3597] = {.lex_state = 0, .external_lex_state = 7},
  [3598] = {.lex_state = 0, .external_lex_state = 7},
  [3599] = {.lex_state = 0, .external_lex_state = 7},
  [3600] = {.lex_state = 0, .external_lex_state = 7},
  [3601] = {.lex_state = 0, .external_lex_state = 7},
  [3602] = {.lex_state = 0, .external_lex_state = 7},
  [3603] = {.lex_state = 44, .external_lex_state = 7},
  [3604] = {.lex_state = 0, .external_lex_state = 7},
  [3605] = {.lex_state = 0, .external_lex_state = 7},
  [3606] = {.lex_state = 0, .external_lex_state = 7},
  [3607] = {.lex_state = 0, .external_lex_state = 7},
  [3608] = {.lex_state = 0, .external_lex_state = 7},
  [3609] = {.lex_state = 0, .external_lex_state = 7},
  [3610] = {.lex_state = 0, .external_lex_state = 7},
  [3611] = {.lex_state = 0, .external_lex_state = 7},
  [3612] = {.lex_state = 0, .external_lex_state = 6},
  [3613] = {.lex_state = 44, .external_lex_state = 7},
  [3614] = {.lex_state = 0, .external_lex_state = 7},
  [3615] = {.lex_state = 0, .external_lex_state = 7},
  [3616] = {.lex_state = 0, .external_lex_state = 7},
  [3617] = {.lex_state = 0, .external_lex_state = 7},
  [3618] = {.lex_state = 0, .external_lex_state = 7},
  [3619] = {.lex_state = 0, .external_lex_state = 7},
  [3620] = {.lex_state = 0, .external_lex_state = 7},
  [3621] = {.lex_state = 0, .external_lex_state = 7},
  [3622] = {.lex_state = 0, .external_lex_state = 7},
  [3623] = {.lex_state = 0, .external_lex_state = 7},
  [3624] = {.lex_state = 0, .external_lex_state = 7},
  [3625] = {.lex_state = 0, .external_lex_state = 7},
  [3626] = {.lex_state = 0, .external_lex_state = 7},
  [3627] = {.lex_state = 0, .external_lex_state = 7},
  [3628] = {.lex_state = 0, .external_lex_state = 7},
  [3629] = {.lex_state = 0, .external_lex_state = 7},
  [3630] = {.lex_state = 0, .external_lex_state = 7},
  [3631] = {.lex_state = 44, .external_lex_state = 7},
  [3632] = {.lex_state = 0, .external_lex_state = 7},
  [3633] = {.lex_state = 0, .external_lex_state = 7},
  [3634] = {.lex_state = 0, .external_lex_state = 7},
  [3635] = {.lex_state = 0, .external_lex_state = 7},
  [3636] = {.lex_state = 0, .external_lex_state = 7},
  [3637] = {.lex_state = 0, .external_lex_state = 7},
  [3638] = {.lex_state = 0, .external_lex_state = 6},
  [3639] = {.lex_state = 0, .external_lex_state = 7},
  [3640] = {.lex_state = 0, .external_lex_state = 7},
  [3641] = {.lex_state = 0, .external_lex_state = 7},
  [3642] = {.lex_state = 0, .external_lex_state = 7},
  [3643] = {.lex_state = 0, .external_lex_state = 7},
  [3644] = {.lex_state = 0, .external_lex_state = 7},
  [3645] = {.lex_state = 0, .external_lex_state = 7},
  [3646] = {.lex_state = 45, .external_lex_state = 7},
  [3647] = {.lex_state = 0, .external_lex_state = 7},
  [3648] = {.lex_state = 0, .external_lex_state = 7},
  [3649] = {.lex_state = 0, .external_lex_state = 7},
  [3650] = {.lex_state = 0, .external_lex_state = 7},
  [3651] = {.lex_state = 44, .external_lex_state = 7},
  [3652] = {.lex_state = 0, .external_lex_state = 7},
  [3653] = {.lex_state = 0, .external_lex_state = 7},
  [3654] = {.lex_state = 0, .external_lex_state = 7},
  [3655] = {.lex_state = 0, .external_lex_state = 7},
  [3656] = {.lex_state = 0, .external_lex_state = 7},
  [3657] = {.lex_state = 0, .external_lex_state = 7},
  [3658] = {.lex_state = 45, .external_lex_state = 7},
  [3659] = {.lex_state = 0, .external_lex_state = 7},
  [3660] = {.lex_state = 0, .external_lex_state = 7},
  [3661] = {.lex_state = 0, .external_lex_state = 7},
  [3662] = {.lex_state = 44, .external_lex_state = 7},
  [3663] = {.lex_state = 0, .external_lex_state = 7},
  [3664] = {.lex_state = 0, .external_lex_state = 7},
  [3665] = {.lex_state = 0, .external_lex_state = 7},
  [3666] = {.lex_state = 0, .external_lex_state = 7},
  [3667] = {.lex_state = 0, .external_lex_state = 7},
  [3668] = {.lex_state = 0, .external_lex_state = 7},
  [3669] = {.lex_state = 0, .external_lex_state = 7},
  [3670] = {.lex_state = 0, .external_lex_state = 7},
  [3671] = {.lex_state = 44, .external_lex_state = 7},
  [3672] = {.lex_state = 0, .external_lex_state = 7},
  [3673] = {.lex_state = 0, .external_lex_state = 7},
  [3674] = {.lex_state = 0, .external_lex_state = 7},
  [3675] = {.lex_state = 0, .external_lex_state = 7},
  [3676] = {.lex_state = 0, .external_lex_state = 7},
  [3677] = {.lex_state = 0, .external_lex_state = 7},
  [3678] = {.lex_state = 0, .external_lex_state = 7},
  [3679] = {.lex_state = 45, .external_lex_state = 7},
  [3680] = {.lex_state = 0, .external_lex_state = 7},
  [3681] = {.lex_state = 0, .external_lex_state = 7},
  [3682] = {.lex_state = 0, .external_lex_state = 7},
  [3683] = {.lex_state = 0, .external_lex_state = 7},
  [3684] = {.lex_state = 0, .external_lex_state = 7},
  [3685] = {.lex_state = 0, .external_lex_state = 7},
  [3686] = {.lex_state = 0, .external_lex_state = 7},
  [3687] = {.lex_state = 0, .external_lex_state = 7},
  [3688] = {.lex_state = 44, .external_lex_state = 7},
  [3689] = {.lex_state = 0, .external_lex_state = 7},
  [3690] = {.lex_state = 0, .external_lex_state = 7},
  [3691] = {.lex_state = 0, .external_lex_state = 7},
  [3692] = {.lex_state = 0, .external_lex_state = 6},
  [3693] = {.lex_state = 0, .external_lex_state = 7},
  [3694] = {.lex_state = 0, .external_lex_state = 7},
  [3695] = {.lex_state = 0, .external_lex_state = 7},
  [3696] = {.lex_state = 0, .external_lex_state = 7},
  [3697] = {.lex_state = 45, .external_lex_state = 7},
  [3698] = {.lex_state = 0, .external_lex_state = 7},
  [3699] = {.lex_state = 0, .external_lex_state = 7},
  [3700] = {.lex_state = 0, .external_lex_state = 7},
  [3701] = {.lex_state = 0, .external_lex_state = 7},
  [3702] = {.lex_state = 0, .external_lex_state = 6},
  [3703] = {.lex_state = 0, .external_lex_state = 7},
  [3704] = {.lex_state = 0, .external_lex_state = 7},
  [3705] = {.lex_state = 44, .external_lex_state = 7},
  [3706] = {.lex_state = 0, .external_lex_state = 7},
  [3707] = {.lex_state = 0, .external_lex_state = 7},
  [3708] = {.lex_state = 0, .external_lex_state = 7},
  [3709] = {.lex_state = 0, .external_lex_state = 7},
  [3710] = {.lex_state = 45, .external_lex_state = 7},
  [3711] = {.lex_state = 0, .external_lex_state = 7},
  [3712] = {.lex_state = 0, .external_lex_state = 7},
  [3713] = {.lex_state = 0, .external_lex_state = 7},
  [3714] = {.lex_state = 0, .external_lex_state = 7},
  [3715] = {.lex_state = 0, .external_lex_state = 7},
  [3716] = {.lex_state = 0, .external_lex_state = 7},
  [3717] = {.lex_state = 0, .external_lex_state = 7},
  [3718] = {.lex_state = 44, .external_lex_state = 7},
  [3719] = {.lex_state = 0, .external_lex_state = 7},
  [3720] = {.lex_state = 0, .external_lex_state = 7},
  [3721] = {.lex_state = 44, .external_lex_state = 7},
  [3722] = {.lex_state = 0, .external_lex_state = 7},
  [3723] = {.lex_state = 0, .external_lex_state = 6},
  [3724] = {.lex_state = 0, .external_lex_state = 7},
  [3725] = {.lex_state = 0, .external_lex_state = 7},
  [3726] = {.lex_state = 45, .external_lex_state = 7},
  [3727] = {.lex_state = 0, .external_lex_state = 7},
  [3728] = {.lex_state = 0, .external_lex_state = 7},
  [3729] = {.lex_state = 0, .external_lex_state = 7},
  [3730] = {.lex_state = 0, .external_lex_state = 7},
  [3731] = {.lex_state = 0, .external_lex_state = 7},
  [3732] = {.lex_state = 0, .external_lex_state = 7},
  [3733] = {.lex_state = 0, .external_lex_state = 7},
  [3734] = {.lex_state = 0, .external_lex_state = 7},
  [3735] = {.lex_state = 44, .external_lex_state = 7},
  [3736] = {.lex_state = 0, .external_lex_state = 7},
  [3737] = {.lex_state = 0, .external_lex_state = 7},
  [3738] = {.lex_state = 0, .external_lex_state = 7},
  [3739] = {.lex_state = 0, .external_lex_state = 7},
  [3740] = {.lex_state = 0, .external_lex_state = 7},
  [3741] = {.lex_state = 45, .external_lex_state = 7},
  [3742] = {.lex_state = 0, .external_lex_state = 6},
  [3743] = {.lex_state = 0, .external_lex_state = 7},
  [3744] = {.lex_state = 0, .external_lex_state = 7},
  [3745] = {.lex_state = 0, .external_lex_state = 7},
  [3746] = {.lex_state = 0, .external_lex_state = 7},
  [3747] = {.lex_state = 0, .external_lex_state = 6},
  [3748] = {.lex_state = 0, .external_lex_state = 7},
  [3749] = {.lex_state = 0, .external_lex_state = 7},
  [3750] = {.lex_state = 0, .external_lex_state = 7},
  [3751] = {.lex_state = 0, .external_lex_state = 7},
  [3752] = {.lex_state = 0, .external_lex_state = 7},
  [3753] = {.lex_state = 44, .external_lex_state = 7},
  [3754] = {.lex_state = 0, .external_lex_state = 7},
  [3755] = {.lex_state = 0, .external_lex_state = 7},
  [3756] = {.lex_state = 0, .external_lex_state = 7},
  [3757] = {.lex_state = 0, .external_lex_state = 7},
  [3758] = {.lex_state = 0, .external_lex_state = 7},
  [3759] = {.lex_state = 0, .external_lex_state = 7},
  [3760] = {.lex_state = 44, .external_lex_state = 7},
  [3761] = {.lex_state = 0, .external_lex_state = 7},
  [3762] = {.lex_state = 0, .external_lex_state = 7},
  [3763] = {.lex_state = 0, .external_lex_state = 6},
  [3764] = {.lex_state = 0, .external_lex_state = 7},
  [3765] = {.lex_state = 0, .external_lex_state = 7},
  [3766] = {.lex_state = 45, .external_lex_state = 7},
  [3767] = {.lex_state = 0, .external_lex_state = 7},
  [3768] = {.lex_state = 0, .external_lex_state = 7},
  [3769] = {.lex_state = 0, .external_lex_state = 7},
  [3770] = {.lex_state = 0, .external_lex_state = 7},
  [3771] = {.lex_state = 32, .external_lex_state = 7},
  [3772] = {.lex_state = 0, .external_lex_state = 7},
  [3773] = {.lex_state = 0, .external_lex_state = 7},
  [3774] = {.lex_state = 0, .external_lex_state = 7},
  [3775] = {.lex_state = 0, .external_lex_state = 7},
  [3776] = {.lex_state = 0, .external_lex_state = 7},
  [3777] = {.lex_state = 0, .external_lex_state = 7},
  [3778] = {.lex_state = 0, .external_lex_state = 7},
  [3779] = {.lex_state = 0, .external_lex_state = 7},
  [3780] = {.lex_state = 0, .external_lex_state = 7},
  [3781] = {.lex_state = 0, .external_lex_state = 7},
  [3782] = {.lex_state = 0, .external_lex_state = 7},
  [3783] = {.lex_state = 0, .external_lex_state = 7},
  [3784] = {.lex_state = 0, .external_lex_state = 7},
  [3785] = {.lex_state = 0, .external_lex_state = 7},
  [3786] = {.lex_state = 0, .external_lex_state = 7},
  [3787] = {.lex_state = 0, .external_lex_state = 7},
  [3788] = {.lex_state = 0, .external_lex_state = 7},
  [3789] = {.lex_state = 0, .external_lex_state = 7},
  [3790] = {.lex_state = 0, .external_lex_state = 7},
  [3791] = {.lex_state = 42, .external_lex_state = 7},
  [3792] = {.lex_state = 0, .external_lex_state = 7},
  [3793] = {.lex_state = 0, .external_lex_state = 7},
  [3794] = {.lex_state = 0, .external_lex_state = 7},
  [3795] = {.lex_state = 0, .external_lex_state = 7},
  [3796] = {.lex_state = 0, .external_lex_state = 7},
  [3797] = {.lex_state = 0, .external_lex_state = 7},
  [3798] = {.lex_state = 0, .external_lex_state = 7},
  [3799] = {.lex_state = 0, .external_lex_state = 7},
  [3800] = {.lex_state = 0, .external_lex_state = 7},
  [3801] = {.lex_state = 0, .external_lex_state = 7},
  [3802] = {.lex_state = 0, .external_lex_state = 7},
  [3803] = {.lex_state = 0, .external_lex_state = 7},
  [3804] = {.lex_state = 0, .external_lex_state = 7},
  [3805] = {.lex_state = 0, .external_lex_state = 7},
  [3806] = {.lex_state = 0, .external_lex_state = 7},
  [3807] = {.lex_state = 0, .external_lex_state = 7},
  [3808] = {.lex_state = 0, .external_lex_state = 7},
  [3809] = {.lex_state = 0, .external_lex_state = 7},
  [3810] = {.lex_state = 0, .external_lex_state = 7},
  [3811] = {.lex_state = 0, .external_lex_state = 7},
  [3812] = {.lex_state = 0, .external_lex_state = 7},
  [3813] = {.lex_state = 0, .external_lex_state = 7},
  [3814] = {.lex_state = 0, .external_lex_state = 7},
  [3815] = {.lex_state = 0, .external_lex_state = 7},
  [3816] = {.lex_state = 0, .external_lex_state = 7},
  [3817] = {.lex_state = 0, .external_lex_state = 7},
  [3818] = {.lex_state = 0, .external_lex_state = 7},
  [3819] = {.lex_state = 0, .external_lex_state = 7},
  [3820] = {.lex_state = 0, .external_lex_state = 7},
  [3821] = {.lex_state = 0, .external_lex_state = 7},
  [3822] = {.lex_state = 0, .external_lex_state = 7},
  [3823] = {.lex_state = 0, .external_lex_state = 7},
  [3824] = {.lex_state = 0, .external_lex_state = 7},
  [3825] = {.lex_state = 0, .external_lex_state = 7},
  [3826] = {.lex_state = 0, .external_lex_state = 7},
  [3827] = {.lex_state = 0, .external_lex_state = 7},
  [3828] = {.lex_state = 0, .external_lex_state = 7},
  [3829] = {.lex_state = 0, .external_lex_state = 7},
  [3830] = {.lex_state = 0, .external_lex_state = 7},
  [3831] = {.lex_state = 0, .external_lex_state = 7},
  [3832] = {.lex_state = 0, .external_lex_state = 7},
  [3833] = {.lex_state = 0, .external_lex_state = 7},
  [3834] = {.lex_state = 0, .external_lex_state = 7},
  [3835] = {.lex_state = 0, .external_lex_state = 7},
  [3836] = {.lex_state = 0, .external_lex_state = 7},
  [3837] = {.lex_state = 0, .external_lex_state = 7},
  [3838] = {.lex_state = 0, .external_lex_state = 7},
  [3839] = {.lex_state = 0, .external_lex_state = 7},
  [3840] = {.lex_state = 0, .external_lex_state = 7},
  [3841] = {.lex_state = 0, .external_lex_state = 7},
  [3842] = {.lex_state = 0, .external_lex_state = 7},
  [3843] = {.lex_state = 0, .external_lex_state = 7},
  [3844] = {.lex_state = 0, .external_lex_state = 7},
  [3845] = {.lex_state = 0, .external_lex_state = 7},
  [3846] = {.lex_state = 0, .external_lex_state = 7},
  [3847] = {.lex_state = 0, .external_lex_state = 7},
  [3848] = {.lex_state = 0, .external_lex_state = 7},
  [3849] = {.lex_state = 0, .external_lex_state = 7},
  [3850] = {.lex_state = 0, .external_lex_state = 7},
  [3851] = {.lex_state = 0, .external_lex_state = 7},
  [3852] = {.lex_state = 0, .external_lex_state = 7},
  [3853] = {.lex_state = 0, .external_lex_state = 7},
  [3854] = {.lex_state = 0, .external_lex_state = 7},
  [3855] = {.lex_state = 0, .external_lex_state = 7},
  [3856] = {.lex_state = 0, .external_lex_state = 7},
  [3857] = {.lex_state = 0, .external_lex_state = 7},
  [3858] = {.lex_state = 0, .external_lex_state = 7},
  [3859] = {.lex_state = 0, .external_lex_state = 7},
  [3860] = {.lex_state = 0, .external_lex_state = 7},
  [3861] = {.lex_state = 0, .external_lex_state = 7},
  [3862] = {.lex_state = 0, .external_lex_state = 7},
  [3863] = {.lex_state = 0, .external_lex_state = 7},
  [3864] = {.lex_state = 0, .external_lex_state = 7},
  [3865] = {.lex_state = 0, .external_lex_state = 7},
  [3866] = {.lex_state = 0, .external_lex_state = 7},
  [3867] = {.lex_state = 0, .external_lex_state = 7},
  [3868] = {.lex_state = 0, .external_lex_state = 7},
  [3869] = {.lex_state = 0, .external_lex_state = 7},
  [3870] = {.lex_state = 0, .external_lex_state = 7},
  [3871] = {.lex_state = 0, .external_lex_state = 7},
  [3872] = {.lex_state = 0, .external_lex_state = 7},
  [3873] = {.lex_state = 0, .external_lex_state = 7},
  [3874] = {.lex_state = 0, .external_lex_state = 7},
  [3875] = {.lex_state = 0, .external_lex_state = 7},
  [3876] = {.lex_state = 0, .external_lex_state = 7},
  [3877] = {.lex_state = 0, .external_lex_state = 7},
  [3878] = {.lex_state = 0, .external_lex_state = 7},
  [3879] = {.lex_state = 0, .external_lex_state = 7},
  [3880] = {.lex_state = 0, .external_lex_state = 7},
  [3881] = {.lex_state = 0, .external_lex_state = 7},
  [3882] = {.lex_state = 0, .external_lex_state = 7},
  [3883] = {.lex_state = 0, .external_lex_state = 7},
  [3884] = {.lex_state = 0, .external_lex_state = 7},
  [3885] = {.lex_state = 0, .external_lex_state = 7},
  [3886] = {.lex_state = 0, .external_lex_state = 7},
  [3887] = {.lex_state = 0, .external_lex_state = 7},
  [3888] = {.lex_state = 0, .external_lex_state = 7},
  [3889] = {.lex_state = 0, .external_lex_state = 7},
  [3890] = {.lex_state = 0, .external_lex_state = 7},
  [3891] = {.lex_state = 0, .external_lex_state = 7},
  [3892] = {.lex_state = 0, .external_lex_state = 7},
  [3893] = {.lex_state = 0, .external_lex_state = 7},
  [3894] = {.lex_state = 0, .external_lex_state = 7},
  [3895] = {.lex_state = 0, .external_lex_state = 7},
  [3896] = {.lex_state = 0, .external_lex_state = 7},
  [3897] = {.lex_state = 0, .external_lex_state = 7},
  [3898] = {.lex_state = 0, .external_lex_state = 7},
  [3899] = {.lex_state = 0, .external_lex_state = 7},
  [3900] = {.lex_state = 0, .external_lex_state = 7},
  [3901] = {.lex_state = 0, .external_lex_state = 7},
  [3902] = {.lex_state = 0, .external_lex_state = 7},
  [3903] = {.lex_state = 0, .external_lex_state = 7},
  [3904] = {.lex_state = 0, .external_lex_state = 7},
  [3905] = {.lex_state = 0, .external_lex_state = 7},
  [3906] = {.lex_state = 0, .external_lex_state = 7},
  [3907] = {.lex_state = 0, .external_lex_state = 7},
  [3908] = {.lex_state = 0, .external_lex_state = 7},
  [3909] = {.lex_state = 0, .external_lex_state = 7},
  [3910] = {.lex_state = 0, .external_lex_state = 7},
  [3911] = {.lex_state = 0, .external_lex_state = 7},
  [3912] = {.lex_state = 0, .external_lex_state = 7},
  [3913] = {.lex_state = 0, .external_lex_state = 7},
  [3914] = {.lex_state = 32, .external_lex_state = 7},
  [3915] = {.lex_state = 0, .external_lex_state = 7},
  [3916] = {.lex_state = 0, .external_lex_state = 7},
  [3917] = {.lex_state = 32, .external_lex_state = 7},
  [3918] = {.lex_state = 0, .external_lex_state = 7},
  [3919] = {.lex_state = 0, .external_lex_state = 7},
  [3920] = {.lex_state = 0, .external_lex_state = 7},
  [3921] = {.lex_state = 0, .external_lex_state = 7},
  [3922] = {.lex_state = 0, .external_lex_state = 7},
  [3923] = {.lex_state = 0, .external_lex_state = 7},
  [3924] = {.lex_state = 0, .external_lex_state = 7},
  [3925] = {.lex_state = 0, .external_lex_state = 7},
  [3926] = {.lex_state = 0, .external_lex_state = 7},
  [3927] = {.lex_state = 0, .external_lex_state = 7},
  [3928] = {.lex_state = 0, .external_lex_state = 7},
  [3929] = {.lex_state = 0, .external_lex_state = 7},
  [3930] = {.lex_state = 0, .external_lex_state = 7},
  [3931] = {.lex_state = 0, .external_lex_state = 7},
  [3932] = {.lex_state = 0, .external_lex_state = 7},
  [3933] = {.lex_state = 0, .external_lex_state = 7},
  [3934] = {.lex_state = 0, .external_lex_state = 7},
  [3935] = {.lex_state = 0, .external_lex_state = 7},
  [3936] = {.lex_state = 0, .external_lex_state = 7},
  [3937] = {.lex_state = 0, .external_lex_state = 7},
  [3938] = {.lex_state = 32, .external_lex_state = 7},
  [3939] = {.lex_state = 0, .external_lex_state = 7},
  [3940] = {.lex_state = 0, .external_lex_state = 7},
  [3941] = {.lex_state = 0, .external_lex_state = 7},
  [3942] = {.lex_state = 0, .external_lex_state = 7},
  [3943] = {.lex_state = 0, .external_lex_state = 7},
  [3944] = {.lex_state = 0, .external_lex_state = 7},
  [3945] = {.lex_state = 0, .external_lex_state = 7},
  [3946] = {.lex_state = 0, .external_lex_state = 7},
  [3947] = {.lex_state = 0, .external_lex_state = 7},
  [3948] = {.lex_state = 0, .external_lex_state = 7},
  [3949] = {.lex_state = 0, .external_lex_state = 7},
  [3950] = {.lex_state = 0, .external_lex_state = 7},
  [3951] = {.lex_state = 0, .external_lex_state = 7},
  [3952] = {.lex_state = 0, .external_lex_state = 7},
  [3953] = {.lex_state = 0, .external_lex_state = 7},
  [3954] = {.lex_state = 0, .external_lex_state = 7},
  [3955] = {.lex_state = 0, .external_lex_state = 7},
  [3956] = {.lex_state = 0, .external_lex_state = 7},
  [3957] = {.lex_state = 0, .external_lex_state = 7},
  [3958] = {.lex_state = 0, .external_lex_state = 7},
  [3959] = {.lex_state = 0, .external_lex_state = 7},
  [3960] = {.lex_state = 0, .external_lex_state = 7},
  [3961] = {.lex_state = 0, .external_lex_state = 7},
  [3962] = {.lex_state = 0, .external_lex_state = 7},
  [3963] = {.lex_state = 0, .external_lex_state = 7},
  [3964] = {.lex_state = 0, .external_lex_state = 7},
  [3965] = {.lex_state = 0, .external_lex_state = 7},
  [3966] = {.lex_state = 0, .external_lex_state = 7},
  [3967] = {.lex_state = 0, .external_lex_state = 6},
  [3968] = {.lex_state = 0, .external_lex_state = 7},
  [3969] = {.lex_state = 0, .external_lex_state = 7},
  [3970] = {.lex_state = 0, .external_lex_state = 7},
  [3971] = {.lex_state = 0, .external_lex_state = 7},
  [3972] = {.lex_state = 0, .external_lex_state = 7},
  [3973] = {.lex_state = 0, .external_lex_state = 7},
  [3974] = {.lex_state = 0, .external_lex_state = 7},
  [3975] = {.lex_state = 0, .external_lex_state = 7},
  [3976] = {.lex_state = 0, .external_lex_state = 7},
  [3977] = {.lex_state = 0, .external_lex_state = 7},
  [3978] = {.lex_state = 0, .external_lex_state = 7},
  [3979] = {.lex_state = 0, .external_lex_state = 7},
  [3980] = {.lex_state = 0, .external_lex_state = 7},
  [3981] = {.lex_state = 0, .external_lex_state = 7},
  [3982] = {.lex_state = 0, .external_lex_state = 7},
  [3983] = {.lex_state = 0, .external_lex_state = 7},
  [3984] = {.lex_state = 0, .external_lex_state = 7},
  [3985] = {.lex_state = 0, .external_lex_state = 7},
  [3986] = {.lex_state = 0, .external_lex_state = 7},
  [3987] = {.lex_state = 0, .external_lex_state = 7},
  [3988] = {.lex_state = 0, .external_lex_state = 7},
  [3989] = {.lex_state = 0, .external_lex_state = 7},
  [3990] = {.lex_state = 0, .external_lex_state = 7},
  [3991] = {.lex_state = 0, .external_lex_state = 7},
  [3992] = {.lex_state = 0, .external_lex_state = 7},
  [3993] = {.lex_state = 0, .external_lex_state = 7},
  [3994] = {.lex_state = 0, .external_lex_state = 7},
  [3995] = {.lex_state = 0, .external_lex_state = 7},
  [3996] = {.lex_state = 0, .external_lex_state = 7},
  [3997] = {.lex_state = 0, .external_lex_state = 7},
  [3998] = {.lex_state = 0, .external_lex_state = 7},
  [3999] = {.lex_state = 0, .external_lex_state = 7},
  [4000] = {.lex_state = 0, .external_lex_state = 7},
  [4001] = {.lex_state = 0, .external_lex_state = 7},
  [4002] = {.lex_state = 0, .external_lex_state = 7},
  [4003] = {.lex_state = 0, .external_lex_state = 7},
  [4004] = {.lex_state = 0, .external_lex_state = 7},
  [4005] = {.lex_state = 0, .external_lex_state = 7},
  [4006] = {.lex_state = 0, .external_lex_state = 7},
  [4007] = {.lex_state = 0, .external_lex_state = 7},
  [4008] = {.lex_state = 0, .external_lex_state = 7},
  [4009] = {.lex_state = 0, .external_lex_state = 7},
  [4010] = {.lex_state = 0, .external_lex_state = 7},
  [4011] = {.lex_state = 0, .external_lex_state = 7},
  [4012] = {.lex_state = 0, .external_lex_state = 7},
  [4013] = {.lex_state = 0, .external_lex_state = 7},
  [4014] = {.lex_state = 0, .external_lex_state = 7},
  [4015] = {.lex_state = 0, .external_lex_state = 7},
  [4016] = {.lex_state = 0, .external_lex_state = 7},
  [4017] = {.lex_state = 0, .external_lex_state = 7},
  [4018] = {.lex_state = 0, .external_lex_state = 7},
  [4019] = {.lex_state = 0, .external_lex_state = 7},
  [4020] = {.lex_state = 0, .external_lex_state = 7},
  [4021] = {.lex_state = 0, .external_lex_state = 7},
  [4022] = {.lex_state = 0, .external_lex_state = 7},
  [4023] = {.lex_state = 0, .external_lex_state = 7},
  [4024] = {.lex_state = 0, .external_lex_state = 7},
  [4025] = {.lex_state = 0, .external_lex_state = 7},
  [4026] = {.lex_state = 0, .external_lex_state = 7},
  [4027] = {.lex_state = 0, .external_lex_state = 7},
  [4028] = {.lex_state = 0, .external_lex_state = 7},
  [4029] = {.lex_state = 0, .external_lex_state = 7},
  [4030] = {.lex_state = 0, .external_lex_state = 7},
  [4031] = {.lex_state = 0, .external_lex_state = 7},
  [4032] = {.lex_state = 0, .external_lex_state = 7},
  [4033] = {.lex_state = 0, .external_lex_state = 7},
  [4034] = {.lex_state = 0, .external_lex_state = 7},
  [4035] = {.lex_state = 0, .external_lex_state = 7},
  [4036] = {.lex_state = 0, .external_lex_state = 7},
  [4037] = {.lex_state = 0, .external_lex_state = 7},
  [4038] = {.lex_state = 0, .external_lex_state = 7},
  [4039] = {.lex_state = 0, .external_lex_state = 7},
  [4040] = {.lex_state = 0, .external_lex_state = 7},
  [4041] = {.lex_state = 0, .external_lex_state = 7},
  [4042] = {.lex_state = 0, .external_lex_state = 7},
  [4043] = {.lex_state = 0, .external_lex_state = 7},
  [4044] = {.lex_state = 0, .external_lex_state = 7},
  [4045] = {.lex_state = 0, .external_lex_state = 7},
  [4046] = {.lex_state = 0, .external_lex_state = 7},
  [4047] = {.lex_state = 0, .external_lex_state = 7},
  [4048] = {.lex_state = 0, .external_lex_state = 7},
  [4049] = {.lex_state = 0, .external_lex_state = 7},
  [4050] = {.lex_state = 0, .external_lex_state = 7},
  [4051] = {.lex_state = 0, .external_lex_state = 7},
  [4052] = {.lex_state = 0, .external_lex_state = 7},
  [4053] = {.lex_state = 0, .external_lex_state = 7},
  [4054] = {.lex_state = 0, .external_lex_state = 7},
  [4055] = {.lex_state = 0, .external_lex_state = 7},
  [4056] = {.lex_state = 0, .external_lex_state = 7},
  [4057] = {.lex_state = 32, .external_lex_state = 7},
  [4058] = {.lex_state = 0, .external_lex_state = 7},
  [4059] = {.lex_state = 0, .external_lex_state = 7},
  [4060] = {.lex_state = 32, .external_lex_state = 7},
  [4061] = {.lex_state = 0, .external_lex_state = 7},
  [4062] = {.lex_state = 0, .external_lex_state = 7},
  [4063] = {.lex_state = 0, .external_lex_state = 7},
  [4064] = {.lex_state = 0, .external_lex_state = 7},
  [4065] = {.lex_state = 0, .external_lex_state = 7},
  [4066] = {.lex_state = 0, .external_lex_state = 7},
  [4067] = {.lex_state = 0, .external_lex_state = 7},
  [4068] = {.lex_state = 0, .external_lex_state = 7},
  [4069] = {.lex_state = 0, .external_lex_state = 7},
  [4070] = {.lex_state = 0, .external_lex_state = 7},
  [4071] = {.lex_state = 0, .external_lex_state = 7},
  [4072] = {.lex_state = 0, .external_lex_state = 7},
  [4073] = {.lex_state = 0, .external_lex_state = 7},
  [4074] = {.lex_state = 0, .external_lex_state = 7},
  [4075] = {.lex_state = 0, .external_lex_state = 7},
  [4076] = {.lex_state = 0, .external_lex_state = 7},
  [4077] = {.lex_state = 0, .external_lex_state = 7},
  [4078] = {.lex_state = 0, .external_lex_state = 7},
  [4079] = {.lex_state = 0, .external_lex_state = 7},
  [4080] = {.lex_state = 0, .external_lex_state = 7},
  [4081] = {.lex_state = 0, .external_lex_state = 7},
  [4082] = {.lex_state = 0, .external_lex_state = 7},
  [4083] = {.lex_state = 0, .external_lex_state = 7},
  [4084] = {.lex_state = 0, .external_lex_state = 7},
  [4085] = {.lex_state = 0, .external_lex_state = 7},
  [4086] = {.lex_state = 0, .external_lex_state = 7},
  [4087] = {.lex_state = 0, .external_lex_state = 7},
  [4088] = {.lex_state = 0, .external_lex_state = 7},
  [4089] = {.lex_state = 0, .external_lex_state = 7},
  [4090] = {.lex_state = 32, .external_lex_state = 7},
  [4091] = {.lex_state = 0, .external_lex_state = 7},
  [4092] = {.lex_state = 0, .external_lex_state = 7},
  [4093] = {.lex_state = 32, .external_lex_state = 7},
  [4094] = {.lex_state = 0, .external_lex_state = 7},
  [4095] = {.lex_state = 0, .external_lex_state = 7},
  [4096] = {.lex_state = 0, .external_lex_state = 7},
  [4097] = {.lex_state = 0, .external_lex_state = 7},
  [4098] = {.lex_state = 0, .external_lex_state = 7},
  [4099] = {.lex_state = 0, .external_lex_state = 7},
  [4100] = {.lex_state = 0, .external_lex_state = 7},
  [4101] = {.lex_state = 0, .external_lex_state = 7},
  [4102] = {.lex_state = 0, .external_lex_state = 7},
  [4103] = {.lex_state = 0, .external_lex_state = 7},
  [4104] = {.lex_state = 0, .external_lex_state = 7},
  [4105] = {.lex_state = 0, .external_lex_state = 7},
  [4106] = {.lex_state = 0, .external_lex_state = 7},
  [4107] = {.lex_state = 0, .external_lex_state = 7},
  [4108] = {.lex_state = 0, .external_lex_state = 7},
  [4109] = {.lex_state = 0, .external_lex_state = 7},
  [4110] = {.lex_state = 0, .external_lex_state = 7},
  [4111] = {.lex_state = 0, .external_lex_state = 7},
  [4112] = {.lex_state = 0, .external_lex_state = 7},
  [4113] = {.lex_state = 0, .external_lex_state = 7},
  [4114] = {.lex_state = 0, .external_lex_state = 7},
  [4115] = {.lex_state = 0, .external_lex_state = 7},
  [4116] = {.lex_state = 0, .external_lex_state = 7},
  [4117] = {.lex_state = 0, .external_lex_state = 7},
  [4118] = {.lex_state = 0, .external_lex_state = 7},
  [4119] = {.lex_state = 0, .external_lex_state = 7},
  [4120] = {.lex_state = 32, .external_lex_state = 7},
  [4121] = {.lex_state = 0, .external_lex_state = 7},
  [4122] = {.lex_state = 0, .external_lex_state = 7},
  [4123] = {.lex_state = 32, .external_lex_state = 7},
  [4124] = {.lex_state = 0, .external_lex_state = 7},
  [4125] = {.lex_state = 0, .external_lex_state = 7},
  [4126] = {.lex_state = 0, .external_lex_state = 7},
  [4127] = {.lex_state = 0, .external_lex_state = 7},
  [4128] = {.lex_state = 0, .external_lex_state = 7},
  [4129] = {.lex_state = 0, .external_lex_state = 7},
  [4130] = {.lex_state = 0, .external_lex_state = 7},
  [4131] = {.lex_state = 0, .external_lex_state = 7},
  [4132] = {.lex_state = 0, .external_lex_state = 7},
  [4133] = {.lex_state = 0, .external_lex_state = 7},
  [4134] = {.lex_state = 0, .external_lex_state = 7},
  [4135] = {.lex_state = 0, .external_lex_state = 7},
  [4136] = {.lex_state = 0, .external_lex_state = 7},
  [4137] = {.lex_state = 0, .external_lex_state = 7},
  [4138] = {.lex_state = 0, .external_lex_state = 7},
  [4139] = {.lex_state = 0, .external_lex_state = 7},
  [4140] = {.lex_state = 0, .external_lex_state = 7},
  [4141] = {.lex_state = 0, .external_lex_state = 7},
  [4142] = {.lex_state = 0, .external_lex_state = 7},
  [4143] = {.lex_state = 0, .external_lex_state = 7},
  [4144] = {.lex_state = 0, .external_lex_state = 7},
  [4145] = {.lex_state = 0, .external_lex_state = 7},
  [4146] = {.lex_state = 0, .external_lex_state = 7},
  [4147] = {.lex_state = 0, .external_lex_state = 7},
  [4148] = {.lex_state = 0, .external_lex_state = 7},
  [4149] = {.lex_state = 0, .external_lex_state = 7},
  [4150] = {.lex_state = 32, .external_lex_state = 7},
  [4151] = {.lex_state = 0, .external_lex_state = 7},
  [4152] = {.lex_state = 0, .external_lex_state = 7},
  [4153] = {.lex_state = 32, .external_lex_state = 7},
  [4154] = {.lex_state = 0, .external_lex_state = 7},
  [4155] = {.lex_state = 0, .external_lex_state = 7},
  [4156] = {.lex_state = 0, .external_lex_state = 7},
  [4157] = {.lex_state = 0, .external_lex_state = 7},
  [4158] = {.lex_state = 0, .external_lex_state = 7},
  [4159] = {.lex_state = 0, .external_lex_state = 7},
  [4160] = {.lex_state = 0, .external_lex_state = 7},
  [4161] = {.lex_state = 0, .external_lex_state = 7},
  [4162] = {.lex_state = 0, .external_lex_state = 7},
  [4163] = {.lex_state = 0, .external_lex_state = 7},
  [4164] = {.lex_state = 0, .external_lex_state = 7},
  [4165] = {.lex_state = 0, .external_lex_state = 7},
  [4166] = {.lex_state = 0, .external_lex_state = 7},
  [4167] = {.lex_state = 0, .external_lex_state = 7},
  [4168] = {.lex_state = 0, .external_lex_state = 7},
  [4169] = {.lex_state = 0, .external_lex_state = 7},
  [4170] = {.lex_state = 0, .external_lex_state = 7},
  [4171] = {.lex_state = 0, .external_lex_state = 7},
  [4172] = {.lex_state = 0, .external_lex_state = 7},
  [4173] = {.lex_state = 0, .external_lex_state = 7},
  [4174] = {.lex_state = 0, .external_lex_state = 7},
  [4175] = {.lex_state = 0, .external_lex_state = 7},
  [4176] = {.lex_state = 0, .external_lex_state = 7},
  [4177] = {.lex_state = 0, .external_lex_state = 7},
  [4178] = {.lex_state = 0, .external_lex_state = 7},
  [4179] = {.lex_state = 0, .external_lex_state = 7},
  [4180] = {.lex_state = 32, .external_lex_state = 7},
  [4181] = {.lex_state = 0, .external_lex_state = 7},
  [4182] = {.lex_state = 0, .external_lex_state = 7},
  [4183] = {.lex_state = 32, .external_lex_state = 7},
  [4184] = {.lex_state = 0, .external_lex_state = 7},
  [4185] = {.lex_state = 0, .external_lex_state = 7},
  [4186] = {.lex_state = 0, .external_lex_state = 7},
  [4187] = {.lex_state = 0, .external_lex_state = 7},
  [4188] = {.lex_state = 0, .external_lex_state = 7},
  [4189] = {.lex_state = 0, .external_lex_state = 7},
  [4190] = {.lex_state = 0, .external_lex_state = 7},
  [4191] = {.lex_state = 0, .external_lex_state = 7},
  [4192] = {.lex_state = 0, .external_lex_state = 7},
  [4193] = {.lex_state = 0, .external_lex_state = 7},
  [4194] = {.lex_state = 0, .external_lex_state = 7},
  [4195] = {.lex_state = 0, .external_lex_state = 7},
  [4196] = {.lex_state = 0, .external_lex_state = 7},
  [4197] = {.lex_state = 0, .external_lex_state = 7},
  [4198] = {.lex_state = 0, .external_lex_state = 7},
  [4199] = {.lex_state = 0, .external_lex_state = 7},
  [4200] = {.lex_state = 0, .external_lex_state = 7},
  [4201] = {.lex_state = 0, .external_lex_state = 7},
  [4202] = {.lex_state = 0, .external_lex_state = 7},
  [4203] = {.lex_state = 0, .external_lex_state = 7},
  [4204] = {.lex_state = 0, .external_lex_state = 7},
  [4205] = {.lex_state = 0, .external_lex_state = 7},
  [4206] = {.lex_state = 0, .external_lex_state = 7},
  [4207] = {.lex_state = 0, .external_lex_state = 7},
  [4208] = {.lex_state = 0, .external_lex_state = 7},
  [4209] = {.lex_state = 0, .external_lex_state = 7},
  [4210] = {.lex_state = 32, .external_lex_state = 7},
  [4211] = {.lex_state = 0, .external_lex_state = 7},
  [4212] = {.lex_state = 0, .external_lex_state = 7},
  [4213] = {.lex_state = 32, .external_lex_state = 7},
  [4214] = {.lex_state = 0, .external_lex_state = 7},
  [4215] = {.lex_state = 0, .external_lex_state = 7},
  [4216] = {.lex_state = 0, .external_lex_state = 7},
  [4217] = {.lex_state = 0, .external_lex_state = 7},
  [4218] = {.lex_state = 0, .external_lex_state = 7},
  [4219] = {.lex_state = 0, .external_lex_state = 7},
  [4220] = {.lex_state = 0, .external_lex_state = 7},
  [4221] = {.lex_state = 0, .external_lex_state = 7},
  [4222] = {.lex_state = 0, .external_lex_state = 7},
  [4223] = {.lex_state = 0, .external_lex_state = 7},
  [4224] = {.lex_state = 0, .external_lex_state = 7},
  [4225] = {.lex_state = 0, .external_lex_state = 7},
  [4226] = {.lex_state = 0, .external_lex_state = 7},
  [4227] = {.lex_state = 0, .external_lex_state = 7},
  [4228] = {.lex_state = 0, .external_lex_state = 7},
  [4229] = {.lex_state = 0, .external_lex_state = 7},
  [4230] = {.lex_state = 0, .external_lex_state = 7},
  [4231] = {.lex_state = 0, .external_lex_state = 7},
  [4232] = {.lex_state = 0, .external_lex_state = 7},
  [4233] = {.lex_state = 0, .external_lex_state = 7},
  [4234] = {.lex_state = 0, .external_lex_state = 7},
  [4235] = {.lex_state = 0, .external_lex_state = 7},
  [4236] = {.lex_state = 0, .external_lex_state = 7},
  [4237] = {.lex_state = 0, .external_lex_state = 7},
  [4238] = {.lex_state = 0, .external_lex_state = 7},
  [4239] = {.lex_state = 0, .external_lex_state = 7},
  [4240] = {.lex_state = 0, .external_lex_state = 7},
  [4241] = {.lex_state = 0, .external_lex_state = 7},
  [4242] = {.lex_state = 0, .external_lex_state = 7},
  [4243] = {.lex_state = 0, .external_lex_state = 7},
  [4244] = {.lex_state = 0, .external_lex_state = 7},
  [4245] = {.lex_state = 0, .external_lex_state = 7},
  [4246] = {.lex_state = 0, .external_lex_state = 7},
  [4247] = {.lex_state = 0, .external_lex_state = 7},
  [4248] = {.lex_state = 0, .external_lex_state = 7},
  [4249] = {.lex_state = 0, .external_lex_state = 7},
  [4250] = {.lex_state = 0, .external_lex_state = 7},
  [4251] = {.lex_state = 0, .external_lex_state = 7},
  [4252] = {.lex_state = 0, .external_lex_state = 7},
  [4253] = {.lex_state = 0, .external_lex_state = 7},
  [4254] = {.lex_state = 0, .external_lex_state = 7},
  [4255] = {.lex_state = 0, .external_lex_state = 7},
  [4256] = {.lex_state = 0, .external_lex_state = 7},
  [4257] = {.lex_state = 0, .external_lex_state = 7},
  [4258] = {.lex_state = 0, .external_lex_state = 7},
  [4259] = {.lex_state = 0, .external_lex_state = 7},
  [4260] = {.lex_state = 0, .external_lex_state = 7},
  [4261] = {.lex_state = 0, .external_lex_state = 7},
  [4262] = {.lex_state = 0, .external_lex_state = 7},
  [4263] = {.lex_state = 0, .external_lex_state = 7},
  [4264] = {.lex_state = 0, .external_lex_state = 7},
  [4265] = {.lex_state = 0, .external_lex_state = 7},
  [4266] = {.lex_state = 0, .external_lex_state = 7},
  [4267] = {.lex_state = 0, .external_lex_state = 7},
  [4268] = {.lex_state = 0, .external_lex_state = 7},
  [4269] = {.lex_state = 0, .external_lex_state = 7},
  [4270] = {.lex_state = 0, .external_lex_state = 7},
  [4271] = {.lex_state = 0, .external_lex_state = 7},
  [4272] = {.lex_state = 0, .external_lex_state = 7},
  [4273] = {.lex_state = 0, .external_lex_state = 7},
  [4274] = {.lex_state = 0, .external_lex_state = 7},
  [4275] = {.lex_state = 0, .external_lex_state = 7},
  [4276] = {.lex_state = 0, .external_lex_state = 7},
  [4277] = {.lex_state = 0, .external_lex_state = 7},
  [4278] = {.lex_state = 0, .external_lex_state = 7},
  [4279] = {.lex_state = 0, .external_lex_state = 7},
  [4280] = {.lex_state = 0, .external_lex_state = 7},
  [4281] = {.lex_state = 0, .external_lex_state = 7},
  [4282] = {.lex_state = 0, .external_lex_state = 7},
  [4283] = {.lex_state = 0, .external_lex_state = 7},
  [4284] = {.lex_state = 0, .external_lex_state = 7},
  [4285] = {.lex_state = 0, .external_lex_state = 7},
  [4286] = {.lex_state = 0, .external_lex_state = 7},
  [4287] = {.lex_state = 0, .external_lex_state = 7},
  [4288] = {.lex_state = 0, .external_lex_state = 7},
  [4289] = {.lex_state = 0, .external_lex_state = 7},
  [4290] = {.lex_state = 0, .external_lex_state = 7},
  [4291] = {.lex_state = 0, .external_lex_state = 7},
  [4292] = {.lex_state = 0, .external_lex_state = 7},
  [4293] = {.lex_state = 0, .external_lex_state = 7},
  [4294] = {.lex_state = 0, .external_lex_state = 7},
  [4295] = {.lex_state = 0, .external_lex_state = 7},
  [4296] = {.lex_state = 0, .external_lex_state = 7},
  [4297] = {.lex_state = 0, .external_lex_state = 7},
  [4298] = {.lex_state = 0, .external_lex_state = 7},
  [4299] = {.lex_state = 0, .external_lex_state = 7},
  [4300] = {.lex_state = 0, .external_lex_state = 7},
  [4301] = {.lex_state = 0, .external_lex_state = 7},
  [4302] = {.lex_state = 0, .external_lex_state = 7},
  [4303] = {.lex_state = 0, .external_lex_state = 7},
  [4304] = {.lex_state = 0, .external_lex_state = 7},
  [4305] = {.lex_state = 0, .external_lex_state = 7},
  [4306] = {.lex_state = 0, .external_lex_state = 7},
  [4307] = {.lex_state = 0, .external_lex_state = 7},
  [4308] = {.lex_state = 0, .external_lex_state = 7},
  [4309] = {.lex_state = 0, .external_lex_state = 7},
  [4310] = {.lex_state = 0, .external_lex_state = 7},
  [4311] = {.lex_state = 0, .external_lex_state = 7},
  [4312] = {.lex_state = 0, .external_lex_state = 7},
  [4313] = {.lex_state = 0, .external_lex_state = 7},
  [4314] = {.lex_state = 0, .external_lex_state = 7},
  [4315] = {.lex_state = 0, .external_lex_state = 7},
  [4316] = {.lex_state = 0, .external_lex_state = 7},
  [4317] = {.lex_state = 0, .external_lex_state = 7},
  [4318] = {.lex_state = 0, .external_lex_state = 7},
  [4319] = {.lex_state = 0, .external_lex_state = 7},
  [4320] = {.lex_state = 0, .external_lex_state = 7},
  [4321] = {.lex_state = 0, .external_lex_state = 7},
  [4322] = {.lex_state = 0, .external_lex_state = 7},
  [4323] = {.lex_state = 0, .external_lex_state = 7},
  [4324] = {.lex_state = 0, .external_lex_state = 7},
  [4325] = {.lex_state = 0, .external_lex_state = 7},
};

enum {
  ts_external_token_block_comment = 0,
  ts_external_token__immediate_paren = 1,
  ts_external_token__string_start = 2,
  ts_external_token__command_start = 3,
  ts_external_token__immediate_string_start = 4,
  ts_external_token__immediate_command_start = 5,
  ts_external_token__string_end = 6,
  ts_external_token__command_end = 7,
  ts_external_token__string_content = 8,
  ts_external_token__string_content_no_interp = 9,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_block_comment] = sym_block_comment,
  [ts_external_token__immediate_paren] = sym__immediate_paren,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__command_start] = sym__command_start,
  [ts_external_token__immediate_string_start] = sym__immediate_string_start,
  [ts_external_token__immediate_command_start] = sym__immediate_command_start,
  [ts_external_token__string_end] = sym__string_end,
  [ts_external_token__command_end] = sym__command_end,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_content_no_interp] = sym__string_content_no_interp,
};

static const bool ts_external_scanner_states[12][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__command_end] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_content_no_interp] = true,
  },
  [2] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
  },
  [3] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [4] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__command_start] = true,
  },
  [5] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [6] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__immediate_paren] = true,
  },
  [7] = {
    [ts_external_token_block_comment] = true,
  },
  [8] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__command_end] = true,
    [ts_external_token__string_content] = true,
  },
  [9] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__string_content] = true,
  },
  [10] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token__string_content_no_interp] = true,
  },
  [11] = {
    [ts_external_token_block_comment] = true,
    [ts_external_token__command_end] = true,
    [ts_external_token__string_content_no_interp] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_primitive] = ACTIONS(1),
    [aux_sym_primitive_definition_token1] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_macro] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LT_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [sym_continue_statement] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LT_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_GT] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_isa] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(1),
    [anon_sym_] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [aux_sym_integer_literal_token1] = ACTIONS(1),
    [aux_sym_integer_literal_token2] = ACTIONS(1),
    [aux_sym_integer_literal_token3] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym__unary_operator] = ACTIONS(1),
    [sym__power_operator] = ACTIONS(1),
    [sym__bitshift_operator] = ACTIONS(1),
    [sym__rational_operator] = ACTIONS(1),
    [sym__times_operator] = ACTIONS(1),
    [sym__plus_operator] = ACTIONS(1),
    [sym__dotty_operator] = ACTIONS(1),
    [sym__comparison_operator] = ACTIONS(1),
    [sym__arrow_operator] = ACTIONS(1),
    [sym__assign_operator] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__command_start] = ACTIONS(1),
    [sym__immediate_string_start] = ACTIONS(1),
    [sym__immediate_command_start] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [sym__command_end] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_content_no_interp] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(4202),
    [sym__expression_list] = STATE(4199),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2598),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2836),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2954),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [2] = {
    [sym__expression_list] = STATE(3636),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_type_argument_list] = STATE(1975),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(89),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_finally] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(103),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [sym__arrow_operator] = ACTIONS(85),
    [sym__assign_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(113),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
    [sym__immediate_string_start] = ACTIONS(117),
    [sym__immediate_command_start] = ACTIONS(119),
  },
  [3] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1068),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_macro_argument_list] = STATE(2153),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [aux_sym_macro_argument_list_repeat1] = STATE(5),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_COMMA] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(125),
    [anon_sym_SEMI] = ACTIONS(125),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_LT_COLON] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_elseif] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_catch] = ACTIONS(125),
    [anon_sym_finally] = ACTIONS(125),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(165),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(125),
    [anon_sym_PIPE_GT] = ACTIONS(125),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(125),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_EQ_GT] = ACTIONS(125),
    [anon_sym_LBRACK2] = ACTIONS(171),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(175),
    [aux_sym_integer_literal_token2] = ACTIONS(175),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(181),
    [sym__bitshift_operator] = ACTIONS(181),
    [sym__rational_operator] = ACTIONS(181),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(181),
    [sym__comparison_operator] = ACTIONS(181),
    [sym__arrow_operator] = ACTIONS(125),
    [sym__assign_operator] = ACTIONS(125),
    [anon_sym_LF] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(185),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [4] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1068),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_macro_argument_list] = STATE(989),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [aux_sym_macro_argument_list_repeat1] = STATE(5),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_COMMA] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(125),
    [anon_sym_SEMI] = ACTIONS(125),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_LT_COLON] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_elseif] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_catch] = ACTIONS(125),
    [anon_sym_finally] = ACTIONS(125),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(165),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(125),
    [anon_sym_PIPE_GT] = ACTIONS(125),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(125),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_EQ_GT] = ACTIONS(125),
    [anon_sym_LBRACK2] = ACTIONS(171),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(175),
    [aux_sym_integer_literal_token2] = ACTIONS(175),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(181),
    [sym__bitshift_operator] = ACTIONS(181),
    [sym__rational_operator] = ACTIONS(181),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(181),
    [sym__comparison_operator] = ACTIONS(181),
    [sym__arrow_operator] = ACTIONS(125),
    [sym__assign_operator] = ACTIONS(125),
    [anon_sym_LF] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(191),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [5] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1068),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [aux_sym_macro_argument_list_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_end] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_COMMA] = ACTIONS(193),
    [anon_sym_RPAREN] = ACTIONS(193),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_EQ] = ACTIONS(193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(193),
    [anon_sym_COLON_COLON] = ACTIONS(193),
    [anon_sym_LT_COLON] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_elseif] = ACTIONS(193),
    [anon_sym_else] = ACTIONS(193),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_catch] = ACTIONS(193),
    [anon_sym_finally] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(165),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(193),
    [anon_sym_LT_PIPE] = ACTIONS(193),
    [anon_sym_PIPE_GT] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_isa] = ACTIONS(193),
    [anon_sym_PIPE_PIPE] = ACTIONS(193),
    [anon_sym_AMP_AMP] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_EQ_GT] = ACTIONS(193),
    [anon_sym_LBRACK2] = ACTIONS(171),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(175),
    [aux_sym_integer_literal_token2] = ACTIONS(175),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(181),
    [sym__bitshift_operator] = ACTIONS(181),
    [sym__rational_operator] = ACTIONS(181),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(181),
    [sym__comparison_operator] = ACTIONS(181),
    [sym__arrow_operator] = ACTIONS(193),
    [sym__assign_operator] = ACTIONS(193),
    [anon_sym_LF] = ACTIONS(195),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [6] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1068),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [aux_sym_macro_argument_list_repeat1] = STATE(6),
    [sym_identifier] = ACTIONS(197),
    [anon_sym_function] = ACTIONS(200),
    [anon_sym_end] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(205),
    [anon_sym_primitive] = ACTIONS(208),
    [aux_sym_primitive_definition_token1] = ACTIONS(211),
    [anon_sym_mutable] = ACTIONS(214),
    [anon_sym_struct] = ACTIONS(217),
    [anon_sym_module] = ACTIONS(220),
    [anon_sym_macro] = ACTIONS(223),
    [anon_sym_LPAREN] = ACTIONS(226),
    [anon_sym_COMMA] = ACTIONS(203),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(203),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT_COLON] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(229),
    [anon_sym_elseif] = ACTIONS(203),
    [anon_sym_else] = ACTIONS(203),
    [anon_sym_try] = ACTIONS(232),
    [anon_sym_catch] = ACTIONS(203),
    [anon_sym_finally] = ACTIONS(203),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_while] = ACTIONS(238),
    [sym_break_statement] = ACTIONS(241),
    [sym_continue_statement] = ACTIONS(241),
    [anon_sym_return] = ACTIONS(244),
    [anon_sym_let] = ACTIONS(247),
    [anon_sym_const] = ACTIONS(250),
    [anon_sym_quote] = ACTIONS(253),
    [anon_sym_using] = ACTIONS(256),
    [anon_sym_import] = ACTIONS(256),
    [anon_sym_export] = ACTIONS(259),
    [anon_sym_COLON2] = ACTIONS(262),
    [anon_sym_begin] = ACTIONS(265),
    [anon_sym_SQUOTE] = ACTIONS(268),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_LT_PIPE] = ACTIONS(203),
    [anon_sym_PIPE_GT] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_isa] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_EQ_GT] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(271),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_AT] = ACTIONS(277),
    [aux_sym_integer_literal_token1] = ACTIONS(280),
    [aux_sym_integer_literal_token2] = ACTIONS(280),
    [aux_sym_integer_literal_token3] = ACTIONS(280),
    [sym_float_literal] = ACTIONS(283),
    [sym__unary_operator] = ACTIONS(286),
    [sym__power_operator] = ACTIONS(289),
    [sym__bitshift_operator] = ACTIONS(289),
    [sym__rational_operator] = ACTIONS(289),
    [sym__times_operator] = ACTIONS(289),
    [sym__plus_operator] = ACTIONS(289),
    [sym__dotty_operator] = ACTIONS(289),
    [sym__comparison_operator] = ACTIONS(289),
    [sym__arrow_operator] = ACTIONS(203),
    [sym__assign_operator] = ACTIONS(203),
    [anon_sym_LF] = ACTIONS(292),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(294),
    [sym__command_start] = ACTIONS(297),
  },
  [7] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2098),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2143),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(300),
    [anon_sym_RPAREN] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_COLON_COLON] = ACTIONS(300),
    [anon_sym_LT_COLON] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(300),
    [anon_sym_else] = ACTIONS(300),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(300),
    [anon_sym_finally] = ACTIONS(300),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(300),
    [anon_sym_PIPE_GT] = ACTIONS(300),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(300),
    [anon_sym_AMP_AMP] = ACTIONS(300),
    [anon_sym_QMARK] = ACTIONS(300),
    [anon_sym_EQ_GT] = ACTIONS(300),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [sym__arrow_operator] = ACTIONS(300),
    [sym__assign_operator] = ACTIONS(300),
    [anon_sym_LF] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [8] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(938),
    [sym__primary_expression] = STATE(870),
    [sym_bare_tuple_expression] = STATE(1067),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_end] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_COMMA] = ACTIONS(300),
    [anon_sym_RPAREN] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_COLON_COLON] = ACTIONS(300),
    [anon_sym_LT_COLON] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_elseif] = ACTIONS(300),
    [anon_sym_else] = ACTIONS(300),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_catch] = ACTIONS(300),
    [anon_sym_finally] = ACTIONS(300),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(165),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(300),
    [anon_sym_PIPE_GT] = ACTIONS(300),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(300),
    [anon_sym_AMP_AMP] = ACTIONS(300),
    [anon_sym_QMARK] = ACTIONS(300),
    [anon_sym_EQ_GT] = ACTIONS(300),
    [anon_sym_LBRACK2] = ACTIONS(171),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(175),
    [aux_sym_integer_literal_token2] = ACTIONS(175),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(181),
    [sym__bitshift_operator] = ACTIONS(181),
    [sym__rational_operator] = ACTIONS(181),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(181),
    [sym__comparison_operator] = ACTIONS(181),
    [sym__arrow_operator] = ACTIONS(300),
    [sym__assign_operator] = ACTIONS(300),
    [anon_sym_LF] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [9] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2149),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(304),
    [anon_sym_finally] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [10] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1032),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_catch] = ACTIONS(304),
    [anon_sym_finally] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(165),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(171),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(175),
    [aux_sym_integer_literal_token2] = ACTIONS(175),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(181),
    [sym__bitshift_operator] = ACTIONS(181),
    [sym__rational_operator] = ACTIONS(181),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(181),
    [sym__comparison_operator] = ACTIONS(181),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [11] = {
    [sym__expression_list] = STATE(2816),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2818),
    [sym_else_clause] = STATE(3931),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2818),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(308),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(310),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(356),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [12] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1337),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_macro_argument_list] = STATE(1349),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [aux_sym_macro_argument_list_repeat1] = STATE(31),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_LT_COLON] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_GT] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(408),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(420),
    [sym__bitshift_operator] = ACTIONS(420),
    [sym__rational_operator] = ACTIONS(420),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(420),
    [sym__comparison_operator] = ACTIONS(420),
    [sym__arrow_operator] = ACTIONS(183),
    [sym__assign_operator] = ACTIONS(125),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(422),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [13] = {
    [sym__expression_list] = STATE(2809),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2810),
    [sym_else_clause] = STATE(4005),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2810),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(428),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(430),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(432),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [14] = {
    [sym__expression_list] = STATE(2826),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2825),
    [sym_else_clause] = STATE(3866),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2825),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(434),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(436),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(438),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [15] = {
    [sym__expression_list] = STATE(2812),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2823),
    [sym_else_clause] = STATE(3999),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2823),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(440),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(444),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [16] = {
    [sym__expression_list] = STATE(2843),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2839),
    [sym_else_clause] = STATE(4222),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2839),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(446),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(448),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(450),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [17] = {
    [sym__expression_list] = STATE(2794),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2795),
    [sym_else_clause] = STATE(4147),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2795),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(452),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(456),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [18] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1337),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_macro_argument_list] = STATE(2373),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [aux_sym_macro_argument_list_repeat1] = STATE(31),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_LT_COLON] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_GT] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(408),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(420),
    [sym__bitshift_operator] = ACTIONS(420),
    [sym__rational_operator] = ACTIONS(420),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(420),
    [sym__comparison_operator] = ACTIONS(420),
    [sym__arrow_operator] = ACTIONS(183),
    [sym__assign_operator] = ACTIONS(125),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(458),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [19] = {
    [sym__expression_list] = STATE(2797),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2798),
    [sym_else_clause] = STATE(4282),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2798),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(460),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(464),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [20] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1052),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_EQ] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_COLON_COLON] = ACTIONS(466),
    [anon_sym_LT_COLON] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_elseif] = ACTIONS(466),
    [anon_sym_else] = ACTIONS(466),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_catch] = ACTIONS(466),
    [anon_sym_finally] = ACTIONS(466),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(165),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(466),
    [anon_sym_PIPE_GT] = ACTIONS(466),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_EQ_GT] = ACTIONS(466),
    [anon_sym_LBRACK2] = ACTIONS(171),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(175),
    [aux_sym_integer_literal_token2] = ACTIONS(175),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(181),
    [sym__bitshift_operator] = ACTIONS(181),
    [sym__rational_operator] = ACTIONS(181),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(181),
    [sym__comparison_operator] = ACTIONS(181),
    [sym__arrow_operator] = ACTIONS(466),
    [sym__assign_operator] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [21] = {
    [sym__expression_list] = STATE(2819),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2817),
    [sym_else_clause] = STATE(4071),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2817),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(470),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(474),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [22] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2261),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_RPAREN] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_EQ] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_COLON_COLON] = ACTIONS(466),
    [anon_sym_LT_COLON] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(466),
    [anon_sym_else] = ACTIONS(466),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(466),
    [anon_sym_finally] = ACTIONS(466),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(466),
    [anon_sym_PIPE_GT] = ACTIONS(466),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_EQ_GT] = ACTIONS(466),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [sym__arrow_operator] = ACTIONS(466),
    [sym__assign_operator] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [23] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1902),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [24] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1904),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [25] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1364),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(408),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(420),
    [sym__bitshift_operator] = ACTIONS(420),
    [sym__rational_operator] = ACTIONS(420),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(420),
    [sym__comparison_operator] = ACTIONS(420),
    [sym__arrow_operator] = ACTIONS(306),
    [sym__assign_operator] = ACTIONS(304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [26] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1860),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_macro_argument_list] = STATE(2153),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [aux_sym_macro_argument_list_repeat1] = STATE(47),
    [ts_builtin_sym_end] = ACTIONS(183),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(125),
    [anon_sym_SEMI] = ACTIONS(125),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_LT_COLON] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(584),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(125),
    [anon_sym_PIPE_GT] = ACTIONS(125),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(125),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_EQ_GT] = ACTIONS(125),
    [anon_sym_LBRACK2] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(596),
    [aux_sym_integer_literal_token2] = ACTIONS(596),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(602),
    [sym__bitshift_operator] = ACTIONS(602),
    [sym__rational_operator] = ACTIONS(602),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(602),
    [sym__comparison_operator] = ACTIONS(602),
    [sym__arrow_operator] = ACTIONS(125),
    [sym__assign_operator] = ACTIONS(125),
    [anon_sym_LF] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(185),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [27] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1860),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_macro_argument_list] = STATE(1580),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [aux_sym_macro_argument_list_repeat1] = STATE(47),
    [ts_builtin_sym_end] = ACTIONS(183),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(125),
    [anon_sym_SEMI] = ACTIONS(125),
    [anon_sym_EQ] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_LT_COLON] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(584),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(125),
    [anon_sym_PIPE_GT] = ACTIONS(125),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(125),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_EQ_GT] = ACTIONS(125),
    [anon_sym_LBRACK2] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(596),
    [aux_sym_integer_literal_token2] = ACTIONS(596),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(602),
    [sym__bitshift_operator] = ACTIONS(602),
    [sym__rational_operator] = ACTIONS(602),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(602),
    [sym__comparison_operator] = ACTIONS(602),
    [sym__arrow_operator] = ACTIONS(125),
    [sym__assign_operator] = ACTIONS(125),
    [anon_sym_LF] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(608),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [28] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1685),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_macro_argument_list] = STATE(1829),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_LT_COLON] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(652),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_GT] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(676),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [29] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2280),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(2383),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_end] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(302),
    [anon_sym_COLON_COLON] = ACTIONS(302),
    [anon_sym_RBRACE] = ACTIONS(302),
    [anon_sym_LT_COLON] = ACTIONS(302),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(724),
    [anon_sym_RBRACK] = ACTIONS(302),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(302),
    [anon_sym_PIPE_GT] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(302),
    [anon_sym_QMARK] = ACTIONS(302),
    [anon_sym_EQ_GT] = ACTIONS(302),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(742),
    [sym__bitshift_operator] = ACTIONS(742),
    [sym__rational_operator] = ACTIONS(742),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(742),
    [sym__comparison_operator] = ACTIONS(742),
    [sym__arrow_operator] = ACTIONS(302),
    [sym__assign_operator] = ACTIONS(300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [30] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1789),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [31] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1337),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [aux_sym_macro_argument_list_repeat1] = STATE(38),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_end] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(195),
    [anon_sym_RPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(195),
    [anon_sym_EQ] = ACTIONS(193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(195),
    [anon_sym_COLON_COLON] = ACTIONS(195),
    [anon_sym_RBRACE] = ACTIONS(195),
    [anon_sym_LT_COLON] = ACTIONS(195),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(195),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(193),
    [anon_sym_LT_PIPE] = ACTIONS(195),
    [anon_sym_PIPE_GT] = ACTIONS(195),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_isa] = ACTIONS(193),
    [anon_sym_PIPE_PIPE] = ACTIONS(195),
    [anon_sym_AMP_AMP] = ACTIONS(195),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_EQ_GT] = ACTIONS(195),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(408),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(420),
    [sym__bitshift_operator] = ACTIONS(420),
    [sym__rational_operator] = ACTIONS(420),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(420),
    [sym__comparison_operator] = ACTIONS(420),
    [sym__arrow_operator] = ACTIONS(195),
    [sym__assign_operator] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [32] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1232),
    [sym__primary_expression] = STATE(1095),
    [sym_bare_tuple_expression] = STATE(1406),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_end] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(302),
    [anon_sym_COLON_COLON] = ACTIONS(302),
    [anon_sym_RBRACE] = ACTIONS(302),
    [anon_sym_LT_COLON] = ACTIONS(302),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(302),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(302),
    [anon_sym_PIPE_GT] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(302),
    [anon_sym_QMARK] = ACTIONS(302),
    [anon_sym_EQ_GT] = ACTIONS(302),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(408),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(420),
    [sym__bitshift_operator] = ACTIONS(420),
    [sym__rational_operator] = ACTIONS(420),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(420),
    [sym__comparison_operator] = ACTIONS(420),
    [sym__arrow_operator] = ACTIONS(302),
    [sym__assign_operator] = ACTIONS(300),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [33] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1800),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_macro_argument_list] = STATE(1722),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [aux_sym_macro_argument_list_repeat1] = STATE(48),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(125),
    [anon_sym_SEMI] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_LT_COLON] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(750),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(125),
    [anon_sym_PIPE_GT] = ACTIONS(125),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(125),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_EQ_GT] = ACTIONS(125),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(125),
    [anon_sym_LF] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(756),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [34] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1901),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [35] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1903),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [36] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1894),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [37] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1685),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_macro_argument_list] = STATE(2581),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(183),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(183),
    [anon_sym_LT_COLON] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(652),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_GT] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(758),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [38] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1337),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [aux_sym_macro_argument_list_repeat1] = STATE(38),
    [sym_identifier] = ACTIONS(760),
    [anon_sym_function] = ACTIONS(763),
    [anon_sym_end] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(766),
    [anon_sym_primitive] = ACTIONS(769),
    [aux_sym_primitive_definition_token1] = ACTIONS(772),
    [anon_sym_mutable] = ACTIONS(775),
    [anon_sym_struct] = ACTIONS(778),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_macro] = ACTIONS(784),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_COMMA] = ACTIONS(292),
    [anon_sym_RPAREN] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_COLON_COLON] = ACTIONS(292),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_LT_COLON] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(790),
    [anon_sym_try] = ACTIONS(793),
    [anon_sym_for] = ACTIONS(796),
    [anon_sym_while] = ACTIONS(799),
    [sym_break_statement] = ACTIONS(802),
    [sym_continue_statement] = ACTIONS(802),
    [anon_sym_return] = ACTIONS(805),
    [anon_sym_let] = ACTIONS(808),
    [anon_sym_const] = ACTIONS(811),
    [anon_sym_quote] = ACTIONS(814),
    [anon_sym_using] = ACTIONS(817),
    [anon_sym_import] = ACTIONS(817),
    [anon_sym_export] = ACTIONS(820),
    [anon_sym_COLON2] = ACTIONS(823),
    [anon_sym_RBRACK] = ACTIONS(292),
    [anon_sym_begin] = ACTIONS(826),
    [anon_sym_SQUOTE] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_LT_PIPE] = ACTIONS(292),
    [anon_sym_PIPE_GT] = ACTIONS(292),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_isa] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(292),
    [anon_sym_AMP_AMP] = ACTIONS(292),
    [anon_sym_QMARK] = ACTIONS(292),
    [anon_sym_EQ_GT] = ACTIONS(292),
    [anon_sym_LBRACK2] = ACTIONS(832),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [anon_sym_AT] = ACTIONS(838),
    [aux_sym_integer_literal_token1] = ACTIONS(841),
    [aux_sym_integer_literal_token2] = ACTIONS(841),
    [aux_sym_integer_literal_token3] = ACTIONS(844),
    [sym_float_literal] = ACTIONS(847),
    [sym__unary_operator] = ACTIONS(850),
    [sym__power_operator] = ACTIONS(853),
    [sym__bitshift_operator] = ACTIONS(853),
    [sym__rational_operator] = ACTIONS(853),
    [sym__times_operator] = ACTIONS(853),
    [sym__plus_operator] = ACTIONS(853),
    [sym__dotty_operator] = ACTIONS(853),
    [sym__comparison_operator] = ACTIONS(853),
    [sym__arrow_operator] = ACTIONS(292),
    [sym__assign_operator] = ACTIONS(203),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(856),
    [sym__command_start] = ACTIONS(859),
  },
  [39] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2376),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_COMMA] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(724),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(742),
    [sym__bitshift_operator] = ACTIONS(742),
    [sym__rational_operator] = ACTIONS(742),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(742),
    [sym__comparison_operator] = ACTIONS(742),
    [sym__arrow_operator] = ACTIONS(306),
    [sym__assign_operator] = ACTIONS(304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [40] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1897),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [41] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1413),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_EQ] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_COLON_COLON] = ACTIONS(466),
    [anon_sym_LT_COLON] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_elseif] = ACTIONS(466),
    [anon_sym_else] = ACTIONS(466),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(165),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(169),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(466),
    [anon_sym_PIPE_GT] = ACTIONS(466),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_EQ_GT] = ACTIONS(466),
    [anon_sym_LBRACK2] = ACTIONS(171),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(175),
    [aux_sym_integer_literal_token2] = ACTIONS(175),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(181),
    [sym__bitshift_operator] = ACTIONS(181),
    [sym__rational_operator] = ACTIONS(181),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(181),
    [sym__comparison_operator] = ACTIONS(181),
    [sym__arrow_operator] = ACTIONS(466),
    [sym__assign_operator] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [42] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1893),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_macro_argument_list] = STATE(1722),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [aux_sym_macro_argument_list_repeat1] = STATE(67),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_SEMI] = ACTIONS(125),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(125),
    [anon_sym_COLON_COLON] = ACTIONS(125),
    [anon_sym_LT_COLON] = ACTIONS(125),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(125),
    [anon_sym_PIPE_GT] = ACTIONS(125),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(125),
    [anon_sym_AMP_AMP] = ACTIONS(125),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_EQ_GT] = ACTIONS(125),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(125),
    [anon_sym_LF] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(756),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [43] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2381),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_EQ] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(468),
    [anon_sym_COLON_COLON] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_LT_COLON] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(724),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(468),
    [anon_sym_PIPE_GT] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(468),
    [anon_sym_EQ_GT] = ACTIONS(468),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(742),
    [sym__bitshift_operator] = ACTIONS(742),
    [sym__rational_operator] = ACTIONS(742),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(742),
    [sym__comparison_operator] = ACTIONS(742),
    [sym__arrow_operator] = ACTIONS(468),
    [sym__assign_operator] = ACTIONS(466),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [44] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1396),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_EQ] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(468),
    [anon_sym_COLON_COLON] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_LT_COLON] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(468),
    [anon_sym_PIPE_GT] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(468),
    [anon_sym_EQ_GT] = ACTIONS(468),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(408),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(420),
    [sym__bitshift_operator] = ACTIONS(420),
    [sym__rational_operator] = ACTIONS(420),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(420),
    [sym__comparison_operator] = ACTIONS(420),
    [sym__arrow_operator] = ACTIONS(468),
    [sym__assign_operator] = ACTIONS(466),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [45] = {
    [sym__expression_list] = STATE(3395),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(862),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(862),
    [anon_sym_else] = ACTIONS(862),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(866),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [46] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2473),
    [sym__primary_expression] = STATE(2256),
    [sym_bare_tuple_expression] = STATE(2531),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_end] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(302),
    [anon_sym_COLON_COLON] = ACTIONS(302),
    [anon_sym_RBRACE] = ACTIONS(302),
    [anon_sym_LT_COLON] = ACTIONS(302),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(910),
    [anon_sym_RBRACK] = ACTIONS(302),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(302),
    [anon_sym_PIPE_GT] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(302),
    [anon_sym_QMARK] = ACTIONS(302),
    [anon_sym_EQ_GT] = ACTIONS(302),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(930),
    [sym__comparison_operator] = ACTIONS(930),
    [sym__arrow_operator] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [47] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1860),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [aux_sym_macro_argument_list_repeat1] = STATE(55),
    [ts_builtin_sym_end] = ACTIONS(195),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(193),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_EQ] = ACTIONS(193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(193),
    [anon_sym_COLON_COLON] = ACTIONS(193),
    [anon_sym_LT_COLON] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(584),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(193),
    [anon_sym_LT_PIPE] = ACTIONS(193),
    [anon_sym_PIPE_GT] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_isa] = ACTIONS(193),
    [anon_sym_PIPE_PIPE] = ACTIONS(193),
    [anon_sym_AMP_AMP] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_EQ_GT] = ACTIONS(193),
    [anon_sym_LBRACK2] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(596),
    [aux_sym_integer_literal_token2] = ACTIONS(596),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(602),
    [sym__bitshift_operator] = ACTIONS(602),
    [sym__rational_operator] = ACTIONS(602),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(602),
    [sym__comparison_operator] = ACTIONS(602),
    [sym__arrow_operator] = ACTIONS(193),
    [sym__assign_operator] = ACTIONS(193),
    [anon_sym_LF] = ACTIONS(195),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [48] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1800),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [aux_sym_macro_argument_list_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(193),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(193),
    [anon_sym_COLON_COLON] = ACTIONS(193),
    [anon_sym_LT_COLON] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(193),
    [anon_sym_else] = ACTIONS(193),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(750),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(193),
    [anon_sym_LT_PIPE] = ACTIONS(193),
    [anon_sym_PIPE_GT] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_isa] = ACTIONS(193),
    [anon_sym_PIPE_PIPE] = ACTIONS(193),
    [anon_sym_AMP_AMP] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_EQ_GT] = ACTIONS(193),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(193),
    [anon_sym_LF] = ACTIONS(195),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [49] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2149),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(306),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(936),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [50] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1685),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(50),
    [sym_identifier] = ACTIONS(940),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_end] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_primitive] = ACTIONS(949),
    [aux_sym_primitive_definition_token1] = ACTIONS(952),
    [anon_sym_mutable] = ACTIONS(955),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(961),
    [anon_sym_macro] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_COMMA] = ACTIONS(292),
    [anon_sym_RPAREN] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_COLON_COLON] = ACTIONS(292),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_LT_COLON] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(979),
    [sym_break_statement] = ACTIONS(982),
    [sym_continue_statement] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_quote] = ACTIONS(994),
    [anon_sym_using] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(1000),
    [anon_sym_COLON2] = ACTIONS(1003),
    [anon_sym_RBRACK] = ACTIONS(292),
    [anon_sym_begin] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_LT_PIPE] = ACTIONS(292),
    [anon_sym_PIPE_GT] = ACTIONS(292),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_isa] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(292),
    [anon_sym_AMP_AMP] = ACTIONS(292),
    [anon_sym_QMARK] = ACTIONS(292),
    [anon_sym_EQ_GT] = ACTIONS(292),
    [anon_sym_LBRACK2] = ACTIONS(1012),
    [anon_sym_DOLLAR] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(1018),
    [aux_sym_integer_literal_token1] = ACTIONS(1021),
    [aux_sym_integer_literal_token2] = ACTIONS(1021),
    [aux_sym_integer_literal_token3] = ACTIONS(1024),
    [sym_float_literal] = ACTIONS(1027),
    [sym__unary_operator] = ACTIONS(1030),
    [sym__power_operator] = ACTIONS(1033),
    [sym__bitshift_operator] = ACTIONS(1033),
    [sym__rational_operator] = ACTIONS(1033),
    [sym__times_operator] = ACTIONS(1036),
    [sym__plus_operator] = ACTIONS(1036),
    [sym__dotty_operator] = ACTIONS(1036),
    [sym__comparison_operator] = ACTIONS(1036),
    [sym__arrow_operator] = ACTIONS(292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1039),
    [sym__command_start] = ACTIONS(1042),
  },
  [51] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2513),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(910),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(930),
    [sym__comparison_operator] = ACTIONS(930),
    [sym__arrow_operator] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [52] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_macro_argument_list] = STATE(1829),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(80),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_SEMI] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_LT_COLON] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_GT] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(676),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [53] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1687),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [ts_builtin_sym_end] = ACTIONS(306),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(584),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(596),
    [aux_sym_integer_literal_token2] = ACTIONS(596),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(602),
    [sym__bitshift_operator] = ACTIONS(602),
    [sym__rational_operator] = ACTIONS(602),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(602),
    [sym__comparison_operator] = ACTIONS(602),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [54] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1497),
    [sym__primary_expression] = STATE(1243),
    [sym_bare_tuple_expression] = STATE(1700),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [ts_builtin_sym_end] = ACTIONS(302),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_COLON_COLON] = ACTIONS(300),
    [anon_sym_LT_COLON] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(584),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(300),
    [anon_sym_PIPE_GT] = ACTIONS(300),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(300),
    [anon_sym_AMP_AMP] = ACTIONS(300),
    [anon_sym_QMARK] = ACTIONS(300),
    [anon_sym_EQ_GT] = ACTIONS(300),
    [anon_sym_LBRACK2] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(596),
    [aux_sym_integer_literal_token2] = ACTIONS(596),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(602),
    [sym__bitshift_operator] = ACTIONS(602),
    [sym__rational_operator] = ACTIONS(602),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(602),
    [sym__comparison_operator] = ACTIONS(602),
    [sym__arrow_operator] = ACTIONS(300),
    [sym__assign_operator] = ACTIONS(300),
    [anon_sym_LF] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [55] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1860),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [aux_sym_macro_argument_list_repeat1] = STATE(55),
    [ts_builtin_sym_end] = ACTIONS(292),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_function] = ACTIONS(1056),
    [anon_sym_abstract] = ACTIONS(1059),
    [anon_sym_primitive] = ACTIONS(1062),
    [aux_sym_primitive_definition_token1] = ACTIONS(1065),
    [anon_sym_mutable] = ACTIONS(1068),
    [anon_sym_struct] = ACTIONS(1071),
    [anon_sym_module] = ACTIONS(1074),
    [anon_sym_macro] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(203),
    [anon_sym_EQ] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT_COLON] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1089),
    [anon_sym_while] = ACTIONS(1092),
    [sym_break_statement] = ACTIONS(1095),
    [sym_continue_statement] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_let] = ACTIONS(1101),
    [anon_sym_const] = ACTIONS(1104),
    [anon_sym_quote] = ACTIONS(1107),
    [anon_sym_using] = ACTIONS(1110),
    [anon_sym_import] = ACTIONS(1110),
    [anon_sym_export] = ACTIONS(1113),
    [anon_sym_COLON2] = ACTIONS(1116),
    [anon_sym_begin] = ACTIONS(1119),
    [anon_sym_SQUOTE] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_LT_PIPE] = ACTIONS(203),
    [anon_sym_PIPE_GT] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_isa] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_EQ_GT] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1125),
    [anon_sym_DOLLAR] = ACTIONS(1128),
    [anon_sym_AT] = ACTIONS(1131),
    [aux_sym_integer_literal_token1] = ACTIONS(1134),
    [aux_sym_integer_literal_token2] = ACTIONS(1134),
    [aux_sym_integer_literal_token3] = ACTIONS(1134),
    [sym_float_literal] = ACTIONS(1137),
    [sym__unary_operator] = ACTIONS(1140),
    [sym__power_operator] = ACTIONS(1143),
    [sym__bitshift_operator] = ACTIONS(1143),
    [sym__rational_operator] = ACTIONS(1143),
    [sym__times_operator] = ACTIONS(1143),
    [sym__plus_operator] = ACTIONS(1143),
    [sym__dotty_operator] = ACTIONS(1143),
    [sym__comparison_operator] = ACTIONS(1143),
    [sym__arrow_operator] = ACTIONS(203),
    [sym__assign_operator] = ACTIONS(203),
    [anon_sym_LF] = ACTIONS(292),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1146),
    [sym__command_start] = ACTIONS(1149),
  },
  [56] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1438),
    [sym__primary_expression] = STATE(1203),
    [sym_bare_tuple_expression] = STATE(1695),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_COLON_COLON] = ACTIONS(300),
    [anon_sym_LT_COLON] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(300),
    [anon_sym_else] = ACTIONS(300),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(750),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(300),
    [anon_sym_PIPE_GT] = ACTIONS(300),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(300),
    [anon_sym_AMP_AMP] = ACTIONS(300),
    [anon_sym_QMARK] = ACTIONS(300),
    [anon_sym_EQ_GT] = ACTIONS(300),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(300),
    [anon_sym_LF] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [57] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1800),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [aux_sym_macro_argument_list_repeat1] = STATE(57),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_function] = ACTIONS(1155),
    [anon_sym_end] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(1158),
    [anon_sym_primitive] = ACTIONS(1161),
    [aux_sym_primitive_definition_token1] = ACTIONS(1164),
    [anon_sym_mutable] = ACTIONS(1167),
    [anon_sym_struct] = ACTIONS(1170),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_macro] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [anon_sym_COMMA] = ACTIONS(203),
    [anon_sym_SEMI] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT_COLON] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_elseif] = ACTIONS(203),
    [anon_sym_else] = ACTIONS(203),
    [anon_sym_try] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1191),
    [sym_break_statement] = ACTIONS(1194),
    [sym_continue_statement] = ACTIONS(1194),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1203),
    [anon_sym_quote] = ACTIONS(1206),
    [anon_sym_using] = ACTIONS(1209),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_export] = ACTIONS(1212),
    [anon_sym_COLON2] = ACTIONS(1215),
    [anon_sym_begin] = ACTIONS(1218),
    [anon_sym_SQUOTE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_LT_PIPE] = ACTIONS(203),
    [anon_sym_PIPE_GT] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_isa] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_EQ_GT] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1224),
    [anon_sym_DOLLAR] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1230),
    [aux_sym_integer_literal_token1] = ACTIONS(1233),
    [aux_sym_integer_literal_token2] = ACTIONS(1233),
    [aux_sym_integer_literal_token3] = ACTIONS(1233),
    [sym_float_literal] = ACTIONS(1236),
    [sym__unary_operator] = ACTIONS(1239),
    [sym__power_operator] = ACTIONS(1242),
    [sym__bitshift_operator] = ACTIONS(1242),
    [sym__rational_operator] = ACTIONS(1242),
    [sym__times_operator] = ACTIONS(1242),
    [sym__plus_operator] = ACTIONS(1242),
    [sym__dotty_operator] = ACTIONS(1242),
    [sym__comparison_operator] = ACTIONS(1242),
    [sym__arrow_operator] = ACTIONS(203),
    [anon_sym_LF] = ACTIONS(292),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1245),
    [sym__command_start] = ACTIONS(1248),
  },
  [58] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1466),
    [sym__primary_expression] = STATE(1237),
    [sym_bare_tuple_expression] = STATE(1845),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(300),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(302),
    [anon_sym_RPAREN] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(302),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(302),
    [anon_sym_COLON_COLON] = ACTIONS(302),
    [anon_sym_RBRACE] = ACTIONS(302),
    [anon_sym_LT_COLON] = ACTIONS(302),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(652),
    [anon_sym_RBRACK] = ACTIONS(302),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(302),
    [anon_sym_PIPE_GT] = ACTIONS(302),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(302),
    [anon_sym_AMP_AMP] = ACTIONS(302),
    [anon_sym_QMARK] = ACTIONS(302),
    [anon_sym_EQ_GT] = ACTIONS(302),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [59] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2617),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2143),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(302),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_EQ] = ACTIONS(300),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_COLON_COLON] = ACTIONS(300),
    [anon_sym_LT_COLON] = ACTIONS(300),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(936),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(300),
    [anon_sym_LT_PIPE] = ACTIONS(300),
    [anon_sym_PIPE_GT] = ACTIONS(300),
    [anon_sym_in] = ACTIONS(300),
    [anon_sym_isa] = ACTIONS(300),
    [anon_sym_PIPE_PIPE] = ACTIONS(300),
    [anon_sym_AMP_AMP] = ACTIONS(300),
    [anon_sym_QMARK] = ACTIONS(300),
    [anon_sym_EQ_GT] = ACTIONS(300),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [sym__arrow_operator] = ACTIONS(300),
    [sym__assign_operator] = ACTIONS(300),
    [anon_sym_LF] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [60] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1685),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(50),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(195),
    [anon_sym_RPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(195),
    [anon_sym_COLON_COLON] = ACTIONS(195),
    [anon_sym_RBRACE] = ACTIONS(195),
    [anon_sym_LT_COLON] = ACTIONS(195),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(652),
    [anon_sym_RBRACK] = ACTIONS(195),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(193),
    [anon_sym_LT_PIPE] = ACTIONS(195),
    [anon_sym_PIPE_GT] = ACTIONS(195),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_isa] = ACTIONS(193),
    [anon_sym_PIPE_PIPE] = ACTIONS(195),
    [anon_sym_AMP_AMP] = ACTIONS(195),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_EQ_GT] = ACTIONS(195),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(195),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [61] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1711),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(750),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [62] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1833),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(652),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [63] = {
    [sym__expression_list] = STATE(4066),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1251),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1253),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1255),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [64] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1839),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(468),
    [anon_sym_COLON_COLON] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_LT_COLON] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(652),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(468),
    [anon_sym_PIPE_GT] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(468),
    [anon_sym_EQ_GT] = ACTIONS(468),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [65] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_macro_argument_list] = STATE(2581),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(80),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(125),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_RPAREN] = ACTIONS(183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_COLON_COLON] = ACTIONS(183),
    [anon_sym_LT_COLON] = ACTIONS(183),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(183),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_LT_PIPE] = ACTIONS(183),
    [anon_sym_PIPE_GT] = ACTIONS(183),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_isa] = ACTIONS(125),
    [anon_sym_PIPE_PIPE] = ACTIONS(183),
    [anon_sym_AMP_AMP] = ACTIONS(183),
    [anon_sym_QMARK] = ACTIONS(183),
    [anon_sym_EQ_GT] = ACTIONS(183),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(183),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(758),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [66] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1711),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [67] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1893),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [aux_sym_macro_argument_list_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(193),
    [anon_sym_COLON_COLON] = ACTIONS(193),
    [anon_sym_LT_COLON] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(193),
    [anon_sym_else] = ACTIONS(193),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(193),
    [anon_sym_LT_PIPE] = ACTIONS(193),
    [anon_sym_PIPE_GT] = ACTIONS(193),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_isa] = ACTIONS(193),
    [anon_sym_PIPE_PIPE] = ACTIONS(193),
    [anon_sym_AMP_AMP] = ACTIONS(193),
    [anon_sym_QMARK] = ACTIONS(193),
    [anon_sym_EQ_GT] = ACTIONS(193),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(193),
    [anon_sym_LF] = ACTIONS(195),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [68] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1865),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_COLON_COLON] = ACTIONS(466),
    [anon_sym_LT_COLON] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(466),
    [anon_sym_else] = ACTIONS(466),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(750),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(466),
    [anon_sym_PIPE_GT] = ACTIONS(466),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_EQ_GT] = ACTIONS(466),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [69] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1893),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [aux_sym_macro_argument_list_repeat1] = STATE(69),
    [sym_identifier] = ACTIONS(1257),
    [anon_sym_function] = ACTIONS(1155),
    [anon_sym_end] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(1158),
    [anon_sym_primitive] = ACTIONS(1161),
    [aux_sym_primitive_definition_token1] = ACTIONS(1164),
    [anon_sym_mutable] = ACTIONS(1167),
    [anon_sym_struct] = ACTIONS(1170),
    [anon_sym_module] = ACTIONS(1173),
    [anon_sym_macro] = ACTIONS(1176),
    [anon_sym_LPAREN] = ACTIONS(1179),
    [anon_sym_SEMI] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(203),
    [anon_sym_COLON_COLON] = ACTIONS(203),
    [anon_sym_LT_COLON] = ACTIONS(203),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_elseif] = ACTIONS(203),
    [anon_sym_else] = ACTIONS(203),
    [anon_sym_try] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1191),
    [sym_break_statement] = ACTIONS(1194),
    [sym_continue_statement] = ACTIONS(1194),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_const] = ACTIONS(1203),
    [anon_sym_quote] = ACTIONS(1206),
    [anon_sym_using] = ACTIONS(1209),
    [anon_sym_import] = ACTIONS(1209),
    [anon_sym_export] = ACTIONS(1212),
    [anon_sym_COLON2] = ACTIONS(1260),
    [anon_sym_begin] = ACTIONS(1218),
    [anon_sym_SQUOTE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_LT_PIPE] = ACTIONS(203),
    [anon_sym_PIPE_GT] = ACTIONS(203),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_isa] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(203),
    [anon_sym_AMP_AMP] = ACTIONS(203),
    [anon_sym_QMARK] = ACTIONS(203),
    [anon_sym_EQ_GT] = ACTIONS(203),
    [anon_sym_LBRACK2] = ACTIONS(1224),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1230),
    [aux_sym_integer_literal_token1] = ACTIONS(1233),
    [aux_sym_integer_literal_token2] = ACTIONS(1233),
    [aux_sym_integer_literal_token3] = ACTIONS(1233),
    [sym_float_literal] = ACTIONS(1236),
    [sym__unary_operator] = ACTIONS(1266),
    [sym__power_operator] = ACTIONS(1242),
    [sym__bitshift_operator] = ACTIONS(1242),
    [sym__rational_operator] = ACTIONS(1242),
    [sym__times_operator] = ACTIONS(1242),
    [sym__plus_operator] = ACTIONS(1242),
    [sym__dotty_operator] = ACTIONS(1242),
    [sym__comparison_operator] = ACTIONS(1242),
    [sym__arrow_operator] = ACTIONS(203),
    [anon_sym_LF] = ACTIONS(292),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1245),
    [sym__command_start] = ACTIONS(1248),
  },
  [70] = {
    [sym__expression_list] = STATE(3928),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1269),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1273),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [71] = {
    [sym__expression_list] = STATE(4001),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1275),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1279),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [72] = {
    [sym__expression_list] = STATE(4143),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1281),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1285),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [73] = {
    [sym__expression_list] = STATE(4218),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1287),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1291),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [74] = {
    [sym__expression_list] = STATE(3989),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1293),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1297),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [75] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2643),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(468),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_EQ] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_COLON_COLON] = ACTIONS(466),
    [anon_sym_LT_COLON] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(936),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(466),
    [anon_sym_PIPE_GT] = ACTIONS(466),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_EQ_GT] = ACTIONS(466),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(938),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [sym__arrow_operator] = ACTIONS(466),
    [sym__assign_operator] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [76] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2502),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(468),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(468),
    [anon_sym_COLON_COLON] = ACTIONS(468),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_LT_COLON] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(910),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(468),
    [anon_sym_PIPE_GT] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(468),
    [anon_sym_EQ_GT] = ACTIONS(468),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(930),
    [sym__comparison_operator] = ACTIONS(930),
    [sym__arrow_operator] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [77] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1692),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [ts_builtin_sym_end] = ACTIONS(468),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_EQ] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_COLON_COLON] = ACTIONS(466),
    [anon_sym_LT_COLON] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(584),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(466),
    [anon_sym_PIPE_GT] = ACTIONS(466),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_EQ_GT] = ACTIONS(466),
    [anon_sym_LBRACK2] = ACTIONS(590),
    [anon_sym_DOLLAR] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(594),
    [aux_sym_integer_literal_token1] = ACTIONS(596),
    [aux_sym_integer_literal_token2] = ACTIONS(596),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(602),
    [sym__bitshift_operator] = ACTIONS(602),
    [sym__rational_operator] = ACTIONS(602),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(602),
    [sym__comparison_operator] = ACTIONS(602),
    [sym__arrow_operator] = ACTIONS(466),
    [sym__assign_operator] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [78] = {
    [sym__expression_list] = STATE(4273),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1299),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1303),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [79] = {
    [sym__expression_list] = STATE(3862),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1305),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(320),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(322),
    [anon_sym_PLUS] = ACTIONS(324),
    [anon_sym_LT_PIPE] = ACTIONS(326),
    [anon_sym_PIPE_GT] = ACTIONS(328),
    [anon_sym_in] = ACTIONS(330),
    [anon_sym_isa] = ACTIONS(330),
    [anon_sym_PIPE_PIPE] = ACTIONS(332),
    [anon_sym_AMP_AMP] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_EQ_GT] = ACTIONS(338),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(340),
    [sym__bitshift_operator] = ACTIONS(342),
    [sym__rational_operator] = ACTIONS(344),
    [sym__times_operator] = ACTIONS(346),
    [sym__plus_operator] = ACTIONS(348),
    [sym__dotty_operator] = ACTIONS(350),
    [sym__comparison_operator] = ACTIONS(352),
    [sym__arrow_operator] = ACTIONS(354),
    [anon_sym_LF] = ACTIONS(1309),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [80] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(193),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_RPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(195),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(195),
    [anon_sym_COLON_COLON] = ACTIONS(195),
    [anon_sym_LT_COLON] = ACTIONS(195),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(195),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(193),
    [anon_sym_LT_PIPE] = ACTIONS(195),
    [anon_sym_PIPE_GT] = ACTIONS(195),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_isa] = ACTIONS(193),
    [anon_sym_PIPE_PIPE] = ACTIONS(195),
    [anon_sym_AMP_AMP] = ACTIONS(195),
    [anon_sym_QMARK] = ACTIONS(195),
    [anon_sym_EQ_GT] = ACTIONS(195),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(195),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [81] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1908),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_SEMI] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(466),
    [anon_sym_COLON_COLON] = ACTIONS(466),
    [anon_sym_LT_COLON] = ACTIONS(466),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_elseif] = ACTIONS(466),
    [anon_sym_else] = ACTIONS(466),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(518),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(466),
    [anon_sym_PIPE_GT] = ACTIONS(466),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_QMARK] = ACTIONS(466),
    [anon_sym_EQ_GT] = ACTIONS(466),
    [anon_sym_LBRACK2] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(528),
    [aux_sym_integer_literal_token1] = ACTIONS(530),
    [aux_sym_integer_literal_token2] = ACTIONS(530),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(536),
    [sym__bitshift_operator] = ACTIONS(536),
    [sym__rational_operator] = ACTIONS(536),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(536),
    [sym__comparison_operator] = ACTIONS(536),
    [sym__arrow_operator] = ACTIONS(466),
    [anon_sym_LF] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [82] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(82),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_end] = ACTIONS(203),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_primitive] = ACTIONS(949),
    [aux_sym_primitive_definition_token1] = ACTIONS(952),
    [anon_sym_mutable] = ACTIONS(955),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(961),
    [anon_sym_macro] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_RPAREN] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(292),
    [anon_sym_COLON_COLON] = ACTIONS(292),
    [anon_sym_LT_COLON] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(979),
    [sym_break_statement] = ACTIONS(982),
    [sym_continue_statement] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_quote] = ACTIONS(994),
    [anon_sym_using] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(1000),
    [anon_sym_COLON2] = ACTIONS(1314),
    [anon_sym_RBRACK] = ACTIONS(292),
    [anon_sym_begin] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(203),
    [anon_sym_LT_PIPE] = ACTIONS(292),
    [anon_sym_PIPE_GT] = ACTIONS(292),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_isa] = ACTIONS(203),
    [anon_sym_PIPE_PIPE] = ACTIONS(292),
    [anon_sym_AMP_AMP] = ACTIONS(292),
    [anon_sym_QMARK] = ACTIONS(292),
    [anon_sym_EQ_GT] = ACTIONS(292),
    [anon_sym_LBRACK2] = ACTIONS(1012),
    [anon_sym_DOLLAR] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(1018),
    [aux_sym_integer_literal_token1] = ACTIONS(1021),
    [aux_sym_integer_literal_token2] = ACTIONS(1021),
    [aux_sym_integer_literal_token3] = ACTIONS(1024),
    [sym_float_literal] = ACTIONS(1027),
    [sym__unary_operator] = ACTIONS(1320),
    [sym__power_operator] = ACTIONS(1033),
    [sym__bitshift_operator] = ACTIONS(1033),
    [sym__rational_operator] = ACTIONS(1033),
    [sym__times_operator] = ACTIONS(1036),
    [sym__plus_operator] = ACTIONS(1036),
    [sym__dotty_operator] = ACTIONS(1036),
    [sym__comparison_operator] = ACTIONS(1036),
    [sym__arrow_operator] = ACTIONS(292),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1039),
    [sym__command_start] = ACTIONS(1042),
  },
  [83] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1833),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [84] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1915),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_SEMI] = ACTIONS(468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(468),
    [anon_sym_COLON_COLON] = ACTIONS(468),
    [anon_sym_LT_COLON] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(468),
    [anon_sym_PIPE_GT] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(468),
    [anon_sym_EQ_GT] = ACTIONS(468),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(674),
    [sym__comparison_operator] = ACTIONS(674),
    [sym__arrow_operator] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [85] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2513),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1325),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(930),
    [sym__comparison_operator] = ACTIONS(930),
    [sym__arrow_operator] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [86] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2630),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_end] = ACTIONS(466),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(468),
    [anon_sym_COLON_COLON] = ACTIONS(468),
    [anon_sym_LT_COLON] = ACTIONS(468),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1325),
    [anon_sym_RBRACK] = ACTIONS(468),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(466),
    [anon_sym_LT_PIPE] = ACTIONS(468),
    [anon_sym_PIPE_GT] = ACTIONS(468),
    [anon_sym_in] = ACTIONS(466),
    [anon_sym_isa] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(468),
    [anon_sym_AMP_AMP] = ACTIONS(468),
    [anon_sym_QMARK] = ACTIONS(468),
    [anon_sym_EQ_GT] = ACTIONS(468),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(930),
    [sym__comparison_operator] = ACTIONS(930),
    [sym__arrow_operator] = ACTIONS(468),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [87] = {
    [sym__expression_list] = STATE(3813),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2305),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3677),
    [sym_spread_expression] = STATE(2601),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1333),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [88] = {
    [sym__expression_list] = STATE(4234),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2264),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3650),
    [sym_spread_expression] = STATE(2625),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [89] = {
    [sym__expression_list] = STATE(4144),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2300),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3711),
    [sym_spread_expression] = STATE(2609),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1349),
    [anon_sym_RPAREN] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [90] = {
    [sym__expression_list] = STATE(4166),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2276),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3738),
    [sym_spread_expression] = STATE(2603),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [91] = {
    [sym__expression_list] = STATE(4019),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2298),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3707),
    [sym_spread_expression] = STATE(2612),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [92] = {
    [sym__expression_list] = STATE(4087),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2291),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3720),
    [sym_spread_expression] = STATE(2619),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1361),
    [anon_sym_RPAREN] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [93] = {
    [sym__expression_list] = STATE(3952),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2301),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3690),
    [sym_spread_expression] = STATE(2620),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1365),
    [anon_sym_RPAREN] = ACTIONS(1367),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [94] = {
    [sym__expression_list] = STATE(3778),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_keyword_parameters] = STATE(4142),
    [sym_optional_parameter] = STATE(2875),
    [sym_spread_parameter] = STATE(2875),
    [sym_typed_parameter] = STATE(2800),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2313),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3634),
    [sym_spread_expression] = STATE(2610),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1331),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1369),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [95] = {
    [sym__expression_list] = STATE(2820),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2822),
    [sym_else_clause] = STATE(4125),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2822),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1373),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [96] = {
    [sym__expression_list] = STATE(2856),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2831),
    [sym_else_clause] = STATE(3767),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2831),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1375),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [97] = {
    [sym__expression_list] = STATE(2807),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2808),
    [sym_else_clause] = STATE(4259),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2808),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1377),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [98] = {
    [sym__expression_list] = STATE(2811),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2844),
    [sym_else_clause] = STATE(3901),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2844),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1379),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [99] = {
    [sym__expression_list] = STATE(2801),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2799),
    [sym_else_clause] = STATE(4051),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2799),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1381),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [100] = {
    [sym__expression_list] = STATE(2834),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2832),
    [sym_else_clause] = STATE(3979),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2832),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1383),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [101] = {
    [sym__expression_list] = STATE(2841),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2838),
    [sym_else_clause] = STATE(4203),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2838),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1385),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [102] = {
    [sym__expression_list] = STATE(2847),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_elseif_clause] = STATE(2824),
    [sym_else_clause] = STATE(3845),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_if_statement_repeat1] = STATE(2824),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1387),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(316),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [103] = {
    [sym__expression_list] = STATE(4141),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1389),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1395),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [104] = {
    [sym__expression_list] = STATE(2868),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3105),
    [sym_finally_clause] = STATE(4307),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1397),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [105] = {
    [sym__expression_list] = STATE(4264),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(172),
    [sym_subtype_clause] = STATE(294),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1403),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [106] = {
    [sym__expression_list] = STATE(3927),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(131),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1409),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1413),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [107] = {
    [sym__expression_list] = STATE(2859),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3076),
    [sym_finally_clause] = STATE(4018),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1415),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [108] = {
    [sym__expression_list] = STATE(4010),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(176),
    [sym_subtype_clause] = STATE(197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1417),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [109] = {
    [sym__expression_list] = STATE(3974),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1419),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1423),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [110] = {
    [sym__expression_list] = STATE(3916),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(167),
    [sym_subtype_clause] = STATE(222),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1425),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [111] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2297),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2754),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2760),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1427),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(1427),
    [anon_sym_else] = ACTIONS(1427),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1427),
    [anon_sym_finally] = ACTIONS(1427),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [112] = {
    [sym__expression_list] = STATE(2860),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3245),
    [sym_finally_clause] = STATE(4091),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1431),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [113] = {
    [sym__expression_list] = STATE(2901),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3396),
    [sym_finally_clause] = STATE(4233),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1433),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [114] = {
    [sym__expression_list] = STATE(4151),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(177),
    [sym_subtype_clause] = STATE(284),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1435),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [115] = {
    [sym__expression_list] = STATE(3840),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1441),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [116] = {
    [sym__expression_list] = STATE(3976),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1443),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1449),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [117] = {
    [sym__expression_list] = STATE(4145),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(128),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1451),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1455),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [118] = {
    [sym__expression_list] = STATE(3864),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(133),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1457),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1461),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [119] = {
    [sym__expression_list] = STATE(4131),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(178),
    [sym_subtype_clause] = STATE(258),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1463),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [120] = {
    [sym__expression_list] = STATE(3860),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(115),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1465),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [121] = {
    [sym__expression_list] = STATE(4002),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(116),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1471),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1475),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [122] = {
    [sym__expression_list] = STATE(3987),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(153),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1477),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1481),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [123] = {
    [sym__expression_list] = STATE(3909),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1483),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1487),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [124] = {
    [sym__expression_list] = STATE(4000),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1489),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1493),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [125] = {
    [sym__expression_list] = STATE(3883),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(169),
    [sym_subtype_clause] = STATE(302),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1495),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [126] = {
    [sym__expression_list] = STATE(3871),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(166),
    [sym_subtype_clause] = STATE(202),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1497),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [127] = {
    [sym__expression_list] = STATE(3990),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(151),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1499),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1501),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [128] = {
    [sym__expression_list] = STATE(4121),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1505),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1509),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [129] = {
    [sym__expression_list] = STATE(4118),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1513),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1515),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [130] = {
    [sym__expression_list] = STATE(2886),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3195),
    [sym_finally_clause] = STATE(4115),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1517),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [131] = {
    [sym__expression_list] = STATE(3907),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1519),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1523),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [132] = {
    [sym__expression_list] = STATE(3986),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(162),
    [sym_subtype_clause] = STATE(248),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1525),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [133] = {
    [sym__expression_list] = STATE(3842),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1527),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1529),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1531),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [134] = {
    [sym__expression_list] = STATE(4272),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(140),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1533),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1537),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [135] = {
    [sym__expression_list] = STATE(2861),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3243),
    [sym_finally_clause] = STATE(3951),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1539),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [136] = {
    [sym__expression_list] = STATE(4225),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(170),
    [sym_subtype_clause] = STATE(272),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1541),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [137] = {
    [sym__expression_list] = STATE(4190),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(143),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1543),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1547),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [138] = {
    [sym__expression_list] = STATE(4256),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1549),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1553),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [139] = {
    [sym__expression_list] = STATE(4274),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(138),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1555),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1557),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1559),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [140] = {
    [sym__expression_list] = STATE(4254),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1561),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1563),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1565),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [141] = {
    [sym__expression_list] = STATE(4048),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1567),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1569),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1571),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [142] = {
    [sym__expression_list] = STATE(4193),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1573),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1575),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1577),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [143] = {
    [sym__expression_list] = STATE(4195),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1579),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1583),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [144] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2297),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2754),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2760),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1585),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(1585),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1585),
    [anon_sym_finally] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [145] = {
    [sym__expression_list] = STATE(4044),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1589),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1591),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1593),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [146] = {
    [sym__expression_list] = STATE(4055),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(163),
    [sym_subtype_clause] = STATE(225),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1595),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [147] = {
    [sym__expression_list] = STATE(4207),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(173),
    [sym_subtype_clause] = STATE(312),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1597),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [148] = {
    [sym__expression_list] = STATE(3929),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(123),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1599),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1603),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [149] = {
    [sym__expression_list] = STATE(2893),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3143),
    [sym_finally_clause] = STATE(4086),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1605),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [150] = {
    [sym__expression_list] = STATE(2858),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_catch_clause] = STATE(3410),
    [sym_finally_clause] = STATE(3879),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1607),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_finally] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [151] = {
    [sym__expression_list] = STATE(3863),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(1930),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1609),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1613),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [152] = {
    [sym__expression_list] = STATE(4074),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(165),
    [sym_subtype_clause] = STATE(211),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1615),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [153] = {
    [sym__expression_list] = STATE(3839),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(1931),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1621),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [154] = {
    [sym__expression_list] = STATE(4288),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(180),
    [sym_subtype_clause] = STATE(279),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1623),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [155] = {
    [sym__expression_list] = STATE(3849),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(175),
    [sym_subtype_clause] = STATE(241),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1625),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [156] = {
    [sym__expression_list] = STATE(4028),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(164),
    [sym_subtype_clause] = STATE(224),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1627),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [157] = {
    [sym__expression_list] = STATE(4067),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_for_statement_repeat1] = STATE(141),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1629),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1631),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1633),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [158] = {
    [sym__expression_list] = STATE(4065),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(145),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1635),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1639),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [159] = {
    [sym__expression_list] = STATE(3937),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_type_parameter_list] = STATE(168),
    [sym_subtype_clause] = STATE(311),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [160] = {
    [sym__expression_list] = STATE(4217),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [aux_sym_let_statement_repeat1] = STATE(142),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1643),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_COMMA] = ACTIONS(1391),
    [anon_sym_SEMI] = ACTIONS(1645),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1647),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [161] = {
    [sym__expression_list] = STATE(3745),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1649),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1651),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1653),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_finally] = ACTIONS(1651),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1655),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [162] = {
    [sym__expression_list] = STATE(3968),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(267),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1657),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [163] = {
    [sym__expression_list] = STATE(4038),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(274),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1659),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [164] = {
    [sym__expression_list] = STATE(3936),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(316),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1661),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [165] = {
    [sym__expression_list] = STATE(4054),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(227),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1663),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [166] = {
    [sym__expression_list] = STATE(3848),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(242),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1665),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [167] = {
    [sym__expression_list] = STATE(3900),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(319),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1667),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [168] = {
    [sym__expression_list] = STATE(3785),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(276),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1669),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [169] = {
    [sym__expression_list] = STATE(3915),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(223),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1671),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [170] = {
    [sym__expression_list] = STATE(4206),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(313),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1673),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [171] = {
    [sym__expression_list] = STATE(3525),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1675),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_elseif] = ACTIONS(1675),
    [anon_sym_else] = ACTIONS(1675),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [172] = {
    [sym__expression_list] = STATE(4248),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(277),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1677),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [173] = {
    [sym__expression_list] = STATE(4185),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(314),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1679),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [174] = {
    [sym__expression_list] = STATE(3996),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1681),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(83),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(95),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(99),
    [anon_sym_LBRACK2] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_AT] = ACTIONS(107),
    [aux_sym_integer_literal_token1] = ACTIONS(63),
    [aux_sym_integer_literal_token2] = ACTIONS(63),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(71),
    [sym__bitshift_operator] = ACTIONS(71),
    [sym__rational_operator] = ACTIONS(71),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(71),
    [sym__comparison_operator] = ACTIONS(71),
    [anon_sym_LF] = ACTIONS(1685),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [175] = {
    [sym__expression_list] = STATE(3833),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(247),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1687),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [176] = {
    [sym__expression_list] = STATE(3985),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(249),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1689),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [177] = {
    [sym__expression_list] = STATE(4130),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(257),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1691),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [178] = {
    [sym__expression_list] = STATE(4111),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(250),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1693),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [179] = {
    [sym__expression_list] = STATE(3789),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2496),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3653),
    [sym_spread_expression] = STATE(2627),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [180] = {
    [sym__expression_list] = STATE(4263),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_subtype_clause] = STATE(292),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1701),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_LT_COLON] = ACTIONS(1407),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [181] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1671),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3140),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1709),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [182] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1680),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3255),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1711),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1715),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [183] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1719),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3088),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1717),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1721),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [184] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1647),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3182),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_SEMI] = ACTIONS(1725),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1727),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [185] = {
    [sym__expression_list] = STATE(3621),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1729),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_finally] = ACTIONS(1729),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [186] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1772),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3239),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1731),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1735),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [187] = {
    [sym__expression_list] = STATE(3636),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(79),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_finally] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [188] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1841),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3369),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1737),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1741),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [189] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1718),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3565),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1743),
    [anon_sym_SEMI] = ACTIONS(1745),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1747),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [190] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1723),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3422),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1749),
    [anon_sym_SEMI] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1753),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [191] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1683),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3136),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_COMMA] = ACTIONS(1755),
    [anon_sym_SEMI] = ACTIONS(1757),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [192] = {
    [sym__expression_list] = STATE(4195),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1579),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [193] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2685),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3033),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1763),
    [anon_sym_RPAREN] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [194] = {
    [sym__expression_list] = STATE(3852),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1771),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [195] = {
    [sym__expression_list] = STATE(4048),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1567),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [196] = {
    [sym__expression_list] = STATE(3992),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1773),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [197] = {
    [sym__expression_list] = STATE(3984),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1775),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [198] = {
    [sym__expression_list] = STATE(4107),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1777),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [199] = {
    [sym__expression_list] = STATE(3980),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1779),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [200] = {
    [sym__expression_list] = STATE(3905),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1781),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [201] = {
    [sym__expression_list] = STATE(4052),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1783),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [202] = {
    [sym__expression_list] = STATE(3847),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1785),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [203] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2684),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2978),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1787),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [204] = {
    [sym__expression_list] = STATE(4044),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1589),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [205] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2687),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3019),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1793),
    [anon_sym_RPAREN] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [206] = {
    [sym__expression_list] = STATE(3870),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1799),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [207] = {
    [sym__expression_list] = STATE(3846),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1801),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [208] = {
    [sym__expression_list] = STATE(3976),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1443),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [209] = {
    [sym__expression_list] = STATE(4267),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1803),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [210] = {
    [sym__expression_list] = STATE(3896),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1805),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [211] = {
    [sym__expression_list] = STATE(4053),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1807),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [212] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2616),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3008),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1809),
    [anon_sym_RPAREN] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [213] = {
    [sym__expression_list] = STATE(4046),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1815),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [214] = {
    [sym__expression_list] = STATE(3842),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1527),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [215] = {
    [sym__expression_list] = STATE(4059),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1817),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [216] = {
    [sym__expression_list] = STATE(3975),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1819),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [217] = {
    [sym__expression_list] = STATE(3863),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1609),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [218] = {
    [sym__expression_list] = STATE(4287),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1821),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [219] = {
    [sym__expression_list] = STATE(3934),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1823),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [220] = {
    [sym__expression_list] = STATE(4042),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1825),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [221] = {
    [sym__expression_list] = STATE(3861),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1827),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [222] = {
    [sym__expression_list] = STATE(3898),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1829),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [223] = {
    [sym__expression_list] = STATE(3895),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1831),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [224] = {
    [sym__expression_list] = STATE(3935),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1833),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [225] = {
    [sym__expression_list] = STATE(4034),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [226] = {
    [sym__expression_list] = STATE(3839),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1617),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [227] = {
    [sym__expression_list] = STATE(4033),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1837),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [228] = {
    [sym__expression_list] = STATE(3841),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1839),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [229] = {
    [sym__expression_list] = STATE(4073),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1841),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [230] = {
    [sym__expression_list] = STATE(3840),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1437),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [231] = {
    [sym__expression_list] = STATE(3943),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1843),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [232] = {
    [sym__expression_list] = STATE(3974),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1419),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [233] = {
    [sym__expression_list] = STATE(4083),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1845),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [234] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2608),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2974),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1847),
    [anon_sym_RPAREN] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [235] = {
    [sym__expression_list] = STATE(4304),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1853),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [236] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2683),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2930),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1855),
    [anon_sym_RPAREN] = ACTIONS(1857),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [237] = {
    [sym__expression_list] = STATE(3837),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1861),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [238] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2607),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2991),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1863),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [239] = {
    [sym__expression_list] = STATE(4030),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1869),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [240] = {
    [sym__expression_list] = STATE(4029),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1871),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [241] = {
    [sym__expression_list] = STATE(3832),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1873),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [242] = {
    [sym__expression_list] = STATE(3831),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1875),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [243] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2686),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2999),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_RPAREN] = ACTIONS(1879),
    [anon_sym_SEMI] = ACTIONS(1881),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [244] = {
    [sym__expression_list] = STATE(3828),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1883),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [245] = {
    [sym__expression_list] = STATE(3825),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1885),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [246] = {
    [sym__expression_list] = STATE(3972),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1887),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [247] = {
    [sym__expression_list] = STATE(3819),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1889),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [248] = {
    [sym__expression_list] = STATE(3965),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1891),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [249] = {
    [sym__expression_list] = STATE(3964),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1893),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [250] = {
    [sym__expression_list] = STATE(4095),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1895),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [251] = {
    [sym__expression_list] = STATE(3869),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1897),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [252] = {
    [sym__expression_list] = STATE(3961),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1899),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [253] = {
    [sym__expression_list] = STATE(4232),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1901),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [254] = {
    [sym__expression_list] = STATE(4101),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1903),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [255] = {
    [sym__expression_list] = STATE(4102),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1905),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [256] = {
    [sym__expression_list] = STATE(4224),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1907),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [257] = {
    [sym__expression_list] = STATE(4106),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1909),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [258] = {
    [sym__expression_list] = STATE(4109),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1911),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [259] = {
    [sym__expression_list] = STATE(3960),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1913),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [260] = {
    [sym__expression_list] = STATE(3878),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1915),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [261] = {
    [sym__expression_list] = STATE(4026),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1917),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [262] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2600),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2949),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1919),
    [anon_sym_RPAREN] = ACTIONS(1921),
    [anon_sym_SEMI] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [263] = {
    [sym__expression_list] = STATE(4116),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1925),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [264] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2689),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2939),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1927),
    [anon_sym_RPAREN] = ACTIONS(1929),
    [anon_sym_SEMI] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [265] = {
    [sym__expression_list] = STATE(4211),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1933),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [266] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2606),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2988),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1935),
    [anon_sym_RPAREN] = ACTIONS(1937),
    [anon_sym_SEMI] = ACTIONS(1939),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [267] = {
    [sym__expression_list] = STATE(3957),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1941),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [268] = {
    [sym__expression_list] = STATE(4009),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1943),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [269] = {
    [sym__expression_list] = STATE(3907),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1519),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [270] = {
    [sym__expression_list] = STATE(4118),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1511),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [271] = {
    [sym__expression_list] = STATE(4119),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1945),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [272] = {
    [sym__expression_list] = STATE(4205),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1947),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [273] = {
    [sym__expression_list] = STATE(4121),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1505),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [274] = {
    [sym__expression_list] = STATE(4024),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1949),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [275] = {
    [sym__expression_list] = STATE(4204),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1951),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [276] = {
    [sym__expression_list] = STATE(3817),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1953),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [277] = {
    [sym__expression_list] = STATE(4239),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1955),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [278] = {
    [sym__expression_list] = STATE(3908),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1957),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [279] = {
    [sym__expression_list] = STATE(4262),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1959),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [280] = {
    [sym__expression_list] = STATE(4194),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1961),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [281] = {
    [sym__expression_list] = STATE(4193),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1573),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [282] = {
    [sym__expression_list] = STATE(4126),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1963),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [283] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2599),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3000),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1965),
    [anon_sym_RPAREN] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [284] = {
    [sym__expression_list] = STATE(4127),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1971),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [285] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2682),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2975),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1973),
    [anon_sym_RPAREN] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [286] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2605),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3023),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1979),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_SEMI] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [287] = {
    [sym__expression_list] = STATE(3909),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1483),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [288] = {
    [sym__expression_list] = STATE(4134),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1985),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [289] = {
    [sym__expression_list] = STATE(4191),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1987),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [290] = {
    [sym__expression_list] = STATE(4242),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1989),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [291] = {
    [sym__expression_list] = STATE(4243),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1991),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [292] = {
    [sym__expression_list] = STATE(4246),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1993),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [293] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2688),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2959),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_RPAREN] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [294] = {
    [sym__expression_list] = STATE(4247),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2001),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [295] = {
    [sym__expression_list] = STATE(3891),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2003),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [296] = {
    [sym__expression_list] = STATE(4149),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2005),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [297] = {
    [sym__expression_list] = STATE(4252),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2007),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [298] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2614),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(2961),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2009),
    [anon_sym_RPAREN] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [299] = {
    [sym__expression_list] = STATE(3912),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2015),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [300] = {
    [sym__expression_list] = STATE(3776),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2017),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [301] = {
    [sym__expression_list] = STATE(4163),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2019),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [302] = {
    [sym__expression_list] = STATE(3913),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2021),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [303] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2615),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3046),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2023),
    [anon_sym_RPAREN] = ACTIONS(2025),
    [anon_sym_SEMI] = ACTIONS(2027),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [304] = {
    [sym__expression_list] = STATE(3890),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2029),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [305] = {
    [sym__expression_list] = STATE(3803),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2031),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [306] = {
    [sym__expression_list] = STATE(4254),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1561),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [307] = {
    [sym__expression_list] = STATE(4255),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2033),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [308] = {
    [sym__expression_list] = STATE(3802),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2035),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [309] = {
    [sym__expression_list] = STATE(4256),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(1549),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [310] = {
    [sym__expression_list] = STATE(3950),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2037),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [311] = {
    [sym__expression_list] = STATE(3786),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2039),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [312] = {
    [sym__expression_list] = STATE(4184),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2041),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [313] = {
    [sym__expression_list] = STATE(4182),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2043),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [314] = {
    [sym__expression_list] = STATE(4174),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2045),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [315] = {
    [sym__expression_list] = STATE(3933),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2047),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [316] = {
    [sym__expression_list] = STATE(3784),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2049),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [317] = {
    [sym__expression_list] = STATE(4017),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2051),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [318] = {
    [sym__expression_list] = STATE(4261),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2053),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [319] = {
    [sym__expression_list] = STATE(3885),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2055),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [320] = {
    [sym__expression_list] = STATE(3920),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2057),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [321] = {
    [sym__expression_list] = STATE(4178),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2059),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [322] = {
    [sym__expression_list] = STATE(4177),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_end] = ACTIONS(2061),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [323] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2065),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [324] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2067),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [325] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2069),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [326] = {
    [sym__expression_list] = STATE(3804),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [327] = {
    [sym__expression_list] = STATE(3822),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [328] = {
    [sym__expression_list] = STATE(4100),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [329] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_SEMI] = ACTIONS(2071),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2071),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [330] = {
    [sym__expression_list] = STATE(3779),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2671),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [331] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2073),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [332] = {
    [sym__expression_list] = STATE(4230),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [333] = {
    [sym__expression_list] = STATE(4241),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [334] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2075),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [335] = {
    [sym__expression_list] = STATE(4097),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [336] = {
    [sym__expression_list] = STATE(3855),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2649),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [337] = {
    [sym__expression_list] = STATE(3799),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2633),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [338] = {
    [sym__expression_list] = STATE(3876),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [339] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2077),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [340] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2079),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [341] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2081),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [342] = {
    [sym__expression_list] = STATE(4081),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [343] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2083),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [344] = {
    [sym__expression_list] = STATE(3880),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2662),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [345] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2085),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [346] = {
    [sym__expression_list] = STATE(3889),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [347] = {
    [sym__expression_list] = STATE(4299),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [348] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_function] = ACTIONS(943),
    [anon_sym_abstract] = ACTIONS(946),
    [anon_sym_primitive] = ACTIONS(949),
    [aux_sym_primitive_definition_token1] = ACTIONS(952),
    [anon_sym_mutable] = ACTIONS(955),
    [anon_sym_struct] = ACTIONS(958),
    [anon_sym_module] = ACTIONS(961),
    [anon_sym_macro] = ACTIONS(964),
    [anon_sym_LPAREN] = ACTIONS(967),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(976),
    [anon_sym_while] = ACTIONS(979),
    [sym_break_statement] = ACTIONS(982),
    [sym_continue_statement] = ACTIONS(982),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_let] = ACTIONS(988),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_quote] = ACTIONS(994),
    [anon_sym_using] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_export] = ACTIONS(1000),
    [anon_sym_COLON2] = ACTIONS(2087),
    [anon_sym_RBRACK] = ACTIONS(292),
    [anon_sym_begin] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(1012),
    [anon_sym_DOLLAR] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(1018),
    [aux_sym_integer_literal_token1] = ACTIONS(1021),
    [aux_sym_integer_literal_token2] = ACTIONS(1021),
    [aux_sym_integer_literal_token3] = ACTIONS(1024),
    [sym_float_literal] = ACTIONS(1027),
    [sym__unary_operator] = ACTIONS(1320),
    [sym__power_operator] = ACTIONS(1033),
    [sym__bitshift_operator] = ACTIONS(1033),
    [sym__rational_operator] = ACTIONS(1033),
    [sym__times_operator] = ACTIONS(1036),
    [sym__plus_operator] = ACTIONS(1036),
    [sym__dotty_operator] = ACTIONS(1033),
    [sym__comparison_operator] = ACTIONS(1036),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1039),
    [sym__command_start] = ACTIONS(1042),
  },
  [349] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2090),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [350] = {
    [sym__expression_list] = STATE(3824),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2641),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [351] = {
    [sym__expression_list] = STATE(3770),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2629),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [352] = {
    [sym__expression_list] = STATE(3947),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [353] = {
    [sym__expression_list] = STATE(4160),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [354] = {
    [sym__expression_list] = STATE(4312),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2660),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [355] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2716),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3756),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2092),
    [anon_sym_RPAREN] = ACTIONS(2094),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [356] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2096),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [357] = {
    [sym__expression_list] = STATE(4027),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [358] = {
    [sym__expression_list] = STATE(4176),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [359] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2602),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2882),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2760),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [360] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2098),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [361] = {
    [sym__expression_list] = STATE(3959),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [362] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2100),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [363] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2102),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [364] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2602),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2882),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2760),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [ts_builtin_sym_end] = ACTIONS(1587),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [365] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2104),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [366] = {
    [sym__expression_list] = STATE(3793),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2640),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [367] = {
    [sym__expression_list] = STATE(4015),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [368] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2106),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [369] = {
    [sym__expression_list] = STATE(3810),
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2157),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2748),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2762),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [370] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_RBRACK] = ACTIONS(2108),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [371] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2110),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [372] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2112),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [373] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [374] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1493),
    [sym__primary_expression] = STATE(1243),
    [sym_bare_tuple_expression] = STATE(3735),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_assignment_expression] = STATE(1663),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [375] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [376] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2696),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2132),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [377] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2136),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [378] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1236),
    [sym__primary_expression] = STATE(1095),
    [sym_bare_tuple_expression] = STATE(1403),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_assignment_expression] = STATE(1661),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [379] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2604),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(3613),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2207),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [380] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(925),
    [sym__primary_expression] = STATE(870),
    [sym_bare_tuple_expression] = STATE(3705),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_assignment_expression] = STATE(1080),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [381] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [382] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2621),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2873),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2202),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [383] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [384] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [385] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [386] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [387] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [388] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2142),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(3721),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2207),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [389] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [390] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2692),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [391] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [392] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2178),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [393] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [394] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2700),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2184),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [395] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [396] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1218),
    [sym__primary_expression] = STATE(1095),
    [sym_bare_tuple_expression] = STATE(3753),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_assignment_expression] = STATE(1810),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [397] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [398] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2190),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [399] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2602),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2882),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2760),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [400] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [401] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [402] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [403] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2198),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [404] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [405] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2673),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(4011),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [406] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [407] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2681),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(4154),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [408] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [409] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [410] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [411] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [412] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2218),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [413] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [414] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2222),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [415] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2295),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2757),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2202),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [416] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [417] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [418] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1202),
    [sym__primary_expression] = STATE(1095),
    [sym_bare_tuple_expression] = STATE(1417),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_assignment_expression] = STATE(1402),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [419] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [420] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [421] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [422] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2232),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [423] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [424] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2236),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [425] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [426] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [427] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2240),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [428] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2454),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(2597),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(2567),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [429] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [430] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1192),
    [sym__primary_expression] = STATE(1095),
    [sym_bare_tuple_expression] = STATE(3603),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_assignment_expression] = STATE(1294),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [431] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2244),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [432] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2297),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2754),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2760),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [433] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [434] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2248),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [435] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2250),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [436] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [437] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2319),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(2440),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(2424),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [438] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [439] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [440] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [441] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [442] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [443] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(1095),
    [sym_bare_tuple_expression] = STATE(1655),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_assignment_expression] = STATE(1661),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [444] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [445] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2455),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3631),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(2494),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [446] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2618),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2647),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2202),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [447] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [448] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2262),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [449] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [450] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [451] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2160),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [452] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [453] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2712),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2270),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2272),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [454] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2274),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [455] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [456] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [457] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [458] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2316),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3671),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(2494),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [459] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1230),
    [sym__primary_expression] = STATE(870),
    [sym_bare_tuple_expression] = STATE(1418),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_assignment_expression] = STATE(1809),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [460] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1920),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_matrix_row] = STATE(3600),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [aux_sym_macro_argument_list_repeat1] = STATE(329),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [461] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2699),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2282),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2284),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [462] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2706),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2286),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2288),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [463] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [464] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [465] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2294),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [466] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [467] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2298),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [468] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [469] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2302),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [470] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2675),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(4226),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [471] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [472] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1279),
    [sym__primary_expression] = STATE(870),
    [sym_bare_tuple_expression] = STATE(3688),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_assignment_expression] = STATE(1783),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [473] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2266),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [474] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [475] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2697),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2306),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2308),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [476] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2691),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2310),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2312),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [477] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(932),
    [sym__primary_expression] = STATE(870),
    [sym_bare_tuple_expression] = STATE(1034),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_assignment_expression] = STATE(1082),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [478] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2664),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(1695),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [479] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [480] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2672),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3334),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(2424),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [481] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2273),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(2395),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(2567),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [482] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1296),
    [sym__primary_expression] = STATE(1095),
    [sym_bare_tuple_expression] = STATE(3651),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_assignment_expression] = STATE(1810),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [483] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2318),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [484] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [485] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2708),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_COMMA] = ACTIONS(2322),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2324),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [486] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2326),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [487] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2328),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [488] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2676),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(4037),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [489] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2330),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [490] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1208),
    [sym__primary_expression] = STATE(870),
    [sym_bare_tuple_expression] = STATE(3662),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_assignment_expression] = STATE(1783),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [491] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2678),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(3942),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [492] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [493] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1455),
    [sym__primary_expression] = STATE(1243),
    [sym_bare_tuple_expression] = STATE(1708),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_assignment_expression] = STATE(1527),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [494] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2334),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [495] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2679),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(4075),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [496] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [497] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2303),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3718),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(2347),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [498] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2338),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [499] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [500] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [501] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [502] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2680),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(3872),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [503] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1285),
    [sym__primary_expression] = STATE(870),
    [sym_bare_tuple_expression] = STATE(1499),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_assignment_expression] = STATE(1809),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [504] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [505] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2137),
    [sym__primary_expression] = STATE(1995),
    [sym_bare_tuple_expression] = STATE(2308),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2202),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [506] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [507] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2677),
    [sym__primary_expression] = STATE(2049),
    [sym_bare_tuple_expression] = STATE(3760),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_assignment_expression] = STATE(4289),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [508] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [509] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [510] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [511] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [512] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2314),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [513] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2358),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [514] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_RPAREN] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [515] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [516] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2364),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [517] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2366),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [518] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2368),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [519] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2370),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [520] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2372),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [521] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2374),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [522] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2376),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [523] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2378),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [524] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2380),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [525] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2382),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [526] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2384),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [527] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2386),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [528] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2388),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [529] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2709),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3500),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [530] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2390),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [531] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2392),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [532] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [533] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2396),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [534] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [535] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2400),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [536] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [537] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2404),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [538] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2406),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [539] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2408),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [540] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2410),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [541] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2717),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_named_field] = STATE(3668),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [542] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2412),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [543] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2414),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [544] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [545] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2418),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [546] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2420),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [547] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2422),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [548] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [549] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2426),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [550] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [551] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2430),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [552] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [553] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2258),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [554] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2729),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [555] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2650),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [556] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2626),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [557] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1356),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [558] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1353),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [559] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2259),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [560] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2639),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [561] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1351),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [562] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2596),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [563] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1358),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [564] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1384),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [565] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2704),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [566] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1297),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [567] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2637),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [568] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1366),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [569] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1376),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [570] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2636),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [571] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(947),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [572] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2634),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [573] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2703),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [574] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2632),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [575] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1355),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [576] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1701),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [577] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1383),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [578] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2380),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [579] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2663),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [580] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2670),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [581] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2669),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [582] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1707),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [583] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(45),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [584] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2668),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [585] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2648),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [586] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1014),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [587] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1011),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [588] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1385),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [589] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1009),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [590] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1006),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [591] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1001),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [592] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2299),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [593] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1352),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [594] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(983),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [595] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(982),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [596] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2293),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [597] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1789),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [598] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2288),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [599] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2285),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [600] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2284),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [601] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2283),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [602] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2281),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [603] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2279),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [604] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2278),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [605] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2197),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [606] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2272),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [607] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2270),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [608] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2269),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [609] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2265),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [610] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2320),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [611] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2723),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [612] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1572),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [613] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2727),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [614] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1361),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [615] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1569),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [616] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(15),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [617] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2728),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [618] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1347),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [619] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1346),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [620] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1904),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [621] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1633),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [622] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(74),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [623] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1868),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [624] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(971),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [625] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2721),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [626] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2702),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [627] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2724),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [628] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2667),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [629] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1903),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [630] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1910),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [631] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2628),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [632] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1902),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [633] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1901),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [634] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1789),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [635] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1642),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [636] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1828),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [637] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2701),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [638] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1816),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [639] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1815),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [640] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1813),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [641] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1648),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [642] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2587),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [643] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(79),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [644] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [645] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(14),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [646] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1650),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [647] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1652),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [648] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1656),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [649] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1657),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [650] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2730),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [651] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2698),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [652] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1658),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [653] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1659),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [654] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1660),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [655] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1909),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [656] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1662),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [657] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2715),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [658] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1770),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [659] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2554),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [660] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2666),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [661] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2642),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [662] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1928),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [663] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1924),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [664] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1083),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [665] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2350),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [666] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2351),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [667] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2352),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [668] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2354),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [669] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(70),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [670] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2565),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [671] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(16),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [672] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1037),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [673] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2356),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [674] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2366),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [675] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2367),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [676] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(73),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [677] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1086),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [678] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2693),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [679] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(975),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [680] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(11),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [681] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(974),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [682] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(973),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [683] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2725),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [684] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2694),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [685] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1838),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [686] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(71),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [687] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(13),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [688] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2731),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [689] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2711),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [690] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(972),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [691] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2422),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [692] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1571),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [693] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2719),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [694] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1806),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [695] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1922),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [696] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1913),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [697] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1911),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [698] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1923),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [699] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2714),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [700] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1926),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [701] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1917),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [702] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(63),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [703] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2417),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [704] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1918),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [705] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1301),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [706] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1927),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [707] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1906),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [708] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1919),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [709] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1784),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [710] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1040),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [711] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1866),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [712] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1921),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [713] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2423),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [714] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1912),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [715] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1925),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [716] = {
    [sym_function_definition] = STATE(1081),
    [sym_abstract_definition] = STATE(1081),
    [sym_primitive_definition] = STATE(1081),
    [sym_struct_definition] = STATE(1081),
    [sym_module_definition] = STATE(1081),
    [sym_macro_definition] = STATE(1081),
    [sym_parameter_list] = STATE(3954),
    [sym_if_statement] = STATE(1081),
    [sym_try_statement] = STATE(1081),
    [sym_for_statement] = STATE(1081),
    [sym_while_statement] = STATE(1081),
    [sym_return_statement] = STATE(1081),
    [sym_let_statement] = STATE(1081),
    [sym_const_statement] = STATE(1081),
    [sym_quote_statement] = STATE(1081),
    [sym_import_statement] = STATE(1081),
    [sym_export_statement] = STATE(1081),
    [sym__expression] = STATE(1019),
    [sym__primary_expression] = STATE(870),
    [sym_operator] = STATE(919),
    [sym_parenthesized_expression] = STATE(870),
    [sym_field_expression] = STATE(818),
    [sym_subscript_expression] = STATE(870),
    [sym_typed_expression] = STATE(1081),
    [sym_parameterized_identifier] = STATE(870),
    [sym_compound_expression] = STATE(1081),
    [sym_call_expression] = STATE(870),
    [sym_broadcast_call_expression] = STATE(870),
    [sym_macro_expression] = STATE(1081),
    [sym_spread_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_ternary_expression] = STATE(1081),
    [sym_pair_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(870),
    [sym_array_expression] = STATE(870),
    [sym_matrix_expression] = STATE(870),
    [sym_generator_expression] = STATE(1081),
    [sym_array_comprehension_expression] = STATE(870),
    [sym_function_expression] = STATE(1081),
    [sym_range_expression] = STATE(1081),
    [sym_coefficient_expression] = STATE(1081),
    [sym_quote_expression] = STATE(1081),
    [sym_interpolation_expression] = STATE(1081),
    [sym_macro_identifier] = STATE(4),
    [sym__literal] = STATE(894),
    [sym_integer_literal] = STATE(894),
    [sym_character_literal] = STATE(894),
    [sym_string_literal] = STATE(894),
    [sym_command_literal] = STATE(894),
    [sym_prefixed_string_literal] = STATE(894),
    [sym_prefixed_command_literal] = STATE(894),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_function] = ACTIONS(123),
    [anon_sym_abstract] = ACTIONS(127),
    [anon_sym_primitive] = ACTIONS(129),
    [aux_sym_primitive_definition_token1] = ACTIONS(131),
    [anon_sym_mutable] = ACTIONS(133),
    [anon_sym_struct] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(137),
    [anon_sym_macro] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_if] = ACTIONS(143),
    [anon_sym_try] = ACTIONS(145),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(149),
    [sym_break_statement] = ACTIONS(151),
    [sym_continue_statement] = ACTIONS(151),
    [anon_sym_return] = ACTIONS(153),
    [anon_sym_let] = ACTIONS(155),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_quote] = ACTIONS(159),
    [anon_sym_using] = ACTIONS(161),
    [anon_sym_import] = ACTIONS(161),
    [anon_sym_export] = ACTIONS(163),
    [anon_sym_COLON2] = ACTIONS(2146),
    [anon_sym_begin] = ACTIONS(167),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_LBRACK2] = ACTIONS(2150),
    [anon_sym_DOLLAR] = ACTIONS(2152),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(2154),
    [aux_sym_integer_literal_token2] = ACTIONS(2154),
    [aux_sym_integer_literal_token3] = ACTIONS(175),
    [sym_float_literal] = ACTIONS(177),
    [sym__unary_operator] = ACTIONS(179),
    [sym__power_operator] = ACTIONS(2156),
    [sym__bitshift_operator] = ACTIONS(2156),
    [sym__rational_operator] = ACTIONS(2156),
    [sym__times_operator] = ACTIONS(181),
    [sym__plus_operator] = ACTIONS(181),
    [sym__dotty_operator] = ACTIONS(2156),
    [sym__comparison_operator] = ACTIONS(181),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(187),
    [sym__command_start] = ACTIONS(189),
  },
  [717] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1916),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [718] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1798),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [719] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1869),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [720] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1870),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [721] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1872),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [722] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1879),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [723] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1884),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [724] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1802),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [725] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1693),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [726] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(3801),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1914),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(52),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(2063),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(1051),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [727] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2653),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [728] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1844),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [729] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2713),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [730] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4317),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2246),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(3),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(81),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(91),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(93),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(1339),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(1341),
    [anon_sym_AT] = ACTIONS(1343),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(109),
    [sym__unary_operator] = ACTIONS(111),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [731] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(3882),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1862),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(33),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(748),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2438),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(754),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [732] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2722),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [733] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1691),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [734] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(17),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [735] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2720),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [736] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1905),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [737] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1643),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [738] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(21),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [739] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1644),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [740] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1645),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [741] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2631),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [742] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2732),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [743] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1646),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [744] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1798),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [745] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2695),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [746] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1900),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [747] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1899),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [748] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1898),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [749] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(72),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [750] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2707),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [751] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1392),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [752] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2635),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [753] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2638),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [754] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2718),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [755] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1836),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [756] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2391),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [757] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2389),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [758] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2378),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [759] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2368),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [760] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2336),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [761] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1811),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [762] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1792),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [763] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1767),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [764] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1764),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [765] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2595),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [766] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2594),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [767] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1759),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [768] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1758),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [769] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2544),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [770] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2591),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [771] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2588),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [772] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2596),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [773] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2586),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [774] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2582),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [775] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2579),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [776] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2578),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [777] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2575),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [778] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2574),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [779] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2572),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [780] = {
    [sym_function_definition] = STATE(1713),
    [sym_abstract_definition] = STATE(1713),
    [sym_primitive_definition] = STATE(1713),
    [sym_struct_definition] = STATE(1713),
    [sym_module_definition] = STATE(1713),
    [sym_macro_definition] = STATE(1713),
    [sym_parameter_list] = STATE(4089),
    [sym_if_statement] = STATE(1713),
    [sym_try_statement] = STATE(1713),
    [sym_for_statement] = STATE(1713),
    [sym_while_statement] = STATE(1713),
    [sym_return_statement] = STATE(1713),
    [sym_let_statement] = STATE(1713),
    [sym_const_statement] = STATE(1713),
    [sym_quote_statement] = STATE(1713),
    [sym_import_statement] = STATE(1713),
    [sym_export_statement] = STATE(1713),
    [sym__expression] = STATE(1756),
    [sym__primary_expression] = STATE(1243),
    [sym_operator] = STATE(1492),
    [sym_parenthesized_expression] = STATE(1243),
    [sym_field_expression] = STATE(1012),
    [sym_subscript_expression] = STATE(1243),
    [sym_typed_expression] = STATE(1713),
    [sym_parameterized_identifier] = STATE(1243),
    [sym_compound_expression] = STATE(1713),
    [sym_call_expression] = STATE(1243),
    [sym_broadcast_call_expression] = STATE(1243),
    [sym_macro_expression] = STATE(1713),
    [sym_spread_expression] = STATE(1713),
    [sym_unary_expression] = STATE(1713),
    [sym_binary_expression] = STATE(1713),
    [sym_ternary_expression] = STATE(1713),
    [sym_pair_expression] = STATE(1713),
    [sym_tuple_expression] = STATE(1243),
    [sym_array_expression] = STATE(1243),
    [sym_matrix_expression] = STATE(1243),
    [sym_generator_expression] = STATE(1713),
    [sym_array_comprehension_expression] = STATE(1243),
    [sym_function_expression] = STATE(1713),
    [sym_range_expression] = STATE(1713),
    [sym_coefficient_expression] = STATE(1713),
    [sym_quote_expression] = STATE(1713),
    [sym_interpolation_expression] = STATE(1713),
    [sym_macro_identifier] = STATE(27),
    [sym__literal] = STATE(1494),
    [sym_integer_literal] = STATE(1494),
    [sym_character_literal] = STATE(1494),
    [sym_string_literal] = STATE(1494),
    [sym_command_literal] = STATE(1494),
    [sym_prefixed_string_literal] = STATE(1494),
    [sym_prefixed_command_literal] = STATE(1494),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_abstract] = ACTIONS(546),
    [anon_sym_primitive] = ACTIONS(548),
    [aux_sym_primitive_definition_token1] = ACTIONS(550),
    [anon_sym_mutable] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_module] = ACTIONS(556),
    [anon_sym_macro] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_while] = ACTIONS(568),
    [sym_break_statement] = ACTIONS(570),
    [sym_continue_statement] = ACTIONS(570),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_let] = ACTIONS(574),
    [anon_sym_const] = ACTIONS(576),
    [anon_sym_quote] = ACTIONS(578),
    [anon_sym_using] = ACTIONS(580),
    [anon_sym_import] = ACTIONS(580),
    [anon_sym_export] = ACTIONS(582),
    [anon_sym_COLON2] = ACTIONS(2118),
    [anon_sym_begin] = ACTIONS(586),
    [anon_sym_SQUOTE] = ACTIONS(2120),
    [anon_sym_LBRACK2] = ACTIONS(2122),
    [anon_sym_DOLLAR] = ACTIONS(2124),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(2126),
    [aux_sym_integer_literal_token2] = ACTIONS(2126),
    [aux_sym_integer_literal_token3] = ACTIONS(596),
    [sym_float_literal] = ACTIONS(598),
    [sym__unary_operator] = ACTIONS(600),
    [sym__power_operator] = ACTIONS(2128),
    [sym__bitshift_operator] = ACTIONS(2128),
    [sym__rational_operator] = ACTIONS(2128),
    [sym__times_operator] = ACTIONS(602),
    [sym__plus_operator] = ACTIONS(602),
    [sym__dotty_operator] = ACTIONS(2128),
    [sym__comparison_operator] = ACTIONS(602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(604),
    [sym__command_start] = ACTIONS(606),
  },
  [781] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2592),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [782] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1897),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [783] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2343),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [784] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1710),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [785] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1896),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [786] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2644),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [787] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1895),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [788] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2646),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [789] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2655),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [790] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1606),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [791] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2710),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [792] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1907),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [793] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(1894),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [794] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2656),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [795] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2690),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [796] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2674),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [797] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2658),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [798] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2665),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [799] = {
    [sym_function_definition] = STATE(1855),
    [sym_abstract_definition] = STATE(1855),
    [sym_primitive_definition] = STATE(1855),
    [sym_struct_definition] = STATE(1855),
    [sym_module_definition] = STATE(1855),
    [sym_macro_definition] = STATE(1855),
    [sym_parameter_list] = STATE(4171),
    [sym_if_statement] = STATE(1855),
    [sym_try_statement] = STATE(1855),
    [sym_for_statement] = STATE(1855),
    [sym_while_statement] = STATE(1855),
    [sym_return_statement] = STATE(1855),
    [sym_let_statement] = STATE(1855),
    [sym_const_statement] = STATE(1855),
    [sym_quote_statement] = STATE(1855),
    [sym_import_statement] = STATE(1855),
    [sym_export_statement] = STATE(1855),
    [sym__expression] = STATE(1808),
    [sym__primary_expression] = STATE(1237),
    [sym_operator] = STATE(1461),
    [sym_parenthesized_expression] = STATE(1237),
    [sym_field_expression] = STATE(1088),
    [sym_subscript_expression] = STATE(1237),
    [sym_typed_expression] = STATE(1855),
    [sym_parameterized_identifier] = STATE(1237),
    [sym_compound_expression] = STATE(1855),
    [sym_call_expression] = STATE(1237),
    [sym_broadcast_call_expression] = STATE(1237),
    [sym_macro_expression] = STATE(1855),
    [sym_spread_expression] = STATE(1855),
    [sym_unary_expression] = STATE(1855),
    [sym_binary_expression] = STATE(1855),
    [sym_ternary_expression] = STATE(1855),
    [sym_pair_expression] = STATE(1855),
    [sym_tuple_expression] = STATE(1237),
    [sym_array_expression] = STATE(1237),
    [sym_matrix_expression] = STATE(1237),
    [sym_generator_expression] = STATE(1855),
    [sym_array_comprehension_expression] = STATE(1237),
    [sym_function_expression] = STATE(1855),
    [sym_range_expression] = STATE(1855),
    [sym_coefficient_expression] = STATE(1855),
    [sym_quote_expression] = STATE(1855),
    [sym_interpolation_expression] = STATE(1855),
    [sym_macro_identifier] = STATE(28),
    [sym__literal] = STATE(1462),
    [sym_integer_literal] = STATE(1462),
    [sym_character_literal] = STATE(1462),
    [sym_string_literal] = STATE(1462),
    [sym_command_literal] = STATE(1462),
    [sym_prefixed_string_literal] = STATE(1462),
    [sym_prefixed_command_literal] = STATE(1462),
    [sym_identifier] = ACTIONS(610),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(614),
    [anon_sym_primitive] = ACTIONS(616),
    [aux_sym_primitive_definition_token1] = ACTIONS(618),
    [anon_sym_mutable] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(624),
    [anon_sym_macro] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_try] = ACTIONS(632),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_while] = ACTIONS(636),
    [sym_break_statement] = ACTIONS(638),
    [sym_continue_statement] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(640),
    [anon_sym_let] = ACTIONS(642),
    [anon_sym_const] = ACTIONS(644),
    [anon_sym_quote] = ACTIONS(646),
    [anon_sym_using] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(650),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_begin] = ACTIONS(654),
    [anon_sym_SQUOTE] = ACTIONS(656),
    [anon_sym_LBRACK2] = ACTIONS(658),
    [anon_sym_DOLLAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(664),
    [aux_sym_integer_literal_token2] = ACTIONS(664),
    [aux_sym_integer_literal_token3] = ACTIONS(666),
    [sym_float_literal] = ACTIONS(668),
    [sym__unary_operator] = ACTIONS(670),
    [sym__power_operator] = ACTIONS(672),
    [sym__bitshift_operator] = ACTIONS(672),
    [sym__rational_operator] = ACTIONS(672),
    [sym__times_operator] = ACTIONS(674),
    [sym__plus_operator] = ACTIONS(674),
    [sym__dotty_operator] = ACTIONS(672),
    [sym__comparison_operator] = ACTIONS(674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(678),
    [sym__command_start] = ACTIONS(680),
  },
  [800] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2503),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [801] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(19),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [802] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2726),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [803] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2657),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [804] = {
    [sym_function_definition] = STATE(1554),
    [sym_abstract_definition] = STATE(1554),
    [sym_primitive_definition] = STATE(1554),
    [sym_struct_definition] = STATE(1554),
    [sym_module_definition] = STATE(1554),
    [sym_macro_definition] = STATE(1554),
    [sym_parameter_list] = STATE(4236),
    [sym_if_statement] = STATE(1554),
    [sym_try_statement] = STATE(1554),
    [sym_for_statement] = STATE(1554),
    [sym_while_statement] = STATE(1554),
    [sym_return_statement] = STATE(1554),
    [sym_let_statement] = STATE(1554),
    [sym_const_statement] = STATE(1554),
    [sym_quote_statement] = STATE(1554),
    [sym_import_statement] = STATE(1554),
    [sym_export_statement] = STATE(1554),
    [sym__expression] = STATE(78),
    [sym__primary_expression] = STATE(1203),
    [sym_operator] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_field_expression] = STATE(1090),
    [sym_subscript_expression] = STATE(1203),
    [sym_typed_expression] = STATE(1554),
    [sym_parameterized_identifier] = STATE(1203),
    [sym_compound_expression] = STATE(1554),
    [sym_call_expression] = STATE(1203),
    [sym_broadcast_call_expression] = STATE(1203),
    [sym_macro_expression] = STATE(1554),
    [sym_spread_expression] = STATE(1554),
    [sym_unary_expression] = STATE(1554),
    [sym_binary_expression] = STATE(1554),
    [sym_ternary_expression] = STATE(1554),
    [sym_pair_expression] = STATE(1554),
    [sym_tuple_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_matrix_expression] = STATE(1203),
    [sym_generator_expression] = STATE(1554),
    [sym_array_comprehension_expression] = STATE(1203),
    [sym_function_expression] = STATE(1554),
    [sym_range_expression] = STATE(1554),
    [sym_coefficient_expression] = STATE(1554),
    [sym_quote_expression] = STATE(1554),
    [sym_interpolation_expression] = STATE(1554),
    [sym_macro_identifier] = STATE(42),
    [sym__literal] = STATE(1435),
    [sym_integer_literal] = STATE(1435),
    [sym_character_literal] = STATE(1435),
    [sym_string_literal] = STATE(1435),
    [sym_command_literal] = STATE(1435),
    [sym_prefixed_string_literal] = STATE(1435),
    [sym_prefixed_command_literal] = STATE(1435),
    [sym_identifier] = ACTIONS(476),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_abstract] = ACTIONS(480),
    [anon_sym_primitive] = ACTIONS(482),
    [aux_sym_primitive_definition_token1] = ACTIONS(484),
    [anon_sym_mutable] = ACTIONS(486),
    [anon_sym_struct] = ACTIONS(488),
    [anon_sym_module] = ACTIONS(490),
    [anon_sym_macro] = ACTIONS(492),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(500),
    [anon_sym_while] = ACTIONS(502),
    [sym_break_statement] = ACTIONS(504),
    [sym_continue_statement] = ACTIONS(504),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_let] = ACTIONS(508),
    [anon_sym_const] = ACTIONS(510),
    [anon_sym_quote] = ACTIONS(512),
    [anon_sym_using] = ACTIONS(514),
    [anon_sym_import] = ACTIONS(514),
    [anon_sym_export] = ACTIONS(516),
    [anon_sym_COLON2] = ACTIONS(2452),
    [anon_sym_begin] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [anon_sym_LBRACK2] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2454),
    [anon_sym_AT] = ACTIONS(2446),
    [aux_sym_integer_literal_token1] = ACTIONS(2448),
    [aux_sym_integer_literal_token2] = ACTIONS(2448),
    [aux_sym_integer_literal_token3] = ACTIONS(530),
    [sym_float_literal] = ACTIONS(532),
    [sym__unary_operator] = ACTIONS(534),
    [sym__power_operator] = ACTIONS(2450),
    [sym__bitshift_operator] = ACTIONS(2450),
    [sym__rational_operator] = ACTIONS(2450),
    [sym__times_operator] = ACTIONS(536),
    [sym__plus_operator] = ACTIONS(536),
    [sym__dotty_operator] = ACTIONS(2450),
    [sym__comparison_operator] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(538),
    [sym__command_start] = ACTIONS(540),
  },
  [805] = {
    [sym_function_definition] = STATE(1415),
    [sym_abstract_definition] = STATE(1415),
    [sym_primitive_definition] = STATE(1415),
    [sym_struct_definition] = STATE(1415),
    [sym_module_definition] = STATE(1415),
    [sym_macro_definition] = STATE(1415),
    [sym_parameter_list] = STATE(3775),
    [sym_if_statement] = STATE(1415),
    [sym_try_statement] = STATE(1415),
    [sym_for_statement] = STATE(1415),
    [sym_while_statement] = STATE(1415),
    [sym_return_statement] = STATE(1415),
    [sym_let_statement] = STATE(1415),
    [sym_const_statement] = STATE(1415),
    [sym_quote_statement] = STATE(1415),
    [sym_import_statement] = STATE(1415),
    [sym_export_statement] = STATE(1415),
    [sym__expression] = STATE(1334),
    [sym__primary_expression] = STATE(1095),
    [sym_operator] = STATE(1224),
    [sym_parenthesized_expression] = STATE(1095),
    [sym_field_expression] = STATE(883),
    [sym_subscript_expression] = STATE(1095),
    [sym_typed_expression] = STATE(1415),
    [sym_parameterized_identifier] = STATE(1095),
    [sym_compound_expression] = STATE(1415),
    [sym_call_expression] = STATE(1095),
    [sym_broadcast_call_expression] = STATE(1095),
    [sym_macro_expression] = STATE(1415),
    [sym_spread_expression] = STATE(1415),
    [sym_unary_expression] = STATE(1415),
    [sym_binary_expression] = STATE(1415),
    [sym_ternary_expression] = STATE(1415),
    [sym_pair_expression] = STATE(1415),
    [sym_tuple_expression] = STATE(1095),
    [sym_array_expression] = STATE(1095),
    [sym_matrix_expression] = STATE(1095),
    [sym_generator_expression] = STATE(1415),
    [sym_array_comprehension_expression] = STATE(1095),
    [sym_function_expression] = STATE(1415),
    [sym_range_expression] = STATE(1415),
    [sym_coefficient_expression] = STATE(1415),
    [sym_quote_expression] = STATE(1415),
    [sym_interpolation_expression] = STATE(1415),
    [sym_macro_identifier] = STATE(12),
    [sym__literal] = STATE(1225),
    [sym_integer_literal] = STATE(1225),
    [sym_character_literal] = STATE(1225),
    [sym_string_literal] = STATE(1225),
    [sym_command_literal] = STATE(1225),
    [sym_prefixed_string_literal] = STATE(1225),
    [sym_prefixed_command_literal] = STATE(1225),
    [sym_identifier] = ACTIONS(358),
    [anon_sym_function] = ACTIONS(360),
    [anon_sym_abstract] = ACTIONS(362),
    [anon_sym_primitive] = ACTIONS(364),
    [aux_sym_primitive_definition_token1] = ACTIONS(366),
    [anon_sym_mutable] = ACTIONS(368),
    [anon_sym_struct] = ACTIONS(370),
    [anon_sym_module] = ACTIONS(372),
    [anon_sym_macro] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(384),
    [sym_break_statement] = ACTIONS(386),
    [sym_continue_statement] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(388),
    [anon_sym_let] = ACTIONS(390),
    [anon_sym_const] = ACTIONS(392),
    [anon_sym_quote] = ACTIONS(394),
    [anon_sym_using] = ACTIONS(396),
    [anon_sym_import] = ACTIONS(396),
    [anon_sym_export] = ACTIONS(398),
    [anon_sym_COLON2] = ACTIONS(2138),
    [anon_sym_begin] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(404),
    [anon_sym_LBRACK2] = ACTIONS(406),
    [anon_sym_DOLLAR] = ACTIONS(2140),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(412),
    [aux_sym_integer_literal_token2] = ACTIONS(412),
    [aux_sym_integer_literal_token3] = ACTIONS(414),
    [sym_float_literal] = ACTIONS(416),
    [sym__unary_operator] = ACTIONS(418),
    [sym__power_operator] = ACTIONS(2142),
    [sym__bitshift_operator] = ACTIONS(2142),
    [sym__rational_operator] = ACTIONS(2142),
    [sym__times_operator] = ACTIONS(420),
    [sym__plus_operator] = ACTIONS(420),
    [sym__dotty_operator] = ACTIONS(2142),
    [sym__comparison_operator] = ACTIONS(420),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(424),
    [sym__command_start] = ACTIONS(426),
  },
  [806] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2197),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [807] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2652),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [808] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3790),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2651),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(65),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(1323),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(2434),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(1329),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [809] = {
    [sym_function_definition] = STATE(2364),
    [sym_abstract_definition] = STATE(2364),
    [sym_primitive_definition] = STATE(2364),
    [sym_struct_definition] = STATE(2364),
    [sym_module_definition] = STATE(2364),
    [sym_macro_definition] = STATE(2364),
    [sym_parameter_list] = STATE(4021),
    [sym_if_statement] = STATE(2364),
    [sym_try_statement] = STATE(2364),
    [sym_for_statement] = STATE(2364),
    [sym_while_statement] = STATE(2364),
    [sym_return_statement] = STATE(2364),
    [sym_let_statement] = STATE(2364),
    [sym_const_statement] = STATE(2364),
    [sym_quote_statement] = STATE(2364),
    [sym_import_statement] = STATE(2364),
    [sym_export_statement] = STATE(2364),
    [sym__expression] = STATE(2397),
    [sym__primary_expression] = STATE(2049),
    [sym_operator] = STATE(2271),
    [sym_parenthesized_expression] = STATE(2049),
    [sym_field_expression] = STATE(2002),
    [sym_subscript_expression] = STATE(2049),
    [sym_typed_expression] = STATE(2364),
    [sym_parameterized_identifier] = STATE(2049),
    [sym_compound_expression] = STATE(2364),
    [sym_call_expression] = STATE(2049),
    [sym_broadcast_call_expression] = STATE(2049),
    [sym_macro_expression] = STATE(2364),
    [sym_spread_expression] = STATE(2364),
    [sym_unary_expression] = STATE(2364),
    [sym_binary_expression] = STATE(2364),
    [sym_ternary_expression] = STATE(2364),
    [sym_pair_expression] = STATE(2364),
    [sym_tuple_expression] = STATE(2049),
    [sym_array_expression] = STATE(2049),
    [sym_matrix_expression] = STATE(2049),
    [sym_generator_expression] = STATE(2364),
    [sym_array_comprehension_expression] = STATE(2049),
    [sym_function_expression] = STATE(2364),
    [sym_range_expression] = STATE(2364),
    [sym_coefficient_expression] = STATE(2364),
    [sym_quote_expression] = STATE(2364),
    [sym_interpolation_expression] = STATE(2364),
    [sym_macro_identifier] = STATE(18),
    [sym__literal] = STATE(2274),
    [sym_integer_literal] = STATE(2274),
    [sym_character_literal] = STATE(2274),
    [sym_string_literal] = STATE(2274),
    [sym_command_literal] = STATE(2274),
    [sym_prefixed_string_literal] = STATE(2274),
    [sym_prefixed_command_literal] = STATE(2274),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(686),
    [anon_sym_primitive] = ACTIONS(688),
    [aux_sym_primitive_definition_token1] = ACTIONS(690),
    [anon_sym_mutable] = ACTIONS(692),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_module] = ACTIONS(696),
    [anon_sym_macro] = ACTIONS(698),
    [anon_sym_LPAREN] = ACTIONS(700),
    [anon_sym_if] = ACTIONS(702),
    [anon_sym_try] = ACTIONS(704),
    [anon_sym_for] = ACTIONS(706),
    [anon_sym_while] = ACTIONS(708),
    [sym_break_statement] = ACTIONS(710),
    [sym_continue_statement] = ACTIONS(710),
    [anon_sym_return] = ACTIONS(712),
    [anon_sym_let] = ACTIONS(714),
    [anon_sym_const] = ACTIONS(716),
    [anon_sym_quote] = ACTIONS(718),
    [anon_sym_using] = ACTIONS(720),
    [anon_sym_import] = ACTIONS(720),
    [anon_sym_export] = ACTIONS(722),
    [anon_sym_COLON2] = ACTIONS(2202),
    [anon_sym_begin] = ACTIONS(726),
    [anon_sym_SQUOTE] = ACTIONS(728),
    [anon_sym_LBRACK2] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(410),
    [aux_sym_integer_literal_token1] = ACTIONS(734),
    [aux_sym_integer_literal_token2] = ACTIONS(734),
    [aux_sym_integer_literal_token3] = ACTIONS(736),
    [sym_float_literal] = ACTIONS(738),
    [sym__unary_operator] = ACTIONS(740),
    [sym__power_operator] = ACTIONS(2206),
    [sym__bitshift_operator] = ACTIONS(2206),
    [sym__rational_operator] = ACTIONS(2206),
    [sym__times_operator] = ACTIONS(742),
    [sym__plus_operator] = ACTIONS(742),
    [sym__dotty_operator] = ACTIONS(2206),
    [sym__comparison_operator] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(744),
    [sym__command_start] = ACTIONS(746),
  },
  [810] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2645),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [811] = {
    [sym_function_definition] = STATE(2557),
    [sym_abstract_definition] = STATE(2557),
    [sym_primitive_definition] = STATE(2557),
    [sym_struct_definition] = STATE(2557),
    [sym_module_definition] = STATE(2557),
    [sym_macro_definition] = STATE(2557),
    [sym_parameter_list] = STATE(3815),
    [sym_if_statement] = STATE(2557),
    [sym_try_statement] = STATE(2557),
    [sym_for_statement] = STATE(2557),
    [sym_while_statement] = STATE(2557),
    [sym_return_statement] = STATE(2557),
    [sym_let_statement] = STATE(2557),
    [sym_const_statement] = STATE(2557),
    [sym_quote_statement] = STATE(2557),
    [sym_import_statement] = STATE(2557),
    [sym_export_statement] = STATE(2557),
    [sym__expression] = STATE(2705),
    [sym__primary_expression] = STATE(2256),
    [sym_operator] = STATE(2451),
    [sym_parenthesized_expression] = STATE(2256),
    [sym_field_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2256),
    [sym_typed_expression] = STATE(2557),
    [sym_parameterized_identifier] = STATE(2256),
    [sym_compound_expression] = STATE(2557),
    [sym_call_expression] = STATE(2256),
    [sym_broadcast_call_expression] = STATE(2256),
    [sym_macro_expression] = STATE(2557),
    [sym_spread_expression] = STATE(2557),
    [sym_unary_expression] = STATE(2557),
    [sym_binary_expression] = STATE(2557),
    [sym_ternary_expression] = STATE(2557),
    [sym_pair_expression] = STATE(2557),
    [sym_tuple_expression] = STATE(2256),
    [sym_array_expression] = STATE(2256),
    [sym_matrix_expression] = STATE(2256),
    [sym_generator_expression] = STATE(2557),
    [sym_array_comprehension_expression] = STATE(2256),
    [sym_function_expression] = STATE(2557),
    [sym_range_expression] = STATE(2557),
    [sym_coefficient_expression] = STATE(2557),
    [sym_quote_expression] = STATE(2557),
    [sym_interpolation_expression] = STATE(2557),
    [sym_macro_identifier] = STATE(37),
    [sym__literal] = STATE(2449),
    [sym_integer_literal] = STATE(2449),
    [sym_character_literal] = STATE(2449),
    [sym_string_literal] = STATE(2449),
    [sym_command_literal] = STATE(2449),
    [sym_prefixed_string_literal] = STATE(2449),
    [sym_prefixed_command_literal] = STATE(2449),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_function] = ACTIONS(870),
    [anon_sym_abstract] = ACTIONS(872),
    [anon_sym_primitive] = ACTIONS(874),
    [aux_sym_primitive_definition_token1] = ACTIONS(876),
    [anon_sym_mutable] = ACTIONS(878),
    [anon_sym_struct] = ACTIONS(880),
    [anon_sym_module] = ACTIONS(882),
    [anon_sym_macro] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_if] = ACTIONS(888),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(892),
    [anon_sym_while] = ACTIONS(894),
    [sym_break_statement] = ACTIONS(896),
    [sym_continue_statement] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(900),
    [anon_sym_const] = ACTIONS(902),
    [anon_sym_quote] = ACTIONS(904),
    [anon_sym_using] = ACTIONS(906),
    [anon_sym_import] = ACTIONS(906),
    [anon_sym_export] = ACTIONS(908),
    [anon_sym_COLON2] = ACTIONS(1769),
    [anon_sym_begin] = ACTIONS(912),
    [anon_sym_SQUOTE] = ACTIONS(914),
    [anon_sym_LBRACK2] = ACTIONS(916),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_AT] = ACTIONS(662),
    [aux_sym_integer_literal_token1] = ACTIONS(920),
    [aux_sym_integer_literal_token2] = ACTIONS(920),
    [aux_sym_integer_literal_token3] = ACTIONS(922),
    [sym_float_literal] = ACTIONS(924),
    [sym__unary_operator] = ACTIONS(926),
    [sym__power_operator] = ACTIONS(928),
    [sym__bitshift_operator] = ACTIONS(928),
    [sym__rational_operator] = ACTIONS(928),
    [sym__times_operator] = ACTIONS(930),
    [sym__plus_operator] = ACTIONS(930),
    [sym__dotty_operator] = ACTIONS(928),
    [sym__comparison_operator] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
    [sym__command_start] = ACTIONS(934),
  },
  [812] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2654),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [813] = {
    [sym_function_definition] = STATE(2123),
    [sym_abstract_definition] = STATE(2123),
    [sym_primitive_definition] = STATE(2123),
    [sym_struct_definition] = STATE(2123),
    [sym_module_definition] = STATE(2123),
    [sym_macro_definition] = STATE(2123),
    [sym_parameter_list] = STATE(4197),
    [sym_if_statement] = STATE(2123),
    [sym_try_statement] = STATE(2123),
    [sym_for_statement] = STATE(2123),
    [sym_while_statement] = STATE(2123),
    [sym_return_statement] = STATE(2123),
    [sym_let_statement] = STATE(2123),
    [sym_const_statement] = STATE(2123),
    [sym_quote_statement] = STATE(2123),
    [sym_import_statement] = STATE(2123),
    [sym_export_statement] = STATE(2123),
    [sym__expression] = STATE(2661),
    [sym__primary_expression] = STATE(1995),
    [sym_operator] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1995),
    [sym_field_expression] = STATE(1946),
    [sym_subscript_expression] = STATE(1995),
    [sym_typed_expression] = STATE(2123),
    [sym_parameterized_identifier] = STATE(1995),
    [sym_compound_expression] = STATE(2123),
    [sym_call_expression] = STATE(1995),
    [sym_broadcast_call_expression] = STATE(1995),
    [sym_macro_expression] = STATE(2123),
    [sym_spread_expression] = STATE(2123),
    [sym_unary_expression] = STATE(2123),
    [sym_binary_expression] = STATE(2123),
    [sym_ternary_expression] = STATE(2123),
    [sym_pair_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(1995),
    [sym_array_expression] = STATE(1995),
    [sym_matrix_expression] = STATE(1995),
    [sym_generator_expression] = STATE(2123),
    [sym_array_comprehension_expression] = STATE(1995),
    [sym_function_expression] = STATE(2123),
    [sym_range_expression] = STATE(2123),
    [sym_coefficient_expression] = STATE(2123),
    [sym_quote_expression] = STATE(2123),
    [sym_interpolation_expression] = STATE(2123),
    [sym_macro_identifier] = STATE(26),
    [sym__literal] = STATE(2052),
    [sym_integer_literal] = STATE(2052),
    [sym_character_literal] = STATE(2052),
    [sym_string_literal] = STATE(2052),
    [sym_command_literal] = STATE(2052),
    [sym_prefixed_string_literal] = STATE(2052),
    [sym_prefixed_command_literal] = STATE(2052),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(9),
    [anon_sym_abstract] = ACTIONS(11),
    [anon_sym_primitive] = ACTIONS(13),
    [aux_sym_primitive_definition_token1] = ACTIONS(15),
    [anon_sym_mutable] = ACTIONS(17),
    [anon_sym_struct] = ACTIONS(19),
    [anon_sym_module] = ACTIONS(21),
    [anon_sym_macro] = ACTIONS(23),
    [anon_sym_LPAREN] = ACTIONS(25),
    [anon_sym_if] = ACTIONS(27),
    [anon_sym_try] = ACTIONS(29),
    [anon_sym_for] = ACTIONS(31),
    [anon_sym_while] = ACTIONS(33),
    [sym_break_statement] = ACTIONS(35),
    [sym_continue_statement] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_const] = ACTIONS(41),
    [anon_sym_quote] = ACTIONS(43),
    [anon_sym_using] = ACTIONS(45),
    [anon_sym_import] = ACTIONS(45),
    [anon_sym_export] = ACTIONS(47),
    [anon_sym_COLON2] = ACTIONS(49),
    [anon_sym_begin] = ACTIONS(51),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym_LBRACK2] = ACTIONS(55),
    [anon_sym_DOLLAR] = ACTIONS(57),
    [anon_sym_AT] = ACTIONS(59),
    [aux_sym_integer_literal_token1] = ACTIONS(61),
    [aux_sym_integer_literal_token2] = ACTIONS(61),
    [aux_sym_integer_literal_token3] = ACTIONS(63),
    [sym_float_literal] = ACTIONS(65),
    [sym__unary_operator] = ACTIONS(67),
    [sym__power_operator] = ACTIONS(69),
    [sym__bitshift_operator] = ACTIONS(69),
    [sym__rational_operator] = ACTIONS(69),
    [sym__times_operator] = ACTIONS(71),
    [sym__plus_operator] = ACTIONS(71),
    [sym__dotty_operator] = ACTIONS(69),
    [sym__comparison_operator] = ACTIONS(71),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
    [sym__command_start] = ACTIONS(75),
  },
  [814] = {
    [sym_type_argument_list] = STATE(871),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_EQ] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_elseif] = ACTIONS(85),
    [anon_sym_else] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_catch] = ACTIONS(85),
    [anon_sym_finally] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(2458),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(85),
    [aux_sym_integer_literal_token1] = ACTIONS(85),
    [aux_sym_integer_literal_token2] = ACTIONS(85),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(85),
    [sym__assign_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
    [sym__immediate_string_start] = ACTIONS(2460),
    [sym__immediate_command_start] = ACTIONS(2462),
  },
  [815] = {
    [sym_type_argument_list] = STATE(871),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_LT_COLON] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_elseif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_catch] = ACTIONS(2464),
    [anon_sym_finally] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2464),
    [anon_sym_PIPE_GT] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2464),
    [aux_sym_integer_literal_token1] = ACTIONS(2464),
    [aux_sym_integer_literal_token2] = ACTIONS(2464),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2464),
    [sym__assign_operator] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
    [sym__immediate_string_start] = ACTIONS(2468),
    [sym__immediate_command_start] = ACTIONS(2470),
  },
  [816] = {
    [sym_type_argument_list] = STATE(1085),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_EQ] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_LT_COLON] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(97),
    [anon_sym_PIPE_GT] = ACTIONS(97),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(97),
    [anon_sym_AMP_AMP] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(97),
    [anon_sym_EQ_GT] = ACTIONS(97),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(2474),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(97),
    [aux_sym_integer_literal_token1] = ACTIONS(97),
    [aux_sym_integer_literal_token2] = ACTIONS(97),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(97),
    [sym__assign_operator] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
    [sym__immediate_string_start] = ACTIONS(2476),
    [sym__immediate_command_start] = ACTIONS(2478),
  },
  [817] = {
    [sym_do_clause] = STATE(853),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_function] = ACTIONS(2480),
    [anon_sym_end] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2480),
    [anon_sym_primitive] = ACTIONS(2480),
    [aux_sym_primitive_definition_token1] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_module] = ACTIONS(2480),
    [anon_sym_macro] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_RPAREN] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_EQ] = ACTIONS(2480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2480),
    [anon_sym_LT_COLON] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_elseif] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_catch] = ACTIONS(2480),
    [anon_sym_finally] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [sym_break_statement] = ACTIONS(2480),
    [sym_continue_statement] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_quote] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_import] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2480),
    [anon_sym_COLON2] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_begin] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_LT_PIPE] = ACTIONS(2480),
    [anon_sym_PIPE_GT] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_isa] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_EQ_GT] = ACTIONS(2480),
    [anon_sym_LBRACK2] = ACTIONS(2480),
    [anon_sym_DOLLAR] = ACTIONS(2480),
    [anon_sym_AT] = ACTIONS(2480),
    [aux_sym_integer_literal_token1] = ACTIONS(2480),
    [aux_sym_integer_literal_token2] = ACTIONS(2480),
    [aux_sym_integer_literal_token3] = ACTIONS(2480),
    [sym_float_literal] = ACTIONS(2480),
    [sym__unary_operator] = ACTIONS(2480),
    [sym__power_operator] = ACTIONS(2480),
    [sym__bitshift_operator] = ACTIONS(2480),
    [sym__rational_operator] = ACTIONS(2480),
    [sym__times_operator] = ACTIONS(2480),
    [sym__plus_operator] = ACTIONS(2480),
    [sym__dotty_operator] = ACTIONS(2480),
    [sym__comparison_operator] = ACTIONS(2480),
    [sym__arrow_operator] = ACTIONS(2480),
    [sym__assign_operator] = ACTIONS(2480),
    [anon_sym_LF] = ACTIONS(2482),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2482),
    [sym__string_start] = ACTIONS(2482),
    [sym__command_start] = ACTIONS(2482),
  },
  [818] = {
    [sym_type_argument_list] = STATE(871),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_EQ] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_elseif] = ACTIONS(85),
    [anon_sym_else] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_catch] = ACTIONS(85),
    [anon_sym_finally] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(85),
    [aux_sym_integer_literal_token1] = ACTIONS(85),
    [aux_sym_integer_literal_token2] = ACTIONS(85),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(85),
    [sym__assign_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
  },
  [819] = {
    [sym_do_clause] = STATE(864),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_end] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_primitive] = ACTIONS(2486),
    [aux_sym_primitive_definition_token1] = ACTIONS(2486),
    [anon_sym_mutable] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_macro] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_RPAREN] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_EQ] = ACTIONS(2486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2486),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_LT_COLON] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_elseif] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_catch] = ACTIONS(2486),
    [anon_sym_finally] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [sym_break_statement] = ACTIONS(2486),
    [sym_continue_statement] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_quote] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_COLON2] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_begin] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2484),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_LT_PIPE] = ACTIONS(2486),
    [anon_sym_PIPE_GT] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_isa] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_EQ_GT] = ACTIONS(2486),
    [anon_sym_LBRACK2] = ACTIONS(2486),
    [anon_sym_DOLLAR] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2486),
    [aux_sym_integer_literal_token1] = ACTIONS(2486),
    [aux_sym_integer_literal_token2] = ACTIONS(2486),
    [aux_sym_integer_literal_token3] = ACTIONS(2486),
    [sym_float_literal] = ACTIONS(2486),
    [sym__unary_operator] = ACTIONS(2486),
    [sym__power_operator] = ACTIONS(2486),
    [sym__bitshift_operator] = ACTIONS(2486),
    [sym__rational_operator] = ACTIONS(2486),
    [sym__times_operator] = ACTIONS(2486),
    [sym__plus_operator] = ACTIONS(2486),
    [sym__dotty_operator] = ACTIONS(2486),
    [sym__comparison_operator] = ACTIONS(2486),
    [sym__arrow_operator] = ACTIONS(2486),
    [sym__assign_operator] = ACTIONS(2486),
    [anon_sym_LF] = ACTIONS(2488),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2488),
    [sym__string_start] = ACTIONS(2488),
    [sym__command_start] = ACTIONS(2488),
  },
  [820] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_primitive] = ACTIONS(2490),
    [aux_sym_primitive_definition_token1] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_macro] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LT_COLON] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_elseif] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(2490),
    [anon_sym_finally] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [sym_break_statement] = ACTIONS(2490),
    [sym_continue_statement] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_quote] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_COLON2] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_begin] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_LT_PIPE] = ACTIONS(2490),
    [anon_sym_PIPE_GT] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_isa] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(2490),
    [anon_sym_LBRACK2] = ACTIONS(2490),
    [anon_sym_DOLLAR] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2490),
    [aux_sym_integer_literal_token1] = ACTIONS(2490),
    [aux_sym_integer_literal_token2] = ACTIONS(2490),
    [aux_sym_integer_literal_token3] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
    [sym__unary_operator] = ACTIONS(2490),
    [sym__power_operator] = ACTIONS(2490),
    [sym__bitshift_operator] = ACTIONS(2490),
    [sym__rational_operator] = ACTIONS(2490),
    [sym__times_operator] = ACTIONS(2490),
    [sym__plus_operator] = ACTIONS(2490),
    [sym__dotty_operator] = ACTIONS(2490),
    [sym__comparison_operator] = ACTIONS(2490),
    [sym__arrow_operator] = ACTIONS(2490),
    [sym__assign_operator] = ACTIONS(2490),
    [anon_sym_LF] = ACTIONS(2492),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2492),
    [sym__string_start] = ACTIONS(2492),
    [sym__command_start] = ACTIONS(2492),
  },
  [821] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_primitive] = ACTIONS(2494),
    [aux_sym_primitive_definition_token1] = ACTIONS(2494),
    [anon_sym_mutable] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_macro] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2494),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LT_COLON] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_elseif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_catch] = ACTIONS(2494),
    [anon_sym_finally] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [sym_break_statement] = ACTIONS(2494),
    [sym_continue_statement] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_quote] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_COLON2] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_begin] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_LT_PIPE] = ACTIONS(2494),
    [anon_sym_PIPE_GT] = ACTIONS(2494),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_isa] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_QMARK] = ACTIONS(2494),
    [anon_sym_EQ_GT] = ACTIONS(2494),
    [anon_sym_LBRACK2] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2494),
    [aux_sym_integer_literal_token1] = ACTIONS(2494),
    [aux_sym_integer_literal_token2] = ACTIONS(2494),
    [aux_sym_integer_literal_token3] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
    [sym__unary_operator] = ACTIONS(2494),
    [sym__power_operator] = ACTIONS(2494),
    [sym__bitshift_operator] = ACTIONS(2494),
    [sym__rational_operator] = ACTIONS(2494),
    [sym__times_operator] = ACTIONS(2494),
    [sym__plus_operator] = ACTIONS(2494),
    [sym__dotty_operator] = ACTIONS(2494),
    [sym__comparison_operator] = ACTIONS(2494),
    [sym__arrow_operator] = ACTIONS(2494),
    [sym__assign_operator] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2496),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2496),
    [sym__string_start] = ACTIONS(2496),
    [sym__command_start] = ACTIONS(2496),
  },
  [822] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_end] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_primitive] = ACTIONS(2498),
    [aux_sym_primitive_definition_token1] = ACTIONS(2498),
    [anon_sym_mutable] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_macro] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2498),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LT_COLON] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_elseif] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_catch] = ACTIONS(2498),
    [anon_sym_finally] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [sym_break_statement] = ACTIONS(2498),
    [sym_continue_statement] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_quote] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_COLON2] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_begin] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_LT_PIPE] = ACTIONS(2498),
    [anon_sym_PIPE_GT] = ACTIONS(2498),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_isa] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_QMARK] = ACTIONS(2498),
    [anon_sym_EQ_GT] = ACTIONS(2498),
    [anon_sym_LBRACK2] = ACTIONS(2498),
    [anon_sym_DOLLAR] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2498),
    [aux_sym_integer_literal_token1] = ACTIONS(2498),
    [aux_sym_integer_literal_token2] = ACTIONS(2498),
    [aux_sym_integer_literal_token3] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
    [sym__unary_operator] = ACTIONS(2498),
    [sym__power_operator] = ACTIONS(2498),
    [sym__bitshift_operator] = ACTIONS(2498),
    [sym__rational_operator] = ACTIONS(2498),
    [sym__times_operator] = ACTIONS(2498),
    [sym__plus_operator] = ACTIONS(2498),
    [sym__dotty_operator] = ACTIONS(2498),
    [sym__comparison_operator] = ACTIONS(2498),
    [sym__arrow_operator] = ACTIONS(2498),
    [sym__assign_operator] = ACTIONS(2498),
    [anon_sym_LF] = ACTIONS(2500),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2500),
    [sym__string_start] = ACTIONS(2500),
    [sym__command_start] = ACTIONS(2500),
  },
  [823] = {
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_end] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_primitive] = ACTIONS(2502),
    [aux_sym_primitive_definition_token1] = ACTIONS(2502),
    [anon_sym_mutable] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_macro] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_LT_COLON] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_elseif] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_catch] = ACTIONS(2502),
    [anon_sym_finally] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [sym_break_statement] = ACTIONS(2502),
    [sym_continue_statement] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_quote] = ACTIONS(2502),
    [anon_sym_using] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_COLON2] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_LT_PIPE] = ACTIONS(2502),
    [anon_sym_PIPE_GT] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2502),
    [anon_sym_isa] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_EQ_GT] = ACTIONS(2502),
    [anon_sym_LBRACK2] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_AT] = ACTIONS(2502),
    [aux_sym_integer_literal_token1] = ACTIONS(2502),
    [aux_sym_integer_literal_token2] = ACTIONS(2502),
    [aux_sym_integer_literal_token3] = ACTIONS(2502),
    [sym_float_literal] = ACTIONS(2502),
    [sym__unary_operator] = ACTIONS(2502),
    [sym__power_operator] = ACTIONS(2502),
    [sym__bitshift_operator] = ACTIONS(2502),
    [sym__rational_operator] = ACTIONS(2502),
    [sym__times_operator] = ACTIONS(2502),
    [sym__plus_operator] = ACTIONS(2502),
    [sym__dotty_operator] = ACTIONS(2502),
    [sym__comparison_operator] = ACTIONS(2502),
    [sym__arrow_operator] = ACTIONS(2502),
    [sym__assign_operator] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2504),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2504),
    [sym__string_start] = ACTIONS(2504),
    [sym__command_start] = ACTIONS(2504),
  },
  [824] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_end] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_primitive] = ACTIONS(2506),
    [aux_sym_primitive_definition_token1] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_macro] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LT_COLON] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_elseif] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_catch] = ACTIONS(2506),
    [anon_sym_finally] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [sym_break_statement] = ACTIONS(2506),
    [sym_continue_statement] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_quote] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_COLON2] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT_PIPE] = ACTIONS(2506),
    [anon_sym_PIPE_GT] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_isa] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_EQ_GT] = ACTIONS(2506),
    [anon_sym_LBRACK2] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2506),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
    [sym__unary_operator] = ACTIONS(2506),
    [sym__power_operator] = ACTIONS(2506),
    [sym__bitshift_operator] = ACTIONS(2506),
    [sym__rational_operator] = ACTIONS(2506),
    [sym__times_operator] = ACTIONS(2506),
    [sym__plus_operator] = ACTIONS(2506),
    [sym__dotty_operator] = ACTIONS(2506),
    [sym__comparison_operator] = ACTIONS(2506),
    [sym__arrow_operator] = ACTIONS(2506),
    [sym__assign_operator] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2508),
    [sym__string_start] = ACTIONS(2508),
    [sym__command_start] = ACTIONS(2508),
  },
  [825] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_end] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_primitive] = ACTIONS(2510),
    [aux_sym_primitive_definition_token1] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_macro] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_RPAREN] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LT_COLON] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_elseif] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(2510),
    [anon_sym_finally] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [sym_break_statement] = ACTIONS(2510),
    [sym_continue_statement] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_quote] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_COLON2] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_LT_PIPE] = ACTIONS(2510),
    [anon_sym_PIPE_GT] = ACTIONS(2510),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_isa] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_EQ_GT] = ACTIONS(2510),
    [anon_sym_LBRACK2] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2510),
    [aux_sym_integer_literal_token1] = ACTIONS(2510),
    [aux_sym_integer_literal_token2] = ACTIONS(2510),
    [aux_sym_integer_literal_token3] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
    [sym__unary_operator] = ACTIONS(2510),
    [sym__power_operator] = ACTIONS(2510),
    [sym__bitshift_operator] = ACTIONS(2510),
    [sym__rational_operator] = ACTIONS(2510),
    [sym__times_operator] = ACTIONS(2510),
    [sym__plus_operator] = ACTIONS(2510),
    [sym__dotty_operator] = ACTIONS(2510),
    [sym__comparison_operator] = ACTIONS(2510),
    [sym__arrow_operator] = ACTIONS(2510),
    [sym__assign_operator] = ACTIONS(2510),
    [anon_sym_LF] = ACTIONS(2512),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2512),
    [sym__string_start] = ACTIONS(2512),
    [sym__command_start] = ACTIONS(2512),
  },
  [826] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_end] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_primitive] = ACTIONS(2514),
    [aux_sym_primitive_definition_token1] = ACTIONS(2514),
    [anon_sym_mutable] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_macro] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_RPAREN] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LT_COLON] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_elseif] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_catch] = ACTIONS(2514),
    [anon_sym_finally] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [sym_break_statement] = ACTIONS(2514),
    [sym_continue_statement] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_quote] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_COLON2] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_LT_PIPE] = ACTIONS(2514),
    [anon_sym_PIPE_GT] = ACTIONS(2514),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_isa] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_EQ_GT] = ACTIONS(2514),
    [anon_sym_LBRACK2] = ACTIONS(2514),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2514),
    [aux_sym_integer_literal_token1] = ACTIONS(2514),
    [aux_sym_integer_literal_token2] = ACTIONS(2514),
    [aux_sym_integer_literal_token3] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__power_operator] = ACTIONS(2514),
    [sym__bitshift_operator] = ACTIONS(2514),
    [sym__rational_operator] = ACTIONS(2514),
    [sym__times_operator] = ACTIONS(2514),
    [sym__plus_operator] = ACTIONS(2514),
    [sym__dotty_operator] = ACTIONS(2514),
    [sym__comparison_operator] = ACTIONS(2514),
    [sym__arrow_operator] = ACTIONS(2514),
    [sym__assign_operator] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2516),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2516),
    [sym__string_start] = ACTIONS(2516),
    [sym__command_start] = ACTIONS(2516),
  },
  [827] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_end] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_primitive] = ACTIONS(2518),
    [aux_sym_primitive_definition_token1] = ACTIONS(2518),
    [anon_sym_mutable] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_macro] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2518),
    [anon_sym_RPAREN] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LT_COLON] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_elseif] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_catch] = ACTIONS(2518),
    [anon_sym_finally] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [sym_break_statement] = ACTIONS(2518),
    [sym_continue_statement] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_quote] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_COLON2] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_LT_PIPE] = ACTIONS(2518),
    [anon_sym_PIPE_GT] = ACTIONS(2518),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_isa] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_EQ_GT] = ACTIONS(2518),
    [anon_sym_LBRACK2] = ACTIONS(2518),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2518),
    [aux_sym_integer_literal_token1] = ACTIONS(2518),
    [aux_sym_integer_literal_token2] = ACTIONS(2518),
    [aux_sym_integer_literal_token3] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
    [sym__unary_operator] = ACTIONS(2518),
    [sym__power_operator] = ACTIONS(2518),
    [sym__bitshift_operator] = ACTIONS(2518),
    [sym__rational_operator] = ACTIONS(2518),
    [sym__times_operator] = ACTIONS(2518),
    [sym__plus_operator] = ACTIONS(2518),
    [sym__dotty_operator] = ACTIONS(2518),
    [sym__comparison_operator] = ACTIONS(2518),
    [sym__arrow_operator] = ACTIONS(2518),
    [sym__assign_operator] = ACTIONS(2518),
    [anon_sym_LF] = ACTIONS(2520),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2520),
    [sym__string_start] = ACTIONS(2520),
    [sym__command_start] = ACTIONS(2520),
  },
  [828] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_end] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_primitive] = ACTIONS(2522),
    [aux_sym_primitive_definition_token1] = ACTIONS(2522),
    [anon_sym_mutable] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_macro] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_COMMA] = ACTIONS(2522),
    [anon_sym_RPAREN] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2522),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LT_COLON] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_elseif] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_catch] = ACTIONS(2522),
    [anon_sym_finally] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [sym_break_statement] = ACTIONS(2522),
    [sym_continue_statement] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_quote] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_COLON2] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_begin] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_LT_PIPE] = ACTIONS(2522),
    [anon_sym_PIPE_GT] = ACTIONS(2522),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_isa] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_QMARK] = ACTIONS(2522),
    [anon_sym_EQ_GT] = ACTIONS(2522),
    [anon_sym_LBRACK2] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2522),
    [aux_sym_integer_literal_token1] = ACTIONS(2522),
    [aux_sym_integer_literal_token2] = ACTIONS(2522),
    [aux_sym_integer_literal_token3] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
    [sym__unary_operator] = ACTIONS(2522),
    [sym__power_operator] = ACTIONS(2522),
    [sym__bitshift_operator] = ACTIONS(2522),
    [sym__rational_operator] = ACTIONS(2522),
    [sym__times_operator] = ACTIONS(2522),
    [sym__plus_operator] = ACTIONS(2522),
    [sym__dotty_operator] = ACTIONS(2522),
    [sym__comparison_operator] = ACTIONS(2522),
    [sym__arrow_operator] = ACTIONS(2522),
    [sym__assign_operator] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2524),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2524),
    [sym__string_start] = ACTIONS(2524),
    [sym__command_start] = ACTIONS(2524),
  },
  [829] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_end] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_primitive] = ACTIONS(2526),
    [aux_sym_primitive_definition_token1] = ACTIONS(2526),
    [anon_sym_mutable] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_macro] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_RPAREN] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(2526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LT_COLON] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_elseif] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_catch] = ACTIONS(2526),
    [anon_sym_finally] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [sym_break_statement] = ACTIONS(2526),
    [sym_continue_statement] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_quote] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_COLON2] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_begin] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_LT_PIPE] = ACTIONS(2526),
    [anon_sym_PIPE_GT] = ACTIONS(2526),
    [anon_sym_in] = ACTIONS(2526),
    [anon_sym_isa] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(2526),
    [anon_sym_LBRACK2] = ACTIONS(2526),
    [anon_sym_DOLLAR] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2526),
    [aux_sym_integer_literal_token1] = ACTIONS(2526),
    [aux_sym_integer_literal_token2] = ACTIONS(2526),
    [aux_sym_integer_literal_token3] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
    [sym__unary_operator] = ACTIONS(2526),
    [sym__power_operator] = ACTIONS(2526),
    [sym__bitshift_operator] = ACTIONS(2526),
    [sym__rational_operator] = ACTIONS(2526),
    [sym__times_operator] = ACTIONS(2526),
    [sym__plus_operator] = ACTIONS(2526),
    [sym__dotty_operator] = ACTIONS(2526),
    [sym__comparison_operator] = ACTIONS(2526),
    [sym__arrow_operator] = ACTIONS(2526),
    [sym__assign_operator] = ACTIONS(2526),
    [anon_sym_LF] = ACTIONS(2528),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2528),
    [sym__string_start] = ACTIONS(2528),
    [sym__command_start] = ACTIONS(2528),
  },
  [830] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_end] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_primitive] = ACTIONS(2530),
    [aux_sym_primitive_definition_token1] = ACTIONS(2530),
    [anon_sym_mutable] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_macro] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_COMMA] = ACTIONS(2530),
    [anon_sym_RPAREN] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_EQ] = ACTIONS(2530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2530),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LT_COLON] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_elseif] = ACTIONS(2530),
    [anon_sym_else] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_catch] = ACTIONS(2530),
    [anon_sym_finally] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [sym_break_statement] = ACTIONS(2530),
    [sym_continue_statement] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_quote] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_COLON2] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_begin] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_LT_PIPE] = ACTIONS(2530),
    [anon_sym_PIPE_GT] = ACTIONS(2530),
    [anon_sym_in] = ACTIONS(2530),
    [anon_sym_isa] = ACTIONS(2530),
    [anon_sym_PIPE_PIPE] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_QMARK] = ACTIONS(2530),
    [anon_sym_EQ_GT] = ACTIONS(2530),
    [anon_sym_LBRACK2] = ACTIONS(2530),
    [anon_sym_DOLLAR] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2530),
    [aux_sym_integer_literal_token1] = ACTIONS(2530),
    [aux_sym_integer_literal_token2] = ACTIONS(2530),
    [aux_sym_integer_literal_token3] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
    [sym__unary_operator] = ACTIONS(2530),
    [sym__power_operator] = ACTIONS(2530),
    [sym__bitshift_operator] = ACTIONS(2530),
    [sym__rational_operator] = ACTIONS(2530),
    [sym__times_operator] = ACTIONS(2530),
    [sym__plus_operator] = ACTIONS(2530),
    [sym__dotty_operator] = ACTIONS(2530),
    [sym__comparison_operator] = ACTIONS(2530),
    [sym__arrow_operator] = ACTIONS(2530),
    [sym__assign_operator] = ACTIONS(2530),
    [anon_sym_LF] = ACTIONS(2532),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2532),
    [sym__string_start] = ACTIONS(2532),
    [sym__command_start] = ACTIONS(2532),
  },
  [831] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_end] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_primitive] = ACTIONS(2534),
    [aux_sym_primitive_definition_token1] = ACTIONS(2534),
    [anon_sym_mutable] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_macro] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LT_COLON] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_elseif] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_catch] = ACTIONS(2534),
    [anon_sym_finally] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [sym_break_statement] = ACTIONS(2534),
    [sym_continue_statement] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_quote] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_COLON2] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_begin] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_LT_PIPE] = ACTIONS(2534),
    [anon_sym_PIPE_GT] = ACTIONS(2534),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_isa] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_QMARK] = ACTIONS(2534),
    [anon_sym_EQ_GT] = ACTIONS(2534),
    [anon_sym_LBRACK2] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2534),
    [aux_sym_integer_literal_token1] = ACTIONS(2534),
    [aux_sym_integer_literal_token2] = ACTIONS(2534),
    [aux_sym_integer_literal_token3] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
    [sym__unary_operator] = ACTIONS(2534),
    [sym__power_operator] = ACTIONS(2534),
    [sym__bitshift_operator] = ACTIONS(2534),
    [sym__rational_operator] = ACTIONS(2534),
    [sym__times_operator] = ACTIONS(2534),
    [sym__plus_operator] = ACTIONS(2534),
    [sym__dotty_operator] = ACTIONS(2534),
    [sym__comparison_operator] = ACTIONS(2534),
    [sym__arrow_operator] = ACTIONS(2534),
    [sym__assign_operator] = ACTIONS(2534),
    [anon_sym_LF] = ACTIONS(2536),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2536),
    [sym__string_start] = ACTIONS(2536),
    [sym__command_start] = ACTIONS(2536),
  },
  [832] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_end] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_primitive] = ACTIONS(2538),
    [aux_sym_primitive_definition_token1] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_macro] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2538),
    [anon_sym_COMMA] = ACTIONS(2538),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym_EQ] = ACTIONS(2538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2538),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LT_COLON] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_elseif] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_catch] = ACTIONS(2538),
    [anon_sym_finally] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [sym_break_statement] = ACTIONS(2538),
    [sym_continue_statement] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_quote] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_DOT] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_COLON2] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_begin] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_LT_PIPE] = ACTIONS(2538),
    [anon_sym_PIPE_GT] = ACTIONS(2538),
    [anon_sym_in] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_EQ_GT] = ACTIONS(2538),
    [anon_sym_LBRACK2] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2538),
    [aux_sym_integer_literal_token1] = ACTIONS(2538),
    [aux_sym_integer_literal_token2] = ACTIONS(2538),
    [aux_sym_integer_literal_token3] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
    [sym__unary_operator] = ACTIONS(2538),
    [sym__power_operator] = ACTIONS(2538),
    [sym__bitshift_operator] = ACTIONS(2538),
    [sym__rational_operator] = ACTIONS(2538),
    [sym__times_operator] = ACTIONS(2538),
    [sym__plus_operator] = ACTIONS(2538),
    [sym__dotty_operator] = ACTIONS(2538),
    [sym__comparison_operator] = ACTIONS(2538),
    [sym__arrow_operator] = ACTIONS(2538),
    [sym__assign_operator] = ACTIONS(2538),
    [anon_sym_LF] = ACTIONS(2540),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2540),
    [sym__string_start] = ACTIONS(2540),
    [sym__command_start] = ACTIONS(2540),
  },
  [833] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_end] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_primitive] = ACTIONS(2542),
    [aux_sym_primitive_definition_token1] = ACTIONS(2542),
    [anon_sym_mutable] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_macro] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2542),
    [anon_sym_RPAREN] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym_EQ] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2542),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LT_COLON] = ACTIONS(2542),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_elseif] = ACTIONS(2542),
    [anon_sym_else] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_catch] = ACTIONS(2542),
    [anon_sym_finally] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [sym_break_statement] = ACTIONS(2542),
    [sym_continue_statement] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_quote] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_COLON2] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_LT_PIPE] = ACTIONS(2542),
    [anon_sym_PIPE_GT] = ACTIONS(2542),
    [anon_sym_in] = ACTIONS(2542),
    [anon_sym_isa] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(2542),
    [anon_sym_EQ_GT] = ACTIONS(2542),
    [anon_sym_LBRACK2] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2542),
    [aux_sym_integer_literal_token1] = ACTIONS(2542),
    [aux_sym_integer_literal_token2] = ACTIONS(2542),
    [aux_sym_integer_literal_token3] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
    [sym__unary_operator] = ACTIONS(2542),
    [sym__power_operator] = ACTIONS(2542),
    [sym__bitshift_operator] = ACTIONS(2542),
    [sym__rational_operator] = ACTIONS(2542),
    [sym__times_operator] = ACTIONS(2542),
    [sym__plus_operator] = ACTIONS(2542),
    [sym__dotty_operator] = ACTIONS(2542),
    [sym__comparison_operator] = ACTIONS(2542),
    [sym__arrow_operator] = ACTIONS(2542),
    [sym__assign_operator] = ACTIONS(2542),
    [anon_sym_LF] = ACTIONS(2544),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2544),
    [sym__string_start] = ACTIONS(2544),
    [sym__command_start] = ACTIONS(2544),
  },
  [834] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_end] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_primitive] = ACTIONS(2546),
    [aux_sym_primitive_definition_token1] = ACTIONS(2546),
    [anon_sym_mutable] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_macro] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_COMMA] = ACTIONS(2546),
    [anon_sym_RPAREN] = ACTIONS(2546),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_EQ] = ACTIONS(2546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LT_COLON] = ACTIONS(2546),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_elseif] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_catch] = ACTIONS(2546),
    [anon_sym_finally] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [sym_break_statement] = ACTIONS(2546),
    [sym_continue_statement] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_quote] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_DOT] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_COLON2] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_begin] = ACTIONS(2546),
    [anon_sym_do] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_LT_PIPE] = ACTIONS(2546),
    [anon_sym_PIPE_GT] = ACTIONS(2546),
    [anon_sym_in] = ACTIONS(2546),
    [anon_sym_isa] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_QMARK] = ACTIONS(2546),
    [anon_sym_EQ_GT] = ACTIONS(2546),
    [anon_sym_LBRACK2] = ACTIONS(2546),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2546),
    [aux_sym_integer_literal_token1] = ACTIONS(2546),
    [aux_sym_integer_literal_token2] = ACTIONS(2546),
    [aux_sym_integer_literal_token3] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
    [sym__unary_operator] = ACTIONS(2546),
    [sym__power_operator] = ACTIONS(2546),
    [sym__bitshift_operator] = ACTIONS(2546),
    [sym__rational_operator] = ACTIONS(2546),
    [sym__times_operator] = ACTIONS(2546),
    [sym__plus_operator] = ACTIONS(2546),
    [sym__dotty_operator] = ACTIONS(2546),
    [sym__comparison_operator] = ACTIONS(2546),
    [sym__arrow_operator] = ACTIONS(2546),
    [sym__assign_operator] = ACTIONS(2546),
    [anon_sym_LF] = ACTIONS(2548),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2548),
    [sym__string_start] = ACTIONS(2548),
    [sym__command_start] = ACTIONS(2548),
  },
  [835] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_end] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_primitive] = ACTIONS(2550),
    [aux_sym_primitive_definition_token1] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_macro] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_COMMA] = ACTIONS(2550),
    [anon_sym_RPAREN] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_EQ] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LT_COLON] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_elseif] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_catch] = ACTIONS(2550),
    [anon_sym_finally] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_break_statement] = ACTIONS(2550),
    [sym_continue_statement] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_quote] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_COLON2] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_begin] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_LT_PIPE] = ACTIONS(2550),
    [anon_sym_PIPE_GT] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_isa] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_QMARK] = ACTIONS(2550),
    [anon_sym_EQ_GT] = ACTIONS(2550),
    [anon_sym_LBRACK2] = ACTIONS(2550),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_AT] = ACTIONS(2550),
    [aux_sym_integer_literal_token1] = ACTIONS(2550),
    [aux_sym_integer_literal_token2] = ACTIONS(2550),
    [aux_sym_integer_literal_token3] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
    [sym__unary_operator] = ACTIONS(2550),
    [sym__power_operator] = ACTIONS(2550),
    [sym__bitshift_operator] = ACTIONS(2550),
    [sym__rational_operator] = ACTIONS(2550),
    [sym__times_operator] = ACTIONS(2550),
    [sym__plus_operator] = ACTIONS(2550),
    [sym__dotty_operator] = ACTIONS(2550),
    [sym__comparison_operator] = ACTIONS(2550),
    [sym__arrow_operator] = ACTIONS(2550),
    [sym__assign_operator] = ACTIONS(2550),
    [anon_sym_LF] = ACTIONS(2552),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2552),
    [sym__string_start] = ACTIONS(2552),
    [sym__command_start] = ACTIONS(2552),
  },
  [836] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_end] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_primitive] = ACTIONS(2554),
    [aux_sym_primitive_definition_token1] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_macro] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2554),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LT_COLON] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_elseif] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_catch] = ACTIONS(2554),
    [anon_sym_finally] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [sym_break_statement] = ACTIONS(2554),
    [sym_continue_statement] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_quote] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_COLON2] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_begin] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_LT_PIPE] = ACTIONS(2554),
    [anon_sym_PIPE_GT] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_isa] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_QMARK] = ACTIONS(2554),
    [anon_sym_EQ_GT] = ACTIONS(2554),
    [anon_sym_LBRACK2] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2554),
    [anon_sym_AT] = ACTIONS(2554),
    [aux_sym_integer_literal_token1] = ACTIONS(2554),
    [aux_sym_integer_literal_token2] = ACTIONS(2554),
    [aux_sym_integer_literal_token3] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
    [sym__unary_operator] = ACTIONS(2554),
    [sym__power_operator] = ACTIONS(2554),
    [sym__bitshift_operator] = ACTIONS(2554),
    [sym__rational_operator] = ACTIONS(2554),
    [sym__times_operator] = ACTIONS(2554),
    [sym__plus_operator] = ACTIONS(2554),
    [sym__dotty_operator] = ACTIONS(2554),
    [sym__comparison_operator] = ACTIONS(2554),
    [sym__arrow_operator] = ACTIONS(2554),
    [sym__assign_operator] = ACTIONS(2554),
    [anon_sym_LF] = ACTIONS(2556),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2556),
    [sym__string_start] = ACTIONS(2556),
    [sym__command_start] = ACTIONS(2556),
  },
  [837] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_end] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_primitive] = ACTIONS(2558),
    [aux_sym_primitive_definition_token1] = ACTIONS(2558),
    [anon_sym_mutable] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_macro] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_COMMA] = ACTIONS(2558),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym_EQ] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2558),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LT_COLON] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_elseif] = ACTIONS(2558),
    [anon_sym_else] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_catch] = ACTIONS(2558),
    [anon_sym_finally] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [sym_break_statement] = ACTIONS(2558),
    [sym_continue_statement] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_quote] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_DOT] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_COLON2] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_begin] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_LT_PIPE] = ACTIONS(2558),
    [anon_sym_PIPE_GT] = ACTIONS(2558),
    [anon_sym_in] = ACTIONS(2558),
    [anon_sym_isa] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_QMARK] = ACTIONS(2558),
    [anon_sym_EQ_GT] = ACTIONS(2558),
    [anon_sym_LBRACK2] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2558),
    [aux_sym_integer_literal_token1] = ACTIONS(2558),
    [aux_sym_integer_literal_token2] = ACTIONS(2558),
    [aux_sym_integer_literal_token3] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
    [sym__unary_operator] = ACTIONS(2558),
    [sym__power_operator] = ACTIONS(2558),
    [sym__bitshift_operator] = ACTIONS(2558),
    [sym__rational_operator] = ACTIONS(2558),
    [sym__times_operator] = ACTIONS(2558),
    [sym__plus_operator] = ACTIONS(2558),
    [sym__dotty_operator] = ACTIONS(2558),
    [sym__comparison_operator] = ACTIONS(2558),
    [sym__arrow_operator] = ACTIONS(2558),
    [sym__assign_operator] = ACTIONS(2558),
    [anon_sym_LF] = ACTIONS(2560),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2560),
    [sym__string_start] = ACTIONS(2560),
    [sym__command_start] = ACTIONS(2560),
  },
  [838] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_primitive] = ACTIONS(2562),
    [aux_sym_primitive_definition_token1] = ACTIONS(2562),
    [anon_sym_mutable] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_macro] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LT_COLON] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_elseif] = ACTIONS(2562),
    [anon_sym_else] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_catch] = ACTIONS(2562),
    [anon_sym_finally] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [sym_break_statement] = ACTIONS(2562),
    [sym_continue_statement] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_quote] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_COLON2] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_LT_PIPE] = ACTIONS(2562),
    [anon_sym_PIPE_GT] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_isa] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2562),
    [anon_sym_LBRACK2] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2562),
    [aux_sym_integer_literal_token1] = ACTIONS(2562),
    [aux_sym_integer_literal_token2] = ACTIONS(2562),
    [aux_sym_integer_literal_token3] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
    [sym__unary_operator] = ACTIONS(2562),
    [sym__power_operator] = ACTIONS(2562),
    [sym__bitshift_operator] = ACTIONS(2562),
    [sym__rational_operator] = ACTIONS(2562),
    [sym__times_operator] = ACTIONS(2562),
    [sym__plus_operator] = ACTIONS(2562),
    [sym__dotty_operator] = ACTIONS(2562),
    [sym__comparison_operator] = ACTIONS(2562),
    [sym__arrow_operator] = ACTIONS(2562),
    [sym__assign_operator] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2564),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__command_start] = ACTIONS(2564),
  },
  [839] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_primitive] = ACTIONS(2566),
    [aux_sym_primitive_definition_token1] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_macro] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LT_COLON] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_elseif] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_catch] = ACTIONS(2566),
    [anon_sym_finally] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [sym_break_statement] = ACTIONS(2566),
    [sym_continue_statement] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_quote] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_COLON2] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_LT_PIPE] = ACTIONS(2566),
    [anon_sym_PIPE_GT] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_isa] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2566),
    [anon_sym_LBRACK2] = ACTIONS(2566),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2566),
    [aux_sym_integer_literal_token1] = ACTIONS(2566),
    [aux_sym_integer_literal_token2] = ACTIONS(2566),
    [aux_sym_integer_literal_token3] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
    [sym__unary_operator] = ACTIONS(2566),
    [sym__power_operator] = ACTIONS(2566),
    [sym__bitshift_operator] = ACTIONS(2566),
    [sym__rational_operator] = ACTIONS(2566),
    [sym__times_operator] = ACTIONS(2566),
    [sym__plus_operator] = ACTIONS(2566),
    [sym__dotty_operator] = ACTIONS(2566),
    [sym__comparison_operator] = ACTIONS(2566),
    [sym__arrow_operator] = ACTIONS(2566),
    [sym__assign_operator] = ACTIONS(2566),
    [anon_sym_LF] = ACTIONS(2568),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2568),
    [sym__string_start] = ACTIONS(2568),
    [sym__command_start] = ACTIONS(2568),
  },
  [840] = {
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_primitive] = ACTIONS(2570),
    [aux_sym_primitive_definition_token1] = ACTIONS(2570),
    [anon_sym_mutable] = ACTIONS(2570),
    [anon_sym_struct] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_macro] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2570),
    [anon_sym_RPAREN] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LT_COLON] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_elseif] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_catch] = ACTIONS(2570),
    [anon_sym_finally] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [sym_break_statement] = ACTIONS(2570),
    [sym_continue_statement] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_quote] = ACTIONS(2570),
    [anon_sym_using] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_COLON2] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_LT_PIPE] = ACTIONS(2570),
    [anon_sym_PIPE_GT] = ACTIONS(2570),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_isa] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_EQ_GT] = ACTIONS(2570),
    [anon_sym_LBRACK2] = ACTIONS(2570),
    [anon_sym_DOLLAR] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(2570),
    [aux_sym_integer_literal_token1] = ACTIONS(2570),
    [aux_sym_integer_literal_token2] = ACTIONS(2570),
    [aux_sym_integer_literal_token3] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
    [sym__unary_operator] = ACTIONS(2570),
    [sym__power_operator] = ACTIONS(2570),
    [sym__bitshift_operator] = ACTIONS(2570),
    [sym__rational_operator] = ACTIONS(2570),
    [sym__times_operator] = ACTIONS(2570),
    [sym__plus_operator] = ACTIONS(2570),
    [sym__dotty_operator] = ACTIONS(2570),
    [sym__comparison_operator] = ACTIONS(2570),
    [sym__arrow_operator] = ACTIONS(2570),
    [sym__assign_operator] = ACTIONS(2570),
    [anon_sym_LF] = ACTIONS(2572),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__command_start] = ACTIONS(2572),
  },
  [841] = {
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_primitive] = ACTIONS(2574),
    [aux_sym_primitive_definition_token1] = ACTIONS(2574),
    [anon_sym_mutable] = ACTIONS(2574),
    [anon_sym_struct] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_macro] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RPAREN] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LT_COLON] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_elseif] = ACTIONS(2574),
    [anon_sym_else] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_catch] = ACTIONS(2574),
    [anon_sym_finally] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [sym_break_statement] = ACTIONS(2574),
    [sym_continue_statement] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_quote] = ACTIONS(2574),
    [anon_sym_using] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_COLON2] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_LT_PIPE] = ACTIONS(2574),
    [anon_sym_PIPE_GT] = ACTIONS(2574),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_isa] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_QMARK] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(2574),
    [anon_sym_LBRACK2] = ACTIONS(2574),
    [anon_sym_DOLLAR] = ACTIONS(2574),
    [anon_sym_AT] = ACTIONS(2574),
    [aux_sym_integer_literal_token1] = ACTIONS(2574),
    [aux_sym_integer_literal_token2] = ACTIONS(2574),
    [aux_sym_integer_literal_token3] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
    [sym__unary_operator] = ACTIONS(2574),
    [sym__power_operator] = ACTIONS(2574),
    [sym__bitshift_operator] = ACTIONS(2574),
    [sym__rational_operator] = ACTIONS(2574),
    [sym__times_operator] = ACTIONS(2574),
    [sym__plus_operator] = ACTIONS(2574),
    [sym__dotty_operator] = ACTIONS(2574),
    [sym__comparison_operator] = ACTIONS(2574),
    [sym__arrow_operator] = ACTIONS(2574),
    [sym__assign_operator] = ACTIONS(2574),
    [anon_sym_LF] = ACTIONS(2576),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__command_start] = ACTIONS(2576),
  },
  [842] = {
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_primitive] = ACTIONS(2578),
    [aux_sym_primitive_definition_token1] = ACTIONS(2578),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_macro] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LT_COLON] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_elseif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_catch] = ACTIONS(2578),
    [anon_sym_finally] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [sym_break_statement] = ACTIONS(2578),
    [sym_continue_statement] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_quote] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_COLON2] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_LT_PIPE] = ACTIONS(2578),
    [anon_sym_PIPE_GT] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_isa] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2578),
    [anon_sym_LBRACK2] = ACTIONS(2578),
    [anon_sym_DOLLAR] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2578),
    [aux_sym_integer_literal_token1] = ACTIONS(2578),
    [aux_sym_integer_literal_token2] = ACTIONS(2578),
    [aux_sym_integer_literal_token3] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
    [sym__unary_operator] = ACTIONS(2578),
    [sym__power_operator] = ACTIONS(2578),
    [sym__bitshift_operator] = ACTIONS(2578),
    [sym__rational_operator] = ACTIONS(2578),
    [sym__times_operator] = ACTIONS(2578),
    [sym__plus_operator] = ACTIONS(2578),
    [sym__dotty_operator] = ACTIONS(2578),
    [sym__comparison_operator] = ACTIONS(2578),
    [sym__arrow_operator] = ACTIONS(2578),
    [sym__assign_operator] = ACTIONS(2578),
    [anon_sym_LF] = ACTIONS(2580),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__command_start] = ACTIONS(2580),
  },
  [843] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_primitive] = ACTIONS(2582),
    [aux_sym_primitive_definition_token1] = ACTIONS(2582),
    [anon_sym_mutable] = ACTIONS(2582),
    [anon_sym_struct] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_macro] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LT_COLON] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_elseif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_catch] = ACTIONS(2582),
    [anon_sym_finally] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [sym_break_statement] = ACTIONS(2582),
    [sym_continue_statement] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_quote] = ACTIONS(2582),
    [anon_sym_using] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_COLON2] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_LT_PIPE] = ACTIONS(2582),
    [anon_sym_PIPE_GT] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_isa] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2582),
    [anon_sym_LBRACK2] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2582),
    [aux_sym_integer_literal_token1] = ACTIONS(2582),
    [aux_sym_integer_literal_token2] = ACTIONS(2582),
    [aux_sym_integer_literal_token3] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
    [sym__unary_operator] = ACTIONS(2582),
    [sym__power_operator] = ACTIONS(2582),
    [sym__bitshift_operator] = ACTIONS(2582),
    [sym__rational_operator] = ACTIONS(2582),
    [sym__times_operator] = ACTIONS(2582),
    [sym__plus_operator] = ACTIONS(2582),
    [sym__dotty_operator] = ACTIONS(2582),
    [sym__comparison_operator] = ACTIONS(2582),
    [sym__arrow_operator] = ACTIONS(2582),
    [sym__assign_operator] = ACTIONS(2582),
    [anon_sym_LF] = ACTIONS(2584),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__command_start] = ACTIONS(2584),
  },
  [844] = {
    [sym_type_argument_list] = STATE(1085),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LT_COLON] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2466),
    [anon_sym_PIPE_GT] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_EQ_GT] = ACTIONS(2466),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2466),
    [aux_sym_integer_literal_token1] = ACTIONS(2466),
    [aux_sym_integer_literal_token2] = ACTIONS(2466),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2466),
    [sym__assign_operator] = ACTIONS(2464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
    [sym__immediate_string_start] = ACTIONS(2468),
    [sym__immediate_command_start] = ACTIONS(2470),
  },
  [845] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_end] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_primitive] = ACTIONS(2586),
    [aux_sym_primitive_definition_token1] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_macro] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_LT_COLON] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_elseif] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_catch] = ACTIONS(2586),
    [anon_sym_finally] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [sym_break_statement] = ACTIONS(2586),
    [sym_continue_statement] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_quote] = ACTIONS(2586),
    [anon_sym_using] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_COLON2] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_LT_PIPE] = ACTIONS(2586),
    [anon_sym_PIPE_GT] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_isa] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2586),
    [anon_sym_LBRACK2] = ACTIONS(2586),
    [anon_sym_DASH_GT] = ACTIONS(2590),
    [anon_sym_DOLLAR] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2586),
    [aux_sym_integer_literal_token1] = ACTIONS(2586),
    [aux_sym_integer_literal_token2] = ACTIONS(2586),
    [aux_sym_integer_literal_token3] = ACTIONS(2586),
    [sym_float_literal] = ACTIONS(2586),
    [sym__unary_operator] = ACTIONS(2586),
    [sym__power_operator] = ACTIONS(2586),
    [sym__bitshift_operator] = ACTIONS(2586),
    [sym__rational_operator] = ACTIONS(2586),
    [sym__times_operator] = ACTIONS(2586),
    [sym__plus_operator] = ACTIONS(2586),
    [sym__dotty_operator] = ACTIONS(2586),
    [sym__comparison_operator] = ACTIONS(2586),
    [sym__arrow_operator] = ACTIONS(2586),
    [sym__assign_operator] = ACTIONS(2586),
    [anon_sym_LF] = ACTIONS(2588),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__command_start] = ACTIONS(2588),
  },
  [846] = {
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_end] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_primitive] = ACTIONS(2592),
    [aux_sym_primitive_definition_token1] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_macro] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2592),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_EQ] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LT_COLON] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_elseif] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_catch] = ACTIONS(2592),
    [anon_sym_finally] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [sym_break_statement] = ACTIONS(2592),
    [sym_continue_statement] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_quote] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_COLON2] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_begin] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_LT_PIPE] = ACTIONS(2592),
    [anon_sym_PIPE_GT] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_isa] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2592),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK2] = ACTIONS(2592),
    [anon_sym_DOLLAR] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(2592),
    [aux_sym_integer_literal_token1] = ACTIONS(2592),
    [aux_sym_integer_literal_token2] = ACTIONS(2592),
    [aux_sym_integer_literal_token3] = ACTIONS(2592),
    [sym_float_literal] = ACTIONS(2592),
    [sym__unary_operator] = ACTIONS(2592),
    [sym__power_operator] = ACTIONS(2592),
    [sym__bitshift_operator] = ACTIONS(2592),
    [sym__rational_operator] = ACTIONS(2592),
    [sym__times_operator] = ACTIONS(2592),
    [sym__plus_operator] = ACTIONS(2592),
    [sym__dotty_operator] = ACTIONS(2592),
    [sym__comparison_operator] = ACTIONS(2592),
    [sym__arrow_operator] = ACTIONS(2592),
    [sym__assign_operator] = ACTIONS(2592),
    [anon_sym_LF] = ACTIONS(2594),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2594),
    [sym__string_start] = ACTIONS(2594),
    [sym__command_start] = ACTIONS(2594),
  },
  [847] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_end] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_primitive] = ACTIONS(2596),
    [aux_sym_primitive_definition_token1] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_macro] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2596),
    [anon_sym_RPAREN] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2596),
    [anon_sym_EQ] = ACTIONS(2596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2596),
    [anon_sym_LT_COLON] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_elseif] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_catch] = ACTIONS(2596),
    [anon_sym_finally] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [sym_break_statement] = ACTIONS(2596),
    [sym_continue_statement] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_quote] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_COLON2] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_begin] = ACTIONS(2596),
    [anon_sym_SQUOTE] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_LT_PIPE] = ACTIONS(2596),
    [anon_sym_PIPE_GT] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_isa] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_QMARK] = ACTIONS(2596),
    [anon_sym_EQ_GT] = ACTIONS(2596),
    [anon_sym_LBRACK2] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(2596),
    [aux_sym_integer_literal_token1] = ACTIONS(2596),
    [aux_sym_integer_literal_token2] = ACTIONS(2596),
    [aux_sym_integer_literal_token3] = ACTIONS(2596),
    [sym_float_literal] = ACTIONS(2596),
    [sym__unary_operator] = ACTIONS(2596),
    [sym__power_operator] = ACTIONS(2596),
    [sym__bitshift_operator] = ACTIONS(2596),
    [sym__rational_operator] = ACTIONS(2596),
    [sym__times_operator] = ACTIONS(2596),
    [sym__plus_operator] = ACTIONS(2596),
    [sym__dotty_operator] = ACTIONS(2596),
    [sym__comparison_operator] = ACTIONS(2596),
    [sym__arrow_operator] = ACTIONS(2596),
    [sym__assign_operator] = ACTIONS(2596),
    [anon_sym_LF] = ACTIONS(2598),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2598),
    [sym__string_start] = ACTIONS(2598),
    [sym__command_start] = ACTIONS(2598),
  },
  [848] = {
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_end] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_primitive] = ACTIONS(2600),
    [aux_sym_primitive_definition_token1] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_macro] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_EQ] = ACTIONS(2600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2600),
    [anon_sym_COLON_COLON] = ACTIONS(2600),
    [anon_sym_LT_COLON] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_elseif] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_catch] = ACTIONS(2600),
    [anon_sym_finally] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [sym_break_statement] = ACTIONS(2600),
    [sym_continue_statement] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_quote] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_COLON2] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_begin] = ACTIONS(2600),
    [anon_sym_SQUOTE] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_LT_PIPE] = ACTIONS(2600),
    [anon_sym_PIPE_GT] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_isa] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_EQ_GT] = ACTIONS(2600),
    [anon_sym_LBRACK2] = ACTIONS(2600),
    [anon_sym_DOLLAR] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2600),
    [aux_sym_integer_literal_token1] = ACTIONS(2600),
    [aux_sym_integer_literal_token2] = ACTIONS(2600),
    [aux_sym_integer_literal_token3] = ACTIONS(2600),
    [sym_float_literal] = ACTIONS(2600),
    [sym__unary_operator] = ACTIONS(2600),
    [sym__power_operator] = ACTIONS(2600),
    [sym__bitshift_operator] = ACTIONS(2600),
    [sym__rational_operator] = ACTIONS(2600),
    [sym__times_operator] = ACTIONS(2600),
    [sym__plus_operator] = ACTIONS(2600),
    [sym__dotty_operator] = ACTIONS(2600),
    [sym__comparison_operator] = ACTIONS(2600),
    [sym__arrow_operator] = ACTIONS(2600),
    [sym__assign_operator] = ACTIONS(2600),
    [anon_sym_LF] = ACTIONS(2602),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2602),
    [sym__string_start] = ACTIONS(2602),
    [sym__command_start] = ACTIONS(2602),
  },
  [849] = {
    [sym_type_argument_list] = STATE(1239),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_elseif] = ACTIONS(85),
    [anon_sym_else] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(2606),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(85),
    [aux_sym_integer_literal_token1] = ACTIONS(85),
    [aux_sym_integer_literal_token2] = ACTIONS(85),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
    [sym__immediate_string_start] = ACTIONS(2608),
    [sym__immediate_command_start] = ACTIONS(2610),
  },
  [850] = {
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_function] = ACTIONS(2612),
    [anon_sym_end] = ACTIONS(2612),
    [anon_sym_abstract] = ACTIONS(2612),
    [anon_sym_primitive] = ACTIONS(2612),
    [aux_sym_primitive_definition_token1] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2612),
    [anon_sym_macro] = ACTIONS(2612),
    [anon_sym_LPAREN] = ACTIONS(2612),
    [anon_sym_COMMA] = ACTIONS(2612),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2612),
    [anon_sym_EQ] = ACTIONS(2612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2612),
    [anon_sym_LT_COLON] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_elseif] = ACTIONS(2612),
    [anon_sym_else] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_catch] = ACTIONS(2612),
    [anon_sym_finally] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [sym_break_statement] = ACTIONS(2612),
    [sym_continue_statement] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_quote] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_import] = ACTIONS(2612),
    [anon_sym_DOT] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2612),
    [anon_sym_COLON2] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2614),
    [anon_sym_begin] = ACTIONS(2612),
    [anon_sym_SQUOTE] = ACTIONS(2612),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_LT_PIPE] = ACTIONS(2612),
    [anon_sym_PIPE_GT] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_isa] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_QMARK] = ACTIONS(2612),
    [anon_sym_EQ_GT] = ACTIONS(2612),
    [anon_sym_LBRACK2] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2612),
    [anon_sym_AT] = ACTIONS(2612),
    [aux_sym_integer_literal_token1] = ACTIONS(2612),
    [aux_sym_integer_literal_token2] = ACTIONS(2612),
    [aux_sym_integer_literal_token3] = ACTIONS(2612),
    [sym_float_literal] = ACTIONS(2612),
    [sym__unary_operator] = ACTIONS(2612),
    [sym__power_operator] = ACTIONS(2612),
    [sym__bitshift_operator] = ACTIONS(2612),
    [sym__rational_operator] = ACTIONS(2612),
    [sym__times_operator] = ACTIONS(2612),
    [sym__plus_operator] = ACTIONS(2612),
    [sym__dotty_operator] = ACTIONS(2612),
    [sym__comparison_operator] = ACTIONS(2612),
    [sym__arrow_operator] = ACTIONS(2612),
    [sym__assign_operator] = ACTIONS(2612),
    [anon_sym_LF] = ACTIONS(2614),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2614),
    [sym__string_start] = ACTIONS(2614),
    [sym__command_start] = ACTIONS(2614),
  },
  [851] = {
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_function] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_abstract] = ACTIONS(2616),
    [anon_sym_primitive] = ACTIONS(2616),
    [aux_sym_primitive_definition_token1] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_macro] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2616),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_LT_COLON] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_elseif] = ACTIONS(2616),
    [anon_sym_else] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_catch] = ACTIONS(2616),
    [anon_sym_finally] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [sym_break_statement] = ACTIONS(2616),
    [sym_continue_statement] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_let] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_quote] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_import] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2616),
    [anon_sym_COLON2] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_SQUOTE] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_LT_PIPE] = ACTIONS(2616),
    [anon_sym_PIPE_GT] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_isa] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2616),
    [anon_sym_LBRACK2] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_AT] = ACTIONS(2616),
    [aux_sym_integer_literal_token1] = ACTIONS(2616),
    [aux_sym_integer_literal_token2] = ACTIONS(2616),
    [aux_sym_integer_literal_token3] = ACTIONS(2616),
    [sym_float_literal] = ACTIONS(2616),
    [sym__unary_operator] = ACTIONS(2616),
    [sym__power_operator] = ACTIONS(2616),
    [sym__bitshift_operator] = ACTIONS(2616),
    [sym__rational_operator] = ACTIONS(2616),
    [sym__times_operator] = ACTIONS(2616),
    [sym__plus_operator] = ACTIONS(2616),
    [sym__dotty_operator] = ACTIONS(2616),
    [sym__comparison_operator] = ACTIONS(2616),
    [sym__arrow_operator] = ACTIONS(2616),
    [sym__assign_operator] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2618),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__command_start] = ACTIONS(2618),
  },
  [852] = {
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_function] = ACTIONS(2620),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_abstract] = ACTIONS(2620),
    [anon_sym_primitive] = ACTIONS(2620),
    [aux_sym_primitive_definition_token1] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_macro] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_RPAREN] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2620),
    [anon_sym_LT_COLON] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_elseif] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_catch] = ACTIONS(2620),
    [anon_sym_finally] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [sym_break_statement] = ACTIONS(2620),
    [sym_continue_statement] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_quote] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_import] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_COLON2] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_LT_PIPE] = ACTIONS(2620),
    [anon_sym_PIPE_GT] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_isa] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK2] = ACTIONS(2620),
    [anon_sym_DOLLAR] = ACTIONS(2620),
    [anon_sym_AT] = ACTIONS(2620),
    [aux_sym_integer_literal_token1] = ACTIONS(2620),
    [aux_sym_integer_literal_token2] = ACTIONS(2620),
    [aux_sym_integer_literal_token3] = ACTIONS(2620),
    [sym_float_literal] = ACTIONS(2620),
    [sym__unary_operator] = ACTIONS(2620),
    [sym__power_operator] = ACTIONS(2620),
    [sym__bitshift_operator] = ACTIONS(2620),
    [sym__rational_operator] = ACTIONS(2620),
    [sym__times_operator] = ACTIONS(2620),
    [sym__plus_operator] = ACTIONS(2620),
    [sym__dotty_operator] = ACTIONS(2620),
    [sym__comparison_operator] = ACTIONS(2620),
    [sym__arrow_operator] = ACTIONS(2620),
    [sym__assign_operator] = ACTIONS(2620),
    [anon_sym_LF] = ACTIONS(2622),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__command_start] = ACTIONS(2622),
  },
  [853] = {
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_primitive] = ACTIONS(2624),
    [aux_sym_primitive_definition_token1] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_macro] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2624),
    [anon_sym_RPAREN] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_LT_COLON] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_elseif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_catch] = ACTIONS(2624),
    [anon_sym_finally] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [sym_break_statement] = ACTIONS(2624),
    [sym_continue_statement] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_quote] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_COLON2] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_SQUOTE] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_LT_PIPE] = ACTIONS(2624),
    [anon_sym_PIPE_GT] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_isa] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2624),
    [anon_sym_LBRACK2] = ACTIONS(2624),
    [anon_sym_DOLLAR] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(2624),
    [aux_sym_integer_literal_token1] = ACTIONS(2624),
    [aux_sym_integer_literal_token2] = ACTIONS(2624),
    [aux_sym_integer_literal_token3] = ACTIONS(2624),
    [sym_float_literal] = ACTIONS(2624),
    [sym__unary_operator] = ACTIONS(2624),
    [sym__power_operator] = ACTIONS(2624),
    [sym__bitshift_operator] = ACTIONS(2624),
    [sym__rational_operator] = ACTIONS(2624),
    [sym__times_operator] = ACTIONS(2624),
    [sym__plus_operator] = ACTIONS(2624),
    [sym__dotty_operator] = ACTIONS(2624),
    [sym__comparison_operator] = ACTIONS(2624),
    [sym__arrow_operator] = ACTIONS(2624),
    [sym__assign_operator] = ACTIONS(2624),
    [anon_sym_LF] = ACTIONS(2626),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__command_start] = ACTIONS(2626),
  },
  [854] = {
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_function] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_primitive] = ACTIONS(2628),
    [aux_sym_primitive_definition_token1] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_macro] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_RPAREN] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_LT_COLON] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_elseif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_catch] = ACTIONS(2628),
    [anon_sym_finally] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [sym_break_statement] = ACTIONS(2628),
    [sym_continue_statement] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_quote] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_COLON2] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_LT_PIPE] = ACTIONS(2628),
    [anon_sym_PIPE_GT] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_isa] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2628),
    [anon_sym_LBRACK2] = ACTIONS(2628),
    [anon_sym_DOLLAR] = ACTIONS(2628),
    [anon_sym_AT] = ACTIONS(2628),
    [aux_sym_integer_literal_token1] = ACTIONS(2628),
    [aux_sym_integer_literal_token2] = ACTIONS(2628),
    [aux_sym_integer_literal_token3] = ACTIONS(2628),
    [sym_float_literal] = ACTIONS(2628),
    [sym__unary_operator] = ACTIONS(2628),
    [sym__power_operator] = ACTIONS(2628),
    [sym__bitshift_operator] = ACTIONS(2628),
    [sym__rational_operator] = ACTIONS(2628),
    [sym__times_operator] = ACTIONS(2628),
    [sym__plus_operator] = ACTIONS(2628),
    [sym__dotty_operator] = ACTIONS(2628),
    [sym__comparison_operator] = ACTIONS(2628),
    [sym__arrow_operator] = ACTIONS(2628),
    [sym__assign_operator] = ACTIONS(2628),
    [anon_sym_LF] = ACTIONS(2630),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__command_start] = ACTIONS(2630),
  },
  [855] = {
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_primitive] = ACTIONS(2632),
    [aux_sym_primitive_definition_token1] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_macro] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_LT_COLON] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_elseif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_catch] = ACTIONS(2632),
    [anon_sym_finally] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [sym_break_statement] = ACTIONS(2632),
    [sym_continue_statement] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_quote] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_COLON2] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_LT_PIPE] = ACTIONS(2632),
    [anon_sym_PIPE_GT] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_isa] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2632),
    [anon_sym_LBRACK2] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2632),
    [aux_sym_integer_literal_token1] = ACTIONS(2632),
    [aux_sym_integer_literal_token2] = ACTIONS(2632),
    [aux_sym_integer_literal_token3] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__unary_operator] = ACTIONS(2632),
    [sym__power_operator] = ACTIONS(2632),
    [sym__bitshift_operator] = ACTIONS(2632),
    [sym__rational_operator] = ACTIONS(2632),
    [sym__times_operator] = ACTIONS(2632),
    [sym__plus_operator] = ACTIONS(2632),
    [sym__dotty_operator] = ACTIONS(2632),
    [sym__comparison_operator] = ACTIONS(2632),
    [sym__arrow_operator] = ACTIONS(2632),
    [sym__assign_operator] = ACTIONS(2632),
    [anon_sym_LF] = ACTIONS(2634),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__command_start] = ACTIONS(2634),
  },
  [856] = {
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_end] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_primitive] = ACTIONS(2636),
    [aux_sym_primitive_definition_token1] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_macro] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2636),
    [anon_sym_LT_COLON] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_elseif] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_catch] = ACTIONS(2636),
    [anon_sym_finally] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [sym_break_statement] = ACTIONS(2636),
    [sym_continue_statement] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_quote] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_COLON2] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_LT_PIPE] = ACTIONS(2636),
    [anon_sym_PIPE_GT] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_isa] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK2] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2636),
    [aux_sym_integer_literal_token1] = ACTIONS(2636),
    [aux_sym_integer_literal_token2] = ACTIONS(2636),
    [aux_sym_integer_literal_token3] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__unary_operator] = ACTIONS(2636),
    [sym__power_operator] = ACTIONS(2636),
    [sym__bitshift_operator] = ACTIONS(2636),
    [sym__rational_operator] = ACTIONS(2636),
    [sym__times_operator] = ACTIONS(2636),
    [sym__plus_operator] = ACTIONS(2636),
    [sym__dotty_operator] = ACTIONS(2636),
    [sym__comparison_operator] = ACTIONS(2636),
    [sym__arrow_operator] = ACTIONS(2636),
    [sym__assign_operator] = ACTIONS(2636),
    [anon_sym_LF] = ACTIONS(2638),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__command_start] = ACTIONS(2638),
  },
  [857] = {
    [sym_type_argument_list] = STATE(1229),
    [ts_builtin_sym_end] = ACTIONS(97),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_EQ] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(2642),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(85),
    [aux_sym_integer_literal_token1] = ACTIONS(85),
    [aux_sym_integer_literal_token2] = ACTIONS(85),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(85),
    [sym__assign_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
    [sym__immediate_string_start] = ACTIONS(2644),
    [sym__immediate_command_start] = ACTIONS(2646),
  },
  [858] = {
    [aux_sym_import_statement_repeat1] = STATE(888),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2650),
    [anon_sym_RPAREN] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2648),
    [anon_sym_LT_COLON] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_elseif] = ACTIONS(2648),
    [anon_sym_else] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_catch] = ACTIONS(2648),
    [anon_sym_finally] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(2652),
    [anon_sym_DOT] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_GT] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_EQ_GT] = ACTIONS(2648),
    [anon_sym_LBRACK2] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2648),
    [aux_sym_integer_literal_token1] = ACTIONS(2648),
    [aux_sym_integer_literal_token2] = ACTIONS(2648),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2648),
    [sym__assign_operator] = ACTIONS(2648),
    [anon_sym_LF] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [859] = {
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(2658),
    [anon_sym_end] = ACTIONS(2658),
    [anon_sym_abstract] = ACTIONS(2658),
    [anon_sym_primitive] = ACTIONS(2658),
    [aux_sym_primitive_definition_token1] = ACTIONS(2658),
    [anon_sym_mutable] = ACTIONS(2658),
    [anon_sym_struct] = ACTIONS(2658),
    [anon_sym_module] = ACTIONS(2658),
    [anon_sym_macro] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_COMMA] = ACTIONS(2658),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2658),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2658),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LT_COLON] = ACTIONS(2658),
    [anon_sym_if] = ACTIONS(2658),
    [anon_sym_elseif] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_try] = ACTIONS(2658),
    [anon_sym_catch] = ACTIONS(2658),
    [anon_sym_finally] = ACTIONS(2658),
    [anon_sym_for] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [sym_break_statement] = ACTIONS(2658),
    [sym_continue_statement] = ACTIONS(2658),
    [anon_sym_return] = ACTIONS(2658),
    [anon_sym_let] = ACTIONS(2658),
    [anon_sym_const] = ACTIONS(2658),
    [anon_sym_quote] = ACTIONS(2658),
    [anon_sym_using] = ACTIONS(2658),
    [anon_sym_import] = ACTIONS(2658),
    [anon_sym_DOT] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2658),
    [anon_sym_COLON2] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_begin] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_LT_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE_GT] = ACTIONS(2658),
    [anon_sym_in] = ACTIONS(2658),
    [anon_sym_isa] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2658),
    [anon_sym_EQ_GT] = ACTIONS(2658),
    [anon_sym_LBRACK2] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2658),
    [aux_sym_integer_literal_token1] = ACTIONS(2658),
    [aux_sym_integer_literal_token2] = ACTIONS(2658),
    [aux_sym_integer_literal_token3] = ACTIONS(2658),
    [sym_float_literal] = ACTIONS(2658),
    [sym__unary_operator] = ACTIONS(2658),
    [sym__power_operator] = ACTIONS(2658),
    [sym__bitshift_operator] = ACTIONS(2658),
    [sym__rational_operator] = ACTIONS(2658),
    [sym__times_operator] = ACTIONS(2658),
    [sym__plus_operator] = ACTIONS(2658),
    [sym__dotty_operator] = ACTIONS(2658),
    [sym__comparison_operator] = ACTIONS(2658),
    [sym__arrow_operator] = ACTIONS(2658),
    [sym__assign_operator] = ACTIONS(2658),
    [anon_sym_LF] = ACTIONS(2660),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2660),
    [sym__string_start] = ACTIONS(2660),
    [sym__command_start] = ACTIONS(2660),
  },
  [860] = {
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(2662),
    [anon_sym_end] = ACTIONS(2662),
    [anon_sym_abstract] = ACTIONS(2662),
    [anon_sym_primitive] = ACTIONS(2662),
    [aux_sym_primitive_definition_token1] = ACTIONS(2662),
    [anon_sym_mutable] = ACTIONS(2662),
    [anon_sym_struct] = ACTIONS(2662),
    [anon_sym_module] = ACTIONS(2662),
    [anon_sym_macro] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_RPAREN] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2662),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LT_COLON] = ACTIONS(2662),
    [anon_sym_if] = ACTIONS(2662),
    [anon_sym_elseif] = ACTIONS(2662),
    [anon_sym_else] = ACTIONS(2662),
    [anon_sym_try] = ACTIONS(2662),
    [anon_sym_catch] = ACTIONS(2662),
    [anon_sym_finally] = ACTIONS(2662),
    [anon_sym_for] = ACTIONS(2662),
    [anon_sym_while] = ACTIONS(2662),
    [sym_break_statement] = ACTIONS(2662),
    [sym_continue_statement] = ACTIONS(2662),
    [anon_sym_return] = ACTIONS(2662),
    [anon_sym_let] = ACTIONS(2662),
    [anon_sym_const] = ACTIONS(2662),
    [anon_sym_quote] = ACTIONS(2662),
    [anon_sym_using] = ACTIONS(2662),
    [anon_sym_import] = ACTIONS(2662),
    [anon_sym_DOT] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_COLON2] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_begin] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [anon_sym_PLUS] = ACTIONS(2662),
    [anon_sym_LT_PIPE] = ACTIONS(2662),
    [anon_sym_PIPE_GT] = ACTIONS(2662),
    [anon_sym_in] = ACTIONS(2662),
    [anon_sym_isa] = ACTIONS(2662),
    [anon_sym_PIPE_PIPE] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_QMARK] = ACTIONS(2662),
    [anon_sym_EQ_GT] = ACTIONS(2662),
    [anon_sym_LBRACK2] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(2662),
    [aux_sym_integer_literal_token1] = ACTIONS(2662),
    [aux_sym_integer_literal_token2] = ACTIONS(2662),
    [aux_sym_integer_literal_token3] = ACTIONS(2662),
    [sym_float_literal] = ACTIONS(2662),
    [sym__unary_operator] = ACTIONS(2662),
    [sym__power_operator] = ACTIONS(2662),
    [sym__bitshift_operator] = ACTIONS(2662),
    [sym__rational_operator] = ACTIONS(2662),
    [sym__times_operator] = ACTIONS(2662),
    [sym__plus_operator] = ACTIONS(2662),
    [sym__dotty_operator] = ACTIONS(2662),
    [sym__comparison_operator] = ACTIONS(2662),
    [sym__arrow_operator] = ACTIONS(2662),
    [sym__assign_operator] = ACTIONS(2662),
    [anon_sym_LF] = ACTIONS(2664),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2664),
    [sym__string_start] = ACTIONS(2664),
    [sym__command_start] = ACTIONS(2664),
  },
  [861] = {
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_end] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_primitive] = ACTIONS(2666),
    [aux_sym_primitive_definition_token1] = ACTIONS(2666),
    [anon_sym_mutable] = ACTIONS(2666),
    [anon_sym_struct] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_macro] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2666),
    [anon_sym_COMMA] = ACTIONS(2666),
    [anon_sym_RPAREN] = ACTIONS(2666),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_EQ] = ACTIONS(2666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2666),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_LT_COLON] = ACTIONS(2666),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_elseif] = ACTIONS(2666),
    [anon_sym_else] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_catch] = ACTIONS(2666),
    [anon_sym_finally] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [sym_break_statement] = ACTIONS(2666),
    [sym_continue_statement] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_quote] = ACTIONS(2666),
    [anon_sym_using] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_DOT] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_COLON2] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_begin] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_LT_PIPE] = ACTIONS(2666),
    [anon_sym_PIPE_GT] = ACTIONS(2666),
    [anon_sym_in] = ACTIONS(2666),
    [anon_sym_isa] = ACTIONS(2666),
    [anon_sym_PIPE_PIPE] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2666),
    [anon_sym_QMARK] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(2666),
    [anon_sym_LBRACK2] = ACTIONS(2666),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [anon_sym_AT] = ACTIONS(2666),
    [aux_sym_integer_literal_token1] = ACTIONS(2666),
    [aux_sym_integer_literal_token2] = ACTIONS(2666),
    [aux_sym_integer_literal_token3] = ACTIONS(2666),
    [sym_float_literal] = ACTIONS(2666),
    [sym__unary_operator] = ACTIONS(2666),
    [sym__power_operator] = ACTIONS(2666),
    [sym__bitshift_operator] = ACTIONS(2666),
    [sym__rational_operator] = ACTIONS(2666),
    [sym__times_operator] = ACTIONS(2666),
    [sym__plus_operator] = ACTIONS(2666),
    [sym__dotty_operator] = ACTIONS(2666),
    [sym__comparison_operator] = ACTIONS(2666),
    [sym__arrow_operator] = ACTIONS(2666),
    [sym__assign_operator] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2668),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2668),
    [sym__string_start] = ACTIONS(2668),
    [sym__command_start] = ACTIONS(2668),
  },
  [862] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_end] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_primitive] = ACTIONS(2670),
    [aux_sym_primitive_definition_token1] = ACTIONS(2670),
    [anon_sym_mutable] = ACTIONS(2670),
    [anon_sym_struct] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_macro] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_COMMA] = ACTIONS(2670),
    [anon_sym_RPAREN] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_EQ] = ACTIONS(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2670),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LT_COLON] = ACTIONS(2670),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_elseif] = ACTIONS(2670),
    [anon_sym_else] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_catch] = ACTIONS(2670),
    [anon_sym_finally] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [sym_break_statement] = ACTIONS(2670),
    [sym_continue_statement] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_quote] = ACTIONS(2670),
    [anon_sym_using] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_DOT] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_COLON2] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_begin] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_LT_PIPE] = ACTIONS(2670),
    [anon_sym_PIPE_GT] = ACTIONS(2670),
    [anon_sym_in] = ACTIONS(2670),
    [anon_sym_isa] = ACTIONS(2670),
    [anon_sym_PIPE_PIPE] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_QMARK] = ACTIONS(2670),
    [anon_sym_EQ_GT] = ACTIONS(2670),
    [anon_sym_LBRACK2] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2670),
    [aux_sym_integer_literal_token1] = ACTIONS(2670),
    [aux_sym_integer_literal_token2] = ACTIONS(2670),
    [aux_sym_integer_literal_token3] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
    [sym__unary_operator] = ACTIONS(2670),
    [sym__power_operator] = ACTIONS(2670),
    [sym__bitshift_operator] = ACTIONS(2670),
    [sym__rational_operator] = ACTIONS(2670),
    [sym__times_operator] = ACTIONS(2670),
    [sym__plus_operator] = ACTIONS(2670),
    [sym__dotty_operator] = ACTIONS(2670),
    [sym__comparison_operator] = ACTIONS(2670),
    [sym__arrow_operator] = ACTIONS(2670),
    [sym__assign_operator] = ACTIONS(2670),
    [anon_sym_LF] = ACTIONS(2672),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2672),
    [sym__string_start] = ACTIONS(2672),
    [sym__command_start] = ACTIONS(2672),
  },
  [863] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_end] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_primitive] = ACTIONS(2674),
    [aux_sym_primitive_definition_token1] = ACTIONS(2674),
    [anon_sym_mutable] = ACTIONS(2674),
    [anon_sym_struct] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_macro] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_COMMA] = ACTIONS(2674),
    [anon_sym_RPAREN] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_EQ] = ACTIONS(2674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2674),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_LT_COLON] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_elseif] = ACTIONS(2674),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_catch] = ACTIONS(2674),
    [anon_sym_finally] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [sym_break_statement] = ACTIONS(2674),
    [sym_continue_statement] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_quote] = ACTIONS(2674),
    [anon_sym_using] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_DOT] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_COLON2] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_begin] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_LT_PIPE] = ACTIONS(2674),
    [anon_sym_PIPE_GT] = ACTIONS(2674),
    [anon_sym_in] = ACTIONS(2674),
    [anon_sym_isa] = ACTIONS(2674),
    [anon_sym_PIPE_PIPE] = ACTIONS(2674),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_QMARK] = ACTIONS(2674),
    [anon_sym_EQ_GT] = ACTIONS(2674),
    [anon_sym_LBRACK2] = ACTIONS(2674),
    [anon_sym_DOLLAR] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2674),
    [aux_sym_integer_literal_token1] = ACTIONS(2674),
    [aux_sym_integer_literal_token2] = ACTIONS(2674),
    [aux_sym_integer_literal_token3] = ACTIONS(2674),
    [sym_float_literal] = ACTIONS(2674),
    [sym__unary_operator] = ACTIONS(2674),
    [sym__power_operator] = ACTIONS(2674),
    [sym__bitshift_operator] = ACTIONS(2674),
    [sym__rational_operator] = ACTIONS(2674),
    [sym__times_operator] = ACTIONS(2674),
    [sym__plus_operator] = ACTIONS(2674),
    [sym__dotty_operator] = ACTIONS(2674),
    [sym__comparison_operator] = ACTIONS(2674),
    [sym__arrow_operator] = ACTIONS(2674),
    [sym__assign_operator] = ACTIONS(2674),
    [anon_sym_LF] = ACTIONS(2676),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2676),
    [sym__string_start] = ACTIONS(2676),
    [sym__command_start] = ACTIONS(2676),
  },
  [864] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_end] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_primitive] = ACTIONS(2678),
    [aux_sym_primitive_definition_token1] = ACTIONS(2678),
    [anon_sym_mutable] = ACTIONS(2678),
    [anon_sym_struct] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_macro] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2678),
    [anon_sym_COMMA] = ACTIONS(2678),
    [anon_sym_RPAREN] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_EQ] = ACTIONS(2678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2678),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LT_COLON] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_elseif] = ACTIONS(2678),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_catch] = ACTIONS(2678),
    [anon_sym_finally] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [sym_break_statement] = ACTIONS(2678),
    [sym_continue_statement] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_quote] = ACTIONS(2678),
    [anon_sym_using] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_DOT] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_COLON2] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_begin] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_LT_PIPE] = ACTIONS(2678),
    [anon_sym_PIPE_GT] = ACTIONS(2678),
    [anon_sym_in] = ACTIONS(2678),
    [anon_sym_isa] = ACTIONS(2678),
    [anon_sym_PIPE_PIPE] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_QMARK] = ACTIONS(2678),
    [anon_sym_EQ_GT] = ACTIONS(2678),
    [anon_sym_LBRACK2] = ACTIONS(2678),
    [anon_sym_DOLLAR] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2678),
    [aux_sym_integer_literal_token1] = ACTIONS(2678),
    [aux_sym_integer_literal_token2] = ACTIONS(2678),
    [aux_sym_integer_literal_token3] = ACTIONS(2678),
    [sym_float_literal] = ACTIONS(2678),
    [sym__unary_operator] = ACTIONS(2678),
    [sym__power_operator] = ACTIONS(2678),
    [sym__bitshift_operator] = ACTIONS(2678),
    [sym__rational_operator] = ACTIONS(2678),
    [sym__times_operator] = ACTIONS(2678),
    [sym__plus_operator] = ACTIONS(2678),
    [sym__dotty_operator] = ACTIONS(2678),
    [sym__comparison_operator] = ACTIONS(2678),
    [sym__arrow_operator] = ACTIONS(2678),
    [sym__assign_operator] = ACTIONS(2678),
    [anon_sym_LF] = ACTIONS(2680),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2680),
    [sym__string_start] = ACTIONS(2680),
    [sym__command_start] = ACTIONS(2680),
  },
  [865] = {
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_end] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_primitive] = ACTIONS(2682),
    [aux_sym_primitive_definition_token1] = ACTIONS(2682),
    [anon_sym_mutable] = ACTIONS(2682),
    [anon_sym_struct] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_macro] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2682),
    [anon_sym_COMMA] = ACTIONS(2682),
    [anon_sym_RPAREN] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_EQ] = ACTIONS(2682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2682),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_LT_COLON] = ACTIONS(2682),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_elseif] = ACTIONS(2682),
    [anon_sym_else] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_catch] = ACTIONS(2682),
    [anon_sym_finally] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [sym_break_statement] = ACTIONS(2682),
    [sym_continue_statement] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_quote] = ACTIONS(2682),
    [anon_sym_using] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_DOT] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_COLON2] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_begin] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_LT_PIPE] = ACTIONS(2682),
    [anon_sym_PIPE_GT] = ACTIONS(2682),
    [anon_sym_in] = ACTIONS(2682),
    [anon_sym_isa] = ACTIONS(2682),
    [anon_sym_PIPE_PIPE] = ACTIONS(2682),
    [anon_sym_AMP_AMP] = ACTIONS(2682),
    [anon_sym_QMARK] = ACTIONS(2682),
    [anon_sym_EQ_GT] = ACTIONS(2682),
    [anon_sym_LBRACK2] = ACTIONS(2682),
    [anon_sym_DOLLAR] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2682),
    [aux_sym_integer_literal_token1] = ACTIONS(2682),
    [aux_sym_integer_literal_token2] = ACTIONS(2682),
    [aux_sym_integer_literal_token3] = ACTIONS(2682),
    [sym_float_literal] = ACTIONS(2682),
    [sym__unary_operator] = ACTIONS(2682),
    [sym__power_operator] = ACTIONS(2682),
    [sym__bitshift_operator] = ACTIONS(2682),
    [sym__rational_operator] = ACTIONS(2682),
    [sym__times_operator] = ACTIONS(2682),
    [sym__plus_operator] = ACTIONS(2682),
    [sym__dotty_operator] = ACTIONS(2682),
    [sym__comparison_operator] = ACTIONS(2682),
    [sym__arrow_operator] = ACTIONS(2682),
    [sym__assign_operator] = ACTIONS(2682),
    [anon_sym_LF] = ACTIONS(2684),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2684),
    [sym__string_start] = ACTIONS(2684),
    [sym__command_start] = ACTIONS(2684),
  },
  [866] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_end] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_primitive] = ACTIONS(2686),
    [aux_sym_primitive_definition_token1] = ACTIONS(2686),
    [anon_sym_mutable] = ACTIONS(2686),
    [anon_sym_struct] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_macro] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_COMMA] = ACTIONS(2686),
    [anon_sym_RPAREN] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(2686),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2686),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LT_COLON] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_elseif] = ACTIONS(2686),
    [anon_sym_else] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_catch] = ACTIONS(2686),
    [anon_sym_finally] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [sym_break_statement] = ACTIONS(2686),
    [sym_continue_statement] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_quote] = ACTIONS(2686),
    [anon_sym_using] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_DOT] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_COLON2] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_begin] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_LT_PIPE] = ACTIONS(2686),
    [anon_sym_PIPE_GT] = ACTIONS(2686),
    [anon_sym_in] = ACTIONS(2686),
    [anon_sym_isa] = ACTIONS(2686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_QMARK] = ACTIONS(2686),
    [anon_sym_EQ_GT] = ACTIONS(2686),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2686),
    [aux_sym_integer_literal_token1] = ACTIONS(2686),
    [aux_sym_integer_literal_token2] = ACTIONS(2686),
    [aux_sym_integer_literal_token3] = ACTIONS(2686),
    [sym_float_literal] = ACTIONS(2686),
    [sym__unary_operator] = ACTIONS(2686),
    [sym__power_operator] = ACTIONS(2686),
    [sym__bitshift_operator] = ACTIONS(2686),
    [sym__rational_operator] = ACTIONS(2686),
    [sym__times_operator] = ACTIONS(2686),
    [sym__plus_operator] = ACTIONS(2686),
    [sym__dotty_operator] = ACTIONS(2686),
    [sym__comparison_operator] = ACTIONS(2686),
    [sym__arrow_operator] = ACTIONS(2686),
    [sym__assign_operator] = ACTIONS(2686),
    [anon_sym_LF] = ACTIONS(2688),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2688),
    [sym__string_start] = ACTIONS(2688),
    [sym__command_start] = ACTIONS(2688),
  },
  [867] = {
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_RPAREN] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LT_COLON] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_elseif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_catch] = ACTIONS(2464),
    [anon_sym_finally] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2464),
    [anon_sym_PIPE_GT] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2464),
    [aux_sym_integer_literal_token1] = ACTIONS(2464),
    [aux_sym_integer_literal_token2] = ACTIONS(2464),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2464),
    [sym__assign_operator] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
  },
  [868] = {
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_end] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_primitive] = ACTIONS(2690),
    [aux_sym_primitive_definition_token1] = ACTIONS(2690),
    [anon_sym_mutable] = ACTIONS(2690),
    [anon_sym_struct] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_macro] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_COMMA] = ACTIONS(2690),
    [anon_sym_RPAREN] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_EQ] = ACTIONS(2690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_LT_COLON] = ACTIONS(2690),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_elseif] = ACTIONS(2690),
    [anon_sym_else] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_catch] = ACTIONS(2690),
    [anon_sym_finally] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [sym_break_statement] = ACTIONS(2690),
    [sym_continue_statement] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_quote] = ACTIONS(2690),
    [anon_sym_using] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_COLON2] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_begin] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_LT_PIPE] = ACTIONS(2690),
    [anon_sym_PIPE_GT] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2690),
    [anon_sym_isa] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_QMARK] = ACTIONS(2690),
    [anon_sym_EQ_GT] = ACTIONS(2690),
    [anon_sym_LBRACK2] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2690),
    [aux_sym_integer_literal_token1] = ACTIONS(2690),
    [aux_sym_integer_literal_token2] = ACTIONS(2690),
    [aux_sym_integer_literal_token3] = ACTIONS(2690),
    [sym_float_literal] = ACTIONS(2690),
    [sym__unary_operator] = ACTIONS(2690),
    [sym__power_operator] = ACTIONS(2690),
    [sym__bitshift_operator] = ACTIONS(2690),
    [sym__rational_operator] = ACTIONS(2690),
    [sym__times_operator] = ACTIONS(2690),
    [sym__plus_operator] = ACTIONS(2690),
    [sym__dotty_operator] = ACTIONS(2690),
    [sym__comparison_operator] = ACTIONS(2690),
    [sym__arrow_operator] = ACTIONS(2690),
    [sym__assign_operator] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2692),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2692),
    [sym__string_start] = ACTIONS(2692),
    [sym__command_start] = ACTIONS(2692),
  },
  [869] = {
    [sym_type_argument_list] = STATE(1221),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_LT_COLON] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(97),
    [anon_sym_PIPE_GT] = ACTIONS(97),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(97),
    [anon_sym_AMP_AMP] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(97),
    [anon_sym_EQ_GT] = ACTIONS(97),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(97),
    [aux_sym_integer_literal_token1] = ACTIONS(97),
    [aux_sym_integer_literal_token2] = ACTIONS(97),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(97),
    [sym__bitshift_operator] = ACTIONS(97),
    [sym__rational_operator] = ACTIONS(97),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
    [sym__immediate_string_start] = ACTIONS(2698),
    [sym__immediate_command_start] = ACTIONS(2700),
  },
  [870] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_elseif] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_catch] = ACTIONS(2702),
    [anon_sym_finally] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_DOT] = ACTIONS(2704),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [sym__assign_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2710),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [871] = {
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_end] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_primitive] = ACTIONS(2712),
    [aux_sym_primitive_definition_token1] = ACTIONS(2712),
    [anon_sym_mutable] = ACTIONS(2712),
    [anon_sym_struct] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_macro] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_COMMA] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2712),
    [anon_sym_COLON_COLON] = ACTIONS(2712),
    [anon_sym_LT_COLON] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_elseif] = ACTIONS(2712),
    [anon_sym_else] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_catch] = ACTIONS(2712),
    [anon_sym_finally] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [sym_break_statement] = ACTIONS(2712),
    [sym_continue_statement] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_quote] = ACTIONS(2712),
    [anon_sym_using] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_DOT] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_COLON2] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_begin] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_LT_PIPE] = ACTIONS(2712),
    [anon_sym_PIPE_GT] = ACTIONS(2712),
    [anon_sym_in] = ACTIONS(2712),
    [anon_sym_isa] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_QMARK] = ACTIONS(2712),
    [anon_sym_EQ_GT] = ACTIONS(2712),
    [anon_sym_LBRACK2] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2712),
    [aux_sym_integer_literal_token1] = ACTIONS(2712),
    [aux_sym_integer_literal_token2] = ACTIONS(2712),
    [aux_sym_integer_literal_token3] = ACTIONS(2712),
    [sym_float_literal] = ACTIONS(2712),
    [sym__unary_operator] = ACTIONS(2712),
    [sym__power_operator] = ACTIONS(2712),
    [sym__bitshift_operator] = ACTIONS(2712),
    [sym__rational_operator] = ACTIONS(2712),
    [sym__times_operator] = ACTIONS(2712),
    [sym__plus_operator] = ACTIONS(2712),
    [sym__dotty_operator] = ACTIONS(2712),
    [sym__comparison_operator] = ACTIONS(2712),
    [sym__arrow_operator] = ACTIONS(2712),
    [sym__assign_operator] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2714),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2714),
    [sym__string_start] = ACTIONS(2714),
    [sym__command_start] = ACTIONS(2714),
  },
  [872] = {
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_end] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_primitive] = ACTIONS(2716),
    [aux_sym_primitive_definition_token1] = ACTIONS(2716),
    [anon_sym_mutable] = ACTIONS(2716),
    [anon_sym_struct] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_macro] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(2716),
    [anon_sym_RPAREN] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(2716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2716),
    [anon_sym_COLON_COLON] = ACTIONS(2716),
    [anon_sym_LT_COLON] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_elseif] = ACTIONS(2716),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_catch] = ACTIONS(2716),
    [anon_sym_finally] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [sym_break_statement] = ACTIONS(2716),
    [sym_continue_statement] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_quote] = ACTIONS(2716),
    [anon_sym_using] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_DOT] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_COLON2] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_begin] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_LT_PIPE] = ACTIONS(2716),
    [anon_sym_PIPE_GT] = ACTIONS(2716),
    [anon_sym_in] = ACTIONS(2716),
    [anon_sym_isa] = ACTIONS(2716),
    [anon_sym_PIPE_PIPE] = ACTIONS(2716),
    [anon_sym_AMP_AMP] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2716),
    [anon_sym_EQ_GT] = ACTIONS(2716),
    [anon_sym_LBRACK2] = ACTIONS(2716),
    [anon_sym_DOLLAR] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2716),
    [aux_sym_integer_literal_token1] = ACTIONS(2716),
    [aux_sym_integer_literal_token2] = ACTIONS(2716),
    [aux_sym_integer_literal_token3] = ACTIONS(2716),
    [sym_float_literal] = ACTIONS(2716),
    [sym__unary_operator] = ACTIONS(2716),
    [sym__power_operator] = ACTIONS(2716),
    [sym__bitshift_operator] = ACTIONS(2716),
    [sym__rational_operator] = ACTIONS(2716),
    [sym__times_operator] = ACTIONS(2716),
    [sym__plus_operator] = ACTIONS(2716),
    [sym__dotty_operator] = ACTIONS(2716),
    [sym__comparison_operator] = ACTIONS(2716),
    [sym__arrow_operator] = ACTIONS(2716),
    [sym__assign_operator] = ACTIONS(2716),
    [anon_sym_LF] = ACTIONS(2718),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2718),
    [sym__string_start] = ACTIONS(2718),
    [sym__command_start] = ACTIONS(2718),
  },
  [873] = {
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_end] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_primitive] = ACTIONS(2720),
    [aux_sym_primitive_definition_token1] = ACTIONS(2720),
    [anon_sym_mutable] = ACTIONS(2720),
    [anon_sym_struct] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_macro] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2720),
    [anon_sym_COMMA] = ACTIONS(2720),
    [anon_sym_RPAREN] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_EQ] = ACTIONS(2720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2720),
    [anon_sym_COLON_COLON] = ACTIONS(2720),
    [anon_sym_LT_COLON] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_elseif] = ACTIONS(2720),
    [anon_sym_else] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_catch] = ACTIONS(2720),
    [anon_sym_finally] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [sym_break_statement] = ACTIONS(2720),
    [sym_continue_statement] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_quote] = ACTIONS(2720),
    [anon_sym_using] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_DOT] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_COLON2] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_begin] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_LT_PIPE] = ACTIONS(2720),
    [anon_sym_PIPE_GT] = ACTIONS(2720),
    [anon_sym_in] = ACTIONS(2720),
    [anon_sym_isa] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(2720),
    [anon_sym_AMP_AMP] = ACTIONS(2720),
    [anon_sym_QMARK] = ACTIONS(2720),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_LBRACK2] = ACTIONS(2720),
    [anon_sym_DOLLAR] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2720),
    [aux_sym_integer_literal_token1] = ACTIONS(2720),
    [aux_sym_integer_literal_token2] = ACTIONS(2720),
    [aux_sym_integer_literal_token3] = ACTIONS(2720),
    [sym_float_literal] = ACTIONS(2720),
    [sym__unary_operator] = ACTIONS(2720),
    [sym__power_operator] = ACTIONS(2720),
    [sym__bitshift_operator] = ACTIONS(2720),
    [sym__rational_operator] = ACTIONS(2720),
    [sym__times_operator] = ACTIONS(2720),
    [sym__plus_operator] = ACTIONS(2720),
    [sym__dotty_operator] = ACTIONS(2720),
    [sym__comparison_operator] = ACTIONS(2720),
    [sym__arrow_operator] = ACTIONS(2720),
    [sym__assign_operator] = ACTIONS(2720),
    [anon_sym_LF] = ACTIONS(2722),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2722),
    [sym__string_start] = ACTIONS(2722),
    [sym__command_start] = ACTIONS(2722),
  },
  [874] = {
    [sym_type_argument_list] = STATE(1239),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_elseif] = ACTIONS(85),
    [anon_sym_else] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(2724),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(85),
    [aux_sym_integer_literal_token1] = ACTIONS(85),
    [aux_sym_integer_literal_token2] = ACTIONS(85),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
    [sym__immediate_string_start] = ACTIONS(2608),
    [sym__immediate_command_start] = ACTIONS(2610),
  },
  [875] = {
    [sym_parenthesized_expression] = STATE(1035),
    [sym_identifier] = ACTIONS(2726),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_end] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_primitive] = ACTIONS(2728),
    [aux_sym_primitive_definition_token1] = ACTIONS(2728),
    [anon_sym_mutable] = ACTIONS(2728),
    [anon_sym_struct] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_macro] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(2730),
    [anon_sym_COMMA] = ACTIONS(2728),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_EQ] = ACTIONS(2728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2728),
    [anon_sym_LT_COLON] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_elseif] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_catch] = ACTIONS(2728),
    [anon_sym_finally] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [sym_break_statement] = ACTIONS(2728),
    [sym_continue_statement] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_quote] = ACTIONS(2728),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_COLON2] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_begin] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_LT_PIPE] = ACTIONS(2728),
    [anon_sym_PIPE_GT] = ACTIONS(2728),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_isa] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_QMARK] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_LBRACK2] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2728),
    [aux_sym_integer_literal_token1] = ACTIONS(2728),
    [aux_sym_integer_literal_token2] = ACTIONS(2728),
    [aux_sym_integer_literal_token3] = ACTIONS(2728),
    [sym_float_literal] = ACTIONS(2728),
    [sym__unary_operator] = ACTIONS(2728),
    [sym__power_operator] = ACTIONS(2728),
    [sym__bitshift_operator] = ACTIONS(2728),
    [sym__rational_operator] = ACTIONS(2728),
    [sym__times_operator] = ACTIONS(2728),
    [sym__plus_operator] = ACTIONS(2728),
    [sym__dotty_operator] = ACTIONS(2728),
    [sym__comparison_operator] = ACTIONS(2728),
    [sym__arrow_operator] = ACTIONS(2728),
    [sym__assign_operator] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2732),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2732),
    [sym__command_start] = ACTIONS(2732),
  },
  [876] = {
    [sym_type_argument_list] = STATE(1229),
    [ts_builtin_sym_end] = ACTIONS(2466),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_LT_COLON] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2464),
    [anon_sym_PIPE_GT] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2464),
    [aux_sym_integer_literal_token1] = ACTIONS(2464),
    [aux_sym_integer_literal_token2] = ACTIONS(2464),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2464),
    [sym__assign_operator] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
    [sym__immediate_string_start] = ACTIONS(2468),
    [sym__immediate_command_start] = ACTIONS(2470),
  },
  [877] = {
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(2734),
    [anon_sym_end] = ACTIONS(2734),
    [anon_sym_abstract] = ACTIONS(2734),
    [anon_sym_primitive] = ACTIONS(2734),
    [aux_sym_primitive_definition_token1] = ACTIONS(2734),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2734),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_macro] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2734),
    [anon_sym_RPAREN] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2734),
    [anon_sym_LT_COLON] = ACTIONS(2734),
    [anon_sym_if] = ACTIONS(2734),
    [anon_sym_elseif] = ACTIONS(2734),
    [anon_sym_else] = ACTIONS(2734),
    [anon_sym_try] = ACTIONS(2734),
    [anon_sym_catch] = ACTIONS(2734),
    [anon_sym_finally] = ACTIONS(2734),
    [anon_sym_for] = ACTIONS(2734),
    [anon_sym_while] = ACTIONS(2734),
    [sym_break_statement] = ACTIONS(2734),
    [sym_continue_statement] = ACTIONS(2734),
    [anon_sym_return] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_const] = ACTIONS(2734),
    [anon_sym_quote] = ACTIONS(2734),
    [anon_sym_using] = ACTIONS(2734),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_COLON2] = ACTIONS(2734),
    [anon_sym_begin] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_LT_PIPE] = ACTIONS(2734),
    [anon_sym_PIPE_GT] = ACTIONS(2734),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_isa] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_EQ_GT] = ACTIONS(2734),
    [anon_sym_LBRACK2] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(2734),
    [anon_sym_AT] = ACTIONS(2734),
    [aux_sym_integer_literal_token1] = ACTIONS(2734),
    [aux_sym_integer_literal_token2] = ACTIONS(2734),
    [aux_sym_integer_literal_token3] = ACTIONS(2734),
    [sym_float_literal] = ACTIONS(2734),
    [sym__unary_operator] = ACTIONS(2734),
    [sym__power_operator] = ACTIONS(2734),
    [sym__bitshift_operator] = ACTIONS(2734),
    [sym__rational_operator] = ACTIONS(2734),
    [sym__times_operator] = ACTIONS(2734),
    [sym__plus_operator] = ACTIONS(2734),
    [sym__dotty_operator] = ACTIONS(2734),
    [sym__comparison_operator] = ACTIONS(2734),
    [sym__arrow_operator] = ACTIONS(2734),
    [sym__assign_operator] = ACTIONS(2734),
    [anon_sym_LF] = ACTIONS(2736),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2736),
    [sym__command_start] = ACTIONS(2736),
  },
  [878] = {
    [sym_type_argument_list] = STATE(1221),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LT_COLON] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2466),
    [anon_sym_PIPE_GT] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_EQ_GT] = ACTIONS(2466),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_AT] = ACTIONS(2466),
    [aux_sym_integer_literal_token1] = ACTIONS(2466),
    [aux_sym_integer_literal_token2] = ACTIONS(2466),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2466),
    [sym__bitshift_operator] = ACTIONS(2466),
    [sym__rational_operator] = ACTIONS(2466),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
    [sym__immediate_string_start] = ACTIONS(2468),
    [sym__immediate_command_start] = ACTIONS(2470),
  },
  [879] = {
    [sym_type_argument_list] = STATE(1239),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_LT_COLON] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_elseif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2464),
    [anon_sym_PIPE_GT] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2464),
    [aux_sym_integer_literal_token1] = ACTIONS(2464),
    [aux_sym_integer_literal_token2] = ACTIONS(2464),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
    [sym__immediate_string_start] = ACTIONS(2468),
    [sym__immediate_command_start] = ACTIONS(2470),
  },
  [880] = {
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_end] = ACTIONS(2738),
    [anon_sym_abstract] = ACTIONS(2738),
    [anon_sym_primitive] = ACTIONS(2738),
    [aux_sym_primitive_definition_token1] = ACTIONS(2738),
    [anon_sym_mutable] = ACTIONS(2738),
    [anon_sym_struct] = ACTIONS(2738),
    [anon_sym_module] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_RPAREN] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2738),
    [anon_sym_COLON_COLON] = ACTIONS(2738),
    [anon_sym_LT_COLON] = ACTIONS(2738),
    [anon_sym_if] = ACTIONS(2738),
    [anon_sym_elseif] = ACTIONS(2738),
    [anon_sym_else] = ACTIONS(2738),
    [anon_sym_try] = ACTIONS(2738),
    [anon_sym_catch] = ACTIONS(2738),
    [anon_sym_finally] = ACTIONS(2738),
    [anon_sym_for] = ACTIONS(2738),
    [anon_sym_while] = ACTIONS(2738),
    [sym_break_statement] = ACTIONS(2738),
    [sym_continue_statement] = ACTIONS(2738),
    [anon_sym_return] = ACTIONS(2738),
    [anon_sym_let] = ACTIONS(2738),
    [anon_sym_const] = ACTIONS(2738),
    [anon_sym_quote] = ACTIONS(2738),
    [anon_sym_using] = ACTIONS(2738),
    [anon_sym_import] = ACTIONS(2738),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_DOT] = ACTIONS(2738),
    [anon_sym_export] = ACTIONS(2738),
    [anon_sym_COLON2] = ACTIONS(2738),
    [anon_sym_begin] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [anon_sym_PLUS] = ACTIONS(2738),
    [anon_sym_LT_PIPE] = ACTIONS(2738),
    [anon_sym_PIPE_GT] = ACTIONS(2738),
    [anon_sym_in] = ACTIONS(2738),
    [anon_sym_isa] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_QMARK] = ACTIONS(2738),
    [anon_sym_EQ_GT] = ACTIONS(2738),
    [anon_sym_LBRACK2] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(2738),
    [anon_sym_AT] = ACTIONS(2738),
    [aux_sym_integer_literal_token1] = ACTIONS(2738),
    [aux_sym_integer_literal_token2] = ACTIONS(2738),
    [aux_sym_integer_literal_token3] = ACTIONS(2738),
    [sym_float_literal] = ACTIONS(2738),
    [sym__unary_operator] = ACTIONS(2738),
    [sym__power_operator] = ACTIONS(2738),
    [sym__bitshift_operator] = ACTIONS(2738),
    [sym__rational_operator] = ACTIONS(2738),
    [sym__times_operator] = ACTIONS(2738),
    [sym__plus_operator] = ACTIONS(2738),
    [sym__dotty_operator] = ACTIONS(2738),
    [sym__comparison_operator] = ACTIONS(2738),
    [sym__arrow_operator] = ACTIONS(2738),
    [sym__assign_operator] = ACTIONS(2738),
    [anon_sym_LF] = ACTIONS(2740),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2740),
    [sym__command_start] = ACTIONS(2740),
  },
  [881] = {
    [sym_do_clause] = STATE(978),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_end] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_primitive] = ACTIONS(2486),
    [aux_sym_primitive_definition_token1] = ACTIONS(2486),
    [anon_sym_mutable] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_macro] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_EQ] = ACTIONS(2486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_LT_COLON] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [sym_break_statement] = ACTIONS(2486),
    [sym_continue_statement] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_quote] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_COLON2] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_begin] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_LT_PIPE] = ACTIONS(2488),
    [anon_sym_PIPE_GT] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_isa] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(2488),
    [anon_sym_LBRACK2] = ACTIONS(2486),
    [anon_sym_DOLLAR] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2488),
    [aux_sym_integer_literal_token1] = ACTIONS(2488),
    [aux_sym_integer_literal_token2] = ACTIONS(2488),
    [aux_sym_integer_literal_token3] = ACTIONS(2486),
    [sym_float_literal] = ACTIONS(2486),
    [sym__unary_operator] = ACTIONS(2486),
    [sym__power_operator] = ACTIONS(2486),
    [sym__bitshift_operator] = ACTIONS(2486),
    [sym__rational_operator] = ACTIONS(2486),
    [sym__times_operator] = ACTIONS(2486),
    [sym__plus_operator] = ACTIONS(2486),
    [sym__dotty_operator] = ACTIONS(2486),
    [sym__comparison_operator] = ACTIONS(2486),
    [sym__arrow_operator] = ACTIONS(2488),
    [sym__assign_operator] = ACTIONS(2486),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2488),
    [sym__string_start] = ACTIONS(2488),
    [sym__command_start] = ACTIONS(2488),
  },
  [882] = {
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2744),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2744),
    [anon_sym_LT_COLON] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_elseif] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(2744),
    [anon_sym_finally] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(2652),
    [anon_sym_DOT] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2744),
    [anon_sym_PIPE_GT] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_LBRACK2] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [aux_sym_integer_literal_token1] = ACTIONS(2744),
    [aux_sym_integer_literal_token2] = ACTIONS(2744),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2744),
    [sym__assign_operator] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [883] = {
    [sym_type_argument_list] = STATE(1085),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_EQ] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_LT_COLON] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(97),
    [anon_sym_PIPE_GT] = ACTIONS(97),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(97),
    [anon_sym_AMP_AMP] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(97),
    [anon_sym_EQ_GT] = ACTIONS(97),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(97),
    [aux_sym_integer_literal_token1] = ACTIONS(97),
    [aux_sym_integer_literal_token2] = ACTIONS(97),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(97),
    [sym__assign_operator] = ACTIONS(85),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
  },
  [884] = {
    [sym_do_clause] = STATE(1047),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_function] = ACTIONS(2480),
    [anon_sym_end] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2480),
    [anon_sym_primitive] = ACTIONS(2480),
    [aux_sym_primitive_definition_token1] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_module] = ACTIONS(2480),
    [anon_sym_macro] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_LT_COLON] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [sym_break_statement] = ACTIONS(2480),
    [sym_continue_statement] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_quote] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_import] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2480),
    [anon_sym_COLON2] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_RBRACK] = ACTIONS(2482),
    [anon_sym_begin] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(2742),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_LT_PIPE] = ACTIONS(2482),
    [anon_sym_PIPE_GT] = ACTIONS(2482),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_isa] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_EQ_GT] = ACTIONS(2482),
    [anon_sym_LBRACK2] = ACTIONS(2480),
    [anon_sym_DOLLAR] = ACTIONS(2480),
    [anon_sym_AT] = ACTIONS(2482),
    [aux_sym_integer_literal_token1] = ACTIONS(2482),
    [aux_sym_integer_literal_token2] = ACTIONS(2482),
    [aux_sym_integer_literal_token3] = ACTIONS(2480),
    [sym_float_literal] = ACTIONS(2480),
    [sym__unary_operator] = ACTIONS(2480),
    [sym__power_operator] = ACTIONS(2480),
    [sym__bitshift_operator] = ACTIONS(2480),
    [sym__rational_operator] = ACTIONS(2480),
    [sym__times_operator] = ACTIONS(2480),
    [sym__plus_operator] = ACTIONS(2480),
    [sym__dotty_operator] = ACTIONS(2480),
    [sym__comparison_operator] = ACTIONS(2480),
    [sym__arrow_operator] = ACTIONS(2482),
    [sym__assign_operator] = ACTIONS(2480),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2482),
    [sym__string_start] = ACTIONS(2482),
    [sym__command_start] = ACTIONS(2482),
  },
  [885] = {
    [sym_parenthesized_expression] = STATE(1079),
    [sym_identifier] = ACTIONS(2748),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2730),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_RPAREN] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2750),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_LT_COLON] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_elseif] = ACTIONS(2750),
    [anon_sym_else] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_catch] = ACTIONS(2750),
    [anon_sym_finally] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2750),
    [anon_sym_PIPE_GT] = ACTIONS(2750),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2750),
    [anon_sym_AMP_AMP] = ACTIONS(2750),
    [anon_sym_QMARK] = ACTIONS(2750),
    [anon_sym_EQ_GT] = ACTIONS(2750),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2750),
    [aux_sym_integer_literal_token1] = ACTIONS(2750),
    [aux_sym_integer_literal_token2] = ACTIONS(2750),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2750),
    [sym__assign_operator] = ACTIONS(2750),
    [anon_sym_LF] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [886] = {
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_primitive] = ACTIONS(2574),
    [aux_sym_primitive_definition_token1] = ACTIONS(2574),
    [anon_sym_mutable] = ACTIONS(2574),
    [anon_sym_struct] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_macro] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2576),
    [anon_sym_COLON_COLON] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_LT_COLON] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [sym_break_statement] = ACTIONS(2574),
    [sym_continue_statement] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_quote] = ACTIONS(2574),
    [anon_sym_using] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_COLON2] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_RBRACK] = ACTIONS(2576),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_LT_PIPE] = ACTIONS(2576),
    [anon_sym_PIPE_GT] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_isa] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(2576),
    [anon_sym_LBRACK2] = ACTIONS(2574),
    [anon_sym_DOLLAR] = ACTIONS(2574),
    [anon_sym_AT] = ACTIONS(2576),
    [aux_sym_integer_literal_token1] = ACTIONS(2576),
    [aux_sym_integer_literal_token2] = ACTIONS(2576),
    [aux_sym_integer_literal_token3] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
    [sym__unary_operator] = ACTIONS(2574),
    [sym__power_operator] = ACTIONS(2574),
    [sym__bitshift_operator] = ACTIONS(2574),
    [sym__rational_operator] = ACTIONS(2574),
    [sym__times_operator] = ACTIONS(2574),
    [sym__plus_operator] = ACTIONS(2574),
    [sym__dotty_operator] = ACTIONS(2574),
    [sym__comparison_operator] = ACTIONS(2574),
    [sym__arrow_operator] = ACTIONS(2576),
    [sym__assign_operator] = ACTIONS(2574),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__command_start] = ACTIONS(2576),
  },
  [887] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_end] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_primitive] = ACTIONS(2538),
    [aux_sym_primitive_definition_token1] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_macro] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(2540),
    [anon_sym_RPAREN] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_EQ] = ACTIONS(2538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2540),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_LT_COLON] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [sym_break_statement] = ACTIONS(2538),
    [sym_continue_statement] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_quote] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_DOT] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_COLON2] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_RBRACK] = ACTIONS(2540),
    [anon_sym_begin] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_LT_PIPE] = ACTIONS(2540),
    [anon_sym_PIPE_GT] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2540),
    [anon_sym_AMP_AMP] = ACTIONS(2540),
    [anon_sym_QMARK] = ACTIONS(2540),
    [anon_sym_EQ_GT] = ACTIONS(2540),
    [anon_sym_LBRACK2] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2540),
    [aux_sym_integer_literal_token1] = ACTIONS(2540),
    [aux_sym_integer_literal_token2] = ACTIONS(2540),
    [aux_sym_integer_literal_token3] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
    [sym__unary_operator] = ACTIONS(2538),
    [sym__power_operator] = ACTIONS(2538),
    [sym__bitshift_operator] = ACTIONS(2538),
    [sym__rational_operator] = ACTIONS(2538),
    [sym__times_operator] = ACTIONS(2538),
    [sym__plus_operator] = ACTIONS(2538),
    [sym__dotty_operator] = ACTIONS(2538),
    [sym__comparison_operator] = ACTIONS(2538),
    [sym__arrow_operator] = ACTIONS(2540),
    [sym__assign_operator] = ACTIONS(2538),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2540),
    [sym__string_start] = ACTIONS(2540),
    [sym__command_start] = ACTIONS(2540),
  },
  [888] = {
    [aux_sym_import_statement_repeat1] = STATE(922),
    [sym_identifier] = ACTIONS(2754),
    [anon_sym_function] = ACTIONS(2754),
    [anon_sym_end] = ACTIONS(2754),
    [anon_sym_abstract] = ACTIONS(2754),
    [anon_sym_primitive] = ACTIONS(2754),
    [aux_sym_primitive_definition_token1] = ACTIONS(2754),
    [anon_sym_mutable] = ACTIONS(2754),
    [anon_sym_struct] = ACTIONS(2754),
    [anon_sym_module] = ACTIONS(2754),
    [anon_sym_macro] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(2650),
    [anon_sym_RPAREN] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_EQ] = ACTIONS(2754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2754),
    [anon_sym_LT_COLON] = ACTIONS(2754),
    [anon_sym_if] = ACTIONS(2754),
    [anon_sym_elseif] = ACTIONS(2754),
    [anon_sym_else] = ACTIONS(2754),
    [anon_sym_try] = ACTIONS(2754),
    [anon_sym_catch] = ACTIONS(2754),
    [anon_sym_finally] = ACTIONS(2754),
    [anon_sym_for] = ACTIONS(2754),
    [anon_sym_while] = ACTIONS(2754),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2754),
    [anon_sym_let] = ACTIONS(2754),
    [anon_sym_const] = ACTIONS(2754),
    [anon_sym_quote] = ACTIONS(2754),
    [anon_sym_using] = ACTIONS(2754),
    [anon_sym_import] = ACTIONS(2754),
    [anon_sym_export] = ACTIONS(2754),
    [anon_sym_COLON2] = ACTIONS(2754),
    [anon_sym_begin] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [anon_sym_PLUS] = ACTIONS(2754),
    [anon_sym_LT_PIPE] = ACTIONS(2754),
    [anon_sym_PIPE_GT] = ACTIONS(2754),
    [anon_sym_in] = ACTIONS(2754),
    [anon_sym_isa] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_QMARK] = ACTIONS(2754),
    [anon_sym_EQ_GT] = ACTIONS(2754),
    [anon_sym_LBRACK2] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [anon_sym_AT] = ACTIONS(2754),
    [aux_sym_integer_literal_token1] = ACTIONS(2754),
    [aux_sym_integer_literal_token2] = ACTIONS(2754),
    [aux_sym_integer_literal_token3] = ACTIONS(2754),
    [sym_float_literal] = ACTIONS(2754),
    [sym__unary_operator] = ACTIONS(2754),
    [sym__power_operator] = ACTIONS(2754),
    [sym__bitshift_operator] = ACTIONS(2754),
    [sym__rational_operator] = ACTIONS(2754),
    [sym__times_operator] = ACTIONS(2754),
    [sym__plus_operator] = ACTIONS(2754),
    [sym__dotty_operator] = ACTIONS(2754),
    [sym__comparison_operator] = ACTIONS(2754),
    [sym__arrow_operator] = ACTIONS(2754),
    [sym__assign_operator] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2756),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2756),
    [sym__command_start] = ACTIONS(2756),
  },
  [889] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_end] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_primitive] = ACTIONS(2510),
    [aux_sym_primitive_definition_token1] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_macro] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_LT_COLON] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [sym_break_statement] = ACTIONS(2510),
    [sym_continue_statement] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_quote] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_COLON2] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_LT_PIPE] = ACTIONS(2512),
    [anon_sym_PIPE_GT] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_isa] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_QMARK] = ACTIONS(2512),
    [anon_sym_EQ_GT] = ACTIONS(2512),
    [anon_sym_LBRACK2] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2512),
    [aux_sym_integer_literal_token1] = ACTIONS(2512),
    [aux_sym_integer_literal_token2] = ACTIONS(2512),
    [aux_sym_integer_literal_token3] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
    [sym__unary_operator] = ACTIONS(2510),
    [sym__power_operator] = ACTIONS(2510),
    [sym__bitshift_operator] = ACTIONS(2510),
    [sym__rational_operator] = ACTIONS(2510),
    [sym__times_operator] = ACTIONS(2510),
    [sym__plus_operator] = ACTIONS(2510),
    [sym__dotty_operator] = ACTIONS(2510),
    [sym__comparison_operator] = ACTIONS(2510),
    [sym__arrow_operator] = ACTIONS(2512),
    [sym__assign_operator] = ACTIONS(2510),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2512),
    [sym__string_start] = ACTIONS(2512),
    [sym__command_start] = ACTIONS(2512),
  },
  [890] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_end] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_primitive] = ACTIONS(2558),
    [aux_sym_primitive_definition_token1] = ACTIONS(2558),
    [anon_sym_mutable] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_macro] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_EQ] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_LT_COLON] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [sym_break_statement] = ACTIONS(2558),
    [sym_continue_statement] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_quote] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_DOT] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_COLON2] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_RBRACK] = ACTIONS(2560),
    [anon_sym_begin] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_LT_PIPE] = ACTIONS(2560),
    [anon_sym_PIPE_GT] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2558),
    [anon_sym_isa] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_QMARK] = ACTIONS(2560),
    [anon_sym_EQ_GT] = ACTIONS(2560),
    [anon_sym_LBRACK2] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2560),
    [aux_sym_integer_literal_token1] = ACTIONS(2560),
    [aux_sym_integer_literal_token2] = ACTIONS(2560),
    [aux_sym_integer_literal_token3] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
    [sym__unary_operator] = ACTIONS(2558),
    [sym__power_operator] = ACTIONS(2558),
    [sym__bitshift_operator] = ACTIONS(2558),
    [sym__rational_operator] = ACTIONS(2558),
    [sym__times_operator] = ACTIONS(2558),
    [sym__plus_operator] = ACTIONS(2558),
    [sym__dotty_operator] = ACTIONS(2558),
    [sym__comparison_operator] = ACTIONS(2558),
    [sym__arrow_operator] = ACTIONS(2560),
    [sym__assign_operator] = ACTIONS(2558),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2560),
    [sym__string_start] = ACTIONS(2560),
    [sym__command_start] = ACTIONS(2560),
  },
  [891] = {
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_end] = ACTIONS(2758),
    [anon_sym_abstract] = ACTIONS(2758),
    [anon_sym_primitive] = ACTIONS(2758),
    [aux_sym_primitive_definition_token1] = ACTIONS(2758),
    [anon_sym_mutable] = ACTIONS(2758),
    [anon_sym_struct] = ACTIONS(2758),
    [anon_sym_module] = ACTIONS(2758),
    [anon_sym_macro] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_RPAREN] = ACTIONS(2758),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2758),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_LT_COLON] = ACTIONS(2758),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_elseif] = ACTIONS(2758),
    [anon_sym_else] = ACTIONS(2758),
    [anon_sym_try] = ACTIONS(2758),
    [anon_sym_catch] = ACTIONS(2758),
    [anon_sym_finally] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [sym_break_statement] = ACTIONS(2758),
    [sym_continue_statement] = ACTIONS(2758),
    [anon_sym_return] = ACTIONS(2758),
    [anon_sym_let] = ACTIONS(2758),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_quote] = ACTIONS(2758),
    [anon_sym_using] = ACTIONS(2758),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_export] = ACTIONS(2758),
    [anon_sym_COLON2] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_begin] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2758),
    [anon_sym_LT_PIPE] = ACTIONS(2758),
    [anon_sym_PIPE_GT] = ACTIONS(2758),
    [anon_sym_in] = ACTIONS(2758),
    [anon_sym_isa] = ACTIONS(2758),
    [anon_sym_PIPE_PIPE] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(2758),
    [anon_sym_QMARK] = ACTIONS(2758),
    [anon_sym_EQ_GT] = ACTIONS(2758),
    [anon_sym_LBRACK2] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2758),
    [anon_sym_AT] = ACTIONS(2758),
    [aux_sym_integer_literal_token1] = ACTIONS(2758),
    [aux_sym_integer_literal_token2] = ACTIONS(2758),
    [aux_sym_integer_literal_token3] = ACTIONS(2758),
    [sym_float_literal] = ACTIONS(2758),
    [sym__unary_operator] = ACTIONS(2758),
    [sym__power_operator] = ACTIONS(2758),
    [sym__bitshift_operator] = ACTIONS(2758),
    [sym__rational_operator] = ACTIONS(2758),
    [sym__times_operator] = ACTIONS(2758),
    [sym__plus_operator] = ACTIONS(2758),
    [sym__dotty_operator] = ACTIONS(2758),
    [sym__comparison_operator] = ACTIONS(2758),
    [sym__arrow_operator] = ACTIONS(2758),
    [sym__assign_operator] = ACTIONS(2758),
    [anon_sym_LF] = ACTIONS(2760),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2760),
    [sym__command_start] = ACTIONS(2760),
  },
  [892] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_primitive] = ACTIONS(2566),
    [aux_sym_primitive_definition_token1] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_macro] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2568),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_LT_COLON] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [sym_break_statement] = ACTIONS(2566),
    [sym_continue_statement] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_quote] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_COLON2] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_RBRACK] = ACTIONS(2568),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_LT_PIPE] = ACTIONS(2568),
    [anon_sym_PIPE_GT] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_isa] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2568),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK2] = ACTIONS(2566),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2568),
    [aux_sym_integer_literal_token1] = ACTIONS(2568),
    [aux_sym_integer_literal_token2] = ACTIONS(2568),
    [aux_sym_integer_literal_token3] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
    [sym__unary_operator] = ACTIONS(2566),
    [sym__power_operator] = ACTIONS(2566),
    [sym__bitshift_operator] = ACTIONS(2566),
    [sym__rational_operator] = ACTIONS(2566),
    [sym__times_operator] = ACTIONS(2566),
    [sym__plus_operator] = ACTIONS(2566),
    [sym__dotty_operator] = ACTIONS(2566),
    [sym__comparison_operator] = ACTIONS(2566),
    [sym__arrow_operator] = ACTIONS(2568),
    [sym__assign_operator] = ACTIONS(2566),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2568),
    [sym__string_start] = ACTIONS(2568),
    [sym__command_start] = ACTIONS(2568),
  },
  [893] = {
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_primitive] = ACTIONS(2570),
    [aux_sym_primitive_definition_token1] = ACTIONS(2570),
    [anon_sym_mutable] = ACTIONS(2570),
    [anon_sym_struct] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_macro] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2572),
    [anon_sym_RPAREN] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2572),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_LT_COLON] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [sym_break_statement] = ACTIONS(2570),
    [sym_continue_statement] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_quote] = ACTIONS(2570),
    [anon_sym_using] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_COLON2] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_RBRACK] = ACTIONS(2572),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_LT_PIPE] = ACTIONS(2572),
    [anon_sym_PIPE_GT] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_isa] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2572),
    [anon_sym_AMP_AMP] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(2572),
    [anon_sym_LBRACK2] = ACTIONS(2570),
    [anon_sym_DOLLAR] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(2572),
    [aux_sym_integer_literal_token1] = ACTIONS(2572),
    [aux_sym_integer_literal_token2] = ACTIONS(2572),
    [aux_sym_integer_literal_token3] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
    [sym__unary_operator] = ACTIONS(2570),
    [sym__power_operator] = ACTIONS(2570),
    [sym__bitshift_operator] = ACTIONS(2570),
    [sym__rational_operator] = ACTIONS(2570),
    [sym__times_operator] = ACTIONS(2570),
    [sym__plus_operator] = ACTIONS(2570),
    [sym__dotty_operator] = ACTIONS(2570),
    [sym__comparison_operator] = ACTIONS(2570),
    [sym__arrow_operator] = ACTIONS(2572),
    [sym__assign_operator] = ACTIONS(2570),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__command_start] = ACTIONS(2572),
  },
  [894] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_elseif] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_catch] = ACTIONS(2702),
    [anon_sym_finally] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2706),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [sym__assign_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [895] = {
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2762),
    [anon_sym_end] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_primitive] = ACTIONS(2762),
    [aux_sym_primitive_definition_token1] = ACTIONS(2762),
    [anon_sym_mutable] = ACTIONS(2762),
    [anon_sym_struct] = ACTIONS(2762),
    [anon_sym_module] = ACTIONS(2762),
    [anon_sym_macro] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_RPAREN] = ACTIONS(2762),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2762),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LT_COLON] = ACTIONS(2762),
    [anon_sym_if] = ACTIONS(2762),
    [anon_sym_elseif] = ACTIONS(2762),
    [anon_sym_else] = ACTIONS(2762),
    [anon_sym_try] = ACTIONS(2762),
    [anon_sym_catch] = ACTIONS(2762),
    [anon_sym_finally] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2762),
    [anon_sym_while] = ACTIONS(2762),
    [sym_break_statement] = ACTIONS(2762),
    [sym_continue_statement] = ACTIONS(2762),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2762),
    [anon_sym_quote] = ACTIONS(2762),
    [anon_sym_using] = ACTIONS(2762),
    [anon_sym_import] = ACTIONS(2762),
    [anon_sym_export] = ACTIONS(2762),
    [anon_sym_COLON2] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_LT_PIPE] = ACTIONS(2762),
    [anon_sym_PIPE_GT] = ACTIONS(2762),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_isa] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2762),
    [anon_sym_AMP_AMP] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_EQ_GT] = ACTIONS(2762),
    [anon_sym_LBRACK2] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2762),
    [aux_sym_integer_literal_token1] = ACTIONS(2762),
    [aux_sym_integer_literal_token2] = ACTIONS(2762),
    [aux_sym_integer_literal_token3] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
    [sym__unary_operator] = ACTIONS(2762),
    [sym__power_operator] = ACTIONS(2762),
    [sym__bitshift_operator] = ACTIONS(2762),
    [sym__rational_operator] = ACTIONS(2762),
    [sym__times_operator] = ACTIONS(2762),
    [sym__plus_operator] = ACTIONS(2762),
    [sym__dotty_operator] = ACTIONS(2762),
    [sym__comparison_operator] = ACTIONS(2762),
    [sym__arrow_operator] = ACTIONS(2762),
    [sym__assign_operator] = ACTIONS(2762),
    [anon_sym_LF] = ACTIONS(2764),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2764),
    [sym__string_start] = ACTIONS(2764),
    [sym__command_start] = ACTIONS(2764),
  },
  [896] = {
    [aux_sym_let_statement_repeat1] = STATE(943),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_end] = ACTIONS(2766),
    [anon_sym_abstract] = ACTIONS(2766),
    [anon_sym_primitive] = ACTIONS(2766),
    [aux_sym_primitive_definition_token1] = ACTIONS(2766),
    [anon_sym_mutable] = ACTIONS(2766),
    [anon_sym_struct] = ACTIONS(2766),
    [anon_sym_module] = ACTIONS(2766),
    [anon_sym_macro] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_RPAREN] = ACTIONS(2766),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2766),
    [anon_sym_LT_COLON] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_elseif] = ACTIONS(2766),
    [anon_sym_else] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_catch] = ACTIONS(2766),
    [anon_sym_finally] = ACTIONS(2766),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [sym_break_statement] = ACTIONS(2766),
    [sym_continue_statement] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_quote] = ACTIONS(2766),
    [anon_sym_using] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2766),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_COLON2] = ACTIONS(2766),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_LT_PIPE] = ACTIONS(2766),
    [anon_sym_PIPE_GT] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(2766),
    [anon_sym_isa] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_EQ_GT] = ACTIONS(2766),
    [anon_sym_LBRACK2] = ACTIONS(2766),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2766),
    [aux_sym_integer_literal_token1] = ACTIONS(2766),
    [aux_sym_integer_literal_token2] = ACTIONS(2766),
    [aux_sym_integer_literal_token3] = ACTIONS(2766),
    [sym_float_literal] = ACTIONS(2766),
    [sym__unary_operator] = ACTIONS(2766),
    [sym__power_operator] = ACTIONS(2766),
    [sym__bitshift_operator] = ACTIONS(2766),
    [sym__rational_operator] = ACTIONS(2766),
    [sym__times_operator] = ACTIONS(2766),
    [sym__plus_operator] = ACTIONS(2766),
    [sym__dotty_operator] = ACTIONS(2766),
    [sym__comparison_operator] = ACTIONS(2766),
    [sym__arrow_operator] = ACTIONS(2766),
    [sym__assign_operator] = ACTIONS(2766),
    [anon_sym_LF] = ACTIONS(2770),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2770),
    [sym__command_start] = ACTIONS(2770),
  },
  [897] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_end] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_primitive] = ACTIONS(2772),
    [aux_sym_primitive_definition_token1] = ACTIONS(2772),
    [anon_sym_mutable] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_macro] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_COMMA] = ACTIONS(2774),
    [anon_sym_RPAREN] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2772),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_LT_COLON] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_elseif] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_catch] = ACTIONS(2772),
    [anon_sym_finally] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [sym_break_statement] = ACTIONS(2772),
    [sym_continue_statement] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_quote] = ACTIONS(2772),
    [anon_sym_using] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_COLON2] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_LT_PIPE] = ACTIONS(2772),
    [anon_sym_PIPE_GT] = ACTIONS(2772),
    [anon_sym_in] = ACTIONS(2772),
    [anon_sym_isa] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2772),
    [anon_sym_EQ_GT] = ACTIONS(2772),
    [anon_sym_LBRACK2] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2772),
    [aux_sym_integer_literal_token1] = ACTIONS(2772),
    [aux_sym_integer_literal_token2] = ACTIONS(2772),
    [aux_sym_integer_literal_token3] = ACTIONS(2772),
    [sym_float_literal] = ACTIONS(2772),
    [sym__unary_operator] = ACTIONS(2772),
    [sym__power_operator] = ACTIONS(2772),
    [sym__bitshift_operator] = ACTIONS(2772),
    [sym__rational_operator] = ACTIONS(2772),
    [sym__times_operator] = ACTIONS(2772),
    [sym__plus_operator] = ACTIONS(2772),
    [sym__dotty_operator] = ACTIONS(2772),
    [sym__comparison_operator] = ACTIONS(2772),
    [sym__arrow_operator] = ACTIONS(2772),
    [sym__assign_operator] = ACTIONS(2772),
    [anon_sym_LF] = ACTIONS(2777),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2777),
    [sym__command_start] = ACTIONS(2777),
  },
  [898] = {
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_primitive] = ACTIONS(2578),
    [aux_sym_primitive_definition_token1] = ACTIONS(2578),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_macro] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_LT_COLON] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [sym_break_statement] = ACTIONS(2578),
    [sym_continue_statement] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_quote] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_COLON2] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_LT_PIPE] = ACTIONS(2580),
    [anon_sym_PIPE_GT] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_isa] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK2] = ACTIONS(2578),
    [anon_sym_DOLLAR] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2580),
    [aux_sym_integer_literal_token1] = ACTIONS(2580),
    [aux_sym_integer_literal_token2] = ACTIONS(2580),
    [aux_sym_integer_literal_token3] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
    [sym__unary_operator] = ACTIONS(2578),
    [sym__power_operator] = ACTIONS(2578),
    [sym__bitshift_operator] = ACTIONS(2578),
    [sym__rational_operator] = ACTIONS(2578),
    [sym__times_operator] = ACTIONS(2578),
    [sym__plus_operator] = ACTIONS(2578),
    [sym__dotty_operator] = ACTIONS(2578),
    [sym__comparison_operator] = ACTIONS(2578),
    [sym__arrow_operator] = ACTIONS(2580),
    [sym__assign_operator] = ACTIONS(2578),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__command_start] = ACTIONS(2580),
  },
  [899] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_primitive] = ACTIONS(2582),
    [aux_sym_primitive_definition_token1] = ACTIONS(2582),
    [anon_sym_mutable] = ACTIONS(2582),
    [anon_sym_struct] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_macro] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_LT_COLON] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [sym_break_statement] = ACTIONS(2582),
    [sym_continue_statement] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_quote] = ACTIONS(2582),
    [anon_sym_using] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_COLON2] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_LT_PIPE] = ACTIONS(2584),
    [anon_sym_PIPE_GT] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_isa] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2584),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK2] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2584),
    [aux_sym_integer_literal_token1] = ACTIONS(2584),
    [aux_sym_integer_literal_token2] = ACTIONS(2584),
    [aux_sym_integer_literal_token3] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
    [sym__unary_operator] = ACTIONS(2582),
    [sym__power_operator] = ACTIONS(2582),
    [sym__bitshift_operator] = ACTIONS(2582),
    [sym__rational_operator] = ACTIONS(2582),
    [sym__times_operator] = ACTIONS(2582),
    [sym__plus_operator] = ACTIONS(2582),
    [sym__dotty_operator] = ACTIONS(2582),
    [sym__comparison_operator] = ACTIONS(2582),
    [sym__arrow_operator] = ACTIONS(2584),
    [sym__assign_operator] = ACTIONS(2582),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__command_start] = ACTIONS(2584),
  },
  [900] = {
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_function] = ACTIONS(2779),
    [anon_sym_end] = ACTIONS(2779),
    [anon_sym_abstract] = ACTIONS(2779),
    [anon_sym_primitive] = ACTIONS(2779),
    [aux_sym_primitive_definition_token1] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_module] = ACTIONS(2779),
    [anon_sym_macro] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_EQ] = ACTIONS(2779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2779),
    [anon_sym_LT_COLON] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_elseif] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_catch] = ACTIONS(2779),
    [anon_sym_finally] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [sym_break_statement] = ACTIONS(2779),
    [sym_continue_statement] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_let] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_quote] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_import] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(2779),
    [anon_sym_COLON2] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [anon_sym_begin] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_LT_PIPE] = ACTIONS(2779),
    [anon_sym_PIPE_GT] = ACTIONS(2779),
    [anon_sym_in] = ACTIONS(2779),
    [anon_sym_isa] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE] = ACTIONS(2779),
    [anon_sym_AMP_AMP] = ACTIONS(2779),
    [anon_sym_QMARK] = ACTIONS(2779),
    [anon_sym_EQ_GT] = ACTIONS(2779),
    [anon_sym_LBRACK2] = ACTIONS(2779),
    [anon_sym_DOLLAR] = ACTIONS(2779),
    [anon_sym_AT] = ACTIONS(2779),
    [aux_sym_integer_literal_token1] = ACTIONS(2779),
    [aux_sym_integer_literal_token2] = ACTIONS(2779),
    [aux_sym_integer_literal_token3] = ACTIONS(2779),
    [sym_float_literal] = ACTIONS(2779),
    [sym__unary_operator] = ACTIONS(2779),
    [sym__power_operator] = ACTIONS(2779),
    [sym__bitshift_operator] = ACTIONS(2779),
    [sym__rational_operator] = ACTIONS(2779),
    [sym__times_operator] = ACTIONS(2779),
    [sym__plus_operator] = ACTIONS(2779),
    [sym__dotty_operator] = ACTIONS(2779),
    [sym__comparison_operator] = ACTIONS(2779),
    [sym__arrow_operator] = ACTIONS(2779),
    [sym__assign_operator] = ACTIONS(2779),
    [anon_sym_LF] = ACTIONS(2781),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2781),
    [sym__command_start] = ACTIONS(2781),
  },
  [901] = {
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_end] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_primitive] = ACTIONS(2783),
    [aux_sym_primitive_definition_token1] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_module] = ACTIONS(2783),
    [anon_sym_macro] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2783),
    [anon_sym_RPAREN] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2783),
    [anon_sym_LT_COLON] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_elseif] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_catch] = ACTIONS(2783),
    [anon_sym_finally] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [sym_break_statement] = ACTIONS(2783),
    [sym_continue_statement] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_quote] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_import] = ACTIONS(2783),
    [anon_sym_export] = ACTIONS(2783),
    [anon_sym_COLON2] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_LT_PIPE] = ACTIONS(2783),
    [anon_sym_PIPE_GT] = ACTIONS(2783),
    [anon_sym_in] = ACTIONS(2783),
    [anon_sym_isa] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_EQ_GT] = ACTIONS(2783),
    [anon_sym_LBRACK2] = ACTIONS(2783),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_AT] = ACTIONS(2783),
    [aux_sym_integer_literal_token1] = ACTIONS(2783),
    [aux_sym_integer_literal_token2] = ACTIONS(2783),
    [aux_sym_integer_literal_token3] = ACTIONS(2783),
    [sym_float_literal] = ACTIONS(2783),
    [sym__unary_operator] = ACTIONS(2783),
    [sym__power_operator] = ACTIONS(2783),
    [sym__bitshift_operator] = ACTIONS(2783),
    [sym__rational_operator] = ACTIONS(2783),
    [sym__times_operator] = ACTIONS(2783),
    [sym__plus_operator] = ACTIONS(2783),
    [sym__dotty_operator] = ACTIONS(2783),
    [sym__comparison_operator] = ACTIONS(2783),
    [sym__arrow_operator] = ACTIONS(2783),
    [sym__assign_operator] = ACTIONS(2783),
    [anon_sym_LF] = ACTIONS(2785),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2785),
    [sym__command_start] = ACTIONS(2785),
  },
  [902] = {
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_function] = ACTIONS(2787),
    [anon_sym_end] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2787),
    [anon_sym_primitive] = ACTIONS(2787),
    [aux_sym_primitive_definition_token1] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_macro] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2787),
    [anon_sym_RPAREN] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2787),
    [anon_sym_LT_COLON] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_elseif] = ACTIONS(2787),
    [anon_sym_else] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_catch] = ACTIONS(2787),
    [anon_sym_finally] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [sym_break_statement] = ACTIONS(2787),
    [sym_continue_statement] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_quote] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_COLON2] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_LT_PIPE] = ACTIONS(2787),
    [anon_sym_PIPE_GT] = ACTIONS(2787),
    [anon_sym_in] = ACTIONS(2787),
    [anon_sym_isa] = ACTIONS(2787),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_GT] = ACTIONS(2787),
    [anon_sym_LBRACK2] = ACTIONS(2787),
    [anon_sym_DOLLAR] = ACTIONS(2787),
    [anon_sym_AT] = ACTIONS(2787),
    [aux_sym_integer_literal_token1] = ACTIONS(2787),
    [aux_sym_integer_literal_token2] = ACTIONS(2787),
    [aux_sym_integer_literal_token3] = ACTIONS(2787),
    [sym_float_literal] = ACTIONS(2787),
    [sym__unary_operator] = ACTIONS(2787),
    [sym__power_operator] = ACTIONS(2787),
    [sym__bitshift_operator] = ACTIONS(2787),
    [sym__rational_operator] = ACTIONS(2787),
    [sym__times_operator] = ACTIONS(2787),
    [sym__plus_operator] = ACTIONS(2787),
    [sym__dotty_operator] = ACTIONS(2787),
    [sym__comparison_operator] = ACTIONS(2787),
    [sym__arrow_operator] = ACTIONS(2787),
    [sym__assign_operator] = ACTIONS(2787),
    [anon_sym_LF] = ACTIONS(2789),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2789),
    [sym__command_start] = ACTIONS(2789),
  },
  [903] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_primitive] = ACTIONS(2490),
    [aux_sym_primitive_definition_token1] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_macro] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_LT_COLON] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [sym_break_statement] = ACTIONS(2490),
    [sym_continue_statement] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_quote] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_COLON2] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_begin] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_LT_PIPE] = ACTIONS(2492),
    [anon_sym_PIPE_GT] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_isa] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_QMARK] = ACTIONS(2492),
    [anon_sym_EQ_GT] = ACTIONS(2492),
    [anon_sym_LBRACK2] = ACTIONS(2490),
    [anon_sym_DOLLAR] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2492),
    [aux_sym_integer_literal_token1] = ACTIONS(2492),
    [aux_sym_integer_literal_token2] = ACTIONS(2492),
    [aux_sym_integer_literal_token3] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
    [sym__unary_operator] = ACTIONS(2490),
    [sym__power_operator] = ACTIONS(2490),
    [sym__bitshift_operator] = ACTIONS(2490),
    [sym__rational_operator] = ACTIONS(2490),
    [sym__times_operator] = ACTIONS(2490),
    [sym__plus_operator] = ACTIONS(2490),
    [sym__dotty_operator] = ACTIONS(2490),
    [sym__comparison_operator] = ACTIONS(2490),
    [sym__arrow_operator] = ACTIONS(2492),
    [sym__assign_operator] = ACTIONS(2490),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2492),
    [sym__string_start] = ACTIONS(2492),
    [sym__command_start] = ACTIONS(2492),
  },
  [904] = {
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_end] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_primitive] = ACTIONS(2791),
    [aux_sym_primitive_definition_token1] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_macro] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2791),
    [anon_sym_RPAREN] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2791),
    [anon_sym_LT_COLON] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_elseif] = ACTIONS(2791),
    [anon_sym_else] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_catch] = ACTIONS(2791),
    [anon_sym_finally] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [sym_break_statement] = ACTIONS(2791),
    [sym_continue_statement] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_quote] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_COLON2] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_LT_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_GT] = ACTIONS(2791),
    [anon_sym_in] = ACTIONS(2791),
    [anon_sym_isa] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_EQ_GT] = ACTIONS(2791),
    [anon_sym_LBRACK2] = ACTIONS(2791),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_AT] = ACTIONS(2791),
    [aux_sym_integer_literal_token1] = ACTIONS(2791),
    [aux_sym_integer_literal_token2] = ACTIONS(2791),
    [aux_sym_integer_literal_token3] = ACTIONS(2791),
    [sym_float_literal] = ACTIONS(2791),
    [sym__unary_operator] = ACTIONS(2791),
    [sym__power_operator] = ACTIONS(2791),
    [sym__bitshift_operator] = ACTIONS(2791),
    [sym__rational_operator] = ACTIONS(2791),
    [sym__times_operator] = ACTIONS(2791),
    [sym__plus_operator] = ACTIONS(2791),
    [sym__dotty_operator] = ACTIONS(2791),
    [sym__comparison_operator] = ACTIONS(2791),
    [sym__arrow_operator] = ACTIONS(2791),
    [sym__assign_operator] = ACTIONS(2791),
    [anon_sym_LF] = ACTIONS(2793),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2793),
    [sym__command_start] = ACTIONS(2793),
  },
  [905] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_end] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_primitive] = ACTIONS(2546),
    [aux_sym_primitive_definition_token1] = ACTIONS(2546),
    [anon_sym_mutable] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_macro] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_EQ] = ACTIONS(2546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_LT_COLON] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [sym_break_statement] = ACTIONS(2546),
    [sym_continue_statement] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_quote] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_DOT] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_COLON2] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_RBRACK] = ACTIONS(2548),
    [anon_sym_begin] = ACTIONS(2546),
    [anon_sym_do] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_LT_PIPE] = ACTIONS(2548),
    [anon_sym_PIPE_GT] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2546),
    [anon_sym_isa] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_QMARK] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(2548),
    [anon_sym_LBRACK2] = ACTIONS(2546),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [aux_sym_integer_literal_token1] = ACTIONS(2548),
    [aux_sym_integer_literal_token2] = ACTIONS(2548),
    [aux_sym_integer_literal_token3] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
    [sym__unary_operator] = ACTIONS(2546),
    [sym__power_operator] = ACTIONS(2546),
    [sym__bitshift_operator] = ACTIONS(2546),
    [sym__rational_operator] = ACTIONS(2546),
    [sym__times_operator] = ACTIONS(2546),
    [sym__plus_operator] = ACTIONS(2546),
    [sym__dotty_operator] = ACTIONS(2546),
    [sym__comparison_operator] = ACTIONS(2546),
    [sym__arrow_operator] = ACTIONS(2548),
    [sym__assign_operator] = ACTIONS(2546),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2548),
    [sym__string_start] = ACTIONS(2548),
    [sym__command_start] = ACTIONS(2548),
  },
  [906] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_primitive] = ACTIONS(2562),
    [aux_sym_primitive_definition_token1] = ACTIONS(2562),
    [anon_sym_mutable] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_macro] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_LT_COLON] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [sym_break_statement] = ACTIONS(2562),
    [sym_continue_statement] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_quote] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_COLON2] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_RBRACK] = ACTIONS(2564),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_LT_PIPE] = ACTIONS(2564),
    [anon_sym_PIPE_GT] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_isa] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_QMARK] = ACTIONS(2564),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_LBRACK2] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2564),
    [aux_sym_integer_literal_token1] = ACTIONS(2564),
    [aux_sym_integer_literal_token2] = ACTIONS(2564),
    [aux_sym_integer_literal_token3] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
    [sym__unary_operator] = ACTIONS(2562),
    [sym__power_operator] = ACTIONS(2562),
    [sym__bitshift_operator] = ACTIONS(2562),
    [sym__rational_operator] = ACTIONS(2562),
    [sym__times_operator] = ACTIONS(2562),
    [sym__plus_operator] = ACTIONS(2562),
    [sym__dotty_operator] = ACTIONS(2562),
    [sym__comparison_operator] = ACTIONS(2562),
    [sym__arrow_operator] = ACTIONS(2564),
    [sym__assign_operator] = ACTIONS(2562),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__command_start] = ACTIONS(2564),
  },
  [907] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_end] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_primitive] = ACTIONS(2534),
    [aux_sym_primitive_definition_token1] = ACTIONS(2534),
    [anon_sym_mutable] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_macro] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_COMMA] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_EQ] = ACTIONS(2534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2536),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_LT_COLON] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [sym_break_statement] = ACTIONS(2534),
    [sym_continue_statement] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_quote] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_COLON2] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_RBRACK] = ACTIONS(2536),
    [anon_sym_begin] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_LT_PIPE] = ACTIONS(2536),
    [anon_sym_PIPE_GT] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_isa] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2536),
    [anon_sym_AMP_AMP] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2536),
    [anon_sym_EQ_GT] = ACTIONS(2536),
    [anon_sym_LBRACK2] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2536),
    [aux_sym_integer_literal_token1] = ACTIONS(2536),
    [aux_sym_integer_literal_token2] = ACTIONS(2536),
    [aux_sym_integer_literal_token3] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
    [sym__unary_operator] = ACTIONS(2534),
    [sym__power_operator] = ACTIONS(2534),
    [sym__bitshift_operator] = ACTIONS(2534),
    [sym__rational_operator] = ACTIONS(2534),
    [sym__times_operator] = ACTIONS(2534),
    [sym__plus_operator] = ACTIONS(2534),
    [sym__dotty_operator] = ACTIONS(2534),
    [sym__comparison_operator] = ACTIONS(2534),
    [sym__arrow_operator] = ACTIONS(2536),
    [sym__assign_operator] = ACTIONS(2534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2536),
    [sym__string_start] = ACTIONS(2536),
    [sym__command_start] = ACTIONS(2536),
  },
  [908] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_end] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_primitive] = ACTIONS(2498),
    [aux_sym_primitive_definition_token1] = ACTIONS(2498),
    [anon_sym_mutable] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_macro] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_COMMA] = ACTIONS(2500),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_LT_COLON] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [sym_break_statement] = ACTIONS(2498),
    [sym_continue_statement] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_quote] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_COLON2] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_RBRACK] = ACTIONS(2500),
    [anon_sym_begin] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_LT_PIPE] = ACTIONS(2500),
    [anon_sym_PIPE_GT] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_isa] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_QMARK] = ACTIONS(2500),
    [anon_sym_EQ_GT] = ACTIONS(2500),
    [anon_sym_LBRACK2] = ACTIONS(2498),
    [anon_sym_DOLLAR] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2500),
    [aux_sym_integer_literal_token1] = ACTIONS(2500),
    [aux_sym_integer_literal_token2] = ACTIONS(2500),
    [aux_sym_integer_literal_token3] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
    [sym__unary_operator] = ACTIONS(2498),
    [sym__power_operator] = ACTIONS(2498),
    [sym__bitshift_operator] = ACTIONS(2498),
    [sym__rational_operator] = ACTIONS(2498),
    [sym__times_operator] = ACTIONS(2498),
    [sym__plus_operator] = ACTIONS(2498),
    [sym__dotty_operator] = ACTIONS(2498),
    [sym__comparison_operator] = ACTIONS(2498),
    [sym__arrow_operator] = ACTIONS(2500),
    [sym__assign_operator] = ACTIONS(2498),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2500),
    [sym__string_start] = ACTIONS(2500),
    [sym__command_start] = ACTIONS(2500),
  },
  [909] = {
    [aux_sym_export_statement_repeat1] = STATE(920),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_function] = ACTIONS(2795),
    [anon_sym_end] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2795),
    [anon_sym_primitive] = ACTIONS(2795),
    [aux_sym_primitive_definition_token1] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_macro] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_COMMA] = ACTIONS(2797),
    [anon_sym_RPAREN] = ACTIONS(2795),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_EQ] = ACTIONS(2795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2795),
    [anon_sym_LT_COLON] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_elseif] = ACTIONS(2795),
    [anon_sym_else] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_catch] = ACTIONS(2795),
    [anon_sym_finally] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [sym_break_statement] = ACTIONS(2795),
    [sym_continue_statement] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_let] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_quote] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_import] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2795),
    [anon_sym_COLON2] = ACTIONS(2795),
    [anon_sym_begin] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_LT_PIPE] = ACTIONS(2795),
    [anon_sym_PIPE_GT] = ACTIONS(2795),
    [anon_sym_in] = ACTIONS(2795),
    [anon_sym_isa] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2795),
    [anon_sym_AMP_AMP] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(2795),
    [anon_sym_EQ_GT] = ACTIONS(2795),
    [anon_sym_LBRACK2] = ACTIONS(2795),
    [anon_sym_DOLLAR] = ACTIONS(2795),
    [anon_sym_AT] = ACTIONS(2795),
    [aux_sym_integer_literal_token1] = ACTIONS(2795),
    [aux_sym_integer_literal_token2] = ACTIONS(2795),
    [aux_sym_integer_literal_token3] = ACTIONS(2795),
    [sym_float_literal] = ACTIONS(2795),
    [sym__unary_operator] = ACTIONS(2795),
    [sym__power_operator] = ACTIONS(2795),
    [sym__bitshift_operator] = ACTIONS(2795),
    [sym__rational_operator] = ACTIONS(2795),
    [sym__times_operator] = ACTIONS(2795),
    [sym__plus_operator] = ACTIONS(2795),
    [sym__dotty_operator] = ACTIONS(2795),
    [sym__comparison_operator] = ACTIONS(2795),
    [sym__arrow_operator] = ACTIONS(2795),
    [sym__assign_operator] = ACTIONS(2795),
    [anon_sym_LF] = ACTIONS(2799),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2799),
    [sym__command_start] = ACTIONS(2799),
  },
  [910] = {
    [sym_identifier] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_RPAREN] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2750),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_LT_COLON] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_elseif] = ACTIONS(2750),
    [anon_sym_else] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_catch] = ACTIONS(2750),
    [anon_sym_finally] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2750),
    [anon_sym_PIPE_GT] = ACTIONS(2750),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2750),
    [anon_sym_AMP_AMP] = ACTIONS(2750),
    [anon_sym_QMARK] = ACTIONS(2750),
    [anon_sym_EQ_GT] = ACTIONS(2750),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2750),
    [aux_sym_integer_literal_token1] = ACTIONS(2750),
    [aux_sym_integer_literal_token2] = ACTIONS(2750),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2750),
    [sym__assign_operator] = ACTIONS(2750),
    [anon_sym_LF] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [911] = {
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(2801),
    [anon_sym_end] = ACTIONS(2801),
    [anon_sym_abstract] = ACTIONS(2801),
    [anon_sym_primitive] = ACTIONS(2801),
    [aux_sym_primitive_definition_token1] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_module] = ACTIONS(2801),
    [anon_sym_macro] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2801),
    [anon_sym_RPAREN] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym_EQ] = ACTIONS(2801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2801),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LT_COLON] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_elseif] = ACTIONS(2801),
    [anon_sym_else] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_catch] = ACTIONS(2801),
    [anon_sym_finally] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [sym_break_statement] = ACTIONS(2801),
    [sym_continue_statement] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_quote] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2801),
    [anon_sym_export] = ACTIONS(2801),
    [anon_sym_COLON2] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_begin] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_LT_PIPE] = ACTIONS(2801),
    [anon_sym_PIPE_GT] = ACTIONS(2801),
    [anon_sym_in] = ACTIONS(2801),
    [anon_sym_isa] = ACTIONS(2801),
    [anon_sym_PIPE_PIPE] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_QMARK] = ACTIONS(2801),
    [anon_sym_EQ_GT] = ACTIONS(2801),
    [anon_sym_LBRACK2] = ACTIONS(2801),
    [anon_sym_DOLLAR] = ACTIONS(2801),
    [anon_sym_AT] = ACTIONS(2801),
    [aux_sym_integer_literal_token1] = ACTIONS(2801),
    [aux_sym_integer_literal_token2] = ACTIONS(2801),
    [aux_sym_integer_literal_token3] = ACTIONS(2801),
    [sym_float_literal] = ACTIONS(2801),
    [sym__unary_operator] = ACTIONS(2801),
    [sym__power_operator] = ACTIONS(2801),
    [sym__bitshift_operator] = ACTIONS(2801),
    [sym__rational_operator] = ACTIONS(2801),
    [sym__times_operator] = ACTIONS(2801),
    [sym__plus_operator] = ACTIONS(2801),
    [sym__dotty_operator] = ACTIONS(2801),
    [sym__comparison_operator] = ACTIONS(2801),
    [sym__arrow_operator] = ACTIONS(2801),
    [sym__assign_operator] = ACTIONS(2801),
    [anon_sym_LF] = ACTIONS(2803),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2803),
    [sym__command_start] = ACTIONS(2803),
  },
  [912] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_primitive] = ACTIONS(2494),
    [aux_sym_primitive_definition_token1] = ACTIONS(2494),
    [anon_sym_mutable] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_macro] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_LT_COLON] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [sym_break_statement] = ACTIONS(2494),
    [sym_continue_statement] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_quote] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_COLON2] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_RBRACK] = ACTIONS(2496),
    [anon_sym_begin] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_LT_PIPE] = ACTIONS(2496),
    [anon_sym_PIPE_GT] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_isa] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2496),
    [anon_sym_AMP_AMP] = ACTIONS(2496),
    [anon_sym_QMARK] = ACTIONS(2496),
    [anon_sym_EQ_GT] = ACTIONS(2496),
    [anon_sym_LBRACK2] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2496),
    [aux_sym_integer_literal_token1] = ACTIONS(2496),
    [aux_sym_integer_literal_token2] = ACTIONS(2496),
    [aux_sym_integer_literal_token3] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
    [sym__unary_operator] = ACTIONS(2494),
    [sym__power_operator] = ACTIONS(2494),
    [sym__bitshift_operator] = ACTIONS(2494),
    [sym__rational_operator] = ACTIONS(2494),
    [sym__times_operator] = ACTIONS(2494),
    [sym__plus_operator] = ACTIONS(2494),
    [sym__dotty_operator] = ACTIONS(2494),
    [sym__comparison_operator] = ACTIONS(2494),
    [sym__arrow_operator] = ACTIONS(2496),
    [sym__assign_operator] = ACTIONS(2494),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2496),
    [sym__string_start] = ACTIONS(2496),
    [sym__command_start] = ACTIONS(2496),
  },
  [913] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_end] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_primitive] = ACTIONS(2586),
    [aux_sym_primitive_definition_token1] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_macro] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_LT_COLON] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [sym_break_statement] = ACTIONS(2586),
    [sym_continue_statement] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_quote] = ACTIONS(2586),
    [anon_sym_using] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_COLON2] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_LT_PIPE] = ACTIONS(2588),
    [anon_sym_PIPE_GT] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_isa] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK2] = ACTIONS(2586),
    [anon_sym_DASH_GT] = ACTIONS(2805),
    [anon_sym_DOLLAR] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2588),
    [aux_sym_integer_literal_token1] = ACTIONS(2588),
    [aux_sym_integer_literal_token2] = ACTIONS(2588),
    [aux_sym_integer_literal_token3] = ACTIONS(2586),
    [sym_float_literal] = ACTIONS(2586),
    [sym__unary_operator] = ACTIONS(2586),
    [sym__power_operator] = ACTIONS(2586),
    [sym__bitshift_operator] = ACTIONS(2586),
    [sym__rational_operator] = ACTIONS(2586),
    [sym__times_operator] = ACTIONS(2586),
    [sym__plus_operator] = ACTIONS(2586),
    [sym__dotty_operator] = ACTIONS(2586),
    [sym__comparison_operator] = ACTIONS(2586),
    [sym__arrow_operator] = ACTIONS(2588),
    [sym__assign_operator] = ACTIONS(2586),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__command_start] = ACTIONS(2588),
  },
  [914] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_end] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_primitive] = ACTIONS(2542),
    [aux_sym_primitive_definition_token1] = ACTIONS(2542),
    [anon_sym_mutable] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_macro] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2544),
    [anon_sym_COMMA] = ACTIONS(2544),
    [anon_sym_RPAREN] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_EQ] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2544),
    [anon_sym_COLON_COLON] = ACTIONS(2544),
    [anon_sym_RBRACE] = ACTIONS(2544),
    [anon_sym_LT_COLON] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [sym_break_statement] = ACTIONS(2542),
    [sym_continue_statement] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_quote] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_COLON2] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_RBRACK] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_LT_PIPE] = ACTIONS(2544),
    [anon_sym_PIPE_GT] = ACTIONS(2544),
    [anon_sym_in] = ACTIONS(2542),
    [anon_sym_isa] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2544),
    [anon_sym_AMP_AMP] = ACTIONS(2544),
    [anon_sym_QMARK] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(2544),
    [anon_sym_LBRACK2] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2544),
    [aux_sym_integer_literal_token1] = ACTIONS(2544),
    [aux_sym_integer_literal_token2] = ACTIONS(2544),
    [aux_sym_integer_literal_token3] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
    [sym__unary_operator] = ACTIONS(2542),
    [sym__power_operator] = ACTIONS(2542),
    [sym__bitshift_operator] = ACTIONS(2542),
    [sym__rational_operator] = ACTIONS(2542),
    [sym__times_operator] = ACTIONS(2542),
    [sym__plus_operator] = ACTIONS(2542),
    [sym__dotty_operator] = ACTIONS(2542),
    [sym__comparison_operator] = ACTIONS(2542),
    [sym__arrow_operator] = ACTIONS(2544),
    [sym__assign_operator] = ACTIONS(2542),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2544),
    [sym__string_start] = ACTIONS(2544),
    [sym__command_start] = ACTIONS(2544),
  },
  [915] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_end] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_primitive] = ACTIONS(2550),
    [aux_sym_primitive_definition_token1] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_macro] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2552),
    [anon_sym_COMMA] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_EQ] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2552),
    [anon_sym_LT_COLON] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_break_statement] = ACTIONS(2550),
    [sym_continue_statement] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_quote] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_COLON2] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_RBRACK] = ACTIONS(2552),
    [anon_sym_begin] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_LT_PIPE] = ACTIONS(2552),
    [anon_sym_PIPE_GT] = ACTIONS(2552),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_isa] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_EQ_GT] = ACTIONS(2552),
    [anon_sym_LBRACK2] = ACTIONS(2550),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_AT] = ACTIONS(2552),
    [aux_sym_integer_literal_token1] = ACTIONS(2552),
    [aux_sym_integer_literal_token2] = ACTIONS(2552),
    [aux_sym_integer_literal_token3] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
    [sym__unary_operator] = ACTIONS(2550),
    [sym__power_operator] = ACTIONS(2550),
    [sym__bitshift_operator] = ACTIONS(2550),
    [sym__rational_operator] = ACTIONS(2550),
    [sym__times_operator] = ACTIONS(2550),
    [sym__plus_operator] = ACTIONS(2550),
    [sym__dotty_operator] = ACTIONS(2550),
    [sym__comparison_operator] = ACTIONS(2550),
    [sym__arrow_operator] = ACTIONS(2552),
    [sym__assign_operator] = ACTIONS(2550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2552),
    [sym__string_start] = ACTIONS(2552),
    [sym__command_start] = ACTIONS(2552),
  },
  [916] = {
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_function] = ACTIONS(2807),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_abstract] = ACTIONS(2807),
    [anon_sym_primitive] = ACTIONS(2807),
    [aux_sym_primitive_definition_token1] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_module] = ACTIONS(2807),
    [anon_sym_macro] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_EQ] = ACTIONS(2807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LT_COLON] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_elseif] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_catch] = ACTIONS(2807),
    [anon_sym_finally] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [sym_break_statement] = ACTIONS(2807),
    [sym_continue_statement] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_let] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_quote] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_import] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_begin] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_LT_PIPE] = ACTIONS(2807),
    [anon_sym_PIPE_GT] = ACTIONS(2807),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_isa] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK2] = ACTIONS(2807),
    [anon_sym_DOLLAR] = ACTIONS(2807),
    [anon_sym_AT] = ACTIONS(2807),
    [aux_sym_integer_literal_token1] = ACTIONS(2807),
    [aux_sym_integer_literal_token2] = ACTIONS(2807),
    [aux_sym_integer_literal_token3] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
    [sym__unary_operator] = ACTIONS(2807),
    [sym__power_operator] = ACTIONS(2807),
    [sym__bitshift_operator] = ACTIONS(2807),
    [sym__rational_operator] = ACTIONS(2807),
    [sym__times_operator] = ACTIONS(2807),
    [sym__plus_operator] = ACTIONS(2807),
    [sym__dotty_operator] = ACTIONS(2807),
    [sym__comparison_operator] = ACTIONS(2807),
    [sym__arrow_operator] = ACTIONS(2807),
    [sym__assign_operator] = ACTIONS(2807),
    [anon_sym_LF] = ACTIONS(2809),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2809),
    [sym__command_start] = ACTIONS(2809),
  },
  [917] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_function] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(2811),
    [anon_sym_abstract] = ACTIONS(2811),
    [anon_sym_primitive] = ACTIONS(2811),
    [aux_sym_primitive_definition_token1] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_macro] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_COMMA] = ACTIONS(2813),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_EQ] = ACTIONS(2811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LT_COLON] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_elseif] = ACTIONS(2811),
    [anon_sym_else] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_catch] = ACTIONS(2811),
    [anon_sym_finally] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [sym_break_statement] = ACTIONS(2811),
    [sym_continue_statement] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_quote] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_COLON2] = ACTIONS(2811),
    [anon_sym_begin] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_LT_PIPE] = ACTIONS(2811),
    [anon_sym_PIPE_GT] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_isa] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_QMARK] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_LBRACK2] = ACTIONS(2811),
    [anon_sym_DOLLAR] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2811),
    [aux_sym_integer_literal_token1] = ACTIONS(2811),
    [aux_sym_integer_literal_token2] = ACTIONS(2811),
    [aux_sym_integer_literal_token3] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
    [sym__unary_operator] = ACTIONS(2811),
    [sym__power_operator] = ACTIONS(2811),
    [sym__bitshift_operator] = ACTIONS(2811),
    [sym__rational_operator] = ACTIONS(2811),
    [sym__times_operator] = ACTIONS(2811),
    [sym__plus_operator] = ACTIONS(2811),
    [sym__dotty_operator] = ACTIONS(2811),
    [sym__comparison_operator] = ACTIONS(2811),
    [sym__arrow_operator] = ACTIONS(2811),
    [sym__assign_operator] = ACTIONS(2811),
    [anon_sym_LF] = ACTIONS(2815),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2815),
    [sym__command_start] = ACTIONS(2815),
  },
  [918] = {
    [sym_identifier] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_primitive] = ACTIONS(304),
    [aux_sym_primitive_definition_token1] = ACTIONS(304),
    [anon_sym_mutable] = ACTIONS(304),
    [anon_sym_struct] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_macro] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_catch] = ACTIONS(304),
    [anon_sym_finally] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [sym_break_statement] = ACTIONS(304),
    [sym_continue_statement] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_quote] = ACTIONS(304),
    [anon_sym_using] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_COLON2] = ACTIONS(304),
    [anon_sym_begin] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(304),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(304),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(304),
    [aux_sym_integer_literal_token1] = ACTIONS(304),
    [aux_sym_integer_literal_token2] = ACTIONS(304),
    [aux_sym_integer_literal_token3] = ACTIONS(304),
    [sym_float_literal] = ACTIONS(304),
    [sym__unary_operator] = ACTIONS(304),
    [sym__power_operator] = ACTIONS(304),
    [sym__bitshift_operator] = ACTIONS(304),
    [sym__rational_operator] = ACTIONS(304),
    [sym__times_operator] = ACTIONS(304),
    [sym__plus_operator] = ACTIONS(304),
    [sym__dotty_operator] = ACTIONS(304),
    [sym__comparison_operator] = ACTIONS(304),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(306),
    [sym__command_start] = ACTIONS(306),
  },
  [919] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_elseif] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_catch] = ACTIONS(2702),
    [anon_sym_finally] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [sym__assign_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2710),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [920] = {
    [aux_sym_export_statement_repeat1] = STATE(920),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_end] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_primitive] = ACTIONS(2817),
    [aux_sym_primitive_definition_token1] = ACTIONS(2817),
    [anon_sym_mutable] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_macro] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2819),
    [anon_sym_RPAREN] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2817),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LT_COLON] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_elseif] = ACTIONS(2817),
    [anon_sym_else] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_catch] = ACTIONS(2817),
    [anon_sym_finally] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [sym_break_statement] = ACTIONS(2817),
    [sym_continue_statement] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_quote] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_COLON2] = ACTIONS(2817),
    [anon_sym_begin] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_LT_PIPE] = ACTIONS(2817),
    [anon_sym_PIPE_GT] = ACTIONS(2817),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_isa] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(2817),
    [anon_sym_LBRACK2] = ACTIONS(2817),
    [anon_sym_DOLLAR] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2817),
    [aux_sym_integer_literal_token1] = ACTIONS(2817),
    [aux_sym_integer_literal_token2] = ACTIONS(2817),
    [aux_sym_integer_literal_token3] = ACTIONS(2817),
    [sym_float_literal] = ACTIONS(2817),
    [sym__unary_operator] = ACTIONS(2817),
    [sym__power_operator] = ACTIONS(2817),
    [sym__bitshift_operator] = ACTIONS(2817),
    [sym__rational_operator] = ACTIONS(2817),
    [sym__times_operator] = ACTIONS(2817),
    [sym__plus_operator] = ACTIONS(2817),
    [sym__dotty_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(2817),
    [sym__arrow_operator] = ACTIONS(2817),
    [sym__assign_operator] = ACTIONS(2817),
    [anon_sym_LF] = ACTIONS(2822),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2822),
    [sym__command_start] = ACTIONS(2822),
  },
  [921] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_end] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_primitive] = ACTIONS(2530),
    [aux_sym_primitive_definition_token1] = ACTIONS(2530),
    [anon_sym_mutable] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_macro] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RPAREN] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_EQ] = ACTIONS(2530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_LT_COLON] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [sym_break_statement] = ACTIONS(2530),
    [sym_continue_statement] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_quote] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_COLON2] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_RBRACK] = ACTIONS(2532),
    [anon_sym_begin] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_LT_PIPE] = ACTIONS(2532),
    [anon_sym_PIPE_GT] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2530),
    [anon_sym_isa] = ACTIONS(2530),
    [anon_sym_PIPE_PIPE] = ACTIONS(2532),
    [anon_sym_AMP_AMP] = ACTIONS(2532),
    [anon_sym_QMARK] = ACTIONS(2532),
    [anon_sym_EQ_GT] = ACTIONS(2532),
    [anon_sym_LBRACK2] = ACTIONS(2530),
    [anon_sym_DOLLAR] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2532),
    [aux_sym_integer_literal_token1] = ACTIONS(2532),
    [aux_sym_integer_literal_token2] = ACTIONS(2532),
    [aux_sym_integer_literal_token3] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
    [sym__unary_operator] = ACTIONS(2530),
    [sym__power_operator] = ACTIONS(2530),
    [sym__bitshift_operator] = ACTIONS(2530),
    [sym__rational_operator] = ACTIONS(2530),
    [sym__times_operator] = ACTIONS(2530),
    [sym__plus_operator] = ACTIONS(2530),
    [sym__dotty_operator] = ACTIONS(2530),
    [sym__comparison_operator] = ACTIONS(2530),
    [sym__arrow_operator] = ACTIONS(2532),
    [sym__assign_operator] = ACTIONS(2530),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2532),
    [sym__string_start] = ACTIONS(2532),
    [sym__command_start] = ACTIONS(2532),
  },
  [922] = {
    [aux_sym_import_statement_repeat1] = STATE(922),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2744),
    [anon_sym_LT_COLON] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_elseif] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(2744),
    [anon_sym_finally] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2744),
    [anon_sym_PIPE_GT] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_LBRACK2] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [aux_sym_integer_literal_token1] = ACTIONS(2744),
    [aux_sym_integer_literal_token2] = ACTIONS(2744),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2744),
    [sym__assign_operator] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [923] = {
    [aux_sym_selected_import_repeat1] = STATE(941),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_function] = ACTIONS(2827),
    [anon_sym_end] = ACTIONS(2827),
    [anon_sym_abstract] = ACTIONS(2827),
    [anon_sym_primitive] = ACTIONS(2827),
    [aux_sym_primitive_definition_token1] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_module] = ACTIONS(2827),
    [anon_sym_macro] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2827),
    [anon_sym_LT_COLON] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_elseif] = ACTIONS(2827),
    [anon_sym_else] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_catch] = ACTIONS(2827),
    [anon_sym_finally] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [sym_break_statement] = ACTIONS(2827),
    [sym_continue_statement] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_quote] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_import] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2827),
    [anon_sym_COLON2] = ACTIONS(2827),
    [anon_sym_begin] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2827),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_LT_PIPE] = ACTIONS(2827),
    [anon_sym_PIPE_GT] = ACTIONS(2827),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_isa] = ACTIONS(2827),
    [anon_sym_PIPE_PIPE] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_EQ_GT] = ACTIONS(2827),
    [anon_sym_LBRACK2] = ACTIONS(2827),
    [anon_sym_DOLLAR] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(2827),
    [aux_sym_integer_literal_token1] = ACTIONS(2827),
    [aux_sym_integer_literal_token2] = ACTIONS(2827),
    [aux_sym_integer_literal_token3] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
    [sym__unary_operator] = ACTIONS(2827),
    [sym__power_operator] = ACTIONS(2827),
    [sym__bitshift_operator] = ACTIONS(2827),
    [sym__rational_operator] = ACTIONS(2827),
    [sym__times_operator] = ACTIONS(2827),
    [sym__plus_operator] = ACTIONS(2827),
    [sym__dotty_operator] = ACTIONS(2827),
    [sym__comparison_operator] = ACTIONS(2827),
    [sym__arrow_operator] = ACTIONS(2827),
    [sym__assign_operator] = ACTIONS(2827),
    [anon_sym_LF] = ACTIONS(2831),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2831),
    [sym__command_start] = ACTIONS(2831),
  },
  [924] = {
    [aux_sym_export_statement_repeat1] = STATE(909),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_end] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_primitive] = ACTIONS(2833),
    [aux_sym_primitive_definition_token1] = ACTIONS(2833),
    [anon_sym_mutable] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_macro] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2797),
    [anon_sym_RPAREN] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2833),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_LT_COLON] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_elseif] = ACTIONS(2833),
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_catch] = ACTIONS(2833),
    [anon_sym_finally] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [sym_break_statement] = ACTIONS(2833),
    [sym_continue_statement] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_quote] = ACTIONS(2833),
    [anon_sym_using] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_COLON2] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_LT_PIPE] = ACTIONS(2833),
    [anon_sym_PIPE_GT] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_isa] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_EQ_GT] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [anon_sym_AT] = ACTIONS(2833),
    [aux_sym_integer_literal_token1] = ACTIONS(2833),
    [aux_sym_integer_literal_token2] = ACTIONS(2833),
    [aux_sym_integer_literal_token3] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym__unary_operator] = ACTIONS(2833),
    [sym__power_operator] = ACTIONS(2833),
    [sym__bitshift_operator] = ACTIONS(2833),
    [sym__rational_operator] = ACTIONS(2833),
    [sym__times_operator] = ACTIONS(2833),
    [sym__plus_operator] = ACTIONS(2833),
    [sym__dotty_operator] = ACTIONS(2833),
    [sym__comparison_operator] = ACTIONS(2833),
    [sym__arrow_operator] = ACTIONS(2833),
    [sym__assign_operator] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2835),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2835),
    [sym__command_start] = ACTIONS(2835),
  },
  [925] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(2869),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_RPAREN] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_elseif] = ACTIONS(2837),
    [anon_sym_else] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_catch] = ACTIONS(2837),
    [anon_sym_finally] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2837),
    [aux_sym_integer_literal_token1] = ACTIONS(2837),
    [aux_sym_integer_literal_token2] = ACTIONS(2837),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2867),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [926] = {
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_end] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_primitive] = ACTIONS(2502),
    [aux_sym_primitive_definition_token1] = ACTIONS(2502),
    [anon_sym_mutable] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_macro] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2504),
    [anon_sym_LT_COLON] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [sym_break_statement] = ACTIONS(2502),
    [sym_continue_statement] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_quote] = ACTIONS(2502),
    [anon_sym_using] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_COLON2] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_RBRACK] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_LT_PIPE] = ACTIONS(2504),
    [anon_sym_PIPE_GT] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2502),
    [anon_sym_isa] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2504),
    [anon_sym_AMP_AMP] = ACTIONS(2504),
    [anon_sym_QMARK] = ACTIONS(2504),
    [anon_sym_EQ_GT] = ACTIONS(2504),
    [anon_sym_LBRACK2] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_AT] = ACTIONS(2504),
    [aux_sym_integer_literal_token1] = ACTIONS(2504),
    [aux_sym_integer_literal_token2] = ACTIONS(2504),
    [aux_sym_integer_literal_token3] = ACTIONS(2502),
    [sym_float_literal] = ACTIONS(2502),
    [sym__unary_operator] = ACTIONS(2502),
    [sym__power_operator] = ACTIONS(2502),
    [sym__bitshift_operator] = ACTIONS(2502),
    [sym__rational_operator] = ACTIONS(2502),
    [sym__times_operator] = ACTIONS(2502),
    [sym__plus_operator] = ACTIONS(2502),
    [sym__dotty_operator] = ACTIONS(2502),
    [sym__comparison_operator] = ACTIONS(2502),
    [sym__arrow_operator] = ACTIONS(2504),
    [sym__assign_operator] = ACTIONS(2502),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2504),
    [sym__string_start] = ACTIONS(2504),
    [sym__command_start] = ACTIONS(2504),
  },
  [927] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_end] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_primitive] = ACTIONS(2526),
    [aux_sym_primitive_definition_token1] = ACTIONS(2526),
    [anon_sym_mutable] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_macro] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_COMMA] = ACTIONS(2528),
    [anon_sym_RPAREN] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_EQ] = ACTIONS(2526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2528),
    [anon_sym_COLON_COLON] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2528),
    [anon_sym_LT_COLON] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [sym_break_statement] = ACTIONS(2526),
    [sym_continue_statement] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_quote] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_COLON2] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_RBRACK] = ACTIONS(2528),
    [anon_sym_begin] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_LT_PIPE] = ACTIONS(2528),
    [anon_sym_PIPE_GT] = ACTIONS(2528),
    [anon_sym_in] = ACTIONS(2526),
    [anon_sym_isa] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2528),
    [anon_sym_AMP_AMP] = ACTIONS(2528),
    [anon_sym_QMARK] = ACTIONS(2528),
    [anon_sym_EQ_GT] = ACTIONS(2528),
    [anon_sym_LBRACK2] = ACTIONS(2526),
    [anon_sym_DOLLAR] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2528),
    [aux_sym_integer_literal_token1] = ACTIONS(2528),
    [aux_sym_integer_literal_token2] = ACTIONS(2528),
    [aux_sym_integer_literal_token3] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
    [sym__unary_operator] = ACTIONS(2526),
    [sym__power_operator] = ACTIONS(2526),
    [sym__bitshift_operator] = ACTIONS(2526),
    [sym__rational_operator] = ACTIONS(2526),
    [sym__times_operator] = ACTIONS(2526),
    [sym__plus_operator] = ACTIONS(2526),
    [sym__dotty_operator] = ACTIONS(2526),
    [sym__comparison_operator] = ACTIONS(2526),
    [sym__arrow_operator] = ACTIONS(2528),
    [sym__assign_operator] = ACTIONS(2526),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2528),
    [sym__string_start] = ACTIONS(2528),
    [sym__command_start] = ACTIONS(2528),
  },
  [928] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_end] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_primitive] = ACTIONS(2554),
    [aux_sym_primitive_definition_token1] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_macro] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_EQ] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2556),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_LT_COLON] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [sym_break_statement] = ACTIONS(2554),
    [sym_continue_statement] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_quote] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_COLON2] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_RBRACK] = ACTIONS(2556),
    [anon_sym_begin] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_LT_PIPE] = ACTIONS(2556),
    [anon_sym_PIPE_GT] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_isa] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2556),
    [anon_sym_AMP_AMP] = ACTIONS(2556),
    [anon_sym_QMARK] = ACTIONS(2556),
    [anon_sym_EQ_GT] = ACTIONS(2556),
    [anon_sym_LBRACK2] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2554),
    [anon_sym_AT] = ACTIONS(2556),
    [aux_sym_integer_literal_token1] = ACTIONS(2556),
    [aux_sym_integer_literal_token2] = ACTIONS(2556),
    [aux_sym_integer_literal_token3] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
    [sym__unary_operator] = ACTIONS(2554),
    [sym__power_operator] = ACTIONS(2554),
    [sym__bitshift_operator] = ACTIONS(2554),
    [sym__rational_operator] = ACTIONS(2554),
    [sym__times_operator] = ACTIONS(2554),
    [sym__plus_operator] = ACTIONS(2554),
    [sym__dotty_operator] = ACTIONS(2554),
    [sym__comparison_operator] = ACTIONS(2554),
    [sym__arrow_operator] = ACTIONS(2556),
    [sym__assign_operator] = ACTIONS(2554),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2556),
    [sym__string_start] = ACTIONS(2556),
    [sym__command_start] = ACTIONS(2556),
  },
  [929] = {
    [aux_sym_import_statement_repeat1] = STATE(888),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(2650),
    [anon_sym_RPAREN] = ACTIONS(2648),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2648),
    [anon_sym_LT_COLON] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_elseif] = ACTIONS(2648),
    [anon_sym_else] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_catch] = ACTIONS(2648),
    [anon_sym_finally] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_GT] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_EQ_GT] = ACTIONS(2648),
    [anon_sym_LBRACK2] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2648),
    [aux_sym_integer_literal_token1] = ACTIONS(2648),
    [aux_sym_integer_literal_token2] = ACTIONS(2648),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2648),
    [sym__assign_operator] = ACTIONS(2648),
    [anon_sym_LF] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [930] = {
    [sym_type_argument_list] = STATE(1221),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(97),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_LT_COLON] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(97),
    [anon_sym_PIPE_GT] = ACTIONS(97),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(97),
    [anon_sym_AMP_AMP] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(97),
    [anon_sym_EQ_GT] = ACTIONS(97),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(2869),
    [anon_sym_DOLLAR] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(97),
    [aux_sym_integer_literal_token1] = ACTIONS(97),
    [aux_sym_integer_literal_token2] = ACTIONS(97),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(97),
    [sym__bitshift_operator] = ACTIONS(97),
    [sym__rational_operator] = ACTIONS(97),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
    [sym__immediate_string_start] = ACTIONS(2698),
    [sym__immediate_command_start] = ACTIONS(2700),
  },
  [931] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_end] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_primitive] = ACTIONS(2506),
    [aux_sym_primitive_definition_token1] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_macro] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_LT_COLON] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [sym_break_statement] = ACTIONS(2506),
    [sym_continue_statement] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_quote] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_COLON2] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_RBRACK] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT_PIPE] = ACTIONS(2508),
    [anon_sym_PIPE_GT] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_isa] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2508),
    [anon_sym_AMP_AMP] = ACTIONS(2508),
    [anon_sym_QMARK] = ACTIONS(2508),
    [anon_sym_EQ_GT] = ACTIONS(2508),
    [anon_sym_LBRACK2] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2508),
    [aux_sym_integer_literal_token1] = ACTIONS(2508),
    [aux_sym_integer_literal_token2] = ACTIONS(2508),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
    [sym__unary_operator] = ACTIONS(2506),
    [sym__power_operator] = ACTIONS(2506),
    [sym__bitshift_operator] = ACTIONS(2506),
    [sym__rational_operator] = ACTIONS(2506),
    [sym__times_operator] = ACTIONS(2506),
    [sym__plus_operator] = ACTIONS(2506),
    [sym__dotty_operator] = ACTIONS(2506),
    [sym__comparison_operator] = ACTIONS(2506),
    [sym__arrow_operator] = ACTIONS(2508),
    [sym__assign_operator] = ACTIONS(2506),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2508),
    [sym__string_start] = ACTIONS(2508),
    [sym__command_start] = ACTIONS(2508),
  },
  [932] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elseif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_catch] = ACTIONS(2871),
    [anon_sym_finally] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [933] = {
    [aux_sym_let_statement_repeat1] = STATE(896),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_abstract] = ACTIONS(2885),
    [anon_sym_primitive] = ACTIONS(2885),
    [aux_sym_primitive_definition_token1] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_macro] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2768),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LT_COLON] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_elseif] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_catch] = ACTIONS(2885),
    [anon_sym_finally] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym_break_statement] = ACTIONS(2885),
    [sym_continue_statement] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_quote] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_LT_PIPE] = ACTIONS(2885),
    [anon_sym_PIPE_GT] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2885),
    [aux_sym_integer_literal_token1] = ACTIONS(2885),
    [aux_sym_integer_literal_token2] = ACTIONS(2885),
    [aux_sym_integer_literal_token3] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym__unary_operator] = ACTIONS(2885),
    [sym__power_operator] = ACTIONS(2885),
    [sym__bitshift_operator] = ACTIONS(2885),
    [sym__rational_operator] = ACTIONS(2885),
    [sym__times_operator] = ACTIONS(2885),
    [sym__plus_operator] = ACTIONS(2885),
    [sym__dotty_operator] = ACTIONS(2885),
    [sym__comparison_operator] = ACTIONS(2885),
    [sym__arrow_operator] = ACTIONS(2885),
    [sym__assign_operator] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2887),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2887),
    [sym__command_start] = ACTIONS(2887),
  },
  [934] = {
    [aux_sym_selected_import_repeat1] = STATE(934),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_end] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_primitive] = ACTIONS(2889),
    [aux_sym_primitive_definition_token1] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_macro] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LT_COLON] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_elseif] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_catch] = ACTIONS(2889),
    [anon_sym_finally] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [sym_break_statement] = ACTIONS(2889),
    [sym_continue_statement] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_quote] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_COLON2] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_LT_PIPE] = ACTIONS(2889),
    [anon_sym_PIPE_GT] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_EQ_GT] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2889),
    [aux_sym_integer_literal_token1] = ACTIONS(2889),
    [aux_sym_integer_literal_token2] = ACTIONS(2889),
    [aux_sym_integer_literal_token3] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym__unary_operator] = ACTIONS(2889),
    [sym__power_operator] = ACTIONS(2889),
    [sym__bitshift_operator] = ACTIONS(2889),
    [sym__rational_operator] = ACTIONS(2889),
    [sym__times_operator] = ACTIONS(2889),
    [sym__plus_operator] = ACTIONS(2889),
    [sym__dotty_operator] = ACTIONS(2889),
    [sym__comparison_operator] = ACTIONS(2889),
    [sym__arrow_operator] = ACTIONS(2889),
    [sym__assign_operator] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2894),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2894),
    [sym__command_start] = ACTIONS(2894),
  },
  [935] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_end] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_primitive] = ACTIONS(2522),
    [aux_sym_primitive_definition_token1] = ACTIONS(2522),
    [anon_sym_mutable] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_macro] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2524),
    [anon_sym_LT_COLON] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [sym_break_statement] = ACTIONS(2522),
    [sym_continue_statement] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_quote] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_COLON2] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_RBRACK] = ACTIONS(2524),
    [anon_sym_begin] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_LT_PIPE] = ACTIONS(2524),
    [anon_sym_PIPE_GT] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_isa] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2524),
    [anon_sym_AMP_AMP] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(2524),
    [anon_sym_LBRACK2] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2524),
    [aux_sym_integer_literal_token1] = ACTIONS(2524),
    [aux_sym_integer_literal_token2] = ACTIONS(2524),
    [aux_sym_integer_literal_token3] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
    [sym__unary_operator] = ACTIONS(2522),
    [sym__power_operator] = ACTIONS(2522),
    [sym__bitshift_operator] = ACTIONS(2522),
    [sym__rational_operator] = ACTIONS(2522),
    [sym__times_operator] = ACTIONS(2522),
    [sym__plus_operator] = ACTIONS(2522),
    [sym__dotty_operator] = ACTIONS(2522),
    [sym__comparison_operator] = ACTIONS(2522),
    [sym__arrow_operator] = ACTIONS(2524),
    [sym__assign_operator] = ACTIONS(2522),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2524),
    [sym__string_start] = ACTIONS(2524),
    [sym__command_start] = ACTIONS(2524),
  },
  [936] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_end] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_primitive] = ACTIONS(2518),
    [aux_sym_primitive_definition_token1] = ACTIONS(2518),
    [anon_sym_mutable] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_macro] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_LT_COLON] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [sym_break_statement] = ACTIONS(2518),
    [sym_continue_statement] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_quote] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_COLON2] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_LT_PIPE] = ACTIONS(2520),
    [anon_sym_PIPE_GT] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_isa] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2520),
    [anon_sym_EQ_GT] = ACTIONS(2520),
    [anon_sym_LBRACK2] = ACTIONS(2518),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2520),
    [aux_sym_integer_literal_token1] = ACTIONS(2520),
    [aux_sym_integer_literal_token2] = ACTIONS(2520),
    [aux_sym_integer_literal_token3] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
    [sym__unary_operator] = ACTIONS(2518),
    [sym__power_operator] = ACTIONS(2518),
    [sym__bitshift_operator] = ACTIONS(2518),
    [sym__rational_operator] = ACTIONS(2518),
    [sym__times_operator] = ACTIONS(2518),
    [sym__plus_operator] = ACTIONS(2518),
    [sym__dotty_operator] = ACTIONS(2518),
    [sym__comparison_operator] = ACTIONS(2518),
    [sym__arrow_operator] = ACTIONS(2520),
    [sym__assign_operator] = ACTIONS(2518),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2520),
    [sym__string_start] = ACTIONS(2520),
    [sym__command_start] = ACTIONS(2520),
  },
  [937] = {
    [sym_identifier] = ACTIONS(2896),
    [anon_sym_function] = ACTIONS(2896),
    [anon_sym_end] = ACTIONS(2896),
    [anon_sym_abstract] = ACTIONS(2896),
    [anon_sym_primitive] = ACTIONS(2896),
    [aux_sym_primitive_definition_token1] = ACTIONS(2896),
    [anon_sym_mutable] = ACTIONS(2896),
    [anon_sym_struct] = ACTIONS(2896),
    [anon_sym_module] = ACTIONS(2896),
    [anon_sym_macro] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_RPAREN] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2896),
    [anon_sym_COLON_COLON] = ACTIONS(2896),
    [anon_sym_LT_COLON] = ACTIONS(2896),
    [anon_sym_if] = ACTIONS(2896),
    [anon_sym_elseif] = ACTIONS(2896),
    [anon_sym_else] = ACTIONS(2896),
    [anon_sym_try] = ACTIONS(2896),
    [anon_sym_catch] = ACTIONS(2896),
    [anon_sym_finally] = ACTIONS(2896),
    [anon_sym_for] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2896),
    [sym_break_statement] = ACTIONS(2896),
    [sym_continue_statement] = ACTIONS(2896),
    [anon_sym_return] = ACTIONS(2896),
    [anon_sym_let] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_quote] = ACTIONS(2896),
    [anon_sym_using] = ACTIONS(2896),
    [anon_sym_import] = ACTIONS(2896),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_COLON2] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_begin] = ACTIONS(2896),
    [anon_sym_SQUOTE] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT_PIPE] = ACTIONS(2896),
    [anon_sym_PIPE_GT] = ACTIONS(2896),
    [anon_sym_in] = ACTIONS(2896),
    [anon_sym_isa] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_EQ_GT] = ACTIONS(2896),
    [anon_sym_LBRACK2] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_AT] = ACTIONS(2896),
    [aux_sym_integer_literal_token1] = ACTIONS(2896),
    [aux_sym_integer_literal_token2] = ACTIONS(2896),
    [aux_sym_integer_literal_token3] = ACTIONS(2896),
    [sym_float_literal] = ACTIONS(2896),
    [sym__unary_operator] = ACTIONS(2896),
    [sym__power_operator] = ACTIONS(2896),
    [sym__bitshift_operator] = ACTIONS(2896),
    [sym__rational_operator] = ACTIONS(2896),
    [sym__times_operator] = ACTIONS(2896),
    [sym__plus_operator] = ACTIONS(2896),
    [sym__dotty_operator] = ACTIONS(2896),
    [sym__comparison_operator] = ACTIONS(2896),
    [sym__arrow_operator] = ACTIONS(2896),
    [sym__assign_operator] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2898),
    [sym__command_start] = ACTIONS(2898),
  },
  [938] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_end] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_primitive] = ACTIONS(2900),
    [aux_sym_primitive_definition_token1] = ACTIONS(2900),
    [anon_sym_mutable] = ACTIONS(2900),
    [anon_sym_struct] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_macro] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(2813),
    [anon_sym_RPAREN] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(2900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_elseif] = ACTIONS(2900),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_catch] = ACTIONS(2900),
    [anon_sym_finally] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [sym_break_statement] = ACTIONS(2900),
    [sym_continue_statement] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_quote] = ACTIONS(2900),
    [anon_sym_using] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2900),
    [anon_sym_DOLLAR] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2900),
    [aux_sym_integer_literal_token1] = ACTIONS(2900),
    [aux_sym_integer_literal_token2] = ACTIONS(2900),
    [aux_sym_integer_literal_token3] = ACTIONS(2900),
    [sym_float_literal] = ACTIONS(2900),
    [sym__unary_operator] = ACTIONS(2900),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2900),
    [anon_sym_LF] = ACTIONS(2902),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2902),
    [sym__command_start] = ACTIONS(2902),
  },
  [939] = {
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_end] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_primitive] = ACTIONS(2904),
    [aux_sym_primitive_definition_token1] = ACTIONS(2904),
    [anon_sym_mutable] = ACTIONS(2904),
    [anon_sym_struct] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_macro] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2904),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_RPAREN] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2904),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LT_COLON] = ACTIONS(2904),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_elseif] = ACTIONS(2904),
    [anon_sym_else] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_catch] = ACTIONS(2904),
    [anon_sym_finally] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [sym_break_statement] = ACTIONS(2904),
    [sym_continue_statement] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_quote] = ACTIONS(2904),
    [anon_sym_using] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_COLON2] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_begin] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_LT_PIPE] = ACTIONS(2904),
    [anon_sym_PIPE_GT] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2904),
    [anon_sym_isa] = ACTIONS(2904),
    [anon_sym_PIPE_PIPE] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2904),
    [anon_sym_QMARK] = ACTIONS(2904),
    [anon_sym_EQ_GT] = ACTIONS(2904),
    [anon_sym_LBRACK2] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2904),
    [anon_sym_AT] = ACTIONS(2904),
    [aux_sym_integer_literal_token1] = ACTIONS(2904),
    [aux_sym_integer_literal_token2] = ACTIONS(2904),
    [aux_sym_integer_literal_token3] = ACTIONS(2904),
    [sym_float_literal] = ACTIONS(2904),
    [sym__unary_operator] = ACTIONS(2904),
    [sym__power_operator] = ACTIONS(2904),
    [sym__bitshift_operator] = ACTIONS(2904),
    [sym__rational_operator] = ACTIONS(2904),
    [sym__times_operator] = ACTIONS(2904),
    [sym__plus_operator] = ACTIONS(2904),
    [sym__dotty_operator] = ACTIONS(2904),
    [sym__comparison_operator] = ACTIONS(2904),
    [sym__arrow_operator] = ACTIONS(2904),
    [sym__assign_operator] = ACTIONS(2904),
    [anon_sym_LF] = ACTIONS(2906),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2906),
    [sym__command_start] = ACTIONS(2906),
  },
  [940] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_end] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_primitive] = ACTIONS(2514),
    [aux_sym_primitive_definition_token1] = ACTIONS(2514),
    [anon_sym_mutable] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_macro] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LT_COLON] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [sym_break_statement] = ACTIONS(2514),
    [sym_continue_statement] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_quote] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_COLON2] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_LT_PIPE] = ACTIONS(2516),
    [anon_sym_PIPE_GT] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_isa] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_QMARK] = ACTIONS(2516),
    [anon_sym_EQ_GT] = ACTIONS(2516),
    [anon_sym_LBRACK2] = ACTIONS(2514),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [aux_sym_integer_literal_token1] = ACTIONS(2516),
    [aux_sym_integer_literal_token2] = ACTIONS(2516),
    [aux_sym_integer_literal_token3] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__power_operator] = ACTIONS(2514),
    [sym__bitshift_operator] = ACTIONS(2514),
    [sym__rational_operator] = ACTIONS(2514),
    [sym__times_operator] = ACTIONS(2514),
    [sym__plus_operator] = ACTIONS(2514),
    [sym__dotty_operator] = ACTIONS(2514),
    [sym__comparison_operator] = ACTIONS(2514),
    [sym__arrow_operator] = ACTIONS(2516),
    [sym__assign_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2516),
    [sym__string_start] = ACTIONS(2516),
    [sym__command_start] = ACTIONS(2516),
  },
  [941] = {
    [aux_sym_selected_import_repeat1] = STATE(934),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_end] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_primitive] = ACTIONS(2908),
    [aux_sym_primitive_definition_token1] = ACTIONS(2908),
    [anon_sym_mutable] = ACTIONS(2908),
    [anon_sym_struct] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_macro] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_LT_COLON] = ACTIONS(2908),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_elseif] = ACTIONS(2908),
    [anon_sym_else] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_catch] = ACTIONS(2908),
    [anon_sym_finally] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [sym_break_statement] = ACTIONS(2908),
    [sym_continue_statement] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_quote] = ACTIONS(2908),
    [anon_sym_using] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_COLON2] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_LT_PIPE] = ACTIONS(2908),
    [anon_sym_PIPE_GT] = ACTIONS(2908),
    [anon_sym_in] = ACTIONS(2908),
    [anon_sym_isa] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_EQ_GT] = ACTIONS(2908),
    [anon_sym_LBRACK2] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2908),
    [aux_sym_integer_literal_token1] = ACTIONS(2908),
    [aux_sym_integer_literal_token2] = ACTIONS(2908),
    [aux_sym_integer_literal_token3] = ACTIONS(2908),
    [sym_float_literal] = ACTIONS(2908),
    [sym__unary_operator] = ACTIONS(2908),
    [sym__power_operator] = ACTIONS(2908),
    [sym__bitshift_operator] = ACTIONS(2908),
    [sym__rational_operator] = ACTIONS(2908),
    [sym__times_operator] = ACTIONS(2908),
    [sym__plus_operator] = ACTIONS(2908),
    [sym__dotty_operator] = ACTIONS(2908),
    [sym__comparison_operator] = ACTIONS(2908),
    [sym__arrow_operator] = ACTIONS(2908),
    [sym__assign_operator] = ACTIONS(2908),
    [anon_sym_LF] = ACTIONS(2910),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2910),
    [sym__command_start] = ACTIONS(2910),
  },
  [942] = {
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_primitive] = ACTIONS(2912),
    [aux_sym_primitive_definition_token1] = ACTIONS(2912),
    [anon_sym_mutable] = ACTIONS(2912),
    [anon_sym_struct] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_macro] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2912),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2912),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2912),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_LT_COLON] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_elseif] = ACTIONS(2912),
    [anon_sym_else] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_catch] = ACTIONS(2912),
    [anon_sym_finally] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [sym_break_statement] = ACTIONS(2912),
    [sym_continue_statement] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_quote] = ACTIONS(2912),
    [anon_sym_using] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_COLON2] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_LT_PIPE] = ACTIONS(2912),
    [anon_sym_PIPE_GT] = ACTIONS(2912),
    [anon_sym_in] = ACTIONS(2912),
    [anon_sym_isa] = ACTIONS(2912),
    [anon_sym_PIPE_PIPE] = ACTIONS(2912),
    [anon_sym_AMP_AMP] = ACTIONS(2912),
    [anon_sym_QMARK] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(2912),
    [anon_sym_LBRACK2] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2912),
    [aux_sym_integer_literal_token2] = ACTIONS(2912),
    [aux_sym_integer_literal_token3] = ACTIONS(2912),
    [sym_float_literal] = ACTIONS(2912),
    [sym__unary_operator] = ACTIONS(2912),
    [sym__power_operator] = ACTIONS(2912),
    [sym__bitshift_operator] = ACTIONS(2912),
    [sym__rational_operator] = ACTIONS(2912),
    [sym__times_operator] = ACTIONS(2912),
    [sym__plus_operator] = ACTIONS(2912),
    [sym__dotty_operator] = ACTIONS(2912),
    [sym__comparison_operator] = ACTIONS(2912),
    [sym__arrow_operator] = ACTIONS(2912),
    [sym__assign_operator] = ACTIONS(2912),
    [anon_sym_LF] = ACTIONS(2914),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2914),
    [sym__string_start] = ACTIONS(2914),
    [sym__command_start] = ACTIONS(2914),
  },
  [943] = {
    [aux_sym_let_statement_repeat1] = STATE(943),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_end] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_primitive] = ACTIONS(2916),
    [aux_sym_primitive_definition_token1] = ACTIONS(2916),
    [anon_sym_mutable] = ACTIONS(2916),
    [anon_sym_struct] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_macro] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2916),
    [anon_sym_COMMA] = ACTIONS(2918),
    [anon_sym_RPAREN] = ACTIONS(2916),
    [anon_sym_SEMI] = ACTIONS(2916),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2916),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_LT_COLON] = ACTIONS(2916),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_elseif] = ACTIONS(2916),
    [anon_sym_else] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_catch] = ACTIONS(2916),
    [anon_sym_finally] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [sym_break_statement] = ACTIONS(2916),
    [sym_continue_statement] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_quote] = ACTIONS(2916),
    [anon_sym_using] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_COLON2] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2916),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_LT_PIPE] = ACTIONS(2916),
    [anon_sym_PIPE_GT] = ACTIONS(2916),
    [anon_sym_in] = ACTIONS(2916),
    [anon_sym_isa] = ACTIONS(2916),
    [anon_sym_PIPE_PIPE] = ACTIONS(2916),
    [anon_sym_AMP_AMP] = ACTIONS(2916),
    [anon_sym_QMARK] = ACTIONS(2916),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_LBRACK2] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2916),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [sym_float_literal] = ACTIONS(2916),
    [sym__unary_operator] = ACTIONS(2916),
    [sym__power_operator] = ACTIONS(2916),
    [sym__bitshift_operator] = ACTIONS(2916),
    [sym__rational_operator] = ACTIONS(2916),
    [sym__times_operator] = ACTIONS(2916),
    [sym__plus_operator] = ACTIONS(2916),
    [sym__dotty_operator] = ACTIONS(2916),
    [sym__comparison_operator] = ACTIONS(2916),
    [sym__arrow_operator] = ACTIONS(2916),
    [sym__assign_operator] = ACTIONS(2916),
    [anon_sym_LF] = ACTIONS(2921),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2921),
    [sym__command_start] = ACTIONS(2921),
  },
  [944] = {
    [sym_identifier] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_end] = ACTIONS(2923),
    [anon_sym_abstract] = ACTIONS(2923),
    [anon_sym_primitive] = ACTIONS(2923),
    [aux_sym_primitive_definition_token1] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_macro] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2923),
    [anon_sym_COMMA] = ACTIONS(2923),
    [anon_sym_RPAREN] = ACTIONS(2923),
    [anon_sym_SEMI] = ACTIONS(2923),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2923),
    [anon_sym_COLON_COLON] = ACTIONS(2923),
    [anon_sym_LT_COLON] = ACTIONS(2923),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_elseif] = ACTIONS(2923),
    [anon_sym_else] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_catch] = ACTIONS(2923),
    [anon_sym_finally] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [sym_break_statement] = ACTIONS(2923),
    [sym_continue_statement] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_quote] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_import] = ACTIONS(2923),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_COLON2] = ACTIONS(2923),
    [anon_sym_begin] = ACTIONS(2923),
    [anon_sym_SQUOTE] = ACTIONS(2923),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_LT_PIPE] = ACTIONS(2923),
    [anon_sym_PIPE_GT] = ACTIONS(2923),
    [anon_sym_in] = ACTIONS(2923),
    [anon_sym_isa] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2923),
    [anon_sym_AMP_AMP] = ACTIONS(2923),
    [anon_sym_QMARK] = ACTIONS(2923),
    [anon_sym_EQ_GT] = ACTIONS(2923),
    [anon_sym_LBRACK2] = ACTIONS(2923),
    [anon_sym_DOLLAR] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2923),
    [aux_sym_integer_literal_token1] = ACTIONS(2923),
    [aux_sym_integer_literal_token2] = ACTIONS(2923),
    [aux_sym_integer_literal_token3] = ACTIONS(2923),
    [sym_float_literal] = ACTIONS(2923),
    [sym__unary_operator] = ACTIONS(2923),
    [sym__power_operator] = ACTIONS(2923),
    [sym__bitshift_operator] = ACTIONS(2923),
    [sym__rational_operator] = ACTIONS(2923),
    [sym__times_operator] = ACTIONS(2923),
    [sym__plus_operator] = ACTIONS(2923),
    [sym__dotty_operator] = ACTIONS(2923),
    [sym__comparison_operator] = ACTIONS(2923),
    [sym__arrow_operator] = ACTIONS(2923),
    [sym__assign_operator] = ACTIONS(2923),
    [anon_sym_LF] = ACTIONS(2925),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2925),
    [sym__command_start] = ACTIONS(2925),
  },
  [945] = {
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_function] = ACTIONS(2927),
    [anon_sym_end] = ACTIONS(2927),
    [anon_sym_abstract] = ACTIONS(2927),
    [anon_sym_primitive] = ACTIONS(2927),
    [aux_sym_primitive_definition_token1] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_module] = ACTIONS(2927),
    [anon_sym_macro] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2927),
    [anon_sym_COMMA] = ACTIONS(2927),
    [anon_sym_RPAREN] = ACTIONS(2927),
    [anon_sym_SEMI] = ACTIONS(2927),
    [anon_sym_EQ] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2927),
    [anon_sym_COLON_COLON] = ACTIONS(2927),
    [anon_sym_LT_COLON] = ACTIONS(2927),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_elseif] = ACTIONS(2927),
    [anon_sym_else] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_catch] = ACTIONS(2927),
    [anon_sym_finally] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [sym_break_statement] = ACTIONS(2927),
    [sym_continue_statement] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_quote] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_import] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2927),
    [anon_sym_COLON2] = ACTIONS(2927),
    [anon_sym_begin] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2927),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_LT_PIPE] = ACTIONS(2927),
    [anon_sym_PIPE_GT] = ACTIONS(2927),
    [anon_sym_in] = ACTIONS(2927),
    [anon_sym_isa] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2927),
    [anon_sym_AMP_AMP] = ACTIONS(2927),
    [anon_sym_QMARK] = ACTIONS(2927),
    [anon_sym_EQ_GT] = ACTIONS(2927),
    [anon_sym_LBRACK2] = ACTIONS(2927),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_AT] = ACTIONS(2927),
    [aux_sym_integer_literal_token1] = ACTIONS(2927),
    [aux_sym_integer_literal_token2] = ACTIONS(2927),
    [aux_sym_integer_literal_token3] = ACTIONS(2927),
    [sym_float_literal] = ACTIONS(2927),
    [sym__unary_operator] = ACTIONS(2927),
    [sym__power_operator] = ACTIONS(2927),
    [sym__bitshift_operator] = ACTIONS(2927),
    [sym__rational_operator] = ACTIONS(2927),
    [sym__times_operator] = ACTIONS(2927),
    [sym__plus_operator] = ACTIONS(2927),
    [sym__dotty_operator] = ACTIONS(2927),
    [sym__comparison_operator] = ACTIONS(2927),
    [sym__arrow_operator] = ACTIONS(2927),
    [sym__assign_operator] = ACTIONS(2927),
    [anon_sym_LF] = ACTIONS(2929),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2929),
    [sym__command_start] = ACTIONS(2929),
  },
  [946] = {
    [sym_identifier] = ACTIONS(2931),
    [anon_sym_function] = ACTIONS(2931),
    [anon_sym_end] = ACTIONS(2931),
    [anon_sym_abstract] = ACTIONS(2931),
    [anon_sym_primitive] = ACTIONS(2931),
    [aux_sym_primitive_definition_token1] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_macro] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_COMMA] = ACTIONS(2931),
    [anon_sym_RPAREN] = ACTIONS(2931),
    [anon_sym_SEMI] = ACTIONS(2931),
    [anon_sym_EQ] = ACTIONS(2931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2931),
    [anon_sym_COLON_COLON] = ACTIONS(2931),
    [anon_sym_LT_COLON] = ACTIONS(2931),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_elseif] = ACTIONS(2931),
    [anon_sym_else] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_catch] = ACTIONS(2931),
    [anon_sym_finally] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [sym_break_statement] = ACTIONS(2931),
    [sym_continue_statement] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_let] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_quote] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_import] = ACTIONS(2931),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_COLON2] = ACTIONS(2931),
    [anon_sym_begin] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2931),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_LT_PIPE] = ACTIONS(2931),
    [anon_sym_PIPE_GT] = ACTIONS(2931),
    [anon_sym_in] = ACTIONS(2931),
    [anon_sym_isa] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2931),
    [anon_sym_AMP_AMP] = ACTIONS(2931),
    [anon_sym_QMARK] = ACTIONS(2931),
    [anon_sym_EQ_GT] = ACTIONS(2931),
    [anon_sym_LBRACK2] = ACTIONS(2931),
    [anon_sym_DOLLAR] = ACTIONS(2931),
    [anon_sym_AT] = ACTIONS(2931),
    [aux_sym_integer_literal_token1] = ACTIONS(2931),
    [aux_sym_integer_literal_token2] = ACTIONS(2931),
    [aux_sym_integer_literal_token3] = ACTIONS(2931),
    [sym_float_literal] = ACTIONS(2931),
    [sym__unary_operator] = ACTIONS(2931),
    [sym__power_operator] = ACTIONS(2931),
    [sym__bitshift_operator] = ACTIONS(2931),
    [sym__rational_operator] = ACTIONS(2931),
    [sym__times_operator] = ACTIONS(2931),
    [sym__plus_operator] = ACTIONS(2931),
    [sym__dotty_operator] = ACTIONS(2931),
    [sym__comparison_operator] = ACTIONS(2931),
    [sym__arrow_operator] = ACTIONS(2931),
    [sym__assign_operator] = ACTIONS(2931),
    [anon_sym_LF] = ACTIONS(2933),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2933),
    [sym__command_start] = ACTIONS(2933),
  },
  [947] = {
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_function] = ACTIONS(2935),
    [anon_sym_end] = ACTIONS(2935),
    [anon_sym_abstract] = ACTIONS(2935),
    [anon_sym_primitive] = ACTIONS(2935),
    [aux_sym_primitive_definition_token1] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_macro] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_EQ] = ACTIONS(2935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_elseif] = ACTIONS(2935),
    [anon_sym_else] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_catch] = ACTIONS(2935),
    [anon_sym_finally] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [sym_break_statement] = ACTIONS(2935),
    [sym_continue_statement] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_quote] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_import] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2935),
    [anon_sym_DOLLAR] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(2935),
    [aux_sym_integer_literal_token1] = ACTIONS(2935),
    [aux_sym_integer_literal_token2] = ACTIONS(2935),
    [aux_sym_integer_literal_token3] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2935),
    [sym__unary_operator] = ACTIONS(2935),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2935),
    [anon_sym_LF] = ACTIONS(2937),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2937),
    [sym__command_start] = ACTIONS(2937),
  },
  [948] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_end] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_primitive] = ACTIONS(2686),
    [aux_sym_primitive_definition_token1] = ACTIONS(2686),
    [anon_sym_mutable] = ACTIONS(2686),
    [anon_sym_struct] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_macro] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2688),
    [anon_sym_COMMA] = ACTIONS(2688),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_EQ] = ACTIONS(2686),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2688),
    [anon_sym_COLON_COLON] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_LT_COLON] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [sym_break_statement] = ACTIONS(2686),
    [sym_continue_statement] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_quote] = ACTIONS(2686),
    [anon_sym_using] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_DOT] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_COLON2] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_RBRACK] = ACTIONS(2688),
    [anon_sym_begin] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_LT_PIPE] = ACTIONS(2688),
    [anon_sym_PIPE_GT] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2686),
    [anon_sym_isa] = ACTIONS(2686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_QMARK] = ACTIONS(2688),
    [anon_sym_EQ_GT] = ACTIONS(2688),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2688),
    [aux_sym_integer_literal_token1] = ACTIONS(2688),
    [aux_sym_integer_literal_token2] = ACTIONS(2688),
    [aux_sym_integer_literal_token3] = ACTIONS(2686),
    [sym_float_literal] = ACTIONS(2686),
    [sym__unary_operator] = ACTIONS(2686),
    [sym__power_operator] = ACTIONS(2686),
    [sym__bitshift_operator] = ACTIONS(2686),
    [sym__rational_operator] = ACTIONS(2686),
    [sym__times_operator] = ACTIONS(2686),
    [sym__plus_operator] = ACTIONS(2686),
    [sym__dotty_operator] = ACTIONS(2686),
    [sym__comparison_operator] = ACTIONS(2686),
    [sym__arrow_operator] = ACTIONS(2688),
    [sym__assign_operator] = ACTIONS(2686),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2688),
    [sym__string_start] = ACTIONS(2688),
    [sym__command_start] = ACTIONS(2688),
  },
  [949] = {
    [sym_identifier] = ACTIONS(2939),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_end] = ACTIONS(2939),
    [anon_sym_abstract] = ACTIONS(2939),
    [anon_sym_primitive] = ACTIONS(2939),
    [aux_sym_primitive_definition_token1] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_module] = ACTIONS(2939),
    [anon_sym_macro] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_COMMA] = ACTIONS(2939),
    [anon_sym_RPAREN] = ACTIONS(2939),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_EQ] = ACTIONS(2939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2939),
    [anon_sym_COLON_COLON] = ACTIONS(2939),
    [anon_sym_LT_COLON] = ACTIONS(2939),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_elseif] = ACTIONS(2939),
    [anon_sym_else] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_catch] = ACTIONS(2939),
    [anon_sym_finally] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [sym_break_statement] = ACTIONS(2939),
    [sym_continue_statement] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_let] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_quote] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_import] = ACTIONS(2939),
    [anon_sym_export] = ACTIONS(2939),
    [anon_sym_COLON2] = ACTIONS(2939),
    [anon_sym_begin] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_LT_PIPE] = ACTIONS(2939),
    [anon_sym_PIPE_GT] = ACTIONS(2939),
    [anon_sym_in] = ACTIONS(2939),
    [anon_sym_isa] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_QMARK] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(2939),
    [anon_sym_LBRACK2] = ACTIONS(2939),
    [anon_sym_DOLLAR] = ACTIONS(2939),
    [anon_sym_AT] = ACTIONS(2939),
    [aux_sym_integer_literal_token1] = ACTIONS(2939),
    [aux_sym_integer_literal_token2] = ACTIONS(2939),
    [aux_sym_integer_literal_token3] = ACTIONS(2939),
    [sym_float_literal] = ACTIONS(2939),
    [sym__unary_operator] = ACTIONS(2939),
    [sym__power_operator] = ACTIONS(2939),
    [sym__bitshift_operator] = ACTIONS(2939),
    [sym__rational_operator] = ACTIONS(2939),
    [sym__times_operator] = ACTIONS(2939),
    [sym__plus_operator] = ACTIONS(2939),
    [sym__dotty_operator] = ACTIONS(2939),
    [sym__comparison_operator] = ACTIONS(2939),
    [sym__arrow_operator] = ACTIONS(2939),
    [sym__assign_operator] = ACTIONS(2939),
    [anon_sym_LF] = ACTIONS(2941),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2941),
    [sym__command_start] = ACTIONS(2941),
  },
  [950] = {
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_function] = ACTIONS(2943),
    [anon_sym_end] = ACTIONS(2943),
    [anon_sym_abstract] = ACTIONS(2943),
    [anon_sym_primitive] = ACTIONS(2943),
    [aux_sym_primitive_definition_token1] = ACTIONS(2943),
    [anon_sym_mutable] = ACTIONS(2943),
    [anon_sym_struct] = ACTIONS(2943),
    [anon_sym_module] = ACTIONS(2943),
    [anon_sym_macro] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_COMMA] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_EQ] = ACTIONS(2943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2943),
    [anon_sym_COLON_COLON] = ACTIONS(2943),
    [anon_sym_LT_COLON] = ACTIONS(2943),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_elseif] = ACTIONS(2943),
    [anon_sym_else] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_catch] = ACTIONS(2943),
    [anon_sym_finally] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [sym_break_statement] = ACTIONS(2943),
    [sym_continue_statement] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_let] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_quote] = ACTIONS(2943),
    [anon_sym_using] = ACTIONS(2943),
    [anon_sym_import] = ACTIONS(2943),
    [anon_sym_export] = ACTIONS(2943),
    [anon_sym_COLON2] = ACTIONS(2943),
    [anon_sym_begin] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_LT_PIPE] = ACTIONS(2943),
    [anon_sym_PIPE_GT] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2943),
    [anon_sym_isa] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_QMARK] = ACTIONS(2943),
    [anon_sym_EQ_GT] = ACTIONS(2943),
    [anon_sym_LBRACK2] = ACTIONS(2943),
    [anon_sym_DOLLAR] = ACTIONS(2943),
    [anon_sym_AT] = ACTIONS(2943),
    [aux_sym_integer_literal_token1] = ACTIONS(2943),
    [aux_sym_integer_literal_token2] = ACTIONS(2943),
    [aux_sym_integer_literal_token3] = ACTIONS(2943),
    [sym_float_literal] = ACTIONS(2943),
    [sym__unary_operator] = ACTIONS(2943),
    [sym__power_operator] = ACTIONS(2943),
    [sym__bitshift_operator] = ACTIONS(2943),
    [sym__rational_operator] = ACTIONS(2943),
    [sym__times_operator] = ACTIONS(2943),
    [sym__plus_operator] = ACTIONS(2943),
    [sym__dotty_operator] = ACTIONS(2943),
    [sym__comparison_operator] = ACTIONS(2943),
    [sym__arrow_operator] = ACTIONS(2943),
    [sym__assign_operator] = ACTIONS(2943),
    [anon_sym_LF] = ACTIONS(2945),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2945),
    [sym__command_start] = ACTIONS(2945),
  },
  [951] = {
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_end] = ACTIONS(2947),
    [anon_sym_abstract] = ACTIONS(2947),
    [anon_sym_primitive] = ACTIONS(2947),
    [aux_sym_primitive_definition_token1] = ACTIONS(2947),
    [anon_sym_mutable] = ACTIONS(2947),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_module] = ACTIONS(2947),
    [anon_sym_macro] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_COLON_COLON] = ACTIONS(2947),
    [anon_sym_LT_COLON] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_elseif] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_catch] = ACTIONS(2947),
    [anon_sym_finally] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [sym_break_statement] = ACTIONS(2947),
    [sym_continue_statement] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_let] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_quote] = ACTIONS(2947),
    [anon_sym_using] = ACTIONS(2947),
    [anon_sym_import] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2947),
    [anon_sym_begin] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_LT_PIPE] = ACTIONS(2947),
    [anon_sym_PIPE_GT] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_isa] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK2] = ACTIONS(2947),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2947),
    [aux_sym_integer_literal_token1] = ACTIONS(2947),
    [aux_sym_integer_literal_token2] = ACTIONS(2947),
    [aux_sym_integer_literal_token3] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2947),
    [sym__unary_operator] = ACTIONS(2947),
    [sym__power_operator] = ACTIONS(2947),
    [sym__bitshift_operator] = ACTIONS(2947),
    [sym__rational_operator] = ACTIONS(2947),
    [sym__times_operator] = ACTIONS(2947),
    [sym__plus_operator] = ACTIONS(2947),
    [sym__dotty_operator] = ACTIONS(2947),
    [sym__comparison_operator] = ACTIONS(2947),
    [sym__arrow_operator] = ACTIONS(2947),
    [sym__assign_operator] = ACTIONS(2947),
    [anon_sym_LF] = ACTIONS(2949),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2949),
    [sym__command_start] = ACTIONS(2949),
  },
  [952] = {
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_end] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_primitive] = ACTIONS(2716),
    [aux_sym_primitive_definition_token1] = ACTIONS(2716),
    [anon_sym_mutable] = ACTIONS(2716),
    [anon_sym_struct] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_macro] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_COMMA] = ACTIONS(2718),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_EQ] = ACTIONS(2716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2718),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_LT_COLON] = ACTIONS(2718),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [sym_break_statement] = ACTIONS(2716),
    [sym_continue_statement] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_quote] = ACTIONS(2716),
    [anon_sym_using] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_DOT] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_COLON2] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_RBRACK] = ACTIONS(2718),
    [anon_sym_begin] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2718),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_LT_PIPE] = ACTIONS(2718),
    [anon_sym_PIPE_GT] = ACTIONS(2718),
    [anon_sym_in] = ACTIONS(2716),
    [anon_sym_isa] = ACTIONS(2716),
    [anon_sym_PIPE_PIPE] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(2718),
    [anon_sym_QMARK] = ACTIONS(2718),
    [anon_sym_EQ_GT] = ACTIONS(2718),
    [anon_sym_LBRACK2] = ACTIONS(2716),
    [anon_sym_DOLLAR] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2718),
    [aux_sym_integer_literal_token1] = ACTIONS(2718),
    [aux_sym_integer_literal_token2] = ACTIONS(2718),
    [aux_sym_integer_literal_token3] = ACTIONS(2716),
    [sym_float_literal] = ACTIONS(2716),
    [sym__unary_operator] = ACTIONS(2716),
    [sym__power_operator] = ACTIONS(2716),
    [sym__bitshift_operator] = ACTIONS(2716),
    [sym__rational_operator] = ACTIONS(2716),
    [sym__times_operator] = ACTIONS(2716),
    [sym__plus_operator] = ACTIONS(2716),
    [sym__dotty_operator] = ACTIONS(2716),
    [sym__comparison_operator] = ACTIONS(2716),
    [sym__arrow_operator] = ACTIONS(2718),
    [sym__assign_operator] = ACTIONS(2716),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2718),
    [sym__string_start] = ACTIONS(2718),
    [sym__command_start] = ACTIONS(2718),
  },
  [953] = {
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_primitive] = ACTIONS(2578),
    [aux_sym_primitive_definition_token1] = ACTIONS(2578),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_macro] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LT_COLON] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_elseif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_catch] = ACTIONS(2578),
    [anon_sym_finally] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [sym_break_statement] = ACTIONS(2578),
    [sym_continue_statement] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_quote] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_COLON2] = ACTIONS(2578),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_LT_PIPE] = ACTIONS(2578),
    [anon_sym_PIPE_GT] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_isa] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2578),
    [anon_sym_LBRACK2] = ACTIONS(2578),
    [anon_sym_DOLLAR] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2578),
    [aux_sym_integer_literal_token1] = ACTIONS(2578),
    [aux_sym_integer_literal_token2] = ACTIONS(2578),
    [aux_sym_integer_literal_token3] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
    [sym__unary_operator] = ACTIONS(2578),
    [sym__power_operator] = ACTIONS(2578),
    [sym__bitshift_operator] = ACTIONS(2578),
    [sym__rational_operator] = ACTIONS(2578),
    [sym__times_operator] = ACTIONS(2578),
    [sym__plus_operator] = ACTIONS(2578),
    [sym__dotty_operator] = ACTIONS(2578),
    [sym__comparison_operator] = ACTIONS(2578),
    [sym__arrow_operator] = ACTIONS(2578),
    [sym__assign_operator] = ACTIONS(2578),
    [anon_sym_LF] = ACTIONS(2580),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2580),
    [sym__command_start] = ACTIONS(2580),
  },
  [954] = {
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_function] = ACTIONS(2951),
    [anon_sym_end] = ACTIONS(2951),
    [anon_sym_abstract] = ACTIONS(2951),
    [anon_sym_primitive] = ACTIONS(2951),
    [aux_sym_primitive_definition_token1] = ACTIONS(2951),
    [anon_sym_mutable] = ACTIONS(2951),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_module] = ACTIONS(2951),
    [anon_sym_macro] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2951),
    [anon_sym_COLON_COLON] = ACTIONS(2951),
    [anon_sym_LT_COLON] = ACTIONS(2951),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_elseif] = ACTIONS(2951),
    [anon_sym_else] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_catch] = ACTIONS(2951),
    [anon_sym_finally] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [sym_break_statement] = ACTIONS(2951),
    [sym_continue_statement] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_let] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_quote] = ACTIONS(2951),
    [anon_sym_using] = ACTIONS(2951),
    [anon_sym_import] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2951),
    [anon_sym_COLON2] = ACTIONS(2951),
    [anon_sym_begin] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_LT_PIPE] = ACTIONS(2951),
    [anon_sym_PIPE_GT] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_isa] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2951),
    [anon_sym_EQ_GT] = ACTIONS(2951),
    [anon_sym_LBRACK2] = ACTIONS(2951),
    [anon_sym_DOLLAR] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2951),
    [aux_sym_integer_literal_token1] = ACTIONS(2951),
    [aux_sym_integer_literal_token2] = ACTIONS(2951),
    [aux_sym_integer_literal_token3] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2951),
    [sym__unary_operator] = ACTIONS(2951),
    [sym__power_operator] = ACTIONS(2951),
    [sym__bitshift_operator] = ACTIONS(2951),
    [sym__rational_operator] = ACTIONS(2951),
    [sym__times_operator] = ACTIONS(2951),
    [sym__plus_operator] = ACTIONS(2951),
    [sym__dotty_operator] = ACTIONS(2951),
    [sym__comparison_operator] = ACTIONS(2951),
    [sym__arrow_operator] = ACTIONS(2951),
    [sym__assign_operator] = ACTIONS(2951),
    [anon_sym_LF] = ACTIONS(2953),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2953),
    [sym__command_start] = ACTIONS(2953),
  },
  [955] = {
    [sym_identifier] = ACTIONS(2955),
    [anon_sym_function] = ACTIONS(2955),
    [anon_sym_end] = ACTIONS(2955),
    [anon_sym_abstract] = ACTIONS(2955),
    [anon_sym_primitive] = ACTIONS(2955),
    [aux_sym_primitive_definition_token1] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_module] = ACTIONS(2955),
    [anon_sym_macro] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_RPAREN] = ACTIONS(2955),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2955),
    [anon_sym_COLON_COLON] = ACTIONS(2955),
    [anon_sym_LT_COLON] = ACTIONS(2955),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_elseif] = ACTIONS(2955),
    [anon_sym_else] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_catch] = ACTIONS(2955),
    [anon_sym_finally] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [sym_break_statement] = ACTIONS(2955),
    [sym_continue_statement] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_let] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_quote] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_import] = ACTIONS(2955),
    [anon_sym_export] = ACTIONS(2955),
    [anon_sym_COLON2] = ACTIONS(2955),
    [anon_sym_begin] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_LT_PIPE] = ACTIONS(2955),
    [anon_sym_PIPE_GT] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2955),
    [anon_sym_isa] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2955),
    [anon_sym_EQ_GT] = ACTIONS(2955),
    [anon_sym_LBRACK2] = ACTIONS(2955),
    [anon_sym_DOLLAR] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(2955),
    [aux_sym_integer_literal_token1] = ACTIONS(2955),
    [aux_sym_integer_literal_token2] = ACTIONS(2955),
    [aux_sym_integer_literal_token3] = ACTIONS(2955),
    [sym_float_literal] = ACTIONS(2955),
    [sym__unary_operator] = ACTIONS(2955),
    [sym__power_operator] = ACTIONS(2955),
    [sym__bitshift_operator] = ACTIONS(2955),
    [sym__rational_operator] = ACTIONS(2955),
    [sym__times_operator] = ACTIONS(2955),
    [sym__plus_operator] = ACTIONS(2955),
    [sym__dotty_operator] = ACTIONS(2955),
    [sym__comparison_operator] = ACTIONS(2955),
    [sym__arrow_operator] = ACTIONS(2955),
    [sym__assign_operator] = ACTIONS(2955),
    [anon_sym_LF] = ACTIONS(2957),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2957),
    [sym__command_start] = ACTIONS(2957),
  },
  [956] = {
    [sym_identifier] = ACTIONS(2959),
    [anon_sym_function] = ACTIONS(2959),
    [anon_sym_end] = ACTIONS(2959),
    [anon_sym_abstract] = ACTIONS(2959),
    [anon_sym_primitive] = ACTIONS(2959),
    [aux_sym_primitive_definition_token1] = ACTIONS(2959),
    [anon_sym_mutable] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2959),
    [anon_sym_macro] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_EQ] = ACTIONS(2959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_COLON_COLON] = ACTIONS(2959),
    [anon_sym_LT_COLON] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_elseif] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2959),
    [anon_sym_try] = ACTIONS(2959),
    [anon_sym_catch] = ACTIONS(2959),
    [anon_sym_finally] = ACTIONS(2959),
    [anon_sym_for] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [sym_break_statement] = ACTIONS(2959),
    [sym_continue_statement] = ACTIONS(2959),
    [anon_sym_return] = ACTIONS(2959),
    [anon_sym_let] = ACTIONS(2959),
    [anon_sym_const] = ACTIONS(2959),
    [anon_sym_quote] = ACTIONS(2959),
    [anon_sym_using] = ACTIONS(2959),
    [anon_sym_import] = ACTIONS(2959),
    [anon_sym_export] = ACTIONS(2959),
    [anon_sym_COLON2] = ACTIONS(2959),
    [anon_sym_begin] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_LT_PIPE] = ACTIONS(2959),
    [anon_sym_PIPE_GT] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2959),
    [anon_sym_isa] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_LBRACK2] = ACTIONS(2959),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_AT] = ACTIONS(2959),
    [aux_sym_integer_literal_token1] = ACTIONS(2959),
    [aux_sym_integer_literal_token2] = ACTIONS(2959),
    [aux_sym_integer_literal_token3] = ACTIONS(2959),
    [sym_float_literal] = ACTIONS(2959),
    [sym__unary_operator] = ACTIONS(2959),
    [sym__power_operator] = ACTIONS(2959),
    [sym__bitshift_operator] = ACTIONS(2959),
    [sym__rational_operator] = ACTIONS(2959),
    [sym__times_operator] = ACTIONS(2959),
    [sym__plus_operator] = ACTIONS(2959),
    [sym__dotty_operator] = ACTIONS(2959),
    [sym__comparison_operator] = ACTIONS(2959),
    [sym__arrow_operator] = ACTIONS(2959),
    [sym__assign_operator] = ACTIONS(2959),
    [anon_sym_LF] = ACTIONS(2961),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2961),
    [sym__command_start] = ACTIONS(2961),
  },
  [957] = {
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_function] = ACTIONS(2963),
    [anon_sym_end] = ACTIONS(2963),
    [anon_sym_abstract] = ACTIONS(2963),
    [anon_sym_primitive] = ACTIONS(2963),
    [aux_sym_primitive_definition_token1] = ACTIONS(2963),
    [anon_sym_mutable] = ACTIONS(2963),
    [anon_sym_struct] = ACTIONS(2963),
    [anon_sym_module] = ACTIONS(2963),
    [anon_sym_macro] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_COLON_COLON] = ACTIONS(2963),
    [anon_sym_LT_COLON] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_elseif] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_try] = ACTIONS(2963),
    [anon_sym_catch] = ACTIONS(2963),
    [anon_sym_finally] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [sym_break_statement] = ACTIONS(2963),
    [sym_continue_statement] = ACTIONS(2963),
    [anon_sym_return] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_const] = ACTIONS(2963),
    [anon_sym_quote] = ACTIONS(2963),
    [anon_sym_using] = ACTIONS(2963),
    [anon_sym_import] = ACTIONS(2963),
    [anon_sym_export] = ACTIONS(2963),
    [anon_sym_COLON2] = ACTIONS(2963),
    [anon_sym_begin] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_LT_PIPE] = ACTIONS(2963),
    [anon_sym_PIPE_GT] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_isa] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_LBRACK2] = ACTIONS(2963),
    [anon_sym_DOLLAR] = ACTIONS(2963),
    [anon_sym_AT] = ACTIONS(2963),
    [aux_sym_integer_literal_token1] = ACTIONS(2963),
    [aux_sym_integer_literal_token2] = ACTIONS(2963),
    [aux_sym_integer_literal_token3] = ACTIONS(2963),
    [sym_float_literal] = ACTIONS(2963),
    [sym__unary_operator] = ACTIONS(2963),
    [sym__power_operator] = ACTIONS(2963),
    [sym__bitshift_operator] = ACTIONS(2963),
    [sym__rational_operator] = ACTIONS(2963),
    [sym__times_operator] = ACTIONS(2963),
    [sym__plus_operator] = ACTIONS(2963),
    [sym__dotty_operator] = ACTIONS(2963),
    [sym__comparison_operator] = ACTIONS(2963),
    [sym__arrow_operator] = ACTIONS(2963),
    [sym__assign_operator] = ACTIONS(2963),
    [anon_sym_LF] = ACTIONS(2965),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2965),
    [sym__command_start] = ACTIONS(2965),
  },
  [958] = {
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_primitive] = ACTIONS(2574),
    [aux_sym_primitive_definition_token1] = ACTIONS(2574),
    [anon_sym_mutable] = ACTIONS(2574),
    [anon_sym_struct] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_macro] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_RPAREN] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LT_COLON] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_elseif] = ACTIONS(2574),
    [anon_sym_else] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_catch] = ACTIONS(2574),
    [anon_sym_finally] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [sym_break_statement] = ACTIONS(2574),
    [sym_continue_statement] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_quote] = ACTIONS(2574),
    [anon_sym_using] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_COLON2] = ACTIONS(2574),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_LT_PIPE] = ACTIONS(2574),
    [anon_sym_PIPE_GT] = ACTIONS(2574),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_isa] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_QMARK] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(2574),
    [anon_sym_LBRACK2] = ACTIONS(2574),
    [anon_sym_DOLLAR] = ACTIONS(2574),
    [anon_sym_AT] = ACTIONS(2574),
    [aux_sym_integer_literal_token1] = ACTIONS(2574),
    [aux_sym_integer_literal_token2] = ACTIONS(2574),
    [aux_sym_integer_literal_token3] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
    [sym__unary_operator] = ACTIONS(2574),
    [sym__power_operator] = ACTIONS(2574),
    [sym__bitshift_operator] = ACTIONS(2574),
    [sym__rational_operator] = ACTIONS(2574),
    [sym__times_operator] = ACTIONS(2574),
    [sym__plus_operator] = ACTIONS(2574),
    [sym__dotty_operator] = ACTIONS(2574),
    [sym__comparison_operator] = ACTIONS(2574),
    [sym__arrow_operator] = ACTIONS(2574),
    [sym__assign_operator] = ACTIONS(2574),
    [anon_sym_LF] = ACTIONS(2576),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2576),
    [sym__command_start] = ACTIONS(2576),
  },
  [959] = {
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_function] = ACTIONS(2967),
    [anon_sym_end] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_primitive] = ACTIONS(2967),
    [aux_sym_primitive_definition_token1] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_module] = ACTIONS(2967),
    [anon_sym_macro] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_COLON_COLON] = ACTIONS(2967),
    [anon_sym_LT_COLON] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_elseif] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_catch] = ACTIONS(2967),
    [anon_sym_finally] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [sym_break_statement] = ACTIONS(2967),
    [sym_continue_statement] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_quote] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_import] = ACTIONS(2967),
    [anon_sym_export] = ACTIONS(2967),
    [anon_sym_COLON2] = ACTIONS(2967),
    [anon_sym_begin] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_LT_PIPE] = ACTIONS(2967),
    [anon_sym_PIPE_GT] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_isa] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_LBRACK2] = ACTIONS(2967),
    [anon_sym_DOLLAR] = ACTIONS(2967),
    [anon_sym_AT] = ACTIONS(2967),
    [aux_sym_integer_literal_token1] = ACTIONS(2967),
    [aux_sym_integer_literal_token2] = ACTIONS(2967),
    [aux_sym_integer_literal_token3] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym__unary_operator] = ACTIONS(2967),
    [sym__power_operator] = ACTIONS(2967),
    [sym__bitshift_operator] = ACTIONS(2967),
    [sym__rational_operator] = ACTIONS(2967),
    [sym__times_operator] = ACTIONS(2967),
    [sym__plus_operator] = ACTIONS(2967),
    [sym__dotty_operator] = ACTIONS(2967),
    [sym__comparison_operator] = ACTIONS(2967),
    [sym__arrow_operator] = ACTIONS(2967),
    [sym__assign_operator] = ACTIONS(2967),
    [anon_sym_LF] = ACTIONS(2969),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2969),
    [sym__command_start] = ACTIONS(2969),
  },
  [960] = {
    [sym_identifier] = ACTIONS(2971),
    [anon_sym_function] = ACTIONS(2971),
    [anon_sym_end] = ACTIONS(2971),
    [anon_sym_abstract] = ACTIONS(2971),
    [anon_sym_primitive] = ACTIONS(2971),
    [aux_sym_primitive_definition_token1] = ACTIONS(2971),
    [anon_sym_mutable] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_module] = ACTIONS(2971),
    [anon_sym_macro] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [anon_sym_COMMA] = ACTIONS(2971),
    [anon_sym_RPAREN] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2971),
    [anon_sym_EQ] = ACTIONS(2971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2971),
    [anon_sym_COLON_COLON] = ACTIONS(2971),
    [anon_sym_LT_COLON] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_elseif] = ACTIONS(2971),
    [anon_sym_else] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_catch] = ACTIONS(2971),
    [anon_sym_finally] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [sym_break_statement] = ACTIONS(2971),
    [sym_continue_statement] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_quote] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_import] = ACTIONS(2971),
    [anon_sym_export] = ACTIONS(2971),
    [anon_sym_COLON2] = ACTIONS(2971),
    [anon_sym_begin] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2971),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_LT_PIPE] = ACTIONS(2971),
    [anon_sym_PIPE_GT] = ACTIONS(2971),
    [anon_sym_in] = ACTIONS(2971),
    [anon_sym_isa] = ACTIONS(2971),
    [anon_sym_PIPE_PIPE] = ACTIONS(2971),
    [anon_sym_AMP_AMP] = ACTIONS(2971),
    [anon_sym_QMARK] = ACTIONS(2971),
    [anon_sym_EQ_GT] = ACTIONS(2971),
    [anon_sym_LBRACK2] = ACTIONS(2971),
    [anon_sym_DOLLAR] = ACTIONS(2971),
    [anon_sym_AT] = ACTIONS(2971),
    [aux_sym_integer_literal_token1] = ACTIONS(2971),
    [aux_sym_integer_literal_token2] = ACTIONS(2971),
    [aux_sym_integer_literal_token3] = ACTIONS(2971),
    [sym_float_literal] = ACTIONS(2971),
    [sym__unary_operator] = ACTIONS(2971),
    [sym__power_operator] = ACTIONS(2971),
    [sym__bitshift_operator] = ACTIONS(2971),
    [sym__rational_operator] = ACTIONS(2971),
    [sym__times_operator] = ACTIONS(2971),
    [sym__plus_operator] = ACTIONS(2971),
    [sym__dotty_operator] = ACTIONS(2971),
    [sym__comparison_operator] = ACTIONS(2971),
    [sym__arrow_operator] = ACTIONS(2971),
    [sym__assign_operator] = ACTIONS(2971),
    [anon_sym_LF] = ACTIONS(2973),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2973),
    [sym__command_start] = ACTIONS(2973),
  },
  [961] = {
    [sym_identifier] = ACTIONS(2975),
    [anon_sym_function] = ACTIONS(2975),
    [anon_sym_end] = ACTIONS(2975),
    [anon_sym_abstract] = ACTIONS(2975),
    [anon_sym_primitive] = ACTIONS(2975),
    [aux_sym_primitive_definition_token1] = ACTIONS(2975),
    [anon_sym_mutable] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_module] = ACTIONS(2975),
    [anon_sym_macro] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2975),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2975),
    [anon_sym_COLON_COLON] = ACTIONS(2975),
    [anon_sym_LT_COLON] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_elseif] = ACTIONS(2975),
    [anon_sym_else] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_catch] = ACTIONS(2975),
    [anon_sym_finally] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [sym_break_statement] = ACTIONS(2975),
    [sym_continue_statement] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_let] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_quote] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_import] = ACTIONS(2975),
    [anon_sym_export] = ACTIONS(2975),
    [anon_sym_COLON2] = ACTIONS(2975),
    [anon_sym_begin] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_LT_PIPE] = ACTIONS(2975),
    [anon_sym_PIPE_GT] = ACTIONS(2975),
    [anon_sym_in] = ACTIONS(2975),
    [anon_sym_isa] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_QMARK] = ACTIONS(2975),
    [anon_sym_EQ_GT] = ACTIONS(2975),
    [anon_sym_LBRACK2] = ACTIONS(2975),
    [anon_sym_DOLLAR] = ACTIONS(2975),
    [anon_sym_AT] = ACTIONS(2975),
    [aux_sym_integer_literal_token1] = ACTIONS(2975),
    [aux_sym_integer_literal_token2] = ACTIONS(2975),
    [aux_sym_integer_literal_token3] = ACTIONS(2975),
    [sym_float_literal] = ACTIONS(2975),
    [sym__unary_operator] = ACTIONS(2975),
    [sym__power_operator] = ACTIONS(2975),
    [sym__bitshift_operator] = ACTIONS(2975),
    [sym__rational_operator] = ACTIONS(2975),
    [sym__times_operator] = ACTIONS(2975),
    [sym__plus_operator] = ACTIONS(2975),
    [sym__dotty_operator] = ACTIONS(2975),
    [sym__comparison_operator] = ACTIONS(2975),
    [sym__arrow_operator] = ACTIONS(2975),
    [sym__assign_operator] = ACTIONS(2975),
    [anon_sym_LF] = ACTIONS(2977),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2977),
    [sym__command_start] = ACTIONS(2977),
  },
  [962] = {
    [sym_identifier] = ACTIONS(2979),
    [anon_sym_function] = ACTIONS(2979),
    [anon_sym_end] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2979),
    [anon_sym_primitive] = ACTIONS(2979),
    [aux_sym_primitive_definition_token1] = ACTIONS(2979),
    [anon_sym_mutable] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_module] = ACTIONS(2979),
    [anon_sym_macro] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_EQ] = ACTIONS(2979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2979),
    [anon_sym_COLON_COLON] = ACTIONS(2979),
    [anon_sym_LT_COLON] = ACTIONS(2979),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_elseif] = ACTIONS(2979),
    [anon_sym_else] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_catch] = ACTIONS(2979),
    [anon_sym_finally] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [sym_break_statement] = ACTIONS(2979),
    [sym_continue_statement] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_quote] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2979),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_COLON2] = ACTIONS(2979),
    [anon_sym_begin] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_LT_PIPE] = ACTIONS(2979),
    [anon_sym_PIPE_GT] = ACTIONS(2979),
    [anon_sym_in] = ACTIONS(2979),
    [anon_sym_isa] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_QMARK] = ACTIONS(2979),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_LBRACK2] = ACTIONS(2979),
    [anon_sym_DOLLAR] = ACTIONS(2979),
    [anon_sym_AT] = ACTIONS(2979),
    [aux_sym_integer_literal_token1] = ACTIONS(2979),
    [aux_sym_integer_literal_token2] = ACTIONS(2979),
    [aux_sym_integer_literal_token3] = ACTIONS(2979),
    [sym_float_literal] = ACTIONS(2979),
    [sym__unary_operator] = ACTIONS(2979),
    [sym__power_operator] = ACTIONS(2979),
    [sym__bitshift_operator] = ACTIONS(2979),
    [sym__rational_operator] = ACTIONS(2979),
    [sym__times_operator] = ACTIONS(2979),
    [sym__plus_operator] = ACTIONS(2979),
    [sym__dotty_operator] = ACTIONS(2979),
    [sym__comparison_operator] = ACTIONS(2979),
    [sym__arrow_operator] = ACTIONS(2979),
    [sym__assign_operator] = ACTIONS(2979),
    [anon_sym_LF] = ACTIONS(2981),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2981),
    [sym__command_start] = ACTIONS(2981),
  },
  [963] = {
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_primitive] = ACTIONS(2570),
    [aux_sym_primitive_definition_token1] = ACTIONS(2570),
    [anon_sym_mutable] = ACTIONS(2570),
    [anon_sym_struct] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_macro] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2570),
    [anon_sym_RPAREN] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LT_COLON] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_elseif] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_catch] = ACTIONS(2570),
    [anon_sym_finally] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [sym_break_statement] = ACTIONS(2570),
    [sym_continue_statement] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_quote] = ACTIONS(2570),
    [anon_sym_using] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_COLON2] = ACTIONS(2570),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_LT_PIPE] = ACTIONS(2570),
    [anon_sym_PIPE_GT] = ACTIONS(2570),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_isa] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_EQ_GT] = ACTIONS(2570),
    [anon_sym_LBRACK2] = ACTIONS(2570),
    [anon_sym_DOLLAR] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(2570),
    [aux_sym_integer_literal_token1] = ACTIONS(2570),
    [aux_sym_integer_literal_token2] = ACTIONS(2570),
    [aux_sym_integer_literal_token3] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
    [sym__unary_operator] = ACTIONS(2570),
    [sym__power_operator] = ACTIONS(2570),
    [sym__bitshift_operator] = ACTIONS(2570),
    [sym__rational_operator] = ACTIONS(2570),
    [sym__times_operator] = ACTIONS(2570),
    [sym__plus_operator] = ACTIONS(2570),
    [sym__dotty_operator] = ACTIONS(2570),
    [sym__comparison_operator] = ACTIONS(2570),
    [sym__arrow_operator] = ACTIONS(2570),
    [sym__assign_operator] = ACTIONS(2570),
    [anon_sym_LF] = ACTIONS(2572),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2572),
    [sym__command_start] = ACTIONS(2572),
  },
  [964] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_primitive] = ACTIONS(2566),
    [aux_sym_primitive_definition_token1] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_macro] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LT_COLON] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_elseif] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_catch] = ACTIONS(2566),
    [anon_sym_finally] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [sym_break_statement] = ACTIONS(2566),
    [sym_continue_statement] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_quote] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_COLON2] = ACTIONS(2566),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_LT_PIPE] = ACTIONS(2566),
    [anon_sym_PIPE_GT] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_isa] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2566),
    [anon_sym_LBRACK2] = ACTIONS(2566),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2566),
    [aux_sym_integer_literal_token1] = ACTIONS(2566),
    [aux_sym_integer_literal_token2] = ACTIONS(2566),
    [aux_sym_integer_literal_token3] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
    [sym__unary_operator] = ACTIONS(2566),
    [sym__power_operator] = ACTIONS(2566),
    [sym__bitshift_operator] = ACTIONS(2566),
    [sym__rational_operator] = ACTIONS(2566),
    [sym__times_operator] = ACTIONS(2566),
    [sym__plus_operator] = ACTIONS(2566),
    [sym__dotty_operator] = ACTIONS(2566),
    [sym__comparison_operator] = ACTIONS(2566),
    [sym__arrow_operator] = ACTIONS(2566),
    [sym__assign_operator] = ACTIONS(2566),
    [anon_sym_LF] = ACTIONS(2568),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2568),
    [sym__command_start] = ACTIONS(2568),
  },
  [965] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_end] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_primitive] = ACTIONS(2558),
    [aux_sym_primitive_definition_token1] = ACTIONS(2558),
    [anon_sym_mutable] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_macro] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_COMMA] = ACTIONS(2558),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym_EQ] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2558),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LT_COLON] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_elseif] = ACTIONS(2558),
    [anon_sym_else] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_catch] = ACTIONS(2558),
    [anon_sym_finally] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [sym_break_statement] = ACTIONS(2558),
    [sym_continue_statement] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_quote] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_COLON2] = ACTIONS(2558),
    [anon_sym_begin] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_LT_PIPE] = ACTIONS(2558),
    [anon_sym_PIPE_GT] = ACTIONS(2558),
    [anon_sym_in] = ACTIONS(2558),
    [anon_sym_isa] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_QMARK] = ACTIONS(2558),
    [anon_sym_EQ_GT] = ACTIONS(2558),
    [anon_sym_LBRACK2] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2558),
    [aux_sym_integer_literal_token1] = ACTIONS(2558),
    [aux_sym_integer_literal_token2] = ACTIONS(2558),
    [aux_sym_integer_literal_token3] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
    [sym__unary_operator] = ACTIONS(2558),
    [sym__power_operator] = ACTIONS(2558),
    [sym__bitshift_operator] = ACTIONS(2558),
    [sym__rational_operator] = ACTIONS(2558),
    [sym__times_operator] = ACTIONS(2558),
    [sym__plus_operator] = ACTIONS(2558),
    [sym__dotty_operator] = ACTIONS(2558),
    [sym__comparison_operator] = ACTIONS(2558),
    [sym__arrow_operator] = ACTIONS(2558),
    [sym__assign_operator] = ACTIONS(2558),
    [anon_sym_LF] = ACTIONS(2560),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2560),
    [sym__command_start] = ACTIONS(2560),
  },
  [966] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_end] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_primitive] = ACTIONS(2550),
    [aux_sym_primitive_definition_token1] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_macro] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_COMMA] = ACTIONS(2550),
    [anon_sym_RPAREN] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_EQ] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LT_COLON] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_elseif] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_catch] = ACTIONS(2550),
    [anon_sym_finally] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_break_statement] = ACTIONS(2550),
    [sym_continue_statement] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_quote] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_COLON2] = ACTIONS(2550),
    [anon_sym_begin] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_LT_PIPE] = ACTIONS(2550),
    [anon_sym_PIPE_GT] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_isa] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_QMARK] = ACTIONS(2550),
    [anon_sym_EQ_GT] = ACTIONS(2550),
    [anon_sym_LBRACK2] = ACTIONS(2550),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_AT] = ACTIONS(2550),
    [aux_sym_integer_literal_token1] = ACTIONS(2550),
    [aux_sym_integer_literal_token2] = ACTIONS(2550),
    [aux_sym_integer_literal_token3] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
    [sym__unary_operator] = ACTIONS(2550),
    [sym__power_operator] = ACTIONS(2550),
    [sym__bitshift_operator] = ACTIONS(2550),
    [sym__rational_operator] = ACTIONS(2550),
    [sym__times_operator] = ACTIONS(2550),
    [sym__plus_operator] = ACTIONS(2550),
    [sym__dotty_operator] = ACTIONS(2550),
    [sym__comparison_operator] = ACTIONS(2550),
    [sym__arrow_operator] = ACTIONS(2550),
    [sym__assign_operator] = ACTIONS(2550),
    [anon_sym_LF] = ACTIONS(2552),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2552),
    [sym__command_start] = ACTIONS(2552),
  },
  [967] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_end] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_primitive] = ACTIONS(2546),
    [aux_sym_primitive_definition_token1] = ACTIONS(2546),
    [anon_sym_mutable] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_macro] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_COMMA] = ACTIONS(2546),
    [anon_sym_RPAREN] = ACTIONS(2546),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_EQ] = ACTIONS(2546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LT_COLON] = ACTIONS(2546),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_elseif] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_catch] = ACTIONS(2546),
    [anon_sym_finally] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [sym_break_statement] = ACTIONS(2546),
    [sym_continue_statement] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_quote] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_COLON2] = ACTIONS(2546),
    [anon_sym_begin] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_LT_PIPE] = ACTIONS(2546),
    [anon_sym_PIPE_GT] = ACTIONS(2546),
    [anon_sym_in] = ACTIONS(2546),
    [anon_sym_isa] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_QMARK] = ACTIONS(2546),
    [anon_sym_EQ_GT] = ACTIONS(2546),
    [anon_sym_LBRACK2] = ACTIONS(2546),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2546),
    [aux_sym_integer_literal_token1] = ACTIONS(2546),
    [aux_sym_integer_literal_token2] = ACTIONS(2546),
    [aux_sym_integer_literal_token3] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
    [sym__unary_operator] = ACTIONS(2546),
    [sym__power_operator] = ACTIONS(2546),
    [sym__bitshift_operator] = ACTIONS(2546),
    [sym__rational_operator] = ACTIONS(2546),
    [sym__times_operator] = ACTIONS(2546),
    [sym__plus_operator] = ACTIONS(2546),
    [sym__dotty_operator] = ACTIONS(2546),
    [sym__comparison_operator] = ACTIONS(2546),
    [sym__arrow_operator] = ACTIONS(2546),
    [sym__assign_operator] = ACTIONS(2546),
    [anon_sym_LF] = ACTIONS(2548),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2548),
    [sym__command_start] = ACTIONS(2548),
  },
  [968] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_primitive] = ACTIONS(2494),
    [aux_sym_primitive_definition_token1] = ACTIONS(2494),
    [anon_sym_mutable] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_macro] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2494),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LT_COLON] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_elseif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_catch] = ACTIONS(2494),
    [anon_sym_finally] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [sym_break_statement] = ACTIONS(2494),
    [sym_continue_statement] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_quote] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_COLON2] = ACTIONS(2494),
    [anon_sym_begin] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_LT_PIPE] = ACTIONS(2494),
    [anon_sym_PIPE_GT] = ACTIONS(2494),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_isa] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_QMARK] = ACTIONS(2494),
    [anon_sym_EQ_GT] = ACTIONS(2494),
    [anon_sym_LBRACK2] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2494),
    [aux_sym_integer_literal_token1] = ACTIONS(2494),
    [aux_sym_integer_literal_token2] = ACTIONS(2494),
    [aux_sym_integer_literal_token3] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
    [sym__unary_operator] = ACTIONS(2494),
    [sym__power_operator] = ACTIONS(2494),
    [sym__bitshift_operator] = ACTIONS(2494),
    [sym__rational_operator] = ACTIONS(2494),
    [sym__times_operator] = ACTIONS(2494),
    [sym__plus_operator] = ACTIONS(2494),
    [sym__dotty_operator] = ACTIONS(2494),
    [sym__comparison_operator] = ACTIONS(2494),
    [sym__arrow_operator] = ACTIONS(2494),
    [sym__assign_operator] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2496),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2496),
    [sym__command_start] = ACTIONS(2496),
  },
  [969] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_end] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_primitive] = ACTIONS(2538),
    [aux_sym_primitive_definition_token1] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_macro] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2538),
    [anon_sym_COMMA] = ACTIONS(2538),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym_EQ] = ACTIONS(2538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2538),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LT_COLON] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_elseif] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_catch] = ACTIONS(2538),
    [anon_sym_finally] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [sym_break_statement] = ACTIONS(2538),
    [sym_continue_statement] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_quote] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_COLON2] = ACTIONS(2538),
    [anon_sym_begin] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_LT_PIPE] = ACTIONS(2538),
    [anon_sym_PIPE_GT] = ACTIONS(2538),
    [anon_sym_in] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_EQ_GT] = ACTIONS(2538),
    [anon_sym_LBRACK2] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2538),
    [aux_sym_integer_literal_token1] = ACTIONS(2538),
    [aux_sym_integer_literal_token2] = ACTIONS(2538),
    [aux_sym_integer_literal_token3] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
    [sym__unary_operator] = ACTIONS(2538),
    [sym__power_operator] = ACTIONS(2538),
    [sym__bitshift_operator] = ACTIONS(2538),
    [sym__rational_operator] = ACTIONS(2538),
    [sym__times_operator] = ACTIONS(2538),
    [sym__plus_operator] = ACTIONS(2538),
    [sym__dotty_operator] = ACTIONS(2538),
    [sym__comparison_operator] = ACTIONS(2538),
    [sym__arrow_operator] = ACTIONS(2538),
    [sym__assign_operator] = ACTIONS(2538),
    [anon_sym_LF] = ACTIONS(2540),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2540),
    [sym__command_start] = ACTIONS(2540),
  },
  [970] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_end] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_primitive] = ACTIONS(2530),
    [aux_sym_primitive_definition_token1] = ACTIONS(2530),
    [anon_sym_mutable] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_macro] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_COMMA] = ACTIONS(2530),
    [anon_sym_RPAREN] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_EQ] = ACTIONS(2530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2530),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LT_COLON] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_elseif] = ACTIONS(2530),
    [anon_sym_else] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_catch] = ACTIONS(2530),
    [anon_sym_finally] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [sym_break_statement] = ACTIONS(2530),
    [sym_continue_statement] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_quote] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_COLON2] = ACTIONS(2530),
    [anon_sym_begin] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_LT_PIPE] = ACTIONS(2530),
    [anon_sym_PIPE_GT] = ACTIONS(2530),
    [anon_sym_in] = ACTIONS(2530),
    [anon_sym_isa] = ACTIONS(2530),
    [anon_sym_PIPE_PIPE] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_QMARK] = ACTIONS(2530),
    [anon_sym_EQ_GT] = ACTIONS(2530),
    [anon_sym_LBRACK2] = ACTIONS(2530),
    [anon_sym_DOLLAR] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2530),
    [aux_sym_integer_literal_token1] = ACTIONS(2530),
    [aux_sym_integer_literal_token2] = ACTIONS(2530),
    [aux_sym_integer_literal_token3] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
    [sym__unary_operator] = ACTIONS(2530),
    [sym__power_operator] = ACTIONS(2530),
    [sym__bitshift_operator] = ACTIONS(2530),
    [sym__rational_operator] = ACTIONS(2530),
    [sym__times_operator] = ACTIONS(2530),
    [sym__plus_operator] = ACTIONS(2530),
    [sym__dotty_operator] = ACTIONS(2530),
    [sym__comparison_operator] = ACTIONS(2530),
    [sym__arrow_operator] = ACTIONS(2530),
    [sym__assign_operator] = ACTIONS(2530),
    [anon_sym_LF] = ACTIONS(2532),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2532),
    [sym__command_start] = ACTIONS(2532),
  },
  [971] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [972] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2983),
    [anon_sym_PIPE_GT] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [973] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2983),
    [anon_sym_PIPE_GT] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [974] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2983),
    [anon_sym_PIPE_GT] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2983),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [975] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2983),
    [anon_sym_PIPE_GT] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2983),
    [sym__rational_operator] = ACTIONS(2983),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [976] = {
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2762),
    [anon_sym_end] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_primitive] = ACTIONS(2762),
    [aux_sym_primitive_definition_token1] = ACTIONS(2762),
    [anon_sym_mutable] = ACTIONS(2762),
    [anon_sym_struct] = ACTIONS(2762),
    [anon_sym_module] = ACTIONS(2762),
    [anon_sym_macro] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_RPAREN] = ACTIONS(2762),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2762),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LT_COLON] = ACTIONS(2762),
    [anon_sym_if] = ACTIONS(2762),
    [anon_sym_elseif] = ACTIONS(2762),
    [anon_sym_else] = ACTIONS(2762),
    [anon_sym_try] = ACTIONS(2762),
    [anon_sym_catch] = ACTIONS(2762),
    [anon_sym_finally] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2762),
    [anon_sym_while] = ACTIONS(2762),
    [sym_break_statement] = ACTIONS(2762),
    [sym_continue_statement] = ACTIONS(2762),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2762),
    [anon_sym_quote] = ACTIONS(2762),
    [anon_sym_using] = ACTIONS(2762),
    [anon_sym_import] = ACTIONS(2762),
    [anon_sym_export] = ACTIONS(2762),
    [anon_sym_COLON2] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_LT_PIPE] = ACTIONS(2762),
    [anon_sym_PIPE_GT] = ACTIONS(2762),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_isa] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2762),
    [anon_sym_AMP_AMP] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_EQ_GT] = ACTIONS(2762),
    [anon_sym_LBRACK2] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2762),
    [aux_sym_integer_literal_token1] = ACTIONS(2762),
    [aux_sym_integer_literal_token2] = ACTIONS(2762),
    [aux_sym_integer_literal_token3] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
    [sym__unary_operator] = ACTIONS(2762),
    [sym__power_operator] = ACTIONS(2762),
    [sym__bitshift_operator] = ACTIONS(2762),
    [sym__rational_operator] = ACTIONS(2762),
    [sym__times_operator] = ACTIONS(2762),
    [sym__plus_operator] = ACTIONS(2762),
    [sym__dotty_operator] = ACTIONS(2762),
    [sym__comparison_operator] = ACTIONS(2762),
    [sym__arrow_operator] = ACTIONS(2762),
    [sym__assign_operator] = ACTIONS(2762),
    [anon_sym_LF] = ACTIONS(2764),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2764),
    [sym__command_start] = ACTIONS(2764),
  },
  [977] = {
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_end] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_primitive] = ACTIONS(2592),
    [aux_sym_primitive_definition_token1] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_macro] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_RPAREN] = ACTIONS(2594),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_EQ] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2594),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_LT_COLON] = ACTIONS(2594),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [sym_break_statement] = ACTIONS(2592),
    [sym_continue_statement] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_quote] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_COLON2] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_RBRACK] = ACTIONS(2594),
    [anon_sym_begin] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_LT_PIPE] = ACTIONS(2594),
    [anon_sym_PIPE_GT] = ACTIONS(2594),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_isa] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_EQ_GT] = ACTIONS(2594),
    [anon_sym_LBRACK2] = ACTIONS(2592),
    [anon_sym_DOLLAR] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(2594),
    [aux_sym_integer_literal_token1] = ACTIONS(2594),
    [aux_sym_integer_literal_token2] = ACTIONS(2594),
    [aux_sym_integer_literal_token3] = ACTIONS(2592),
    [sym_float_literal] = ACTIONS(2592),
    [sym__unary_operator] = ACTIONS(2592),
    [sym__power_operator] = ACTIONS(2592),
    [sym__bitshift_operator] = ACTIONS(2592),
    [sym__rational_operator] = ACTIONS(2592),
    [sym__times_operator] = ACTIONS(2592),
    [sym__plus_operator] = ACTIONS(2592),
    [sym__dotty_operator] = ACTIONS(2592),
    [sym__comparison_operator] = ACTIONS(2592),
    [sym__arrow_operator] = ACTIONS(2594),
    [sym__assign_operator] = ACTIONS(2592),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2594),
    [sym__string_start] = ACTIONS(2594),
    [sym__command_start] = ACTIONS(2594),
  },
  [978] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_end] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_primitive] = ACTIONS(2678),
    [aux_sym_primitive_definition_token1] = ACTIONS(2678),
    [anon_sym_mutable] = ACTIONS(2678),
    [anon_sym_struct] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_macro] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_COMMA] = ACTIONS(2680),
    [anon_sym_RPAREN] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_EQ] = ACTIONS(2678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2680),
    [anon_sym_COLON_COLON] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_LT_COLON] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [sym_break_statement] = ACTIONS(2678),
    [sym_continue_statement] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_quote] = ACTIONS(2678),
    [anon_sym_using] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_DOT] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_COLON2] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_RBRACK] = ACTIONS(2680),
    [anon_sym_begin] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_LT_PIPE] = ACTIONS(2680),
    [anon_sym_PIPE_GT] = ACTIONS(2680),
    [anon_sym_in] = ACTIONS(2678),
    [anon_sym_isa] = ACTIONS(2678),
    [anon_sym_PIPE_PIPE] = ACTIONS(2680),
    [anon_sym_AMP_AMP] = ACTIONS(2680),
    [anon_sym_QMARK] = ACTIONS(2680),
    [anon_sym_EQ_GT] = ACTIONS(2680),
    [anon_sym_LBRACK2] = ACTIONS(2678),
    [anon_sym_DOLLAR] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2680),
    [aux_sym_integer_literal_token1] = ACTIONS(2680),
    [aux_sym_integer_literal_token2] = ACTIONS(2680),
    [aux_sym_integer_literal_token3] = ACTIONS(2678),
    [sym_float_literal] = ACTIONS(2678),
    [sym__unary_operator] = ACTIONS(2678),
    [sym__power_operator] = ACTIONS(2678),
    [sym__bitshift_operator] = ACTIONS(2678),
    [sym__rational_operator] = ACTIONS(2678),
    [sym__times_operator] = ACTIONS(2678),
    [sym__plus_operator] = ACTIONS(2678),
    [sym__dotty_operator] = ACTIONS(2678),
    [sym__comparison_operator] = ACTIONS(2678),
    [sym__arrow_operator] = ACTIONS(2680),
    [sym__assign_operator] = ACTIONS(2678),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2680),
    [sym__string_start] = ACTIONS(2680),
    [sym__command_start] = ACTIONS(2680),
  },
  [979] = {
    [sym_identifier] = ACTIONS(2987),
    [anon_sym_function] = ACTIONS(2987),
    [anon_sym_end] = ACTIONS(2987),
    [anon_sym_abstract] = ACTIONS(2987),
    [anon_sym_primitive] = ACTIONS(2987),
    [aux_sym_primitive_definition_token1] = ACTIONS(2987),
    [anon_sym_mutable] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2987),
    [anon_sym_module] = ACTIONS(2987),
    [anon_sym_macro] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2987),
    [anon_sym_COMMA] = ACTIONS(2987),
    [anon_sym_RPAREN] = ACTIONS(2987),
    [anon_sym_SEMI] = ACTIONS(2987),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2987),
    [anon_sym_COLON_COLON] = ACTIONS(2987),
    [anon_sym_LT_COLON] = ACTIONS(2987),
    [anon_sym_if] = ACTIONS(2987),
    [anon_sym_elseif] = ACTIONS(2987),
    [anon_sym_else] = ACTIONS(2987),
    [anon_sym_try] = ACTIONS(2987),
    [anon_sym_catch] = ACTIONS(2987),
    [anon_sym_finally] = ACTIONS(2987),
    [anon_sym_for] = ACTIONS(2987),
    [anon_sym_while] = ACTIONS(2987),
    [sym_break_statement] = ACTIONS(2987),
    [sym_continue_statement] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_const] = ACTIONS(2987),
    [anon_sym_quote] = ACTIONS(2987),
    [anon_sym_using] = ACTIONS(2987),
    [anon_sym_import] = ACTIONS(2987),
    [anon_sym_export] = ACTIONS(2987),
    [anon_sym_COLON2] = ACTIONS(2987),
    [anon_sym_begin] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2987),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_LT_PIPE] = ACTIONS(2987),
    [anon_sym_PIPE_GT] = ACTIONS(2987),
    [anon_sym_in] = ACTIONS(2987),
    [anon_sym_isa] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2987),
    [anon_sym_AMP_AMP] = ACTIONS(2987),
    [anon_sym_QMARK] = ACTIONS(2987),
    [anon_sym_EQ_GT] = ACTIONS(2987),
    [anon_sym_LBRACK2] = ACTIONS(2987),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [anon_sym_AT] = ACTIONS(2987),
    [aux_sym_integer_literal_token1] = ACTIONS(2987),
    [aux_sym_integer_literal_token2] = ACTIONS(2987),
    [aux_sym_integer_literal_token3] = ACTIONS(2987),
    [sym_float_literal] = ACTIONS(2987),
    [sym__unary_operator] = ACTIONS(2987),
    [sym__power_operator] = ACTIONS(2987),
    [sym__bitshift_operator] = ACTIONS(2987),
    [sym__rational_operator] = ACTIONS(2987),
    [sym__times_operator] = ACTIONS(2987),
    [sym__plus_operator] = ACTIONS(2987),
    [sym__dotty_operator] = ACTIONS(2987),
    [sym__comparison_operator] = ACTIONS(2987),
    [sym__arrow_operator] = ACTIONS(2987),
    [sym__assign_operator] = ACTIONS(2987),
    [anon_sym_LF] = ACTIONS(2989),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2989),
    [sym__command_start] = ACTIONS(2989),
  },
  [980] = {
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_function] = ACTIONS(2991),
    [anon_sym_end] = ACTIONS(2991),
    [anon_sym_abstract] = ACTIONS(2991),
    [anon_sym_primitive] = ACTIONS(2991),
    [aux_sym_primitive_definition_token1] = ACTIONS(2991),
    [anon_sym_mutable] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2991),
    [anon_sym_module] = ACTIONS(2991),
    [anon_sym_macro] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_EQ] = ACTIONS(2991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2991),
    [anon_sym_COLON_COLON] = ACTIONS(2991),
    [anon_sym_LT_COLON] = ACTIONS(2991),
    [anon_sym_if] = ACTIONS(2991),
    [anon_sym_elseif] = ACTIONS(2991),
    [anon_sym_else] = ACTIONS(2991),
    [anon_sym_try] = ACTIONS(2991),
    [anon_sym_catch] = ACTIONS(2991),
    [anon_sym_finally] = ACTIONS(2991),
    [anon_sym_for] = ACTIONS(2991),
    [anon_sym_while] = ACTIONS(2991),
    [sym_break_statement] = ACTIONS(2991),
    [sym_continue_statement] = ACTIONS(2991),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_let] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2991),
    [anon_sym_quote] = ACTIONS(2991),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_import] = ACTIONS(2991),
    [anon_sym_export] = ACTIONS(2991),
    [anon_sym_COLON2] = ACTIONS(2991),
    [anon_sym_begin] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2991),
    [anon_sym_LT_PIPE] = ACTIONS(2991),
    [anon_sym_PIPE_GT] = ACTIONS(2991),
    [anon_sym_in] = ACTIONS(2991),
    [anon_sym_isa] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_QMARK] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_LBRACK2] = ACTIONS(2991),
    [anon_sym_DOLLAR] = ACTIONS(2991),
    [anon_sym_AT] = ACTIONS(2991),
    [aux_sym_integer_literal_token1] = ACTIONS(2991),
    [aux_sym_integer_literal_token2] = ACTIONS(2991),
    [aux_sym_integer_literal_token3] = ACTIONS(2991),
    [sym_float_literal] = ACTIONS(2991),
    [sym__unary_operator] = ACTIONS(2991),
    [sym__power_operator] = ACTIONS(2991),
    [sym__bitshift_operator] = ACTIONS(2991),
    [sym__rational_operator] = ACTIONS(2991),
    [sym__times_operator] = ACTIONS(2991),
    [sym__plus_operator] = ACTIONS(2991),
    [sym__dotty_operator] = ACTIONS(2991),
    [sym__comparison_operator] = ACTIONS(2991),
    [sym__arrow_operator] = ACTIONS(2991),
    [sym__assign_operator] = ACTIONS(2991),
    [anon_sym_LF] = ACTIONS(2993),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2993),
    [sym__command_start] = ACTIONS(2993),
  },
  [981] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_end] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_primitive] = ACTIONS(2522),
    [aux_sym_primitive_definition_token1] = ACTIONS(2522),
    [anon_sym_mutable] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_macro] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_COMMA] = ACTIONS(2522),
    [anon_sym_RPAREN] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2522),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LT_COLON] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_elseif] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_catch] = ACTIONS(2522),
    [anon_sym_finally] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [sym_break_statement] = ACTIONS(2522),
    [sym_continue_statement] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_quote] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_COLON2] = ACTIONS(2522),
    [anon_sym_begin] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_LT_PIPE] = ACTIONS(2522),
    [anon_sym_PIPE_GT] = ACTIONS(2522),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_isa] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_QMARK] = ACTIONS(2522),
    [anon_sym_EQ_GT] = ACTIONS(2522),
    [anon_sym_LBRACK2] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2522),
    [aux_sym_integer_literal_token1] = ACTIONS(2522),
    [aux_sym_integer_literal_token2] = ACTIONS(2522),
    [aux_sym_integer_literal_token3] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
    [sym__unary_operator] = ACTIONS(2522),
    [sym__power_operator] = ACTIONS(2522),
    [sym__bitshift_operator] = ACTIONS(2522),
    [sym__rational_operator] = ACTIONS(2522),
    [sym__times_operator] = ACTIONS(2522),
    [sym__plus_operator] = ACTIONS(2522),
    [sym__dotty_operator] = ACTIONS(2522),
    [sym__comparison_operator] = ACTIONS(2522),
    [sym__arrow_operator] = ACTIONS(2522),
    [sym__assign_operator] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2524),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2524),
    [sym__command_start] = ACTIONS(2524),
  },
  [982] = {
    [sym_identifier] = ACTIONS(2995),
    [anon_sym_function] = ACTIONS(2995),
    [anon_sym_end] = ACTIONS(2995),
    [anon_sym_abstract] = ACTIONS(2995),
    [anon_sym_primitive] = ACTIONS(2995),
    [aux_sym_primitive_definition_token1] = ACTIONS(2995),
    [anon_sym_mutable] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2995),
    [anon_sym_module] = ACTIONS(2995),
    [anon_sym_macro] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2995),
    [anon_sym_RPAREN] = ACTIONS(2995),
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2995),
    [anon_sym_elseif] = ACTIONS(2995),
    [anon_sym_else] = ACTIONS(2995),
    [anon_sym_try] = ACTIONS(2995),
    [anon_sym_catch] = ACTIONS(2995),
    [anon_sym_finally] = ACTIONS(2995),
    [anon_sym_for] = ACTIONS(2995),
    [anon_sym_while] = ACTIONS(2995),
    [sym_break_statement] = ACTIONS(2995),
    [sym_continue_statement] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2995),
    [anon_sym_let] = ACTIONS(2995),
    [anon_sym_const] = ACTIONS(2995),
    [anon_sym_quote] = ACTIONS(2995),
    [anon_sym_using] = ACTIONS(2995),
    [anon_sym_import] = ACTIONS(2995),
    [anon_sym_export] = ACTIONS(2995),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2995),
    [anon_sym_DOLLAR] = ACTIONS(2995),
    [anon_sym_AT] = ACTIONS(2995),
    [aux_sym_integer_literal_token1] = ACTIONS(2995),
    [aux_sym_integer_literal_token2] = ACTIONS(2995),
    [aux_sym_integer_literal_token3] = ACTIONS(2995),
    [sym_float_literal] = ACTIONS(2995),
    [sym__unary_operator] = ACTIONS(2995),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2995),
    [anon_sym_LF] = ACTIONS(2997),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2997),
    [sym__command_start] = ACTIONS(2997),
  },
  [983] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [984] = {
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_function] = ACTIONS(2999),
    [anon_sym_end] = ACTIONS(2999),
    [anon_sym_abstract] = ACTIONS(2999),
    [anon_sym_primitive] = ACTIONS(2999),
    [aux_sym_primitive_definition_token1] = ACTIONS(2999),
    [anon_sym_mutable] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(2999),
    [anon_sym_module] = ACTIONS(2999),
    [anon_sym_macro] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(2999),
    [anon_sym_COMMA] = ACTIONS(2999),
    [anon_sym_RPAREN] = ACTIONS(2999),
    [anon_sym_SEMI] = ACTIONS(2999),
    [anon_sym_EQ] = ACTIONS(2999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2999),
    [anon_sym_COLON_COLON] = ACTIONS(2999),
    [anon_sym_LT_COLON] = ACTIONS(2999),
    [anon_sym_if] = ACTIONS(2999),
    [anon_sym_elseif] = ACTIONS(2999),
    [anon_sym_else] = ACTIONS(2999),
    [anon_sym_try] = ACTIONS(2999),
    [anon_sym_catch] = ACTIONS(2999),
    [anon_sym_finally] = ACTIONS(2999),
    [anon_sym_for] = ACTIONS(2999),
    [anon_sym_while] = ACTIONS(2999),
    [sym_break_statement] = ACTIONS(2999),
    [sym_continue_statement] = ACTIONS(2999),
    [anon_sym_return] = ACTIONS(2999),
    [anon_sym_let] = ACTIONS(2999),
    [anon_sym_const] = ACTIONS(2999),
    [anon_sym_quote] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(2999),
    [anon_sym_import] = ACTIONS(2999),
    [anon_sym_export] = ACTIONS(2999),
    [anon_sym_COLON2] = ACTIONS(2999),
    [anon_sym_begin] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(2999),
    [anon_sym_PLUS] = ACTIONS(2999),
    [anon_sym_LT_PIPE] = ACTIONS(2999),
    [anon_sym_PIPE_GT] = ACTIONS(2999),
    [anon_sym_in] = ACTIONS(2999),
    [anon_sym_isa] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(2999),
    [anon_sym_AMP_AMP] = ACTIONS(2999),
    [anon_sym_QMARK] = ACTIONS(2999),
    [anon_sym_EQ_GT] = ACTIONS(2999),
    [anon_sym_LBRACK2] = ACTIONS(2999),
    [anon_sym_DOLLAR] = ACTIONS(2999),
    [anon_sym_AT] = ACTIONS(2999),
    [aux_sym_integer_literal_token1] = ACTIONS(2999),
    [aux_sym_integer_literal_token2] = ACTIONS(2999),
    [aux_sym_integer_literal_token3] = ACTIONS(2999),
    [sym_float_literal] = ACTIONS(2999),
    [sym__unary_operator] = ACTIONS(2999),
    [sym__power_operator] = ACTIONS(2999),
    [sym__bitshift_operator] = ACTIONS(2999),
    [sym__rational_operator] = ACTIONS(2999),
    [sym__times_operator] = ACTIONS(2999),
    [sym__plus_operator] = ACTIONS(2999),
    [sym__dotty_operator] = ACTIONS(2999),
    [sym__comparison_operator] = ACTIONS(2999),
    [sym__arrow_operator] = ACTIONS(2999),
    [sym__assign_operator] = ACTIONS(2999),
    [anon_sym_LF] = ACTIONS(3001),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3001),
    [sym__command_start] = ACTIONS(3001),
  },
  [985] = {
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_end] = ACTIONS(3003),
    [anon_sym_abstract] = ACTIONS(3003),
    [anon_sym_primitive] = ACTIONS(3003),
    [aux_sym_primitive_definition_token1] = ACTIONS(3003),
    [anon_sym_mutable] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3003),
    [anon_sym_module] = ACTIONS(3003),
    [anon_sym_macro] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3003),
    [anon_sym_COMMA] = ACTIONS(3003),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_SEMI] = ACTIONS(3003),
    [anon_sym_EQ] = ACTIONS(3003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3003),
    [anon_sym_COLON_COLON] = ACTIONS(3003),
    [anon_sym_LT_COLON] = ACTIONS(3003),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_elseif] = ACTIONS(3003),
    [anon_sym_else] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_catch] = ACTIONS(3003),
    [anon_sym_finally] = ACTIONS(3003),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [sym_break_statement] = ACTIONS(3003),
    [sym_continue_statement] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_const] = ACTIONS(3003),
    [anon_sym_quote] = ACTIONS(3003),
    [anon_sym_using] = ACTIONS(3003),
    [anon_sym_import] = ACTIONS(3003),
    [anon_sym_export] = ACTIONS(3003),
    [anon_sym_COLON2] = ACTIONS(3003),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_SQUOTE] = ACTIONS(3003),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_LT_PIPE] = ACTIONS(3003),
    [anon_sym_PIPE_GT] = ACTIONS(3003),
    [anon_sym_in] = ACTIONS(3003),
    [anon_sym_isa] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3003),
    [anon_sym_AMP_AMP] = ACTIONS(3003),
    [anon_sym_QMARK] = ACTIONS(3003),
    [anon_sym_EQ_GT] = ACTIONS(3003),
    [anon_sym_LBRACK2] = ACTIONS(3003),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_AT] = ACTIONS(3003),
    [aux_sym_integer_literal_token1] = ACTIONS(3003),
    [aux_sym_integer_literal_token2] = ACTIONS(3003),
    [aux_sym_integer_literal_token3] = ACTIONS(3003),
    [sym_float_literal] = ACTIONS(3003),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__power_operator] = ACTIONS(3003),
    [sym__bitshift_operator] = ACTIONS(3003),
    [sym__rational_operator] = ACTIONS(3003),
    [sym__times_operator] = ACTIONS(3003),
    [sym__plus_operator] = ACTIONS(3003),
    [sym__dotty_operator] = ACTIONS(3003),
    [sym__comparison_operator] = ACTIONS(3003),
    [sym__arrow_operator] = ACTIONS(3003),
    [sym__assign_operator] = ACTIONS(3003),
    [anon_sym_LF] = ACTIONS(3005),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3005),
    [sym__command_start] = ACTIONS(3005),
  },
  [986] = {
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_end] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(3007),
    [anon_sym_primitive] = ACTIONS(3007),
    [aux_sym_primitive_definition_token1] = ACTIONS(3007),
    [anon_sym_mutable] = ACTIONS(3007),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_macro] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3007),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3007),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_LT_COLON] = ACTIONS(3007),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_elseif] = ACTIONS(3007),
    [anon_sym_else] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_catch] = ACTIONS(3007),
    [anon_sym_finally] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [sym_break_statement] = ACTIONS(3007),
    [sym_continue_statement] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_const] = ACTIONS(3007),
    [anon_sym_quote] = ACTIONS(3007),
    [anon_sym_using] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_COLON2] = ACTIONS(3007),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_LT_PIPE] = ACTIONS(3007),
    [anon_sym_PIPE_GT] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_isa] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_QMARK] = ACTIONS(3007),
    [anon_sym_EQ_GT] = ACTIONS(3007),
    [anon_sym_LBRACK2] = ACTIONS(3007),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(3007),
    [aux_sym_integer_literal_token1] = ACTIONS(3007),
    [aux_sym_integer_literal_token2] = ACTIONS(3007),
    [aux_sym_integer_literal_token3] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3007),
    [sym__unary_operator] = ACTIONS(3007),
    [sym__power_operator] = ACTIONS(3007),
    [sym__bitshift_operator] = ACTIONS(3007),
    [sym__rational_operator] = ACTIONS(3007),
    [sym__times_operator] = ACTIONS(3007),
    [sym__plus_operator] = ACTIONS(3007),
    [sym__dotty_operator] = ACTIONS(3007),
    [sym__comparison_operator] = ACTIONS(3007),
    [sym__arrow_operator] = ACTIONS(3007),
    [sym__assign_operator] = ACTIONS(3007),
    [anon_sym_LF] = ACTIONS(3009),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3009),
    [sym__command_start] = ACTIONS(3009),
  },
  [987] = {
    [sym_do_clause] = STATE(1195),
    [ts_builtin_sym_end] = ACTIONS(2482),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_function] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2480),
    [anon_sym_primitive] = ACTIONS(2480),
    [aux_sym_primitive_definition_token1] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_module] = ACTIONS(2480),
    [anon_sym_macro] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_EQ] = ACTIONS(2480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2480),
    [anon_sym_LT_COLON] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [sym_break_statement] = ACTIONS(2480),
    [sym_continue_statement] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_quote] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_import] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2480),
    [anon_sym_COLON2] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_begin] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_LT_PIPE] = ACTIONS(2480),
    [anon_sym_PIPE_GT] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_isa] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_EQ_GT] = ACTIONS(2480),
    [anon_sym_LBRACK2] = ACTIONS(2480),
    [anon_sym_DOLLAR] = ACTIONS(2480),
    [anon_sym_AT] = ACTIONS(2480),
    [aux_sym_integer_literal_token1] = ACTIONS(2480),
    [aux_sym_integer_literal_token2] = ACTIONS(2480),
    [aux_sym_integer_literal_token3] = ACTIONS(2480),
    [sym_float_literal] = ACTIONS(2480),
    [sym__unary_operator] = ACTIONS(2480),
    [sym__power_operator] = ACTIONS(2480),
    [sym__bitshift_operator] = ACTIONS(2480),
    [sym__rational_operator] = ACTIONS(2480),
    [sym__times_operator] = ACTIONS(2480),
    [sym__plus_operator] = ACTIONS(2480),
    [sym__dotty_operator] = ACTIONS(2480),
    [sym__comparison_operator] = ACTIONS(2480),
    [sym__arrow_operator] = ACTIONS(2480),
    [sym__assign_operator] = ACTIONS(2480),
    [anon_sym_LF] = ACTIONS(2482),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2482),
    [sym__string_start] = ACTIONS(2482),
    [sym__command_start] = ACTIONS(2482),
  },
  [988] = {
    [sym_identifier] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3013),
    [anon_sym_end] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_primitive] = ACTIONS(3013),
    [aux_sym_primitive_definition_token1] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_macro] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3013),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_RPAREN] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3013),
    [anon_sym_LT_COLON] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_elseif] = ACTIONS(3013),
    [anon_sym_else] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_catch] = ACTIONS(3013),
    [anon_sym_finally] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [sym_break_statement] = ACTIONS(3013),
    [sym_continue_statement] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_quote] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_import] = ACTIONS(3013),
    [anon_sym_export] = ACTIONS(3013),
    [anon_sym_COLON2] = ACTIONS(3013),
    [anon_sym_begin] = ACTIONS(3013),
    [anon_sym_SQUOTE] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_LT_PIPE] = ACTIONS(3013),
    [anon_sym_PIPE_GT] = ACTIONS(3013),
    [anon_sym_in] = ACTIONS(3013),
    [anon_sym_isa] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3013),
    [anon_sym_AMP_AMP] = ACTIONS(3013),
    [anon_sym_QMARK] = ACTIONS(3013),
    [anon_sym_EQ_GT] = ACTIONS(3013),
    [anon_sym_LBRACK2] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3013),
    [aux_sym_integer_literal_token1] = ACTIONS(3013),
    [aux_sym_integer_literal_token2] = ACTIONS(3013),
    [aux_sym_integer_literal_token3] = ACTIONS(3013),
    [sym_float_literal] = ACTIONS(3013),
    [sym__unary_operator] = ACTIONS(3013),
    [sym__power_operator] = ACTIONS(3013),
    [sym__bitshift_operator] = ACTIONS(3013),
    [sym__rational_operator] = ACTIONS(3013),
    [sym__times_operator] = ACTIONS(3013),
    [sym__plus_operator] = ACTIONS(3013),
    [sym__dotty_operator] = ACTIONS(3013),
    [sym__comparison_operator] = ACTIONS(3013),
    [sym__arrow_operator] = ACTIONS(3013),
    [sym__assign_operator] = ACTIONS(3013),
    [anon_sym_LF] = ACTIONS(3015),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3015),
    [sym__command_start] = ACTIONS(3015),
  },
  [989] = {
    [sym_identifier] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3017),
    [anon_sym_end] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3017),
    [anon_sym_primitive] = ACTIONS(3017),
    [aux_sym_primitive_definition_token1] = ACTIONS(3017),
    [anon_sym_mutable] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3017),
    [anon_sym_module] = ACTIONS(3017),
    [anon_sym_macro] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3017),
    [anon_sym_COMMA] = ACTIONS(3017),
    [anon_sym_RPAREN] = ACTIONS(3017),
    [anon_sym_SEMI] = ACTIONS(3017),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3017),
    [anon_sym_COLON_COLON] = ACTIONS(3017),
    [anon_sym_LT_COLON] = ACTIONS(3017),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_elseif] = ACTIONS(3017),
    [anon_sym_else] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_catch] = ACTIONS(3017),
    [anon_sym_finally] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [sym_break_statement] = ACTIONS(3017),
    [sym_continue_statement] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_let] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3017),
    [anon_sym_quote] = ACTIONS(3017),
    [anon_sym_using] = ACTIONS(3017),
    [anon_sym_import] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(3017),
    [anon_sym_COLON2] = ACTIONS(3017),
    [anon_sym_begin] = ACTIONS(3017),
    [anon_sym_SQUOTE] = ACTIONS(3017),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_LT_PIPE] = ACTIONS(3017),
    [anon_sym_PIPE_GT] = ACTIONS(3017),
    [anon_sym_in] = ACTIONS(3017),
    [anon_sym_isa] = ACTIONS(3017),
    [anon_sym_PIPE_PIPE] = ACTIONS(3017),
    [anon_sym_AMP_AMP] = ACTIONS(3017),
    [anon_sym_QMARK] = ACTIONS(3017),
    [anon_sym_EQ_GT] = ACTIONS(3017),
    [anon_sym_LBRACK2] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(3017),
    [anon_sym_AT] = ACTIONS(3017),
    [aux_sym_integer_literal_token1] = ACTIONS(3017),
    [aux_sym_integer_literal_token2] = ACTIONS(3017),
    [aux_sym_integer_literal_token3] = ACTIONS(3017),
    [sym_float_literal] = ACTIONS(3017),
    [sym__unary_operator] = ACTIONS(3017),
    [sym__power_operator] = ACTIONS(3017),
    [sym__bitshift_operator] = ACTIONS(3017),
    [sym__rational_operator] = ACTIONS(3017),
    [sym__times_operator] = ACTIONS(3017),
    [sym__plus_operator] = ACTIONS(3017),
    [sym__dotty_operator] = ACTIONS(3017),
    [sym__comparison_operator] = ACTIONS(3017),
    [sym__arrow_operator] = ACTIONS(3017),
    [sym__assign_operator] = ACTIONS(3017),
    [anon_sym_LF] = ACTIONS(3019),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3019),
    [sym__command_start] = ACTIONS(3019),
  },
  [990] = {
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_end] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_primitive] = ACTIONS(3021),
    [aux_sym_primitive_definition_token1] = ACTIONS(3021),
    [anon_sym_mutable] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_macro] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3021),
    [anon_sym_COMMA] = ACTIONS(3021),
    [anon_sym_RPAREN] = ACTIONS(3021),
    [anon_sym_SEMI] = ACTIONS(3021),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3021),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_LT_COLON] = ACTIONS(3021),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_elseif] = ACTIONS(3021),
    [anon_sym_else] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_catch] = ACTIONS(3021),
    [anon_sym_finally] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [sym_break_statement] = ACTIONS(3021),
    [sym_continue_statement] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_quote] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_COLON2] = ACTIONS(3021),
    [anon_sym_begin] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3021),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_LT_PIPE] = ACTIONS(3021),
    [anon_sym_PIPE_GT] = ACTIONS(3021),
    [anon_sym_in] = ACTIONS(3021),
    [anon_sym_isa] = ACTIONS(3021),
    [anon_sym_PIPE_PIPE] = ACTIONS(3021),
    [anon_sym_AMP_AMP] = ACTIONS(3021),
    [anon_sym_QMARK] = ACTIONS(3021),
    [anon_sym_EQ_GT] = ACTIONS(3021),
    [anon_sym_LBRACK2] = ACTIONS(3021),
    [anon_sym_DOLLAR] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3021),
    [aux_sym_integer_literal_token1] = ACTIONS(3021),
    [aux_sym_integer_literal_token2] = ACTIONS(3021),
    [aux_sym_integer_literal_token3] = ACTIONS(3021),
    [sym_float_literal] = ACTIONS(3021),
    [sym__unary_operator] = ACTIONS(3021),
    [sym__power_operator] = ACTIONS(3021),
    [sym__bitshift_operator] = ACTIONS(3021),
    [sym__rational_operator] = ACTIONS(3021),
    [sym__times_operator] = ACTIONS(3021),
    [sym__plus_operator] = ACTIONS(3021),
    [sym__dotty_operator] = ACTIONS(3021),
    [sym__comparison_operator] = ACTIONS(3021),
    [sym__arrow_operator] = ACTIONS(3021),
    [sym__assign_operator] = ACTIONS(3021),
    [anon_sym_LF] = ACTIONS(3023),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3023),
    [sym__command_start] = ACTIONS(3023),
  },
  [991] = {
    [sym_identifier] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3025),
    [anon_sym_end] = ACTIONS(3025),
    [anon_sym_abstract] = ACTIONS(3025),
    [anon_sym_primitive] = ACTIONS(3025),
    [aux_sym_primitive_definition_token1] = ACTIONS(3025),
    [anon_sym_mutable] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3025),
    [anon_sym_module] = ACTIONS(3025),
    [anon_sym_macro] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3025),
    [anon_sym_COMMA] = ACTIONS(3025),
    [anon_sym_RPAREN] = ACTIONS(3025),
    [anon_sym_SEMI] = ACTIONS(3025),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3025),
    [anon_sym_COLON_COLON] = ACTIONS(3025),
    [anon_sym_LT_COLON] = ACTIONS(3025),
    [anon_sym_if] = ACTIONS(3025),
    [anon_sym_elseif] = ACTIONS(3025),
    [anon_sym_else] = ACTIONS(3025),
    [anon_sym_try] = ACTIONS(3025),
    [anon_sym_catch] = ACTIONS(3025),
    [anon_sym_finally] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3025),
    [anon_sym_while] = ACTIONS(3025),
    [sym_break_statement] = ACTIONS(3025),
    [sym_continue_statement] = ACTIONS(3025),
    [anon_sym_return] = ACTIONS(3025),
    [anon_sym_let] = ACTIONS(3025),
    [anon_sym_const] = ACTIONS(3025),
    [anon_sym_quote] = ACTIONS(3025),
    [anon_sym_using] = ACTIONS(3025),
    [anon_sym_import] = ACTIONS(3025),
    [anon_sym_export] = ACTIONS(3025),
    [anon_sym_COLON2] = ACTIONS(3025),
    [anon_sym_begin] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3025),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_LT_PIPE] = ACTIONS(3025),
    [anon_sym_PIPE_GT] = ACTIONS(3025),
    [anon_sym_in] = ACTIONS(3025),
    [anon_sym_isa] = ACTIONS(3025),
    [anon_sym_PIPE_PIPE] = ACTIONS(3025),
    [anon_sym_AMP_AMP] = ACTIONS(3025),
    [anon_sym_QMARK] = ACTIONS(3025),
    [anon_sym_EQ_GT] = ACTIONS(3025),
    [anon_sym_LBRACK2] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3025),
    [anon_sym_AT] = ACTIONS(3025),
    [aux_sym_integer_literal_token1] = ACTIONS(3025),
    [aux_sym_integer_literal_token2] = ACTIONS(3025),
    [aux_sym_integer_literal_token3] = ACTIONS(3025),
    [sym_float_literal] = ACTIONS(3025),
    [sym__unary_operator] = ACTIONS(3025),
    [sym__power_operator] = ACTIONS(3025),
    [sym__bitshift_operator] = ACTIONS(3025),
    [sym__rational_operator] = ACTIONS(3025),
    [sym__times_operator] = ACTIONS(3025),
    [sym__plus_operator] = ACTIONS(3025),
    [sym__dotty_operator] = ACTIONS(3025),
    [sym__comparison_operator] = ACTIONS(3025),
    [sym__arrow_operator] = ACTIONS(3025),
    [sym__assign_operator] = ACTIONS(3025),
    [anon_sym_LF] = ACTIONS(3027),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3027),
    [sym__command_start] = ACTIONS(3027),
  },
  [992] = {
    [sym_identifier] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3029),
    [anon_sym_end] = ACTIONS(3029),
    [anon_sym_abstract] = ACTIONS(3029),
    [anon_sym_primitive] = ACTIONS(3029),
    [aux_sym_primitive_definition_token1] = ACTIONS(3029),
    [anon_sym_mutable] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3029),
    [anon_sym_module] = ACTIONS(3029),
    [anon_sym_macro] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3029),
    [anon_sym_COMMA] = ACTIONS(3029),
    [anon_sym_RPAREN] = ACTIONS(3029),
    [anon_sym_SEMI] = ACTIONS(3029),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3029),
    [anon_sym_COLON_COLON] = ACTIONS(3029),
    [anon_sym_LT_COLON] = ACTIONS(3029),
    [anon_sym_if] = ACTIONS(3029),
    [anon_sym_elseif] = ACTIONS(3029),
    [anon_sym_else] = ACTIONS(3029),
    [anon_sym_try] = ACTIONS(3029),
    [anon_sym_catch] = ACTIONS(3029),
    [anon_sym_finally] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3029),
    [anon_sym_while] = ACTIONS(3029),
    [sym_break_statement] = ACTIONS(3029),
    [sym_continue_statement] = ACTIONS(3029),
    [anon_sym_return] = ACTIONS(3029),
    [anon_sym_let] = ACTIONS(3029),
    [anon_sym_const] = ACTIONS(3029),
    [anon_sym_quote] = ACTIONS(3029),
    [anon_sym_using] = ACTIONS(3029),
    [anon_sym_import] = ACTIONS(3029),
    [anon_sym_export] = ACTIONS(3029),
    [anon_sym_COLON2] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3029),
    [anon_sym_PLUS] = ACTIONS(3029),
    [anon_sym_LT_PIPE] = ACTIONS(3029),
    [anon_sym_PIPE_GT] = ACTIONS(3029),
    [anon_sym_in] = ACTIONS(3029),
    [anon_sym_isa] = ACTIONS(3029),
    [anon_sym_PIPE_PIPE] = ACTIONS(3029),
    [anon_sym_AMP_AMP] = ACTIONS(3029),
    [anon_sym_QMARK] = ACTIONS(3029),
    [anon_sym_EQ_GT] = ACTIONS(3029),
    [anon_sym_LBRACK2] = ACTIONS(3029),
    [anon_sym_DOLLAR] = ACTIONS(3029),
    [anon_sym_AT] = ACTIONS(3029),
    [aux_sym_integer_literal_token1] = ACTIONS(3029),
    [aux_sym_integer_literal_token2] = ACTIONS(3029),
    [aux_sym_integer_literal_token3] = ACTIONS(3029),
    [sym_float_literal] = ACTIONS(3029),
    [sym__unary_operator] = ACTIONS(3029),
    [sym__power_operator] = ACTIONS(3029),
    [sym__bitshift_operator] = ACTIONS(3029),
    [sym__rational_operator] = ACTIONS(3029),
    [sym__times_operator] = ACTIONS(3029),
    [sym__plus_operator] = ACTIONS(3029),
    [sym__dotty_operator] = ACTIONS(3029),
    [sym__comparison_operator] = ACTIONS(3029),
    [sym__arrow_operator] = ACTIONS(3029),
    [sym__assign_operator] = ACTIONS(3029),
    [anon_sym_LF] = ACTIONS(3031),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3031),
    [sym__command_start] = ACTIONS(3031),
  },
  [993] = {
    [sym_identifier] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3033),
    [anon_sym_end] = ACTIONS(3033),
    [anon_sym_abstract] = ACTIONS(3033),
    [anon_sym_primitive] = ACTIONS(3033),
    [aux_sym_primitive_definition_token1] = ACTIONS(3033),
    [anon_sym_mutable] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3033),
    [anon_sym_module] = ACTIONS(3033),
    [anon_sym_macro] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3033),
    [anon_sym_COMMA] = ACTIONS(3033),
    [anon_sym_RPAREN] = ACTIONS(3033),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3033),
    [anon_sym_COLON_COLON] = ACTIONS(3033),
    [anon_sym_LT_COLON] = ACTIONS(3033),
    [anon_sym_if] = ACTIONS(3033),
    [anon_sym_elseif] = ACTIONS(3033),
    [anon_sym_else] = ACTIONS(3033),
    [anon_sym_try] = ACTIONS(3033),
    [anon_sym_catch] = ACTIONS(3033),
    [anon_sym_finally] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3033),
    [anon_sym_while] = ACTIONS(3033),
    [sym_break_statement] = ACTIONS(3033),
    [sym_continue_statement] = ACTIONS(3033),
    [anon_sym_return] = ACTIONS(3033),
    [anon_sym_let] = ACTIONS(3033),
    [anon_sym_const] = ACTIONS(3033),
    [anon_sym_quote] = ACTIONS(3033),
    [anon_sym_using] = ACTIONS(3033),
    [anon_sym_import] = ACTIONS(3033),
    [anon_sym_export] = ACTIONS(3033),
    [anon_sym_COLON2] = ACTIONS(3033),
    [anon_sym_begin] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3033),
    [anon_sym_PLUS] = ACTIONS(3033),
    [anon_sym_LT_PIPE] = ACTIONS(3033),
    [anon_sym_PIPE_GT] = ACTIONS(3033),
    [anon_sym_in] = ACTIONS(3033),
    [anon_sym_isa] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3033),
    [anon_sym_AMP_AMP] = ACTIONS(3033),
    [anon_sym_QMARK] = ACTIONS(3033),
    [anon_sym_EQ_GT] = ACTIONS(3033),
    [anon_sym_LBRACK2] = ACTIONS(3033),
    [anon_sym_DOLLAR] = ACTIONS(3033),
    [anon_sym_AT] = ACTIONS(3033),
    [aux_sym_integer_literal_token1] = ACTIONS(3033),
    [aux_sym_integer_literal_token2] = ACTIONS(3033),
    [aux_sym_integer_literal_token3] = ACTIONS(3033),
    [sym_float_literal] = ACTIONS(3033),
    [sym__unary_operator] = ACTIONS(3033),
    [sym__power_operator] = ACTIONS(3033),
    [sym__bitshift_operator] = ACTIONS(3033),
    [sym__rational_operator] = ACTIONS(3033),
    [sym__times_operator] = ACTIONS(3033),
    [sym__plus_operator] = ACTIONS(3033),
    [sym__dotty_operator] = ACTIONS(3033),
    [sym__comparison_operator] = ACTIONS(3033),
    [sym__arrow_operator] = ACTIONS(3033),
    [sym__assign_operator] = ACTIONS(3033),
    [anon_sym_LF] = ACTIONS(3035),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3035),
    [sym__command_start] = ACTIONS(3035),
  },
  [994] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3037),
    [anon_sym_end] = ACTIONS(3037),
    [anon_sym_abstract] = ACTIONS(3037),
    [anon_sym_primitive] = ACTIONS(3037),
    [aux_sym_primitive_definition_token1] = ACTIONS(3037),
    [anon_sym_mutable] = ACTIONS(3037),
    [anon_sym_struct] = ACTIONS(3037),
    [anon_sym_module] = ACTIONS(3037),
    [anon_sym_macro] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3037),
    [anon_sym_COMMA] = ACTIONS(3037),
    [anon_sym_RPAREN] = ACTIONS(3037),
    [anon_sym_SEMI] = ACTIONS(3037),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3037),
    [anon_sym_COLON_COLON] = ACTIONS(3037),
    [anon_sym_LT_COLON] = ACTIONS(3037),
    [anon_sym_if] = ACTIONS(3037),
    [anon_sym_elseif] = ACTIONS(3037),
    [anon_sym_else] = ACTIONS(3037),
    [anon_sym_try] = ACTIONS(3037),
    [anon_sym_catch] = ACTIONS(3037),
    [anon_sym_finally] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3037),
    [anon_sym_while] = ACTIONS(3037),
    [sym_break_statement] = ACTIONS(3037),
    [sym_continue_statement] = ACTIONS(3037),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_let] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3037),
    [anon_sym_quote] = ACTIONS(3037),
    [anon_sym_using] = ACTIONS(3037),
    [anon_sym_import] = ACTIONS(3037),
    [anon_sym_export] = ACTIONS(3037),
    [anon_sym_COLON2] = ACTIONS(3037),
    [anon_sym_begin] = ACTIONS(3037),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_LT_PIPE] = ACTIONS(3037),
    [anon_sym_PIPE_GT] = ACTIONS(3037),
    [anon_sym_in] = ACTIONS(3037),
    [anon_sym_isa] = ACTIONS(3037),
    [anon_sym_PIPE_PIPE] = ACTIONS(3037),
    [anon_sym_AMP_AMP] = ACTIONS(3037),
    [anon_sym_QMARK] = ACTIONS(3037),
    [anon_sym_EQ_GT] = ACTIONS(3037),
    [anon_sym_LBRACK2] = ACTIONS(3037),
    [anon_sym_DOLLAR] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(3037),
    [aux_sym_integer_literal_token1] = ACTIONS(3037),
    [aux_sym_integer_literal_token2] = ACTIONS(3037),
    [aux_sym_integer_literal_token3] = ACTIONS(3037),
    [sym_float_literal] = ACTIONS(3037),
    [sym__unary_operator] = ACTIONS(3037),
    [sym__power_operator] = ACTIONS(3037),
    [sym__bitshift_operator] = ACTIONS(3037),
    [sym__rational_operator] = ACTIONS(3037),
    [sym__times_operator] = ACTIONS(3037),
    [sym__plus_operator] = ACTIONS(3037),
    [sym__dotty_operator] = ACTIONS(3037),
    [sym__comparison_operator] = ACTIONS(3037),
    [sym__arrow_operator] = ACTIONS(3037),
    [sym__assign_operator] = ACTIONS(3037),
    [anon_sym_LF] = ACTIONS(3039),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3039),
    [sym__command_start] = ACTIONS(3039),
  },
  [995] = {
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_end] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_primitive] = ACTIONS(2889),
    [aux_sym_primitive_definition_token1] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_macro] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LT_COLON] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_elseif] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_catch] = ACTIONS(2889),
    [anon_sym_finally] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [sym_break_statement] = ACTIONS(2889),
    [sym_continue_statement] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_quote] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_COLON2] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_LT_PIPE] = ACTIONS(2889),
    [anon_sym_PIPE_GT] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_EQ_GT] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2889),
    [aux_sym_integer_literal_token1] = ACTIONS(2889),
    [aux_sym_integer_literal_token2] = ACTIONS(2889),
    [aux_sym_integer_literal_token3] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym__unary_operator] = ACTIONS(2889),
    [sym__power_operator] = ACTIONS(2889),
    [sym__bitshift_operator] = ACTIONS(2889),
    [sym__rational_operator] = ACTIONS(2889),
    [sym__times_operator] = ACTIONS(2889),
    [sym__plus_operator] = ACTIONS(2889),
    [sym__dotty_operator] = ACTIONS(2889),
    [sym__comparison_operator] = ACTIONS(2889),
    [sym__arrow_operator] = ACTIONS(2889),
    [sym__assign_operator] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2894),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2894),
    [sym__command_start] = ACTIONS(2894),
  },
  [996] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3041),
    [anon_sym_end] = ACTIONS(3041),
    [anon_sym_abstract] = ACTIONS(3041),
    [anon_sym_primitive] = ACTIONS(3041),
    [aux_sym_primitive_definition_token1] = ACTIONS(3041),
    [anon_sym_mutable] = ACTIONS(3041),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_module] = ACTIONS(3041),
    [anon_sym_macro] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3041),
    [anon_sym_COMMA] = ACTIONS(3041),
    [anon_sym_RPAREN] = ACTIONS(3041),
    [anon_sym_SEMI] = ACTIONS(3041),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3041),
    [anon_sym_COLON_COLON] = ACTIONS(3041),
    [anon_sym_LT_COLON] = ACTIONS(3041),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_elseif] = ACTIONS(3041),
    [anon_sym_else] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_catch] = ACTIONS(3041),
    [anon_sym_finally] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [sym_break_statement] = ACTIONS(3041),
    [sym_continue_statement] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_let] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_quote] = ACTIONS(3041),
    [anon_sym_using] = ACTIONS(3041),
    [anon_sym_import] = ACTIONS(3041),
    [anon_sym_export] = ACTIONS(3041),
    [anon_sym_COLON2] = ACTIONS(3041),
    [anon_sym_begin] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_LT_PIPE] = ACTIONS(3041),
    [anon_sym_PIPE_GT] = ACTIONS(3041),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_isa] = ACTIONS(3041),
    [anon_sym_PIPE_PIPE] = ACTIONS(3041),
    [anon_sym_AMP_AMP] = ACTIONS(3041),
    [anon_sym_QMARK] = ACTIONS(3041),
    [anon_sym_EQ_GT] = ACTIONS(3041),
    [anon_sym_LBRACK2] = ACTIONS(3041),
    [anon_sym_DOLLAR] = ACTIONS(3041),
    [anon_sym_AT] = ACTIONS(3041),
    [aux_sym_integer_literal_token1] = ACTIONS(3041),
    [aux_sym_integer_literal_token2] = ACTIONS(3041),
    [aux_sym_integer_literal_token3] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym__unary_operator] = ACTIONS(3041),
    [sym__power_operator] = ACTIONS(3041),
    [sym__bitshift_operator] = ACTIONS(3041),
    [sym__rational_operator] = ACTIONS(3041),
    [sym__times_operator] = ACTIONS(3041),
    [sym__plus_operator] = ACTIONS(3041),
    [sym__dotty_operator] = ACTIONS(3041),
    [sym__comparison_operator] = ACTIONS(3041),
    [sym__arrow_operator] = ACTIONS(3041),
    [sym__assign_operator] = ACTIONS(3041),
    [anon_sym_LF] = ACTIONS(3043),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3043),
    [sym__command_start] = ACTIONS(3043),
  },
  [997] = {
    [sym_do_clause] = STATE(1184),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_function] = ACTIONS(2480),
    [anon_sym_end] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2480),
    [anon_sym_primitive] = ACTIONS(2480),
    [aux_sym_primitive_definition_token1] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_module] = ACTIONS(2480),
    [anon_sym_macro] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2482),
    [anon_sym_COLON_COLON] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_LT_COLON] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [sym_break_statement] = ACTIONS(2480),
    [sym_continue_statement] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_quote] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_import] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2480),
    [anon_sym_COLON2] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_RBRACK] = ACTIONS(2482),
    [anon_sym_begin] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_LT_PIPE] = ACTIONS(2482),
    [anon_sym_PIPE_GT] = ACTIONS(2482),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_isa] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2482),
    [anon_sym_AMP_AMP] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_EQ_GT] = ACTIONS(2482),
    [anon_sym_LBRACK2] = ACTIONS(2480),
    [anon_sym_DOLLAR] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2482),
    [aux_sym_integer_literal_token1] = ACTIONS(2482),
    [aux_sym_integer_literal_token2] = ACTIONS(2482),
    [aux_sym_integer_literal_token3] = ACTIONS(2480),
    [sym_float_literal] = ACTIONS(2480),
    [sym__unary_operator] = ACTIONS(2480),
    [sym__power_operator] = ACTIONS(2482),
    [sym__bitshift_operator] = ACTIONS(2482),
    [sym__rational_operator] = ACTIONS(2482),
    [sym__times_operator] = ACTIONS(2480),
    [sym__plus_operator] = ACTIONS(2480),
    [sym__dotty_operator] = ACTIONS(2480),
    [sym__comparison_operator] = ACTIONS(2480),
    [sym__arrow_operator] = ACTIONS(2482),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2482),
    [sym__string_start] = ACTIONS(2482),
    [sym__command_start] = ACTIONS(2482),
  },
  [998] = {
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_end] = ACTIONS(3047),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_primitive] = ACTIONS(3047),
    [aux_sym_primitive_definition_token1] = ACTIONS(3047),
    [anon_sym_mutable] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3047),
    [anon_sym_module] = ACTIONS(3047),
    [anon_sym_macro] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_EQ] = ACTIONS(3047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3047),
    [anon_sym_COLON_COLON] = ACTIONS(3047),
    [anon_sym_LT_COLON] = ACTIONS(3047),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_elseif] = ACTIONS(3047),
    [anon_sym_else] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_catch] = ACTIONS(3047),
    [anon_sym_finally] = ACTIONS(3047),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [sym_break_statement] = ACTIONS(3047),
    [sym_continue_statement] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_const] = ACTIONS(3047),
    [anon_sym_quote] = ACTIONS(3047),
    [anon_sym_using] = ACTIONS(3047),
    [anon_sym_import] = ACTIONS(3047),
    [anon_sym_export] = ACTIONS(3047),
    [anon_sym_COLON2] = ACTIONS(3047),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_LT_PIPE] = ACTIONS(3047),
    [anon_sym_PIPE_GT] = ACTIONS(3047),
    [anon_sym_in] = ACTIONS(3047),
    [anon_sym_isa] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_EQ_GT] = ACTIONS(3047),
    [anon_sym_LBRACK2] = ACTIONS(3047),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_AT] = ACTIONS(3047),
    [aux_sym_integer_literal_token1] = ACTIONS(3047),
    [aux_sym_integer_literal_token2] = ACTIONS(3047),
    [aux_sym_integer_literal_token3] = ACTIONS(3047),
    [sym_float_literal] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3047),
    [sym__power_operator] = ACTIONS(3047),
    [sym__bitshift_operator] = ACTIONS(3047),
    [sym__rational_operator] = ACTIONS(3047),
    [sym__times_operator] = ACTIONS(3047),
    [sym__plus_operator] = ACTIONS(3047),
    [sym__dotty_operator] = ACTIONS(3047),
    [sym__comparison_operator] = ACTIONS(3047),
    [sym__arrow_operator] = ACTIONS(3047),
    [sym__assign_operator] = ACTIONS(3047),
    [anon_sym_LF] = ACTIONS(3049),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3049),
    [sym__command_start] = ACTIONS(3049),
  },
  [999] = {
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_end] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_primitive] = ACTIONS(3051),
    [aux_sym_primitive_definition_token1] = ACTIONS(3051),
    [anon_sym_mutable] = ACTIONS(3051),
    [anon_sym_struct] = ACTIONS(3051),
    [anon_sym_module] = ACTIONS(3051),
    [anon_sym_macro] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3051),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3051),
    [anon_sym_COLON_COLON] = ACTIONS(3051),
    [anon_sym_LT_COLON] = ACTIONS(3051),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_elseif] = ACTIONS(3051),
    [anon_sym_else] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_catch] = ACTIONS(3051),
    [anon_sym_finally] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [sym_break_statement] = ACTIONS(3051),
    [sym_continue_statement] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_const] = ACTIONS(3051),
    [anon_sym_quote] = ACTIONS(3051),
    [anon_sym_using] = ACTIONS(3051),
    [anon_sym_import] = ACTIONS(3051),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_COLON2] = ACTIONS(3051),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_LT_PIPE] = ACTIONS(3051),
    [anon_sym_PIPE_GT] = ACTIONS(3051),
    [anon_sym_in] = ACTIONS(3051),
    [anon_sym_isa] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_EQ_GT] = ACTIONS(3051),
    [anon_sym_LBRACK2] = ACTIONS(3051),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_AT] = ACTIONS(3051),
    [aux_sym_integer_literal_token1] = ACTIONS(3051),
    [aux_sym_integer_literal_token2] = ACTIONS(3051),
    [aux_sym_integer_literal_token3] = ACTIONS(3051),
    [sym_float_literal] = ACTIONS(3051),
    [sym__unary_operator] = ACTIONS(3051),
    [sym__power_operator] = ACTIONS(3051),
    [sym__bitshift_operator] = ACTIONS(3051),
    [sym__rational_operator] = ACTIONS(3051),
    [sym__times_operator] = ACTIONS(3051),
    [sym__plus_operator] = ACTIONS(3051),
    [sym__dotty_operator] = ACTIONS(3051),
    [sym__comparison_operator] = ACTIONS(3051),
    [sym__arrow_operator] = ACTIONS(3051),
    [sym__assign_operator] = ACTIONS(3051),
    [anon_sym_LF] = ACTIONS(3053),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3053),
    [sym__command_start] = ACTIONS(3053),
  },
  [1000] = {
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_end] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_primitive] = ACTIONS(3055),
    [aux_sym_primitive_definition_token1] = ACTIONS(3055),
    [anon_sym_mutable] = ACTIONS(3055),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_module] = ACTIONS(3055),
    [anon_sym_macro] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3055),
    [anon_sym_COLON_COLON] = ACTIONS(3055),
    [anon_sym_LT_COLON] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_elseif] = ACTIONS(3055),
    [anon_sym_else] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_catch] = ACTIONS(3055),
    [anon_sym_finally] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [sym_break_statement] = ACTIONS(3055),
    [sym_continue_statement] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_quote] = ACTIONS(3055),
    [anon_sym_using] = ACTIONS(3055),
    [anon_sym_import] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3055),
    [anon_sym_COLON2] = ACTIONS(3055),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_LT_PIPE] = ACTIONS(3055),
    [anon_sym_PIPE_GT] = ACTIONS(3055),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_isa] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_EQ_GT] = ACTIONS(3055),
    [anon_sym_LBRACK2] = ACTIONS(3055),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3055),
    [aux_sym_integer_literal_token1] = ACTIONS(3055),
    [aux_sym_integer_literal_token2] = ACTIONS(3055),
    [aux_sym_integer_literal_token3] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym__unary_operator] = ACTIONS(3055),
    [sym__power_operator] = ACTIONS(3055),
    [sym__bitshift_operator] = ACTIONS(3055),
    [sym__rational_operator] = ACTIONS(3055),
    [sym__times_operator] = ACTIONS(3055),
    [sym__plus_operator] = ACTIONS(3055),
    [sym__dotty_operator] = ACTIONS(3055),
    [sym__comparison_operator] = ACTIONS(3055),
    [sym__arrow_operator] = ACTIONS(3055),
    [sym__assign_operator] = ACTIONS(3055),
    [anon_sym_LF] = ACTIONS(3057),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3057),
    [sym__command_start] = ACTIONS(3057),
  },
  [1001] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1002] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_end] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_primitive] = ACTIONS(2518),
    [aux_sym_primitive_definition_token1] = ACTIONS(2518),
    [anon_sym_mutable] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_macro] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2518),
    [anon_sym_RPAREN] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LT_COLON] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_elseif] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_catch] = ACTIONS(2518),
    [anon_sym_finally] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [sym_break_statement] = ACTIONS(2518),
    [sym_continue_statement] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_quote] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_COLON2] = ACTIONS(2518),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_LT_PIPE] = ACTIONS(2518),
    [anon_sym_PIPE_GT] = ACTIONS(2518),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_isa] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_EQ_GT] = ACTIONS(2518),
    [anon_sym_LBRACK2] = ACTIONS(2518),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2518),
    [aux_sym_integer_literal_token1] = ACTIONS(2518),
    [aux_sym_integer_literal_token2] = ACTIONS(2518),
    [aux_sym_integer_literal_token3] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
    [sym__unary_operator] = ACTIONS(2518),
    [sym__power_operator] = ACTIONS(2518),
    [sym__bitshift_operator] = ACTIONS(2518),
    [sym__rational_operator] = ACTIONS(2518),
    [sym__times_operator] = ACTIONS(2518),
    [sym__plus_operator] = ACTIONS(2518),
    [sym__dotty_operator] = ACTIONS(2518),
    [sym__comparison_operator] = ACTIONS(2518),
    [sym__arrow_operator] = ACTIONS(2518),
    [sym__assign_operator] = ACTIONS(2518),
    [anon_sym_LF] = ACTIONS(2520),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2520),
    [sym__command_start] = ACTIONS(2520),
  },
  [1003] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_end] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_primitive] = ACTIONS(2514),
    [aux_sym_primitive_definition_token1] = ACTIONS(2514),
    [anon_sym_mutable] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_macro] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_RPAREN] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LT_COLON] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_elseif] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_catch] = ACTIONS(2514),
    [anon_sym_finally] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [sym_break_statement] = ACTIONS(2514),
    [sym_continue_statement] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_quote] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_COLON2] = ACTIONS(2514),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_LT_PIPE] = ACTIONS(2514),
    [anon_sym_PIPE_GT] = ACTIONS(2514),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_isa] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_EQ_GT] = ACTIONS(2514),
    [anon_sym_LBRACK2] = ACTIONS(2514),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2514),
    [aux_sym_integer_literal_token1] = ACTIONS(2514),
    [aux_sym_integer_literal_token2] = ACTIONS(2514),
    [aux_sym_integer_literal_token3] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__power_operator] = ACTIONS(2514),
    [sym__bitshift_operator] = ACTIONS(2514),
    [sym__rational_operator] = ACTIONS(2514),
    [sym__times_operator] = ACTIONS(2514),
    [sym__plus_operator] = ACTIONS(2514),
    [sym__dotty_operator] = ACTIONS(2514),
    [sym__comparison_operator] = ACTIONS(2514),
    [sym__arrow_operator] = ACTIONS(2514),
    [sym__assign_operator] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2516),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2516),
    [sym__command_start] = ACTIONS(2516),
  },
  [1004] = {
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_end] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_primitive] = ACTIONS(3059),
    [aux_sym_primitive_definition_token1] = ACTIONS(3059),
    [anon_sym_mutable] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3059),
    [anon_sym_module] = ACTIONS(3059),
    [anon_sym_macro] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3059),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3059),
    [anon_sym_COLON_COLON] = ACTIONS(3059),
    [anon_sym_LT_COLON] = ACTIONS(3059),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_elseif] = ACTIONS(3059),
    [anon_sym_else] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_catch] = ACTIONS(3059),
    [anon_sym_finally] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [sym_break_statement] = ACTIONS(3059),
    [sym_continue_statement] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_const] = ACTIONS(3059),
    [anon_sym_quote] = ACTIONS(3059),
    [anon_sym_using] = ACTIONS(3059),
    [anon_sym_import] = ACTIONS(3059),
    [anon_sym_export] = ACTIONS(3059),
    [anon_sym_COLON2] = ACTIONS(3059),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_LT_PIPE] = ACTIONS(3059),
    [anon_sym_PIPE_GT] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(3059),
    [anon_sym_isa] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_EQ_GT] = ACTIONS(3059),
    [anon_sym_LBRACK2] = ACTIONS(3059),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [aux_sym_integer_literal_token1] = ACTIONS(3059),
    [aux_sym_integer_literal_token2] = ACTIONS(3059),
    [aux_sym_integer_literal_token3] = ACTIONS(3059),
    [sym_float_literal] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__power_operator] = ACTIONS(3059),
    [sym__bitshift_operator] = ACTIONS(3059),
    [sym__rational_operator] = ACTIONS(3059),
    [sym__times_operator] = ACTIONS(3059),
    [sym__plus_operator] = ACTIONS(3059),
    [sym__dotty_operator] = ACTIONS(3059),
    [sym__comparison_operator] = ACTIONS(3059),
    [sym__arrow_operator] = ACTIONS(3059),
    [sym__assign_operator] = ACTIONS(3059),
    [anon_sym_LF] = ACTIONS(3061),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3061),
    [sym__command_start] = ACTIONS(3061),
  },
  [1005] = {
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_end] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_primitive] = ACTIONS(3063),
    [aux_sym_primitive_definition_token1] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_module] = ACTIONS(3063),
    [anon_sym_macro] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3063),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [anon_sym_LT_COLON] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_elseif] = ACTIONS(3063),
    [anon_sym_else] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_catch] = ACTIONS(3063),
    [anon_sym_finally] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [sym_break_statement] = ACTIONS(3063),
    [sym_continue_statement] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_import] = ACTIONS(3063),
    [anon_sym_export] = ACTIONS(3063),
    [anon_sym_COLON2] = ACTIONS(3063),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_LT_PIPE] = ACTIONS(3063),
    [anon_sym_PIPE_GT] = ACTIONS(3063),
    [anon_sym_in] = ACTIONS(3063),
    [anon_sym_isa] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_EQ_GT] = ACTIONS(3063),
    [anon_sym_LBRACK2] = ACTIONS(3063),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [aux_sym_integer_literal_token1] = ACTIONS(3063),
    [aux_sym_integer_literal_token2] = ACTIONS(3063),
    [aux_sym_integer_literal_token3] = ACTIONS(3063),
    [sym_float_literal] = ACTIONS(3063),
    [sym__unary_operator] = ACTIONS(3063),
    [sym__power_operator] = ACTIONS(3063),
    [sym__bitshift_operator] = ACTIONS(3063),
    [sym__rational_operator] = ACTIONS(3063),
    [sym__times_operator] = ACTIONS(3063),
    [sym__plus_operator] = ACTIONS(3063),
    [sym__dotty_operator] = ACTIONS(3063),
    [sym__comparison_operator] = ACTIONS(3063),
    [sym__arrow_operator] = ACTIONS(3063),
    [sym__assign_operator] = ACTIONS(3063),
    [anon_sym_LF] = ACTIONS(3065),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3065),
    [sym__command_start] = ACTIONS(3065),
  },
  [1006] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1007] = {
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_end] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_primitive] = ACTIONS(3067),
    [aux_sym_primitive_definition_token1] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_module] = ACTIONS(3067),
    [anon_sym_macro] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3067),
    [anon_sym_COLON_COLON] = ACTIONS(3067),
    [anon_sym_LT_COLON] = ACTIONS(3067),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_elseif] = ACTIONS(3067),
    [anon_sym_else] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_catch] = ACTIONS(3067),
    [anon_sym_finally] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [sym_break_statement] = ACTIONS(3067),
    [sym_continue_statement] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_quote] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_import] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3067),
    [anon_sym_COLON2] = ACTIONS(3067),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_LT_PIPE] = ACTIONS(3067),
    [anon_sym_PIPE_GT] = ACTIONS(3067),
    [anon_sym_in] = ACTIONS(3067),
    [anon_sym_isa] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_EQ_GT] = ACTIONS(3067),
    [anon_sym_LBRACK2] = ACTIONS(3067),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3067),
    [aux_sym_integer_literal_token1] = ACTIONS(3067),
    [aux_sym_integer_literal_token2] = ACTIONS(3067),
    [aux_sym_integer_literal_token3] = ACTIONS(3067),
    [sym_float_literal] = ACTIONS(3067),
    [sym__unary_operator] = ACTIONS(3067),
    [sym__power_operator] = ACTIONS(3067),
    [sym__bitshift_operator] = ACTIONS(3067),
    [sym__rational_operator] = ACTIONS(3067),
    [sym__times_operator] = ACTIONS(3067),
    [sym__plus_operator] = ACTIONS(3067),
    [sym__dotty_operator] = ACTIONS(3067),
    [sym__comparison_operator] = ACTIONS(3067),
    [sym__arrow_operator] = ACTIONS(3067),
    [sym__assign_operator] = ACTIONS(3067),
    [anon_sym_LF] = ACTIONS(3069),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3069),
    [sym__command_start] = ACTIONS(3069),
  },
  [1008] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_end] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_primitive] = ACTIONS(2510),
    [aux_sym_primitive_definition_token1] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_macro] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_RPAREN] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LT_COLON] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_elseif] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(2510),
    [anon_sym_finally] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [sym_break_statement] = ACTIONS(2510),
    [sym_continue_statement] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_quote] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_COLON2] = ACTIONS(2510),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_LT_PIPE] = ACTIONS(2510),
    [anon_sym_PIPE_GT] = ACTIONS(2510),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_isa] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_EQ_GT] = ACTIONS(2510),
    [anon_sym_LBRACK2] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2510),
    [aux_sym_integer_literal_token1] = ACTIONS(2510),
    [aux_sym_integer_literal_token2] = ACTIONS(2510),
    [aux_sym_integer_literal_token3] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
    [sym__unary_operator] = ACTIONS(2510),
    [sym__power_operator] = ACTIONS(2510),
    [sym__bitshift_operator] = ACTIONS(2510),
    [sym__rational_operator] = ACTIONS(2510),
    [sym__times_operator] = ACTIONS(2510),
    [sym__plus_operator] = ACTIONS(2510),
    [sym__dotty_operator] = ACTIONS(2510),
    [sym__comparison_operator] = ACTIONS(2510),
    [sym__arrow_operator] = ACTIONS(2510),
    [sym__assign_operator] = ACTIONS(2510),
    [anon_sym_LF] = ACTIONS(2512),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2512),
    [sym__command_start] = ACTIONS(2512),
  },
  [1009] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2983),
    [anon_sym_PIPE_GT] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1010] = {
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [aux_sym_primitive_definition_token1] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_LT_COLON] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_LT_PIPE] = ACTIONS(3071),
    [anon_sym_PIPE_GT] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_EQ_GT] = ACTIONS(3071),
    [anon_sym_LBRACK2] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [sym_float_literal] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__dotty_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__assign_operator] = ACTIONS(3071),
    [anon_sym_LF] = ACTIONS(3073),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3073),
    [sym__command_start] = ACTIONS(3073),
  },
  [1011] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1012] = {
    [sym_type_argument_list] = STATE(1229),
    [ts_builtin_sym_end] = ACTIONS(97),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_EQ] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(85),
    [aux_sym_integer_literal_token1] = ACTIONS(85),
    [aux_sym_integer_literal_token2] = ACTIONS(85),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(85),
    [sym__assign_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
  },
  [1013] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_primitive] = ACTIONS(2490),
    [aux_sym_primitive_definition_token1] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_macro] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LT_COLON] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_elseif] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(2490),
    [anon_sym_finally] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [sym_break_statement] = ACTIONS(2490),
    [sym_continue_statement] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_quote] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_COLON2] = ACTIONS(2490),
    [anon_sym_begin] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_LT_PIPE] = ACTIONS(2490),
    [anon_sym_PIPE_GT] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_isa] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(2490),
    [anon_sym_LBRACK2] = ACTIONS(2490),
    [anon_sym_DOLLAR] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2490),
    [aux_sym_integer_literal_token1] = ACTIONS(2490),
    [aux_sym_integer_literal_token2] = ACTIONS(2490),
    [aux_sym_integer_literal_token3] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
    [sym__unary_operator] = ACTIONS(2490),
    [sym__power_operator] = ACTIONS(2490),
    [sym__bitshift_operator] = ACTIONS(2490),
    [sym__rational_operator] = ACTIONS(2490),
    [sym__times_operator] = ACTIONS(2490),
    [sym__plus_operator] = ACTIONS(2490),
    [sym__dotty_operator] = ACTIONS(2490),
    [sym__comparison_operator] = ACTIONS(2490),
    [sym__arrow_operator] = ACTIONS(2490),
    [sym__assign_operator] = ACTIONS(2490),
    [anon_sym_LF] = ACTIONS(2492),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2492),
    [sym__command_start] = ACTIONS(2492),
  },
  [1014] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2983),
    [anon_sym_PIPE_GT] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1015] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_end] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_primitive] = ACTIONS(2596),
    [aux_sym_primitive_definition_token1] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_macro] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_EQ] = ACTIONS(2596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2598),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_LT_COLON] = ACTIONS(2598),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [sym_break_statement] = ACTIONS(2596),
    [sym_continue_statement] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_quote] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_COLON2] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_RBRACK] = ACTIONS(2598),
    [anon_sym_begin] = ACTIONS(2596),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_LT_PIPE] = ACTIONS(2598),
    [anon_sym_PIPE_GT] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_isa] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_EQ_GT] = ACTIONS(2598),
    [anon_sym_LBRACK2] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(2598),
    [aux_sym_integer_literal_token1] = ACTIONS(2598),
    [aux_sym_integer_literal_token2] = ACTIONS(2598),
    [aux_sym_integer_literal_token3] = ACTIONS(2596),
    [sym_float_literal] = ACTIONS(2596),
    [sym__unary_operator] = ACTIONS(2596),
    [sym__power_operator] = ACTIONS(2596),
    [sym__bitshift_operator] = ACTIONS(2596),
    [sym__rational_operator] = ACTIONS(2596),
    [sym__times_operator] = ACTIONS(2596),
    [sym__plus_operator] = ACTIONS(2596),
    [sym__dotty_operator] = ACTIONS(2596),
    [sym__comparison_operator] = ACTIONS(2596),
    [sym__arrow_operator] = ACTIONS(2598),
    [sym__assign_operator] = ACTIONS(2596),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2598),
    [sym__string_start] = ACTIONS(2598),
    [sym__command_start] = ACTIONS(2598),
  },
  [1016] = {
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_end] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_primitive] = ACTIONS(3075),
    [aux_sym_primitive_definition_token1] = ACTIONS(3075),
    [anon_sym_mutable] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_macro] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_LT_COLON] = ACTIONS(3075),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_elseif] = ACTIONS(3075),
    [anon_sym_else] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_catch] = ACTIONS(3075),
    [anon_sym_finally] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [sym_break_statement] = ACTIONS(3075),
    [sym_continue_statement] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_quote] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_import] = ACTIONS(3075),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_LT_PIPE] = ACTIONS(3075),
    [anon_sym_PIPE_GT] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_EQ_GT] = ACTIONS(3075),
    [anon_sym_LBRACK2] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3075),
    [sym_float_literal] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__times_operator] = ACTIONS(3075),
    [sym__plus_operator] = ACTIONS(3075),
    [sym__dotty_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3075),
    [sym__assign_operator] = ACTIONS(3075),
    [anon_sym_LF] = ACTIONS(3077),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3077),
    [sym__command_start] = ACTIONS(3077),
  },
  [1017] = {
    [sym_do_clause] = STATE(1276),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_end] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_primitive] = ACTIONS(2486),
    [aux_sym_primitive_definition_token1] = ACTIONS(2486),
    [anon_sym_mutable] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_macro] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2486),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_LT_COLON] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_elseif] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [sym_break_statement] = ACTIONS(2486),
    [sym_continue_statement] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_quote] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_COLON2] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_begin] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_LT_PIPE] = ACTIONS(2486),
    [anon_sym_PIPE_GT] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_isa] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_EQ_GT] = ACTIONS(2486),
    [anon_sym_LBRACK2] = ACTIONS(2486),
    [anon_sym_DOLLAR] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2486),
    [aux_sym_integer_literal_token1] = ACTIONS(2486),
    [aux_sym_integer_literal_token2] = ACTIONS(2486),
    [aux_sym_integer_literal_token3] = ACTIONS(2486),
    [sym_float_literal] = ACTIONS(2486),
    [sym__unary_operator] = ACTIONS(2486),
    [sym__power_operator] = ACTIONS(2486),
    [sym__bitshift_operator] = ACTIONS(2486),
    [sym__rational_operator] = ACTIONS(2486),
    [sym__times_operator] = ACTIONS(2486),
    [sym__plus_operator] = ACTIONS(2486),
    [sym__dotty_operator] = ACTIONS(2486),
    [sym__comparison_operator] = ACTIONS(2486),
    [sym__arrow_operator] = ACTIONS(2486),
    [anon_sym_LF] = ACTIONS(2488),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2488),
    [sym__string_start] = ACTIONS(2488),
    [sym__command_start] = ACTIONS(2488),
  },
  [1018] = {
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3081),
    [anon_sym_end] = ACTIONS(3081),
    [anon_sym_abstract] = ACTIONS(3081),
    [anon_sym_primitive] = ACTIONS(3081),
    [aux_sym_primitive_definition_token1] = ACTIONS(3081),
    [anon_sym_mutable] = ACTIONS(3081),
    [anon_sym_struct] = ACTIONS(3081),
    [anon_sym_module] = ACTIONS(3081),
    [anon_sym_macro] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3081),
    [anon_sym_COMMA] = ACTIONS(3081),
    [anon_sym_RPAREN] = ACTIONS(3081),
    [anon_sym_SEMI] = ACTIONS(3081),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3081),
    [anon_sym_COLON_COLON] = ACTIONS(3081),
    [anon_sym_LT_COLON] = ACTIONS(3081),
    [anon_sym_if] = ACTIONS(3081),
    [anon_sym_elseif] = ACTIONS(3081),
    [anon_sym_else] = ACTIONS(3081),
    [anon_sym_try] = ACTIONS(3081),
    [anon_sym_catch] = ACTIONS(3081),
    [anon_sym_finally] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3081),
    [anon_sym_while] = ACTIONS(3081),
    [sym_break_statement] = ACTIONS(3081),
    [sym_continue_statement] = ACTIONS(3081),
    [anon_sym_return] = ACTIONS(3081),
    [anon_sym_let] = ACTIONS(3081),
    [anon_sym_const] = ACTIONS(3081),
    [anon_sym_quote] = ACTIONS(3081),
    [anon_sym_using] = ACTIONS(3081),
    [anon_sym_import] = ACTIONS(3081),
    [anon_sym_export] = ACTIONS(3081),
    [anon_sym_COLON2] = ACTIONS(3081),
    [anon_sym_begin] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym_PLUS] = ACTIONS(3081),
    [anon_sym_LT_PIPE] = ACTIONS(3081),
    [anon_sym_PIPE_GT] = ACTIONS(3081),
    [anon_sym_in] = ACTIONS(3081),
    [anon_sym_isa] = ACTIONS(3081),
    [anon_sym_PIPE_PIPE] = ACTIONS(3081),
    [anon_sym_AMP_AMP] = ACTIONS(3081),
    [anon_sym_QMARK] = ACTIONS(3081),
    [anon_sym_EQ_GT] = ACTIONS(3081),
    [anon_sym_LBRACK2] = ACTIONS(3081),
    [anon_sym_DOLLAR] = ACTIONS(3081),
    [anon_sym_AT] = ACTIONS(3081),
    [aux_sym_integer_literal_token1] = ACTIONS(3081),
    [aux_sym_integer_literal_token2] = ACTIONS(3081),
    [aux_sym_integer_literal_token3] = ACTIONS(3081),
    [sym_float_literal] = ACTIONS(3081),
    [sym__unary_operator] = ACTIONS(3081),
    [sym__power_operator] = ACTIONS(3081),
    [sym__bitshift_operator] = ACTIONS(3081),
    [sym__rational_operator] = ACTIONS(3081),
    [sym__times_operator] = ACTIONS(3081),
    [sym__plus_operator] = ACTIONS(3081),
    [sym__dotty_operator] = ACTIONS(3081),
    [sym__comparison_operator] = ACTIONS(3081),
    [sym__arrow_operator] = ACTIONS(3081),
    [sym__assign_operator] = ACTIONS(3081),
    [anon_sym_LF] = ACTIONS(3083),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3083),
    [sym__command_start] = ACTIONS(3083),
  },
  [1019] = {
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_end] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_primitive] = ACTIONS(2772),
    [aux_sym_primitive_definition_token1] = ACTIONS(2772),
    [anon_sym_mutable] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_macro] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_COMMA] = ACTIONS(2772),
    [anon_sym_RPAREN] = ACTIONS(2772),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_elseif] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_catch] = ACTIONS(2772),
    [anon_sym_finally] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [sym_break_statement] = ACTIONS(2772),
    [sym_continue_statement] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_quote] = ACTIONS(2772),
    [anon_sym_using] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2772),
    [aux_sym_integer_literal_token1] = ACTIONS(2772),
    [aux_sym_integer_literal_token2] = ACTIONS(2772),
    [aux_sym_integer_literal_token3] = ACTIONS(2772),
    [sym_float_literal] = ACTIONS(2772),
    [sym__unary_operator] = ACTIONS(2772),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(2772),
    [anon_sym_LF] = ACTIONS(2777),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2777),
    [sym__command_start] = ACTIONS(2777),
  },
  [1020] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_end] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_primitive] = ACTIONS(2534),
    [aux_sym_primitive_definition_token1] = ACTIONS(2534),
    [anon_sym_mutable] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_macro] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LT_COLON] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_elseif] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_catch] = ACTIONS(2534),
    [anon_sym_finally] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [sym_break_statement] = ACTIONS(2534),
    [sym_continue_statement] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_quote] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_COLON2] = ACTIONS(2534),
    [anon_sym_begin] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_LT_PIPE] = ACTIONS(2534),
    [anon_sym_PIPE_GT] = ACTIONS(2534),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_isa] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_QMARK] = ACTIONS(2534),
    [anon_sym_EQ_GT] = ACTIONS(2534),
    [anon_sym_LBRACK2] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2534),
    [aux_sym_integer_literal_token1] = ACTIONS(2534),
    [aux_sym_integer_literal_token2] = ACTIONS(2534),
    [aux_sym_integer_literal_token3] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
    [sym__unary_operator] = ACTIONS(2534),
    [sym__power_operator] = ACTIONS(2534),
    [sym__bitshift_operator] = ACTIONS(2534),
    [sym__rational_operator] = ACTIONS(2534),
    [sym__times_operator] = ACTIONS(2534),
    [sym__plus_operator] = ACTIONS(2534),
    [sym__dotty_operator] = ACTIONS(2534),
    [sym__comparison_operator] = ACTIONS(2534),
    [sym__arrow_operator] = ACTIONS(2534),
    [sym__assign_operator] = ACTIONS(2534),
    [anon_sym_LF] = ACTIONS(2536),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2536),
    [sym__command_start] = ACTIONS(2536),
  },
  [1021] = {
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_end] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_primitive] = ACTIONS(2916),
    [aux_sym_primitive_definition_token1] = ACTIONS(2916),
    [anon_sym_mutable] = ACTIONS(2916),
    [anon_sym_struct] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_macro] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2916),
    [anon_sym_COMMA] = ACTIONS(2916),
    [anon_sym_RPAREN] = ACTIONS(2916),
    [anon_sym_SEMI] = ACTIONS(2916),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2916),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_LT_COLON] = ACTIONS(2916),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_elseif] = ACTIONS(2916),
    [anon_sym_else] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_catch] = ACTIONS(2916),
    [anon_sym_finally] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [sym_break_statement] = ACTIONS(2916),
    [sym_continue_statement] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_quote] = ACTIONS(2916),
    [anon_sym_using] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_COLON2] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2916),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_LT_PIPE] = ACTIONS(2916),
    [anon_sym_PIPE_GT] = ACTIONS(2916),
    [anon_sym_in] = ACTIONS(2916),
    [anon_sym_isa] = ACTIONS(2916),
    [anon_sym_PIPE_PIPE] = ACTIONS(2916),
    [anon_sym_AMP_AMP] = ACTIONS(2916),
    [anon_sym_QMARK] = ACTIONS(2916),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_LBRACK2] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2916),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [sym_float_literal] = ACTIONS(2916),
    [sym__unary_operator] = ACTIONS(2916),
    [sym__power_operator] = ACTIONS(2916),
    [sym__bitshift_operator] = ACTIONS(2916),
    [sym__rational_operator] = ACTIONS(2916),
    [sym__times_operator] = ACTIONS(2916),
    [sym__plus_operator] = ACTIONS(2916),
    [sym__dotty_operator] = ACTIONS(2916),
    [sym__comparison_operator] = ACTIONS(2916),
    [sym__arrow_operator] = ACTIONS(2916),
    [sym__assign_operator] = ACTIONS(2916),
    [anon_sym_LF] = ACTIONS(2921),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2921),
    [sym__command_start] = ACTIONS(2921),
  },
  [1022] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_end] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_primitive] = ACTIONS(2498),
    [aux_sym_primitive_definition_token1] = ACTIONS(2498),
    [anon_sym_mutable] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_macro] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2498),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LT_COLON] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_elseif] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_catch] = ACTIONS(2498),
    [anon_sym_finally] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [sym_break_statement] = ACTIONS(2498),
    [sym_continue_statement] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_quote] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_COLON2] = ACTIONS(2498),
    [anon_sym_begin] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_LT_PIPE] = ACTIONS(2498),
    [anon_sym_PIPE_GT] = ACTIONS(2498),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_isa] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_QMARK] = ACTIONS(2498),
    [anon_sym_EQ_GT] = ACTIONS(2498),
    [anon_sym_LBRACK2] = ACTIONS(2498),
    [anon_sym_DOLLAR] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2498),
    [aux_sym_integer_literal_token1] = ACTIONS(2498),
    [aux_sym_integer_literal_token2] = ACTIONS(2498),
    [aux_sym_integer_literal_token3] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
    [sym__unary_operator] = ACTIONS(2498),
    [sym__power_operator] = ACTIONS(2498),
    [sym__bitshift_operator] = ACTIONS(2498),
    [sym__rational_operator] = ACTIONS(2498),
    [sym__times_operator] = ACTIONS(2498),
    [sym__plus_operator] = ACTIONS(2498),
    [sym__dotty_operator] = ACTIONS(2498),
    [sym__comparison_operator] = ACTIONS(2498),
    [sym__arrow_operator] = ACTIONS(2498),
    [sym__assign_operator] = ACTIONS(2498),
    [anon_sym_LF] = ACTIONS(2500),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2500),
    [sym__command_start] = ACTIONS(2500),
  },
  [1023] = {
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3085),
    [anon_sym_end] = ACTIONS(3085),
    [anon_sym_abstract] = ACTIONS(3085),
    [anon_sym_primitive] = ACTIONS(3085),
    [aux_sym_primitive_definition_token1] = ACTIONS(3085),
    [anon_sym_mutable] = ACTIONS(3085),
    [anon_sym_struct] = ACTIONS(3085),
    [anon_sym_module] = ACTIONS(3085),
    [anon_sym_macro] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3085),
    [anon_sym_COMMA] = ACTIONS(3085),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_SEMI] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3085),
    [anon_sym_COLON_COLON] = ACTIONS(3085),
    [anon_sym_LT_COLON] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_elseif] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3085),
    [anon_sym_try] = ACTIONS(3085),
    [anon_sym_catch] = ACTIONS(3085),
    [anon_sym_finally] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [sym_break_statement] = ACTIONS(3085),
    [sym_continue_statement] = ACTIONS(3085),
    [anon_sym_return] = ACTIONS(3085),
    [anon_sym_let] = ACTIONS(3085),
    [anon_sym_const] = ACTIONS(3085),
    [anon_sym_quote] = ACTIONS(3085),
    [anon_sym_using] = ACTIONS(3085),
    [anon_sym_import] = ACTIONS(3085),
    [anon_sym_export] = ACTIONS(3085),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_begin] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_LT_PIPE] = ACTIONS(3085),
    [anon_sym_PIPE_GT] = ACTIONS(3085),
    [anon_sym_in] = ACTIONS(3085),
    [anon_sym_isa] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3085),
    [anon_sym_AMP_AMP] = ACTIONS(3085),
    [anon_sym_QMARK] = ACTIONS(3085),
    [anon_sym_EQ_GT] = ACTIONS(3085),
    [anon_sym_LBRACK2] = ACTIONS(3085),
    [anon_sym_DOLLAR] = ACTIONS(3085),
    [anon_sym_AT] = ACTIONS(3085),
    [aux_sym_integer_literal_token1] = ACTIONS(3085),
    [aux_sym_integer_literal_token2] = ACTIONS(3085),
    [aux_sym_integer_literal_token3] = ACTIONS(3085),
    [sym_float_literal] = ACTIONS(3085),
    [sym__unary_operator] = ACTIONS(3085),
    [sym__power_operator] = ACTIONS(3085),
    [sym__bitshift_operator] = ACTIONS(3085),
    [sym__rational_operator] = ACTIONS(3085),
    [sym__times_operator] = ACTIONS(3085),
    [sym__plus_operator] = ACTIONS(3085),
    [sym__dotty_operator] = ACTIONS(3085),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__arrow_operator] = ACTIONS(3085),
    [sym__assign_operator] = ACTIONS(3085),
    [anon_sym_LF] = ACTIONS(3087),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3087),
    [sym__command_start] = ACTIONS(3087),
  },
  [1024] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_end] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_primitive] = ACTIONS(2542),
    [aux_sym_primitive_definition_token1] = ACTIONS(2542),
    [anon_sym_mutable] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_macro] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2542),
    [anon_sym_RPAREN] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym_EQ] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2542),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LT_COLON] = ACTIONS(2542),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_elseif] = ACTIONS(2542),
    [anon_sym_else] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_catch] = ACTIONS(2542),
    [anon_sym_finally] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [sym_break_statement] = ACTIONS(2542),
    [sym_continue_statement] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_quote] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_COLON2] = ACTIONS(2542),
    [anon_sym_begin] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_LT_PIPE] = ACTIONS(2542),
    [anon_sym_PIPE_GT] = ACTIONS(2542),
    [anon_sym_in] = ACTIONS(2542),
    [anon_sym_isa] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(2542),
    [anon_sym_EQ_GT] = ACTIONS(2542),
    [anon_sym_LBRACK2] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2542),
    [aux_sym_integer_literal_token1] = ACTIONS(2542),
    [aux_sym_integer_literal_token2] = ACTIONS(2542),
    [aux_sym_integer_literal_token3] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
    [sym__unary_operator] = ACTIONS(2542),
    [sym__power_operator] = ACTIONS(2542),
    [sym__bitshift_operator] = ACTIONS(2542),
    [sym__rational_operator] = ACTIONS(2542),
    [sym__times_operator] = ACTIONS(2542),
    [sym__plus_operator] = ACTIONS(2542),
    [sym__dotty_operator] = ACTIONS(2542),
    [sym__comparison_operator] = ACTIONS(2542),
    [sym__arrow_operator] = ACTIONS(2542),
    [sym__assign_operator] = ACTIONS(2542),
    [anon_sym_LF] = ACTIONS(2544),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2544),
    [sym__command_start] = ACTIONS(2544),
  },
  [1025] = {
    [sym_identifier] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3089),
    [anon_sym_end] = ACTIONS(3089),
    [anon_sym_abstract] = ACTIONS(3089),
    [anon_sym_primitive] = ACTIONS(3089),
    [aux_sym_primitive_definition_token1] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(3089),
    [anon_sym_macro] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3089),
    [anon_sym_COMMA] = ACTIONS(3089),
    [anon_sym_RPAREN] = ACTIONS(3089),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3089),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_LT_COLON] = ACTIONS(3089),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_elseif] = ACTIONS(3089),
    [anon_sym_else] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_catch] = ACTIONS(3089),
    [anon_sym_finally] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [sym_break_statement] = ACTIONS(3089),
    [sym_continue_statement] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_let] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_quote] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_import] = ACTIONS(3089),
    [anon_sym_export] = ACTIONS(3089),
    [anon_sym_COLON2] = ACTIONS(3089),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_LT_PIPE] = ACTIONS(3089),
    [anon_sym_PIPE_GT] = ACTIONS(3089),
    [anon_sym_in] = ACTIONS(3089),
    [anon_sym_isa] = ACTIONS(3089),
    [anon_sym_PIPE_PIPE] = ACTIONS(3089),
    [anon_sym_AMP_AMP] = ACTIONS(3089),
    [anon_sym_QMARK] = ACTIONS(3089),
    [anon_sym_EQ_GT] = ACTIONS(3089),
    [anon_sym_LBRACK2] = ACTIONS(3089),
    [anon_sym_DOLLAR] = ACTIONS(3089),
    [anon_sym_AT] = ACTIONS(3089),
    [aux_sym_integer_literal_token1] = ACTIONS(3089),
    [aux_sym_integer_literal_token2] = ACTIONS(3089),
    [aux_sym_integer_literal_token3] = ACTIONS(3089),
    [sym_float_literal] = ACTIONS(3089),
    [sym__unary_operator] = ACTIONS(3089),
    [sym__power_operator] = ACTIONS(3089),
    [sym__bitshift_operator] = ACTIONS(3089),
    [sym__rational_operator] = ACTIONS(3089),
    [sym__times_operator] = ACTIONS(3089),
    [sym__plus_operator] = ACTIONS(3089),
    [sym__dotty_operator] = ACTIONS(3089),
    [sym__comparison_operator] = ACTIONS(3089),
    [sym__arrow_operator] = ACTIONS(3089),
    [sym__assign_operator] = ACTIONS(3089),
    [anon_sym_LF] = ACTIONS(3091),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3091),
    [sym__command_start] = ACTIONS(3091),
  },
  [1026] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_end] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_primitive] = ACTIONS(2554),
    [aux_sym_primitive_definition_token1] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_macro] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2554),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_RPAREN] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LT_COLON] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_elseif] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_catch] = ACTIONS(2554),
    [anon_sym_finally] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [sym_break_statement] = ACTIONS(2554),
    [sym_continue_statement] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_quote] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_COLON2] = ACTIONS(2554),
    [anon_sym_begin] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_LT_PIPE] = ACTIONS(2554),
    [anon_sym_PIPE_GT] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_isa] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_QMARK] = ACTIONS(2554),
    [anon_sym_EQ_GT] = ACTIONS(2554),
    [anon_sym_LBRACK2] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2554),
    [anon_sym_AT] = ACTIONS(2554),
    [aux_sym_integer_literal_token1] = ACTIONS(2554),
    [aux_sym_integer_literal_token2] = ACTIONS(2554),
    [aux_sym_integer_literal_token3] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
    [sym__unary_operator] = ACTIONS(2554),
    [sym__power_operator] = ACTIONS(2554),
    [sym__bitshift_operator] = ACTIONS(2554),
    [sym__rational_operator] = ACTIONS(2554),
    [sym__times_operator] = ACTIONS(2554),
    [sym__plus_operator] = ACTIONS(2554),
    [sym__dotty_operator] = ACTIONS(2554),
    [sym__comparison_operator] = ACTIONS(2554),
    [sym__arrow_operator] = ACTIONS(2554),
    [sym__assign_operator] = ACTIONS(2554),
    [anon_sym_LF] = ACTIONS(2556),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2556),
    [sym__command_start] = ACTIONS(2556),
  },
  [1027] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_primitive] = ACTIONS(2562),
    [aux_sym_primitive_definition_token1] = ACTIONS(2562),
    [anon_sym_mutable] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_macro] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LT_COLON] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_elseif] = ACTIONS(2562),
    [anon_sym_else] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_catch] = ACTIONS(2562),
    [anon_sym_finally] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [sym_break_statement] = ACTIONS(2562),
    [sym_continue_statement] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_quote] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_COLON2] = ACTIONS(2562),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_LT_PIPE] = ACTIONS(2562),
    [anon_sym_PIPE_GT] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_isa] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2562),
    [anon_sym_LBRACK2] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2562),
    [aux_sym_integer_literal_token1] = ACTIONS(2562),
    [aux_sym_integer_literal_token2] = ACTIONS(2562),
    [aux_sym_integer_literal_token3] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
    [sym__unary_operator] = ACTIONS(2562),
    [sym__power_operator] = ACTIONS(2562),
    [sym__bitshift_operator] = ACTIONS(2562),
    [sym__rational_operator] = ACTIONS(2562),
    [sym__times_operator] = ACTIONS(2562),
    [sym__plus_operator] = ACTIONS(2562),
    [sym__dotty_operator] = ACTIONS(2562),
    [sym__comparison_operator] = ACTIONS(2562),
    [sym__arrow_operator] = ACTIONS(2562),
    [sym__assign_operator] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2564),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2564),
    [sym__command_start] = ACTIONS(2564),
  },
  [1028] = {
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_end] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_primitive] = ACTIONS(2720),
    [aux_sym_primitive_definition_token1] = ACTIONS(2720),
    [anon_sym_mutable] = ACTIONS(2720),
    [anon_sym_struct] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_macro] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_COMMA] = ACTIONS(2722),
    [anon_sym_RPAREN] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_EQ] = ACTIONS(2720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2722),
    [anon_sym_COLON_COLON] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_LT_COLON] = ACTIONS(2722),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [sym_break_statement] = ACTIONS(2720),
    [sym_continue_statement] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_quote] = ACTIONS(2720),
    [anon_sym_using] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_DOT] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_COLON2] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_RBRACK] = ACTIONS(2722),
    [anon_sym_begin] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2722),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_LT_PIPE] = ACTIONS(2722),
    [anon_sym_PIPE_GT] = ACTIONS(2722),
    [anon_sym_in] = ACTIONS(2720),
    [anon_sym_isa] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(2722),
    [anon_sym_AMP_AMP] = ACTIONS(2722),
    [anon_sym_QMARK] = ACTIONS(2722),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_LBRACK2] = ACTIONS(2720),
    [anon_sym_DOLLAR] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2722),
    [aux_sym_integer_literal_token1] = ACTIONS(2722),
    [aux_sym_integer_literal_token2] = ACTIONS(2722),
    [aux_sym_integer_literal_token3] = ACTIONS(2720),
    [sym_float_literal] = ACTIONS(2720),
    [sym__unary_operator] = ACTIONS(2720),
    [sym__power_operator] = ACTIONS(2720),
    [sym__bitshift_operator] = ACTIONS(2720),
    [sym__rational_operator] = ACTIONS(2720),
    [sym__times_operator] = ACTIONS(2720),
    [sym__plus_operator] = ACTIONS(2720),
    [sym__dotty_operator] = ACTIONS(2720),
    [sym__comparison_operator] = ACTIONS(2720),
    [sym__arrow_operator] = ACTIONS(2722),
    [sym__assign_operator] = ACTIONS(2720),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2722),
    [sym__string_start] = ACTIONS(2722),
    [sym__command_start] = ACTIONS(2722),
  },
  [1029] = {
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3093),
    [anon_sym_end] = ACTIONS(3093),
    [anon_sym_abstract] = ACTIONS(3093),
    [anon_sym_primitive] = ACTIONS(3093),
    [aux_sym_primitive_definition_token1] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_module] = ACTIONS(3093),
    [anon_sym_macro] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3093),
    [anon_sym_COMMA] = ACTIONS(3093),
    [anon_sym_RPAREN] = ACTIONS(3093),
    [anon_sym_SEMI] = ACTIONS(3093),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3093),
    [anon_sym_COLON_COLON] = ACTIONS(3093),
    [anon_sym_LT_COLON] = ACTIONS(3093),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_elseif] = ACTIONS(3093),
    [anon_sym_else] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_catch] = ACTIONS(3093),
    [anon_sym_finally] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [sym_break_statement] = ACTIONS(3093),
    [sym_continue_statement] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_let] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_quote] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_import] = ACTIONS(3093),
    [anon_sym_export] = ACTIONS(3093),
    [anon_sym_COLON2] = ACTIONS(3093),
    [anon_sym_begin] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_LT_PIPE] = ACTIONS(3093),
    [anon_sym_PIPE_GT] = ACTIONS(3093),
    [anon_sym_in] = ACTIONS(3093),
    [anon_sym_isa] = ACTIONS(3093),
    [anon_sym_PIPE_PIPE] = ACTIONS(3093),
    [anon_sym_AMP_AMP] = ACTIONS(3093),
    [anon_sym_QMARK] = ACTIONS(3093),
    [anon_sym_EQ_GT] = ACTIONS(3093),
    [anon_sym_LBRACK2] = ACTIONS(3093),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(3093),
    [aux_sym_integer_literal_token1] = ACTIONS(3093),
    [aux_sym_integer_literal_token2] = ACTIONS(3093),
    [aux_sym_integer_literal_token3] = ACTIONS(3093),
    [sym_float_literal] = ACTIONS(3093),
    [sym__unary_operator] = ACTIONS(3093),
    [sym__power_operator] = ACTIONS(3093),
    [sym__bitshift_operator] = ACTIONS(3093),
    [sym__rational_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3093),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__dotty_operator] = ACTIONS(3093),
    [sym__comparison_operator] = ACTIONS(3093),
    [sym__arrow_operator] = ACTIONS(3093),
    [sym__assign_operator] = ACTIONS(3093),
    [anon_sym_LF] = ACTIONS(3095),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3095),
    [sym__command_start] = ACTIONS(3095),
  },
  [1030] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_end] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_primitive] = ACTIONS(2526),
    [aux_sym_primitive_definition_token1] = ACTIONS(2526),
    [anon_sym_mutable] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_macro] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_RPAREN] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(2526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LT_COLON] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_elseif] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_catch] = ACTIONS(2526),
    [anon_sym_finally] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [sym_break_statement] = ACTIONS(2526),
    [sym_continue_statement] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_quote] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_COLON2] = ACTIONS(2526),
    [anon_sym_begin] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_LT_PIPE] = ACTIONS(2526),
    [anon_sym_PIPE_GT] = ACTIONS(2526),
    [anon_sym_in] = ACTIONS(2526),
    [anon_sym_isa] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(2526),
    [anon_sym_LBRACK2] = ACTIONS(2526),
    [anon_sym_DOLLAR] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2526),
    [aux_sym_integer_literal_token1] = ACTIONS(2526),
    [aux_sym_integer_literal_token2] = ACTIONS(2526),
    [aux_sym_integer_literal_token3] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
    [sym__unary_operator] = ACTIONS(2526),
    [sym__power_operator] = ACTIONS(2526),
    [sym__bitshift_operator] = ACTIONS(2526),
    [sym__rational_operator] = ACTIONS(2526),
    [sym__times_operator] = ACTIONS(2526),
    [sym__plus_operator] = ACTIONS(2526),
    [sym__dotty_operator] = ACTIONS(2526),
    [sym__comparison_operator] = ACTIONS(2526),
    [sym__arrow_operator] = ACTIONS(2526),
    [sym__assign_operator] = ACTIONS(2526),
    [anon_sym_LF] = ACTIONS(2528),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2528),
    [sym__command_start] = ACTIONS(2528),
  },
  [1031] = {
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3097),
    [anon_sym_end] = ACTIONS(3097),
    [anon_sym_abstract] = ACTIONS(3097),
    [anon_sym_primitive] = ACTIONS(3097),
    [aux_sym_primitive_definition_token1] = ACTIONS(3097),
    [anon_sym_mutable] = ACTIONS(3097),
    [anon_sym_struct] = ACTIONS(3097),
    [anon_sym_module] = ACTIONS(3097),
    [anon_sym_macro] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3097),
    [anon_sym_COMMA] = ACTIONS(3097),
    [anon_sym_RPAREN] = ACTIONS(3097),
    [anon_sym_SEMI] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3097),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_LT_COLON] = ACTIONS(3097),
    [anon_sym_if] = ACTIONS(3097),
    [anon_sym_elseif] = ACTIONS(3097),
    [anon_sym_else] = ACTIONS(3097),
    [anon_sym_try] = ACTIONS(3097),
    [anon_sym_catch] = ACTIONS(3097),
    [anon_sym_finally] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3097),
    [anon_sym_while] = ACTIONS(3097),
    [sym_break_statement] = ACTIONS(3097),
    [sym_continue_statement] = ACTIONS(3097),
    [anon_sym_return] = ACTIONS(3097),
    [anon_sym_let] = ACTIONS(3097),
    [anon_sym_const] = ACTIONS(3097),
    [anon_sym_quote] = ACTIONS(3097),
    [anon_sym_using] = ACTIONS(3097),
    [anon_sym_import] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3097),
    [anon_sym_COLON2] = ACTIONS(3097),
    [anon_sym_begin] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_LT_PIPE] = ACTIONS(3097),
    [anon_sym_PIPE_GT] = ACTIONS(3097),
    [anon_sym_in] = ACTIONS(3097),
    [anon_sym_isa] = ACTIONS(3097),
    [anon_sym_PIPE_PIPE] = ACTIONS(3097),
    [anon_sym_AMP_AMP] = ACTIONS(3097),
    [anon_sym_QMARK] = ACTIONS(3097),
    [anon_sym_EQ_GT] = ACTIONS(3097),
    [anon_sym_LBRACK2] = ACTIONS(3097),
    [anon_sym_DOLLAR] = ACTIONS(3097),
    [anon_sym_AT] = ACTIONS(3097),
    [aux_sym_integer_literal_token1] = ACTIONS(3097),
    [aux_sym_integer_literal_token2] = ACTIONS(3097),
    [aux_sym_integer_literal_token3] = ACTIONS(3097),
    [sym_float_literal] = ACTIONS(3097),
    [sym__unary_operator] = ACTIONS(3097),
    [sym__power_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3097),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__times_operator] = ACTIONS(3097),
    [sym__plus_operator] = ACTIONS(3097),
    [sym__dotty_operator] = ACTIONS(3097),
    [sym__comparison_operator] = ACTIONS(3097),
    [sym__arrow_operator] = ACTIONS(3097),
    [sym__assign_operator] = ACTIONS(3097),
    [anon_sym_LF] = ACTIONS(3099),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3099),
    [sym__command_start] = ACTIONS(3099),
  },
  [1032] = {
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3101),
    [anon_sym_end] = ACTIONS(3101),
    [anon_sym_abstract] = ACTIONS(3101),
    [anon_sym_primitive] = ACTIONS(3101),
    [aux_sym_primitive_definition_token1] = ACTIONS(3101),
    [anon_sym_mutable] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_module] = ACTIONS(3101),
    [anon_sym_macro] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3101),
    [anon_sym_COMMA] = ACTIONS(3101),
    [anon_sym_RPAREN] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3101),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3101),
    [anon_sym_COLON_COLON] = ACTIONS(3101),
    [anon_sym_LT_COLON] = ACTIONS(3101),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_elseif] = ACTIONS(3101),
    [anon_sym_else] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_catch] = ACTIONS(3101),
    [anon_sym_finally] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [sym_break_statement] = ACTIONS(3101),
    [sym_continue_statement] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_let] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_quote] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3101),
    [anon_sym_COLON2] = ACTIONS(3101),
    [anon_sym_begin] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_LT_PIPE] = ACTIONS(3101),
    [anon_sym_PIPE_GT] = ACTIONS(3101),
    [anon_sym_in] = ACTIONS(3101),
    [anon_sym_isa] = ACTIONS(3101),
    [anon_sym_PIPE_PIPE] = ACTIONS(3101),
    [anon_sym_AMP_AMP] = ACTIONS(3101),
    [anon_sym_QMARK] = ACTIONS(3101),
    [anon_sym_EQ_GT] = ACTIONS(3101),
    [anon_sym_LBRACK2] = ACTIONS(3101),
    [anon_sym_DOLLAR] = ACTIONS(3101),
    [anon_sym_AT] = ACTIONS(3101),
    [aux_sym_integer_literal_token1] = ACTIONS(3101),
    [aux_sym_integer_literal_token2] = ACTIONS(3101),
    [aux_sym_integer_literal_token3] = ACTIONS(3101),
    [sym_float_literal] = ACTIONS(3101),
    [sym__unary_operator] = ACTIONS(3101),
    [sym__power_operator] = ACTIONS(3101),
    [sym__bitshift_operator] = ACTIONS(3101),
    [sym__rational_operator] = ACTIONS(3101),
    [sym__times_operator] = ACTIONS(3101),
    [sym__plus_operator] = ACTIONS(3101),
    [sym__dotty_operator] = ACTIONS(3101),
    [sym__comparison_operator] = ACTIONS(3101),
    [sym__arrow_operator] = ACTIONS(3101),
    [sym__assign_operator] = ACTIONS(3101),
    [anon_sym_LF] = ACTIONS(3103),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3103),
    [sym__command_start] = ACTIONS(3103),
  },
  [1033] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_end] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_primitive] = ACTIONS(2674),
    [aux_sym_primitive_definition_token1] = ACTIONS(2674),
    [anon_sym_mutable] = ACTIONS(2674),
    [anon_sym_struct] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_macro] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2676),
    [anon_sym_COMMA] = ACTIONS(2676),
    [anon_sym_RPAREN] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2676),
    [anon_sym_EQ] = ACTIONS(2674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_LT_COLON] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [sym_break_statement] = ACTIONS(2674),
    [sym_continue_statement] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_quote] = ACTIONS(2674),
    [anon_sym_using] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_DOT] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_COLON2] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_RBRACK] = ACTIONS(2676),
    [anon_sym_begin] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_LT_PIPE] = ACTIONS(2676),
    [anon_sym_PIPE_GT] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2674),
    [anon_sym_isa] = ACTIONS(2674),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_QMARK] = ACTIONS(2676),
    [anon_sym_EQ_GT] = ACTIONS(2676),
    [anon_sym_LBRACK2] = ACTIONS(2674),
    [anon_sym_DOLLAR] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2676),
    [aux_sym_integer_literal_token1] = ACTIONS(2676),
    [aux_sym_integer_literal_token2] = ACTIONS(2676),
    [aux_sym_integer_literal_token3] = ACTIONS(2674),
    [sym_float_literal] = ACTIONS(2674),
    [sym__unary_operator] = ACTIONS(2674),
    [sym__power_operator] = ACTIONS(2674),
    [sym__bitshift_operator] = ACTIONS(2674),
    [sym__rational_operator] = ACTIONS(2674),
    [sym__times_operator] = ACTIONS(2674),
    [sym__plus_operator] = ACTIONS(2674),
    [sym__dotty_operator] = ACTIONS(2674),
    [sym__comparison_operator] = ACTIONS(2674),
    [sym__arrow_operator] = ACTIONS(2676),
    [sym__assign_operator] = ACTIONS(2674),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2676),
    [sym__string_start] = ACTIONS(2676),
    [sym__command_start] = ACTIONS(2676),
  },
  [1034] = {
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(2873),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_LT_COLON] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elseif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_catch] = ACTIONS(2871),
    [anon_sym_finally] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_LT_PIPE] = ACTIONS(2871),
    [anon_sym_PIPE_GT] = ACTIONS(2871),
    [anon_sym_in] = ACTIONS(2871),
    [anon_sym_isa] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [anon_sym_QMARK] = ACTIONS(2871),
    [anon_sym_EQ_GT] = ACTIONS(2871),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2871),
    [sym__bitshift_operator] = ACTIONS(2871),
    [sym__rational_operator] = ACTIONS(2871),
    [sym__times_operator] = ACTIONS(2871),
    [sym__plus_operator] = ACTIONS(2871),
    [sym__dotty_operator] = ACTIONS(2871),
    [sym__comparison_operator] = ACTIONS(2871),
    [sym__arrow_operator] = ACTIONS(2871),
    [sym__assign_operator] = ACTIONS(2873),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1035] = {
    [sym_identifier] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3105),
    [anon_sym_end] = ACTIONS(3105),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_primitive] = ACTIONS(3105),
    [aux_sym_primitive_definition_token1] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_module] = ACTIONS(3105),
    [anon_sym_macro] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_COMMA] = ACTIONS(3105),
    [anon_sym_RPAREN] = ACTIONS(3105),
    [anon_sym_SEMI] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3105),
    [anon_sym_COLON_COLON] = ACTIONS(3105),
    [anon_sym_LT_COLON] = ACTIONS(3105),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_elseif] = ACTIONS(3105),
    [anon_sym_else] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_catch] = ACTIONS(3105),
    [anon_sym_finally] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [sym_break_statement] = ACTIONS(3105),
    [sym_continue_statement] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_let] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_quote] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_import] = ACTIONS(3105),
    [anon_sym_export] = ACTIONS(3105),
    [anon_sym_COLON2] = ACTIONS(3105),
    [anon_sym_begin] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_LT_PIPE] = ACTIONS(3105),
    [anon_sym_PIPE_GT] = ACTIONS(3105),
    [anon_sym_in] = ACTIONS(3105),
    [anon_sym_isa] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3105),
    [anon_sym_AMP_AMP] = ACTIONS(3105),
    [anon_sym_QMARK] = ACTIONS(3105),
    [anon_sym_EQ_GT] = ACTIONS(3105),
    [anon_sym_LBRACK2] = ACTIONS(3105),
    [anon_sym_DOLLAR] = ACTIONS(3105),
    [anon_sym_AT] = ACTIONS(3105),
    [aux_sym_integer_literal_token1] = ACTIONS(3105),
    [aux_sym_integer_literal_token2] = ACTIONS(3105),
    [aux_sym_integer_literal_token3] = ACTIONS(3105),
    [sym_float_literal] = ACTIONS(3105),
    [sym__unary_operator] = ACTIONS(3105),
    [sym__power_operator] = ACTIONS(3105),
    [sym__bitshift_operator] = ACTIONS(3105),
    [sym__rational_operator] = ACTIONS(3105),
    [sym__times_operator] = ACTIONS(3105),
    [sym__plus_operator] = ACTIONS(3105),
    [sym__dotty_operator] = ACTIONS(3105),
    [sym__comparison_operator] = ACTIONS(3105),
    [sym__arrow_operator] = ACTIONS(3105),
    [sym__assign_operator] = ACTIONS(3105),
    [anon_sym_LF] = ACTIONS(3107),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3107),
    [sym__command_start] = ACTIONS(3107),
  },
  [1036] = {
    [sym_identifier] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3109),
    [anon_sym_end] = ACTIONS(3109),
    [anon_sym_abstract] = ACTIONS(3109),
    [anon_sym_primitive] = ACTIONS(3109),
    [aux_sym_primitive_definition_token1] = ACTIONS(3109),
    [anon_sym_mutable] = ACTIONS(3109),
    [anon_sym_struct] = ACTIONS(3109),
    [anon_sym_module] = ACTIONS(3109),
    [anon_sym_macro] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3109),
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_RPAREN] = ACTIONS(3109),
    [anon_sym_SEMI] = ACTIONS(3109),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3109),
    [anon_sym_LT_COLON] = ACTIONS(3109),
    [anon_sym_if] = ACTIONS(3109),
    [anon_sym_elseif] = ACTIONS(3109),
    [anon_sym_else] = ACTIONS(3109),
    [anon_sym_try] = ACTIONS(3109),
    [anon_sym_catch] = ACTIONS(3109),
    [anon_sym_finally] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3109),
    [anon_sym_while] = ACTIONS(3109),
    [sym_break_statement] = ACTIONS(3109),
    [sym_continue_statement] = ACTIONS(3109),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_let] = ACTIONS(3109),
    [anon_sym_const] = ACTIONS(3109),
    [anon_sym_quote] = ACTIONS(3109),
    [anon_sym_using] = ACTIONS(3109),
    [anon_sym_import] = ACTIONS(3109),
    [anon_sym_export] = ACTIONS(3109),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_begin] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_LT_PIPE] = ACTIONS(3109),
    [anon_sym_PIPE_GT] = ACTIONS(3109),
    [anon_sym_in] = ACTIONS(3109),
    [anon_sym_isa] = ACTIONS(3109),
    [anon_sym_PIPE_PIPE] = ACTIONS(3109),
    [anon_sym_AMP_AMP] = ACTIONS(3109),
    [anon_sym_QMARK] = ACTIONS(3109),
    [anon_sym_EQ_GT] = ACTIONS(3109),
    [anon_sym_LBRACK2] = ACTIONS(3109),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_AT] = ACTIONS(3109),
    [aux_sym_integer_literal_token1] = ACTIONS(3109),
    [aux_sym_integer_literal_token2] = ACTIONS(3109),
    [aux_sym_integer_literal_token3] = ACTIONS(3109),
    [sym_float_literal] = ACTIONS(3109),
    [sym__unary_operator] = ACTIONS(3109),
    [sym__power_operator] = ACTIONS(3109),
    [sym__bitshift_operator] = ACTIONS(3109),
    [sym__rational_operator] = ACTIONS(3109),
    [sym__times_operator] = ACTIONS(3109),
    [sym__plus_operator] = ACTIONS(3109),
    [sym__dotty_operator] = ACTIONS(3109),
    [sym__comparison_operator] = ACTIONS(3109),
    [sym__arrow_operator] = ACTIONS(3109),
    [sym__assign_operator] = ACTIONS(3109),
    [anon_sym_LF] = ACTIONS(3111),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3111),
    [sym__command_start] = ACTIONS(3111),
  },
  [1037] = {
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3113),
    [anon_sym_end] = ACTIONS(3113),
    [anon_sym_abstract] = ACTIONS(3113),
    [anon_sym_primitive] = ACTIONS(3113),
    [aux_sym_primitive_definition_token1] = ACTIONS(3113),
    [anon_sym_mutable] = ACTIONS(3113),
    [anon_sym_struct] = ACTIONS(3113),
    [anon_sym_module] = ACTIONS(3113),
    [anon_sym_macro] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3113),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_RPAREN] = ACTIONS(3113),
    [anon_sym_SEMI] = ACTIONS(3113),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(3113),
    [anon_sym_elseif] = ACTIONS(3113),
    [anon_sym_else] = ACTIONS(3113),
    [anon_sym_try] = ACTIONS(3113),
    [anon_sym_catch] = ACTIONS(3113),
    [anon_sym_finally] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3113),
    [anon_sym_while] = ACTIONS(3113),
    [sym_break_statement] = ACTIONS(3113),
    [sym_continue_statement] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3113),
    [anon_sym_let] = ACTIONS(3113),
    [anon_sym_const] = ACTIONS(3113),
    [anon_sym_quote] = ACTIONS(3113),
    [anon_sym_using] = ACTIONS(3113),
    [anon_sym_import] = ACTIONS(3113),
    [anon_sym_export] = ACTIONS(3113),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(3113),
    [anon_sym_PIPE_GT] = ACTIONS(3113),
    [anon_sym_in] = ACTIONS(3113),
    [anon_sym_isa] = ACTIONS(3113),
    [anon_sym_PIPE_PIPE] = ACTIONS(3113),
    [anon_sym_AMP_AMP] = ACTIONS(3113),
    [anon_sym_QMARK] = ACTIONS(3113),
    [anon_sym_EQ_GT] = ACTIONS(3113),
    [anon_sym_LBRACK2] = ACTIONS(3113),
    [anon_sym_DOLLAR] = ACTIONS(3113),
    [anon_sym_AT] = ACTIONS(3113),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [sym_float_literal] = ACTIONS(3113),
    [sym__unary_operator] = ACTIONS(3113),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(3113),
    [sym__arrow_operator] = ACTIONS(3113),
    [sym__assign_operator] = ACTIONS(3113),
    [anon_sym_LF] = ACTIONS(3115),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3115),
    [sym__command_start] = ACTIONS(3115),
  },
  [1038] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_primitive] = ACTIONS(2582),
    [aux_sym_primitive_definition_token1] = ACTIONS(2582),
    [anon_sym_mutable] = ACTIONS(2582),
    [anon_sym_struct] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_macro] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LT_COLON] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_elseif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_catch] = ACTIONS(2582),
    [anon_sym_finally] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [sym_break_statement] = ACTIONS(2582),
    [sym_continue_statement] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_quote] = ACTIONS(2582),
    [anon_sym_using] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_COLON2] = ACTIONS(2582),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_LT_PIPE] = ACTIONS(2582),
    [anon_sym_PIPE_GT] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_isa] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2582),
    [anon_sym_LBRACK2] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2582),
    [aux_sym_integer_literal_token1] = ACTIONS(2582),
    [aux_sym_integer_literal_token2] = ACTIONS(2582),
    [aux_sym_integer_literal_token3] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
    [sym__unary_operator] = ACTIONS(2582),
    [sym__power_operator] = ACTIONS(2582),
    [sym__bitshift_operator] = ACTIONS(2582),
    [sym__rational_operator] = ACTIONS(2582),
    [sym__times_operator] = ACTIONS(2582),
    [sym__plus_operator] = ACTIONS(2582),
    [sym__dotty_operator] = ACTIONS(2582),
    [sym__comparison_operator] = ACTIONS(2582),
    [sym__arrow_operator] = ACTIONS(2582),
    [sym__assign_operator] = ACTIONS(2582),
    [anon_sym_LF] = ACTIONS(2584),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2584),
    [sym__command_start] = ACTIONS(2584),
  },
  [1039] = {
    [sym_identifier] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_primitive] = ACTIONS(304),
    [aux_sym_primitive_definition_token1] = ACTIONS(304),
    [anon_sym_mutable] = ACTIONS(304),
    [anon_sym_struct] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_macro] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_catch] = ACTIONS(304),
    [anon_sym_finally] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [sym_break_statement] = ACTIONS(304),
    [sym_continue_statement] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_quote] = ACTIONS(304),
    [anon_sym_using] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_COLON2] = ACTIONS(304),
    [anon_sym_begin] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(304),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(304),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(304),
    [aux_sym_integer_literal_token1] = ACTIONS(304),
    [aux_sym_integer_literal_token2] = ACTIONS(304),
    [aux_sym_integer_literal_token3] = ACTIONS(304),
    [sym_float_literal] = ACTIONS(304),
    [sym__unary_operator] = ACTIONS(304),
    [sym__power_operator] = ACTIONS(304),
    [sym__bitshift_operator] = ACTIONS(304),
    [sym__rational_operator] = ACTIONS(304),
    [sym__times_operator] = ACTIONS(304),
    [sym__plus_operator] = ACTIONS(304),
    [sym__dotty_operator] = ACTIONS(304),
    [sym__comparison_operator] = ACTIONS(304),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(306),
    [sym__command_start] = ACTIONS(306),
  },
  [1040] = {
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3117),
    [anon_sym_end] = ACTIONS(3117),
    [anon_sym_abstract] = ACTIONS(3117),
    [anon_sym_primitive] = ACTIONS(3117),
    [aux_sym_primitive_definition_token1] = ACTIONS(3117),
    [anon_sym_mutable] = ACTIONS(3117),
    [anon_sym_struct] = ACTIONS(3117),
    [anon_sym_module] = ACTIONS(3117),
    [anon_sym_macro] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3117),
    [anon_sym_COMMA] = ACTIONS(3117),
    [anon_sym_RPAREN] = ACTIONS(3117),
    [anon_sym_SEMI] = ACTIONS(3117),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(3117),
    [anon_sym_elseif] = ACTIONS(3117),
    [anon_sym_else] = ACTIONS(3117),
    [anon_sym_try] = ACTIONS(3117),
    [anon_sym_catch] = ACTIONS(3117),
    [anon_sym_finally] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_while] = ACTIONS(3117),
    [sym_break_statement] = ACTIONS(3117),
    [sym_continue_statement] = ACTIONS(3117),
    [anon_sym_return] = ACTIONS(3117),
    [anon_sym_let] = ACTIONS(3117),
    [anon_sym_const] = ACTIONS(3117),
    [anon_sym_quote] = ACTIONS(3117),
    [anon_sym_using] = ACTIONS(3117),
    [anon_sym_import] = ACTIONS(3117),
    [anon_sym_export] = ACTIONS(3117),
    [anon_sym_COLON2] = ACTIONS(3119),
    [anon_sym_begin] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(3119),
    [anon_sym_PIPE_GT] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(3119),
    [anon_sym_isa] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_EQ_GT] = ACTIONS(3119),
    [anon_sym_LBRACK2] = ACTIONS(3117),
    [anon_sym_DOLLAR] = ACTIONS(3117),
    [anon_sym_AT] = ACTIONS(3117),
    [aux_sym_integer_literal_token1] = ACTIONS(3117),
    [aux_sym_integer_literal_token2] = ACTIONS(3117),
    [aux_sym_integer_literal_token3] = ACTIONS(3117),
    [sym_float_literal] = ACTIONS(3117),
    [sym__unary_operator] = ACTIONS(3117),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(3119),
    [sym__comparison_operator] = ACTIONS(3119),
    [sym__arrow_operator] = ACTIONS(3119),
    [sym__assign_operator] = ACTIONS(3117),
    [anon_sym_LF] = ACTIONS(3121),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3121),
    [sym__command_start] = ACTIONS(3121),
  },
  [1041] = {
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_end] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_primitive] = ACTIONS(2682),
    [aux_sym_primitive_definition_token1] = ACTIONS(2682),
    [anon_sym_mutable] = ACTIONS(2682),
    [anon_sym_struct] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_macro] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2684),
    [anon_sym_COMMA] = ACTIONS(2684),
    [anon_sym_RPAREN] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2684),
    [anon_sym_EQ] = ACTIONS(2682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_LT_COLON] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [sym_break_statement] = ACTIONS(2682),
    [sym_continue_statement] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_quote] = ACTIONS(2682),
    [anon_sym_using] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_DOT] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_COLON2] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_RBRACK] = ACTIONS(2684),
    [anon_sym_begin] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_LT_PIPE] = ACTIONS(2684),
    [anon_sym_PIPE_GT] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2682),
    [anon_sym_isa] = ACTIONS(2682),
    [anon_sym_PIPE_PIPE] = ACTIONS(2684),
    [anon_sym_AMP_AMP] = ACTIONS(2684),
    [anon_sym_QMARK] = ACTIONS(2684),
    [anon_sym_EQ_GT] = ACTIONS(2684),
    [anon_sym_LBRACK2] = ACTIONS(2682),
    [anon_sym_DOLLAR] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2684),
    [aux_sym_integer_literal_token1] = ACTIONS(2684),
    [aux_sym_integer_literal_token2] = ACTIONS(2684),
    [aux_sym_integer_literal_token3] = ACTIONS(2682),
    [sym_float_literal] = ACTIONS(2682),
    [sym__unary_operator] = ACTIONS(2682),
    [sym__power_operator] = ACTIONS(2682),
    [sym__bitshift_operator] = ACTIONS(2682),
    [sym__rational_operator] = ACTIONS(2682),
    [sym__times_operator] = ACTIONS(2682),
    [sym__plus_operator] = ACTIONS(2682),
    [sym__dotty_operator] = ACTIONS(2682),
    [sym__comparison_operator] = ACTIONS(2682),
    [sym__arrow_operator] = ACTIONS(2684),
    [sym__assign_operator] = ACTIONS(2682),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2684),
    [sym__string_start] = ACTIONS(2684),
    [sym__command_start] = ACTIONS(2684),
  },
  [1042] = {
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_function] = ACTIONS(2612),
    [anon_sym_end] = ACTIONS(2612),
    [anon_sym_abstract] = ACTIONS(2612),
    [anon_sym_primitive] = ACTIONS(2612),
    [aux_sym_primitive_definition_token1] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2612),
    [anon_sym_macro] = ACTIONS(2612),
    [anon_sym_LPAREN] = ACTIONS(2614),
    [anon_sym_COMMA] = ACTIONS(2614),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_EQ] = ACTIONS(2612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2614),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [anon_sym_LT_COLON] = ACTIONS(2614),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [sym_break_statement] = ACTIONS(2612),
    [sym_continue_statement] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_quote] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_import] = ACTIONS(2612),
    [anon_sym_DOT] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2612),
    [anon_sym_COLON2] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2614),
    [anon_sym_RBRACK] = ACTIONS(2614),
    [anon_sym_begin] = ACTIONS(2612),
    [anon_sym_SQUOTE] = ACTIONS(2614),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_LT_PIPE] = ACTIONS(2614),
    [anon_sym_PIPE_GT] = ACTIONS(2614),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_isa] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_QMARK] = ACTIONS(2614),
    [anon_sym_EQ_GT] = ACTIONS(2614),
    [anon_sym_LBRACK2] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2612),
    [anon_sym_AT] = ACTIONS(2614),
    [aux_sym_integer_literal_token1] = ACTIONS(2614),
    [aux_sym_integer_literal_token2] = ACTIONS(2614),
    [aux_sym_integer_literal_token3] = ACTIONS(2612),
    [sym_float_literal] = ACTIONS(2612),
    [sym__unary_operator] = ACTIONS(2612),
    [sym__power_operator] = ACTIONS(2612),
    [sym__bitshift_operator] = ACTIONS(2612),
    [sym__rational_operator] = ACTIONS(2612),
    [sym__times_operator] = ACTIONS(2612),
    [sym__plus_operator] = ACTIONS(2612),
    [sym__dotty_operator] = ACTIONS(2612),
    [sym__comparison_operator] = ACTIONS(2612),
    [sym__arrow_operator] = ACTIONS(2614),
    [sym__assign_operator] = ACTIONS(2612),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2614),
    [sym__string_start] = ACTIONS(2614),
    [sym__command_start] = ACTIONS(2614),
  },
  [1043] = {
    [sym_do_clause] = STATE(1197),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_end] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_primitive] = ACTIONS(2486),
    [aux_sym_primitive_definition_token1] = ACTIONS(2486),
    [anon_sym_mutable] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_macro] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_COMMA] = ACTIONS(2488),
    [anon_sym_RPAREN] = ACTIONS(2488),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2488),
    [anon_sym_COLON_COLON] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_LT_COLON] = ACTIONS(2488),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [sym_break_statement] = ACTIONS(2486),
    [sym_continue_statement] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_quote] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_COLON2] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_RBRACK] = ACTIONS(2488),
    [anon_sym_begin] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(3045),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_LT_PIPE] = ACTIONS(2488),
    [anon_sym_PIPE_GT] = ACTIONS(2488),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_isa] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2488),
    [anon_sym_AMP_AMP] = ACTIONS(2488),
    [anon_sym_QMARK] = ACTIONS(2488),
    [anon_sym_EQ_GT] = ACTIONS(2488),
    [anon_sym_LBRACK2] = ACTIONS(2486),
    [anon_sym_DOLLAR] = ACTIONS(2488),
    [anon_sym_AT] = ACTIONS(2488),
    [aux_sym_integer_literal_token1] = ACTIONS(2488),
    [aux_sym_integer_literal_token2] = ACTIONS(2488),
    [aux_sym_integer_literal_token3] = ACTIONS(2486),
    [sym_float_literal] = ACTIONS(2486),
    [sym__unary_operator] = ACTIONS(2486),
    [sym__power_operator] = ACTIONS(2488),
    [sym__bitshift_operator] = ACTIONS(2488),
    [sym__rational_operator] = ACTIONS(2488),
    [sym__times_operator] = ACTIONS(2486),
    [sym__plus_operator] = ACTIONS(2486),
    [sym__dotty_operator] = ACTIONS(2486),
    [sym__comparison_operator] = ACTIONS(2486),
    [sym__arrow_operator] = ACTIONS(2488),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2488),
    [sym__string_start] = ACTIONS(2488),
    [sym__command_start] = ACTIONS(2488),
  },
  [1044] = {
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_function] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_abstract] = ACTIONS(2616),
    [anon_sym_primitive] = ACTIONS(2616),
    [aux_sym_primitive_definition_token1] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_macro] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_LT_COLON] = ACTIONS(2618),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [sym_break_statement] = ACTIONS(2616),
    [sym_continue_statement] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_let] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_quote] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_import] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2616),
    [anon_sym_COLON2] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2618),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_LT_PIPE] = ACTIONS(2618),
    [anon_sym_PIPE_GT] = ACTIONS(2618),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_isa] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK2] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_AT] = ACTIONS(2618),
    [aux_sym_integer_literal_token1] = ACTIONS(2618),
    [aux_sym_integer_literal_token2] = ACTIONS(2618),
    [aux_sym_integer_literal_token3] = ACTIONS(2616),
    [sym_float_literal] = ACTIONS(2616),
    [sym__unary_operator] = ACTIONS(2616),
    [sym__power_operator] = ACTIONS(2616),
    [sym__bitshift_operator] = ACTIONS(2616),
    [sym__rational_operator] = ACTIONS(2616),
    [sym__times_operator] = ACTIONS(2616),
    [sym__plus_operator] = ACTIONS(2616),
    [sym__dotty_operator] = ACTIONS(2616),
    [sym__comparison_operator] = ACTIONS(2616),
    [sym__arrow_operator] = ACTIONS(2618),
    [sym__assign_operator] = ACTIONS(2616),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__command_start] = ACTIONS(2618),
  },
  [1045] = {
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_end] = ACTIONS(3123),
    [anon_sym_abstract] = ACTIONS(3123),
    [anon_sym_primitive] = ACTIONS(3123),
    [aux_sym_primitive_definition_token1] = ACTIONS(3123),
    [anon_sym_mutable] = ACTIONS(3123),
    [anon_sym_struct] = ACTIONS(3123),
    [anon_sym_module] = ACTIONS(3123),
    [anon_sym_macro] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3123),
    [anon_sym_COMMA] = ACTIONS(3123),
    [anon_sym_RPAREN] = ACTIONS(3123),
    [anon_sym_SEMI] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3123),
    [anon_sym_COLON_COLON] = ACTIONS(3123),
    [anon_sym_LT_COLON] = ACTIONS(3123),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_elseif] = ACTIONS(3123),
    [anon_sym_else] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_catch] = ACTIONS(3123),
    [anon_sym_finally] = ACTIONS(3123),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [sym_break_statement] = ACTIONS(3123),
    [sym_continue_statement] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_const] = ACTIONS(3123),
    [anon_sym_quote] = ACTIONS(3123),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_import] = ACTIONS(3123),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_COLON2] = ACTIONS(3123),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_SQUOTE] = ACTIONS(3123),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_LT_PIPE] = ACTIONS(3123),
    [anon_sym_PIPE_GT] = ACTIONS(3123),
    [anon_sym_in] = ACTIONS(3123),
    [anon_sym_isa] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3123),
    [anon_sym_AMP_AMP] = ACTIONS(3123),
    [anon_sym_QMARK] = ACTIONS(3123),
    [anon_sym_EQ_GT] = ACTIONS(3123),
    [anon_sym_LBRACK2] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_AT] = ACTIONS(3123),
    [aux_sym_integer_literal_token1] = ACTIONS(3123),
    [aux_sym_integer_literal_token2] = ACTIONS(3123),
    [aux_sym_integer_literal_token3] = ACTIONS(3123),
    [sym_float_literal] = ACTIONS(3123),
    [sym__unary_operator] = ACTIONS(3123),
    [sym__power_operator] = ACTIONS(3123),
    [sym__bitshift_operator] = ACTIONS(3123),
    [sym__rational_operator] = ACTIONS(3123),
    [sym__times_operator] = ACTIONS(3123),
    [sym__plus_operator] = ACTIONS(3123),
    [sym__dotty_operator] = ACTIONS(3123),
    [sym__comparison_operator] = ACTIONS(3123),
    [sym__arrow_operator] = ACTIONS(3123),
    [sym__assign_operator] = ACTIONS(3123),
    [anon_sym_LF] = ACTIONS(3125),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3125),
    [sym__command_start] = ACTIONS(3125),
  },
  [1046] = {
    [sym_do_clause] = STATE(1281),
    [sym_identifier] = ACTIONS(2480),
    [anon_sym_function] = ACTIONS(2480),
    [anon_sym_end] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2480),
    [anon_sym_primitive] = ACTIONS(2480),
    [aux_sym_primitive_definition_token1] = ACTIONS(2480),
    [anon_sym_mutable] = ACTIONS(2480),
    [anon_sym_struct] = ACTIONS(2480),
    [anon_sym_module] = ACTIONS(2480),
    [anon_sym_macro] = ACTIONS(2480),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_COMMA] = ACTIONS(2480),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2480),
    [anon_sym_COLON_COLON] = ACTIONS(2480),
    [anon_sym_LT_COLON] = ACTIONS(2480),
    [anon_sym_if] = ACTIONS(2480),
    [anon_sym_elseif] = ACTIONS(2480),
    [anon_sym_else] = ACTIONS(2480),
    [anon_sym_try] = ACTIONS(2480),
    [anon_sym_for] = ACTIONS(2480),
    [anon_sym_while] = ACTIONS(2480),
    [sym_break_statement] = ACTIONS(2480),
    [sym_continue_statement] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2480),
    [anon_sym_let] = ACTIONS(2480),
    [anon_sym_const] = ACTIONS(2480),
    [anon_sym_quote] = ACTIONS(2480),
    [anon_sym_using] = ACTIONS(2480),
    [anon_sym_import] = ACTIONS(2480),
    [anon_sym_DOT] = ACTIONS(2480),
    [anon_sym_export] = ACTIONS(2480),
    [anon_sym_COLON2] = ACTIONS(2480),
    [anon_sym_LBRACK] = ACTIONS(2482),
    [anon_sym_begin] = ACTIONS(2480),
    [anon_sym_do] = ACTIONS(3079),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [anon_sym_PLUS] = ACTIONS(2480),
    [anon_sym_LT_PIPE] = ACTIONS(2480),
    [anon_sym_PIPE_GT] = ACTIONS(2480),
    [anon_sym_in] = ACTIONS(2480),
    [anon_sym_isa] = ACTIONS(2480),
    [anon_sym_PIPE_PIPE] = ACTIONS(2480),
    [anon_sym_AMP_AMP] = ACTIONS(2480),
    [anon_sym_QMARK] = ACTIONS(2480),
    [anon_sym_EQ_GT] = ACTIONS(2480),
    [anon_sym_LBRACK2] = ACTIONS(2480),
    [anon_sym_DOLLAR] = ACTIONS(2480),
    [anon_sym_AT] = ACTIONS(2480),
    [aux_sym_integer_literal_token1] = ACTIONS(2480),
    [aux_sym_integer_literal_token2] = ACTIONS(2480),
    [aux_sym_integer_literal_token3] = ACTIONS(2480),
    [sym_float_literal] = ACTIONS(2480),
    [sym__unary_operator] = ACTIONS(2480),
    [sym__power_operator] = ACTIONS(2480),
    [sym__bitshift_operator] = ACTIONS(2480),
    [sym__rational_operator] = ACTIONS(2480),
    [sym__times_operator] = ACTIONS(2480),
    [sym__plus_operator] = ACTIONS(2480),
    [sym__dotty_operator] = ACTIONS(2480),
    [sym__comparison_operator] = ACTIONS(2480),
    [sym__arrow_operator] = ACTIONS(2480),
    [anon_sym_LF] = ACTIONS(2482),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2482),
    [sym__string_start] = ACTIONS(2482),
    [sym__command_start] = ACTIONS(2482),
  },
  [1047] = {
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_primitive] = ACTIONS(2624),
    [aux_sym_primitive_definition_token1] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_macro] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_LT_COLON] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [sym_break_statement] = ACTIONS(2624),
    [sym_continue_statement] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_quote] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_COLON2] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_SQUOTE] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_LT_PIPE] = ACTIONS(2626),
    [anon_sym_PIPE_GT] = ACTIONS(2626),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_isa] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2626),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK2] = ACTIONS(2624),
    [anon_sym_DOLLAR] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(2626),
    [aux_sym_integer_literal_token1] = ACTIONS(2626),
    [aux_sym_integer_literal_token2] = ACTIONS(2626),
    [aux_sym_integer_literal_token3] = ACTIONS(2624),
    [sym_float_literal] = ACTIONS(2624),
    [sym__unary_operator] = ACTIONS(2624),
    [sym__power_operator] = ACTIONS(2624),
    [sym__bitshift_operator] = ACTIONS(2624),
    [sym__rational_operator] = ACTIONS(2624),
    [sym__times_operator] = ACTIONS(2624),
    [sym__plus_operator] = ACTIONS(2624),
    [sym__dotty_operator] = ACTIONS(2624),
    [sym__comparison_operator] = ACTIONS(2624),
    [sym__arrow_operator] = ACTIONS(2626),
    [sym__assign_operator] = ACTIONS(2624),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__command_start] = ACTIONS(2626),
  },
  [1048] = {
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_function] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_primitive] = ACTIONS(2628),
    [aux_sym_primitive_definition_token1] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_macro] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_LT_COLON] = ACTIONS(2630),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [sym_break_statement] = ACTIONS(2628),
    [sym_continue_statement] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_quote] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_COLON2] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_LT_PIPE] = ACTIONS(2630),
    [anon_sym_PIPE_GT] = ACTIONS(2630),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_isa] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK2] = ACTIONS(2628),
    [anon_sym_DOLLAR] = ACTIONS(2628),
    [anon_sym_AT] = ACTIONS(2630),
    [aux_sym_integer_literal_token1] = ACTIONS(2630),
    [aux_sym_integer_literal_token2] = ACTIONS(2630),
    [aux_sym_integer_literal_token3] = ACTIONS(2628),
    [sym_float_literal] = ACTIONS(2628),
    [sym__unary_operator] = ACTIONS(2628),
    [sym__power_operator] = ACTIONS(2628),
    [sym__bitshift_operator] = ACTIONS(2628),
    [sym__rational_operator] = ACTIONS(2628),
    [sym__times_operator] = ACTIONS(2628),
    [sym__plus_operator] = ACTIONS(2628),
    [sym__dotty_operator] = ACTIONS(2628),
    [sym__comparison_operator] = ACTIONS(2628),
    [sym__arrow_operator] = ACTIONS(2630),
    [sym__assign_operator] = ACTIONS(2628),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__command_start] = ACTIONS(2630),
  },
  [1049] = {
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_primitive] = ACTIONS(2632),
    [aux_sym_primitive_definition_token1] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_macro] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_LT_COLON] = ACTIONS(2634),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [sym_break_statement] = ACTIONS(2632),
    [sym_continue_statement] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_quote] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_COLON2] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_LT_PIPE] = ACTIONS(2634),
    [anon_sym_PIPE_GT] = ACTIONS(2634),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_isa] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2634),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK2] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2634),
    [aux_sym_integer_literal_token1] = ACTIONS(2634),
    [aux_sym_integer_literal_token2] = ACTIONS(2634),
    [aux_sym_integer_literal_token3] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__unary_operator] = ACTIONS(2632),
    [sym__power_operator] = ACTIONS(2632),
    [sym__bitshift_operator] = ACTIONS(2632),
    [sym__rational_operator] = ACTIONS(2632),
    [sym__times_operator] = ACTIONS(2632),
    [sym__plus_operator] = ACTIONS(2632),
    [sym__dotty_operator] = ACTIONS(2632),
    [sym__comparison_operator] = ACTIONS(2632),
    [sym__arrow_operator] = ACTIONS(2634),
    [sym__assign_operator] = ACTIONS(2632),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__command_start] = ACTIONS(2634),
  },
  [1050] = {
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_end] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_primitive] = ACTIONS(2636),
    [aux_sym_primitive_definition_token1] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_macro] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_LT_COLON] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [sym_break_statement] = ACTIONS(2636),
    [sym_continue_statement] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_quote] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_COLON2] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_RBRACK] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_LT_PIPE] = ACTIONS(2638),
    [anon_sym_PIPE_GT] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_isa] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_EQ_GT] = ACTIONS(2638),
    [anon_sym_LBRACK2] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2638),
    [aux_sym_integer_literal_token1] = ACTIONS(2638),
    [aux_sym_integer_literal_token2] = ACTIONS(2638),
    [aux_sym_integer_literal_token3] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__unary_operator] = ACTIONS(2636),
    [sym__power_operator] = ACTIONS(2636),
    [sym__bitshift_operator] = ACTIONS(2636),
    [sym__rational_operator] = ACTIONS(2636),
    [sym__times_operator] = ACTIONS(2636),
    [sym__plus_operator] = ACTIONS(2636),
    [sym__dotty_operator] = ACTIONS(2636),
    [sym__comparison_operator] = ACTIONS(2636),
    [sym__arrow_operator] = ACTIONS(2638),
    [sym__assign_operator] = ACTIONS(2636),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__command_start] = ACTIONS(2638),
  },
  [1051] = {
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_end] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_primitive] = ACTIONS(2666),
    [aux_sym_primitive_definition_token1] = ACTIONS(2666),
    [anon_sym_mutable] = ACTIONS(2666),
    [anon_sym_struct] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_macro] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2668),
    [anon_sym_COMMA] = ACTIONS(2668),
    [anon_sym_RPAREN] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2668),
    [anon_sym_EQ] = ACTIONS(2666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2668),
    [anon_sym_COLON_COLON] = ACTIONS(2668),
    [anon_sym_RBRACE] = ACTIONS(2668),
    [anon_sym_LT_COLON] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [sym_break_statement] = ACTIONS(2666),
    [sym_continue_statement] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_quote] = ACTIONS(2666),
    [anon_sym_using] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_DOT] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_COLON2] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_RBRACK] = ACTIONS(2668),
    [anon_sym_begin] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_LT_PIPE] = ACTIONS(2668),
    [anon_sym_PIPE_GT] = ACTIONS(2668),
    [anon_sym_in] = ACTIONS(2666),
    [anon_sym_isa] = ACTIONS(2666),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_QMARK] = ACTIONS(2668),
    [anon_sym_EQ_GT] = ACTIONS(2668),
    [anon_sym_LBRACK2] = ACTIONS(2666),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [anon_sym_AT] = ACTIONS(2668),
    [aux_sym_integer_literal_token1] = ACTIONS(2668),
    [aux_sym_integer_literal_token2] = ACTIONS(2668),
    [aux_sym_integer_literal_token3] = ACTIONS(2666),
    [sym_float_literal] = ACTIONS(2666),
    [sym__unary_operator] = ACTIONS(2666),
    [sym__power_operator] = ACTIONS(2666),
    [sym__bitshift_operator] = ACTIONS(2666),
    [sym__rational_operator] = ACTIONS(2666),
    [sym__times_operator] = ACTIONS(2666),
    [sym__plus_operator] = ACTIONS(2666),
    [sym__dotty_operator] = ACTIONS(2666),
    [sym__comparison_operator] = ACTIONS(2666),
    [sym__arrow_operator] = ACTIONS(2668),
    [sym__assign_operator] = ACTIONS(2666),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2668),
    [sym__string_start] = ACTIONS(2668),
    [sym__command_start] = ACTIONS(2668),
  },
  [1052] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_end] = ACTIONS(3127),
    [anon_sym_abstract] = ACTIONS(3127),
    [anon_sym_primitive] = ACTIONS(3127),
    [aux_sym_primitive_definition_token1] = ACTIONS(3127),
    [anon_sym_mutable] = ACTIONS(3127),
    [anon_sym_struct] = ACTIONS(3127),
    [anon_sym_module] = ACTIONS(3127),
    [anon_sym_macro] = ACTIONS(3127),
    [anon_sym_LPAREN] = ACTIONS(3127),
    [anon_sym_COMMA] = ACTIONS(3127),
    [anon_sym_RPAREN] = ACTIONS(3127),
    [anon_sym_SEMI] = ACTIONS(3127),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_elseif] = ACTIONS(3127),
    [anon_sym_else] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_catch] = ACTIONS(3127),
    [anon_sym_finally] = ACTIONS(3127),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [sym_break_statement] = ACTIONS(3127),
    [sym_continue_statement] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_const] = ACTIONS(3127),
    [anon_sym_quote] = ACTIONS(3127),
    [anon_sym_using] = ACTIONS(3127),
    [anon_sym_import] = ACTIONS(3127),
    [anon_sym_export] = ACTIONS(3127),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_GT] = ACTIONS(3127),
    [anon_sym_in] = ACTIONS(3127),
    [anon_sym_isa] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3127),
    [anon_sym_AMP_AMP] = ACTIONS(3127),
    [anon_sym_QMARK] = ACTIONS(3127),
    [anon_sym_EQ_GT] = ACTIONS(3127),
    [anon_sym_LBRACK2] = ACTIONS(3127),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_AT] = ACTIONS(3127),
    [aux_sym_integer_literal_token1] = ACTIONS(3127),
    [aux_sym_integer_literal_token2] = ACTIONS(3127),
    [aux_sym_integer_literal_token3] = ACTIONS(3127),
    [sym_float_literal] = ACTIONS(3127),
    [sym__unary_operator] = ACTIONS(3127),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(3127),
    [sym__arrow_operator] = ACTIONS(3127),
    [sym__assign_operator] = ACTIONS(3127),
    [anon_sym_LF] = ACTIONS(3129),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3129),
    [sym__command_start] = ACTIONS(3129),
  },
  [1053] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_end] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_primitive] = ACTIONS(2670),
    [aux_sym_primitive_definition_token1] = ACTIONS(2670),
    [anon_sym_mutable] = ACTIONS(2670),
    [anon_sym_struct] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_macro] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_COMMA] = ACTIONS(2670),
    [anon_sym_RPAREN] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_EQ] = ACTIONS(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2670),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LT_COLON] = ACTIONS(2670),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_elseif] = ACTIONS(2670),
    [anon_sym_else] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_catch] = ACTIONS(2670),
    [anon_sym_finally] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [sym_break_statement] = ACTIONS(2670),
    [sym_continue_statement] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_quote] = ACTIONS(2670),
    [anon_sym_using] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_COLON2] = ACTIONS(2670),
    [anon_sym_begin] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_LT_PIPE] = ACTIONS(2670),
    [anon_sym_PIPE_GT] = ACTIONS(2670),
    [anon_sym_in] = ACTIONS(2670),
    [anon_sym_isa] = ACTIONS(2670),
    [anon_sym_PIPE_PIPE] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_QMARK] = ACTIONS(2670),
    [anon_sym_EQ_GT] = ACTIONS(2670),
    [anon_sym_LBRACK2] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2670),
    [aux_sym_integer_literal_token1] = ACTIONS(2670),
    [aux_sym_integer_literal_token2] = ACTIONS(2670),
    [aux_sym_integer_literal_token3] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
    [sym__unary_operator] = ACTIONS(2670),
    [sym__power_operator] = ACTIONS(2670),
    [sym__bitshift_operator] = ACTIONS(2670),
    [sym__rational_operator] = ACTIONS(2670),
    [sym__times_operator] = ACTIONS(2670),
    [sym__plus_operator] = ACTIONS(2670),
    [sym__dotty_operator] = ACTIONS(2670),
    [sym__comparison_operator] = ACTIONS(2670),
    [sym__arrow_operator] = ACTIONS(2670),
    [sym__assign_operator] = ACTIONS(2670),
    [anon_sym_LF] = ACTIONS(2672),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2672),
    [sym__command_start] = ACTIONS(2672),
  },
  [1054] = {
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_end] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_primitive] = ACTIONS(2817),
    [aux_sym_primitive_definition_token1] = ACTIONS(2817),
    [anon_sym_mutable] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_macro] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2817),
    [anon_sym_RPAREN] = ACTIONS(2817),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2817),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LT_COLON] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_elseif] = ACTIONS(2817),
    [anon_sym_else] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_catch] = ACTIONS(2817),
    [anon_sym_finally] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [sym_break_statement] = ACTIONS(2817),
    [sym_continue_statement] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_quote] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_COLON2] = ACTIONS(2817),
    [anon_sym_begin] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_LT_PIPE] = ACTIONS(2817),
    [anon_sym_PIPE_GT] = ACTIONS(2817),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_isa] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(2817),
    [anon_sym_LBRACK2] = ACTIONS(2817),
    [anon_sym_DOLLAR] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2817),
    [aux_sym_integer_literal_token1] = ACTIONS(2817),
    [aux_sym_integer_literal_token2] = ACTIONS(2817),
    [aux_sym_integer_literal_token3] = ACTIONS(2817),
    [sym_float_literal] = ACTIONS(2817),
    [sym__unary_operator] = ACTIONS(2817),
    [sym__power_operator] = ACTIONS(2817),
    [sym__bitshift_operator] = ACTIONS(2817),
    [sym__rational_operator] = ACTIONS(2817),
    [sym__times_operator] = ACTIONS(2817),
    [sym__plus_operator] = ACTIONS(2817),
    [sym__dotty_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(2817),
    [sym__arrow_operator] = ACTIONS(2817),
    [sym__assign_operator] = ACTIONS(2817),
    [anon_sym_LF] = ACTIONS(2822),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2822),
    [sym__command_start] = ACTIONS(2822),
  },
  [1055] = {
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2744),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2744),
    [anon_sym_LT_COLON] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_elseif] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_catch] = ACTIONS(2744),
    [anon_sym_finally] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2744),
    [anon_sym_PIPE_GT] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_LBRACK2] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [aux_sym_integer_literal_token1] = ACTIONS(2744),
    [aux_sym_integer_literal_token2] = ACTIONS(2744),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2744),
    [sym__assign_operator] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1056] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_end] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_primitive] = ACTIONS(2670),
    [aux_sym_primitive_definition_token1] = ACTIONS(2670),
    [anon_sym_mutable] = ACTIONS(2670),
    [anon_sym_struct] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_macro] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_RPAREN] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_EQ] = ACTIONS(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2672),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_LT_COLON] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [sym_break_statement] = ACTIONS(2670),
    [sym_continue_statement] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_quote] = ACTIONS(2670),
    [anon_sym_using] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_DOT] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_COLON2] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_RBRACK] = ACTIONS(2672),
    [anon_sym_begin] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_LT_PIPE] = ACTIONS(2672),
    [anon_sym_PIPE_GT] = ACTIONS(2672),
    [anon_sym_in] = ACTIONS(2670),
    [anon_sym_isa] = ACTIONS(2670),
    [anon_sym_PIPE_PIPE] = ACTIONS(2672),
    [anon_sym_AMP_AMP] = ACTIONS(2672),
    [anon_sym_QMARK] = ACTIONS(2672),
    [anon_sym_EQ_GT] = ACTIONS(2672),
    [anon_sym_LBRACK2] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2672),
    [aux_sym_integer_literal_token1] = ACTIONS(2672),
    [aux_sym_integer_literal_token2] = ACTIONS(2672),
    [aux_sym_integer_literal_token3] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
    [sym__unary_operator] = ACTIONS(2670),
    [sym__power_operator] = ACTIONS(2670),
    [sym__bitshift_operator] = ACTIONS(2670),
    [sym__rational_operator] = ACTIONS(2670),
    [sym__times_operator] = ACTIONS(2670),
    [sym__plus_operator] = ACTIONS(2670),
    [sym__dotty_operator] = ACTIONS(2670),
    [sym__comparison_operator] = ACTIONS(2670),
    [sym__arrow_operator] = ACTIONS(2672),
    [sym__assign_operator] = ACTIONS(2670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2672),
    [sym__string_start] = ACTIONS(2672),
    [sym__command_start] = ACTIONS(2672),
  },
  [1057] = {
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_end] = ACTIONS(3131),
    [anon_sym_abstract] = ACTIONS(3131),
    [anon_sym_primitive] = ACTIONS(3131),
    [aux_sym_primitive_definition_token1] = ACTIONS(3131),
    [anon_sym_mutable] = ACTIONS(3131),
    [anon_sym_struct] = ACTIONS(3131),
    [anon_sym_module] = ACTIONS(3131),
    [anon_sym_macro] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3131),
    [anon_sym_COMMA] = ACTIONS(3131),
    [anon_sym_RPAREN] = ACTIONS(3131),
    [anon_sym_SEMI] = ACTIONS(3131),
    [anon_sym_EQ] = ACTIONS(3131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3131),
    [anon_sym_COLON_COLON] = ACTIONS(3131),
    [anon_sym_LT_COLON] = ACTIONS(3131),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_elseif] = ACTIONS(3131),
    [anon_sym_else] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_catch] = ACTIONS(3131),
    [anon_sym_finally] = ACTIONS(3131),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [sym_break_statement] = ACTIONS(3131),
    [sym_continue_statement] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_const] = ACTIONS(3131),
    [anon_sym_quote] = ACTIONS(3131),
    [anon_sym_using] = ACTIONS(3131),
    [anon_sym_import] = ACTIONS(3131),
    [anon_sym_export] = ACTIONS(3131),
    [anon_sym_COLON2] = ACTIONS(3131),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_SQUOTE] = ACTIONS(3131),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_LT_PIPE] = ACTIONS(3131),
    [anon_sym_PIPE_GT] = ACTIONS(3131),
    [anon_sym_in] = ACTIONS(3131),
    [anon_sym_isa] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3131),
    [anon_sym_AMP_AMP] = ACTIONS(3131),
    [anon_sym_QMARK] = ACTIONS(3131),
    [anon_sym_EQ_GT] = ACTIONS(3131),
    [anon_sym_LBRACK2] = ACTIONS(3131),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_AT] = ACTIONS(3131),
    [aux_sym_integer_literal_token1] = ACTIONS(3131),
    [aux_sym_integer_literal_token2] = ACTIONS(3131),
    [aux_sym_integer_literal_token3] = ACTIONS(3131),
    [sym_float_literal] = ACTIONS(3131),
    [sym__unary_operator] = ACTIONS(3131),
    [sym__power_operator] = ACTIONS(3131),
    [sym__bitshift_operator] = ACTIONS(3131),
    [sym__rational_operator] = ACTIONS(3131),
    [sym__times_operator] = ACTIONS(3131),
    [sym__plus_operator] = ACTIONS(3131),
    [sym__dotty_operator] = ACTIONS(3131),
    [sym__comparison_operator] = ACTIONS(3131),
    [sym__arrow_operator] = ACTIONS(3131),
    [sym__assign_operator] = ACTIONS(3131),
    [anon_sym_LF] = ACTIONS(3133),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3133),
    [sym__command_start] = ACTIONS(3133),
  },
  [1058] = {
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_end] = ACTIONS(3135),
    [anon_sym_abstract] = ACTIONS(3135),
    [anon_sym_primitive] = ACTIONS(3135),
    [aux_sym_primitive_definition_token1] = ACTIONS(3135),
    [anon_sym_mutable] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3135),
    [anon_sym_module] = ACTIONS(3135),
    [anon_sym_macro] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3135),
    [anon_sym_COMMA] = ACTIONS(3135),
    [anon_sym_RPAREN] = ACTIONS(3135),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_EQ] = ACTIONS(3135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3135),
    [anon_sym_COLON_COLON] = ACTIONS(3135),
    [anon_sym_LT_COLON] = ACTIONS(3135),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_elseif] = ACTIONS(3135),
    [anon_sym_else] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_catch] = ACTIONS(3135),
    [anon_sym_finally] = ACTIONS(3135),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [sym_break_statement] = ACTIONS(3135),
    [sym_continue_statement] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_const] = ACTIONS(3135),
    [anon_sym_quote] = ACTIONS(3135),
    [anon_sym_using] = ACTIONS(3135),
    [anon_sym_import] = ACTIONS(3135),
    [anon_sym_export] = ACTIONS(3135),
    [anon_sym_COLON2] = ACTIONS(3135),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_SQUOTE] = ACTIONS(3135),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_LT_PIPE] = ACTIONS(3135),
    [anon_sym_PIPE_GT] = ACTIONS(3135),
    [anon_sym_in] = ACTIONS(3135),
    [anon_sym_isa] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3135),
    [anon_sym_AMP_AMP] = ACTIONS(3135),
    [anon_sym_QMARK] = ACTIONS(3135),
    [anon_sym_EQ_GT] = ACTIONS(3135),
    [anon_sym_LBRACK2] = ACTIONS(3135),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_AT] = ACTIONS(3135),
    [aux_sym_integer_literal_token1] = ACTIONS(3135),
    [aux_sym_integer_literal_token2] = ACTIONS(3135),
    [aux_sym_integer_literal_token3] = ACTIONS(3135),
    [sym_float_literal] = ACTIONS(3135),
    [sym__unary_operator] = ACTIONS(3135),
    [sym__power_operator] = ACTIONS(3135),
    [sym__bitshift_operator] = ACTIONS(3135),
    [sym__rational_operator] = ACTIONS(3135),
    [sym__times_operator] = ACTIONS(3135),
    [sym__plus_operator] = ACTIONS(3135),
    [sym__dotty_operator] = ACTIONS(3135),
    [sym__comparison_operator] = ACTIONS(3135),
    [sym__arrow_operator] = ACTIONS(3135),
    [sym__assign_operator] = ACTIONS(3135),
    [anon_sym_LF] = ACTIONS(3137),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3137),
    [sym__command_start] = ACTIONS(3137),
  },
  [1059] = {
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_end] = ACTIONS(3139),
    [anon_sym_abstract] = ACTIONS(3139),
    [anon_sym_primitive] = ACTIONS(3139),
    [aux_sym_primitive_definition_token1] = ACTIONS(3139),
    [anon_sym_mutable] = ACTIONS(3139),
    [anon_sym_struct] = ACTIONS(3139),
    [anon_sym_module] = ACTIONS(3139),
    [anon_sym_macro] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_COMMA] = ACTIONS(3139),
    [anon_sym_RPAREN] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(3139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3139),
    [anon_sym_COLON_COLON] = ACTIONS(3139),
    [anon_sym_LT_COLON] = ACTIONS(3139),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_elseif] = ACTIONS(3139),
    [anon_sym_else] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_catch] = ACTIONS(3139),
    [anon_sym_finally] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [sym_break_statement] = ACTIONS(3139),
    [sym_continue_statement] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_quote] = ACTIONS(3139),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_import] = ACTIONS(3139),
    [anon_sym_export] = ACTIONS(3139),
    [anon_sym_COLON2] = ACTIONS(3139),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_LT_PIPE] = ACTIONS(3139),
    [anon_sym_PIPE_GT] = ACTIONS(3139),
    [anon_sym_in] = ACTIONS(3139),
    [anon_sym_isa] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3139),
    [anon_sym_AMP_AMP] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3139),
    [anon_sym_EQ_GT] = ACTIONS(3139),
    [anon_sym_LBRACK2] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_AT] = ACTIONS(3139),
    [aux_sym_integer_literal_token1] = ACTIONS(3139),
    [aux_sym_integer_literal_token2] = ACTIONS(3139),
    [aux_sym_integer_literal_token3] = ACTIONS(3139),
    [sym_float_literal] = ACTIONS(3139),
    [sym__unary_operator] = ACTIONS(3139),
    [sym__power_operator] = ACTIONS(3139),
    [sym__bitshift_operator] = ACTIONS(3139),
    [sym__rational_operator] = ACTIONS(3139),
    [sym__times_operator] = ACTIONS(3139),
    [sym__plus_operator] = ACTIONS(3139),
    [sym__dotty_operator] = ACTIONS(3139),
    [sym__comparison_operator] = ACTIONS(3139),
    [sym__arrow_operator] = ACTIONS(3139),
    [sym__assign_operator] = ACTIONS(3139),
    [anon_sym_LF] = ACTIONS(3141),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3141),
    [sym__command_start] = ACTIONS(3141),
  },
  [1060] = {
    [sym_identifier] = ACTIONS(3143),
    [anon_sym_function] = ACTIONS(3143),
    [anon_sym_end] = ACTIONS(3143),
    [anon_sym_abstract] = ACTIONS(3143),
    [anon_sym_primitive] = ACTIONS(3143),
    [aux_sym_primitive_definition_token1] = ACTIONS(3143),
    [anon_sym_mutable] = ACTIONS(3143),
    [anon_sym_struct] = ACTIONS(3143),
    [anon_sym_module] = ACTIONS(3143),
    [anon_sym_macro] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(3143),
    [anon_sym_COMMA] = ACTIONS(3143),
    [anon_sym_RPAREN] = ACTIONS(3143),
    [anon_sym_SEMI] = ACTIONS(3143),
    [anon_sym_EQ] = ACTIONS(3143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3143),
    [anon_sym_COLON_COLON] = ACTIONS(3143),
    [anon_sym_LT_COLON] = ACTIONS(3143),
    [anon_sym_if] = ACTIONS(3143),
    [anon_sym_elseif] = ACTIONS(3143),
    [anon_sym_else] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(3143),
    [anon_sym_catch] = ACTIONS(3143),
    [anon_sym_finally] = ACTIONS(3143),
    [anon_sym_for] = ACTIONS(3143),
    [anon_sym_while] = ACTIONS(3143),
    [sym_break_statement] = ACTIONS(3143),
    [sym_continue_statement] = ACTIONS(3143),
    [anon_sym_return] = ACTIONS(3143),
    [anon_sym_let] = ACTIONS(3143),
    [anon_sym_const] = ACTIONS(3143),
    [anon_sym_quote] = ACTIONS(3143),
    [anon_sym_using] = ACTIONS(3143),
    [anon_sym_import] = ACTIONS(3143),
    [anon_sym_export] = ACTIONS(3143),
    [anon_sym_COLON2] = ACTIONS(3143),
    [anon_sym_begin] = ACTIONS(3143),
    [anon_sym_SQUOTE] = ACTIONS(3143),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_LT_PIPE] = ACTIONS(3143),
    [anon_sym_PIPE_GT] = ACTIONS(3143),
    [anon_sym_in] = ACTIONS(3143),
    [anon_sym_isa] = ACTIONS(3143),
    [anon_sym_PIPE_PIPE] = ACTIONS(3143),
    [anon_sym_AMP_AMP] = ACTIONS(3143),
    [anon_sym_QMARK] = ACTIONS(3143),
    [anon_sym_EQ_GT] = ACTIONS(3143),
    [anon_sym_LBRACK2] = ACTIONS(3143),
    [anon_sym_DOLLAR] = ACTIONS(3143),
    [anon_sym_AT] = ACTIONS(3143),
    [aux_sym_integer_literal_token1] = ACTIONS(3143),
    [aux_sym_integer_literal_token2] = ACTIONS(3143),
    [aux_sym_integer_literal_token3] = ACTIONS(3143),
    [sym_float_literal] = ACTIONS(3143),
    [sym__unary_operator] = ACTIONS(3143),
    [sym__power_operator] = ACTIONS(3143),
    [sym__bitshift_operator] = ACTIONS(3143),
    [sym__rational_operator] = ACTIONS(3143),
    [sym__times_operator] = ACTIONS(3143),
    [sym__plus_operator] = ACTIONS(3143),
    [sym__dotty_operator] = ACTIONS(3143),
    [sym__comparison_operator] = ACTIONS(3143),
    [sym__arrow_operator] = ACTIONS(3143),
    [sym__assign_operator] = ACTIONS(3143),
    [anon_sym_LF] = ACTIONS(3145),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3145),
    [sym__command_start] = ACTIONS(3145),
  },
  [1061] = {
    [sym_identifier] = ACTIONS(3147),
    [anon_sym_function] = ACTIONS(3147),
    [anon_sym_end] = ACTIONS(3147),
    [anon_sym_abstract] = ACTIONS(3147),
    [anon_sym_primitive] = ACTIONS(3147),
    [aux_sym_primitive_definition_token1] = ACTIONS(3147),
    [anon_sym_mutable] = ACTIONS(3147),
    [anon_sym_struct] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(3147),
    [anon_sym_macro] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3147),
    [anon_sym_COMMA] = ACTIONS(3147),
    [anon_sym_RPAREN] = ACTIONS(3147),
    [anon_sym_SEMI] = ACTIONS(3147),
    [anon_sym_EQ] = ACTIONS(3147),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3147),
    [anon_sym_COLON_COLON] = ACTIONS(3147),
    [anon_sym_LT_COLON] = ACTIONS(3147),
    [anon_sym_if] = ACTIONS(3147),
    [anon_sym_elseif] = ACTIONS(3147),
    [anon_sym_else] = ACTIONS(3147),
    [anon_sym_try] = ACTIONS(3147),
    [anon_sym_catch] = ACTIONS(3147),
    [anon_sym_finally] = ACTIONS(3147),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_while] = ACTIONS(3147),
    [sym_break_statement] = ACTIONS(3147),
    [sym_continue_statement] = ACTIONS(3147),
    [anon_sym_return] = ACTIONS(3147),
    [anon_sym_let] = ACTIONS(3147),
    [anon_sym_const] = ACTIONS(3147),
    [anon_sym_quote] = ACTIONS(3147),
    [anon_sym_using] = ACTIONS(3147),
    [anon_sym_import] = ACTIONS(3147),
    [anon_sym_export] = ACTIONS(3147),
    [anon_sym_COLON2] = ACTIONS(3147),
    [anon_sym_begin] = ACTIONS(3147),
    [anon_sym_SQUOTE] = ACTIONS(3147),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_LT_PIPE] = ACTIONS(3147),
    [anon_sym_PIPE_GT] = ACTIONS(3147),
    [anon_sym_in] = ACTIONS(3147),
    [anon_sym_isa] = ACTIONS(3147),
    [anon_sym_PIPE_PIPE] = ACTIONS(3147),
    [anon_sym_AMP_AMP] = ACTIONS(3147),
    [anon_sym_QMARK] = ACTIONS(3147),
    [anon_sym_EQ_GT] = ACTIONS(3147),
    [anon_sym_LBRACK2] = ACTIONS(3147),
    [anon_sym_DOLLAR] = ACTIONS(3147),
    [anon_sym_AT] = ACTIONS(3147),
    [aux_sym_integer_literal_token1] = ACTIONS(3147),
    [aux_sym_integer_literal_token2] = ACTIONS(3147),
    [aux_sym_integer_literal_token3] = ACTIONS(3147),
    [sym_float_literal] = ACTIONS(3147),
    [sym__unary_operator] = ACTIONS(3147),
    [sym__power_operator] = ACTIONS(3147),
    [sym__bitshift_operator] = ACTIONS(3147),
    [sym__rational_operator] = ACTIONS(3147),
    [sym__times_operator] = ACTIONS(3147),
    [sym__plus_operator] = ACTIONS(3147),
    [sym__dotty_operator] = ACTIONS(3147),
    [sym__comparison_operator] = ACTIONS(3147),
    [sym__arrow_operator] = ACTIONS(3147),
    [sym__assign_operator] = ACTIONS(3147),
    [anon_sym_LF] = ACTIONS(3149),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3149),
    [sym__command_start] = ACTIONS(3149),
  },
  [1062] = {
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_function] = ACTIONS(3151),
    [anon_sym_end] = ACTIONS(3151),
    [anon_sym_abstract] = ACTIONS(3151),
    [anon_sym_primitive] = ACTIONS(3151),
    [aux_sym_primitive_definition_token1] = ACTIONS(3151),
    [anon_sym_mutable] = ACTIONS(3151),
    [anon_sym_struct] = ACTIONS(3151),
    [anon_sym_module] = ACTIONS(3151),
    [anon_sym_macro] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3151),
    [anon_sym_COMMA] = ACTIONS(3151),
    [anon_sym_RPAREN] = ACTIONS(3151),
    [anon_sym_SEMI] = ACTIONS(3151),
    [anon_sym_EQ] = ACTIONS(3151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3151),
    [anon_sym_COLON_COLON] = ACTIONS(3151),
    [anon_sym_LT_COLON] = ACTIONS(3151),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_elseif] = ACTIONS(3151),
    [anon_sym_else] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_catch] = ACTIONS(3151),
    [anon_sym_finally] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [sym_break_statement] = ACTIONS(3151),
    [sym_continue_statement] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_let] = ACTIONS(3151),
    [anon_sym_const] = ACTIONS(3151),
    [anon_sym_quote] = ACTIONS(3151),
    [anon_sym_using] = ACTIONS(3151),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_export] = ACTIONS(3151),
    [anon_sym_COLON2] = ACTIONS(3151),
    [anon_sym_begin] = ACTIONS(3151),
    [anon_sym_SQUOTE] = ACTIONS(3151),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_LT_PIPE] = ACTIONS(3151),
    [anon_sym_PIPE_GT] = ACTIONS(3151),
    [anon_sym_in] = ACTIONS(3151),
    [anon_sym_isa] = ACTIONS(3151),
    [anon_sym_PIPE_PIPE] = ACTIONS(3151),
    [anon_sym_AMP_AMP] = ACTIONS(3151),
    [anon_sym_QMARK] = ACTIONS(3151),
    [anon_sym_EQ_GT] = ACTIONS(3151),
    [anon_sym_LBRACK2] = ACTIONS(3151),
    [anon_sym_DOLLAR] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(3151),
    [aux_sym_integer_literal_token1] = ACTIONS(3151),
    [aux_sym_integer_literal_token2] = ACTIONS(3151),
    [aux_sym_integer_literal_token3] = ACTIONS(3151),
    [sym_float_literal] = ACTIONS(3151),
    [sym__unary_operator] = ACTIONS(3151),
    [sym__power_operator] = ACTIONS(3151),
    [sym__bitshift_operator] = ACTIONS(3151),
    [sym__rational_operator] = ACTIONS(3151),
    [sym__times_operator] = ACTIONS(3151),
    [sym__plus_operator] = ACTIONS(3151),
    [sym__dotty_operator] = ACTIONS(3151),
    [sym__comparison_operator] = ACTIONS(3151),
    [sym__arrow_operator] = ACTIONS(3151),
    [sym__assign_operator] = ACTIONS(3151),
    [anon_sym_LF] = ACTIONS(3153),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3153),
    [sym__command_start] = ACTIONS(3153),
  },
  [1063] = {
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_function] = ACTIONS(3155),
    [anon_sym_end] = ACTIONS(3155),
    [anon_sym_abstract] = ACTIONS(3155),
    [anon_sym_primitive] = ACTIONS(3155),
    [aux_sym_primitive_definition_token1] = ACTIONS(3155),
    [anon_sym_mutable] = ACTIONS(3155),
    [anon_sym_struct] = ACTIONS(3155),
    [anon_sym_module] = ACTIONS(3155),
    [anon_sym_macro] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3155),
    [anon_sym_COMMA] = ACTIONS(3155),
    [anon_sym_RPAREN] = ACTIONS(3155),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3155),
    [anon_sym_COLON_COLON] = ACTIONS(3155),
    [anon_sym_LT_COLON] = ACTIONS(3155),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_elseif] = ACTIONS(3155),
    [anon_sym_else] = ACTIONS(3155),
    [anon_sym_try] = ACTIONS(3155),
    [anon_sym_catch] = ACTIONS(3155),
    [anon_sym_finally] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [sym_break_statement] = ACTIONS(3155),
    [sym_continue_statement] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_let] = ACTIONS(3155),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_quote] = ACTIONS(3155),
    [anon_sym_using] = ACTIONS(3155),
    [anon_sym_import] = ACTIONS(3155),
    [anon_sym_export] = ACTIONS(3155),
    [anon_sym_COLON2] = ACTIONS(3155),
    [anon_sym_begin] = ACTIONS(3155),
    [anon_sym_SQUOTE] = ACTIONS(3155),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_LT_PIPE] = ACTIONS(3155),
    [anon_sym_PIPE_GT] = ACTIONS(3155),
    [anon_sym_in] = ACTIONS(3155),
    [anon_sym_isa] = ACTIONS(3155),
    [anon_sym_PIPE_PIPE] = ACTIONS(3155),
    [anon_sym_AMP_AMP] = ACTIONS(3155),
    [anon_sym_QMARK] = ACTIONS(3155),
    [anon_sym_EQ_GT] = ACTIONS(3155),
    [anon_sym_LBRACK2] = ACTIONS(3155),
    [anon_sym_DOLLAR] = ACTIONS(3155),
    [anon_sym_AT] = ACTIONS(3155),
    [aux_sym_integer_literal_token1] = ACTIONS(3155),
    [aux_sym_integer_literal_token2] = ACTIONS(3155),
    [aux_sym_integer_literal_token3] = ACTIONS(3155),
    [sym_float_literal] = ACTIONS(3155),
    [sym__unary_operator] = ACTIONS(3155),
    [sym__power_operator] = ACTIONS(3155),
    [sym__bitshift_operator] = ACTIONS(3155),
    [sym__rational_operator] = ACTIONS(3155),
    [sym__times_operator] = ACTIONS(3155),
    [sym__plus_operator] = ACTIONS(3155),
    [sym__dotty_operator] = ACTIONS(3155),
    [sym__comparison_operator] = ACTIONS(3155),
    [sym__arrow_operator] = ACTIONS(3155),
    [sym__assign_operator] = ACTIONS(3155),
    [anon_sym_LF] = ACTIONS(3157),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3157),
    [sym__command_start] = ACTIONS(3157),
  },
  [1064] = {
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_function] = ACTIONS(2620),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_abstract] = ACTIONS(2620),
    [anon_sym_primitive] = ACTIONS(2620),
    [aux_sym_primitive_definition_token1] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_macro] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_EQ] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_LT_COLON] = ACTIONS(2622),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [sym_break_statement] = ACTIONS(2620),
    [sym_continue_statement] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_quote] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_import] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_COLON2] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_RBRACK] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_LT_PIPE] = ACTIONS(2622),
    [anon_sym_PIPE_GT] = ACTIONS(2622),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_isa] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_EQ_GT] = ACTIONS(2622),
    [anon_sym_LBRACK2] = ACTIONS(2620),
    [anon_sym_DOLLAR] = ACTIONS(2620),
    [anon_sym_AT] = ACTIONS(2622),
    [aux_sym_integer_literal_token1] = ACTIONS(2622),
    [aux_sym_integer_literal_token2] = ACTIONS(2622),
    [aux_sym_integer_literal_token3] = ACTIONS(2620),
    [sym_float_literal] = ACTIONS(2620),
    [sym__unary_operator] = ACTIONS(2620),
    [sym__power_operator] = ACTIONS(2620),
    [sym__bitshift_operator] = ACTIONS(2620),
    [sym__rational_operator] = ACTIONS(2620),
    [sym__times_operator] = ACTIONS(2620),
    [sym__plus_operator] = ACTIONS(2620),
    [sym__dotty_operator] = ACTIONS(2620),
    [sym__comparison_operator] = ACTIONS(2620),
    [sym__arrow_operator] = ACTIONS(2622),
    [sym__assign_operator] = ACTIONS(2620),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__command_start] = ACTIONS(2622),
  },
  [1065] = {
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(2658),
    [anon_sym_end] = ACTIONS(2658),
    [anon_sym_abstract] = ACTIONS(2658),
    [anon_sym_primitive] = ACTIONS(2658),
    [aux_sym_primitive_definition_token1] = ACTIONS(2658),
    [anon_sym_mutable] = ACTIONS(2658),
    [anon_sym_struct] = ACTIONS(2658),
    [anon_sym_module] = ACTIONS(2658),
    [anon_sym_macro] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2660),
    [anon_sym_COMMA] = ACTIONS(2660),
    [anon_sym_RPAREN] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2660),
    [anon_sym_EQ] = ACTIONS(2658),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2660),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [anon_sym_LT_COLON] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2658),
    [anon_sym_try] = ACTIONS(2658),
    [anon_sym_for] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [sym_break_statement] = ACTIONS(2658),
    [sym_continue_statement] = ACTIONS(2658),
    [anon_sym_return] = ACTIONS(2658),
    [anon_sym_let] = ACTIONS(2658),
    [anon_sym_const] = ACTIONS(2658),
    [anon_sym_quote] = ACTIONS(2658),
    [anon_sym_using] = ACTIONS(2658),
    [anon_sym_import] = ACTIONS(2658),
    [anon_sym_DOT] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2658),
    [anon_sym_COLON2] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_RBRACK] = ACTIONS(2660),
    [anon_sym_begin] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_LT_PIPE] = ACTIONS(2660),
    [anon_sym_PIPE_GT] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2658),
    [anon_sym_isa] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2660),
    [anon_sym_QMARK] = ACTIONS(2660),
    [anon_sym_EQ_GT] = ACTIONS(2660),
    [anon_sym_LBRACK2] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2660),
    [aux_sym_integer_literal_token1] = ACTIONS(2660),
    [aux_sym_integer_literal_token2] = ACTIONS(2660),
    [aux_sym_integer_literal_token3] = ACTIONS(2658),
    [sym_float_literal] = ACTIONS(2658),
    [sym__unary_operator] = ACTIONS(2658),
    [sym__power_operator] = ACTIONS(2658),
    [sym__bitshift_operator] = ACTIONS(2658),
    [sym__rational_operator] = ACTIONS(2658),
    [sym__times_operator] = ACTIONS(2658),
    [sym__plus_operator] = ACTIONS(2658),
    [sym__dotty_operator] = ACTIONS(2658),
    [sym__comparison_operator] = ACTIONS(2658),
    [sym__arrow_operator] = ACTIONS(2660),
    [sym__assign_operator] = ACTIONS(2658),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2660),
    [sym__string_start] = ACTIONS(2660),
    [sym__command_start] = ACTIONS(2660),
  },
  [1066] = {
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(2662),
    [anon_sym_end] = ACTIONS(2662),
    [anon_sym_abstract] = ACTIONS(2662),
    [anon_sym_primitive] = ACTIONS(2662),
    [aux_sym_primitive_definition_token1] = ACTIONS(2662),
    [anon_sym_mutable] = ACTIONS(2662),
    [anon_sym_struct] = ACTIONS(2662),
    [anon_sym_module] = ACTIONS(2662),
    [anon_sym_macro] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(2664),
    [anon_sym_RPAREN] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2664),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2664),
    [anon_sym_COLON_COLON] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_LT_COLON] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2662),
    [anon_sym_try] = ACTIONS(2662),
    [anon_sym_for] = ACTIONS(2662),
    [anon_sym_while] = ACTIONS(2662),
    [sym_break_statement] = ACTIONS(2662),
    [sym_continue_statement] = ACTIONS(2662),
    [anon_sym_return] = ACTIONS(2662),
    [anon_sym_let] = ACTIONS(2662),
    [anon_sym_const] = ACTIONS(2662),
    [anon_sym_quote] = ACTIONS(2662),
    [anon_sym_using] = ACTIONS(2662),
    [anon_sym_import] = ACTIONS(2662),
    [anon_sym_DOT] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_COLON2] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_RBRACK] = ACTIONS(2664),
    [anon_sym_begin] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2662),
    [anon_sym_LT_PIPE] = ACTIONS(2664),
    [anon_sym_PIPE_GT] = ACTIONS(2664),
    [anon_sym_in] = ACTIONS(2662),
    [anon_sym_isa] = ACTIONS(2662),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_QMARK] = ACTIONS(2664),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_LBRACK2] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(2664),
    [aux_sym_integer_literal_token1] = ACTIONS(2664),
    [aux_sym_integer_literal_token2] = ACTIONS(2664),
    [aux_sym_integer_literal_token3] = ACTIONS(2662),
    [sym_float_literal] = ACTIONS(2662),
    [sym__unary_operator] = ACTIONS(2662),
    [sym__power_operator] = ACTIONS(2662),
    [sym__bitshift_operator] = ACTIONS(2662),
    [sym__rational_operator] = ACTIONS(2662),
    [sym__times_operator] = ACTIONS(2662),
    [sym__plus_operator] = ACTIONS(2662),
    [sym__dotty_operator] = ACTIONS(2662),
    [sym__comparison_operator] = ACTIONS(2662),
    [sym__arrow_operator] = ACTIONS(2664),
    [sym__assign_operator] = ACTIONS(2662),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2664),
    [sym__string_start] = ACTIONS(2664),
    [sym__command_start] = ACTIONS(2664),
  },
  [1067] = {
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_end] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_primitive] = ACTIONS(2900),
    [aux_sym_primitive_definition_token1] = ACTIONS(2900),
    [anon_sym_mutable] = ACTIONS(2900),
    [anon_sym_struct] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_macro] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(2900),
    [anon_sym_RPAREN] = ACTIONS(2900),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(2900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2900),
    [anon_sym_COLON_COLON] = ACTIONS(2900),
    [anon_sym_LT_COLON] = ACTIONS(2900),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_elseif] = ACTIONS(2900),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_catch] = ACTIONS(2900),
    [anon_sym_finally] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [sym_break_statement] = ACTIONS(2900),
    [sym_continue_statement] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_quote] = ACTIONS(2900),
    [anon_sym_using] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_COLON2] = ACTIONS(2900),
    [anon_sym_begin] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2900),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_LT_PIPE] = ACTIONS(2900),
    [anon_sym_PIPE_GT] = ACTIONS(2900),
    [anon_sym_in] = ACTIONS(2900),
    [anon_sym_isa] = ACTIONS(2900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2900),
    [anon_sym_AMP_AMP] = ACTIONS(2900),
    [anon_sym_QMARK] = ACTIONS(2900),
    [anon_sym_EQ_GT] = ACTIONS(2900),
    [anon_sym_LBRACK2] = ACTIONS(2900),
    [anon_sym_DOLLAR] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2900),
    [aux_sym_integer_literal_token1] = ACTIONS(2900),
    [aux_sym_integer_literal_token2] = ACTIONS(2900),
    [aux_sym_integer_literal_token3] = ACTIONS(2900),
    [sym_float_literal] = ACTIONS(2900),
    [sym__unary_operator] = ACTIONS(2900),
    [sym__power_operator] = ACTIONS(2900),
    [sym__bitshift_operator] = ACTIONS(2900),
    [sym__rational_operator] = ACTIONS(2900),
    [sym__times_operator] = ACTIONS(2900),
    [sym__plus_operator] = ACTIONS(2900),
    [sym__dotty_operator] = ACTIONS(2900),
    [sym__comparison_operator] = ACTIONS(2900),
    [sym__arrow_operator] = ACTIONS(2900),
    [sym__assign_operator] = ACTIONS(2900),
    [anon_sym_LF] = ACTIONS(2902),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2902),
    [sym__command_start] = ACTIONS(2902),
  },
  [1068] = {
    [sym_identifier] = ACTIONS(3159),
    [anon_sym_function] = ACTIONS(3159),
    [anon_sym_end] = ACTIONS(3159),
    [anon_sym_abstract] = ACTIONS(3159),
    [anon_sym_primitive] = ACTIONS(3159),
    [aux_sym_primitive_definition_token1] = ACTIONS(3159),
    [anon_sym_mutable] = ACTIONS(3159),
    [anon_sym_struct] = ACTIONS(3159),
    [anon_sym_module] = ACTIONS(3159),
    [anon_sym_macro] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3159),
    [anon_sym_COMMA] = ACTIONS(3159),
    [anon_sym_RPAREN] = ACTIONS(3159),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym_EQ] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(3159),
    [anon_sym_elseif] = ACTIONS(3159),
    [anon_sym_else] = ACTIONS(3159),
    [anon_sym_try] = ACTIONS(3159),
    [anon_sym_catch] = ACTIONS(3159),
    [anon_sym_finally] = ACTIONS(3159),
    [anon_sym_for] = ACTIONS(3159),
    [anon_sym_while] = ACTIONS(3159),
    [sym_break_statement] = ACTIONS(3159),
    [sym_continue_statement] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3159),
    [anon_sym_let] = ACTIONS(3159),
    [anon_sym_const] = ACTIONS(3159),
    [anon_sym_quote] = ACTIONS(3159),
    [anon_sym_using] = ACTIONS(3159),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_export] = ACTIONS(3159),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(3159),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(3159),
    [anon_sym_DOLLAR] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3159),
    [aux_sym_integer_literal_token1] = ACTIONS(3159),
    [aux_sym_integer_literal_token2] = ACTIONS(3159),
    [aux_sym_integer_literal_token3] = ACTIONS(3159),
    [sym_float_literal] = ACTIONS(3159),
    [sym__unary_operator] = ACTIONS(3159),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(3159),
    [anon_sym_LF] = ACTIONS(3161),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3161),
    [sym__command_start] = ACTIONS(3161),
  },
  [1069] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_function] = ACTIONS(3163),
    [anon_sym_end] = ACTIONS(3163),
    [anon_sym_abstract] = ACTIONS(3163),
    [anon_sym_primitive] = ACTIONS(3163),
    [aux_sym_primitive_definition_token1] = ACTIONS(3163),
    [anon_sym_mutable] = ACTIONS(3163),
    [anon_sym_struct] = ACTIONS(3163),
    [anon_sym_module] = ACTIONS(3163),
    [anon_sym_macro] = ACTIONS(3163),
    [anon_sym_LPAREN] = ACTIONS(3163),
    [anon_sym_COMMA] = ACTIONS(3163),
    [anon_sym_RPAREN] = ACTIONS(3163),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3163),
    [anon_sym_COLON_COLON] = ACTIONS(3163),
    [anon_sym_LT_COLON] = ACTIONS(3163),
    [anon_sym_if] = ACTIONS(3163),
    [anon_sym_elseif] = ACTIONS(3163),
    [anon_sym_else] = ACTIONS(3163),
    [anon_sym_try] = ACTIONS(3163),
    [anon_sym_catch] = ACTIONS(3163),
    [anon_sym_finally] = ACTIONS(3163),
    [anon_sym_for] = ACTIONS(3163),
    [anon_sym_while] = ACTIONS(3163),
    [sym_break_statement] = ACTIONS(3163),
    [sym_continue_statement] = ACTIONS(3163),
    [anon_sym_return] = ACTIONS(3163),
    [anon_sym_let] = ACTIONS(3163),
    [anon_sym_const] = ACTIONS(3163),
    [anon_sym_quote] = ACTIONS(3163),
    [anon_sym_using] = ACTIONS(3163),
    [anon_sym_import] = ACTIONS(3163),
    [anon_sym_export] = ACTIONS(3163),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_begin] = ACTIONS(3163),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_LT_PIPE] = ACTIONS(3163),
    [anon_sym_PIPE_GT] = ACTIONS(3163),
    [anon_sym_in] = ACTIONS(3163),
    [anon_sym_isa] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3163),
    [anon_sym_AMP_AMP] = ACTIONS(3163),
    [anon_sym_QMARK] = ACTIONS(3163),
    [anon_sym_EQ_GT] = ACTIONS(3163),
    [anon_sym_LBRACK2] = ACTIONS(3163),
    [anon_sym_DOLLAR] = ACTIONS(3163),
    [anon_sym_AT] = ACTIONS(3163),
    [aux_sym_integer_literal_token1] = ACTIONS(3163),
    [aux_sym_integer_literal_token2] = ACTIONS(3163),
    [aux_sym_integer_literal_token3] = ACTIONS(3163),
    [sym_float_literal] = ACTIONS(3163),
    [sym__unary_operator] = ACTIONS(3163),
    [sym__power_operator] = ACTIONS(3163),
    [sym__bitshift_operator] = ACTIONS(3163),
    [sym__rational_operator] = ACTIONS(3163),
    [sym__times_operator] = ACTIONS(3163),
    [sym__plus_operator] = ACTIONS(3163),
    [sym__dotty_operator] = ACTIONS(3163),
    [sym__comparison_operator] = ACTIONS(3163),
    [sym__arrow_operator] = ACTIONS(3163),
    [sym__assign_operator] = ACTIONS(3163),
    [anon_sym_LF] = ACTIONS(3165),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3165),
    [sym__command_start] = ACTIONS(3165),
  },
  [1070] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_end] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_primitive] = ACTIONS(2506),
    [aux_sym_primitive_definition_token1] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_macro] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_RPAREN] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LT_COLON] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_elseif] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_catch] = ACTIONS(2506),
    [anon_sym_finally] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [sym_break_statement] = ACTIONS(2506),
    [sym_continue_statement] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_quote] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_COLON2] = ACTIONS(2506),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT_PIPE] = ACTIONS(2506),
    [anon_sym_PIPE_GT] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_isa] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_EQ_GT] = ACTIONS(2506),
    [anon_sym_LBRACK2] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2506),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
    [sym__unary_operator] = ACTIONS(2506),
    [sym__power_operator] = ACTIONS(2506),
    [sym__bitshift_operator] = ACTIONS(2506),
    [sym__rational_operator] = ACTIONS(2506),
    [sym__times_operator] = ACTIONS(2506),
    [sym__plus_operator] = ACTIONS(2506),
    [sym__dotty_operator] = ACTIONS(2506),
    [sym__comparison_operator] = ACTIONS(2506),
    [sym__arrow_operator] = ACTIONS(2506),
    [sym__assign_operator] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2508),
    [sym__command_start] = ACTIONS(2508),
  },
  [1071] = {
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_end] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_primitive] = ACTIONS(2690),
    [aux_sym_primitive_definition_token1] = ACTIONS(2690),
    [anon_sym_mutable] = ACTIONS(2690),
    [anon_sym_struct] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_macro] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_COMMA] = ACTIONS(2692),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(2690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_LT_COLON] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [sym_break_statement] = ACTIONS(2690),
    [sym_continue_statement] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_quote] = ACTIONS(2690),
    [anon_sym_using] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_COLON2] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_RBRACK] = ACTIONS(2692),
    [anon_sym_begin] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_LT_PIPE] = ACTIONS(2692),
    [anon_sym_PIPE_GT] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2690),
    [anon_sym_isa] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_QMARK] = ACTIONS(2692),
    [anon_sym_EQ_GT] = ACTIONS(2692),
    [anon_sym_LBRACK2] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2692),
    [aux_sym_integer_literal_token1] = ACTIONS(2692),
    [aux_sym_integer_literal_token2] = ACTIONS(2692),
    [aux_sym_integer_literal_token3] = ACTIONS(2690),
    [sym_float_literal] = ACTIONS(2690),
    [sym__unary_operator] = ACTIONS(2690),
    [sym__power_operator] = ACTIONS(2690),
    [sym__bitshift_operator] = ACTIONS(2690),
    [sym__rational_operator] = ACTIONS(2690),
    [sym__times_operator] = ACTIONS(2690),
    [sym__plus_operator] = ACTIONS(2690),
    [sym__dotty_operator] = ACTIONS(2690),
    [sym__comparison_operator] = ACTIONS(2690),
    [sym__arrow_operator] = ACTIONS(2692),
    [sym__assign_operator] = ACTIONS(2690),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2692),
    [sym__string_start] = ACTIONS(2692),
    [sym__command_start] = ACTIONS(2692),
  },
  [1072] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_function] = ACTIONS(3167),
    [anon_sym_end] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_primitive] = ACTIONS(3167),
    [aux_sym_primitive_definition_token1] = ACTIONS(3167),
    [anon_sym_mutable] = ACTIONS(3167),
    [anon_sym_struct] = ACTIONS(3167),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_macro] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_COMMA] = ACTIONS(3167),
    [anon_sym_RPAREN] = ACTIONS(3167),
    [anon_sym_SEMI] = ACTIONS(3167),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3167),
    [anon_sym_COLON_COLON] = ACTIONS(3167),
    [anon_sym_LT_COLON] = ACTIONS(3167),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_elseif] = ACTIONS(3167),
    [anon_sym_else] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_catch] = ACTIONS(3167),
    [anon_sym_finally] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [sym_break_statement] = ACTIONS(3167),
    [sym_continue_statement] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_quote] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3167),
    [anon_sym_COLON2] = ACTIONS(3167),
    [anon_sym_begin] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_LT_PIPE] = ACTIONS(3167),
    [anon_sym_PIPE_GT] = ACTIONS(3167),
    [anon_sym_in] = ACTIONS(3167),
    [anon_sym_isa] = ACTIONS(3167),
    [anon_sym_PIPE_PIPE] = ACTIONS(3167),
    [anon_sym_AMP_AMP] = ACTIONS(3167),
    [anon_sym_QMARK] = ACTIONS(3167),
    [anon_sym_EQ_GT] = ACTIONS(3167),
    [anon_sym_LBRACK2] = ACTIONS(3167),
    [anon_sym_DOLLAR] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(3167),
    [aux_sym_integer_literal_token1] = ACTIONS(3167),
    [aux_sym_integer_literal_token2] = ACTIONS(3167),
    [aux_sym_integer_literal_token3] = ACTIONS(3167),
    [sym_float_literal] = ACTIONS(3167),
    [sym__unary_operator] = ACTIONS(3167),
    [sym__power_operator] = ACTIONS(3167),
    [sym__bitshift_operator] = ACTIONS(3167),
    [sym__rational_operator] = ACTIONS(3167),
    [sym__times_operator] = ACTIONS(3167),
    [sym__plus_operator] = ACTIONS(3167),
    [sym__dotty_operator] = ACTIONS(3167),
    [sym__comparison_operator] = ACTIONS(3167),
    [sym__arrow_operator] = ACTIONS(3167),
    [sym__assign_operator] = ACTIONS(3167),
    [anon_sym_LF] = ACTIONS(3169),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3169),
    [sym__command_start] = ACTIONS(3169),
  },
  [1073] = {
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_function] = ACTIONS(3171),
    [anon_sym_end] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3171),
    [anon_sym_primitive] = ACTIONS(3171),
    [aux_sym_primitive_definition_token1] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_struct] = ACTIONS(3171),
    [anon_sym_module] = ACTIONS(3171),
    [anon_sym_macro] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3171),
    [anon_sym_COMMA] = ACTIONS(3171),
    [anon_sym_RPAREN] = ACTIONS(3171),
    [anon_sym_SEMI] = ACTIONS(3171),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3171),
    [anon_sym_COLON_COLON] = ACTIONS(3171),
    [anon_sym_LT_COLON] = ACTIONS(3171),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_elseif] = ACTIONS(3171),
    [anon_sym_else] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_catch] = ACTIONS(3171),
    [anon_sym_finally] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [sym_break_statement] = ACTIONS(3171),
    [sym_continue_statement] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_let] = ACTIONS(3171),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_quote] = ACTIONS(3171),
    [anon_sym_using] = ACTIONS(3171),
    [anon_sym_import] = ACTIONS(3171),
    [anon_sym_export] = ACTIONS(3171),
    [anon_sym_COLON2] = ACTIONS(3171),
    [anon_sym_begin] = ACTIONS(3171),
    [anon_sym_SQUOTE] = ACTIONS(3171),
    [anon_sym_PLUS] = ACTIONS(3171),
    [anon_sym_LT_PIPE] = ACTIONS(3171),
    [anon_sym_PIPE_GT] = ACTIONS(3171),
    [anon_sym_in] = ACTIONS(3171),
    [anon_sym_isa] = ACTIONS(3171),
    [anon_sym_PIPE_PIPE] = ACTIONS(3171),
    [anon_sym_AMP_AMP] = ACTIONS(3171),
    [anon_sym_QMARK] = ACTIONS(3171),
    [anon_sym_EQ_GT] = ACTIONS(3171),
    [anon_sym_LBRACK2] = ACTIONS(3171),
    [anon_sym_DOLLAR] = ACTIONS(3171),
    [anon_sym_AT] = ACTIONS(3171),
    [aux_sym_integer_literal_token1] = ACTIONS(3171),
    [aux_sym_integer_literal_token2] = ACTIONS(3171),
    [aux_sym_integer_literal_token3] = ACTIONS(3171),
    [sym_float_literal] = ACTIONS(3171),
    [sym__unary_operator] = ACTIONS(3171),
    [sym__power_operator] = ACTIONS(3171),
    [sym__bitshift_operator] = ACTIONS(3171),
    [sym__rational_operator] = ACTIONS(3171),
    [sym__times_operator] = ACTIONS(3171),
    [sym__plus_operator] = ACTIONS(3171),
    [sym__dotty_operator] = ACTIONS(3171),
    [sym__comparison_operator] = ACTIONS(3171),
    [sym__arrow_operator] = ACTIONS(3171),
    [sym__assign_operator] = ACTIONS(3171),
    [anon_sym_LF] = ACTIONS(3173),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3173),
    [sym__command_start] = ACTIONS(3173),
  },
  [1074] = {
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LT_COLON] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2466),
    [anon_sym_PIPE_GT] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_EQ_GT] = ACTIONS(2466),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2466),
    [aux_sym_integer_literal_token1] = ACTIONS(2466),
    [aux_sym_integer_literal_token2] = ACTIONS(2466),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2466),
    [sym__assign_operator] = ACTIONS(2464),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
  },
  [1075] = {
    [sym_identifier] = ACTIONS(3175),
    [anon_sym_function] = ACTIONS(3175),
    [anon_sym_end] = ACTIONS(3175),
    [anon_sym_abstract] = ACTIONS(3175),
    [anon_sym_primitive] = ACTIONS(3175),
    [aux_sym_primitive_definition_token1] = ACTIONS(3175),
    [anon_sym_mutable] = ACTIONS(3175),
    [anon_sym_struct] = ACTIONS(3175),
    [anon_sym_module] = ACTIONS(3175),
    [anon_sym_macro] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(3175),
    [anon_sym_COMMA] = ACTIONS(3175),
    [anon_sym_RPAREN] = ACTIONS(3175),
    [anon_sym_SEMI] = ACTIONS(3175),
    [anon_sym_EQ] = ACTIONS(3175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3175),
    [anon_sym_COLON_COLON] = ACTIONS(3175),
    [anon_sym_LT_COLON] = ACTIONS(3175),
    [anon_sym_if] = ACTIONS(3175),
    [anon_sym_elseif] = ACTIONS(3175),
    [anon_sym_else] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(3175),
    [anon_sym_catch] = ACTIONS(3175),
    [anon_sym_finally] = ACTIONS(3175),
    [anon_sym_for] = ACTIONS(3175),
    [anon_sym_while] = ACTIONS(3175),
    [sym_break_statement] = ACTIONS(3175),
    [sym_continue_statement] = ACTIONS(3175),
    [anon_sym_return] = ACTIONS(3175),
    [anon_sym_let] = ACTIONS(3175),
    [anon_sym_const] = ACTIONS(3175),
    [anon_sym_quote] = ACTIONS(3175),
    [anon_sym_using] = ACTIONS(3175),
    [anon_sym_import] = ACTIONS(3175),
    [anon_sym_export] = ACTIONS(3175),
    [anon_sym_COLON2] = ACTIONS(3175),
    [anon_sym_begin] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3175),
    [anon_sym_PLUS] = ACTIONS(3175),
    [anon_sym_LT_PIPE] = ACTIONS(3175),
    [anon_sym_PIPE_GT] = ACTIONS(3175),
    [anon_sym_in] = ACTIONS(3175),
    [anon_sym_isa] = ACTIONS(3175),
    [anon_sym_PIPE_PIPE] = ACTIONS(3175),
    [anon_sym_AMP_AMP] = ACTIONS(3175),
    [anon_sym_QMARK] = ACTIONS(3175),
    [anon_sym_EQ_GT] = ACTIONS(3175),
    [anon_sym_LBRACK2] = ACTIONS(3175),
    [anon_sym_DOLLAR] = ACTIONS(3175),
    [anon_sym_AT] = ACTIONS(3175),
    [aux_sym_integer_literal_token1] = ACTIONS(3175),
    [aux_sym_integer_literal_token2] = ACTIONS(3175),
    [aux_sym_integer_literal_token3] = ACTIONS(3175),
    [sym_float_literal] = ACTIONS(3175),
    [sym__unary_operator] = ACTIONS(3175),
    [sym__power_operator] = ACTIONS(3175),
    [sym__bitshift_operator] = ACTIONS(3175),
    [sym__rational_operator] = ACTIONS(3175),
    [sym__times_operator] = ACTIONS(3175),
    [sym__plus_operator] = ACTIONS(3175),
    [sym__dotty_operator] = ACTIONS(3175),
    [sym__comparison_operator] = ACTIONS(3175),
    [sym__arrow_operator] = ACTIONS(3175),
    [sym__assign_operator] = ACTIONS(3175),
    [anon_sym_LF] = ACTIONS(3177),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3177),
    [sym__command_start] = ACTIONS(3177),
  },
  [1076] = {
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_function] = ACTIONS(3179),
    [anon_sym_end] = ACTIONS(3179),
    [anon_sym_abstract] = ACTIONS(3179),
    [anon_sym_primitive] = ACTIONS(3179),
    [aux_sym_primitive_definition_token1] = ACTIONS(3179),
    [anon_sym_mutable] = ACTIONS(3179),
    [anon_sym_struct] = ACTIONS(3179),
    [anon_sym_module] = ACTIONS(3179),
    [anon_sym_macro] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3179),
    [anon_sym_COMMA] = ACTIONS(3179),
    [anon_sym_RPAREN] = ACTIONS(3179),
    [anon_sym_SEMI] = ACTIONS(3179),
    [anon_sym_EQ] = ACTIONS(3179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3179),
    [anon_sym_COLON_COLON] = ACTIONS(3179),
    [anon_sym_LT_COLON] = ACTIONS(3179),
    [anon_sym_if] = ACTIONS(3179),
    [anon_sym_elseif] = ACTIONS(3179),
    [anon_sym_else] = ACTIONS(3179),
    [anon_sym_try] = ACTIONS(3179),
    [anon_sym_catch] = ACTIONS(3179),
    [anon_sym_finally] = ACTIONS(3179),
    [anon_sym_for] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3179),
    [sym_break_statement] = ACTIONS(3179),
    [sym_continue_statement] = ACTIONS(3179),
    [anon_sym_return] = ACTIONS(3179),
    [anon_sym_let] = ACTIONS(3179),
    [anon_sym_const] = ACTIONS(3179),
    [anon_sym_quote] = ACTIONS(3179),
    [anon_sym_using] = ACTIONS(3179),
    [anon_sym_import] = ACTIONS(3179),
    [anon_sym_export] = ACTIONS(3179),
    [anon_sym_COLON2] = ACTIONS(3179),
    [anon_sym_begin] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(3179),
    [anon_sym_PLUS] = ACTIONS(3179),
    [anon_sym_LT_PIPE] = ACTIONS(3179),
    [anon_sym_PIPE_GT] = ACTIONS(3179),
    [anon_sym_in] = ACTIONS(3179),
    [anon_sym_isa] = ACTIONS(3179),
    [anon_sym_PIPE_PIPE] = ACTIONS(3179),
    [anon_sym_AMP_AMP] = ACTIONS(3179),
    [anon_sym_QMARK] = ACTIONS(3179),
    [anon_sym_EQ_GT] = ACTIONS(3179),
    [anon_sym_LBRACK2] = ACTIONS(3179),
    [anon_sym_DOLLAR] = ACTIONS(3179),
    [anon_sym_AT] = ACTIONS(3179),
    [aux_sym_integer_literal_token1] = ACTIONS(3179),
    [aux_sym_integer_literal_token2] = ACTIONS(3179),
    [aux_sym_integer_literal_token3] = ACTIONS(3179),
    [sym_float_literal] = ACTIONS(3179),
    [sym__unary_operator] = ACTIONS(3179),
    [sym__power_operator] = ACTIONS(3179),
    [sym__bitshift_operator] = ACTIONS(3179),
    [sym__rational_operator] = ACTIONS(3179),
    [sym__times_operator] = ACTIONS(3179),
    [sym__plus_operator] = ACTIONS(3179),
    [sym__dotty_operator] = ACTIONS(3179),
    [sym__comparison_operator] = ACTIONS(3179),
    [sym__arrow_operator] = ACTIONS(3179),
    [sym__assign_operator] = ACTIONS(3179),
    [anon_sym_LF] = ACTIONS(3181),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3181),
    [sym__command_start] = ACTIONS(3181),
  },
  [1077] = {
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [anon_sym_end] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_primitive] = ACTIONS(3183),
    [aux_sym_primitive_definition_token1] = ACTIONS(3183),
    [anon_sym_mutable] = ACTIONS(3183),
    [anon_sym_struct] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_macro] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3183),
    [anon_sym_COMMA] = ACTIONS(3183),
    [anon_sym_RPAREN] = ACTIONS(3183),
    [anon_sym_SEMI] = ACTIONS(3183),
    [anon_sym_EQ] = ACTIONS(3183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3183),
    [anon_sym_COLON_COLON] = ACTIONS(3183),
    [anon_sym_LT_COLON] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_elseif] = ACTIONS(3183),
    [anon_sym_else] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_catch] = ACTIONS(3183),
    [anon_sym_finally] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [sym_break_statement] = ACTIONS(3183),
    [sym_continue_statement] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_quote] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_COLON2] = ACTIONS(3183),
    [anon_sym_begin] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3183),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_LT_PIPE] = ACTIONS(3183),
    [anon_sym_PIPE_GT] = ACTIONS(3183),
    [anon_sym_in] = ACTIONS(3183),
    [anon_sym_isa] = ACTIONS(3183),
    [anon_sym_PIPE_PIPE] = ACTIONS(3183),
    [anon_sym_AMP_AMP] = ACTIONS(3183),
    [anon_sym_QMARK] = ACTIONS(3183),
    [anon_sym_EQ_GT] = ACTIONS(3183),
    [anon_sym_LBRACK2] = ACTIONS(3183),
    [anon_sym_DOLLAR] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3183),
    [aux_sym_integer_literal_token1] = ACTIONS(3183),
    [aux_sym_integer_literal_token2] = ACTIONS(3183),
    [aux_sym_integer_literal_token3] = ACTIONS(3183),
    [sym_float_literal] = ACTIONS(3183),
    [sym__unary_operator] = ACTIONS(3183),
    [sym__power_operator] = ACTIONS(3183),
    [sym__bitshift_operator] = ACTIONS(3183),
    [sym__rational_operator] = ACTIONS(3183),
    [sym__times_operator] = ACTIONS(3183),
    [sym__plus_operator] = ACTIONS(3183),
    [sym__dotty_operator] = ACTIONS(3183),
    [sym__comparison_operator] = ACTIONS(3183),
    [sym__arrow_operator] = ACTIONS(3183),
    [sym__assign_operator] = ACTIONS(3183),
    [anon_sym_LF] = ACTIONS(3185),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3185),
    [sym__command_start] = ACTIONS(3185),
  },
  [1078] = {
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_end] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_primitive] = ACTIONS(2600),
    [aux_sym_primitive_definition_token1] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_macro] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_EQ] = ACTIONS(2600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_LT_COLON] = ACTIONS(2602),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [sym_break_statement] = ACTIONS(2600),
    [sym_continue_statement] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_quote] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_COLON2] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_begin] = ACTIONS(2600),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_LT_PIPE] = ACTIONS(2602),
    [anon_sym_PIPE_GT] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_isa] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_EQ_GT] = ACTIONS(2602),
    [anon_sym_LBRACK2] = ACTIONS(2600),
    [anon_sym_DOLLAR] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2602),
    [aux_sym_integer_literal_token1] = ACTIONS(2602),
    [aux_sym_integer_literal_token2] = ACTIONS(2602),
    [aux_sym_integer_literal_token3] = ACTIONS(2600),
    [sym_float_literal] = ACTIONS(2600),
    [sym__unary_operator] = ACTIONS(2600),
    [sym__power_operator] = ACTIONS(2600),
    [sym__bitshift_operator] = ACTIONS(2600),
    [sym__rational_operator] = ACTIONS(2600),
    [sym__times_operator] = ACTIONS(2600),
    [sym__plus_operator] = ACTIONS(2600),
    [sym__dotty_operator] = ACTIONS(2600),
    [sym__comparison_operator] = ACTIONS(2600),
    [sym__arrow_operator] = ACTIONS(2602),
    [sym__assign_operator] = ACTIONS(2600),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2602),
    [sym__string_start] = ACTIONS(2602),
    [sym__command_start] = ACTIONS(2602),
  },
  [1079] = {
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3187),
    [anon_sym_end] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_primitive] = ACTIONS(3187),
    [aux_sym_primitive_definition_token1] = ACTIONS(3187),
    [anon_sym_mutable] = ACTIONS(3187),
    [anon_sym_struct] = ACTIONS(3187),
    [anon_sym_module] = ACTIONS(3187),
    [anon_sym_macro] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3187),
    [anon_sym_COMMA] = ACTIONS(3187),
    [anon_sym_RPAREN] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3187),
    [anon_sym_EQ] = ACTIONS(3187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3187),
    [anon_sym_COLON_COLON] = ACTIONS(3187),
    [anon_sym_LT_COLON] = ACTIONS(3187),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_elseif] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_catch] = ACTIONS(3187),
    [anon_sym_finally] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [sym_break_statement] = ACTIONS(3187),
    [sym_continue_statement] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_quote] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3187),
    [anon_sym_export] = ACTIONS(3187),
    [anon_sym_COLON2] = ACTIONS(3187),
    [anon_sym_begin] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3187),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_LT_PIPE] = ACTIONS(3187),
    [anon_sym_PIPE_GT] = ACTIONS(3187),
    [anon_sym_in] = ACTIONS(3187),
    [anon_sym_isa] = ACTIONS(3187),
    [anon_sym_PIPE_PIPE] = ACTIONS(3187),
    [anon_sym_AMP_AMP] = ACTIONS(3187),
    [anon_sym_QMARK] = ACTIONS(3187),
    [anon_sym_EQ_GT] = ACTIONS(3187),
    [anon_sym_LBRACK2] = ACTIONS(3187),
    [anon_sym_DOLLAR] = ACTIONS(3187),
    [anon_sym_AT] = ACTIONS(3187),
    [aux_sym_integer_literal_token1] = ACTIONS(3187),
    [aux_sym_integer_literal_token2] = ACTIONS(3187),
    [aux_sym_integer_literal_token3] = ACTIONS(3187),
    [sym_float_literal] = ACTIONS(3187),
    [sym__unary_operator] = ACTIONS(3187),
    [sym__power_operator] = ACTIONS(3187),
    [sym__bitshift_operator] = ACTIONS(3187),
    [sym__rational_operator] = ACTIONS(3187),
    [sym__times_operator] = ACTIONS(3187),
    [sym__plus_operator] = ACTIONS(3187),
    [sym__dotty_operator] = ACTIONS(3187),
    [sym__comparison_operator] = ACTIONS(3187),
    [sym__arrow_operator] = ACTIONS(3187),
    [sym__assign_operator] = ACTIONS(3187),
    [anon_sym_LF] = ACTIONS(3189),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3189),
    [sym__command_start] = ACTIONS(3189),
  },
  [1080] = {
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_RPAREN] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2837),
    [anon_sym_COLON_COLON] = ACTIONS(2837),
    [anon_sym_LT_COLON] = ACTIONS(2837),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_elseif] = ACTIONS(2837),
    [anon_sym_else] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_catch] = ACTIONS(2837),
    [anon_sym_finally] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(2837),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_LT_PIPE] = ACTIONS(2837),
    [anon_sym_PIPE_GT] = ACTIONS(2837),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_isa] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2837),
    [aux_sym_integer_literal_token1] = ACTIONS(2837),
    [aux_sym_integer_literal_token2] = ACTIONS(2837),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(2837),
    [sym__bitshift_operator] = ACTIONS(2837),
    [sym__rational_operator] = ACTIONS(2837),
    [sym__times_operator] = ACTIONS(2837),
    [sym__plus_operator] = ACTIONS(2837),
    [sym__dotty_operator] = ACTIONS(2837),
    [sym__comparison_operator] = ACTIONS(2837),
    [sym__arrow_operator] = ACTIONS(2837),
    [sym__assign_operator] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2867),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1081] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_elseif] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_catch] = ACTIONS(2702),
    [anon_sym_finally] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [sym__assign_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1082] = {
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2871),
    [anon_sym_RPAREN] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_LT_COLON] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elseif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_catch] = ACTIONS(2871),
    [anon_sym_finally] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_LT_PIPE] = ACTIONS(2871),
    [anon_sym_PIPE_GT] = ACTIONS(2871),
    [anon_sym_in] = ACTIONS(2871),
    [anon_sym_isa] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [anon_sym_QMARK] = ACTIONS(2871),
    [anon_sym_EQ_GT] = ACTIONS(2871),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2871),
    [sym__bitshift_operator] = ACTIONS(2871),
    [sym__rational_operator] = ACTIONS(2871),
    [sym__times_operator] = ACTIONS(2871),
    [sym__plus_operator] = ACTIONS(2871),
    [sym__dotty_operator] = ACTIONS(2871),
    [sym__comparison_operator] = ACTIONS(2871),
    [sym__arrow_operator] = ACTIONS(2871),
    [sym__assign_operator] = ACTIONS(2871),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1083] = {
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_end] = ACTIONS(3119),
    [anon_sym_abstract] = ACTIONS(3119),
    [anon_sym_primitive] = ACTIONS(3119),
    [aux_sym_primitive_definition_token1] = ACTIONS(3119),
    [anon_sym_mutable] = ACTIONS(3119),
    [anon_sym_struct] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_macro] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3119),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_elseif] = ACTIONS(3119),
    [anon_sym_else] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_catch] = ACTIONS(3119),
    [anon_sym_finally] = ACTIONS(3119),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [sym_break_statement] = ACTIONS(3119),
    [sym_continue_statement] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_const] = ACTIONS(3119),
    [anon_sym_quote] = ACTIONS(3119),
    [anon_sym_using] = ACTIONS(3119),
    [anon_sym_import] = ACTIONS(3119),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_COLON2] = ACTIONS(3119),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(3119),
    [anon_sym_PIPE_GT] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(3119),
    [anon_sym_isa] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_EQ_GT] = ACTIONS(3119),
    [anon_sym_LBRACK2] = ACTIONS(3119),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3119),
    [aux_sym_integer_literal_token1] = ACTIONS(3119),
    [aux_sym_integer_literal_token2] = ACTIONS(3119),
    [aux_sym_integer_literal_token3] = ACTIONS(3119),
    [sym_float_literal] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(3119),
    [sym__comparison_operator] = ACTIONS(3119),
    [sym__arrow_operator] = ACTIONS(3119),
    [sym__assign_operator] = ACTIONS(3119),
    [anon_sym_LF] = ACTIONS(3191),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3191),
    [sym__command_start] = ACTIONS(3191),
  },
  [1084] = {
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_end] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_primitive] = ACTIONS(3193),
    [aux_sym_primitive_definition_token1] = ACTIONS(3193),
    [anon_sym_mutable] = ACTIONS(3193),
    [anon_sym_struct] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_macro] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_COMMA] = ACTIONS(3193),
    [anon_sym_RPAREN] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3193),
    [anon_sym_LT_COLON] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_elseif] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_catch] = ACTIONS(3193),
    [anon_sym_finally] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [sym_break_statement] = ACTIONS(3193),
    [sym_continue_statement] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_quote] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_import] = ACTIONS(3193),
    [anon_sym_export] = ACTIONS(3193),
    [anon_sym_COLON2] = ACTIONS(3193),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_LT_PIPE] = ACTIONS(3193),
    [anon_sym_PIPE_GT] = ACTIONS(3193),
    [anon_sym_in] = ACTIONS(3193),
    [anon_sym_isa] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_EQ_GT] = ACTIONS(3193),
    [anon_sym_LBRACK2] = ACTIONS(3193),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_AT] = ACTIONS(3193),
    [aux_sym_integer_literal_token1] = ACTIONS(3193),
    [aux_sym_integer_literal_token2] = ACTIONS(3193),
    [aux_sym_integer_literal_token3] = ACTIONS(3193),
    [sym_float_literal] = ACTIONS(3193),
    [sym__unary_operator] = ACTIONS(3193),
    [sym__power_operator] = ACTIONS(3193),
    [sym__bitshift_operator] = ACTIONS(3193),
    [sym__rational_operator] = ACTIONS(3193),
    [sym__times_operator] = ACTIONS(3193),
    [sym__plus_operator] = ACTIONS(3193),
    [sym__dotty_operator] = ACTIONS(3193),
    [sym__comparison_operator] = ACTIONS(3193),
    [sym__arrow_operator] = ACTIONS(3193),
    [sym__assign_operator] = ACTIONS(3193),
    [anon_sym_LF] = ACTIONS(3195),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3195),
    [sym__command_start] = ACTIONS(3195),
  },
  [1085] = {
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_end] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_primitive] = ACTIONS(2712),
    [aux_sym_primitive_definition_token1] = ACTIONS(2712),
    [anon_sym_mutable] = ACTIONS(2712),
    [anon_sym_struct] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_macro] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_COMMA] = ACTIONS(2714),
    [anon_sym_RPAREN] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2714),
    [anon_sym_COLON_COLON] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_LT_COLON] = ACTIONS(2714),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [sym_break_statement] = ACTIONS(2712),
    [sym_continue_statement] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_quote] = ACTIONS(2712),
    [anon_sym_using] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_DOT] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_COLON2] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_RBRACK] = ACTIONS(2714),
    [anon_sym_begin] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_LT_PIPE] = ACTIONS(2714),
    [anon_sym_PIPE_GT] = ACTIONS(2714),
    [anon_sym_in] = ACTIONS(2712),
    [anon_sym_isa] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2714),
    [anon_sym_AMP_AMP] = ACTIONS(2714),
    [anon_sym_QMARK] = ACTIONS(2714),
    [anon_sym_EQ_GT] = ACTIONS(2714),
    [anon_sym_LBRACK2] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2714),
    [aux_sym_integer_literal_token1] = ACTIONS(2714),
    [aux_sym_integer_literal_token2] = ACTIONS(2714),
    [aux_sym_integer_literal_token3] = ACTIONS(2712),
    [sym_float_literal] = ACTIONS(2712),
    [sym__unary_operator] = ACTIONS(2712),
    [sym__power_operator] = ACTIONS(2712),
    [sym__bitshift_operator] = ACTIONS(2712),
    [sym__rational_operator] = ACTIONS(2712),
    [sym__times_operator] = ACTIONS(2712),
    [sym__plus_operator] = ACTIONS(2712),
    [sym__dotty_operator] = ACTIONS(2712),
    [sym__comparison_operator] = ACTIONS(2712),
    [sym__arrow_operator] = ACTIONS(2714),
    [sym__assign_operator] = ACTIONS(2712),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2714),
    [sym__string_start] = ACTIONS(2714),
    [sym__command_start] = ACTIONS(2714),
  },
  [1086] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_elseif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_catch] = ACTIONS(2983),
    [anon_sym_finally] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2983),
    [anon_sym_PIPE_GT] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK2] = ACTIONS(2983),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2983),
    [aux_sym_integer_literal_token1] = ACTIONS(2983),
    [aux_sym_integer_literal_token2] = ACTIONS(2983),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2983),
    [sym__bitshift_operator] = ACTIONS(2983),
    [sym__rational_operator] = ACTIONS(2983),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2983),
    [sym__assign_operator] = ACTIONS(2983),
    [anon_sym_LF] = ACTIONS(2985),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1087] = {
    [aux_sym_import_statement_repeat1] = STATE(1274),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(3197),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_LT_COLON] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(3199),
    [anon_sym_DOT] = ACTIONS(3201),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2656),
    [anon_sym_PIPE_GT] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_LBRACK2] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2656),
    [aux_sym_integer_literal_token1] = ACTIONS(2656),
    [aux_sym_integer_literal_token2] = ACTIONS(2656),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2656),
    [sym__assign_operator] = ACTIONS(2648),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1088] = {
    [sym_type_argument_list] = STATE(1221),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(97),
    [anon_sym_COLON_COLON] = ACTIONS(97),
    [anon_sym_LBRACE] = ACTIONS(2694),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_LT_COLON] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(97),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(97),
    [anon_sym_PIPE_GT] = ACTIONS(97),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(97),
    [anon_sym_AMP_AMP] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(97),
    [anon_sym_EQ_GT] = ACTIONS(97),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DOLLAR] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(97),
    [aux_sym_integer_literal_token1] = ACTIONS(97),
    [aux_sym_integer_literal_token2] = ACTIONS(97),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(97),
    [sym__bitshift_operator] = ACTIONS(97),
    [sym__rational_operator] = ACTIONS(97),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
  },
  [1089] = {
    [sym_identifier] = ACTIONS(3203),
    [anon_sym_function] = ACTIONS(3203),
    [anon_sym_end] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_primitive] = ACTIONS(3203),
    [aux_sym_primitive_definition_token1] = ACTIONS(3203),
    [anon_sym_mutable] = ACTIONS(3203),
    [anon_sym_struct] = ACTIONS(3203),
    [anon_sym_module] = ACTIONS(3203),
    [anon_sym_macro] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3203),
    [anon_sym_COMMA] = ACTIONS(3203),
    [anon_sym_RPAREN] = ACTIONS(3203),
    [anon_sym_SEMI] = ACTIONS(3203),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3203),
    [anon_sym_COLON_COLON] = ACTIONS(3203),
    [anon_sym_LT_COLON] = ACTIONS(3203),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_elseif] = ACTIONS(3203),
    [anon_sym_else] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_catch] = ACTIONS(3203),
    [anon_sym_finally] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [sym_break_statement] = ACTIONS(3203),
    [sym_continue_statement] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_quote] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_import] = ACTIONS(3203),
    [anon_sym_export] = ACTIONS(3203),
    [anon_sym_COLON2] = ACTIONS(3203),
    [anon_sym_begin] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3203),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_LT_PIPE] = ACTIONS(3203),
    [anon_sym_PIPE_GT] = ACTIONS(3203),
    [anon_sym_in] = ACTIONS(3203),
    [anon_sym_isa] = ACTIONS(3203),
    [anon_sym_PIPE_PIPE] = ACTIONS(3203),
    [anon_sym_AMP_AMP] = ACTIONS(3203),
    [anon_sym_QMARK] = ACTIONS(3203),
    [anon_sym_EQ_GT] = ACTIONS(3203),
    [anon_sym_LBRACK2] = ACTIONS(3203),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [anon_sym_AT] = ACTIONS(3203),
    [aux_sym_integer_literal_token1] = ACTIONS(3203),
    [aux_sym_integer_literal_token2] = ACTIONS(3203),
    [aux_sym_integer_literal_token3] = ACTIONS(3203),
    [sym_float_literal] = ACTIONS(3203),
    [sym__unary_operator] = ACTIONS(3203),
    [sym__power_operator] = ACTIONS(3203),
    [sym__bitshift_operator] = ACTIONS(3203),
    [sym__rational_operator] = ACTIONS(3203),
    [sym__times_operator] = ACTIONS(3203),
    [sym__plus_operator] = ACTIONS(3203),
    [sym__dotty_operator] = ACTIONS(3203),
    [sym__comparison_operator] = ACTIONS(3203),
    [sym__arrow_operator] = ACTIONS(3203),
    [sym__assign_operator] = ACTIONS(3203),
    [anon_sym_LF] = ACTIONS(3205),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3205),
    [sym__command_start] = ACTIONS(3205),
  },
  [1090] = {
    [sym_type_argument_list] = STATE(1239),
    [sym_identifier] = ACTIONS(85),
    [anon_sym_function] = ACTIONS(85),
    [anon_sym_end] = ACTIONS(85),
    [anon_sym_abstract] = ACTIONS(85),
    [anon_sym_primitive] = ACTIONS(85),
    [aux_sym_primitive_definition_token1] = ACTIONS(85),
    [anon_sym_mutable] = ACTIONS(85),
    [anon_sym_struct] = ACTIONS(85),
    [anon_sym_module] = ACTIONS(85),
    [anon_sym_macro] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_COLON_COLON] = ACTIONS(85),
    [anon_sym_LBRACE] = ACTIONS(2604),
    [anon_sym_LT_COLON] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(85),
    [anon_sym_elseif] = ACTIONS(85),
    [anon_sym_else] = ACTIONS(85),
    [anon_sym_try] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(85),
    [sym_break_statement] = ACTIONS(85),
    [sym_continue_statement] = ACTIONS(85),
    [anon_sym_return] = ACTIONS(85),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_const] = ACTIONS(85),
    [anon_sym_quote] = ACTIONS(85),
    [anon_sym_using] = ACTIONS(85),
    [anon_sym_import] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(85),
    [anon_sym_COLON2] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(85),
    [anon_sym_LT_PIPE] = ACTIONS(85),
    [anon_sym_PIPE_GT] = ACTIONS(85),
    [anon_sym_in] = ACTIONS(85),
    [anon_sym_isa] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_AMP_AMP] = ACTIONS(85),
    [anon_sym_QMARK] = ACTIONS(85),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_LBRACK2] = ACTIONS(85),
    [anon_sym_DOLLAR] = ACTIONS(85),
    [anon_sym_AT] = ACTIONS(85),
    [aux_sym_integer_literal_token1] = ACTIONS(85),
    [aux_sym_integer_literal_token2] = ACTIONS(85),
    [aux_sym_integer_literal_token3] = ACTIONS(85),
    [sym_float_literal] = ACTIONS(85),
    [sym__unary_operator] = ACTIONS(85),
    [sym__power_operator] = ACTIONS(85),
    [sym__bitshift_operator] = ACTIONS(85),
    [sym__rational_operator] = ACTIONS(85),
    [sym__times_operator] = ACTIONS(85),
    [sym__plus_operator] = ACTIONS(85),
    [sym__dotty_operator] = ACTIONS(85),
    [sym__comparison_operator] = ACTIONS(85),
    [sym__arrow_operator] = ACTIONS(85),
    [anon_sym_LF] = ACTIONS(97),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(97),
    [sym__command_start] = ACTIONS(97),
  },
  [1091] = {
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_end] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_primitive] = ACTIONS(3207),
    [aux_sym_primitive_definition_token1] = ACTIONS(3207),
    [anon_sym_mutable] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_macro] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(3207),
    [anon_sym_RPAREN] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3209),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(3207),
    [anon_sym_LT_COLON] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_elseif] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_catch] = ACTIONS(3207),
    [anon_sym_finally] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [sym_break_statement] = ACTIONS(3207),
    [sym_continue_statement] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_quote] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_COLON2] = ACTIONS(3207),
    [anon_sym_begin] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_LT_PIPE] = ACTIONS(3207),
    [anon_sym_PIPE_GT] = ACTIONS(3207),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_isa] = ACTIONS(3207),
    [anon_sym_PIPE_PIPE] = ACTIONS(3207),
    [anon_sym_AMP_AMP] = ACTIONS(3207),
    [anon_sym_QMARK] = ACTIONS(3207),
    [anon_sym_EQ_GT] = ACTIONS(3207),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_DOLLAR] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [aux_sym_integer_literal_token1] = ACTIONS(3207),
    [aux_sym_integer_literal_token2] = ACTIONS(3207),
    [aux_sym_integer_literal_token3] = ACTIONS(3207),
    [sym_float_literal] = ACTIONS(3207),
    [sym__unary_operator] = ACTIONS(3207),
    [sym__power_operator] = ACTIONS(3207),
    [sym__bitshift_operator] = ACTIONS(3207),
    [sym__rational_operator] = ACTIONS(3207),
    [sym__times_operator] = ACTIONS(3207),
    [sym__plus_operator] = ACTIONS(3207),
    [sym__dotty_operator] = ACTIONS(3207),
    [sym__comparison_operator] = ACTIONS(3207),
    [sym__arrow_operator] = ACTIONS(3207),
    [sym__assign_operator] = ACTIONS(3207),
    [anon_sym_LF] = ACTIONS(3211),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3211),
    [sym__command_start] = ACTIONS(3211),
  },
  [1092] = {
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_end] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_primitive] = ACTIONS(3213),
    [aux_sym_primitive_definition_token1] = ACTIONS(3213),
    [anon_sym_mutable] = ACTIONS(3213),
    [anon_sym_struct] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_macro] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_SEMI] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3213),
    [anon_sym_COLON_COLON] = ACTIONS(3213),
    [anon_sym_LT_COLON] = ACTIONS(3213),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_elseif] = ACTIONS(3213),
    [anon_sym_else] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_catch] = ACTIONS(3213),
    [anon_sym_finally] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [sym_break_statement] = ACTIONS(3213),
    [sym_continue_statement] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_quote] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_COLON2] = ACTIONS(3213),
    [anon_sym_begin] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3213),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_LT_PIPE] = ACTIONS(3213),
    [anon_sym_PIPE_GT] = ACTIONS(3213),
    [anon_sym_in] = ACTIONS(3213),
    [anon_sym_isa] = ACTIONS(3213),
    [anon_sym_PIPE_PIPE] = ACTIONS(3213),
    [anon_sym_AMP_AMP] = ACTIONS(3213),
    [anon_sym_QMARK] = ACTIONS(3213),
    [anon_sym_EQ_GT] = ACTIONS(3213),
    [anon_sym_LBRACK2] = ACTIONS(3213),
    [anon_sym_DOLLAR] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3213),
    [aux_sym_integer_literal_token1] = ACTIONS(3213),
    [aux_sym_integer_literal_token2] = ACTIONS(3213),
    [aux_sym_integer_literal_token3] = ACTIONS(3213),
    [sym_float_literal] = ACTIONS(3213),
    [sym__unary_operator] = ACTIONS(3213),
    [sym__power_operator] = ACTIONS(3213),
    [sym__bitshift_operator] = ACTIONS(3213),
    [sym__rational_operator] = ACTIONS(3213),
    [sym__times_operator] = ACTIONS(3213),
    [sym__plus_operator] = ACTIONS(3213),
    [sym__dotty_operator] = ACTIONS(3213),
    [sym__comparison_operator] = ACTIONS(3213),
    [sym__arrow_operator] = ACTIONS(3213),
    [sym__assign_operator] = ACTIONS(3213),
    [anon_sym_LF] = ACTIONS(3215),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3215),
    [sym__command_start] = ACTIONS(3215),
  },
  [1093] = {
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_primitive] = ACTIONS(2912),
    [aux_sym_primitive_definition_token1] = ACTIONS(2912),
    [anon_sym_mutable] = ACTIONS(2912),
    [anon_sym_struct] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_macro] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2912),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2912),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2912),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_LT_COLON] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_elseif] = ACTIONS(2912),
    [anon_sym_else] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_catch] = ACTIONS(2912),
    [anon_sym_finally] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [sym_break_statement] = ACTIONS(2912),
    [sym_continue_statement] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_quote] = ACTIONS(2912),
    [anon_sym_using] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_COLON2] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_LT_PIPE] = ACTIONS(2912),
    [anon_sym_PIPE_GT] = ACTIONS(2912),
    [anon_sym_in] = ACTIONS(2912),
    [anon_sym_isa] = ACTIONS(2912),
    [anon_sym_PIPE_PIPE] = ACTIONS(2912),
    [anon_sym_AMP_AMP] = ACTIONS(2912),
    [anon_sym_QMARK] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(2912),
    [anon_sym_LBRACK2] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2912),
    [aux_sym_integer_literal_token2] = ACTIONS(2912),
    [aux_sym_integer_literal_token3] = ACTIONS(2912),
    [sym_float_literal] = ACTIONS(2912),
    [sym__unary_operator] = ACTIONS(2912),
    [sym__power_operator] = ACTIONS(2912),
    [sym__bitshift_operator] = ACTIONS(2912),
    [sym__rational_operator] = ACTIONS(2912),
    [sym__times_operator] = ACTIONS(2912),
    [sym__plus_operator] = ACTIONS(2912),
    [sym__dotty_operator] = ACTIONS(2912),
    [sym__comparison_operator] = ACTIONS(2912),
    [sym__arrow_operator] = ACTIONS(2912),
    [sym__assign_operator] = ACTIONS(2912),
    [anon_sym_LF] = ACTIONS(2914),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2914),
    [sym__command_start] = ACTIONS(2914),
  },
  [1094] = {
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_function] = ACTIONS(3217),
    [anon_sym_end] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_primitive] = ACTIONS(3217),
    [aux_sym_primitive_definition_token1] = ACTIONS(3217),
    [anon_sym_mutable] = ACTIONS(3217),
    [anon_sym_struct] = ACTIONS(3217),
    [anon_sym_module] = ACTIONS(3217),
    [anon_sym_macro] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_COMMA] = ACTIONS(3217),
    [anon_sym_RPAREN] = ACTIONS(3217),
    [anon_sym_SEMI] = ACTIONS(3217),
    [anon_sym_EQ] = ACTIONS(3217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3217),
    [anon_sym_COLON_COLON] = ACTIONS(3217),
    [anon_sym_LT_COLON] = ACTIONS(3217),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_elseif] = ACTIONS(3217),
    [anon_sym_else] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_catch] = ACTIONS(3217),
    [anon_sym_finally] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [sym_break_statement] = ACTIONS(3217),
    [sym_continue_statement] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_quote] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_import] = ACTIONS(3217),
    [anon_sym_export] = ACTIONS(3217),
    [anon_sym_COLON2] = ACTIONS(3217),
    [anon_sym_begin] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3217),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_LT_PIPE] = ACTIONS(3217),
    [anon_sym_PIPE_GT] = ACTIONS(3217),
    [anon_sym_in] = ACTIONS(3217),
    [anon_sym_isa] = ACTIONS(3217),
    [anon_sym_PIPE_PIPE] = ACTIONS(3217),
    [anon_sym_AMP_AMP] = ACTIONS(3217),
    [anon_sym_QMARK] = ACTIONS(3217),
    [anon_sym_EQ_GT] = ACTIONS(3217),
    [anon_sym_LBRACK2] = ACTIONS(3217),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [anon_sym_AT] = ACTIONS(3217),
    [aux_sym_integer_literal_token1] = ACTIONS(3217),
    [aux_sym_integer_literal_token2] = ACTIONS(3217),
    [aux_sym_integer_literal_token3] = ACTIONS(3217),
    [sym_float_literal] = ACTIONS(3217),
    [sym__unary_operator] = ACTIONS(3217),
    [sym__power_operator] = ACTIONS(3217),
    [sym__bitshift_operator] = ACTIONS(3217),
    [sym__rational_operator] = ACTIONS(3217),
    [sym__times_operator] = ACTIONS(3217),
    [sym__plus_operator] = ACTIONS(3217),
    [sym__dotty_operator] = ACTIONS(3217),
    [sym__comparison_operator] = ACTIONS(3217),
    [sym__arrow_operator] = ACTIONS(3217),
    [sym__assign_operator] = ACTIONS(3217),
    [anon_sym_LF] = ACTIONS(3219),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3219),
    [sym__command_start] = ACTIONS(3219),
  },
  [1095] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_COMMA] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_LT_COLON] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_DOT] = ACTIONS(3221),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_RBRACK] = ACTIONS(2708),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_GT] = ACTIONS(2708),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2708),
    [anon_sym_AMP_AMP] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2708),
    [anon_sym_EQ_GT] = ACTIONS(2708),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2708),
    [aux_sym_integer_literal_token1] = ACTIONS(2708),
    [aux_sym_integer_literal_token2] = ACTIONS(2708),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2708),
    [sym__assign_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1096] = {
    [sym_do_clause] = STATE(1273),
    [ts_builtin_sym_end] = ACTIONS(2488),
    [sym_identifier] = ACTIONS(2486),
    [anon_sym_function] = ACTIONS(2486),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_primitive] = ACTIONS(2486),
    [aux_sym_primitive_definition_token1] = ACTIONS(2486),
    [anon_sym_mutable] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_module] = ACTIONS(2486),
    [anon_sym_macro] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2486),
    [anon_sym_COMMA] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2486),
    [anon_sym_EQ] = ACTIONS(2486),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2486),
    [anon_sym_COLON_COLON] = ACTIONS(2486),
    [anon_sym_LT_COLON] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [sym_break_statement] = ACTIONS(2486),
    [sym_continue_statement] = ACTIONS(2486),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_quote] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_import] = ACTIONS(2486),
    [anon_sym_DOT] = ACTIONS(2486),
    [anon_sym_export] = ACTIONS(2486),
    [anon_sym_COLON2] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_begin] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_LT_PIPE] = ACTIONS(2486),
    [anon_sym_PIPE_GT] = ACTIONS(2486),
    [anon_sym_in] = ACTIONS(2486),
    [anon_sym_isa] = ACTIONS(2486),
    [anon_sym_PIPE_PIPE] = ACTIONS(2486),
    [anon_sym_AMP_AMP] = ACTIONS(2486),
    [anon_sym_QMARK] = ACTIONS(2486),
    [anon_sym_EQ_GT] = ACTIONS(2486),
    [anon_sym_LBRACK2] = ACTIONS(2486),
    [anon_sym_DOLLAR] = ACTIONS(2486),
    [anon_sym_AT] = ACTIONS(2486),
    [aux_sym_integer_literal_token1] = ACTIONS(2486),
    [aux_sym_integer_literal_token2] = ACTIONS(2486),
    [aux_sym_integer_literal_token3] = ACTIONS(2486),
    [sym_float_literal] = ACTIONS(2486),
    [sym__unary_operator] = ACTIONS(2486),
    [sym__power_operator] = ACTIONS(2486),
    [sym__bitshift_operator] = ACTIONS(2486),
    [sym__rational_operator] = ACTIONS(2486),
    [sym__times_operator] = ACTIONS(2486),
    [sym__plus_operator] = ACTIONS(2486),
    [sym__dotty_operator] = ACTIONS(2486),
    [sym__comparison_operator] = ACTIONS(2486),
    [sym__arrow_operator] = ACTIONS(2486),
    [sym__assign_operator] = ACTIONS(2486),
    [anon_sym_LF] = ACTIONS(2488),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2488),
    [sym__string_start] = ACTIONS(2488),
    [sym__command_start] = ACTIONS(2488),
  },
  [1097] = {
    [sym_identifier] = ACTIONS(3227),
    [anon_sym_function] = ACTIONS(3227),
    [anon_sym_end] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_primitive] = ACTIONS(3227),
    [aux_sym_primitive_definition_token1] = ACTIONS(3227),
    [anon_sym_mutable] = ACTIONS(3227),
    [anon_sym_struct] = ACTIONS(3227),
    [anon_sym_module] = ACTIONS(3227),
    [anon_sym_macro] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3227),
    [anon_sym_COMMA] = ACTIONS(3227),
    [anon_sym_RPAREN] = ACTIONS(3227),
    [anon_sym_SEMI] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3227),
    [anon_sym_COLON_COLON] = ACTIONS(3227),
    [anon_sym_LT_COLON] = ACTIONS(3227),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_elseif] = ACTIONS(3227),
    [anon_sym_else] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_catch] = ACTIONS(3227),
    [anon_sym_finally] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [sym_break_statement] = ACTIONS(3227),
    [sym_continue_statement] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_quote] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_export] = ACTIONS(3227),
    [anon_sym_COLON2] = ACTIONS(3227),
    [anon_sym_begin] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3227),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_LT_PIPE] = ACTIONS(3227),
    [anon_sym_PIPE_GT] = ACTIONS(3227),
    [anon_sym_in] = ACTIONS(3227),
    [anon_sym_isa] = ACTIONS(3227),
    [anon_sym_PIPE_PIPE] = ACTIONS(3227),
    [anon_sym_AMP_AMP] = ACTIONS(3227),
    [anon_sym_QMARK] = ACTIONS(3227),
    [anon_sym_EQ_GT] = ACTIONS(3227),
    [anon_sym_LBRACK2] = ACTIONS(3227),
    [anon_sym_DOLLAR] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3227),
    [aux_sym_integer_literal_token1] = ACTIONS(3227),
    [aux_sym_integer_literal_token2] = ACTIONS(3227),
    [aux_sym_integer_literal_token3] = ACTIONS(3227),
    [sym_float_literal] = ACTIONS(3227),
    [sym__unary_operator] = ACTIONS(3227),
    [sym__power_operator] = ACTIONS(3227),
    [sym__bitshift_operator] = ACTIONS(3227),
    [sym__rational_operator] = ACTIONS(3227),
    [sym__times_operator] = ACTIONS(3227),
    [sym__plus_operator] = ACTIONS(3227),
    [sym__dotty_operator] = ACTIONS(3227),
    [sym__comparison_operator] = ACTIONS(3227),
    [sym__arrow_operator] = ACTIONS(3227),
    [sym__assign_operator] = ACTIONS(3227),
    [anon_sym_LF] = ACTIONS(3229),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3229),
    [sym__command_start] = ACTIONS(3229),
  },
  [1098] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_end] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_primitive] = ACTIONS(2510),
    [aux_sym_primitive_definition_token1] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_macro] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LT_COLON] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_elseif] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [sym_break_statement] = ACTIONS(2510),
    [sym_continue_statement] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_quote] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_COLON2] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_LT_PIPE] = ACTIONS(2510),
    [anon_sym_PIPE_GT] = ACTIONS(2510),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_isa] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_EQ_GT] = ACTIONS(2510),
    [anon_sym_LBRACK2] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2510),
    [aux_sym_integer_literal_token1] = ACTIONS(2510),
    [aux_sym_integer_literal_token2] = ACTIONS(2510),
    [aux_sym_integer_literal_token3] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
    [sym__unary_operator] = ACTIONS(2510),
    [sym__power_operator] = ACTIONS(2510),
    [sym__bitshift_operator] = ACTIONS(2510),
    [sym__rational_operator] = ACTIONS(2510),
    [sym__times_operator] = ACTIONS(2510),
    [sym__plus_operator] = ACTIONS(2510),
    [sym__dotty_operator] = ACTIONS(2510),
    [sym__comparison_operator] = ACTIONS(2510),
    [sym__arrow_operator] = ACTIONS(2510),
    [anon_sym_LF] = ACTIONS(2512),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2512),
    [sym__string_start] = ACTIONS(2512),
    [sym__command_start] = ACTIONS(2512),
  },
  [1099] = {
    [ts_builtin_sym_end] = ACTIONS(2584),
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_primitive] = ACTIONS(2582),
    [aux_sym_primitive_definition_token1] = ACTIONS(2582),
    [anon_sym_mutable] = ACTIONS(2582),
    [anon_sym_struct] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_macro] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LT_COLON] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [sym_break_statement] = ACTIONS(2582),
    [sym_continue_statement] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_quote] = ACTIONS(2582),
    [anon_sym_using] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_COLON2] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_LT_PIPE] = ACTIONS(2582),
    [anon_sym_PIPE_GT] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_isa] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2582),
    [anon_sym_LBRACK2] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2582),
    [aux_sym_integer_literal_token1] = ACTIONS(2582),
    [aux_sym_integer_literal_token2] = ACTIONS(2582),
    [aux_sym_integer_literal_token3] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
    [sym__unary_operator] = ACTIONS(2582),
    [sym__power_operator] = ACTIONS(2582),
    [sym__bitshift_operator] = ACTIONS(2582),
    [sym__rational_operator] = ACTIONS(2582),
    [sym__times_operator] = ACTIONS(2582),
    [sym__plus_operator] = ACTIONS(2582),
    [sym__dotty_operator] = ACTIONS(2582),
    [sym__comparison_operator] = ACTIONS(2582),
    [sym__arrow_operator] = ACTIONS(2582),
    [sym__assign_operator] = ACTIONS(2582),
    [anon_sym_LF] = ACTIONS(2584),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__command_start] = ACTIONS(2584),
  },
  [1100] = {
    [sym_parenthesized_expression] = STATE(1367),
    [sym_identifier] = ACTIONS(3231),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_end] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_primitive] = ACTIONS(2728),
    [aux_sym_primitive_definition_token1] = ACTIONS(2728),
    [anon_sym_mutable] = ACTIONS(2728),
    [anon_sym_struct] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_macro] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_COMMA] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_EQ] = ACTIONS(2728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2732),
    [anon_sym_COLON_COLON] = ACTIONS(2732),
    [anon_sym_RBRACE] = ACTIONS(2732),
    [anon_sym_LT_COLON] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [sym_break_statement] = ACTIONS(2728),
    [sym_continue_statement] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_quote] = ACTIONS(2728),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_COLON2] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_RBRACK] = ACTIONS(2732),
    [anon_sym_begin] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_LT_PIPE] = ACTIONS(2732),
    [anon_sym_PIPE_GT] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_isa] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_QMARK] = ACTIONS(2732),
    [anon_sym_EQ_GT] = ACTIONS(2732),
    [anon_sym_LBRACK2] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2732),
    [aux_sym_integer_literal_token1] = ACTIONS(2732),
    [aux_sym_integer_literal_token2] = ACTIONS(2732),
    [aux_sym_integer_literal_token3] = ACTIONS(2728),
    [sym_float_literal] = ACTIONS(2728),
    [sym__unary_operator] = ACTIONS(2728),
    [sym__power_operator] = ACTIONS(2728),
    [sym__bitshift_operator] = ACTIONS(2728),
    [sym__rational_operator] = ACTIONS(2728),
    [sym__times_operator] = ACTIONS(2728),
    [sym__plus_operator] = ACTIONS(2728),
    [sym__dotty_operator] = ACTIONS(2728),
    [sym__comparison_operator] = ACTIONS(2728),
    [sym__arrow_operator] = ACTIONS(2732),
    [sym__assign_operator] = ACTIONS(2728),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2732),
    [sym__command_start] = ACTIONS(2732),
  },
  [1101] = {
    [sym_parenthesized_expression] = STATE(1412),
    [sym_identifier] = ACTIONS(3235),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2752),
    [anon_sym_COLON_COLON] = ACTIONS(2752),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_LT_COLON] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2752),
    [anon_sym_PIPE_GT] = ACTIONS(2752),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_QMARK] = ACTIONS(2752),
    [anon_sym_EQ_GT] = ACTIONS(2752),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2752),
    [aux_sym_integer_literal_token1] = ACTIONS(2752),
    [aux_sym_integer_literal_token2] = ACTIONS(2752),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2752),
    [sym__assign_operator] = ACTIONS(2750),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1102] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_end] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_primitive] = ACTIONS(2586),
    [aux_sym_primitive_definition_token1] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_macro] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_LT_COLON] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_elseif] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [sym_break_statement] = ACTIONS(2586),
    [sym_continue_statement] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_quote] = ACTIONS(2586),
    [anon_sym_using] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_COLON2] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_LT_PIPE] = ACTIONS(2586),
    [anon_sym_PIPE_GT] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_isa] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2586),
    [anon_sym_LBRACK2] = ACTIONS(2586),
    [anon_sym_DASH_GT] = ACTIONS(2590),
    [anon_sym_DOLLAR] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2586),
    [aux_sym_integer_literal_token1] = ACTIONS(2586),
    [aux_sym_integer_literal_token2] = ACTIONS(2586),
    [aux_sym_integer_literal_token3] = ACTIONS(2586),
    [sym_float_literal] = ACTIONS(2586),
    [sym__unary_operator] = ACTIONS(2586),
    [sym__power_operator] = ACTIONS(2586),
    [sym__bitshift_operator] = ACTIONS(2586),
    [sym__rational_operator] = ACTIONS(2586),
    [sym__times_operator] = ACTIONS(2586),
    [sym__plus_operator] = ACTIONS(2586),
    [sym__dotty_operator] = ACTIONS(2586),
    [sym__comparison_operator] = ACTIONS(2586),
    [sym__arrow_operator] = ACTIONS(2586),
    [anon_sym_LF] = ACTIONS(2588),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__command_start] = ACTIONS(2588),
  },
  [1103] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_end] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_primitive] = ACTIONS(2526),
    [aux_sym_primitive_definition_token1] = ACTIONS(2526),
    [anon_sym_mutable] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_macro] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_COMMA] = ACTIONS(2528),
    [anon_sym_RPAREN] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2528),
    [anon_sym_COLON_COLON] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2528),
    [anon_sym_LT_COLON] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [sym_break_statement] = ACTIONS(2526),
    [sym_continue_statement] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_quote] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_COLON2] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_RBRACK] = ACTIONS(2528),
    [anon_sym_begin] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_LT_PIPE] = ACTIONS(2528),
    [anon_sym_PIPE_GT] = ACTIONS(2528),
    [anon_sym_in] = ACTIONS(2526),
    [anon_sym_isa] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2528),
    [anon_sym_AMP_AMP] = ACTIONS(2528),
    [anon_sym_QMARK] = ACTIONS(2528),
    [anon_sym_EQ_GT] = ACTIONS(2528),
    [anon_sym_LBRACK2] = ACTIONS(2526),
    [anon_sym_DOLLAR] = ACTIONS(2528),
    [anon_sym_AT] = ACTIONS(2528),
    [aux_sym_integer_literal_token1] = ACTIONS(2528),
    [aux_sym_integer_literal_token2] = ACTIONS(2528),
    [aux_sym_integer_literal_token3] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
    [sym__unary_operator] = ACTIONS(2526),
    [sym__power_operator] = ACTIONS(2528),
    [sym__bitshift_operator] = ACTIONS(2528),
    [sym__rational_operator] = ACTIONS(2528),
    [sym__times_operator] = ACTIONS(2526),
    [sym__plus_operator] = ACTIONS(2526),
    [sym__dotty_operator] = ACTIONS(2526),
    [sym__comparison_operator] = ACTIONS(2526),
    [sym__arrow_operator] = ACTIONS(2528),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2528),
    [sym__string_start] = ACTIONS(2528),
    [sym__command_start] = ACTIONS(2528),
  },
  [1104] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_primitive] = ACTIONS(2562),
    [aux_sym_primitive_definition_token1] = ACTIONS(2562),
    [anon_sym_mutable] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_macro] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_LT_COLON] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [sym_break_statement] = ACTIONS(2562),
    [sym_continue_statement] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_quote] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_COLON2] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_RBRACK] = ACTIONS(2564),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_LT_PIPE] = ACTIONS(2564),
    [anon_sym_PIPE_GT] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_isa] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_QMARK] = ACTIONS(2564),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_LBRACK2] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2564),
    [anon_sym_AT] = ACTIONS(2564),
    [aux_sym_integer_literal_token1] = ACTIONS(2564),
    [aux_sym_integer_literal_token2] = ACTIONS(2564),
    [aux_sym_integer_literal_token3] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
    [sym__unary_operator] = ACTIONS(2562),
    [sym__power_operator] = ACTIONS(2564),
    [sym__bitshift_operator] = ACTIONS(2564),
    [sym__rational_operator] = ACTIONS(2564),
    [sym__times_operator] = ACTIONS(2562),
    [sym__plus_operator] = ACTIONS(2562),
    [sym__dotty_operator] = ACTIONS(2562),
    [sym__comparison_operator] = ACTIONS(2562),
    [sym__arrow_operator] = ACTIONS(2564),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__command_start] = ACTIONS(2564),
  },
  [1105] = {
    [ts_builtin_sym_end] = ACTIONS(2504),
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_primitive] = ACTIONS(2502),
    [aux_sym_primitive_definition_token1] = ACTIONS(2502),
    [anon_sym_mutable] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_macro] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_LT_COLON] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [sym_break_statement] = ACTIONS(2502),
    [sym_continue_statement] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_quote] = ACTIONS(2502),
    [anon_sym_using] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_COLON2] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_LT_PIPE] = ACTIONS(2502),
    [anon_sym_PIPE_GT] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2502),
    [anon_sym_isa] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_EQ_GT] = ACTIONS(2502),
    [anon_sym_LBRACK2] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_AT] = ACTIONS(2502),
    [aux_sym_integer_literal_token1] = ACTIONS(2502),
    [aux_sym_integer_literal_token2] = ACTIONS(2502),
    [aux_sym_integer_literal_token3] = ACTIONS(2502),
    [sym_float_literal] = ACTIONS(2502),
    [sym__unary_operator] = ACTIONS(2502),
    [sym__power_operator] = ACTIONS(2502),
    [sym__bitshift_operator] = ACTIONS(2502),
    [sym__rational_operator] = ACTIONS(2502),
    [sym__times_operator] = ACTIONS(2502),
    [sym__plus_operator] = ACTIONS(2502),
    [sym__dotty_operator] = ACTIONS(2502),
    [sym__comparison_operator] = ACTIONS(2502),
    [sym__arrow_operator] = ACTIONS(2502),
    [sym__assign_operator] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2504),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2504),
    [sym__string_start] = ACTIONS(2504),
    [sym__command_start] = ACTIONS(2504),
  },
  [1106] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_end] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_primitive] = ACTIONS(2554),
    [aux_sym_primitive_definition_token1] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_macro] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2556),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_LT_COLON] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [sym_break_statement] = ACTIONS(2554),
    [sym_continue_statement] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_quote] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_COLON2] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_RBRACK] = ACTIONS(2556),
    [anon_sym_begin] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_LT_PIPE] = ACTIONS(2556),
    [anon_sym_PIPE_GT] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_isa] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2556),
    [anon_sym_AMP_AMP] = ACTIONS(2556),
    [anon_sym_QMARK] = ACTIONS(2556),
    [anon_sym_EQ_GT] = ACTIONS(2556),
    [anon_sym_LBRACK2] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2556),
    [anon_sym_AT] = ACTIONS(2556),
    [aux_sym_integer_literal_token1] = ACTIONS(2556),
    [aux_sym_integer_literal_token2] = ACTIONS(2556),
    [aux_sym_integer_literal_token3] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
    [sym__unary_operator] = ACTIONS(2554),
    [sym__power_operator] = ACTIONS(2556),
    [sym__bitshift_operator] = ACTIONS(2556),
    [sym__rational_operator] = ACTIONS(2556),
    [sym__times_operator] = ACTIONS(2554),
    [sym__plus_operator] = ACTIONS(2554),
    [sym__dotty_operator] = ACTIONS(2554),
    [sym__comparison_operator] = ACTIONS(2554),
    [sym__arrow_operator] = ACTIONS(2556),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2556),
    [sym__string_start] = ACTIONS(2556),
    [sym__command_start] = ACTIONS(2556),
  },
  [1107] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_end] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_primitive] = ACTIONS(2542),
    [aux_sym_primitive_definition_token1] = ACTIONS(2542),
    [anon_sym_mutable] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_macro] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2544),
    [anon_sym_COMMA] = ACTIONS(2544),
    [anon_sym_RPAREN] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2544),
    [anon_sym_COLON_COLON] = ACTIONS(2544),
    [anon_sym_RBRACE] = ACTIONS(2544),
    [anon_sym_LT_COLON] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [sym_break_statement] = ACTIONS(2542),
    [sym_continue_statement] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_quote] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_COLON2] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_RBRACK] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_LT_PIPE] = ACTIONS(2544),
    [anon_sym_PIPE_GT] = ACTIONS(2544),
    [anon_sym_in] = ACTIONS(2542),
    [anon_sym_isa] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2544),
    [anon_sym_AMP_AMP] = ACTIONS(2544),
    [anon_sym_QMARK] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(2544),
    [anon_sym_LBRACK2] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(2544),
    [anon_sym_AT] = ACTIONS(2544),
    [aux_sym_integer_literal_token1] = ACTIONS(2544),
    [aux_sym_integer_literal_token2] = ACTIONS(2544),
    [aux_sym_integer_literal_token3] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
    [sym__unary_operator] = ACTIONS(2542),
    [sym__power_operator] = ACTIONS(2544),
    [sym__bitshift_operator] = ACTIONS(2544),
    [sym__rational_operator] = ACTIONS(2544),
    [sym__times_operator] = ACTIONS(2542),
    [sym__plus_operator] = ACTIONS(2542),
    [sym__dotty_operator] = ACTIONS(2542),
    [sym__comparison_operator] = ACTIONS(2542),
    [sym__arrow_operator] = ACTIONS(2544),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2544),
    [sym__string_start] = ACTIONS(2544),
    [sym__command_start] = ACTIONS(2544),
  },
  [1108] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_end] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_primitive] = ACTIONS(2498),
    [aux_sym_primitive_definition_token1] = ACTIONS(2498),
    [anon_sym_mutable] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_macro] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_COMMA] = ACTIONS(2500),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_LT_COLON] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [sym_break_statement] = ACTIONS(2498),
    [sym_continue_statement] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_quote] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_COLON2] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_RBRACK] = ACTIONS(2500),
    [anon_sym_begin] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_LT_PIPE] = ACTIONS(2500),
    [anon_sym_PIPE_GT] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_isa] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_QMARK] = ACTIONS(2500),
    [anon_sym_EQ_GT] = ACTIONS(2500),
    [anon_sym_LBRACK2] = ACTIONS(2498),
    [anon_sym_DOLLAR] = ACTIONS(2500),
    [anon_sym_AT] = ACTIONS(2500),
    [aux_sym_integer_literal_token1] = ACTIONS(2500),
    [aux_sym_integer_literal_token2] = ACTIONS(2500),
    [aux_sym_integer_literal_token3] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
    [sym__unary_operator] = ACTIONS(2498),
    [sym__power_operator] = ACTIONS(2500),
    [sym__bitshift_operator] = ACTIONS(2500),
    [sym__rational_operator] = ACTIONS(2500),
    [sym__times_operator] = ACTIONS(2498),
    [sym__plus_operator] = ACTIONS(2498),
    [sym__dotty_operator] = ACTIONS(2498),
    [sym__comparison_operator] = ACTIONS(2498),
    [sym__arrow_operator] = ACTIONS(2500),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2500),
    [sym__string_start] = ACTIONS(2500),
    [sym__command_start] = ACTIONS(2500),
  },
  [1109] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_end] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_primitive] = ACTIONS(2534),
    [aux_sym_primitive_definition_token1] = ACTIONS(2534),
    [anon_sym_mutable] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_macro] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_COMMA] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2536),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_LT_COLON] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [sym_break_statement] = ACTIONS(2534),
    [sym_continue_statement] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_quote] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_COLON2] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_RBRACK] = ACTIONS(2536),
    [anon_sym_begin] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_LT_PIPE] = ACTIONS(2536),
    [anon_sym_PIPE_GT] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_isa] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2536),
    [anon_sym_AMP_AMP] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2536),
    [anon_sym_EQ_GT] = ACTIONS(2536),
    [anon_sym_LBRACK2] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [anon_sym_AT] = ACTIONS(2536),
    [aux_sym_integer_literal_token1] = ACTIONS(2536),
    [aux_sym_integer_literal_token2] = ACTIONS(2536),
    [aux_sym_integer_literal_token3] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
    [sym__unary_operator] = ACTIONS(2534),
    [sym__power_operator] = ACTIONS(2536),
    [sym__bitshift_operator] = ACTIONS(2536),
    [sym__rational_operator] = ACTIONS(2536),
    [sym__times_operator] = ACTIONS(2534),
    [sym__plus_operator] = ACTIONS(2534),
    [sym__dotty_operator] = ACTIONS(2534),
    [sym__comparison_operator] = ACTIONS(2534),
    [sym__arrow_operator] = ACTIONS(2536),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2536),
    [sym__string_start] = ACTIONS(2536),
    [sym__command_start] = ACTIONS(2536),
  },
  [1110] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_primitive] = ACTIONS(2490),
    [aux_sym_primitive_definition_token1] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_macro] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_LT_COLON] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [sym_break_statement] = ACTIONS(2490),
    [sym_continue_statement] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_quote] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_COLON2] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_begin] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_LT_PIPE] = ACTIONS(2492),
    [anon_sym_PIPE_GT] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_isa] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_QMARK] = ACTIONS(2492),
    [anon_sym_EQ_GT] = ACTIONS(2492),
    [anon_sym_LBRACK2] = ACTIONS(2490),
    [anon_sym_DOLLAR] = ACTIONS(2492),
    [anon_sym_AT] = ACTIONS(2492),
    [aux_sym_integer_literal_token1] = ACTIONS(2492),
    [aux_sym_integer_literal_token2] = ACTIONS(2492),
    [aux_sym_integer_literal_token3] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
    [sym__unary_operator] = ACTIONS(2490),
    [sym__power_operator] = ACTIONS(2492),
    [sym__bitshift_operator] = ACTIONS(2492),
    [sym__rational_operator] = ACTIONS(2492),
    [sym__times_operator] = ACTIONS(2490),
    [sym__plus_operator] = ACTIONS(2490),
    [sym__dotty_operator] = ACTIONS(2490),
    [sym__comparison_operator] = ACTIONS(2490),
    [sym__arrow_operator] = ACTIONS(2492),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2492),
    [sym__string_start] = ACTIONS(2492),
    [sym__command_start] = ACTIONS(2492),
  },
  [1111] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_end] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_primitive] = ACTIONS(2510),
    [aux_sym_primitive_definition_token1] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_macro] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_LT_COLON] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [sym_break_statement] = ACTIONS(2510),
    [sym_continue_statement] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_quote] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_COLON2] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_LT_PIPE] = ACTIONS(2512),
    [anon_sym_PIPE_GT] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_isa] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_QMARK] = ACTIONS(2512),
    [anon_sym_EQ_GT] = ACTIONS(2512),
    [anon_sym_LBRACK2] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(2512),
    [anon_sym_AT] = ACTIONS(2512),
    [aux_sym_integer_literal_token1] = ACTIONS(2512),
    [aux_sym_integer_literal_token2] = ACTIONS(2512),
    [aux_sym_integer_literal_token3] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
    [sym__unary_operator] = ACTIONS(2510),
    [sym__power_operator] = ACTIONS(2512),
    [sym__bitshift_operator] = ACTIONS(2512),
    [sym__rational_operator] = ACTIONS(2512),
    [sym__times_operator] = ACTIONS(2510),
    [sym__plus_operator] = ACTIONS(2510),
    [sym__dotty_operator] = ACTIONS(2510),
    [sym__comparison_operator] = ACTIONS(2510),
    [sym__arrow_operator] = ACTIONS(2512),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2512),
    [sym__string_start] = ACTIONS(2512),
    [sym__command_start] = ACTIONS(2512),
  },
  [1112] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_end] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_primitive] = ACTIONS(2514),
    [aux_sym_primitive_definition_token1] = ACTIONS(2514),
    [anon_sym_mutable] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_macro] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LT_COLON] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [sym_break_statement] = ACTIONS(2514),
    [sym_continue_statement] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_quote] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_COLON2] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_LT_PIPE] = ACTIONS(2516),
    [anon_sym_PIPE_GT] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_isa] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_QMARK] = ACTIONS(2516),
    [anon_sym_EQ_GT] = ACTIONS(2516),
    [anon_sym_LBRACK2] = ACTIONS(2514),
    [anon_sym_DOLLAR] = ACTIONS(2516),
    [anon_sym_AT] = ACTIONS(2516),
    [aux_sym_integer_literal_token1] = ACTIONS(2516),
    [aux_sym_integer_literal_token2] = ACTIONS(2516),
    [aux_sym_integer_literal_token3] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__power_operator] = ACTIONS(2516),
    [sym__bitshift_operator] = ACTIONS(2516),
    [sym__rational_operator] = ACTIONS(2516),
    [sym__times_operator] = ACTIONS(2514),
    [sym__plus_operator] = ACTIONS(2514),
    [sym__dotty_operator] = ACTIONS(2514),
    [sym__comparison_operator] = ACTIONS(2514),
    [sym__arrow_operator] = ACTIONS(2516),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2516),
    [sym__string_start] = ACTIONS(2516),
    [sym__command_start] = ACTIONS(2516),
  },
  [1113] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_end] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_primitive] = ACTIONS(2518),
    [aux_sym_primitive_definition_token1] = ACTIONS(2518),
    [anon_sym_mutable] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_macro] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_LT_COLON] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [sym_break_statement] = ACTIONS(2518),
    [sym_continue_statement] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_quote] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_COLON2] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_LT_PIPE] = ACTIONS(2520),
    [anon_sym_PIPE_GT] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_isa] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2520),
    [anon_sym_EQ_GT] = ACTIONS(2520),
    [anon_sym_LBRACK2] = ACTIONS(2518),
    [anon_sym_DOLLAR] = ACTIONS(2520),
    [anon_sym_AT] = ACTIONS(2520),
    [aux_sym_integer_literal_token1] = ACTIONS(2520),
    [aux_sym_integer_literal_token2] = ACTIONS(2520),
    [aux_sym_integer_literal_token3] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
    [sym__unary_operator] = ACTIONS(2518),
    [sym__power_operator] = ACTIONS(2520),
    [sym__bitshift_operator] = ACTIONS(2520),
    [sym__rational_operator] = ACTIONS(2520),
    [sym__times_operator] = ACTIONS(2518),
    [sym__plus_operator] = ACTIONS(2518),
    [sym__dotty_operator] = ACTIONS(2518),
    [sym__comparison_operator] = ACTIONS(2518),
    [sym__arrow_operator] = ACTIONS(2520),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2520),
    [sym__string_start] = ACTIONS(2520),
    [sym__command_start] = ACTIONS(2520),
  },
  [1114] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_end] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_primitive] = ACTIONS(2522),
    [aux_sym_primitive_definition_token1] = ACTIONS(2522),
    [anon_sym_mutable] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_macro] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2524),
    [anon_sym_LT_COLON] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [sym_break_statement] = ACTIONS(2522),
    [sym_continue_statement] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_quote] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_COLON2] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_RBRACK] = ACTIONS(2524),
    [anon_sym_begin] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_LT_PIPE] = ACTIONS(2524),
    [anon_sym_PIPE_GT] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_isa] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2524),
    [anon_sym_AMP_AMP] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(2524),
    [anon_sym_LBRACK2] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2524),
    [anon_sym_AT] = ACTIONS(2524),
    [aux_sym_integer_literal_token1] = ACTIONS(2524),
    [aux_sym_integer_literal_token2] = ACTIONS(2524),
    [aux_sym_integer_literal_token3] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
    [sym__unary_operator] = ACTIONS(2522),
    [sym__power_operator] = ACTIONS(2524),
    [sym__bitshift_operator] = ACTIONS(2524),
    [sym__rational_operator] = ACTIONS(2524),
    [sym__times_operator] = ACTIONS(2522),
    [sym__plus_operator] = ACTIONS(2522),
    [sym__dotty_operator] = ACTIONS(2522),
    [sym__comparison_operator] = ACTIONS(2522),
    [sym__arrow_operator] = ACTIONS(2524),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2524),
    [sym__string_start] = ACTIONS(2524),
    [sym__command_start] = ACTIONS(2524),
  },
  [1115] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_end] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_primitive] = ACTIONS(2530),
    [aux_sym_primitive_definition_token1] = ACTIONS(2530),
    [anon_sym_mutable] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_macro] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RPAREN] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_LT_COLON] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [sym_break_statement] = ACTIONS(2530),
    [sym_continue_statement] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_quote] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_COLON2] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_RBRACK] = ACTIONS(2532),
    [anon_sym_begin] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_LT_PIPE] = ACTIONS(2532),
    [anon_sym_PIPE_GT] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2530),
    [anon_sym_isa] = ACTIONS(2530),
    [anon_sym_PIPE_PIPE] = ACTIONS(2532),
    [anon_sym_AMP_AMP] = ACTIONS(2532),
    [anon_sym_QMARK] = ACTIONS(2532),
    [anon_sym_EQ_GT] = ACTIONS(2532),
    [anon_sym_LBRACK2] = ACTIONS(2530),
    [anon_sym_DOLLAR] = ACTIONS(2532),
    [anon_sym_AT] = ACTIONS(2532),
    [aux_sym_integer_literal_token1] = ACTIONS(2532),
    [aux_sym_integer_literal_token2] = ACTIONS(2532),
    [aux_sym_integer_literal_token3] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
    [sym__unary_operator] = ACTIONS(2530),
    [sym__power_operator] = ACTIONS(2532),
    [sym__bitshift_operator] = ACTIONS(2532),
    [sym__rational_operator] = ACTIONS(2532),
    [sym__times_operator] = ACTIONS(2530),
    [sym__plus_operator] = ACTIONS(2530),
    [sym__dotty_operator] = ACTIONS(2530),
    [sym__comparison_operator] = ACTIONS(2530),
    [sym__arrow_operator] = ACTIONS(2532),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2532),
    [sym__string_start] = ACTIONS(2532),
    [sym__command_start] = ACTIONS(2532),
  },
  [1116] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_end] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_primitive] = ACTIONS(2538),
    [aux_sym_primitive_definition_token1] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_macro] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(2540),
    [anon_sym_RPAREN] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2540),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_LT_COLON] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [sym_break_statement] = ACTIONS(2538),
    [sym_continue_statement] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_quote] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_DOT] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_COLON2] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_RBRACK] = ACTIONS(2540),
    [anon_sym_begin] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_LT_PIPE] = ACTIONS(2540),
    [anon_sym_PIPE_GT] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2540),
    [anon_sym_AMP_AMP] = ACTIONS(2540),
    [anon_sym_QMARK] = ACTIONS(2540),
    [anon_sym_EQ_GT] = ACTIONS(2540),
    [anon_sym_LBRACK2] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(2540),
    [anon_sym_AT] = ACTIONS(2540),
    [aux_sym_integer_literal_token1] = ACTIONS(2540),
    [aux_sym_integer_literal_token2] = ACTIONS(2540),
    [aux_sym_integer_literal_token3] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
    [sym__unary_operator] = ACTIONS(2538),
    [sym__power_operator] = ACTIONS(2540),
    [sym__bitshift_operator] = ACTIONS(2540),
    [sym__rational_operator] = ACTIONS(2540),
    [sym__times_operator] = ACTIONS(2538),
    [sym__plus_operator] = ACTIONS(2538),
    [sym__dotty_operator] = ACTIONS(2538),
    [sym__comparison_operator] = ACTIONS(2538),
    [sym__arrow_operator] = ACTIONS(2540),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2540),
    [sym__string_start] = ACTIONS(2540),
    [sym__command_start] = ACTIONS(2540),
  },
  [1117] = {
    [ts_builtin_sym_end] = ACTIONS(2588),
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_primitive] = ACTIONS(2586),
    [aux_sym_primitive_definition_token1] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_macro] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2586),
    [anon_sym_COLON_COLON] = ACTIONS(2586),
    [anon_sym_LT_COLON] = ACTIONS(2586),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [sym_break_statement] = ACTIONS(2586),
    [sym_continue_statement] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_quote] = ACTIONS(2586),
    [anon_sym_using] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_COLON2] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_LT_PIPE] = ACTIONS(2586),
    [anon_sym_PIPE_GT] = ACTIONS(2586),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_isa] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2586),
    [anon_sym_EQ_GT] = ACTIONS(2586),
    [anon_sym_LBRACK2] = ACTIONS(2586),
    [anon_sym_DASH_GT] = ACTIONS(2590),
    [anon_sym_DOLLAR] = ACTIONS(2586),
    [anon_sym_AT] = ACTIONS(2586),
    [aux_sym_integer_literal_token1] = ACTIONS(2586),
    [aux_sym_integer_literal_token2] = ACTIONS(2586),
    [aux_sym_integer_literal_token3] = ACTIONS(2586),
    [sym_float_literal] = ACTIONS(2586),
    [sym__unary_operator] = ACTIONS(2586),
    [sym__power_operator] = ACTIONS(2586),
    [sym__bitshift_operator] = ACTIONS(2586),
    [sym__rational_operator] = ACTIONS(2586),
    [sym__times_operator] = ACTIONS(2586),
    [sym__plus_operator] = ACTIONS(2586),
    [sym__dotty_operator] = ACTIONS(2586),
    [sym__comparison_operator] = ACTIONS(2586),
    [sym__arrow_operator] = ACTIONS(2586),
    [sym__assign_operator] = ACTIONS(2586),
    [anon_sym_LF] = ACTIONS(2588),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__command_start] = ACTIONS(2588),
  },
  [1118] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_primitive] = ACTIONS(2494),
    [aux_sym_primitive_definition_token1] = ACTIONS(2494),
    [anon_sym_mutable] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_macro] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_LT_COLON] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [sym_break_statement] = ACTIONS(2494),
    [sym_continue_statement] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_quote] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_COLON2] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_RBRACK] = ACTIONS(2496),
    [anon_sym_begin] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_LT_PIPE] = ACTIONS(2496),
    [anon_sym_PIPE_GT] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_isa] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2496),
    [anon_sym_AMP_AMP] = ACTIONS(2496),
    [anon_sym_QMARK] = ACTIONS(2496),
    [anon_sym_EQ_GT] = ACTIONS(2496),
    [anon_sym_LBRACK2] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2496),
    [anon_sym_AT] = ACTIONS(2496),
    [aux_sym_integer_literal_token1] = ACTIONS(2496),
    [aux_sym_integer_literal_token2] = ACTIONS(2496),
    [aux_sym_integer_literal_token3] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
    [sym__unary_operator] = ACTIONS(2494),
    [sym__power_operator] = ACTIONS(2496),
    [sym__bitshift_operator] = ACTIONS(2496),
    [sym__rational_operator] = ACTIONS(2496),
    [sym__times_operator] = ACTIONS(2494),
    [sym__plus_operator] = ACTIONS(2494),
    [sym__dotty_operator] = ACTIONS(2494),
    [sym__comparison_operator] = ACTIONS(2494),
    [sym__arrow_operator] = ACTIONS(2496),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2496),
    [sym__string_start] = ACTIONS(2496),
    [sym__command_start] = ACTIONS(2496),
  },
  [1119] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_end] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_primitive] = ACTIONS(2546),
    [aux_sym_primitive_definition_token1] = ACTIONS(2546),
    [anon_sym_mutable] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_macro] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_LT_COLON] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [sym_break_statement] = ACTIONS(2546),
    [sym_continue_statement] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_quote] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_DOT] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_COLON2] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_RBRACK] = ACTIONS(2548),
    [anon_sym_begin] = ACTIONS(2546),
    [anon_sym_do] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_LT_PIPE] = ACTIONS(2548),
    [anon_sym_PIPE_GT] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2546),
    [anon_sym_isa] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_QMARK] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(2548),
    [anon_sym_LBRACK2] = ACTIONS(2546),
    [anon_sym_DOLLAR] = ACTIONS(2548),
    [anon_sym_AT] = ACTIONS(2548),
    [aux_sym_integer_literal_token1] = ACTIONS(2548),
    [aux_sym_integer_literal_token2] = ACTIONS(2548),
    [aux_sym_integer_literal_token3] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
    [sym__unary_operator] = ACTIONS(2546),
    [sym__power_operator] = ACTIONS(2548),
    [sym__bitshift_operator] = ACTIONS(2548),
    [sym__rational_operator] = ACTIONS(2548),
    [sym__times_operator] = ACTIONS(2546),
    [sym__plus_operator] = ACTIONS(2546),
    [sym__dotty_operator] = ACTIONS(2546),
    [sym__comparison_operator] = ACTIONS(2546),
    [sym__arrow_operator] = ACTIONS(2548),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2548),
    [sym__string_start] = ACTIONS(2548),
    [sym__command_start] = ACTIONS(2548),
  },
  [1120] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_end] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_primitive] = ACTIONS(2550),
    [aux_sym_primitive_definition_token1] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_macro] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2552),
    [anon_sym_COMMA] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2552),
    [anon_sym_LT_COLON] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_break_statement] = ACTIONS(2550),
    [sym_continue_statement] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_quote] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_COLON2] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_RBRACK] = ACTIONS(2552),
    [anon_sym_begin] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_LT_PIPE] = ACTIONS(2552),
    [anon_sym_PIPE_GT] = ACTIONS(2552),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_isa] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_EQ_GT] = ACTIONS(2552),
    [anon_sym_LBRACK2] = ACTIONS(2550),
    [anon_sym_DOLLAR] = ACTIONS(2552),
    [anon_sym_AT] = ACTIONS(2552),
    [aux_sym_integer_literal_token1] = ACTIONS(2552),
    [aux_sym_integer_literal_token2] = ACTIONS(2552),
    [aux_sym_integer_literal_token3] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
    [sym__unary_operator] = ACTIONS(2550),
    [sym__power_operator] = ACTIONS(2552),
    [sym__bitshift_operator] = ACTIONS(2552),
    [sym__rational_operator] = ACTIONS(2552),
    [sym__times_operator] = ACTIONS(2550),
    [sym__plus_operator] = ACTIONS(2550),
    [sym__dotty_operator] = ACTIONS(2550),
    [sym__comparison_operator] = ACTIONS(2550),
    [sym__arrow_operator] = ACTIONS(2552),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2552),
    [sym__string_start] = ACTIONS(2552),
    [sym__command_start] = ACTIONS(2552),
  },
  [1121] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_end] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_primitive] = ACTIONS(2558),
    [aux_sym_primitive_definition_token1] = ACTIONS(2558),
    [anon_sym_mutable] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_macro] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_LT_COLON] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [sym_break_statement] = ACTIONS(2558),
    [sym_continue_statement] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_quote] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_DOT] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_COLON2] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_RBRACK] = ACTIONS(2560),
    [anon_sym_begin] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_LT_PIPE] = ACTIONS(2560),
    [anon_sym_PIPE_GT] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2558),
    [anon_sym_isa] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_QMARK] = ACTIONS(2560),
    [anon_sym_EQ_GT] = ACTIONS(2560),
    [anon_sym_LBRACK2] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2560),
    [anon_sym_AT] = ACTIONS(2560),
    [aux_sym_integer_literal_token1] = ACTIONS(2560),
    [aux_sym_integer_literal_token2] = ACTIONS(2560),
    [aux_sym_integer_literal_token3] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
    [sym__unary_operator] = ACTIONS(2558),
    [sym__power_operator] = ACTIONS(2560),
    [sym__bitshift_operator] = ACTIONS(2560),
    [sym__rational_operator] = ACTIONS(2560),
    [sym__times_operator] = ACTIONS(2558),
    [sym__plus_operator] = ACTIONS(2558),
    [sym__dotty_operator] = ACTIONS(2558),
    [sym__comparison_operator] = ACTIONS(2558),
    [sym__arrow_operator] = ACTIONS(2560),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2560),
    [sym__string_start] = ACTIONS(2560),
    [sym__command_start] = ACTIONS(2560),
  },
  [1122] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_primitive] = ACTIONS(2566),
    [aux_sym_primitive_definition_token1] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_macro] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2568),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_LT_COLON] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [sym_break_statement] = ACTIONS(2566),
    [sym_continue_statement] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_quote] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_COLON2] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_RBRACK] = ACTIONS(2568),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_LT_PIPE] = ACTIONS(2568),
    [anon_sym_PIPE_GT] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_isa] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2568),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK2] = ACTIONS(2566),
    [anon_sym_DOLLAR] = ACTIONS(2568),
    [anon_sym_AT] = ACTIONS(2568),
    [aux_sym_integer_literal_token1] = ACTIONS(2568),
    [aux_sym_integer_literal_token2] = ACTIONS(2568),
    [aux_sym_integer_literal_token3] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
    [sym__unary_operator] = ACTIONS(2566),
    [sym__power_operator] = ACTIONS(2568),
    [sym__bitshift_operator] = ACTIONS(2568),
    [sym__rational_operator] = ACTIONS(2568),
    [sym__times_operator] = ACTIONS(2566),
    [sym__plus_operator] = ACTIONS(2566),
    [sym__dotty_operator] = ACTIONS(2566),
    [sym__comparison_operator] = ACTIONS(2566),
    [sym__arrow_operator] = ACTIONS(2568),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2568),
    [sym__string_start] = ACTIONS(2568),
    [sym__command_start] = ACTIONS(2568),
  },
  [1123] = {
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_primitive] = ACTIONS(2570),
    [aux_sym_primitive_definition_token1] = ACTIONS(2570),
    [anon_sym_mutable] = ACTIONS(2570),
    [anon_sym_struct] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_macro] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2572),
    [anon_sym_RPAREN] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_LT_COLON] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [sym_break_statement] = ACTIONS(2570),
    [sym_continue_statement] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_quote] = ACTIONS(2570),
    [anon_sym_using] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_COLON2] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_RBRACK] = ACTIONS(2572),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_LT_PIPE] = ACTIONS(2572),
    [anon_sym_PIPE_GT] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_isa] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2572),
    [anon_sym_AMP_AMP] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(2572),
    [anon_sym_LBRACK2] = ACTIONS(2570),
    [anon_sym_DOLLAR] = ACTIONS(2572),
    [anon_sym_AT] = ACTIONS(2572),
    [aux_sym_integer_literal_token1] = ACTIONS(2572),
    [aux_sym_integer_literal_token2] = ACTIONS(2572),
    [aux_sym_integer_literal_token3] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
    [sym__unary_operator] = ACTIONS(2570),
    [sym__power_operator] = ACTIONS(2572),
    [sym__bitshift_operator] = ACTIONS(2572),
    [sym__rational_operator] = ACTIONS(2572),
    [sym__times_operator] = ACTIONS(2570),
    [sym__plus_operator] = ACTIONS(2570),
    [sym__dotty_operator] = ACTIONS(2570),
    [sym__comparison_operator] = ACTIONS(2570),
    [sym__arrow_operator] = ACTIONS(2572),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__command_start] = ACTIONS(2572),
  },
  [1124] = {
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_primitive] = ACTIONS(2574),
    [aux_sym_primitive_definition_token1] = ACTIONS(2574),
    [anon_sym_mutable] = ACTIONS(2574),
    [anon_sym_struct] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_macro] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2576),
    [anon_sym_COLON_COLON] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_LT_COLON] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [sym_break_statement] = ACTIONS(2574),
    [sym_continue_statement] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_quote] = ACTIONS(2574),
    [anon_sym_using] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_COLON2] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_RBRACK] = ACTIONS(2576),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_LT_PIPE] = ACTIONS(2576),
    [anon_sym_PIPE_GT] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_isa] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(2576),
    [anon_sym_LBRACK2] = ACTIONS(2574),
    [anon_sym_DOLLAR] = ACTIONS(2576),
    [anon_sym_AT] = ACTIONS(2576),
    [aux_sym_integer_literal_token1] = ACTIONS(2576),
    [aux_sym_integer_literal_token2] = ACTIONS(2576),
    [aux_sym_integer_literal_token3] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
    [sym__unary_operator] = ACTIONS(2574),
    [sym__power_operator] = ACTIONS(2576),
    [sym__bitshift_operator] = ACTIONS(2576),
    [sym__rational_operator] = ACTIONS(2576),
    [sym__times_operator] = ACTIONS(2574),
    [sym__plus_operator] = ACTIONS(2574),
    [sym__dotty_operator] = ACTIONS(2574),
    [sym__comparison_operator] = ACTIONS(2574),
    [sym__arrow_operator] = ACTIONS(2576),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__command_start] = ACTIONS(2576),
  },
  [1125] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_end] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_primitive] = ACTIONS(2526),
    [aux_sym_primitive_definition_token1] = ACTIONS(2526),
    [anon_sym_mutable] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_macro] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LT_COLON] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_elseif] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [sym_break_statement] = ACTIONS(2526),
    [sym_continue_statement] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_quote] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_COLON2] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_begin] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_LT_PIPE] = ACTIONS(2526),
    [anon_sym_PIPE_GT] = ACTIONS(2526),
    [anon_sym_in] = ACTIONS(2526),
    [anon_sym_isa] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(2526),
    [anon_sym_LBRACK2] = ACTIONS(2526),
    [anon_sym_DOLLAR] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2526),
    [aux_sym_integer_literal_token1] = ACTIONS(2526),
    [aux_sym_integer_literal_token2] = ACTIONS(2526),
    [aux_sym_integer_literal_token3] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
    [sym__unary_operator] = ACTIONS(2526),
    [sym__power_operator] = ACTIONS(2526),
    [sym__bitshift_operator] = ACTIONS(2526),
    [sym__rational_operator] = ACTIONS(2526),
    [sym__times_operator] = ACTIONS(2526),
    [sym__plus_operator] = ACTIONS(2526),
    [sym__dotty_operator] = ACTIONS(2526),
    [sym__comparison_operator] = ACTIONS(2526),
    [sym__arrow_operator] = ACTIONS(2526),
    [anon_sym_LF] = ACTIONS(2528),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2528),
    [sym__string_start] = ACTIONS(2528),
    [sym__command_start] = ACTIONS(2528),
  },
  [1126] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_primitive] = ACTIONS(2562),
    [aux_sym_primitive_definition_token1] = ACTIONS(2562),
    [anon_sym_mutable] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_macro] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LT_COLON] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_elseif] = ACTIONS(2562),
    [anon_sym_else] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [sym_break_statement] = ACTIONS(2562),
    [sym_continue_statement] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_quote] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_COLON2] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_LT_PIPE] = ACTIONS(2562),
    [anon_sym_PIPE_GT] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_isa] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2562),
    [anon_sym_LBRACK2] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2562),
    [aux_sym_integer_literal_token1] = ACTIONS(2562),
    [aux_sym_integer_literal_token2] = ACTIONS(2562),
    [aux_sym_integer_literal_token3] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
    [sym__unary_operator] = ACTIONS(2562),
    [sym__power_operator] = ACTIONS(2562),
    [sym__bitshift_operator] = ACTIONS(2562),
    [sym__rational_operator] = ACTIONS(2562),
    [sym__times_operator] = ACTIONS(2562),
    [sym__plus_operator] = ACTIONS(2562),
    [sym__dotty_operator] = ACTIONS(2562),
    [sym__comparison_operator] = ACTIONS(2562),
    [sym__arrow_operator] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2564),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__command_start] = ACTIONS(2564),
  },
  [1127] = {
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_primitive] = ACTIONS(2578),
    [aux_sym_primitive_definition_token1] = ACTIONS(2578),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_macro] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_LT_COLON] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [sym_break_statement] = ACTIONS(2578),
    [sym_continue_statement] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_quote] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_COLON2] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_LT_PIPE] = ACTIONS(2580),
    [anon_sym_PIPE_GT] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_isa] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK2] = ACTIONS(2578),
    [anon_sym_DOLLAR] = ACTIONS(2580),
    [anon_sym_AT] = ACTIONS(2580),
    [aux_sym_integer_literal_token1] = ACTIONS(2580),
    [aux_sym_integer_literal_token2] = ACTIONS(2580),
    [aux_sym_integer_literal_token3] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
    [sym__unary_operator] = ACTIONS(2578),
    [sym__power_operator] = ACTIONS(2580),
    [sym__bitshift_operator] = ACTIONS(2580),
    [sym__rational_operator] = ACTIONS(2580),
    [sym__times_operator] = ACTIONS(2578),
    [sym__plus_operator] = ACTIONS(2578),
    [sym__dotty_operator] = ACTIONS(2578),
    [sym__comparison_operator] = ACTIONS(2578),
    [sym__arrow_operator] = ACTIONS(2580),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__command_start] = ACTIONS(2580),
  },
  [1128] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_end] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_primitive] = ACTIONS(2554),
    [aux_sym_primitive_definition_token1] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_macro] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2554),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LT_COLON] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_elseif] = ACTIONS(2554),
    [anon_sym_else] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [sym_break_statement] = ACTIONS(2554),
    [sym_continue_statement] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_quote] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_COLON2] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_begin] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_LT_PIPE] = ACTIONS(2554),
    [anon_sym_PIPE_GT] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_isa] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_QMARK] = ACTIONS(2554),
    [anon_sym_EQ_GT] = ACTIONS(2554),
    [anon_sym_LBRACK2] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2554),
    [anon_sym_AT] = ACTIONS(2554),
    [aux_sym_integer_literal_token1] = ACTIONS(2554),
    [aux_sym_integer_literal_token2] = ACTIONS(2554),
    [aux_sym_integer_literal_token3] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
    [sym__unary_operator] = ACTIONS(2554),
    [sym__power_operator] = ACTIONS(2554),
    [sym__bitshift_operator] = ACTIONS(2554),
    [sym__rational_operator] = ACTIONS(2554),
    [sym__times_operator] = ACTIONS(2554),
    [sym__plus_operator] = ACTIONS(2554),
    [sym__dotty_operator] = ACTIONS(2554),
    [sym__comparison_operator] = ACTIONS(2554),
    [sym__arrow_operator] = ACTIONS(2554),
    [anon_sym_LF] = ACTIONS(2556),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2556),
    [sym__string_start] = ACTIONS(2556),
    [sym__command_start] = ACTIONS(2556),
  },
  [1129] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_end] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_primitive] = ACTIONS(2542),
    [aux_sym_primitive_definition_token1] = ACTIONS(2542),
    [anon_sym_mutable] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_macro] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2542),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LT_COLON] = ACTIONS(2542),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_elseif] = ACTIONS(2542),
    [anon_sym_else] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [sym_break_statement] = ACTIONS(2542),
    [sym_continue_statement] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_quote] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_COLON2] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_LT_PIPE] = ACTIONS(2542),
    [anon_sym_PIPE_GT] = ACTIONS(2542),
    [anon_sym_in] = ACTIONS(2542),
    [anon_sym_isa] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(2542),
    [anon_sym_EQ_GT] = ACTIONS(2542),
    [anon_sym_LBRACK2] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2542),
    [aux_sym_integer_literal_token1] = ACTIONS(2542),
    [aux_sym_integer_literal_token2] = ACTIONS(2542),
    [aux_sym_integer_literal_token3] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
    [sym__unary_operator] = ACTIONS(2542),
    [sym__power_operator] = ACTIONS(2542),
    [sym__bitshift_operator] = ACTIONS(2542),
    [sym__rational_operator] = ACTIONS(2542),
    [sym__times_operator] = ACTIONS(2542),
    [sym__plus_operator] = ACTIONS(2542),
    [sym__dotty_operator] = ACTIONS(2542),
    [sym__comparison_operator] = ACTIONS(2542),
    [sym__arrow_operator] = ACTIONS(2542),
    [anon_sym_LF] = ACTIONS(2544),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2544),
    [sym__string_start] = ACTIONS(2544),
    [sym__command_start] = ACTIONS(2544),
  },
  [1130] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_primitive] = ACTIONS(2582),
    [aux_sym_primitive_definition_token1] = ACTIONS(2582),
    [anon_sym_mutable] = ACTIONS(2582),
    [anon_sym_struct] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_macro] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_LT_COLON] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [sym_break_statement] = ACTIONS(2582),
    [sym_continue_statement] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_quote] = ACTIONS(2582),
    [anon_sym_using] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_COLON2] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_LT_PIPE] = ACTIONS(2584),
    [anon_sym_PIPE_GT] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_isa] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2584),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK2] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2584),
    [anon_sym_AT] = ACTIONS(2584),
    [aux_sym_integer_literal_token1] = ACTIONS(2584),
    [aux_sym_integer_literal_token2] = ACTIONS(2584),
    [aux_sym_integer_literal_token3] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
    [sym__unary_operator] = ACTIONS(2582),
    [sym__power_operator] = ACTIONS(2584),
    [sym__bitshift_operator] = ACTIONS(2584),
    [sym__rational_operator] = ACTIONS(2584),
    [sym__times_operator] = ACTIONS(2582),
    [sym__plus_operator] = ACTIONS(2582),
    [sym__dotty_operator] = ACTIONS(2582),
    [sym__comparison_operator] = ACTIONS(2582),
    [sym__arrow_operator] = ACTIONS(2584),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__command_start] = ACTIONS(2584),
  },
  [1131] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_end] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_primitive] = ACTIONS(2498),
    [aux_sym_primitive_definition_token1] = ACTIONS(2498),
    [anon_sym_mutable] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_macro] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2498),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LT_COLON] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_elseif] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [sym_break_statement] = ACTIONS(2498),
    [sym_continue_statement] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_quote] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_COLON2] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_begin] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_LT_PIPE] = ACTIONS(2498),
    [anon_sym_PIPE_GT] = ACTIONS(2498),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_isa] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_QMARK] = ACTIONS(2498),
    [anon_sym_EQ_GT] = ACTIONS(2498),
    [anon_sym_LBRACK2] = ACTIONS(2498),
    [anon_sym_DOLLAR] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2498),
    [aux_sym_integer_literal_token1] = ACTIONS(2498),
    [aux_sym_integer_literal_token2] = ACTIONS(2498),
    [aux_sym_integer_literal_token3] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
    [sym__unary_operator] = ACTIONS(2498),
    [sym__power_operator] = ACTIONS(2498),
    [sym__bitshift_operator] = ACTIONS(2498),
    [sym__rational_operator] = ACTIONS(2498),
    [sym__times_operator] = ACTIONS(2498),
    [sym__plus_operator] = ACTIONS(2498),
    [sym__dotty_operator] = ACTIONS(2498),
    [sym__comparison_operator] = ACTIONS(2498),
    [sym__arrow_operator] = ACTIONS(2498),
    [anon_sym_LF] = ACTIONS(2500),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2500),
    [sym__string_start] = ACTIONS(2500),
    [sym__command_start] = ACTIONS(2500),
  },
  [1132] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_end] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_primitive] = ACTIONS(2534),
    [aux_sym_primitive_definition_token1] = ACTIONS(2534),
    [anon_sym_mutable] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_macro] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LT_COLON] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_elseif] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [sym_break_statement] = ACTIONS(2534),
    [sym_continue_statement] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_quote] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_COLON2] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_begin] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_LT_PIPE] = ACTIONS(2534),
    [anon_sym_PIPE_GT] = ACTIONS(2534),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_isa] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_QMARK] = ACTIONS(2534),
    [anon_sym_EQ_GT] = ACTIONS(2534),
    [anon_sym_LBRACK2] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2534),
    [aux_sym_integer_literal_token1] = ACTIONS(2534),
    [aux_sym_integer_literal_token2] = ACTIONS(2534),
    [aux_sym_integer_literal_token3] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
    [sym__unary_operator] = ACTIONS(2534),
    [sym__power_operator] = ACTIONS(2534),
    [sym__bitshift_operator] = ACTIONS(2534),
    [sym__rational_operator] = ACTIONS(2534),
    [sym__times_operator] = ACTIONS(2534),
    [sym__plus_operator] = ACTIONS(2534),
    [sym__dotty_operator] = ACTIONS(2534),
    [sym__comparison_operator] = ACTIONS(2534),
    [sym__arrow_operator] = ACTIONS(2534),
    [anon_sym_LF] = ACTIONS(2536),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2536),
    [sym__string_start] = ACTIONS(2536),
    [sym__command_start] = ACTIONS(2536),
  },
  [1133] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_primitive] = ACTIONS(2490),
    [aux_sym_primitive_definition_token1] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_macro] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LT_COLON] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_elseif] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [sym_break_statement] = ACTIONS(2490),
    [sym_continue_statement] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_quote] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_COLON2] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_begin] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_LT_PIPE] = ACTIONS(2490),
    [anon_sym_PIPE_GT] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_isa] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(2490),
    [anon_sym_LBRACK2] = ACTIONS(2490),
    [anon_sym_DOLLAR] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2490),
    [aux_sym_integer_literal_token1] = ACTIONS(2490),
    [aux_sym_integer_literal_token2] = ACTIONS(2490),
    [aux_sym_integer_literal_token3] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
    [sym__unary_operator] = ACTIONS(2490),
    [sym__power_operator] = ACTIONS(2490),
    [sym__bitshift_operator] = ACTIONS(2490),
    [sym__rational_operator] = ACTIONS(2490),
    [sym__times_operator] = ACTIONS(2490),
    [sym__plus_operator] = ACTIONS(2490),
    [sym__dotty_operator] = ACTIONS(2490),
    [sym__comparison_operator] = ACTIONS(2490),
    [sym__arrow_operator] = ACTIONS(2490),
    [anon_sym_LF] = ACTIONS(2492),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2492),
    [sym__string_start] = ACTIONS(2492),
    [sym__command_start] = ACTIONS(2492),
  },
  [1134] = {
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(2734),
    [anon_sym_end] = ACTIONS(2734),
    [anon_sym_abstract] = ACTIONS(2734),
    [anon_sym_primitive] = ACTIONS(2734),
    [aux_sym_primitive_definition_token1] = ACTIONS(2734),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2734),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_macro] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_COMMA] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2736),
    [anon_sym_COLON_COLON] = ACTIONS(2736),
    [anon_sym_RBRACE] = ACTIONS(2736),
    [anon_sym_LT_COLON] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2734),
    [anon_sym_try] = ACTIONS(2734),
    [anon_sym_for] = ACTIONS(2734),
    [anon_sym_while] = ACTIONS(2734),
    [sym_break_statement] = ACTIONS(2734),
    [sym_continue_statement] = ACTIONS(2734),
    [anon_sym_return] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_const] = ACTIONS(2734),
    [anon_sym_quote] = ACTIONS(2734),
    [anon_sym_using] = ACTIONS(2734),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_COLON2] = ACTIONS(2734),
    [anon_sym_RBRACK] = ACTIONS(2736),
    [anon_sym_begin] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_LT_PIPE] = ACTIONS(2736),
    [anon_sym_PIPE_GT] = ACTIONS(2736),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_isa] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2736),
    [anon_sym_AMP_AMP] = ACTIONS(2736),
    [anon_sym_QMARK] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2736),
    [anon_sym_LBRACK2] = ACTIONS(2736),
    [anon_sym_DOLLAR] = ACTIONS(2734),
    [anon_sym_AT] = ACTIONS(2736),
    [aux_sym_integer_literal_token1] = ACTIONS(2736),
    [aux_sym_integer_literal_token2] = ACTIONS(2736),
    [aux_sym_integer_literal_token3] = ACTIONS(2734),
    [sym_float_literal] = ACTIONS(2734),
    [sym__unary_operator] = ACTIONS(2734),
    [sym__power_operator] = ACTIONS(2734),
    [sym__bitshift_operator] = ACTIONS(2734),
    [sym__rational_operator] = ACTIONS(2734),
    [sym__times_operator] = ACTIONS(2734),
    [sym__plus_operator] = ACTIONS(2734),
    [sym__dotty_operator] = ACTIONS(2734),
    [sym__comparison_operator] = ACTIONS(2734),
    [sym__arrow_operator] = ACTIONS(2736),
    [sym__assign_operator] = ACTIONS(2734),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2736),
    [sym__command_start] = ACTIONS(2736),
  },
  [1135] = {
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_end] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_primitive] = ACTIONS(2502),
    [aux_sym_primitive_definition_token1] = ACTIONS(2502),
    [anon_sym_mutable] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_macro] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2502),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2502),
    [anon_sym_LT_COLON] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_elseif] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [sym_break_statement] = ACTIONS(2502),
    [sym_continue_statement] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_quote] = ACTIONS(2502),
    [anon_sym_using] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_COLON2] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_LT_PIPE] = ACTIONS(2502),
    [anon_sym_PIPE_GT] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2502),
    [anon_sym_isa] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_EQ_GT] = ACTIONS(2502),
    [anon_sym_LBRACK2] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_AT] = ACTIONS(2502),
    [aux_sym_integer_literal_token1] = ACTIONS(2502),
    [aux_sym_integer_literal_token2] = ACTIONS(2502),
    [aux_sym_integer_literal_token3] = ACTIONS(2502),
    [sym_float_literal] = ACTIONS(2502),
    [sym__unary_operator] = ACTIONS(2502),
    [sym__power_operator] = ACTIONS(2502),
    [sym__bitshift_operator] = ACTIONS(2502),
    [sym__rational_operator] = ACTIONS(2502),
    [sym__times_operator] = ACTIONS(2502),
    [sym__plus_operator] = ACTIONS(2502),
    [sym__dotty_operator] = ACTIONS(2502),
    [sym__comparison_operator] = ACTIONS(2502),
    [sym__arrow_operator] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2504),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2504),
    [sym__string_start] = ACTIONS(2504),
    [sym__command_start] = ACTIONS(2504),
  },
  [1136] = {
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_COMMA] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_LT_COLON] = ACTIONS(2746),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(3199),
    [anon_sym_DOT] = ACTIONS(3201),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_RBRACK] = ACTIONS(2746),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2746),
    [anon_sym_PIPE_GT] = ACTIONS(2746),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_QMARK] = ACTIONS(2746),
    [anon_sym_EQ_GT] = ACTIONS(2746),
    [anon_sym_LBRACK2] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2746),
    [aux_sym_integer_literal_token1] = ACTIONS(2746),
    [aux_sym_integer_literal_token2] = ACTIONS(2746),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2746),
    [sym__assign_operator] = ACTIONS(2744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1137] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_end] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_primitive] = ACTIONS(2506),
    [aux_sym_primitive_definition_token1] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_macro] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LT_COLON] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_elseif] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [sym_break_statement] = ACTIONS(2506),
    [sym_continue_statement] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_quote] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_COLON2] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT_PIPE] = ACTIONS(2506),
    [anon_sym_PIPE_GT] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_isa] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_EQ_GT] = ACTIONS(2506),
    [anon_sym_LBRACK2] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2506),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
    [sym__unary_operator] = ACTIONS(2506),
    [sym__power_operator] = ACTIONS(2506),
    [sym__bitshift_operator] = ACTIONS(2506),
    [sym__rational_operator] = ACTIONS(2506),
    [sym__times_operator] = ACTIONS(2506),
    [sym__plus_operator] = ACTIONS(2506),
    [sym__dotty_operator] = ACTIONS(2506),
    [sym__comparison_operator] = ACTIONS(2506),
    [sym__arrow_operator] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2508),
    [sym__string_start] = ACTIONS(2508),
    [sym__command_start] = ACTIONS(2508),
  },
  [1138] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_end] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_primitive] = ACTIONS(2514),
    [aux_sym_primitive_definition_token1] = ACTIONS(2514),
    [anon_sym_mutable] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_macro] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LT_COLON] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_elseif] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [sym_break_statement] = ACTIONS(2514),
    [sym_continue_statement] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_quote] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_COLON2] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_LT_PIPE] = ACTIONS(2514),
    [anon_sym_PIPE_GT] = ACTIONS(2514),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_isa] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_EQ_GT] = ACTIONS(2514),
    [anon_sym_LBRACK2] = ACTIONS(2514),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2514),
    [aux_sym_integer_literal_token1] = ACTIONS(2514),
    [aux_sym_integer_literal_token2] = ACTIONS(2514),
    [aux_sym_integer_literal_token3] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__power_operator] = ACTIONS(2514),
    [sym__bitshift_operator] = ACTIONS(2514),
    [sym__rational_operator] = ACTIONS(2514),
    [sym__times_operator] = ACTIONS(2514),
    [sym__plus_operator] = ACTIONS(2514),
    [sym__dotty_operator] = ACTIONS(2514),
    [sym__comparison_operator] = ACTIONS(2514),
    [sym__arrow_operator] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2516),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2516),
    [sym__string_start] = ACTIONS(2516),
    [sym__command_start] = ACTIONS(2516),
  },
  [1139] = {
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_end] = ACTIONS(2738),
    [anon_sym_abstract] = ACTIONS(2738),
    [anon_sym_primitive] = ACTIONS(2738),
    [aux_sym_primitive_definition_token1] = ACTIONS(2738),
    [anon_sym_mutable] = ACTIONS(2738),
    [anon_sym_struct] = ACTIONS(2738),
    [anon_sym_module] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_EQ] = ACTIONS(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_LT_COLON] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2738),
    [anon_sym_try] = ACTIONS(2738),
    [anon_sym_for] = ACTIONS(2738),
    [anon_sym_while] = ACTIONS(2738),
    [sym_break_statement] = ACTIONS(2738),
    [sym_continue_statement] = ACTIONS(2738),
    [anon_sym_return] = ACTIONS(2738),
    [anon_sym_let] = ACTIONS(2738),
    [anon_sym_const] = ACTIONS(2738),
    [anon_sym_quote] = ACTIONS(2738),
    [anon_sym_using] = ACTIONS(2738),
    [anon_sym_import] = ACTIONS(2738),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_DOT] = ACTIONS(2738),
    [anon_sym_export] = ACTIONS(2738),
    [anon_sym_COLON2] = ACTIONS(2738),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_begin] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2738),
    [anon_sym_LT_PIPE] = ACTIONS(2740),
    [anon_sym_PIPE_GT] = ACTIONS(2740),
    [anon_sym_in] = ACTIONS(2738),
    [anon_sym_isa] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_EQ_GT] = ACTIONS(2740),
    [anon_sym_LBRACK2] = ACTIONS(2740),
    [anon_sym_DOLLAR] = ACTIONS(2738),
    [anon_sym_AT] = ACTIONS(2740),
    [aux_sym_integer_literal_token1] = ACTIONS(2740),
    [aux_sym_integer_literal_token2] = ACTIONS(2740),
    [aux_sym_integer_literal_token3] = ACTIONS(2738),
    [sym_float_literal] = ACTIONS(2738),
    [sym__unary_operator] = ACTIONS(2738),
    [sym__power_operator] = ACTIONS(2738),
    [sym__bitshift_operator] = ACTIONS(2738),
    [sym__rational_operator] = ACTIONS(2738),
    [sym__times_operator] = ACTIONS(2738),
    [sym__plus_operator] = ACTIONS(2738),
    [sym__dotty_operator] = ACTIONS(2738),
    [sym__comparison_operator] = ACTIONS(2738),
    [sym__arrow_operator] = ACTIONS(2740),
    [sym__assign_operator] = ACTIONS(2738),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2740),
    [sym__command_start] = ACTIONS(2740),
  },
  [1140] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_end] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_primitive] = ACTIONS(2518),
    [aux_sym_primitive_definition_token1] = ACTIONS(2518),
    [anon_sym_mutable] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_macro] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LT_COLON] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_elseif] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [sym_break_statement] = ACTIONS(2518),
    [sym_continue_statement] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_quote] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_COLON2] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_LT_PIPE] = ACTIONS(2518),
    [anon_sym_PIPE_GT] = ACTIONS(2518),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_isa] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_EQ_GT] = ACTIONS(2518),
    [anon_sym_LBRACK2] = ACTIONS(2518),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2518),
    [aux_sym_integer_literal_token1] = ACTIONS(2518),
    [aux_sym_integer_literal_token2] = ACTIONS(2518),
    [aux_sym_integer_literal_token3] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
    [sym__unary_operator] = ACTIONS(2518),
    [sym__power_operator] = ACTIONS(2518),
    [sym__bitshift_operator] = ACTIONS(2518),
    [sym__rational_operator] = ACTIONS(2518),
    [sym__times_operator] = ACTIONS(2518),
    [sym__plus_operator] = ACTIONS(2518),
    [sym__dotty_operator] = ACTIONS(2518),
    [sym__comparison_operator] = ACTIONS(2518),
    [sym__arrow_operator] = ACTIONS(2518),
    [anon_sym_LF] = ACTIONS(2520),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2520),
    [sym__string_start] = ACTIONS(2520),
    [sym__command_start] = ACTIONS(2520),
  },
  [1141] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_end] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_primitive] = ACTIONS(2522),
    [aux_sym_primitive_definition_token1] = ACTIONS(2522),
    [anon_sym_mutable] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_macro] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_COMMA] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2522),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LT_COLON] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_elseif] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [sym_break_statement] = ACTIONS(2522),
    [sym_continue_statement] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_quote] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_COLON2] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_begin] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_LT_PIPE] = ACTIONS(2522),
    [anon_sym_PIPE_GT] = ACTIONS(2522),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_isa] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_QMARK] = ACTIONS(2522),
    [anon_sym_EQ_GT] = ACTIONS(2522),
    [anon_sym_LBRACK2] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2522),
    [aux_sym_integer_literal_token1] = ACTIONS(2522),
    [aux_sym_integer_literal_token2] = ACTIONS(2522),
    [aux_sym_integer_literal_token3] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
    [sym__unary_operator] = ACTIONS(2522),
    [sym__power_operator] = ACTIONS(2522),
    [sym__bitshift_operator] = ACTIONS(2522),
    [sym__rational_operator] = ACTIONS(2522),
    [sym__times_operator] = ACTIONS(2522),
    [sym__plus_operator] = ACTIONS(2522),
    [sym__dotty_operator] = ACTIONS(2522),
    [sym__comparison_operator] = ACTIONS(2522),
    [sym__arrow_operator] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2524),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2524),
    [sym__string_start] = ACTIONS(2524),
    [sym__command_start] = ACTIONS(2524),
  },
  [1142] = {
    [sym_identifier] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2586),
    [anon_sym_end] = ACTIONS(2586),
    [anon_sym_abstract] = ACTIONS(2586),
    [anon_sym_primitive] = ACTIONS(2586),
    [aux_sym_primitive_definition_token1] = ACTIONS(2586),
    [anon_sym_mutable] = ACTIONS(2586),
    [anon_sym_struct] = ACTIONS(2586),
    [anon_sym_module] = ACTIONS(2586),
    [anon_sym_macro] = ACTIONS(2586),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_COLON_COLON] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_LT_COLON] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2586),
    [anon_sym_try] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2586),
    [anon_sym_while] = ACTIONS(2586),
    [sym_break_statement] = ACTIONS(2586),
    [sym_continue_statement] = ACTIONS(2586),
    [anon_sym_return] = ACTIONS(2586),
    [anon_sym_let] = ACTIONS(2586),
    [anon_sym_const] = ACTIONS(2586),
    [anon_sym_quote] = ACTIONS(2586),
    [anon_sym_using] = ACTIONS(2586),
    [anon_sym_import] = ACTIONS(2586),
    [anon_sym_DOT] = ACTIONS(2586),
    [anon_sym_export] = ACTIONS(2586),
    [anon_sym_COLON2] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_begin] = ACTIONS(2586),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_LT_PIPE] = ACTIONS(2588),
    [anon_sym_PIPE_GT] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2586),
    [anon_sym_isa] = ACTIONS(2586),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_EQ_GT] = ACTIONS(2588),
    [anon_sym_LBRACK2] = ACTIONS(2586),
    [anon_sym_DASH_GT] = ACTIONS(2805),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [anon_sym_AT] = ACTIONS(2588),
    [aux_sym_integer_literal_token1] = ACTIONS(2588),
    [aux_sym_integer_literal_token2] = ACTIONS(2588),
    [aux_sym_integer_literal_token3] = ACTIONS(2586),
    [sym_float_literal] = ACTIONS(2586),
    [sym__unary_operator] = ACTIONS(2586),
    [sym__power_operator] = ACTIONS(2588),
    [sym__bitshift_operator] = ACTIONS(2588),
    [sym__rational_operator] = ACTIONS(2588),
    [sym__times_operator] = ACTIONS(2586),
    [sym__plus_operator] = ACTIONS(2586),
    [sym__dotty_operator] = ACTIONS(2586),
    [sym__comparison_operator] = ACTIONS(2586),
    [sym__arrow_operator] = ACTIONS(2588),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2588),
    [sym__string_start] = ACTIONS(2588),
    [sym__command_start] = ACTIONS(2588),
  },
  [1143] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_end] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_primitive] = ACTIONS(2530),
    [aux_sym_primitive_definition_token1] = ACTIONS(2530),
    [anon_sym_mutable] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_macro] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_COMMA] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2530),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LT_COLON] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_elseif] = ACTIONS(2530),
    [anon_sym_else] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [sym_break_statement] = ACTIONS(2530),
    [sym_continue_statement] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_quote] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_COLON2] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_begin] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_LT_PIPE] = ACTIONS(2530),
    [anon_sym_PIPE_GT] = ACTIONS(2530),
    [anon_sym_in] = ACTIONS(2530),
    [anon_sym_isa] = ACTIONS(2530),
    [anon_sym_PIPE_PIPE] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_QMARK] = ACTIONS(2530),
    [anon_sym_EQ_GT] = ACTIONS(2530),
    [anon_sym_LBRACK2] = ACTIONS(2530),
    [anon_sym_DOLLAR] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2530),
    [aux_sym_integer_literal_token1] = ACTIONS(2530),
    [aux_sym_integer_literal_token2] = ACTIONS(2530),
    [aux_sym_integer_literal_token3] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
    [sym__unary_operator] = ACTIONS(2530),
    [sym__power_operator] = ACTIONS(2530),
    [sym__bitshift_operator] = ACTIONS(2530),
    [sym__rational_operator] = ACTIONS(2530),
    [sym__times_operator] = ACTIONS(2530),
    [sym__plus_operator] = ACTIONS(2530),
    [sym__dotty_operator] = ACTIONS(2530),
    [sym__comparison_operator] = ACTIONS(2530),
    [sym__arrow_operator] = ACTIONS(2530),
    [anon_sym_LF] = ACTIONS(2532),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2532),
    [sym__string_start] = ACTIONS(2532),
    [sym__command_start] = ACTIONS(2532),
  },
  [1144] = {
    [ts_builtin_sym_end] = ACTIONS(2524),
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_primitive] = ACTIONS(2522),
    [aux_sym_primitive_definition_token1] = ACTIONS(2522),
    [anon_sym_mutable] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_macro] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2522),
    [anon_sym_COMMA] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2522),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2522),
    [anon_sym_COLON_COLON] = ACTIONS(2522),
    [anon_sym_LT_COLON] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [sym_break_statement] = ACTIONS(2522),
    [sym_continue_statement] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_quote] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_DOT] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_COLON2] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_begin] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_LT_PIPE] = ACTIONS(2522),
    [anon_sym_PIPE_GT] = ACTIONS(2522),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_isa] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2522),
    [anon_sym_AMP_AMP] = ACTIONS(2522),
    [anon_sym_QMARK] = ACTIONS(2522),
    [anon_sym_EQ_GT] = ACTIONS(2522),
    [anon_sym_LBRACK2] = ACTIONS(2522),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2522),
    [aux_sym_integer_literal_token1] = ACTIONS(2522),
    [aux_sym_integer_literal_token2] = ACTIONS(2522),
    [aux_sym_integer_literal_token3] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
    [sym__unary_operator] = ACTIONS(2522),
    [sym__power_operator] = ACTIONS(2522),
    [sym__bitshift_operator] = ACTIONS(2522),
    [sym__rational_operator] = ACTIONS(2522),
    [sym__times_operator] = ACTIONS(2522),
    [sym__plus_operator] = ACTIONS(2522),
    [sym__dotty_operator] = ACTIONS(2522),
    [sym__comparison_operator] = ACTIONS(2522),
    [sym__arrow_operator] = ACTIONS(2522),
    [sym__assign_operator] = ACTIONS(2522),
    [anon_sym_LF] = ACTIONS(2524),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2524),
    [sym__string_start] = ACTIONS(2524),
    [sym__command_start] = ACTIONS(2524),
  },
  [1145] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_end] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_primitive] = ACTIONS(2538),
    [aux_sym_primitive_definition_token1] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_macro] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2538),
    [anon_sym_COMMA] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2538),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LT_COLON] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_elseif] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [sym_break_statement] = ACTIONS(2538),
    [sym_continue_statement] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_quote] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_DOT] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_COLON2] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_begin] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_LT_PIPE] = ACTIONS(2538),
    [anon_sym_PIPE_GT] = ACTIONS(2538),
    [anon_sym_in] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_EQ_GT] = ACTIONS(2538),
    [anon_sym_LBRACK2] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2538),
    [aux_sym_integer_literal_token1] = ACTIONS(2538),
    [aux_sym_integer_literal_token2] = ACTIONS(2538),
    [aux_sym_integer_literal_token3] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
    [sym__unary_operator] = ACTIONS(2538),
    [sym__power_operator] = ACTIONS(2538),
    [sym__bitshift_operator] = ACTIONS(2538),
    [sym__rational_operator] = ACTIONS(2538),
    [sym__times_operator] = ACTIONS(2538),
    [sym__plus_operator] = ACTIONS(2538),
    [sym__dotty_operator] = ACTIONS(2538),
    [sym__comparison_operator] = ACTIONS(2538),
    [sym__arrow_operator] = ACTIONS(2538),
    [anon_sym_LF] = ACTIONS(2540),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2540),
    [sym__string_start] = ACTIONS(2540),
    [sym__command_start] = ACTIONS(2540),
  },
  [1146] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_primitive] = ACTIONS(2494),
    [aux_sym_primitive_definition_token1] = ACTIONS(2494),
    [anon_sym_mutable] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_macro] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2494),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LT_COLON] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_elseif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [sym_break_statement] = ACTIONS(2494),
    [sym_continue_statement] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_quote] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_COLON2] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_begin] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_LT_PIPE] = ACTIONS(2494),
    [anon_sym_PIPE_GT] = ACTIONS(2494),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_isa] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_QMARK] = ACTIONS(2494),
    [anon_sym_EQ_GT] = ACTIONS(2494),
    [anon_sym_LBRACK2] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2494),
    [aux_sym_integer_literal_token1] = ACTIONS(2494),
    [aux_sym_integer_literal_token2] = ACTIONS(2494),
    [aux_sym_integer_literal_token3] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
    [sym__unary_operator] = ACTIONS(2494),
    [sym__power_operator] = ACTIONS(2494),
    [sym__bitshift_operator] = ACTIONS(2494),
    [sym__rational_operator] = ACTIONS(2494),
    [sym__times_operator] = ACTIONS(2494),
    [sym__plus_operator] = ACTIONS(2494),
    [sym__dotty_operator] = ACTIONS(2494),
    [sym__comparison_operator] = ACTIONS(2494),
    [sym__arrow_operator] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2496),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2496),
    [sym__string_start] = ACTIONS(2496),
    [sym__command_start] = ACTIONS(2496),
  },
  [1147] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_end] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_primitive] = ACTIONS(2546),
    [aux_sym_primitive_definition_token1] = ACTIONS(2546),
    [anon_sym_mutable] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_macro] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_COMMA] = ACTIONS(2546),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LT_COLON] = ACTIONS(2546),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_elseif] = ACTIONS(2546),
    [anon_sym_else] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [sym_break_statement] = ACTIONS(2546),
    [sym_continue_statement] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_quote] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_DOT] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_COLON2] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_begin] = ACTIONS(2546),
    [anon_sym_do] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_LT_PIPE] = ACTIONS(2546),
    [anon_sym_PIPE_GT] = ACTIONS(2546),
    [anon_sym_in] = ACTIONS(2546),
    [anon_sym_isa] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_QMARK] = ACTIONS(2546),
    [anon_sym_EQ_GT] = ACTIONS(2546),
    [anon_sym_LBRACK2] = ACTIONS(2546),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2546),
    [aux_sym_integer_literal_token1] = ACTIONS(2546),
    [aux_sym_integer_literal_token2] = ACTIONS(2546),
    [aux_sym_integer_literal_token3] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
    [sym__unary_operator] = ACTIONS(2546),
    [sym__power_operator] = ACTIONS(2546),
    [sym__bitshift_operator] = ACTIONS(2546),
    [sym__rational_operator] = ACTIONS(2546),
    [sym__times_operator] = ACTIONS(2546),
    [sym__plus_operator] = ACTIONS(2546),
    [sym__dotty_operator] = ACTIONS(2546),
    [sym__comparison_operator] = ACTIONS(2546),
    [sym__arrow_operator] = ACTIONS(2546),
    [anon_sym_LF] = ACTIONS(2548),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2548),
    [sym__string_start] = ACTIONS(2548),
    [sym__command_start] = ACTIONS(2548),
  },
  [1148] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_end] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_primitive] = ACTIONS(2550),
    [aux_sym_primitive_definition_token1] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_macro] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_COMMA] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LT_COLON] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_elseif] = ACTIONS(2550),
    [anon_sym_else] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_break_statement] = ACTIONS(2550),
    [sym_continue_statement] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_quote] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_COLON2] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_begin] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_LT_PIPE] = ACTIONS(2550),
    [anon_sym_PIPE_GT] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_isa] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_QMARK] = ACTIONS(2550),
    [anon_sym_EQ_GT] = ACTIONS(2550),
    [anon_sym_LBRACK2] = ACTIONS(2550),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_AT] = ACTIONS(2550),
    [aux_sym_integer_literal_token1] = ACTIONS(2550),
    [aux_sym_integer_literal_token2] = ACTIONS(2550),
    [aux_sym_integer_literal_token3] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
    [sym__unary_operator] = ACTIONS(2550),
    [sym__power_operator] = ACTIONS(2550),
    [sym__bitshift_operator] = ACTIONS(2550),
    [sym__rational_operator] = ACTIONS(2550),
    [sym__times_operator] = ACTIONS(2550),
    [sym__plus_operator] = ACTIONS(2550),
    [sym__dotty_operator] = ACTIONS(2550),
    [sym__comparison_operator] = ACTIONS(2550),
    [sym__arrow_operator] = ACTIONS(2550),
    [anon_sym_LF] = ACTIONS(2552),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2552),
    [sym__string_start] = ACTIONS(2552),
    [sym__command_start] = ACTIONS(2552),
  },
  [1149] = {
    [ts_builtin_sym_end] = ACTIONS(2520),
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_primitive] = ACTIONS(2518),
    [aux_sym_primitive_definition_token1] = ACTIONS(2518),
    [anon_sym_mutable] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_macro] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2518),
    [anon_sym_EQ] = ACTIONS(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2518),
    [anon_sym_COLON_COLON] = ACTIONS(2518),
    [anon_sym_LT_COLON] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [sym_break_statement] = ACTIONS(2518),
    [sym_continue_statement] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_quote] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_DOT] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_COLON2] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_LT_PIPE] = ACTIONS(2518),
    [anon_sym_PIPE_GT] = ACTIONS(2518),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_isa] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2518),
    [anon_sym_AMP_AMP] = ACTIONS(2518),
    [anon_sym_QMARK] = ACTIONS(2518),
    [anon_sym_EQ_GT] = ACTIONS(2518),
    [anon_sym_LBRACK2] = ACTIONS(2518),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2518),
    [aux_sym_integer_literal_token1] = ACTIONS(2518),
    [aux_sym_integer_literal_token2] = ACTIONS(2518),
    [aux_sym_integer_literal_token3] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
    [sym__unary_operator] = ACTIONS(2518),
    [sym__power_operator] = ACTIONS(2518),
    [sym__bitshift_operator] = ACTIONS(2518),
    [sym__rational_operator] = ACTIONS(2518),
    [sym__times_operator] = ACTIONS(2518),
    [sym__plus_operator] = ACTIONS(2518),
    [sym__dotty_operator] = ACTIONS(2518),
    [sym__comparison_operator] = ACTIONS(2518),
    [sym__arrow_operator] = ACTIONS(2518),
    [sym__assign_operator] = ACTIONS(2518),
    [anon_sym_LF] = ACTIONS(2520),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2520),
    [sym__string_start] = ACTIONS(2520),
    [sym__command_start] = ACTIONS(2520),
  },
  [1150] = {
    [ts_builtin_sym_end] = ACTIONS(2580),
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_primitive] = ACTIONS(2578),
    [aux_sym_primitive_definition_token1] = ACTIONS(2578),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_macro] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LT_COLON] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [sym_break_statement] = ACTIONS(2578),
    [sym_continue_statement] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_quote] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_COLON2] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_LT_PIPE] = ACTIONS(2578),
    [anon_sym_PIPE_GT] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_isa] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2578),
    [anon_sym_LBRACK2] = ACTIONS(2578),
    [anon_sym_DOLLAR] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2578),
    [aux_sym_integer_literal_token1] = ACTIONS(2578),
    [aux_sym_integer_literal_token2] = ACTIONS(2578),
    [aux_sym_integer_literal_token3] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
    [sym__unary_operator] = ACTIONS(2578),
    [sym__power_operator] = ACTIONS(2578),
    [sym__bitshift_operator] = ACTIONS(2578),
    [sym__rational_operator] = ACTIONS(2578),
    [sym__times_operator] = ACTIONS(2578),
    [sym__plus_operator] = ACTIONS(2578),
    [sym__dotty_operator] = ACTIONS(2578),
    [sym__comparison_operator] = ACTIONS(2578),
    [sym__arrow_operator] = ACTIONS(2578),
    [sym__assign_operator] = ACTIONS(2578),
    [anon_sym_LF] = ACTIONS(2580),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__command_start] = ACTIONS(2580),
  },
  [1151] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_end] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_primitive] = ACTIONS(2558),
    [aux_sym_primitive_definition_token1] = ACTIONS(2558),
    [anon_sym_mutable] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_macro] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_COMMA] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2558),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LT_COLON] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_elseif] = ACTIONS(2558),
    [anon_sym_else] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [sym_break_statement] = ACTIONS(2558),
    [sym_continue_statement] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_quote] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_DOT] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_COLON2] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_begin] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_LT_PIPE] = ACTIONS(2558),
    [anon_sym_PIPE_GT] = ACTIONS(2558),
    [anon_sym_in] = ACTIONS(2558),
    [anon_sym_isa] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_QMARK] = ACTIONS(2558),
    [anon_sym_EQ_GT] = ACTIONS(2558),
    [anon_sym_LBRACK2] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2558),
    [aux_sym_integer_literal_token1] = ACTIONS(2558),
    [aux_sym_integer_literal_token2] = ACTIONS(2558),
    [aux_sym_integer_literal_token3] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
    [sym__unary_operator] = ACTIONS(2558),
    [sym__power_operator] = ACTIONS(2558),
    [sym__bitshift_operator] = ACTIONS(2558),
    [sym__rational_operator] = ACTIONS(2558),
    [sym__times_operator] = ACTIONS(2558),
    [sym__plus_operator] = ACTIONS(2558),
    [sym__dotty_operator] = ACTIONS(2558),
    [sym__comparison_operator] = ACTIONS(2558),
    [sym__arrow_operator] = ACTIONS(2558),
    [anon_sym_LF] = ACTIONS(2560),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2560),
    [sym__string_start] = ACTIONS(2560),
    [sym__command_start] = ACTIONS(2560),
  },
  [1152] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_primitive] = ACTIONS(2566),
    [aux_sym_primitive_definition_token1] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_macro] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LT_COLON] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_elseif] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [sym_break_statement] = ACTIONS(2566),
    [sym_continue_statement] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_quote] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_COLON2] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_LT_PIPE] = ACTIONS(2566),
    [anon_sym_PIPE_GT] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_isa] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2566),
    [anon_sym_LBRACK2] = ACTIONS(2566),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2566),
    [aux_sym_integer_literal_token1] = ACTIONS(2566),
    [aux_sym_integer_literal_token2] = ACTIONS(2566),
    [aux_sym_integer_literal_token3] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
    [sym__unary_operator] = ACTIONS(2566),
    [sym__power_operator] = ACTIONS(2566),
    [sym__bitshift_operator] = ACTIONS(2566),
    [sym__rational_operator] = ACTIONS(2566),
    [sym__times_operator] = ACTIONS(2566),
    [sym__plus_operator] = ACTIONS(2566),
    [sym__dotty_operator] = ACTIONS(2566),
    [sym__comparison_operator] = ACTIONS(2566),
    [sym__arrow_operator] = ACTIONS(2566),
    [anon_sym_LF] = ACTIONS(2568),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2568),
    [sym__string_start] = ACTIONS(2568),
    [sym__command_start] = ACTIONS(2568),
  },
  [1153] = {
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_primitive] = ACTIONS(2570),
    [aux_sym_primitive_definition_token1] = ACTIONS(2570),
    [anon_sym_mutable] = ACTIONS(2570),
    [anon_sym_struct] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_macro] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LT_COLON] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_elseif] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [sym_break_statement] = ACTIONS(2570),
    [sym_continue_statement] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_quote] = ACTIONS(2570),
    [anon_sym_using] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_COLON2] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_LT_PIPE] = ACTIONS(2570),
    [anon_sym_PIPE_GT] = ACTIONS(2570),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_isa] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_EQ_GT] = ACTIONS(2570),
    [anon_sym_LBRACK2] = ACTIONS(2570),
    [anon_sym_DOLLAR] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(2570),
    [aux_sym_integer_literal_token1] = ACTIONS(2570),
    [aux_sym_integer_literal_token2] = ACTIONS(2570),
    [aux_sym_integer_literal_token3] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
    [sym__unary_operator] = ACTIONS(2570),
    [sym__power_operator] = ACTIONS(2570),
    [sym__bitshift_operator] = ACTIONS(2570),
    [sym__rational_operator] = ACTIONS(2570),
    [sym__times_operator] = ACTIONS(2570),
    [sym__plus_operator] = ACTIONS(2570),
    [sym__dotty_operator] = ACTIONS(2570),
    [sym__comparison_operator] = ACTIONS(2570),
    [sym__arrow_operator] = ACTIONS(2570),
    [anon_sym_LF] = ACTIONS(2572),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__command_start] = ACTIONS(2572),
  },
  [1154] = {
    [ts_builtin_sym_end] = ACTIONS(2576),
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_primitive] = ACTIONS(2574),
    [aux_sym_primitive_definition_token1] = ACTIONS(2574),
    [anon_sym_mutable] = ACTIONS(2574),
    [anon_sym_struct] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_macro] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LT_COLON] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [sym_break_statement] = ACTIONS(2574),
    [sym_continue_statement] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_quote] = ACTIONS(2574),
    [anon_sym_using] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_COLON2] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_LT_PIPE] = ACTIONS(2574),
    [anon_sym_PIPE_GT] = ACTIONS(2574),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_isa] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_QMARK] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(2574),
    [anon_sym_LBRACK2] = ACTIONS(2574),
    [anon_sym_DOLLAR] = ACTIONS(2574),
    [anon_sym_AT] = ACTIONS(2574),
    [aux_sym_integer_literal_token1] = ACTIONS(2574),
    [aux_sym_integer_literal_token2] = ACTIONS(2574),
    [aux_sym_integer_literal_token3] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
    [sym__unary_operator] = ACTIONS(2574),
    [sym__power_operator] = ACTIONS(2574),
    [sym__bitshift_operator] = ACTIONS(2574),
    [sym__rational_operator] = ACTIONS(2574),
    [sym__times_operator] = ACTIONS(2574),
    [sym__plus_operator] = ACTIONS(2574),
    [sym__dotty_operator] = ACTIONS(2574),
    [sym__comparison_operator] = ACTIONS(2574),
    [sym__arrow_operator] = ACTIONS(2574),
    [sym__assign_operator] = ACTIONS(2574),
    [anon_sym_LF] = ACTIONS(2576),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__command_start] = ACTIONS(2576),
  },
  [1155] = {
    [ts_builtin_sym_end] = ACTIONS(2516),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_primitive] = ACTIONS(2514),
    [aux_sym_primitive_definition_token1] = ACTIONS(2514),
    [anon_sym_mutable] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_macro] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2514),
    [anon_sym_COMMA] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2514),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2514),
    [anon_sym_COLON_COLON] = ACTIONS(2514),
    [anon_sym_LT_COLON] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [sym_break_statement] = ACTIONS(2514),
    [sym_continue_statement] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_quote] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_DOT] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_COLON2] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_LT_PIPE] = ACTIONS(2514),
    [anon_sym_PIPE_GT] = ACTIONS(2514),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_isa] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2514),
    [anon_sym_AMP_AMP] = ACTIONS(2514),
    [anon_sym_QMARK] = ACTIONS(2514),
    [anon_sym_EQ_GT] = ACTIONS(2514),
    [anon_sym_LBRACK2] = ACTIONS(2514),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2514),
    [aux_sym_integer_literal_token1] = ACTIONS(2514),
    [aux_sym_integer_literal_token2] = ACTIONS(2514),
    [aux_sym_integer_literal_token3] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__power_operator] = ACTIONS(2514),
    [sym__bitshift_operator] = ACTIONS(2514),
    [sym__rational_operator] = ACTIONS(2514),
    [sym__times_operator] = ACTIONS(2514),
    [sym__plus_operator] = ACTIONS(2514),
    [sym__dotty_operator] = ACTIONS(2514),
    [sym__comparison_operator] = ACTIONS(2514),
    [sym__arrow_operator] = ACTIONS(2514),
    [sym__assign_operator] = ACTIONS(2514),
    [anon_sym_LF] = ACTIONS(2516),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2516),
    [sym__string_start] = ACTIONS(2516),
    [sym__command_start] = ACTIONS(2516),
  },
  [1156] = {
    [sym_identifier] = ACTIONS(2502),
    [anon_sym_function] = ACTIONS(2502),
    [anon_sym_end] = ACTIONS(2502),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_primitive] = ACTIONS(2502),
    [aux_sym_primitive_definition_token1] = ACTIONS(2502),
    [anon_sym_mutable] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_module] = ACTIONS(2502),
    [anon_sym_macro] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2504),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2504),
    [anon_sym_COLON_COLON] = ACTIONS(2504),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2504),
    [anon_sym_LT_COLON] = ACTIONS(2504),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [sym_break_statement] = ACTIONS(2502),
    [sym_continue_statement] = ACTIONS(2502),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_quote] = ACTIONS(2502),
    [anon_sym_using] = ACTIONS(2502),
    [anon_sym_import] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_export] = ACTIONS(2502),
    [anon_sym_COLON2] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_RBRACK] = ACTIONS(2504),
    [anon_sym_begin] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_LT_PIPE] = ACTIONS(2504),
    [anon_sym_PIPE_GT] = ACTIONS(2504),
    [anon_sym_in] = ACTIONS(2502),
    [anon_sym_isa] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2504),
    [anon_sym_AMP_AMP] = ACTIONS(2504),
    [anon_sym_QMARK] = ACTIONS(2504),
    [anon_sym_EQ_GT] = ACTIONS(2504),
    [anon_sym_LBRACK2] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2504),
    [anon_sym_AT] = ACTIONS(2504),
    [aux_sym_integer_literal_token1] = ACTIONS(2504),
    [aux_sym_integer_literal_token2] = ACTIONS(2504),
    [aux_sym_integer_literal_token3] = ACTIONS(2502),
    [sym_float_literal] = ACTIONS(2502),
    [sym__unary_operator] = ACTIONS(2502),
    [sym__power_operator] = ACTIONS(2504),
    [sym__bitshift_operator] = ACTIONS(2504),
    [sym__rational_operator] = ACTIONS(2504),
    [sym__times_operator] = ACTIONS(2502),
    [sym__plus_operator] = ACTIONS(2502),
    [sym__dotty_operator] = ACTIONS(2502),
    [sym__comparison_operator] = ACTIONS(2502),
    [sym__arrow_operator] = ACTIONS(2504),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2504),
    [sym__string_start] = ACTIONS(2504),
    [sym__command_start] = ACTIONS(2504),
  },
  [1157] = {
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_primitive] = ACTIONS(2574),
    [aux_sym_primitive_definition_token1] = ACTIONS(2574),
    [anon_sym_mutable] = ACTIONS(2574),
    [anon_sym_struct] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_macro] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2574),
    [anon_sym_COMMA] = ACTIONS(2574),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2574),
    [anon_sym_COLON_COLON] = ACTIONS(2574),
    [anon_sym_LT_COLON] = ACTIONS(2574),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_elseif] = ACTIONS(2574),
    [anon_sym_else] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [sym_break_statement] = ACTIONS(2574),
    [sym_continue_statement] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_quote] = ACTIONS(2574),
    [anon_sym_using] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_DOT] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_COLON2] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2576),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_do] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2574),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_LT_PIPE] = ACTIONS(2574),
    [anon_sym_PIPE_GT] = ACTIONS(2574),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_isa] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2574),
    [anon_sym_AMP_AMP] = ACTIONS(2574),
    [anon_sym_QMARK] = ACTIONS(2574),
    [anon_sym_EQ_GT] = ACTIONS(2574),
    [anon_sym_LBRACK2] = ACTIONS(2574),
    [anon_sym_DOLLAR] = ACTIONS(2574),
    [anon_sym_AT] = ACTIONS(2574),
    [aux_sym_integer_literal_token1] = ACTIONS(2574),
    [aux_sym_integer_literal_token2] = ACTIONS(2574),
    [aux_sym_integer_literal_token3] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
    [sym__unary_operator] = ACTIONS(2574),
    [sym__power_operator] = ACTIONS(2574),
    [sym__bitshift_operator] = ACTIONS(2574),
    [sym__rational_operator] = ACTIONS(2574),
    [sym__times_operator] = ACTIONS(2574),
    [sym__plus_operator] = ACTIONS(2574),
    [sym__dotty_operator] = ACTIONS(2574),
    [sym__comparison_operator] = ACTIONS(2574),
    [sym__arrow_operator] = ACTIONS(2574),
    [anon_sym_LF] = ACTIONS(2576),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2576),
    [sym__string_start] = ACTIONS(2576),
    [sym__command_start] = ACTIONS(2576),
  },
  [1158] = {
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_primitive] = ACTIONS(2578),
    [aux_sym_primitive_definition_token1] = ACTIONS(2578),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_macro] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2578),
    [anon_sym_COMMA] = ACTIONS(2578),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2578),
    [anon_sym_COLON_COLON] = ACTIONS(2578),
    [anon_sym_LT_COLON] = ACTIONS(2578),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_elseif] = ACTIONS(2578),
    [anon_sym_else] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [sym_break_statement] = ACTIONS(2578),
    [sym_continue_statement] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_quote] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_DOT] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_COLON2] = ACTIONS(2578),
    [anon_sym_LBRACK] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_do] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2578),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_LT_PIPE] = ACTIONS(2578),
    [anon_sym_PIPE_GT] = ACTIONS(2578),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_isa] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2578),
    [anon_sym_AMP_AMP] = ACTIONS(2578),
    [anon_sym_QMARK] = ACTIONS(2578),
    [anon_sym_EQ_GT] = ACTIONS(2578),
    [anon_sym_LBRACK2] = ACTIONS(2578),
    [anon_sym_DOLLAR] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2578),
    [aux_sym_integer_literal_token1] = ACTIONS(2578),
    [aux_sym_integer_literal_token2] = ACTIONS(2578),
    [aux_sym_integer_literal_token3] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
    [sym__unary_operator] = ACTIONS(2578),
    [sym__power_operator] = ACTIONS(2578),
    [sym__bitshift_operator] = ACTIONS(2578),
    [sym__rational_operator] = ACTIONS(2578),
    [sym__times_operator] = ACTIONS(2578),
    [sym__plus_operator] = ACTIONS(2578),
    [sym__dotty_operator] = ACTIONS(2578),
    [sym__comparison_operator] = ACTIONS(2578),
    [sym__arrow_operator] = ACTIONS(2578),
    [anon_sym_LF] = ACTIONS(2580),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2580),
    [sym__string_start] = ACTIONS(2580),
    [sym__command_start] = ACTIONS(2580),
  },
  [1159] = {
    [ts_builtin_sym_end] = ACTIONS(2572),
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_primitive] = ACTIONS(2570),
    [aux_sym_primitive_definition_token1] = ACTIONS(2570),
    [anon_sym_mutable] = ACTIONS(2570),
    [anon_sym_struct] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_macro] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2570),
    [anon_sym_COMMA] = ACTIONS(2570),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2570),
    [anon_sym_COLON_COLON] = ACTIONS(2570),
    [anon_sym_LT_COLON] = ACTIONS(2570),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [sym_break_statement] = ACTIONS(2570),
    [sym_continue_statement] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_quote] = ACTIONS(2570),
    [anon_sym_using] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_DOT] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_COLON2] = ACTIONS(2570),
    [anon_sym_LBRACK] = ACTIONS(2572),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_do] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2570),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_LT_PIPE] = ACTIONS(2570),
    [anon_sym_PIPE_GT] = ACTIONS(2570),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_isa] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2570),
    [anon_sym_AMP_AMP] = ACTIONS(2570),
    [anon_sym_QMARK] = ACTIONS(2570),
    [anon_sym_EQ_GT] = ACTIONS(2570),
    [anon_sym_LBRACK2] = ACTIONS(2570),
    [anon_sym_DOLLAR] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(2570),
    [aux_sym_integer_literal_token1] = ACTIONS(2570),
    [aux_sym_integer_literal_token2] = ACTIONS(2570),
    [aux_sym_integer_literal_token3] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
    [sym__unary_operator] = ACTIONS(2570),
    [sym__power_operator] = ACTIONS(2570),
    [sym__bitshift_operator] = ACTIONS(2570),
    [sym__rational_operator] = ACTIONS(2570),
    [sym__times_operator] = ACTIONS(2570),
    [sym__plus_operator] = ACTIONS(2570),
    [sym__dotty_operator] = ACTIONS(2570),
    [sym__comparison_operator] = ACTIONS(2570),
    [sym__arrow_operator] = ACTIONS(2570),
    [sym__assign_operator] = ACTIONS(2570),
    [anon_sym_LF] = ACTIONS(2572),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2572),
    [sym__string_start] = ACTIONS(2572),
    [sym__command_start] = ACTIONS(2572),
  },
  [1160] = {
    [ts_builtin_sym_end] = ACTIONS(2568),
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_primitive] = ACTIONS(2566),
    [aux_sym_primitive_definition_token1] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_macro] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2566),
    [anon_sym_COMMA] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2566),
    [anon_sym_COLON_COLON] = ACTIONS(2566),
    [anon_sym_LT_COLON] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [sym_break_statement] = ACTIONS(2566),
    [sym_continue_statement] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_quote] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_DOT] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_COLON2] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2568),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_LT_PIPE] = ACTIONS(2566),
    [anon_sym_PIPE_GT] = ACTIONS(2566),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_isa] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(2566),
    [anon_sym_QMARK] = ACTIONS(2566),
    [anon_sym_EQ_GT] = ACTIONS(2566),
    [anon_sym_LBRACK2] = ACTIONS(2566),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2566),
    [aux_sym_integer_literal_token1] = ACTIONS(2566),
    [aux_sym_integer_literal_token2] = ACTIONS(2566),
    [aux_sym_integer_literal_token3] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
    [sym__unary_operator] = ACTIONS(2566),
    [sym__power_operator] = ACTIONS(2566),
    [sym__bitshift_operator] = ACTIONS(2566),
    [sym__rational_operator] = ACTIONS(2566),
    [sym__times_operator] = ACTIONS(2566),
    [sym__plus_operator] = ACTIONS(2566),
    [sym__dotty_operator] = ACTIONS(2566),
    [sym__comparison_operator] = ACTIONS(2566),
    [sym__arrow_operator] = ACTIONS(2566),
    [sym__assign_operator] = ACTIONS(2566),
    [anon_sym_LF] = ACTIONS(2568),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2568),
    [sym__string_start] = ACTIONS(2568),
    [sym__command_start] = ACTIONS(2568),
  },
  [1161] = {
    [ts_builtin_sym_end] = ACTIONS(2560),
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_primitive] = ACTIONS(2558),
    [aux_sym_primitive_definition_token1] = ACTIONS(2558),
    [anon_sym_mutable] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_macro] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2558),
    [anon_sym_COMMA] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2558),
    [anon_sym_EQ] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2558),
    [anon_sym_COLON_COLON] = ACTIONS(2558),
    [anon_sym_LT_COLON] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [sym_break_statement] = ACTIONS(2558),
    [sym_continue_statement] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_quote] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_DOT] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_COLON2] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_begin] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2558),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_LT_PIPE] = ACTIONS(2558),
    [anon_sym_PIPE_GT] = ACTIONS(2558),
    [anon_sym_in] = ACTIONS(2558),
    [anon_sym_isa] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2558),
    [anon_sym_AMP_AMP] = ACTIONS(2558),
    [anon_sym_QMARK] = ACTIONS(2558),
    [anon_sym_EQ_GT] = ACTIONS(2558),
    [anon_sym_LBRACK2] = ACTIONS(2558),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2558),
    [aux_sym_integer_literal_token1] = ACTIONS(2558),
    [aux_sym_integer_literal_token2] = ACTIONS(2558),
    [aux_sym_integer_literal_token3] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
    [sym__unary_operator] = ACTIONS(2558),
    [sym__power_operator] = ACTIONS(2558),
    [sym__bitshift_operator] = ACTIONS(2558),
    [sym__rational_operator] = ACTIONS(2558),
    [sym__times_operator] = ACTIONS(2558),
    [sym__plus_operator] = ACTIONS(2558),
    [sym__dotty_operator] = ACTIONS(2558),
    [sym__comparison_operator] = ACTIONS(2558),
    [sym__arrow_operator] = ACTIONS(2558),
    [sym__assign_operator] = ACTIONS(2558),
    [anon_sym_LF] = ACTIONS(2560),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2560),
    [sym__string_start] = ACTIONS(2560),
    [sym__command_start] = ACTIONS(2560),
  },
  [1162] = {
    [ts_builtin_sym_end] = ACTIONS(2508),
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_primitive] = ACTIONS(2506),
    [aux_sym_primitive_definition_token1] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_macro] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2506),
    [anon_sym_COLON_COLON] = ACTIONS(2506),
    [anon_sym_LT_COLON] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [sym_break_statement] = ACTIONS(2506),
    [sym_continue_statement] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_quote] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_COLON2] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT_PIPE] = ACTIONS(2506),
    [anon_sym_PIPE_GT] = ACTIONS(2506),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_isa] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(2506),
    [anon_sym_EQ_GT] = ACTIONS(2506),
    [anon_sym_LBRACK2] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2506),
    [aux_sym_integer_literal_token1] = ACTIONS(2506),
    [aux_sym_integer_literal_token2] = ACTIONS(2506),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
    [sym__unary_operator] = ACTIONS(2506),
    [sym__power_operator] = ACTIONS(2506),
    [sym__bitshift_operator] = ACTIONS(2506),
    [sym__rational_operator] = ACTIONS(2506),
    [sym__times_operator] = ACTIONS(2506),
    [sym__plus_operator] = ACTIONS(2506),
    [sym__dotty_operator] = ACTIONS(2506),
    [sym__comparison_operator] = ACTIONS(2506),
    [sym__arrow_operator] = ACTIONS(2506),
    [sym__assign_operator] = ACTIONS(2506),
    [anon_sym_LF] = ACTIONS(2508),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2508),
    [sym__string_start] = ACTIONS(2508),
    [sym__command_start] = ACTIONS(2508),
  },
  [1163] = {
    [ts_builtin_sym_end] = ACTIONS(2512),
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_primitive] = ACTIONS(2510),
    [aux_sym_primitive_definition_token1] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_macro] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2510),
    [anon_sym_COMMA] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2510),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2510),
    [anon_sym_LT_COLON] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [sym_break_statement] = ACTIONS(2510),
    [sym_continue_statement] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_quote] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_DOT] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_COLON2] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_LT_PIPE] = ACTIONS(2510),
    [anon_sym_PIPE_GT] = ACTIONS(2510),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_isa] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2510),
    [anon_sym_AMP_AMP] = ACTIONS(2510),
    [anon_sym_QMARK] = ACTIONS(2510),
    [anon_sym_EQ_GT] = ACTIONS(2510),
    [anon_sym_LBRACK2] = ACTIONS(2510),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2510),
    [aux_sym_integer_literal_token1] = ACTIONS(2510),
    [aux_sym_integer_literal_token2] = ACTIONS(2510),
    [aux_sym_integer_literal_token3] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
    [sym__unary_operator] = ACTIONS(2510),
    [sym__power_operator] = ACTIONS(2510),
    [sym__bitshift_operator] = ACTIONS(2510),
    [sym__rational_operator] = ACTIONS(2510),
    [sym__times_operator] = ACTIONS(2510),
    [sym__plus_operator] = ACTIONS(2510),
    [sym__dotty_operator] = ACTIONS(2510),
    [sym__comparison_operator] = ACTIONS(2510),
    [sym__arrow_operator] = ACTIONS(2510),
    [sym__assign_operator] = ACTIONS(2510),
    [anon_sym_LF] = ACTIONS(2512),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2512),
    [sym__string_start] = ACTIONS(2512),
    [sym__command_start] = ACTIONS(2512),
  },
  [1164] = {
    [ts_builtin_sym_end] = ACTIONS(2492),
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_primitive] = ACTIONS(2490),
    [aux_sym_primitive_definition_token1] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_macro] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_COMMA] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2490),
    [anon_sym_EQ] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2490),
    [anon_sym_LT_COLON] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [sym_break_statement] = ACTIONS(2490),
    [sym_continue_statement] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_quote] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_DOT] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_COLON2] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_begin] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_LT_PIPE] = ACTIONS(2490),
    [anon_sym_PIPE_GT] = ACTIONS(2490),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_isa] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2490),
    [anon_sym_AMP_AMP] = ACTIONS(2490),
    [anon_sym_QMARK] = ACTIONS(2490),
    [anon_sym_EQ_GT] = ACTIONS(2490),
    [anon_sym_LBRACK2] = ACTIONS(2490),
    [anon_sym_DOLLAR] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2490),
    [aux_sym_integer_literal_token1] = ACTIONS(2490),
    [aux_sym_integer_literal_token2] = ACTIONS(2490),
    [aux_sym_integer_literal_token3] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
    [sym__unary_operator] = ACTIONS(2490),
    [sym__power_operator] = ACTIONS(2490),
    [sym__bitshift_operator] = ACTIONS(2490),
    [sym__rational_operator] = ACTIONS(2490),
    [sym__times_operator] = ACTIONS(2490),
    [sym__plus_operator] = ACTIONS(2490),
    [sym__dotty_operator] = ACTIONS(2490),
    [sym__comparison_operator] = ACTIONS(2490),
    [sym__arrow_operator] = ACTIONS(2490),
    [sym__assign_operator] = ACTIONS(2490),
    [anon_sym_LF] = ACTIONS(2492),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2492),
    [sym__string_start] = ACTIONS(2492),
    [sym__command_start] = ACTIONS(2492),
  },
  [1165] = {
    [ts_builtin_sym_end] = ACTIONS(2536),
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_primitive] = ACTIONS(2534),
    [aux_sym_primitive_definition_token1] = ACTIONS(2534),
    [anon_sym_mutable] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_macro] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2534),
    [anon_sym_COMMA] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2534),
    [anon_sym_COLON_COLON] = ACTIONS(2534),
    [anon_sym_LT_COLON] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [sym_break_statement] = ACTIONS(2534),
    [sym_continue_statement] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_quote] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_COLON2] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_begin] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_LT_PIPE] = ACTIONS(2534),
    [anon_sym_PIPE_GT] = ACTIONS(2534),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_isa] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_QMARK] = ACTIONS(2534),
    [anon_sym_EQ_GT] = ACTIONS(2534),
    [anon_sym_LBRACK2] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2534),
    [aux_sym_integer_literal_token1] = ACTIONS(2534),
    [aux_sym_integer_literal_token2] = ACTIONS(2534),
    [aux_sym_integer_literal_token3] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
    [sym__unary_operator] = ACTIONS(2534),
    [sym__power_operator] = ACTIONS(2534),
    [sym__bitshift_operator] = ACTIONS(2534),
    [sym__rational_operator] = ACTIONS(2534),
    [sym__times_operator] = ACTIONS(2534),
    [sym__plus_operator] = ACTIONS(2534),
    [sym__dotty_operator] = ACTIONS(2534),
    [sym__comparison_operator] = ACTIONS(2534),
    [sym__arrow_operator] = ACTIONS(2534),
    [sym__assign_operator] = ACTIONS(2534),
    [anon_sym_LF] = ACTIONS(2536),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2536),
    [sym__string_start] = ACTIONS(2536),
    [sym__command_start] = ACTIONS(2536),
  },
  [1166] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_end] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_primitive] = ACTIONS(2506),
    [aux_sym_primitive_definition_token1] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_macro] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_LT_COLON] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [sym_break_statement] = ACTIONS(2506),
    [sym_continue_statement] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_quote] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_DOT] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_COLON2] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_RBRACK] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT_PIPE] = ACTIONS(2508),
    [anon_sym_PIPE_GT] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_isa] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2508),
    [anon_sym_AMP_AMP] = ACTIONS(2508),
    [anon_sym_QMARK] = ACTIONS(2508),
    [anon_sym_EQ_GT] = ACTIONS(2508),
    [anon_sym_LBRACK2] = ACTIONS(2506),
    [anon_sym_DOLLAR] = ACTIONS(2508),
    [anon_sym_AT] = ACTIONS(2508),
    [aux_sym_integer_literal_token1] = ACTIONS(2508),
    [aux_sym_integer_literal_token2] = ACTIONS(2508),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
    [sym__unary_operator] = ACTIONS(2506),
    [sym__power_operator] = ACTIONS(2508),
    [sym__bitshift_operator] = ACTIONS(2508),
    [sym__rational_operator] = ACTIONS(2508),
    [sym__times_operator] = ACTIONS(2506),
    [sym__plus_operator] = ACTIONS(2506),
    [sym__dotty_operator] = ACTIONS(2506),
    [sym__comparison_operator] = ACTIONS(2506),
    [sym__arrow_operator] = ACTIONS(2508),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2508),
    [sym__string_start] = ACTIONS(2508),
    [sym__command_start] = ACTIONS(2508),
  },
  [1167] = {
    [ts_builtin_sym_end] = ACTIONS(2500),
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_primitive] = ACTIONS(2498),
    [aux_sym_primitive_definition_token1] = ACTIONS(2498),
    [anon_sym_mutable] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_macro] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2498),
    [anon_sym_COMMA] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2498),
    [anon_sym_COLON_COLON] = ACTIONS(2498),
    [anon_sym_LT_COLON] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [sym_break_statement] = ACTIONS(2498),
    [sym_continue_statement] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_quote] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_COLON2] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_begin] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_LT_PIPE] = ACTIONS(2498),
    [anon_sym_PIPE_GT] = ACTIONS(2498),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_isa] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2498),
    [anon_sym_AMP_AMP] = ACTIONS(2498),
    [anon_sym_QMARK] = ACTIONS(2498),
    [anon_sym_EQ_GT] = ACTIONS(2498),
    [anon_sym_LBRACK2] = ACTIONS(2498),
    [anon_sym_DOLLAR] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2498),
    [aux_sym_integer_literal_token1] = ACTIONS(2498),
    [aux_sym_integer_literal_token2] = ACTIONS(2498),
    [aux_sym_integer_literal_token3] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
    [sym__unary_operator] = ACTIONS(2498),
    [sym__power_operator] = ACTIONS(2498),
    [sym__bitshift_operator] = ACTIONS(2498),
    [sym__rational_operator] = ACTIONS(2498),
    [sym__times_operator] = ACTIONS(2498),
    [sym__plus_operator] = ACTIONS(2498),
    [sym__dotty_operator] = ACTIONS(2498),
    [sym__comparison_operator] = ACTIONS(2498),
    [sym__arrow_operator] = ACTIONS(2498),
    [sym__assign_operator] = ACTIONS(2498),
    [anon_sym_LF] = ACTIONS(2500),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2500),
    [sym__string_start] = ACTIONS(2500),
    [sym__command_start] = ACTIONS(2500),
  },
  [1168] = {
    [ts_builtin_sym_end] = ACTIONS(2552),
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_primitive] = ACTIONS(2550),
    [aux_sym_primitive_definition_token1] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_macro] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2550),
    [anon_sym_COMMA] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2550),
    [anon_sym_EQ] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2550),
    [anon_sym_COLON_COLON] = ACTIONS(2550),
    [anon_sym_LT_COLON] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_break_statement] = ACTIONS(2550),
    [sym_continue_statement] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_quote] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_DOT] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_COLON2] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_begin] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_LT_PIPE] = ACTIONS(2550),
    [anon_sym_PIPE_GT] = ACTIONS(2550),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_isa] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2550),
    [anon_sym_AMP_AMP] = ACTIONS(2550),
    [anon_sym_QMARK] = ACTIONS(2550),
    [anon_sym_EQ_GT] = ACTIONS(2550),
    [anon_sym_LBRACK2] = ACTIONS(2550),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_AT] = ACTIONS(2550),
    [aux_sym_integer_literal_token1] = ACTIONS(2550),
    [aux_sym_integer_literal_token2] = ACTIONS(2550),
    [aux_sym_integer_literal_token3] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
    [sym__unary_operator] = ACTIONS(2550),
    [sym__power_operator] = ACTIONS(2550),
    [sym__bitshift_operator] = ACTIONS(2550),
    [sym__rational_operator] = ACTIONS(2550),
    [sym__times_operator] = ACTIONS(2550),
    [sym__plus_operator] = ACTIONS(2550),
    [sym__dotty_operator] = ACTIONS(2550),
    [sym__comparison_operator] = ACTIONS(2550),
    [sym__arrow_operator] = ACTIONS(2550),
    [sym__assign_operator] = ACTIONS(2550),
    [anon_sym_LF] = ACTIONS(2552),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2552),
    [sym__string_start] = ACTIONS(2552),
    [sym__command_start] = ACTIONS(2552),
  },
  [1169] = {
    [ts_builtin_sym_end] = ACTIONS(2544),
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_primitive] = ACTIONS(2542),
    [aux_sym_primitive_definition_token1] = ACTIONS(2542),
    [anon_sym_mutable] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_macro] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2542),
    [anon_sym_COMMA] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2542),
    [anon_sym_EQ] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2542),
    [anon_sym_COLON_COLON] = ACTIONS(2542),
    [anon_sym_LT_COLON] = ACTIONS(2542),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [sym_break_statement] = ACTIONS(2542),
    [sym_continue_statement] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_quote] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_DOT] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_COLON2] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_LT_PIPE] = ACTIONS(2542),
    [anon_sym_PIPE_GT] = ACTIONS(2542),
    [anon_sym_in] = ACTIONS(2542),
    [anon_sym_isa] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2542),
    [anon_sym_AMP_AMP] = ACTIONS(2542),
    [anon_sym_QMARK] = ACTIONS(2542),
    [anon_sym_EQ_GT] = ACTIONS(2542),
    [anon_sym_LBRACK2] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2542),
    [aux_sym_integer_literal_token1] = ACTIONS(2542),
    [aux_sym_integer_literal_token2] = ACTIONS(2542),
    [aux_sym_integer_literal_token3] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
    [sym__unary_operator] = ACTIONS(2542),
    [sym__power_operator] = ACTIONS(2542),
    [sym__bitshift_operator] = ACTIONS(2542),
    [sym__rational_operator] = ACTIONS(2542),
    [sym__times_operator] = ACTIONS(2542),
    [sym__plus_operator] = ACTIONS(2542),
    [sym__dotty_operator] = ACTIONS(2542),
    [sym__comparison_operator] = ACTIONS(2542),
    [sym__arrow_operator] = ACTIONS(2542),
    [sym__assign_operator] = ACTIONS(2542),
    [anon_sym_LF] = ACTIONS(2544),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2544),
    [sym__string_start] = ACTIONS(2544),
    [sym__command_start] = ACTIONS(2544),
  },
  [1170] = {
    [ts_builtin_sym_end] = ACTIONS(2556),
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_primitive] = ACTIONS(2554),
    [aux_sym_primitive_definition_token1] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_macro] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2554),
    [anon_sym_COMMA] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2554),
    [anon_sym_EQ] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2554),
    [anon_sym_COLON_COLON] = ACTIONS(2554),
    [anon_sym_LT_COLON] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [sym_break_statement] = ACTIONS(2554),
    [sym_continue_statement] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_quote] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_DOT] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_COLON2] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_begin] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_LT_PIPE] = ACTIONS(2554),
    [anon_sym_PIPE_GT] = ACTIONS(2554),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_isa] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2554),
    [anon_sym_AMP_AMP] = ACTIONS(2554),
    [anon_sym_QMARK] = ACTIONS(2554),
    [anon_sym_EQ_GT] = ACTIONS(2554),
    [anon_sym_LBRACK2] = ACTIONS(2554),
    [anon_sym_DOLLAR] = ACTIONS(2554),
    [anon_sym_AT] = ACTIONS(2554),
    [aux_sym_integer_literal_token1] = ACTIONS(2554),
    [aux_sym_integer_literal_token2] = ACTIONS(2554),
    [aux_sym_integer_literal_token3] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
    [sym__unary_operator] = ACTIONS(2554),
    [sym__power_operator] = ACTIONS(2554),
    [sym__bitshift_operator] = ACTIONS(2554),
    [sym__rational_operator] = ACTIONS(2554),
    [sym__times_operator] = ACTIONS(2554),
    [sym__plus_operator] = ACTIONS(2554),
    [sym__dotty_operator] = ACTIONS(2554),
    [sym__comparison_operator] = ACTIONS(2554),
    [sym__arrow_operator] = ACTIONS(2554),
    [sym__assign_operator] = ACTIONS(2554),
    [anon_sym_LF] = ACTIONS(2556),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2556),
    [sym__string_start] = ACTIONS(2556),
    [sym__command_start] = ACTIONS(2556),
  },
  [1171] = {
    [ts_builtin_sym_end] = ACTIONS(2548),
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_primitive] = ACTIONS(2546),
    [aux_sym_primitive_definition_token1] = ACTIONS(2546),
    [anon_sym_mutable] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_macro] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2546),
    [anon_sym_COMMA] = ACTIONS(2546),
    [anon_sym_SEMI] = ACTIONS(2546),
    [anon_sym_EQ] = ACTIONS(2546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2546),
    [anon_sym_COLON_COLON] = ACTIONS(2546),
    [anon_sym_LT_COLON] = ACTIONS(2546),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [sym_break_statement] = ACTIONS(2546),
    [sym_continue_statement] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_quote] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_DOT] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_COLON2] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_begin] = ACTIONS(2546),
    [anon_sym_do] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2546),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_LT_PIPE] = ACTIONS(2546),
    [anon_sym_PIPE_GT] = ACTIONS(2546),
    [anon_sym_in] = ACTIONS(2546),
    [anon_sym_isa] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(2546),
    [anon_sym_QMARK] = ACTIONS(2546),
    [anon_sym_EQ_GT] = ACTIONS(2546),
    [anon_sym_LBRACK2] = ACTIONS(2546),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2546),
    [aux_sym_integer_literal_token1] = ACTIONS(2546),
    [aux_sym_integer_literal_token2] = ACTIONS(2546),
    [aux_sym_integer_literal_token3] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
    [sym__unary_operator] = ACTIONS(2546),
    [sym__power_operator] = ACTIONS(2546),
    [sym__bitshift_operator] = ACTIONS(2546),
    [sym__rational_operator] = ACTIONS(2546),
    [sym__times_operator] = ACTIONS(2546),
    [sym__plus_operator] = ACTIONS(2546),
    [sym__dotty_operator] = ACTIONS(2546),
    [sym__comparison_operator] = ACTIONS(2546),
    [sym__arrow_operator] = ACTIONS(2546),
    [sym__assign_operator] = ACTIONS(2546),
    [anon_sym_LF] = ACTIONS(2548),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2548),
    [sym__string_start] = ACTIONS(2548),
    [sym__command_start] = ACTIONS(2548),
  },
  [1172] = {
    [ts_builtin_sym_end] = ACTIONS(2496),
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_primitive] = ACTIONS(2494),
    [aux_sym_primitive_definition_token1] = ACTIONS(2494),
    [anon_sym_mutable] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_macro] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2494),
    [anon_sym_COMMA] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2494),
    [anon_sym_COLON_COLON] = ACTIONS(2494),
    [anon_sym_LT_COLON] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [sym_break_statement] = ACTIONS(2494),
    [sym_continue_statement] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_quote] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_DOT] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_COLON2] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_begin] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_LT_PIPE] = ACTIONS(2494),
    [anon_sym_PIPE_GT] = ACTIONS(2494),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_isa] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2494),
    [anon_sym_AMP_AMP] = ACTIONS(2494),
    [anon_sym_QMARK] = ACTIONS(2494),
    [anon_sym_EQ_GT] = ACTIONS(2494),
    [anon_sym_LBRACK2] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2494),
    [aux_sym_integer_literal_token1] = ACTIONS(2494),
    [aux_sym_integer_literal_token2] = ACTIONS(2494),
    [aux_sym_integer_literal_token3] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
    [sym__unary_operator] = ACTIONS(2494),
    [sym__power_operator] = ACTIONS(2494),
    [sym__bitshift_operator] = ACTIONS(2494),
    [sym__rational_operator] = ACTIONS(2494),
    [sym__times_operator] = ACTIONS(2494),
    [sym__plus_operator] = ACTIONS(2494),
    [sym__dotty_operator] = ACTIONS(2494),
    [sym__comparison_operator] = ACTIONS(2494),
    [sym__arrow_operator] = ACTIONS(2494),
    [sym__assign_operator] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2496),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2496),
    [sym__string_start] = ACTIONS(2496),
    [sym__command_start] = ACTIONS(2496),
  },
  [1173] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_primitive] = ACTIONS(2582),
    [aux_sym_primitive_definition_token1] = ACTIONS(2582),
    [anon_sym_mutable] = ACTIONS(2582),
    [anon_sym_struct] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_macro] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2582),
    [anon_sym_COLON_COLON] = ACTIONS(2582),
    [anon_sym_LT_COLON] = ACTIONS(2582),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_elseif] = ACTIONS(2582),
    [anon_sym_else] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [sym_break_statement] = ACTIONS(2582),
    [sym_continue_statement] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_quote] = ACTIONS(2582),
    [anon_sym_using] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_DOT] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_COLON2] = ACTIONS(2582),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_do] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2582),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_LT_PIPE] = ACTIONS(2582),
    [anon_sym_PIPE_GT] = ACTIONS(2582),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_isa] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2582),
    [anon_sym_AMP_AMP] = ACTIONS(2582),
    [anon_sym_QMARK] = ACTIONS(2582),
    [anon_sym_EQ_GT] = ACTIONS(2582),
    [anon_sym_LBRACK2] = ACTIONS(2582),
    [anon_sym_DOLLAR] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2582),
    [aux_sym_integer_literal_token1] = ACTIONS(2582),
    [aux_sym_integer_literal_token2] = ACTIONS(2582),
    [aux_sym_integer_literal_token3] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
    [sym__unary_operator] = ACTIONS(2582),
    [sym__power_operator] = ACTIONS(2582),
    [sym__bitshift_operator] = ACTIONS(2582),
    [sym__rational_operator] = ACTIONS(2582),
    [sym__times_operator] = ACTIONS(2582),
    [sym__plus_operator] = ACTIONS(2582),
    [sym__dotty_operator] = ACTIONS(2582),
    [sym__comparison_operator] = ACTIONS(2582),
    [sym__arrow_operator] = ACTIONS(2582),
    [anon_sym_LF] = ACTIONS(2584),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2584),
    [sym__string_start] = ACTIONS(2584),
    [sym__command_start] = ACTIONS(2584),
  },
  [1174] = {
    [ts_builtin_sym_end] = ACTIONS(2540),
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_primitive] = ACTIONS(2538),
    [aux_sym_primitive_definition_token1] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_macro] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2538),
    [anon_sym_COMMA] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2538),
    [anon_sym_EQ] = ACTIONS(2538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2538),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LT_COLON] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [sym_break_statement] = ACTIONS(2538),
    [sym_continue_statement] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_quote] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_DOT] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_COLON2] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_begin] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_LT_PIPE] = ACTIONS(2538),
    [anon_sym_PIPE_GT] = ACTIONS(2538),
    [anon_sym_in] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2538),
    [anon_sym_AMP_AMP] = ACTIONS(2538),
    [anon_sym_QMARK] = ACTIONS(2538),
    [anon_sym_EQ_GT] = ACTIONS(2538),
    [anon_sym_LBRACK2] = ACTIONS(2538),
    [anon_sym_DOLLAR] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2538),
    [aux_sym_integer_literal_token1] = ACTIONS(2538),
    [aux_sym_integer_literal_token2] = ACTIONS(2538),
    [aux_sym_integer_literal_token3] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
    [sym__unary_operator] = ACTIONS(2538),
    [sym__power_operator] = ACTIONS(2538),
    [sym__bitshift_operator] = ACTIONS(2538),
    [sym__rational_operator] = ACTIONS(2538),
    [sym__times_operator] = ACTIONS(2538),
    [sym__plus_operator] = ACTIONS(2538),
    [sym__dotty_operator] = ACTIONS(2538),
    [sym__comparison_operator] = ACTIONS(2538),
    [sym__arrow_operator] = ACTIONS(2538),
    [sym__assign_operator] = ACTIONS(2538),
    [anon_sym_LF] = ACTIONS(2540),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2540),
    [sym__string_start] = ACTIONS(2540),
    [sym__command_start] = ACTIONS(2540),
  },
  [1175] = {
    [ts_builtin_sym_end] = ACTIONS(2532),
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_primitive] = ACTIONS(2530),
    [aux_sym_primitive_definition_token1] = ACTIONS(2530),
    [anon_sym_mutable] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_macro] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2530),
    [anon_sym_COMMA] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_EQ] = ACTIONS(2530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2530),
    [anon_sym_COLON_COLON] = ACTIONS(2530),
    [anon_sym_LT_COLON] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [sym_break_statement] = ACTIONS(2530),
    [sym_continue_statement] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_quote] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_DOT] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_COLON2] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_begin] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_LT_PIPE] = ACTIONS(2530),
    [anon_sym_PIPE_GT] = ACTIONS(2530),
    [anon_sym_in] = ACTIONS(2530),
    [anon_sym_isa] = ACTIONS(2530),
    [anon_sym_PIPE_PIPE] = ACTIONS(2530),
    [anon_sym_AMP_AMP] = ACTIONS(2530),
    [anon_sym_QMARK] = ACTIONS(2530),
    [anon_sym_EQ_GT] = ACTIONS(2530),
    [anon_sym_LBRACK2] = ACTIONS(2530),
    [anon_sym_DOLLAR] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2530),
    [aux_sym_integer_literal_token1] = ACTIONS(2530),
    [aux_sym_integer_literal_token2] = ACTIONS(2530),
    [aux_sym_integer_literal_token3] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
    [sym__unary_operator] = ACTIONS(2530),
    [sym__power_operator] = ACTIONS(2530),
    [sym__bitshift_operator] = ACTIONS(2530),
    [sym__rational_operator] = ACTIONS(2530),
    [sym__times_operator] = ACTIONS(2530),
    [sym__plus_operator] = ACTIONS(2530),
    [sym__dotty_operator] = ACTIONS(2530),
    [sym__comparison_operator] = ACTIONS(2530),
    [sym__arrow_operator] = ACTIONS(2530),
    [sym__assign_operator] = ACTIONS(2530),
    [anon_sym_LF] = ACTIONS(2532),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2532),
    [sym__string_start] = ACTIONS(2532),
    [sym__command_start] = ACTIONS(2532),
  },
  [1176] = {
    [ts_builtin_sym_end] = ACTIONS(2564),
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_primitive] = ACTIONS(2562),
    [aux_sym_primitive_definition_token1] = ACTIONS(2562),
    [anon_sym_mutable] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_macro] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2562),
    [anon_sym_COLON_COLON] = ACTIONS(2562),
    [anon_sym_LT_COLON] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [sym_break_statement] = ACTIONS(2562),
    [sym_continue_statement] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_quote] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_DOT] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_COLON2] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_LT_PIPE] = ACTIONS(2562),
    [anon_sym_PIPE_GT] = ACTIONS(2562),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_isa] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2562),
    [anon_sym_AMP_AMP] = ACTIONS(2562),
    [anon_sym_QMARK] = ACTIONS(2562),
    [anon_sym_EQ_GT] = ACTIONS(2562),
    [anon_sym_LBRACK2] = ACTIONS(2562),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2562),
    [aux_sym_integer_literal_token1] = ACTIONS(2562),
    [aux_sym_integer_literal_token2] = ACTIONS(2562),
    [aux_sym_integer_literal_token3] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
    [sym__unary_operator] = ACTIONS(2562),
    [sym__power_operator] = ACTIONS(2562),
    [sym__bitshift_operator] = ACTIONS(2562),
    [sym__rational_operator] = ACTIONS(2562),
    [sym__times_operator] = ACTIONS(2562),
    [sym__plus_operator] = ACTIONS(2562),
    [sym__dotty_operator] = ACTIONS(2562),
    [sym__comparison_operator] = ACTIONS(2562),
    [sym__arrow_operator] = ACTIONS(2562),
    [sym__assign_operator] = ACTIONS(2562),
    [anon_sym_LF] = ACTIONS(2564),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2564),
    [sym__string_start] = ACTIONS(2564),
    [sym__command_start] = ACTIONS(2564),
  },
  [1177] = {
    [ts_builtin_sym_end] = ACTIONS(2528),
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_primitive] = ACTIONS(2526),
    [aux_sym_primitive_definition_token1] = ACTIONS(2526),
    [anon_sym_mutable] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_macro] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(2526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LT_COLON] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [sym_break_statement] = ACTIONS(2526),
    [sym_continue_statement] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_quote] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_COLON2] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_begin] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_LT_PIPE] = ACTIONS(2526),
    [anon_sym_PIPE_GT] = ACTIONS(2526),
    [anon_sym_in] = ACTIONS(2526),
    [anon_sym_isa] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_EQ_GT] = ACTIONS(2526),
    [anon_sym_LBRACK2] = ACTIONS(2526),
    [anon_sym_DOLLAR] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2526),
    [aux_sym_integer_literal_token1] = ACTIONS(2526),
    [aux_sym_integer_literal_token2] = ACTIONS(2526),
    [aux_sym_integer_literal_token3] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
    [sym__unary_operator] = ACTIONS(2526),
    [sym__power_operator] = ACTIONS(2526),
    [sym__bitshift_operator] = ACTIONS(2526),
    [sym__rational_operator] = ACTIONS(2526),
    [sym__times_operator] = ACTIONS(2526),
    [sym__plus_operator] = ACTIONS(2526),
    [sym__dotty_operator] = ACTIONS(2526),
    [sym__comparison_operator] = ACTIONS(2526),
    [sym__arrow_operator] = ACTIONS(2526),
    [sym__assign_operator] = ACTIONS(2526),
    [anon_sym_LF] = ACTIONS(2528),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2528),
    [sym__string_start] = ACTIONS(2528),
    [sym__command_start] = ACTIONS(2528),
  },
  [1178] = {
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_end] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_primitive] = ACTIONS(2783),
    [aux_sym_primitive_definition_token1] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_module] = ACTIONS(2783),
    [anon_sym_macro] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_EQ] = ACTIONS(2783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2785),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_LT_COLON] = ACTIONS(2785),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [sym_break_statement] = ACTIONS(2783),
    [sym_continue_statement] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_quote] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_import] = ACTIONS(2783),
    [anon_sym_export] = ACTIONS(2783),
    [anon_sym_COLON2] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_LT_PIPE] = ACTIONS(2785),
    [anon_sym_PIPE_GT] = ACTIONS(2785),
    [anon_sym_in] = ACTIONS(2783),
    [anon_sym_isa] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_QMARK] = ACTIONS(2785),
    [anon_sym_EQ_GT] = ACTIONS(2785),
    [anon_sym_LBRACK2] = ACTIONS(2783),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_AT] = ACTIONS(2785),
    [aux_sym_integer_literal_token1] = ACTIONS(2785),
    [aux_sym_integer_literal_token2] = ACTIONS(2785),
    [aux_sym_integer_literal_token3] = ACTIONS(2783),
    [sym_float_literal] = ACTIONS(2783),
    [sym__unary_operator] = ACTIONS(2783),
    [sym__power_operator] = ACTIONS(2783),
    [sym__bitshift_operator] = ACTIONS(2783),
    [sym__rational_operator] = ACTIONS(2783),
    [sym__times_operator] = ACTIONS(2783),
    [sym__plus_operator] = ACTIONS(2783),
    [sym__dotty_operator] = ACTIONS(2783),
    [sym__comparison_operator] = ACTIONS(2783),
    [sym__arrow_operator] = ACTIONS(2785),
    [sym__assign_operator] = ACTIONS(2783),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2785),
    [sym__command_start] = ACTIONS(2785),
  },
  [1179] = {
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_end] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_primitive] = ACTIONS(2716),
    [aux_sym_primitive_definition_token1] = ACTIONS(2716),
    [anon_sym_mutable] = ACTIONS(2716),
    [anon_sym_struct] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_macro] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2716),
    [anon_sym_COLON_COLON] = ACTIONS(2716),
    [anon_sym_LT_COLON] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_elseif] = ACTIONS(2716),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [sym_break_statement] = ACTIONS(2716),
    [sym_continue_statement] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_quote] = ACTIONS(2716),
    [anon_sym_using] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_DOT] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_COLON2] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_begin] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_LT_PIPE] = ACTIONS(2716),
    [anon_sym_PIPE_GT] = ACTIONS(2716),
    [anon_sym_in] = ACTIONS(2716),
    [anon_sym_isa] = ACTIONS(2716),
    [anon_sym_PIPE_PIPE] = ACTIONS(2716),
    [anon_sym_AMP_AMP] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2716),
    [anon_sym_EQ_GT] = ACTIONS(2716),
    [anon_sym_LBRACK2] = ACTIONS(2716),
    [anon_sym_DOLLAR] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2716),
    [aux_sym_integer_literal_token1] = ACTIONS(2716),
    [aux_sym_integer_literal_token2] = ACTIONS(2716),
    [aux_sym_integer_literal_token3] = ACTIONS(2716),
    [sym_float_literal] = ACTIONS(2716),
    [sym__unary_operator] = ACTIONS(2716),
    [sym__power_operator] = ACTIONS(2716),
    [sym__bitshift_operator] = ACTIONS(2716),
    [sym__rational_operator] = ACTIONS(2716),
    [sym__times_operator] = ACTIONS(2716),
    [sym__plus_operator] = ACTIONS(2716),
    [sym__dotty_operator] = ACTIONS(2716),
    [sym__comparison_operator] = ACTIONS(2716),
    [sym__arrow_operator] = ACTIONS(2716),
    [anon_sym_LF] = ACTIONS(2718),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2718),
    [sym__string_start] = ACTIONS(2718),
    [sym__command_start] = ACTIONS(2718),
  },
  [1180] = {
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_end] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_primitive] = ACTIONS(2636),
    [aux_sym_primitive_definition_token1] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_macro] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_RPAREN] = ACTIONS(2638),
    [anon_sym_SEMI] = ACTIONS(2638),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2638),
    [anon_sym_COLON_COLON] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_LT_COLON] = ACTIONS(2638),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [sym_break_statement] = ACTIONS(2636),
    [sym_continue_statement] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_quote] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_COLON2] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_RBRACK] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_LT_PIPE] = ACTIONS(2638),
    [anon_sym_PIPE_GT] = ACTIONS(2638),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_isa] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2638),
    [anon_sym_AMP_AMP] = ACTIONS(2638),
    [anon_sym_QMARK] = ACTIONS(2638),
    [anon_sym_EQ_GT] = ACTIONS(2638),
    [anon_sym_LBRACK2] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2638),
    [anon_sym_AT] = ACTIONS(2638),
    [aux_sym_integer_literal_token1] = ACTIONS(2638),
    [aux_sym_integer_literal_token2] = ACTIONS(2638),
    [aux_sym_integer_literal_token3] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__unary_operator] = ACTIONS(2636),
    [sym__power_operator] = ACTIONS(2638),
    [sym__bitshift_operator] = ACTIONS(2638),
    [sym__rational_operator] = ACTIONS(2638),
    [sym__times_operator] = ACTIONS(2636),
    [sym__plus_operator] = ACTIONS(2636),
    [sym__dotty_operator] = ACTIONS(2636),
    [sym__comparison_operator] = ACTIONS(2636),
    [sym__arrow_operator] = ACTIONS(2638),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__command_start] = ACTIONS(2638),
  },
  [1181] = {
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_primitive] = ACTIONS(2632),
    [aux_sym_primitive_definition_token1] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_macro] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2634),
    [anon_sym_COMMA] = ACTIONS(2634),
    [anon_sym_RPAREN] = ACTIONS(2634),
    [anon_sym_SEMI] = ACTIONS(2634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2634),
    [anon_sym_COLON_COLON] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2634),
    [anon_sym_LT_COLON] = ACTIONS(2634),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [sym_break_statement] = ACTIONS(2632),
    [sym_continue_statement] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_quote] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_COLON2] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_RBRACK] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_LT_PIPE] = ACTIONS(2634),
    [anon_sym_PIPE_GT] = ACTIONS(2634),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_isa] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2634),
    [anon_sym_AMP_AMP] = ACTIONS(2634),
    [anon_sym_QMARK] = ACTIONS(2634),
    [anon_sym_EQ_GT] = ACTIONS(2634),
    [anon_sym_LBRACK2] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2634),
    [anon_sym_AT] = ACTIONS(2634),
    [aux_sym_integer_literal_token1] = ACTIONS(2634),
    [aux_sym_integer_literal_token2] = ACTIONS(2634),
    [aux_sym_integer_literal_token3] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__unary_operator] = ACTIONS(2632),
    [sym__power_operator] = ACTIONS(2634),
    [sym__bitshift_operator] = ACTIONS(2634),
    [sym__rational_operator] = ACTIONS(2634),
    [sym__times_operator] = ACTIONS(2632),
    [sym__plus_operator] = ACTIONS(2632),
    [sym__dotty_operator] = ACTIONS(2632),
    [sym__comparison_operator] = ACTIONS(2632),
    [sym__arrow_operator] = ACTIONS(2634),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__command_start] = ACTIONS(2634),
  },
  [1182] = {
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_function] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_primitive] = ACTIONS(2628),
    [aux_sym_primitive_definition_token1] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_macro] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [anon_sym_COMMA] = ACTIONS(2630),
    [anon_sym_RPAREN] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2630),
    [anon_sym_COLON_COLON] = ACTIONS(2630),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_LT_COLON] = ACTIONS(2630),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [sym_break_statement] = ACTIONS(2628),
    [sym_continue_statement] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_quote] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_COLON2] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_RBRACK] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_LT_PIPE] = ACTIONS(2630),
    [anon_sym_PIPE_GT] = ACTIONS(2630),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_isa] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2630),
    [anon_sym_AMP_AMP] = ACTIONS(2630),
    [anon_sym_QMARK] = ACTIONS(2630),
    [anon_sym_EQ_GT] = ACTIONS(2630),
    [anon_sym_LBRACK2] = ACTIONS(2628),
    [anon_sym_DOLLAR] = ACTIONS(2630),
    [anon_sym_AT] = ACTIONS(2630),
    [aux_sym_integer_literal_token1] = ACTIONS(2630),
    [aux_sym_integer_literal_token2] = ACTIONS(2630),
    [aux_sym_integer_literal_token3] = ACTIONS(2628),
    [sym_float_literal] = ACTIONS(2628),
    [sym__unary_operator] = ACTIONS(2628),
    [sym__power_operator] = ACTIONS(2630),
    [sym__bitshift_operator] = ACTIONS(2630),
    [sym__rational_operator] = ACTIONS(2630),
    [sym__times_operator] = ACTIONS(2628),
    [sym__plus_operator] = ACTIONS(2628),
    [sym__dotty_operator] = ACTIONS(2628),
    [sym__comparison_operator] = ACTIONS(2628),
    [sym__arrow_operator] = ACTIONS(2630),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__command_start] = ACTIONS(2630),
  },
  [1183] = {
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_end] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_primitive] = ACTIONS(2720),
    [aux_sym_primitive_definition_token1] = ACTIONS(2720),
    [anon_sym_mutable] = ACTIONS(2720),
    [anon_sym_struct] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_macro] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2722),
    [anon_sym_COMMA] = ACTIONS(2722),
    [anon_sym_RPAREN] = ACTIONS(2722),
    [anon_sym_SEMI] = ACTIONS(2722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2722),
    [anon_sym_COLON_COLON] = ACTIONS(2722),
    [anon_sym_RBRACE] = ACTIONS(2722),
    [anon_sym_LT_COLON] = ACTIONS(2722),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [sym_break_statement] = ACTIONS(2720),
    [sym_continue_statement] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_quote] = ACTIONS(2720),
    [anon_sym_using] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_DOT] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_COLON2] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_RBRACK] = ACTIONS(2722),
    [anon_sym_begin] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2722),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_LT_PIPE] = ACTIONS(2722),
    [anon_sym_PIPE_GT] = ACTIONS(2722),
    [anon_sym_in] = ACTIONS(2720),
    [anon_sym_isa] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(2722),
    [anon_sym_AMP_AMP] = ACTIONS(2722),
    [anon_sym_QMARK] = ACTIONS(2722),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_LBRACK2] = ACTIONS(2720),
    [anon_sym_DOLLAR] = ACTIONS(2722),
    [anon_sym_AT] = ACTIONS(2722),
    [aux_sym_integer_literal_token1] = ACTIONS(2722),
    [aux_sym_integer_literal_token2] = ACTIONS(2722),
    [aux_sym_integer_literal_token3] = ACTIONS(2720),
    [sym_float_literal] = ACTIONS(2720),
    [sym__unary_operator] = ACTIONS(2720),
    [sym__power_operator] = ACTIONS(2722),
    [sym__bitshift_operator] = ACTIONS(2722),
    [sym__rational_operator] = ACTIONS(2722),
    [sym__times_operator] = ACTIONS(2720),
    [sym__plus_operator] = ACTIONS(2720),
    [sym__dotty_operator] = ACTIONS(2720),
    [sym__comparison_operator] = ACTIONS(2720),
    [sym__arrow_operator] = ACTIONS(2722),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2722),
    [sym__string_start] = ACTIONS(2722),
    [sym__command_start] = ACTIONS(2722),
  },
  [1184] = {
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_primitive] = ACTIONS(2624),
    [aux_sym_primitive_definition_token1] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_macro] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2626),
    [anon_sym_COMMA] = ACTIONS(2626),
    [anon_sym_RPAREN] = ACTIONS(2626),
    [anon_sym_SEMI] = ACTIONS(2626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2626),
    [anon_sym_COLON_COLON] = ACTIONS(2626),
    [anon_sym_RBRACE] = ACTIONS(2626),
    [anon_sym_LT_COLON] = ACTIONS(2626),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [sym_break_statement] = ACTIONS(2624),
    [sym_continue_statement] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_quote] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_COLON2] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_RBRACK] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_SQUOTE] = ACTIONS(2626),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_LT_PIPE] = ACTIONS(2626),
    [anon_sym_PIPE_GT] = ACTIONS(2626),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_isa] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(2626),
    [anon_sym_QMARK] = ACTIONS(2626),
    [anon_sym_EQ_GT] = ACTIONS(2626),
    [anon_sym_LBRACK2] = ACTIONS(2624),
    [anon_sym_DOLLAR] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2626),
    [aux_sym_integer_literal_token1] = ACTIONS(2626),
    [aux_sym_integer_literal_token2] = ACTIONS(2626),
    [aux_sym_integer_literal_token3] = ACTIONS(2624),
    [sym_float_literal] = ACTIONS(2624),
    [sym__unary_operator] = ACTIONS(2624),
    [sym__power_operator] = ACTIONS(2626),
    [sym__bitshift_operator] = ACTIONS(2626),
    [sym__rational_operator] = ACTIONS(2626),
    [sym__times_operator] = ACTIONS(2624),
    [sym__plus_operator] = ACTIONS(2624),
    [sym__dotty_operator] = ACTIONS(2624),
    [sym__comparison_operator] = ACTIONS(2624),
    [sym__arrow_operator] = ACTIONS(2626),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__command_start] = ACTIONS(2626),
  },
  [1185] = {
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_function] = ACTIONS(2620),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_abstract] = ACTIONS(2620),
    [anon_sym_primitive] = ACTIONS(2620),
    [aux_sym_primitive_definition_token1] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_macro] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2622),
    [anon_sym_COMMA] = ACTIONS(2622),
    [anon_sym_RPAREN] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2622),
    [anon_sym_COLON_COLON] = ACTIONS(2622),
    [anon_sym_RBRACE] = ACTIONS(2622),
    [anon_sym_LT_COLON] = ACTIONS(2622),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [sym_break_statement] = ACTIONS(2620),
    [sym_continue_statement] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_quote] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_import] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_COLON2] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_RBRACK] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_LT_PIPE] = ACTIONS(2622),
    [anon_sym_PIPE_GT] = ACTIONS(2622),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_isa] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2622),
    [anon_sym_AMP_AMP] = ACTIONS(2622),
    [anon_sym_QMARK] = ACTIONS(2622),
    [anon_sym_EQ_GT] = ACTIONS(2622),
    [anon_sym_LBRACK2] = ACTIONS(2620),
    [anon_sym_DOLLAR] = ACTIONS(2622),
    [anon_sym_AT] = ACTIONS(2622),
    [aux_sym_integer_literal_token1] = ACTIONS(2622),
    [aux_sym_integer_literal_token2] = ACTIONS(2622),
    [aux_sym_integer_literal_token3] = ACTIONS(2620),
    [sym_float_literal] = ACTIONS(2620),
    [sym__unary_operator] = ACTIONS(2620),
    [sym__power_operator] = ACTIONS(2622),
    [sym__bitshift_operator] = ACTIONS(2622),
    [sym__rational_operator] = ACTIONS(2622),
    [sym__times_operator] = ACTIONS(2620),
    [sym__plus_operator] = ACTIONS(2620),
    [sym__dotty_operator] = ACTIONS(2620),
    [sym__comparison_operator] = ACTIONS(2620),
    [sym__arrow_operator] = ACTIONS(2622),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__command_start] = ACTIONS(2622),
  },
  [1186] = {
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_function] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_abstract] = ACTIONS(2616),
    [anon_sym_primitive] = ACTIONS(2616),
    [aux_sym_primitive_definition_token1] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_macro] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2618),
    [anon_sym_COMMA] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2618),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2618),
    [anon_sym_COLON_COLON] = ACTIONS(2618),
    [anon_sym_RBRACE] = ACTIONS(2618),
    [anon_sym_LT_COLON] = ACTIONS(2618),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [sym_break_statement] = ACTIONS(2616),
    [sym_continue_statement] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_let] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_quote] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_import] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2616),
    [anon_sym_COLON2] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_RBRACK] = ACTIONS(2618),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_SQUOTE] = ACTIONS(2618),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_LT_PIPE] = ACTIONS(2618),
    [anon_sym_PIPE_GT] = ACTIONS(2618),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_isa] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2618),
    [anon_sym_AMP_AMP] = ACTIONS(2618),
    [anon_sym_QMARK] = ACTIONS(2618),
    [anon_sym_EQ_GT] = ACTIONS(2618),
    [anon_sym_LBRACK2] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [anon_sym_AT] = ACTIONS(2618),
    [aux_sym_integer_literal_token1] = ACTIONS(2618),
    [aux_sym_integer_literal_token2] = ACTIONS(2618),
    [aux_sym_integer_literal_token3] = ACTIONS(2616),
    [sym_float_literal] = ACTIONS(2616),
    [sym__unary_operator] = ACTIONS(2616),
    [sym__power_operator] = ACTIONS(2618),
    [sym__bitshift_operator] = ACTIONS(2618),
    [sym__rational_operator] = ACTIONS(2618),
    [sym__times_operator] = ACTIONS(2616),
    [sym__plus_operator] = ACTIONS(2616),
    [sym__dotty_operator] = ACTIONS(2616),
    [sym__comparison_operator] = ACTIONS(2616),
    [sym__arrow_operator] = ACTIONS(2618),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__command_start] = ACTIONS(2618),
  },
  [1187] = {
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_function] = ACTIONS(2612),
    [anon_sym_end] = ACTIONS(2612),
    [anon_sym_abstract] = ACTIONS(2612),
    [anon_sym_primitive] = ACTIONS(2612),
    [aux_sym_primitive_definition_token1] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2612),
    [anon_sym_macro] = ACTIONS(2612),
    [anon_sym_LPAREN] = ACTIONS(2614),
    [anon_sym_COMMA] = ACTIONS(2614),
    [anon_sym_RPAREN] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2614),
    [anon_sym_COLON_COLON] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2614),
    [anon_sym_LT_COLON] = ACTIONS(2614),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [sym_break_statement] = ACTIONS(2612),
    [sym_continue_statement] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_quote] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_import] = ACTIONS(2612),
    [anon_sym_DOT] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2612),
    [anon_sym_COLON2] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2614),
    [anon_sym_RBRACK] = ACTIONS(2614),
    [anon_sym_begin] = ACTIONS(2612),
    [anon_sym_SQUOTE] = ACTIONS(2614),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_LT_PIPE] = ACTIONS(2614),
    [anon_sym_PIPE_GT] = ACTIONS(2614),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_isa] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2614),
    [anon_sym_AMP_AMP] = ACTIONS(2614),
    [anon_sym_QMARK] = ACTIONS(2614),
    [anon_sym_EQ_GT] = ACTIONS(2614),
    [anon_sym_LBRACK2] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [anon_sym_AT] = ACTIONS(2614),
    [aux_sym_integer_literal_token1] = ACTIONS(2614),
    [aux_sym_integer_literal_token2] = ACTIONS(2614),
    [aux_sym_integer_literal_token3] = ACTIONS(2612),
    [sym_float_literal] = ACTIONS(2612),
    [sym__unary_operator] = ACTIONS(2612),
    [sym__power_operator] = ACTIONS(2614),
    [sym__bitshift_operator] = ACTIONS(2614),
    [sym__rational_operator] = ACTIONS(2614),
    [sym__times_operator] = ACTIONS(2612),
    [sym__plus_operator] = ACTIONS(2612),
    [sym__dotty_operator] = ACTIONS(2612),
    [sym__comparison_operator] = ACTIONS(2612),
    [sym__arrow_operator] = ACTIONS(2614),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2614),
    [sym__string_start] = ACTIONS(2614),
    [sym__command_start] = ACTIONS(2614),
  },
  [1188] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1188),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_end] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_primitive] = ACTIONS(2772),
    [aux_sym_primitive_definition_token1] = ACTIONS(2772),
    [anon_sym_mutable] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_macro] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(3237),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2777),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_LT_COLON] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [sym_break_statement] = ACTIONS(2772),
    [sym_continue_statement] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_quote] = ACTIONS(2772),
    [anon_sym_using] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_COLON2] = ACTIONS(2772),
    [anon_sym_RBRACK] = ACTIONS(2777),
    [anon_sym_begin] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_LT_PIPE] = ACTIONS(2777),
    [anon_sym_PIPE_GT] = ACTIONS(2777),
    [anon_sym_in] = ACTIONS(2772),
    [anon_sym_isa] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_QMARK] = ACTIONS(2777),
    [anon_sym_EQ_GT] = ACTIONS(2777),
    [anon_sym_LBRACK2] = ACTIONS(2777),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2777),
    [aux_sym_integer_literal_token1] = ACTIONS(2777),
    [aux_sym_integer_literal_token2] = ACTIONS(2777),
    [aux_sym_integer_literal_token3] = ACTIONS(2772),
    [sym_float_literal] = ACTIONS(2772),
    [sym__unary_operator] = ACTIONS(2772),
    [sym__power_operator] = ACTIONS(2772),
    [sym__bitshift_operator] = ACTIONS(2772),
    [sym__rational_operator] = ACTIONS(2772),
    [sym__times_operator] = ACTIONS(2772),
    [sym__plus_operator] = ACTIONS(2772),
    [sym__dotty_operator] = ACTIONS(2772),
    [sym__comparison_operator] = ACTIONS(2772),
    [sym__arrow_operator] = ACTIONS(2777),
    [sym__assign_operator] = ACTIONS(2772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2777),
    [sym__command_start] = ACTIONS(2777),
  },
  [1189] = {
    [ts_builtin_sym_end] = ACTIONS(2614),
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_function] = ACTIONS(2612),
    [anon_sym_abstract] = ACTIONS(2612),
    [anon_sym_primitive] = ACTIONS(2612),
    [aux_sym_primitive_definition_token1] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2612),
    [anon_sym_macro] = ACTIONS(2612),
    [anon_sym_LPAREN] = ACTIONS(2612),
    [anon_sym_COMMA] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2612),
    [anon_sym_EQ] = ACTIONS(2612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2612),
    [anon_sym_LT_COLON] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [sym_break_statement] = ACTIONS(2612),
    [sym_continue_statement] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_quote] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_import] = ACTIONS(2612),
    [anon_sym_DOT] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2612),
    [anon_sym_COLON2] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2614),
    [anon_sym_begin] = ACTIONS(2612),
    [anon_sym_SQUOTE] = ACTIONS(2612),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_LT_PIPE] = ACTIONS(2612),
    [anon_sym_PIPE_GT] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_isa] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_QMARK] = ACTIONS(2612),
    [anon_sym_EQ_GT] = ACTIONS(2612),
    [anon_sym_LBRACK2] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2612),
    [anon_sym_AT] = ACTIONS(2612),
    [aux_sym_integer_literal_token1] = ACTIONS(2612),
    [aux_sym_integer_literal_token2] = ACTIONS(2612),
    [aux_sym_integer_literal_token3] = ACTIONS(2612),
    [sym_float_literal] = ACTIONS(2612),
    [sym__unary_operator] = ACTIONS(2612),
    [sym__power_operator] = ACTIONS(2612),
    [sym__bitshift_operator] = ACTIONS(2612),
    [sym__rational_operator] = ACTIONS(2612),
    [sym__times_operator] = ACTIONS(2612),
    [sym__plus_operator] = ACTIONS(2612),
    [sym__dotty_operator] = ACTIONS(2612),
    [sym__comparison_operator] = ACTIONS(2612),
    [sym__arrow_operator] = ACTIONS(2612),
    [sym__assign_operator] = ACTIONS(2612),
    [anon_sym_LF] = ACTIONS(2614),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2614),
    [sym__string_start] = ACTIONS(2614),
    [sym__command_start] = ACTIONS(2614),
  },
  [1190] = {
    [ts_builtin_sym_end] = ACTIONS(2618),
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_function] = ACTIONS(2616),
    [anon_sym_abstract] = ACTIONS(2616),
    [anon_sym_primitive] = ACTIONS(2616),
    [aux_sym_primitive_definition_token1] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_macro] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_EQ] = ACTIONS(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_LT_COLON] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [sym_break_statement] = ACTIONS(2616),
    [sym_continue_statement] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_let] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_quote] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_import] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2616),
    [anon_sym_COLON2] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_SQUOTE] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_LT_PIPE] = ACTIONS(2616),
    [anon_sym_PIPE_GT] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_isa] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2616),
    [anon_sym_LBRACK2] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_AT] = ACTIONS(2616),
    [aux_sym_integer_literal_token1] = ACTIONS(2616),
    [aux_sym_integer_literal_token2] = ACTIONS(2616),
    [aux_sym_integer_literal_token3] = ACTIONS(2616),
    [sym_float_literal] = ACTIONS(2616),
    [sym__unary_operator] = ACTIONS(2616),
    [sym__power_operator] = ACTIONS(2616),
    [sym__bitshift_operator] = ACTIONS(2616),
    [sym__rational_operator] = ACTIONS(2616),
    [sym__times_operator] = ACTIONS(2616),
    [sym__plus_operator] = ACTIONS(2616),
    [sym__dotty_operator] = ACTIONS(2616),
    [sym__comparison_operator] = ACTIONS(2616),
    [sym__arrow_operator] = ACTIONS(2616),
    [sym__assign_operator] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2618),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__command_start] = ACTIONS(2618),
  },
  [1191] = {
    [ts_builtin_sym_end] = ACTIONS(2622),
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_function] = ACTIONS(2620),
    [anon_sym_abstract] = ACTIONS(2620),
    [anon_sym_primitive] = ACTIONS(2620),
    [aux_sym_primitive_definition_token1] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_macro] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_EQ] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2620),
    [anon_sym_LT_COLON] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [sym_break_statement] = ACTIONS(2620),
    [sym_continue_statement] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_quote] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_import] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_COLON2] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_LT_PIPE] = ACTIONS(2620),
    [anon_sym_PIPE_GT] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_isa] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK2] = ACTIONS(2620),
    [anon_sym_DOLLAR] = ACTIONS(2620),
    [anon_sym_AT] = ACTIONS(2620),
    [aux_sym_integer_literal_token1] = ACTIONS(2620),
    [aux_sym_integer_literal_token2] = ACTIONS(2620),
    [aux_sym_integer_literal_token3] = ACTIONS(2620),
    [sym_float_literal] = ACTIONS(2620),
    [sym__unary_operator] = ACTIONS(2620),
    [sym__power_operator] = ACTIONS(2620),
    [sym__bitshift_operator] = ACTIONS(2620),
    [sym__rational_operator] = ACTIONS(2620),
    [sym__times_operator] = ACTIONS(2620),
    [sym__plus_operator] = ACTIONS(2620),
    [sym__dotty_operator] = ACTIONS(2620),
    [sym__comparison_operator] = ACTIONS(2620),
    [sym__arrow_operator] = ACTIONS(2620),
    [sym__assign_operator] = ACTIONS(2620),
    [anon_sym_LF] = ACTIONS(2622),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__command_start] = ACTIONS(2622),
  },
  [1192] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(2869),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2867),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(2867),
    [anon_sym_LBRACK2] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2867),
    [aux_sym_integer_literal_token1] = ACTIONS(2867),
    [aux_sym_integer_literal_token2] = ACTIONS(2867),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1193] = {
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_end] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_primitive] = ACTIONS(2592),
    [aux_sym_primitive_definition_token1] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_macro] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2594),
    [anon_sym_COMMA] = ACTIONS(2594),
    [anon_sym_RPAREN] = ACTIONS(2594),
    [anon_sym_SEMI] = ACTIONS(2594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2594),
    [anon_sym_COLON_COLON] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2594),
    [anon_sym_LT_COLON] = ACTIONS(2594),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [sym_break_statement] = ACTIONS(2592),
    [sym_continue_statement] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_quote] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_COLON2] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_RBRACK] = ACTIONS(2594),
    [anon_sym_begin] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2594),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_LT_PIPE] = ACTIONS(2594),
    [anon_sym_PIPE_GT] = ACTIONS(2594),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_isa] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2594),
    [anon_sym_AMP_AMP] = ACTIONS(2594),
    [anon_sym_QMARK] = ACTIONS(2594),
    [anon_sym_EQ_GT] = ACTIONS(2594),
    [anon_sym_LBRACK2] = ACTIONS(2592),
    [anon_sym_DOLLAR] = ACTIONS(2594),
    [anon_sym_AT] = ACTIONS(2594),
    [aux_sym_integer_literal_token1] = ACTIONS(2594),
    [aux_sym_integer_literal_token2] = ACTIONS(2594),
    [aux_sym_integer_literal_token3] = ACTIONS(2592),
    [sym_float_literal] = ACTIONS(2592),
    [sym__unary_operator] = ACTIONS(2592),
    [sym__power_operator] = ACTIONS(2594),
    [sym__bitshift_operator] = ACTIONS(2594),
    [sym__rational_operator] = ACTIONS(2594),
    [sym__times_operator] = ACTIONS(2592),
    [sym__plus_operator] = ACTIONS(2592),
    [sym__dotty_operator] = ACTIONS(2592),
    [sym__comparison_operator] = ACTIONS(2592),
    [sym__arrow_operator] = ACTIONS(2594),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2594),
    [sym__string_start] = ACTIONS(2594),
    [sym__command_start] = ACTIONS(2594),
  },
  [1194] = {
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_end] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_primitive] = ACTIONS(2682),
    [aux_sym_primitive_definition_token1] = ACTIONS(2682),
    [anon_sym_mutable] = ACTIONS(2682),
    [anon_sym_struct] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_macro] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2684),
    [anon_sym_COMMA] = ACTIONS(2684),
    [anon_sym_RPAREN] = ACTIONS(2684),
    [anon_sym_SEMI] = ACTIONS(2684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2684),
    [anon_sym_COLON_COLON] = ACTIONS(2684),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_LT_COLON] = ACTIONS(2684),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [sym_break_statement] = ACTIONS(2682),
    [sym_continue_statement] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_quote] = ACTIONS(2682),
    [anon_sym_using] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_DOT] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_COLON2] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_RBRACK] = ACTIONS(2684),
    [anon_sym_begin] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2684),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_LT_PIPE] = ACTIONS(2684),
    [anon_sym_PIPE_GT] = ACTIONS(2684),
    [anon_sym_in] = ACTIONS(2682),
    [anon_sym_isa] = ACTIONS(2682),
    [anon_sym_PIPE_PIPE] = ACTIONS(2684),
    [anon_sym_AMP_AMP] = ACTIONS(2684),
    [anon_sym_QMARK] = ACTIONS(2684),
    [anon_sym_EQ_GT] = ACTIONS(2684),
    [anon_sym_LBRACK2] = ACTIONS(2682),
    [anon_sym_DOLLAR] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2684),
    [aux_sym_integer_literal_token1] = ACTIONS(2684),
    [aux_sym_integer_literal_token2] = ACTIONS(2684),
    [aux_sym_integer_literal_token3] = ACTIONS(2682),
    [sym_float_literal] = ACTIONS(2682),
    [sym__unary_operator] = ACTIONS(2682),
    [sym__power_operator] = ACTIONS(2684),
    [sym__bitshift_operator] = ACTIONS(2684),
    [sym__rational_operator] = ACTIONS(2684),
    [sym__times_operator] = ACTIONS(2682),
    [sym__plus_operator] = ACTIONS(2682),
    [sym__dotty_operator] = ACTIONS(2682),
    [sym__comparison_operator] = ACTIONS(2682),
    [sym__arrow_operator] = ACTIONS(2684),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2684),
    [sym__string_start] = ACTIONS(2684),
    [sym__command_start] = ACTIONS(2684),
  },
  [1195] = {
    [ts_builtin_sym_end] = ACTIONS(2626),
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_primitive] = ACTIONS(2624),
    [aux_sym_primitive_definition_token1] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_macro] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2624),
    [anon_sym_EQ] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_LT_COLON] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [sym_break_statement] = ACTIONS(2624),
    [sym_continue_statement] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_quote] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_COLON2] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_SQUOTE] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_LT_PIPE] = ACTIONS(2624),
    [anon_sym_PIPE_GT] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_isa] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2624),
    [anon_sym_LBRACK2] = ACTIONS(2624),
    [anon_sym_DOLLAR] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(2624),
    [aux_sym_integer_literal_token1] = ACTIONS(2624),
    [aux_sym_integer_literal_token2] = ACTIONS(2624),
    [aux_sym_integer_literal_token3] = ACTIONS(2624),
    [sym_float_literal] = ACTIONS(2624),
    [sym__unary_operator] = ACTIONS(2624),
    [sym__power_operator] = ACTIONS(2624),
    [sym__bitshift_operator] = ACTIONS(2624),
    [sym__rational_operator] = ACTIONS(2624),
    [sym__times_operator] = ACTIONS(2624),
    [sym__plus_operator] = ACTIONS(2624),
    [sym__dotty_operator] = ACTIONS(2624),
    [sym__comparison_operator] = ACTIONS(2624),
    [sym__arrow_operator] = ACTIONS(2624),
    [sym__assign_operator] = ACTIONS(2624),
    [anon_sym_LF] = ACTIONS(2626),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__command_start] = ACTIONS(2626),
  },
  [1196] = {
    [ts_builtin_sym_end] = ACTIONS(2630),
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_function] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_primitive] = ACTIONS(2628),
    [aux_sym_primitive_definition_token1] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_macro] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_EQ] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_LT_COLON] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [sym_break_statement] = ACTIONS(2628),
    [sym_continue_statement] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_quote] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_COLON2] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_LT_PIPE] = ACTIONS(2628),
    [anon_sym_PIPE_GT] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_isa] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2628),
    [anon_sym_LBRACK2] = ACTIONS(2628),
    [anon_sym_DOLLAR] = ACTIONS(2628),
    [anon_sym_AT] = ACTIONS(2628),
    [aux_sym_integer_literal_token1] = ACTIONS(2628),
    [aux_sym_integer_literal_token2] = ACTIONS(2628),
    [aux_sym_integer_literal_token3] = ACTIONS(2628),
    [sym_float_literal] = ACTIONS(2628),
    [sym__unary_operator] = ACTIONS(2628),
    [sym__power_operator] = ACTIONS(2628),
    [sym__bitshift_operator] = ACTIONS(2628),
    [sym__rational_operator] = ACTIONS(2628),
    [sym__times_operator] = ACTIONS(2628),
    [sym__plus_operator] = ACTIONS(2628),
    [sym__dotty_operator] = ACTIONS(2628),
    [sym__comparison_operator] = ACTIONS(2628),
    [sym__arrow_operator] = ACTIONS(2628),
    [sym__assign_operator] = ACTIONS(2628),
    [anon_sym_LF] = ACTIONS(2630),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__command_start] = ACTIONS(2630),
  },
  [1197] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_end] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_primitive] = ACTIONS(2678),
    [aux_sym_primitive_definition_token1] = ACTIONS(2678),
    [anon_sym_mutable] = ACTIONS(2678),
    [anon_sym_struct] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_macro] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2680),
    [anon_sym_COMMA] = ACTIONS(2680),
    [anon_sym_RPAREN] = ACTIONS(2680),
    [anon_sym_SEMI] = ACTIONS(2680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2680),
    [anon_sym_COLON_COLON] = ACTIONS(2680),
    [anon_sym_RBRACE] = ACTIONS(2680),
    [anon_sym_LT_COLON] = ACTIONS(2680),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [sym_break_statement] = ACTIONS(2678),
    [sym_continue_statement] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_quote] = ACTIONS(2678),
    [anon_sym_using] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_DOT] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_COLON2] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_RBRACK] = ACTIONS(2680),
    [anon_sym_begin] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_LT_PIPE] = ACTIONS(2680),
    [anon_sym_PIPE_GT] = ACTIONS(2680),
    [anon_sym_in] = ACTIONS(2678),
    [anon_sym_isa] = ACTIONS(2678),
    [anon_sym_PIPE_PIPE] = ACTIONS(2680),
    [anon_sym_AMP_AMP] = ACTIONS(2680),
    [anon_sym_QMARK] = ACTIONS(2680),
    [anon_sym_EQ_GT] = ACTIONS(2680),
    [anon_sym_LBRACK2] = ACTIONS(2678),
    [anon_sym_DOLLAR] = ACTIONS(2680),
    [anon_sym_AT] = ACTIONS(2680),
    [aux_sym_integer_literal_token1] = ACTIONS(2680),
    [aux_sym_integer_literal_token2] = ACTIONS(2680),
    [aux_sym_integer_literal_token3] = ACTIONS(2678),
    [sym_float_literal] = ACTIONS(2678),
    [sym__unary_operator] = ACTIONS(2678),
    [sym__power_operator] = ACTIONS(2680),
    [sym__bitshift_operator] = ACTIONS(2680),
    [sym__rational_operator] = ACTIONS(2680),
    [sym__times_operator] = ACTIONS(2678),
    [sym__plus_operator] = ACTIONS(2678),
    [sym__dotty_operator] = ACTIONS(2678),
    [sym__comparison_operator] = ACTIONS(2678),
    [sym__arrow_operator] = ACTIONS(2680),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2680),
    [sym__string_start] = ACTIONS(2680),
    [sym__command_start] = ACTIONS(2680),
  },
  [1198] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_end] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_primitive] = ACTIONS(2674),
    [aux_sym_primitive_definition_token1] = ACTIONS(2674),
    [anon_sym_mutable] = ACTIONS(2674),
    [anon_sym_struct] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_macro] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2676),
    [anon_sym_COMMA] = ACTIONS(2676),
    [anon_sym_RPAREN] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2676),
    [anon_sym_COLON_COLON] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_LT_COLON] = ACTIONS(2676),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [sym_break_statement] = ACTIONS(2674),
    [sym_continue_statement] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_quote] = ACTIONS(2674),
    [anon_sym_using] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_DOT] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_COLON2] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_RBRACK] = ACTIONS(2676),
    [anon_sym_begin] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2676),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_LT_PIPE] = ACTIONS(2676),
    [anon_sym_PIPE_GT] = ACTIONS(2676),
    [anon_sym_in] = ACTIONS(2674),
    [anon_sym_isa] = ACTIONS(2674),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_QMARK] = ACTIONS(2676),
    [anon_sym_EQ_GT] = ACTIONS(2676),
    [anon_sym_LBRACK2] = ACTIONS(2674),
    [anon_sym_DOLLAR] = ACTIONS(2676),
    [anon_sym_AT] = ACTIONS(2676),
    [aux_sym_integer_literal_token1] = ACTIONS(2676),
    [aux_sym_integer_literal_token2] = ACTIONS(2676),
    [aux_sym_integer_literal_token3] = ACTIONS(2674),
    [sym_float_literal] = ACTIONS(2674),
    [sym__unary_operator] = ACTIONS(2674),
    [sym__power_operator] = ACTIONS(2676),
    [sym__bitshift_operator] = ACTIONS(2676),
    [sym__rational_operator] = ACTIONS(2676),
    [sym__times_operator] = ACTIONS(2674),
    [sym__plus_operator] = ACTIONS(2674),
    [sym__dotty_operator] = ACTIONS(2674),
    [sym__comparison_operator] = ACTIONS(2674),
    [sym__arrow_operator] = ACTIONS(2676),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2676),
    [sym__string_start] = ACTIONS(2676),
    [sym__command_start] = ACTIONS(2676),
  },
  [1199] = {
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_function] = ACTIONS(2807),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_abstract] = ACTIONS(2807),
    [anon_sym_primitive] = ACTIONS(2807),
    [aux_sym_primitive_definition_token1] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_module] = ACTIONS(2807),
    [anon_sym_macro] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2809),
    [anon_sym_RPAREN] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_LT_COLON] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [sym_break_statement] = ACTIONS(2807),
    [sym_continue_statement] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_let] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_quote] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_import] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_RBRACK] = ACTIONS(2809),
    [anon_sym_begin] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_LT_PIPE] = ACTIONS(2809),
    [anon_sym_PIPE_GT] = ACTIONS(2809),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_isa] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2809),
    [anon_sym_LBRACK2] = ACTIONS(2807),
    [anon_sym_DOLLAR] = ACTIONS(2807),
    [anon_sym_AT] = ACTIONS(2809),
    [aux_sym_integer_literal_token1] = ACTIONS(2809),
    [aux_sym_integer_literal_token2] = ACTIONS(2809),
    [aux_sym_integer_literal_token3] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
    [sym__unary_operator] = ACTIONS(2807),
    [sym__power_operator] = ACTIONS(2807),
    [sym__bitshift_operator] = ACTIONS(2807),
    [sym__rational_operator] = ACTIONS(2807),
    [sym__times_operator] = ACTIONS(2807),
    [sym__plus_operator] = ACTIONS(2807),
    [sym__dotty_operator] = ACTIONS(2807),
    [sym__comparison_operator] = ACTIONS(2807),
    [sym__arrow_operator] = ACTIONS(2809),
    [sym__assign_operator] = ACTIONS(2807),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2809),
    [sym__command_start] = ACTIONS(2809),
  },
  [1200] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_end] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_primitive] = ACTIONS(2686),
    [aux_sym_primitive_definition_token1] = ACTIONS(2686),
    [anon_sym_mutable] = ACTIONS(2686),
    [anon_sym_struct] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_macro] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2688),
    [anon_sym_COMMA] = ACTIONS(2688),
    [anon_sym_RPAREN] = ACTIONS(2688),
    [anon_sym_SEMI] = ACTIONS(2688),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2688),
    [anon_sym_COLON_COLON] = ACTIONS(2688),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_LT_COLON] = ACTIONS(2688),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [sym_break_statement] = ACTIONS(2686),
    [sym_continue_statement] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_quote] = ACTIONS(2686),
    [anon_sym_using] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_DOT] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_COLON2] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_RBRACK] = ACTIONS(2688),
    [anon_sym_begin] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2688),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_LT_PIPE] = ACTIONS(2688),
    [anon_sym_PIPE_GT] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(2686),
    [anon_sym_isa] = ACTIONS(2686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2688),
    [anon_sym_AMP_AMP] = ACTIONS(2688),
    [anon_sym_QMARK] = ACTIONS(2688),
    [anon_sym_EQ_GT] = ACTIONS(2688),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(2688),
    [anon_sym_AT] = ACTIONS(2688),
    [aux_sym_integer_literal_token1] = ACTIONS(2688),
    [aux_sym_integer_literal_token2] = ACTIONS(2688),
    [aux_sym_integer_literal_token3] = ACTIONS(2686),
    [sym_float_literal] = ACTIONS(2686),
    [sym__unary_operator] = ACTIONS(2686),
    [sym__power_operator] = ACTIONS(2688),
    [sym__bitshift_operator] = ACTIONS(2688),
    [sym__rational_operator] = ACTIONS(2688),
    [sym__times_operator] = ACTIONS(2686),
    [sym__plus_operator] = ACTIONS(2686),
    [sym__dotty_operator] = ACTIONS(2686),
    [sym__comparison_operator] = ACTIONS(2686),
    [sym__arrow_operator] = ACTIONS(2688),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2688),
    [sym__string_start] = ACTIONS(2688),
    [sym__command_start] = ACTIONS(2688),
  },
  [1201] = {
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_end] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_primitive] = ACTIONS(2716),
    [aux_sym_primitive_definition_token1] = ACTIONS(2716),
    [anon_sym_mutable] = ACTIONS(2716),
    [anon_sym_struct] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_macro] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_COMMA] = ACTIONS(2718),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2718),
    [anon_sym_COLON_COLON] = ACTIONS(2718),
    [anon_sym_RBRACE] = ACTIONS(2718),
    [anon_sym_LT_COLON] = ACTIONS(2718),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [sym_break_statement] = ACTIONS(2716),
    [sym_continue_statement] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_quote] = ACTIONS(2716),
    [anon_sym_using] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_DOT] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_COLON2] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_RBRACK] = ACTIONS(2718),
    [anon_sym_begin] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2718),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_LT_PIPE] = ACTIONS(2718),
    [anon_sym_PIPE_GT] = ACTIONS(2718),
    [anon_sym_in] = ACTIONS(2716),
    [anon_sym_isa] = ACTIONS(2716),
    [anon_sym_PIPE_PIPE] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(2718),
    [anon_sym_QMARK] = ACTIONS(2718),
    [anon_sym_EQ_GT] = ACTIONS(2718),
    [anon_sym_LBRACK2] = ACTIONS(2716),
    [anon_sym_DOLLAR] = ACTIONS(2718),
    [anon_sym_AT] = ACTIONS(2718),
    [aux_sym_integer_literal_token1] = ACTIONS(2718),
    [aux_sym_integer_literal_token2] = ACTIONS(2718),
    [aux_sym_integer_literal_token3] = ACTIONS(2716),
    [sym_float_literal] = ACTIONS(2716),
    [sym__unary_operator] = ACTIONS(2716),
    [sym__power_operator] = ACTIONS(2718),
    [sym__bitshift_operator] = ACTIONS(2718),
    [sym__rational_operator] = ACTIONS(2718),
    [sym__times_operator] = ACTIONS(2716),
    [sym__plus_operator] = ACTIONS(2716),
    [sym__dotty_operator] = ACTIONS(2716),
    [sym__comparison_operator] = ACTIONS(2716),
    [sym__arrow_operator] = ACTIONS(2718),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2718),
    [sym__string_start] = ACTIONS(2718),
    [sym__command_start] = ACTIONS(2718),
  },
  [1202] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1222),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2883),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2883),
    [aux_sym_integer_literal_token1] = ACTIONS(2883),
    [aux_sym_integer_literal_token2] = ACTIONS(2883),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(3268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1203] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_elseif] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_DOT] = ACTIONS(3278),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3282),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1204] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_end] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_primitive] = ACTIONS(2596),
    [aux_sym_primitive_definition_token1] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_macro] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2598),
    [anon_sym_COMMA] = ACTIONS(2598),
    [anon_sym_RPAREN] = ACTIONS(2598),
    [anon_sym_SEMI] = ACTIONS(2598),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2598),
    [anon_sym_COLON_COLON] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2598),
    [anon_sym_LT_COLON] = ACTIONS(2598),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [sym_break_statement] = ACTIONS(2596),
    [sym_continue_statement] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_quote] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_COLON2] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_RBRACK] = ACTIONS(2598),
    [anon_sym_begin] = ACTIONS(2596),
    [anon_sym_SQUOTE] = ACTIONS(2598),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_LT_PIPE] = ACTIONS(2598),
    [anon_sym_PIPE_GT] = ACTIONS(2598),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_isa] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(2598),
    [anon_sym_QMARK] = ACTIONS(2598),
    [anon_sym_EQ_GT] = ACTIONS(2598),
    [anon_sym_LBRACK2] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2598),
    [anon_sym_AT] = ACTIONS(2598),
    [aux_sym_integer_literal_token1] = ACTIONS(2598),
    [aux_sym_integer_literal_token2] = ACTIONS(2598),
    [aux_sym_integer_literal_token3] = ACTIONS(2596),
    [sym_float_literal] = ACTIONS(2596),
    [sym__unary_operator] = ACTIONS(2596),
    [sym__power_operator] = ACTIONS(2598),
    [sym__bitshift_operator] = ACTIONS(2598),
    [sym__rational_operator] = ACTIONS(2598),
    [sym__times_operator] = ACTIONS(2596),
    [sym__plus_operator] = ACTIONS(2596),
    [sym__dotty_operator] = ACTIONS(2596),
    [sym__comparison_operator] = ACTIONS(2596),
    [sym__arrow_operator] = ACTIONS(2598),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2598),
    [sym__string_start] = ACTIONS(2598),
    [sym__command_start] = ACTIONS(2598),
  },
  [1205] = {
    [ts_builtin_sym_end] = ACTIONS(2634),
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_primitive] = ACTIONS(2632),
    [aux_sym_primitive_definition_token1] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_macro] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_EQ] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_LT_COLON] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [sym_break_statement] = ACTIONS(2632),
    [sym_continue_statement] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_quote] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_COLON2] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_LT_PIPE] = ACTIONS(2632),
    [anon_sym_PIPE_GT] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_isa] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2632),
    [anon_sym_LBRACK2] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2632),
    [aux_sym_integer_literal_token1] = ACTIONS(2632),
    [aux_sym_integer_literal_token2] = ACTIONS(2632),
    [aux_sym_integer_literal_token3] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__unary_operator] = ACTIONS(2632),
    [sym__power_operator] = ACTIONS(2632),
    [sym__bitshift_operator] = ACTIONS(2632),
    [sym__rational_operator] = ACTIONS(2632),
    [sym__times_operator] = ACTIONS(2632),
    [sym__plus_operator] = ACTIONS(2632),
    [sym__dotty_operator] = ACTIONS(2632),
    [sym__comparison_operator] = ACTIONS(2632),
    [sym__arrow_operator] = ACTIONS(2632),
    [sym__assign_operator] = ACTIONS(2632),
    [anon_sym_LF] = ACTIONS(2634),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__command_start] = ACTIONS(2634),
  },
  [1206] = {
    [ts_builtin_sym_end] = ACTIONS(2638),
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_primitive] = ACTIONS(2636),
    [aux_sym_primitive_definition_token1] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_macro] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_EQ] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2636),
    [anon_sym_LT_COLON] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [sym_break_statement] = ACTIONS(2636),
    [sym_continue_statement] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_quote] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_COLON2] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_LT_PIPE] = ACTIONS(2636),
    [anon_sym_PIPE_GT] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_isa] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK2] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2636),
    [aux_sym_integer_literal_token1] = ACTIONS(2636),
    [aux_sym_integer_literal_token2] = ACTIONS(2636),
    [aux_sym_integer_literal_token3] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__unary_operator] = ACTIONS(2636),
    [sym__power_operator] = ACTIONS(2636),
    [sym__bitshift_operator] = ACTIONS(2636),
    [sym__rational_operator] = ACTIONS(2636),
    [sym__times_operator] = ACTIONS(2636),
    [sym__plus_operator] = ACTIONS(2636),
    [sym__dotty_operator] = ACTIONS(2636),
    [sym__comparison_operator] = ACTIONS(2636),
    [sym__arrow_operator] = ACTIONS(2636),
    [sym__assign_operator] = ACTIONS(2636),
    [anon_sym_LF] = ACTIONS(2638),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__command_start] = ACTIONS(2638),
  },
  [1207] = {
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2466),
    [anon_sym_COMMA] = ACTIONS(2466),
    [anon_sym_RPAREN] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2466),
    [anon_sym_COLON_COLON] = ACTIONS(2466),
    [anon_sym_RBRACE] = ACTIONS(2466),
    [anon_sym_LT_COLON] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_RBRACK] = ACTIONS(2466),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2466),
    [anon_sym_PIPE_GT] = ACTIONS(2466),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2466),
    [anon_sym_AMP_AMP] = ACTIONS(2466),
    [anon_sym_QMARK] = ACTIONS(2466),
    [anon_sym_EQ_GT] = ACTIONS(2466),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2466),
    [anon_sym_AT] = ACTIONS(2466),
    [aux_sym_integer_literal_token1] = ACTIONS(2466),
    [aux_sym_integer_literal_token2] = ACTIONS(2466),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2466),
    [sym__bitshift_operator] = ACTIONS(2466),
    [sym__rational_operator] = ACTIONS(2466),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
  },
  [1208] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(2869),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3284),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(3286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_elseif] = ACTIONS(2837),
    [anon_sym_else] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2837),
    [aux_sym_integer_literal_token1] = ACTIONS(2837),
    [aux_sym_integer_literal_token2] = ACTIONS(2837),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(2867),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1209] = {
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(2658),
    [anon_sym_end] = ACTIONS(2658),
    [anon_sym_abstract] = ACTIONS(2658),
    [anon_sym_primitive] = ACTIONS(2658),
    [aux_sym_primitive_definition_token1] = ACTIONS(2658),
    [anon_sym_mutable] = ACTIONS(2658),
    [anon_sym_struct] = ACTIONS(2658),
    [anon_sym_module] = ACTIONS(2658),
    [anon_sym_macro] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2660),
    [anon_sym_COMMA] = ACTIONS(2660),
    [anon_sym_RPAREN] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(2660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2660),
    [anon_sym_COLON_COLON] = ACTIONS(2660),
    [anon_sym_RBRACE] = ACTIONS(2660),
    [anon_sym_LT_COLON] = ACTIONS(2660),
    [anon_sym_if] = ACTIONS(2658),
    [anon_sym_try] = ACTIONS(2658),
    [anon_sym_for] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [sym_break_statement] = ACTIONS(2658),
    [sym_continue_statement] = ACTIONS(2658),
    [anon_sym_return] = ACTIONS(2658),
    [anon_sym_let] = ACTIONS(2658),
    [anon_sym_const] = ACTIONS(2658),
    [anon_sym_quote] = ACTIONS(2658),
    [anon_sym_using] = ACTIONS(2658),
    [anon_sym_import] = ACTIONS(2658),
    [anon_sym_DOT] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2658),
    [anon_sym_COLON2] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_RBRACK] = ACTIONS(2660),
    [anon_sym_begin] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2660),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_LT_PIPE] = ACTIONS(2660),
    [anon_sym_PIPE_GT] = ACTIONS(2660),
    [anon_sym_in] = ACTIONS(2658),
    [anon_sym_isa] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2660),
    [anon_sym_AMP_AMP] = ACTIONS(2660),
    [anon_sym_QMARK] = ACTIONS(2660),
    [anon_sym_EQ_GT] = ACTIONS(2660),
    [anon_sym_LBRACK2] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(2660),
    [anon_sym_AT] = ACTIONS(2660),
    [aux_sym_integer_literal_token1] = ACTIONS(2660),
    [aux_sym_integer_literal_token2] = ACTIONS(2660),
    [aux_sym_integer_literal_token3] = ACTIONS(2658),
    [sym_float_literal] = ACTIONS(2658),
    [sym__unary_operator] = ACTIONS(2658),
    [sym__power_operator] = ACTIONS(2660),
    [sym__bitshift_operator] = ACTIONS(2660),
    [sym__rational_operator] = ACTIONS(2660),
    [sym__times_operator] = ACTIONS(2658),
    [sym__plus_operator] = ACTIONS(2658),
    [sym__dotty_operator] = ACTIONS(2658),
    [sym__comparison_operator] = ACTIONS(2658),
    [sym__arrow_operator] = ACTIONS(2660),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2660),
    [sym__string_start] = ACTIONS(2660),
    [sym__command_start] = ACTIONS(2660),
  },
  [1210] = {
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(2662),
    [anon_sym_end] = ACTIONS(2662),
    [anon_sym_abstract] = ACTIONS(2662),
    [anon_sym_primitive] = ACTIONS(2662),
    [aux_sym_primitive_definition_token1] = ACTIONS(2662),
    [anon_sym_mutable] = ACTIONS(2662),
    [anon_sym_struct] = ACTIONS(2662),
    [anon_sym_module] = ACTIONS(2662),
    [anon_sym_macro] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2664),
    [anon_sym_COMMA] = ACTIONS(2664),
    [anon_sym_RPAREN] = ACTIONS(2664),
    [anon_sym_SEMI] = ACTIONS(2664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2664),
    [anon_sym_COLON_COLON] = ACTIONS(2664),
    [anon_sym_RBRACE] = ACTIONS(2664),
    [anon_sym_LT_COLON] = ACTIONS(2664),
    [anon_sym_if] = ACTIONS(2662),
    [anon_sym_try] = ACTIONS(2662),
    [anon_sym_for] = ACTIONS(2662),
    [anon_sym_while] = ACTIONS(2662),
    [sym_break_statement] = ACTIONS(2662),
    [sym_continue_statement] = ACTIONS(2662),
    [anon_sym_return] = ACTIONS(2662),
    [anon_sym_let] = ACTIONS(2662),
    [anon_sym_const] = ACTIONS(2662),
    [anon_sym_quote] = ACTIONS(2662),
    [anon_sym_using] = ACTIONS(2662),
    [anon_sym_import] = ACTIONS(2662),
    [anon_sym_DOT] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_COLON2] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_RBRACK] = ACTIONS(2664),
    [anon_sym_begin] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2664),
    [anon_sym_PLUS] = ACTIONS(2662),
    [anon_sym_LT_PIPE] = ACTIONS(2664),
    [anon_sym_PIPE_GT] = ACTIONS(2664),
    [anon_sym_in] = ACTIONS(2662),
    [anon_sym_isa] = ACTIONS(2662),
    [anon_sym_PIPE_PIPE] = ACTIONS(2664),
    [anon_sym_AMP_AMP] = ACTIONS(2664),
    [anon_sym_QMARK] = ACTIONS(2664),
    [anon_sym_EQ_GT] = ACTIONS(2664),
    [anon_sym_LBRACK2] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(2664),
    [anon_sym_AT] = ACTIONS(2664),
    [aux_sym_integer_literal_token1] = ACTIONS(2664),
    [aux_sym_integer_literal_token2] = ACTIONS(2664),
    [aux_sym_integer_literal_token3] = ACTIONS(2662),
    [sym_float_literal] = ACTIONS(2662),
    [sym__unary_operator] = ACTIONS(2662),
    [sym__power_operator] = ACTIONS(2664),
    [sym__bitshift_operator] = ACTIONS(2664),
    [sym__rational_operator] = ACTIONS(2664),
    [sym__times_operator] = ACTIONS(2662),
    [sym__plus_operator] = ACTIONS(2662),
    [sym__dotty_operator] = ACTIONS(2662),
    [sym__comparison_operator] = ACTIONS(2662),
    [sym__arrow_operator] = ACTIONS(2664),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2664),
    [sym__string_start] = ACTIONS(2664),
    [sym__command_start] = ACTIONS(2664),
  },
  [1211] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_end] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_primitive] = ACTIONS(2670),
    [aux_sym_primitive_definition_token1] = ACTIONS(2670),
    [anon_sym_mutable] = ACTIONS(2670),
    [anon_sym_struct] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_macro] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_RPAREN] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2672),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_LT_COLON] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [sym_break_statement] = ACTIONS(2670),
    [sym_continue_statement] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_quote] = ACTIONS(2670),
    [anon_sym_using] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_DOT] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_COLON2] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_RBRACK] = ACTIONS(2672),
    [anon_sym_begin] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_LT_PIPE] = ACTIONS(2672),
    [anon_sym_PIPE_GT] = ACTIONS(2672),
    [anon_sym_in] = ACTIONS(2670),
    [anon_sym_isa] = ACTIONS(2670),
    [anon_sym_PIPE_PIPE] = ACTIONS(2672),
    [anon_sym_AMP_AMP] = ACTIONS(2672),
    [anon_sym_QMARK] = ACTIONS(2672),
    [anon_sym_EQ_GT] = ACTIONS(2672),
    [anon_sym_LBRACK2] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2672),
    [anon_sym_AT] = ACTIONS(2672),
    [aux_sym_integer_literal_token1] = ACTIONS(2672),
    [aux_sym_integer_literal_token2] = ACTIONS(2672),
    [aux_sym_integer_literal_token3] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
    [sym__unary_operator] = ACTIONS(2670),
    [sym__power_operator] = ACTIONS(2672),
    [sym__bitshift_operator] = ACTIONS(2672),
    [sym__rational_operator] = ACTIONS(2672),
    [sym__times_operator] = ACTIONS(2670),
    [sym__plus_operator] = ACTIONS(2670),
    [sym__dotty_operator] = ACTIONS(2670),
    [sym__comparison_operator] = ACTIONS(2670),
    [sym__arrow_operator] = ACTIONS(2672),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2672),
    [sym__string_start] = ACTIONS(2672),
    [sym__command_start] = ACTIONS(2672),
  },
  [1212] = {
    [aux_sym_selected_import_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_end] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_primitive] = ACTIONS(2889),
    [aux_sym_primitive_definition_token1] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_macro] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(3288),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2894),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_LT_COLON] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [sym_break_statement] = ACTIONS(2889),
    [sym_continue_statement] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_quote] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_COLON2] = ACTIONS(2889),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_begin] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_LT_PIPE] = ACTIONS(2894),
    [anon_sym_PIPE_GT] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_LBRACK2] = ACTIONS(2894),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2894),
    [aux_sym_integer_literal_token1] = ACTIONS(2894),
    [aux_sym_integer_literal_token2] = ACTIONS(2894),
    [aux_sym_integer_literal_token3] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym__unary_operator] = ACTIONS(2889),
    [sym__power_operator] = ACTIONS(2889),
    [sym__bitshift_operator] = ACTIONS(2889),
    [sym__rational_operator] = ACTIONS(2889),
    [sym__times_operator] = ACTIONS(2889),
    [sym__plus_operator] = ACTIONS(2889),
    [sym__dotty_operator] = ACTIONS(2889),
    [sym__comparison_operator] = ACTIONS(2889),
    [sym__arrow_operator] = ACTIONS(2894),
    [sym__assign_operator] = ACTIONS(2889),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2894),
    [sym__command_start] = ACTIONS(2894),
  },
  [1213] = {
    [aux_sym_import_statement_repeat1] = STATE(1444),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2648),
    [anon_sym_LT_COLON] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_elseif] = ACTIONS(2648),
    [anon_sym_else] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(3293),
    [anon_sym_DOT] = ACTIONS(3295),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_GT] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_EQ_GT] = ACTIONS(2648),
    [anon_sym_LBRACK2] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2648),
    [aux_sym_integer_literal_token1] = ACTIONS(2648),
    [aux_sym_integer_literal_token2] = ACTIONS(2648),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2648),
    [anon_sym_LF] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1214] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_end] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_primitive] = ACTIONS(2670),
    [aux_sym_primitive_definition_token1] = ACTIONS(2670),
    [anon_sym_mutable] = ACTIONS(2670),
    [anon_sym_struct] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_macro] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_COMMA] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2670),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LT_COLON] = ACTIONS(2670),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_elseif] = ACTIONS(2670),
    [anon_sym_else] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [sym_break_statement] = ACTIONS(2670),
    [sym_continue_statement] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_quote] = ACTIONS(2670),
    [anon_sym_using] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_DOT] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_COLON2] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_begin] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_LT_PIPE] = ACTIONS(2670),
    [anon_sym_PIPE_GT] = ACTIONS(2670),
    [anon_sym_in] = ACTIONS(2670),
    [anon_sym_isa] = ACTIONS(2670),
    [anon_sym_PIPE_PIPE] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_QMARK] = ACTIONS(2670),
    [anon_sym_EQ_GT] = ACTIONS(2670),
    [anon_sym_LBRACK2] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2670),
    [aux_sym_integer_literal_token1] = ACTIONS(2670),
    [aux_sym_integer_literal_token2] = ACTIONS(2670),
    [aux_sym_integer_literal_token3] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
    [sym__unary_operator] = ACTIONS(2670),
    [sym__power_operator] = ACTIONS(2670),
    [sym__bitshift_operator] = ACTIONS(2670),
    [sym__rational_operator] = ACTIONS(2670),
    [sym__times_operator] = ACTIONS(2670),
    [sym__plus_operator] = ACTIONS(2670),
    [sym__dotty_operator] = ACTIONS(2670),
    [sym__comparison_operator] = ACTIONS(2670),
    [sym__arrow_operator] = ACTIONS(2670),
    [anon_sym_LF] = ACTIONS(2672),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2672),
    [sym__string_start] = ACTIONS(2672),
    [sym__command_start] = ACTIONS(2672),
  },
  [1215] = {
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_end] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_primitive] = ACTIONS(2690),
    [aux_sym_primitive_definition_token1] = ACTIONS(2690),
    [anon_sym_mutable] = ACTIONS(2690),
    [anon_sym_struct] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_macro] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_COMMA] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_LT_COLON] = ACTIONS(2690),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_elseif] = ACTIONS(2690),
    [anon_sym_else] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [sym_break_statement] = ACTIONS(2690),
    [sym_continue_statement] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_quote] = ACTIONS(2690),
    [anon_sym_using] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_COLON2] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_begin] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_LT_PIPE] = ACTIONS(2690),
    [anon_sym_PIPE_GT] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2690),
    [anon_sym_isa] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_QMARK] = ACTIONS(2690),
    [anon_sym_EQ_GT] = ACTIONS(2690),
    [anon_sym_LBRACK2] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2690),
    [aux_sym_integer_literal_token1] = ACTIONS(2690),
    [aux_sym_integer_literal_token2] = ACTIONS(2690),
    [aux_sym_integer_literal_token3] = ACTIONS(2690),
    [sym_float_literal] = ACTIONS(2690),
    [sym__unary_operator] = ACTIONS(2690),
    [sym__power_operator] = ACTIONS(2690),
    [sym__bitshift_operator] = ACTIONS(2690),
    [sym__rational_operator] = ACTIONS(2690),
    [sym__times_operator] = ACTIONS(2690),
    [sym__plus_operator] = ACTIONS(2690),
    [sym__dotty_operator] = ACTIONS(2690),
    [sym__comparison_operator] = ACTIONS(2690),
    [sym__arrow_operator] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2692),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2692),
    [sym__string_start] = ACTIONS(2692),
    [sym__command_start] = ACTIONS(2692),
  },
  [1216] = {
    [ts_builtin_sym_end] = ACTIONS(2466),
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_EQ] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LT_COLON] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2464),
    [anon_sym_PIPE_GT] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2464),
    [aux_sym_integer_literal_token1] = ACTIONS(2464),
    [aux_sym_integer_literal_token2] = ACTIONS(2464),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2464),
    [sym__assign_operator] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
  },
  [1217] = {
    [ts_builtin_sym_end] = ACTIONS(2598),
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_primitive] = ACTIONS(2596),
    [aux_sym_primitive_definition_token1] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_macro] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2596),
    [anon_sym_EQ] = ACTIONS(2596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2596),
    [anon_sym_LT_COLON] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [sym_break_statement] = ACTIONS(2596),
    [sym_continue_statement] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_quote] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_COLON2] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_begin] = ACTIONS(2596),
    [anon_sym_SQUOTE] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_LT_PIPE] = ACTIONS(2596),
    [anon_sym_PIPE_GT] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_isa] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_QMARK] = ACTIONS(2596),
    [anon_sym_EQ_GT] = ACTIONS(2596),
    [anon_sym_LBRACK2] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(2596),
    [aux_sym_integer_literal_token1] = ACTIONS(2596),
    [aux_sym_integer_literal_token2] = ACTIONS(2596),
    [aux_sym_integer_literal_token3] = ACTIONS(2596),
    [sym_float_literal] = ACTIONS(2596),
    [sym__unary_operator] = ACTIONS(2596),
    [sym__power_operator] = ACTIONS(2596),
    [sym__bitshift_operator] = ACTIONS(2596),
    [sym__rational_operator] = ACTIONS(2596),
    [sym__times_operator] = ACTIONS(2596),
    [sym__plus_operator] = ACTIONS(2596),
    [sym__dotty_operator] = ACTIONS(2596),
    [sym__comparison_operator] = ACTIONS(2596),
    [sym__arrow_operator] = ACTIONS(2596),
    [sym__assign_operator] = ACTIONS(2596),
    [anon_sym_LF] = ACTIONS(2598),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2598),
    [sym__string_start] = ACTIONS(2598),
    [sym__command_start] = ACTIONS(2598),
  },
  [1218] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(2869),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(3297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2867),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(2867),
    [anon_sym_LBRACK2] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2867),
    [aux_sym_integer_literal_token1] = ACTIONS(2867),
    [aux_sym_integer_literal_token2] = ACTIONS(2867),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(3297),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1219] = {
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_end] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_primitive] = ACTIONS(2666),
    [aux_sym_primitive_definition_token1] = ACTIONS(2666),
    [anon_sym_mutable] = ACTIONS(2666),
    [anon_sym_struct] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_macro] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2668),
    [anon_sym_COMMA] = ACTIONS(2668),
    [anon_sym_RPAREN] = ACTIONS(2668),
    [anon_sym_SEMI] = ACTIONS(2668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2668),
    [anon_sym_COLON_COLON] = ACTIONS(2668),
    [anon_sym_RBRACE] = ACTIONS(2668),
    [anon_sym_LT_COLON] = ACTIONS(2668),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [sym_break_statement] = ACTIONS(2666),
    [sym_continue_statement] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_quote] = ACTIONS(2666),
    [anon_sym_using] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_DOT] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_COLON2] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_RBRACK] = ACTIONS(2668),
    [anon_sym_begin] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2668),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_LT_PIPE] = ACTIONS(2668),
    [anon_sym_PIPE_GT] = ACTIONS(2668),
    [anon_sym_in] = ACTIONS(2666),
    [anon_sym_isa] = ACTIONS(2666),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_QMARK] = ACTIONS(2668),
    [anon_sym_EQ_GT] = ACTIONS(2668),
    [anon_sym_LBRACK2] = ACTIONS(2666),
    [anon_sym_DOLLAR] = ACTIONS(2668),
    [anon_sym_AT] = ACTIONS(2668),
    [aux_sym_integer_literal_token1] = ACTIONS(2668),
    [aux_sym_integer_literal_token2] = ACTIONS(2668),
    [aux_sym_integer_literal_token3] = ACTIONS(2666),
    [sym_float_literal] = ACTIONS(2666),
    [sym__unary_operator] = ACTIONS(2666),
    [sym__power_operator] = ACTIONS(2668),
    [sym__bitshift_operator] = ACTIONS(2668),
    [sym__rational_operator] = ACTIONS(2668),
    [sym__times_operator] = ACTIONS(2666),
    [sym__plus_operator] = ACTIONS(2666),
    [sym__dotty_operator] = ACTIONS(2666),
    [sym__comparison_operator] = ACTIONS(2666),
    [sym__arrow_operator] = ACTIONS(2668),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2668),
    [sym__string_start] = ACTIONS(2668),
    [sym__command_start] = ACTIONS(2668),
  },
  [1220] = {
    [sym_identifier] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2752),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2752),
    [anon_sym_COLON_COLON] = ACTIONS(2752),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_LT_COLON] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2752),
    [anon_sym_PIPE_GT] = ACTIONS(2752),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_QMARK] = ACTIONS(2752),
    [anon_sym_EQ_GT] = ACTIONS(2752),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2752),
    [aux_sym_integer_literal_token1] = ACTIONS(2752),
    [aux_sym_integer_literal_token2] = ACTIONS(2752),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2752),
    [sym__assign_operator] = ACTIONS(2750),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1221] = {
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_end] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_primitive] = ACTIONS(2712),
    [aux_sym_primitive_definition_token1] = ACTIONS(2712),
    [anon_sym_mutable] = ACTIONS(2712),
    [anon_sym_struct] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_macro] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_COMMA] = ACTIONS(2714),
    [anon_sym_RPAREN] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2714),
    [anon_sym_COLON_COLON] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_LT_COLON] = ACTIONS(2714),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [sym_break_statement] = ACTIONS(2712),
    [sym_continue_statement] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_quote] = ACTIONS(2712),
    [anon_sym_using] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_DOT] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_COLON2] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_RBRACK] = ACTIONS(2714),
    [anon_sym_begin] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_LT_PIPE] = ACTIONS(2714),
    [anon_sym_PIPE_GT] = ACTIONS(2714),
    [anon_sym_in] = ACTIONS(2712),
    [anon_sym_isa] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2714),
    [anon_sym_AMP_AMP] = ACTIONS(2714),
    [anon_sym_QMARK] = ACTIONS(2714),
    [anon_sym_EQ_GT] = ACTIONS(2714),
    [anon_sym_LBRACK2] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2714),
    [anon_sym_AT] = ACTIONS(2714),
    [aux_sym_integer_literal_token1] = ACTIONS(2714),
    [aux_sym_integer_literal_token2] = ACTIONS(2714),
    [aux_sym_integer_literal_token3] = ACTIONS(2712),
    [sym_float_literal] = ACTIONS(2712),
    [sym__unary_operator] = ACTIONS(2712),
    [sym__power_operator] = ACTIONS(2714),
    [sym__bitshift_operator] = ACTIONS(2714),
    [sym__rational_operator] = ACTIONS(2714),
    [sym__times_operator] = ACTIONS(2712),
    [sym__plus_operator] = ACTIONS(2712),
    [sym__dotty_operator] = ACTIONS(2712),
    [sym__comparison_operator] = ACTIONS(2712),
    [sym__arrow_operator] = ACTIONS(2714),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2714),
    [sym__string_start] = ACTIONS(2714),
    [sym__command_start] = ACTIONS(2714),
  },
  [1222] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1188),
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_function] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(2811),
    [anon_sym_abstract] = ACTIONS(2811),
    [anon_sym_primitive] = ACTIONS(2811),
    [aux_sym_primitive_definition_token1] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_macro] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_COMMA] = ACTIONS(3299),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_EQ] = ACTIONS(2811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_LT_COLON] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [sym_break_statement] = ACTIONS(2811),
    [sym_continue_statement] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_quote] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_COLON2] = ACTIONS(2811),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_begin] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_LT_PIPE] = ACTIONS(2815),
    [anon_sym_PIPE_GT] = ACTIONS(2815),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_isa] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2815),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_LBRACK2] = ACTIONS(2815),
    [anon_sym_DOLLAR] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2815),
    [aux_sym_integer_literal_token1] = ACTIONS(2815),
    [aux_sym_integer_literal_token2] = ACTIONS(2815),
    [aux_sym_integer_literal_token3] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
    [sym__unary_operator] = ACTIONS(2811),
    [sym__power_operator] = ACTIONS(2811),
    [sym__bitshift_operator] = ACTIONS(2811),
    [sym__rational_operator] = ACTIONS(2811),
    [sym__times_operator] = ACTIONS(2811),
    [sym__plus_operator] = ACTIONS(2811),
    [sym__dotty_operator] = ACTIONS(2811),
    [sym__comparison_operator] = ACTIONS(2811),
    [sym__arrow_operator] = ACTIONS(2815),
    [sym__assign_operator] = ACTIONS(2811),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2815),
    [sym__command_start] = ACTIONS(2815),
  },
  [1223] = {
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_end] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_primitive] = ACTIONS(2690),
    [aux_sym_primitive_definition_token1] = ACTIONS(2690),
    [anon_sym_mutable] = ACTIONS(2690),
    [anon_sym_struct] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_macro] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2692),
    [anon_sym_COMMA] = ACTIONS(2692),
    [anon_sym_RPAREN] = ACTIONS(2692),
    [anon_sym_SEMI] = ACTIONS(2692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2692),
    [anon_sym_COLON_COLON] = ACTIONS(2692),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_LT_COLON] = ACTIONS(2692),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [sym_break_statement] = ACTIONS(2690),
    [sym_continue_statement] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_quote] = ACTIONS(2690),
    [anon_sym_using] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_COLON2] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_RBRACK] = ACTIONS(2692),
    [anon_sym_begin] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2692),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_LT_PIPE] = ACTIONS(2692),
    [anon_sym_PIPE_GT] = ACTIONS(2692),
    [anon_sym_in] = ACTIONS(2690),
    [anon_sym_isa] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2692),
    [anon_sym_AMP_AMP] = ACTIONS(2692),
    [anon_sym_QMARK] = ACTIONS(2692),
    [anon_sym_EQ_GT] = ACTIONS(2692),
    [anon_sym_LBRACK2] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2692),
    [anon_sym_AT] = ACTIONS(2692),
    [aux_sym_integer_literal_token1] = ACTIONS(2692),
    [aux_sym_integer_literal_token2] = ACTIONS(2692),
    [aux_sym_integer_literal_token3] = ACTIONS(2690),
    [sym_float_literal] = ACTIONS(2690),
    [sym__unary_operator] = ACTIONS(2690),
    [sym__power_operator] = ACTIONS(2692),
    [sym__bitshift_operator] = ACTIONS(2692),
    [sym__rational_operator] = ACTIONS(2692),
    [sym__times_operator] = ACTIONS(2690),
    [sym__plus_operator] = ACTIONS(2690),
    [sym__dotty_operator] = ACTIONS(2690),
    [sym__comparison_operator] = ACTIONS(2690),
    [sym__arrow_operator] = ACTIONS(2692),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2692),
    [sym__string_start] = ACTIONS(2692),
    [sym__command_start] = ACTIONS(2692),
  },
  [1224] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_COMMA] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_LT_COLON] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_RBRACK] = ACTIONS(2708),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_GT] = ACTIONS(2708),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2708),
    [anon_sym_AMP_AMP] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2708),
    [anon_sym_EQ_GT] = ACTIONS(2708),
    [anon_sym_LBRACK2] = ACTIONS(2708),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2708),
    [aux_sym_integer_literal_token1] = ACTIONS(2708),
    [aux_sym_integer_literal_token2] = ACTIONS(2708),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2708),
    [sym__assign_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3225),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1225] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_COMMA] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_LT_COLON] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3223),
    [anon_sym_RBRACK] = ACTIONS(2708),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_GT] = ACTIONS(2708),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2708),
    [anon_sym_AMP_AMP] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2708),
    [anon_sym_EQ_GT] = ACTIONS(2708),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2708),
    [aux_sym_integer_literal_token1] = ACTIONS(2708),
    [aux_sym_integer_literal_token2] = ACTIONS(2708),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2708),
    [sym__assign_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1226] = {
    [aux_sym_import_statement_repeat1] = STATE(1477),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(3301),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_LT_COLON] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(3303),
    [anon_sym_DOT] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2656),
    [anon_sym_PIPE_GT] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_LBRACK2] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [aux_sym_integer_literal_token1] = ACTIONS(2656),
    [aux_sym_integer_literal_token2] = ACTIONS(2656),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2656),
    [sym__bitshift_operator] = ACTIONS(2656),
    [sym__rational_operator] = ACTIONS(2656),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1227] = {
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_end] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_primitive] = ACTIONS(2592),
    [aux_sym_primitive_definition_token1] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_macro] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2592),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LT_COLON] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_elseif] = ACTIONS(2592),
    [anon_sym_else] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [sym_break_statement] = ACTIONS(2592),
    [sym_continue_statement] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_quote] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_COLON2] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_begin] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_LT_PIPE] = ACTIONS(2592),
    [anon_sym_PIPE_GT] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_isa] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2592),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK2] = ACTIONS(2592),
    [anon_sym_DOLLAR] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(2592),
    [aux_sym_integer_literal_token1] = ACTIONS(2592),
    [aux_sym_integer_literal_token2] = ACTIONS(2592),
    [aux_sym_integer_literal_token3] = ACTIONS(2592),
    [sym_float_literal] = ACTIONS(2592),
    [sym__unary_operator] = ACTIONS(2592),
    [sym__power_operator] = ACTIONS(2592),
    [sym__bitshift_operator] = ACTIONS(2592),
    [sym__rational_operator] = ACTIONS(2592),
    [sym__times_operator] = ACTIONS(2592),
    [sym__plus_operator] = ACTIONS(2592),
    [sym__dotty_operator] = ACTIONS(2592),
    [sym__comparison_operator] = ACTIONS(2592),
    [sym__arrow_operator] = ACTIONS(2592),
    [anon_sym_LF] = ACTIONS(2594),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2594),
    [sym__string_start] = ACTIONS(2594),
    [sym__command_start] = ACTIONS(2594),
  },
  [1228] = {
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(2801),
    [anon_sym_end] = ACTIONS(2801),
    [anon_sym_abstract] = ACTIONS(2801),
    [anon_sym_primitive] = ACTIONS(2801),
    [aux_sym_primitive_definition_token1] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_module] = ACTIONS(2801),
    [anon_sym_macro] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_EQ] = ACTIONS(2801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_LT_COLON] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [sym_break_statement] = ACTIONS(2801),
    [sym_continue_statement] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_quote] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2801),
    [anon_sym_export] = ACTIONS(2801),
    [anon_sym_COLON2] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_RBRACK] = ACTIONS(2803),
    [anon_sym_begin] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_LT_PIPE] = ACTIONS(2803),
    [anon_sym_PIPE_GT] = ACTIONS(2803),
    [anon_sym_in] = ACTIONS(2801),
    [anon_sym_isa] = ACTIONS(2801),
    [anon_sym_PIPE_PIPE] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_QMARK] = ACTIONS(2803),
    [anon_sym_EQ_GT] = ACTIONS(2803),
    [anon_sym_LBRACK2] = ACTIONS(2801),
    [anon_sym_DOLLAR] = ACTIONS(2801),
    [anon_sym_AT] = ACTIONS(2803),
    [aux_sym_integer_literal_token1] = ACTIONS(2803),
    [aux_sym_integer_literal_token2] = ACTIONS(2803),
    [aux_sym_integer_literal_token3] = ACTIONS(2801),
    [sym_float_literal] = ACTIONS(2801),
    [sym__unary_operator] = ACTIONS(2801),
    [sym__power_operator] = ACTIONS(2801),
    [sym__bitshift_operator] = ACTIONS(2801),
    [sym__rational_operator] = ACTIONS(2801),
    [sym__times_operator] = ACTIONS(2801),
    [sym__plus_operator] = ACTIONS(2801),
    [sym__dotty_operator] = ACTIONS(2801),
    [sym__comparison_operator] = ACTIONS(2801),
    [sym__arrow_operator] = ACTIONS(2803),
    [sym__assign_operator] = ACTIONS(2801),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2803),
    [sym__command_start] = ACTIONS(2803),
  },
  [1229] = {
    [ts_builtin_sym_end] = ACTIONS(2714),
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_primitive] = ACTIONS(2712),
    [aux_sym_primitive_definition_token1] = ACTIONS(2712),
    [anon_sym_mutable] = ACTIONS(2712),
    [anon_sym_struct] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_macro] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_COMMA] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2712),
    [anon_sym_COLON_COLON] = ACTIONS(2712),
    [anon_sym_LT_COLON] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [sym_break_statement] = ACTIONS(2712),
    [sym_continue_statement] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_quote] = ACTIONS(2712),
    [anon_sym_using] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_DOT] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_COLON2] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_begin] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_LT_PIPE] = ACTIONS(2712),
    [anon_sym_PIPE_GT] = ACTIONS(2712),
    [anon_sym_in] = ACTIONS(2712),
    [anon_sym_isa] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_QMARK] = ACTIONS(2712),
    [anon_sym_EQ_GT] = ACTIONS(2712),
    [anon_sym_LBRACK2] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2712),
    [aux_sym_integer_literal_token1] = ACTIONS(2712),
    [aux_sym_integer_literal_token2] = ACTIONS(2712),
    [aux_sym_integer_literal_token3] = ACTIONS(2712),
    [sym_float_literal] = ACTIONS(2712),
    [sym__unary_operator] = ACTIONS(2712),
    [sym__power_operator] = ACTIONS(2712),
    [sym__bitshift_operator] = ACTIONS(2712),
    [sym__rational_operator] = ACTIONS(2712),
    [sym__times_operator] = ACTIONS(2712),
    [sym__plus_operator] = ACTIONS(2712),
    [sym__dotty_operator] = ACTIONS(2712),
    [sym__comparison_operator] = ACTIONS(2712),
    [sym__arrow_operator] = ACTIONS(2712),
    [sym__assign_operator] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2714),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2714),
    [sym__string_start] = ACTIONS(2714),
    [sym__command_start] = ACTIONS(2714),
  },
  [1230] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(3307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elseif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(3307),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1231] = {
    [ts_builtin_sym_end] = ACTIONS(2692),
    [sym_identifier] = ACTIONS(2690),
    [anon_sym_function] = ACTIONS(2690),
    [anon_sym_abstract] = ACTIONS(2690),
    [anon_sym_primitive] = ACTIONS(2690),
    [aux_sym_primitive_definition_token1] = ACTIONS(2690),
    [anon_sym_mutable] = ACTIONS(2690),
    [anon_sym_struct] = ACTIONS(2690),
    [anon_sym_module] = ACTIONS(2690),
    [anon_sym_macro] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_COMMA] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_EQ] = ACTIONS(2690),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2690),
    [anon_sym_COLON_COLON] = ACTIONS(2690),
    [anon_sym_LT_COLON] = ACTIONS(2690),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_try] = ACTIONS(2690),
    [anon_sym_for] = ACTIONS(2690),
    [anon_sym_while] = ACTIONS(2690),
    [sym_break_statement] = ACTIONS(2690),
    [sym_continue_statement] = ACTIONS(2690),
    [anon_sym_return] = ACTIONS(2690),
    [anon_sym_let] = ACTIONS(2690),
    [anon_sym_const] = ACTIONS(2690),
    [anon_sym_quote] = ACTIONS(2690),
    [anon_sym_using] = ACTIONS(2690),
    [anon_sym_import] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(2690),
    [anon_sym_export] = ACTIONS(2690),
    [anon_sym_COLON2] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2692),
    [anon_sym_begin] = ACTIONS(2690),
    [anon_sym_SQUOTE] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2690),
    [anon_sym_LT_PIPE] = ACTIONS(2690),
    [anon_sym_PIPE_GT] = ACTIONS(2690),
    [anon_sym_in] = ACTIONS(2690),
    [anon_sym_isa] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_QMARK] = ACTIONS(2690),
    [anon_sym_EQ_GT] = ACTIONS(2690),
    [anon_sym_LBRACK2] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2690),
    [aux_sym_integer_literal_token1] = ACTIONS(2690),
    [aux_sym_integer_literal_token2] = ACTIONS(2690),
    [aux_sym_integer_literal_token3] = ACTIONS(2690),
    [sym_float_literal] = ACTIONS(2690),
    [sym__unary_operator] = ACTIONS(2690),
    [sym__power_operator] = ACTIONS(2690),
    [sym__bitshift_operator] = ACTIONS(2690),
    [sym__rational_operator] = ACTIONS(2690),
    [sym__times_operator] = ACTIONS(2690),
    [sym__plus_operator] = ACTIONS(2690),
    [sym__dotty_operator] = ACTIONS(2690),
    [sym__comparison_operator] = ACTIONS(2690),
    [sym__arrow_operator] = ACTIONS(2690),
    [sym__assign_operator] = ACTIONS(2690),
    [anon_sym_LF] = ACTIONS(2692),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2692),
    [sym__string_start] = ACTIONS(2692),
    [sym__command_start] = ACTIONS(2692),
  },
  [1232] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1222),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_end] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_primitive] = ACTIONS(2900),
    [aux_sym_primitive_definition_token1] = ACTIONS(2900),
    [anon_sym_mutable] = ACTIONS(2900),
    [anon_sym_struct] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_macro] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(3299),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [sym_break_statement] = ACTIONS(2900),
    [sym_continue_statement] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_quote] = ACTIONS(2900),
    [anon_sym_using] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_begin] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(2902),
    [anon_sym_DOLLAR] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2902),
    [aux_sym_integer_literal_token1] = ACTIONS(2902),
    [aux_sym_integer_literal_token2] = ACTIONS(2902),
    [aux_sym_integer_literal_token3] = ACTIONS(2900),
    [sym_float_literal] = ACTIONS(2900),
    [sym__unary_operator] = ACTIONS(2900),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2900),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2902),
    [sym__command_start] = ACTIONS(2902),
  },
  [1233] = {
    [aux_sym_import_statement_repeat1] = STATE(1511),
    [ts_builtin_sym_end] = ACTIONS(2656),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2648),
    [anon_sym_LT_COLON] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_COLON] = ACTIONS(3311),
    [anon_sym_DOT] = ACTIONS(3313),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_GT] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_EQ_GT] = ACTIONS(2648),
    [anon_sym_LBRACK2] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2648),
    [aux_sym_integer_literal_token1] = ACTIONS(2648),
    [aux_sym_integer_literal_token2] = ACTIONS(2648),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2648),
    [sym__assign_operator] = ACTIONS(2648),
    [anon_sym_LF] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1234] = {
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_end] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_primitive] = ACTIONS(2600),
    [aux_sym_primitive_definition_token1] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_macro] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(2602),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2602),
    [anon_sym_COLON_COLON] = ACTIONS(2602),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_LT_COLON] = ACTIONS(2602),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [sym_break_statement] = ACTIONS(2600),
    [sym_continue_statement] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_quote] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_COLON2] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_RBRACK] = ACTIONS(2602),
    [anon_sym_begin] = ACTIONS(2600),
    [anon_sym_SQUOTE] = ACTIONS(2602),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_LT_PIPE] = ACTIONS(2602),
    [anon_sym_PIPE_GT] = ACTIONS(2602),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_isa] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2602),
    [anon_sym_AMP_AMP] = ACTIONS(2602),
    [anon_sym_QMARK] = ACTIONS(2602),
    [anon_sym_EQ_GT] = ACTIONS(2602),
    [anon_sym_LBRACK2] = ACTIONS(2600),
    [anon_sym_DOLLAR] = ACTIONS(2602),
    [anon_sym_AT] = ACTIONS(2602),
    [aux_sym_integer_literal_token1] = ACTIONS(2602),
    [aux_sym_integer_literal_token2] = ACTIONS(2602),
    [aux_sym_integer_literal_token3] = ACTIONS(2600),
    [sym_float_literal] = ACTIONS(2600),
    [sym__unary_operator] = ACTIONS(2600),
    [sym__power_operator] = ACTIONS(2602),
    [sym__bitshift_operator] = ACTIONS(2602),
    [sym__rational_operator] = ACTIONS(2602),
    [sym__times_operator] = ACTIONS(2600),
    [sym__plus_operator] = ACTIONS(2600),
    [sym__dotty_operator] = ACTIONS(2600),
    [sym__comparison_operator] = ACTIONS(2600),
    [sym__arrow_operator] = ACTIONS(2602),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2602),
    [sym__string_start] = ACTIONS(2602),
    [sym__command_start] = ACTIONS(2602),
  },
  [1235] = {
    [aux_sym_let_statement_repeat1] = STATE(1266),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_abstract] = ACTIONS(2885),
    [anon_sym_primitive] = ACTIONS(2885),
    [aux_sym_primitive_definition_token1] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_macro] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(3315),
    [anon_sym_RPAREN] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_LT_COLON] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym_break_statement] = ACTIONS(2885),
    [sym_continue_statement] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_quote] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2885),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [anon_sym_begin] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_LT_PIPE] = ACTIONS(2887),
    [anon_sym_PIPE_GT] = ACTIONS(2887),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_EQ_GT] = ACTIONS(2887),
    [anon_sym_LBRACK2] = ACTIONS(2887),
    [anon_sym_DOLLAR] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2887),
    [aux_sym_integer_literal_token1] = ACTIONS(2887),
    [aux_sym_integer_literal_token2] = ACTIONS(2887),
    [aux_sym_integer_literal_token3] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym__unary_operator] = ACTIONS(2885),
    [sym__power_operator] = ACTIONS(2885),
    [sym__bitshift_operator] = ACTIONS(2885),
    [sym__rational_operator] = ACTIONS(2885),
    [sym__times_operator] = ACTIONS(2885),
    [sym__plus_operator] = ACTIONS(2885),
    [sym__dotty_operator] = ACTIONS(2885),
    [sym__comparison_operator] = ACTIONS(2885),
    [sym__arrow_operator] = ACTIONS(2887),
    [sym__assign_operator] = ACTIONS(2885),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2887),
    [sym__command_start] = ACTIONS(2887),
  },
  [1236] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1222),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(3297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2883),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2883),
    [aux_sym_integer_literal_token1] = ACTIONS(2883),
    [aux_sym_integer_literal_token2] = ACTIONS(2883),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(3297),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1237] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_COMMA] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_LT_COLON] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_DOT] = ACTIONS(3317),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_RBRACK] = ACTIONS(2708),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_GT] = ACTIONS(2708),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2708),
    [anon_sym_AMP_AMP] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2708),
    [anon_sym_EQ_GT] = ACTIONS(2708),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_AT] = ACTIONS(2708),
    [aux_sym_integer_literal_token1] = ACTIONS(2708),
    [aux_sym_integer_literal_token2] = ACTIONS(2708),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2708),
    [sym__bitshift_operator] = ACTIONS(2708),
    [sym__rational_operator] = ACTIONS(2708),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3321),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1238] = {
    [aux_sym_import_statement_repeat1] = STATE(1274),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(3197),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_LT_COLON] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2656),
    [anon_sym_PIPE_GT] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_LBRACK2] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2656),
    [aux_sym_integer_literal_token1] = ACTIONS(2656),
    [aux_sym_integer_literal_token2] = ACTIONS(2656),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2656),
    [sym__assign_operator] = ACTIONS(2648),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1239] = {
    [sym_identifier] = ACTIONS(2712),
    [anon_sym_function] = ACTIONS(2712),
    [anon_sym_end] = ACTIONS(2712),
    [anon_sym_abstract] = ACTIONS(2712),
    [anon_sym_primitive] = ACTIONS(2712),
    [aux_sym_primitive_definition_token1] = ACTIONS(2712),
    [anon_sym_mutable] = ACTIONS(2712),
    [anon_sym_struct] = ACTIONS(2712),
    [anon_sym_module] = ACTIONS(2712),
    [anon_sym_macro] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_COMMA] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2712),
    [anon_sym_COLON_COLON] = ACTIONS(2712),
    [anon_sym_LT_COLON] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2712),
    [anon_sym_elseif] = ACTIONS(2712),
    [anon_sym_else] = ACTIONS(2712),
    [anon_sym_try] = ACTIONS(2712),
    [anon_sym_for] = ACTIONS(2712),
    [anon_sym_while] = ACTIONS(2712),
    [sym_break_statement] = ACTIONS(2712),
    [sym_continue_statement] = ACTIONS(2712),
    [anon_sym_return] = ACTIONS(2712),
    [anon_sym_let] = ACTIONS(2712),
    [anon_sym_const] = ACTIONS(2712),
    [anon_sym_quote] = ACTIONS(2712),
    [anon_sym_using] = ACTIONS(2712),
    [anon_sym_import] = ACTIONS(2712),
    [anon_sym_DOT] = ACTIONS(2712),
    [anon_sym_export] = ACTIONS(2712),
    [anon_sym_COLON2] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_begin] = ACTIONS(2712),
    [anon_sym_SQUOTE] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2712),
    [anon_sym_LT_PIPE] = ACTIONS(2712),
    [anon_sym_PIPE_GT] = ACTIONS(2712),
    [anon_sym_in] = ACTIONS(2712),
    [anon_sym_isa] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_QMARK] = ACTIONS(2712),
    [anon_sym_EQ_GT] = ACTIONS(2712),
    [anon_sym_LBRACK2] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2712),
    [aux_sym_integer_literal_token1] = ACTIONS(2712),
    [aux_sym_integer_literal_token2] = ACTIONS(2712),
    [aux_sym_integer_literal_token3] = ACTIONS(2712),
    [sym_float_literal] = ACTIONS(2712),
    [sym__unary_operator] = ACTIONS(2712),
    [sym__power_operator] = ACTIONS(2712),
    [sym__bitshift_operator] = ACTIONS(2712),
    [sym__rational_operator] = ACTIONS(2712),
    [sym__times_operator] = ACTIONS(2712),
    [sym__plus_operator] = ACTIONS(2712),
    [sym__dotty_operator] = ACTIONS(2712),
    [sym__comparison_operator] = ACTIONS(2712),
    [sym__arrow_operator] = ACTIONS(2712),
    [anon_sym_LF] = ACTIONS(2714),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2714),
    [sym__string_start] = ACTIONS(2714),
    [sym__command_start] = ACTIONS(2714),
  },
  [1240] = {
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2762),
    [anon_sym_end] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_primitive] = ACTIONS(2762),
    [aux_sym_primitive_definition_token1] = ACTIONS(2762),
    [anon_sym_mutable] = ACTIONS(2762),
    [anon_sym_struct] = ACTIONS(2762),
    [anon_sym_module] = ACTIONS(2762),
    [anon_sym_macro] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_COMMA] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2764),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2764),
    [anon_sym_COLON_COLON] = ACTIONS(2764),
    [anon_sym_RBRACE] = ACTIONS(2764),
    [anon_sym_LT_COLON] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2762),
    [anon_sym_try] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2762),
    [anon_sym_while] = ACTIONS(2762),
    [sym_break_statement] = ACTIONS(2762),
    [sym_continue_statement] = ACTIONS(2762),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2762),
    [anon_sym_quote] = ACTIONS(2762),
    [anon_sym_using] = ACTIONS(2762),
    [anon_sym_import] = ACTIONS(2762),
    [anon_sym_export] = ACTIONS(2762),
    [anon_sym_COLON2] = ACTIONS(2762),
    [anon_sym_RBRACK] = ACTIONS(2764),
    [anon_sym_begin] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_LT_PIPE] = ACTIONS(2764),
    [anon_sym_PIPE_GT] = ACTIONS(2764),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_isa] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2764),
    [anon_sym_AMP_AMP] = ACTIONS(2764),
    [anon_sym_QMARK] = ACTIONS(2764),
    [anon_sym_EQ_GT] = ACTIONS(2764),
    [anon_sym_LBRACK2] = ACTIONS(2764),
    [anon_sym_DOLLAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2764),
    [aux_sym_integer_literal_token1] = ACTIONS(2764),
    [aux_sym_integer_literal_token2] = ACTIONS(2764),
    [aux_sym_integer_literal_token3] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
    [sym__unary_operator] = ACTIONS(2762),
    [sym__power_operator] = ACTIONS(2762),
    [sym__bitshift_operator] = ACTIONS(2762),
    [sym__rational_operator] = ACTIONS(2762),
    [sym__times_operator] = ACTIONS(2762),
    [sym__plus_operator] = ACTIONS(2762),
    [sym__dotty_operator] = ACTIONS(2762),
    [sym__comparison_operator] = ACTIONS(2762),
    [sym__arrow_operator] = ACTIONS(2764),
    [sym__assign_operator] = ACTIONS(2762),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2764),
    [sym__string_start] = ACTIONS(2764),
    [sym__command_start] = ACTIONS(2764),
  },
  [1241] = {
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_primitive] = ACTIONS(2912),
    [aux_sym_primitive_definition_token1] = ACTIONS(2912),
    [anon_sym_mutable] = ACTIONS(2912),
    [anon_sym_struct] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_macro] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2914),
    [anon_sym_SEMI] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_LT_COLON] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [sym_break_statement] = ACTIONS(2912),
    [sym_continue_statement] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_quote] = ACTIONS(2912),
    [anon_sym_using] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_COLON2] = ACTIONS(2912),
    [anon_sym_RBRACK] = ACTIONS(2914),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_LT_PIPE] = ACTIONS(2914),
    [anon_sym_PIPE_GT] = ACTIONS(2914),
    [anon_sym_in] = ACTIONS(2912),
    [anon_sym_isa] = ACTIONS(2912),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_EQ_GT] = ACTIONS(2914),
    [anon_sym_LBRACK2] = ACTIONS(2914),
    [anon_sym_DOLLAR] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2914),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2912),
    [sym_float_literal] = ACTIONS(2912),
    [sym__unary_operator] = ACTIONS(2912),
    [sym__power_operator] = ACTIONS(2912),
    [sym__bitshift_operator] = ACTIONS(2912),
    [sym__rational_operator] = ACTIONS(2912),
    [sym__times_operator] = ACTIONS(2912),
    [sym__plus_operator] = ACTIONS(2912),
    [sym__dotty_operator] = ACTIONS(2912),
    [sym__comparison_operator] = ACTIONS(2912),
    [sym__arrow_operator] = ACTIONS(2914),
    [sym__assign_operator] = ACTIONS(2912),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2914),
    [sym__string_start] = ACTIONS(2914),
    [sym__command_start] = ACTIONS(2914),
  },
  [1242] = {
    [aux_sym_export_statement_repeat1] = STATE(1282),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_end] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_primitive] = ACTIONS(2833),
    [aux_sym_primitive_definition_token1] = ACTIONS(2833),
    [anon_sym_mutable] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_macro] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(3323),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_LT_COLON] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [sym_break_statement] = ACTIONS(2833),
    [sym_continue_statement] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_quote] = ACTIONS(2833),
    [anon_sym_using] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_COLON2] = ACTIONS(2833),
    [anon_sym_RBRACK] = ACTIONS(2835),
    [anon_sym_begin] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_LT_PIPE] = ACTIONS(2835),
    [anon_sym_PIPE_GT] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_isa] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2835),
    [anon_sym_LBRACK2] = ACTIONS(2835),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [anon_sym_AT] = ACTIONS(2835),
    [aux_sym_integer_literal_token1] = ACTIONS(2835),
    [aux_sym_integer_literal_token2] = ACTIONS(2835),
    [aux_sym_integer_literal_token3] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym__unary_operator] = ACTIONS(2833),
    [sym__power_operator] = ACTIONS(2833),
    [sym__bitshift_operator] = ACTIONS(2833),
    [sym__rational_operator] = ACTIONS(2833),
    [sym__times_operator] = ACTIONS(2833),
    [sym__plus_operator] = ACTIONS(2833),
    [sym__dotty_operator] = ACTIONS(2833),
    [sym__comparison_operator] = ACTIONS(2833),
    [sym__arrow_operator] = ACTIONS(2835),
    [sym__assign_operator] = ACTIONS(2833),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2835),
    [sym__command_start] = ACTIONS(2835),
  },
  [1243] = {
    [ts_builtin_sym_end] = ACTIONS(2708),
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_DOT] = ACTIONS(3325),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [sym__assign_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3329),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1244] = {
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_end] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_primitive] = ACTIONS(2666),
    [aux_sym_primitive_definition_token1] = ACTIONS(2666),
    [anon_sym_mutable] = ACTIONS(2666),
    [anon_sym_struct] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_macro] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2666),
    [anon_sym_COMMA] = ACTIONS(2666),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2666),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_LT_COLON] = ACTIONS(2666),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_elseif] = ACTIONS(2666),
    [anon_sym_else] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [sym_break_statement] = ACTIONS(2666),
    [sym_continue_statement] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_quote] = ACTIONS(2666),
    [anon_sym_using] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_DOT] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_COLON2] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_begin] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_LT_PIPE] = ACTIONS(2666),
    [anon_sym_PIPE_GT] = ACTIONS(2666),
    [anon_sym_in] = ACTIONS(2666),
    [anon_sym_isa] = ACTIONS(2666),
    [anon_sym_PIPE_PIPE] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2666),
    [anon_sym_QMARK] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(2666),
    [anon_sym_LBRACK2] = ACTIONS(2666),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [anon_sym_AT] = ACTIONS(2666),
    [aux_sym_integer_literal_token1] = ACTIONS(2666),
    [aux_sym_integer_literal_token2] = ACTIONS(2666),
    [aux_sym_integer_literal_token3] = ACTIONS(2666),
    [sym_float_literal] = ACTIONS(2666),
    [sym__unary_operator] = ACTIONS(2666),
    [sym__power_operator] = ACTIONS(2666),
    [sym__bitshift_operator] = ACTIONS(2666),
    [sym__rational_operator] = ACTIONS(2666),
    [sym__times_operator] = ACTIONS(2666),
    [sym__plus_operator] = ACTIONS(2666),
    [sym__dotty_operator] = ACTIONS(2666),
    [sym__comparison_operator] = ACTIONS(2666),
    [sym__arrow_operator] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2668),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2668),
    [sym__string_start] = ACTIONS(2668),
    [sym__command_start] = ACTIONS(2668),
  },
  [1245] = {
    [aux_sym_selected_import_repeat1] = STATE(1212),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_end] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_primitive] = ACTIONS(2908),
    [aux_sym_primitive_definition_token1] = ACTIONS(2908),
    [anon_sym_mutable] = ACTIONS(2908),
    [anon_sym_struct] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_macro] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(3331),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_LT_COLON] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [sym_break_statement] = ACTIONS(2908),
    [sym_continue_statement] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_quote] = ACTIONS(2908),
    [anon_sym_using] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_COLON2] = ACTIONS(2908),
    [anon_sym_RBRACK] = ACTIONS(2910),
    [anon_sym_begin] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_LT_PIPE] = ACTIONS(2910),
    [anon_sym_PIPE_GT] = ACTIONS(2910),
    [anon_sym_in] = ACTIONS(2908),
    [anon_sym_isa] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_EQ_GT] = ACTIONS(2910),
    [anon_sym_LBRACK2] = ACTIONS(2910),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2910),
    [aux_sym_integer_literal_token1] = ACTIONS(2910),
    [aux_sym_integer_literal_token2] = ACTIONS(2910),
    [aux_sym_integer_literal_token3] = ACTIONS(2908),
    [sym_float_literal] = ACTIONS(2908),
    [sym__unary_operator] = ACTIONS(2908),
    [sym__power_operator] = ACTIONS(2908),
    [sym__bitshift_operator] = ACTIONS(2908),
    [sym__rational_operator] = ACTIONS(2908),
    [sym__times_operator] = ACTIONS(2908),
    [sym__plus_operator] = ACTIONS(2908),
    [sym__dotty_operator] = ACTIONS(2908),
    [sym__comparison_operator] = ACTIONS(2908),
    [sym__arrow_operator] = ACTIONS(2910),
    [sym__assign_operator] = ACTIONS(2908),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2910),
    [sym__command_start] = ACTIONS(2910),
  },
  [1246] = {
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(2662),
    [anon_sym_end] = ACTIONS(2662),
    [anon_sym_abstract] = ACTIONS(2662),
    [anon_sym_primitive] = ACTIONS(2662),
    [aux_sym_primitive_definition_token1] = ACTIONS(2662),
    [anon_sym_mutable] = ACTIONS(2662),
    [anon_sym_struct] = ACTIONS(2662),
    [anon_sym_module] = ACTIONS(2662),
    [anon_sym_macro] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2662),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LT_COLON] = ACTIONS(2662),
    [anon_sym_if] = ACTIONS(2662),
    [anon_sym_elseif] = ACTIONS(2662),
    [anon_sym_else] = ACTIONS(2662),
    [anon_sym_try] = ACTIONS(2662),
    [anon_sym_for] = ACTIONS(2662),
    [anon_sym_while] = ACTIONS(2662),
    [sym_break_statement] = ACTIONS(2662),
    [sym_continue_statement] = ACTIONS(2662),
    [anon_sym_return] = ACTIONS(2662),
    [anon_sym_let] = ACTIONS(2662),
    [anon_sym_const] = ACTIONS(2662),
    [anon_sym_quote] = ACTIONS(2662),
    [anon_sym_using] = ACTIONS(2662),
    [anon_sym_import] = ACTIONS(2662),
    [anon_sym_DOT] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_COLON2] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_begin] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [anon_sym_PLUS] = ACTIONS(2662),
    [anon_sym_LT_PIPE] = ACTIONS(2662),
    [anon_sym_PIPE_GT] = ACTIONS(2662),
    [anon_sym_in] = ACTIONS(2662),
    [anon_sym_isa] = ACTIONS(2662),
    [anon_sym_PIPE_PIPE] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_QMARK] = ACTIONS(2662),
    [anon_sym_EQ_GT] = ACTIONS(2662),
    [anon_sym_LBRACK2] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(2662),
    [aux_sym_integer_literal_token1] = ACTIONS(2662),
    [aux_sym_integer_literal_token2] = ACTIONS(2662),
    [aux_sym_integer_literal_token3] = ACTIONS(2662),
    [sym_float_literal] = ACTIONS(2662),
    [sym__unary_operator] = ACTIONS(2662),
    [sym__power_operator] = ACTIONS(2662),
    [sym__bitshift_operator] = ACTIONS(2662),
    [sym__rational_operator] = ACTIONS(2662),
    [sym__times_operator] = ACTIONS(2662),
    [sym__plus_operator] = ACTIONS(2662),
    [sym__dotty_operator] = ACTIONS(2662),
    [sym__comparison_operator] = ACTIONS(2662),
    [sym__arrow_operator] = ACTIONS(2662),
    [anon_sym_LF] = ACTIONS(2664),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2664),
    [sym__string_start] = ACTIONS(2664),
    [sym__command_start] = ACTIONS(2664),
  },
  [1247] = {
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(2658),
    [anon_sym_end] = ACTIONS(2658),
    [anon_sym_abstract] = ACTIONS(2658),
    [anon_sym_primitive] = ACTIONS(2658),
    [aux_sym_primitive_definition_token1] = ACTIONS(2658),
    [anon_sym_mutable] = ACTIONS(2658),
    [anon_sym_struct] = ACTIONS(2658),
    [anon_sym_module] = ACTIONS(2658),
    [anon_sym_macro] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_COMMA] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2658),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LT_COLON] = ACTIONS(2658),
    [anon_sym_if] = ACTIONS(2658),
    [anon_sym_elseif] = ACTIONS(2658),
    [anon_sym_else] = ACTIONS(2658),
    [anon_sym_try] = ACTIONS(2658),
    [anon_sym_for] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [sym_break_statement] = ACTIONS(2658),
    [sym_continue_statement] = ACTIONS(2658),
    [anon_sym_return] = ACTIONS(2658),
    [anon_sym_let] = ACTIONS(2658),
    [anon_sym_const] = ACTIONS(2658),
    [anon_sym_quote] = ACTIONS(2658),
    [anon_sym_using] = ACTIONS(2658),
    [anon_sym_import] = ACTIONS(2658),
    [anon_sym_DOT] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2658),
    [anon_sym_COLON2] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_begin] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_LT_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE_GT] = ACTIONS(2658),
    [anon_sym_in] = ACTIONS(2658),
    [anon_sym_isa] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2658),
    [anon_sym_EQ_GT] = ACTIONS(2658),
    [anon_sym_LBRACK2] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2658),
    [aux_sym_integer_literal_token1] = ACTIONS(2658),
    [aux_sym_integer_literal_token2] = ACTIONS(2658),
    [aux_sym_integer_literal_token3] = ACTIONS(2658),
    [sym_float_literal] = ACTIONS(2658),
    [sym__unary_operator] = ACTIONS(2658),
    [sym__power_operator] = ACTIONS(2658),
    [sym__bitshift_operator] = ACTIONS(2658),
    [sym__rational_operator] = ACTIONS(2658),
    [sym__times_operator] = ACTIONS(2658),
    [sym__plus_operator] = ACTIONS(2658),
    [sym__dotty_operator] = ACTIONS(2658),
    [sym__comparison_operator] = ACTIONS(2658),
    [sym__arrow_operator] = ACTIONS(2658),
    [anon_sym_LF] = ACTIONS(2660),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2660),
    [sym__string_start] = ACTIONS(2660),
    [sym__command_start] = ACTIONS(2660),
  },
  [1248] = {
    [ts_builtin_sym_end] = ACTIONS(2722),
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_primitive] = ACTIONS(2720),
    [aux_sym_primitive_definition_token1] = ACTIONS(2720),
    [anon_sym_mutable] = ACTIONS(2720),
    [anon_sym_struct] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_macro] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2720),
    [anon_sym_COMMA] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_EQ] = ACTIONS(2720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2720),
    [anon_sym_COLON_COLON] = ACTIONS(2720),
    [anon_sym_LT_COLON] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [sym_break_statement] = ACTIONS(2720),
    [sym_continue_statement] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_quote] = ACTIONS(2720),
    [anon_sym_using] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_DOT] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_COLON2] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_begin] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_LT_PIPE] = ACTIONS(2720),
    [anon_sym_PIPE_GT] = ACTIONS(2720),
    [anon_sym_in] = ACTIONS(2720),
    [anon_sym_isa] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(2720),
    [anon_sym_AMP_AMP] = ACTIONS(2720),
    [anon_sym_QMARK] = ACTIONS(2720),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_LBRACK2] = ACTIONS(2720),
    [anon_sym_DOLLAR] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2720),
    [aux_sym_integer_literal_token1] = ACTIONS(2720),
    [aux_sym_integer_literal_token2] = ACTIONS(2720),
    [aux_sym_integer_literal_token3] = ACTIONS(2720),
    [sym_float_literal] = ACTIONS(2720),
    [sym__unary_operator] = ACTIONS(2720),
    [sym__power_operator] = ACTIONS(2720),
    [sym__bitshift_operator] = ACTIONS(2720),
    [sym__rational_operator] = ACTIONS(2720),
    [sym__times_operator] = ACTIONS(2720),
    [sym__plus_operator] = ACTIONS(2720),
    [sym__dotty_operator] = ACTIONS(2720),
    [sym__comparison_operator] = ACTIONS(2720),
    [sym__arrow_operator] = ACTIONS(2720),
    [sym__assign_operator] = ACTIONS(2720),
    [anon_sym_LF] = ACTIONS(2722),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2722),
    [sym__string_start] = ACTIONS(2722),
    [sym__command_start] = ACTIONS(2722),
  },
  [1249] = {
    [sym_identifier] = ACTIONS(2464),
    [anon_sym_function] = ACTIONS(2464),
    [anon_sym_end] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2464),
    [anon_sym_primitive] = ACTIONS(2464),
    [aux_sym_primitive_definition_token1] = ACTIONS(2464),
    [anon_sym_mutable] = ACTIONS(2464),
    [anon_sym_struct] = ACTIONS(2464),
    [anon_sym_module] = ACTIONS(2464),
    [anon_sym_macro] = ACTIONS(2464),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_COMMA] = ACTIONS(2464),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2464),
    [anon_sym_COLON_COLON] = ACTIONS(2464),
    [anon_sym_LT_COLON] = ACTIONS(2464),
    [anon_sym_if] = ACTIONS(2464),
    [anon_sym_elseif] = ACTIONS(2464),
    [anon_sym_else] = ACTIONS(2464),
    [anon_sym_try] = ACTIONS(2464),
    [anon_sym_for] = ACTIONS(2464),
    [anon_sym_while] = ACTIONS(2464),
    [sym_break_statement] = ACTIONS(2464),
    [sym_continue_statement] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2464),
    [anon_sym_let] = ACTIONS(2464),
    [anon_sym_const] = ACTIONS(2464),
    [anon_sym_quote] = ACTIONS(2464),
    [anon_sym_using] = ACTIONS(2464),
    [anon_sym_import] = ACTIONS(2464),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym_export] = ACTIONS(2464),
    [anon_sym_COLON2] = ACTIONS(2464),
    [anon_sym_LBRACK] = ACTIONS(97),
    [anon_sym_begin] = ACTIONS(2464),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [anon_sym_PLUS] = ACTIONS(2464),
    [anon_sym_LT_PIPE] = ACTIONS(2464),
    [anon_sym_PIPE_GT] = ACTIONS(2464),
    [anon_sym_in] = ACTIONS(2464),
    [anon_sym_isa] = ACTIONS(2464),
    [anon_sym_PIPE_PIPE] = ACTIONS(2464),
    [anon_sym_AMP_AMP] = ACTIONS(2464),
    [anon_sym_QMARK] = ACTIONS(2464),
    [anon_sym_EQ_GT] = ACTIONS(2464),
    [anon_sym_LBRACK2] = ACTIONS(2464),
    [anon_sym_DOLLAR] = ACTIONS(2464),
    [anon_sym_AT] = ACTIONS(2464),
    [aux_sym_integer_literal_token1] = ACTIONS(2464),
    [aux_sym_integer_literal_token2] = ACTIONS(2464),
    [aux_sym_integer_literal_token3] = ACTIONS(2464),
    [sym_float_literal] = ACTIONS(2464),
    [sym__unary_operator] = ACTIONS(2464),
    [sym__power_operator] = ACTIONS(2464),
    [sym__bitshift_operator] = ACTIONS(2464),
    [sym__rational_operator] = ACTIONS(2464),
    [sym__times_operator] = ACTIONS(2464),
    [sym__plus_operator] = ACTIONS(2464),
    [sym__dotty_operator] = ACTIONS(2464),
    [sym__comparison_operator] = ACTIONS(2464),
    [sym__arrow_operator] = ACTIONS(2464),
    [anon_sym_LF] = ACTIONS(2466),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(97),
    [sym__string_start] = ACTIONS(2466),
    [sym__command_start] = ACTIONS(2466),
  },
  [1250] = {
    [ts_builtin_sym_end] = ACTIONS(2718),
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_primitive] = ACTIONS(2716),
    [aux_sym_primitive_definition_token1] = ACTIONS(2716),
    [anon_sym_mutable] = ACTIONS(2716),
    [anon_sym_struct] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_macro] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2716),
    [anon_sym_EQ] = ACTIONS(2716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2716),
    [anon_sym_COLON_COLON] = ACTIONS(2716),
    [anon_sym_LT_COLON] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [sym_break_statement] = ACTIONS(2716),
    [sym_continue_statement] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_quote] = ACTIONS(2716),
    [anon_sym_using] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_DOT] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_COLON2] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_begin] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_LT_PIPE] = ACTIONS(2716),
    [anon_sym_PIPE_GT] = ACTIONS(2716),
    [anon_sym_in] = ACTIONS(2716),
    [anon_sym_isa] = ACTIONS(2716),
    [anon_sym_PIPE_PIPE] = ACTIONS(2716),
    [anon_sym_AMP_AMP] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2716),
    [anon_sym_EQ_GT] = ACTIONS(2716),
    [anon_sym_LBRACK2] = ACTIONS(2716),
    [anon_sym_DOLLAR] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2716),
    [aux_sym_integer_literal_token1] = ACTIONS(2716),
    [aux_sym_integer_literal_token2] = ACTIONS(2716),
    [aux_sym_integer_literal_token3] = ACTIONS(2716),
    [sym_float_literal] = ACTIONS(2716),
    [sym__unary_operator] = ACTIONS(2716),
    [sym__power_operator] = ACTIONS(2716),
    [sym__bitshift_operator] = ACTIONS(2716),
    [sym__rational_operator] = ACTIONS(2716),
    [sym__times_operator] = ACTIONS(2716),
    [sym__plus_operator] = ACTIONS(2716),
    [sym__dotty_operator] = ACTIONS(2716),
    [sym__comparison_operator] = ACTIONS(2716),
    [sym__arrow_operator] = ACTIONS(2716),
    [sym__assign_operator] = ACTIONS(2716),
    [anon_sym_LF] = ACTIONS(2718),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2718),
    [sym__string_start] = ACTIONS(2718),
    [sym__command_start] = ACTIONS(2718),
  },
  [1251] = {
    [sym_identifier] = ACTIONS(2636),
    [anon_sym_function] = ACTIONS(2636),
    [anon_sym_end] = ACTIONS(2636),
    [anon_sym_abstract] = ACTIONS(2636),
    [anon_sym_primitive] = ACTIONS(2636),
    [aux_sym_primitive_definition_token1] = ACTIONS(2636),
    [anon_sym_mutable] = ACTIONS(2636),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_module] = ACTIONS(2636),
    [anon_sym_macro] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_COMMA] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2636),
    [anon_sym_COLON_COLON] = ACTIONS(2636),
    [anon_sym_LT_COLON] = ACTIONS(2636),
    [anon_sym_if] = ACTIONS(2636),
    [anon_sym_elseif] = ACTIONS(2636),
    [anon_sym_else] = ACTIONS(2636),
    [anon_sym_try] = ACTIONS(2636),
    [anon_sym_for] = ACTIONS(2636),
    [anon_sym_while] = ACTIONS(2636),
    [sym_break_statement] = ACTIONS(2636),
    [sym_continue_statement] = ACTIONS(2636),
    [anon_sym_return] = ACTIONS(2636),
    [anon_sym_let] = ACTIONS(2636),
    [anon_sym_const] = ACTIONS(2636),
    [anon_sym_quote] = ACTIONS(2636),
    [anon_sym_using] = ACTIONS(2636),
    [anon_sym_import] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_export] = ACTIONS(2636),
    [anon_sym_COLON2] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2638),
    [anon_sym_begin] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2636),
    [anon_sym_LT_PIPE] = ACTIONS(2636),
    [anon_sym_PIPE_GT] = ACTIONS(2636),
    [anon_sym_in] = ACTIONS(2636),
    [anon_sym_isa] = ACTIONS(2636),
    [anon_sym_PIPE_PIPE] = ACTIONS(2636),
    [anon_sym_AMP_AMP] = ACTIONS(2636),
    [anon_sym_QMARK] = ACTIONS(2636),
    [anon_sym_EQ_GT] = ACTIONS(2636),
    [anon_sym_LBRACK2] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2636),
    [aux_sym_integer_literal_token1] = ACTIONS(2636),
    [aux_sym_integer_literal_token2] = ACTIONS(2636),
    [aux_sym_integer_literal_token3] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__unary_operator] = ACTIONS(2636),
    [sym__power_operator] = ACTIONS(2636),
    [sym__bitshift_operator] = ACTIONS(2636),
    [sym__rational_operator] = ACTIONS(2636),
    [sym__times_operator] = ACTIONS(2636),
    [sym__plus_operator] = ACTIONS(2636),
    [sym__dotty_operator] = ACTIONS(2636),
    [sym__comparison_operator] = ACTIONS(2636),
    [sym__arrow_operator] = ACTIONS(2636),
    [anon_sym_LF] = ACTIONS(2638),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2638),
    [sym__string_start] = ACTIONS(2638),
    [sym__command_start] = ACTIONS(2638),
  },
  [1252] = {
    [sym_identifier] = ACTIONS(2632),
    [anon_sym_function] = ACTIONS(2632),
    [anon_sym_end] = ACTIONS(2632),
    [anon_sym_abstract] = ACTIONS(2632),
    [anon_sym_primitive] = ACTIONS(2632),
    [aux_sym_primitive_definition_token1] = ACTIONS(2632),
    [anon_sym_mutable] = ACTIONS(2632),
    [anon_sym_struct] = ACTIONS(2632),
    [anon_sym_module] = ACTIONS(2632),
    [anon_sym_macro] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_COMMA] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2632),
    [anon_sym_COLON_COLON] = ACTIONS(2632),
    [anon_sym_LT_COLON] = ACTIONS(2632),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_elseif] = ACTIONS(2632),
    [anon_sym_else] = ACTIONS(2632),
    [anon_sym_try] = ACTIONS(2632),
    [anon_sym_for] = ACTIONS(2632),
    [anon_sym_while] = ACTIONS(2632),
    [sym_break_statement] = ACTIONS(2632),
    [sym_continue_statement] = ACTIONS(2632),
    [anon_sym_return] = ACTIONS(2632),
    [anon_sym_let] = ACTIONS(2632),
    [anon_sym_const] = ACTIONS(2632),
    [anon_sym_quote] = ACTIONS(2632),
    [anon_sym_using] = ACTIONS(2632),
    [anon_sym_import] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_export] = ACTIONS(2632),
    [anon_sym_COLON2] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2634),
    [anon_sym_begin] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2632),
    [anon_sym_LT_PIPE] = ACTIONS(2632),
    [anon_sym_PIPE_GT] = ACTIONS(2632),
    [anon_sym_in] = ACTIONS(2632),
    [anon_sym_isa] = ACTIONS(2632),
    [anon_sym_PIPE_PIPE] = ACTIONS(2632),
    [anon_sym_AMP_AMP] = ACTIONS(2632),
    [anon_sym_QMARK] = ACTIONS(2632),
    [anon_sym_EQ_GT] = ACTIONS(2632),
    [anon_sym_LBRACK2] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2632),
    [aux_sym_integer_literal_token1] = ACTIONS(2632),
    [aux_sym_integer_literal_token2] = ACTIONS(2632),
    [aux_sym_integer_literal_token3] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__unary_operator] = ACTIONS(2632),
    [sym__power_operator] = ACTIONS(2632),
    [sym__bitshift_operator] = ACTIONS(2632),
    [sym__rational_operator] = ACTIONS(2632),
    [sym__times_operator] = ACTIONS(2632),
    [sym__plus_operator] = ACTIONS(2632),
    [sym__dotty_operator] = ACTIONS(2632),
    [sym__comparison_operator] = ACTIONS(2632),
    [sym__arrow_operator] = ACTIONS(2632),
    [anon_sym_LF] = ACTIONS(2634),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2634),
    [sym__string_start] = ACTIONS(2634),
    [sym__command_start] = ACTIONS(2634),
  },
  [1253] = {
    [ts_builtin_sym_end] = ACTIONS(2664),
    [sym_identifier] = ACTIONS(2662),
    [anon_sym_function] = ACTIONS(2662),
    [anon_sym_abstract] = ACTIONS(2662),
    [anon_sym_primitive] = ACTIONS(2662),
    [aux_sym_primitive_definition_token1] = ACTIONS(2662),
    [anon_sym_mutable] = ACTIONS(2662),
    [anon_sym_struct] = ACTIONS(2662),
    [anon_sym_module] = ACTIONS(2662),
    [anon_sym_macro] = ACTIONS(2662),
    [anon_sym_LPAREN] = ACTIONS(2662),
    [anon_sym_COMMA] = ACTIONS(2662),
    [anon_sym_SEMI] = ACTIONS(2662),
    [anon_sym_EQ] = ACTIONS(2662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2662),
    [anon_sym_COLON_COLON] = ACTIONS(2662),
    [anon_sym_LT_COLON] = ACTIONS(2662),
    [anon_sym_if] = ACTIONS(2662),
    [anon_sym_try] = ACTIONS(2662),
    [anon_sym_for] = ACTIONS(2662),
    [anon_sym_while] = ACTIONS(2662),
    [sym_break_statement] = ACTIONS(2662),
    [sym_continue_statement] = ACTIONS(2662),
    [anon_sym_return] = ACTIONS(2662),
    [anon_sym_let] = ACTIONS(2662),
    [anon_sym_const] = ACTIONS(2662),
    [anon_sym_quote] = ACTIONS(2662),
    [anon_sym_using] = ACTIONS(2662),
    [anon_sym_import] = ACTIONS(2662),
    [anon_sym_DOT] = ACTIONS(2662),
    [anon_sym_export] = ACTIONS(2662),
    [anon_sym_COLON2] = ACTIONS(2662),
    [anon_sym_LBRACK] = ACTIONS(2664),
    [anon_sym_begin] = ACTIONS(2662),
    [anon_sym_SQUOTE] = ACTIONS(2662),
    [anon_sym_PLUS] = ACTIONS(2662),
    [anon_sym_LT_PIPE] = ACTIONS(2662),
    [anon_sym_PIPE_GT] = ACTIONS(2662),
    [anon_sym_in] = ACTIONS(2662),
    [anon_sym_isa] = ACTIONS(2662),
    [anon_sym_PIPE_PIPE] = ACTIONS(2662),
    [anon_sym_AMP_AMP] = ACTIONS(2662),
    [anon_sym_QMARK] = ACTIONS(2662),
    [anon_sym_EQ_GT] = ACTIONS(2662),
    [anon_sym_LBRACK2] = ACTIONS(2662),
    [anon_sym_DOLLAR] = ACTIONS(2662),
    [anon_sym_AT] = ACTIONS(2662),
    [aux_sym_integer_literal_token1] = ACTIONS(2662),
    [aux_sym_integer_literal_token2] = ACTIONS(2662),
    [aux_sym_integer_literal_token3] = ACTIONS(2662),
    [sym_float_literal] = ACTIONS(2662),
    [sym__unary_operator] = ACTIONS(2662),
    [sym__power_operator] = ACTIONS(2662),
    [sym__bitshift_operator] = ACTIONS(2662),
    [sym__rational_operator] = ACTIONS(2662),
    [sym__times_operator] = ACTIONS(2662),
    [sym__plus_operator] = ACTIONS(2662),
    [sym__dotty_operator] = ACTIONS(2662),
    [sym__comparison_operator] = ACTIONS(2662),
    [sym__arrow_operator] = ACTIONS(2662),
    [sym__assign_operator] = ACTIONS(2662),
    [anon_sym_LF] = ACTIONS(2664),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2664),
    [sym__string_start] = ACTIONS(2664),
    [sym__command_start] = ACTIONS(2664),
  },
  [1254] = {
    [sym_identifier] = ACTIONS(2896),
    [anon_sym_function] = ACTIONS(2896),
    [anon_sym_end] = ACTIONS(2896),
    [anon_sym_abstract] = ACTIONS(2896),
    [anon_sym_primitive] = ACTIONS(2896),
    [aux_sym_primitive_definition_token1] = ACTIONS(2896),
    [anon_sym_mutable] = ACTIONS(2896),
    [anon_sym_struct] = ACTIONS(2896),
    [anon_sym_module] = ACTIONS(2896),
    [anon_sym_macro] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_COMMA] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2898),
    [anon_sym_COLON_COLON] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_LT_COLON] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2896),
    [anon_sym_try] = ACTIONS(2896),
    [anon_sym_for] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2896),
    [sym_break_statement] = ACTIONS(2896),
    [sym_continue_statement] = ACTIONS(2896),
    [anon_sym_return] = ACTIONS(2896),
    [anon_sym_let] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_quote] = ACTIONS(2896),
    [anon_sym_using] = ACTIONS(2896),
    [anon_sym_import] = ACTIONS(2896),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_COLON2] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_RBRACK] = ACTIONS(2898),
    [anon_sym_begin] = ACTIONS(2896),
    [anon_sym_SQUOTE] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT_PIPE] = ACTIONS(2898),
    [anon_sym_PIPE_GT] = ACTIONS(2898),
    [anon_sym_in] = ACTIONS(2896),
    [anon_sym_isa] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2898),
    [anon_sym_AMP_AMP] = ACTIONS(2898),
    [anon_sym_QMARK] = ACTIONS(2898),
    [anon_sym_EQ_GT] = ACTIONS(2898),
    [anon_sym_LBRACK2] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_AT] = ACTIONS(2898),
    [aux_sym_integer_literal_token1] = ACTIONS(2898),
    [aux_sym_integer_literal_token2] = ACTIONS(2898),
    [aux_sym_integer_literal_token3] = ACTIONS(2896),
    [sym_float_literal] = ACTIONS(2896),
    [sym__unary_operator] = ACTIONS(2896),
    [sym__power_operator] = ACTIONS(2896),
    [sym__bitshift_operator] = ACTIONS(2896),
    [sym__rational_operator] = ACTIONS(2896),
    [sym__times_operator] = ACTIONS(2896),
    [sym__plus_operator] = ACTIONS(2896),
    [sym__dotty_operator] = ACTIONS(2896),
    [sym__comparison_operator] = ACTIONS(2896),
    [sym__arrow_operator] = ACTIONS(2898),
    [sym__assign_operator] = ACTIONS(2896),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2898),
    [sym__command_start] = ACTIONS(2898),
  },
  [1255] = {
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_end] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_primitive] = ACTIONS(2791),
    [aux_sym_primitive_definition_token1] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_macro] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2793),
    [anon_sym_COMMA] = ACTIONS(2793),
    [anon_sym_RPAREN] = ACTIONS(2793),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_RBRACE] = ACTIONS(2793),
    [anon_sym_LT_COLON] = ACTIONS(2793),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [sym_break_statement] = ACTIONS(2791),
    [sym_continue_statement] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_quote] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_COLON2] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [anon_sym_RBRACK] = ACTIONS(2793),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_LT_PIPE] = ACTIONS(2793),
    [anon_sym_PIPE_GT] = ACTIONS(2793),
    [anon_sym_in] = ACTIONS(2791),
    [anon_sym_isa] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_QMARK] = ACTIONS(2793),
    [anon_sym_EQ_GT] = ACTIONS(2793),
    [anon_sym_LBRACK2] = ACTIONS(2791),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_AT] = ACTIONS(2793),
    [aux_sym_integer_literal_token1] = ACTIONS(2793),
    [aux_sym_integer_literal_token2] = ACTIONS(2793),
    [aux_sym_integer_literal_token3] = ACTIONS(2791),
    [sym_float_literal] = ACTIONS(2791),
    [sym__unary_operator] = ACTIONS(2791),
    [sym__power_operator] = ACTIONS(2791),
    [sym__bitshift_operator] = ACTIONS(2791),
    [sym__rational_operator] = ACTIONS(2791),
    [sym__times_operator] = ACTIONS(2791),
    [sym__plus_operator] = ACTIONS(2791),
    [sym__dotty_operator] = ACTIONS(2791),
    [sym__comparison_operator] = ACTIONS(2791),
    [sym__arrow_operator] = ACTIONS(2793),
    [sym__assign_operator] = ACTIONS(2791),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2793),
    [sym__command_start] = ACTIONS(2793),
  },
  [1256] = {
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_function] = ACTIONS(2787),
    [anon_sym_end] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2787),
    [anon_sym_primitive] = ACTIONS(2787),
    [aux_sym_primitive_definition_token1] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_macro] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_RPAREN] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_EQ] = ACTIONS(2787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2789),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_LT_COLON] = ACTIONS(2789),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [sym_break_statement] = ACTIONS(2787),
    [sym_continue_statement] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_quote] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_COLON2] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_RBRACK] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_LT_PIPE] = ACTIONS(2789),
    [anon_sym_PIPE_GT] = ACTIONS(2789),
    [anon_sym_in] = ACTIONS(2787),
    [anon_sym_isa] = ACTIONS(2787),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_EQ_GT] = ACTIONS(2789),
    [anon_sym_LBRACK2] = ACTIONS(2787),
    [anon_sym_DOLLAR] = ACTIONS(2787),
    [anon_sym_AT] = ACTIONS(2789),
    [aux_sym_integer_literal_token1] = ACTIONS(2789),
    [aux_sym_integer_literal_token2] = ACTIONS(2789),
    [aux_sym_integer_literal_token3] = ACTIONS(2787),
    [sym_float_literal] = ACTIONS(2787),
    [sym__unary_operator] = ACTIONS(2787),
    [sym__power_operator] = ACTIONS(2787),
    [sym__bitshift_operator] = ACTIONS(2787),
    [sym__rational_operator] = ACTIONS(2787),
    [sym__times_operator] = ACTIONS(2787),
    [sym__plus_operator] = ACTIONS(2787),
    [sym__dotty_operator] = ACTIONS(2787),
    [sym__comparison_operator] = ACTIONS(2787),
    [sym__arrow_operator] = ACTIONS(2789),
    [sym__assign_operator] = ACTIONS(2787),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2789),
    [sym__command_start] = ACTIONS(2789),
  },
  [1257] = {
    [aux_sym_export_statement_repeat1] = STATE(1257),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_end] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_primitive] = ACTIONS(2817),
    [aux_sym_primitive_definition_token1] = ACTIONS(2817),
    [anon_sym_mutable] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_macro] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_COMMA] = ACTIONS(3333),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_LT_COLON] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [sym_break_statement] = ACTIONS(2817),
    [sym_continue_statement] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_quote] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_COLON2] = ACTIONS(2817),
    [anon_sym_RBRACK] = ACTIONS(2822),
    [anon_sym_begin] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_LT_PIPE] = ACTIONS(2822),
    [anon_sym_PIPE_GT] = ACTIONS(2822),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_isa] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_QMARK] = ACTIONS(2822),
    [anon_sym_EQ_GT] = ACTIONS(2822),
    [anon_sym_LBRACK2] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2822),
    [aux_sym_integer_literal_token1] = ACTIONS(2822),
    [aux_sym_integer_literal_token2] = ACTIONS(2822),
    [aux_sym_integer_literal_token3] = ACTIONS(2817),
    [sym_float_literal] = ACTIONS(2817),
    [sym__unary_operator] = ACTIONS(2817),
    [sym__power_operator] = ACTIONS(2817),
    [sym__bitshift_operator] = ACTIONS(2817),
    [sym__rational_operator] = ACTIONS(2817),
    [sym__times_operator] = ACTIONS(2817),
    [sym__plus_operator] = ACTIONS(2817),
    [sym__dotty_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(2817),
    [sym__arrow_operator] = ACTIONS(2822),
    [sym__assign_operator] = ACTIONS(2817),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2822),
    [sym__command_start] = ACTIONS(2822),
  },
  [1258] = {
    [aux_sym_import_statement_repeat1] = STATE(1258),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_LT_COLON] = ACTIONS(2746),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_RBRACK] = ACTIONS(2746),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2746),
    [anon_sym_PIPE_GT] = ACTIONS(2746),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_QMARK] = ACTIONS(2746),
    [anon_sym_EQ_GT] = ACTIONS(2746),
    [anon_sym_LBRACK2] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2746),
    [aux_sym_integer_literal_token1] = ACTIONS(2746),
    [aux_sym_integer_literal_token2] = ACTIONS(2746),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2746),
    [sym__assign_operator] = ACTIONS(2744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1259] = {
    [ts_builtin_sym_end] = ACTIONS(2688),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_primitive] = ACTIONS(2686),
    [aux_sym_primitive_definition_token1] = ACTIONS(2686),
    [anon_sym_mutable] = ACTIONS(2686),
    [anon_sym_struct] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_macro] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_COMMA] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(2686),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2686),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LT_COLON] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [sym_break_statement] = ACTIONS(2686),
    [sym_continue_statement] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_quote] = ACTIONS(2686),
    [anon_sym_using] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_DOT] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_COLON2] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_begin] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_LT_PIPE] = ACTIONS(2686),
    [anon_sym_PIPE_GT] = ACTIONS(2686),
    [anon_sym_in] = ACTIONS(2686),
    [anon_sym_isa] = ACTIONS(2686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_QMARK] = ACTIONS(2686),
    [anon_sym_EQ_GT] = ACTIONS(2686),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2686),
    [aux_sym_integer_literal_token1] = ACTIONS(2686),
    [aux_sym_integer_literal_token2] = ACTIONS(2686),
    [aux_sym_integer_literal_token3] = ACTIONS(2686),
    [sym_float_literal] = ACTIONS(2686),
    [sym__unary_operator] = ACTIONS(2686),
    [sym__power_operator] = ACTIONS(2686),
    [sym__bitshift_operator] = ACTIONS(2686),
    [sym__rational_operator] = ACTIONS(2686),
    [sym__times_operator] = ACTIONS(2686),
    [sym__plus_operator] = ACTIONS(2686),
    [sym__dotty_operator] = ACTIONS(2686),
    [sym__comparison_operator] = ACTIONS(2686),
    [sym__arrow_operator] = ACTIONS(2686),
    [sym__assign_operator] = ACTIONS(2686),
    [anon_sym_LF] = ACTIONS(2688),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2688),
    [sym__string_start] = ACTIONS(2688),
    [sym__command_start] = ACTIONS(2688),
  },
  [1260] = {
    [ts_builtin_sym_end] = ACTIONS(2594),
    [sym_identifier] = ACTIONS(2592),
    [anon_sym_function] = ACTIONS(2592),
    [anon_sym_abstract] = ACTIONS(2592),
    [anon_sym_primitive] = ACTIONS(2592),
    [aux_sym_primitive_definition_token1] = ACTIONS(2592),
    [anon_sym_mutable] = ACTIONS(2592),
    [anon_sym_struct] = ACTIONS(2592),
    [anon_sym_module] = ACTIONS(2592),
    [anon_sym_macro] = ACTIONS(2592),
    [anon_sym_LPAREN] = ACTIONS(2592),
    [anon_sym_COMMA] = ACTIONS(2592),
    [anon_sym_SEMI] = ACTIONS(2592),
    [anon_sym_EQ] = ACTIONS(2592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2592),
    [anon_sym_COLON_COLON] = ACTIONS(2592),
    [anon_sym_LT_COLON] = ACTIONS(2592),
    [anon_sym_if] = ACTIONS(2592),
    [anon_sym_try] = ACTIONS(2592),
    [anon_sym_for] = ACTIONS(2592),
    [anon_sym_while] = ACTIONS(2592),
    [sym_break_statement] = ACTIONS(2592),
    [sym_continue_statement] = ACTIONS(2592),
    [anon_sym_return] = ACTIONS(2592),
    [anon_sym_let] = ACTIONS(2592),
    [anon_sym_const] = ACTIONS(2592),
    [anon_sym_quote] = ACTIONS(2592),
    [anon_sym_using] = ACTIONS(2592),
    [anon_sym_import] = ACTIONS(2592),
    [anon_sym_DOT] = ACTIONS(2592),
    [anon_sym_export] = ACTIONS(2592),
    [anon_sym_COLON2] = ACTIONS(2592),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_begin] = ACTIONS(2592),
    [anon_sym_SQUOTE] = ACTIONS(2592),
    [anon_sym_PLUS] = ACTIONS(2592),
    [anon_sym_LT_PIPE] = ACTIONS(2592),
    [anon_sym_PIPE_GT] = ACTIONS(2592),
    [anon_sym_in] = ACTIONS(2592),
    [anon_sym_isa] = ACTIONS(2592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2592),
    [anon_sym_AMP_AMP] = ACTIONS(2592),
    [anon_sym_QMARK] = ACTIONS(2592),
    [anon_sym_EQ_GT] = ACTIONS(2592),
    [anon_sym_LBRACK2] = ACTIONS(2592),
    [anon_sym_DOLLAR] = ACTIONS(2592),
    [anon_sym_AT] = ACTIONS(2592),
    [aux_sym_integer_literal_token1] = ACTIONS(2592),
    [aux_sym_integer_literal_token2] = ACTIONS(2592),
    [aux_sym_integer_literal_token3] = ACTIONS(2592),
    [sym_float_literal] = ACTIONS(2592),
    [sym__unary_operator] = ACTIONS(2592),
    [sym__power_operator] = ACTIONS(2592),
    [sym__bitshift_operator] = ACTIONS(2592),
    [sym__rational_operator] = ACTIONS(2592),
    [sym__times_operator] = ACTIONS(2592),
    [sym__plus_operator] = ACTIONS(2592),
    [sym__dotty_operator] = ACTIONS(2592),
    [sym__comparison_operator] = ACTIONS(2592),
    [sym__arrow_operator] = ACTIONS(2592),
    [sym__assign_operator] = ACTIONS(2592),
    [anon_sym_LF] = ACTIONS(2594),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2594),
    [sym__string_start] = ACTIONS(2594),
    [sym__command_start] = ACTIONS(2594),
  },
  [1261] = {
    [sym_identifier] = ACTIONS(2596),
    [anon_sym_function] = ACTIONS(2596),
    [anon_sym_end] = ACTIONS(2596),
    [anon_sym_abstract] = ACTIONS(2596),
    [anon_sym_primitive] = ACTIONS(2596),
    [aux_sym_primitive_definition_token1] = ACTIONS(2596),
    [anon_sym_mutable] = ACTIONS(2596),
    [anon_sym_struct] = ACTIONS(2596),
    [anon_sym_module] = ACTIONS(2596),
    [anon_sym_macro] = ACTIONS(2596),
    [anon_sym_LPAREN] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2596),
    [anon_sym_COLON_COLON] = ACTIONS(2596),
    [anon_sym_LT_COLON] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2596),
    [anon_sym_elseif] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2596),
    [anon_sym_while] = ACTIONS(2596),
    [sym_break_statement] = ACTIONS(2596),
    [sym_continue_statement] = ACTIONS(2596),
    [anon_sym_return] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2596),
    [anon_sym_const] = ACTIONS(2596),
    [anon_sym_quote] = ACTIONS(2596),
    [anon_sym_using] = ACTIONS(2596),
    [anon_sym_import] = ACTIONS(2596),
    [anon_sym_DOT] = ACTIONS(2596),
    [anon_sym_export] = ACTIONS(2596),
    [anon_sym_COLON2] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(2598),
    [anon_sym_begin] = ACTIONS(2596),
    [anon_sym_SQUOTE] = ACTIONS(2596),
    [anon_sym_PLUS] = ACTIONS(2596),
    [anon_sym_LT_PIPE] = ACTIONS(2596),
    [anon_sym_PIPE_GT] = ACTIONS(2596),
    [anon_sym_in] = ACTIONS(2596),
    [anon_sym_isa] = ACTIONS(2596),
    [anon_sym_PIPE_PIPE] = ACTIONS(2596),
    [anon_sym_AMP_AMP] = ACTIONS(2596),
    [anon_sym_QMARK] = ACTIONS(2596),
    [anon_sym_EQ_GT] = ACTIONS(2596),
    [anon_sym_LBRACK2] = ACTIONS(2596),
    [anon_sym_DOLLAR] = ACTIONS(2596),
    [anon_sym_AT] = ACTIONS(2596),
    [aux_sym_integer_literal_token1] = ACTIONS(2596),
    [aux_sym_integer_literal_token2] = ACTIONS(2596),
    [aux_sym_integer_literal_token3] = ACTIONS(2596),
    [sym_float_literal] = ACTIONS(2596),
    [sym__unary_operator] = ACTIONS(2596),
    [sym__power_operator] = ACTIONS(2596),
    [sym__bitshift_operator] = ACTIONS(2596),
    [sym__rational_operator] = ACTIONS(2596),
    [sym__times_operator] = ACTIONS(2596),
    [sym__plus_operator] = ACTIONS(2596),
    [sym__dotty_operator] = ACTIONS(2596),
    [sym__comparison_operator] = ACTIONS(2596),
    [sym__arrow_operator] = ACTIONS(2596),
    [anon_sym_LF] = ACTIONS(2598),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2598),
    [sym__string_start] = ACTIONS(2598),
    [sym__command_start] = ACTIONS(2598),
  },
  [1262] = {
    [aux_sym_selected_import_repeat1] = STATE(1245),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_function] = ACTIONS(2827),
    [anon_sym_end] = ACTIONS(2827),
    [anon_sym_abstract] = ACTIONS(2827),
    [anon_sym_primitive] = ACTIONS(2827),
    [aux_sym_primitive_definition_token1] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_module] = ACTIONS(2827),
    [anon_sym_macro] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(3331),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_LT_COLON] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [sym_break_statement] = ACTIONS(2827),
    [sym_continue_statement] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_quote] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_import] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2827),
    [anon_sym_COLON2] = ACTIONS(2827),
    [anon_sym_RBRACK] = ACTIONS(2831),
    [anon_sym_begin] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_LT_PIPE] = ACTIONS(2831),
    [anon_sym_PIPE_GT] = ACTIONS(2831),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_isa] = ACTIONS(2827),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_EQ_GT] = ACTIONS(2831),
    [anon_sym_LBRACK2] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(2831),
    [aux_sym_integer_literal_token1] = ACTIONS(2831),
    [aux_sym_integer_literal_token2] = ACTIONS(2831),
    [aux_sym_integer_literal_token3] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
    [sym__unary_operator] = ACTIONS(2827),
    [sym__power_operator] = ACTIONS(2827),
    [sym__bitshift_operator] = ACTIONS(2827),
    [sym__rational_operator] = ACTIONS(2827),
    [sym__times_operator] = ACTIONS(2827),
    [sym__plus_operator] = ACTIONS(2827),
    [sym__dotty_operator] = ACTIONS(2827),
    [sym__comparison_operator] = ACTIONS(2827),
    [sym__arrow_operator] = ACTIONS(2831),
    [sym__assign_operator] = ACTIONS(2827),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2831),
    [sym__command_start] = ACTIONS(2831),
  },
  [1263] = {
    [ts_builtin_sym_end] = ACTIONS(2660),
    [sym_identifier] = ACTIONS(2658),
    [anon_sym_function] = ACTIONS(2658),
    [anon_sym_abstract] = ACTIONS(2658),
    [anon_sym_primitive] = ACTIONS(2658),
    [aux_sym_primitive_definition_token1] = ACTIONS(2658),
    [anon_sym_mutable] = ACTIONS(2658),
    [anon_sym_struct] = ACTIONS(2658),
    [anon_sym_module] = ACTIONS(2658),
    [anon_sym_macro] = ACTIONS(2658),
    [anon_sym_LPAREN] = ACTIONS(2658),
    [anon_sym_COMMA] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2658),
    [anon_sym_EQ] = ACTIONS(2658),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2658),
    [anon_sym_COLON_COLON] = ACTIONS(2658),
    [anon_sym_LT_COLON] = ACTIONS(2658),
    [anon_sym_if] = ACTIONS(2658),
    [anon_sym_try] = ACTIONS(2658),
    [anon_sym_for] = ACTIONS(2658),
    [anon_sym_while] = ACTIONS(2658),
    [sym_break_statement] = ACTIONS(2658),
    [sym_continue_statement] = ACTIONS(2658),
    [anon_sym_return] = ACTIONS(2658),
    [anon_sym_let] = ACTIONS(2658),
    [anon_sym_const] = ACTIONS(2658),
    [anon_sym_quote] = ACTIONS(2658),
    [anon_sym_using] = ACTIONS(2658),
    [anon_sym_import] = ACTIONS(2658),
    [anon_sym_DOT] = ACTIONS(2658),
    [anon_sym_export] = ACTIONS(2658),
    [anon_sym_COLON2] = ACTIONS(2658),
    [anon_sym_LBRACK] = ACTIONS(2660),
    [anon_sym_begin] = ACTIONS(2658),
    [anon_sym_SQUOTE] = ACTIONS(2658),
    [anon_sym_PLUS] = ACTIONS(2658),
    [anon_sym_LT_PIPE] = ACTIONS(2658),
    [anon_sym_PIPE_GT] = ACTIONS(2658),
    [anon_sym_in] = ACTIONS(2658),
    [anon_sym_isa] = ACTIONS(2658),
    [anon_sym_PIPE_PIPE] = ACTIONS(2658),
    [anon_sym_AMP_AMP] = ACTIONS(2658),
    [anon_sym_QMARK] = ACTIONS(2658),
    [anon_sym_EQ_GT] = ACTIONS(2658),
    [anon_sym_LBRACK2] = ACTIONS(2658),
    [anon_sym_DOLLAR] = ACTIONS(2658),
    [anon_sym_AT] = ACTIONS(2658),
    [aux_sym_integer_literal_token1] = ACTIONS(2658),
    [aux_sym_integer_literal_token2] = ACTIONS(2658),
    [aux_sym_integer_literal_token3] = ACTIONS(2658),
    [sym_float_literal] = ACTIONS(2658),
    [sym__unary_operator] = ACTIONS(2658),
    [sym__power_operator] = ACTIONS(2658),
    [sym__bitshift_operator] = ACTIONS(2658),
    [sym__rational_operator] = ACTIONS(2658),
    [sym__times_operator] = ACTIONS(2658),
    [sym__plus_operator] = ACTIONS(2658),
    [sym__dotty_operator] = ACTIONS(2658),
    [sym__comparison_operator] = ACTIONS(2658),
    [sym__arrow_operator] = ACTIONS(2658),
    [sym__assign_operator] = ACTIONS(2658),
    [anon_sym_LF] = ACTIONS(2660),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2660),
    [sym__string_start] = ACTIONS(2660),
    [sym__command_start] = ACTIONS(2660),
  },
  [1264] = {
    [sym_identifier] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_primitive] = ACTIONS(304),
    [aux_sym_primitive_definition_token1] = ACTIONS(304),
    [anon_sym_mutable] = ACTIONS(304),
    [anon_sym_struct] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_macro] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [sym_break_statement] = ACTIONS(304),
    [sym_continue_statement] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_quote] = ACTIONS(304),
    [anon_sym_using] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_COLON2] = ACTIONS(304),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(306),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(306),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(306),
    [aux_sym_integer_literal_token1] = ACTIONS(306),
    [aux_sym_integer_literal_token2] = ACTIONS(306),
    [aux_sym_integer_literal_token3] = ACTIONS(304),
    [sym_float_literal] = ACTIONS(304),
    [sym__unary_operator] = ACTIONS(304),
    [sym__power_operator] = ACTIONS(304),
    [sym__bitshift_operator] = ACTIONS(304),
    [sym__rational_operator] = ACTIONS(304),
    [sym__times_operator] = ACTIONS(304),
    [sym__plus_operator] = ACTIONS(304),
    [sym__dotty_operator] = ACTIONS(304),
    [sym__comparison_operator] = ACTIONS(304),
    [sym__arrow_operator] = ACTIONS(306),
    [sym__assign_operator] = ACTIONS(304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(306),
    [sym__command_start] = ACTIONS(306),
  },
  [1265] = {
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_end] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_primitive] = ACTIONS(2600),
    [aux_sym_primitive_definition_token1] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_macro] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2600),
    [anon_sym_COLON_COLON] = ACTIONS(2600),
    [anon_sym_LT_COLON] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_elseif] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [sym_break_statement] = ACTIONS(2600),
    [sym_continue_statement] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_quote] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_COLON2] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_begin] = ACTIONS(2600),
    [anon_sym_SQUOTE] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_LT_PIPE] = ACTIONS(2600),
    [anon_sym_PIPE_GT] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_isa] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_EQ_GT] = ACTIONS(2600),
    [anon_sym_LBRACK2] = ACTIONS(2600),
    [anon_sym_DOLLAR] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2600),
    [aux_sym_integer_literal_token1] = ACTIONS(2600),
    [aux_sym_integer_literal_token2] = ACTIONS(2600),
    [aux_sym_integer_literal_token3] = ACTIONS(2600),
    [sym_float_literal] = ACTIONS(2600),
    [sym__unary_operator] = ACTIONS(2600),
    [sym__power_operator] = ACTIONS(2600),
    [sym__bitshift_operator] = ACTIONS(2600),
    [sym__rational_operator] = ACTIONS(2600),
    [sym__times_operator] = ACTIONS(2600),
    [sym__plus_operator] = ACTIONS(2600),
    [sym__dotty_operator] = ACTIONS(2600),
    [sym__comparison_operator] = ACTIONS(2600),
    [sym__arrow_operator] = ACTIONS(2600),
    [anon_sym_LF] = ACTIONS(2602),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2602),
    [sym__string_start] = ACTIONS(2602),
    [sym__command_start] = ACTIONS(2602),
  },
  [1266] = {
    [aux_sym_let_statement_repeat1] = STATE(1268),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_end] = ACTIONS(2766),
    [anon_sym_abstract] = ACTIONS(2766),
    [anon_sym_primitive] = ACTIONS(2766),
    [aux_sym_primitive_definition_token1] = ACTIONS(2766),
    [anon_sym_mutable] = ACTIONS(2766),
    [anon_sym_struct] = ACTIONS(2766),
    [anon_sym_module] = ACTIONS(2766),
    [anon_sym_macro] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(3315),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_LT_COLON] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [sym_break_statement] = ACTIONS(2766),
    [sym_continue_statement] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_quote] = ACTIONS(2766),
    [anon_sym_using] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2766),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_COLON2] = ACTIONS(2766),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_LT_PIPE] = ACTIONS(2770),
    [anon_sym_PIPE_GT] = ACTIONS(2770),
    [anon_sym_in] = ACTIONS(2766),
    [anon_sym_isa] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_EQ_GT] = ACTIONS(2770),
    [anon_sym_LBRACK2] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2770),
    [aux_sym_integer_literal_token1] = ACTIONS(2770),
    [aux_sym_integer_literal_token2] = ACTIONS(2770),
    [aux_sym_integer_literal_token3] = ACTIONS(2766),
    [sym_float_literal] = ACTIONS(2766),
    [sym__unary_operator] = ACTIONS(2766),
    [sym__power_operator] = ACTIONS(2766),
    [sym__bitshift_operator] = ACTIONS(2766),
    [sym__rational_operator] = ACTIONS(2766),
    [sym__times_operator] = ACTIONS(2766),
    [sym__plus_operator] = ACTIONS(2766),
    [sym__dotty_operator] = ACTIONS(2766),
    [sym__comparison_operator] = ACTIONS(2766),
    [sym__arrow_operator] = ACTIONS(2770),
    [sym__assign_operator] = ACTIONS(2766),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2770),
    [sym__command_start] = ACTIONS(2770),
  },
  [1267] = {
    [ts_builtin_sym_end] = ACTIONS(2602),
    [sym_identifier] = ACTIONS(2600),
    [anon_sym_function] = ACTIONS(2600),
    [anon_sym_abstract] = ACTIONS(2600),
    [anon_sym_primitive] = ACTIONS(2600),
    [aux_sym_primitive_definition_token1] = ACTIONS(2600),
    [anon_sym_mutable] = ACTIONS(2600),
    [anon_sym_struct] = ACTIONS(2600),
    [anon_sym_module] = ACTIONS(2600),
    [anon_sym_macro] = ACTIONS(2600),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_EQ] = ACTIONS(2600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2600),
    [anon_sym_COLON_COLON] = ACTIONS(2600),
    [anon_sym_LT_COLON] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2600),
    [anon_sym_while] = ACTIONS(2600),
    [sym_break_statement] = ACTIONS(2600),
    [sym_continue_statement] = ACTIONS(2600),
    [anon_sym_return] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2600),
    [anon_sym_const] = ACTIONS(2600),
    [anon_sym_quote] = ACTIONS(2600),
    [anon_sym_using] = ACTIONS(2600),
    [anon_sym_import] = ACTIONS(2600),
    [anon_sym_DOT] = ACTIONS(2600),
    [anon_sym_export] = ACTIONS(2600),
    [anon_sym_COLON2] = ACTIONS(2600),
    [anon_sym_LBRACK] = ACTIONS(2602),
    [anon_sym_begin] = ACTIONS(2600),
    [anon_sym_SQUOTE] = ACTIONS(2600),
    [anon_sym_PLUS] = ACTIONS(2600),
    [anon_sym_LT_PIPE] = ACTIONS(2600),
    [anon_sym_PIPE_GT] = ACTIONS(2600),
    [anon_sym_in] = ACTIONS(2600),
    [anon_sym_isa] = ACTIONS(2600),
    [anon_sym_PIPE_PIPE] = ACTIONS(2600),
    [anon_sym_AMP_AMP] = ACTIONS(2600),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_EQ_GT] = ACTIONS(2600),
    [anon_sym_LBRACK2] = ACTIONS(2600),
    [anon_sym_DOLLAR] = ACTIONS(2600),
    [anon_sym_AT] = ACTIONS(2600),
    [aux_sym_integer_literal_token1] = ACTIONS(2600),
    [aux_sym_integer_literal_token2] = ACTIONS(2600),
    [aux_sym_integer_literal_token3] = ACTIONS(2600),
    [sym_float_literal] = ACTIONS(2600),
    [sym__unary_operator] = ACTIONS(2600),
    [sym__power_operator] = ACTIONS(2600),
    [sym__bitshift_operator] = ACTIONS(2600),
    [sym__rational_operator] = ACTIONS(2600),
    [sym__times_operator] = ACTIONS(2600),
    [sym__plus_operator] = ACTIONS(2600),
    [sym__dotty_operator] = ACTIONS(2600),
    [sym__comparison_operator] = ACTIONS(2600),
    [sym__arrow_operator] = ACTIONS(2600),
    [sym__assign_operator] = ACTIONS(2600),
    [anon_sym_LF] = ACTIONS(2602),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2602),
    [sym__string_start] = ACTIONS(2602),
    [sym__command_start] = ACTIONS(2602),
  },
  [1268] = {
    [aux_sym_let_statement_repeat1] = STATE(1268),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_end] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_primitive] = ACTIONS(2916),
    [aux_sym_primitive_definition_token1] = ACTIONS(2916),
    [anon_sym_mutable] = ACTIONS(2916),
    [anon_sym_struct] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_macro] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(3339),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_LT_COLON] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [sym_break_statement] = ACTIONS(2916),
    [sym_continue_statement] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_quote] = ACTIONS(2916),
    [anon_sym_using] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_COLON2] = ACTIONS(2916),
    [anon_sym_RBRACK] = ACTIONS(2921),
    [anon_sym_begin] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_LT_PIPE] = ACTIONS(2921),
    [anon_sym_PIPE_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2916),
    [anon_sym_isa] = ACTIONS(2916),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2921),
    [aux_sym_integer_literal_token1] = ACTIONS(2921),
    [aux_sym_integer_literal_token2] = ACTIONS(2921),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [sym_float_literal] = ACTIONS(2916),
    [sym__unary_operator] = ACTIONS(2916),
    [sym__power_operator] = ACTIONS(2916),
    [sym__bitshift_operator] = ACTIONS(2916),
    [sym__rational_operator] = ACTIONS(2916),
    [sym__times_operator] = ACTIONS(2916),
    [sym__plus_operator] = ACTIONS(2916),
    [sym__dotty_operator] = ACTIONS(2916),
    [sym__comparison_operator] = ACTIONS(2916),
    [sym__arrow_operator] = ACTIONS(2921),
    [sym__assign_operator] = ACTIONS(2916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2921),
    [sym__command_start] = ACTIONS(2921),
  },
  [1269] = {
    [ts_builtin_sym_end] = ACTIONS(2684),
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_primitive] = ACTIONS(2682),
    [aux_sym_primitive_definition_token1] = ACTIONS(2682),
    [anon_sym_mutable] = ACTIONS(2682),
    [anon_sym_struct] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_macro] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2682),
    [anon_sym_COMMA] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_EQ] = ACTIONS(2682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2682),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_LT_COLON] = ACTIONS(2682),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [sym_break_statement] = ACTIONS(2682),
    [sym_continue_statement] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_quote] = ACTIONS(2682),
    [anon_sym_using] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_DOT] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_COLON2] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_begin] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_LT_PIPE] = ACTIONS(2682),
    [anon_sym_PIPE_GT] = ACTIONS(2682),
    [anon_sym_in] = ACTIONS(2682),
    [anon_sym_isa] = ACTIONS(2682),
    [anon_sym_PIPE_PIPE] = ACTIONS(2682),
    [anon_sym_AMP_AMP] = ACTIONS(2682),
    [anon_sym_QMARK] = ACTIONS(2682),
    [anon_sym_EQ_GT] = ACTIONS(2682),
    [anon_sym_LBRACK2] = ACTIONS(2682),
    [anon_sym_DOLLAR] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2682),
    [aux_sym_integer_literal_token1] = ACTIONS(2682),
    [aux_sym_integer_literal_token2] = ACTIONS(2682),
    [aux_sym_integer_literal_token3] = ACTIONS(2682),
    [sym_float_literal] = ACTIONS(2682),
    [sym__unary_operator] = ACTIONS(2682),
    [sym__power_operator] = ACTIONS(2682),
    [sym__bitshift_operator] = ACTIONS(2682),
    [sym__rational_operator] = ACTIONS(2682),
    [sym__times_operator] = ACTIONS(2682),
    [sym__plus_operator] = ACTIONS(2682),
    [sym__dotty_operator] = ACTIONS(2682),
    [sym__comparison_operator] = ACTIONS(2682),
    [sym__arrow_operator] = ACTIONS(2682),
    [sym__assign_operator] = ACTIONS(2682),
    [anon_sym_LF] = ACTIONS(2684),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2684),
    [sym__string_start] = ACTIONS(2684),
    [sym__command_start] = ACTIONS(2684),
  },
  [1270] = {
    [ts_builtin_sym_end] = ACTIONS(2668),
    [sym_identifier] = ACTIONS(2666),
    [anon_sym_function] = ACTIONS(2666),
    [anon_sym_abstract] = ACTIONS(2666),
    [anon_sym_primitive] = ACTIONS(2666),
    [aux_sym_primitive_definition_token1] = ACTIONS(2666),
    [anon_sym_mutable] = ACTIONS(2666),
    [anon_sym_struct] = ACTIONS(2666),
    [anon_sym_module] = ACTIONS(2666),
    [anon_sym_macro] = ACTIONS(2666),
    [anon_sym_LPAREN] = ACTIONS(2666),
    [anon_sym_COMMA] = ACTIONS(2666),
    [anon_sym_SEMI] = ACTIONS(2666),
    [anon_sym_EQ] = ACTIONS(2666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2666),
    [anon_sym_COLON_COLON] = ACTIONS(2666),
    [anon_sym_LT_COLON] = ACTIONS(2666),
    [anon_sym_if] = ACTIONS(2666),
    [anon_sym_try] = ACTIONS(2666),
    [anon_sym_for] = ACTIONS(2666),
    [anon_sym_while] = ACTIONS(2666),
    [sym_break_statement] = ACTIONS(2666),
    [sym_continue_statement] = ACTIONS(2666),
    [anon_sym_return] = ACTIONS(2666),
    [anon_sym_let] = ACTIONS(2666),
    [anon_sym_const] = ACTIONS(2666),
    [anon_sym_quote] = ACTIONS(2666),
    [anon_sym_using] = ACTIONS(2666),
    [anon_sym_import] = ACTIONS(2666),
    [anon_sym_DOT] = ACTIONS(2666),
    [anon_sym_export] = ACTIONS(2666),
    [anon_sym_COLON2] = ACTIONS(2666),
    [anon_sym_LBRACK] = ACTIONS(2668),
    [anon_sym_begin] = ACTIONS(2666),
    [anon_sym_SQUOTE] = ACTIONS(2666),
    [anon_sym_PLUS] = ACTIONS(2666),
    [anon_sym_LT_PIPE] = ACTIONS(2666),
    [anon_sym_PIPE_GT] = ACTIONS(2666),
    [anon_sym_in] = ACTIONS(2666),
    [anon_sym_isa] = ACTIONS(2666),
    [anon_sym_PIPE_PIPE] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2666),
    [anon_sym_QMARK] = ACTIONS(2666),
    [anon_sym_EQ_GT] = ACTIONS(2666),
    [anon_sym_LBRACK2] = ACTIONS(2666),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [anon_sym_AT] = ACTIONS(2666),
    [aux_sym_integer_literal_token1] = ACTIONS(2666),
    [aux_sym_integer_literal_token2] = ACTIONS(2666),
    [aux_sym_integer_literal_token3] = ACTIONS(2666),
    [sym_float_literal] = ACTIONS(2666),
    [sym__unary_operator] = ACTIONS(2666),
    [sym__power_operator] = ACTIONS(2666),
    [sym__bitshift_operator] = ACTIONS(2666),
    [sym__rational_operator] = ACTIONS(2666),
    [sym__times_operator] = ACTIONS(2666),
    [sym__plus_operator] = ACTIONS(2666),
    [sym__dotty_operator] = ACTIONS(2666),
    [sym__comparison_operator] = ACTIONS(2666),
    [sym__arrow_operator] = ACTIONS(2666),
    [sym__assign_operator] = ACTIONS(2666),
    [anon_sym_LF] = ACTIONS(2668),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2668),
    [sym__string_start] = ACTIONS(2668),
    [sym__command_start] = ACTIONS(2668),
  },
  [1271] = {
    [ts_builtin_sym_end] = ACTIONS(2672),
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_primitive] = ACTIONS(2670),
    [aux_sym_primitive_definition_token1] = ACTIONS(2670),
    [anon_sym_mutable] = ACTIONS(2670),
    [anon_sym_struct] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_macro] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2670),
    [anon_sym_COMMA] = ACTIONS(2670),
    [anon_sym_SEMI] = ACTIONS(2670),
    [anon_sym_EQ] = ACTIONS(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2670),
    [anon_sym_COLON_COLON] = ACTIONS(2670),
    [anon_sym_LT_COLON] = ACTIONS(2670),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [sym_break_statement] = ACTIONS(2670),
    [sym_continue_statement] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_quote] = ACTIONS(2670),
    [anon_sym_using] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_DOT] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_COLON2] = ACTIONS(2670),
    [anon_sym_LBRACK] = ACTIONS(2672),
    [anon_sym_begin] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2670),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_LT_PIPE] = ACTIONS(2670),
    [anon_sym_PIPE_GT] = ACTIONS(2670),
    [anon_sym_in] = ACTIONS(2670),
    [anon_sym_isa] = ACTIONS(2670),
    [anon_sym_PIPE_PIPE] = ACTIONS(2670),
    [anon_sym_AMP_AMP] = ACTIONS(2670),
    [anon_sym_QMARK] = ACTIONS(2670),
    [anon_sym_EQ_GT] = ACTIONS(2670),
    [anon_sym_LBRACK2] = ACTIONS(2670),
    [anon_sym_DOLLAR] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2670),
    [aux_sym_integer_literal_token1] = ACTIONS(2670),
    [aux_sym_integer_literal_token2] = ACTIONS(2670),
    [aux_sym_integer_literal_token3] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
    [sym__unary_operator] = ACTIONS(2670),
    [sym__power_operator] = ACTIONS(2670),
    [sym__bitshift_operator] = ACTIONS(2670),
    [sym__rational_operator] = ACTIONS(2670),
    [sym__times_operator] = ACTIONS(2670),
    [sym__plus_operator] = ACTIONS(2670),
    [sym__dotty_operator] = ACTIONS(2670),
    [sym__comparison_operator] = ACTIONS(2670),
    [sym__arrow_operator] = ACTIONS(2670),
    [sym__assign_operator] = ACTIONS(2670),
    [anon_sym_LF] = ACTIONS(2672),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2672),
    [sym__string_start] = ACTIONS(2672),
    [sym__command_start] = ACTIONS(2672),
  },
  [1272] = {
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_function] = ACTIONS(2686),
    [anon_sym_end] = ACTIONS(2686),
    [anon_sym_abstract] = ACTIONS(2686),
    [anon_sym_primitive] = ACTIONS(2686),
    [aux_sym_primitive_definition_token1] = ACTIONS(2686),
    [anon_sym_mutable] = ACTIONS(2686),
    [anon_sym_struct] = ACTIONS(2686),
    [anon_sym_module] = ACTIONS(2686),
    [anon_sym_macro] = ACTIONS(2686),
    [anon_sym_LPAREN] = ACTIONS(2686),
    [anon_sym_COMMA] = ACTIONS(2686),
    [anon_sym_SEMI] = ACTIONS(2686),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2686),
    [anon_sym_COLON_COLON] = ACTIONS(2686),
    [anon_sym_LT_COLON] = ACTIONS(2686),
    [anon_sym_if] = ACTIONS(2686),
    [anon_sym_elseif] = ACTIONS(2686),
    [anon_sym_else] = ACTIONS(2686),
    [anon_sym_try] = ACTIONS(2686),
    [anon_sym_for] = ACTIONS(2686),
    [anon_sym_while] = ACTIONS(2686),
    [sym_break_statement] = ACTIONS(2686),
    [sym_continue_statement] = ACTIONS(2686),
    [anon_sym_return] = ACTIONS(2686),
    [anon_sym_let] = ACTIONS(2686),
    [anon_sym_const] = ACTIONS(2686),
    [anon_sym_quote] = ACTIONS(2686),
    [anon_sym_using] = ACTIONS(2686),
    [anon_sym_import] = ACTIONS(2686),
    [anon_sym_DOT] = ACTIONS(2686),
    [anon_sym_export] = ACTIONS(2686),
    [anon_sym_COLON2] = ACTIONS(2686),
    [anon_sym_LBRACK] = ACTIONS(2688),
    [anon_sym_begin] = ACTIONS(2686),
    [anon_sym_SQUOTE] = ACTIONS(2686),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_LT_PIPE] = ACTIONS(2686),
    [anon_sym_PIPE_GT] = ACTIONS(2686),
    [anon_sym_in] = ACTIONS(2686),
    [anon_sym_isa] = ACTIONS(2686),
    [anon_sym_PIPE_PIPE] = ACTIONS(2686),
    [anon_sym_AMP_AMP] = ACTIONS(2686),
    [anon_sym_QMARK] = ACTIONS(2686),
    [anon_sym_EQ_GT] = ACTIONS(2686),
    [anon_sym_LBRACK2] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(2686),
    [anon_sym_AT] = ACTIONS(2686),
    [aux_sym_integer_literal_token1] = ACTIONS(2686),
    [aux_sym_integer_literal_token2] = ACTIONS(2686),
    [aux_sym_integer_literal_token3] = ACTIONS(2686),
    [sym_float_literal] = ACTIONS(2686),
    [sym__unary_operator] = ACTIONS(2686),
    [sym__power_operator] = ACTIONS(2686),
    [sym__bitshift_operator] = ACTIONS(2686),
    [sym__rational_operator] = ACTIONS(2686),
    [sym__times_operator] = ACTIONS(2686),
    [sym__plus_operator] = ACTIONS(2686),
    [sym__dotty_operator] = ACTIONS(2686),
    [sym__comparison_operator] = ACTIONS(2686),
    [sym__arrow_operator] = ACTIONS(2686),
    [anon_sym_LF] = ACTIONS(2688),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2688),
    [sym__string_start] = ACTIONS(2688),
    [sym__command_start] = ACTIONS(2688),
  },
  [1273] = {
    [ts_builtin_sym_end] = ACTIONS(2680),
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_primitive] = ACTIONS(2678),
    [aux_sym_primitive_definition_token1] = ACTIONS(2678),
    [anon_sym_mutable] = ACTIONS(2678),
    [anon_sym_struct] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_macro] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2678),
    [anon_sym_COMMA] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_EQ] = ACTIONS(2678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2678),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LT_COLON] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [sym_break_statement] = ACTIONS(2678),
    [sym_continue_statement] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_quote] = ACTIONS(2678),
    [anon_sym_using] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_DOT] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_COLON2] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_begin] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_LT_PIPE] = ACTIONS(2678),
    [anon_sym_PIPE_GT] = ACTIONS(2678),
    [anon_sym_in] = ACTIONS(2678),
    [anon_sym_isa] = ACTIONS(2678),
    [anon_sym_PIPE_PIPE] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_QMARK] = ACTIONS(2678),
    [anon_sym_EQ_GT] = ACTIONS(2678),
    [anon_sym_LBRACK2] = ACTIONS(2678),
    [anon_sym_DOLLAR] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2678),
    [aux_sym_integer_literal_token1] = ACTIONS(2678),
    [aux_sym_integer_literal_token2] = ACTIONS(2678),
    [aux_sym_integer_literal_token3] = ACTIONS(2678),
    [sym_float_literal] = ACTIONS(2678),
    [sym__unary_operator] = ACTIONS(2678),
    [sym__power_operator] = ACTIONS(2678),
    [sym__bitshift_operator] = ACTIONS(2678),
    [sym__rational_operator] = ACTIONS(2678),
    [sym__times_operator] = ACTIONS(2678),
    [sym__plus_operator] = ACTIONS(2678),
    [sym__dotty_operator] = ACTIONS(2678),
    [sym__comparison_operator] = ACTIONS(2678),
    [sym__arrow_operator] = ACTIONS(2678),
    [sym__assign_operator] = ACTIONS(2678),
    [anon_sym_LF] = ACTIONS(2680),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2680),
    [sym__string_start] = ACTIONS(2680),
    [sym__command_start] = ACTIONS(2680),
  },
  [1274] = {
    [aux_sym_import_statement_repeat1] = STATE(1258),
    [sym_identifier] = ACTIONS(2754),
    [anon_sym_function] = ACTIONS(2754),
    [anon_sym_end] = ACTIONS(2754),
    [anon_sym_abstract] = ACTIONS(2754),
    [anon_sym_primitive] = ACTIONS(2754),
    [aux_sym_primitive_definition_token1] = ACTIONS(2754),
    [anon_sym_mutable] = ACTIONS(2754),
    [anon_sym_struct] = ACTIONS(2754),
    [anon_sym_module] = ACTIONS(2754),
    [anon_sym_macro] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(3197),
    [anon_sym_RPAREN] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2756),
    [anon_sym_EQ] = ACTIONS(2754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(2756),
    [anon_sym_LT_COLON] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2754),
    [anon_sym_try] = ACTIONS(2754),
    [anon_sym_for] = ACTIONS(2754),
    [anon_sym_while] = ACTIONS(2754),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2754),
    [anon_sym_let] = ACTIONS(2754),
    [anon_sym_const] = ACTIONS(2754),
    [anon_sym_quote] = ACTIONS(2754),
    [anon_sym_using] = ACTIONS(2754),
    [anon_sym_import] = ACTIONS(2754),
    [anon_sym_export] = ACTIONS(2754),
    [anon_sym_COLON2] = ACTIONS(2754),
    [anon_sym_RBRACK] = ACTIONS(2756),
    [anon_sym_begin] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2754),
    [anon_sym_LT_PIPE] = ACTIONS(2756),
    [anon_sym_PIPE_GT] = ACTIONS(2756),
    [anon_sym_in] = ACTIONS(2754),
    [anon_sym_isa] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_EQ_GT] = ACTIONS(2756),
    [anon_sym_LBRACK2] = ACTIONS(2756),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [anon_sym_AT] = ACTIONS(2756),
    [aux_sym_integer_literal_token1] = ACTIONS(2756),
    [aux_sym_integer_literal_token2] = ACTIONS(2756),
    [aux_sym_integer_literal_token3] = ACTIONS(2754),
    [sym_float_literal] = ACTIONS(2754),
    [sym__unary_operator] = ACTIONS(2754),
    [sym__power_operator] = ACTIONS(2754),
    [sym__bitshift_operator] = ACTIONS(2754),
    [sym__rational_operator] = ACTIONS(2754),
    [sym__times_operator] = ACTIONS(2754),
    [sym__plus_operator] = ACTIONS(2754),
    [sym__dotty_operator] = ACTIONS(2754),
    [sym__comparison_operator] = ACTIONS(2754),
    [sym__arrow_operator] = ACTIONS(2756),
    [sym__assign_operator] = ACTIONS(2754),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2756),
    [sym__command_start] = ACTIONS(2756),
  },
  [1275] = {
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_end] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_primitive] = ACTIONS(2674),
    [aux_sym_primitive_definition_token1] = ACTIONS(2674),
    [anon_sym_mutable] = ACTIONS(2674),
    [anon_sym_struct] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_macro] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_COMMA] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2674),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_LT_COLON] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_elseif] = ACTIONS(2674),
    [anon_sym_else] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [sym_break_statement] = ACTIONS(2674),
    [sym_continue_statement] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_quote] = ACTIONS(2674),
    [anon_sym_using] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_DOT] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_COLON2] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_begin] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_LT_PIPE] = ACTIONS(2674),
    [anon_sym_PIPE_GT] = ACTIONS(2674),
    [anon_sym_in] = ACTIONS(2674),
    [anon_sym_isa] = ACTIONS(2674),
    [anon_sym_PIPE_PIPE] = ACTIONS(2674),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_QMARK] = ACTIONS(2674),
    [anon_sym_EQ_GT] = ACTIONS(2674),
    [anon_sym_LBRACK2] = ACTIONS(2674),
    [anon_sym_DOLLAR] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2674),
    [aux_sym_integer_literal_token1] = ACTIONS(2674),
    [aux_sym_integer_literal_token2] = ACTIONS(2674),
    [aux_sym_integer_literal_token3] = ACTIONS(2674),
    [sym_float_literal] = ACTIONS(2674),
    [sym__unary_operator] = ACTIONS(2674),
    [sym__power_operator] = ACTIONS(2674),
    [sym__bitshift_operator] = ACTIONS(2674),
    [sym__rational_operator] = ACTIONS(2674),
    [sym__times_operator] = ACTIONS(2674),
    [sym__plus_operator] = ACTIONS(2674),
    [sym__dotty_operator] = ACTIONS(2674),
    [sym__comparison_operator] = ACTIONS(2674),
    [sym__arrow_operator] = ACTIONS(2674),
    [anon_sym_LF] = ACTIONS(2676),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2676),
    [sym__string_start] = ACTIONS(2676),
    [sym__command_start] = ACTIONS(2676),
  },
  [1276] = {
    [sym_identifier] = ACTIONS(2678),
    [anon_sym_function] = ACTIONS(2678),
    [anon_sym_end] = ACTIONS(2678),
    [anon_sym_abstract] = ACTIONS(2678),
    [anon_sym_primitive] = ACTIONS(2678),
    [aux_sym_primitive_definition_token1] = ACTIONS(2678),
    [anon_sym_mutable] = ACTIONS(2678),
    [anon_sym_struct] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(2678),
    [anon_sym_macro] = ACTIONS(2678),
    [anon_sym_LPAREN] = ACTIONS(2678),
    [anon_sym_COMMA] = ACTIONS(2678),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2678),
    [anon_sym_COLON_COLON] = ACTIONS(2678),
    [anon_sym_LT_COLON] = ACTIONS(2678),
    [anon_sym_if] = ACTIONS(2678),
    [anon_sym_elseif] = ACTIONS(2678),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_try] = ACTIONS(2678),
    [anon_sym_for] = ACTIONS(2678),
    [anon_sym_while] = ACTIONS(2678),
    [sym_break_statement] = ACTIONS(2678),
    [sym_continue_statement] = ACTIONS(2678),
    [anon_sym_return] = ACTIONS(2678),
    [anon_sym_let] = ACTIONS(2678),
    [anon_sym_const] = ACTIONS(2678),
    [anon_sym_quote] = ACTIONS(2678),
    [anon_sym_using] = ACTIONS(2678),
    [anon_sym_import] = ACTIONS(2678),
    [anon_sym_DOT] = ACTIONS(2678),
    [anon_sym_export] = ACTIONS(2678),
    [anon_sym_COLON2] = ACTIONS(2678),
    [anon_sym_LBRACK] = ACTIONS(2680),
    [anon_sym_begin] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym_PLUS] = ACTIONS(2678),
    [anon_sym_LT_PIPE] = ACTIONS(2678),
    [anon_sym_PIPE_GT] = ACTIONS(2678),
    [anon_sym_in] = ACTIONS(2678),
    [anon_sym_isa] = ACTIONS(2678),
    [anon_sym_PIPE_PIPE] = ACTIONS(2678),
    [anon_sym_AMP_AMP] = ACTIONS(2678),
    [anon_sym_QMARK] = ACTIONS(2678),
    [anon_sym_EQ_GT] = ACTIONS(2678),
    [anon_sym_LBRACK2] = ACTIONS(2678),
    [anon_sym_DOLLAR] = ACTIONS(2678),
    [anon_sym_AT] = ACTIONS(2678),
    [aux_sym_integer_literal_token1] = ACTIONS(2678),
    [aux_sym_integer_literal_token2] = ACTIONS(2678),
    [aux_sym_integer_literal_token3] = ACTIONS(2678),
    [sym_float_literal] = ACTIONS(2678),
    [sym__unary_operator] = ACTIONS(2678),
    [sym__power_operator] = ACTIONS(2678),
    [sym__bitshift_operator] = ACTIONS(2678),
    [sym__rational_operator] = ACTIONS(2678),
    [sym__times_operator] = ACTIONS(2678),
    [sym__plus_operator] = ACTIONS(2678),
    [sym__dotty_operator] = ACTIONS(2678),
    [sym__comparison_operator] = ACTIONS(2678),
    [sym__arrow_operator] = ACTIONS(2678),
    [anon_sym_LF] = ACTIONS(2680),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2680),
    [sym__string_start] = ACTIONS(2680),
    [sym__command_start] = ACTIONS(2680),
  },
  [1277] = {
    [sym_identifier] = ACTIONS(2682),
    [anon_sym_function] = ACTIONS(2682),
    [anon_sym_end] = ACTIONS(2682),
    [anon_sym_abstract] = ACTIONS(2682),
    [anon_sym_primitive] = ACTIONS(2682),
    [aux_sym_primitive_definition_token1] = ACTIONS(2682),
    [anon_sym_mutable] = ACTIONS(2682),
    [anon_sym_struct] = ACTIONS(2682),
    [anon_sym_module] = ACTIONS(2682),
    [anon_sym_macro] = ACTIONS(2682),
    [anon_sym_LPAREN] = ACTIONS(2682),
    [anon_sym_COMMA] = ACTIONS(2682),
    [anon_sym_SEMI] = ACTIONS(2682),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2682),
    [anon_sym_COLON_COLON] = ACTIONS(2682),
    [anon_sym_LT_COLON] = ACTIONS(2682),
    [anon_sym_if] = ACTIONS(2682),
    [anon_sym_elseif] = ACTIONS(2682),
    [anon_sym_else] = ACTIONS(2682),
    [anon_sym_try] = ACTIONS(2682),
    [anon_sym_for] = ACTIONS(2682),
    [anon_sym_while] = ACTIONS(2682),
    [sym_break_statement] = ACTIONS(2682),
    [sym_continue_statement] = ACTIONS(2682),
    [anon_sym_return] = ACTIONS(2682),
    [anon_sym_let] = ACTIONS(2682),
    [anon_sym_const] = ACTIONS(2682),
    [anon_sym_quote] = ACTIONS(2682),
    [anon_sym_using] = ACTIONS(2682),
    [anon_sym_import] = ACTIONS(2682),
    [anon_sym_DOT] = ACTIONS(2682),
    [anon_sym_export] = ACTIONS(2682),
    [anon_sym_COLON2] = ACTIONS(2682),
    [anon_sym_LBRACK] = ACTIONS(2684),
    [anon_sym_begin] = ACTIONS(2682),
    [anon_sym_SQUOTE] = ACTIONS(2682),
    [anon_sym_PLUS] = ACTIONS(2682),
    [anon_sym_LT_PIPE] = ACTIONS(2682),
    [anon_sym_PIPE_GT] = ACTIONS(2682),
    [anon_sym_in] = ACTIONS(2682),
    [anon_sym_isa] = ACTIONS(2682),
    [anon_sym_PIPE_PIPE] = ACTIONS(2682),
    [anon_sym_AMP_AMP] = ACTIONS(2682),
    [anon_sym_QMARK] = ACTIONS(2682),
    [anon_sym_EQ_GT] = ACTIONS(2682),
    [anon_sym_LBRACK2] = ACTIONS(2682),
    [anon_sym_DOLLAR] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2682),
    [aux_sym_integer_literal_token1] = ACTIONS(2682),
    [aux_sym_integer_literal_token2] = ACTIONS(2682),
    [aux_sym_integer_literal_token3] = ACTIONS(2682),
    [sym_float_literal] = ACTIONS(2682),
    [sym__unary_operator] = ACTIONS(2682),
    [sym__power_operator] = ACTIONS(2682),
    [sym__bitshift_operator] = ACTIONS(2682),
    [sym__rational_operator] = ACTIONS(2682),
    [sym__times_operator] = ACTIONS(2682),
    [sym__plus_operator] = ACTIONS(2682),
    [sym__dotty_operator] = ACTIONS(2682),
    [sym__comparison_operator] = ACTIONS(2682),
    [sym__arrow_operator] = ACTIONS(2682),
    [anon_sym_LF] = ACTIONS(2684),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2684),
    [sym__string_start] = ACTIONS(2684),
    [sym__command_start] = ACTIONS(2684),
  },
  [1278] = {
    [sym_identifier] = ACTIONS(2720),
    [anon_sym_function] = ACTIONS(2720),
    [anon_sym_end] = ACTIONS(2720),
    [anon_sym_abstract] = ACTIONS(2720),
    [anon_sym_primitive] = ACTIONS(2720),
    [aux_sym_primitive_definition_token1] = ACTIONS(2720),
    [anon_sym_mutable] = ACTIONS(2720),
    [anon_sym_struct] = ACTIONS(2720),
    [anon_sym_module] = ACTIONS(2720),
    [anon_sym_macro] = ACTIONS(2720),
    [anon_sym_LPAREN] = ACTIONS(2720),
    [anon_sym_COMMA] = ACTIONS(2720),
    [anon_sym_SEMI] = ACTIONS(2720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2720),
    [anon_sym_COLON_COLON] = ACTIONS(2720),
    [anon_sym_LT_COLON] = ACTIONS(2720),
    [anon_sym_if] = ACTIONS(2720),
    [anon_sym_elseif] = ACTIONS(2720),
    [anon_sym_else] = ACTIONS(2720),
    [anon_sym_try] = ACTIONS(2720),
    [anon_sym_for] = ACTIONS(2720),
    [anon_sym_while] = ACTIONS(2720),
    [sym_break_statement] = ACTIONS(2720),
    [sym_continue_statement] = ACTIONS(2720),
    [anon_sym_return] = ACTIONS(2720),
    [anon_sym_let] = ACTIONS(2720),
    [anon_sym_const] = ACTIONS(2720),
    [anon_sym_quote] = ACTIONS(2720),
    [anon_sym_using] = ACTIONS(2720),
    [anon_sym_import] = ACTIONS(2720),
    [anon_sym_DOT] = ACTIONS(2720),
    [anon_sym_export] = ACTIONS(2720),
    [anon_sym_COLON2] = ACTIONS(2720),
    [anon_sym_LBRACK] = ACTIONS(2722),
    [anon_sym_begin] = ACTIONS(2720),
    [anon_sym_SQUOTE] = ACTIONS(2720),
    [anon_sym_PLUS] = ACTIONS(2720),
    [anon_sym_LT_PIPE] = ACTIONS(2720),
    [anon_sym_PIPE_GT] = ACTIONS(2720),
    [anon_sym_in] = ACTIONS(2720),
    [anon_sym_isa] = ACTIONS(2720),
    [anon_sym_PIPE_PIPE] = ACTIONS(2720),
    [anon_sym_AMP_AMP] = ACTIONS(2720),
    [anon_sym_QMARK] = ACTIONS(2720),
    [anon_sym_EQ_GT] = ACTIONS(2720),
    [anon_sym_LBRACK2] = ACTIONS(2720),
    [anon_sym_DOLLAR] = ACTIONS(2720),
    [anon_sym_AT] = ACTIONS(2720),
    [aux_sym_integer_literal_token1] = ACTIONS(2720),
    [aux_sym_integer_literal_token2] = ACTIONS(2720),
    [aux_sym_integer_literal_token3] = ACTIONS(2720),
    [sym_float_literal] = ACTIONS(2720),
    [sym__unary_operator] = ACTIONS(2720),
    [sym__power_operator] = ACTIONS(2720),
    [sym__bitshift_operator] = ACTIONS(2720),
    [sym__rational_operator] = ACTIONS(2720),
    [sym__times_operator] = ACTIONS(2720),
    [sym__plus_operator] = ACTIONS(2720),
    [sym__dotty_operator] = ACTIONS(2720),
    [sym__comparison_operator] = ACTIONS(2720),
    [sym__arrow_operator] = ACTIONS(2720),
    [anon_sym_LF] = ACTIONS(2722),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2722),
    [sym__string_start] = ACTIONS(2722),
    [sym__command_start] = ACTIONS(2722),
  },
  [1279] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(2869),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(3307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_elseif] = ACTIONS(2837),
    [anon_sym_else] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2837),
    [aux_sym_integer_literal_token1] = ACTIONS(2837),
    [aux_sym_integer_literal_token2] = ACTIONS(2837),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(3307),
    [anon_sym_LF] = ACTIONS(2867),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1280] = {
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_function] = ACTIONS(2628),
    [anon_sym_end] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_primitive] = ACTIONS(2628),
    [aux_sym_primitive_definition_token1] = ACTIONS(2628),
    [anon_sym_mutable] = ACTIONS(2628),
    [anon_sym_struct] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_macro] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2628),
    [anon_sym_COMMA] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2628),
    [anon_sym_COLON_COLON] = ACTIONS(2628),
    [anon_sym_LT_COLON] = ACTIONS(2628),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_elseif] = ACTIONS(2628),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [sym_break_statement] = ACTIONS(2628),
    [sym_continue_statement] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [anon_sym_quote] = ACTIONS(2628),
    [anon_sym_using] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_DOT] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_COLON2] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [anon_sym_begin] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_LT_PIPE] = ACTIONS(2628),
    [anon_sym_PIPE_GT] = ACTIONS(2628),
    [anon_sym_in] = ACTIONS(2628),
    [anon_sym_isa] = ACTIONS(2628),
    [anon_sym_PIPE_PIPE] = ACTIONS(2628),
    [anon_sym_AMP_AMP] = ACTIONS(2628),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_EQ_GT] = ACTIONS(2628),
    [anon_sym_LBRACK2] = ACTIONS(2628),
    [anon_sym_DOLLAR] = ACTIONS(2628),
    [anon_sym_AT] = ACTIONS(2628),
    [aux_sym_integer_literal_token1] = ACTIONS(2628),
    [aux_sym_integer_literal_token2] = ACTIONS(2628),
    [aux_sym_integer_literal_token3] = ACTIONS(2628),
    [sym_float_literal] = ACTIONS(2628),
    [sym__unary_operator] = ACTIONS(2628),
    [sym__power_operator] = ACTIONS(2628),
    [sym__bitshift_operator] = ACTIONS(2628),
    [sym__rational_operator] = ACTIONS(2628),
    [sym__times_operator] = ACTIONS(2628),
    [sym__plus_operator] = ACTIONS(2628),
    [sym__dotty_operator] = ACTIONS(2628),
    [sym__comparison_operator] = ACTIONS(2628),
    [sym__arrow_operator] = ACTIONS(2628),
    [anon_sym_LF] = ACTIONS(2630),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2630),
    [sym__string_start] = ACTIONS(2630),
    [sym__command_start] = ACTIONS(2630),
  },
  [1281] = {
    [sym_identifier] = ACTIONS(2624),
    [anon_sym_function] = ACTIONS(2624),
    [anon_sym_end] = ACTIONS(2624),
    [anon_sym_abstract] = ACTIONS(2624),
    [anon_sym_primitive] = ACTIONS(2624),
    [aux_sym_primitive_definition_token1] = ACTIONS(2624),
    [anon_sym_mutable] = ACTIONS(2624),
    [anon_sym_struct] = ACTIONS(2624),
    [anon_sym_module] = ACTIONS(2624),
    [anon_sym_macro] = ACTIONS(2624),
    [anon_sym_LPAREN] = ACTIONS(2624),
    [anon_sym_COMMA] = ACTIONS(2624),
    [anon_sym_SEMI] = ACTIONS(2624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2624),
    [anon_sym_COLON_COLON] = ACTIONS(2624),
    [anon_sym_LT_COLON] = ACTIONS(2624),
    [anon_sym_if] = ACTIONS(2624),
    [anon_sym_elseif] = ACTIONS(2624),
    [anon_sym_else] = ACTIONS(2624),
    [anon_sym_try] = ACTIONS(2624),
    [anon_sym_for] = ACTIONS(2624),
    [anon_sym_while] = ACTIONS(2624),
    [sym_break_statement] = ACTIONS(2624),
    [sym_continue_statement] = ACTIONS(2624),
    [anon_sym_return] = ACTIONS(2624),
    [anon_sym_let] = ACTIONS(2624),
    [anon_sym_const] = ACTIONS(2624),
    [anon_sym_quote] = ACTIONS(2624),
    [anon_sym_using] = ACTIONS(2624),
    [anon_sym_import] = ACTIONS(2624),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_export] = ACTIONS(2624),
    [anon_sym_COLON2] = ACTIONS(2624),
    [anon_sym_LBRACK] = ACTIONS(2626),
    [anon_sym_begin] = ACTIONS(2624),
    [anon_sym_SQUOTE] = ACTIONS(2624),
    [anon_sym_PLUS] = ACTIONS(2624),
    [anon_sym_LT_PIPE] = ACTIONS(2624),
    [anon_sym_PIPE_GT] = ACTIONS(2624),
    [anon_sym_in] = ACTIONS(2624),
    [anon_sym_isa] = ACTIONS(2624),
    [anon_sym_PIPE_PIPE] = ACTIONS(2624),
    [anon_sym_AMP_AMP] = ACTIONS(2624),
    [anon_sym_QMARK] = ACTIONS(2624),
    [anon_sym_EQ_GT] = ACTIONS(2624),
    [anon_sym_LBRACK2] = ACTIONS(2624),
    [anon_sym_DOLLAR] = ACTIONS(2624),
    [anon_sym_AT] = ACTIONS(2624),
    [aux_sym_integer_literal_token1] = ACTIONS(2624),
    [aux_sym_integer_literal_token2] = ACTIONS(2624),
    [aux_sym_integer_literal_token3] = ACTIONS(2624),
    [sym_float_literal] = ACTIONS(2624),
    [sym__unary_operator] = ACTIONS(2624),
    [sym__power_operator] = ACTIONS(2624),
    [sym__bitshift_operator] = ACTIONS(2624),
    [sym__rational_operator] = ACTIONS(2624),
    [sym__times_operator] = ACTIONS(2624),
    [sym__plus_operator] = ACTIONS(2624),
    [sym__dotty_operator] = ACTIONS(2624),
    [sym__comparison_operator] = ACTIONS(2624),
    [sym__arrow_operator] = ACTIONS(2624),
    [anon_sym_LF] = ACTIONS(2626),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2626),
    [sym__string_start] = ACTIONS(2626),
    [sym__command_start] = ACTIONS(2626),
  },
  [1282] = {
    [aux_sym_export_statement_repeat1] = STATE(1257),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_function] = ACTIONS(2795),
    [anon_sym_end] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2795),
    [anon_sym_primitive] = ACTIONS(2795),
    [aux_sym_primitive_definition_token1] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_macro] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_COMMA] = ACTIONS(3323),
    [anon_sym_RPAREN] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_EQ] = ACTIONS(2795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_LT_COLON] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [sym_break_statement] = ACTIONS(2795),
    [sym_continue_statement] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_let] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_quote] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_import] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2795),
    [anon_sym_COLON2] = ACTIONS(2795),
    [anon_sym_RBRACK] = ACTIONS(2799),
    [anon_sym_begin] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_LT_PIPE] = ACTIONS(2799),
    [anon_sym_PIPE_GT] = ACTIONS(2799),
    [anon_sym_in] = ACTIONS(2795),
    [anon_sym_isa] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_QMARK] = ACTIONS(2799),
    [anon_sym_EQ_GT] = ACTIONS(2799),
    [anon_sym_LBRACK2] = ACTIONS(2799),
    [anon_sym_DOLLAR] = ACTIONS(2795),
    [anon_sym_AT] = ACTIONS(2799),
    [aux_sym_integer_literal_token1] = ACTIONS(2799),
    [aux_sym_integer_literal_token2] = ACTIONS(2799),
    [aux_sym_integer_literal_token3] = ACTIONS(2795),
    [sym_float_literal] = ACTIONS(2795),
    [sym__unary_operator] = ACTIONS(2795),
    [sym__power_operator] = ACTIONS(2795),
    [sym__bitshift_operator] = ACTIONS(2795),
    [sym__rational_operator] = ACTIONS(2795),
    [sym__times_operator] = ACTIONS(2795),
    [sym__plus_operator] = ACTIONS(2795),
    [sym__dotty_operator] = ACTIONS(2795),
    [sym__comparison_operator] = ACTIONS(2795),
    [sym__arrow_operator] = ACTIONS(2799),
    [sym__assign_operator] = ACTIONS(2795),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2799),
    [sym__command_start] = ACTIONS(2799),
  },
  [1283] = {
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_function] = ACTIONS(2779),
    [anon_sym_end] = ACTIONS(2779),
    [anon_sym_abstract] = ACTIONS(2779),
    [anon_sym_primitive] = ACTIONS(2779),
    [aux_sym_primitive_definition_token1] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_module] = ACTIONS(2779),
    [anon_sym_macro] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2781),
    [anon_sym_RPAREN] = ACTIONS(2781),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_EQ] = ACTIONS(2779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2781),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_LT_COLON] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [sym_break_statement] = ACTIONS(2779),
    [sym_continue_statement] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_let] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_quote] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_import] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(2779),
    [anon_sym_COLON2] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [anon_sym_RBRACK] = ACTIONS(2781),
    [anon_sym_begin] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_LT_PIPE] = ACTIONS(2781),
    [anon_sym_PIPE_GT] = ACTIONS(2781),
    [anon_sym_in] = ACTIONS(2779),
    [anon_sym_isa] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(2781),
    [anon_sym_EQ_GT] = ACTIONS(2781),
    [anon_sym_LBRACK2] = ACTIONS(2779),
    [anon_sym_DOLLAR] = ACTIONS(2779),
    [anon_sym_AT] = ACTIONS(2781),
    [aux_sym_integer_literal_token1] = ACTIONS(2781),
    [aux_sym_integer_literal_token2] = ACTIONS(2781),
    [aux_sym_integer_literal_token3] = ACTIONS(2779),
    [sym_float_literal] = ACTIONS(2779),
    [sym__unary_operator] = ACTIONS(2779),
    [sym__power_operator] = ACTIONS(2779),
    [sym__bitshift_operator] = ACTIONS(2779),
    [sym__rational_operator] = ACTIONS(2779),
    [sym__times_operator] = ACTIONS(2779),
    [sym__plus_operator] = ACTIONS(2779),
    [sym__dotty_operator] = ACTIONS(2779),
    [sym__comparison_operator] = ACTIONS(2779),
    [sym__arrow_operator] = ACTIONS(2781),
    [sym__assign_operator] = ACTIONS(2779),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2781),
    [sym__command_start] = ACTIONS(2781),
  },
  [1284] = {
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_end] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_primitive] = ACTIONS(2904),
    [aux_sym_primitive_definition_token1] = ACTIONS(2904),
    [anon_sym_mutable] = ACTIONS(2904),
    [anon_sym_struct] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_macro] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2906),
    [anon_sym_RPAREN] = ACTIONS(2906),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_LT_COLON] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [sym_break_statement] = ACTIONS(2904),
    [sym_continue_statement] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_quote] = ACTIONS(2904),
    [anon_sym_using] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_COLON2] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_RBRACK] = ACTIONS(2906),
    [anon_sym_begin] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_LT_PIPE] = ACTIONS(2906),
    [anon_sym_PIPE_GT] = ACTIONS(2906),
    [anon_sym_in] = ACTIONS(2904),
    [anon_sym_isa] = ACTIONS(2904),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_EQ_GT] = ACTIONS(2906),
    [anon_sym_LBRACK2] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2904),
    [anon_sym_AT] = ACTIONS(2906),
    [aux_sym_integer_literal_token1] = ACTIONS(2906),
    [aux_sym_integer_literal_token2] = ACTIONS(2906),
    [aux_sym_integer_literal_token3] = ACTIONS(2904),
    [sym_float_literal] = ACTIONS(2904),
    [sym__unary_operator] = ACTIONS(2904),
    [sym__power_operator] = ACTIONS(2904),
    [sym__bitshift_operator] = ACTIONS(2904),
    [sym__rational_operator] = ACTIONS(2904),
    [sym__times_operator] = ACTIONS(2904),
    [sym__plus_operator] = ACTIONS(2904),
    [sym__dotty_operator] = ACTIONS(2904),
    [sym__comparison_operator] = ACTIONS(2904),
    [sym__arrow_operator] = ACTIONS(2906),
    [sym__assign_operator] = ACTIONS(2904),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2906),
    [sym__command_start] = ACTIONS(2906),
  },
  [1285] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2813),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(3286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elseif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2843),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_GT] = ACTIONS(2851),
    [anon_sym_in] = ACTIONS(2853),
    [anon_sym_isa] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2875),
    [anon_sym_AMP_AMP] = ACTIONS(2877),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2881),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(2863),
    [sym__comparison_operator] = ACTIONS(2853),
    [sym__arrow_operator] = ACTIONS(2865),
    [sym__assign_operator] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1286] = {
    [sym_identifier] = ACTIONS(2620),
    [anon_sym_function] = ACTIONS(2620),
    [anon_sym_end] = ACTIONS(2620),
    [anon_sym_abstract] = ACTIONS(2620),
    [anon_sym_primitive] = ACTIONS(2620),
    [aux_sym_primitive_definition_token1] = ACTIONS(2620),
    [anon_sym_mutable] = ACTIONS(2620),
    [anon_sym_struct] = ACTIONS(2620),
    [anon_sym_module] = ACTIONS(2620),
    [anon_sym_macro] = ACTIONS(2620),
    [anon_sym_LPAREN] = ACTIONS(2620),
    [anon_sym_COMMA] = ACTIONS(2620),
    [anon_sym_SEMI] = ACTIONS(2620),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2620),
    [anon_sym_COLON_COLON] = ACTIONS(2620),
    [anon_sym_LT_COLON] = ACTIONS(2620),
    [anon_sym_if] = ACTIONS(2620),
    [anon_sym_elseif] = ACTIONS(2620),
    [anon_sym_else] = ACTIONS(2620),
    [anon_sym_try] = ACTIONS(2620),
    [anon_sym_for] = ACTIONS(2620),
    [anon_sym_while] = ACTIONS(2620),
    [sym_break_statement] = ACTIONS(2620),
    [sym_continue_statement] = ACTIONS(2620),
    [anon_sym_return] = ACTIONS(2620),
    [anon_sym_let] = ACTIONS(2620),
    [anon_sym_const] = ACTIONS(2620),
    [anon_sym_quote] = ACTIONS(2620),
    [anon_sym_using] = ACTIONS(2620),
    [anon_sym_import] = ACTIONS(2620),
    [anon_sym_DOT] = ACTIONS(2620),
    [anon_sym_export] = ACTIONS(2620),
    [anon_sym_COLON2] = ACTIONS(2620),
    [anon_sym_LBRACK] = ACTIONS(2622),
    [anon_sym_begin] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2620),
    [anon_sym_PLUS] = ACTIONS(2620),
    [anon_sym_LT_PIPE] = ACTIONS(2620),
    [anon_sym_PIPE_GT] = ACTIONS(2620),
    [anon_sym_in] = ACTIONS(2620),
    [anon_sym_isa] = ACTIONS(2620),
    [anon_sym_PIPE_PIPE] = ACTIONS(2620),
    [anon_sym_AMP_AMP] = ACTIONS(2620),
    [anon_sym_QMARK] = ACTIONS(2620),
    [anon_sym_EQ_GT] = ACTIONS(2620),
    [anon_sym_LBRACK2] = ACTIONS(2620),
    [anon_sym_DOLLAR] = ACTIONS(2620),
    [anon_sym_AT] = ACTIONS(2620),
    [aux_sym_integer_literal_token1] = ACTIONS(2620),
    [aux_sym_integer_literal_token2] = ACTIONS(2620),
    [aux_sym_integer_literal_token3] = ACTIONS(2620),
    [sym_float_literal] = ACTIONS(2620),
    [sym__unary_operator] = ACTIONS(2620),
    [sym__power_operator] = ACTIONS(2620),
    [sym__bitshift_operator] = ACTIONS(2620),
    [sym__rational_operator] = ACTIONS(2620),
    [sym__times_operator] = ACTIONS(2620),
    [sym__plus_operator] = ACTIONS(2620),
    [sym__dotty_operator] = ACTIONS(2620),
    [sym__comparison_operator] = ACTIONS(2620),
    [sym__arrow_operator] = ACTIONS(2620),
    [anon_sym_LF] = ACTIONS(2622),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2622),
    [sym__string_start] = ACTIONS(2622),
    [sym__command_start] = ACTIONS(2622),
  },
  [1287] = {
    [sym_identifier] = ACTIONS(2616),
    [anon_sym_function] = ACTIONS(2616),
    [anon_sym_end] = ACTIONS(2616),
    [anon_sym_abstract] = ACTIONS(2616),
    [anon_sym_primitive] = ACTIONS(2616),
    [aux_sym_primitive_definition_token1] = ACTIONS(2616),
    [anon_sym_mutable] = ACTIONS(2616),
    [anon_sym_struct] = ACTIONS(2616),
    [anon_sym_module] = ACTIONS(2616),
    [anon_sym_macro] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2616),
    [anon_sym_COMMA] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2616),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2616),
    [anon_sym_COLON_COLON] = ACTIONS(2616),
    [anon_sym_LT_COLON] = ACTIONS(2616),
    [anon_sym_if] = ACTIONS(2616),
    [anon_sym_elseif] = ACTIONS(2616),
    [anon_sym_else] = ACTIONS(2616),
    [anon_sym_try] = ACTIONS(2616),
    [anon_sym_for] = ACTIONS(2616),
    [anon_sym_while] = ACTIONS(2616),
    [sym_break_statement] = ACTIONS(2616),
    [sym_continue_statement] = ACTIONS(2616),
    [anon_sym_return] = ACTIONS(2616),
    [anon_sym_let] = ACTIONS(2616),
    [anon_sym_const] = ACTIONS(2616),
    [anon_sym_quote] = ACTIONS(2616),
    [anon_sym_using] = ACTIONS(2616),
    [anon_sym_import] = ACTIONS(2616),
    [anon_sym_DOT] = ACTIONS(2616),
    [anon_sym_export] = ACTIONS(2616),
    [anon_sym_COLON2] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2618),
    [anon_sym_begin] = ACTIONS(2616),
    [anon_sym_SQUOTE] = ACTIONS(2616),
    [anon_sym_PLUS] = ACTIONS(2616),
    [anon_sym_LT_PIPE] = ACTIONS(2616),
    [anon_sym_PIPE_GT] = ACTIONS(2616),
    [anon_sym_in] = ACTIONS(2616),
    [anon_sym_isa] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_QMARK] = ACTIONS(2616),
    [anon_sym_EQ_GT] = ACTIONS(2616),
    [anon_sym_LBRACK2] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2616),
    [anon_sym_AT] = ACTIONS(2616),
    [aux_sym_integer_literal_token1] = ACTIONS(2616),
    [aux_sym_integer_literal_token2] = ACTIONS(2616),
    [aux_sym_integer_literal_token3] = ACTIONS(2616),
    [sym_float_literal] = ACTIONS(2616),
    [sym__unary_operator] = ACTIONS(2616),
    [sym__power_operator] = ACTIONS(2616),
    [sym__bitshift_operator] = ACTIONS(2616),
    [sym__rational_operator] = ACTIONS(2616),
    [sym__times_operator] = ACTIONS(2616),
    [sym__plus_operator] = ACTIONS(2616),
    [sym__dotty_operator] = ACTIONS(2616),
    [sym__comparison_operator] = ACTIONS(2616),
    [sym__arrow_operator] = ACTIONS(2616),
    [anon_sym_LF] = ACTIONS(2618),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2618),
    [sym__string_start] = ACTIONS(2618),
    [sym__command_start] = ACTIONS(2618),
  },
  [1288] = {
    [sym_identifier] = ACTIONS(2612),
    [anon_sym_function] = ACTIONS(2612),
    [anon_sym_end] = ACTIONS(2612),
    [anon_sym_abstract] = ACTIONS(2612),
    [anon_sym_primitive] = ACTIONS(2612),
    [aux_sym_primitive_definition_token1] = ACTIONS(2612),
    [anon_sym_mutable] = ACTIONS(2612),
    [anon_sym_struct] = ACTIONS(2612),
    [anon_sym_module] = ACTIONS(2612),
    [anon_sym_macro] = ACTIONS(2612),
    [anon_sym_LPAREN] = ACTIONS(2612),
    [anon_sym_COMMA] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2612),
    [anon_sym_COLON_COLON] = ACTIONS(2612),
    [anon_sym_LT_COLON] = ACTIONS(2612),
    [anon_sym_if] = ACTIONS(2612),
    [anon_sym_elseif] = ACTIONS(2612),
    [anon_sym_else] = ACTIONS(2612),
    [anon_sym_try] = ACTIONS(2612),
    [anon_sym_for] = ACTIONS(2612),
    [anon_sym_while] = ACTIONS(2612),
    [sym_break_statement] = ACTIONS(2612),
    [sym_continue_statement] = ACTIONS(2612),
    [anon_sym_return] = ACTIONS(2612),
    [anon_sym_let] = ACTIONS(2612),
    [anon_sym_const] = ACTIONS(2612),
    [anon_sym_quote] = ACTIONS(2612),
    [anon_sym_using] = ACTIONS(2612),
    [anon_sym_import] = ACTIONS(2612),
    [anon_sym_DOT] = ACTIONS(2612),
    [anon_sym_export] = ACTIONS(2612),
    [anon_sym_COLON2] = ACTIONS(2612),
    [anon_sym_LBRACK] = ACTIONS(2614),
    [anon_sym_begin] = ACTIONS(2612),
    [anon_sym_SQUOTE] = ACTIONS(2612),
    [anon_sym_PLUS] = ACTIONS(2612),
    [anon_sym_LT_PIPE] = ACTIONS(2612),
    [anon_sym_PIPE_GT] = ACTIONS(2612),
    [anon_sym_in] = ACTIONS(2612),
    [anon_sym_isa] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_QMARK] = ACTIONS(2612),
    [anon_sym_EQ_GT] = ACTIONS(2612),
    [anon_sym_LBRACK2] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2612),
    [anon_sym_AT] = ACTIONS(2612),
    [aux_sym_integer_literal_token1] = ACTIONS(2612),
    [aux_sym_integer_literal_token2] = ACTIONS(2612),
    [aux_sym_integer_literal_token3] = ACTIONS(2612),
    [sym_float_literal] = ACTIONS(2612),
    [sym__unary_operator] = ACTIONS(2612),
    [sym__power_operator] = ACTIONS(2612),
    [sym__bitshift_operator] = ACTIONS(2612),
    [sym__rational_operator] = ACTIONS(2612),
    [sym__times_operator] = ACTIONS(2612),
    [sym__plus_operator] = ACTIONS(2612),
    [sym__dotty_operator] = ACTIONS(2612),
    [sym__comparison_operator] = ACTIONS(2612),
    [sym__arrow_operator] = ACTIONS(2612),
    [anon_sym_LF] = ACTIONS(2614),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2614),
    [sym__string_start] = ACTIONS(2614),
    [sym__command_start] = ACTIONS(2614),
  },
  [1289] = {
    [ts_builtin_sym_end] = ACTIONS(2676),
    [sym_identifier] = ACTIONS(2674),
    [anon_sym_function] = ACTIONS(2674),
    [anon_sym_abstract] = ACTIONS(2674),
    [anon_sym_primitive] = ACTIONS(2674),
    [aux_sym_primitive_definition_token1] = ACTIONS(2674),
    [anon_sym_mutable] = ACTIONS(2674),
    [anon_sym_struct] = ACTIONS(2674),
    [anon_sym_module] = ACTIONS(2674),
    [anon_sym_macro] = ACTIONS(2674),
    [anon_sym_LPAREN] = ACTIONS(2674),
    [anon_sym_COMMA] = ACTIONS(2674),
    [anon_sym_SEMI] = ACTIONS(2674),
    [anon_sym_EQ] = ACTIONS(2674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2674),
    [anon_sym_COLON_COLON] = ACTIONS(2674),
    [anon_sym_LT_COLON] = ACTIONS(2674),
    [anon_sym_if] = ACTIONS(2674),
    [anon_sym_try] = ACTIONS(2674),
    [anon_sym_for] = ACTIONS(2674),
    [anon_sym_while] = ACTIONS(2674),
    [sym_break_statement] = ACTIONS(2674),
    [sym_continue_statement] = ACTIONS(2674),
    [anon_sym_return] = ACTIONS(2674),
    [anon_sym_let] = ACTIONS(2674),
    [anon_sym_const] = ACTIONS(2674),
    [anon_sym_quote] = ACTIONS(2674),
    [anon_sym_using] = ACTIONS(2674),
    [anon_sym_import] = ACTIONS(2674),
    [anon_sym_DOT] = ACTIONS(2674),
    [anon_sym_export] = ACTIONS(2674),
    [anon_sym_COLON2] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2676),
    [anon_sym_begin] = ACTIONS(2674),
    [anon_sym_SQUOTE] = ACTIONS(2674),
    [anon_sym_PLUS] = ACTIONS(2674),
    [anon_sym_LT_PIPE] = ACTIONS(2674),
    [anon_sym_PIPE_GT] = ACTIONS(2674),
    [anon_sym_in] = ACTIONS(2674),
    [anon_sym_isa] = ACTIONS(2674),
    [anon_sym_PIPE_PIPE] = ACTIONS(2674),
    [anon_sym_AMP_AMP] = ACTIONS(2674),
    [anon_sym_QMARK] = ACTIONS(2674),
    [anon_sym_EQ_GT] = ACTIONS(2674),
    [anon_sym_LBRACK2] = ACTIONS(2674),
    [anon_sym_DOLLAR] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2674),
    [aux_sym_integer_literal_token1] = ACTIONS(2674),
    [aux_sym_integer_literal_token2] = ACTIONS(2674),
    [aux_sym_integer_literal_token3] = ACTIONS(2674),
    [sym_float_literal] = ACTIONS(2674),
    [sym__unary_operator] = ACTIONS(2674),
    [sym__power_operator] = ACTIONS(2674),
    [sym__bitshift_operator] = ACTIONS(2674),
    [sym__rational_operator] = ACTIONS(2674),
    [sym__times_operator] = ACTIONS(2674),
    [sym__plus_operator] = ACTIONS(2674),
    [sym__dotty_operator] = ACTIONS(2674),
    [sym__comparison_operator] = ACTIONS(2674),
    [sym__arrow_operator] = ACTIONS(2674),
    [sym__assign_operator] = ACTIONS(2674),
    [anon_sym_LF] = ACTIONS(2676),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2676),
    [sym__string_start] = ACTIONS(2676),
    [sym__command_start] = ACTIONS(2676),
  },
  [1290] = {
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_end] = ACTIONS(2758),
    [anon_sym_abstract] = ACTIONS(2758),
    [anon_sym_primitive] = ACTIONS(2758),
    [aux_sym_primitive_definition_token1] = ACTIONS(2758),
    [anon_sym_mutable] = ACTIONS(2758),
    [anon_sym_struct] = ACTIONS(2758),
    [anon_sym_module] = ACTIONS(2758),
    [anon_sym_macro] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2760),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2760),
    [anon_sym_RBRACE] = ACTIONS(2760),
    [anon_sym_LT_COLON] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_try] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [sym_break_statement] = ACTIONS(2758),
    [sym_continue_statement] = ACTIONS(2758),
    [anon_sym_return] = ACTIONS(2758),
    [anon_sym_let] = ACTIONS(2758),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_quote] = ACTIONS(2758),
    [anon_sym_using] = ACTIONS(2758),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_export] = ACTIONS(2758),
    [anon_sym_COLON2] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_RBRACK] = ACTIONS(2760),
    [anon_sym_begin] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2758),
    [anon_sym_LT_PIPE] = ACTIONS(2760),
    [anon_sym_PIPE_GT] = ACTIONS(2760),
    [anon_sym_in] = ACTIONS(2758),
    [anon_sym_isa] = ACTIONS(2758),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_EQ_GT] = ACTIONS(2760),
    [anon_sym_LBRACK2] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2758),
    [anon_sym_AT] = ACTIONS(2760),
    [aux_sym_integer_literal_token1] = ACTIONS(2760),
    [aux_sym_integer_literal_token2] = ACTIONS(2760),
    [aux_sym_integer_literal_token3] = ACTIONS(2758),
    [sym_float_literal] = ACTIONS(2758),
    [sym__unary_operator] = ACTIONS(2758),
    [sym__power_operator] = ACTIONS(2758),
    [sym__bitshift_operator] = ACTIONS(2758),
    [sym__rational_operator] = ACTIONS(2758),
    [sym__times_operator] = ACTIONS(2758),
    [sym__plus_operator] = ACTIONS(2758),
    [sym__dotty_operator] = ACTIONS(2758),
    [sym__comparison_operator] = ACTIONS(2758),
    [sym__arrow_operator] = ACTIONS(2760),
    [sym__assign_operator] = ACTIONS(2758),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2760),
    [sym__command_start] = ACTIONS(2760),
  },
  [1291] = {
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_function] = ACTIONS(3085),
    [anon_sym_end] = ACTIONS(3085),
    [anon_sym_abstract] = ACTIONS(3085),
    [anon_sym_primitive] = ACTIONS(3085),
    [aux_sym_primitive_definition_token1] = ACTIONS(3085),
    [anon_sym_mutable] = ACTIONS(3085),
    [anon_sym_struct] = ACTIONS(3085),
    [anon_sym_module] = ACTIONS(3085),
    [anon_sym_macro] = ACTIONS(3085),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_COLON_COLON] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_LT_COLON] = ACTIONS(3087),
    [anon_sym_if] = ACTIONS(3085),
    [anon_sym_try] = ACTIONS(3085),
    [anon_sym_for] = ACTIONS(3085),
    [anon_sym_while] = ACTIONS(3085),
    [sym_break_statement] = ACTIONS(3085),
    [sym_continue_statement] = ACTIONS(3085),
    [anon_sym_return] = ACTIONS(3085),
    [anon_sym_let] = ACTIONS(3085),
    [anon_sym_const] = ACTIONS(3085),
    [anon_sym_quote] = ACTIONS(3085),
    [anon_sym_using] = ACTIONS(3085),
    [anon_sym_import] = ACTIONS(3085),
    [anon_sym_export] = ACTIONS(3085),
    [anon_sym_COLON2] = ACTIONS(3085),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_begin] = ACTIONS(3085),
    [anon_sym_SQUOTE] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_LT_PIPE] = ACTIONS(3087),
    [anon_sym_PIPE_GT] = ACTIONS(3087),
    [anon_sym_in] = ACTIONS(3085),
    [anon_sym_isa] = ACTIONS(3085),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_LBRACK2] = ACTIONS(3087),
    [anon_sym_DOLLAR] = ACTIONS(3085),
    [anon_sym_AT] = ACTIONS(3087),
    [aux_sym_integer_literal_token1] = ACTIONS(3087),
    [aux_sym_integer_literal_token2] = ACTIONS(3087),
    [aux_sym_integer_literal_token3] = ACTIONS(3085),
    [sym_float_literal] = ACTIONS(3085),
    [sym__unary_operator] = ACTIONS(3085),
    [sym__power_operator] = ACTIONS(3085),
    [sym__bitshift_operator] = ACTIONS(3085),
    [sym__rational_operator] = ACTIONS(3085),
    [sym__times_operator] = ACTIONS(3085),
    [sym__plus_operator] = ACTIONS(3085),
    [sym__dotty_operator] = ACTIONS(3085),
    [sym__comparison_operator] = ACTIONS(3085),
    [sym__arrow_operator] = ACTIONS(3087),
    [sym__assign_operator] = ACTIONS(3085),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3087),
    [sym__command_start] = ACTIONS(3087),
  },
  [1292] = {
    [sym_identifier] = ACTIONS(2498),
    [anon_sym_function] = ACTIONS(2498),
    [anon_sym_end] = ACTIONS(2498),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_primitive] = ACTIONS(2498),
    [aux_sym_primitive_definition_token1] = ACTIONS(2498),
    [anon_sym_mutable] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_module] = ACTIONS(2498),
    [anon_sym_macro] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_COMMA] = ACTIONS(2500),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_LT_COLON] = ACTIONS(2500),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [sym_break_statement] = ACTIONS(2498),
    [sym_continue_statement] = ACTIONS(2498),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_quote] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_import] = ACTIONS(2498),
    [anon_sym_export] = ACTIONS(2498),
    [anon_sym_COLON2] = ACTIONS(2498),
    [anon_sym_RBRACK] = ACTIONS(2500),
    [anon_sym_begin] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_LT_PIPE] = ACTIONS(2500),
    [anon_sym_PIPE_GT] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2498),
    [anon_sym_isa] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_QMARK] = ACTIONS(2500),
    [anon_sym_EQ_GT] = ACTIONS(2500),
    [anon_sym_LBRACK2] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2498),
    [anon_sym_AT] = ACTIONS(2500),
    [aux_sym_integer_literal_token1] = ACTIONS(2500),
    [aux_sym_integer_literal_token2] = ACTIONS(2500),
    [aux_sym_integer_literal_token3] = ACTIONS(2498),
    [sym_float_literal] = ACTIONS(2498),
    [sym__unary_operator] = ACTIONS(2498),
    [sym__power_operator] = ACTIONS(2498),
    [sym__bitshift_operator] = ACTIONS(2498),
    [sym__rational_operator] = ACTIONS(2498),
    [sym__times_operator] = ACTIONS(2498),
    [sym__plus_operator] = ACTIONS(2498),
    [sym__dotty_operator] = ACTIONS(2498),
    [sym__comparison_operator] = ACTIONS(2498),
    [sym__arrow_operator] = ACTIONS(2500),
    [sym__assign_operator] = ACTIONS(2498),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2500),
    [sym__command_start] = ACTIONS(2500),
  },
  [1293] = {
    [sym_identifier] = ACTIONS(2530),
    [anon_sym_function] = ACTIONS(2530),
    [anon_sym_end] = ACTIONS(2530),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_primitive] = ACTIONS(2530),
    [aux_sym_primitive_definition_token1] = ACTIONS(2530),
    [anon_sym_mutable] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_module] = ACTIONS(2530),
    [anon_sym_macro] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_COMMA] = ACTIONS(2532),
    [anon_sym_RPAREN] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_EQ] = ACTIONS(2530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2532),
    [anon_sym_COLON_COLON] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_LT_COLON] = ACTIONS(2532),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [sym_break_statement] = ACTIONS(2530),
    [sym_continue_statement] = ACTIONS(2530),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_quote] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_import] = ACTIONS(2530),
    [anon_sym_export] = ACTIONS(2530),
    [anon_sym_COLON2] = ACTIONS(2530),
    [anon_sym_RBRACK] = ACTIONS(2532),
    [anon_sym_begin] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_LT_PIPE] = ACTIONS(2532),
    [anon_sym_PIPE_GT] = ACTIONS(2532),
    [anon_sym_in] = ACTIONS(2530),
    [anon_sym_isa] = ACTIONS(2530),
    [anon_sym_PIPE_PIPE] = ACTIONS(2532),
    [anon_sym_AMP_AMP] = ACTIONS(2532),
    [anon_sym_QMARK] = ACTIONS(2532),
    [anon_sym_EQ_GT] = ACTIONS(2532),
    [anon_sym_LBRACK2] = ACTIONS(2532),
    [anon_sym_DOLLAR] = ACTIONS(2530),
    [anon_sym_AT] = ACTIONS(2532),
    [aux_sym_integer_literal_token1] = ACTIONS(2532),
    [aux_sym_integer_literal_token2] = ACTIONS(2532),
    [aux_sym_integer_literal_token3] = ACTIONS(2530),
    [sym_float_literal] = ACTIONS(2530),
    [sym__unary_operator] = ACTIONS(2530),
    [sym__power_operator] = ACTIONS(2530),
    [sym__bitshift_operator] = ACTIONS(2530),
    [sym__rational_operator] = ACTIONS(2530),
    [sym__times_operator] = ACTIONS(2530),
    [sym__plus_operator] = ACTIONS(2530),
    [sym__dotty_operator] = ACTIONS(2530),
    [sym__comparison_operator] = ACTIONS(2530),
    [sym__arrow_operator] = ACTIONS(2532),
    [sym__assign_operator] = ACTIONS(2530),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2532),
    [sym__command_start] = ACTIONS(2532),
  },
  [1294] = {
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(2867),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2867),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2867),
    [anon_sym_LT_COLON] = ACTIONS(2867),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(2867),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(2867),
    [anon_sym_PLUS] = ACTIONS(2837),
    [anon_sym_LT_PIPE] = ACTIONS(2867),
    [anon_sym_PIPE_GT] = ACTIONS(2867),
    [anon_sym_in] = ACTIONS(2837),
    [anon_sym_isa] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(2867),
    [anon_sym_LBRACK2] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2867),
    [aux_sym_integer_literal_token1] = ACTIONS(2867),
    [aux_sym_integer_literal_token2] = ACTIONS(2867),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(2837),
    [sym__bitshift_operator] = ACTIONS(2837),
    [sym__rational_operator] = ACTIONS(2837),
    [sym__times_operator] = ACTIONS(2837),
    [sym__plus_operator] = ACTIONS(2837),
    [sym__dotty_operator] = ACTIONS(2837),
    [sym__comparison_operator] = ACTIONS(2837),
    [sym__arrow_operator] = ACTIONS(2867),
    [sym__assign_operator] = ACTIONS(2837),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1295] = {
    [sym_identifier] = ACTIONS(2522),
    [anon_sym_function] = ACTIONS(2522),
    [anon_sym_end] = ACTIONS(2522),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_primitive] = ACTIONS(2522),
    [aux_sym_primitive_definition_token1] = ACTIONS(2522),
    [anon_sym_mutable] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_module] = ACTIONS(2522),
    [anon_sym_macro] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_COMMA] = ACTIONS(2524),
    [anon_sym_RPAREN] = ACTIONS(2524),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_EQ] = ACTIONS(2522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2524),
    [anon_sym_COLON_COLON] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2524),
    [anon_sym_LT_COLON] = ACTIONS(2524),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [sym_break_statement] = ACTIONS(2522),
    [sym_continue_statement] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_quote] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_export] = ACTIONS(2522),
    [anon_sym_COLON2] = ACTIONS(2522),
    [anon_sym_RBRACK] = ACTIONS(2524),
    [anon_sym_begin] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_LT_PIPE] = ACTIONS(2524),
    [anon_sym_PIPE_GT] = ACTIONS(2524),
    [anon_sym_in] = ACTIONS(2522),
    [anon_sym_isa] = ACTIONS(2522),
    [anon_sym_PIPE_PIPE] = ACTIONS(2524),
    [anon_sym_AMP_AMP] = ACTIONS(2524),
    [anon_sym_QMARK] = ACTIONS(2524),
    [anon_sym_EQ_GT] = ACTIONS(2524),
    [anon_sym_LBRACK2] = ACTIONS(2524),
    [anon_sym_DOLLAR] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2524),
    [aux_sym_integer_literal_token1] = ACTIONS(2524),
    [aux_sym_integer_literal_token2] = ACTIONS(2524),
    [aux_sym_integer_literal_token3] = ACTIONS(2522),
    [sym_float_literal] = ACTIONS(2522),
    [sym__unary_operator] = ACTIONS(2522),
    [sym__power_operator] = ACTIONS(2522),
    [sym__bitshift_operator] = ACTIONS(2522),
    [sym__rational_operator] = ACTIONS(2522),
    [sym__times_operator] = ACTIONS(2522),
    [sym__plus_operator] = ACTIONS(2522),
    [sym__dotty_operator] = ACTIONS(2522),
    [sym__comparison_operator] = ACTIONS(2522),
    [sym__arrow_operator] = ACTIONS(2524),
    [sym__assign_operator] = ACTIONS(2522),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2524),
    [sym__command_start] = ACTIONS(2524),
  },
  [1296] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(2869),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_end] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2867),
    [anon_sym_COMMA] = ACTIONS(3342),
    [anon_sym_RPAREN] = ACTIONS(2867),
    [anon_sym_SEMI] = ACTIONS(2867),
    [anon_sym_EQ] = ACTIONS(3344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2867),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2867),
    [anon_sym_AMP_AMP] = ACTIONS(2867),
    [anon_sym_QMARK] = ACTIONS(2867),
    [anon_sym_EQ_GT] = ACTIONS(2867),
    [anon_sym_LBRACK2] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2867),
    [aux_sym_integer_literal_token1] = ACTIONS(2867),
    [aux_sym_integer_literal_token2] = ACTIONS(2867),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(3344),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1297] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2985),
    [anon_sym_PIPE_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(2983),
    [sym__bitshift_operator] = ACTIONS(2983),
    [sym__rational_operator] = ACTIONS(2983),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1298] = {
    [sym_identifier] = ACTIONS(2494),
    [anon_sym_function] = ACTIONS(2494),
    [anon_sym_end] = ACTIONS(2494),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_primitive] = ACTIONS(2494),
    [aux_sym_primitive_definition_token1] = ACTIONS(2494),
    [anon_sym_mutable] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_module] = ACTIONS(2494),
    [anon_sym_macro] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_COMMA] = ACTIONS(2496),
    [anon_sym_RPAREN] = ACTIONS(2496),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2496),
    [anon_sym_COLON_COLON] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_LT_COLON] = ACTIONS(2496),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [sym_break_statement] = ACTIONS(2494),
    [sym_continue_statement] = ACTIONS(2494),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_quote] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_import] = ACTIONS(2494),
    [anon_sym_export] = ACTIONS(2494),
    [anon_sym_COLON2] = ACTIONS(2494),
    [anon_sym_RBRACK] = ACTIONS(2496),
    [anon_sym_begin] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_LT_PIPE] = ACTIONS(2496),
    [anon_sym_PIPE_GT] = ACTIONS(2496),
    [anon_sym_in] = ACTIONS(2494),
    [anon_sym_isa] = ACTIONS(2494),
    [anon_sym_PIPE_PIPE] = ACTIONS(2496),
    [anon_sym_AMP_AMP] = ACTIONS(2496),
    [anon_sym_QMARK] = ACTIONS(2496),
    [anon_sym_EQ_GT] = ACTIONS(2496),
    [anon_sym_LBRACK2] = ACTIONS(2496),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_AT] = ACTIONS(2496),
    [aux_sym_integer_literal_token1] = ACTIONS(2496),
    [aux_sym_integer_literal_token2] = ACTIONS(2496),
    [aux_sym_integer_literal_token3] = ACTIONS(2494),
    [sym_float_literal] = ACTIONS(2494),
    [sym__unary_operator] = ACTIONS(2494),
    [sym__power_operator] = ACTIONS(2494),
    [sym__bitshift_operator] = ACTIONS(2494),
    [sym__rational_operator] = ACTIONS(2494),
    [sym__times_operator] = ACTIONS(2494),
    [sym__plus_operator] = ACTIONS(2494),
    [sym__dotty_operator] = ACTIONS(2494),
    [sym__comparison_operator] = ACTIONS(2494),
    [sym__arrow_operator] = ACTIONS(2496),
    [sym__assign_operator] = ACTIONS(2494),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2496),
    [sym__command_start] = ACTIONS(2496),
  },
  [1299] = {
    [sym_identifier] = ACTIONS(2518),
    [anon_sym_function] = ACTIONS(2518),
    [anon_sym_end] = ACTIONS(2518),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_primitive] = ACTIONS(2518),
    [aux_sym_primitive_definition_token1] = ACTIONS(2518),
    [anon_sym_mutable] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_module] = ACTIONS(2518),
    [anon_sym_macro] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2520),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_EQ] = ACTIONS(2518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2520),
    [anon_sym_COLON_COLON] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_LT_COLON] = ACTIONS(2520),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [sym_break_statement] = ACTIONS(2518),
    [sym_continue_statement] = ACTIONS(2518),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_quote] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_import] = ACTIONS(2518),
    [anon_sym_export] = ACTIONS(2518),
    [anon_sym_COLON2] = ACTIONS(2518),
    [anon_sym_RBRACK] = ACTIONS(2520),
    [anon_sym_begin] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_LT_PIPE] = ACTIONS(2520),
    [anon_sym_PIPE_GT] = ACTIONS(2520),
    [anon_sym_in] = ACTIONS(2518),
    [anon_sym_isa] = ACTIONS(2518),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(2520),
    [anon_sym_EQ_GT] = ACTIONS(2520),
    [anon_sym_LBRACK2] = ACTIONS(2520),
    [anon_sym_DOLLAR] = ACTIONS(2518),
    [anon_sym_AT] = ACTIONS(2520),
    [aux_sym_integer_literal_token1] = ACTIONS(2520),
    [aux_sym_integer_literal_token2] = ACTIONS(2520),
    [aux_sym_integer_literal_token3] = ACTIONS(2518),
    [sym_float_literal] = ACTIONS(2518),
    [sym__unary_operator] = ACTIONS(2518),
    [sym__power_operator] = ACTIONS(2518),
    [sym__bitshift_operator] = ACTIONS(2518),
    [sym__rational_operator] = ACTIONS(2518),
    [sym__times_operator] = ACTIONS(2518),
    [sym__plus_operator] = ACTIONS(2518),
    [sym__dotty_operator] = ACTIONS(2518),
    [sym__comparison_operator] = ACTIONS(2518),
    [sym__arrow_operator] = ACTIONS(2520),
    [sym__assign_operator] = ACTIONS(2518),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2520),
    [sym__command_start] = ACTIONS(2520),
  },
  [1300] = {
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_function] = ACTIONS(3093),
    [anon_sym_end] = ACTIONS(3093),
    [anon_sym_abstract] = ACTIONS(3093),
    [anon_sym_primitive] = ACTIONS(3093),
    [aux_sym_primitive_definition_token1] = ACTIONS(3093),
    [anon_sym_mutable] = ACTIONS(3093),
    [anon_sym_struct] = ACTIONS(3093),
    [anon_sym_module] = ACTIONS(3093),
    [anon_sym_macro] = ACTIONS(3093),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_COLON_COLON] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_LT_COLON] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(3093),
    [anon_sym_try] = ACTIONS(3093),
    [anon_sym_for] = ACTIONS(3093),
    [anon_sym_while] = ACTIONS(3093),
    [sym_break_statement] = ACTIONS(3093),
    [sym_continue_statement] = ACTIONS(3093),
    [anon_sym_return] = ACTIONS(3093),
    [anon_sym_let] = ACTIONS(3093),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_quote] = ACTIONS(3093),
    [anon_sym_using] = ACTIONS(3093),
    [anon_sym_import] = ACTIONS(3093),
    [anon_sym_export] = ACTIONS(3093),
    [anon_sym_COLON2] = ACTIONS(3093),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_begin] = ACTIONS(3093),
    [anon_sym_SQUOTE] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_LT_PIPE] = ACTIONS(3095),
    [anon_sym_PIPE_GT] = ACTIONS(3095),
    [anon_sym_in] = ACTIONS(3093),
    [anon_sym_isa] = ACTIONS(3093),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_LBRACK2] = ACTIONS(3095),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [anon_sym_AT] = ACTIONS(3095),
    [aux_sym_integer_literal_token1] = ACTIONS(3095),
    [aux_sym_integer_literal_token2] = ACTIONS(3095),
    [aux_sym_integer_literal_token3] = ACTIONS(3093),
    [sym_float_literal] = ACTIONS(3093),
    [sym__unary_operator] = ACTIONS(3093),
    [sym__power_operator] = ACTIONS(3093),
    [sym__bitshift_operator] = ACTIONS(3093),
    [sym__rational_operator] = ACTIONS(3093),
    [sym__times_operator] = ACTIONS(3093),
    [sym__plus_operator] = ACTIONS(3093),
    [sym__dotty_operator] = ACTIONS(3093),
    [sym__comparison_operator] = ACTIONS(3093),
    [sym__arrow_operator] = ACTIONS(3095),
    [sym__assign_operator] = ACTIONS(3093),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3095),
    [sym__command_start] = ACTIONS(3095),
  },
  [1301] = {
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_function] = ACTIONS(3117),
    [anon_sym_end] = ACTIONS(3117),
    [anon_sym_abstract] = ACTIONS(3117),
    [anon_sym_primitive] = ACTIONS(3117),
    [aux_sym_primitive_definition_token1] = ACTIONS(3117),
    [anon_sym_mutable] = ACTIONS(3117),
    [anon_sym_struct] = ACTIONS(3117),
    [anon_sym_module] = ACTIONS(3117),
    [anon_sym_macro] = ACTIONS(3117),
    [anon_sym_LPAREN] = ACTIONS(3121),
    [anon_sym_COMMA] = ACTIONS(3121),
    [anon_sym_RPAREN] = ACTIONS(3121),
    [anon_sym_SEMI] = ACTIONS(3121),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3121),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3117),
    [anon_sym_try] = ACTIONS(3117),
    [anon_sym_for] = ACTIONS(3117),
    [anon_sym_while] = ACTIONS(3117),
    [sym_break_statement] = ACTIONS(3117),
    [sym_continue_statement] = ACTIONS(3117),
    [anon_sym_return] = ACTIONS(3117),
    [anon_sym_let] = ACTIONS(3117),
    [anon_sym_const] = ACTIONS(3117),
    [anon_sym_quote] = ACTIONS(3117),
    [anon_sym_using] = ACTIONS(3117),
    [anon_sym_import] = ACTIONS(3117),
    [anon_sym_export] = ACTIONS(3117),
    [anon_sym_COLON2] = ACTIONS(3119),
    [anon_sym_RBRACK] = ACTIONS(3121),
    [anon_sym_begin] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3191),
    [anon_sym_PIPE_GT] = ACTIONS(3191),
    [anon_sym_in] = ACTIONS(3119),
    [anon_sym_isa] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3191),
    [anon_sym_AMP_AMP] = ACTIONS(3191),
    [anon_sym_QMARK] = ACTIONS(3191),
    [anon_sym_EQ_GT] = ACTIONS(3191),
    [anon_sym_LBRACK2] = ACTIONS(3121),
    [anon_sym_DOLLAR] = ACTIONS(3117),
    [anon_sym_AT] = ACTIONS(3121),
    [aux_sym_integer_literal_token1] = ACTIONS(3121),
    [aux_sym_integer_literal_token2] = ACTIONS(3121),
    [aux_sym_integer_literal_token3] = ACTIONS(3117),
    [sym_float_literal] = ACTIONS(3117),
    [sym__unary_operator] = ACTIONS(3117),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3119),
    [sym__comparison_operator] = ACTIONS(3119),
    [sym__arrow_operator] = ACTIONS(3191),
    [sym__assign_operator] = ACTIONS(3117),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3121),
    [sym__command_start] = ACTIONS(3121),
  },
  [1302] = {
    [sym_identifier] = ACTIONS(2510),
    [anon_sym_function] = ACTIONS(2510),
    [anon_sym_end] = ACTIONS(2510),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_primitive] = ACTIONS(2510),
    [aux_sym_primitive_definition_token1] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_module] = ACTIONS(2510),
    [anon_sym_macro] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_COMMA] = ACTIONS(2512),
    [anon_sym_RPAREN] = ACTIONS(2512),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_EQ] = ACTIONS(2510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2512),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_LT_COLON] = ACTIONS(2512),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [sym_break_statement] = ACTIONS(2510),
    [sym_continue_statement] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_quote] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_import] = ACTIONS(2510),
    [anon_sym_export] = ACTIONS(2510),
    [anon_sym_COLON2] = ACTIONS(2510),
    [anon_sym_RBRACK] = ACTIONS(2512),
    [anon_sym_begin] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_LT_PIPE] = ACTIONS(2512),
    [anon_sym_PIPE_GT] = ACTIONS(2512),
    [anon_sym_in] = ACTIONS(2510),
    [anon_sym_isa] = ACTIONS(2510),
    [anon_sym_PIPE_PIPE] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_QMARK] = ACTIONS(2512),
    [anon_sym_EQ_GT] = ACTIONS(2512),
    [anon_sym_LBRACK2] = ACTIONS(2512),
    [anon_sym_DOLLAR] = ACTIONS(2510),
    [anon_sym_AT] = ACTIONS(2512),
    [aux_sym_integer_literal_token1] = ACTIONS(2512),
    [aux_sym_integer_literal_token2] = ACTIONS(2512),
    [aux_sym_integer_literal_token3] = ACTIONS(2510),
    [sym_float_literal] = ACTIONS(2510),
    [sym__unary_operator] = ACTIONS(2510),
    [sym__power_operator] = ACTIONS(2510),
    [sym__bitshift_operator] = ACTIONS(2510),
    [sym__rational_operator] = ACTIONS(2510),
    [sym__times_operator] = ACTIONS(2510),
    [sym__plus_operator] = ACTIONS(2510),
    [sym__dotty_operator] = ACTIONS(2510),
    [sym__comparison_operator] = ACTIONS(2510),
    [sym__arrow_operator] = ACTIONS(2512),
    [sym__assign_operator] = ACTIONS(2510),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2512),
    [sym__command_start] = ACTIONS(2512),
  },
  [1303] = {
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_function] = ACTIONS(3151),
    [anon_sym_end] = ACTIONS(3151),
    [anon_sym_abstract] = ACTIONS(3151),
    [anon_sym_primitive] = ACTIONS(3151),
    [aux_sym_primitive_definition_token1] = ACTIONS(3151),
    [anon_sym_mutable] = ACTIONS(3151),
    [anon_sym_struct] = ACTIONS(3151),
    [anon_sym_module] = ACTIONS(3151),
    [anon_sym_macro] = ACTIONS(3151),
    [anon_sym_LPAREN] = ACTIONS(3153),
    [anon_sym_COMMA] = ACTIONS(3153),
    [anon_sym_RPAREN] = ACTIONS(3153),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_EQ] = ACTIONS(3151),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3153),
    [anon_sym_COLON_COLON] = ACTIONS(3153),
    [anon_sym_RBRACE] = ACTIONS(3153),
    [anon_sym_LT_COLON] = ACTIONS(3153),
    [anon_sym_if] = ACTIONS(3151),
    [anon_sym_try] = ACTIONS(3151),
    [anon_sym_for] = ACTIONS(3151),
    [anon_sym_while] = ACTIONS(3151),
    [sym_break_statement] = ACTIONS(3151),
    [sym_continue_statement] = ACTIONS(3151),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_let] = ACTIONS(3151),
    [anon_sym_const] = ACTIONS(3151),
    [anon_sym_quote] = ACTIONS(3151),
    [anon_sym_using] = ACTIONS(3151),
    [anon_sym_import] = ACTIONS(3151),
    [anon_sym_export] = ACTIONS(3151),
    [anon_sym_COLON2] = ACTIONS(3151),
    [anon_sym_RBRACK] = ACTIONS(3153),
    [anon_sym_begin] = ACTIONS(3151),
    [anon_sym_SQUOTE] = ACTIONS(3153),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_LT_PIPE] = ACTIONS(3153),
    [anon_sym_PIPE_GT] = ACTIONS(3153),
    [anon_sym_in] = ACTIONS(3151),
    [anon_sym_isa] = ACTIONS(3151),
    [anon_sym_PIPE_PIPE] = ACTIONS(3153),
    [anon_sym_AMP_AMP] = ACTIONS(3153),
    [anon_sym_QMARK] = ACTIONS(3153),
    [anon_sym_EQ_GT] = ACTIONS(3153),
    [anon_sym_LBRACK2] = ACTIONS(3153),
    [anon_sym_DOLLAR] = ACTIONS(3151),
    [anon_sym_AT] = ACTIONS(3153),
    [aux_sym_integer_literal_token1] = ACTIONS(3153),
    [aux_sym_integer_literal_token2] = ACTIONS(3153),
    [aux_sym_integer_literal_token3] = ACTIONS(3151),
    [sym_float_literal] = ACTIONS(3151),
    [sym__unary_operator] = ACTIONS(3151),
    [sym__power_operator] = ACTIONS(3151),
    [sym__bitshift_operator] = ACTIONS(3151),
    [sym__rational_operator] = ACTIONS(3151),
    [sym__times_operator] = ACTIONS(3151),
    [sym__plus_operator] = ACTIONS(3151),
    [sym__dotty_operator] = ACTIONS(3151),
    [sym__comparison_operator] = ACTIONS(3151),
    [sym__arrow_operator] = ACTIONS(3153),
    [sym__assign_operator] = ACTIONS(3151),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3153),
    [sym__command_start] = ACTIONS(3153),
  },
  [1304] = {
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_function] = ACTIONS(2490),
    [anon_sym_end] = ACTIONS(2490),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_primitive] = ACTIONS(2490),
    [aux_sym_primitive_definition_token1] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_module] = ACTIONS(2490),
    [anon_sym_macro] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_COMMA] = ACTIONS(2492),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2490),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2492),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_LT_COLON] = ACTIONS(2492),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [sym_break_statement] = ACTIONS(2490),
    [sym_continue_statement] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_quote] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_import] = ACTIONS(2490),
    [anon_sym_export] = ACTIONS(2490),
    [anon_sym_COLON2] = ACTIONS(2490),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_begin] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_LT_PIPE] = ACTIONS(2492),
    [anon_sym_PIPE_GT] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2490),
    [anon_sym_isa] = ACTIONS(2490),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_QMARK] = ACTIONS(2492),
    [anon_sym_EQ_GT] = ACTIONS(2492),
    [anon_sym_LBRACK2] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2490),
    [anon_sym_AT] = ACTIONS(2492),
    [aux_sym_integer_literal_token1] = ACTIONS(2492),
    [aux_sym_integer_literal_token2] = ACTIONS(2492),
    [aux_sym_integer_literal_token3] = ACTIONS(2490),
    [sym_float_literal] = ACTIONS(2490),
    [sym__unary_operator] = ACTIONS(2490),
    [sym__power_operator] = ACTIONS(2490),
    [sym__bitshift_operator] = ACTIONS(2490),
    [sym__rational_operator] = ACTIONS(2490),
    [sym__times_operator] = ACTIONS(2490),
    [sym__plus_operator] = ACTIONS(2490),
    [sym__dotty_operator] = ACTIONS(2490),
    [sym__comparison_operator] = ACTIONS(2490),
    [sym__arrow_operator] = ACTIONS(2492),
    [sym__assign_operator] = ACTIONS(2490),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2492),
    [sym__command_start] = ACTIONS(2492),
  },
  [1305] = {
    [sym_identifier] = ACTIONS(2534),
    [anon_sym_function] = ACTIONS(2534),
    [anon_sym_end] = ACTIONS(2534),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_primitive] = ACTIONS(2534),
    [aux_sym_primitive_definition_token1] = ACTIONS(2534),
    [anon_sym_mutable] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_module] = ACTIONS(2534),
    [anon_sym_macro] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_COMMA] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_EQ] = ACTIONS(2534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2536),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_LT_COLON] = ACTIONS(2536),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [sym_break_statement] = ACTIONS(2534),
    [sym_continue_statement] = ACTIONS(2534),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_quote] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_import] = ACTIONS(2534),
    [anon_sym_export] = ACTIONS(2534),
    [anon_sym_COLON2] = ACTIONS(2534),
    [anon_sym_RBRACK] = ACTIONS(2536),
    [anon_sym_begin] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_LT_PIPE] = ACTIONS(2536),
    [anon_sym_PIPE_GT] = ACTIONS(2536),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_isa] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2536),
    [anon_sym_AMP_AMP] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2536),
    [anon_sym_EQ_GT] = ACTIONS(2536),
    [anon_sym_LBRACK2] = ACTIONS(2536),
    [anon_sym_DOLLAR] = ACTIONS(2534),
    [anon_sym_AT] = ACTIONS(2536),
    [aux_sym_integer_literal_token1] = ACTIONS(2536),
    [aux_sym_integer_literal_token2] = ACTIONS(2536),
    [aux_sym_integer_literal_token3] = ACTIONS(2534),
    [sym_float_literal] = ACTIONS(2534),
    [sym__unary_operator] = ACTIONS(2534),
    [sym__power_operator] = ACTIONS(2534),
    [sym__bitshift_operator] = ACTIONS(2534),
    [sym__rational_operator] = ACTIONS(2534),
    [sym__times_operator] = ACTIONS(2534),
    [sym__plus_operator] = ACTIONS(2534),
    [sym__dotty_operator] = ACTIONS(2534),
    [sym__comparison_operator] = ACTIONS(2534),
    [sym__arrow_operator] = ACTIONS(2536),
    [sym__assign_operator] = ACTIONS(2534),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2536),
    [sym__command_start] = ACTIONS(2536),
  },
  [1306] = {
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(2734),
    [anon_sym_end] = ACTIONS(2734),
    [anon_sym_abstract] = ACTIONS(2734),
    [anon_sym_primitive] = ACTIONS(2734),
    [aux_sym_primitive_definition_token1] = ACTIONS(2734),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2734),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_macro] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2734),
    [anon_sym_LT_COLON] = ACTIONS(2734),
    [anon_sym_if] = ACTIONS(2734),
    [anon_sym_elseif] = ACTIONS(2734),
    [anon_sym_else] = ACTIONS(2734),
    [anon_sym_try] = ACTIONS(2734),
    [anon_sym_for] = ACTIONS(2734),
    [anon_sym_while] = ACTIONS(2734),
    [sym_break_statement] = ACTIONS(2734),
    [sym_continue_statement] = ACTIONS(2734),
    [anon_sym_return] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_const] = ACTIONS(2734),
    [anon_sym_quote] = ACTIONS(2734),
    [anon_sym_using] = ACTIONS(2734),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_COLON2] = ACTIONS(2734),
    [anon_sym_begin] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_LT_PIPE] = ACTIONS(2734),
    [anon_sym_PIPE_GT] = ACTIONS(2734),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_isa] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_EQ_GT] = ACTIONS(2734),
    [anon_sym_LBRACK2] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(2734),
    [anon_sym_AT] = ACTIONS(2734),
    [aux_sym_integer_literal_token1] = ACTIONS(2734),
    [aux_sym_integer_literal_token2] = ACTIONS(2734),
    [aux_sym_integer_literal_token3] = ACTIONS(2734),
    [sym_float_literal] = ACTIONS(2734),
    [sym__unary_operator] = ACTIONS(2734),
    [sym__power_operator] = ACTIONS(2734),
    [sym__bitshift_operator] = ACTIONS(2734),
    [sym__rational_operator] = ACTIONS(2734),
    [sym__times_operator] = ACTIONS(2734),
    [sym__plus_operator] = ACTIONS(2734),
    [sym__dotty_operator] = ACTIONS(2734),
    [sym__comparison_operator] = ACTIONS(2734),
    [sym__arrow_operator] = ACTIONS(2734),
    [anon_sym_LF] = ACTIONS(2736),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2736),
    [sym__command_start] = ACTIONS(2736),
  },
  [1307] = {
    [sym_identifier] = ACTIONS(2959),
    [anon_sym_function] = ACTIONS(2959),
    [anon_sym_end] = ACTIONS(2959),
    [anon_sym_abstract] = ACTIONS(2959),
    [anon_sym_primitive] = ACTIONS(2959),
    [aux_sym_primitive_definition_token1] = ACTIONS(2959),
    [anon_sym_mutable] = ACTIONS(2959),
    [anon_sym_struct] = ACTIONS(2959),
    [anon_sym_module] = ACTIONS(2959),
    [anon_sym_macro] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2961),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2961),
    [anon_sym_COLON_COLON] = ACTIONS(2961),
    [anon_sym_RBRACE] = ACTIONS(2961),
    [anon_sym_LT_COLON] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_try] = ACTIONS(2959),
    [anon_sym_for] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [sym_break_statement] = ACTIONS(2959),
    [sym_continue_statement] = ACTIONS(2959),
    [anon_sym_return] = ACTIONS(2959),
    [anon_sym_let] = ACTIONS(2959),
    [anon_sym_const] = ACTIONS(2959),
    [anon_sym_quote] = ACTIONS(2959),
    [anon_sym_using] = ACTIONS(2959),
    [anon_sym_import] = ACTIONS(2959),
    [anon_sym_export] = ACTIONS(2959),
    [anon_sym_COLON2] = ACTIONS(2959),
    [anon_sym_RBRACK] = ACTIONS(2961),
    [anon_sym_begin] = ACTIONS(2959),
    [anon_sym_SQUOTE] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_LT_PIPE] = ACTIONS(2961),
    [anon_sym_PIPE_GT] = ACTIONS(2961),
    [anon_sym_in] = ACTIONS(2959),
    [anon_sym_isa] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_EQ_GT] = ACTIONS(2961),
    [anon_sym_LBRACK2] = ACTIONS(2961),
    [anon_sym_DOLLAR] = ACTIONS(2959),
    [anon_sym_AT] = ACTIONS(2961),
    [aux_sym_integer_literal_token1] = ACTIONS(2961),
    [aux_sym_integer_literal_token2] = ACTIONS(2961),
    [aux_sym_integer_literal_token3] = ACTIONS(2959),
    [sym_float_literal] = ACTIONS(2959),
    [sym__unary_operator] = ACTIONS(2959),
    [sym__power_operator] = ACTIONS(2959),
    [sym__bitshift_operator] = ACTIONS(2959),
    [sym__rational_operator] = ACTIONS(2959),
    [sym__times_operator] = ACTIONS(2959),
    [sym__plus_operator] = ACTIONS(2959),
    [sym__dotty_operator] = ACTIONS(2959),
    [sym__comparison_operator] = ACTIONS(2959),
    [sym__arrow_operator] = ACTIONS(2961),
    [sym__assign_operator] = ACTIONS(2959),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2961),
    [sym__command_start] = ACTIONS(2961),
  },
  [1308] = {
    [sym_identifier] = ACTIONS(3227),
    [anon_sym_function] = ACTIONS(3227),
    [anon_sym_end] = ACTIONS(3227),
    [anon_sym_abstract] = ACTIONS(3227),
    [anon_sym_primitive] = ACTIONS(3227),
    [aux_sym_primitive_definition_token1] = ACTIONS(3227),
    [anon_sym_mutable] = ACTIONS(3227),
    [anon_sym_struct] = ACTIONS(3227),
    [anon_sym_module] = ACTIONS(3227),
    [anon_sym_macro] = ACTIONS(3227),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_COMMA] = ACTIONS(3229),
    [anon_sym_RPAREN] = ACTIONS(3229),
    [anon_sym_SEMI] = ACTIONS(3229),
    [anon_sym_EQ] = ACTIONS(3227),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3229),
    [anon_sym_COLON_COLON] = ACTIONS(3229),
    [anon_sym_RBRACE] = ACTIONS(3229),
    [anon_sym_LT_COLON] = ACTIONS(3229),
    [anon_sym_if] = ACTIONS(3227),
    [anon_sym_try] = ACTIONS(3227),
    [anon_sym_for] = ACTIONS(3227),
    [anon_sym_while] = ACTIONS(3227),
    [sym_break_statement] = ACTIONS(3227),
    [sym_continue_statement] = ACTIONS(3227),
    [anon_sym_return] = ACTIONS(3227),
    [anon_sym_let] = ACTIONS(3227),
    [anon_sym_const] = ACTIONS(3227),
    [anon_sym_quote] = ACTIONS(3227),
    [anon_sym_using] = ACTIONS(3227),
    [anon_sym_import] = ACTIONS(3227),
    [anon_sym_export] = ACTIONS(3227),
    [anon_sym_COLON2] = ACTIONS(3227),
    [anon_sym_RBRACK] = ACTIONS(3229),
    [anon_sym_begin] = ACTIONS(3227),
    [anon_sym_SQUOTE] = ACTIONS(3229),
    [anon_sym_PLUS] = ACTIONS(3227),
    [anon_sym_LT_PIPE] = ACTIONS(3229),
    [anon_sym_PIPE_GT] = ACTIONS(3229),
    [anon_sym_in] = ACTIONS(3227),
    [anon_sym_isa] = ACTIONS(3227),
    [anon_sym_PIPE_PIPE] = ACTIONS(3229),
    [anon_sym_AMP_AMP] = ACTIONS(3229),
    [anon_sym_QMARK] = ACTIONS(3229),
    [anon_sym_EQ_GT] = ACTIONS(3229),
    [anon_sym_LBRACK2] = ACTIONS(3229),
    [anon_sym_DOLLAR] = ACTIONS(3227),
    [anon_sym_AT] = ACTIONS(3229),
    [aux_sym_integer_literal_token1] = ACTIONS(3229),
    [aux_sym_integer_literal_token2] = ACTIONS(3229),
    [aux_sym_integer_literal_token3] = ACTIONS(3227),
    [sym_float_literal] = ACTIONS(3227),
    [sym__unary_operator] = ACTIONS(3227),
    [sym__power_operator] = ACTIONS(3227),
    [sym__bitshift_operator] = ACTIONS(3227),
    [sym__rational_operator] = ACTIONS(3227),
    [sym__times_operator] = ACTIONS(3227),
    [sym__plus_operator] = ACTIONS(3227),
    [sym__dotty_operator] = ACTIONS(3227),
    [sym__comparison_operator] = ACTIONS(3227),
    [sym__arrow_operator] = ACTIONS(3229),
    [sym__assign_operator] = ACTIONS(3227),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3229),
    [sym__command_start] = ACTIONS(3229),
  },
  [1309] = {
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2744),
    [anon_sym_LT_COLON] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_elseif] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(3293),
    [anon_sym_DOT] = ACTIONS(3295),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2744),
    [anon_sym_PIPE_GT] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_LBRACK2] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [aux_sym_integer_literal_token1] = ACTIONS(2744),
    [aux_sym_integer_literal_token2] = ACTIONS(2744),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1310] = {
    [sym_identifier] = ACTIONS(3217),
    [anon_sym_function] = ACTIONS(3217),
    [anon_sym_end] = ACTIONS(3217),
    [anon_sym_abstract] = ACTIONS(3217),
    [anon_sym_primitive] = ACTIONS(3217),
    [aux_sym_primitive_definition_token1] = ACTIONS(3217),
    [anon_sym_mutable] = ACTIONS(3217),
    [anon_sym_struct] = ACTIONS(3217),
    [anon_sym_module] = ACTIONS(3217),
    [anon_sym_macro] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3219),
    [anon_sym_COMMA] = ACTIONS(3219),
    [anon_sym_RPAREN] = ACTIONS(3219),
    [anon_sym_SEMI] = ACTIONS(3219),
    [anon_sym_EQ] = ACTIONS(3217),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3219),
    [anon_sym_COLON_COLON] = ACTIONS(3219),
    [anon_sym_RBRACE] = ACTIONS(3219),
    [anon_sym_LT_COLON] = ACTIONS(3219),
    [anon_sym_if] = ACTIONS(3217),
    [anon_sym_try] = ACTIONS(3217),
    [anon_sym_for] = ACTIONS(3217),
    [anon_sym_while] = ACTIONS(3217),
    [sym_break_statement] = ACTIONS(3217),
    [sym_continue_statement] = ACTIONS(3217),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_let] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3217),
    [anon_sym_quote] = ACTIONS(3217),
    [anon_sym_using] = ACTIONS(3217),
    [anon_sym_import] = ACTIONS(3217),
    [anon_sym_export] = ACTIONS(3217),
    [anon_sym_COLON2] = ACTIONS(3217),
    [anon_sym_RBRACK] = ACTIONS(3219),
    [anon_sym_begin] = ACTIONS(3217),
    [anon_sym_SQUOTE] = ACTIONS(3219),
    [anon_sym_PLUS] = ACTIONS(3217),
    [anon_sym_LT_PIPE] = ACTIONS(3219),
    [anon_sym_PIPE_GT] = ACTIONS(3219),
    [anon_sym_in] = ACTIONS(3217),
    [anon_sym_isa] = ACTIONS(3217),
    [anon_sym_PIPE_PIPE] = ACTIONS(3219),
    [anon_sym_AMP_AMP] = ACTIONS(3219),
    [anon_sym_QMARK] = ACTIONS(3219),
    [anon_sym_EQ_GT] = ACTIONS(3219),
    [anon_sym_LBRACK2] = ACTIONS(3219),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [anon_sym_AT] = ACTIONS(3219),
    [aux_sym_integer_literal_token1] = ACTIONS(3219),
    [aux_sym_integer_literal_token2] = ACTIONS(3219),
    [aux_sym_integer_literal_token3] = ACTIONS(3217),
    [sym_float_literal] = ACTIONS(3217),
    [sym__unary_operator] = ACTIONS(3217),
    [sym__power_operator] = ACTIONS(3217),
    [sym__bitshift_operator] = ACTIONS(3217),
    [sym__rational_operator] = ACTIONS(3217),
    [sym__times_operator] = ACTIONS(3217),
    [sym__plus_operator] = ACTIONS(3217),
    [sym__dotty_operator] = ACTIONS(3217),
    [sym__comparison_operator] = ACTIONS(3217),
    [sym__arrow_operator] = ACTIONS(3219),
    [sym__assign_operator] = ACTIONS(3217),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3219),
    [sym__command_start] = ACTIONS(3219),
  },
  [1311] = {
    [sym_identifier] = ACTIONS(3213),
    [anon_sym_function] = ACTIONS(3213),
    [anon_sym_end] = ACTIONS(3213),
    [anon_sym_abstract] = ACTIONS(3213),
    [anon_sym_primitive] = ACTIONS(3213),
    [aux_sym_primitive_definition_token1] = ACTIONS(3213),
    [anon_sym_mutable] = ACTIONS(3213),
    [anon_sym_struct] = ACTIONS(3213),
    [anon_sym_module] = ACTIONS(3213),
    [anon_sym_macro] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3215),
    [anon_sym_COMMA] = ACTIONS(3215),
    [anon_sym_RPAREN] = ACTIONS(3215),
    [anon_sym_SEMI] = ACTIONS(3215),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3215),
    [anon_sym_COLON_COLON] = ACTIONS(3215),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_LT_COLON] = ACTIONS(3215),
    [anon_sym_if] = ACTIONS(3213),
    [anon_sym_try] = ACTIONS(3213),
    [anon_sym_for] = ACTIONS(3213),
    [anon_sym_while] = ACTIONS(3213),
    [sym_break_statement] = ACTIONS(3213),
    [sym_continue_statement] = ACTIONS(3213),
    [anon_sym_return] = ACTIONS(3213),
    [anon_sym_let] = ACTIONS(3213),
    [anon_sym_const] = ACTIONS(3213),
    [anon_sym_quote] = ACTIONS(3213),
    [anon_sym_using] = ACTIONS(3213),
    [anon_sym_import] = ACTIONS(3213),
    [anon_sym_export] = ACTIONS(3213),
    [anon_sym_COLON2] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3215),
    [anon_sym_begin] = ACTIONS(3213),
    [anon_sym_SQUOTE] = ACTIONS(3215),
    [anon_sym_PLUS] = ACTIONS(3213),
    [anon_sym_LT_PIPE] = ACTIONS(3215),
    [anon_sym_PIPE_GT] = ACTIONS(3215),
    [anon_sym_in] = ACTIONS(3213),
    [anon_sym_isa] = ACTIONS(3213),
    [anon_sym_PIPE_PIPE] = ACTIONS(3215),
    [anon_sym_AMP_AMP] = ACTIONS(3215),
    [anon_sym_QMARK] = ACTIONS(3215),
    [anon_sym_EQ_GT] = ACTIONS(3215),
    [anon_sym_LBRACK2] = ACTIONS(3215),
    [anon_sym_DOLLAR] = ACTIONS(3213),
    [anon_sym_AT] = ACTIONS(3215),
    [aux_sym_integer_literal_token1] = ACTIONS(3215),
    [aux_sym_integer_literal_token2] = ACTIONS(3215),
    [aux_sym_integer_literal_token3] = ACTIONS(3213),
    [sym_float_literal] = ACTIONS(3213),
    [sym__unary_operator] = ACTIONS(3213),
    [sym__power_operator] = ACTIONS(3213),
    [sym__bitshift_operator] = ACTIONS(3213),
    [sym__rational_operator] = ACTIONS(3213),
    [sym__times_operator] = ACTIONS(3213),
    [sym__plus_operator] = ACTIONS(3213),
    [sym__dotty_operator] = ACTIONS(3213),
    [sym__comparison_operator] = ACTIONS(3213),
    [sym__arrow_operator] = ACTIONS(3215),
    [sym__assign_operator] = ACTIONS(3213),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3215),
    [sym__command_start] = ACTIONS(3215),
  },
  [1312] = {
    [sym_identifier] = ACTIONS(3203),
    [anon_sym_function] = ACTIONS(3203),
    [anon_sym_end] = ACTIONS(3203),
    [anon_sym_abstract] = ACTIONS(3203),
    [anon_sym_primitive] = ACTIONS(3203),
    [aux_sym_primitive_definition_token1] = ACTIONS(3203),
    [anon_sym_mutable] = ACTIONS(3203),
    [anon_sym_struct] = ACTIONS(3203),
    [anon_sym_module] = ACTIONS(3203),
    [anon_sym_macro] = ACTIONS(3203),
    [anon_sym_LPAREN] = ACTIONS(3205),
    [anon_sym_COMMA] = ACTIONS(3205),
    [anon_sym_RPAREN] = ACTIONS(3205),
    [anon_sym_SEMI] = ACTIONS(3205),
    [anon_sym_EQ] = ACTIONS(3203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3205),
    [anon_sym_COLON_COLON] = ACTIONS(3205),
    [anon_sym_RBRACE] = ACTIONS(3205),
    [anon_sym_LT_COLON] = ACTIONS(3205),
    [anon_sym_if] = ACTIONS(3203),
    [anon_sym_try] = ACTIONS(3203),
    [anon_sym_for] = ACTIONS(3203),
    [anon_sym_while] = ACTIONS(3203),
    [sym_break_statement] = ACTIONS(3203),
    [sym_continue_statement] = ACTIONS(3203),
    [anon_sym_return] = ACTIONS(3203),
    [anon_sym_let] = ACTIONS(3203),
    [anon_sym_const] = ACTIONS(3203),
    [anon_sym_quote] = ACTIONS(3203),
    [anon_sym_using] = ACTIONS(3203),
    [anon_sym_import] = ACTIONS(3203),
    [anon_sym_export] = ACTIONS(3203),
    [anon_sym_COLON2] = ACTIONS(3203),
    [anon_sym_RBRACK] = ACTIONS(3205),
    [anon_sym_begin] = ACTIONS(3203),
    [anon_sym_SQUOTE] = ACTIONS(3205),
    [anon_sym_PLUS] = ACTIONS(3203),
    [anon_sym_LT_PIPE] = ACTIONS(3205),
    [anon_sym_PIPE_GT] = ACTIONS(3205),
    [anon_sym_in] = ACTIONS(3203),
    [anon_sym_isa] = ACTIONS(3203),
    [anon_sym_PIPE_PIPE] = ACTIONS(3205),
    [anon_sym_AMP_AMP] = ACTIONS(3205),
    [anon_sym_QMARK] = ACTIONS(3205),
    [anon_sym_EQ_GT] = ACTIONS(3205),
    [anon_sym_LBRACK2] = ACTIONS(3205),
    [anon_sym_DOLLAR] = ACTIONS(3203),
    [anon_sym_AT] = ACTIONS(3205),
    [aux_sym_integer_literal_token1] = ACTIONS(3205),
    [aux_sym_integer_literal_token2] = ACTIONS(3205),
    [aux_sym_integer_literal_token3] = ACTIONS(3203),
    [sym_float_literal] = ACTIONS(3203),
    [sym__unary_operator] = ACTIONS(3203),
    [sym__power_operator] = ACTIONS(3203),
    [sym__bitshift_operator] = ACTIONS(3203),
    [sym__rational_operator] = ACTIONS(3203),
    [sym__times_operator] = ACTIONS(3203),
    [sym__plus_operator] = ACTIONS(3203),
    [sym__dotty_operator] = ACTIONS(3203),
    [sym__comparison_operator] = ACTIONS(3203),
    [sym__arrow_operator] = ACTIONS(3205),
    [sym__assign_operator] = ACTIONS(3203),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3205),
    [sym__command_start] = ACTIONS(3205),
  },
  [1313] = {
    [sym_identifier] = ACTIONS(3183),
    [anon_sym_function] = ACTIONS(3183),
    [anon_sym_end] = ACTIONS(3183),
    [anon_sym_abstract] = ACTIONS(3183),
    [anon_sym_primitive] = ACTIONS(3183),
    [aux_sym_primitive_definition_token1] = ACTIONS(3183),
    [anon_sym_mutable] = ACTIONS(3183),
    [anon_sym_struct] = ACTIONS(3183),
    [anon_sym_module] = ACTIONS(3183),
    [anon_sym_macro] = ACTIONS(3183),
    [anon_sym_LPAREN] = ACTIONS(3185),
    [anon_sym_COMMA] = ACTIONS(3185),
    [anon_sym_RPAREN] = ACTIONS(3185),
    [anon_sym_SEMI] = ACTIONS(3185),
    [anon_sym_EQ] = ACTIONS(3183),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3185),
    [anon_sym_COLON_COLON] = ACTIONS(3185),
    [anon_sym_RBRACE] = ACTIONS(3185),
    [anon_sym_LT_COLON] = ACTIONS(3185),
    [anon_sym_if] = ACTIONS(3183),
    [anon_sym_try] = ACTIONS(3183),
    [anon_sym_for] = ACTIONS(3183),
    [anon_sym_while] = ACTIONS(3183),
    [sym_break_statement] = ACTIONS(3183),
    [sym_continue_statement] = ACTIONS(3183),
    [anon_sym_return] = ACTIONS(3183),
    [anon_sym_let] = ACTIONS(3183),
    [anon_sym_const] = ACTIONS(3183),
    [anon_sym_quote] = ACTIONS(3183),
    [anon_sym_using] = ACTIONS(3183),
    [anon_sym_import] = ACTIONS(3183),
    [anon_sym_export] = ACTIONS(3183),
    [anon_sym_COLON2] = ACTIONS(3183),
    [anon_sym_RBRACK] = ACTIONS(3185),
    [anon_sym_begin] = ACTIONS(3183),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [anon_sym_PLUS] = ACTIONS(3183),
    [anon_sym_LT_PIPE] = ACTIONS(3185),
    [anon_sym_PIPE_GT] = ACTIONS(3185),
    [anon_sym_in] = ACTIONS(3183),
    [anon_sym_isa] = ACTIONS(3183),
    [anon_sym_PIPE_PIPE] = ACTIONS(3185),
    [anon_sym_AMP_AMP] = ACTIONS(3185),
    [anon_sym_QMARK] = ACTIONS(3185),
    [anon_sym_EQ_GT] = ACTIONS(3185),
    [anon_sym_LBRACK2] = ACTIONS(3185),
    [anon_sym_DOLLAR] = ACTIONS(3183),
    [anon_sym_AT] = ACTIONS(3185),
    [aux_sym_integer_literal_token1] = ACTIONS(3185),
    [aux_sym_integer_literal_token2] = ACTIONS(3185),
    [aux_sym_integer_literal_token3] = ACTIONS(3183),
    [sym_float_literal] = ACTIONS(3183),
    [sym__unary_operator] = ACTIONS(3183),
    [sym__power_operator] = ACTIONS(3183),
    [sym__bitshift_operator] = ACTIONS(3183),
    [sym__rational_operator] = ACTIONS(3183),
    [sym__times_operator] = ACTIONS(3183),
    [sym__plus_operator] = ACTIONS(3183),
    [sym__dotty_operator] = ACTIONS(3183),
    [sym__comparison_operator] = ACTIONS(3183),
    [sym__arrow_operator] = ACTIONS(3185),
    [sym__assign_operator] = ACTIONS(3183),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3185),
    [sym__command_start] = ACTIONS(3185),
  },
  [1314] = {
    [sym_identifier] = ACTIONS(3089),
    [anon_sym_function] = ACTIONS(3089),
    [anon_sym_end] = ACTIONS(3089),
    [anon_sym_abstract] = ACTIONS(3089),
    [anon_sym_primitive] = ACTIONS(3089),
    [aux_sym_primitive_definition_token1] = ACTIONS(3089),
    [anon_sym_mutable] = ACTIONS(3089),
    [anon_sym_struct] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(3089),
    [anon_sym_macro] = ACTIONS(3089),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3091),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3091),
    [anon_sym_COLON_COLON] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_LT_COLON] = ACTIONS(3091),
    [anon_sym_if] = ACTIONS(3089),
    [anon_sym_try] = ACTIONS(3089),
    [anon_sym_for] = ACTIONS(3089),
    [anon_sym_while] = ACTIONS(3089),
    [sym_break_statement] = ACTIONS(3089),
    [sym_continue_statement] = ACTIONS(3089),
    [anon_sym_return] = ACTIONS(3089),
    [anon_sym_let] = ACTIONS(3089),
    [anon_sym_const] = ACTIONS(3089),
    [anon_sym_quote] = ACTIONS(3089),
    [anon_sym_using] = ACTIONS(3089),
    [anon_sym_import] = ACTIONS(3089),
    [anon_sym_export] = ACTIONS(3089),
    [anon_sym_COLON2] = ACTIONS(3089),
    [anon_sym_RBRACK] = ACTIONS(3091),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_LT_PIPE] = ACTIONS(3091),
    [anon_sym_PIPE_GT] = ACTIONS(3091),
    [anon_sym_in] = ACTIONS(3089),
    [anon_sym_isa] = ACTIONS(3089),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_EQ_GT] = ACTIONS(3091),
    [anon_sym_LBRACK2] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3089),
    [anon_sym_AT] = ACTIONS(3091),
    [aux_sym_integer_literal_token1] = ACTIONS(3091),
    [aux_sym_integer_literal_token2] = ACTIONS(3091),
    [aux_sym_integer_literal_token3] = ACTIONS(3089),
    [sym_float_literal] = ACTIONS(3089),
    [sym__unary_operator] = ACTIONS(3089),
    [sym__power_operator] = ACTIONS(3089),
    [sym__bitshift_operator] = ACTIONS(3089),
    [sym__rational_operator] = ACTIONS(3089),
    [sym__times_operator] = ACTIONS(3089),
    [sym__plus_operator] = ACTIONS(3089),
    [sym__dotty_operator] = ACTIONS(3089),
    [sym__comparison_operator] = ACTIONS(3089),
    [sym__arrow_operator] = ACTIONS(3091),
    [sym__assign_operator] = ACTIONS(3089),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3091),
    [sym__command_start] = ACTIONS(3091),
  },
  [1315] = {
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_end] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_primitive] = ACTIONS(2916),
    [aux_sym_primitive_definition_token1] = ACTIONS(2916),
    [anon_sym_mutable] = ACTIONS(2916),
    [anon_sym_struct] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_macro] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(2921),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_LT_COLON] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [sym_break_statement] = ACTIONS(2916),
    [sym_continue_statement] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_quote] = ACTIONS(2916),
    [anon_sym_using] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_COLON2] = ACTIONS(2916),
    [anon_sym_RBRACK] = ACTIONS(2921),
    [anon_sym_begin] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_LT_PIPE] = ACTIONS(2921),
    [anon_sym_PIPE_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2916),
    [anon_sym_isa] = ACTIONS(2916),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2921),
    [aux_sym_integer_literal_token1] = ACTIONS(2921),
    [aux_sym_integer_literal_token2] = ACTIONS(2921),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [sym_float_literal] = ACTIONS(2916),
    [sym__unary_operator] = ACTIONS(2916),
    [sym__power_operator] = ACTIONS(2916),
    [sym__bitshift_operator] = ACTIONS(2916),
    [sym__rational_operator] = ACTIONS(2916),
    [sym__times_operator] = ACTIONS(2916),
    [sym__plus_operator] = ACTIONS(2916),
    [sym__dotty_operator] = ACTIONS(2916),
    [sym__comparison_operator] = ACTIONS(2916),
    [sym__arrow_operator] = ACTIONS(2921),
    [sym__assign_operator] = ACTIONS(2916),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2921),
    [sym__command_start] = ACTIONS(2921),
  },
  [1316] = {
    [sym_identifier] = ACTIONS(2550),
    [anon_sym_function] = ACTIONS(2550),
    [anon_sym_end] = ACTIONS(2550),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_primitive] = ACTIONS(2550),
    [aux_sym_primitive_definition_token1] = ACTIONS(2550),
    [anon_sym_mutable] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_module] = ACTIONS(2550),
    [anon_sym_macro] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2552),
    [anon_sym_COMMA] = ACTIONS(2552),
    [anon_sym_RPAREN] = ACTIONS(2552),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_EQ] = ACTIONS(2550),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2552),
    [anon_sym_COLON_COLON] = ACTIONS(2552),
    [anon_sym_RBRACE] = ACTIONS(2552),
    [anon_sym_LT_COLON] = ACTIONS(2552),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [sym_break_statement] = ACTIONS(2550),
    [sym_continue_statement] = ACTIONS(2550),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_quote] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_import] = ACTIONS(2550),
    [anon_sym_export] = ACTIONS(2550),
    [anon_sym_COLON2] = ACTIONS(2550),
    [anon_sym_RBRACK] = ACTIONS(2552),
    [anon_sym_begin] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_LT_PIPE] = ACTIONS(2552),
    [anon_sym_PIPE_GT] = ACTIONS(2552),
    [anon_sym_in] = ACTIONS(2550),
    [anon_sym_isa] = ACTIONS(2550),
    [anon_sym_PIPE_PIPE] = ACTIONS(2552),
    [anon_sym_AMP_AMP] = ACTIONS(2552),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_EQ_GT] = ACTIONS(2552),
    [anon_sym_LBRACK2] = ACTIONS(2552),
    [anon_sym_DOLLAR] = ACTIONS(2550),
    [anon_sym_AT] = ACTIONS(2552),
    [aux_sym_integer_literal_token1] = ACTIONS(2552),
    [aux_sym_integer_literal_token2] = ACTIONS(2552),
    [aux_sym_integer_literal_token3] = ACTIONS(2550),
    [sym_float_literal] = ACTIONS(2550),
    [sym__unary_operator] = ACTIONS(2550),
    [sym__power_operator] = ACTIONS(2550),
    [sym__bitshift_operator] = ACTIONS(2550),
    [sym__rational_operator] = ACTIONS(2550),
    [sym__times_operator] = ACTIONS(2550),
    [sym__plus_operator] = ACTIONS(2550),
    [sym__dotty_operator] = ACTIONS(2550),
    [sym__comparison_operator] = ACTIONS(2550),
    [sym__arrow_operator] = ACTIONS(2552),
    [sym__assign_operator] = ACTIONS(2550),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2552),
    [sym__command_start] = ACTIONS(2552),
  },
  [1317] = {
    [sym_identifier] = ACTIONS(2558),
    [anon_sym_function] = ACTIONS(2558),
    [anon_sym_end] = ACTIONS(2558),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_primitive] = ACTIONS(2558),
    [aux_sym_primitive_definition_token1] = ACTIONS(2558),
    [anon_sym_mutable] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_module] = ACTIONS(2558),
    [anon_sym_macro] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_COMMA] = ACTIONS(2560),
    [anon_sym_RPAREN] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_EQ] = ACTIONS(2558),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2560),
    [anon_sym_COLON_COLON] = ACTIONS(2560),
    [anon_sym_RBRACE] = ACTIONS(2560),
    [anon_sym_LT_COLON] = ACTIONS(2560),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [sym_break_statement] = ACTIONS(2558),
    [sym_continue_statement] = ACTIONS(2558),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_quote] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_import] = ACTIONS(2558),
    [anon_sym_export] = ACTIONS(2558),
    [anon_sym_COLON2] = ACTIONS(2558),
    [anon_sym_RBRACK] = ACTIONS(2560),
    [anon_sym_begin] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_LT_PIPE] = ACTIONS(2560),
    [anon_sym_PIPE_GT] = ACTIONS(2560),
    [anon_sym_in] = ACTIONS(2558),
    [anon_sym_isa] = ACTIONS(2558),
    [anon_sym_PIPE_PIPE] = ACTIONS(2560),
    [anon_sym_AMP_AMP] = ACTIONS(2560),
    [anon_sym_QMARK] = ACTIONS(2560),
    [anon_sym_EQ_GT] = ACTIONS(2560),
    [anon_sym_LBRACK2] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(2558),
    [anon_sym_AT] = ACTIONS(2560),
    [aux_sym_integer_literal_token1] = ACTIONS(2560),
    [aux_sym_integer_literal_token2] = ACTIONS(2560),
    [aux_sym_integer_literal_token3] = ACTIONS(2558),
    [sym_float_literal] = ACTIONS(2558),
    [sym__unary_operator] = ACTIONS(2558),
    [sym__power_operator] = ACTIONS(2558),
    [sym__bitshift_operator] = ACTIONS(2558),
    [sym__rational_operator] = ACTIONS(2558),
    [sym__times_operator] = ACTIONS(2558),
    [sym__plus_operator] = ACTIONS(2558),
    [sym__dotty_operator] = ACTIONS(2558),
    [sym__comparison_operator] = ACTIONS(2558),
    [sym__arrow_operator] = ACTIONS(2560),
    [sym__assign_operator] = ACTIONS(2558),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2560),
    [sym__command_start] = ACTIONS(2560),
  },
  [1318] = {
    [sym_identifier] = ACTIONS(2566),
    [anon_sym_function] = ACTIONS(2566),
    [anon_sym_end] = ACTIONS(2566),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_primitive] = ACTIONS(2566),
    [aux_sym_primitive_definition_token1] = ACTIONS(2566),
    [anon_sym_mutable] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_module] = ACTIONS(2566),
    [anon_sym_macro] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2568),
    [anon_sym_COMMA] = ACTIONS(2568),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(2566),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2568),
    [anon_sym_COLON_COLON] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_LT_COLON] = ACTIONS(2568),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [sym_break_statement] = ACTIONS(2566),
    [sym_continue_statement] = ACTIONS(2566),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_quote] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_import] = ACTIONS(2566),
    [anon_sym_export] = ACTIONS(2566),
    [anon_sym_COLON2] = ACTIONS(2566),
    [anon_sym_RBRACK] = ACTIONS(2568),
    [anon_sym_begin] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2568),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_LT_PIPE] = ACTIONS(2568),
    [anon_sym_PIPE_GT] = ACTIONS(2568),
    [anon_sym_in] = ACTIONS(2566),
    [anon_sym_isa] = ACTIONS(2566),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_QMARK] = ACTIONS(2568),
    [anon_sym_EQ_GT] = ACTIONS(2568),
    [anon_sym_LBRACK2] = ACTIONS(2568),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_AT] = ACTIONS(2568),
    [aux_sym_integer_literal_token1] = ACTIONS(2568),
    [aux_sym_integer_literal_token2] = ACTIONS(2568),
    [aux_sym_integer_literal_token3] = ACTIONS(2566),
    [sym_float_literal] = ACTIONS(2566),
    [sym__unary_operator] = ACTIONS(2566),
    [sym__power_operator] = ACTIONS(2566),
    [sym__bitshift_operator] = ACTIONS(2566),
    [sym__rational_operator] = ACTIONS(2566),
    [sym__times_operator] = ACTIONS(2566),
    [sym__plus_operator] = ACTIONS(2566),
    [sym__dotty_operator] = ACTIONS(2566),
    [sym__comparison_operator] = ACTIONS(2566),
    [sym__arrow_operator] = ACTIONS(2568),
    [sym__assign_operator] = ACTIONS(2566),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2568),
    [sym__command_start] = ACTIONS(2568),
  },
  [1319] = {
    [sym_identifier] = ACTIONS(2570),
    [anon_sym_function] = ACTIONS(2570),
    [anon_sym_end] = ACTIONS(2570),
    [anon_sym_abstract] = ACTIONS(2570),
    [anon_sym_primitive] = ACTIONS(2570),
    [aux_sym_primitive_definition_token1] = ACTIONS(2570),
    [anon_sym_mutable] = ACTIONS(2570),
    [anon_sym_struct] = ACTIONS(2570),
    [anon_sym_module] = ACTIONS(2570),
    [anon_sym_macro] = ACTIONS(2570),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_COMMA] = ACTIONS(2572),
    [anon_sym_RPAREN] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2572),
    [anon_sym_EQ] = ACTIONS(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2572),
    [anon_sym_COLON_COLON] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_LT_COLON] = ACTIONS(2572),
    [anon_sym_if] = ACTIONS(2570),
    [anon_sym_try] = ACTIONS(2570),
    [anon_sym_for] = ACTIONS(2570),
    [anon_sym_while] = ACTIONS(2570),
    [sym_break_statement] = ACTIONS(2570),
    [sym_continue_statement] = ACTIONS(2570),
    [anon_sym_return] = ACTIONS(2570),
    [anon_sym_let] = ACTIONS(2570),
    [anon_sym_const] = ACTIONS(2570),
    [anon_sym_quote] = ACTIONS(2570),
    [anon_sym_using] = ACTIONS(2570),
    [anon_sym_import] = ACTIONS(2570),
    [anon_sym_export] = ACTIONS(2570),
    [anon_sym_COLON2] = ACTIONS(2570),
    [anon_sym_RBRACK] = ACTIONS(2572),
    [anon_sym_begin] = ACTIONS(2570),
    [anon_sym_SQUOTE] = ACTIONS(2572),
    [anon_sym_PLUS] = ACTIONS(2570),
    [anon_sym_LT_PIPE] = ACTIONS(2572),
    [anon_sym_PIPE_GT] = ACTIONS(2572),
    [anon_sym_in] = ACTIONS(2570),
    [anon_sym_isa] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(2572),
    [anon_sym_AMP_AMP] = ACTIONS(2572),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_EQ_GT] = ACTIONS(2572),
    [anon_sym_LBRACK2] = ACTIONS(2572),
    [anon_sym_DOLLAR] = ACTIONS(2570),
    [anon_sym_AT] = ACTIONS(2572),
    [aux_sym_integer_literal_token1] = ACTIONS(2572),
    [aux_sym_integer_literal_token2] = ACTIONS(2572),
    [aux_sym_integer_literal_token3] = ACTIONS(2570),
    [sym_float_literal] = ACTIONS(2570),
    [sym__unary_operator] = ACTIONS(2570),
    [sym__power_operator] = ACTIONS(2570),
    [sym__bitshift_operator] = ACTIONS(2570),
    [sym__rational_operator] = ACTIONS(2570),
    [sym__times_operator] = ACTIONS(2570),
    [sym__plus_operator] = ACTIONS(2570),
    [sym__dotty_operator] = ACTIONS(2570),
    [sym__comparison_operator] = ACTIONS(2570),
    [sym__arrow_operator] = ACTIONS(2572),
    [sym__assign_operator] = ACTIONS(2570),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2572),
    [sym__command_start] = ACTIONS(2572),
  },
  [1320] = {
    [sym_identifier] = ACTIONS(3179),
    [anon_sym_function] = ACTIONS(3179),
    [anon_sym_end] = ACTIONS(3179),
    [anon_sym_abstract] = ACTIONS(3179),
    [anon_sym_primitive] = ACTIONS(3179),
    [aux_sym_primitive_definition_token1] = ACTIONS(3179),
    [anon_sym_mutable] = ACTIONS(3179),
    [anon_sym_struct] = ACTIONS(3179),
    [anon_sym_module] = ACTIONS(3179),
    [anon_sym_macro] = ACTIONS(3179),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_COMMA] = ACTIONS(3181),
    [anon_sym_RPAREN] = ACTIONS(3181),
    [anon_sym_SEMI] = ACTIONS(3181),
    [anon_sym_EQ] = ACTIONS(3179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3181),
    [anon_sym_COLON_COLON] = ACTIONS(3181),
    [anon_sym_RBRACE] = ACTIONS(3181),
    [anon_sym_LT_COLON] = ACTIONS(3181),
    [anon_sym_if] = ACTIONS(3179),
    [anon_sym_try] = ACTIONS(3179),
    [anon_sym_for] = ACTIONS(3179),
    [anon_sym_while] = ACTIONS(3179),
    [sym_break_statement] = ACTIONS(3179),
    [sym_continue_statement] = ACTIONS(3179),
    [anon_sym_return] = ACTIONS(3179),
    [anon_sym_let] = ACTIONS(3179),
    [anon_sym_const] = ACTIONS(3179),
    [anon_sym_quote] = ACTIONS(3179),
    [anon_sym_using] = ACTIONS(3179),
    [anon_sym_import] = ACTIONS(3179),
    [anon_sym_export] = ACTIONS(3179),
    [anon_sym_COLON2] = ACTIONS(3179),
    [anon_sym_RBRACK] = ACTIONS(3181),
    [anon_sym_begin] = ACTIONS(3179),
    [anon_sym_SQUOTE] = ACTIONS(3181),
    [anon_sym_PLUS] = ACTIONS(3179),
    [anon_sym_LT_PIPE] = ACTIONS(3181),
    [anon_sym_PIPE_GT] = ACTIONS(3181),
    [anon_sym_in] = ACTIONS(3179),
    [anon_sym_isa] = ACTIONS(3179),
    [anon_sym_PIPE_PIPE] = ACTIONS(3181),
    [anon_sym_AMP_AMP] = ACTIONS(3181),
    [anon_sym_QMARK] = ACTIONS(3181),
    [anon_sym_EQ_GT] = ACTIONS(3181),
    [anon_sym_LBRACK2] = ACTIONS(3181),
    [anon_sym_DOLLAR] = ACTIONS(3179),
    [anon_sym_AT] = ACTIONS(3181),
    [aux_sym_integer_literal_token1] = ACTIONS(3181),
    [aux_sym_integer_literal_token2] = ACTIONS(3181),
    [aux_sym_integer_literal_token3] = ACTIONS(3179),
    [sym_float_literal] = ACTIONS(3179),
    [sym__unary_operator] = ACTIONS(3179),
    [sym__power_operator] = ACTIONS(3179),
    [sym__bitshift_operator] = ACTIONS(3179),
    [sym__rational_operator] = ACTIONS(3179),
    [sym__times_operator] = ACTIONS(3179),
    [sym__plus_operator] = ACTIONS(3179),
    [sym__dotty_operator] = ACTIONS(3179),
    [sym__comparison_operator] = ACTIONS(3179),
    [sym__arrow_operator] = ACTIONS(3181),
    [sym__assign_operator] = ACTIONS(3179),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3181),
    [sym__command_start] = ACTIONS(3181),
  },
  [1321] = {
    [sym_identifier] = ACTIONS(3175),
    [anon_sym_function] = ACTIONS(3175),
    [anon_sym_end] = ACTIONS(3175),
    [anon_sym_abstract] = ACTIONS(3175),
    [anon_sym_primitive] = ACTIONS(3175),
    [aux_sym_primitive_definition_token1] = ACTIONS(3175),
    [anon_sym_mutable] = ACTIONS(3175),
    [anon_sym_struct] = ACTIONS(3175),
    [anon_sym_module] = ACTIONS(3175),
    [anon_sym_macro] = ACTIONS(3175),
    [anon_sym_LPAREN] = ACTIONS(3177),
    [anon_sym_COMMA] = ACTIONS(3177),
    [anon_sym_RPAREN] = ACTIONS(3177),
    [anon_sym_SEMI] = ACTIONS(3177),
    [anon_sym_EQ] = ACTIONS(3175),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3177),
    [anon_sym_COLON_COLON] = ACTIONS(3177),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [anon_sym_LT_COLON] = ACTIONS(3177),
    [anon_sym_if] = ACTIONS(3175),
    [anon_sym_try] = ACTIONS(3175),
    [anon_sym_for] = ACTIONS(3175),
    [anon_sym_while] = ACTIONS(3175),
    [sym_break_statement] = ACTIONS(3175),
    [sym_continue_statement] = ACTIONS(3175),
    [anon_sym_return] = ACTIONS(3175),
    [anon_sym_let] = ACTIONS(3175),
    [anon_sym_const] = ACTIONS(3175),
    [anon_sym_quote] = ACTIONS(3175),
    [anon_sym_using] = ACTIONS(3175),
    [anon_sym_import] = ACTIONS(3175),
    [anon_sym_export] = ACTIONS(3175),
    [anon_sym_COLON2] = ACTIONS(3175),
    [anon_sym_RBRACK] = ACTIONS(3177),
    [anon_sym_begin] = ACTIONS(3175),
    [anon_sym_SQUOTE] = ACTIONS(3177),
    [anon_sym_PLUS] = ACTIONS(3175),
    [anon_sym_LT_PIPE] = ACTIONS(3177),
    [anon_sym_PIPE_GT] = ACTIONS(3177),
    [anon_sym_in] = ACTIONS(3175),
    [anon_sym_isa] = ACTIONS(3175),
    [anon_sym_PIPE_PIPE] = ACTIONS(3177),
    [anon_sym_AMP_AMP] = ACTIONS(3177),
    [anon_sym_QMARK] = ACTIONS(3177),
    [anon_sym_EQ_GT] = ACTIONS(3177),
    [anon_sym_LBRACK2] = ACTIONS(3177),
    [anon_sym_DOLLAR] = ACTIONS(3175),
    [anon_sym_AT] = ACTIONS(3177),
    [aux_sym_integer_literal_token1] = ACTIONS(3177),
    [aux_sym_integer_literal_token2] = ACTIONS(3177),
    [aux_sym_integer_literal_token3] = ACTIONS(3175),
    [sym_float_literal] = ACTIONS(3175),
    [sym__unary_operator] = ACTIONS(3175),
    [sym__power_operator] = ACTIONS(3175),
    [sym__bitshift_operator] = ACTIONS(3175),
    [sym__rational_operator] = ACTIONS(3175),
    [sym__times_operator] = ACTIONS(3175),
    [sym__plus_operator] = ACTIONS(3175),
    [sym__dotty_operator] = ACTIONS(3175),
    [sym__comparison_operator] = ACTIONS(3175),
    [sym__arrow_operator] = ACTIONS(3177),
    [sym__assign_operator] = ACTIONS(3175),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3177),
    [sym__command_start] = ACTIONS(3177),
  },
  [1322] = {
    [sym_identifier] = ACTIONS(2574),
    [anon_sym_function] = ACTIONS(2574),
    [anon_sym_end] = ACTIONS(2574),
    [anon_sym_abstract] = ACTIONS(2574),
    [anon_sym_primitive] = ACTIONS(2574),
    [aux_sym_primitive_definition_token1] = ACTIONS(2574),
    [anon_sym_mutable] = ACTIONS(2574),
    [anon_sym_struct] = ACTIONS(2574),
    [anon_sym_module] = ACTIONS(2574),
    [anon_sym_macro] = ACTIONS(2574),
    [anon_sym_LPAREN] = ACTIONS(2576),
    [anon_sym_COMMA] = ACTIONS(2576),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2576),
    [anon_sym_EQ] = ACTIONS(2574),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2576),
    [anon_sym_COLON_COLON] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_LT_COLON] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2574),
    [anon_sym_try] = ACTIONS(2574),
    [anon_sym_for] = ACTIONS(2574),
    [anon_sym_while] = ACTIONS(2574),
    [sym_break_statement] = ACTIONS(2574),
    [sym_continue_statement] = ACTIONS(2574),
    [anon_sym_return] = ACTIONS(2574),
    [anon_sym_let] = ACTIONS(2574),
    [anon_sym_const] = ACTIONS(2574),
    [anon_sym_quote] = ACTIONS(2574),
    [anon_sym_using] = ACTIONS(2574),
    [anon_sym_import] = ACTIONS(2574),
    [anon_sym_export] = ACTIONS(2574),
    [anon_sym_COLON2] = ACTIONS(2574),
    [anon_sym_RBRACK] = ACTIONS(2576),
    [anon_sym_begin] = ACTIONS(2574),
    [anon_sym_SQUOTE] = ACTIONS(2576),
    [anon_sym_PLUS] = ACTIONS(2574),
    [anon_sym_LT_PIPE] = ACTIONS(2576),
    [anon_sym_PIPE_GT] = ACTIONS(2576),
    [anon_sym_in] = ACTIONS(2574),
    [anon_sym_isa] = ACTIONS(2574),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_QMARK] = ACTIONS(2576),
    [anon_sym_EQ_GT] = ACTIONS(2576),
    [anon_sym_LBRACK2] = ACTIONS(2576),
    [anon_sym_DOLLAR] = ACTIONS(2574),
    [anon_sym_AT] = ACTIONS(2576),
    [aux_sym_integer_literal_token1] = ACTIONS(2576),
    [aux_sym_integer_literal_token2] = ACTIONS(2576),
    [aux_sym_integer_literal_token3] = ACTIONS(2574),
    [sym_float_literal] = ACTIONS(2574),
    [sym__unary_operator] = ACTIONS(2574),
    [sym__power_operator] = ACTIONS(2574),
    [sym__bitshift_operator] = ACTIONS(2574),
    [sym__rational_operator] = ACTIONS(2574),
    [sym__times_operator] = ACTIONS(2574),
    [sym__plus_operator] = ACTIONS(2574),
    [sym__dotty_operator] = ACTIONS(2574),
    [sym__comparison_operator] = ACTIONS(2574),
    [sym__arrow_operator] = ACTIONS(2576),
    [sym__assign_operator] = ACTIONS(2574),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2576),
    [sym__command_start] = ACTIONS(2576),
  },
  [1323] = {
    [sym_identifier] = ACTIONS(3171),
    [anon_sym_function] = ACTIONS(3171),
    [anon_sym_end] = ACTIONS(3171),
    [anon_sym_abstract] = ACTIONS(3171),
    [anon_sym_primitive] = ACTIONS(3171),
    [aux_sym_primitive_definition_token1] = ACTIONS(3171),
    [anon_sym_mutable] = ACTIONS(3171),
    [anon_sym_struct] = ACTIONS(3171),
    [anon_sym_module] = ACTIONS(3171),
    [anon_sym_macro] = ACTIONS(3171),
    [anon_sym_LPAREN] = ACTIONS(3173),
    [anon_sym_COMMA] = ACTIONS(3173),
    [anon_sym_RPAREN] = ACTIONS(3173),
    [anon_sym_SEMI] = ACTIONS(3173),
    [anon_sym_EQ] = ACTIONS(3171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3173),
    [anon_sym_COLON_COLON] = ACTIONS(3173),
    [anon_sym_RBRACE] = ACTIONS(3173),
    [anon_sym_LT_COLON] = ACTIONS(3173),
    [anon_sym_if] = ACTIONS(3171),
    [anon_sym_try] = ACTIONS(3171),
    [anon_sym_for] = ACTIONS(3171),
    [anon_sym_while] = ACTIONS(3171),
    [sym_break_statement] = ACTIONS(3171),
    [sym_continue_statement] = ACTIONS(3171),
    [anon_sym_return] = ACTIONS(3171),
    [anon_sym_let] = ACTIONS(3171),
    [anon_sym_const] = ACTIONS(3171),
    [anon_sym_quote] = ACTIONS(3171),
    [anon_sym_using] = ACTIONS(3171),
    [anon_sym_import] = ACTIONS(3171),
    [anon_sym_export] = ACTIONS(3171),
    [anon_sym_COLON2] = ACTIONS(3171),
    [anon_sym_RBRACK] = ACTIONS(3173),
    [anon_sym_begin] = ACTIONS(3171),
    [anon_sym_SQUOTE] = ACTIONS(3173),
    [anon_sym_PLUS] = ACTIONS(3171),
    [anon_sym_LT_PIPE] = ACTIONS(3173),
    [anon_sym_PIPE_GT] = ACTIONS(3173),
    [anon_sym_in] = ACTIONS(3171),
    [anon_sym_isa] = ACTIONS(3171),
    [anon_sym_PIPE_PIPE] = ACTIONS(3173),
    [anon_sym_AMP_AMP] = ACTIONS(3173),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_EQ_GT] = ACTIONS(3173),
    [anon_sym_LBRACK2] = ACTIONS(3173),
    [anon_sym_DOLLAR] = ACTIONS(3171),
    [anon_sym_AT] = ACTIONS(3173),
    [aux_sym_integer_literal_token1] = ACTIONS(3173),
    [aux_sym_integer_literal_token2] = ACTIONS(3173),
    [aux_sym_integer_literal_token3] = ACTIONS(3171),
    [sym_float_literal] = ACTIONS(3171),
    [sym__unary_operator] = ACTIONS(3171),
    [sym__power_operator] = ACTIONS(3171),
    [sym__bitshift_operator] = ACTIONS(3171),
    [sym__rational_operator] = ACTIONS(3171),
    [sym__times_operator] = ACTIONS(3171),
    [sym__plus_operator] = ACTIONS(3171),
    [sym__dotty_operator] = ACTIONS(3171),
    [sym__comparison_operator] = ACTIONS(3171),
    [sym__arrow_operator] = ACTIONS(3173),
    [sym__assign_operator] = ACTIONS(3171),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3173),
    [sym__command_start] = ACTIONS(3173),
  },
  [1324] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_function] = ACTIONS(3163),
    [anon_sym_end] = ACTIONS(3163),
    [anon_sym_abstract] = ACTIONS(3163),
    [anon_sym_primitive] = ACTIONS(3163),
    [aux_sym_primitive_definition_token1] = ACTIONS(3163),
    [anon_sym_mutable] = ACTIONS(3163),
    [anon_sym_struct] = ACTIONS(3163),
    [anon_sym_module] = ACTIONS(3163),
    [anon_sym_macro] = ACTIONS(3163),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3165),
    [anon_sym_COLON_COLON] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_LT_COLON] = ACTIONS(3165),
    [anon_sym_if] = ACTIONS(3163),
    [anon_sym_try] = ACTIONS(3163),
    [anon_sym_for] = ACTIONS(3163),
    [anon_sym_while] = ACTIONS(3163),
    [sym_break_statement] = ACTIONS(3163),
    [sym_continue_statement] = ACTIONS(3163),
    [anon_sym_return] = ACTIONS(3163),
    [anon_sym_let] = ACTIONS(3163),
    [anon_sym_const] = ACTIONS(3163),
    [anon_sym_quote] = ACTIONS(3163),
    [anon_sym_using] = ACTIONS(3163),
    [anon_sym_import] = ACTIONS(3163),
    [anon_sym_export] = ACTIONS(3163),
    [anon_sym_COLON2] = ACTIONS(3163),
    [anon_sym_RBRACK] = ACTIONS(3165),
    [anon_sym_begin] = ACTIONS(3163),
    [anon_sym_SQUOTE] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_LT_PIPE] = ACTIONS(3165),
    [anon_sym_PIPE_GT] = ACTIONS(3165),
    [anon_sym_in] = ACTIONS(3163),
    [anon_sym_isa] = ACTIONS(3163),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_EQ_GT] = ACTIONS(3165),
    [anon_sym_LBRACK2] = ACTIONS(3165),
    [anon_sym_DOLLAR] = ACTIONS(3163),
    [anon_sym_AT] = ACTIONS(3165),
    [aux_sym_integer_literal_token1] = ACTIONS(3165),
    [aux_sym_integer_literal_token2] = ACTIONS(3165),
    [aux_sym_integer_literal_token3] = ACTIONS(3163),
    [sym_float_literal] = ACTIONS(3163),
    [sym__unary_operator] = ACTIONS(3163),
    [sym__power_operator] = ACTIONS(3163),
    [sym__bitshift_operator] = ACTIONS(3163),
    [sym__rational_operator] = ACTIONS(3163),
    [sym__times_operator] = ACTIONS(3163),
    [sym__plus_operator] = ACTIONS(3163),
    [sym__dotty_operator] = ACTIONS(3163),
    [sym__comparison_operator] = ACTIONS(3163),
    [sym__arrow_operator] = ACTIONS(3165),
    [sym__assign_operator] = ACTIONS(3163),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3165),
    [sym__command_start] = ACTIONS(3165),
  },
  [1325] = {
    [sym_identifier] = ACTIONS(3123),
    [anon_sym_function] = ACTIONS(3123),
    [anon_sym_end] = ACTIONS(3123),
    [anon_sym_abstract] = ACTIONS(3123),
    [anon_sym_primitive] = ACTIONS(3123),
    [aux_sym_primitive_definition_token1] = ACTIONS(3123),
    [anon_sym_mutable] = ACTIONS(3123),
    [anon_sym_struct] = ACTIONS(3123),
    [anon_sym_module] = ACTIONS(3123),
    [anon_sym_macro] = ACTIONS(3123),
    [anon_sym_LPAREN] = ACTIONS(3125),
    [anon_sym_COMMA] = ACTIONS(3125),
    [anon_sym_RPAREN] = ACTIONS(3125),
    [anon_sym_SEMI] = ACTIONS(3125),
    [anon_sym_EQ] = ACTIONS(3123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3125),
    [anon_sym_COLON_COLON] = ACTIONS(3125),
    [anon_sym_RBRACE] = ACTIONS(3125),
    [anon_sym_LT_COLON] = ACTIONS(3125),
    [anon_sym_if] = ACTIONS(3123),
    [anon_sym_try] = ACTIONS(3123),
    [anon_sym_for] = ACTIONS(3123),
    [anon_sym_while] = ACTIONS(3123),
    [sym_break_statement] = ACTIONS(3123),
    [sym_continue_statement] = ACTIONS(3123),
    [anon_sym_return] = ACTIONS(3123),
    [anon_sym_let] = ACTIONS(3123),
    [anon_sym_const] = ACTIONS(3123),
    [anon_sym_quote] = ACTIONS(3123),
    [anon_sym_using] = ACTIONS(3123),
    [anon_sym_import] = ACTIONS(3123),
    [anon_sym_export] = ACTIONS(3123),
    [anon_sym_COLON2] = ACTIONS(3123),
    [anon_sym_RBRACK] = ACTIONS(3125),
    [anon_sym_begin] = ACTIONS(3123),
    [anon_sym_SQUOTE] = ACTIONS(3125),
    [anon_sym_PLUS] = ACTIONS(3123),
    [anon_sym_LT_PIPE] = ACTIONS(3125),
    [anon_sym_PIPE_GT] = ACTIONS(3125),
    [anon_sym_in] = ACTIONS(3123),
    [anon_sym_isa] = ACTIONS(3123),
    [anon_sym_PIPE_PIPE] = ACTIONS(3125),
    [anon_sym_AMP_AMP] = ACTIONS(3125),
    [anon_sym_QMARK] = ACTIONS(3125),
    [anon_sym_EQ_GT] = ACTIONS(3125),
    [anon_sym_LBRACK2] = ACTIONS(3125),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [anon_sym_AT] = ACTIONS(3125),
    [aux_sym_integer_literal_token1] = ACTIONS(3125),
    [aux_sym_integer_literal_token2] = ACTIONS(3125),
    [aux_sym_integer_literal_token3] = ACTIONS(3123),
    [sym_float_literal] = ACTIONS(3123),
    [sym__unary_operator] = ACTIONS(3123),
    [sym__power_operator] = ACTIONS(3123),
    [sym__bitshift_operator] = ACTIONS(3123),
    [sym__rational_operator] = ACTIONS(3123),
    [sym__times_operator] = ACTIONS(3123),
    [sym__plus_operator] = ACTIONS(3123),
    [sym__dotty_operator] = ACTIONS(3123),
    [sym__comparison_operator] = ACTIONS(3123),
    [sym__arrow_operator] = ACTIONS(3125),
    [sym__assign_operator] = ACTIONS(3123),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3125),
    [sym__command_start] = ACTIONS(3125),
  },
  [1326] = {
    [sym_identifier] = ACTIONS(2578),
    [anon_sym_function] = ACTIONS(2578),
    [anon_sym_end] = ACTIONS(2578),
    [anon_sym_abstract] = ACTIONS(2578),
    [anon_sym_primitive] = ACTIONS(2578),
    [aux_sym_primitive_definition_token1] = ACTIONS(2578),
    [anon_sym_mutable] = ACTIONS(2578),
    [anon_sym_struct] = ACTIONS(2578),
    [anon_sym_module] = ACTIONS(2578),
    [anon_sym_macro] = ACTIONS(2578),
    [anon_sym_LPAREN] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_EQ] = ACTIONS(2578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2580),
    [anon_sym_COLON_COLON] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_LT_COLON] = ACTIONS(2580),
    [anon_sym_if] = ACTIONS(2578),
    [anon_sym_try] = ACTIONS(2578),
    [anon_sym_for] = ACTIONS(2578),
    [anon_sym_while] = ACTIONS(2578),
    [sym_break_statement] = ACTIONS(2578),
    [sym_continue_statement] = ACTIONS(2578),
    [anon_sym_return] = ACTIONS(2578),
    [anon_sym_let] = ACTIONS(2578),
    [anon_sym_const] = ACTIONS(2578),
    [anon_sym_quote] = ACTIONS(2578),
    [anon_sym_using] = ACTIONS(2578),
    [anon_sym_import] = ACTIONS(2578),
    [anon_sym_export] = ACTIONS(2578),
    [anon_sym_COLON2] = ACTIONS(2578),
    [anon_sym_RBRACK] = ACTIONS(2580),
    [anon_sym_begin] = ACTIONS(2578),
    [anon_sym_SQUOTE] = ACTIONS(2580),
    [anon_sym_PLUS] = ACTIONS(2578),
    [anon_sym_LT_PIPE] = ACTIONS(2580),
    [anon_sym_PIPE_GT] = ACTIONS(2580),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_isa] = ACTIONS(2578),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_QMARK] = ACTIONS(2580),
    [anon_sym_EQ_GT] = ACTIONS(2580),
    [anon_sym_LBRACK2] = ACTIONS(2580),
    [anon_sym_DOLLAR] = ACTIONS(2578),
    [anon_sym_AT] = ACTIONS(2580),
    [aux_sym_integer_literal_token1] = ACTIONS(2580),
    [aux_sym_integer_literal_token2] = ACTIONS(2580),
    [aux_sym_integer_literal_token3] = ACTIONS(2578),
    [sym_float_literal] = ACTIONS(2578),
    [sym__unary_operator] = ACTIONS(2578),
    [sym__power_operator] = ACTIONS(2578),
    [sym__bitshift_operator] = ACTIONS(2578),
    [sym__rational_operator] = ACTIONS(2578),
    [sym__times_operator] = ACTIONS(2578),
    [sym__plus_operator] = ACTIONS(2578),
    [sym__dotty_operator] = ACTIONS(2578),
    [sym__comparison_operator] = ACTIONS(2578),
    [sym__arrow_operator] = ACTIONS(2580),
    [sym__assign_operator] = ACTIONS(2578),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2580),
    [sym__command_start] = ACTIONS(2580),
  },
  [1327] = {
    [sym_identifier] = ACTIONS(2582),
    [anon_sym_function] = ACTIONS(2582),
    [anon_sym_end] = ACTIONS(2582),
    [anon_sym_abstract] = ACTIONS(2582),
    [anon_sym_primitive] = ACTIONS(2582),
    [aux_sym_primitive_definition_token1] = ACTIONS(2582),
    [anon_sym_mutable] = ACTIONS(2582),
    [anon_sym_struct] = ACTIONS(2582),
    [anon_sym_module] = ACTIONS(2582),
    [anon_sym_macro] = ACTIONS(2582),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_EQ] = ACTIONS(2582),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2584),
    [anon_sym_COLON_COLON] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_LT_COLON] = ACTIONS(2584),
    [anon_sym_if] = ACTIONS(2582),
    [anon_sym_try] = ACTIONS(2582),
    [anon_sym_for] = ACTIONS(2582),
    [anon_sym_while] = ACTIONS(2582),
    [sym_break_statement] = ACTIONS(2582),
    [sym_continue_statement] = ACTIONS(2582),
    [anon_sym_return] = ACTIONS(2582),
    [anon_sym_let] = ACTIONS(2582),
    [anon_sym_const] = ACTIONS(2582),
    [anon_sym_quote] = ACTIONS(2582),
    [anon_sym_using] = ACTIONS(2582),
    [anon_sym_import] = ACTIONS(2582),
    [anon_sym_export] = ACTIONS(2582),
    [anon_sym_COLON2] = ACTIONS(2582),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_begin] = ACTIONS(2582),
    [anon_sym_SQUOTE] = ACTIONS(2584),
    [anon_sym_PLUS] = ACTIONS(2582),
    [anon_sym_LT_PIPE] = ACTIONS(2584),
    [anon_sym_PIPE_GT] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2582),
    [anon_sym_isa] = ACTIONS(2582),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_QMARK] = ACTIONS(2584),
    [anon_sym_EQ_GT] = ACTIONS(2584),
    [anon_sym_LBRACK2] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2582),
    [anon_sym_AT] = ACTIONS(2584),
    [aux_sym_integer_literal_token1] = ACTIONS(2584),
    [aux_sym_integer_literal_token2] = ACTIONS(2584),
    [aux_sym_integer_literal_token3] = ACTIONS(2582),
    [sym_float_literal] = ACTIONS(2582),
    [sym__unary_operator] = ACTIONS(2582),
    [sym__power_operator] = ACTIONS(2582),
    [sym__bitshift_operator] = ACTIONS(2582),
    [sym__rational_operator] = ACTIONS(2582),
    [sym__times_operator] = ACTIONS(2582),
    [sym__plus_operator] = ACTIONS(2582),
    [sym__dotty_operator] = ACTIONS(2582),
    [sym__comparison_operator] = ACTIONS(2582),
    [sym__arrow_operator] = ACTIONS(2584),
    [sym__assign_operator] = ACTIONS(2582),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2584),
    [sym__command_start] = ACTIONS(2584),
  },
  [1328] = {
    [sym_identifier] = ACTIONS(2542),
    [anon_sym_function] = ACTIONS(2542),
    [anon_sym_end] = ACTIONS(2542),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_primitive] = ACTIONS(2542),
    [aux_sym_primitive_definition_token1] = ACTIONS(2542),
    [anon_sym_mutable] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_module] = ACTIONS(2542),
    [anon_sym_macro] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2544),
    [anon_sym_COMMA] = ACTIONS(2544),
    [anon_sym_RPAREN] = ACTIONS(2544),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_EQ] = ACTIONS(2542),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2544),
    [anon_sym_COLON_COLON] = ACTIONS(2544),
    [anon_sym_RBRACE] = ACTIONS(2544),
    [anon_sym_LT_COLON] = ACTIONS(2544),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [sym_break_statement] = ACTIONS(2542),
    [sym_continue_statement] = ACTIONS(2542),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_quote] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_import] = ACTIONS(2542),
    [anon_sym_export] = ACTIONS(2542),
    [anon_sym_COLON2] = ACTIONS(2542),
    [anon_sym_RBRACK] = ACTIONS(2544),
    [anon_sym_begin] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_LT_PIPE] = ACTIONS(2544),
    [anon_sym_PIPE_GT] = ACTIONS(2544),
    [anon_sym_in] = ACTIONS(2542),
    [anon_sym_isa] = ACTIONS(2542),
    [anon_sym_PIPE_PIPE] = ACTIONS(2544),
    [anon_sym_AMP_AMP] = ACTIONS(2544),
    [anon_sym_QMARK] = ACTIONS(2544),
    [anon_sym_EQ_GT] = ACTIONS(2544),
    [anon_sym_LBRACK2] = ACTIONS(2544),
    [anon_sym_DOLLAR] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2544),
    [aux_sym_integer_literal_token1] = ACTIONS(2544),
    [aux_sym_integer_literal_token2] = ACTIONS(2544),
    [aux_sym_integer_literal_token3] = ACTIONS(2542),
    [sym_float_literal] = ACTIONS(2542),
    [sym__unary_operator] = ACTIONS(2542),
    [sym__power_operator] = ACTIONS(2542),
    [sym__bitshift_operator] = ACTIONS(2542),
    [sym__rational_operator] = ACTIONS(2542),
    [sym__times_operator] = ACTIONS(2542),
    [sym__plus_operator] = ACTIONS(2542),
    [sym__dotty_operator] = ACTIONS(2542),
    [sym__comparison_operator] = ACTIONS(2542),
    [sym__arrow_operator] = ACTIONS(2544),
    [sym__assign_operator] = ACTIONS(2542),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2544),
    [sym__command_start] = ACTIONS(2544),
  },
  [1329] = {
    [sym_identifier] = ACTIONS(3155),
    [anon_sym_function] = ACTIONS(3155),
    [anon_sym_end] = ACTIONS(3155),
    [anon_sym_abstract] = ACTIONS(3155),
    [anon_sym_primitive] = ACTIONS(3155),
    [aux_sym_primitive_definition_token1] = ACTIONS(3155),
    [anon_sym_mutable] = ACTIONS(3155),
    [anon_sym_struct] = ACTIONS(3155),
    [anon_sym_module] = ACTIONS(3155),
    [anon_sym_macro] = ACTIONS(3155),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_COMMA] = ACTIONS(3157),
    [anon_sym_RPAREN] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(3157),
    [anon_sym_EQ] = ACTIONS(3155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3157),
    [anon_sym_COLON_COLON] = ACTIONS(3157),
    [anon_sym_RBRACE] = ACTIONS(3157),
    [anon_sym_LT_COLON] = ACTIONS(3157),
    [anon_sym_if] = ACTIONS(3155),
    [anon_sym_try] = ACTIONS(3155),
    [anon_sym_for] = ACTIONS(3155),
    [anon_sym_while] = ACTIONS(3155),
    [sym_break_statement] = ACTIONS(3155),
    [sym_continue_statement] = ACTIONS(3155),
    [anon_sym_return] = ACTIONS(3155),
    [anon_sym_let] = ACTIONS(3155),
    [anon_sym_const] = ACTIONS(3155),
    [anon_sym_quote] = ACTIONS(3155),
    [anon_sym_using] = ACTIONS(3155),
    [anon_sym_import] = ACTIONS(3155),
    [anon_sym_export] = ACTIONS(3155),
    [anon_sym_COLON2] = ACTIONS(3155),
    [anon_sym_RBRACK] = ACTIONS(3157),
    [anon_sym_begin] = ACTIONS(3155),
    [anon_sym_SQUOTE] = ACTIONS(3157),
    [anon_sym_PLUS] = ACTIONS(3155),
    [anon_sym_LT_PIPE] = ACTIONS(3157),
    [anon_sym_PIPE_GT] = ACTIONS(3157),
    [anon_sym_in] = ACTIONS(3155),
    [anon_sym_isa] = ACTIONS(3155),
    [anon_sym_PIPE_PIPE] = ACTIONS(3157),
    [anon_sym_AMP_AMP] = ACTIONS(3157),
    [anon_sym_QMARK] = ACTIONS(3157),
    [anon_sym_EQ_GT] = ACTIONS(3157),
    [anon_sym_LBRACK2] = ACTIONS(3157),
    [anon_sym_DOLLAR] = ACTIONS(3155),
    [anon_sym_AT] = ACTIONS(3157),
    [aux_sym_integer_literal_token1] = ACTIONS(3157),
    [aux_sym_integer_literal_token2] = ACTIONS(3157),
    [aux_sym_integer_literal_token3] = ACTIONS(3155),
    [sym_float_literal] = ACTIONS(3155),
    [sym__unary_operator] = ACTIONS(3155),
    [sym__power_operator] = ACTIONS(3155),
    [sym__bitshift_operator] = ACTIONS(3155),
    [sym__rational_operator] = ACTIONS(3155),
    [sym__times_operator] = ACTIONS(3155),
    [sym__plus_operator] = ACTIONS(3155),
    [sym__dotty_operator] = ACTIONS(3155),
    [sym__comparison_operator] = ACTIONS(3155),
    [sym__arrow_operator] = ACTIONS(3157),
    [sym__assign_operator] = ACTIONS(3155),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3157),
    [sym__command_start] = ACTIONS(3157),
  },
  [1330] = {
    [sym_identifier] = ACTIONS(2670),
    [anon_sym_function] = ACTIONS(2670),
    [anon_sym_end] = ACTIONS(2670),
    [anon_sym_abstract] = ACTIONS(2670),
    [anon_sym_primitive] = ACTIONS(2670),
    [aux_sym_primitive_definition_token1] = ACTIONS(2670),
    [anon_sym_mutable] = ACTIONS(2670),
    [anon_sym_struct] = ACTIONS(2670),
    [anon_sym_module] = ACTIONS(2670),
    [anon_sym_macro] = ACTIONS(2670),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_COMMA] = ACTIONS(2672),
    [anon_sym_RPAREN] = ACTIONS(2672),
    [anon_sym_SEMI] = ACTIONS(2672),
    [anon_sym_EQ] = ACTIONS(2670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2672),
    [anon_sym_COLON_COLON] = ACTIONS(2672),
    [anon_sym_RBRACE] = ACTIONS(2672),
    [anon_sym_LT_COLON] = ACTIONS(2672),
    [anon_sym_if] = ACTIONS(2670),
    [anon_sym_try] = ACTIONS(2670),
    [anon_sym_for] = ACTIONS(2670),
    [anon_sym_while] = ACTIONS(2670),
    [sym_break_statement] = ACTIONS(2670),
    [sym_continue_statement] = ACTIONS(2670),
    [anon_sym_return] = ACTIONS(2670),
    [anon_sym_let] = ACTIONS(2670),
    [anon_sym_const] = ACTIONS(2670),
    [anon_sym_quote] = ACTIONS(2670),
    [anon_sym_using] = ACTIONS(2670),
    [anon_sym_import] = ACTIONS(2670),
    [anon_sym_export] = ACTIONS(2670),
    [anon_sym_COLON2] = ACTIONS(2670),
    [anon_sym_RBRACK] = ACTIONS(2672),
    [anon_sym_begin] = ACTIONS(2670),
    [anon_sym_SQUOTE] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(2670),
    [anon_sym_LT_PIPE] = ACTIONS(2672),
    [anon_sym_PIPE_GT] = ACTIONS(2672),
    [anon_sym_in] = ACTIONS(2670),
    [anon_sym_isa] = ACTIONS(2670),
    [anon_sym_PIPE_PIPE] = ACTIONS(2672),
    [anon_sym_AMP_AMP] = ACTIONS(2672),
    [anon_sym_QMARK] = ACTIONS(2672),
    [anon_sym_EQ_GT] = ACTIONS(2672),
    [anon_sym_LBRACK2] = ACTIONS(2672),
    [anon_sym_DOLLAR] = ACTIONS(2670),
    [anon_sym_AT] = ACTIONS(2672),
    [aux_sym_integer_literal_token1] = ACTIONS(2672),
    [aux_sym_integer_literal_token2] = ACTIONS(2672),
    [aux_sym_integer_literal_token3] = ACTIONS(2670),
    [sym_float_literal] = ACTIONS(2670),
    [sym__unary_operator] = ACTIONS(2670),
    [sym__power_operator] = ACTIONS(2670),
    [sym__bitshift_operator] = ACTIONS(2670),
    [sym__rational_operator] = ACTIONS(2670),
    [sym__times_operator] = ACTIONS(2670),
    [sym__plus_operator] = ACTIONS(2670),
    [sym__dotty_operator] = ACTIONS(2670),
    [sym__comparison_operator] = ACTIONS(2670),
    [sym__arrow_operator] = ACTIONS(2672),
    [sym__assign_operator] = ACTIONS(2670),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2672),
    [sym__command_start] = ACTIONS(2672),
  },
  [1331] = {
    [sym_identifier] = ACTIONS(2554),
    [anon_sym_function] = ACTIONS(2554),
    [anon_sym_end] = ACTIONS(2554),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_primitive] = ACTIONS(2554),
    [aux_sym_primitive_definition_token1] = ACTIONS(2554),
    [anon_sym_mutable] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_module] = ACTIONS(2554),
    [anon_sym_macro] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_COMMA] = ACTIONS(2556),
    [anon_sym_RPAREN] = ACTIONS(2556),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_EQ] = ACTIONS(2554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2556),
    [anon_sym_COLON_COLON] = ACTIONS(2556),
    [anon_sym_RBRACE] = ACTIONS(2556),
    [anon_sym_LT_COLON] = ACTIONS(2556),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [sym_break_statement] = ACTIONS(2554),
    [sym_continue_statement] = ACTIONS(2554),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_quote] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_import] = ACTIONS(2554),
    [anon_sym_export] = ACTIONS(2554),
    [anon_sym_COLON2] = ACTIONS(2554),
    [anon_sym_RBRACK] = ACTIONS(2556),
    [anon_sym_begin] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_LT_PIPE] = ACTIONS(2556),
    [anon_sym_PIPE_GT] = ACTIONS(2556),
    [anon_sym_in] = ACTIONS(2554),
    [anon_sym_isa] = ACTIONS(2554),
    [anon_sym_PIPE_PIPE] = ACTIONS(2556),
    [anon_sym_AMP_AMP] = ACTIONS(2556),
    [anon_sym_QMARK] = ACTIONS(2556),
    [anon_sym_EQ_GT] = ACTIONS(2556),
    [anon_sym_LBRACK2] = ACTIONS(2556),
    [anon_sym_DOLLAR] = ACTIONS(2554),
    [anon_sym_AT] = ACTIONS(2556),
    [aux_sym_integer_literal_token1] = ACTIONS(2556),
    [aux_sym_integer_literal_token2] = ACTIONS(2556),
    [aux_sym_integer_literal_token3] = ACTIONS(2554),
    [sym_float_literal] = ACTIONS(2554),
    [sym__unary_operator] = ACTIONS(2554),
    [sym__power_operator] = ACTIONS(2554),
    [sym__bitshift_operator] = ACTIONS(2554),
    [sym__rational_operator] = ACTIONS(2554),
    [sym__times_operator] = ACTIONS(2554),
    [sym__plus_operator] = ACTIONS(2554),
    [sym__dotty_operator] = ACTIONS(2554),
    [sym__comparison_operator] = ACTIONS(2554),
    [sym__arrow_operator] = ACTIONS(2556),
    [sym__assign_operator] = ACTIONS(2554),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2556),
    [sym__command_start] = ACTIONS(2556),
  },
  [1332] = {
    [sym_identifier] = ACTIONS(3143),
    [anon_sym_function] = ACTIONS(3143),
    [anon_sym_end] = ACTIONS(3143),
    [anon_sym_abstract] = ACTIONS(3143),
    [anon_sym_primitive] = ACTIONS(3143),
    [aux_sym_primitive_definition_token1] = ACTIONS(3143),
    [anon_sym_mutable] = ACTIONS(3143),
    [anon_sym_struct] = ACTIONS(3143),
    [anon_sym_module] = ACTIONS(3143),
    [anon_sym_macro] = ACTIONS(3143),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_COMMA] = ACTIONS(3145),
    [anon_sym_RPAREN] = ACTIONS(3145),
    [anon_sym_SEMI] = ACTIONS(3145),
    [anon_sym_EQ] = ACTIONS(3143),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3145),
    [anon_sym_COLON_COLON] = ACTIONS(3145),
    [anon_sym_RBRACE] = ACTIONS(3145),
    [anon_sym_LT_COLON] = ACTIONS(3145),
    [anon_sym_if] = ACTIONS(3143),
    [anon_sym_try] = ACTIONS(3143),
    [anon_sym_for] = ACTIONS(3143),
    [anon_sym_while] = ACTIONS(3143),
    [sym_break_statement] = ACTIONS(3143),
    [sym_continue_statement] = ACTIONS(3143),
    [anon_sym_return] = ACTIONS(3143),
    [anon_sym_let] = ACTIONS(3143),
    [anon_sym_const] = ACTIONS(3143),
    [anon_sym_quote] = ACTIONS(3143),
    [anon_sym_using] = ACTIONS(3143),
    [anon_sym_import] = ACTIONS(3143),
    [anon_sym_export] = ACTIONS(3143),
    [anon_sym_COLON2] = ACTIONS(3143),
    [anon_sym_RBRACK] = ACTIONS(3145),
    [anon_sym_begin] = ACTIONS(3143),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym_PLUS] = ACTIONS(3143),
    [anon_sym_LT_PIPE] = ACTIONS(3145),
    [anon_sym_PIPE_GT] = ACTIONS(3145),
    [anon_sym_in] = ACTIONS(3143),
    [anon_sym_isa] = ACTIONS(3143),
    [anon_sym_PIPE_PIPE] = ACTIONS(3145),
    [anon_sym_AMP_AMP] = ACTIONS(3145),
    [anon_sym_QMARK] = ACTIONS(3145),
    [anon_sym_EQ_GT] = ACTIONS(3145),
    [anon_sym_LBRACK2] = ACTIONS(3145),
    [anon_sym_DOLLAR] = ACTIONS(3143),
    [anon_sym_AT] = ACTIONS(3145),
    [aux_sym_integer_literal_token1] = ACTIONS(3145),
    [aux_sym_integer_literal_token2] = ACTIONS(3145),
    [aux_sym_integer_literal_token3] = ACTIONS(3143),
    [sym_float_literal] = ACTIONS(3143),
    [sym__unary_operator] = ACTIONS(3143),
    [sym__power_operator] = ACTIONS(3143),
    [sym__bitshift_operator] = ACTIONS(3143),
    [sym__rational_operator] = ACTIONS(3143),
    [sym__times_operator] = ACTIONS(3143),
    [sym__plus_operator] = ACTIONS(3143),
    [sym__dotty_operator] = ACTIONS(3143),
    [sym__comparison_operator] = ACTIONS(3143),
    [sym__arrow_operator] = ACTIONS(3145),
    [sym__assign_operator] = ACTIONS(3143),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3145),
    [sym__command_start] = ACTIONS(3145),
  },
  [1333] = {
    [sym_identifier] = ACTIONS(3139),
    [anon_sym_function] = ACTIONS(3139),
    [anon_sym_end] = ACTIONS(3139),
    [anon_sym_abstract] = ACTIONS(3139),
    [anon_sym_primitive] = ACTIONS(3139),
    [aux_sym_primitive_definition_token1] = ACTIONS(3139),
    [anon_sym_mutable] = ACTIONS(3139),
    [anon_sym_struct] = ACTIONS(3139),
    [anon_sym_module] = ACTIONS(3139),
    [anon_sym_macro] = ACTIONS(3139),
    [anon_sym_LPAREN] = ACTIONS(3141),
    [anon_sym_COMMA] = ACTIONS(3141),
    [anon_sym_RPAREN] = ACTIONS(3141),
    [anon_sym_SEMI] = ACTIONS(3141),
    [anon_sym_EQ] = ACTIONS(3139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3141),
    [anon_sym_COLON_COLON] = ACTIONS(3141),
    [anon_sym_RBRACE] = ACTIONS(3141),
    [anon_sym_LT_COLON] = ACTIONS(3141),
    [anon_sym_if] = ACTIONS(3139),
    [anon_sym_try] = ACTIONS(3139),
    [anon_sym_for] = ACTIONS(3139),
    [anon_sym_while] = ACTIONS(3139),
    [sym_break_statement] = ACTIONS(3139),
    [sym_continue_statement] = ACTIONS(3139),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_let] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3139),
    [anon_sym_quote] = ACTIONS(3139),
    [anon_sym_using] = ACTIONS(3139),
    [anon_sym_import] = ACTIONS(3139),
    [anon_sym_export] = ACTIONS(3139),
    [anon_sym_COLON2] = ACTIONS(3139),
    [anon_sym_RBRACK] = ACTIONS(3141),
    [anon_sym_begin] = ACTIONS(3139),
    [anon_sym_SQUOTE] = ACTIONS(3141),
    [anon_sym_PLUS] = ACTIONS(3139),
    [anon_sym_LT_PIPE] = ACTIONS(3141),
    [anon_sym_PIPE_GT] = ACTIONS(3141),
    [anon_sym_in] = ACTIONS(3139),
    [anon_sym_isa] = ACTIONS(3139),
    [anon_sym_PIPE_PIPE] = ACTIONS(3141),
    [anon_sym_AMP_AMP] = ACTIONS(3141),
    [anon_sym_QMARK] = ACTIONS(3141),
    [anon_sym_EQ_GT] = ACTIONS(3141),
    [anon_sym_LBRACK2] = ACTIONS(3141),
    [anon_sym_DOLLAR] = ACTIONS(3139),
    [anon_sym_AT] = ACTIONS(3141),
    [aux_sym_integer_literal_token1] = ACTIONS(3141),
    [aux_sym_integer_literal_token2] = ACTIONS(3141),
    [aux_sym_integer_literal_token3] = ACTIONS(3139),
    [sym_float_literal] = ACTIONS(3139),
    [sym__unary_operator] = ACTIONS(3139),
    [sym__power_operator] = ACTIONS(3139),
    [sym__bitshift_operator] = ACTIONS(3139),
    [sym__rational_operator] = ACTIONS(3139),
    [sym__times_operator] = ACTIONS(3139),
    [sym__plus_operator] = ACTIONS(3139),
    [sym__dotty_operator] = ACTIONS(3139),
    [sym__comparison_operator] = ACTIONS(3139),
    [sym__arrow_operator] = ACTIONS(3141),
    [sym__assign_operator] = ACTIONS(3139),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3141),
    [sym__command_start] = ACTIONS(3141),
  },
  [1334] = {
    [sym_identifier] = ACTIONS(2935),
    [anon_sym_function] = ACTIONS(2935),
    [anon_sym_end] = ACTIONS(2935),
    [anon_sym_abstract] = ACTIONS(2935),
    [anon_sym_primitive] = ACTIONS(2935),
    [aux_sym_primitive_definition_token1] = ACTIONS(2935),
    [anon_sym_mutable] = ACTIONS(2935),
    [anon_sym_struct] = ACTIONS(2935),
    [anon_sym_module] = ACTIONS(2935),
    [anon_sym_macro] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2937),
    [anon_sym_COMMA] = ACTIONS(2937),
    [anon_sym_RPAREN] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2937),
    [anon_sym_EQ] = ACTIONS(2935),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2935),
    [anon_sym_try] = ACTIONS(2935),
    [anon_sym_for] = ACTIONS(2935),
    [anon_sym_while] = ACTIONS(2935),
    [sym_break_statement] = ACTIONS(2935),
    [sym_continue_statement] = ACTIONS(2935),
    [anon_sym_return] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_const] = ACTIONS(2935),
    [anon_sym_quote] = ACTIONS(2935),
    [anon_sym_using] = ACTIONS(2935),
    [anon_sym_import] = ACTIONS(2935),
    [anon_sym_export] = ACTIONS(2935),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2937),
    [anon_sym_begin] = ACTIONS(2935),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(2937),
    [anon_sym_DOLLAR] = ACTIONS(2935),
    [anon_sym_AT] = ACTIONS(2937),
    [aux_sym_integer_literal_token1] = ACTIONS(2937),
    [aux_sym_integer_literal_token2] = ACTIONS(2937),
    [aux_sym_integer_literal_token3] = ACTIONS(2935),
    [sym_float_literal] = ACTIONS(2935),
    [sym__unary_operator] = ACTIONS(2935),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2935),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2937),
    [sym__command_start] = ACTIONS(2937),
  },
  [1335] = {
    [sym_identifier] = ACTIONS(2506),
    [anon_sym_function] = ACTIONS(2506),
    [anon_sym_end] = ACTIONS(2506),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_primitive] = ACTIONS(2506),
    [aux_sym_primitive_definition_token1] = ACTIONS(2506),
    [anon_sym_mutable] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_module] = ACTIONS(2506),
    [anon_sym_macro] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2508),
    [anon_sym_COMMA] = ACTIONS(2508),
    [anon_sym_RPAREN] = ACTIONS(2508),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_EQ] = ACTIONS(2506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2508),
    [anon_sym_COLON_COLON] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_LT_COLON] = ACTIONS(2508),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [sym_break_statement] = ACTIONS(2506),
    [sym_continue_statement] = ACTIONS(2506),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_quote] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_import] = ACTIONS(2506),
    [anon_sym_export] = ACTIONS(2506),
    [anon_sym_COLON2] = ACTIONS(2506),
    [anon_sym_RBRACK] = ACTIONS(2508),
    [anon_sym_begin] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_LT_PIPE] = ACTIONS(2508),
    [anon_sym_PIPE_GT] = ACTIONS(2508),
    [anon_sym_in] = ACTIONS(2506),
    [anon_sym_isa] = ACTIONS(2506),
    [anon_sym_PIPE_PIPE] = ACTIONS(2508),
    [anon_sym_AMP_AMP] = ACTIONS(2508),
    [anon_sym_QMARK] = ACTIONS(2508),
    [anon_sym_EQ_GT] = ACTIONS(2508),
    [anon_sym_LBRACK2] = ACTIONS(2508),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_AT] = ACTIONS(2508),
    [aux_sym_integer_literal_token1] = ACTIONS(2508),
    [aux_sym_integer_literal_token2] = ACTIONS(2508),
    [aux_sym_integer_literal_token3] = ACTIONS(2506),
    [sym_float_literal] = ACTIONS(2506),
    [sym__unary_operator] = ACTIONS(2506),
    [sym__power_operator] = ACTIONS(2506),
    [sym__bitshift_operator] = ACTIONS(2506),
    [sym__rational_operator] = ACTIONS(2506),
    [sym__times_operator] = ACTIONS(2506),
    [sym__plus_operator] = ACTIONS(2506),
    [sym__dotty_operator] = ACTIONS(2506),
    [sym__comparison_operator] = ACTIONS(2506),
    [sym__arrow_operator] = ACTIONS(2508),
    [sym__assign_operator] = ACTIONS(2506),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2508),
    [sym__command_start] = ACTIONS(2508),
  },
  [1336] = {
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_function] = ACTIONS(3131),
    [anon_sym_end] = ACTIONS(3131),
    [anon_sym_abstract] = ACTIONS(3131),
    [anon_sym_primitive] = ACTIONS(3131),
    [aux_sym_primitive_definition_token1] = ACTIONS(3131),
    [anon_sym_mutable] = ACTIONS(3131),
    [anon_sym_struct] = ACTIONS(3131),
    [anon_sym_module] = ACTIONS(3131),
    [anon_sym_macro] = ACTIONS(3131),
    [anon_sym_LPAREN] = ACTIONS(3133),
    [anon_sym_COMMA] = ACTIONS(3133),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_SEMI] = ACTIONS(3133),
    [anon_sym_EQ] = ACTIONS(3131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3133),
    [anon_sym_COLON_COLON] = ACTIONS(3133),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_LT_COLON] = ACTIONS(3133),
    [anon_sym_if] = ACTIONS(3131),
    [anon_sym_try] = ACTIONS(3131),
    [anon_sym_for] = ACTIONS(3131),
    [anon_sym_while] = ACTIONS(3131),
    [sym_break_statement] = ACTIONS(3131),
    [sym_continue_statement] = ACTIONS(3131),
    [anon_sym_return] = ACTIONS(3131),
    [anon_sym_let] = ACTIONS(3131),
    [anon_sym_const] = ACTIONS(3131),
    [anon_sym_quote] = ACTIONS(3131),
    [anon_sym_using] = ACTIONS(3131),
    [anon_sym_import] = ACTIONS(3131),
    [anon_sym_export] = ACTIONS(3131),
    [anon_sym_COLON2] = ACTIONS(3131),
    [anon_sym_RBRACK] = ACTIONS(3133),
    [anon_sym_begin] = ACTIONS(3131),
    [anon_sym_SQUOTE] = ACTIONS(3133),
    [anon_sym_PLUS] = ACTIONS(3131),
    [anon_sym_LT_PIPE] = ACTIONS(3133),
    [anon_sym_PIPE_GT] = ACTIONS(3133),
    [anon_sym_in] = ACTIONS(3131),
    [anon_sym_isa] = ACTIONS(3131),
    [anon_sym_PIPE_PIPE] = ACTIONS(3133),
    [anon_sym_AMP_AMP] = ACTIONS(3133),
    [anon_sym_QMARK] = ACTIONS(3133),
    [anon_sym_EQ_GT] = ACTIONS(3133),
    [anon_sym_LBRACK2] = ACTIONS(3133),
    [anon_sym_DOLLAR] = ACTIONS(3131),
    [anon_sym_AT] = ACTIONS(3133),
    [aux_sym_integer_literal_token1] = ACTIONS(3133),
    [aux_sym_integer_literal_token2] = ACTIONS(3133),
    [aux_sym_integer_literal_token3] = ACTIONS(3131),
    [sym_float_literal] = ACTIONS(3131),
    [sym__unary_operator] = ACTIONS(3131),
    [sym__power_operator] = ACTIONS(3131),
    [sym__bitshift_operator] = ACTIONS(3131),
    [sym__rational_operator] = ACTIONS(3131),
    [sym__times_operator] = ACTIONS(3131),
    [sym__plus_operator] = ACTIONS(3131),
    [sym__dotty_operator] = ACTIONS(3131),
    [sym__comparison_operator] = ACTIONS(3131),
    [sym__arrow_operator] = ACTIONS(3133),
    [sym__assign_operator] = ACTIONS(3131),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3133),
    [sym__command_start] = ACTIONS(3133),
  },
  [1337] = {
    [sym_identifier] = ACTIONS(3159),
    [anon_sym_function] = ACTIONS(3159),
    [anon_sym_end] = ACTIONS(3159),
    [anon_sym_abstract] = ACTIONS(3159),
    [anon_sym_primitive] = ACTIONS(3159),
    [aux_sym_primitive_definition_token1] = ACTIONS(3159),
    [anon_sym_mutable] = ACTIONS(3159),
    [anon_sym_struct] = ACTIONS(3159),
    [anon_sym_module] = ACTIONS(3159),
    [anon_sym_macro] = ACTIONS(3159),
    [anon_sym_LPAREN] = ACTIONS(3161),
    [anon_sym_COMMA] = ACTIONS(3161),
    [anon_sym_RPAREN] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3161),
    [anon_sym_EQ] = ACTIONS(3159),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3159),
    [anon_sym_try] = ACTIONS(3159),
    [anon_sym_for] = ACTIONS(3159),
    [anon_sym_while] = ACTIONS(3159),
    [sym_break_statement] = ACTIONS(3159),
    [sym_continue_statement] = ACTIONS(3159),
    [anon_sym_return] = ACTIONS(3159),
    [anon_sym_let] = ACTIONS(3159),
    [anon_sym_const] = ACTIONS(3159),
    [anon_sym_quote] = ACTIONS(3159),
    [anon_sym_using] = ACTIONS(3159),
    [anon_sym_import] = ACTIONS(3159),
    [anon_sym_export] = ACTIONS(3159),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(3161),
    [anon_sym_begin] = ACTIONS(3159),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(3161),
    [anon_sym_DOLLAR] = ACTIONS(3159),
    [anon_sym_AT] = ACTIONS(3161),
    [aux_sym_integer_literal_token1] = ACTIONS(3161),
    [aux_sym_integer_literal_token2] = ACTIONS(3161),
    [aux_sym_integer_literal_token3] = ACTIONS(3159),
    [sym_float_literal] = ACTIONS(3159),
    [sym__unary_operator] = ACTIONS(3159),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(3159),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3161),
    [sym__command_start] = ACTIONS(3161),
  },
  [1338] = {
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_COMMA] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_LT_COLON] = ACTIONS(2746),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_RBRACK] = ACTIONS(2746),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2746),
    [anon_sym_PIPE_GT] = ACTIONS(2746),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_QMARK] = ACTIONS(2746),
    [anon_sym_EQ_GT] = ACTIONS(2746),
    [anon_sym_LBRACK2] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2746),
    [aux_sym_integer_literal_token1] = ACTIONS(2746),
    [aux_sym_integer_literal_token2] = ACTIONS(2746),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2746),
    [sym__assign_operator] = ACTIONS(2744),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1339] = {
    [sym_identifier] = ACTIONS(3075),
    [anon_sym_function] = ACTIONS(3075),
    [anon_sym_end] = ACTIONS(3075),
    [anon_sym_abstract] = ACTIONS(3075),
    [anon_sym_primitive] = ACTIONS(3075),
    [aux_sym_primitive_definition_token1] = ACTIONS(3075),
    [anon_sym_mutable] = ACTIONS(3075),
    [anon_sym_struct] = ACTIONS(3075),
    [anon_sym_module] = ACTIONS(3075),
    [anon_sym_macro] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3077),
    [anon_sym_COMMA] = ACTIONS(3077),
    [anon_sym_RPAREN] = ACTIONS(3077),
    [anon_sym_SEMI] = ACTIONS(3077),
    [anon_sym_EQ] = ACTIONS(3075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3077),
    [anon_sym_COLON_COLON] = ACTIONS(3077),
    [anon_sym_RBRACE] = ACTIONS(3077),
    [anon_sym_LT_COLON] = ACTIONS(3077),
    [anon_sym_if] = ACTIONS(3075),
    [anon_sym_try] = ACTIONS(3075),
    [anon_sym_for] = ACTIONS(3075),
    [anon_sym_while] = ACTIONS(3075),
    [sym_break_statement] = ACTIONS(3075),
    [sym_continue_statement] = ACTIONS(3075),
    [anon_sym_return] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_const] = ACTIONS(3075),
    [anon_sym_quote] = ACTIONS(3075),
    [anon_sym_using] = ACTIONS(3075),
    [anon_sym_import] = ACTIONS(3075),
    [anon_sym_export] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3077),
    [anon_sym_begin] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym_PLUS] = ACTIONS(3075),
    [anon_sym_LT_PIPE] = ACTIONS(3077),
    [anon_sym_PIPE_GT] = ACTIONS(3077),
    [anon_sym_in] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3077),
    [anon_sym_AMP_AMP] = ACTIONS(3077),
    [anon_sym_QMARK] = ACTIONS(3077),
    [anon_sym_EQ_GT] = ACTIONS(3077),
    [anon_sym_LBRACK2] = ACTIONS(3077),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3077),
    [aux_sym_integer_literal_token1] = ACTIONS(3077),
    [aux_sym_integer_literal_token2] = ACTIONS(3077),
    [aux_sym_integer_literal_token3] = ACTIONS(3075),
    [sym_float_literal] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__times_operator] = ACTIONS(3075),
    [sym__plus_operator] = ACTIONS(3075),
    [sym__dotty_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3077),
    [sym__assign_operator] = ACTIONS(3075),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3077),
    [sym__command_start] = ACTIONS(3077),
  },
  [1340] = {
    [sym_identifier] = ACTIONS(3063),
    [anon_sym_function] = ACTIONS(3063),
    [anon_sym_end] = ACTIONS(3063),
    [anon_sym_abstract] = ACTIONS(3063),
    [anon_sym_primitive] = ACTIONS(3063),
    [aux_sym_primitive_definition_token1] = ACTIONS(3063),
    [anon_sym_mutable] = ACTIONS(3063),
    [anon_sym_struct] = ACTIONS(3063),
    [anon_sym_module] = ACTIONS(3063),
    [anon_sym_macro] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3065),
    [anon_sym_COMMA] = ACTIONS(3065),
    [anon_sym_RPAREN] = ACTIONS(3065),
    [anon_sym_SEMI] = ACTIONS(3065),
    [anon_sym_EQ] = ACTIONS(3063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3065),
    [anon_sym_COLON_COLON] = ACTIONS(3065),
    [anon_sym_RBRACE] = ACTIONS(3065),
    [anon_sym_LT_COLON] = ACTIONS(3065),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_try] = ACTIONS(3063),
    [anon_sym_for] = ACTIONS(3063),
    [anon_sym_while] = ACTIONS(3063),
    [sym_break_statement] = ACTIONS(3063),
    [sym_continue_statement] = ACTIONS(3063),
    [anon_sym_return] = ACTIONS(3063),
    [anon_sym_let] = ACTIONS(3063),
    [anon_sym_const] = ACTIONS(3063),
    [anon_sym_quote] = ACTIONS(3063),
    [anon_sym_using] = ACTIONS(3063),
    [anon_sym_import] = ACTIONS(3063),
    [anon_sym_export] = ACTIONS(3063),
    [anon_sym_COLON2] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3065),
    [anon_sym_begin] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym_PLUS] = ACTIONS(3063),
    [anon_sym_LT_PIPE] = ACTIONS(3065),
    [anon_sym_PIPE_GT] = ACTIONS(3065),
    [anon_sym_in] = ACTIONS(3063),
    [anon_sym_isa] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3065),
    [anon_sym_AMP_AMP] = ACTIONS(3065),
    [anon_sym_QMARK] = ACTIONS(3065),
    [anon_sym_EQ_GT] = ACTIONS(3065),
    [anon_sym_LBRACK2] = ACTIONS(3065),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3065),
    [aux_sym_integer_literal_token1] = ACTIONS(3065),
    [aux_sym_integer_literal_token2] = ACTIONS(3065),
    [aux_sym_integer_literal_token3] = ACTIONS(3063),
    [sym_float_literal] = ACTIONS(3063),
    [sym__unary_operator] = ACTIONS(3063),
    [sym__power_operator] = ACTIONS(3063),
    [sym__bitshift_operator] = ACTIONS(3063),
    [sym__rational_operator] = ACTIONS(3063),
    [sym__times_operator] = ACTIONS(3063),
    [sym__plus_operator] = ACTIONS(3063),
    [sym__dotty_operator] = ACTIONS(3063),
    [sym__comparison_operator] = ACTIONS(3063),
    [sym__arrow_operator] = ACTIONS(3065),
    [sym__assign_operator] = ACTIONS(3063),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3065),
    [sym__command_start] = ACTIONS(3065),
  },
  [1341] = {
    [sym_identifier] = ACTIONS(2951),
    [anon_sym_function] = ACTIONS(2951),
    [anon_sym_end] = ACTIONS(2951),
    [anon_sym_abstract] = ACTIONS(2951),
    [anon_sym_primitive] = ACTIONS(2951),
    [aux_sym_primitive_definition_token1] = ACTIONS(2951),
    [anon_sym_mutable] = ACTIONS(2951),
    [anon_sym_struct] = ACTIONS(2951),
    [anon_sym_module] = ACTIONS(2951),
    [anon_sym_macro] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2953),
    [anon_sym_RPAREN] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2953),
    [anon_sym_EQ] = ACTIONS(2951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2953),
    [anon_sym_COLON_COLON] = ACTIONS(2953),
    [anon_sym_RBRACE] = ACTIONS(2953),
    [anon_sym_LT_COLON] = ACTIONS(2953),
    [anon_sym_if] = ACTIONS(2951),
    [anon_sym_try] = ACTIONS(2951),
    [anon_sym_for] = ACTIONS(2951),
    [anon_sym_while] = ACTIONS(2951),
    [sym_break_statement] = ACTIONS(2951),
    [sym_continue_statement] = ACTIONS(2951),
    [anon_sym_return] = ACTIONS(2951),
    [anon_sym_let] = ACTIONS(2951),
    [anon_sym_const] = ACTIONS(2951),
    [anon_sym_quote] = ACTIONS(2951),
    [anon_sym_using] = ACTIONS(2951),
    [anon_sym_import] = ACTIONS(2951),
    [anon_sym_export] = ACTIONS(2951),
    [anon_sym_COLON2] = ACTIONS(2951),
    [anon_sym_RBRACK] = ACTIONS(2953),
    [anon_sym_begin] = ACTIONS(2951),
    [anon_sym_SQUOTE] = ACTIONS(2953),
    [anon_sym_PLUS] = ACTIONS(2951),
    [anon_sym_LT_PIPE] = ACTIONS(2953),
    [anon_sym_PIPE_GT] = ACTIONS(2953),
    [anon_sym_in] = ACTIONS(2951),
    [anon_sym_isa] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2953),
    [anon_sym_EQ_GT] = ACTIONS(2953),
    [anon_sym_LBRACK2] = ACTIONS(2953),
    [anon_sym_DOLLAR] = ACTIONS(2951),
    [anon_sym_AT] = ACTIONS(2953),
    [aux_sym_integer_literal_token1] = ACTIONS(2953),
    [aux_sym_integer_literal_token2] = ACTIONS(2953),
    [aux_sym_integer_literal_token3] = ACTIONS(2951),
    [sym_float_literal] = ACTIONS(2951),
    [sym__unary_operator] = ACTIONS(2951),
    [sym__power_operator] = ACTIONS(2951),
    [sym__bitshift_operator] = ACTIONS(2951),
    [sym__rational_operator] = ACTIONS(2951),
    [sym__times_operator] = ACTIONS(2951),
    [sym__plus_operator] = ACTIONS(2951),
    [sym__dotty_operator] = ACTIONS(2951),
    [sym__comparison_operator] = ACTIONS(2951),
    [sym__arrow_operator] = ACTIONS(2953),
    [sym__assign_operator] = ACTIONS(2951),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2953),
    [sym__command_start] = ACTIONS(2953),
  },
  [1342] = {
    [sym_identifier] = ACTIONS(2979),
    [anon_sym_function] = ACTIONS(2979),
    [anon_sym_end] = ACTIONS(2979),
    [anon_sym_abstract] = ACTIONS(2979),
    [anon_sym_primitive] = ACTIONS(2979),
    [aux_sym_primitive_definition_token1] = ACTIONS(2979),
    [anon_sym_mutable] = ACTIONS(2979),
    [anon_sym_struct] = ACTIONS(2979),
    [anon_sym_module] = ACTIONS(2979),
    [anon_sym_macro] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2981),
    [anon_sym_COMMA] = ACTIONS(2981),
    [anon_sym_RPAREN] = ACTIONS(2981),
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_EQ] = ACTIONS(2979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2981),
    [anon_sym_COLON_COLON] = ACTIONS(2981),
    [anon_sym_RBRACE] = ACTIONS(2981),
    [anon_sym_LT_COLON] = ACTIONS(2981),
    [anon_sym_if] = ACTIONS(2979),
    [anon_sym_try] = ACTIONS(2979),
    [anon_sym_for] = ACTIONS(2979),
    [anon_sym_while] = ACTIONS(2979),
    [sym_break_statement] = ACTIONS(2979),
    [sym_continue_statement] = ACTIONS(2979),
    [anon_sym_return] = ACTIONS(2979),
    [anon_sym_let] = ACTIONS(2979),
    [anon_sym_const] = ACTIONS(2979),
    [anon_sym_quote] = ACTIONS(2979),
    [anon_sym_using] = ACTIONS(2979),
    [anon_sym_import] = ACTIONS(2979),
    [anon_sym_export] = ACTIONS(2979),
    [anon_sym_COLON2] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2981),
    [anon_sym_begin] = ACTIONS(2979),
    [anon_sym_SQUOTE] = ACTIONS(2981),
    [anon_sym_PLUS] = ACTIONS(2979),
    [anon_sym_LT_PIPE] = ACTIONS(2981),
    [anon_sym_PIPE_GT] = ACTIONS(2981),
    [anon_sym_in] = ACTIONS(2979),
    [anon_sym_isa] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2981),
    [anon_sym_AMP_AMP] = ACTIONS(2981),
    [anon_sym_QMARK] = ACTIONS(2981),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_LBRACK2] = ACTIONS(2981),
    [anon_sym_DOLLAR] = ACTIONS(2979),
    [anon_sym_AT] = ACTIONS(2981),
    [aux_sym_integer_literal_token1] = ACTIONS(2981),
    [aux_sym_integer_literal_token2] = ACTIONS(2981),
    [aux_sym_integer_literal_token3] = ACTIONS(2979),
    [sym_float_literal] = ACTIONS(2979),
    [sym__unary_operator] = ACTIONS(2979),
    [sym__power_operator] = ACTIONS(2979),
    [sym__bitshift_operator] = ACTIONS(2979),
    [sym__rational_operator] = ACTIONS(2979),
    [sym__times_operator] = ACTIONS(2979),
    [sym__plus_operator] = ACTIONS(2979),
    [sym__dotty_operator] = ACTIONS(2979),
    [sym__comparison_operator] = ACTIONS(2979),
    [sym__arrow_operator] = ACTIONS(2981),
    [sym__assign_operator] = ACTIONS(2979),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2981),
    [sym__command_start] = ACTIONS(2981),
  },
  [1343] = {
    [sym_identifier] = ACTIONS(2975),
    [anon_sym_function] = ACTIONS(2975),
    [anon_sym_end] = ACTIONS(2975),
    [anon_sym_abstract] = ACTIONS(2975),
    [anon_sym_primitive] = ACTIONS(2975),
    [aux_sym_primitive_definition_token1] = ACTIONS(2975),
    [anon_sym_mutable] = ACTIONS(2975),
    [anon_sym_struct] = ACTIONS(2975),
    [anon_sym_module] = ACTIONS(2975),
    [anon_sym_macro] = ACTIONS(2975),
    [anon_sym_LPAREN] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2977),
    [anon_sym_RPAREN] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2977),
    [anon_sym_COLON_COLON] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_LT_COLON] = ACTIONS(2977),
    [anon_sym_if] = ACTIONS(2975),
    [anon_sym_try] = ACTIONS(2975),
    [anon_sym_for] = ACTIONS(2975),
    [anon_sym_while] = ACTIONS(2975),
    [sym_break_statement] = ACTIONS(2975),
    [sym_continue_statement] = ACTIONS(2975),
    [anon_sym_return] = ACTIONS(2975),
    [anon_sym_let] = ACTIONS(2975),
    [anon_sym_const] = ACTIONS(2975),
    [anon_sym_quote] = ACTIONS(2975),
    [anon_sym_using] = ACTIONS(2975),
    [anon_sym_import] = ACTIONS(2975),
    [anon_sym_export] = ACTIONS(2975),
    [anon_sym_COLON2] = ACTIONS(2975),
    [anon_sym_RBRACK] = ACTIONS(2977),
    [anon_sym_begin] = ACTIONS(2975),
    [anon_sym_SQUOTE] = ACTIONS(2977),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_LT_PIPE] = ACTIONS(2977),
    [anon_sym_PIPE_GT] = ACTIONS(2977),
    [anon_sym_in] = ACTIONS(2975),
    [anon_sym_isa] = ACTIONS(2975),
    [anon_sym_PIPE_PIPE] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_EQ_GT] = ACTIONS(2977),
    [anon_sym_LBRACK2] = ACTIONS(2977),
    [anon_sym_DOLLAR] = ACTIONS(2975),
    [anon_sym_AT] = ACTIONS(2977),
    [aux_sym_integer_literal_token1] = ACTIONS(2977),
    [aux_sym_integer_literal_token2] = ACTIONS(2977),
    [aux_sym_integer_literal_token3] = ACTIONS(2975),
    [sym_float_literal] = ACTIONS(2975),
    [sym__unary_operator] = ACTIONS(2975),
    [sym__power_operator] = ACTIONS(2975),
    [sym__bitshift_operator] = ACTIONS(2975),
    [sym__rational_operator] = ACTIONS(2975),
    [sym__times_operator] = ACTIONS(2975),
    [sym__plus_operator] = ACTIONS(2975),
    [sym__dotty_operator] = ACTIONS(2975),
    [sym__comparison_operator] = ACTIONS(2975),
    [sym__arrow_operator] = ACTIONS(2977),
    [sym__assign_operator] = ACTIONS(2975),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2977),
    [sym__command_start] = ACTIONS(2977),
  },
  [1344] = {
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_end] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_primitive] = ACTIONS(2817),
    [aux_sym_primitive_definition_token1] = ACTIONS(2817),
    [anon_sym_mutable] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_macro] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_COMMA] = ACTIONS(2822),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_LT_COLON] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [sym_break_statement] = ACTIONS(2817),
    [sym_continue_statement] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_quote] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_COLON2] = ACTIONS(2817),
    [anon_sym_RBRACK] = ACTIONS(2822),
    [anon_sym_begin] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_LT_PIPE] = ACTIONS(2822),
    [anon_sym_PIPE_GT] = ACTIONS(2822),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_isa] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_QMARK] = ACTIONS(2822),
    [anon_sym_EQ_GT] = ACTIONS(2822),
    [anon_sym_LBRACK2] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2822),
    [aux_sym_integer_literal_token1] = ACTIONS(2822),
    [aux_sym_integer_literal_token2] = ACTIONS(2822),
    [aux_sym_integer_literal_token3] = ACTIONS(2817),
    [sym_float_literal] = ACTIONS(2817),
    [sym__unary_operator] = ACTIONS(2817),
    [sym__power_operator] = ACTIONS(2817),
    [sym__bitshift_operator] = ACTIONS(2817),
    [sym__rational_operator] = ACTIONS(2817),
    [sym__times_operator] = ACTIONS(2817),
    [sym__plus_operator] = ACTIONS(2817),
    [sym__dotty_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(2817),
    [sym__arrow_operator] = ACTIONS(2822),
    [sym__assign_operator] = ACTIONS(2817),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2822),
    [sym__command_start] = ACTIONS(2822),
  },
  [1345] = {
    [sym_identifier] = ACTIONS(2971),
    [anon_sym_function] = ACTIONS(2971),
    [anon_sym_end] = ACTIONS(2971),
    [anon_sym_abstract] = ACTIONS(2971),
    [anon_sym_primitive] = ACTIONS(2971),
    [aux_sym_primitive_definition_token1] = ACTIONS(2971),
    [anon_sym_mutable] = ACTIONS(2971),
    [anon_sym_struct] = ACTIONS(2971),
    [anon_sym_module] = ACTIONS(2971),
    [anon_sym_macro] = ACTIONS(2971),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_EQ] = ACTIONS(2971),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_COLON_COLON] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_LT_COLON] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2971),
    [anon_sym_try] = ACTIONS(2971),
    [anon_sym_for] = ACTIONS(2971),
    [anon_sym_while] = ACTIONS(2971),
    [sym_break_statement] = ACTIONS(2971),
    [sym_continue_statement] = ACTIONS(2971),
    [anon_sym_return] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_const] = ACTIONS(2971),
    [anon_sym_quote] = ACTIONS(2971),
    [anon_sym_using] = ACTIONS(2971),
    [anon_sym_import] = ACTIONS(2971),
    [anon_sym_export] = ACTIONS(2971),
    [anon_sym_COLON2] = ACTIONS(2971),
    [anon_sym_RBRACK] = ACTIONS(2973),
    [anon_sym_begin] = ACTIONS(2971),
    [anon_sym_SQUOTE] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_LT_PIPE] = ACTIONS(2973),
    [anon_sym_PIPE_GT] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2971),
    [anon_sym_isa] = ACTIONS(2971),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(2973),
    [anon_sym_LBRACK2] = ACTIONS(2973),
    [anon_sym_DOLLAR] = ACTIONS(2971),
    [anon_sym_AT] = ACTIONS(2973),
    [aux_sym_integer_literal_token1] = ACTIONS(2973),
    [aux_sym_integer_literal_token2] = ACTIONS(2973),
    [aux_sym_integer_literal_token3] = ACTIONS(2971),
    [sym_float_literal] = ACTIONS(2971),
    [sym__unary_operator] = ACTIONS(2971),
    [sym__power_operator] = ACTIONS(2971),
    [sym__bitshift_operator] = ACTIONS(2971),
    [sym__rational_operator] = ACTIONS(2971),
    [sym__times_operator] = ACTIONS(2971),
    [sym__plus_operator] = ACTIONS(2971),
    [sym__dotty_operator] = ACTIONS(2971),
    [sym__comparison_operator] = ACTIONS(2971),
    [sym__arrow_operator] = ACTIONS(2973),
    [sym__assign_operator] = ACTIONS(2971),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2973),
    [sym__command_start] = ACTIONS(2973),
  },
  [1346] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1347] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(2985),
    [anon_sym_PIPE_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1348] = {
    [sym_identifier] = ACTIONS(2967),
    [anon_sym_function] = ACTIONS(2967),
    [anon_sym_end] = ACTIONS(2967),
    [anon_sym_abstract] = ACTIONS(2967),
    [anon_sym_primitive] = ACTIONS(2967),
    [aux_sym_primitive_definition_token1] = ACTIONS(2967),
    [anon_sym_mutable] = ACTIONS(2967),
    [anon_sym_struct] = ACTIONS(2967),
    [anon_sym_module] = ACTIONS(2967),
    [anon_sym_macro] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2969),
    [anon_sym_RPAREN] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2967),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2969),
    [anon_sym_COLON_COLON] = ACTIONS(2969),
    [anon_sym_RBRACE] = ACTIONS(2969),
    [anon_sym_LT_COLON] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_try] = ACTIONS(2967),
    [anon_sym_for] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [sym_break_statement] = ACTIONS(2967),
    [sym_continue_statement] = ACTIONS(2967),
    [anon_sym_return] = ACTIONS(2967),
    [anon_sym_let] = ACTIONS(2967),
    [anon_sym_const] = ACTIONS(2967),
    [anon_sym_quote] = ACTIONS(2967),
    [anon_sym_using] = ACTIONS(2967),
    [anon_sym_import] = ACTIONS(2967),
    [anon_sym_export] = ACTIONS(2967),
    [anon_sym_COLON2] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2969),
    [anon_sym_begin] = ACTIONS(2967),
    [anon_sym_SQUOTE] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_LT_PIPE] = ACTIONS(2969),
    [anon_sym_PIPE_GT] = ACTIONS(2969),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_isa] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_QMARK] = ACTIONS(2969),
    [anon_sym_EQ_GT] = ACTIONS(2969),
    [anon_sym_LBRACK2] = ACTIONS(2969),
    [anon_sym_DOLLAR] = ACTIONS(2967),
    [anon_sym_AT] = ACTIONS(2969),
    [aux_sym_integer_literal_token1] = ACTIONS(2969),
    [aux_sym_integer_literal_token2] = ACTIONS(2969),
    [aux_sym_integer_literal_token3] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym__unary_operator] = ACTIONS(2967),
    [sym__power_operator] = ACTIONS(2967),
    [sym__bitshift_operator] = ACTIONS(2967),
    [sym__rational_operator] = ACTIONS(2967),
    [sym__times_operator] = ACTIONS(2967),
    [sym__plus_operator] = ACTIONS(2967),
    [sym__dotty_operator] = ACTIONS(2967),
    [sym__comparison_operator] = ACTIONS(2967),
    [sym__arrow_operator] = ACTIONS(2969),
    [sym__assign_operator] = ACTIONS(2967),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2969),
    [sym__command_start] = ACTIONS(2969),
  },
  [1349] = {
    [sym_identifier] = ACTIONS(3017),
    [anon_sym_function] = ACTIONS(3017),
    [anon_sym_end] = ACTIONS(3017),
    [anon_sym_abstract] = ACTIONS(3017),
    [anon_sym_primitive] = ACTIONS(3017),
    [aux_sym_primitive_definition_token1] = ACTIONS(3017),
    [anon_sym_mutable] = ACTIONS(3017),
    [anon_sym_struct] = ACTIONS(3017),
    [anon_sym_module] = ACTIONS(3017),
    [anon_sym_macro] = ACTIONS(3017),
    [anon_sym_LPAREN] = ACTIONS(3019),
    [anon_sym_COMMA] = ACTIONS(3019),
    [anon_sym_RPAREN] = ACTIONS(3019),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_EQ] = ACTIONS(3017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3019),
    [anon_sym_COLON_COLON] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3019),
    [anon_sym_LT_COLON] = ACTIONS(3019),
    [anon_sym_if] = ACTIONS(3017),
    [anon_sym_try] = ACTIONS(3017),
    [anon_sym_for] = ACTIONS(3017),
    [anon_sym_while] = ACTIONS(3017),
    [sym_break_statement] = ACTIONS(3017),
    [sym_continue_statement] = ACTIONS(3017),
    [anon_sym_return] = ACTIONS(3017),
    [anon_sym_let] = ACTIONS(3017),
    [anon_sym_const] = ACTIONS(3017),
    [anon_sym_quote] = ACTIONS(3017),
    [anon_sym_using] = ACTIONS(3017),
    [anon_sym_import] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(3017),
    [anon_sym_COLON2] = ACTIONS(3017),
    [anon_sym_RBRACK] = ACTIONS(3019),
    [anon_sym_begin] = ACTIONS(3017),
    [anon_sym_SQUOTE] = ACTIONS(3019),
    [anon_sym_PLUS] = ACTIONS(3017),
    [anon_sym_LT_PIPE] = ACTIONS(3019),
    [anon_sym_PIPE_GT] = ACTIONS(3019),
    [anon_sym_in] = ACTIONS(3017),
    [anon_sym_isa] = ACTIONS(3017),
    [anon_sym_PIPE_PIPE] = ACTIONS(3019),
    [anon_sym_AMP_AMP] = ACTIONS(3019),
    [anon_sym_QMARK] = ACTIONS(3019),
    [anon_sym_EQ_GT] = ACTIONS(3019),
    [anon_sym_LBRACK2] = ACTIONS(3019),
    [anon_sym_DOLLAR] = ACTIONS(3017),
    [anon_sym_AT] = ACTIONS(3019),
    [aux_sym_integer_literal_token1] = ACTIONS(3019),
    [aux_sym_integer_literal_token2] = ACTIONS(3019),
    [aux_sym_integer_literal_token3] = ACTIONS(3017),
    [sym_float_literal] = ACTIONS(3017),
    [sym__unary_operator] = ACTIONS(3017),
    [sym__power_operator] = ACTIONS(3017),
    [sym__bitshift_operator] = ACTIONS(3017),
    [sym__rational_operator] = ACTIONS(3017),
    [sym__times_operator] = ACTIONS(3017),
    [sym__plus_operator] = ACTIONS(3017),
    [sym__dotty_operator] = ACTIONS(3017),
    [sym__comparison_operator] = ACTIONS(3017),
    [sym__arrow_operator] = ACTIONS(3019),
    [sym__assign_operator] = ACTIONS(3017),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3019),
    [sym__command_start] = ACTIONS(3019),
  },
  [1350] = {
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_end] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_primitive] = ACTIONS(3193),
    [aux_sym_primitive_definition_token1] = ACTIONS(3193),
    [anon_sym_mutable] = ACTIONS(3193),
    [anon_sym_struct] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_macro] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3195),
    [anon_sym_COMMA] = ACTIONS(3195),
    [anon_sym_RPAREN] = ACTIONS(3195),
    [anon_sym_SEMI] = ACTIONS(3195),
    [anon_sym_EQ] = ACTIONS(3193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3195),
    [anon_sym_COLON_COLON] = ACTIONS(3195),
    [anon_sym_RBRACE] = ACTIONS(3195),
    [anon_sym_LT_COLON] = ACTIONS(3195),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [sym_break_statement] = ACTIONS(3193),
    [sym_continue_statement] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_quote] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_import] = ACTIONS(3193),
    [anon_sym_export] = ACTIONS(3193),
    [anon_sym_COLON2] = ACTIONS(3193),
    [anon_sym_RBRACK] = ACTIONS(3195),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3195),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_LT_PIPE] = ACTIONS(3195),
    [anon_sym_PIPE_GT] = ACTIONS(3195),
    [anon_sym_in] = ACTIONS(3193),
    [anon_sym_isa] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3195),
    [anon_sym_AMP_AMP] = ACTIONS(3195),
    [anon_sym_QMARK] = ACTIONS(3195),
    [anon_sym_EQ_GT] = ACTIONS(3195),
    [anon_sym_LBRACK2] = ACTIONS(3195),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_AT] = ACTIONS(3195),
    [aux_sym_integer_literal_token1] = ACTIONS(3195),
    [aux_sym_integer_literal_token2] = ACTIONS(3195),
    [aux_sym_integer_literal_token3] = ACTIONS(3193),
    [sym_float_literal] = ACTIONS(3193),
    [sym__unary_operator] = ACTIONS(3193),
    [sym__power_operator] = ACTIONS(3193),
    [sym__bitshift_operator] = ACTIONS(3193),
    [sym__rational_operator] = ACTIONS(3193),
    [sym__times_operator] = ACTIONS(3193),
    [sym__plus_operator] = ACTIONS(3193),
    [sym__dotty_operator] = ACTIONS(3193),
    [sym__comparison_operator] = ACTIONS(3193),
    [sym__arrow_operator] = ACTIONS(3195),
    [sym__assign_operator] = ACTIONS(3193),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3195),
    [sym__command_start] = ACTIONS(3195),
  },
  [1351] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2985),
    [anon_sym_PIPE_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(2983),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1352] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2985),
    [anon_sym_PIPE_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(2983),
    [sym__rational_operator] = ACTIONS(2983),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1353] = {
    [sym_identifier] = ACTIONS(2995),
    [anon_sym_function] = ACTIONS(2995),
    [anon_sym_end] = ACTIONS(2995),
    [anon_sym_abstract] = ACTIONS(2995),
    [anon_sym_primitive] = ACTIONS(2995),
    [aux_sym_primitive_definition_token1] = ACTIONS(2995),
    [anon_sym_mutable] = ACTIONS(2995),
    [anon_sym_struct] = ACTIONS(2995),
    [anon_sym_module] = ACTIONS(2995),
    [anon_sym_macro] = ACTIONS(2995),
    [anon_sym_LPAREN] = ACTIONS(2997),
    [anon_sym_COMMA] = ACTIONS(2997),
    [anon_sym_RPAREN] = ACTIONS(2997),
    [anon_sym_SEMI] = ACTIONS(2997),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2995),
    [anon_sym_try] = ACTIONS(2995),
    [anon_sym_for] = ACTIONS(2995),
    [anon_sym_while] = ACTIONS(2995),
    [sym_break_statement] = ACTIONS(2995),
    [sym_continue_statement] = ACTIONS(2995),
    [anon_sym_return] = ACTIONS(2995),
    [anon_sym_let] = ACTIONS(2995),
    [anon_sym_const] = ACTIONS(2995),
    [anon_sym_quote] = ACTIONS(2995),
    [anon_sym_using] = ACTIONS(2995),
    [anon_sym_import] = ACTIONS(2995),
    [anon_sym_export] = ACTIONS(2995),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2997),
    [anon_sym_begin] = ACTIONS(2995),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(2997),
    [anon_sym_DOLLAR] = ACTIONS(2995),
    [anon_sym_AT] = ACTIONS(2997),
    [aux_sym_integer_literal_token1] = ACTIONS(2997),
    [aux_sym_integer_literal_token2] = ACTIONS(2997),
    [aux_sym_integer_literal_token3] = ACTIONS(2995),
    [sym_float_literal] = ACTIONS(2995),
    [sym__unary_operator] = ACTIONS(2995),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2995),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2997),
    [sym__command_start] = ACTIONS(2997),
  },
  [1354] = {
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_function] = ACTIONS(3097),
    [anon_sym_end] = ACTIONS(3097),
    [anon_sym_abstract] = ACTIONS(3097),
    [anon_sym_primitive] = ACTIONS(3097),
    [aux_sym_primitive_definition_token1] = ACTIONS(3097),
    [anon_sym_mutable] = ACTIONS(3097),
    [anon_sym_struct] = ACTIONS(3097),
    [anon_sym_module] = ACTIONS(3097),
    [anon_sym_macro] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3099),
    [anon_sym_COLON_COLON] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_LT_COLON] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3097),
    [anon_sym_try] = ACTIONS(3097),
    [anon_sym_for] = ACTIONS(3097),
    [anon_sym_while] = ACTIONS(3097),
    [sym_break_statement] = ACTIONS(3097),
    [sym_continue_statement] = ACTIONS(3097),
    [anon_sym_return] = ACTIONS(3097),
    [anon_sym_let] = ACTIONS(3097),
    [anon_sym_const] = ACTIONS(3097),
    [anon_sym_quote] = ACTIONS(3097),
    [anon_sym_using] = ACTIONS(3097),
    [anon_sym_import] = ACTIONS(3097),
    [anon_sym_export] = ACTIONS(3097),
    [anon_sym_COLON2] = ACTIONS(3097),
    [anon_sym_RBRACK] = ACTIONS(3099),
    [anon_sym_begin] = ACTIONS(3097),
    [anon_sym_SQUOTE] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_LT_PIPE] = ACTIONS(3099),
    [anon_sym_PIPE_GT] = ACTIONS(3099),
    [anon_sym_in] = ACTIONS(3097),
    [anon_sym_isa] = ACTIONS(3097),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_EQ_GT] = ACTIONS(3099),
    [anon_sym_LBRACK2] = ACTIONS(3099),
    [anon_sym_DOLLAR] = ACTIONS(3097),
    [anon_sym_AT] = ACTIONS(3099),
    [aux_sym_integer_literal_token1] = ACTIONS(3099),
    [aux_sym_integer_literal_token2] = ACTIONS(3099),
    [aux_sym_integer_literal_token3] = ACTIONS(3097),
    [sym_float_literal] = ACTIONS(3097),
    [sym__unary_operator] = ACTIONS(3097),
    [sym__power_operator] = ACTIONS(3097),
    [sym__bitshift_operator] = ACTIONS(3097),
    [sym__rational_operator] = ACTIONS(3097),
    [sym__times_operator] = ACTIONS(3097),
    [sym__plus_operator] = ACTIONS(3097),
    [sym__dotty_operator] = ACTIONS(3097),
    [sym__comparison_operator] = ACTIONS(3097),
    [sym__arrow_operator] = ACTIONS(3099),
    [sym__assign_operator] = ACTIONS(3097),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3099),
    [sym__command_start] = ACTIONS(3099),
  },
  [1355] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1356] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1357] = {
    [sym_identifier] = ACTIONS(3109),
    [anon_sym_function] = ACTIONS(3109),
    [anon_sym_end] = ACTIONS(3109),
    [anon_sym_abstract] = ACTIONS(3109),
    [anon_sym_primitive] = ACTIONS(3109),
    [aux_sym_primitive_definition_token1] = ACTIONS(3109),
    [anon_sym_mutable] = ACTIONS(3109),
    [anon_sym_struct] = ACTIONS(3109),
    [anon_sym_module] = ACTIONS(3109),
    [anon_sym_macro] = ACTIONS(3109),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3111),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3111),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3111),
    [anon_sym_LT_COLON] = ACTIONS(3111),
    [anon_sym_if] = ACTIONS(3109),
    [anon_sym_try] = ACTIONS(3109),
    [anon_sym_for] = ACTIONS(3109),
    [anon_sym_while] = ACTIONS(3109),
    [sym_break_statement] = ACTIONS(3109),
    [sym_continue_statement] = ACTIONS(3109),
    [anon_sym_return] = ACTIONS(3109),
    [anon_sym_let] = ACTIONS(3109),
    [anon_sym_const] = ACTIONS(3109),
    [anon_sym_quote] = ACTIONS(3109),
    [anon_sym_using] = ACTIONS(3109),
    [anon_sym_import] = ACTIONS(3109),
    [anon_sym_export] = ACTIONS(3109),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_RBRACK] = ACTIONS(3111),
    [anon_sym_begin] = ACTIONS(3109),
    [anon_sym_SQUOTE] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_LT_PIPE] = ACTIONS(3111),
    [anon_sym_PIPE_GT] = ACTIONS(3111),
    [anon_sym_in] = ACTIONS(3109),
    [anon_sym_isa] = ACTIONS(3109),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_LBRACK2] = ACTIONS(3111),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_AT] = ACTIONS(3111),
    [aux_sym_integer_literal_token1] = ACTIONS(3111),
    [aux_sym_integer_literal_token2] = ACTIONS(3111),
    [aux_sym_integer_literal_token3] = ACTIONS(3109),
    [sym_float_literal] = ACTIONS(3109),
    [sym__unary_operator] = ACTIONS(3109),
    [sym__power_operator] = ACTIONS(3109),
    [sym__bitshift_operator] = ACTIONS(3109),
    [sym__rational_operator] = ACTIONS(3109),
    [sym__times_operator] = ACTIONS(3109),
    [sym__plus_operator] = ACTIONS(3109),
    [sym__dotty_operator] = ACTIONS(3109),
    [sym__comparison_operator] = ACTIONS(3109),
    [sym__arrow_operator] = ACTIONS(3111),
    [sym__assign_operator] = ACTIONS(3109),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3111),
    [sym__command_start] = ACTIONS(3111),
  },
  [1358] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1359] = {
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_function] = ACTIONS(2514),
    [anon_sym_end] = ACTIONS(2514),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_primitive] = ACTIONS(2514),
    [aux_sym_primitive_definition_token1] = ACTIONS(2514),
    [anon_sym_mutable] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_module] = ACTIONS(2514),
    [anon_sym_macro] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_COMMA] = ACTIONS(2516),
    [anon_sym_RPAREN] = ACTIONS(2516),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_EQ] = ACTIONS(2514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2516),
    [anon_sym_COLON_COLON] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_LT_COLON] = ACTIONS(2516),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [sym_break_statement] = ACTIONS(2514),
    [sym_continue_statement] = ACTIONS(2514),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_quote] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_import] = ACTIONS(2514),
    [anon_sym_export] = ACTIONS(2514),
    [anon_sym_COLON2] = ACTIONS(2514),
    [anon_sym_RBRACK] = ACTIONS(2516),
    [anon_sym_begin] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_LT_PIPE] = ACTIONS(2516),
    [anon_sym_PIPE_GT] = ACTIONS(2516),
    [anon_sym_in] = ACTIONS(2514),
    [anon_sym_isa] = ACTIONS(2514),
    [anon_sym_PIPE_PIPE] = ACTIONS(2516),
    [anon_sym_AMP_AMP] = ACTIONS(2516),
    [anon_sym_QMARK] = ACTIONS(2516),
    [anon_sym_EQ_GT] = ACTIONS(2516),
    [anon_sym_LBRACK2] = ACTIONS(2516),
    [anon_sym_DOLLAR] = ACTIONS(2514),
    [anon_sym_AT] = ACTIONS(2516),
    [aux_sym_integer_literal_token1] = ACTIONS(2516),
    [aux_sym_integer_literal_token2] = ACTIONS(2516),
    [aux_sym_integer_literal_token3] = ACTIONS(2514),
    [sym_float_literal] = ACTIONS(2514),
    [sym__unary_operator] = ACTIONS(2514),
    [sym__power_operator] = ACTIONS(2514),
    [sym__bitshift_operator] = ACTIONS(2514),
    [sym__rational_operator] = ACTIONS(2514),
    [sym__times_operator] = ACTIONS(2514),
    [sym__plus_operator] = ACTIONS(2514),
    [sym__dotty_operator] = ACTIONS(2514),
    [sym__comparison_operator] = ACTIONS(2514),
    [sym__arrow_operator] = ACTIONS(2516),
    [sym__assign_operator] = ACTIONS(2514),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2516),
    [sym__command_start] = ACTIONS(2516),
  },
  [1360] = {
    [sym_identifier] = ACTIONS(3135),
    [anon_sym_function] = ACTIONS(3135),
    [anon_sym_end] = ACTIONS(3135),
    [anon_sym_abstract] = ACTIONS(3135),
    [anon_sym_primitive] = ACTIONS(3135),
    [aux_sym_primitive_definition_token1] = ACTIONS(3135),
    [anon_sym_mutable] = ACTIONS(3135),
    [anon_sym_struct] = ACTIONS(3135),
    [anon_sym_module] = ACTIONS(3135),
    [anon_sym_macro] = ACTIONS(3135),
    [anon_sym_LPAREN] = ACTIONS(3137),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_RPAREN] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3137),
    [anon_sym_EQ] = ACTIONS(3135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3137),
    [anon_sym_COLON_COLON] = ACTIONS(3137),
    [anon_sym_RBRACE] = ACTIONS(3137),
    [anon_sym_LT_COLON] = ACTIONS(3137),
    [anon_sym_if] = ACTIONS(3135),
    [anon_sym_try] = ACTIONS(3135),
    [anon_sym_for] = ACTIONS(3135),
    [anon_sym_while] = ACTIONS(3135),
    [sym_break_statement] = ACTIONS(3135),
    [sym_continue_statement] = ACTIONS(3135),
    [anon_sym_return] = ACTIONS(3135),
    [anon_sym_let] = ACTIONS(3135),
    [anon_sym_const] = ACTIONS(3135),
    [anon_sym_quote] = ACTIONS(3135),
    [anon_sym_using] = ACTIONS(3135),
    [anon_sym_import] = ACTIONS(3135),
    [anon_sym_export] = ACTIONS(3135),
    [anon_sym_COLON2] = ACTIONS(3135),
    [anon_sym_RBRACK] = ACTIONS(3137),
    [anon_sym_begin] = ACTIONS(3135),
    [anon_sym_SQUOTE] = ACTIONS(3137),
    [anon_sym_PLUS] = ACTIONS(3135),
    [anon_sym_LT_PIPE] = ACTIONS(3137),
    [anon_sym_PIPE_GT] = ACTIONS(3137),
    [anon_sym_in] = ACTIONS(3135),
    [anon_sym_isa] = ACTIONS(3135),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_AMP_AMP] = ACTIONS(3137),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_EQ_GT] = ACTIONS(3137),
    [anon_sym_LBRACK2] = ACTIONS(3137),
    [anon_sym_DOLLAR] = ACTIONS(3135),
    [anon_sym_AT] = ACTIONS(3137),
    [aux_sym_integer_literal_token1] = ACTIONS(3137),
    [aux_sym_integer_literal_token2] = ACTIONS(3137),
    [aux_sym_integer_literal_token3] = ACTIONS(3135),
    [sym_float_literal] = ACTIONS(3135),
    [sym__unary_operator] = ACTIONS(3135),
    [sym__power_operator] = ACTIONS(3135),
    [sym__bitshift_operator] = ACTIONS(3135),
    [sym__rational_operator] = ACTIONS(3135),
    [sym__times_operator] = ACTIONS(3135),
    [sym__plus_operator] = ACTIONS(3135),
    [sym__dotty_operator] = ACTIONS(3135),
    [sym__comparison_operator] = ACTIONS(3135),
    [sym__arrow_operator] = ACTIONS(3137),
    [sym__assign_operator] = ACTIONS(3135),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3137),
    [sym__command_start] = ACTIONS(3137),
  },
  [1361] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2985),
    [anon_sym_PIPE_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(2983),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1362] = {
    [sym_identifier] = ACTIONS(2927),
    [anon_sym_function] = ACTIONS(2927),
    [anon_sym_end] = ACTIONS(2927),
    [anon_sym_abstract] = ACTIONS(2927),
    [anon_sym_primitive] = ACTIONS(2927),
    [aux_sym_primitive_definition_token1] = ACTIONS(2927),
    [anon_sym_mutable] = ACTIONS(2927),
    [anon_sym_struct] = ACTIONS(2927),
    [anon_sym_module] = ACTIONS(2927),
    [anon_sym_macro] = ACTIONS(2927),
    [anon_sym_LPAREN] = ACTIONS(2929),
    [anon_sym_COMMA] = ACTIONS(2929),
    [anon_sym_RPAREN] = ACTIONS(2929),
    [anon_sym_SEMI] = ACTIONS(2929),
    [anon_sym_EQ] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2929),
    [anon_sym_COLON_COLON] = ACTIONS(2929),
    [anon_sym_RBRACE] = ACTIONS(2929),
    [anon_sym_LT_COLON] = ACTIONS(2929),
    [anon_sym_if] = ACTIONS(2927),
    [anon_sym_try] = ACTIONS(2927),
    [anon_sym_for] = ACTIONS(2927),
    [anon_sym_while] = ACTIONS(2927),
    [sym_break_statement] = ACTIONS(2927),
    [sym_continue_statement] = ACTIONS(2927),
    [anon_sym_return] = ACTIONS(2927),
    [anon_sym_let] = ACTIONS(2927),
    [anon_sym_const] = ACTIONS(2927),
    [anon_sym_quote] = ACTIONS(2927),
    [anon_sym_using] = ACTIONS(2927),
    [anon_sym_import] = ACTIONS(2927),
    [anon_sym_export] = ACTIONS(2927),
    [anon_sym_COLON2] = ACTIONS(2927),
    [anon_sym_RBRACK] = ACTIONS(2929),
    [anon_sym_begin] = ACTIONS(2927),
    [anon_sym_SQUOTE] = ACTIONS(2929),
    [anon_sym_PLUS] = ACTIONS(2927),
    [anon_sym_LT_PIPE] = ACTIONS(2929),
    [anon_sym_PIPE_GT] = ACTIONS(2929),
    [anon_sym_in] = ACTIONS(2927),
    [anon_sym_isa] = ACTIONS(2927),
    [anon_sym_PIPE_PIPE] = ACTIONS(2929),
    [anon_sym_AMP_AMP] = ACTIONS(2929),
    [anon_sym_QMARK] = ACTIONS(2929),
    [anon_sym_EQ_GT] = ACTIONS(2929),
    [anon_sym_LBRACK2] = ACTIONS(2929),
    [anon_sym_DOLLAR] = ACTIONS(2927),
    [anon_sym_AT] = ACTIONS(2929),
    [aux_sym_integer_literal_token1] = ACTIONS(2929),
    [aux_sym_integer_literal_token2] = ACTIONS(2929),
    [aux_sym_integer_literal_token3] = ACTIONS(2927),
    [sym_float_literal] = ACTIONS(2927),
    [sym__unary_operator] = ACTIONS(2927),
    [sym__power_operator] = ACTIONS(2927),
    [sym__bitshift_operator] = ACTIONS(2927),
    [sym__rational_operator] = ACTIONS(2927),
    [sym__times_operator] = ACTIONS(2927),
    [sym__plus_operator] = ACTIONS(2927),
    [sym__dotty_operator] = ACTIONS(2927),
    [sym__comparison_operator] = ACTIONS(2927),
    [sym__arrow_operator] = ACTIONS(2929),
    [sym__assign_operator] = ACTIONS(2927),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2929),
    [sym__command_start] = ACTIONS(2929),
  },
  [1363] = {
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_function] = ACTIONS(3081),
    [anon_sym_end] = ACTIONS(3081),
    [anon_sym_abstract] = ACTIONS(3081),
    [anon_sym_primitive] = ACTIONS(3081),
    [aux_sym_primitive_definition_token1] = ACTIONS(3081),
    [anon_sym_mutable] = ACTIONS(3081),
    [anon_sym_struct] = ACTIONS(3081),
    [anon_sym_module] = ACTIONS(3081),
    [anon_sym_macro] = ACTIONS(3081),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3083),
    [anon_sym_RPAREN] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3083),
    [anon_sym_COLON_COLON] = ACTIONS(3083),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_LT_COLON] = ACTIONS(3083),
    [anon_sym_if] = ACTIONS(3081),
    [anon_sym_try] = ACTIONS(3081),
    [anon_sym_for] = ACTIONS(3081),
    [anon_sym_while] = ACTIONS(3081),
    [sym_break_statement] = ACTIONS(3081),
    [sym_continue_statement] = ACTIONS(3081),
    [anon_sym_return] = ACTIONS(3081),
    [anon_sym_let] = ACTIONS(3081),
    [anon_sym_const] = ACTIONS(3081),
    [anon_sym_quote] = ACTIONS(3081),
    [anon_sym_using] = ACTIONS(3081),
    [anon_sym_import] = ACTIONS(3081),
    [anon_sym_export] = ACTIONS(3081),
    [anon_sym_COLON2] = ACTIONS(3081),
    [anon_sym_RBRACK] = ACTIONS(3083),
    [anon_sym_begin] = ACTIONS(3081),
    [anon_sym_SQUOTE] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3081),
    [anon_sym_LT_PIPE] = ACTIONS(3083),
    [anon_sym_PIPE_GT] = ACTIONS(3083),
    [anon_sym_in] = ACTIONS(3081),
    [anon_sym_isa] = ACTIONS(3081),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_EQ_GT] = ACTIONS(3083),
    [anon_sym_LBRACK2] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(3081),
    [anon_sym_AT] = ACTIONS(3083),
    [aux_sym_integer_literal_token1] = ACTIONS(3083),
    [aux_sym_integer_literal_token2] = ACTIONS(3083),
    [aux_sym_integer_literal_token3] = ACTIONS(3081),
    [sym_float_literal] = ACTIONS(3081),
    [sym__unary_operator] = ACTIONS(3081),
    [sym__power_operator] = ACTIONS(3081),
    [sym__bitshift_operator] = ACTIONS(3081),
    [sym__rational_operator] = ACTIONS(3081),
    [sym__times_operator] = ACTIONS(3081),
    [sym__plus_operator] = ACTIONS(3081),
    [sym__dotty_operator] = ACTIONS(3081),
    [sym__comparison_operator] = ACTIONS(3081),
    [sym__arrow_operator] = ACTIONS(3083),
    [sym__assign_operator] = ACTIONS(3081),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3083),
    [sym__command_start] = ACTIONS(3083),
  },
  [1364] = {
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3101),
    [anon_sym_end] = ACTIONS(3101),
    [anon_sym_abstract] = ACTIONS(3101),
    [anon_sym_primitive] = ACTIONS(3101),
    [aux_sym_primitive_definition_token1] = ACTIONS(3101),
    [anon_sym_mutable] = ACTIONS(3101),
    [anon_sym_struct] = ACTIONS(3101),
    [anon_sym_module] = ACTIONS(3101),
    [anon_sym_macro] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3103),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3103),
    [anon_sym_COLON_COLON] = ACTIONS(3103),
    [anon_sym_RBRACE] = ACTIONS(3103),
    [anon_sym_LT_COLON] = ACTIONS(3103),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [sym_break_statement] = ACTIONS(3101),
    [sym_continue_statement] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_let] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [anon_sym_quote] = ACTIONS(3101),
    [anon_sym_using] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3101),
    [anon_sym_COLON2] = ACTIONS(3101),
    [anon_sym_RBRACK] = ACTIONS(3103),
    [anon_sym_begin] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_LT_PIPE] = ACTIONS(3103),
    [anon_sym_PIPE_GT] = ACTIONS(3103),
    [anon_sym_in] = ACTIONS(3101),
    [anon_sym_isa] = ACTIONS(3101),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_EQ_GT] = ACTIONS(3103),
    [anon_sym_LBRACK2] = ACTIONS(3103),
    [anon_sym_DOLLAR] = ACTIONS(3101),
    [anon_sym_AT] = ACTIONS(3103),
    [aux_sym_integer_literal_token1] = ACTIONS(3103),
    [aux_sym_integer_literal_token2] = ACTIONS(3103),
    [aux_sym_integer_literal_token3] = ACTIONS(3101),
    [sym_float_literal] = ACTIONS(3101),
    [sym__unary_operator] = ACTIONS(3101),
    [sym__power_operator] = ACTIONS(3101),
    [sym__bitshift_operator] = ACTIONS(3101),
    [sym__rational_operator] = ACTIONS(3101),
    [sym__times_operator] = ACTIONS(3101),
    [sym__plus_operator] = ACTIONS(3101),
    [sym__dotty_operator] = ACTIONS(3101),
    [sym__comparison_operator] = ACTIONS(3101),
    [sym__arrow_operator] = ACTIONS(3103),
    [sym__assign_operator] = ACTIONS(3101),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3103),
    [sym__command_start] = ACTIONS(3103),
  },
  [1365] = {
    [sym_identifier] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [aux_sym_primitive_definition_token1] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3073),
    [anon_sym_COMMA] = ACTIONS(3073),
    [anon_sym_RPAREN] = ACTIONS(3073),
    [anon_sym_SEMI] = ACTIONS(3073),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3073),
    [anon_sym_COLON_COLON] = ACTIONS(3073),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_LT_COLON] = ACTIONS(3073),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3073),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_LT_PIPE] = ACTIONS(3073),
    [anon_sym_PIPE_GT] = ACTIONS(3073),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3073),
    [anon_sym_AMP_AMP] = ACTIONS(3073),
    [anon_sym_QMARK] = ACTIONS(3073),
    [anon_sym_EQ_GT] = ACTIONS(3073),
    [anon_sym_LBRACK2] = ACTIONS(3073),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3073),
    [aux_sym_integer_literal_token1] = ACTIONS(3073),
    [aux_sym_integer_literal_token2] = ACTIONS(3073),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [sym_float_literal] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__dotty_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3073),
    [sym__assign_operator] = ACTIONS(3071),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3073),
    [sym__command_start] = ACTIONS(3073),
  },
  [1366] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(2985),
    [anon_sym_PIPE_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1367] = {
    [sym_identifier] = ACTIONS(3105),
    [anon_sym_function] = ACTIONS(3105),
    [anon_sym_end] = ACTIONS(3105),
    [anon_sym_abstract] = ACTIONS(3105),
    [anon_sym_primitive] = ACTIONS(3105),
    [aux_sym_primitive_definition_token1] = ACTIONS(3105),
    [anon_sym_mutable] = ACTIONS(3105),
    [anon_sym_struct] = ACTIONS(3105),
    [anon_sym_module] = ACTIONS(3105),
    [anon_sym_macro] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3107),
    [anon_sym_COLON_COLON] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_LT_COLON] = ACTIONS(3107),
    [anon_sym_if] = ACTIONS(3105),
    [anon_sym_try] = ACTIONS(3105),
    [anon_sym_for] = ACTIONS(3105),
    [anon_sym_while] = ACTIONS(3105),
    [sym_break_statement] = ACTIONS(3105),
    [sym_continue_statement] = ACTIONS(3105),
    [anon_sym_return] = ACTIONS(3105),
    [anon_sym_let] = ACTIONS(3105),
    [anon_sym_const] = ACTIONS(3105),
    [anon_sym_quote] = ACTIONS(3105),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_import] = ACTIONS(3105),
    [anon_sym_export] = ACTIONS(3105),
    [anon_sym_COLON2] = ACTIONS(3105),
    [anon_sym_RBRACK] = ACTIONS(3107),
    [anon_sym_begin] = ACTIONS(3105),
    [anon_sym_SQUOTE] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_LT_PIPE] = ACTIONS(3107),
    [anon_sym_PIPE_GT] = ACTIONS(3107),
    [anon_sym_in] = ACTIONS(3105),
    [anon_sym_isa] = ACTIONS(3105),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_EQ_GT] = ACTIONS(3107),
    [anon_sym_LBRACK2] = ACTIONS(3107),
    [anon_sym_DOLLAR] = ACTIONS(3105),
    [anon_sym_AT] = ACTIONS(3107),
    [aux_sym_integer_literal_token1] = ACTIONS(3107),
    [aux_sym_integer_literal_token2] = ACTIONS(3107),
    [aux_sym_integer_literal_token3] = ACTIONS(3105),
    [sym_float_literal] = ACTIONS(3105),
    [sym__unary_operator] = ACTIONS(3105),
    [sym__power_operator] = ACTIONS(3105),
    [sym__bitshift_operator] = ACTIONS(3105),
    [sym__rational_operator] = ACTIONS(3105),
    [sym__times_operator] = ACTIONS(3105),
    [sym__plus_operator] = ACTIONS(3105),
    [sym__dotty_operator] = ACTIONS(3105),
    [sym__comparison_operator] = ACTIONS(3105),
    [sym__arrow_operator] = ACTIONS(3107),
    [sym__assign_operator] = ACTIONS(3105),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3107),
    [sym__command_start] = ACTIONS(3107),
  },
  [1368] = {
    [sym_identifier] = ACTIONS(2562),
    [anon_sym_function] = ACTIONS(2562),
    [anon_sym_end] = ACTIONS(2562),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_primitive] = ACTIONS(2562),
    [aux_sym_primitive_definition_token1] = ACTIONS(2562),
    [anon_sym_mutable] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_module] = ACTIONS(2562),
    [anon_sym_macro] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_EQ] = ACTIONS(2562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2564),
    [anon_sym_COLON_COLON] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_LT_COLON] = ACTIONS(2564),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [sym_break_statement] = ACTIONS(2562),
    [sym_continue_statement] = ACTIONS(2562),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_quote] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_import] = ACTIONS(2562),
    [anon_sym_export] = ACTIONS(2562),
    [anon_sym_COLON2] = ACTIONS(2562),
    [anon_sym_RBRACK] = ACTIONS(2564),
    [anon_sym_begin] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_LT_PIPE] = ACTIONS(2564),
    [anon_sym_PIPE_GT] = ACTIONS(2564),
    [anon_sym_in] = ACTIONS(2562),
    [anon_sym_isa] = ACTIONS(2562),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_QMARK] = ACTIONS(2564),
    [anon_sym_EQ_GT] = ACTIONS(2564),
    [anon_sym_LBRACK2] = ACTIONS(2564),
    [anon_sym_DOLLAR] = ACTIONS(2562),
    [anon_sym_AT] = ACTIONS(2564),
    [aux_sym_integer_literal_token1] = ACTIONS(2564),
    [aux_sym_integer_literal_token2] = ACTIONS(2564),
    [aux_sym_integer_literal_token3] = ACTIONS(2562),
    [sym_float_literal] = ACTIONS(2562),
    [sym__unary_operator] = ACTIONS(2562),
    [sym__power_operator] = ACTIONS(2562),
    [sym__bitshift_operator] = ACTIONS(2562),
    [sym__rational_operator] = ACTIONS(2562),
    [sym__times_operator] = ACTIONS(2562),
    [sym__plus_operator] = ACTIONS(2562),
    [sym__dotty_operator] = ACTIONS(2562),
    [sym__comparison_operator] = ACTIONS(2562),
    [sym__arrow_operator] = ACTIONS(2564),
    [sym__assign_operator] = ACTIONS(2562),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2564),
    [sym__command_start] = ACTIONS(2564),
  },
  [1369] = {
    [sym_identifier] = ACTIONS(3059),
    [anon_sym_function] = ACTIONS(3059),
    [anon_sym_end] = ACTIONS(3059),
    [anon_sym_abstract] = ACTIONS(3059),
    [anon_sym_primitive] = ACTIONS(3059),
    [aux_sym_primitive_definition_token1] = ACTIONS(3059),
    [anon_sym_mutable] = ACTIONS(3059),
    [anon_sym_struct] = ACTIONS(3059),
    [anon_sym_module] = ACTIONS(3059),
    [anon_sym_macro] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_COMMA] = ACTIONS(3061),
    [anon_sym_RPAREN] = ACTIONS(3061),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_EQ] = ACTIONS(3059),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3061),
    [anon_sym_COLON_COLON] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3061),
    [anon_sym_LT_COLON] = ACTIONS(3061),
    [anon_sym_if] = ACTIONS(3059),
    [anon_sym_try] = ACTIONS(3059),
    [anon_sym_for] = ACTIONS(3059),
    [anon_sym_while] = ACTIONS(3059),
    [sym_break_statement] = ACTIONS(3059),
    [sym_continue_statement] = ACTIONS(3059),
    [anon_sym_return] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_const] = ACTIONS(3059),
    [anon_sym_quote] = ACTIONS(3059),
    [anon_sym_using] = ACTIONS(3059),
    [anon_sym_import] = ACTIONS(3059),
    [anon_sym_export] = ACTIONS(3059),
    [anon_sym_COLON2] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3061),
    [anon_sym_begin] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym_PLUS] = ACTIONS(3059),
    [anon_sym_LT_PIPE] = ACTIONS(3061),
    [anon_sym_PIPE_GT] = ACTIONS(3061),
    [anon_sym_in] = ACTIONS(3059),
    [anon_sym_isa] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3061),
    [anon_sym_AMP_AMP] = ACTIONS(3061),
    [anon_sym_QMARK] = ACTIONS(3061),
    [anon_sym_EQ_GT] = ACTIONS(3061),
    [anon_sym_LBRACK2] = ACTIONS(3061),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3061),
    [aux_sym_integer_literal_token1] = ACTIONS(3061),
    [aux_sym_integer_literal_token2] = ACTIONS(3061),
    [aux_sym_integer_literal_token3] = ACTIONS(3059),
    [sym_float_literal] = ACTIONS(3059),
    [sym__unary_operator] = ACTIONS(3059),
    [sym__power_operator] = ACTIONS(3059),
    [sym__bitshift_operator] = ACTIONS(3059),
    [sym__rational_operator] = ACTIONS(3059),
    [sym__times_operator] = ACTIONS(3059),
    [sym__plus_operator] = ACTIONS(3059),
    [sym__dotty_operator] = ACTIONS(3059),
    [sym__comparison_operator] = ACTIONS(3059),
    [sym__arrow_operator] = ACTIONS(3061),
    [sym__assign_operator] = ACTIONS(3059),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3061),
    [sym__command_start] = ACTIONS(3061),
  },
  [1370] = {
    [sym_identifier] = ACTIONS(3047),
    [anon_sym_function] = ACTIONS(3047),
    [anon_sym_end] = ACTIONS(3047),
    [anon_sym_abstract] = ACTIONS(3047),
    [anon_sym_primitive] = ACTIONS(3047),
    [aux_sym_primitive_definition_token1] = ACTIONS(3047),
    [anon_sym_mutable] = ACTIONS(3047),
    [anon_sym_struct] = ACTIONS(3047),
    [anon_sym_module] = ACTIONS(3047),
    [anon_sym_macro] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_COMMA] = ACTIONS(3049),
    [anon_sym_RPAREN] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(3049),
    [anon_sym_EQ] = ACTIONS(3047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3049),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_RBRACE] = ACTIONS(3049),
    [anon_sym_LT_COLON] = ACTIONS(3049),
    [anon_sym_if] = ACTIONS(3047),
    [anon_sym_try] = ACTIONS(3047),
    [anon_sym_for] = ACTIONS(3047),
    [anon_sym_while] = ACTIONS(3047),
    [sym_break_statement] = ACTIONS(3047),
    [sym_continue_statement] = ACTIONS(3047),
    [anon_sym_return] = ACTIONS(3047),
    [anon_sym_let] = ACTIONS(3047),
    [anon_sym_const] = ACTIONS(3047),
    [anon_sym_quote] = ACTIONS(3047),
    [anon_sym_using] = ACTIONS(3047),
    [anon_sym_import] = ACTIONS(3047),
    [anon_sym_export] = ACTIONS(3047),
    [anon_sym_COLON2] = ACTIONS(3047),
    [anon_sym_RBRACK] = ACTIONS(3049),
    [anon_sym_begin] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym_PLUS] = ACTIONS(3047),
    [anon_sym_LT_PIPE] = ACTIONS(3049),
    [anon_sym_PIPE_GT] = ACTIONS(3049),
    [anon_sym_in] = ACTIONS(3047),
    [anon_sym_isa] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3049),
    [anon_sym_AMP_AMP] = ACTIONS(3049),
    [anon_sym_QMARK] = ACTIONS(3049),
    [anon_sym_EQ_GT] = ACTIONS(3049),
    [anon_sym_LBRACK2] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3047),
    [anon_sym_AT] = ACTIONS(3049),
    [aux_sym_integer_literal_token1] = ACTIONS(3049),
    [aux_sym_integer_literal_token2] = ACTIONS(3049),
    [aux_sym_integer_literal_token3] = ACTIONS(3047),
    [sym_float_literal] = ACTIONS(3047),
    [sym__unary_operator] = ACTIONS(3047),
    [sym__power_operator] = ACTIONS(3047),
    [sym__bitshift_operator] = ACTIONS(3047),
    [sym__rational_operator] = ACTIONS(3047),
    [sym__times_operator] = ACTIONS(3047),
    [sym__plus_operator] = ACTIONS(3047),
    [sym__dotty_operator] = ACTIONS(3047),
    [sym__comparison_operator] = ACTIONS(3047),
    [sym__arrow_operator] = ACTIONS(3049),
    [sym__assign_operator] = ACTIONS(3047),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3049),
    [sym__command_start] = ACTIONS(3049),
  },
  [1371] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_function] = ACTIONS(3041),
    [anon_sym_end] = ACTIONS(3041),
    [anon_sym_abstract] = ACTIONS(3041),
    [anon_sym_primitive] = ACTIONS(3041),
    [aux_sym_primitive_definition_token1] = ACTIONS(3041),
    [anon_sym_mutable] = ACTIONS(3041),
    [anon_sym_struct] = ACTIONS(3041),
    [anon_sym_module] = ACTIONS(3041),
    [anon_sym_macro] = ACTIONS(3041),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3043),
    [anon_sym_COLON_COLON] = ACTIONS(3043),
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_LT_COLON] = ACTIONS(3043),
    [anon_sym_if] = ACTIONS(3041),
    [anon_sym_try] = ACTIONS(3041),
    [anon_sym_for] = ACTIONS(3041),
    [anon_sym_while] = ACTIONS(3041),
    [sym_break_statement] = ACTIONS(3041),
    [sym_continue_statement] = ACTIONS(3041),
    [anon_sym_return] = ACTIONS(3041),
    [anon_sym_let] = ACTIONS(3041),
    [anon_sym_const] = ACTIONS(3041),
    [anon_sym_quote] = ACTIONS(3041),
    [anon_sym_using] = ACTIONS(3041),
    [anon_sym_import] = ACTIONS(3041),
    [anon_sym_export] = ACTIONS(3041),
    [anon_sym_COLON2] = ACTIONS(3041),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [anon_sym_begin] = ACTIONS(3041),
    [anon_sym_SQUOTE] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_LT_PIPE] = ACTIONS(3043),
    [anon_sym_PIPE_GT] = ACTIONS(3043),
    [anon_sym_in] = ACTIONS(3041),
    [anon_sym_isa] = ACTIONS(3041),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_EQ_GT] = ACTIONS(3043),
    [anon_sym_LBRACK2] = ACTIONS(3043),
    [anon_sym_DOLLAR] = ACTIONS(3041),
    [anon_sym_AT] = ACTIONS(3043),
    [aux_sym_integer_literal_token1] = ACTIONS(3043),
    [aux_sym_integer_literal_token2] = ACTIONS(3043),
    [aux_sym_integer_literal_token3] = ACTIONS(3041),
    [sym_float_literal] = ACTIONS(3041),
    [sym__unary_operator] = ACTIONS(3041),
    [sym__power_operator] = ACTIONS(3041),
    [sym__bitshift_operator] = ACTIONS(3041),
    [sym__rational_operator] = ACTIONS(3041),
    [sym__times_operator] = ACTIONS(3041),
    [sym__plus_operator] = ACTIONS(3041),
    [sym__dotty_operator] = ACTIONS(3041),
    [sym__comparison_operator] = ACTIONS(3041),
    [sym__arrow_operator] = ACTIONS(3043),
    [sym__assign_operator] = ACTIONS(3041),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3043),
    [sym__command_start] = ACTIONS(3043),
  },
  [1372] = {
    [sym_identifier] = ACTIONS(2931),
    [anon_sym_function] = ACTIONS(2931),
    [anon_sym_end] = ACTIONS(2931),
    [anon_sym_abstract] = ACTIONS(2931),
    [anon_sym_primitive] = ACTIONS(2931),
    [aux_sym_primitive_definition_token1] = ACTIONS(2931),
    [anon_sym_mutable] = ACTIONS(2931),
    [anon_sym_struct] = ACTIONS(2931),
    [anon_sym_module] = ACTIONS(2931),
    [anon_sym_macro] = ACTIONS(2931),
    [anon_sym_LPAREN] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2933),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2933),
    [anon_sym_COLON_COLON] = ACTIONS(2933),
    [anon_sym_RBRACE] = ACTIONS(2933),
    [anon_sym_LT_COLON] = ACTIONS(2933),
    [anon_sym_if] = ACTIONS(2931),
    [anon_sym_try] = ACTIONS(2931),
    [anon_sym_for] = ACTIONS(2931),
    [anon_sym_while] = ACTIONS(2931),
    [sym_break_statement] = ACTIONS(2931),
    [sym_continue_statement] = ACTIONS(2931),
    [anon_sym_return] = ACTIONS(2931),
    [anon_sym_let] = ACTIONS(2931),
    [anon_sym_const] = ACTIONS(2931),
    [anon_sym_quote] = ACTIONS(2931),
    [anon_sym_using] = ACTIONS(2931),
    [anon_sym_import] = ACTIONS(2931),
    [anon_sym_export] = ACTIONS(2931),
    [anon_sym_COLON2] = ACTIONS(2931),
    [anon_sym_RBRACK] = ACTIONS(2933),
    [anon_sym_begin] = ACTIONS(2931),
    [anon_sym_SQUOTE] = ACTIONS(2933),
    [anon_sym_PLUS] = ACTIONS(2931),
    [anon_sym_LT_PIPE] = ACTIONS(2933),
    [anon_sym_PIPE_GT] = ACTIONS(2933),
    [anon_sym_in] = ACTIONS(2931),
    [anon_sym_isa] = ACTIONS(2931),
    [anon_sym_PIPE_PIPE] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2933),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_EQ_GT] = ACTIONS(2933),
    [anon_sym_LBRACK2] = ACTIONS(2933),
    [anon_sym_DOLLAR] = ACTIONS(2931),
    [anon_sym_AT] = ACTIONS(2933),
    [aux_sym_integer_literal_token1] = ACTIONS(2933),
    [aux_sym_integer_literal_token2] = ACTIONS(2933),
    [aux_sym_integer_literal_token3] = ACTIONS(2931),
    [sym_float_literal] = ACTIONS(2931),
    [sym__unary_operator] = ACTIONS(2931),
    [sym__power_operator] = ACTIONS(2931),
    [sym__bitshift_operator] = ACTIONS(2931),
    [sym__rational_operator] = ACTIONS(2931),
    [sym__times_operator] = ACTIONS(2931),
    [sym__plus_operator] = ACTIONS(2931),
    [sym__dotty_operator] = ACTIONS(2931),
    [sym__comparison_operator] = ACTIONS(2931),
    [sym__arrow_operator] = ACTIONS(2933),
    [sym__assign_operator] = ACTIONS(2931),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2933),
    [sym__command_start] = ACTIONS(2933),
  },
  [1373] = {
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_end] = ACTIONS(2738),
    [anon_sym_abstract] = ACTIONS(2738),
    [anon_sym_primitive] = ACTIONS(2738),
    [aux_sym_primitive_definition_token1] = ACTIONS(2738),
    [anon_sym_mutable] = ACTIONS(2738),
    [anon_sym_struct] = ACTIONS(2738),
    [anon_sym_module] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2738),
    [anon_sym_COLON_COLON] = ACTIONS(2738),
    [anon_sym_LT_COLON] = ACTIONS(2738),
    [anon_sym_if] = ACTIONS(2738),
    [anon_sym_elseif] = ACTIONS(2738),
    [anon_sym_else] = ACTIONS(2738),
    [anon_sym_try] = ACTIONS(2738),
    [anon_sym_for] = ACTIONS(2738),
    [anon_sym_while] = ACTIONS(2738),
    [sym_break_statement] = ACTIONS(2738),
    [sym_continue_statement] = ACTIONS(2738),
    [anon_sym_return] = ACTIONS(2738),
    [anon_sym_let] = ACTIONS(2738),
    [anon_sym_const] = ACTIONS(2738),
    [anon_sym_quote] = ACTIONS(2738),
    [anon_sym_using] = ACTIONS(2738),
    [anon_sym_import] = ACTIONS(2738),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_DOT] = ACTIONS(2738),
    [anon_sym_export] = ACTIONS(2738),
    [anon_sym_COLON2] = ACTIONS(2738),
    [anon_sym_begin] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [anon_sym_PLUS] = ACTIONS(2738),
    [anon_sym_LT_PIPE] = ACTIONS(2738),
    [anon_sym_PIPE_GT] = ACTIONS(2738),
    [anon_sym_in] = ACTIONS(2738),
    [anon_sym_isa] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_QMARK] = ACTIONS(2738),
    [anon_sym_EQ_GT] = ACTIONS(2738),
    [anon_sym_LBRACK2] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(2738),
    [anon_sym_AT] = ACTIONS(2738),
    [aux_sym_integer_literal_token1] = ACTIONS(2738),
    [aux_sym_integer_literal_token2] = ACTIONS(2738),
    [aux_sym_integer_literal_token3] = ACTIONS(2738),
    [sym_float_literal] = ACTIONS(2738),
    [sym__unary_operator] = ACTIONS(2738),
    [sym__power_operator] = ACTIONS(2738),
    [sym__bitshift_operator] = ACTIONS(2738),
    [sym__rational_operator] = ACTIONS(2738),
    [sym__times_operator] = ACTIONS(2738),
    [sym__plus_operator] = ACTIONS(2738),
    [sym__dotty_operator] = ACTIONS(2738),
    [sym__comparison_operator] = ACTIONS(2738),
    [sym__arrow_operator] = ACTIONS(2738),
    [anon_sym_LF] = ACTIONS(2740),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2740),
    [sym__command_start] = ACTIONS(2740),
  },
  [1374] = {
    [sym_identifier] = ACTIONS(2939),
    [anon_sym_function] = ACTIONS(2939),
    [anon_sym_end] = ACTIONS(2939),
    [anon_sym_abstract] = ACTIONS(2939),
    [anon_sym_primitive] = ACTIONS(2939),
    [aux_sym_primitive_definition_token1] = ACTIONS(2939),
    [anon_sym_mutable] = ACTIONS(2939),
    [anon_sym_struct] = ACTIONS(2939),
    [anon_sym_module] = ACTIONS(2939),
    [anon_sym_macro] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2941),
    [anon_sym_COMMA] = ACTIONS(2941),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2941),
    [anon_sym_EQ] = ACTIONS(2939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2941),
    [anon_sym_COLON_COLON] = ACTIONS(2941),
    [anon_sym_RBRACE] = ACTIONS(2941),
    [anon_sym_LT_COLON] = ACTIONS(2941),
    [anon_sym_if] = ACTIONS(2939),
    [anon_sym_try] = ACTIONS(2939),
    [anon_sym_for] = ACTIONS(2939),
    [anon_sym_while] = ACTIONS(2939),
    [sym_break_statement] = ACTIONS(2939),
    [sym_continue_statement] = ACTIONS(2939),
    [anon_sym_return] = ACTIONS(2939),
    [anon_sym_let] = ACTIONS(2939),
    [anon_sym_const] = ACTIONS(2939),
    [anon_sym_quote] = ACTIONS(2939),
    [anon_sym_using] = ACTIONS(2939),
    [anon_sym_import] = ACTIONS(2939),
    [anon_sym_export] = ACTIONS(2939),
    [anon_sym_COLON2] = ACTIONS(2939),
    [anon_sym_RBRACK] = ACTIONS(2941),
    [anon_sym_begin] = ACTIONS(2939),
    [anon_sym_SQUOTE] = ACTIONS(2941),
    [anon_sym_PLUS] = ACTIONS(2939),
    [anon_sym_LT_PIPE] = ACTIONS(2941),
    [anon_sym_PIPE_GT] = ACTIONS(2941),
    [anon_sym_in] = ACTIONS(2939),
    [anon_sym_isa] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2941),
    [anon_sym_QMARK] = ACTIONS(2941),
    [anon_sym_EQ_GT] = ACTIONS(2941),
    [anon_sym_LBRACK2] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(2939),
    [anon_sym_AT] = ACTIONS(2941),
    [aux_sym_integer_literal_token1] = ACTIONS(2941),
    [aux_sym_integer_literal_token2] = ACTIONS(2941),
    [aux_sym_integer_literal_token3] = ACTIONS(2939),
    [sym_float_literal] = ACTIONS(2939),
    [sym__unary_operator] = ACTIONS(2939),
    [sym__power_operator] = ACTIONS(2939),
    [sym__bitshift_operator] = ACTIONS(2939),
    [sym__rational_operator] = ACTIONS(2939),
    [sym__times_operator] = ACTIONS(2939),
    [sym__plus_operator] = ACTIONS(2939),
    [sym__dotty_operator] = ACTIONS(2939),
    [sym__comparison_operator] = ACTIONS(2939),
    [sym__arrow_operator] = ACTIONS(2941),
    [sym__assign_operator] = ACTIONS(2939),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2941),
    [sym__command_start] = ACTIONS(2941),
  },
  [1375] = {
    [sym_identifier] = ACTIONS(2943),
    [anon_sym_function] = ACTIONS(2943),
    [anon_sym_end] = ACTIONS(2943),
    [anon_sym_abstract] = ACTIONS(2943),
    [anon_sym_primitive] = ACTIONS(2943),
    [aux_sym_primitive_definition_token1] = ACTIONS(2943),
    [anon_sym_mutable] = ACTIONS(2943),
    [anon_sym_struct] = ACTIONS(2943),
    [anon_sym_module] = ACTIONS(2943),
    [anon_sym_macro] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2945),
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2945),
    [anon_sym_COLON_COLON] = ACTIONS(2945),
    [anon_sym_RBRACE] = ACTIONS(2945),
    [anon_sym_LT_COLON] = ACTIONS(2945),
    [anon_sym_if] = ACTIONS(2943),
    [anon_sym_try] = ACTIONS(2943),
    [anon_sym_for] = ACTIONS(2943),
    [anon_sym_while] = ACTIONS(2943),
    [sym_break_statement] = ACTIONS(2943),
    [sym_continue_statement] = ACTIONS(2943),
    [anon_sym_return] = ACTIONS(2943),
    [anon_sym_let] = ACTIONS(2943),
    [anon_sym_const] = ACTIONS(2943),
    [anon_sym_quote] = ACTIONS(2943),
    [anon_sym_using] = ACTIONS(2943),
    [anon_sym_import] = ACTIONS(2943),
    [anon_sym_export] = ACTIONS(2943),
    [anon_sym_COLON2] = ACTIONS(2943),
    [anon_sym_RBRACK] = ACTIONS(2945),
    [anon_sym_begin] = ACTIONS(2943),
    [anon_sym_SQUOTE] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2943),
    [anon_sym_LT_PIPE] = ACTIONS(2945),
    [anon_sym_PIPE_GT] = ACTIONS(2945),
    [anon_sym_in] = ACTIONS(2943),
    [anon_sym_isa] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_QMARK] = ACTIONS(2945),
    [anon_sym_EQ_GT] = ACTIONS(2945),
    [anon_sym_LBRACK2] = ACTIONS(2945),
    [anon_sym_DOLLAR] = ACTIONS(2943),
    [anon_sym_AT] = ACTIONS(2945),
    [aux_sym_integer_literal_token1] = ACTIONS(2945),
    [aux_sym_integer_literal_token2] = ACTIONS(2945),
    [aux_sym_integer_literal_token3] = ACTIONS(2943),
    [sym_float_literal] = ACTIONS(2943),
    [sym__unary_operator] = ACTIONS(2943),
    [sym__power_operator] = ACTIONS(2943),
    [sym__bitshift_operator] = ACTIONS(2943),
    [sym__rational_operator] = ACTIONS(2943),
    [sym__times_operator] = ACTIONS(2943),
    [sym__plus_operator] = ACTIONS(2943),
    [sym__dotty_operator] = ACTIONS(2943),
    [sym__comparison_operator] = ACTIONS(2943),
    [sym__arrow_operator] = ACTIONS(2945),
    [sym__assign_operator] = ACTIONS(2943),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2945),
    [sym__command_start] = ACTIONS(2945),
  },
  [1376] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1377] = {
    [ts_builtin_sym_end] = ACTIONS(2736),
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(2734),
    [anon_sym_abstract] = ACTIONS(2734),
    [anon_sym_primitive] = ACTIONS(2734),
    [aux_sym_primitive_definition_token1] = ACTIONS(2734),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2734),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_macro] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2734),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2734),
    [anon_sym_LT_COLON] = ACTIONS(2734),
    [anon_sym_if] = ACTIONS(2734),
    [anon_sym_try] = ACTIONS(2734),
    [anon_sym_for] = ACTIONS(2734),
    [anon_sym_while] = ACTIONS(2734),
    [sym_break_statement] = ACTIONS(2734),
    [sym_continue_statement] = ACTIONS(2734),
    [anon_sym_return] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_const] = ACTIONS(2734),
    [anon_sym_quote] = ACTIONS(2734),
    [anon_sym_using] = ACTIONS(2734),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_COLON2] = ACTIONS(2734),
    [anon_sym_begin] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2734),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_LT_PIPE] = ACTIONS(2734),
    [anon_sym_PIPE_GT] = ACTIONS(2734),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_isa] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2734),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_EQ_GT] = ACTIONS(2734),
    [anon_sym_LBRACK2] = ACTIONS(2734),
    [anon_sym_DOLLAR] = ACTIONS(2734),
    [anon_sym_AT] = ACTIONS(2734),
    [aux_sym_integer_literal_token1] = ACTIONS(2734),
    [aux_sym_integer_literal_token2] = ACTIONS(2734),
    [aux_sym_integer_literal_token3] = ACTIONS(2734),
    [sym_float_literal] = ACTIONS(2734),
    [sym__unary_operator] = ACTIONS(2734),
    [sym__power_operator] = ACTIONS(2734),
    [sym__bitshift_operator] = ACTIONS(2734),
    [sym__rational_operator] = ACTIONS(2734),
    [sym__times_operator] = ACTIONS(2734),
    [sym__plus_operator] = ACTIONS(2734),
    [sym__dotty_operator] = ACTIONS(2734),
    [sym__comparison_operator] = ACTIONS(2734),
    [sym__arrow_operator] = ACTIONS(2734),
    [sym__assign_operator] = ACTIONS(2734),
    [anon_sym_LF] = ACTIONS(2736),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2736),
    [sym__command_start] = ACTIONS(2736),
  },
  [1378] = {
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2744),
    [anon_sym_LT_COLON] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(3311),
    [anon_sym_DOT] = ACTIONS(3313),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2744),
    [anon_sym_PIPE_GT] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_LBRACK2] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [aux_sym_integer_literal_token1] = ACTIONS(2744),
    [aux_sym_integer_literal_token2] = ACTIONS(2744),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2744),
    [sym__assign_operator] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1379] = {
    [sym_identifier] = ACTIONS(2947),
    [anon_sym_function] = ACTIONS(2947),
    [anon_sym_end] = ACTIONS(2947),
    [anon_sym_abstract] = ACTIONS(2947),
    [anon_sym_primitive] = ACTIONS(2947),
    [aux_sym_primitive_definition_token1] = ACTIONS(2947),
    [anon_sym_mutable] = ACTIONS(2947),
    [anon_sym_struct] = ACTIONS(2947),
    [anon_sym_module] = ACTIONS(2947),
    [anon_sym_macro] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2949),
    [anon_sym_RPAREN] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2949),
    [anon_sym_COLON_COLON] = ACTIONS(2949),
    [anon_sym_RBRACE] = ACTIONS(2949),
    [anon_sym_LT_COLON] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_try] = ACTIONS(2947),
    [anon_sym_for] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [sym_break_statement] = ACTIONS(2947),
    [sym_continue_statement] = ACTIONS(2947),
    [anon_sym_return] = ACTIONS(2947),
    [anon_sym_let] = ACTIONS(2947),
    [anon_sym_const] = ACTIONS(2947),
    [anon_sym_quote] = ACTIONS(2947),
    [anon_sym_using] = ACTIONS(2947),
    [anon_sym_import] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2949),
    [anon_sym_begin] = ACTIONS(2947),
    [anon_sym_SQUOTE] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_LT_PIPE] = ACTIONS(2949),
    [anon_sym_PIPE_GT] = ACTIONS(2949),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_isa] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_QMARK] = ACTIONS(2949),
    [anon_sym_EQ_GT] = ACTIONS(2949),
    [anon_sym_LBRACK2] = ACTIONS(2949),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [anon_sym_AT] = ACTIONS(2949),
    [aux_sym_integer_literal_token1] = ACTIONS(2949),
    [aux_sym_integer_literal_token2] = ACTIONS(2949),
    [aux_sym_integer_literal_token3] = ACTIONS(2947),
    [sym_float_literal] = ACTIONS(2947),
    [sym__unary_operator] = ACTIONS(2947),
    [sym__power_operator] = ACTIONS(2947),
    [sym__bitshift_operator] = ACTIONS(2947),
    [sym__rational_operator] = ACTIONS(2947),
    [sym__times_operator] = ACTIONS(2947),
    [sym__plus_operator] = ACTIONS(2947),
    [sym__dotty_operator] = ACTIONS(2947),
    [sym__comparison_operator] = ACTIONS(2947),
    [sym__arrow_operator] = ACTIONS(2949),
    [sym__assign_operator] = ACTIONS(2947),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2949),
    [sym__command_start] = ACTIONS(2949),
  },
  [1380] = {
    [sym_identifier] = ACTIONS(2955),
    [anon_sym_function] = ACTIONS(2955),
    [anon_sym_end] = ACTIONS(2955),
    [anon_sym_abstract] = ACTIONS(2955),
    [anon_sym_primitive] = ACTIONS(2955),
    [aux_sym_primitive_definition_token1] = ACTIONS(2955),
    [anon_sym_mutable] = ACTIONS(2955),
    [anon_sym_struct] = ACTIONS(2955),
    [anon_sym_module] = ACTIONS(2955),
    [anon_sym_macro] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2957),
    [anon_sym_RPAREN] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2957),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2957),
    [anon_sym_COLON_COLON] = ACTIONS(2957),
    [anon_sym_RBRACE] = ACTIONS(2957),
    [anon_sym_LT_COLON] = ACTIONS(2957),
    [anon_sym_if] = ACTIONS(2955),
    [anon_sym_try] = ACTIONS(2955),
    [anon_sym_for] = ACTIONS(2955),
    [anon_sym_while] = ACTIONS(2955),
    [sym_break_statement] = ACTIONS(2955),
    [sym_continue_statement] = ACTIONS(2955),
    [anon_sym_return] = ACTIONS(2955),
    [anon_sym_let] = ACTIONS(2955),
    [anon_sym_const] = ACTIONS(2955),
    [anon_sym_quote] = ACTIONS(2955),
    [anon_sym_using] = ACTIONS(2955),
    [anon_sym_import] = ACTIONS(2955),
    [anon_sym_export] = ACTIONS(2955),
    [anon_sym_COLON2] = ACTIONS(2955),
    [anon_sym_RBRACK] = ACTIONS(2957),
    [anon_sym_begin] = ACTIONS(2955),
    [anon_sym_SQUOTE] = ACTIONS(2957),
    [anon_sym_PLUS] = ACTIONS(2955),
    [anon_sym_LT_PIPE] = ACTIONS(2957),
    [anon_sym_PIPE_GT] = ACTIONS(2957),
    [anon_sym_in] = ACTIONS(2955),
    [anon_sym_isa] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_EQ_GT] = ACTIONS(2957),
    [anon_sym_LBRACK2] = ACTIONS(2957),
    [anon_sym_DOLLAR] = ACTIONS(2955),
    [anon_sym_AT] = ACTIONS(2957),
    [aux_sym_integer_literal_token1] = ACTIONS(2957),
    [aux_sym_integer_literal_token2] = ACTIONS(2957),
    [aux_sym_integer_literal_token3] = ACTIONS(2955),
    [sym_float_literal] = ACTIONS(2955),
    [sym__unary_operator] = ACTIONS(2955),
    [sym__power_operator] = ACTIONS(2955),
    [sym__bitshift_operator] = ACTIONS(2955),
    [sym__rational_operator] = ACTIONS(2955),
    [sym__times_operator] = ACTIONS(2955),
    [sym__plus_operator] = ACTIONS(2955),
    [sym__dotty_operator] = ACTIONS(2955),
    [sym__comparison_operator] = ACTIONS(2955),
    [sym__arrow_operator] = ACTIONS(2957),
    [sym__assign_operator] = ACTIONS(2955),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2957),
    [sym__command_start] = ACTIONS(2957),
  },
  [1381] = {
    [sym_identifier] = ACTIONS(2923),
    [anon_sym_function] = ACTIONS(2923),
    [anon_sym_end] = ACTIONS(2923),
    [anon_sym_abstract] = ACTIONS(2923),
    [anon_sym_primitive] = ACTIONS(2923),
    [aux_sym_primitive_definition_token1] = ACTIONS(2923),
    [anon_sym_mutable] = ACTIONS(2923),
    [anon_sym_struct] = ACTIONS(2923),
    [anon_sym_module] = ACTIONS(2923),
    [anon_sym_macro] = ACTIONS(2923),
    [anon_sym_LPAREN] = ACTIONS(2925),
    [anon_sym_COMMA] = ACTIONS(2925),
    [anon_sym_RPAREN] = ACTIONS(2925),
    [anon_sym_SEMI] = ACTIONS(2925),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2925),
    [anon_sym_COLON_COLON] = ACTIONS(2925),
    [anon_sym_RBRACE] = ACTIONS(2925),
    [anon_sym_LT_COLON] = ACTIONS(2925),
    [anon_sym_if] = ACTIONS(2923),
    [anon_sym_try] = ACTIONS(2923),
    [anon_sym_for] = ACTIONS(2923),
    [anon_sym_while] = ACTIONS(2923),
    [sym_break_statement] = ACTIONS(2923),
    [sym_continue_statement] = ACTIONS(2923),
    [anon_sym_return] = ACTIONS(2923),
    [anon_sym_let] = ACTIONS(2923),
    [anon_sym_const] = ACTIONS(2923),
    [anon_sym_quote] = ACTIONS(2923),
    [anon_sym_using] = ACTIONS(2923),
    [anon_sym_import] = ACTIONS(2923),
    [anon_sym_export] = ACTIONS(2923),
    [anon_sym_COLON2] = ACTIONS(2923),
    [anon_sym_RBRACK] = ACTIONS(2925),
    [anon_sym_begin] = ACTIONS(2923),
    [anon_sym_SQUOTE] = ACTIONS(2925),
    [anon_sym_PLUS] = ACTIONS(2923),
    [anon_sym_LT_PIPE] = ACTIONS(2925),
    [anon_sym_PIPE_GT] = ACTIONS(2925),
    [anon_sym_in] = ACTIONS(2923),
    [anon_sym_isa] = ACTIONS(2923),
    [anon_sym_PIPE_PIPE] = ACTIONS(2925),
    [anon_sym_AMP_AMP] = ACTIONS(2925),
    [anon_sym_QMARK] = ACTIONS(2925),
    [anon_sym_EQ_GT] = ACTIONS(2925),
    [anon_sym_LBRACK2] = ACTIONS(2925),
    [anon_sym_DOLLAR] = ACTIONS(2923),
    [anon_sym_AT] = ACTIONS(2925),
    [aux_sym_integer_literal_token1] = ACTIONS(2925),
    [aux_sym_integer_literal_token2] = ACTIONS(2925),
    [aux_sym_integer_literal_token3] = ACTIONS(2923),
    [sym_float_literal] = ACTIONS(2923),
    [sym__unary_operator] = ACTIONS(2923),
    [sym__power_operator] = ACTIONS(2923),
    [sym__bitshift_operator] = ACTIONS(2923),
    [sym__rational_operator] = ACTIONS(2923),
    [sym__times_operator] = ACTIONS(2923),
    [sym__plus_operator] = ACTIONS(2923),
    [sym__dotty_operator] = ACTIONS(2923),
    [sym__comparison_operator] = ACTIONS(2923),
    [sym__arrow_operator] = ACTIONS(2925),
    [sym__assign_operator] = ACTIONS(2923),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2925),
    [sym__command_start] = ACTIONS(2925),
  },
  [1382] = {
    [sym_identifier] = ACTIONS(2963),
    [anon_sym_function] = ACTIONS(2963),
    [anon_sym_end] = ACTIONS(2963),
    [anon_sym_abstract] = ACTIONS(2963),
    [anon_sym_primitive] = ACTIONS(2963),
    [aux_sym_primitive_definition_token1] = ACTIONS(2963),
    [anon_sym_mutable] = ACTIONS(2963),
    [anon_sym_struct] = ACTIONS(2963),
    [anon_sym_module] = ACTIONS(2963),
    [anon_sym_macro] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2965),
    [anon_sym_RPAREN] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2965),
    [anon_sym_COLON_COLON] = ACTIONS(2965),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_LT_COLON] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_try] = ACTIONS(2963),
    [anon_sym_for] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [sym_break_statement] = ACTIONS(2963),
    [sym_continue_statement] = ACTIONS(2963),
    [anon_sym_return] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_const] = ACTIONS(2963),
    [anon_sym_quote] = ACTIONS(2963),
    [anon_sym_using] = ACTIONS(2963),
    [anon_sym_import] = ACTIONS(2963),
    [anon_sym_export] = ACTIONS(2963),
    [anon_sym_COLON2] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2965),
    [anon_sym_begin] = ACTIONS(2963),
    [anon_sym_SQUOTE] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_LT_PIPE] = ACTIONS(2965),
    [anon_sym_PIPE_GT] = ACTIONS(2965),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_isa] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2965),
    [anon_sym_QMARK] = ACTIONS(2965),
    [anon_sym_EQ_GT] = ACTIONS(2965),
    [anon_sym_LBRACK2] = ACTIONS(2965),
    [anon_sym_DOLLAR] = ACTIONS(2963),
    [anon_sym_AT] = ACTIONS(2965),
    [aux_sym_integer_literal_token1] = ACTIONS(2965),
    [aux_sym_integer_literal_token2] = ACTIONS(2965),
    [aux_sym_integer_literal_token3] = ACTIONS(2963),
    [sym_float_literal] = ACTIONS(2963),
    [sym__unary_operator] = ACTIONS(2963),
    [sym__power_operator] = ACTIONS(2963),
    [sym__bitshift_operator] = ACTIONS(2963),
    [sym__rational_operator] = ACTIONS(2963),
    [sym__times_operator] = ACTIONS(2963),
    [sym__plus_operator] = ACTIONS(2963),
    [sym__dotty_operator] = ACTIONS(2963),
    [sym__comparison_operator] = ACTIONS(2963),
    [sym__arrow_operator] = ACTIONS(2965),
    [sym__assign_operator] = ACTIONS(2963),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2965),
    [sym__command_start] = ACTIONS(2965),
  },
  [1383] = {
    [sym_identifier] = ACTIONS(2983),
    [anon_sym_function] = ACTIONS(2983),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_abstract] = ACTIONS(2983),
    [anon_sym_primitive] = ACTIONS(2983),
    [aux_sym_primitive_definition_token1] = ACTIONS(2983),
    [anon_sym_mutable] = ACTIONS(2983),
    [anon_sym_struct] = ACTIONS(2983),
    [anon_sym_module] = ACTIONS(2983),
    [anon_sym_macro] = ACTIONS(2983),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2985),
    [anon_sym_RPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2985),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_try] = ACTIONS(2983),
    [anon_sym_for] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [sym_break_statement] = ACTIONS(2983),
    [sym_continue_statement] = ACTIONS(2983),
    [anon_sym_return] = ACTIONS(2983),
    [anon_sym_let] = ACTIONS(2983),
    [anon_sym_const] = ACTIONS(2983),
    [anon_sym_quote] = ACTIONS(2983),
    [anon_sym_using] = ACTIONS(2983),
    [anon_sym_import] = ACTIONS(2983),
    [anon_sym_export] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2985),
    [anon_sym_begin] = ACTIONS(2983),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_LT_PIPE] = ACTIONS(2985),
    [anon_sym_PIPE_GT] = ACTIONS(2985),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_isa] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_QMARK] = ACTIONS(2985),
    [anon_sym_EQ_GT] = ACTIONS(2985),
    [anon_sym_LBRACK2] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2983),
    [anon_sym_AT] = ACTIONS(2985),
    [aux_sym_integer_literal_token1] = ACTIONS(2985),
    [aux_sym_integer_literal_token2] = ACTIONS(2985),
    [aux_sym_integer_literal_token3] = ACTIONS(2983),
    [sym_float_literal] = ACTIONS(2983),
    [sym__unary_operator] = ACTIONS(2983),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(2983),
    [sym__dotty_operator] = ACTIONS(2983),
    [sym__comparison_operator] = ACTIONS(2983),
    [sym__arrow_operator] = ACTIONS(2985),
    [sym__assign_operator] = ACTIONS(2983),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2985),
    [sym__command_start] = ACTIONS(2985),
  },
  [1384] = {
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_function] = ACTIONS(3113),
    [anon_sym_end] = ACTIONS(3113),
    [anon_sym_abstract] = ACTIONS(3113),
    [anon_sym_primitive] = ACTIONS(3113),
    [aux_sym_primitive_definition_token1] = ACTIONS(3113),
    [anon_sym_mutable] = ACTIONS(3113),
    [anon_sym_struct] = ACTIONS(3113),
    [anon_sym_module] = ACTIONS(3113),
    [anon_sym_macro] = ACTIONS(3113),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3113),
    [anon_sym_try] = ACTIONS(3113),
    [anon_sym_for] = ACTIONS(3113),
    [anon_sym_while] = ACTIONS(3113),
    [sym_break_statement] = ACTIONS(3113),
    [sym_continue_statement] = ACTIONS(3113),
    [anon_sym_return] = ACTIONS(3113),
    [anon_sym_let] = ACTIONS(3113),
    [anon_sym_const] = ACTIONS(3113),
    [anon_sym_quote] = ACTIONS(3113),
    [anon_sym_using] = ACTIONS(3113),
    [anon_sym_import] = ACTIONS(3113),
    [anon_sym_export] = ACTIONS(3113),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(3115),
    [anon_sym_begin] = ACTIONS(3113),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3115),
    [anon_sym_PIPE_GT] = ACTIONS(3115),
    [anon_sym_in] = ACTIONS(3113),
    [anon_sym_isa] = ACTIONS(3113),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_EQ_GT] = ACTIONS(3115),
    [anon_sym_LBRACK2] = ACTIONS(3115),
    [anon_sym_DOLLAR] = ACTIONS(3113),
    [anon_sym_AT] = ACTIONS(3115),
    [aux_sym_integer_literal_token1] = ACTIONS(3115),
    [aux_sym_integer_literal_token2] = ACTIONS(3115),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [sym_float_literal] = ACTIONS(3113),
    [sym__unary_operator] = ACTIONS(3113),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3113),
    [sym__arrow_operator] = ACTIONS(3115),
    [sym__assign_operator] = ACTIONS(3113),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3115),
    [sym__command_start] = ACTIONS(3115),
  },
  [1385] = {
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_end] = ACTIONS(3119),
    [anon_sym_abstract] = ACTIONS(3119),
    [anon_sym_primitive] = ACTIONS(3119),
    [aux_sym_primitive_definition_token1] = ACTIONS(3119),
    [anon_sym_mutable] = ACTIONS(3119),
    [anon_sym_struct] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_macro] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3191),
    [anon_sym_COMMA] = ACTIONS(3191),
    [anon_sym_RPAREN] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(3191),
    [anon_sym_EQ] = ACTIONS(3119),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3191),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [sym_break_statement] = ACTIONS(3119),
    [sym_continue_statement] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_const] = ACTIONS(3119),
    [anon_sym_quote] = ACTIONS(3119),
    [anon_sym_using] = ACTIONS(3119),
    [anon_sym_import] = ACTIONS(3119),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_COLON2] = ACTIONS(3119),
    [anon_sym_RBRACK] = ACTIONS(3191),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3191),
    [anon_sym_PIPE_GT] = ACTIONS(3191),
    [anon_sym_in] = ACTIONS(3119),
    [anon_sym_isa] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3191),
    [anon_sym_AMP_AMP] = ACTIONS(3191),
    [anon_sym_QMARK] = ACTIONS(3191),
    [anon_sym_EQ_GT] = ACTIONS(3191),
    [anon_sym_LBRACK2] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3191),
    [aux_sym_integer_literal_token1] = ACTIONS(3191),
    [aux_sym_integer_literal_token2] = ACTIONS(3191),
    [aux_sym_integer_literal_token3] = ACTIONS(3119),
    [sym_float_literal] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3119),
    [sym__comparison_operator] = ACTIONS(3119),
    [sym__arrow_operator] = ACTIONS(3191),
    [sym__assign_operator] = ACTIONS(3119),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3191),
    [sym__command_start] = ACTIONS(3191),
  },
  [1386] = {
    [sym_identifier] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(2538),
    [anon_sym_end] = ACTIONS(2538),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_primitive] = ACTIONS(2538),
    [aux_sym_primitive_definition_token1] = ACTIONS(2538),
    [anon_sym_mutable] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_module] = ACTIONS(2538),
    [anon_sym_macro] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2540),
    [anon_sym_COMMA] = ACTIONS(2540),
    [anon_sym_RPAREN] = ACTIONS(2540),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_EQ] = ACTIONS(2538),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2540),
    [anon_sym_COLON_COLON] = ACTIONS(2540),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_LT_COLON] = ACTIONS(2540),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [sym_break_statement] = ACTIONS(2538),
    [sym_continue_statement] = ACTIONS(2538),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_quote] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_import] = ACTIONS(2538),
    [anon_sym_export] = ACTIONS(2538),
    [anon_sym_COLON2] = ACTIONS(2538),
    [anon_sym_RBRACK] = ACTIONS(2540),
    [anon_sym_begin] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_LT_PIPE] = ACTIONS(2540),
    [anon_sym_PIPE_GT] = ACTIONS(2540),
    [anon_sym_in] = ACTIONS(2538),
    [anon_sym_isa] = ACTIONS(2538),
    [anon_sym_PIPE_PIPE] = ACTIONS(2540),
    [anon_sym_AMP_AMP] = ACTIONS(2540),
    [anon_sym_QMARK] = ACTIONS(2540),
    [anon_sym_EQ_GT] = ACTIONS(2540),
    [anon_sym_LBRACK2] = ACTIONS(2540),
    [anon_sym_DOLLAR] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(2540),
    [aux_sym_integer_literal_token1] = ACTIONS(2540),
    [aux_sym_integer_literal_token2] = ACTIONS(2540),
    [aux_sym_integer_literal_token3] = ACTIONS(2538),
    [sym_float_literal] = ACTIONS(2538),
    [sym__unary_operator] = ACTIONS(2538),
    [sym__power_operator] = ACTIONS(2538),
    [sym__bitshift_operator] = ACTIONS(2538),
    [sym__rational_operator] = ACTIONS(2538),
    [sym__times_operator] = ACTIONS(2538),
    [sym__plus_operator] = ACTIONS(2538),
    [sym__dotty_operator] = ACTIONS(2538),
    [sym__comparison_operator] = ACTIONS(2538),
    [sym__arrow_operator] = ACTIONS(2540),
    [sym__assign_operator] = ACTIONS(2538),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2540),
    [sym__command_start] = ACTIONS(2540),
  },
  [1387] = {
    [sym_parenthesized_expression] = STATE(1684),
    [sym_identifier] = ACTIONS(3346),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2750),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_LT_COLON] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_elseif] = ACTIONS(2750),
    [anon_sym_else] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2750),
    [anon_sym_PIPE_GT] = ACTIONS(2750),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2750),
    [anon_sym_AMP_AMP] = ACTIONS(2750),
    [anon_sym_QMARK] = ACTIONS(2750),
    [anon_sym_EQ_GT] = ACTIONS(2750),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2750),
    [aux_sym_integer_literal_token1] = ACTIONS(2750),
    [aux_sym_integer_literal_token2] = ACTIONS(2750),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2750),
    [anon_sym_LF] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1388] = {
    [sym_identifier] = ACTIONS(2987),
    [anon_sym_function] = ACTIONS(2987),
    [anon_sym_end] = ACTIONS(2987),
    [anon_sym_abstract] = ACTIONS(2987),
    [anon_sym_primitive] = ACTIONS(2987),
    [aux_sym_primitive_definition_token1] = ACTIONS(2987),
    [anon_sym_mutable] = ACTIONS(2987),
    [anon_sym_struct] = ACTIONS(2987),
    [anon_sym_module] = ACTIONS(2987),
    [anon_sym_macro] = ACTIONS(2987),
    [anon_sym_LPAREN] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2989),
    [anon_sym_RPAREN] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2989),
    [anon_sym_COLON_COLON] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2989),
    [anon_sym_LT_COLON] = ACTIONS(2989),
    [anon_sym_if] = ACTIONS(2987),
    [anon_sym_try] = ACTIONS(2987),
    [anon_sym_for] = ACTIONS(2987),
    [anon_sym_while] = ACTIONS(2987),
    [sym_break_statement] = ACTIONS(2987),
    [sym_continue_statement] = ACTIONS(2987),
    [anon_sym_return] = ACTIONS(2987),
    [anon_sym_let] = ACTIONS(2987),
    [anon_sym_const] = ACTIONS(2987),
    [anon_sym_quote] = ACTIONS(2987),
    [anon_sym_using] = ACTIONS(2987),
    [anon_sym_import] = ACTIONS(2987),
    [anon_sym_export] = ACTIONS(2987),
    [anon_sym_COLON2] = ACTIONS(2987),
    [anon_sym_RBRACK] = ACTIONS(2989),
    [anon_sym_begin] = ACTIONS(2987),
    [anon_sym_SQUOTE] = ACTIONS(2989),
    [anon_sym_PLUS] = ACTIONS(2987),
    [anon_sym_LT_PIPE] = ACTIONS(2989),
    [anon_sym_PIPE_GT] = ACTIONS(2989),
    [anon_sym_in] = ACTIONS(2987),
    [anon_sym_isa] = ACTIONS(2987),
    [anon_sym_PIPE_PIPE] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_EQ_GT] = ACTIONS(2989),
    [anon_sym_LBRACK2] = ACTIONS(2989),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [anon_sym_AT] = ACTIONS(2989),
    [aux_sym_integer_literal_token1] = ACTIONS(2989),
    [aux_sym_integer_literal_token2] = ACTIONS(2989),
    [aux_sym_integer_literal_token3] = ACTIONS(2987),
    [sym_float_literal] = ACTIONS(2987),
    [sym__unary_operator] = ACTIONS(2987),
    [sym__power_operator] = ACTIONS(2987),
    [sym__bitshift_operator] = ACTIONS(2987),
    [sym__rational_operator] = ACTIONS(2987),
    [sym__times_operator] = ACTIONS(2987),
    [sym__plus_operator] = ACTIONS(2987),
    [sym__dotty_operator] = ACTIONS(2987),
    [sym__comparison_operator] = ACTIONS(2987),
    [sym__arrow_operator] = ACTIONS(2989),
    [sym__assign_operator] = ACTIONS(2987),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2989),
    [sym__command_start] = ACTIONS(2989),
  },
  [1389] = {
    [sym_identifier] = ACTIONS(2991),
    [anon_sym_function] = ACTIONS(2991),
    [anon_sym_end] = ACTIONS(2991),
    [anon_sym_abstract] = ACTIONS(2991),
    [anon_sym_primitive] = ACTIONS(2991),
    [aux_sym_primitive_definition_token1] = ACTIONS(2991),
    [anon_sym_mutable] = ACTIONS(2991),
    [anon_sym_struct] = ACTIONS(2991),
    [anon_sym_module] = ACTIONS(2991),
    [anon_sym_macro] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2991),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2993),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_LT_COLON] = ACTIONS(2993),
    [anon_sym_if] = ACTIONS(2991),
    [anon_sym_try] = ACTIONS(2991),
    [anon_sym_for] = ACTIONS(2991),
    [anon_sym_while] = ACTIONS(2991),
    [sym_break_statement] = ACTIONS(2991),
    [sym_continue_statement] = ACTIONS(2991),
    [anon_sym_return] = ACTIONS(2991),
    [anon_sym_let] = ACTIONS(2991),
    [anon_sym_const] = ACTIONS(2991),
    [anon_sym_quote] = ACTIONS(2991),
    [anon_sym_using] = ACTIONS(2991),
    [anon_sym_import] = ACTIONS(2991),
    [anon_sym_export] = ACTIONS(2991),
    [anon_sym_COLON2] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2993),
    [anon_sym_begin] = ACTIONS(2991),
    [anon_sym_SQUOTE] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2991),
    [anon_sym_LT_PIPE] = ACTIONS(2993),
    [anon_sym_PIPE_GT] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2991),
    [anon_sym_isa] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2993),
    [anon_sym_EQ_GT] = ACTIONS(2993),
    [anon_sym_LBRACK2] = ACTIONS(2993),
    [anon_sym_DOLLAR] = ACTIONS(2991),
    [anon_sym_AT] = ACTIONS(2993),
    [aux_sym_integer_literal_token1] = ACTIONS(2993),
    [aux_sym_integer_literal_token2] = ACTIONS(2993),
    [aux_sym_integer_literal_token3] = ACTIONS(2991),
    [sym_float_literal] = ACTIONS(2991),
    [sym__unary_operator] = ACTIONS(2991),
    [sym__power_operator] = ACTIONS(2991),
    [sym__bitshift_operator] = ACTIONS(2991),
    [sym__rational_operator] = ACTIONS(2991),
    [sym__times_operator] = ACTIONS(2991),
    [sym__plus_operator] = ACTIONS(2991),
    [sym__dotty_operator] = ACTIONS(2991),
    [sym__comparison_operator] = ACTIONS(2991),
    [sym__arrow_operator] = ACTIONS(2993),
    [sym__assign_operator] = ACTIONS(2991),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2993),
    [sym__command_start] = ACTIONS(2993),
  },
  [1390] = {
    [sym_identifier] = ACTIONS(2999),
    [anon_sym_function] = ACTIONS(2999),
    [anon_sym_end] = ACTIONS(2999),
    [anon_sym_abstract] = ACTIONS(2999),
    [anon_sym_primitive] = ACTIONS(2999),
    [aux_sym_primitive_definition_token1] = ACTIONS(2999),
    [anon_sym_mutable] = ACTIONS(2999),
    [anon_sym_struct] = ACTIONS(2999),
    [anon_sym_module] = ACTIONS(2999),
    [anon_sym_macro] = ACTIONS(2999),
    [anon_sym_LPAREN] = ACTIONS(3001),
    [anon_sym_COMMA] = ACTIONS(3001),
    [anon_sym_RPAREN] = ACTIONS(3001),
    [anon_sym_SEMI] = ACTIONS(3001),
    [anon_sym_EQ] = ACTIONS(2999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3001),
    [anon_sym_COLON_COLON] = ACTIONS(3001),
    [anon_sym_RBRACE] = ACTIONS(3001),
    [anon_sym_LT_COLON] = ACTIONS(3001),
    [anon_sym_if] = ACTIONS(2999),
    [anon_sym_try] = ACTIONS(2999),
    [anon_sym_for] = ACTIONS(2999),
    [anon_sym_while] = ACTIONS(2999),
    [sym_break_statement] = ACTIONS(2999),
    [sym_continue_statement] = ACTIONS(2999),
    [anon_sym_return] = ACTIONS(2999),
    [anon_sym_let] = ACTIONS(2999),
    [anon_sym_const] = ACTIONS(2999),
    [anon_sym_quote] = ACTIONS(2999),
    [anon_sym_using] = ACTIONS(2999),
    [anon_sym_import] = ACTIONS(2999),
    [anon_sym_export] = ACTIONS(2999),
    [anon_sym_COLON2] = ACTIONS(2999),
    [anon_sym_RBRACK] = ACTIONS(3001),
    [anon_sym_begin] = ACTIONS(2999),
    [anon_sym_SQUOTE] = ACTIONS(3001),
    [anon_sym_PLUS] = ACTIONS(2999),
    [anon_sym_LT_PIPE] = ACTIONS(3001),
    [anon_sym_PIPE_GT] = ACTIONS(3001),
    [anon_sym_in] = ACTIONS(2999),
    [anon_sym_isa] = ACTIONS(2999),
    [anon_sym_PIPE_PIPE] = ACTIONS(3001),
    [anon_sym_AMP_AMP] = ACTIONS(3001),
    [anon_sym_QMARK] = ACTIONS(3001),
    [anon_sym_EQ_GT] = ACTIONS(3001),
    [anon_sym_LBRACK2] = ACTIONS(3001),
    [anon_sym_DOLLAR] = ACTIONS(2999),
    [anon_sym_AT] = ACTIONS(3001),
    [aux_sym_integer_literal_token1] = ACTIONS(3001),
    [aux_sym_integer_literal_token2] = ACTIONS(3001),
    [aux_sym_integer_literal_token3] = ACTIONS(2999),
    [sym_float_literal] = ACTIONS(2999),
    [sym__unary_operator] = ACTIONS(2999),
    [sym__power_operator] = ACTIONS(2999),
    [sym__bitshift_operator] = ACTIONS(2999),
    [sym__rational_operator] = ACTIONS(2999),
    [sym__times_operator] = ACTIONS(2999),
    [sym__plus_operator] = ACTIONS(2999),
    [sym__dotty_operator] = ACTIONS(2999),
    [sym__comparison_operator] = ACTIONS(2999),
    [sym__arrow_operator] = ACTIONS(3001),
    [sym__assign_operator] = ACTIONS(2999),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3001),
    [sym__command_start] = ACTIONS(3001),
  },
  [1391] = {
    [sym_identifier] = ACTIONS(3003),
    [anon_sym_function] = ACTIONS(3003),
    [anon_sym_end] = ACTIONS(3003),
    [anon_sym_abstract] = ACTIONS(3003),
    [anon_sym_primitive] = ACTIONS(3003),
    [aux_sym_primitive_definition_token1] = ACTIONS(3003),
    [anon_sym_mutable] = ACTIONS(3003),
    [anon_sym_struct] = ACTIONS(3003),
    [anon_sym_module] = ACTIONS(3003),
    [anon_sym_macro] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [anon_sym_COMMA] = ACTIONS(3005),
    [anon_sym_RPAREN] = ACTIONS(3005),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(3003),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3005),
    [anon_sym_COLON_COLON] = ACTIONS(3005),
    [anon_sym_RBRACE] = ACTIONS(3005),
    [anon_sym_LT_COLON] = ACTIONS(3005),
    [anon_sym_if] = ACTIONS(3003),
    [anon_sym_try] = ACTIONS(3003),
    [anon_sym_for] = ACTIONS(3003),
    [anon_sym_while] = ACTIONS(3003),
    [sym_break_statement] = ACTIONS(3003),
    [sym_continue_statement] = ACTIONS(3003),
    [anon_sym_return] = ACTIONS(3003),
    [anon_sym_let] = ACTIONS(3003),
    [anon_sym_const] = ACTIONS(3003),
    [anon_sym_quote] = ACTIONS(3003),
    [anon_sym_using] = ACTIONS(3003),
    [anon_sym_import] = ACTIONS(3003),
    [anon_sym_export] = ACTIONS(3003),
    [anon_sym_COLON2] = ACTIONS(3003),
    [anon_sym_RBRACK] = ACTIONS(3005),
    [anon_sym_begin] = ACTIONS(3003),
    [anon_sym_SQUOTE] = ACTIONS(3005),
    [anon_sym_PLUS] = ACTIONS(3003),
    [anon_sym_LT_PIPE] = ACTIONS(3005),
    [anon_sym_PIPE_GT] = ACTIONS(3005),
    [anon_sym_in] = ACTIONS(3003),
    [anon_sym_isa] = ACTIONS(3003),
    [anon_sym_PIPE_PIPE] = ACTIONS(3005),
    [anon_sym_AMP_AMP] = ACTIONS(3005),
    [anon_sym_QMARK] = ACTIONS(3005),
    [anon_sym_EQ_GT] = ACTIONS(3005),
    [anon_sym_LBRACK2] = ACTIONS(3005),
    [anon_sym_DOLLAR] = ACTIONS(3003),
    [anon_sym_AT] = ACTIONS(3005),
    [aux_sym_integer_literal_token1] = ACTIONS(3005),
    [aux_sym_integer_literal_token2] = ACTIONS(3005),
    [aux_sym_integer_literal_token3] = ACTIONS(3003),
    [sym_float_literal] = ACTIONS(3003),
    [sym__unary_operator] = ACTIONS(3003),
    [sym__power_operator] = ACTIONS(3003),
    [sym__bitshift_operator] = ACTIONS(3003),
    [sym__rational_operator] = ACTIONS(3003),
    [sym__times_operator] = ACTIONS(3003),
    [sym__plus_operator] = ACTIONS(3003),
    [sym__dotty_operator] = ACTIONS(3003),
    [sym__comparison_operator] = ACTIONS(3003),
    [sym__arrow_operator] = ACTIONS(3005),
    [sym__assign_operator] = ACTIONS(3003),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3005),
    [sym__command_start] = ACTIONS(3005),
  },
  [1392] = {
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_end] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_primitive] = ACTIONS(2772),
    [aux_sym_primitive_definition_token1] = ACTIONS(2772),
    [anon_sym_mutable] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_macro] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2777),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [sym_break_statement] = ACTIONS(2772),
    [sym_continue_statement] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_quote] = ACTIONS(2772),
    [anon_sym_using] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2777),
    [anon_sym_begin] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(2777),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2777),
    [aux_sym_integer_literal_token1] = ACTIONS(2777),
    [aux_sym_integer_literal_token2] = ACTIONS(2777),
    [aux_sym_integer_literal_token3] = ACTIONS(2772),
    [sym_float_literal] = ACTIONS(2772),
    [sym__unary_operator] = ACTIONS(2772),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(2772),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2777),
    [sym__command_start] = ACTIONS(2777),
  },
  [1393] = {
    [sym_identifier] = ACTIONS(3007),
    [anon_sym_function] = ACTIONS(3007),
    [anon_sym_end] = ACTIONS(3007),
    [anon_sym_abstract] = ACTIONS(3007),
    [anon_sym_primitive] = ACTIONS(3007),
    [aux_sym_primitive_definition_token1] = ACTIONS(3007),
    [anon_sym_mutable] = ACTIONS(3007),
    [anon_sym_struct] = ACTIONS(3007),
    [anon_sym_module] = ACTIONS(3007),
    [anon_sym_macro] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3009),
    [anon_sym_COMMA] = ACTIONS(3009),
    [anon_sym_RPAREN] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3009),
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3009),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_RBRACE] = ACTIONS(3009),
    [anon_sym_LT_COLON] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3007),
    [anon_sym_try] = ACTIONS(3007),
    [anon_sym_for] = ACTIONS(3007),
    [anon_sym_while] = ACTIONS(3007),
    [sym_break_statement] = ACTIONS(3007),
    [sym_continue_statement] = ACTIONS(3007),
    [anon_sym_return] = ACTIONS(3007),
    [anon_sym_let] = ACTIONS(3007),
    [anon_sym_const] = ACTIONS(3007),
    [anon_sym_quote] = ACTIONS(3007),
    [anon_sym_using] = ACTIONS(3007),
    [anon_sym_import] = ACTIONS(3007),
    [anon_sym_export] = ACTIONS(3007),
    [anon_sym_COLON2] = ACTIONS(3007),
    [anon_sym_RBRACK] = ACTIONS(3009),
    [anon_sym_begin] = ACTIONS(3007),
    [anon_sym_SQUOTE] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3007),
    [anon_sym_LT_PIPE] = ACTIONS(3009),
    [anon_sym_PIPE_GT] = ACTIONS(3009),
    [anon_sym_in] = ACTIONS(3007),
    [anon_sym_isa] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3009),
    [anon_sym_AMP_AMP] = ACTIONS(3009),
    [anon_sym_QMARK] = ACTIONS(3009),
    [anon_sym_EQ_GT] = ACTIONS(3009),
    [anon_sym_LBRACK2] = ACTIONS(3009),
    [anon_sym_DOLLAR] = ACTIONS(3007),
    [anon_sym_AT] = ACTIONS(3009),
    [aux_sym_integer_literal_token1] = ACTIONS(3009),
    [aux_sym_integer_literal_token2] = ACTIONS(3009),
    [aux_sym_integer_literal_token3] = ACTIONS(3007),
    [sym_float_literal] = ACTIONS(3007),
    [sym__unary_operator] = ACTIONS(3007),
    [sym__power_operator] = ACTIONS(3007),
    [sym__bitshift_operator] = ACTIONS(3007),
    [sym__rational_operator] = ACTIONS(3007),
    [sym__times_operator] = ACTIONS(3007),
    [sym__plus_operator] = ACTIONS(3007),
    [sym__dotty_operator] = ACTIONS(3007),
    [sym__comparison_operator] = ACTIONS(3007),
    [sym__arrow_operator] = ACTIONS(3009),
    [sym__assign_operator] = ACTIONS(3007),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3009),
    [sym__command_start] = ACTIONS(3009),
  },
  [1394] = {
    [sym_parenthesized_expression] = STATE(1848),
    [sym_identifier] = ACTIONS(3350),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2752),
    [anon_sym_COLON_COLON] = ACTIONS(2752),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_LT_COLON] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2752),
    [anon_sym_PIPE_GT] = ACTIONS(2752),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_QMARK] = ACTIONS(2752),
    [anon_sym_EQ_GT] = ACTIONS(2752),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2752),
    [aux_sym_integer_literal_token1] = ACTIONS(2752),
    [aux_sym_integer_literal_token2] = ACTIONS(2752),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2752),
    [sym__bitshift_operator] = ACTIONS(2752),
    [sym__rational_operator] = ACTIONS(2752),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1395] = {
    [sym_parenthesized_expression] = STATE(1835),
    [sym_identifier] = ACTIONS(3354),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_end] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_primitive] = ACTIONS(2728),
    [aux_sym_primitive_definition_token1] = ACTIONS(2728),
    [anon_sym_mutable] = ACTIONS(2728),
    [anon_sym_struct] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_macro] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2732),
    [anon_sym_COLON_COLON] = ACTIONS(2732),
    [anon_sym_RBRACE] = ACTIONS(2732),
    [anon_sym_LT_COLON] = ACTIONS(2732),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [sym_break_statement] = ACTIONS(2728),
    [sym_continue_statement] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_quote] = ACTIONS(2728),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_COLON2] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_RBRACK] = ACTIONS(2732),
    [anon_sym_begin] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_LT_PIPE] = ACTIONS(2732),
    [anon_sym_PIPE_GT] = ACTIONS(2732),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_isa] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_QMARK] = ACTIONS(2732),
    [anon_sym_EQ_GT] = ACTIONS(2732),
    [anon_sym_LBRACK2] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2732),
    [aux_sym_integer_literal_token1] = ACTIONS(2732),
    [aux_sym_integer_literal_token2] = ACTIONS(2732),
    [aux_sym_integer_literal_token3] = ACTIONS(2728),
    [sym_float_literal] = ACTIONS(2728),
    [sym__unary_operator] = ACTIONS(2728),
    [sym__power_operator] = ACTIONS(2732),
    [sym__bitshift_operator] = ACTIONS(2732),
    [sym__rational_operator] = ACTIONS(2732),
    [sym__times_operator] = ACTIONS(2728),
    [sym__plus_operator] = ACTIONS(2728),
    [sym__dotty_operator] = ACTIONS(2728),
    [sym__comparison_operator] = ACTIONS(2728),
    [sym__arrow_operator] = ACTIONS(2732),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2732),
    [sym__command_start] = ACTIONS(2732),
  },
  [1396] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_function] = ACTIONS(3127),
    [anon_sym_end] = ACTIONS(3127),
    [anon_sym_abstract] = ACTIONS(3127),
    [anon_sym_primitive] = ACTIONS(3127),
    [aux_sym_primitive_definition_token1] = ACTIONS(3127),
    [anon_sym_mutable] = ACTIONS(3127),
    [anon_sym_struct] = ACTIONS(3127),
    [anon_sym_module] = ACTIONS(3127),
    [anon_sym_macro] = ACTIONS(3127),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(3127),
    [anon_sym_try] = ACTIONS(3127),
    [anon_sym_for] = ACTIONS(3127),
    [anon_sym_while] = ACTIONS(3127),
    [sym_break_statement] = ACTIONS(3127),
    [sym_continue_statement] = ACTIONS(3127),
    [anon_sym_return] = ACTIONS(3127),
    [anon_sym_let] = ACTIONS(3127),
    [anon_sym_const] = ACTIONS(3127),
    [anon_sym_quote] = ACTIONS(3127),
    [anon_sym_using] = ACTIONS(3127),
    [anon_sym_import] = ACTIONS(3127),
    [anon_sym_export] = ACTIONS(3127),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(3129),
    [anon_sym_begin] = ACTIONS(3127),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3129),
    [anon_sym_PIPE_GT] = ACTIONS(3129),
    [anon_sym_in] = ACTIONS(3127),
    [anon_sym_isa] = ACTIONS(3127),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_EQ_GT] = ACTIONS(3129),
    [anon_sym_LBRACK2] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3127),
    [anon_sym_AT] = ACTIONS(3129),
    [aux_sym_integer_literal_token1] = ACTIONS(3129),
    [aux_sym_integer_literal_token2] = ACTIONS(3129),
    [aux_sym_integer_literal_token3] = ACTIONS(3127),
    [sym_float_literal] = ACTIONS(3127),
    [sym__unary_operator] = ACTIONS(3127),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3127),
    [sym__arrow_operator] = ACTIONS(3129),
    [sym__assign_operator] = ACTIONS(3127),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3129),
    [sym__command_start] = ACTIONS(3129),
  },
  [1397] = {
    [sym_identifier] = ACTIONS(3013),
    [anon_sym_function] = ACTIONS(3013),
    [anon_sym_end] = ACTIONS(3013),
    [anon_sym_abstract] = ACTIONS(3013),
    [anon_sym_primitive] = ACTIONS(3013),
    [aux_sym_primitive_definition_token1] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_module] = ACTIONS(3013),
    [anon_sym_macro] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3015),
    [anon_sym_COMMA] = ACTIONS(3015),
    [anon_sym_RPAREN] = ACTIONS(3015),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym_EQ] = ACTIONS(3013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3015),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_LT_COLON] = ACTIONS(3015),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [sym_break_statement] = ACTIONS(3013),
    [sym_continue_statement] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_let] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_quote] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_import] = ACTIONS(3013),
    [anon_sym_export] = ACTIONS(3013),
    [anon_sym_COLON2] = ACTIONS(3013),
    [anon_sym_RBRACK] = ACTIONS(3015),
    [anon_sym_begin] = ACTIONS(3013),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_LT_PIPE] = ACTIONS(3015),
    [anon_sym_PIPE_GT] = ACTIONS(3015),
    [anon_sym_in] = ACTIONS(3013),
    [anon_sym_isa] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_QMARK] = ACTIONS(3015),
    [anon_sym_EQ_GT] = ACTIONS(3015),
    [anon_sym_LBRACK2] = ACTIONS(3015),
    [anon_sym_DOLLAR] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3015),
    [aux_sym_integer_literal_token1] = ACTIONS(3015),
    [aux_sym_integer_literal_token2] = ACTIONS(3015),
    [aux_sym_integer_literal_token3] = ACTIONS(3013),
    [sym_float_literal] = ACTIONS(3013),
    [sym__unary_operator] = ACTIONS(3013),
    [sym__power_operator] = ACTIONS(3013),
    [sym__bitshift_operator] = ACTIONS(3013),
    [sym__rational_operator] = ACTIONS(3013),
    [sym__times_operator] = ACTIONS(3013),
    [sym__plus_operator] = ACTIONS(3013),
    [sym__dotty_operator] = ACTIONS(3013),
    [sym__comparison_operator] = ACTIONS(3013),
    [sym__arrow_operator] = ACTIONS(3015),
    [sym__assign_operator] = ACTIONS(3013),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3015),
    [sym__command_start] = ACTIONS(3015),
  },
  [1398] = {
    [sym_identifier] = ACTIONS(3021),
    [anon_sym_function] = ACTIONS(3021),
    [anon_sym_end] = ACTIONS(3021),
    [anon_sym_abstract] = ACTIONS(3021),
    [anon_sym_primitive] = ACTIONS(3021),
    [aux_sym_primitive_definition_token1] = ACTIONS(3021),
    [anon_sym_mutable] = ACTIONS(3021),
    [anon_sym_struct] = ACTIONS(3021),
    [anon_sym_module] = ACTIONS(3021),
    [anon_sym_macro] = ACTIONS(3021),
    [anon_sym_LPAREN] = ACTIONS(3023),
    [anon_sym_COMMA] = ACTIONS(3023),
    [anon_sym_RPAREN] = ACTIONS(3023),
    [anon_sym_SEMI] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3023),
    [anon_sym_COLON_COLON] = ACTIONS(3023),
    [anon_sym_RBRACE] = ACTIONS(3023),
    [anon_sym_LT_COLON] = ACTIONS(3023),
    [anon_sym_if] = ACTIONS(3021),
    [anon_sym_try] = ACTIONS(3021),
    [anon_sym_for] = ACTIONS(3021),
    [anon_sym_while] = ACTIONS(3021),
    [sym_break_statement] = ACTIONS(3021),
    [sym_continue_statement] = ACTIONS(3021),
    [anon_sym_return] = ACTIONS(3021),
    [anon_sym_let] = ACTIONS(3021),
    [anon_sym_const] = ACTIONS(3021),
    [anon_sym_quote] = ACTIONS(3021),
    [anon_sym_using] = ACTIONS(3021),
    [anon_sym_import] = ACTIONS(3021),
    [anon_sym_export] = ACTIONS(3021),
    [anon_sym_COLON2] = ACTIONS(3021),
    [anon_sym_RBRACK] = ACTIONS(3023),
    [anon_sym_begin] = ACTIONS(3021),
    [anon_sym_SQUOTE] = ACTIONS(3023),
    [anon_sym_PLUS] = ACTIONS(3021),
    [anon_sym_LT_PIPE] = ACTIONS(3023),
    [anon_sym_PIPE_GT] = ACTIONS(3023),
    [anon_sym_in] = ACTIONS(3021),
    [anon_sym_isa] = ACTIONS(3021),
    [anon_sym_PIPE_PIPE] = ACTIONS(3023),
    [anon_sym_AMP_AMP] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_EQ_GT] = ACTIONS(3023),
    [anon_sym_LBRACK2] = ACTIONS(3023),
    [anon_sym_DOLLAR] = ACTIONS(3021),
    [anon_sym_AT] = ACTIONS(3023),
    [aux_sym_integer_literal_token1] = ACTIONS(3023),
    [aux_sym_integer_literal_token2] = ACTIONS(3023),
    [aux_sym_integer_literal_token3] = ACTIONS(3021),
    [sym_float_literal] = ACTIONS(3021),
    [sym__unary_operator] = ACTIONS(3021),
    [sym__power_operator] = ACTIONS(3021),
    [sym__bitshift_operator] = ACTIONS(3021),
    [sym__rational_operator] = ACTIONS(3021),
    [sym__times_operator] = ACTIONS(3021),
    [sym__plus_operator] = ACTIONS(3021),
    [sym__dotty_operator] = ACTIONS(3021),
    [sym__comparison_operator] = ACTIONS(3021),
    [sym__arrow_operator] = ACTIONS(3023),
    [sym__assign_operator] = ACTIONS(3021),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3023),
    [sym__command_start] = ACTIONS(3023),
  },
  [1399] = {
    [sym_identifier] = ACTIONS(3025),
    [anon_sym_function] = ACTIONS(3025),
    [anon_sym_end] = ACTIONS(3025),
    [anon_sym_abstract] = ACTIONS(3025),
    [anon_sym_primitive] = ACTIONS(3025),
    [aux_sym_primitive_definition_token1] = ACTIONS(3025),
    [anon_sym_mutable] = ACTIONS(3025),
    [anon_sym_struct] = ACTIONS(3025),
    [anon_sym_module] = ACTIONS(3025),
    [anon_sym_macro] = ACTIONS(3025),
    [anon_sym_LPAREN] = ACTIONS(3027),
    [anon_sym_COMMA] = ACTIONS(3027),
    [anon_sym_RPAREN] = ACTIONS(3027),
    [anon_sym_SEMI] = ACTIONS(3027),
    [anon_sym_EQ] = ACTIONS(3025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3027),
    [anon_sym_COLON_COLON] = ACTIONS(3027),
    [anon_sym_RBRACE] = ACTIONS(3027),
    [anon_sym_LT_COLON] = ACTIONS(3027),
    [anon_sym_if] = ACTIONS(3025),
    [anon_sym_try] = ACTIONS(3025),
    [anon_sym_for] = ACTIONS(3025),
    [anon_sym_while] = ACTIONS(3025),
    [sym_break_statement] = ACTIONS(3025),
    [sym_continue_statement] = ACTIONS(3025),
    [anon_sym_return] = ACTIONS(3025),
    [anon_sym_let] = ACTIONS(3025),
    [anon_sym_const] = ACTIONS(3025),
    [anon_sym_quote] = ACTIONS(3025),
    [anon_sym_using] = ACTIONS(3025),
    [anon_sym_import] = ACTIONS(3025),
    [anon_sym_export] = ACTIONS(3025),
    [anon_sym_COLON2] = ACTIONS(3025),
    [anon_sym_RBRACK] = ACTIONS(3027),
    [anon_sym_begin] = ACTIONS(3025),
    [anon_sym_SQUOTE] = ACTIONS(3027),
    [anon_sym_PLUS] = ACTIONS(3025),
    [anon_sym_LT_PIPE] = ACTIONS(3027),
    [anon_sym_PIPE_GT] = ACTIONS(3027),
    [anon_sym_in] = ACTIONS(3025),
    [anon_sym_isa] = ACTIONS(3025),
    [anon_sym_PIPE_PIPE] = ACTIONS(3027),
    [anon_sym_AMP_AMP] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_EQ_GT] = ACTIONS(3027),
    [anon_sym_LBRACK2] = ACTIONS(3027),
    [anon_sym_DOLLAR] = ACTIONS(3025),
    [anon_sym_AT] = ACTIONS(3027),
    [aux_sym_integer_literal_token1] = ACTIONS(3027),
    [aux_sym_integer_literal_token2] = ACTIONS(3027),
    [aux_sym_integer_literal_token3] = ACTIONS(3025),
    [sym_float_literal] = ACTIONS(3025),
    [sym__unary_operator] = ACTIONS(3025),
    [sym__power_operator] = ACTIONS(3025),
    [sym__bitshift_operator] = ACTIONS(3025),
    [sym__rational_operator] = ACTIONS(3025),
    [sym__times_operator] = ACTIONS(3025),
    [sym__plus_operator] = ACTIONS(3025),
    [sym__dotty_operator] = ACTIONS(3025),
    [sym__comparison_operator] = ACTIONS(3025),
    [sym__arrow_operator] = ACTIONS(3027),
    [sym__assign_operator] = ACTIONS(3025),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3027),
    [sym__command_start] = ACTIONS(3027),
  },
  [1400] = {
    [sym_parenthesized_expression] = STATE(1709),
    [sym_identifier] = ACTIONS(3356),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_end] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_primitive] = ACTIONS(2728),
    [aux_sym_primitive_definition_token1] = ACTIONS(2728),
    [anon_sym_mutable] = ACTIONS(2728),
    [anon_sym_struct] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_macro] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(3348),
    [anon_sym_COMMA] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2728),
    [anon_sym_LT_COLON] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_elseif] = ACTIONS(2728),
    [anon_sym_else] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [sym_break_statement] = ACTIONS(2728),
    [sym_continue_statement] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_quote] = ACTIONS(2728),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_COLON2] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_begin] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_LT_PIPE] = ACTIONS(2728),
    [anon_sym_PIPE_GT] = ACTIONS(2728),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_isa] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_QMARK] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_LBRACK2] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2728),
    [aux_sym_integer_literal_token1] = ACTIONS(2728),
    [aux_sym_integer_literal_token2] = ACTIONS(2728),
    [aux_sym_integer_literal_token3] = ACTIONS(2728),
    [sym_float_literal] = ACTIONS(2728),
    [sym__unary_operator] = ACTIONS(2728),
    [sym__power_operator] = ACTIONS(2728),
    [sym__bitshift_operator] = ACTIONS(2728),
    [sym__rational_operator] = ACTIONS(2728),
    [sym__times_operator] = ACTIONS(2728),
    [sym__plus_operator] = ACTIONS(2728),
    [sym__dotty_operator] = ACTIONS(2728),
    [sym__comparison_operator] = ACTIONS(2728),
    [sym__arrow_operator] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2732),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2732),
    [sym__command_start] = ACTIONS(2732),
  },
  [1401] = {
    [sym_identifier] = ACTIONS(3029),
    [anon_sym_function] = ACTIONS(3029),
    [anon_sym_end] = ACTIONS(3029),
    [anon_sym_abstract] = ACTIONS(3029),
    [anon_sym_primitive] = ACTIONS(3029),
    [aux_sym_primitive_definition_token1] = ACTIONS(3029),
    [anon_sym_mutable] = ACTIONS(3029),
    [anon_sym_struct] = ACTIONS(3029),
    [anon_sym_module] = ACTIONS(3029),
    [anon_sym_macro] = ACTIONS(3029),
    [anon_sym_LPAREN] = ACTIONS(3031),
    [anon_sym_COMMA] = ACTIONS(3031),
    [anon_sym_RPAREN] = ACTIONS(3031),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3031),
    [anon_sym_COLON_COLON] = ACTIONS(3031),
    [anon_sym_RBRACE] = ACTIONS(3031),
    [anon_sym_LT_COLON] = ACTIONS(3031),
    [anon_sym_if] = ACTIONS(3029),
    [anon_sym_try] = ACTIONS(3029),
    [anon_sym_for] = ACTIONS(3029),
    [anon_sym_while] = ACTIONS(3029),
    [sym_break_statement] = ACTIONS(3029),
    [sym_continue_statement] = ACTIONS(3029),
    [anon_sym_return] = ACTIONS(3029),
    [anon_sym_let] = ACTIONS(3029),
    [anon_sym_const] = ACTIONS(3029),
    [anon_sym_quote] = ACTIONS(3029),
    [anon_sym_using] = ACTIONS(3029),
    [anon_sym_import] = ACTIONS(3029),
    [anon_sym_export] = ACTIONS(3029),
    [anon_sym_COLON2] = ACTIONS(3029),
    [anon_sym_RBRACK] = ACTIONS(3031),
    [anon_sym_begin] = ACTIONS(3029),
    [anon_sym_SQUOTE] = ACTIONS(3031),
    [anon_sym_PLUS] = ACTIONS(3029),
    [anon_sym_LT_PIPE] = ACTIONS(3031),
    [anon_sym_PIPE_GT] = ACTIONS(3031),
    [anon_sym_in] = ACTIONS(3029),
    [anon_sym_isa] = ACTIONS(3029),
    [anon_sym_PIPE_PIPE] = ACTIONS(3031),
    [anon_sym_AMP_AMP] = ACTIONS(3031),
    [anon_sym_QMARK] = ACTIONS(3031),
    [anon_sym_EQ_GT] = ACTIONS(3031),
    [anon_sym_LBRACK2] = ACTIONS(3031),
    [anon_sym_DOLLAR] = ACTIONS(3029),
    [anon_sym_AT] = ACTIONS(3031),
    [aux_sym_integer_literal_token1] = ACTIONS(3031),
    [aux_sym_integer_literal_token2] = ACTIONS(3031),
    [aux_sym_integer_literal_token3] = ACTIONS(3029),
    [sym_float_literal] = ACTIONS(3029),
    [sym__unary_operator] = ACTIONS(3029),
    [sym__power_operator] = ACTIONS(3029),
    [sym__bitshift_operator] = ACTIONS(3029),
    [sym__rational_operator] = ACTIONS(3029),
    [sym__times_operator] = ACTIONS(3029),
    [sym__plus_operator] = ACTIONS(3029),
    [sym__dotty_operator] = ACTIONS(3029),
    [sym__comparison_operator] = ACTIONS(3029),
    [sym__arrow_operator] = ACTIONS(3031),
    [sym__assign_operator] = ACTIONS(3029),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3031),
    [sym__command_start] = ACTIONS(3031),
  },
  [1402] = {
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(2871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_LT_COLON] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_RBRACK] = ACTIONS(2883),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_LT_PIPE] = ACTIONS(2883),
    [anon_sym_PIPE_GT] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2871),
    [anon_sym_isa] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_EQ_GT] = ACTIONS(2883),
    [anon_sym_LBRACK2] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2883),
    [aux_sym_integer_literal_token1] = ACTIONS(2883),
    [aux_sym_integer_literal_token2] = ACTIONS(2883),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2871),
    [sym__bitshift_operator] = ACTIONS(2871),
    [sym__rational_operator] = ACTIONS(2871),
    [sym__times_operator] = ACTIONS(2871),
    [sym__plus_operator] = ACTIONS(2871),
    [sym__dotty_operator] = ACTIONS(2871),
    [sym__comparison_operator] = ACTIONS(2871),
    [sym__arrow_operator] = ACTIONS(2883),
    [sym__assign_operator] = ACTIONS(2871),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1403] = {
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(3297),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_LT_COLON] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_RBRACK] = ACTIONS(2883),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_LT_PIPE] = ACTIONS(2883),
    [anon_sym_PIPE_GT] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2871),
    [anon_sym_isa] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_EQ_GT] = ACTIONS(2883),
    [anon_sym_LBRACK2] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2883),
    [aux_sym_integer_literal_token1] = ACTIONS(2883),
    [aux_sym_integer_literal_token2] = ACTIONS(2883),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2871),
    [sym__bitshift_operator] = ACTIONS(2871),
    [sym__rational_operator] = ACTIONS(2871),
    [sym__times_operator] = ACTIONS(2871),
    [sym__plus_operator] = ACTIONS(2871),
    [sym__dotty_operator] = ACTIONS(2871),
    [sym__comparison_operator] = ACTIONS(2871),
    [sym__arrow_operator] = ACTIONS(2883),
    [sym__assign_operator] = ACTIONS(3297),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1404] = {
    [sym_identifier] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_primitive] = ACTIONS(304),
    [aux_sym_primitive_definition_token1] = ACTIONS(304),
    [anon_sym_mutable] = ACTIONS(304),
    [anon_sym_struct] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_macro] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [sym_break_statement] = ACTIONS(304),
    [sym_continue_statement] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_quote] = ACTIONS(304),
    [anon_sym_using] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_COLON2] = ACTIONS(304),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(306),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(306),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(306),
    [aux_sym_integer_literal_token1] = ACTIONS(306),
    [aux_sym_integer_literal_token2] = ACTIONS(306),
    [aux_sym_integer_literal_token3] = ACTIONS(304),
    [sym_float_literal] = ACTIONS(304),
    [sym__unary_operator] = ACTIONS(304),
    [sym__power_operator] = ACTIONS(304),
    [sym__bitshift_operator] = ACTIONS(304),
    [sym__rational_operator] = ACTIONS(304),
    [sym__times_operator] = ACTIONS(304),
    [sym__plus_operator] = ACTIONS(304),
    [sym__dotty_operator] = ACTIONS(304),
    [sym__comparison_operator] = ACTIONS(304),
    [sym__arrow_operator] = ACTIONS(306),
    [sym__assign_operator] = ACTIONS(304),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(306),
    [sym__command_start] = ACTIONS(306),
  },
  [1405] = {
    [sym_identifier] = ACTIONS(3147),
    [anon_sym_function] = ACTIONS(3147),
    [anon_sym_end] = ACTIONS(3147),
    [anon_sym_abstract] = ACTIONS(3147),
    [anon_sym_primitive] = ACTIONS(3147),
    [aux_sym_primitive_definition_token1] = ACTIONS(3147),
    [anon_sym_mutable] = ACTIONS(3147),
    [anon_sym_struct] = ACTIONS(3147),
    [anon_sym_module] = ACTIONS(3147),
    [anon_sym_macro] = ACTIONS(3147),
    [anon_sym_LPAREN] = ACTIONS(3149),
    [anon_sym_COMMA] = ACTIONS(3149),
    [anon_sym_RPAREN] = ACTIONS(3149),
    [anon_sym_SEMI] = ACTIONS(3149),
    [anon_sym_EQ] = ACTIONS(3147),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3149),
    [anon_sym_COLON_COLON] = ACTIONS(3149),
    [anon_sym_RBRACE] = ACTIONS(3149),
    [anon_sym_LT_COLON] = ACTIONS(3149),
    [anon_sym_if] = ACTIONS(3147),
    [anon_sym_try] = ACTIONS(3147),
    [anon_sym_for] = ACTIONS(3147),
    [anon_sym_while] = ACTIONS(3147),
    [sym_break_statement] = ACTIONS(3147),
    [sym_continue_statement] = ACTIONS(3147),
    [anon_sym_return] = ACTIONS(3147),
    [anon_sym_let] = ACTIONS(3147),
    [anon_sym_const] = ACTIONS(3147),
    [anon_sym_quote] = ACTIONS(3147),
    [anon_sym_using] = ACTIONS(3147),
    [anon_sym_import] = ACTIONS(3147),
    [anon_sym_export] = ACTIONS(3147),
    [anon_sym_COLON2] = ACTIONS(3147),
    [anon_sym_RBRACK] = ACTIONS(3149),
    [anon_sym_begin] = ACTIONS(3147),
    [anon_sym_SQUOTE] = ACTIONS(3149),
    [anon_sym_PLUS] = ACTIONS(3147),
    [anon_sym_LT_PIPE] = ACTIONS(3149),
    [anon_sym_PIPE_GT] = ACTIONS(3149),
    [anon_sym_in] = ACTIONS(3147),
    [anon_sym_isa] = ACTIONS(3147),
    [anon_sym_PIPE_PIPE] = ACTIONS(3149),
    [anon_sym_AMP_AMP] = ACTIONS(3149),
    [anon_sym_QMARK] = ACTIONS(3149),
    [anon_sym_EQ_GT] = ACTIONS(3149),
    [anon_sym_LBRACK2] = ACTIONS(3149),
    [anon_sym_DOLLAR] = ACTIONS(3147),
    [anon_sym_AT] = ACTIONS(3149),
    [aux_sym_integer_literal_token1] = ACTIONS(3149),
    [aux_sym_integer_literal_token2] = ACTIONS(3149),
    [aux_sym_integer_literal_token3] = ACTIONS(3147),
    [sym_float_literal] = ACTIONS(3147),
    [sym__unary_operator] = ACTIONS(3147),
    [sym__power_operator] = ACTIONS(3147),
    [sym__bitshift_operator] = ACTIONS(3147),
    [sym__rational_operator] = ACTIONS(3147),
    [sym__times_operator] = ACTIONS(3147),
    [sym__plus_operator] = ACTIONS(3147),
    [sym__dotty_operator] = ACTIONS(3147),
    [sym__comparison_operator] = ACTIONS(3147),
    [sym__arrow_operator] = ACTIONS(3149),
    [sym__assign_operator] = ACTIONS(3147),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3149),
    [sym__command_start] = ACTIONS(3149),
  },
  [1406] = {
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_end] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_primitive] = ACTIONS(2900),
    [aux_sym_primitive_definition_token1] = ACTIONS(2900),
    [anon_sym_mutable] = ACTIONS(2900),
    [anon_sym_struct] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_macro] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(2902),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_EQ] = ACTIONS(2900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2902),
    [anon_sym_COLON_COLON] = ACTIONS(2902),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_LT_COLON] = ACTIONS(2902),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [sym_break_statement] = ACTIONS(2900),
    [sym_continue_statement] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_quote] = ACTIONS(2900),
    [anon_sym_using] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_COLON2] = ACTIONS(2900),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_begin] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(2902),
    [anon_sym_PLUS] = ACTIONS(2900),
    [anon_sym_LT_PIPE] = ACTIONS(2902),
    [anon_sym_PIPE_GT] = ACTIONS(2902),
    [anon_sym_in] = ACTIONS(2900),
    [anon_sym_isa] = ACTIONS(2900),
    [anon_sym_PIPE_PIPE] = ACTIONS(2902),
    [anon_sym_AMP_AMP] = ACTIONS(2902),
    [anon_sym_QMARK] = ACTIONS(2902),
    [anon_sym_EQ_GT] = ACTIONS(2902),
    [anon_sym_LBRACK2] = ACTIONS(2902),
    [anon_sym_DOLLAR] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2902),
    [aux_sym_integer_literal_token1] = ACTIONS(2902),
    [aux_sym_integer_literal_token2] = ACTIONS(2902),
    [aux_sym_integer_literal_token3] = ACTIONS(2900),
    [sym_float_literal] = ACTIONS(2900),
    [sym__unary_operator] = ACTIONS(2900),
    [sym__power_operator] = ACTIONS(2900),
    [sym__bitshift_operator] = ACTIONS(2900),
    [sym__rational_operator] = ACTIONS(2900),
    [sym__times_operator] = ACTIONS(2900),
    [sym__plus_operator] = ACTIONS(2900),
    [sym__dotty_operator] = ACTIONS(2900),
    [sym__comparison_operator] = ACTIONS(2900),
    [sym__arrow_operator] = ACTIONS(2902),
    [sym__assign_operator] = ACTIONS(2900),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2902),
    [sym__command_start] = ACTIONS(2902),
  },
  [1407] = {
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_end] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_primitive] = ACTIONS(3207),
    [aux_sym_primitive_definition_token1] = ACTIONS(3207),
    [anon_sym_mutable] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_macro] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_RPAREN] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3211),
    [anon_sym_COLON_COLON] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_LT_COLON] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [sym_break_statement] = ACTIONS(3207),
    [sym_continue_statement] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_quote] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_COLON2] = ACTIONS(3207),
    [anon_sym_RBRACK] = ACTIONS(3211),
    [anon_sym_begin] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_LT_PIPE] = ACTIONS(3211),
    [anon_sym_PIPE_GT] = ACTIONS(3211),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_isa] = ACTIONS(3207),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3211),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_EQ_GT] = ACTIONS(3211),
    [anon_sym_LBRACK2] = ACTIONS(3211),
    [anon_sym_DOLLAR] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3211),
    [aux_sym_integer_literal_token1] = ACTIONS(3211),
    [aux_sym_integer_literal_token2] = ACTIONS(3211),
    [aux_sym_integer_literal_token3] = ACTIONS(3207),
    [sym_float_literal] = ACTIONS(3207),
    [sym__unary_operator] = ACTIONS(3207),
    [sym__power_operator] = ACTIONS(3207),
    [sym__bitshift_operator] = ACTIONS(3207),
    [sym__rational_operator] = ACTIONS(3207),
    [sym__times_operator] = ACTIONS(3207),
    [sym__plus_operator] = ACTIONS(3207),
    [sym__dotty_operator] = ACTIONS(3207),
    [sym__comparison_operator] = ACTIONS(3207),
    [sym__arrow_operator] = ACTIONS(3211),
    [sym__assign_operator] = ACTIONS(3207),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3211),
    [sym__command_start] = ACTIONS(3211),
  },
  [1408] = {
    [sym_identifier] = ACTIONS(2546),
    [anon_sym_function] = ACTIONS(2546),
    [anon_sym_end] = ACTIONS(2546),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_primitive] = ACTIONS(2546),
    [aux_sym_primitive_definition_token1] = ACTIONS(2546),
    [anon_sym_mutable] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(2546),
    [anon_sym_macro] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_COMMA] = ACTIONS(2548),
    [anon_sym_RPAREN] = ACTIONS(2548),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_EQ] = ACTIONS(2546),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2548),
    [anon_sym_COLON_COLON] = ACTIONS(2548),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_LT_COLON] = ACTIONS(2548),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [sym_break_statement] = ACTIONS(2546),
    [sym_continue_statement] = ACTIONS(2546),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_quote] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_import] = ACTIONS(2546),
    [anon_sym_export] = ACTIONS(2546),
    [anon_sym_COLON2] = ACTIONS(2546),
    [anon_sym_RBRACK] = ACTIONS(2548),
    [anon_sym_begin] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_LT_PIPE] = ACTIONS(2548),
    [anon_sym_PIPE_GT] = ACTIONS(2548),
    [anon_sym_in] = ACTIONS(2546),
    [anon_sym_isa] = ACTIONS(2546),
    [anon_sym_PIPE_PIPE] = ACTIONS(2548),
    [anon_sym_AMP_AMP] = ACTIONS(2548),
    [anon_sym_QMARK] = ACTIONS(2548),
    [anon_sym_EQ_GT] = ACTIONS(2548),
    [anon_sym_LBRACK2] = ACTIONS(2548),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [aux_sym_integer_literal_token1] = ACTIONS(2548),
    [aux_sym_integer_literal_token2] = ACTIONS(2548),
    [aux_sym_integer_literal_token3] = ACTIONS(2546),
    [sym_float_literal] = ACTIONS(2546),
    [sym__unary_operator] = ACTIONS(2546),
    [sym__power_operator] = ACTIONS(2546),
    [sym__bitshift_operator] = ACTIONS(2546),
    [sym__rational_operator] = ACTIONS(2546),
    [sym__times_operator] = ACTIONS(2546),
    [sym__plus_operator] = ACTIONS(2546),
    [sym__dotty_operator] = ACTIONS(2546),
    [sym__comparison_operator] = ACTIONS(2546),
    [sym__arrow_operator] = ACTIONS(2548),
    [sym__assign_operator] = ACTIONS(2546),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2548),
    [sym__command_start] = ACTIONS(2548),
  },
  [1409] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_function] = ACTIONS(3167),
    [anon_sym_end] = ACTIONS(3167),
    [anon_sym_abstract] = ACTIONS(3167),
    [anon_sym_primitive] = ACTIONS(3167),
    [aux_sym_primitive_definition_token1] = ACTIONS(3167),
    [anon_sym_mutable] = ACTIONS(3167),
    [anon_sym_struct] = ACTIONS(3167),
    [anon_sym_module] = ACTIONS(3167),
    [anon_sym_macro] = ACTIONS(3167),
    [anon_sym_LPAREN] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(3169),
    [anon_sym_RPAREN] = ACTIONS(3169),
    [anon_sym_SEMI] = ACTIONS(3169),
    [anon_sym_EQ] = ACTIONS(3167),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3169),
    [anon_sym_COLON_COLON] = ACTIONS(3169),
    [anon_sym_RBRACE] = ACTIONS(3169),
    [anon_sym_LT_COLON] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(3167),
    [anon_sym_try] = ACTIONS(3167),
    [anon_sym_for] = ACTIONS(3167),
    [anon_sym_while] = ACTIONS(3167),
    [sym_break_statement] = ACTIONS(3167),
    [sym_continue_statement] = ACTIONS(3167),
    [anon_sym_return] = ACTIONS(3167),
    [anon_sym_let] = ACTIONS(3167),
    [anon_sym_const] = ACTIONS(3167),
    [anon_sym_quote] = ACTIONS(3167),
    [anon_sym_using] = ACTIONS(3167),
    [anon_sym_import] = ACTIONS(3167),
    [anon_sym_export] = ACTIONS(3167),
    [anon_sym_COLON2] = ACTIONS(3167),
    [anon_sym_RBRACK] = ACTIONS(3169),
    [anon_sym_begin] = ACTIONS(3167),
    [anon_sym_SQUOTE] = ACTIONS(3169),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_LT_PIPE] = ACTIONS(3169),
    [anon_sym_PIPE_GT] = ACTIONS(3169),
    [anon_sym_in] = ACTIONS(3167),
    [anon_sym_isa] = ACTIONS(3167),
    [anon_sym_PIPE_PIPE] = ACTIONS(3169),
    [anon_sym_AMP_AMP] = ACTIONS(3169),
    [anon_sym_QMARK] = ACTIONS(3169),
    [anon_sym_EQ_GT] = ACTIONS(3169),
    [anon_sym_LBRACK2] = ACTIONS(3169),
    [anon_sym_DOLLAR] = ACTIONS(3167),
    [anon_sym_AT] = ACTIONS(3169),
    [aux_sym_integer_literal_token1] = ACTIONS(3169),
    [aux_sym_integer_literal_token2] = ACTIONS(3169),
    [aux_sym_integer_literal_token3] = ACTIONS(3167),
    [sym_float_literal] = ACTIONS(3167),
    [sym__unary_operator] = ACTIONS(3167),
    [sym__power_operator] = ACTIONS(3167),
    [sym__bitshift_operator] = ACTIONS(3167),
    [sym__rational_operator] = ACTIONS(3167),
    [sym__times_operator] = ACTIONS(3167),
    [sym__plus_operator] = ACTIONS(3167),
    [sym__dotty_operator] = ACTIONS(3167),
    [sym__comparison_operator] = ACTIONS(3167),
    [sym__arrow_operator] = ACTIONS(3169),
    [sym__assign_operator] = ACTIONS(3167),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3169),
    [sym__command_start] = ACTIONS(3169),
  },
  [1410] = {
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2762),
    [anon_sym_end] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_primitive] = ACTIONS(2762),
    [aux_sym_primitive_definition_token1] = ACTIONS(2762),
    [anon_sym_mutable] = ACTIONS(2762),
    [anon_sym_struct] = ACTIONS(2762),
    [anon_sym_module] = ACTIONS(2762),
    [anon_sym_macro] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_COMMA] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2764),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2764),
    [anon_sym_COLON_COLON] = ACTIONS(2764),
    [anon_sym_RBRACE] = ACTIONS(2764),
    [anon_sym_LT_COLON] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2762),
    [anon_sym_try] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2762),
    [anon_sym_while] = ACTIONS(2762),
    [sym_break_statement] = ACTIONS(2762),
    [sym_continue_statement] = ACTIONS(2762),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2762),
    [anon_sym_quote] = ACTIONS(2762),
    [anon_sym_using] = ACTIONS(2762),
    [anon_sym_import] = ACTIONS(2762),
    [anon_sym_export] = ACTIONS(2762),
    [anon_sym_COLON2] = ACTIONS(2762),
    [anon_sym_RBRACK] = ACTIONS(2764),
    [anon_sym_begin] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_LT_PIPE] = ACTIONS(2764),
    [anon_sym_PIPE_GT] = ACTIONS(2764),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_isa] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2764),
    [anon_sym_AMP_AMP] = ACTIONS(2764),
    [anon_sym_QMARK] = ACTIONS(2764),
    [anon_sym_EQ_GT] = ACTIONS(2764),
    [anon_sym_LBRACK2] = ACTIONS(2764),
    [anon_sym_DOLLAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2764),
    [aux_sym_integer_literal_token1] = ACTIONS(2764),
    [aux_sym_integer_literal_token2] = ACTIONS(2764),
    [aux_sym_integer_literal_token3] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
    [sym__unary_operator] = ACTIONS(2762),
    [sym__power_operator] = ACTIONS(2762),
    [sym__bitshift_operator] = ACTIONS(2762),
    [sym__rational_operator] = ACTIONS(2762),
    [sym__times_operator] = ACTIONS(2762),
    [sym__plus_operator] = ACTIONS(2762),
    [sym__dotty_operator] = ACTIONS(2762),
    [sym__comparison_operator] = ACTIONS(2762),
    [sym__arrow_operator] = ACTIONS(2764),
    [sym__assign_operator] = ACTIONS(2762),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2764),
    [sym__command_start] = ACTIONS(2764),
  },
  [1411] = {
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_primitive] = ACTIONS(2912),
    [aux_sym_primitive_definition_token1] = ACTIONS(2912),
    [anon_sym_mutable] = ACTIONS(2912),
    [anon_sym_struct] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_macro] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2914),
    [anon_sym_SEMI] = ACTIONS(2914),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_LT_COLON] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [sym_break_statement] = ACTIONS(2912),
    [sym_continue_statement] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_quote] = ACTIONS(2912),
    [anon_sym_using] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_COLON2] = ACTIONS(2912),
    [anon_sym_RBRACK] = ACTIONS(2914),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_LT_PIPE] = ACTIONS(2914),
    [anon_sym_PIPE_GT] = ACTIONS(2914),
    [anon_sym_in] = ACTIONS(2912),
    [anon_sym_isa] = ACTIONS(2912),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_EQ_GT] = ACTIONS(2914),
    [anon_sym_LBRACK2] = ACTIONS(2914),
    [anon_sym_DOLLAR] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2914),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2912),
    [sym_float_literal] = ACTIONS(2912),
    [sym__unary_operator] = ACTIONS(2912),
    [sym__power_operator] = ACTIONS(2912),
    [sym__bitshift_operator] = ACTIONS(2912),
    [sym__rational_operator] = ACTIONS(2912),
    [sym__times_operator] = ACTIONS(2912),
    [sym__plus_operator] = ACTIONS(2912),
    [sym__dotty_operator] = ACTIONS(2912),
    [sym__comparison_operator] = ACTIONS(2912),
    [sym__arrow_operator] = ACTIONS(2914),
    [sym__assign_operator] = ACTIONS(2912),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2914),
    [sym__command_start] = ACTIONS(2914),
  },
  [1412] = {
    [sym_identifier] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3187),
    [anon_sym_end] = ACTIONS(3187),
    [anon_sym_abstract] = ACTIONS(3187),
    [anon_sym_primitive] = ACTIONS(3187),
    [aux_sym_primitive_definition_token1] = ACTIONS(3187),
    [anon_sym_mutable] = ACTIONS(3187),
    [anon_sym_struct] = ACTIONS(3187),
    [anon_sym_module] = ACTIONS(3187),
    [anon_sym_macro] = ACTIONS(3187),
    [anon_sym_LPAREN] = ACTIONS(3189),
    [anon_sym_COMMA] = ACTIONS(3189),
    [anon_sym_RPAREN] = ACTIONS(3189),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_EQ] = ACTIONS(3187),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3189),
    [anon_sym_COLON_COLON] = ACTIONS(3189),
    [anon_sym_RBRACE] = ACTIONS(3189),
    [anon_sym_LT_COLON] = ACTIONS(3189),
    [anon_sym_if] = ACTIONS(3187),
    [anon_sym_try] = ACTIONS(3187),
    [anon_sym_for] = ACTIONS(3187),
    [anon_sym_while] = ACTIONS(3187),
    [sym_break_statement] = ACTIONS(3187),
    [sym_continue_statement] = ACTIONS(3187),
    [anon_sym_return] = ACTIONS(3187),
    [anon_sym_let] = ACTIONS(3187),
    [anon_sym_const] = ACTIONS(3187),
    [anon_sym_quote] = ACTIONS(3187),
    [anon_sym_using] = ACTIONS(3187),
    [anon_sym_import] = ACTIONS(3187),
    [anon_sym_export] = ACTIONS(3187),
    [anon_sym_COLON2] = ACTIONS(3187),
    [anon_sym_RBRACK] = ACTIONS(3189),
    [anon_sym_begin] = ACTIONS(3187),
    [anon_sym_SQUOTE] = ACTIONS(3189),
    [anon_sym_PLUS] = ACTIONS(3187),
    [anon_sym_LT_PIPE] = ACTIONS(3189),
    [anon_sym_PIPE_GT] = ACTIONS(3189),
    [anon_sym_in] = ACTIONS(3187),
    [anon_sym_isa] = ACTIONS(3187),
    [anon_sym_PIPE_PIPE] = ACTIONS(3189),
    [anon_sym_AMP_AMP] = ACTIONS(3189),
    [anon_sym_QMARK] = ACTIONS(3189),
    [anon_sym_EQ_GT] = ACTIONS(3189),
    [anon_sym_LBRACK2] = ACTIONS(3189),
    [anon_sym_DOLLAR] = ACTIONS(3187),
    [anon_sym_AT] = ACTIONS(3189),
    [aux_sym_integer_literal_token1] = ACTIONS(3189),
    [aux_sym_integer_literal_token2] = ACTIONS(3189),
    [aux_sym_integer_literal_token3] = ACTIONS(3187),
    [sym_float_literal] = ACTIONS(3187),
    [sym__unary_operator] = ACTIONS(3187),
    [sym__power_operator] = ACTIONS(3187),
    [sym__bitshift_operator] = ACTIONS(3187),
    [sym__rational_operator] = ACTIONS(3187),
    [sym__times_operator] = ACTIONS(3187),
    [sym__plus_operator] = ACTIONS(3187),
    [sym__dotty_operator] = ACTIONS(3187),
    [sym__comparison_operator] = ACTIONS(3187),
    [sym__arrow_operator] = ACTIONS(3189),
    [sym__assign_operator] = ACTIONS(3187),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3189),
    [sym__command_start] = ACTIONS(3189),
  },
  [1413] = {
    [sym_identifier] = ACTIONS(3119),
    [anon_sym_function] = ACTIONS(3119),
    [anon_sym_end] = ACTIONS(3119),
    [anon_sym_abstract] = ACTIONS(3119),
    [anon_sym_primitive] = ACTIONS(3119),
    [aux_sym_primitive_definition_token1] = ACTIONS(3119),
    [anon_sym_mutable] = ACTIONS(3119),
    [anon_sym_struct] = ACTIONS(3119),
    [anon_sym_module] = ACTIONS(3119),
    [anon_sym_macro] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3127),
    [anon_sym_SEMI] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2839),
    [anon_sym_COLON_COLON] = ACTIONS(2841),
    [anon_sym_LT_COLON] = ACTIONS(2841),
    [anon_sym_if] = ACTIONS(3119),
    [anon_sym_elseif] = ACTIONS(3119),
    [anon_sym_else] = ACTIONS(3119),
    [anon_sym_try] = ACTIONS(3119),
    [anon_sym_for] = ACTIONS(3119),
    [anon_sym_while] = ACTIONS(3119),
    [sym_break_statement] = ACTIONS(3119),
    [sym_continue_statement] = ACTIONS(3119),
    [anon_sym_return] = ACTIONS(3119),
    [anon_sym_let] = ACTIONS(3119),
    [anon_sym_const] = ACTIONS(3119),
    [anon_sym_quote] = ACTIONS(3119),
    [anon_sym_using] = ACTIONS(3119),
    [anon_sym_import] = ACTIONS(3119),
    [anon_sym_export] = ACTIONS(3119),
    [anon_sym_COLON2] = ACTIONS(3119),
    [anon_sym_begin] = ACTIONS(3119),
    [anon_sym_SQUOTE] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2847),
    [anon_sym_LT_PIPE] = ACTIONS(3119),
    [anon_sym_PIPE_GT] = ACTIONS(3119),
    [anon_sym_in] = ACTIONS(3119),
    [anon_sym_isa] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_EQ_GT] = ACTIONS(3119),
    [anon_sym_LBRACK2] = ACTIONS(3119),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3119),
    [aux_sym_integer_literal_token1] = ACTIONS(3119),
    [aux_sym_integer_literal_token2] = ACTIONS(3119),
    [aux_sym_integer_literal_token3] = ACTIONS(3119),
    [sym_float_literal] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__power_operator] = ACTIONS(2855),
    [sym__bitshift_operator] = ACTIONS(2857),
    [sym__rational_operator] = ACTIONS(2859),
    [sym__times_operator] = ACTIONS(2861),
    [sym__plus_operator] = ACTIONS(2847),
    [sym__dotty_operator] = ACTIONS(3119),
    [sym__comparison_operator] = ACTIONS(3119),
    [sym__arrow_operator] = ACTIONS(3119),
    [sym__assign_operator] = ACTIONS(3127),
    [anon_sym_LF] = ACTIONS(3191),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3191),
    [sym__command_start] = ACTIONS(3191),
  },
  [1414] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1222),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(3299),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(3344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3240),
    [anon_sym_COLON_COLON] = ACTIONS(3242),
    [anon_sym_LT_COLON] = ACTIONS(3242),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(3244),
    [anon_sym_RBRACK] = ACTIONS(2883),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(3246),
    [anon_sym_PLUS] = ACTIONS(3248),
    [anon_sym_LT_PIPE] = ACTIONS(3250),
    [anon_sym_PIPE_GT] = ACTIONS(3252),
    [anon_sym_in] = ACTIONS(3254),
    [anon_sym_isa] = ACTIONS(3254),
    [anon_sym_PIPE_PIPE] = ACTIONS(3270),
    [anon_sym_AMP_AMP] = ACTIONS(3272),
    [anon_sym_QMARK] = ACTIONS(3274),
    [anon_sym_EQ_GT] = ACTIONS(3276),
    [anon_sym_LBRACK2] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2883),
    [aux_sym_integer_literal_token1] = ACTIONS(2883),
    [aux_sym_integer_literal_token2] = ACTIONS(2883),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(3256),
    [sym__bitshift_operator] = ACTIONS(3258),
    [sym__rational_operator] = ACTIONS(3260),
    [sym__times_operator] = ACTIONS(3262),
    [sym__plus_operator] = ACTIONS(3248),
    [sym__dotty_operator] = ACTIONS(3264),
    [sym__comparison_operator] = ACTIONS(3254),
    [sym__arrow_operator] = ACTIONS(3266),
    [sym__assign_operator] = ACTIONS(3344),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1415] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_COMMA] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_LT_COLON] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_RBRACK] = ACTIONS(2708),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_GT] = ACTIONS(2708),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2708),
    [anon_sym_AMP_AMP] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2708),
    [anon_sym_EQ_GT] = ACTIONS(2708),
    [anon_sym_LBRACK2] = ACTIONS(2708),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2708),
    [aux_sym_integer_literal_token1] = ACTIONS(2708),
    [aux_sym_integer_literal_token2] = ACTIONS(2708),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2708),
    [sym__assign_operator] = ACTIONS(2702),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1416] = {
    [sym_parenthesized_expression] = STATE(1688),
    [ts_builtin_sym_end] = ACTIONS(2732),
    [sym_identifier] = ACTIONS(3360),
    [anon_sym_function] = ACTIONS(2728),
    [anon_sym_abstract] = ACTIONS(2728),
    [anon_sym_primitive] = ACTIONS(2728),
    [aux_sym_primitive_definition_token1] = ACTIONS(2728),
    [anon_sym_mutable] = ACTIONS(2728),
    [anon_sym_struct] = ACTIONS(2728),
    [anon_sym_module] = ACTIONS(2728),
    [anon_sym_macro] = ACTIONS(2728),
    [anon_sym_LPAREN] = ACTIONS(3362),
    [anon_sym_COMMA] = ACTIONS(2728),
    [anon_sym_SEMI] = ACTIONS(2728),
    [anon_sym_EQ] = ACTIONS(2728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2728),
    [anon_sym_COLON_COLON] = ACTIONS(2728),
    [anon_sym_LT_COLON] = ACTIONS(2728),
    [anon_sym_if] = ACTIONS(2728),
    [anon_sym_try] = ACTIONS(2728),
    [anon_sym_for] = ACTIONS(2728),
    [anon_sym_while] = ACTIONS(2728),
    [sym_break_statement] = ACTIONS(2728),
    [sym_continue_statement] = ACTIONS(2728),
    [anon_sym_return] = ACTIONS(2728),
    [anon_sym_let] = ACTIONS(2728),
    [anon_sym_const] = ACTIONS(2728),
    [anon_sym_quote] = ACTIONS(2728),
    [anon_sym_using] = ACTIONS(2728),
    [anon_sym_import] = ACTIONS(2728),
    [anon_sym_export] = ACTIONS(2728),
    [anon_sym_COLON2] = ACTIONS(2728),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_begin] = ACTIONS(2728),
    [anon_sym_SQUOTE] = ACTIONS(2728),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_LT_PIPE] = ACTIONS(2728),
    [anon_sym_PIPE_GT] = ACTIONS(2728),
    [anon_sym_in] = ACTIONS(2728),
    [anon_sym_isa] = ACTIONS(2728),
    [anon_sym_PIPE_PIPE] = ACTIONS(2728),
    [anon_sym_AMP_AMP] = ACTIONS(2728),
    [anon_sym_QMARK] = ACTIONS(2728),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_LBRACK2] = ACTIONS(2728),
    [anon_sym_DOLLAR] = ACTIONS(2728),
    [anon_sym_AT] = ACTIONS(2728),
    [aux_sym_integer_literal_token1] = ACTIONS(2728),
    [aux_sym_integer_literal_token2] = ACTIONS(2728),
    [aux_sym_integer_literal_token3] = ACTIONS(2728),
    [sym_float_literal] = ACTIONS(2728),
    [sym__unary_operator] = ACTIONS(2728),
    [sym__power_operator] = ACTIONS(2728),
    [sym__bitshift_operator] = ACTIONS(2728),
    [sym__rational_operator] = ACTIONS(2728),
    [sym__times_operator] = ACTIONS(2728),
    [sym__plus_operator] = ACTIONS(2728),
    [sym__dotty_operator] = ACTIONS(2728),
    [sym__comparison_operator] = ACTIONS(2728),
    [sym__arrow_operator] = ACTIONS(2728),
    [sym__assign_operator] = ACTIONS(2728),
    [anon_sym_LF] = ACTIONS(2732),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2732),
    [sym__command_start] = ACTIONS(2732),
  },
  [1417] = {
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_SEMI] = ACTIONS(2883),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2883),
    [anon_sym_COLON_COLON] = ACTIONS(2883),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_LT_COLON] = ACTIONS(2883),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_RBRACK] = ACTIONS(2883),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2883),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_LT_PIPE] = ACTIONS(2883),
    [anon_sym_PIPE_GT] = ACTIONS(2883),
    [anon_sym_in] = ACTIONS(2871),
    [anon_sym_isa] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2883),
    [anon_sym_AMP_AMP] = ACTIONS(2883),
    [anon_sym_QMARK] = ACTIONS(2883),
    [anon_sym_EQ_GT] = ACTIONS(2883),
    [anon_sym_LBRACK2] = ACTIONS(2883),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2883),
    [aux_sym_integer_literal_token1] = ACTIONS(2883),
    [aux_sym_integer_literal_token2] = ACTIONS(2883),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2871),
    [sym__bitshift_operator] = ACTIONS(2871),
    [sym__rational_operator] = ACTIONS(2871),
    [sym__times_operator] = ACTIONS(2871),
    [sym__plus_operator] = ACTIONS(2871),
    [sym__dotty_operator] = ACTIONS(2871),
    [sym__comparison_operator] = ACTIONS(2871),
    [sym__arrow_operator] = ACTIONS(2883),
    [sym__assign_operator] = ACTIONS(3268),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1418] = {
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(3307),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_LT_COLON] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elseif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_LT_PIPE] = ACTIONS(2871),
    [anon_sym_PIPE_GT] = ACTIONS(2871),
    [anon_sym_in] = ACTIONS(2871),
    [anon_sym_isa] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [anon_sym_QMARK] = ACTIONS(2871),
    [anon_sym_EQ_GT] = ACTIONS(2871),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2871),
    [sym__bitshift_operator] = ACTIONS(2871),
    [sym__rational_operator] = ACTIONS(2871),
    [sym__times_operator] = ACTIONS(2871),
    [sym__plus_operator] = ACTIONS(2871),
    [sym__dotty_operator] = ACTIONS(2871),
    [sym__comparison_operator] = ACTIONS(2871),
    [sym__arrow_operator] = ACTIONS(2871),
    [sym__assign_operator] = ACTIONS(3307),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1419] = {
    [sym_identifier] = ACTIONS(3033),
    [anon_sym_function] = ACTIONS(3033),
    [anon_sym_end] = ACTIONS(3033),
    [anon_sym_abstract] = ACTIONS(3033),
    [anon_sym_primitive] = ACTIONS(3033),
    [aux_sym_primitive_definition_token1] = ACTIONS(3033),
    [anon_sym_mutable] = ACTIONS(3033),
    [anon_sym_struct] = ACTIONS(3033),
    [anon_sym_module] = ACTIONS(3033),
    [anon_sym_macro] = ACTIONS(3033),
    [anon_sym_LPAREN] = ACTIONS(3035),
    [anon_sym_COMMA] = ACTIONS(3035),
    [anon_sym_RPAREN] = ACTIONS(3035),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(3033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3035),
    [anon_sym_COLON_COLON] = ACTIONS(3035),
    [anon_sym_RBRACE] = ACTIONS(3035),
    [anon_sym_LT_COLON] = ACTIONS(3035),
    [anon_sym_if] = ACTIONS(3033),
    [anon_sym_try] = ACTIONS(3033),
    [anon_sym_for] = ACTIONS(3033),
    [anon_sym_while] = ACTIONS(3033),
    [sym_break_statement] = ACTIONS(3033),
    [sym_continue_statement] = ACTIONS(3033),
    [anon_sym_return] = ACTIONS(3033),
    [anon_sym_let] = ACTIONS(3033),
    [anon_sym_const] = ACTIONS(3033),
    [anon_sym_quote] = ACTIONS(3033),
    [anon_sym_using] = ACTIONS(3033),
    [anon_sym_import] = ACTIONS(3033),
    [anon_sym_export] = ACTIONS(3033),
    [anon_sym_COLON2] = ACTIONS(3033),
    [anon_sym_RBRACK] = ACTIONS(3035),
    [anon_sym_begin] = ACTIONS(3033),
    [anon_sym_SQUOTE] = ACTIONS(3035),
    [anon_sym_PLUS] = ACTIONS(3033),
    [anon_sym_LT_PIPE] = ACTIONS(3035),
    [anon_sym_PIPE_GT] = ACTIONS(3035),
    [anon_sym_in] = ACTIONS(3033),
    [anon_sym_isa] = ACTIONS(3033),
    [anon_sym_PIPE_PIPE] = ACTIONS(3035),
    [anon_sym_AMP_AMP] = ACTIONS(3035),
    [anon_sym_QMARK] = ACTIONS(3035),
    [anon_sym_EQ_GT] = ACTIONS(3035),
    [anon_sym_LBRACK2] = ACTIONS(3035),
    [anon_sym_DOLLAR] = ACTIONS(3033),
    [anon_sym_AT] = ACTIONS(3035),
    [aux_sym_integer_literal_token1] = ACTIONS(3035),
    [aux_sym_integer_literal_token2] = ACTIONS(3035),
    [aux_sym_integer_literal_token3] = ACTIONS(3033),
    [sym_float_literal] = ACTIONS(3033),
    [sym__unary_operator] = ACTIONS(3033),
    [sym__power_operator] = ACTIONS(3033),
    [sym__bitshift_operator] = ACTIONS(3033),
    [sym__rational_operator] = ACTIONS(3033),
    [sym__times_operator] = ACTIONS(3033),
    [sym__plus_operator] = ACTIONS(3033),
    [sym__dotty_operator] = ACTIONS(3033),
    [sym__comparison_operator] = ACTIONS(3033),
    [sym__arrow_operator] = ACTIONS(3035),
    [sym__assign_operator] = ACTIONS(3033),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3035),
    [sym__command_start] = ACTIONS(3035),
  },
  [1420] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_function] = ACTIONS(3037),
    [anon_sym_end] = ACTIONS(3037),
    [anon_sym_abstract] = ACTIONS(3037),
    [anon_sym_primitive] = ACTIONS(3037),
    [aux_sym_primitive_definition_token1] = ACTIONS(3037),
    [anon_sym_mutable] = ACTIONS(3037),
    [anon_sym_struct] = ACTIONS(3037),
    [anon_sym_module] = ACTIONS(3037),
    [anon_sym_macro] = ACTIONS(3037),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3039),
    [anon_sym_COLON_COLON] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3039),
    [anon_sym_LT_COLON] = ACTIONS(3039),
    [anon_sym_if] = ACTIONS(3037),
    [anon_sym_try] = ACTIONS(3037),
    [anon_sym_for] = ACTIONS(3037),
    [anon_sym_while] = ACTIONS(3037),
    [sym_break_statement] = ACTIONS(3037),
    [sym_continue_statement] = ACTIONS(3037),
    [anon_sym_return] = ACTIONS(3037),
    [anon_sym_let] = ACTIONS(3037),
    [anon_sym_const] = ACTIONS(3037),
    [anon_sym_quote] = ACTIONS(3037),
    [anon_sym_using] = ACTIONS(3037),
    [anon_sym_import] = ACTIONS(3037),
    [anon_sym_export] = ACTIONS(3037),
    [anon_sym_COLON2] = ACTIONS(3037),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_begin] = ACTIONS(3037),
    [anon_sym_SQUOTE] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_LT_PIPE] = ACTIONS(3039),
    [anon_sym_PIPE_GT] = ACTIONS(3039),
    [anon_sym_in] = ACTIONS(3037),
    [anon_sym_isa] = ACTIONS(3037),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_EQ_GT] = ACTIONS(3039),
    [anon_sym_LBRACK2] = ACTIONS(3039),
    [anon_sym_DOLLAR] = ACTIONS(3037),
    [anon_sym_AT] = ACTIONS(3039),
    [aux_sym_integer_literal_token1] = ACTIONS(3039),
    [aux_sym_integer_literal_token2] = ACTIONS(3039),
    [aux_sym_integer_literal_token3] = ACTIONS(3037),
    [sym_float_literal] = ACTIONS(3037),
    [sym__unary_operator] = ACTIONS(3037),
    [sym__power_operator] = ACTIONS(3037),
    [sym__bitshift_operator] = ACTIONS(3037),
    [sym__rational_operator] = ACTIONS(3037),
    [sym__times_operator] = ACTIONS(3037),
    [sym__plus_operator] = ACTIONS(3037),
    [sym__dotty_operator] = ACTIONS(3037),
    [sym__comparison_operator] = ACTIONS(3037),
    [sym__arrow_operator] = ACTIONS(3039),
    [sym__assign_operator] = ACTIONS(3037),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3039),
    [sym__command_start] = ACTIONS(3039),
  },
  [1421] = {
    [sym_parenthesized_expression] = STATE(1703),
    [ts_builtin_sym_end] = ACTIONS(2752),
    [sym_identifier] = ACTIONS(3364),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(3362),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2750),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_LT_COLON] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2750),
    [anon_sym_PIPE_GT] = ACTIONS(2750),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2750),
    [anon_sym_AMP_AMP] = ACTIONS(2750),
    [anon_sym_QMARK] = ACTIONS(2750),
    [anon_sym_EQ_GT] = ACTIONS(2750),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2750),
    [aux_sym_integer_literal_token1] = ACTIONS(2750),
    [aux_sym_integer_literal_token2] = ACTIONS(2750),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2750),
    [sym__assign_operator] = ACTIONS(2750),
    [anon_sym_LF] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1422] = {
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_end] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_primitive] = ACTIONS(2889),
    [aux_sym_primitive_definition_token1] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_macro] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2894),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_LT_COLON] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [sym_break_statement] = ACTIONS(2889),
    [sym_continue_statement] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_quote] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_COLON2] = ACTIONS(2889),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_begin] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_LT_PIPE] = ACTIONS(2894),
    [anon_sym_PIPE_GT] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_LBRACK2] = ACTIONS(2894),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2894),
    [aux_sym_integer_literal_token1] = ACTIONS(2894),
    [aux_sym_integer_literal_token2] = ACTIONS(2894),
    [aux_sym_integer_literal_token3] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym__unary_operator] = ACTIONS(2889),
    [sym__power_operator] = ACTIONS(2889),
    [sym__bitshift_operator] = ACTIONS(2889),
    [sym__rational_operator] = ACTIONS(2889),
    [sym__times_operator] = ACTIONS(2889),
    [sym__plus_operator] = ACTIONS(2889),
    [sym__dotty_operator] = ACTIONS(2889),
    [sym__comparison_operator] = ACTIONS(2889),
    [sym__arrow_operator] = ACTIONS(2894),
    [sym__assign_operator] = ACTIONS(2889),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2894),
    [sym__command_start] = ACTIONS(2894),
  },
  [1423] = {
    [sym_identifier] = ACTIONS(2526),
    [anon_sym_function] = ACTIONS(2526),
    [anon_sym_end] = ACTIONS(2526),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_primitive] = ACTIONS(2526),
    [aux_sym_primitive_definition_token1] = ACTIONS(2526),
    [anon_sym_mutable] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_module] = ACTIONS(2526),
    [anon_sym_macro] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_COMMA] = ACTIONS(2528),
    [anon_sym_RPAREN] = ACTIONS(2528),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_EQ] = ACTIONS(2526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2528),
    [anon_sym_COLON_COLON] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2528),
    [anon_sym_LT_COLON] = ACTIONS(2528),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [sym_break_statement] = ACTIONS(2526),
    [sym_continue_statement] = ACTIONS(2526),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_quote] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_import] = ACTIONS(2526),
    [anon_sym_export] = ACTIONS(2526),
    [anon_sym_COLON2] = ACTIONS(2526),
    [anon_sym_RBRACK] = ACTIONS(2528),
    [anon_sym_begin] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_LT_PIPE] = ACTIONS(2528),
    [anon_sym_PIPE_GT] = ACTIONS(2528),
    [anon_sym_in] = ACTIONS(2526),
    [anon_sym_isa] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2528),
    [anon_sym_AMP_AMP] = ACTIONS(2528),
    [anon_sym_QMARK] = ACTIONS(2528),
    [anon_sym_EQ_GT] = ACTIONS(2528),
    [anon_sym_LBRACK2] = ACTIONS(2528),
    [anon_sym_DOLLAR] = ACTIONS(2526),
    [anon_sym_AT] = ACTIONS(2528),
    [aux_sym_integer_literal_token1] = ACTIONS(2528),
    [aux_sym_integer_literal_token2] = ACTIONS(2528),
    [aux_sym_integer_literal_token3] = ACTIONS(2526),
    [sym_float_literal] = ACTIONS(2526),
    [sym__unary_operator] = ACTIONS(2526),
    [sym__power_operator] = ACTIONS(2526),
    [sym__bitshift_operator] = ACTIONS(2526),
    [sym__rational_operator] = ACTIONS(2526),
    [sym__times_operator] = ACTIONS(2526),
    [sym__plus_operator] = ACTIONS(2526),
    [sym__dotty_operator] = ACTIONS(2526),
    [sym__comparison_operator] = ACTIONS(2526),
    [sym__arrow_operator] = ACTIONS(2528),
    [sym__assign_operator] = ACTIONS(2526),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2528),
    [sym__command_start] = ACTIONS(2528),
  },
  [1424] = {
    [sym_identifier] = ACTIONS(3051),
    [anon_sym_function] = ACTIONS(3051),
    [anon_sym_end] = ACTIONS(3051),
    [anon_sym_abstract] = ACTIONS(3051),
    [anon_sym_primitive] = ACTIONS(3051),
    [aux_sym_primitive_definition_token1] = ACTIONS(3051),
    [anon_sym_mutable] = ACTIONS(3051),
    [anon_sym_struct] = ACTIONS(3051),
    [anon_sym_module] = ACTIONS(3051),
    [anon_sym_macro] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3053),
    [anon_sym_COMMA] = ACTIONS(3053),
    [anon_sym_RPAREN] = ACTIONS(3053),
    [anon_sym_SEMI] = ACTIONS(3053),
    [anon_sym_EQ] = ACTIONS(3051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3053),
    [anon_sym_COLON_COLON] = ACTIONS(3053),
    [anon_sym_RBRACE] = ACTIONS(3053),
    [anon_sym_LT_COLON] = ACTIONS(3053),
    [anon_sym_if] = ACTIONS(3051),
    [anon_sym_try] = ACTIONS(3051),
    [anon_sym_for] = ACTIONS(3051),
    [anon_sym_while] = ACTIONS(3051),
    [sym_break_statement] = ACTIONS(3051),
    [sym_continue_statement] = ACTIONS(3051),
    [anon_sym_return] = ACTIONS(3051),
    [anon_sym_let] = ACTIONS(3051),
    [anon_sym_const] = ACTIONS(3051),
    [anon_sym_quote] = ACTIONS(3051),
    [anon_sym_using] = ACTIONS(3051),
    [anon_sym_import] = ACTIONS(3051),
    [anon_sym_export] = ACTIONS(3051),
    [anon_sym_COLON2] = ACTIONS(3051),
    [anon_sym_RBRACK] = ACTIONS(3053),
    [anon_sym_begin] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [anon_sym_PLUS] = ACTIONS(3051),
    [anon_sym_LT_PIPE] = ACTIONS(3053),
    [anon_sym_PIPE_GT] = ACTIONS(3053),
    [anon_sym_in] = ACTIONS(3051),
    [anon_sym_isa] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3053),
    [anon_sym_AMP_AMP] = ACTIONS(3053),
    [anon_sym_QMARK] = ACTIONS(3053),
    [anon_sym_EQ_GT] = ACTIONS(3053),
    [anon_sym_LBRACK2] = ACTIONS(3053),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_AT] = ACTIONS(3053),
    [aux_sym_integer_literal_token1] = ACTIONS(3053),
    [aux_sym_integer_literal_token2] = ACTIONS(3053),
    [aux_sym_integer_literal_token3] = ACTIONS(3051),
    [sym_float_literal] = ACTIONS(3051),
    [sym__unary_operator] = ACTIONS(3051),
    [sym__power_operator] = ACTIONS(3051),
    [sym__bitshift_operator] = ACTIONS(3051),
    [sym__rational_operator] = ACTIONS(3051),
    [sym__times_operator] = ACTIONS(3051),
    [sym__plus_operator] = ACTIONS(3051),
    [sym__dotty_operator] = ACTIONS(3051),
    [sym__comparison_operator] = ACTIONS(3051),
    [sym__arrow_operator] = ACTIONS(3053),
    [sym__assign_operator] = ACTIONS(3051),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3053),
    [sym__command_start] = ACTIONS(3053),
  },
  [1425] = {
    [ts_builtin_sym_end] = ACTIONS(2740),
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_abstract] = ACTIONS(2738),
    [anon_sym_primitive] = ACTIONS(2738),
    [aux_sym_primitive_definition_token1] = ACTIONS(2738),
    [anon_sym_mutable] = ACTIONS(2738),
    [anon_sym_struct] = ACTIONS(2738),
    [anon_sym_module] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2738),
    [anon_sym_COMMA] = ACTIONS(2738),
    [anon_sym_SEMI] = ACTIONS(2738),
    [anon_sym_EQ] = ACTIONS(2738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2738),
    [anon_sym_COLON_COLON] = ACTIONS(2738),
    [anon_sym_LT_COLON] = ACTIONS(2738),
    [anon_sym_if] = ACTIONS(2738),
    [anon_sym_try] = ACTIONS(2738),
    [anon_sym_for] = ACTIONS(2738),
    [anon_sym_while] = ACTIONS(2738),
    [sym_break_statement] = ACTIONS(2738),
    [sym_continue_statement] = ACTIONS(2738),
    [anon_sym_return] = ACTIONS(2738),
    [anon_sym_let] = ACTIONS(2738),
    [anon_sym_const] = ACTIONS(2738),
    [anon_sym_quote] = ACTIONS(2738),
    [anon_sym_using] = ACTIONS(2738),
    [anon_sym_import] = ACTIONS(2738),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_DOT] = ACTIONS(2738),
    [anon_sym_export] = ACTIONS(2738),
    [anon_sym_COLON2] = ACTIONS(2738),
    [anon_sym_begin] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2738),
    [anon_sym_PLUS] = ACTIONS(2738),
    [anon_sym_LT_PIPE] = ACTIONS(2738),
    [anon_sym_PIPE_GT] = ACTIONS(2738),
    [anon_sym_in] = ACTIONS(2738),
    [anon_sym_isa] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2738),
    [anon_sym_AMP_AMP] = ACTIONS(2738),
    [anon_sym_QMARK] = ACTIONS(2738),
    [anon_sym_EQ_GT] = ACTIONS(2738),
    [anon_sym_LBRACK2] = ACTIONS(2738),
    [anon_sym_DOLLAR] = ACTIONS(2738),
    [anon_sym_AT] = ACTIONS(2738),
    [aux_sym_integer_literal_token1] = ACTIONS(2738),
    [aux_sym_integer_literal_token2] = ACTIONS(2738),
    [aux_sym_integer_literal_token3] = ACTIONS(2738),
    [sym_float_literal] = ACTIONS(2738),
    [sym__unary_operator] = ACTIONS(2738),
    [sym__power_operator] = ACTIONS(2738),
    [sym__bitshift_operator] = ACTIONS(2738),
    [sym__rational_operator] = ACTIONS(2738),
    [sym__times_operator] = ACTIONS(2738),
    [sym__plus_operator] = ACTIONS(2738),
    [sym__dotty_operator] = ACTIONS(2738),
    [sym__comparison_operator] = ACTIONS(2738),
    [sym__arrow_operator] = ACTIONS(2738),
    [sym__assign_operator] = ACTIONS(2738),
    [anon_sym_LF] = ACTIONS(2740),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2740),
    [sym__command_start] = ACTIONS(2740),
  },
  [1426] = {
    [sym_identifier] = ACTIONS(3055),
    [anon_sym_function] = ACTIONS(3055),
    [anon_sym_end] = ACTIONS(3055),
    [anon_sym_abstract] = ACTIONS(3055),
    [anon_sym_primitive] = ACTIONS(3055),
    [aux_sym_primitive_definition_token1] = ACTIONS(3055),
    [anon_sym_mutable] = ACTIONS(3055),
    [anon_sym_struct] = ACTIONS(3055),
    [anon_sym_module] = ACTIONS(3055),
    [anon_sym_macro] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3057),
    [anon_sym_COMMA] = ACTIONS(3057),
    [anon_sym_RPAREN] = ACTIONS(3057),
    [anon_sym_SEMI] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(3055),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3057),
    [anon_sym_COLON_COLON] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3057),
    [anon_sym_LT_COLON] = ACTIONS(3057),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_try] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_while] = ACTIONS(3055),
    [sym_break_statement] = ACTIONS(3055),
    [sym_continue_statement] = ACTIONS(3055),
    [anon_sym_return] = ACTIONS(3055),
    [anon_sym_let] = ACTIONS(3055),
    [anon_sym_const] = ACTIONS(3055),
    [anon_sym_quote] = ACTIONS(3055),
    [anon_sym_using] = ACTIONS(3055),
    [anon_sym_import] = ACTIONS(3055),
    [anon_sym_export] = ACTIONS(3055),
    [anon_sym_COLON2] = ACTIONS(3055),
    [anon_sym_RBRACK] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [anon_sym_PLUS] = ACTIONS(3055),
    [anon_sym_LT_PIPE] = ACTIONS(3057),
    [anon_sym_PIPE_GT] = ACTIONS(3057),
    [anon_sym_in] = ACTIONS(3055),
    [anon_sym_isa] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3057),
    [anon_sym_AMP_AMP] = ACTIONS(3057),
    [anon_sym_QMARK] = ACTIONS(3057),
    [anon_sym_EQ_GT] = ACTIONS(3057),
    [anon_sym_LBRACK2] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3057),
    [aux_sym_integer_literal_token1] = ACTIONS(3057),
    [aux_sym_integer_literal_token2] = ACTIONS(3057),
    [aux_sym_integer_literal_token3] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym__unary_operator] = ACTIONS(3055),
    [sym__power_operator] = ACTIONS(3055),
    [sym__bitshift_operator] = ACTIONS(3055),
    [sym__rational_operator] = ACTIONS(3055),
    [sym__times_operator] = ACTIONS(3055),
    [sym__plus_operator] = ACTIONS(3055),
    [sym__dotty_operator] = ACTIONS(3055),
    [sym__comparison_operator] = ACTIONS(3055),
    [sym__arrow_operator] = ACTIONS(3057),
    [sym__assign_operator] = ACTIONS(3055),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3057),
    [sym__command_start] = ACTIONS(3057),
  },
  [1427] = {
    [sym_identifier] = ACTIONS(3067),
    [anon_sym_function] = ACTIONS(3067),
    [anon_sym_end] = ACTIONS(3067),
    [anon_sym_abstract] = ACTIONS(3067),
    [anon_sym_primitive] = ACTIONS(3067),
    [aux_sym_primitive_definition_token1] = ACTIONS(3067),
    [anon_sym_mutable] = ACTIONS(3067),
    [anon_sym_struct] = ACTIONS(3067),
    [anon_sym_module] = ACTIONS(3067),
    [anon_sym_macro] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3069),
    [anon_sym_COMMA] = ACTIONS(3069),
    [anon_sym_RPAREN] = ACTIONS(3069),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3069),
    [anon_sym_COLON_COLON] = ACTIONS(3069),
    [anon_sym_RBRACE] = ACTIONS(3069),
    [anon_sym_LT_COLON] = ACTIONS(3069),
    [anon_sym_if] = ACTIONS(3067),
    [anon_sym_try] = ACTIONS(3067),
    [anon_sym_for] = ACTIONS(3067),
    [anon_sym_while] = ACTIONS(3067),
    [sym_break_statement] = ACTIONS(3067),
    [sym_continue_statement] = ACTIONS(3067),
    [anon_sym_return] = ACTIONS(3067),
    [anon_sym_let] = ACTIONS(3067),
    [anon_sym_const] = ACTIONS(3067),
    [anon_sym_quote] = ACTIONS(3067),
    [anon_sym_using] = ACTIONS(3067),
    [anon_sym_import] = ACTIONS(3067),
    [anon_sym_export] = ACTIONS(3067),
    [anon_sym_COLON2] = ACTIONS(3067),
    [anon_sym_RBRACK] = ACTIONS(3069),
    [anon_sym_begin] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_LT_PIPE] = ACTIONS(3069),
    [anon_sym_PIPE_GT] = ACTIONS(3069),
    [anon_sym_in] = ACTIONS(3067),
    [anon_sym_isa] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_EQ_GT] = ACTIONS(3069),
    [anon_sym_LBRACK2] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3069),
    [aux_sym_integer_literal_token1] = ACTIONS(3069),
    [aux_sym_integer_literal_token2] = ACTIONS(3069),
    [aux_sym_integer_literal_token3] = ACTIONS(3067),
    [sym_float_literal] = ACTIONS(3067),
    [sym__unary_operator] = ACTIONS(3067),
    [sym__power_operator] = ACTIONS(3067),
    [sym__bitshift_operator] = ACTIONS(3067),
    [sym__rational_operator] = ACTIONS(3067),
    [sym__times_operator] = ACTIONS(3067),
    [sym__plus_operator] = ACTIONS(3067),
    [sym__dotty_operator] = ACTIONS(3067),
    [sym__comparison_operator] = ACTIONS(3067),
    [sym__arrow_operator] = ACTIONS(3069),
    [sym__assign_operator] = ACTIONS(3067),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3069),
    [sym__command_start] = ACTIONS(3069),
  },
  [1428] = {
    [sym_identifier] = ACTIONS(2738),
    [anon_sym_function] = ACTIONS(2738),
    [anon_sym_end] = ACTIONS(2738),
    [anon_sym_abstract] = ACTIONS(2738),
    [anon_sym_primitive] = ACTIONS(2738),
    [aux_sym_primitive_definition_token1] = ACTIONS(2738),
    [anon_sym_mutable] = ACTIONS(2738),
    [anon_sym_struct] = ACTIONS(2738),
    [anon_sym_module] = ACTIONS(2738),
    [anon_sym_macro] = ACTIONS(2738),
    [anon_sym_LPAREN] = ACTIONS(2740),
    [anon_sym_COMMA] = ACTIONS(2740),
    [anon_sym_RPAREN] = ACTIONS(2740),
    [anon_sym_SEMI] = ACTIONS(2740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2740),
    [anon_sym_COLON_COLON] = ACTIONS(2740),
    [anon_sym_RBRACE] = ACTIONS(2740),
    [anon_sym_LT_COLON] = ACTIONS(2740),
    [anon_sym_if] = ACTIONS(2738),
    [anon_sym_try] = ACTIONS(2738),
    [anon_sym_for] = ACTIONS(2738),
    [anon_sym_while] = ACTIONS(2738),
    [sym_break_statement] = ACTIONS(2738),
    [sym_continue_statement] = ACTIONS(2738),
    [anon_sym_return] = ACTIONS(2738),
    [anon_sym_let] = ACTIONS(2738),
    [anon_sym_const] = ACTIONS(2738),
    [anon_sym_quote] = ACTIONS(2738),
    [anon_sym_using] = ACTIONS(2738),
    [anon_sym_import] = ACTIONS(2738),
    [anon_sym_COLON] = ACTIONS(2738),
    [anon_sym_DOT] = ACTIONS(2738),
    [anon_sym_export] = ACTIONS(2738),
    [anon_sym_COLON2] = ACTIONS(2738),
    [anon_sym_RBRACK] = ACTIONS(2740),
    [anon_sym_begin] = ACTIONS(2738),
    [anon_sym_SQUOTE] = ACTIONS(2740),
    [anon_sym_PLUS] = ACTIONS(2738),
    [anon_sym_LT_PIPE] = ACTIONS(2740),
    [anon_sym_PIPE_GT] = ACTIONS(2740),
    [anon_sym_in] = ACTIONS(2738),
    [anon_sym_isa] = ACTIONS(2738),
    [anon_sym_PIPE_PIPE] = ACTIONS(2740),
    [anon_sym_AMP_AMP] = ACTIONS(2740),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_EQ_GT] = ACTIONS(2740),
    [anon_sym_LBRACK2] = ACTIONS(2740),
    [anon_sym_DOLLAR] = ACTIONS(2740),
    [anon_sym_AT] = ACTIONS(2740),
    [aux_sym_integer_literal_token1] = ACTIONS(2740),
    [aux_sym_integer_literal_token2] = ACTIONS(2740),
    [aux_sym_integer_literal_token3] = ACTIONS(2738),
    [sym_float_literal] = ACTIONS(2738),
    [sym__unary_operator] = ACTIONS(2738),
    [sym__power_operator] = ACTIONS(2740),
    [sym__bitshift_operator] = ACTIONS(2740),
    [sym__rational_operator] = ACTIONS(2740),
    [sym__times_operator] = ACTIONS(2738),
    [sym__plus_operator] = ACTIONS(2738),
    [sym__dotty_operator] = ACTIONS(2738),
    [sym__comparison_operator] = ACTIONS(2738),
    [sym__arrow_operator] = ACTIONS(2740),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2740),
    [sym__command_start] = ACTIONS(2740),
  },
  [1429] = {
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_COMMA] = ACTIONS(2746),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_LT_COLON] = ACTIONS(2746),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(3303),
    [anon_sym_DOT] = ACTIONS(3305),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_RBRACK] = ACTIONS(2746),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2746),
    [anon_sym_PIPE_GT] = ACTIONS(2746),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_QMARK] = ACTIONS(2746),
    [anon_sym_EQ_GT] = ACTIONS(2746),
    [anon_sym_LBRACK2] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [anon_sym_AT] = ACTIONS(2746),
    [aux_sym_integer_literal_token1] = ACTIONS(2746),
    [aux_sym_integer_literal_token2] = ACTIONS(2746),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2746),
    [sym__bitshift_operator] = ACTIONS(2746),
    [sym__rational_operator] = ACTIONS(2746),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1430] = {
    [sym_identifier] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(2734),
    [anon_sym_end] = ACTIONS(2734),
    [anon_sym_abstract] = ACTIONS(2734),
    [anon_sym_primitive] = ACTIONS(2734),
    [aux_sym_primitive_definition_token1] = ACTIONS(2734),
    [anon_sym_mutable] = ACTIONS(2734),
    [anon_sym_struct] = ACTIONS(2734),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_macro] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_COMMA] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2736),
    [anon_sym_SEMI] = ACTIONS(2736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2736),
    [anon_sym_COLON_COLON] = ACTIONS(2736),
    [anon_sym_RBRACE] = ACTIONS(2736),
    [anon_sym_LT_COLON] = ACTIONS(2736),
    [anon_sym_if] = ACTIONS(2734),
    [anon_sym_try] = ACTIONS(2734),
    [anon_sym_for] = ACTIONS(2734),
    [anon_sym_while] = ACTIONS(2734),
    [sym_break_statement] = ACTIONS(2734),
    [sym_continue_statement] = ACTIONS(2734),
    [anon_sym_return] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_const] = ACTIONS(2734),
    [anon_sym_quote] = ACTIONS(2734),
    [anon_sym_using] = ACTIONS(2734),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_COLON2] = ACTIONS(2734),
    [anon_sym_RBRACK] = ACTIONS(2736),
    [anon_sym_begin] = ACTIONS(2734),
    [anon_sym_SQUOTE] = ACTIONS(2736),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_LT_PIPE] = ACTIONS(2736),
    [anon_sym_PIPE_GT] = ACTIONS(2736),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_isa] = ACTIONS(2734),
    [anon_sym_PIPE_PIPE] = ACTIONS(2736),
    [anon_sym_AMP_AMP] = ACTIONS(2736),
    [anon_sym_QMARK] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2736),
    [anon_sym_LBRACK2] = ACTIONS(2736),
    [anon_sym_DOLLAR] = ACTIONS(2736),
    [anon_sym_AT] = ACTIONS(2736),
    [aux_sym_integer_literal_token1] = ACTIONS(2736),
    [aux_sym_integer_literal_token2] = ACTIONS(2736),
    [aux_sym_integer_literal_token3] = ACTIONS(2734),
    [sym_float_literal] = ACTIONS(2734),
    [sym__unary_operator] = ACTIONS(2734),
    [sym__power_operator] = ACTIONS(2736),
    [sym__bitshift_operator] = ACTIONS(2736),
    [sym__rational_operator] = ACTIONS(2736),
    [sym__times_operator] = ACTIONS(2734),
    [sym__plus_operator] = ACTIONS(2734),
    [sym__dotty_operator] = ACTIONS(2734),
    [sym__comparison_operator] = ACTIONS(2734),
    [sym__arrow_operator] = ACTIONS(2736),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2736),
    [sym__command_start] = ACTIONS(2736),
  },
  [1431] = {
    [aux_sym_import_statement_repeat1] = STATE(1444),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2648),
    [anon_sym_LT_COLON] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_elseif] = ACTIONS(2648),
    [anon_sym_else] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_GT] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_EQ_GT] = ACTIONS(2648),
    [anon_sym_LBRACK2] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2648),
    [aux_sym_integer_literal_token1] = ACTIONS(2648),
    [aux_sym_integer_literal_token2] = ACTIONS(2648),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2648),
    [anon_sym_LF] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1432] = {
    [aux_sym_selected_import_repeat1] = STATE(1487),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_function] = ACTIONS(2827),
    [anon_sym_end] = ACTIONS(2827),
    [anon_sym_abstract] = ACTIONS(2827),
    [anon_sym_primitive] = ACTIONS(2827),
    [aux_sym_primitive_definition_token1] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_module] = ACTIONS(2827),
    [anon_sym_macro] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_COMMA] = ACTIONS(3366),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2831),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_LT_COLON] = ACTIONS(2831),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [sym_break_statement] = ACTIONS(2827),
    [sym_continue_statement] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_quote] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_import] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2827),
    [anon_sym_COLON2] = ACTIONS(2827),
    [anon_sym_RBRACK] = ACTIONS(2831),
    [anon_sym_begin] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_LT_PIPE] = ACTIONS(2831),
    [anon_sym_PIPE_GT] = ACTIONS(2831),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_isa] = ACTIONS(2827),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_EQ_GT] = ACTIONS(2831),
    [anon_sym_LBRACK2] = ACTIONS(2831),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [anon_sym_AT] = ACTIONS(2831),
    [aux_sym_integer_literal_token1] = ACTIONS(2831),
    [aux_sym_integer_literal_token2] = ACTIONS(2831),
    [aux_sym_integer_literal_token3] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
    [sym__unary_operator] = ACTIONS(2827),
    [sym__power_operator] = ACTIONS(2831),
    [sym__bitshift_operator] = ACTIONS(2831),
    [sym__rational_operator] = ACTIONS(2831),
    [sym__times_operator] = ACTIONS(2827),
    [sym__plus_operator] = ACTIONS(2827),
    [sym__dotty_operator] = ACTIONS(2827),
    [sym__comparison_operator] = ACTIONS(2827),
    [sym__arrow_operator] = ACTIONS(2831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2831),
    [sym__command_start] = ACTIONS(2831),
  },
  [1433] = {
    [sym_identifier] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2750),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_LT_COLON] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_elseif] = ACTIONS(2750),
    [anon_sym_else] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2750),
    [anon_sym_PIPE_GT] = ACTIONS(2750),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2750),
    [anon_sym_AMP_AMP] = ACTIONS(2750),
    [anon_sym_QMARK] = ACTIONS(2750),
    [anon_sym_EQ_GT] = ACTIONS(2750),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2750),
    [aux_sym_integer_literal_token1] = ACTIONS(2750),
    [aux_sym_integer_literal_token2] = ACTIONS(2750),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2750),
    [anon_sym_LF] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1434] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_elseif] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3282),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1435] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_elseif] = ACTIONS(2702),
    [anon_sym_else] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3280),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1436] = {
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_function] = ACTIONS(2807),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_abstract] = ACTIONS(2807),
    [anon_sym_primitive] = ACTIONS(2807),
    [aux_sym_primitive_definition_token1] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_module] = ACTIONS(2807),
    [anon_sym_macro] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LT_COLON] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_elseif] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [sym_break_statement] = ACTIONS(2807),
    [sym_continue_statement] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_let] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_quote] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_import] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_begin] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_LT_PIPE] = ACTIONS(2807),
    [anon_sym_PIPE_GT] = ACTIONS(2807),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_isa] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK2] = ACTIONS(2807),
    [anon_sym_DOLLAR] = ACTIONS(2807),
    [anon_sym_AT] = ACTIONS(2807),
    [aux_sym_integer_literal_token1] = ACTIONS(2807),
    [aux_sym_integer_literal_token2] = ACTIONS(2807),
    [aux_sym_integer_literal_token3] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
    [sym__unary_operator] = ACTIONS(2807),
    [sym__power_operator] = ACTIONS(2807),
    [sym__bitshift_operator] = ACTIONS(2807),
    [sym__rational_operator] = ACTIONS(2807),
    [sym__times_operator] = ACTIONS(2807),
    [sym__plus_operator] = ACTIONS(2807),
    [sym__dotty_operator] = ACTIONS(2807),
    [sym__comparison_operator] = ACTIONS(2807),
    [sym__arrow_operator] = ACTIONS(2807),
    [anon_sym_LF] = ACTIONS(2809),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2809),
    [sym__command_start] = ACTIONS(2809),
  },
  [1437] = {
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(2801),
    [anon_sym_end] = ACTIONS(2801),
    [anon_sym_abstract] = ACTIONS(2801),
    [anon_sym_primitive] = ACTIONS(2801),
    [aux_sym_primitive_definition_token1] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_module] = ACTIONS(2801),
    [anon_sym_macro] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2801),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LT_COLON] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_elseif] = ACTIONS(2801),
    [anon_sym_else] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [sym_break_statement] = ACTIONS(2801),
    [sym_continue_statement] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_quote] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2801),
    [anon_sym_export] = ACTIONS(2801),
    [anon_sym_COLON2] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_begin] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_LT_PIPE] = ACTIONS(2801),
    [anon_sym_PIPE_GT] = ACTIONS(2801),
    [anon_sym_in] = ACTIONS(2801),
    [anon_sym_isa] = ACTIONS(2801),
    [anon_sym_PIPE_PIPE] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_QMARK] = ACTIONS(2801),
    [anon_sym_EQ_GT] = ACTIONS(2801),
    [anon_sym_LBRACK2] = ACTIONS(2801),
    [anon_sym_DOLLAR] = ACTIONS(2801),
    [anon_sym_AT] = ACTIONS(2801),
    [aux_sym_integer_literal_token1] = ACTIONS(2801),
    [aux_sym_integer_literal_token2] = ACTIONS(2801),
    [aux_sym_integer_literal_token3] = ACTIONS(2801),
    [sym_float_literal] = ACTIONS(2801),
    [sym__unary_operator] = ACTIONS(2801),
    [sym__power_operator] = ACTIONS(2801),
    [sym__bitshift_operator] = ACTIONS(2801),
    [sym__rational_operator] = ACTIONS(2801),
    [sym__times_operator] = ACTIONS(2801),
    [sym__plus_operator] = ACTIONS(2801),
    [sym__dotty_operator] = ACTIONS(2801),
    [sym__comparison_operator] = ACTIONS(2801),
    [sym__arrow_operator] = ACTIONS(2801),
    [anon_sym_LF] = ACTIONS(2803),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2803),
    [sym__command_start] = ACTIONS(2803),
  },
  [1438] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1469),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_end] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_primitive] = ACTIONS(2900),
    [aux_sym_primitive_definition_token1] = ACTIONS(2900),
    [anon_sym_mutable] = ACTIONS(2900),
    [anon_sym_struct] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_macro] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(312),
    [anon_sym_COLON_COLON] = ACTIONS(314),
    [anon_sym_LT_COLON] = ACTIONS(314),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_elseif] = ACTIONS(2900),
    [anon_sym_else] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [sym_break_statement] = ACTIONS(2900),
    [sym_continue_statement] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_quote] = ACTIONS(2900),
    [anon_sym_using] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_COLON2] = ACTIONS(3370),
    [anon_sym_begin] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(3372),
    [anon_sym_PLUS] = ACTIONS(3374),
    [anon_sym_LT_PIPE] = ACTIONS(3376),
    [anon_sym_PIPE_GT] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3380),
    [anon_sym_isa] = ACTIONS(3380),
    [anon_sym_PIPE_PIPE] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3384),
    [anon_sym_QMARK] = ACTIONS(3386),
    [anon_sym_EQ_GT] = ACTIONS(3388),
    [anon_sym_LBRACK2] = ACTIONS(2900),
    [anon_sym_DOLLAR] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2900),
    [aux_sym_integer_literal_token1] = ACTIONS(2900),
    [aux_sym_integer_literal_token2] = ACTIONS(2900),
    [aux_sym_integer_literal_token3] = ACTIONS(2900),
    [sym_float_literal] = ACTIONS(2900),
    [sym__unary_operator] = ACTIONS(2900),
    [sym__power_operator] = ACTIONS(3390),
    [sym__bitshift_operator] = ACTIONS(3392),
    [sym__rational_operator] = ACTIONS(3394),
    [sym__times_operator] = ACTIONS(3396),
    [sym__plus_operator] = ACTIONS(3374),
    [sym__dotty_operator] = ACTIONS(3398),
    [sym__comparison_operator] = ACTIONS(3380),
    [sym__arrow_operator] = ACTIONS(3400),
    [anon_sym_LF] = ACTIONS(2902),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2902),
    [sym__command_start] = ACTIONS(2902),
  },
  [1439] = {
    [aux_sym_let_statement_repeat1] = STATE(1443),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_abstract] = ACTIONS(2885),
    [anon_sym_primitive] = ACTIONS(2885),
    [aux_sym_primitive_definition_token1] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_macro] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LT_COLON] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_elseif] = ACTIONS(2885),
    [anon_sym_else] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym_break_statement] = ACTIONS(2885),
    [sym_continue_statement] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_quote] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_LT_PIPE] = ACTIONS(2885),
    [anon_sym_PIPE_GT] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2885),
    [aux_sym_integer_literal_token1] = ACTIONS(2885),
    [aux_sym_integer_literal_token2] = ACTIONS(2885),
    [aux_sym_integer_literal_token3] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym__unary_operator] = ACTIONS(2885),
    [sym__power_operator] = ACTIONS(2885),
    [sym__bitshift_operator] = ACTIONS(2885),
    [sym__rational_operator] = ACTIONS(2885),
    [sym__times_operator] = ACTIONS(2885),
    [sym__plus_operator] = ACTIONS(2885),
    [sym__dotty_operator] = ACTIONS(2885),
    [sym__comparison_operator] = ACTIONS(2885),
    [sym__arrow_operator] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2887),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2887),
    [sym__command_start] = ACTIONS(2887),
  },
  [1440] = {
    [aux_sym_export_statement_repeat1] = STATE(1445),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_end] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_primitive] = ACTIONS(2833),
    [aux_sym_primitive_definition_token1] = ACTIONS(2833),
    [anon_sym_mutable] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_macro] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(3404),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2833),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_LT_COLON] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_elseif] = ACTIONS(2833),
    [anon_sym_else] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [sym_break_statement] = ACTIONS(2833),
    [sym_continue_statement] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_quote] = ACTIONS(2833),
    [anon_sym_using] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_COLON2] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_LT_PIPE] = ACTIONS(2833),
    [anon_sym_PIPE_GT] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_isa] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_EQ_GT] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [anon_sym_AT] = ACTIONS(2833),
    [aux_sym_integer_literal_token1] = ACTIONS(2833),
    [aux_sym_integer_literal_token2] = ACTIONS(2833),
    [aux_sym_integer_literal_token3] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym__unary_operator] = ACTIONS(2833),
    [sym__power_operator] = ACTIONS(2833),
    [sym__bitshift_operator] = ACTIONS(2833),
    [sym__rational_operator] = ACTIONS(2833),
    [sym__times_operator] = ACTIONS(2833),
    [sym__plus_operator] = ACTIONS(2833),
    [sym__dotty_operator] = ACTIONS(2833),
    [sym__comparison_operator] = ACTIONS(2833),
    [sym__arrow_operator] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2835),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2835),
    [sym__command_start] = ACTIONS(2835),
  },
  [1441] = {
    [sym_identifier] = ACTIONS(2896),
    [anon_sym_function] = ACTIONS(2896),
    [anon_sym_end] = ACTIONS(2896),
    [anon_sym_abstract] = ACTIONS(2896),
    [anon_sym_primitive] = ACTIONS(2896),
    [aux_sym_primitive_definition_token1] = ACTIONS(2896),
    [anon_sym_mutable] = ACTIONS(2896),
    [anon_sym_struct] = ACTIONS(2896),
    [anon_sym_module] = ACTIONS(2896),
    [anon_sym_macro] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2896),
    [anon_sym_COLON_COLON] = ACTIONS(2896),
    [anon_sym_LT_COLON] = ACTIONS(2896),
    [anon_sym_if] = ACTIONS(2896),
    [anon_sym_elseif] = ACTIONS(2896),
    [anon_sym_else] = ACTIONS(2896),
    [anon_sym_try] = ACTIONS(2896),
    [anon_sym_for] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2896),
    [sym_break_statement] = ACTIONS(2896),
    [sym_continue_statement] = ACTIONS(2896),
    [anon_sym_return] = ACTIONS(2896),
    [anon_sym_let] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_quote] = ACTIONS(2896),
    [anon_sym_using] = ACTIONS(2896),
    [anon_sym_import] = ACTIONS(2896),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_COLON2] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_begin] = ACTIONS(2896),
    [anon_sym_SQUOTE] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT_PIPE] = ACTIONS(2896),
    [anon_sym_PIPE_GT] = ACTIONS(2896),
    [anon_sym_in] = ACTIONS(2896),
    [anon_sym_isa] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_EQ_GT] = ACTIONS(2896),
    [anon_sym_LBRACK2] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_AT] = ACTIONS(2896),
    [aux_sym_integer_literal_token1] = ACTIONS(2896),
    [aux_sym_integer_literal_token2] = ACTIONS(2896),
    [aux_sym_integer_literal_token3] = ACTIONS(2896),
    [sym_float_literal] = ACTIONS(2896),
    [sym__unary_operator] = ACTIONS(2896),
    [sym__power_operator] = ACTIONS(2896),
    [sym__bitshift_operator] = ACTIONS(2896),
    [sym__rational_operator] = ACTIONS(2896),
    [sym__times_operator] = ACTIONS(2896),
    [sym__plus_operator] = ACTIONS(2896),
    [sym__dotty_operator] = ACTIONS(2896),
    [sym__comparison_operator] = ACTIONS(2896),
    [sym__arrow_operator] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2898),
    [sym__command_start] = ACTIONS(2898),
  },
  [1442] = {
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_end] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_primitive] = ACTIONS(2791),
    [aux_sym_primitive_definition_token1] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_macro] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2791),
    [anon_sym_LT_COLON] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_elseif] = ACTIONS(2791),
    [anon_sym_else] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [sym_break_statement] = ACTIONS(2791),
    [sym_continue_statement] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_quote] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_COLON2] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_LT_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_GT] = ACTIONS(2791),
    [anon_sym_in] = ACTIONS(2791),
    [anon_sym_isa] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_EQ_GT] = ACTIONS(2791),
    [anon_sym_LBRACK2] = ACTIONS(2791),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_AT] = ACTIONS(2791),
    [aux_sym_integer_literal_token1] = ACTIONS(2791),
    [aux_sym_integer_literal_token2] = ACTIONS(2791),
    [aux_sym_integer_literal_token3] = ACTIONS(2791),
    [sym_float_literal] = ACTIONS(2791),
    [sym__unary_operator] = ACTIONS(2791),
    [sym__power_operator] = ACTIONS(2791),
    [sym__bitshift_operator] = ACTIONS(2791),
    [sym__rational_operator] = ACTIONS(2791),
    [sym__times_operator] = ACTIONS(2791),
    [sym__plus_operator] = ACTIONS(2791),
    [sym__dotty_operator] = ACTIONS(2791),
    [sym__comparison_operator] = ACTIONS(2791),
    [sym__arrow_operator] = ACTIONS(2791),
    [anon_sym_LF] = ACTIONS(2793),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2793),
    [sym__command_start] = ACTIONS(2793),
  },
  [1443] = {
    [aux_sym_let_statement_repeat1] = STATE(1482),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_end] = ACTIONS(2766),
    [anon_sym_abstract] = ACTIONS(2766),
    [anon_sym_primitive] = ACTIONS(2766),
    [aux_sym_primitive_definition_token1] = ACTIONS(2766),
    [anon_sym_mutable] = ACTIONS(2766),
    [anon_sym_struct] = ACTIONS(2766),
    [anon_sym_module] = ACTIONS(2766),
    [anon_sym_macro] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2766),
    [anon_sym_LT_COLON] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_elseif] = ACTIONS(2766),
    [anon_sym_else] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [sym_break_statement] = ACTIONS(2766),
    [sym_continue_statement] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_quote] = ACTIONS(2766),
    [anon_sym_using] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2766),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_COLON2] = ACTIONS(2766),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_LT_PIPE] = ACTIONS(2766),
    [anon_sym_PIPE_GT] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(2766),
    [anon_sym_isa] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_EQ_GT] = ACTIONS(2766),
    [anon_sym_LBRACK2] = ACTIONS(2766),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2766),
    [aux_sym_integer_literal_token1] = ACTIONS(2766),
    [aux_sym_integer_literal_token2] = ACTIONS(2766),
    [aux_sym_integer_literal_token3] = ACTIONS(2766),
    [sym_float_literal] = ACTIONS(2766),
    [sym__unary_operator] = ACTIONS(2766),
    [sym__power_operator] = ACTIONS(2766),
    [sym__bitshift_operator] = ACTIONS(2766),
    [sym__rational_operator] = ACTIONS(2766),
    [sym__times_operator] = ACTIONS(2766),
    [sym__plus_operator] = ACTIONS(2766),
    [sym__dotty_operator] = ACTIONS(2766),
    [sym__comparison_operator] = ACTIONS(2766),
    [sym__arrow_operator] = ACTIONS(2766),
    [anon_sym_LF] = ACTIONS(2770),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2770),
    [sym__command_start] = ACTIONS(2770),
  },
  [1444] = {
    [aux_sym_import_statement_repeat1] = STATE(1450),
    [sym_identifier] = ACTIONS(2754),
    [anon_sym_function] = ACTIONS(2754),
    [anon_sym_end] = ACTIONS(2754),
    [anon_sym_abstract] = ACTIONS(2754),
    [anon_sym_primitive] = ACTIONS(2754),
    [aux_sym_primitive_definition_token1] = ACTIONS(2754),
    [anon_sym_mutable] = ACTIONS(2754),
    [anon_sym_struct] = ACTIONS(2754),
    [anon_sym_module] = ACTIONS(2754),
    [anon_sym_macro] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2754),
    [anon_sym_LT_COLON] = ACTIONS(2754),
    [anon_sym_if] = ACTIONS(2754),
    [anon_sym_elseif] = ACTIONS(2754),
    [anon_sym_else] = ACTIONS(2754),
    [anon_sym_try] = ACTIONS(2754),
    [anon_sym_for] = ACTIONS(2754),
    [anon_sym_while] = ACTIONS(2754),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2754),
    [anon_sym_let] = ACTIONS(2754),
    [anon_sym_const] = ACTIONS(2754),
    [anon_sym_quote] = ACTIONS(2754),
    [anon_sym_using] = ACTIONS(2754),
    [anon_sym_import] = ACTIONS(2754),
    [anon_sym_export] = ACTIONS(2754),
    [anon_sym_COLON2] = ACTIONS(2754),
    [anon_sym_begin] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [anon_sym_PLUS] = ACTIONS(2754),
    [anon_sym_LT_PIPE] = ACTIONS(2754),
    [anon_sym_PIPE_GT] = ACTIONS(2754),
    [anon_sym_in] = ACTIONS(2754),
    [anon_sym_isa] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_QMARK] = ACTIONS(2754),
    [anon_sym_EQ_GT] = ACTIONS(2754),
    [anon_sym_LBRACK2] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [anon_sym_AT] = ACTIONS(2754),
    [aux_sym_integer_literal_token1] = ACTIONS(2754),
    [aux_sym_integer_literal_token2] = ACTIONS(2754),
    [aux_sym_integer_literal_token3] = ACTIONS(2754),
    [sym_float_literal] = ACTIONS(2754),
    [sym__unary_operator] = ACTIONS(2754),
    [sym__power_operator] = ACTIONS(2754),
    [sym__bitshift_operator] = ACTIONS(2754),
    [sym__rational_operator] = ACTIONS(2754),
    [sym__times_operator] = ACTIONS(2754),
    [sym__plus_operator] = ACTIONS(2754),
    [sym__dotty_operator] = ACTIONS(2754),
    [sym__comparison_operator] = ACTIONS(2754),
    [sym__arrow_operator] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2756),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2756),
    [sym__command_start] = ACTIONS(2756),
  },
  [1445] = {
    [aux_sym_export_statement_repeat1] = STATE(1451),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_function] = ACTIONS(2795),
    [anon_sym_end] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2795),
    [anon_sym_primitive] = ACTIONS(2795),
    [aux_sym_primitive_definition_token1] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_macro] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_COMMA] = ACTIONS(3404),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2795),
    [anon_sym_LT_COLON] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_elseif] = ACTIONS(2795),
    [anon_sym_else] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [sym_break_statement] = ACTIONS(2795),
    [sym_continue_statement] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_let] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_quote] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_import] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2795),
    [anon_sym_COLON2] = ACTIONS(2795),
    [anon_sym_begin] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_LT_PIPE] = ACTIONS(2795),
    [anon_sym_PIPE_GT] = ACTIONS(2795),
    [anon_sym_in] = ACTIONS(2795),
    [anon_sym_isa] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2795),
    [anon_sym_AMP_AMP] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(2795),
    [anon_sym_EQ_GT] = ACTIONS(2795),
    [anon_sym_LBRACK2] = ACTIONS(2795),
    [anon_sym_DOLLAR] = ACTIONS(2795),
    [anon_sym_AT] = ACTIONS(2795),
    [aux_sym_integer_literal_token1] = ACTIONS(2795),
    [aux_sym_integer_literal_token2] = ACTIONS(2795),
    [aux_sym_integer_literal_token3] = ACTIONS(2795),
    [sym_float_literal] = ACTIONS(2795),
    [sym__unary_operator] = ACTIONS(2795),
    [sym__power_operator] = ACTIONS(2795),
    [sym__bitshift_operator] = ACTIONS(2795),
    [sym__rational_operator] = ACTIONS(2795),
    [sym__times_operator] = ACTIONS(2795),
    [sym__plus_operator] = ACTIONS(2795),
    [sym__dotty_operator] = ACTIONS(2795),
    [sym__comparison_operator] = ACTIONS(2795),
    [sym__arrow_operator] = ACTIONS(2795),
    [anon_sym_LF] = ACTIONS(2799),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2799),
    [sym__command_start] = ACTIONS(2799),
  },
  [1446] = {
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_end] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_primitive] = ACTIONS(2904),
    [aux_sym_primitive_definition_token1] = ACTIONS(2904),
    [anon_sym_mutable] = ACTIONS(2904),
    [anon_sym_struct] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_macro] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2904),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2904),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LT_COLON] = ACTIONS(2904),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_elseif] = ACTIONS(2904),
    [anon_sym_else] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [sym_break_statement] = ACTIONS(2904),
    [sym_continue_statement] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_quote] = ACTIONS(2904),
    [anon_sym_using] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_COLON2] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_begin] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_LT_PIPE] = ACTIONS(2904),
    [anon_sym_PIPE_GT] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2904),
    [anon_sym_isa] = ACTIONS(2904),
    [anon_sym_PIPE_PIPE] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2904),
    [anon_sym_QMARK] = ACTIONS(2904),
    [anon_sym_EQ_GT] = ACTIONS(2904),
    [anon_sym_LBRACK2] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2904),
    [anon_sym_AT] = ACTIONS(2904),
    [aux_sym_integer_literal_token1] = ACTIONS(2904),
    [aux_sym_integer_literal_token2] = ACTIONS(2904),
    [aux_sym_integer_literal_token3] = ACTIONS(2904),
    [sym_float_literal] = ACTIONS(2904),
    [sym__unary_operator] = ACTIONS(2904),
    [sym__power_operator] = ACTIONS(2904),
    [sym__bitshift_operator] = ACTIONS(2904),
    [sym__rational_operator] = ACTIONS(2904),
    [sym__times_operator] = ACTIONS(2904),
    [sym__plus_operator] = ACTIONS(2904),
    [sym__dotty_operator] = ACTIONS(2904),
    [sym__comparison_operator] = ACTIONS(2904),
    [sym__arrow_operator] = ACTIONS(2904),
    [anon_sym_LF] = ACTIONS(2906),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2906),
    [sym__command_start] = ACTIONS(2906),
  },
  [1447] = {
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_function] = ACTIONS(2779),
    [anon_sym_end] = ACTIONS(2779),
    [anon_sym_abstract] = ACTIONS(2779),
    [anon_sym_primitive] = ACTIONS(2779),
    [aux_sym_primitive_definition_token1] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_module] = ACTIONS(2779),
    [anon_sym_macro] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2779),
    [anon_sym_LT_COLON] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_elseif] = ACTIONS(2779),
    [anon_sym_else] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [sym_break_statement] = ACTIONS(2779),
    [sym_continue_statement] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_let] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_quote] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_import] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(2779),
    [anon_sym_COLON2] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [anon_sym_begin] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_LT_PIPE] = ACTIONS(2779),
    [anon_sym_PIPE_GT] = ACTIONS(2779),
    [anon_sym_in] = ACTIONS(2779),
    [anon_sym_isa] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE] = ACTIONS(2779),
    [anon_sym_AMP_AMP] = ACTIONS(2779),
    [anon_sym_QMARK] = ACTIONS(2779),
    [anon_sym_EQ_GT] = ACTIONS(2779),
    [anon_sym_LBRACK2] = ACTIONS(2779),
    [anon_sym_DOLLAR] = ACTIONS(2779),
    [anon_sym_AT] = ACTIONS(2779),
    [aux_sym_integer_literal_token1] = ACTIONS(2779),
    [aux_sym_integer_literal_token2] = ACTIONS(2779),
    [aux_sym_integer_literal_token3] = ACTIONS(2779),
    [sym_float_literal] = ACTIONS(2779),
    [sym__unary_operator] = ACTIONS(2779),
    [sym__power_operator] = ACTIONS(2779),
    [sym__bitshift_operator] = ACTIONS(2779),
    [sym__rational_operator] = ACTIONS(2779),
    [sym__times_operator] = ACTIONS(2779),
    [sym__plus_operator] = ACTIONS(2779),
    [sym__dotty_operator] = ACTIONS(2779),
    [sym__comparison_operator] = ACTIONS(2779),
    [sym__arrow_operator] = ACTIONS(2779),
    [anon_sym_LF] = ACTIONS(2781),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2781),
    [sym__command_start] = ACTIONS(2781),
  },
  [1448] = {
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_end] = ACTIONS(2758),
    [anon_sym_abstract] = ACTIONS(2758),
    [anon_sym_primitive] = ACTIONS(2758),
    [aux_sym_primitive_definition_token1] = ACTIONS(2758),
    [anon_sym_mutable] = ACTIONS(2758),
    [anon_sym_struct] = ACTIONS(2758),
    [anon_sym_module] = ACTIONS(2758),
    [anon_sym_macro] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2758),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_LT_COLON] = ACTIONS(2758),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_elseif] = ACTIONS(2758),
    [anon_sym_else] = ACTIONS(2758),
    [anon_sym_try] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [sym_break_statement] = ACTIONS(2758),
    [sym_continue_statement] = ACTIONS(2758),
    [anon_sym_return] = ACTIONS(2758),
    [anon_sym_let] = ACTIONS(2758),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_quote] = ACTIONS(2758),
    [anon_sym_using] = ACTIONS(2758),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_export] = ACTIONS(2758),
    [anon_sym_COLON2] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_begin] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2758),
    [anon_sym_LT_PIPE] = ACTIONS(2758),
    [anon_sym_PIPE_GT] = ACTIONS(2758),
    [anon_sym_in] = ACTIONS(2758),
    [anon_sym_isa] = ACTIONS(2758),
    [anon_sym_PIPE_PIPE] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(2758),
    [anon_sym_QMARK] = ACTIONS(2758),
    [anon_sym_EQ_GT] = ACTIONS(2758),
    [anon_sym_LBRACK2] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2758),
    [anon_sym_AT] = ACTIONS(2758),
    [aux_sym_integer_literal_token1] = ACTIONS(2758),
    [aux_sym_integer_literal_token2] = ACTIONS(2758),
    [aux_sym_integer_literal_token3] = ACTIONS(2758),
    [sym_float_literal] = ACTIONS(2758),
    [sym__unary_operator] = ACTIONS(2758),
    [sym__power_operator] = ACTIONS(2758),
    [sym__bitshift_operator] = ACTIONS(2758),
    [sym__rational_operator] = ACTIONS(2758),
    [sym__times_operator] = ACTIONS(2758),
    [sym__plus_operator] = ACTIONS(2758),
    [sym__dotty_operator] = ACTIONS(2758),
    [sym__comparison_operator] = ACTIONS(2758),
    [sym__arrow_operator] = ACTIONS(2758),
    [anon_sym_LF] = ACTIONS(2760),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2760),
    [sym__command_start] = ACTIONS(2760),
  },
  [1449] = {
    [aux_sym_selected_import_repeat1] = STATE(1456),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_function] = ACTIONS(2827),
    [anon_sym_end] = ACTIONS(2827),
    [anon_sym_abstract] = ACTIONS(2827),
    [anon_sym_primitive] = ACTIONS(2827),
    [aux_sym_primitive_definition_token1] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_module] = ACTIONS(2827),
    [anon_sym_macro] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2827),
    [anon_sym_LT_COLON] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_elseif] = ACTIONS(2827),
    [anon_sym_else] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [sym_break_statement] = ACTIONS(2827),
    [sym_continue_statement] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_quote] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_import] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2827),
    [anon_sym_COLON2] = ACTIONS(2827),
    [anon_sym_begin] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2827),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_LT_PIPE] = ACTIONS(2827),
    [anon_sym_PIPE_GT] = ACTIONS(2827),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_isa] = ACTIONS(2827),
    [anon_sym_PIPE_PIPE] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_EQ_GT] = ACTIONS(2827),
    [anon_sym_LBRACK2] = ACTIONS(2827),
    [anon_sym_DOLLAR] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(2827),
    [aux_sym_integer_literal_token1] = ACTIONS(2827),
    [aux_sym_integer_literal_token2] = ACTIONS(2827),
    [aux_sym_integer_literal_token3] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
    [sym__unary_operator] = ACTIONS(2827),
    [sym__power_operator] = ACTIONS(2827),
    [sym__bitshift_operator] = ACTIONS(2827),
    [sym__rational_operator] = ACTIONS(2827),
    [sym__times_operator] = ACTIONS(2827),
    [sym__plus_operator] = ACTIONS(2827),
    [sym__dotty_operator] = ACTIONS(2827),
    [sym__comparison_operator] = ACTIONS(2827),
    [sym__arrow_operator] = ACTIONS(2827),
    [anon_sym_LF] = ACTIONS(2831),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2831),
    [sym__command_start] = ACTIONS(2831),
  },
  [1450] = {
    [aux_sym_import_statement_repeat1] = STATE(1450),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(3408),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2744),
    [anon_sym_LT_COLON] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_elseif] = ACTIONS(2744),
    [anon_sym_else] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2744),
    [anon_sym_PIPE_GT] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_LBRACK2] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [aux_sym_integer_literal_token1] = ACTIONS(2744),
    [aux_sym_integer_literal_token2] = ACTIONS(2744),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1451] = {
    [aux_sym_export_statement_repeat1] = STATE(1451),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_end] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_primitive] = ACTIONS(2817),
    [aux_sym_primitive_definition_token1] = ACTIONS(2817),
    [anon_sym_mutable] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_macro] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(3411),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2817),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LT_COLON] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_elseif] = ACTIONS(2817),
    [anon_sym_else] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [sym_break_statement] = ACTIONS(2817),
    [sym_continue_statement] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_quote] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_COLON2] = ACTIONS(2817),
    [anon_sym_begin] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_LT_PIPE] = ACTIONS(2817),
    [anon_sym_PIPE_GT] = ACTIONS(2817),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_isa] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(2817),
    [anon_sym_LBRACK2] = ACTIONS(2817),
    [anon_sym_DOLLAR] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2817),
    [aux_sym_integer_literal_token1] = ACTIONS(2817),
    [aux_sym_integer_literal_token2] = ACTIONS(2817),
    [aux_sym_integer_literal_token3] = ACTIONS(2817),
    [sym_float_literal] = ACTIONS(2817),
    [sym__unary_operator] = ACTIONS(2817),
    [sym__power_operator] = ACTIONS(2817),
    [sym__bitshift_operator] = ACTIONS(2817),
    [sym__rational_operator] = ACTIONS(2817),
    [sym__times_operator] = ACTIONS(2817),
    [sym__plus_operator] = ACTIONS(2817),
    [sym__dotty_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(2817),
    [sym__arrow_operator] = ACTIONS(2817),
    [anon_sym_LF] = ACTIONS(2822),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2822),
    [sym__command_start] = ACTIONS(2822),
  },
  [1452] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(2777),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_primitive] = ACTIONS(2772),
    [aux_sym_primitive_definition_token1] = ACTIONS(2772),
    [anon_sym_mutable] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_macro] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_COMMA] = ACTIONS(3414),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_EQ] = ACTIONS(2772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2772),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_LT_COLON] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [sym_break_statement] = ACTIONS(2772),
    [sym_continue_statement] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_quote] = ACTIONS(2772),
    [anon_sym_using] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_COLON2] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_LT_PIPE] = ACTIONS(2772),
    [anon_sym_PIPE_GT] = ACTIONS(2772),
    [anon_sym_in] = ACTIONS(2772),
    [anon_sym_isa] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2772),
    [anon_sym_EQ_GT] = ACTIONS(2772),
    [anon_sym_LBRACK2] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2772),
    [aux_sym_integer_literal_token1] = ACTIONS(2772),
    [aux_sym_integer_literal_token2] = ACTIONS(2772),
    [aux_sym_integer_literal_token3] = ACTIONS(2772),
    [sym_float_literal] = ACTIONS(2772),
    [sym__unary_operator] = ACTIONS(2772),
    [sym__power_operator] = ACTIONS(2772),
    [sym__bitshift_operator] = ACTIONS(2772),
    [sym__rational_operator] = ACTIONS(2772),
    [sym__times_operator] = ACTIONS(2772),
    [sym__plus_operator] = ACTIONS(2772),
    [sym__dotty_operator] = ACTIONS(2772),
    [sym__comparison_operator] = ACTIONS(2772),
    [sym__arrow_operator] = ACTIONS(2772),
    [sym__assign_operator] = ACTIONS(2772),
    [anon_sym_LF] = ACTIONS(2777),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2777),
    [sym__command_start] = ACTIONS(2777),
  },
  [1453] = {
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_function] = ACTIONS(2787),
    [anon_sym_end] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2787),
    [anon_sym_primitive] = ACTIONS(2787),
    [aux_sym_primitive_definition_token1] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_macro] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2787),
    [anon_sym_LT_COLON] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_elseif] = ACTIONS(2787),
    [anon_sym_else] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [sym_break_statement] = ACTIONS(2787),
    [sym_continue_statement] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_quote] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_COLON2] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_LT_PIPE] = ACTIONS(2787),
    [anon_sym_PIPE_GT] = ACTIONS(2787),
    [anon_sym_in] = ACTIONS(2787),
    [anon_sym_isa] = ACTIONS(2787),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_GT] = ACTIONS(2787),
    [anon_sym_LBRACK2] = ACTIONS(2787),
    [anon_sym_DOLLAR] = ACTIONS(2787),
    [anon_sym_AT] = ACTIONS(2787),
    [aux_sym_integer_literal_token1] = ACTIONS(2787),
    [aux_sym_integer_literal_token2] = ACTIONS(2787),
    [aux_sym_integer_literal_token3] = ACTIONS(2787),
    [sym_float_literal] = ACTIONS(2787),
    [sym__unary_operator] = ACTIONS(2787),
    [sym__power_operator] = ACTIONS(2787),
    [sym__bitshift_operator] = ACTIONS(2787),
    [sym__rational_operator] = ACTIONS(2787),
    [sym__times_operator] = ACTIONS(2787),
    [sym__plus_operator] = ACTIONS(2787),
    [sym__dotty_operator] = ACTIONS(2787),
    [sym__comparison_operator] = ACTIONS(2787),
    [sym__arrow_operator] = ACTIONS(2787),
    [anon_sym_LF] = ACTIONS(2789),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2789),
    [sym__command_start] = ACTIONS(2789),
  },
  [1454] = {
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_end] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_primitive] = ACTIONS(2783),
    [aux_sym_primitive_definition_token1] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_module] = ACTIONS(2783),
    [anon_sym_macro] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2783),
    [anon_sym_LT_COLON] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_elseif] = ACTIONS(2783),
    [anon_sym_else] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [sym_break_statement] = ACTIONS(2783),
    [sym_continue_statement] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_quote] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_import] = ACTIONS(2783),
    [anon_sym_export] = ACTIONS(2783),
    [anon_sym_COLON2] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_LT_PIPE] = ACTIONS(2783),
    [anon_sym_PIPE_GT] = ACTIONS(2783),
    [anon_sym_in] = ACTIONS(2783),
    [anon_sym_isa] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_EQ_GT] = ACTIONS(2783),
    [anon_sym_LBRACK2] = ACTIONS(2783),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_AT] = ACTIONS(2783),
    [aux_sym_integer_literal_token1] = ACTIONS(2783),
    [aux_sym_integer_literal_token2] = ACTIONS(2783),
    [aux_sym_integer_literal_token3] = ACTIONS(2783),
    [sym_float_literal] = ACTIONS(2783),
    [sym__unary_operator] = ACTIONS(2783),
    [sym__power_operator] = ACTIONS(2783),
    [sym__bitshift_operator] = ACTIONS(2783),
    [sym__rational_operator] = ACTIONS(2783),
    [sym__times_operator] = ACTIONS(2783),
    [sym__plus_operator] = ACTIONS(2783),
    [sym__dotty_operator] = ACTIONS(2783),
    [sym__comparison_operator] = ACTIONS(2783),
    [sym__arrow_operator] = ACTIONS(2783),
    [anon_sym_LF] = ACTIONS(2785),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2785),
    [sym__command_start] = ACTIONS(2785),
  },
  [1455] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1458),
    [ts_builtin_sym_end] = ACTIONS(2883),
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_COMMA] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(3417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LT_COLON] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(3423),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_LT_PIPE] = ACTIONS(3429),
    [anon_sym_PIPE_GT] = ACTIONS(3431),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_isa] = ACTIONS(3433),
    [anon_sym_PIPE_PIPE] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_QMARK] = ACTIONS(3439),
    [anon_sym_EQ_GT] = ACTIONS(3441),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(3443),
    [sym__bitshift_operator] = ACTIONS(3445),
    [sym__rational_operator] = ACTIONS(3447),
    [sym__times_operator] = ACTIONS(3449),
    [sym__plus_operator] = ACTIONS(3427),
    [sym__dotty_operator] = ACTIONS(3451),
    [sym__comparison_operator] = ACTIONS(3433),
    [sym__arrow_operator] = ACTIONS(3453),
    [sym__assign_operator] = ACTIONS(3417),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1456] = {
    [aux_sym_selected_import_repeat1] = STATE(1457),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_end] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_primitive] = ACTIONS(2908),
    [aux_sym_primitive_definition_token1] = ACTIONS(2908),
    [anon_sym_mutable] = ACTIONS(2908),
    [anon_sym_struct] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_macro] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_LT_COLON] = ACTIONS(2908),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_elseif] = ACTIONS(2908),
    [anon_sym_else] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [sym_break_statement] = ACTIONS(2908),
    [sym_continue_statement] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_quote] = ACTIONS(2908),
    [anon_sym_using] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_COLON2] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_LT_PIPE] = ACTIONS(2908),
    [anon_sym_PIPE_GT] = ACTIONS(2908),
    [anon_sym_in] = ACTIONS(2908),
    [anon_sym_isa] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_EQ_GT] = ACTIONS(2908),
    [anon_sym_LBRACK2] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2908),
    [aux_sym_integer_literal_token1] = ACTIONS(2908),
    [aux_sym_integer_literal_token2] = ACTIONS(2908),
    [aux_sym_integer_literal_token3] = ACTIONS(2908),
    [sym_float_literal] = ACTIONS(2908),
    [sym__unary_operator] = ACTIONS(2908),
    [sym__power_operator] = ACTIONS(2908),
    [sym__bitshift_operator] = ACTIONS(2908),
    [sym__rational_operator] = ACTIONS(2908),
    [sym__times_operator] = ACTIONS(2908),
    [sym__plus_operator] = ACTIONS(2908),
    [sym__dotty_operator] = ACTIONS(2908),
    [sym__comparison_operator] = ACTIONS(2908),
    [sym__arrow_operator] = ACTIONS(2908),
    [anon_sym_LF] = ACTIONS(2910),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2910),
    [sym__command_start] = ACTIONS(2910),
  },
  [1457] = {
    [aux_sym_selected_import_repeat1] = STATE(1457),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_end] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_primitive] = ACTIONS(2889),
    [aux_sym_primitive_definition_token1] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_macro] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LT_COLON] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_elseif] = ACTIONS(2889),
    [anon_sym_else] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [sym_break_statement] = ACTIONS(2889),
    [sym_continue_statement] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_quote] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_COLON2] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_LT_PIPE] = ACTIONS(2889),
    [anon_sym_PIPE_GT] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_EQ_GT] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2889),
    [aux_sym_integer_literal_token1] = ACTIONS(2889),
    [aux_sym_integer_literal_token2] = ACTIONS(2889),
    [aux_sym_integer_literal_token3] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym__unary_operator] = ACTIONS(2889),
    [sym__power_operator] = ACTIONS(2889),
    [sym__bitshift_operator] = ACTIONS(2889),
    [sym__rational_operator] = ACTIONS(2889),
    [sym__times_operator] = ACTIONS(2889),
    [sym__plus_operator] = ACTIONS(2889),
    [sym__dotty_operator] = ACTIONS(2889),
    [sym__comparison_operator] = ACTIONS(2889),
    [sym__arrow_operator] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2894),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2894),
    [sym__command_start] = ACTIONS(2894),
  },
  [1458] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1452),
    [ts_builtin_sym_end] = ACTIONS(2815),
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_function] = ACTIONS(2811),
    [anon_sym_abstract] = ACTIONS(2811),
    [anon_sym_primitive] = ACTIONS(2811),
    [aux_sym_primitive_definition_token1] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_macro] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_EQ] = ACTIONS(2811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LT_COLON] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [sym_break_statement] = ACTIONS(2811),
    [sym_continue_statement] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_quote] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_COLON2] = ACTIONS(2811),
    [anon_sym_begin] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_LT_PIPE] = ACTIONS(2811),
    [anon_sym_PIPE_GT] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_isa] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_QMARK] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_LBRACK2] = ACTIONS(2811),
    [anon_sym_DOLLAR] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2811),
    [aux_sym_integer_literal_token1] = ACTIONS(2811),
    [aux_sym_integer_literal_token2] = ACTIONS(2811),
    [aux_sym_integer_literal_token3] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
    [sym__unary_operator] = ACTIONS(2811),
    [sym__power_operator] = ACTIONS(2811),
    [sym__bitshift_operator] = ACTIONS(2811),
    [sym__rational_operator] = ACTIONS(2811),
    [sym__times_operator] = ACTIONS(2811),
    [sym__plus_operator] = ACTIONS(2811),
    [sym__dotty_operator] = ACTIONS(2811),
    [sym__comparison_operator] = ACTIONS(2811),
    [sym__arrow_operator] = ACTIONS(2811),
    [sym__assign_operator] = ACTIONS(2811),
    [anon_sym_LF] = ACTIONS(2815),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2815),
    [sym__command_start] = ACTIONS(2815),
  },
  [1459] = {
    [sym_identifier] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_end] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2752),
    [anon_sym_COMMA] = ACTIONS(2752),
    [anon_sym_RPAREN] = ACTIONS(2752),
    [anon_sym_SEMI] = ACTIONS(2752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2752),
    [anon_sym_COLON_COLON] = ACTIONS(2752),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_LT_COLON] = ACTIONS(2752),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_RBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2752),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2752),
    [anon_sym_PIPE_GT] = ACTIONS(2752),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2752),
    [anon_sym_AMP_AMP] = ACTIONS(2752),
    [anon_sym_QMARK] = ACTIONS(2752),
    [anon_sym_EQ_GT] = ACTIONS(2752),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2752),
    [anon_sym_AT] = ACTIONS(2752),
    [aux_sym_integer_literal_token1] = ACTIONS(2752),
    [aux_sym_integer_literal_token2] = ACTIONS(2752),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2752),
    [sym__bitshift_operator] = ACTIONS(2752),
    [sym__rational_operator] = ACTIONS(2752),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1460] = {
    [sym_identifier] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_primitive] = ACTIONS(304),
    [aux_sym_primitive_definition_token1] = ACTIONS(304),
    [anon_sym_mutable] = ACTIONS(304),
    [anon_sym_struct] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_macro] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_elseif] = ACTIONS(304),
    [anon_sym_else] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [sym_break_statement] = ACTIONS(304),
    [sym_continue_statement] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_quote] = ACTIONS(304),
    [anon_sym_using] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_COLON2] = ACTIONS(304),
    [anon_sym_begin] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(304),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(304),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(304),
    [aux_sym_integer_literal_token1] = ACTIONS(304),
    [aux_sym_integer_literal_token2] = ACTIONS(304),
    [aux_sym_integer_literal_token3] = ACTIONS(304),
    [sym_float_literal] = ACTIONS(304),
    [sym__unary_operator] = ACTIONS(304),
    [sym__power_operator] = ACTIONS(304),
    [sym__bitshift_operator] = ACTIONS(304),
    [sym__rational_operator] = ACTIONS(304),
    [sym__times_operator] = ACTIONS(304),
    [sym__plus_operator] = ACTIONS(304),
    [sym__dotty_operator] = ACTIONS(304),
    [sym__comparison_operator] = ACTIONS(304),
    [sym__arrow_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(306),
    [sym__command_start] = ACTIONS(306),
  },
  [1461] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_COMMA] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_LT_COLON] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_RBRACK] = ACTIONS(2708),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_GT] = ACTIONS(2708),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2708),
    [anon_sym_AMP_AMP] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2708),
    [anon_sym_EQ_GT] = ACTIONS(2708),
    [anon_sym_LBRACK2] = ACTIONS(2708),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_AT] = ACTIONS(2708),
    [aux_sym_integer_literal_token1] = ACTIONS(2708),
    [aux_sym_integer_literal_token2] = ACTIONS(2708),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2708),
    [sym__bitshift_operator] = ACTIONS(2708),
    [sym__rational_operator] = ACTIONS(2708),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3321),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1462] = {
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_end] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2708),
    [anon_sym_COMMA] = ACTIONS(2708),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [anon_sym_SEMI] = ACTIONS(2708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2708),
    [anon_sym_COLON_COLON] = ACTIONS(2708),
    [anon_sym_RBRACE] = ACTIONS(2708),
    [anon_sym_LT_COLON] = ACTIONS(2708),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3319),
    [anon_sym_RBRACK] = ACTIONS(2708),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2708),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_GT] = ACTIONS(2708),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2708),
    [anon_sym_AMP_AMP] = ACTIONS(2708),
    [anon_sym_QMARK] = ACTIONS(2708),
    [anon_sym_EQ_GT] = ACTIONS(2708),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2708),
    [anon_sym_AT] = ACTIONS(2708),
    [aux_sym_integer_literal_token1] = ACTIONS(2708),
    [aux_sym_integer_literal_token2] = ACTIONS(2708),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2708),
    [sym__bitshift_operator] = ACTIONS(2708),
    [sym__rational_operator] = ACTIONS(2708),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1463] = {
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_function] = ACTIONS(2807),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_abstract] = ACTIONS(2807),
    [anon_sym_primitive] = ACTIONS(2807),
    [aux_sym_primitive_definition_token1] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_module] = ACTIONS(2807),
    [anon_sym_macro] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2809),
    [anon_sym_RPAREN] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2809),
    [anon_sym_LT_COLON] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [sym_break_statement] = ACTIONS(2807),
    [sym_continue_statement] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_let] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_quote] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_import] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_RBRACK] = ACTIONS(2809),
    [anon_sym_begin] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_LT_PIPE] = ACTIONS(2809),
    [anon_sym_PIPE_GT] = ACTIONS(2809),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_isa] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2809),
    [anon_sym_LBRACK2] = ACTIONS(2807),
    [anon_sym_DOLLAR] = ACTIONS(2809),
    [anon_sym_AT] = ACTIONS(2809),
    [aux_sym_integer_literal_token1] = ACTIONS(2809),
    [aux_sym_integer_literal_token2] = ACTIONS(2809),
    [aux_sym_integer_literal_token3] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
    [sym__unary_operator] = ACTIONS(2807),
    [sym__power_operator] = ACTIONS(2809),
    [sym__bitshift_operator] = ACTIONS(2809),
    [sym__rational_operator] = ACTIONS(2809),
    [sym__times_operator] = ACTIONS(2807),
    [sym__plus_operator] = ACTIONS(2807),
    [sym__dotty_operator] = ACTIONS(2807),
    [sym__comparison_operator] = ACTIONS(2807),
    [sym__arrow_operator] = ACTIONS(2809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2809),
    [sym__command_start] = ACTIONS(2809),
  },
  [1464] = {
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(2801),
    [anon_sym_end] = ACTIONS(2801),
    [anon_sym_abstract] = ACTIONS(2801),
    [anon_sym_primitive] = ACTIONS(2801),
    [aux_sym_primitive_definition_token1] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_module] = ACTIONS(2801),
    [anon_sym_macro] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2803),
    [anon_sym_COLON_COLON] = ACTIONS(2803),
    [anon_sym_RBRACE] = ACTIONS(2803),
    [anon_sym_LT_COLON] = ACTIONS(2803),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [sym_break_statement] = ACTIONS(2801),
    [sym_continue_statement] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_quote] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2801),
    [anon_sym_export] = ACTIONS(2801),
    [anon_sym_COLON2] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_RBRACK] = ACTIONS(2803),
    [anon_sym_begin] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_LT_PIPE] = ACTIONS(2803),
    [anon_sym_PIPE_GT] = ACTIONS(2803),
    [anon_sym_in] = ACTIONS(2801),
    [anon_sym_isa] = ACTIONS(2801),
    [anon_sym_PIPE_PIPE] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_QMARK] = ACTIONS(2803),
    [anon_sym_EQ_GT] = ACTIONS(2803),
    [anon_sym_LBRACK2] = ACTIONS(2801),
    [anon_sym_DOLLAR] = ACTIONS(2803),
    [anon_sym_AT] = ACTIONS(2803),
    [aux_sym_integer_literal_token1] = ACTIONS(2803),
    [aux_sym_integer_literal_token2] = ACTIONS(2803),
    [aux_sym_integer_literal_token3] = ACTIONS(2801),
    [sym_float_literal] = ACTIONS(2801),
    [sym__unary_operator] = ACTIONS(2801),
    [sym__power_operator] = ACTIONS(2803),
    [sym__bitshift_operator] = ACTIONS(2803),
    [sym__rational_operator] = ACTIONS(2803),
    [sym__times_operator] = ACTIONS(2801),
    [sym__plus_operator] = ACTIONS(2801),
    [sym__dotty_operator] = ACTIONS(2801),
    [sym__comparison_operator] = ACTIONS(2801),
    [sym__arrow_operator] = ACTIONS(2803),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2803),
    [sym__command_start] = ACTIONS(2803),
  },
  [1465] = {
    [aux_sym_let_statement_repeat1] = STATE(1465),
    [ts_builtin_sym_end] = ACTIONS(2921),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_primitive] = ACTIONS(2916),
    [aux_sym_primitive_definition_token1] = ACTIONS(2916),
    [anon_sym_mutable] = ACTIONS(2916),
    [anon_sym_struct] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_macro] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2916),
    [anon_sym_COMMA] = ACTIONS(3460),
    [anon_sym_SEMI] = ACTIONS(2916),
    [anon_sym_EQ] = ACTIONS(2916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2916),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_LT_COLON] = ACTIONS(2916),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [sym_break_statement] = ACTIONS(2916),
    [sym_continue_statement] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_quote] = ACTIONS(2916),
    [anon_sym_using] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_COLON2] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2916),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_LT_PIPE] = ACTIONS(2916),
    [anon_sym_PIPE_GT] = ACTIONS(2916),
    [anon_sym_in] = ACTIONS(2916),
    [anon_sym_isa] = ACTIONS(2916),
    [anon_sym_PIPE_PIPE] = ACTIONS(2916),
    [anon_sym_AMP_AMP] = ACTIONS(2916),
    [anon_sym_QMARK] = ACTIONS(2916),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_LBRACK2] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2916),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [sym_float_literal] = ACTIONS(2916),
    [sym__unary_operator] = ACTIONS(2916),
    [sym__power_operator] = ACTIONS(2916),
    [sym__bitshift_operator] = ACTIONS(2916),
    [sym__rational_operator] = ACTIONS(2916),
    [sym__times_operator] = ACTIONS(2916),
    [sym__plus_operator] = ACTIONS(2916),
    [sym__dotty_operator] = ACTIONS(2916),
    [sym__comparison_operator] = ACTIONS(2916),
    [sym__arrow_operator] = ACTIONS(2916),
    [sym__assign_operator] = ACTIONS(2916),
    [anon_sym_LF] = ACTIONS(2921),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2921),
    [sym__command_start] = ACTIONS(2921),
  },
  [1466] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1507),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_end] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_primitive] = ACTIONS(2900),
    [aux_sym_primitive_definition_token1] = ACTIONS(2900),
    [anon_sym_mutable] = ACTIONS(2900),
    [anon_sym_struct] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_macro] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2902),
    [anon_sym_COMMA] = ACTIONS(3463),
    [anon_sym_RPAREN] = ACTIONS(2902),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3465),
    [anon_sym_COLON_COLON] = ACTIONS(3467),
    [anon_sym_RBRACE] = ACTIONS(2902),
    [anon_sym_LT_COLON] = ACTIONS(3467),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [sym_break_statement] = ACTIONS(2900),
    [sym_continue_statement] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_quote] = ACTIONS(2900),
    [anon_sym_using] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_COLON2] = ACTIONS(3469),
    [anon_sym_RBRACK] = ACTIONS(2902),
    [anon_sym_begin] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(3471),
    [anon_sym_PLUS] = ACTIONS(3473),
    [anon_sym_LT_PIPE] = ACTIONS(3475),
    [anon_sym_PIPE_GT] = ACTIONS(3477),
    [anon_sym_in] = ACTIONS(3479),
    [anon_sym_isa] = ACTIONS(3479),
    [anon_sym_PIPE_PIPE] = ACTIONS(3481),
    [anon_sym_AMP_AMP] = ACTIONS(3483),
    [anon_sym_QMARK] = ACTIONS(3485),
    [anon_sym_EQ_GT] = ACTIONS(3487),
    [anon_sym_LBRACK2] = ACTIONS(2902),
    [anon_sym_DOLLAR] = ACTIONS(2902),
    [anon_sym_AT] = ACTIONS(2902),
    [aux_sym_integer_literal_token1] = ACTIONS(2902),
    [aux_sym_integer_literal_token2] = ACTIONS(2902),
    [aux_sym_integer_literal_token3] = ACTIONS(2900),
    [sym_float_literal] = ACTIONS(2900),
    [sym__unary_operator] = ACTIONS(2900),
    [sym__power_operator] = ACTIONS(3489),
    [sym__bitshift_operator] = ACTIONS(3491),
    [sym__rational_operator] = ACTIONS(3493),
    [sym__times_operator] = ACTIONS(3495),
    [sym__plus_operator] = ACTIONS(3473),
    [sym__dotty_operator] = ACTIONS(3497),
    [sym__comparison_operator] = ACTIONS(3479),
    [sym__arrow_operator] = ACTIONS(3499),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2902),
    [sym__command_start] = ACTIONS(2902),
  },
  [1467] = {
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_end] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_primitive] = ACTIONS(3207),
    [aux_sym_primitive_definition_token1] = ACTIONS(3207),
    [anon_sym_mutable] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_macro] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(3207),
    [anon_sym_SEMI] = ACTIONS(3207),
    [anon_sym_EQ] = ACTIONS(3501),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3207),
    [anon_sym_COLON_COLON] = ACTIONS(3207),
    [anon_sym_LT_COLON] = ACTIONS(3207),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_elseif] = ACTIONS(3207),
    [anon_sym_else] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [sym_break_statement] = ACTIONS(3207),
    [sym_continue_statement] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_quote] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_COLON2] = ACTIONS(3207),
    [anon_sym_begin] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3207),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_LT_PIPE] = ACTIONS(3207),
    [anon_sym_PIPE_GT] = ACTIONS(3207),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_isa] = ACTIONS(3207),
    [anon_sym_PIPE_PIPE] = ACTIONS(3207),
    [anon_sym_AMP_AMP] = ACTIONS(3207),
    [anon_sym_QMARK] = ACTIONS(3207),
    [anon_sym_EQ_GT] = ACTIONS(3207),
    [anon_sym_LBRACK2] = ACTIONS(3207),
    [anon_sym_DOLLAR] = ACTIONS(3207),
    [anon_sym_AT] = ACTIONS(3207),
    [aux_sym_integer_literal_token1] = ACTIONS(3207),
    [aux_sym_integer_literal_token2] = ACTIONS(3207),
    [aux_sym_integer_literal_token3] = ACTIONS(3207),
    [sym_float_literal] = ACTIONS(3207),
    [sym__unary_operator] = ACTIONS(3207),
    [sym__power_operator] = ACTIONS(3207),
    [sym__bitshift_operator] = ACTIONS(3207),
    [sym__rational_operator] = ACTIONS(3207),
    [sym__times_operator] = ACTIONS(3207),
    [sym__plus_operator] = ACTIONS(3207),
    [sym__dotty_operator] = ACTIONS(3207),
    [sym__comparison_operator] = ACTIONS(3207),
    [sym__arrow_operator] = ACTIONS(3207),
    [anon_sym_LF] = ACTIONS(3211),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3211),
    [sym__command_start] = ACTIONS(3211),
  },
  [1468] = {
    [aux_sym_let_statement_repeat1] = STATE(1476),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2885),
    [anon_sym_end] = ACTIONS(2885),
    [anon_sym_abstract] = ACTIONS(2885),
    [anon_sym_primitive] = ACTIONS(2885),
    [aux_sym_primitive_definition_token1] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_macro] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_RPAREN] = ACTIONS(2887),
    [anon_sym_SEMI] = ACTIONS(2887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2887),
    [anon_sym_COLON_COLON] = ACTIONS(2887),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_LT_COLON] = ACTIONS(2887),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym_break_statement] = ACTIONS(2885),
    [sym_continue_statement] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_quote] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2885),
    [anon_sym_RBRACK] = ACTIONS(2887),
    [anon_sym_begin] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2887),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_LT_PIPE] = ACTIONS(2887),
    [anon_sym_PIPE_GT] = ACTIONS(2887),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2887),
    [anon_sym_AMP_AMP] = ACTIONS(2887),
    [anon_sym_QMARK] = ACTIONS(2887),
    [anon_sym_EQ_GT] = ACTIONS(2887),
    [anon_sym_LBRACK2] = ACTIONS(2887),
    [anon_sym_DOLLAR] = ACTIONS(2887),
    [anon_sym_AT] = ACTIONS(2887),
    [aux_sym_integer_literal_token1] = ACTIONS(2887),
    [aux_sym_integer_literal_token2] = ACTIONS(2887),
    [aux_sym_integer_literal_token3] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym__unary_operator] = ACTIONS(2885),
    [sym__power_operator] = ACTIONS(2887),
    [sym__bitshift_operator] = ACTIONS(2887),
    [sym__rational_operator] = ACTIONS(2887),
    [sym__times_operator] = ACTIONS(2885),
    [sym__plus_operator] = ACTIONS(2885),
    [sym__dotty_operator] = ACTIONS(2885),
    [sym__comparison_operator] = ACTIONS(2885),
    [sym__arrow_operator] = ACTIONS(2887),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2887),
    [sym__command_start] = ACTIONS(2887),
  },
  [1469] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1517),
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_function] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(2811),
    [anon_sym_abstract] = ACTIONS(2811),
    [anon_sym_primitive] = ACTIONS(2811),
    [aux_sym_primitive_definition_token1] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_macro] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_COMMA] = ACTIONS(3368),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2811),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LT_COLON] = ACTIONS(2811),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_elseif] = ACTIONS(2811),
    [anon_sym_else] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [sym_break_statement] = ACTIONS(2811),
    [sym_continue_statement] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_quote] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_COLON2] = ACTIONS(2811),
    [anon_sym_begin] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_LT_PIPE] = ACTIONS(2811),
    [anon_sym_PIPE_GT] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_isa] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_QMARK] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_LBRACK2] = ACTIONS(2811),
    [anon_sym_DOLLAR] = ACTIONS(2811),
    [anon_sym_AT] = ACTIONS(2811),
    [aux_sym_integer_literal_token1] = ACTIONS(2811),
    [aux_sym_integer_literal_token2] = ACTIONS(2811),
    [aux_sym_integer_literal_token3] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
    [sym__unary_operator] = ACTIONS(2811),
    [sym__power_operator] = ACTIONS(2811),
    [sym__bitshift_operator] = ACTIONS(2811),
    [sym__rational_operator] = ACTIONS(2811),
    [sym__times_operator] = ACTIONS(2811),
    [sym__plus_operator] = ACTIONS(2811),
    [sym__dotty_operator] = ACTIONS(2811),
    [sym__comparison_operator] = ACTIONS(2811),
    [sym__arrow_operator] = ACTIONS(2811),
    [anon_sym_LF] = ACTIONS(2815),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2815),
    [sym__command_start] = ACTIONS(2815),
  },
  [1470] = {
    [aux_sym_import_statement_repeat1] = STATE(1477),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_end] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(3301),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_COLON_COLON] = ACTIONS(2656),
    [anon_sym_RBRACE] = ACTIONS(2656),
    [anon_sym_LT_COLON] = ACTIONS(2656),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2656),
    [anon_sym_PIPE_GT] = ACTIONS(2656),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_LBRACK2] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [aux_sym_integer_literal_token1] = ACTIONS(2656),
    [aux_sym_integer_literal_token2] = ACTIONS(2656),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2656),
    [sym__bitshift_operator] = ACTIONS(2656),
    [sym__rational_operator] = ACTIONS(2656),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1471] = {
    [aux_sym_export_statement_repeat1] = STATE(1478),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_end] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_primitive] = ACTIONS(2833),
    [aux_sym_primitive_definition_token1] = ACTIONS(2833),
    [anon_sym_mutable] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_macro] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_COMMA] = ACTIONS(3505),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2835),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_LT_COLON] = ACTIONS(2835),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [sym_break_statement] = ACTIONS(2833),
    [sym_continue_statement] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_quote] = ACTIONS(2833),
    [anon_sym_using] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_COLON2] = ACTIONS(2833),
    [anon_sym_RBRACK] = ACTIONS(2835),
    [anon_sym_begin] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_LT_PIPE] = ACTIONS(2835),
    [anon_sym_PIPE_GT] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_isa] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2835),
    [anon_sym_LBRACK2] = ACTIONS(2835),
    [anon_sym_DOLLAR] = ACTIONS(2835),
    [anon_sym_AT] = ACTIONS(2835),
    [aux_sym_integer_literal_token1] = ACTIONS(2835),
    [aux_sym_integer_literal_token2] = ACTIONS(2835),
    [aux_sym_integer_literal_token3] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym__unary_operator] = ACTIONS(2833),
    [sym__power_operator] = ACTIONS(2835),
    [sym__bitshift_operator] = ACTIONS(2835),
    [sym__rational_operator] = ACTIONS(2835),
    [sym__times_operator] = ACTIONS(2833),
    [sym__plus_operator] = ACTIONS(2833),
    [sym__dotty_operator] = ACTIONS(2833),
    [sym__comparison_operator] = ACTIONS(2833),
    [sym__arrow_operator] = ACTIONS(2835),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2835),
    [sym__command_start] = ACTIONS(2835),
  },
  [1472] = {
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2762),
    [anon_sym_end] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_primitive] = ACTIONS(2762),
    [aux_sym_primitive_definition_token1] = ACTIONS(2762),
    [anon_sym_mutable] = ACTIONS(2762),
    [anon_sym_struct] = ACTIONS(2762),
    [anon_sym_module] = ACTIONS(2762),
    [anon_sym_macro] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2762),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LT_COLON] = ACTIONS(2762),
    [anon_sym_if] = ACTIONS(2762),
    [anon_sym_elseif] = ACTIONS(2762),
    [anon_sym_else] = ACTIONS(2762),
    [anon_sym_try] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2762),
    [anon_sym_while] = ACTIONS(2762),
    [sym_break_statement] = ACTIONS(2762),
    [sym_continue_statement] = ACTIONS(2762),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2762),
    [anon_sym_quote] = ACTIONS(2762),
    [anon_sym_using] = ACTIONS(2762),
    [anon_sym_import] = ACTIONS(2762),
    [anon_sym_export] = ACTIONS(2762),
    [anon_sym_COLON2] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_LT_PIPE] = ACTIONS(2762),
    [anon_sym_PIPE_GT] = ACTIONS(2762),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_isa] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2762),
    [anon_sym_AMP_AMP] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_EQ_GT] = ACTIONS(2762),
    [anon_sym_LBRACK2] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2762),
    [aux_sym_integer_literal_token1] = ACTIONS(2762),
    [aux_sym_integer_literal_token2] = ACTIONS(2762),
    [aux_sym_integer_literal_token3] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
    [sym__unary_operator] = ACTIONS(2762),
    [sym__power_operator] = ACTIONS(2762),
    [sym__bitshift_operator] = ACTIONS(2762),
    [sym__rational_operator] = ACTIONS(2762),
    [sym__times_operator] = ACTIONS(2762),
    [sym__plus_operator] = ACTIONS(2762),
    [sym__dotty_operator] = ACTIONS(2762),
    [sym__comparison_operator] = ACTIONS(2762),
    [sym__arrow_operator] = ACTIONS(2762),
    [anon_sym_LF] = ACTIONS(2764),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2764),
    [sym__string_start] = ACTIONS(2764),
    [sym__command_start] = ACTIONS(2764),
  },
  [1473] = {
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_primitive] = ACTIONS(2912),
    [aux_sym_primitive_definition_token1] = ACTIONS(2912),
    [anon_sym_mutable] = ACTIONS(2912),
    [anon_sym_struct] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_macro] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2912),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2912),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_LT_COLON] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_elseif] = ACTIONS(2912),
    [anon_sym_else] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [sym_break_statement] = ACTIONS(2912),
    [sym_continue_statement] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_quote] = ACTIONS(2912),
    [anon_sym_using] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_COLON2] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_LT_PIPE] = ACTIONS(2912),
    [anon_sym_PIPE_GT] = ACTIONS(2912),
    [anon_sym_in] = ACTIONS(2912),
    [anon_sym_isa] = ACTIONS(2912),
    [anon_sym_PIPE_PIPE] = ACTIONS(2912),
    [anon_sym_AMP_AMP] = ACTIONS(2912),
    [anon_sym_QMARK] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(2912),
    [anon_sym_LBRACK2] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2912),
    [aux_sym_integer_literal_token2] = ACTIONS(2912),
    [aux_sym_integer_literal_token3] = ACTIONS(2912),
    [sym_float_literal] = ACTIONS(2912),
    [sym__unary_operator] = ACTIONS(2912),
    [sym__power_operator] = ACTIONS(2912),
    [sym__bitshift_operator] = ACTIONS(2912),
    [sym__rational_operator] = ACTIONS(2912),
    [sym__times_operator] = ACTIONS(2912),
    [sym__plus_operator] = ACTIONS(2912),
    [sym__dotty_operator] = ACTIONS(2912),
    [sym__comparison_operator] = ACTIONS(2912),
    [sym__arrow_operator] = ACTIONS(2912),
    [anon_sym_LF] = ACTIONS(2914),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2914),
    [sym__string_start] = ACTIONS(2914),
    [sym__command_start] = ACTIONS(2914),
  },
  [1474] = {
    [sym_identifier] = ACTIONS(2896),
    [anon_sym_function] = ACTIONS(2896),
    [anon_sym_end] = ACTIONS(2896),
    [anon_sym_abstract] = ACTIONS(2896),
    [anon_sym_primitive] = ACTIONS(2896),
    [aux_sym_primitive_definition_token1] = ACTIONS(2896),
    [anon_sym_mutable] = ACTIONS(2896),
    [anon_sym_struct] = ACTIONS(2896),
    [anon_sym_module] = ACTIONS(2896),
    [anon_sym_macro] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2898),
    [anon_sym_COMMA] = ACTIONS(2898),
    [anon_sym_RPAREN] = ACTIONS(2898),
    [anon_sym_SEMI] = ACTIONS(2898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2898),
    [anon_sym_COLON_COLON] = ACTIONS(2898),
    [anon_sym_RBRACE] = ACTIONS(2898),
    [anon_sym_LT_COLON] = ACTIONS(2898),
    [anon_sym_if] = ACTIONS(2896),
    [anon_sym_try] = ACTIONS(2896),
    [anon_sym_for] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2896),
    [sym_break_statement] = ACTIONS(2896),
    [sym_continue_statement] = ACTIONS(2896),
    [anon_sym_return] = ACTIONS(2896),
    [anon_sym_let] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_quote] = ACTIONS(2896),
    [anon_sym_using] = ACTIONS(2896),
    [anon_sym_import] = ACTIONS(2896),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_COLON2] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_RBRACK] = ACTIONS(2898),
    [anon_sym_begin] = ACTIONS(2896),
    [anon_sym_SQUOTE] = ACTIONS(2898),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT_PIPE] = ACTIONS(2898),
    [anon_sym_PIPE_GT] = ACTIONS(2898),
    [anon_sym_in] = ACTIONS(2896),
    [anon_sym_isa] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2898),
    [anon_sym_AMP_AMP] = ACTIONS(2898),
    [anon_sym_QMARK] = ACTIONS(2898),
    [anon_sym_EQ_GT] = ACTIONS(2898),
    [anon_sym_LBRACK2] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2898),
    [anon_sym_AT] = ACTIONS(2898),
    [aux_sym_integer_literal_token1] = ACTIONS(2898),
    [aux_sym_integer_literal_token2] = ACTIONS(2898),
    [aux_sym_integer_literal_token3] = ACTIONS(2896),
    [sym_float_literal] = ACTIONS(2896),
    [sym__unary_operator] = ACTIONS(2896),
    [sym__power_operator] = ACTIONS(2898),
    [sym__bitshift_operator] = ACTIONS(2898),
    [sym__rational_operator] = ACTIONS(2898),
    [sym__times_operator] = ACTIONS(2896),
    [sym__plus_operator] = ACTIONS(2896),
    [sym__dotty_operator] = ACTIONS(2896),
    [sym__comparison_operator] = ACTIONS(2896),
    [sym__arrow_operator] = ACTIONS(2898),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2898),
    [sym__command_start] = ACTIONS(2898),
  },
  [1475] = {
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_end] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_primitive] = ACTIONS(2791),
    [aux_sym_primitive_definition_token1] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_macro] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2793),
    [anon_sym_COMMA] = ACTIONS(2793),
    [anon_sym_RPAREN] = ACTIONS(2793),
    [anon_sym_SEMI] = ACTIONS(2793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2793),
    [anon_sym_COLON_COLON] = ACTIONS(2793),
    [anon_sym_RBRACE] = ACTIONS(2793),
    [anon_sym_LT_COLON] = ACTIONS(2793),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [sym_break_statement] = ACTIONS(2791),
    [sym_continue_statement] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_quote] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_COLON2] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [anon_sym_RBRACK] = ACTIONS(2793),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2793),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_LT_PIPE] = ACTIONS(2793),
    [anon_sym_PIPE_GT] = ACTIONS(2793),
    [anon_sym_in] = ACTIONS(2791),
    [anon_sym_isa] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2793),
    [anon_sym_AMP_AMP] = ACTIONS(2793),
    [anon_sym_QMARK] = ACTIONS(2793),
    [anon_sym_EQ_GT] = ACTIONS(2793),
    [anon_sym_LBRACK2] = ACTIONS(2791),
    [anon_sym_DOLLAR] = ACTIONS(2793),
    [anon_sym_AT] = ACTIONS(2793),
    [aux_sym_integer_literal_token1] = ACTIONS(2793),
    [aux_sym_integer_literal_token2] = ACTIONS(2793),
    [aux_sym_integer_literal_token3] = ACTIONS(2791),
    [sym_float_literal] = ACTIONS(2791),
    [sym__unary_operator] = ACTIONS(2791),
    [sym__power_operator] = ACTIONS(2793),
    [sym__bitshift_operator] = ACTIONS(2793),
    [sym__rational_operator] = ACTIONS(2793),
    [sym__times_operator] = ACTIONS(2791),
    [sym__plus_operator] = ACTIONS(2791),
    [sym__dotty_operator] = ACTIONS(2791),
    [sym__comparison_operator] = ACTIONS(2791),
    [sym__arrow_operator] = ACTIONS(2793),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2793),
    [sym__command_start] = ACTIONS(2793),
  },
  [1476] = {
    [aux_sym_let_statement_repeat1] = STATE(1518),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_end] = ACTIONS(2766),
    [anon_sym_abstract] = ACTIONS(2766),
    [anon_sym_primitive] = ACTIONS(2766),
    [aux_sym_primitive_definition_token1] = ACTIONS(2766),
    [anon_sym_mutable] = ACTIONS(2766),
    [anon_sym_struct] = ACTIONS(2766),
    [anon_sym_module] = ACTIONS(2766),
    [anon_sym_macro] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(3503),
    [anon_sym_RPAREN] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2770),
    [anon_sym_COLON_COLON] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_LT_COLON] = ACTIONS(2770),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [sym_break_statement] = ACTIONS(2766),
    [sym_continue_statement] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_quote] = ACTIONS(2766),
    [anon_sym_using] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2766),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_COLON2] = ACTIONS(2766),
    [anon_sym_RBRACK] = ACTIONS(2770),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2770),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_LT_PIPE] = ACTIONS(2770),
    [anon_sym_PIPE_GT] = ACTIONS(2770),
    [anon_sym_in] = ACTIONS(2766),
    [anon_sym_isa] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2770),
    [anon_sym_AMP_AMP] = ACTIONS(2770),
    [anon_sym_QMARK] = ACTIONS(2770),
    [anon_sym_EQ_GT] = ACTIONS(2770),
    [anon_sym_LBRACK2] = ACTIONS(2770),
    [anon_sym_DOLLAR] = ACTIONS(2770),
    [anon_sym_AT] = ACTIONS(2770),
    [aux_sym_integer_literal_token1] = ACTIONS(2770),
    [aux_sym_integer_literal_token2] = ACTIONS(2770),
    [aux_sym_integer_literal_token3] = ACTIONS(2766),
    [sym_float_literal] = ACTIONS(2766),
    [sym__unary_operator] = ACTIONS(2766),
    [sym__power_operator] = ACTIONS(2770),
    [sym__bitshift_operator] = ACTIONS(2770),
    [sym__rational_operator] = ACTIONS(2770),
    [sym__times_operator] = ACTIONS(2766),
    [sym__plus_operator] = ACTIONS(2766),
    [sym__dotty_operator] = ACTIONS(2766),
    [sym__comparison_operator] = ACTIONS(2766),
    [sym__arrow_operator] = ACTIONS(2770),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2770),
    [sym__command_start] = ACTIONS(2770),
  },
  [1477] = {
    [aux_sym_import_statement_repeat1] = STATE(1483),
    [sym_identifier] = ACTIONS(2754),
    [anon_sym_function] = ACTIONS(2754),
    [anon_sym_end] = ACTIONS(2754),
    [anon_sym_abstract] = ACTIONS(2754),
    [anon_sym_primitive] = ACTIONS(2754),
    [aux_sym_primitive_definition_token1] = ACTIONS(2754),
    [anon_sym_mutable] = ACTIONS(2754),
    [anon_sym_struct] = ACTIONS(2754),
    [anon_sym_module] = ACTIONS(2754),
    [anon_sym_macro] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(2756),
    [anon_sym_COMMA] = ACTIONS(3301),
    [anon_sym_RPAREN] = ACTIONS(2756),
    [anon_sym_SEMI] = ACTIONS(2756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2756),
    [anon_sym_COLON_COLON] = ACTIONS(2756),
    [anon_sym_RBRACE] = ACTIONS(2756),
    [anon_sym_LT_COLON] = ACTIONS(2756),
    [anon_sym_if] = ACTIONS(2754),
    [anon_sym_try] = ACTIONS(2754),
    [anon_sym_for] = ACTIONS(2754),
    [anon_sym_while] = ACTIONS(2754),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2754),
    [anon_sym_let] = ACTIONS(2754),
    [anon_sym_const] = ACTIONS(2754),
    [anon_sym_quote] = ACTIONS(2754),
    [anon_sym_using] = ACTIONS(2754),
    [anon_sym_import] = ACTIONS(2754),
    [anon_sym_export] = ACTIONS(2754),
    [anon_sym_COLON2] = ACTIONS(2754),
    [anon_sym_RBRACK] = ACTIONS(2756),
    [anon_sym_begin] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2756),
    [anon_sym_PLUS] = ACTIONS(2754),
    [anon_sym_LT_PIPE] = ACTIONS(2756),
    [anon_sym_PIPE_GT] = ACTIONS(2756),
    [anon_sym_in] = ACTIONS(2754),
    [anon_sym_isa] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2756),
    [anon_sym_AMP_AMP] = ACTIONS(2756),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_EQ_GT] = ACTIONS(2756),
    [anon_sym_LBRACK2] = ACTIONS(2756),
    [anon_sym_DOLLAR] = ACTIONS(2756),
    [anon_sym_AT] = ACTIONS(2756),
    [aux_sym_integer_literal_token1] = ACTIONS(2756),
    [aux_sym_integer_literal_token2] = ACTIONS(2756),
    [aux_sym_integer_literal_token3] = ACTIONS(2754),
    [sym_float_literal] = ACTIONS(2754),
    [sym__unary_operator] = ACTIONS(2754),
    [sym__power_operator] = ACTIONS(2756),
    [sym__bitshift_operator] = ACTIONS(2756),
    [sym__rational_operator] = ACTIONS(2756),
    [sym__times_operator] = ACTIONS(2754),
    [sym__plus_operator] = ACTIONS(2754),
    [sym__dotty_operator] = ACTIONS(2754),
    [sym__comparison_operator] = ACTIONS(2754),
    [sym__arrow_operator] = ACTIONS(2756),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2756),
    [sym__command_start] = ACTIONS(2756),
  },
  [1478] = {
    [aux_sym_export_statement_repeat1] = STATE(1484),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_function] = ACTIONS(2795),
    [anon_sym_end] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2795),
    [anon_sym_primitive] = ACTIONS(2795),
    [aux_sym_primitive_definition_token1] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_macro] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2799),
    [anon_sym_COMMA] = ACTIONS(3505),
    [anon_sym_RPAREN] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2799),
    [anon_sym_LT_COLON] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [sym_break_statement] = ACTIONS(2795),
    [sym_continue_statement] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_let] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_quote] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_import] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2795),
    [anon_sym_COLON2] = ACTIONS(2795),
    [anon_sym_RBRACK] = ACTIONS(2799),
    [anon_sym_begin] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_LT_PIPE] = ACTIONS(2799),
    [anon_sym_PIPE_GT] = ACTIONS(2799),
    [anon_sym_in] = ACTIONS(2795),
    [anon_sym_isa] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2799),
    [anon_sym_AMP_AMP] = ACTIONS(2799),
    [anon_sym_QMARK] = ACTIONS(2799),
    [anon_sym_EQ_GT] = ACTIONS(2799),
    [anon_sym_LBRACK2] = ACTIONS(2799),
    [anon_sym_DOLLAR] = ACTIONS(2799),
    [anon_sym_AT] = ACTIONS(2799),
    [aux_sym_integer_literal_token1] = ACTIONS(2799),
    [aux_sym_integer_literal_token2] = ACTIONS(2799),
    [aux_sym_integer_literal_token3] = ACTIONS(2795),
    [sym_float_literal] = ACTIONS(2795),
    [sym__unary_operator] = ACTIONS(2795),
    [sym__power_operator] = ACTIONS(2799),
    [sym__bitshift_operator] = ACTIONS(2799),
    [sym__rational_operator] = ACTIONS(2799),
    [sym__times_operator] = ACTIONS(2795),
    [sym__plus_operator] = ACTIONS(2795),
    [sym__dotty_operator] = ACTIONS(2795),
    [sym__comparison_operator] = ACTIONS(2795),
    [sym__arrow_operator] = ACTIONS(2799),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2799),
    [sym__command_start] = ACTIONS(2799),
  },
  [1479] = {
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_end] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_primitive] = ACTIONS(2904),
    [aux_sym_primitive_definition_token1] = ACTIONS(2904),
    [anon_sym_mutable] = ACTIONS(2904),
    [anon_sym_struct] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_macro] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2906),
    [anon_sym_COMMA] = ACTIONS(2906),
    [anon_sym_RPAREN] = ACTIONS(2906),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2906),
    [anon_sym_COLON_COLON] = ACTIONS(2906),
    [anon_sym_RBRACE] = ACTIONS(2906),
    [anon_sym_LT_COLON] = ACTIONS(2906),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [sym_break_statement] = ACTIONS(2904),
    [sym_continue_statement] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_quote] = ACTIONS(2904),
    [anon_sym_using] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_COLON2] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_RBRACK] = ACTIONS(2906),
    [anon_sym_begin] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2906),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_LT_PIPE] = ACTIONS(2906),
    [anon_sym_PIPE_GT] = ACTIONS(2906),
    [anon_sym_in] = ACTIONS(2904),
    [anon_sym_isa] = ACTIONS(2904),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_QMARK] = ACTIONS(2906),
    [anon_sym_EQ_GT] = ACTIONS(2906),
    [anon_sym_LBRACK2] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2906),
    [anon_sym_AT] = ACTIONS(2906),
    [aux_sym_integer_literal_token1] = ACTIONS(2906),
    [aux_sym_integer_literal_token2] = ACTIONS(2906),
    [aux_sym_integer_literal_token3] = ACTIONS(2904),
    [sym_float_literal] = ACTIONS(2904),
    [sym__unary_operator] = ACTIONS(2904),
    [sym__power_operator] = ACTIONS(2906),
    [sym__bitshift_operator] = ACTIONS(2906),
    [sym__rational_operator] = ACTIONS(2906),
    [sym__times_operator] = ACTIONS(2904),
    [sym__plus_operator] = ACTIONS(2904),
    [sym__dotty_operator] = ACTIONS(2904),
    [sym__comparison_operator] = ACTIONS(2904),
    [sym__arrow_operator] = ACTIONS(2906),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2906),
    [sym__command_start] = ACTIONS(2906),
  },
  [1480] = {
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_function] = ACTIONS(2779),
    [anon_sym_end] = ACTIONS(2779),
    [anon_sym_abstract] = ACTIONS(2779),
    [anon_sym_primitive] = ACTIONS(2779),
    [aux_sym_primitive_definition_token1] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_module] = ACTIONS(2779),
    [anon_sym_macro] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2781),
    [anon_sym_COMMA] = ACTIONS(2781),
    [anon_sym_RPAREN] = ACTIONS(2781),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2781),
    [anon_sym_COLON_COLON] = ACTIONS(2781),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_LT_COLON] = ACTIONS(2781),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [sym_break_statement] = ACTIONS(2779),
    [sym_continue_statement] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_let] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_quote] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_import] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(2779),
    [anon_sym_COLON2] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [anon_sym_RBRACK] = ACTIONS(2781),
    [anon_sym_begin] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2781),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_LT_PIPE] = ACTIONS(2781),
    [anon_sym_PIPE_GT] = ACTIONS(2781),
    [anon_sym_in] = ACTIONS(2779),
    [anon_sym_isa] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE] = ACTIONS(2781),
    [anon_sym_AMP_AMP] = ACTIONS(2781),
    [anon_sym_QMARK] = ACTIONS(2781),
    [anon_sym_EQ_GT] = ACTIONS(2781),
    [anon_sym_LBRACK2] = ACTIONS(2779),
    [anon_sym_DOLLAR] = ACTIONS(2781),
    [anon_sym_AT] = ACTIONS(2781),
    [aux_sym_integer_literal_token1] = ACTIONS(2781),
    [aux_sym_integer_literal_token2] = ACTIONS(2781),
    [aux_sym_integer_literal_token3] = ACTIONS(2779),
    [sym_float_literal] = ACTIONS(2779),
    [sym__unary_operator] = ACTIONS(2779),
    [sym__power_operator] = ACTIONS(2781),
    [sym__bitshift_operator] = ACTIONS(2781),
    [sym__rational_operator] = ACTIONS(2781),
    [sym__times_operator] = ACTIONS(2779),
    [sym__plus_operator] = ACTIONS(2779),
    [sym__dotty_operator] = ACTIONS(2779),
    [sym__comparison_operator] = ACTIONS(2779),
    [sym__arrow_operator] = ACTIONS(2781),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2781),
    [sym__command_start] = ACTIONS(2781),
  },
  [1481] = {
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_end] = ACTIONS(2758),
    [anon_sym_abstract] = ACTIONS(2758),
    [anon_sym_primitive] = ACTIONS(2758),
    [aux_sym_primitive_definition_token1] = ACTIONS(2758),
    [anon_sym_mutable] = ACTIONS(2758),
    [anon_sym_struct] = ACTIONS(2758),
    [anon_sym_module] = ACTIONS(2758),
    [anon_sym_macro] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2760),
    [anon_sym_COMMA] = ACTIONS(2760),
    [anon_sym_RPAREN] = ACTIONS(2760),
    [anon_sym_SEMI] = ACTIONS(2760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2760),
    [anon_sym_COLON_COLON] = ACTIONS(2760),
    [anon_sym_RBRACE] = ACTIONS(2760),
    [anon_sym_LT_COLON] = ACTIONS(2760),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_try] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [sym_break_statement] = ACTIONS(2758),
    [sym_continue_statement] = ACTIONS(2758),
    [anon_sym_return] = ACTIONS(2758),
    [anon_sym_let] = ACTIONS(2758),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_quote] = ACTIONS(2758),
    [anon_sym_using] = ACTIONS(2758),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_export] = ACTIONS(2758),
    [anon_sym_COLON2] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_RBRACK] = ACTIONS(2760),
    [anon_sym_begin] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2760),
    [anon_sym_PLUS] = ACTIONS(2758),
    [anon_sym_LT_PIPE] = ACTIONS(2760),
    [anon_sym_PIPE_GT] = ACTIONS(2760),
    [anon_sym_in] = ACTIONS(2758),
    [anon_sym_isa] = ACTIONS(2758),
    [anon_sym_PIPE_PIPE] = ACTIONS(2760),
    [anon_sym_AMP_AMP] = ACTIONS(2760),
    [anon_sym_QMARK] = ACTIONS(2760),
    [anon_sym_EQ_GT] = ACTIONS(2760),
    [anon_sym_LBRACK2] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2760),
    [anon_sym_AT] = ACTIONS(2760),
    [aux_sym_integer_literal_token1] = ACTIONS(2760),
    [aux_sym_integer_literal_token2] = ACTIONS(2760),
    [aux_sym_integer_literal_token3] = ACTIONS(2758),
    [sym_float_literal] = ACTIONS(2758),
    [sym__unary_operator] = ACTIONS(2758),
    [sym__power_operator] = ACTIONS(2760),
    [sym__bitshift_operator] = ACTIONS(2760),
    [sym__rational_operator] = ACTIONS(2760),
    [sym__times_operator] = ACTIONS(2758),
    [sym__plus_operator] = ACTIONS(2758),
    [sym__dotty_operator] = ACTIONS(2758),
    [sym__comparison_operator] = ACTIONS(2758),
    [sym__arrow_operator] = ACTIONS(2760),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2760),
    [sym__command_start] = ACTIONS(2760),
  },
  [1482] = {
    [aux_sym_let_statement_repeat1] = STATE(1482),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_end] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_primitive] = ACTIONS(2916),
    [aux_sym_primitive_definition_token1] = ACTIONS(2916),
    [anon_sym_mutable] = ACTIONS(2916),
    [anon_sym_struct] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_macro] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2916),
    [anon_sym_COMMA] = ACTIONS(3507),
    [anon_sym_SEMI] = ACTIONS(2916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2916),
    [anon_sym_COLON_COLON] = ACTIONS(2916),
    [anon_sym_LT_COLON] = ACTIONS(2916),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_elseif] = ACTIONS(2916),
    [anon_sym_else] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [sym_break_statement] = ACTIONS(2916),
    [sym_continue_statement] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_quote] = ACTIONS(2916),
    [anon_sym_using] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_COLON2] = ACTIONS(2916),
    [anon_sym_begin] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2916),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_LT_PIPE] = ACTIONS(2916),
    [anon_sym_PIPE_GT] = ACTIONS(2916),
    [anon_sym_in] = ACTIONS(2916),
    [anon_sym_isa] = ACTIONS(2916),
    [anon_sym_PIPE_PIPE] = ACTIONS(2916),
    [anon_sym_AMP_AMP] = ACTIONS(2916),
    [anon_sym_QMARK] = ACTIONS(2916),
    [anon_sym_EQ_GT] = ACTIONS(2916),
    [anon_sym_LBRACK2] = ACTIONS(2916),
    [anon_sym_DOLLAR] = ACTIONS(2916),
    [anon_sym_AT] = ACTIONS(2916),
    [aux_sym_integer_literal_token1] = ACTIONS(2916),
    [aux_sym_integer_literal_token2] = ACTIONS(2916),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [sym_float_literal] = ACTIONS(2916),
    [sym__unary_operator] = ACTIONS(2916),
    [sym__power_operator] = ACTIONS(2916),
    [sym__bitshift_operator] = ACTIONS(2916),
    [sym__rational_operator] = ACTIONS(2916),
    [sym__times_operator] = ACTIONS(2916),
    [sym__plus_operator] = ACTIONS(2916),
    [sym__dotty_operator] = ACTIONS(2916),
    [sym__comparison_operator] = ACTIONS(2916),
    [sym__arrow_operator] = ACTIONS(2916),
    [anon_sym_LF] = ACTIONS(2921),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2921),
    [sym__command_start] = ACTIONS(2921),
  },
  [1483] = {
    [aux_sym_import_statement_repeat1] = STATE(1483),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_end] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2746),
    [anon_sym_COMMA] = ACTIONS(3510),
    [anon_sym_RPAREN] = ACTIONS(2746),
    [anon_sym_SEMI] = ACTIONS(2746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2746),
    [anon_sym_COLON_COLON] = ACTIONS(2746),
    [anon_sym_RBRACE] = ACTIONS(2746),
    [anon_sym_LT_COLON] = ACTIONS(2746),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_RBRACK] = ACTIONS(2746),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2746),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2746),
    [anon_sym_PIPE_GT] = ACTIONS(2746),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2746),
    [anon_sym_AMP_AMP] = ACTIONS(2746),
    [anon_sym_QMARK] = ACTIONS(2746),
    [anon_sym_EQ_GT] = ACTIONS(2746),
    [anon_sym_LBRACK2] = ACTIONS(2746),
    [anon_sym_DOLLAR] = ACTIONS(2746),
    [anon_sym_AT] = ACTIONS(2746),
    [aux_sym_integer_literal_token1] = ACTIONS(2746),
    [aux_sym_integer_literal_token2] = ACTIONS(2746),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2746),
    [sym__bitshift_operator] = ACTIONS(2746),
    [sym__rational_operator] = ACTIONS(2746),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1484] = {
    [aux_sym_export_statement_repeat1] = STATE(1484),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_end] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_primitive] = ACTIONS(2817),
    [aux_sym_primitive_definition_token1] = ACTIONS(2817),
    [anon_sym_mutable] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_macro] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2822),
    [anon_sym_COMMA] = ACTIONS(3513),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2822),
    [anon_sym_LT_COLON] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [sym_break_statement] = ACTIONS(2817),
    [sym_continue_statement] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_quote] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_COLON2] = ACTIONS(2817),
    [anon_sym_RBRACK] = ACTIONS(2822),
    [anon_sym_begin] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_LT_PIPE] = ACTIONS(2822),
    [anon_sym_PIPE_GT] = ACTIONS(2822),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_isa] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2822),
    [anon_sym_AMP_AMP] = ACTIONS(2822),
    [anon_sym_QMARK] = ACTIONS(2822),
    [anon_sym_EQ_GT] = ACTIONS(2822),
    [anon_sym_LBRACK2] = ACTIONS(2822),
    [anon_sym_DOLLAR] = ACTIONS(2822),
    [anon_sym_AT] = ACTIONS(2822),
    [aux_sym_integer_literal_token1] = ACTIONS(2822),
    [aux_sym_integer_literal_token2] = ACTIONS(2822),
    [aux_sym_integer_literal_token3] = ACTIONS(2817),
    [sym_float_literal] = ACTIONS(2817),
    [sym__unary_operator] = ACTIONS(2817),
    [sym__power_operator] = ACTIONS(2822),
    [sym__bitshift_operator] = ACTIONS(2822),
    [sym__rational_operator] = ACTIONS(2822),
    [sym__times_operator] = ACTIONS(2817),
    [sym__plus_operator] = ACTIONS(2817),
    [sym__dotty_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(2817),
    [sym__arrow_operator] = ACTIONS(2822),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2822),
    [sym__command_start] = ACTIONS(2822),
  },
  [1485] = {
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_function] = ACTIONS(2787),
    [anon_sym_end] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2787),
    [anon_sym_primitive] = ACTIONS(2787),
    [aux_sym_primitive_definition_token1] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_macro] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_COMMA] = ACTIONS(2789),
    [anon_sym_RPAREN] = ACTIONS(2789),
    [anon_sym_SEMI] = ACTIONS(2789),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2789),
    [anon_sym_COLON_COLON] = ACTIONS(2789),
    [anon_sym_RBRACE] = ACTIONS(2789),
    [anon_sym_LT_COLON] = ACTIONS(2789),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [sym_break_statement] = ACTIONS(2787),
    [sym_continue_statement] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_quote] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_COLON2] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_RBRACK] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2789),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_LT_PIPE] = ACTIONS(2789),
    [anon_sym_PIPE_GT] = ACTIONS(2789),
    [anon_sym_in] = ACTIONS(2787),
    [anon_sym_isa] = ACTIONS(2787),
    [anon_sym_PIPE_PIPE] = ACTIONS(2789),
    [anon_sym_AMP_AMP] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(2789),
    [anon_sym_EQ_GT] = ACTIONS(2789),
    [anon_sym_LBRACK2] = ACTIONS(2787),
    [anon_sym_DOLLAR] = ACTIONS(2789),
    [anon_sym_AT] = ACTIONS(2789),
    [aux_sym_integer_literal_token1] = ACTIONS(2789),
    [aux_sym_integer_literal_token2] = ACTIONS(2789),
    [aux_sym_integer_literal_token3] = ACTIONS(2787),
    [sym_float_literal] = ACTIONS(2787),
    [sym__unary_operator] = ACTIONS(2787),
    [sym__power_operator] = ACTIONS(2789),
    [sym__bitshift_operator] = ACTIONS(2789),
    [sym__rational_operator] = ACTIONS(2789),
    [sym__times_operator] = ACTIONS(2787),
    [sym__plus_operator] = ACTIONS(2787),
    [sym__dotty_operator] = ACTIONS(2787),
    [sym__comparison_operator] = ACTIONS(2787),
    [sym__arrow_operator] = ACTIONS(2789),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2789),
    [sym__command_start] = ACTIONS(2789),
  },
  [1486] = {
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_end] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_primitive] = ACTIONS(2783),
    [aux_sym_primitive_definition_token1] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_module] = ACTIONS(2783),
    [anon_sym_macro] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_SEMI] = ACTIONS(2785),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2785),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_RBRACE] = ACTIONS(2785),
    [anon_sym_LT_COLON] = ACTIONS(2785),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [sym_break_statement] = ACTIONS(2783),
    [sym_continue_statement] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_quote] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_import] = ACTIONS(2783),
    [anon_sym_export] = ACTIONS(2783),
    [anon_sym_COLON2] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2785),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_LT_PIPE] = ACTIONS(2785),
    [anon_sym_PIPE_GT] = ACTIONS(2785),
    [anon_sym_in] = ACTIONS(2783),
    [anon_sym_isa] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2785),
    [anon_sym_AMP_AMP] = ACTIONS(2785),
    [anon_sym_QMARK] = ACTIONS(2785),
    [anon_sym_EQ_GT] = ACTIONS(2785),
    [anon_sym_LBRACK2] = ACTIONS(2783),
    [anon_sym_DOLLAR] = ACTIONS(2785),
    [anon_sym_AT] = ACTIONS(2785),
    [aux_sym_integer_literal_token1] = ACTIONS(2785),
    [aux_sym_integer_literal_token2] = ACTIONS(2785),
    [aux_sym_integer_literal_token3] = ACTIONS(2783),
    [sym_float_literal] = ACTIONS(2783),
    [sym__unary_operator] = ACTIONS(2783),
    [sym__power_operator] = ACTIONS(2785),
    [sym__bitshift_operator] = ACTIONS(2785),
    [sym__rational_operator] = ACTIONS(2785),
    [sym__times_operator] = ACTIONS(2783),
    [sym__plus_operator] = ACTIONS(2783),
    [sym__dotty_operator] = ACTIONS(2783),
    [sym__comparison_operator] = ACTIONS(2783),
    [sym__arrow_operator] = ACTIONS(2785),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2785),
    [sym__command_start] = ACTIONS(2785),
  },
  [1487] = {
    [aux_sym_selected_import_repeat1] = STATE(1489),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_end] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_primitive] = ACTIONS(2908),
    [aux_sym_primitive_definition_token1] = ACTIONS(2908),
    [anon_sym_mutable] = ACTIONS(2908),
    [anon_sym_struct] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_macro] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(3366),
    [anon_sym_RPAREN] = ACTIONS(2910),
    [anon_sym_SEMI] = ACTIONS(2910),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2910),
    [anon_sym_COLON_COLON] = ACTIONS(2910),
    [anon_sym_RBRACE] = ACTIONS(2910),
    [anon_sym_LT_COLON] = ACTIONS(2910),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [sym_break_statement] = ACTIONS(2908),
    [sym_continue_statement] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_quote] = ACTIONS(2908),
    [anon_sym_using] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_COLON2] = ACTIONS(2908),
    [anon_sym_RBRACK] = ACTIONS(2910),
    [anon_sym_begin] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_LT_PIPE] = ACTIONS(2910),
    [anon_sym_PIPE_GT] = ACTIONS(2910),
    [anon_sym_in] = ACTIONS(2908),
    [anon_sym_isa] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2910),
    [anon_sym_EQ_GT] = ACTIONS(2910),
    [anon_sym_LBRACK2] = ACTIONS(2910),
    [anon_sym_DOLLAR] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(2910),
    [aux_sym_integer_literal_token1] = ACTIONS(2910),
    [aux_sym_integer_literal_token2] = ACTIONS(2910),
    [aux_sym_integer_literal_token3] = ACTIONS(2908),
    [sym_float_literal] = ACTIONS(2908),
    [sym__unary_operator] = ACTIONS(2908),
    [sym__power_operator] = ACTIONS(2910),
    [sym__bitshift_operator] = ACTIONS(2910),
    [sym__rational_operator] = ACTIONS(2910),
    [sym__times_operator] = ACTIONS(2908),
    [sym__plus_operator] = ACTIONS(2908),
    [sym__dotty_operator] = ACTIONS(2908),
    [sym__comparison_operator] = ACTIONS(2908),
    [sym__arrow_operator] = ACTIONS(2910),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2910),
    [sym__command_start] = ACTIONS(2910),
  },
  [1488] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1488),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_end] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_primitive] = ACTIONS(2772),
    [aux_sym_primitive_definition_token1] = ACTIONS(2772),
    [anon_sym_mutable] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_macro] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(3516),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2777),
    [anon_sym_COLON_COLON] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_LT_COLON] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [sym_break_statement] = ACTIONS(2772),
    [sym_continue_statement] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_quote] = ACTIONS(2772),
    [anon_sym_using] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_COLON2] = ACTIONS(2772),
    [anon_sym_RBRACK] = ACTIONS(2777),
    [anon_sym_begin] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_LT_PIPE] = ACTIONS(2777),
    [anon_sym_PIPE_GT] = ACTIONS(2777),
    [anon_sym_in] = ACTIONS(2772),
    [anon_sym_isa] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_QMARK] = ACTIONS(2777),
    [anon_sym_EQ_GT] = ACTIONS(2777),
    [anon_sym_LBRACK2] = ACTIONS(2777),
    [anon_sym_DOLLAR] = ACTIONS(2777),
    [anon_sym_AT] = ACTIONS(2777),
    [aux_sym_integer_literal_token1] = ACTIONS(2777),
    [aux_sym_integer_literal_token2] = ACTIONS(2777),
    [aux_sym_integer_literal_token3] = ACTIONS(2772),
    [sym_float_literal] = ACTIONS(2772),
    [sym__unary_operator] = ACTIONS(2772),
    [sym__power_operator] = ACTIONS(2777),
    [sym__bitshift_operator] = ACTIONS(2777),
    [sym__rational_operator] = ACTIONS(2777),
    [sym__times_operator] = ACTIONS(2772),
    [sym__plus_operator] = ACTIONS(2772),
    [sym__dotty_operator] = ACTIONS(2772),
    [sym__comparison_operator] = ACTIONS(2772),
    [sym__arrow_operator] = ACTIONS(2777),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2777),
    [sym__command_start] = ACTIONS(2777),
  },
  [1489] = {
    [aux_sym_selected_import_repeat1] = STATE(1489),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_end] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_primitive] = ACTIONS(2889),
    [aux_sym_primitive_definition_token1] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_macro] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_COMMA] = ACTIONS(3519),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2894),
    [anon_sym_COLON_COLON] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_LT_COLON] = ACTIONS(2894),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [sym_break_statement] = ACTIONS(2889),
    [sym_continue_statement] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_quote] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_COLON2] = ACTIONS(2889),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_begin] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_LT_PIPE] = ACTIONS(2894),
    [anon_sym_PIPE_GT] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_LBRACK2] = ACTIONS(2894),
    [anon_sym_DOLLAR] = ACTIONS(2894),
    [anon_sym_AT] = ACTIONS(2894),
    [aux_sym_integer_literal_token1] = ACTIONS(2894),
    [aux_sym_integer_literal_token2] = ACTIONS(2894),
    [aux_sym_integer_literal_token3] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym__unary_operator] = ACTIONS(2889),
    [sym__power_operator] = ACTIONS(2894),
    [sym__bitshift_operator] = ACTIONS(2894),
    [sym__rational_operator] = ACTIONS(2894),
    [sym__times_operator] = ACTIONS(2889),
    [sym__plus_operator] = ACTIONS(2889),
    [sym__dotty_operator] = ACTIONS(2889),
    [sym__comparison_operator] = ACTIONS(2889),
    [sym__arrow_operator] = ACTIONS(2894),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2894),
    [sym__command_start] = ACTIONS(2894),
  },
  [1490] = {
    [ts_builtin_sym_end] = ACTIONS(2752),
    [sym_identifier] = ACTIONS(2750),
    [anon_sym_function] = ACTIONS(2750),
    [anon_sym_abstract] = ACTIONS(2750),
    [anon_sym_primitive] = ACTIONS(2750),
    [aux_sym_primitive_definition_token1] = ACTIONS(2750),
    [anon_sym_mutable] = ACTIONS(2750),
    [anon_sym_struct] = ACTIONS(2750),
    [anon_sym_module] = ACTIONS(2750),
    [anon_sym_macro] = ACTIONS(2750),
    [anon_sym_LPAREN] = ACTIONS(2750),
    [anon_sym_COMMA] = ACTIONS(2750),
    [anon_sym_SEMI] = ACTIONS(2750),
    [anon_sym_EQ] = ACTIONS(2750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2750),
    [anon_sym_COLON_COLON] = ACTIONS(2750),
    [anon_sym_LT_COLON] = ACTIONS(2750),
    [anon_sym_if] = ACTIONS(2750),
    [anon_sym_try] = ACTIONS(2750),
    [anon_sym_for] = ACTIONS(2750),
    [anon_sym_while] = ACTIONS(2750),
    [sym_break_statement] = ACTIONS(2750),
    [sym_continue_statement] = ACTIONS(2750),
    [anon_sym_return] = ACTIONS(2750),
    [anon_sym_let] = ACTIONS(2750),
    [anon_sym_const] = ACTIONS(2750),
    [anon_sym_quote] = ACTIONS(2750),
    [anon_sym_using] = ACTIONS(2750),
    [anon_sym_import] = ACTIONS(2750),
    [anon_sym_export] = ACTIONS(2750),
    [anon_sym_COLON2] = ACTIONS(2750),
    [anon_sym_LBRACK] = ACTIONS(2752),
    [anon_sym_begin] = ACTIONS(2750),
    [anon_sym_SQUOTE] = ACTIONS(2750),
    [anon_sym_PLUS] = ACTIONS(2750),
    [anon_sym_LT_PIPE] = ACTIONS(2750),
    [anon_sym_PIPE_GT] = ACTIONS(2750),
    [anon_sym_in] = ACTIONS(2750),
    [anon_sym_isa] = ACTIONS(2750),
    [anon_sym_PIPE_PIPE] = ACTIONS(2750),
    [anon_sym_AMP_AMP] = ACTIONS(2750),
    [anon_sym_QMARK] = ACTIONS(2750),
    [anon_sym_EQ_GT] = ACTIONS(2750),
    [anon_sym_LBRACK2] = ACTIONS(2750),
    [anon_sym_DOLLAR] = ACTIONS(2750),
    [anon_sym_AT] = ACTIONS(2750),
    [aux_sym_integer_literal_token1] = ACTIONS(2750),
    [aux_sym_integer_literal_token2] = ACTIONS(2750),
    [aux_sym_integer_literal_token3] = ACTIONS(2750),
    [sym_float_literal] = ACTIONS(2750),
    [sym__unary_operator] = ACTIONS(2750),
    [sym__power_operator] = ACTIONS(2750),
    [sym__bitshift_operator] = ACTIONS(2750),
    [sym__rational_operator] = ACTIONS(2750),
    [sym__times_operator] = ACTIONS(2750),
    [sym__plus_operator] = ACTIONS(2750),
    [sym__dotty_operator] = ACTIONS(2750),
    [sym__comparison_operator] = ACTIONS(2750),
    [sym__arrow_operator] = ACTIONS(2750),
    [sym__assign_operator] = ACTIONS(2750),
    [anon_sym_LF] = ACTIONS(2752),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2752),
    [sym__command_start] = ACTIONS(2752),
  },
  [1491] = {
    [sym_identifier] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_end] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_primitive] = ACTIONS(304),
    [aux_sym_primitive_definition_token1] = ACTIONS(304),
    [anon_sym_mutable] = ACTIONS(304),
    [anon_sym_struct] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_macro] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(306),
    [anon_sym_COLON_COLON] = ACTIONS(306),
    [anon_sym_RBRACE] = ACTIONS(306),
    [anon_sym_LT_COLON] = ACTIONS(306),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [sym_break_statement] = ACTIONS(304),
    [sym_continue_statement] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_quote] = ACTIONS(304),
    [anon_sym_using] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_COLON2] = ACTIONS(304),
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_begin] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(306),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(306),
    [anon_sym_PIPE_GT] = ACTIONS(306),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(306),
    [anon_sym_AMP_AMP] = ACTIONS(306),
    [anon_sym_QMARK] = ACTIONS(306),
    [anon_sym_EQ_GT] = ACTIONS(306),
    [anon_sym_LBRACK2] = ACTIONS(306),
    [anon_sym_DOLLAR] = ACTIONS(306),
    [anon_sym_AT] = ACTIONS(306),
    [aux_sym_integer_literal_token1] = ACTIONS(306),
    [aux_sym_integer_literal_token2] = ACTIONS(306),
    [aux_sym_integer_literal_token3] = ACTIONS(304),
    [sym_float_literal] = ACTIONS(304),
    [sym__unary_operator] = ACTIONS(304),
    [sym__power_operator] = ACTIONS(306),
    [sym__bitshift_operator] = ACTIONS(306),
    [sym__rational_operator] = ACTIONS(306),
    [sym__times_operator] = ACTIONS(304),
    [sym__plus_operator] = ACTIONS(304),
    [sym__dotty_operator] = ACTIONS(304),
    [sym__comparison_operator] = ACTIONS(304),
    [sym__arrow_operator] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(306),
    [sym__command_start] = ACTIONS(306),
  },
  [1492] = {
    [ts_builtin_sym_end] = ACTIONS(2708),
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [sym__assign_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(3329),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1493] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(2869),
    [ts_builtin_sym_end] = ACTIONS(2867),
    [sym_identifier] = ACTIONS(2837),
    [anon_sym_function] = ACTIONS(2837),
    [anon_sym_abstract] = ACTIONS(2837),
    [anon_sym_primitive] = ACTIONS(2837),
    [aux_sym_primitive_definition_token1] = ACTIONS(2837),
    [anon_sym_mutable] = ACTIONS(2837),
    [anon_sym_struct] = ACTIONS(2837),
    [anon_sym_module] = ACTIONS(2837),
    [anon_sym_macro] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LT_COLON] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(2837),
    [anon_sym_try] = ACTIONS(2837),
    [anon_sym_for] = ACTIONS(2837),
    [anon_sym_while] = ACTIONS(2837),
    [sym_break_statement] = ACTIONS(2837),
    [sym_continue_statement] = ACTIONS(2837),
    [anon_sym_return] = ACTIONS(2837),
    [anon_sym_let] = ACTIONS(2837),
    [anon_sym_const] = ACTIONS(2837),
    [anon_sym_quote] = ACTIONS(2837),
    [anon_sym_using] = ACTIONS(2837),
    [anon_sym_import] = ACTIONS(2837),
    [anon_sym_export] = ACTIONS(2837),
    [anon_sym_COLON2] = ACTIONS(3423),
    [anon_sym_begin] = ACTIONS(2837),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_LT_PIPE] = ACTIONS(3429),
    [anon_sym_PIPE_GT] = ACTIONS(3431),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_isa] = ACTIONS(3433),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(2837),
    [anon_sym_LBRACK2] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2837),
    [aux_sym_integer_literal_token1] = ACTIONS(2837),
    [aux_sym_integer_literal_token2] = ACTIONS(2837),
    [aux_sym_integer_literal_token3] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__unary_operator] = ACTIONS(2837),
    [sym__power_operator] = ACTIONS(3443),
    [sym__bitshift_operator] = ACTIONS(3445),
    [sym__rational_operator] = ACTIONS(3447),
    [sym__times_operator] = ACTIONS(3449),
    [sym__plus_operator] = ACTIONS(3427),
    [sym__dotty_operator] = ACTIONS(3451),
    [sym__comparison_operator] = ACTIONS(3433),
    [sym__arrow_operator] = ACTIONS(3453),
    [sym__assign_operator] = ACTIONS(2837),
    [anon_sym_LF] = ACTIONS(2867),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2867),
    [sym__command_start] = ACTIONS(2867),
  },
  [1494] = {
    [ts_builtin_sym_end] = ACTIONS(2708),
    [sym_identifier] = ACTIONS(2702),
    [anon_sym_function] = ACTIONS(2702),
    [anon_sym_abstract] = ACTIONS(2702),
    [anon_sym_primitive] = ACTIONS(2702),
    [aux_sym_primitive_definition_token1] = ACTIONS(2702),
    [anon_sym_mutable] = ACTIONS(2702),
    [anon_sym_struct] = ACTIONS(2702),
    [anon_sym_module] = ACTIONS(2702),
    [anon_sym_macro] = ACTIONS(2702),
    [anon_sym_LPAREN] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2702),
    [anon_sym_SEMI] = ACTIONS(2702),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2702),
    [anon_sym_COLON_COLON] = ACTIONS(2702),
    [anon_sym_LT_COLON] = ACTIONS(2702),
    [anon_sym_if] = ACTIONS(2702),
    [anon_sym_try] = ACTIONS(2702),
    [anon_sym_for] = ACTIONS(2702),
    [anon_sym_while] = ACTIONS(2702),
    [sym_break_statement] = ACTIONS(2702),
    [sym_continue_statement] = ACTIONS(2702),
    [anon_sym_return] = ACTIONS(2702),
    [anon_sym_let] = ACTIONS(2702),
    [anon_sym_const] = ACTIONS(2702),
    [anon_sym_quote] = ACTIONS(2702),
    [anon_sym_using] = ACTIONS(2702),
    [anon_sym_import] = ACTIONS(2702),
    [anon_sym_export] = ACTIONS(2702),
    [anon_sym_COLON2] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(3327),
    [anon_sym_begin] = ACTIONS(2702),
    [anon_sym_SQUOTE] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_LT_PIPE] = ACTIONS(2702),
    [anon_sym_PIPE_GT] = ACTIONS(2702),
    [anon_sym_in] = ACTIONS(2702),
    [anon_sym_isa] = ACTIONS(2702),
    [anon_sym_PIPE_PIPE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2702),
    [anon_sym_EQ_GT] = ACTIONS(2702),
    [anon_sym_LBRACK2] = ACTIONS(2702),
    [anon_sym_DOLLAR] = ACTIONS(2702),
    [anon_sym_AT] = ACTIONS(2702),
    [aux_sym_integer_literal_token1] = ACTIONS(2702),
    [aux_sym_integer_literal_token2] = ACTIONS(2702),
    [aux_sym_integer_literal_token3] = ACTIONS(2702),
    [sym_float_literal] = ACTIONS(2702),
    [sym__unary_operator] = ACTIONS(2702),
    [sym__power_operator] = ACTIONS(2702),
    [sym__bitshift_operator] = ACTIONS(2702),
    [sym__rational_operator] = ACTIONS(2702),
    [sym__times_operator] = ACTIONS(2702),
    [sym__plus_operator] = ACTIONS(2702),
    [sym__dotty_operator] = ACTIONS(2702),
    [sym__comparison_operator] = ACTIONS(2702),
    [sym__arrow_operator] = ACTIONS(2702),
    [sym__assign_operator] = ACTIONS(2702),
    [anon_sym_LF] = ACTIONS(2708),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2708),
    [sym__command_start] = ACTIONS(2708),
  },
  [1495] = {
    [ts_builtin_sym_end] = ACTIONS(2809),
    [sym_identifier] = ACTIONS(2807),
    [anon_sym_function] = ACTIONS(2807),
    [anon_sym_abstract] = ACTIONS(2807),
    [anon_sym_primitive] = ACTIONS(2807),
    [aux_sym_primitive_definition_token1] = ACTIONS(2807),
    [anon_sym_mutable] = ACTIONS(2807),
    [anon_sym_struct] = ACTIONS(2807),
    [anon_sym_module] = ACTIONS(2807),
    [anon_sym_macro] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_EQ] = ACTIONS(2807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LT_COLON] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_try] = ACTIONS(2807),
    [anon_sym_for] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [sym_break_statement] = ACTIONS(2807),
    [sym_continue_statement] = ACTIONS(2807),
    [anon_sym_return] = ACTIONS(2807),
    [anon_sym_let] = ACTIONS(2807),
    [anon_sym_const] = ACTIONS(2807),
    [anon_sym_quote] = ACTIONS(2807),
    [anon_sym_using] = ACTIONS(2807),
    [anon_sym_import] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_begin] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_LT_PIPE] = ACTIONS(2807),
    [anon_sym_PIPE_GT] = ACTIONS(2807),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_isa] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK2] = ACTIONS(2807),
    [anon_sym_DOLLAR] = ACTIONS(2807),
    [anon_sym_AT] = ACTIONS(2807),
    [aux_sym_integer_literal_token1] = ACTIONS(2807),
    [aux_sym_integer_literal_token2] = ACTIONS(2807),
    [aux_sym_integer_literal_token3] = ACTIONS(2807),
    [sym_float_literal] = ACTIONS(2807),
    [sym__unary_operator] = ACTIONS(2807),
    [sym__power_operator] = ACTIONS(2807),
    [sym__bitshift_operator] = ACTIONS(2807),
    [sym__rational_operator] = ACTIONS(2807),
    [sym__times_operator] = ACTIONS(2807),
    [sym__plus_operator] = ACTIONS(2807),
    [sym__dotty_operator] = ACTIONS(2807),
    [sym__comparison_operator] = ACTIONS(2807),
    [sym__arrow_operator] = ACTIONS(2807),
    [sym__assign_operator] = ACTIONS(2807),
    [anon_sym_LF] = ACTIONS(2809),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2809),
    [sym__command_start] = ACTIONS(2809),
  },
  [1496] = {
    [ts_builtin_sym_end] = ACTIONS(2803),
    [sym_identifier] = ACTIONS(2801),
    [anon_sym_function] = ACTIONS(2801),
    [anon_sym_abstract] = ACTIONS(2801),
    [anon_sym_primitive] = ACTIONS(2801),
    [aux_sym_primitive_definition_token1] = ACTIONS(2801),
    [anon_sym_mutable] = ACTIONS(2801),
    [anon_sym_struct] = ACTIONS(2801),
    [anon_sym_module] = ACTIONS(2801),
    [anon_sym_macro] = ACTIONS(2801),
    [anon_sym_LPAREN] = ACTIONS(2801),
    [anon_sym_COMMA] = ACTIONS(2801),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym_EQ] = ACTIONS(2801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2801),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LT_COLON] = ACTIONS(2801),
    [anon_sym_if] = ACTIONS(2801),
    [anon_sym_try] = ACTIONS(2801),
    [anon_sym_for] = ACTIONS(2801),
    [anon_sym_while] = ACTIONS(2801),
    [sym_break_statement] = ACTIONS(2801),
    [sym_continue_statement] = ACTIONS(2801),
    [anon_sym_return] = ACTIONS(2801),
    [anon_sym_let] = ACTIONS(2801),
    [anon_sym_const] = ACTIONS(2801),
    [anon_sym_quote] = ACTIONS(2801),
    [anon_sym_using] = ACTIONS(2801),
    [anon_sym_import] = ACTIONS(2801),
    [anon_sym_export] = ACTIONS(2801),
    [anon_sym_COLON2] = ACTIONS(2801),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_begin] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_PLUS] = ACTIONS(2801),
    [anon_sym_LT_PIPE] = ACTIONS(2801),
    [anon_sym_PIPE_GT] = ACTIONS(2801),
    [anon_sym_in] = ACTIONS(2801),
    [anon_sym_isa] = ACTIONS(2801),
    [anon_sym_PIPE_PIPE] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_QMARK] = ACTIONS(2801),
    [anon_sym_EQ_GT] = ACTIONS(2801),
    [anon_sym_LBRACK2] = ACTIONS(2801),
    [anon_sym_DOLLAR] = ACTIONS(2801),
    [anon_sym_AT] = ACTIONS(2801),
    [aux_sym_integer_literal_token1] = ACTIONS(2801),
    [aux_sym_integer_literal_token2] = ACTIONS(2801),
    [aux_sym_integer_literal_token3] = ACTIONS(2801),
    [sym_float_literal] = ACTIONS(2801),
    [sym__unary_operator] = ACTIONS(2801),
    [sym__power_operator] = ACTIONS(2801),
    [sym__bitshift_operator] = ACTIONS(2801),
    [sym__rational_operator] = ACTIONS(2801),
    [sym__times_operator] = ACTIONS(2801),
    [sym__plus_operator] = ACTIONS(2801),
    [sym__dotty_operator] = ACTIONS(2801),
    [sym__comparison_operator] = ACTIONS(2801),
    [sym__arrow_operator] = ACTIONS(2801),
    [sym__assign_operator] = ACTIONS(2801),
    [anon_sym_LF] = ACTIONS(2803),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2803),
    [sym__command_start] = ACTIONS(2803),
  },
  [1497] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1458),
    [ts_builtin_sym_end] = ACTIONS(2902),
    [sym_identifier] = ACTIONS(2900),
    [anon_sym_function] = ACTIONS(2900),
    [anon_sym_abstract] = ACTIONS(2900),
    [anon_sym_primitive] = ACTIONS(2900),
    [aux_sym_primitive_definition_token1] = ACTIONS(2900),
    [anon_sym_mutable] = ACTIONS(2900),
    [anon_sym_struct] = ACTIONS(2900),
    [anon_sym_module] = ACTIONS(2900),
    [anon_sym_macro] = ACTIONS(2900),
    [anon_sym_LPAREN] = ACTIONS(2900),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_SEMI] = ACTIONS(2900),
    [anon_sym_EQ] = ACTIONS(2900),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3419),
    [anon_sym_COLON_COLON] = ACTIONS(3421),
    [anon_sym_LT_COLON] = ACTIONS(3421),
    [anon_sym_if] = ACTIONS(2900),
    [anon_sym_try] = ACTIONS(2900),
    [anon_sym_for] = ACTIONS(2900),
    [anon_sym_while] = ACTIONS(2900),
    [sym_break_statement] = ACTIONS(2900),
    [sym_continue_statement] = ACTIONS(2900),
    [anon_sym_return] = ACTIONS(2900),
    [anon_sym_let] = ACTIONS(2900),
    [anon_sym_const] = ACTIONS(2900),
    [anon_sym_quote] = ACTIONS(2900),
    [anon_sym_using] = ACTIONS(2900),
    [anon_sym_import] = ACTIONS(2900),
    [anon_sym_export] = ACTIONS(2900),
    [anon_sym_COLON2] = ACTIONS(3423),
    [anon_sym_begin] = ACTIONS(2900),
    [anon_sym_SQUOTE] = ACTIONS(3425),
    [anon_sym_PLUS] = ACTIONS(3427),
    [anon_sym_LT_PIPE] = ACTIONS(3429),
    [anon_sym_PIPE_GT] = ACTIONS(3431),
    [anon_sym_in] = ACTIONS(3433),
    [anon_sym_isa] = ACTIONS(3433),
    [anon_sym_PIPE_PIPE] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3437),
    [anon_sym_QMARK] = ACTIONS(3439),
    [anon_sym_EQ_GT] = ACTIONS(3441),
    [anon_sym_LBRACK2] = ACTIONS(2900),
    [anon_sym_DOLLAR] = ACTIONS(2900),
    [anon_sym_AT] = ACTIONS(2900),
    [aux_sym_integer_literal_token1] = ACTIONS(2900),
    [aux_sym_integer_literal_token2] = ACTIONS(2900),
    [aux_sym_integer_literal_token3] = ACTIONS(2900),
    [sym_float_literal] = ACTIONS(2900),
    [sym__unary_operator] = ACTIONS(2900),
    [sym__power_operator] = ACTIONS(3443),
    [sym__bitshift_operator] = ACTIONS(3445),
    [sym__rational_operator] = ACTIONS(3447),
    [sym__times_operator] = ACTIONS(3449),
    [sym__plus_operator] = ACTIONS(3427),
    [sym__dotty_operator] = ACTIONS(3451),
    [sym__comparison_operator] = ACTIONS(3433),
    [sym__arrow_operator] = ACTIONS(3453),
    [sym__assign_operator] = ACTIONS(2900),
    [anon_sym_LF] = ACTIONS(2902),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2902),
    [sym__command_start] = ACTIONS(2902),
  },
  [1498] = {
    [sym_identifier] = ACTIONS(3207),
    [anon_sym_function] = ACTIONS(3207),
    [anon_sym_end] = ACTIONS(3207),
    [anon_sym_abstract] = ACTIONS(3207),
    [anon_sym_primitive] = ACTIONS(3207),
    [aux_sym_primitive_definition_token1] = ACTIONS(3207),
    [anon_sym_mutable] = ACTIONS(3207),
    [anon_sym_struct] = ACTIONS(3207),
    [anon_sym_module] = ACTIONS(3207),
    [anon_sym_macro] = ACTIONS(3207),
    [anon_sym_LPAREN] = ACTIONS(3211),
    [anon_sym_COMMA] = ACTIONS(3211),
    [anon_sym_RPAREN] = ACTIONS(3211),
    [anon_sym_SEMI] = ACTIONS(3211),
    [anon_sym_EQ] = ACTIONS(3522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3211),
    [anon_sym_COLON_COLON] = ACTIONS(3211),
    [anon_sym_RBRACE] = ACTIONS(3211),
    [anon_sym_LT_COLON] = ACTIONS(3211),
    [anon_sym_if] = ACTIONS(3207),
    [anon_sym_try] = ACTIONS(3207),
    [anon_sym_for] = ACTIONS(3207),
    [anon_sym_while] = ACTIONS(3207),
    [sym_break_statement] = ACTIONS(3207),
    [sym_continue_statement] = ACTIONS(3207),
    [anon_sym_return] = ACTIONS(3207),
    [anon_sym_let] = ACTIONS(3207),
    [anon_sym_const] = ACTIONS(3207),
    [anon_sym_quote] = ACTIONS(3207),
    [anon_sym_using] = ACTIONS(3207),
    [anon_sym_import] = ACTIONS(3207),
    [anon_sym_export] = ACTIONS(3207),
    [anon_sym_COLON2] = ACTIONS(3207),
    [anon_sym_RBRACK] = ACTIONS(3211),
    [anon_sym_begin] = ACTIONS(3207),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_PLUS] = ACTIONS(3207),
    [anon_sym_LT_PIPE] = ACTIONS(3211),
    [anon_sym_PIPE_GT] = ACTIONS(3211),
    [anon_sym_in] = ACTIONS(3207),
    [anon_sym_isa] = ACTIONS(3207),
    [anon_sym_PIPE_PIPE] = ACTIONS(3211),
    [anon_sym_AMP_AMP] = ACTIONS(3211),
    [anon_sym_QMARK] = ACTIONS(3211),
    [anon_sym_EQ_GT] = ACTIONS(3211),
    [anon_sym_LBRACK2] = ACTIONS(3211),
    [anon_sym_DOLLAR] = ACTIONS(3211),
    [anon_sym_AT] = ACTIONS(3211),
    [aux_sym_integer_literal_token1] = ACTIONS(3211),
    [aux_sym_integer_literal_token2] = ACTIONS(3211),
    [aux_sym_integer_literal_token3] = ACTIONS(3207),
    [sym_float_literal] = ACTIONS(3207),
    [sym__unary_operator] = ACTIONS(3207),
    [sym__power_operator] = ACTIONS(3211),
    [sym__bitshift_operator] = ACTIONS(3211),
    [sym__rational_operator] = ACTIONS(3211),
    [sym__times_operator] = ACTIONS(3207),
    [sym__plus_operator] = ACTIONS(3207),
    [sym__dotty_operator] = ACTIONS(3207),
    [sym__comparison_operator] = ACTIONS(3207),
    [sym__arrow_operator] = ACTIONS(3211),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3211),
    [sym__command_start] = ACTIONS(3211),
  },
  [1499] = {
    [sym_identifier] = ACTIONS(2871),
    [anon_sym_function] = ACTIONS(2871),
    [anon_sym_end] = ACTIONS(2871),
    [anon_sym_abstract] = ACTIONS(2871),
    [anon_sym_primitive] = ACTIONS(2871),
    [aux_sym_primitive_definition_token1] = ACTIONS(2871),
    [anon_sym_mutable] = ACTIONS(2871),
    [anon_sym_struct] = ACTIONS(2871),
    [anon_sym_module] = ACTIONS(2871),
    [anon_sym_macro] = ACTIONS(2871),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_EQ] = ACTIONS(3286),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2871),
    [anon_sym_COLON_COLON] = ACTIONS(2871),
    [anon_sym_LT_COLON] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2871),
    [anon_sym_elseif] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2871),
    [anon_sym_while] = ACTIONS(2871),
    [sym_break_statement] = ACTIONS(2871),
    [sym_continue_statement] = ACTIONS(2871),
    [anon_sym_return] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2871),
    [anon_sym_const] = ACTIONS(2871),
    [anon_sym_quote] = ACTIONS(2871),
    [anon_sym_using] = ACTIONS(2871),
    [anon_sym_import] = ACTIONS(2871),
    [anon_sym_export] = ACTIONS(2871),
    [anon_sym_COLON2] = ACTIONS(2871),
    [anon_sym_begin] = ACTIONS(2871),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [anon_sym_PLUS] = ACTIONS(2871),
    [anon_sym_LT_PIPE] = ACTIONS(2871),
    [anon_sym_PIPE_GT] = ACTIONS(2871),
    [anon_sym_in] = ACTIONS(2871),
    [anon_sym_isa] = ACTIONS(2871),
    [anon_sym_PIPE_PIPE] = ACTIONS(2871),
    [anon_sym_AMP_AMP] = ACTIONS(2871),
    [anon_sym_QMARK] = ACTIONS(2871),
    [anon_sym_EQ_GT] = ACTIONS(2871),
    [anon_sym_LBRACK2] = ACTIONS(2871),
    [anon_sym_DOLLAR] = ACTIONS(2871),
    [anon_sym_AT] = ACTIONS(2871),
    [aux_sym_integer_literal_token1] = ACTIONS(2871),
    [aux_sym_integer_literal_token2] = ACTIONS(2871),
    [aux_sym_integer_literal_token3] = ACTIONS(2871),
    [sym_float_literal] = ACTIONS(2871),
    [sym__unary_operator] = ACTIONS(2871),
    [sym__power_operator] = ACTIONS(2871),
    [sym__bitshift_operator] = ACTIONS(2871),
    [sym__rational_operator] = ACTIONS(2871),
    [sym__times_operator] = ACTIONS(2871),
    [sym__plus_operator] = ACTIONS(2871),
    [sym__dotty_operator] = ACTIONS(2871),
    [sym__comparison_operator] = ACTIONS(2871),
    [sym__arrow_operator] = ACTIONS(2871),
    [sym__assign_operator] = ACTIONS(3286),
    [anon_sym_LF] = ACTIONS(2883),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2883),
    [sym__command_start] = ACTIONS(2883),
  },
  [1500] = {
    [aux_sym_let_statement_repeat1] = STATE(1508),
    [ts_builtin_sym_end] = ACTIONS(2887),
    [sym_identifier] = ACTIONS(2885),
    [anon_sym_function] = ACTIONS(2885),
    [anon_sym_abstract] = ACTIONS(2885),
    [anon_sym_primitive] = ACTIONS(2885),
    [aux_sym_primitive_definition_token1] = ACTIONS(2885),
    [anon_sym_mutable] = ACTIONS(2885),
    [anon_sym_struct] = ACTIONS(2885),
    [anon_sym_module] = ACTIONS(2885),
    [anon_sym_macro] = ACTIONS(2885),
    [anon_sym_LPAREN] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_SEMI] = ACTIONS(2885),
    [anon_sym_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2885),
    [anon_sym_COLON_COLON] = ACTIONS(2885),
    [anon_sym_LT_COLON] = ACTIONS(2885),
    [anon_sym_if] = ACTIONS(2885),
    [anon_sym_try] = ACTIONS(2885),
    [anon_sym_for] = ACTIONS(2885),
    [anon_sym_while] = ACTIONS(2885),
    [sym_break_statement] = ACTIONS(2885),
    [sym_continue_statement] = ACTIONS(2885),
    [anon_sym_return] = ACTIONS(2885),
    [anon_sym_let] = ACTIONS(2885),
    [anon_sym_const] = ACTIONS(2885),
    [anon_sym_quote] = ACTIONS(2885),
    [anon_sym_using] = ACTIONS(2885),
    [anon_sym_import] = ACTIONS(2885),
    [anon_sym_export] = ACTIONS(2885),
    [anon_sym_COLON2] = ACTIONS(2885),
    [anon_sym_begin] = ACTIONS(2885),
    [anon_sym_SQUOTE] = ACTIONS(2885),
    [anon_sym_PLUS] = ACTIONS(2885),
    [anon_sym_LT_PIPE] = ACTIONS(2885),
    [anon_sym_PIPE_GT] = ACTIONS(2885),
    [anon_sym_in] = ACTIONS(2885),
    [anon_sym_isa] = ACTIONS(2885),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_QMARK] = ACTIONS(2885),
    [anon_sym_EQ_GT] = ACTIONS(2885),
    [anon_sym_LBRACK2] = ACTIONS(2885),
    [anon_sym_DOLLAR] = ACTIONS(2885),
    [anon_sym_AT] = ACTIONS(2885),
    [aux_sym_integer_literal_token1] = ACTIONS(2885),
    [aux_sym_integer_literal_token2] = ACTIONS(2885),
    [aux_sym_integer_literal_token3] = ACTIONS(2885),
    [sym_float_literal] = ACTIONS(2885),
    [sym__unary_operator] = ACTIONS(2885),
    [sym__power_operator] = ACTIONS(2885),
    [sym__bitshift_operator] = ACTIONS(2885),
    [sym__rational_operator] = ACTIONS(2885),
    [sym__times_operator] = ACTIONS(2885),
    [sym__plus_operator] = ACTIONS(2885),
    [sym__dotty_operator] = ACTIONS(2885),
    [sym__comparison_operator] = ACTIONS(2885),
    [sym__arrow_operator] = ACTIONS(2885),
    [sym__assign_operator] = ACTIONS(2885),
    [anon_sym_LF] = ACTIONS(2887),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2887),
    [sym__command_start] = ACTIONS(2887),
  },
  [1501] = {
    [aux_sym_export_statement_repeat1] = STATE(1512),
    [ts_builtin_sym_end] = ACTIONS(2835),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_function] = ACTIONS(2833),
    [anon_sym_abstract] = ACTIONS(2833),
    [anon_sym_primitive] = ACTIONS(2833),
    [aux_sym_primitive_definition_token1] = ACTIONS(2833),
    [anon_sym_mutable] = ACTIONS(2833),
    [anon_sym_struct] = ACTIONS(2833),
    [anon_sym_module] = ACTIONS(2833),
    [anon_sym_macro] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(3526),
    [anon_sym_SEMI] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2833),
    [anon_sym_COLON_COLON] = ACTIONS(2833),
    [anon_sym_LT_COLON] = ACTIONS(2833),
    [anon_sym_if] = ACTIONS(2833),
    [anon_sym_try] = ACTIONS(2833),
    [anon_sym_for] = ACTIONS(2833),
    [anon_sym_while] = ACTIONS(2833),
    [sym_break_statement] = ACTIONS(2833),
    [sym_continue_statement] = ACTIONS(2833),
    [anon_sym_return] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_const] = ACTIONS(2833),
    [anon_sym_quote] = ACTIONS(2833),
    [anon_sym_using] = ACTIONS(2833),
    [anon_sym_import] = ACTIONS(2833),
    [anon_sym_export] = ACTIONS(2833),
    [anon_sym_COLON2] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(2833),
    [anon_sym_SQUOTE] = ACTIONS(2833),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_LT_PIPE] = ACTIONS(2833),
    [anon_sym_PIPE_GT] = ACTIONS(2833),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_isa] = ACTIONS(2833),
    [anon_sym_PIPE_PIPE] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_EQ_GT] = ACTIONS(2833),
    [anon_sym_LBRACK2] = ACTIONS(2833),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [anon_sym_AT] = ACTIONS(2833),
    [aux_sym_integer_literal_token1] = ACTIONS(2833),
    [aux_sym_integer_literal_token2] = ACTIONS(2833),
    [aux_sym_integer_literal_token3] = ACTIONS(2833),
    [sym_float_literal] = ACTIONS(2833),
    [sym__unary_operator] = ACTIONS(2833),
    [sym__power_operator] = ACTIONS(2833),
    [sym__bitshift_operator] = ACTIONS(2833),
    [sym__rational_operator] = ACTIONS(2833),
    [sym__times_operator] = ACTIONS(2833),
    [sym__plus_operator] = ACTIONS(2833),
    [sym__dotty_operator] = ACTIONS(2833),
    [sym__comparison_operator] = ACTIONS(2833),
    [sym__arrow_operator] = ACTIONS(2833),
    [sym__assign_operator] = ACTIONS(2833),
    [anon_sym_LF] = ACTIONS(2835),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2835),
    [sym__command_start] = ACTIONS(2835),
  },
  [1502] = {
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2762),
    [anon_sym_end] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_primitive] = ACTIONS(2762),
    [aux_sym_primitive_definition_token1] = ACTIONS(2762),
    [anon_sym_mutable] = ACTIONS(2762),
    [anon_sym_struct] = ACTIONS(2762),
    [anon_sym_module] = ACTIONS(2762),
    [anon_sym_macro] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_COMMA] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(2764),
    [anon_sym_SEMI] = ACTIONS(2764),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2764),
    [anon_sym_COLON_COLON] = ACTIONS(2764),
    [anon_sym_RBRACE] = ACTIONS(2764),
    [anon_sym_LT_COLON] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2762),
    [anon_sym_try] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2762),
    [anon_sym_while] = ACTIONS(2762),
    [sym_break_statement] = ACTIONS(2762),
    [sym_continue_statement] = ACTIONS(2762),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2762),
    [anon_sym_quote] = ACTIONS(2762),
    [anon_sym_using] = ACTIONS(2762),
    [anon_sym_import] = ACTIONS(2762),
    [anon_sym_export] = ACTIONS(2762),
    [anon_sym_COLON2] = ACTIONS(2762),
    [anon_sym_RBRACK] = ACTIONS(2764),
    [anon_sym_begin] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_LT_PIPE] = ACTIONS(2764),
    [anon_sym_PIPE_GT] = ACTIONS(2764),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_isa] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2764),
    [anon_sym_AMP_AMP] = ACTIONS(2764),
    [anon_sym_QMARK] = ACTIONS(2764),
    [anon_sym_EQ_GT] = ACTIONS(2764),
    [anon_sym_LBRACK2] = ACTIONS(2764),
    [anon_sym_DOLLAR] = ACTIONS(2764),
    [anon_sym_AT] = ACTIONS(2764),
    [aux_sym_integer_literal_token1] = ACTIONS(2764),
    [aux_sym_integer_literal_token2] = ACTIONS(2764),
    [aux_sym_integer_literal_token3] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
    [sym__unary_operator] = ACTIONS(2762),
    [sym__power_operator] = ACTIONS(2764),
    [sym__bitshift_operator] = ACTIONS(2764),
    [sym__rational_operator] = ACTIONS(2764),
    [sym__times_operator] = ACTIONS(2762),
    [sym__plus_operator] = ACTIONS(2762),
    [sym__dotty_operator] = ACTIONS(2762),
    [sym__comparison_operator] = ACTIONS(2762),
    [sym__arrow_operator] = ACTIONS(2764),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2764),
    [sym__string_start] = ACTIONS(2764),
    [sym__command_start] = ACTIONS(2764),
  },
  [1503] = {
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_end] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_primitive] = ACTIONS(2912),
    [aux_sym_primitive_definition_token1] = ACTIONS(2912),
    [anon_sym_mutable] = ACTIONS(2912),
    [anon_sym_struct] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_macro] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2914),
    [anon_sym_RPAREN] = ACTIONS(2914),
    [anon_sym_SEMI] = ACTIONS(2914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2914),
    [anon_sym_COLON_COLON] = ACTIONS(2914),
    [anon_sym_RBRACE] = ACTIONS(2914),
    [anon_sym_LT_COLON] = ACTIONS(2914),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [sym_break_statement] = ACTIONS(2912),
    [sym_continue_statement] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_quote] = ACTIONS(2912),
    [anon_sym_using] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_COLON2] = ACTIONS(2912),
    [anon_sym_RBRACK] = ACTIONS(2914),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2914),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_LT_PIPE] = ACTIONS(2914),
    [anon_sym_PIPE_GT] = ACTIONS(2914),
    [anon_sym_in] = ACTIONS(2912),
    [anon_sym_isa] = ACTIONS(2912),
    [anon_sym_PIPE_PIPE] = ACTIONS(2914),
    [anon_sym_AMP_AMP] = ACTIONS(2914),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_EQ_GT] = ACTIONS(2914),
    [anon_sym_LBRACK2] = ACTIONS(2914),
    [anon_sym_DOLLAR] = ACTIONS(2914),
    [anon_sym_AT] = ACTIONS(2914),
    [aux_sym_integer_literal_token1] = ACTIONS(2914),
    [aux_sym_integer_literal_token2] = ACTIONS(2914),
    [aux_sym_integer_literal_token3] = ACTIONS(2912),
    [sym_float_literal] = ACTIONS(2912),
    [sym__unary_operator] = ACTIONS(2912),
    [sym__power_operator] = ACTIONS(2914),
    [sym__bitshift_operator] = ACTIONS(2914),
    [sym__rational_operator] = ACTIONS(2914),
    [sym__times_operator] = ACTIONS(2912),
    [sym__plus_operator] = ACTIONS(2912),
    [sym__dotty_operator] = ACTIONS(2912),
    [sym__comparison_operator] = ACTIONS(2912),
    [sym__arrow_operator] = ACTIONS(2914),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2914),
    [sym__string_start] = ACTIONS(2914),
    [sym__command_start] = ACTIONS(2914),
  },
  [1504] = {
    [aux_sym_import_statement_repeat1] = STATE(1511),
    [ts_builtin_sym_end] = ACTIONS(2656),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_function] = ACTIONS(2648),
    [anon_sym_abstract] = ACTIONS(2648),
    [anon_sym_primitive] = ACTIONS(2648),
    [aux_sym_primitive_definition_token1] = ACTIONS(2648),
    [anon_sym_mutable] = ACTIONS(2648),
    [anon_sym_struct] = ACTIONS(2648),
    [anon_sym_module] = ACTIONS(2648),
    [anon_sym_macro] = ACTIONS(2648),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_COMMA] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(2648),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2648),
    [anon_sym_COLON_COLON] = ACTIONS(2648),
    [anon_sym_LT_COLON] = ACTIONS(2648),
    [anon_sym_if] = ACTIONS(2648),
    [anon_sym_try] = ACTIONS(2648),
    [anon_sym_for] = ACTIONS(2648),
    [anon_sym_while] = ACTIONS(2648),
    [sym_break_statement] = ACTIONS(2648),
    [sym_continue_statement] = ACTIONS(2648),
    [anon_sym_return] = ACTIONS(2648),
    [anon_sym_let] = ACTIONS(2648),
    [anon_sym_const] = ACTIONS(2648),
    [anon_sym_quote] = ACTIONS(2648),
    [anon_sym_using] = ACTIONS(2648),
    [anon_sym_import] = ACTIONS(2648),
    [anon_sym_export] = ACTIONS(2648),
    [anon_sym_COLON2] = ACTIONS(2648),
    [anon_sym_begin] = ACTIONS(2648),
    [anon_sym_SQUOTE] = ACTIONS(2648),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_LT_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_GT] = ACTIONS(2648),
    [anon_sym_in] = ACTIONS(2648),
    [anon_sym_isa] = ACTIONS(2648),
    [anon_sym_PIPE_PIPE] = ACTIONS(2648),
    [anon_sym_AMP_AMP] = ACTIONS(2648),
    [anon_sym_QMARK] = ACTIONS(2648),
    [anon_sym_EQ_GT] = ACTIONS(2648),
    [anon_sym_LBRACK2] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_AT] = ACTIONS(2648),
    [aux_sym_integer_literal_token1] = ACTIONS(2648),
    [aux_sym_integer_literal_token2] = ACTIONS(2648),
    [aux_sym_integer_literal_token3] = ACTIONS(2648),
    [sym_float_literal] = ACTIONS(2648),
    [sym__unary_operator] = ACTIONS(2648),
    [sym__power_operator] = ACTIONS(2648),
    [sym__bitshift_operator] = ACTIONS(2648),
    [sym__rational_operator] = ACTIONS(2648),
    [sym__times_operator] = ACTIONS(2648),
    [sym__plus_operator] = ACTIONS(2648),
    [sym__dotty_operator] = ACTIONS(2648),
    [sym__comparison_operator] = ACTIONS(2648),
    [sym__arrow_operator] = ACTIONS(2648),
    [sym__assign_operator] = ACTIONS(2648),
    [anon_sym_LF] = ACTIONS(2656),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2656),
    [sym__command_start] = ACTIONS(2656),
  },
  [1505] = {
    [ts_builtin_sym_end] = ACTIONS(2898),
    [sym_identifier] = ACTIONS(2896),
    [anon_sym_function] = ACTIONS(2896),
    [anon_sym_abstract] = ACTIONS(2896),
    [anon_sym_primitive] = ACTIONS(2896),
    [aux_sym_primitive_definition_token1] = ACTIONS(2896),
    [anon_sym_mutable] = ACTIONS(2896),
    [anon_sym_struct] = ACTIONS(2896),
    [anon_sym_module] = ACTIONS(2896),
    [anon_sym_macro] = ACTIONS(2896),
    [anon_sym_LPAREN] = ACTIONS(2896),
    [anon_sym_COMMA] = ACTIONS(2896),
    [anon_sym_SEMI] = ACTIONS(2896),
    [anon_sym_EQ] = ACTIONS(2896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2896),
    [anon_sym_COLON_COLON] = ACTIONS(2896),
    [anon_sym_LT_COLON] = ACTIONS(2896),
    [anon_sym_if] = ACTIONS(2896),
    [anon_sym_try] = ACTIONS(2896),
    [anon_sym_for] = ACTIONS(2896),
    [anon_sym_while] = ACTIONS(2896),
    [sym_break_statement] = ACTIONS(2896),
    [sym_continue_statement] = ACTIONS(2896),
    [anon_sym_return] = ACTIONS(2896),
    [anon_sym_let] = ACTIONS(2896),
    [anon_sym_const] = ACTIONS(2896),
    [anon_sym_quote] = ACTIONS(2896),
    [anon_sym_using] = ACTIONS(2896),
    [anon_sym_import] = ACTIONS(2896),
    [anon_sym_export] = ACTIONS(2896),
    [anon_sym_COLON2] = ACTIONS(2896),
    [anon_sym_LBRACK] = ACTIONS(2898),
    [anon_sym_begin] = ACTIONS(2896),
    [anon_sym_SQUOTE] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(2896),
    [anon_sym_LT_PIPE] = ACTIONS(2896),
    [anon_sym_PIPE_GT] = ACTIONS(2896),
    [anon_sym_in] = ACTIONS(2896),
    [anon_sym_isa] = ACTIONS(2896),
    [anon_sym_PIPE_PIPE] = ACTIONS(2896),
    [anon_sym_AMP_AMP] = ACTIONS(2896),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_EQ_GT] = ACTIONS(2896),
    [anon_sym_LBRACK2] = ACTIONS(2896),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_AT] = ACTIONS(2896),
    [aux_sym_integer_literal_token1] = ACTIONS(2896),
    [aux_sym_integer_literal_token2] = ACTIONS(2896),
    [aux_sym_integer_literal_token3] = ACTIONS(2896),
    [sym_float_literal] = ACTIONS(2896),
    [sym__unary_operator] = ACTIONS(2896),
    [sym__power_operator] = ACTIONS(2896),
    [sym__bitshift_operator] = ACTIONS(2896),
    [sym__rational_operator] = ACTIONS(2896),
    [sym__times_operator] = ACTIONS(2896),
    [sym__plus_operator] = ACTIONS(2896),
    [sym__dotty_operator] = ACTIONS(2896),
    [sym__comparison_operator] = ACTIONS(2896),
    [sym__arrow_operator] = ACTIONS(2896),
    [sym__assign_operator] = ACTIONS(2896),
    [anon_sym_LF] = ACTIONS(2898),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2898),
    [sym__command_start] = ACTIONS(2898),
  },
  [1506] = {
    [ts_builtin_sym_end] = ACTIONS(2793),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_function] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2791),
    [anon_sym_primitive] = ACTIONS(2791),
    [aux_sym_primitive_definition_token1] = ACTIONS(2791),
    [anon_sym_mutable] = ACTIONS(2791),
    [anon_sym_struct] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_macro] = ACTIONS(2791),
    [anon_sym_LPAREN] = ACTIONS(2791),
    [anon_sym_COMMA] = ACTIONS(2791),
    [anon_sym_SEMI] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2791),
    [anon_sym_COLON_COLON] = ACTIONS(2791),
    [anon_sym_LT_COLON] = ACTIONS(2791),
    [anon_sym_if] = ACTIONS(2791),
    [anon_sym_try] = ACTIONS(2791),
    [anon_sym_for] = ACTIONS(2791),
    [anon_sym_while] = ACTIONS(2791),
    [sym_break_statement] = ACTIONS(2791),
    [sym_continue_statement] = ACTIONS(2791),
    [anon_sym_return] = ACTIONS(2791),
    [anon_sym_let] = ACTIONS(2791),
    [anon_sym_const] = ACTIONS(2791),
    [anon_sym_quote] = ACTIONS(2791),
    [anon_sym_using] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_COLON2] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2793),
    [anon_sym_begin] = ACTIONS(2791),
    [anon_sym_SQUOTE] = ACTIONS(2791),
    [anon_sym_PLUS] = ACTIONS(2791),
    [anon_sym_LT_PIPE] = ACTIONS(2791),
    [anon_sym_PIPE_GT] = ACTIONS(2791),
    [anon_sym_in] = ACTIONS(2791),
    [anon_sym_isa] = ACTIONS(2791),
    [anon_sym_PIPE_PIPE] = ACTIONS(2791),
    [anon_sym_AMP_AMP] = ACTIONS(2791),
    [anon_sym_QMARK] = ACTIONS(2791),
    [anon_sym_EQ_GT] = ACTIONS(2791),
    [anon_sym_LBRACK2] = ACTIONS(2791),
    [anon_sym_DOLLAR] = ACTIONS(2791),
    [anon_sym_AT] = ACTIONS(2791),
    [aux_sym_integer_literal_token1] = ACTIONS(2791),
    [aux_sym_integer_literal_token2] = ACTIONS(2791),
    [aux_sym_integer_literal_token3] = ACTIONS(2791),
    [sym_float_literal] = ACTIONS(2791),
    [sym__unary_operator] = ACTIONS(2791),
    [sym__power_operator] = ACTIONS(2791),
    [sym__bitshift_operator] = ACTIONS(2791),
    [sym__rational_operator] = ACTIONS(2791),
    [sym__times_operator] = ACTIONS(2791),
    [sym__plus_operator] = ACTIONS(2791),
    [sym__dotty_operator] = ACTIONS(2791),
    [sym__comparison_operator] = ACTIONS(2791),
    [sym__arrow_operator] = ACTIONS(2791),
    [sym__assign_operator] = ACTIONS(2791),
    [anon_sym_LF] = ACTIONS(2793),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2793),
    [sym__command_start] = ACTIONS(2793),
  },
  [1507] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1488),
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_function] = ACTIONS(2811),
    [anon_sym_end] = ACTIONS(2811),
    [anon_sym_abstract] = ACTIONS(2811),
    [anon_sym_primitive] = ACTIONS(2811),
    [aux_sym_primitive_definition_token1] = ACTIONS(2811),
    [anon_sym_mutable] = ACTIONS(2811),
    [anon_sym_struct] = ACTIONS(2811),
    [anon_sym_module] = ACTIONS(2811),
    [anon_sym_macro] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_COMMA] = ACTIONS(3463),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2815),
    [anon_sym_COLON_COLON] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_LT_COLON] = ACTIONS(2815),
    [anon_sym_if] = ACTIONS(2811),
    [anon_sym_try] = ACTIONS(2811),
    [anon_sym_for] = ACTIONS(2811),
    [anon_sym_while] = ACTIONS(2811),
    [sym_break_statement] = ACTIONS(2811),
    [sym_continue_statement] = ACTIONS(2811),
    [anon_sym_return] = ACTIONS(2811),
    [anon_sym_let] = ACTIONS(2811),
    [anon_sym_const] = ACTIONS(2811),
    [anon_sym_quote] = ACTIONS(2811),
    [anon_sym_using] = ACTIONS(2811),
    [anon_sym_import] = ACTIONS(2811),
    [anon_sym_export] = ACTIONS(2811),
    [anon_sym_COLON2] = ACTIONS(2811),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_begin] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_LT_PIPE] = ACTIONS(2815),
    [anon_sym_PIPE_GT] = ACTIONS(2815),
    [anon_sym_in] = ACTIONS(2811),
    [anon_sym_isa] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2815),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_LBRACK2] = ACTIONS(2815),
    [anon_sym_DOLLAR] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2815),
    [aux_sym_integer_literal_token1] = ACTIONS(2815),
    [aux_sym_integer_literal_token2] = ACTIONS(2815),
    [aux_sym_integer_literal_token3] = ACTIONS(2811),
    [sym_float_literal] = ACTIONS(2811),
    [sym__unary_operator] = ACTIONS(2811),
    [sym__power_operator] = ACTIONS(2815),
    [sym__bitshift_operator] = ACTIONS(2815),
    [sym__rational_operator] = ACTIONS(2815),
    [sym__times_operator] = ACTIONS(2811),
    [sym__plus_operator] = ACTIONS(2811),
    [sym__dotty_operator] = ACTIONS(2811),
    [sym__comparison_operator] = ACTIONS(2811),
    [sym__arrow_operator] = ACTIONS(2815),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2815),
    [sym__command_start] = ACTIONS(2815),
  },
  [1508] = {
    [aux_sym_let_statement_repeat1] = STATE(1465),
    [ts_builtin_sym_end] = ACTIONS(2770),
    [sym_identifier] = ACTIONS(2766),
    [anon_sym_function] = ACTIONS(2766),
    [anon_sym_abstract] = ACTIONS(2766),
    [anon_sym_primitive] = ACTIONS(2766),
    [aux_sym_primitive_definition_token1] = ACTIONS(2766),
    [anon_sym_mutable] = ACTIONS(2766),
    [anon_sym_struct] = ACTIONS(2766),
    [anon_sym_module] = ACTIONS(2766),
    [anon_sym_macro] = ACTIONS(2766),
    [anon_sym_LPAREN] = ACTIONS(2766),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_SEMI] = ACTIONS(2766),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2766),
    [anon_sym_COLON_COLON] = ACTIONS(2766),
    [anon_sym_LT_COLON] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2766),
    [anon_sym_try] = ACTIONS(2766),
    [anon_sym_for] = ACTIONS(2766),
    [anon_sym_while] = ACTIONS(2766),
    [sym_break_statement] = ACTIONS(2766),
    [sym_continue_statement] = ACTIONS(2766),
    [anon_sym_return] = ACTIONS(2766),
    [anon_sym_let] = ACTIONS(2766),
    [anon_sym_const] = ACTIONS(2766),
    [anon_sym_quote] = ACTIONS(2766),
    [anon_sym_using] = ACTIONS(2766),
    [anon_sym_import] = ACTIONS(2766),
    [anon_sym_export] = ACTIONS(2766),
    [anon_sym_COLON2] = ACTIONS(2766),
    [anon_sym_begin] = ACTIONS(2766),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_LT_PIPE] = ACTIONS(2766),
    [anon_sym_PIPE_GT] = ACTIONS(2766),
    [anon_sym_in] = ACTIONS(2766),
    [anon_sym_isa] = ACTIONS(2766),
    [anon_sym_PIPE_PIPE] = ACTIONS(2766),
    [anon_sym_AMP_AMP] = ACTIONS(2766),
    [anon_sym_QMARK] = ACTIONS(2766),
    [anon_sym_EQ_GT] = ACTIONS(2766),
    [anon_sym_LBRACK2] = ACTIONS(2766),
    [anon_sym_DOLLAR] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2766),
    [aux_sym_integer_literal_token1] = ACTIONS(2766),
    [aux_sym_integer_literal_token2] = ACTIONS(2766),
    [aux_sym_integer_literal_token3] = ACTIONS(2766),
    [sym_float_literal] = ACTIONS(2766),
    [sym__unary_operator] = ACTIONS(2766),
    [sym__power_operator] = ACTIONS(2766),
    [sym__bitshift_operator] = ACTIONS(2766),
    [sym__rational_operator] = ACTIONS(2766),
    [sym__times_operator] = ACTIONS(2766),
    [sym__plus_operator] = ACTIONS(2766),
    [sym__dotty_operator] = ACTIONS(2766),
    [sym__comparison_operator] = ACTIONS(2766),
    [sym__arrow_operator] = ACTIONS(2766),
    [sym__assign_operator] = ACTIONS(2766),
    [anon_sym_LF] = ACTIONS(2770),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2770),
    [sym__command_start] = ACTIONS(2770),
  },
  [1509] = {
    [ts_builtin_sym_end] = ACTIONS(2764),
    [sym_identifier] = ACTIONS(2762),
    [anon_sym_function] = ACTIONS(2762),
    [anon_sym_abstract] = ACTIONS(2762),
    [anon_sym_primitive] = ACTIONS(2762),
    [aux_sym_primitive_definition_token1] = ACTIONS(2762),
    [anon_sym_mutable] = ACTIONS(2762),
    [anon_sym_struct] = ACTIONS(2762),
    [anon_sym_module] = ACTIONS(2762),
    [anon_sym_macro] = ACTIONS(2762),
    [anon_sym_LPAREN] = ACTIONS(2762),
    [anon_sym_COMMA] = ACTIONS(2762),
    [anon_sym_SEMI] = ACTIONS(2762),
    [anon_sym_EQ] = ACTIONS(2762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2762),
    [anon_sym_COLON_COLON] = ACTIONS(2762),
    [anon_sym_LT_COLON] = ACTIONS(2762),
    [anon_sym_if] = ACTIONS(2762),
    [anon_sym_try] = ACTIONS(2762),
    [anon_sym_for] = ACTIONS(2762),
    [anon_sym_while] = ACTIONS(2762),
    [sym_break_statement] = ACTIONS(2762),
    [sym_continue_statement] = ACTIONS(2762),
    [anon_sym_return] = ACTIONS(2762),
    [anon_sym_let] = ACTIONS(2762),
    [anon_sym_const] = ACTIONS(2762),
    [anon_sym_quote] = ACTIONS(2762),
    [anon_sym_using] = ACTIONS(2762),
    [anon_sym_import] = ACTIONS(2762),
    [anon_sym_export] = ACTIONS(2762),
    [anon_sym_COLON2] = ACTIONS(2762),
    [anon_sym_begin] = ACTIONS(2762),
    [anon_sym_SQUOTE] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(2762),
    [anon_sym_LT_PIPE] = ACTIONS(2762),
    [anon_sym_PIPE_GT] = ACTIONS(2762),
    [anon_sym_in] = ACTIONS(2762),
    [anon_sym_isa] = ACTIONS(2762),
    [anon_sym_PIPE_PIPE] = ACTIONS(2762),
    [anon_sym_AMP_AMP] = ACTIONS(2762),
    [anon_sym_QMARK] = ACTIONS(2762),
    [anon_sym_EQ_GT] = ACTIONS(2762),
    [anon_sym_LBRACK2] = ACTIONS(2762),
    [anon_sym_DOLLAR] = ACTIONS(2762),
    [anon_sym_AT] = ACTIONS(2762),
    [aux_sym_integer_literal_token1] = ACTIONS(2762),
    [aux_sym_integer_literal_token2] = ACTIONS(2762),
    [aux_sym_integer_literal_token3] = ACTIONS(2762),
    [sym_float_literal] = ACTIONS(2762),
    [sym__unary_operator] = ACTIONS(2762),
    [sym__power_operator] = ACTIONS(2762),
    [sym__bitshift_operator] = ACTIONS(2762),
    [sym__rational_operator] = ACTIONS(2762),
    [sym__times_operator] = ACTIONS(2762),
    [sym__plus_operator] = ACTIONS(2762),
    [sym__dotty_operator] = ACTIONS(2762),
    [sym__comparison_operator] = ACTIONS(2762),
    [sym__arrow_operator] = ACTIONS(2762),
    [sym__assign_operator] = ACTIONS(2762),
    [anon_sym_LF] = ACTIONS(2764),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2764),
    [sym__string_start] = ACTIONS(2764),
    [sym__command_start] = ACTIONS(2764),
  },
  [1510] = {
    [ts_builtin_sym_end] = ACTIONS(2914),
    [sym_identifier] = ACTIONS(2912),
    [anon_sym_function] = ACTIONS(2912),
    [anon_sym_abstract] = ACTIONS(2912),
    [anon_sym_primitive] = ACTIONS(2912),
    [aux_sym_primitive_definition_token1] = ACTIONS(2912),
    [anon_sym_mutable] = ACTIONS(2912),
    [anon_sym_struct] = ACTIONS(2912),
    [anon_sym_module] = ACTIONS(2912),
    [anon_sym_macro] = ACTIONS(2912),
    [anon_sym_LPAREN] = ACTIONS(2912),
    [anon_sym_COMMA] = ACTIONS(2912),
    [anon_sym_SEMI] = ACTIONS(2912),
    [anon_sym_EQ] = ACTIONS(2912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2912),
    [anon_sym_COLON_COLON] = ACTIONS(2912),
    [anon_sym_LT_COLON] = ACTIONS(2912),
    [anon_sym_if] = ACTIONS(2912),
    [anon_sym_try] = ACTIONS(2912),
    [anon_sym_for] = ACTIONS(2912),
    [anon_sym_while] = ACTIONS(2912),
    [sym_break_statement] = ACTIONS(2912),
    [sym_continue_statement] = ACTIONS(2912),
    [anon_sym_return] = ACTIONS(2912),
    [anon_sym_let] = ACTIONS(2912),
    [anon_sym_const] = ACTIONS(2912),
    [anon_sym_quote] = ACTIONS(2912),
    [anon_sym_using] = ACTIONS(2912),
    [anon_sym_import] = ACTIONS(2912),
    [anon_sym_export] = ACTIONS(2912),
    [anon_sym_COLON2] = ACTIONS(2912),
    [anon_sym_begin] = ACTIONS(2912),
    [anon_sym_SQUOTE] = ACTIONS(2912),
    [anon_sym_PLUS] = ACTIONS(2912),
    [anon_sym_LT_PIPE] = ACTIONS(2912),
    [anon_sym_PIPE_GT] = ACTIONS(2912),
    [anon_sym_in] = ACTIONS(2912),
    [anon_sym_isa] = ACTIONS(2912),
    [anon_sym_PIPE_PIPE] = ACTIONS(2912),
    [anon_sym_AMP_AMP] = ACTIONS(2912),
    [anon_sym_QMARK] = ACTIONS(2912),
    [anon_sym_EQ_GT] = ACTIONS(2912),
    [anon_sym_LBRACK2] = ACTIONS(2912),
    [anon_sym_DOLLAR] = ACTIONS(2912),
    [anon_sym_AT] = ACTIONS(2912),
    [aux_sym_integer_literal_token1] = ACTIONS(2912),
    [aux_sym_integer_literal_token2] = ACTIONS(2912),
    [aux_sym_integer_literal_token3] = ACTIONS(2912),
    [sym_float_literal] = ACTIONS(2912),
    [sym__unary_operator] = ACTIONS(2912),
    [sym__power_operator] = ACTIONS(2912),
    [sym__bitshift_operator] = ACTIONS(2912),
    [sym__rational_operator] = ACTIONS(2912),
    [sym__times_operator] = ACTIONS(2912),
    [sym__plus_operator] = ACTIONS(2912),
    [sym__dotty_operator] = ACTIONS(2912),
    [sym__comparison_operator] = ACTIONS(2912),
    [sym__arrow_operator] = ACTIONS(2912),
    [sym__assign_operator] = ACTIONS(2912),
    [anon_sym_LF] = ACTIONS(2914),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(2914),
    [sym__string_start] = ACTIONS(2914),
    [sym__command_start] = ACTIONS(2914),
  },
  [1511] = {
    [aux_sym_import_statement_repeat1] = STATE(1520),
    [ts_builtin_sym_end] = ACTIONS(2756),
    [sym_identifier] = ACTIONS(2754),
    [anon_sym_function] = ACTIONS(2754),
    [anon_sym_abstract] = ACTIONS(2754),
    [anon_sym_primitive] = ACTIONS(2754),
    [aux_sym_primitive_definition_token1] = ACTIONS(2754),
    [anon_sym_mutable] = ACTIONS(2754),
    [anon_sym_struct] = ACTIONS(2754),
    [anon_sym_module] = ACTIONS(2754),
    [anon_sym_macro] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_EQ] = ACTIONS(2754),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2754),
    [anon_sym_COLON_COLON] = ACTIONS(2754),
    [anon_sym_LT_COLON] = ACTIONS(2754),
    [anon_sym_if] = ACTIONS(2754),
    [anon_sym_try] = ACTIONS(2754),
    [anon_sym_for] = ACTIONS(2754),
    [anon_sym_while] = ACTIONS(2754),
    [sym_break_statement] = ACTIONS(2754),
    [sym_continue_statement] = ACTIONS(2754),
    [anon_sym_return] = ACTIONS(2754),
    [anon_sym_let] = ACTIONS(2754),
    [anon_sym_const] = ACTIONS(2754),
    [anon_sym_quote] = ACTIONS(2754),
    [anon_sym_using] = ACTIONS(2754),
    [anon_sym_import] = ACTIONS(2754),
    [anon_sym_export] = ACTIONS(2754),
    [anon_sym_COLON2] = ACTIONS(2754),
    [anon_sym_begin] = ACTIONS(2754),
    [anon_sym_SQUOTE] = ACTIONS(2754),
    [anon_sym_PLUS] = ACTIONS(2754),
    [anon_sym_LT_PIPE] = ACTIONS(2754),
    [anon_sym_PIPE_GT] = ACTIONS(2754),
    [anon_sym_in] = ACTIONS(2754),
    [anon_sym_isa] = ACTIONS(2754),
    [anon_sym_PIPE_PIPE] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(2754),
    [anon_sym_QMARK] = ACTIONS(2754),
    [anon_sym_EQ_GT] = ACTIONS(2754),
    [anon_sym_LBRACK2] = ACTIONS(2754),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [anon_sym_AT] = ACTIONS(2754),
    [aux_sym_integer_literal_token1] = ACTIONS(2754),
    [aux_sym_integer_literal_token2] = ACTIONS(2754),
    [aux_sym_integer_literal_token3] = ACTIONS(2754),
    [sym_float_literal] = ACTIONS(2754),
    [sym__unary_operator] = ACTIONS(2754),
    [sym__power_operator] = ACTIONS(2754),
    [sym__bitshift_operator] = ACTIONS(2754),
    [sym__rational_operator] = ACTIONS(2754),
    [sym__times_operator] = ACTIONS(2754),
    [sym__plus_operator] = ACTIONS(2754),
    [sym__dotty_operator] = ACTIONS(2754),
    [sym__comparison_operator] = ACTIONS(2754),
    [sym__arrow_operator] = ACTIONS(2754),
    [sym__assign_operator] = ACTIONS(2754),
    [anon_sym_LF] = ACTIONS(2756),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2756),
    [sym__command_start] = ACTIONS(2756),
  },
  [1512] = {
    [aux_sym_export_statement_repeat1] = STATE(1521),
    [ts_builtin_sym_end] = ACTIONS(2799),
    [sym_identifier] = ACTIONS(2795),
    [anon_sym_function] = ACTIONS(2795),
    [anon_sym_abstract] = ACTIONS(2795),
    [anon_sym_primitive] = ACTIONS(2795),
    [aux_sym_primitive_definition_token1] = ACTIONS(2795),
    [anon_sym_mutable] = ACTIONS(2795),
    [anon_sym_struct] = ACTIONS(2795),
    [anon_sym_module] = ACTIONS(2795),
    [anon_sym_macro] = ACTIONS(2795),
    [anon_sym_LPAREN] = ACTIONS(2795),
    [anon_sym_COMMA] = ACTIONS(3526),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_EQ] = ACTIONS(2795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2795),
    [anon_sym_COLON_COLON] = ACTIONS(2795),
    [anon_sym_LT_COLON] = ACTIONS(2795),
    [anon_sym_if] = ACTIONS(2795),
    [anon_sym_try] = ACTIONS(2795),
    [anon_sym_for] = ACTIONS(2795),
    [anon_sym_while] = ACTIONS(2795),
    [sym_break_statement] = ACTIONS(2795),
    [sym_continue_statement] = ACTIONS(2795),
    [anon_sym_return] = ACTIONS(2795),
    [anon_sym_let] = ACTIONS(2795),
    [anon_sym_const] = ACTIONS(2795),
    [anon_sym_quote] = ACTIONS(2795),
    [anon_sym_using] = ACTIONS(2795),
    [anon_sym_import] = ACTIONS(2795),
    [anon_sym_export] = ACTIONS(2795),
    [anon_sym_COLON2] = ACTIONS(2795),
    [anon_sym_begin] = ACTIONS(2795),
    [anon_sym_SQUOTE] = ACTIONS(2795),
    [anon_sym_PLUS] = ACTIONS(2795),
    [anon_sym_LT_PIPE] = ACTIONS(2795),
    [anon_sym_PIPE_GT] = ACTIONS(2795),
    [anon_sym_in] = ACTIONS(2795),
    [anon_sym_isa] = ACTIONS(2795),
    [anon_sym_PIPE_PIPE] = ACTIONS(2795),
    [anon_sym_AMP_AMP] = ACTIONS(2795),
    [anon_sym_QMARK] = ACTIONS(2795),
    [anon_sym_EQ_GT] = ACTIONS(2795),
    [anon_sym_LBRACK2] = ACTIONS(2795),
    [anon_sym_DOLLAR] = ACTIONS(2795),
    [anon_sym_AT] = ACTIONS(2795),
    [aux_sym_integer_literal_token1] = ACTIONS(2795),
    [aux_sym_integer_literal_token2] = ACTIONS(2795),
    [aux_sym_integer_literal_token3] = ACTIONS(2795),
    [sym_float_literal] = ACTIONS(2795),
    [sym__unary_operator] = ACTIONS(2795),
    [sym__power_operator] = ACTIONS(2795),
    [sym__bitshift_operator] = ACTIONS(2795),
    [sym__rational_operator] = ACTIONS(2795),
    [sym__times_operator] = ACTIONS(2795),
    [sym__plus_operator] = ACTIONS(2795),
    [sym__dotty_operator] = ACTIONS(2795),
    [sym__comparison_operator] = ACTIONS(2795),
    [sym__arrow_operator] = ACTIONS(2795),
    [sym__assign_operator] = ACTIONS(2795),
    [anon_sym_LF] = ACTIONS(2799),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2799),
    [sym__command_start] = ACTIONS(2799),
  },
  [1513] = {
    [ts_builtin_sym_end] = ACTIONS(2906),
    [sym_identifier] = ACTIONS(2904),
    [anon_sym_function] = ACTIONS(2904),
    [anon_sym_abstract] = ACTIONS(2904),
    [anon_sym_primitive] = ACTIONS(2904),
    [aux_sym_primitive_definition_token1] = ACTIONS(2904),
    [anon_sym_mutable] = ACTIONS(2904),
    [anon_sym_struct] = ACTIONS(2904),
    [anon_sym_module] = ACTIONS(2904),
    [anon_sym_macro] = ACTIONS(2904),
    [anon_sym_LPAREN] = ACTIONS(2904),
    [anon_sym_COMMA] = ACTIONS(2904),
    [anon_sym_SEMI] = ACTIONS(2904),
    [anon_sym_EQ] = ACTIONS(2904),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2904),
    [anon_sym_COLON_COLON] = ACTIONS(2904),
    [anon_sym_LT_COLON] = ACTIONS(2904),
    [anon_sym_if] = ACTIONS(2904),
    [anon_sym_try] = ACTIONS(2904),
    [anon_sym_for] = ACTIONS(2904),
    [anon_sym_while] = ACTIONS(2904),
    [sym_break_statement] = ACTIONS(2904),
    [sym_continue_statement] = ACTIONS(2904),
    [anon_sym_return] = ACTIONS(2904),
    [anon_sym_let] = ACTIONS(2904),
    [anon_sym_const] = ACTIONS(2904),
    [anon_sym_quote] = ACTIONS(2904),
    [anon_sym_using] = ACTIONS(2904),
    [anon_sym_import] = ACTIONS(2904),
    [anon_sym_export] = ACTIONS(2904),
    [anon_sym_COLON2] = ACTIONS(2904),
    [anon_sym_LBRACK] = ACTIONS(2906),
    [anon_sym_begin] = ACTIONS(2904),
    [anon_sym_SQUOTE] = ACTIONS(2904),
    [anon_sym_PLUS] = ACTIONS(2904),
    [anon_sym_LT_PIPE] = ACTIONS(2904),
    [anon_sym_PIPE_GT] = ACTIONS(2904),
    [anon_sym_in] = ACTIONS(2904),
    [anon_sym_isa] = ACTIONS(2904),
    [anon_sym_PIPE_PIPE] = ACTIONS(2904),
    [anon_sym_AMP_AMP] = ACTIONS(2904),
    [anon_sym_QMARK] = ACTIONS(2904),
    [anon_sym_EQ_GT] = ACTIONS(2904),
    [anon_sym_LBRACK2] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(2904),
    [anon_sym_AT] = ACTIONS(2904),
    [aux_sym_integer_literal_token1] = ACTIONS(2904),
    [aux_sym_integer_literal_token2] = ACTIONS(2904),
    [aux_sym_integer_literal_token3] = ACTIONS(2904),
    [sym_float_literal] = ACTIONS(2904),
    [sym__unary_operator] = ACTIONS(2904),
    [sym__power_operator] = ACTIONS(2904),
    [sym__bitshift_operator] = ACTIONS(2904),
    [sym__rational_operator] = ACTIONS(2904),
    [sym__times_operator] = ACTIONS(2904),
    [sym__plus_operator] = ACTIONS(2904),
    [sym__dotty_operator] = ACTIONS(2904),
    [sym__comparison_operator] = ACTIONS(2904),
    [sym__arrow_operator] = ACTIONS(2904),
    [sym__assign_operator] = ACTIONS(2904),
    [anon_sym_LF] = ACTIONS(2906),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2906),
    [sym__command_start] = ACTIONS(2906),
  },
  [1514] = {
    [ts_builtin_sym_end] = ACTIONS(2760),
    [sym_identifier] = ACTIONS(2758),
    [anon_sym_function] = ACTIONS(2758),
    [anon_sym_abstract] = ACTIONS(2758),
    [anon_sym_primitive] = ACTIONS(2758),
    [aux_sym_primitive_definition_token1] = ACTIONS(2758),
    [anon_sym_mutable] = ACTIONS(2758),
    [anon_sym_struct] = ACTIONS(2758),
    [anon_sym_module] = ACTIONS(2758),
    [anon_sym_macro] = ACTIONS(2758),
    [anon_sym_LPAREN] = ACTIONS(2758),
    [anon_sym_COMMA] = ACTIONS(2758),
    [anon_sym_SEMI] = ACTIONS(2758),
    [anon_sym_EQ] = ACTIONS(2758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2758),
    [anon_sym_COLON_COLON] = ACTIONS(2758),
    [anon_sym_LT_COLON] = ACTIONS(2758),
    [anon_sym_if] = ACTIONS(2758),
    [anon_sym_try] = ACTIONS(2758),
    [anon_sym_for] = ACTIONS(2758),
    [anon_sym_while] = ACTIONS(2758),
    [sym_break_statement] = ACTIONS(2758),
    [sym_continue_statement] = ACTIONS(2758),
    [anon_sym_return] = ACTIONS(2758),
    [anon_sym_let] = ACTIONS(2758),
    [anon_sym_const] = ACTIONS(2758),
    [anon_sym_quote] = ACTIONS(2758),
    [anon_sym_using] = ACTIONS(2758),
    [anon_sym_import] = ACTIONS(2758),
    [anon_sym_export] = ACTIONS(2758),
    [anon_sym_COLON2] = ACTIONS(2758),
    [anon_sym_LBRACK] = ACTIONS(2760),
    [anon_sym_begin] = ACTIONS(2758),
    [anon_sym_SQUOTE] = ACTIONS(2758),
    [anon_sym_PLUS] = ACTIONS(2758),
    [anon_sym_LT_PIPE] = ACTIONS(2758),
    [anon_sym_PIPE_GT] = ACTIONS(2758),
    [anon_sym_in] = ACTIONS(2758),
    [anon_sym_isa] = ACTIONS(2758),
    [anon_sym_PIPE_PIPE] = ACTIONS(2758),
    [anon_sym_AMP_AMP] = ACTIONS(2758),
    [anon_sym_QMARK] = ACTIONS(2758),
    [anon_sym_EQ_GT] = ACTIONS(2758),
    [anon_sym_LBRACK2] = ACTIONS(2758),
    [anon_sym_DOLLAR] = ACTIONS(2758),
    [anon_sym_AT] = ACTIONS(2758),
    [aux_sym_integer_literal_token1] = ACTIONS(2758),
    [aux_sym_integer_literal_token2] = ACTIONS(2758),
    [aux_sym_integer_literal_token3] = ACTIONS(2758),
    [sym_float_literal] = ACTIONS(2758),
    [sym__unary_operator] = ACTIONS(2758),
    [sym__power_operator] = ACTIONS(2758),
    [sym__bitshift_operator] = ACTIONS(2758),
    [sym__rational_operator] = ACTIONS(2758),
    [sym__times_operator] = ACTIONS(2758),
    [sym__plus_operator] = ACTIONS(2758),
    [sym__dotty_operator] = ACTIONS(2758),
    [sym__comparison_operator] = ACTIONS(2758),
    [sym__arrow_operator] = ACTIONS(2758),
    [sym__assign_operator] = ACTIONS(2758),
    [anon_sym_LF] = ACTIONS(2760),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2760),
    [sym__command_start] = ACTIONS(2760),
  },
  [1515] = {
    [ts_builtin_sym_end] = ACTIONS(2781),
    [sym_identifier] = ACTIONS(2779),
    [anon_sym_function] = ACTIONS(2779),
    [anon_sym_abstract] = ACTIONS(2779),
    [anon_sym_primitive] = ACTIONS(2779),
    [aux_sym_primitive_definition_token1] = ACTIONS(2779),
    [anon_sym_mutable] = ACTIONS(2779),
    [anon_sym_struct] = ACTIONS(2779),
    [anon_sym_module] = ACTIONS(2779),
    [anon_sym_macro] = ACTIONS(2779),
    [anon_sym_LPAREN] = ACTIONS(2779),
    [anon_sym_COMMA] = ACTIONS(2779),
    [anon_sym_SEMI] = ACTIONS(2779),
    [anon_sym_EQ] = ACTIONS(2779),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2779),
    [anon_sym_COLON_COLON] = ACTIONS(2779),
    [anon_sym_LT_COLON] = ACTIONS(2779),
    [anon_sym_if] = ACTIONS(2779),
    [anon_sym_try] = ACTIONS(2779),
    [anon_sym_for] = ACTIONS(2779),
    [anon_sym_while] = ACTIONS(2779),
    [sym_break_statement] = ACTIONS(2779),
    [sym_continue_statement] = ACTIONS(2779),
    [anon_sym_return] = ACTIONS(2779),
    [anon_sym_let] = ACTIONS(2779),
    [anon_sym_const] = ACTIONS(2779),
    [anon_sym_quote] = ACTIONS(2779),
    [anon_sym_using] = ACTIONS(2779),
    [anon_sym_import] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(2779),
    [anon_sym_COLON2] = ACTIONS(2779),
    [anon_sym_LBRACK] = ACTIONS(2781),
    [anon_sym_begin] = ACTIONS(2779),
    [anon_sym_SQUOTE] = ACTIONS(2779),
    [anon_sym_PLUS] = ACTIONS(2779),
    [anon_sym_LT_PIPE] = ACTIONS(2779),
    [anon_sym_PIPE_GT] = ACTIONS(2779),
    [anon_sym_in] = ACTIONS(2779),
    [anon_sym_isa] = ACTIONS(2779),
    [anon_sym_PIPE_PIPE] = ACTIONS(2779),
    [anon_sym_AMP_AMP] = ACTIONS(2779),
    [anon_sym_QMARK] = ACTIONS(2779),
    [anon_sym_EQ_GT] = ACTIONS(2779),
    [anon_sym_LBRACK2] = ACTIONS(2779),
    [anon_sym_DOLLAR] = ACTIONS(2779),
    [anon_sym_AT] = ACTIONS(2779),
    [aux_sym_integer_literal_token1] = ACTIONS(2779),
    [aux_sym_integer_literal_token2] = ACTIONS(2779),
    [aux_sym_integer_literal_token3] = ACTIONS(2779),
    [sym_float_literal] = ACTIONS(2779),
    [sym__unary_operator] = ACTIONS(2779),
    [sym__power_operator] = ACTIONS(2779),
    [sym__bitshift_operator] = ACTIONS(2779),
    [sym__rational_operator] = ACTIONS(2779),
    [sym__times_operator] = ACTIONS(2779),
    [sym__plus_operator] = ACTIONS(2779),
    [sym__dotty_operator] = ACTIONS(2779),
    [sym__comparison_operator] = ACTIONS(2779),
    [sym__arrow_operator] = ACTIONS(2779),
    [sym__assign_operator] = ACTIONS(2779),
    [anon_sym_LF] = ACTIONS(2781),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2781),
    [sym__command_start] = ACTIONS(2781),
  },
  [1516] = {
    [sym_identifier] = ACTIONS(3193),
    [anon_sym_function] = ACTIONS(3193),
    [anon_sym_end] = ACTIONS(3193),
    [anon_sym_abstract] = ACTIONS(3193),
    [anon_sym_primitive] = ACTIONS(3193),
    [aux_sym_primitive_definition_token1] = ACTIONS(3193),
    [anon_sym_mutable] = ACTIONS(3193),
    [anon_sym_struct] = ACTIONS(3193),
    [anon_sym_module] = ACTIONS(3193),
    [anon_sym_macro] = ACTIONS(3193),
    [anon_sym_LPAREN] = ACTIONS(3193),
    [anon_sym_SEMI] = ACTIONS(3193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3193),
    [anon_sym_COLON_COLON] = ACTIONS(3193),
    [anon_sym_LT_COLON] = ACTIONS(3193),
    [anon_sym_if] = ACTIONS(3193),
    [anon_sym_elseif] = ACTIONS(3193),
    [anon_sym_else] = ACTIONS(3193),
    [anon_sym_try] = ACTIONS(3193),
    [anon_sym_for] = ACTIONS(3193),
    [anon_sym_while] = ACTIONS(3193),
    [sym_break_statement] = ACTIONS(3193),
    [sym_continue_statement] = ACTIONS(3193),
    [anon_sym_return] = ACTIONS(3193),
    [anon_sym_let] = ACTIONS(3193),
    [anon_sym_const] = ACTIONS(3193),
    [anon_sym_quote] = ACTIONS(3193),
    [anon_sym_using] = ACTIONS(3193),
    [anon_sym_import] = ACTIONS(3193),
    [anon_sym_export] = ACTIONS(3193),
    [anon_sym_COLON2] = ACTIONS(3193),
    [anon_sym_begin] = ACTIONS(3193),
    [anon_sym_SQUOTE] = ACTIONS(3193),
    [anon_sym_PLUS] = ACTIONS(3193),
    [anon_sym_LT_PIPE] = ACTIONS(3193),
    [anon_sym_PIPE_GT] = ACTIONS(3193),
    [anon_sym_in] = ACTIONS(3193),
    [anon_sym_isa] = ACTIONS(3193),
    [anon_sym_PIPE_PIPE] = ACTIONS(3193),
    [anon_sym_AMP_AMP] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_EQ_GT] = ACTIONS(3193),
    [anon_sym_LBRACK2] = ACTIONS(3193),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_AT] = ACTIONS(3193),
    [aux_sym_integer_literal_token1] = ACTIONS(3193),
    [aux_sym_integer_literal_token2] = ACTIONS(3193),
    [aux_sym_integer_literal_token3] = ACTIONS(3193),
    [sym_float_literal] = ACTIONS(3193),
    [sym_escape_sequence] = ACTIONS(3528),
    [aux_sym_character_literal_token1] = ACTIONS(3528),
    [sym__unary_operator] = ACTIONS(3193),
    [sym__power_operator] = ACTIONS(3193),
    [sym__bitshift_operator] = ACTIONS(3193),
    [sym__rational_operator] = ACTIONS(3193),
    [sym__times_operator] = ACTIONS(3193),
    [sym__plus_operator] = ACTIONS(3193),
    [sym__dotty_operator] = ACTIONS(3193),
    [sym__comparison_operator] = ACTIONS(3193),
    [sym__arrow_operator] = ACTIONS(3193),
    [anon_sym_LF] = ACTIONS(3193),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(3195),
    [sym__command_start] = ACTIONS(3195),
  },
  [1517] = {
    [aux_sym_bare_tuple_expression_repeat1] = STATE(1517),
    [sym_identifier] = ACTIONS(2772),
    [anon_sym_function] = ACTIONS(2772),
    [anon_sym_end] = ACTIONS(2772),
    [anon_sym_abstract] = ACTIONS(2772),
    [anon_sym_primitive] = ACTIONS(2772),
    [aux_sym_primitive_definition_token1] = ACTIONS(2772),
    [anon_sym_mutable] = ACTIONS(2772),
    [anon_sym_struct] = ACTIONS(2772),
    [anon_sym_module] = ACTIONS(2772),
    [anon_sym_macro] = ACTIONS(2772),
    [anon_sym_LPAREN] = ACTIONS(2772),
    [anon_sym_COMMA] = ACTIONS(3530),
    [anon_sym_SEMI] = ACTIONS(2772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2772),
    [anon_sym_COLON_COLON] = ACTIONS(2772),
    [anon_sym_LT_COLON] = ACTIONS(2772),
    [anon_sym_if] = ACTIONS(2772),
    [anon_sym_elseif] = ACTIONS(2772),
    [anon_sym_else] = ACTIONS(2772),
    [anon_sym_try] = ACTIONS(2772),
    [anon_sym_for] = ACTIONS(2772),
    [anon_sym_while] = ACTIONS(2772),
    [sym_break_statement] = ACTIONS(2772),
    [sym_continue_statement] = ACTIONS(2772),
    [anon_sym_return] = ACTIONS(2772),
    [anon_sym_let] = ACTIONS(2772),
    [anon_sym_const] = ACTIONS(2772),
    [anon_sym_quote] = ACTIONS(2772),
    [anon_sym_using] = ACTIONS(2772),
    [anon_sym_import] = ACTIONS(2772),
    [anon_sym_export] = ACTIONS(2772),
    [anon_sym_COLON2] = ACTIONS(2772),
    [anon_sym_begin] = ACTIONS(2772),
    [anon_sym_SQUOTE] = ACTIONS(2772),
    [anon_sym_PLUS] = ACTIONS(2772),
    [anon_sym_LT_PIPE] = ACTIONS(2772),
    [anon_sym_PIPE_GT] = ACTIONS(2772),
    [anon_sym_in] = ACTIONS(2772),
    [anon_sym_isa] = ACTIONS(2772),
    [anon_sym_PIPE_PIPE] = ACTIONS(2772),
    [anon_sym_AMP_AMP] = ACTIONS(2772),
    [anon_sym_QMARK] = ACTIONS(2772),
    [anon_sym_EQ_GT] = ACTIONS(2772),
    [anon_sym_LBRACK2] = ACTIONS(2772),
    [anon_sym_DOLLAR] = ACTIONS(2772),
    [anon_sym_AT] = ACTIONS(2772),
    [aux_sym_integer_literal_token1] = ACTIONS(2772),
    [aux_sym_integer_literal_token2] = ACTIONS(2772),
    [aux_sym_integer_literal_token3] = ACTIONS(2772),
    [sym_float_literal] = ACTIONS(2772),
    [sym__unary_operator] = ACTIONS(2772),
    [sym__power_operator] = ACTIONS(2772),
    [sym__bitshift_operator] = ACTIONS(2772),
    [sym__rational_operator] = ACTIONS(2772),
    [sym__times_operator] = ACTIONS(2772),
    [sym__plus_operator] = ACTIONS(2772),
    [sym__dotty_operator] = ACTIONS(2772),
    [sym__comparison_operator] = ACTIONS(2772),
    [sym__arrow_operator] = ACTIONS(2772),
    [anon_sym_LF] = ACTIONS(2777),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2777),
    [sym__command_start] = ACTIONS(2777),
  },
  [1518] = {
    [aux_sym_let_statement_repeat1] = STATE(1518),
    [sym_identifier] = ACTIONS(2916),
    [anon_sym_function] = ACTIONS(2916),
    [anon_sym_end] = ACTIONS(2916),
    [anon_sym_abstract] = ACTIONS(2916),
    [anon_sym_primitive] = ACTIONS(2916),
    [aux_sym_primitive_definition_token1] = ACTIONS(2916),
    [anon_sym_mutable] = ACTIONS(2916),
    [anon_sym_struct] = ACTIONS(2916),
    [anon_sym_module] = ACTIONS(2916),
    [anon_sym_macro] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2921),
    [anon_sym_COMMA] = ACTIONS(3533),
    [anon_sym_RPAREN] = ACTIONS(2921),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2921),
    [anon_sym_COLON_COLON] = ACTIONS(2921),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_LT_COLON] = ACTIONS(2921),
    [anon_sym_if] = ACTIONS(2916),
    [anon_sym_try] = ACTIONS(2916),
    [anon_sym_for] = ACTIONS(2916),
    [anon_sym_while] = ACTIONS(2916),
    [sym_break_statement] = ACTIONS(2916),
    [sym_continue_statement] = ACTIONS(2916),
    [anon_sym_return] = ACTIONS(2916),
    [anon_sym_let] = ACTIONS(2916),
    [anon_sym_const] = ACTIONS(2916),
    [anon_sym_quote] = ACTIONS(2916),
    [anon_sym_using] = ACTIONS(2916),
    [anon_sym_import] = ACTIONS(2916),
    [anon_sym_export] = ACTIONS(2916),
    [anon_sym_COLON2] = ACTIONS(2916),
    [anon_sym_RBRACK] = ACTIONS(2921),
    [anon_sym_begin] = ACTIONS(2916),
    [anon_sym_SQUOTE] = ACTIONS(2921),
    [anon_sym_PLUS] = ACTIONS(2916),
    [anon_sym_LT_PIPE] = ACTIONS(2921),
    [anon_sym_PIPE_GT] = ACTIONS(2921),
    [anon_sym_in] = ACTIONS(2916),
    [anon_sym_isa] = ACTIONS(2916),
    [anon_sym_PIPE_PIPE] = ACTIONS(2921),
    [anon_sym_AMP_AMP] = ACTIONS(2921),
    [anon_sym_QMARK] = ACTIONS(2921),
    [anon_sym_EQ_GT] = ACTIONS(2921),
    [anon_sym_LBRACK2] = ACTIONS(2921),
    [anon_sym_DOLLAR] = ACTIONS(2921),
    [anon_sym_AT] = ACTIONS(2921),
    [aux_sym_integer_literal_token1] = ACTIONS(2921),
    [aux_sym_integer_literal_token2] = ACTIONS(2921),
    [aux_sym_integer_literal_token3] = ACTIONS(2916),
    [sym_float_literal] = ACTIONS(2916),
    [sym__unary_operator] = ACTIONS(2916),
    [sym__power_operator] = ACTIONS(2921),
    [sym__bitshift_operator] = ACTIONS(2921),
    [sym__rational_operator] = ACTIONS(2921),
    [sym__times_operator] = ACTIONS(2916),
    [sym__plus_operator] = ACTIONS(2916),
    [sym__dotty_operator] = ACTIONS(2916),
    [sym__comparison_operator] = ACTIONS(2916),
    [sym__arrow_operator] = ACTIONS(2921),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2921),
    [sym__command_start] = ACTIONS(2921),
  },
  [1519] = {
    [aux_sym_selected_import_repeat1] = STATE(1524),
    [ts_builtin_sym_end] = ACTIONS(2831),
    [sym_identifier] = ACTIONS(2827),
    [anon_sym_function] = ACTIONS(2827),
    [anon_sym_abstract] = ACTIONS(2827),
    [anon_sym_primitive] = ACTIONS(2827),
    [aux_sym_primitive_definition_token1] = ACTIONS(2827),
    [anon_sym_mutable] = ACTIONS(2827),
    [anon_sym_struct] = ACTIONS(2827),
    [anon_sym_module] = ACTIONS(2827),
    [anon_sym_macro] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(3536),
    [anon_sym_SEMI] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2827),
    [anon_sym_LT_COLON] = ACTIONS(2827),
    [anon_sym_if] = ACTIONS(2827),
    [anon_sym_try] = ACTIONS(2827),
    [anon_sym_for] = ACTIONS(2827),
    [anon_sym_while] = ACTIONS(2827),
    [sym_break_statement] = ACTIONS(2827),
    [sym_continue_statement] = ACTIONS(2827),
    [anon_sym_return] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_const] = ACTIONS(2827),
    [anon_sym_quote] = ACTIONS(2827),
    [anon_sym_using] = ACTIONS(2827),
    [anon_sym_import] = ACTIONS(2827),
    [anon_sym_export] = ACTIONS(2827),
    [anon_sym_COLON2] = ACTIONS(2827),
    [anon_sym_begin] = ACTIONS(2827),
    [anon_sym_SQUOTE] = ACTIONS(2827),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_LT_PIPE] = ACTIONS(2827),
    [anon_sym_PIPE_GT] = ACTIONS(2827),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_isa] = ACTIONS(2827),
    [anon_sym_PIPE_PIPE] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_EQ_GT] = ACTIONS(2827),
    [anon_sym_LBRACK2] = ACTIONS(2827),
    [anon_sym_DOLLAR] = ACTIONS(2827),
    [anon_sym_AT] = ACTIONS(2827),
    [aux_sym_integer_literal_token1] = ACTIONS(2827),
    [aux_sym_integer_literal_token2] = ACTIONS(2827),
    [aux_sym_integer_literal_token3] = ACTIONS(2827),
    [sym_float_literal] = ACTIONS(2827),
    [sym__unary_operator] = ACTIONS(2827),
    [sym__power_operator] = ACTIONS(2827),
    [sym__bitshift_operator] = ACTIONS(2827),
    [sym__rational_operator] = ACTIONS(2827),
    [sym__times_operator] = ACTIONS(2827),
    [sym__plus_operator] = ACTIONS(2827),
    [sym__dotty_operator] = ACTIONS(2827),
    [sym__comparison_operator] = ACTIONS(2827),
    [sym__arrow_operator] = ACTIONS(2827),
    [sym__assign_operator] = ACTIONS(2827),
    [anon_sym_LF] = ACTIONS(2831),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2831),
    [sym__command_start] = ACTIONS(2831),
  },
  [1520] = {
    [aux_sym_import_statement_repeat1] = STATE(1520),
    [ts_builtin_sym_end] = ACTIONS(2746),
    [sym_identifier] = ACTIONS(2744),
    [anon_sym_function] = ACTIONS(2744),
    [anon_sym_abstract] = ACTIONS(2744),
    [anon_sym_primitive] = ACTIONS(2744),
    [aux_sym_primitive_definition_token1] = ACTIONS(2744),
    [anon_sym_mutable] = ACTIONS(2744),
    [anon_sym_struct] = ACTIONS(2744),
    [anon_sym_module] = ACTIONS(2744),
    [anon_sym_macro] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(3538),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_COLON_COLON] = ACTIONS(2744),
    [anon_sym_LT_COLON] = ACTIONS(2744),
    [anon_sym_if] = ACTIONS(2744),
    [anon_sym_try] = ACTIONS(2744),
    [anon_sym_for] = ACTIONS(2744),
    [anon_sym_while] = ACTIONS(2744),
    [sym_break_statement] = ACTIONS(2744),
    [sym_continue_statement] = ACTIONS(2744),
    [anon_sym_return] = ACTIONS(2744),
    [anon_sym_let] = ACTIONS(2744),
    [anon_sym_const] = ACTIONS(2744),
    [anon_sym_quote] = ACTIONS(2744),
    [anon_sym_using] = ACTIONS(2744),
    [anon_sym_import] = ACTIONS(2744),
    [anon_sym_export] = ACTIONS(2744),
    [anon_sym_COLON2] = ACTIONS(2744),
    [anon_sym_begin] = ACTIONS(2744),
    [anon_sym_SQUOTE] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2744),
    [anon_sym_LT_PIPE] = ACTIONS(2744),
    [anon_sym_PIPE_GT] = ACTIONS(2744),
    [anon_sym_in] = ACTIONS(2744),
    [anon_sym_isa] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_LBRACK2] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [aux_sym_integer_literal_token1] = ACTIONS(2744),
    [aux_sym_integer_literal_token2] = ACTIONS(2744),
    [aux_sym_integer_literal_token3] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__unary_operator] = ACTIONS(2744),
    [sym__power_operator] = ACTIONS(2744),
    [sym__bitshift_operator] = ACTIONS(2744),
    [sym__rational_operator] = ACTIONS(2744),
    [sym__times_operator] = ACTIONS(2744),
    [sym__plus_operator] = ACTIONS(2744),
    [sym__dotty_operator] = ACTIONS(2744),
    [sym__comparison_operator] = ACTIONS(2744),
    [sym__arrow_operator] = ACTIONS(2744),
    [sym__assign_operator] = ACTIONS(2744),
    [anon_sym_LF] = ACTIONS(2746),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2746),
    [sym__command_start] = ACTIONS(2746),
  },
  [1521] = {
    [aux_sym_export_statement_repeat1] = STATE(1521),
    [ts_builtin_sym_end] = ACTIONS(2822),
    [sym_identifier] = ACTIONS(2817),
    [anon_sym_function] = ACTIONS(2817),
    [anon_sym_abstract] = ACTIONS(2817),
    [anon_sym_primitive] = ACTIONS(2817),
    [aux_sym_primitive_definition_token1] = ACTIONS(2817),
    [anon_sym_mutable] = ACTIONS(2817),
    [anon_sym_struct] = ACTIONS(2817),
    [anon_sym_module] = ACTIONS(2817),
    [anon_sym_macro] = ACTIONS(2817),
    [anon_sym_LPAREN] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(2817),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2817),
    [anon_sym_COLON_COLON] = ACTIONS(2817),
    [anon_sym_LT_COLON] = ACTIONS(2817),
    [anon_sym_if] = ACTIONS(2817),
    [anon_sym_try] = ACTIONS(2817),
    [anon_sym_for] = ACTIONS(2817),
    [anon_sym_while] = ACTIONS(2817),
    [sym_break_statement] = ACTIONS(2817),
    [sym_continue_statement] = ACTIONS(2817),
    [anon_sym_return] = ACTIONS(2817),
    [anon_sym_let] = ACTIONS(2817),
    [anon_sym_const] = ACTIONS(2817),
    [anon_sym_quote] = ACTIONS(2817),
    [anon_sym_using] = ACTIONS(2817),
    [anon_sym_import] = ACTIONS(2817),
    [anon_sym_export] = ACTIONS(2817),
    [anon_sym_COLON2] = ACTIONS(2817),
    [anon_sym_begin] = ACTIONS(2817),
    [anon_sym_SQUOTE] = ACTIONS(2817),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_LT_PIPE] = ACTIONS(2817),
    [anon_sym_PIPE_GT] = ACTIONS(2817),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_isa] = ACTIONS(2817),
    [anon_sym_PIPE_PIPE] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2817),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_EQ_GT] = ACTIONS(2817),
    [anon_sym_LBRACK2] = ACTIONS(2817),
    [anon_sym_DOLLAR] = ACTIONS(2817),
    [anon_sym_AT] = ACTIONS(2817),
    [aux_sym_integer_literal_token1] = ACTIONS(2817),
    [aux_sym_integer_literal_token2] = ACTIONS(2817),
    [aux_sym_integer_literal_token3] = ACTIONS(2817),
    [sym_float_literal] = ACTIONS(2817),
    [sym__unary_operator] = ACTIONS(2817),
    [sym__power_operator] = ACTIONS(2817),
    [sym__bitshift_operator] = ACTIONS(2817),
    [sym__rational_operator] = ACTIONS(2817),
    [sym__times_operator] = ACTIONS(2817),
    [sym__plus_operator] = ACTIONS(2817),
    [sym__dotty_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(2817),
    [sym__arrow_operator] = ACTIONS(2817),
    [sym__assign_operator] = ACTIONS(2817),
    [anon_sym_LF] = ACTIONS(2822),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2822),
    [sym__command_start] = ACTIONS(2822),
  },
  [1522] = {
    [ts_builtin_sym_end] = ACTIONS(2789),
    [sym_identifier] = ACTIONS(2787),
    [anon_sym_function] = ACTIONS(2787),
    [anon_sym_abstract] = ACTIONS(2787),
    [anon_sym_primitive] = ACTIONS(2787),
    [aux_sym_primitive_definition_token1] = ACTIONS(2787),
    [anon_sym_mutable] = ACTIONS(2787),
    [anon_sym_struct] = ACTIONS(2787),
    [anon_sym_module] = ACTIONS(2787),
    [anon_sym_macro] = ACTIONS(2787),
    [anon_sym_LPAREN] = ACTIONS(2787),
    [anon_sym_COMMA] = ACTIONS(2787),
    [anon_sym_SEMI] = ACTIONS(2787),
    [anon_sym_EQ] = ACTIONS(2787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2787),
    [anon_sym_COLON_COLON] = ACTIONS(2787),
    [anon_sym_LT_COLON] = ACTIONS(2787),
    [anon_sym_if] = ACTIONS(2787),
    [anon_sym_try] = ACTIONS(2787),
    [anon_sym_for] = ACTIONS(2787),
    [anon_sym_while] = ACTIONS(2787),
    [sym_break_statement] = ACTIONS(2787),
    [sym_continue_statement] = ACTIONS(2787),
    [anon_sym_return] = ACTIONS(2787),
    [anon_sym_let] = ACTIONS(2787),
    [anon_sym_const] = ACTIONS(2787),
    [anon_sym_quote] = ACTIONS(2787),
    [anon_sym_using] = ACTIONS(2787),
    [anon_sym_import] = ACTIONS(2787),
    [anon_sym_export] = ACTIONS(2787),
    [anon_sym_COLON2] = ACTIONS(2787),
    [anon_sym_LBRACK] = ACTIONS(2789),
    [anon_sym_begin] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2787),
    [anon_sym_PLUS] = ACTIONS(2787),
    [anon_sym_LT_PIPE] = ACTIONS(2787),
    [anon_sym_PIPE_GT] = ACTIONS(2787),
    [anon_sym_in] = ACTIONS(2787),
    [anon_sym_isa] = ACTIONS(2787),
    [anon_sym_PIPE_PIPE] = ACTIONS(2787),
    [anon_sym_AMP_AMP] = ACTIONS(2787),
    [anon_sym_QMARK] = ACTIONS(2787),
    [anon_sym_EQ_GT] = ACTIONS(2787),
    [anon_sym_LBRACK2] = ACTIONS(2787),
    [anon_sym_DOLLAR] = ACTIONS(2787),
    [anon_sym_AT] = ACTIONS(2787),
    [aux_sym_integer_literal_token1] = ACTIONS(2787),
    [aux_sym_integer_literal_token2] = ACTIONS(2787),
    [aux_sym_integer_literal_token3] = ACTIONS(2787),
    [sym_float_literal] = ACTIONS(2787),
    [sym__unary_operator] = ACTIONS(2787),
    [sym__power_operator] = ACTIONS(2787),
    [sym__bitshift_operator] = ACTIONS(2787),
    [sym__rational_operator] = ACTIONS(2787),
    [sym__times_operator] = ACTIONS(2787),
    [sym__plus_operator] = ACTIONS(2787),
    [sym__dotty_operator] = ACTIONS(2787),
    [sym__comparison_operator] = ACTIONS(2787),
    [sym__arrow_operator] = ACTIONS(2787),
    [sym__assign_operator] = ACTIONS(2787),
    [anon_sym_LF] = ACTIONS(2789),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2789),
    [sym__command_start] = ACTIONS(2789),
  },
  [1523] = {
    [ts_builtin_sym_end] = ACTIONS(2785),
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_function] = ACTIONS(2783),
    [anon_sym_abstract] = ACTIONS(2783),
    [anon_sym_primitive] = ACTIONS(2783),
    [aux_sym_primitive_definition_token1] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_module] = ACTIONS(2783),
    [anon_sym_macro] = ACTIONS(2783),
    [anon_sym_LPAREN] = ACTIONS(2783),
    [anon_sym_COMMA] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(2783),
    [anon_sym_EQ] = ACTIONS(2783),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2783),
    [anon_sym_LT_COLON] = ACTIONS(2783),
    [anon_sym_if] = ACTIONS(2783),
    [anon_sym_try] = ACTIONS(2783),
    [anon_sym_for] = ACTIONS(2783),
    [anon_sym_while] = ACTIONS(2783),
    [sym_break_statement] = ACTIONS(2783),
    [sym_continue_statement] = ACTIONS(2783),
    [anon_sym_return] = ACTIONS(2783),
    [anon_sym_let] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_quote] = ACTIONS(2783),
    [anon_sym_using] = ACTIONS(2783),
    [anon_sym_import] = ACTIONS(2783),
    [anon_sym_export] = ACTIONS(2783),
    [anon_sym_COLON2] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_begin] = ACTIONS(2783),
    [anon_sym_SQUOTE] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_LT_PIPE] = ACTIONS(2783),
    [anon_sym_PIPE_GT] = ACTIONS(2783),
    [anon_sym_in] = ACTIONS(2783),
    [anon_sym_isa] = ACTIONS(2783),
    [anon_sym_PIPE_PIPE] = ACTIONS(2783),
    [anon_sym_AMP_AMP] = ACTIONS(2783),
    [anon_sym_QMARK] = ACTIONS(2783),
    [anon_sym_EQ_GT] = ACTIONS(2783),
    [anon_sym_LBRACK2] = ACTIONS(2783),
    [anon_sym_DOLLAR] = ACTIONS(2783),
    [anon_sym_AT] = ACTIONS(2783),
    [aux_sym_integer_literal_token1] = ACTIONS(2783),
    [aux_sym_integer_literal_token2] = ACTIONS(2783),
    [aux_sym_integer_literal_token3] = ACTIONS(2783),
    [sym_float_literal] = ACTIONS(2783),
    [sym__unary_operator] = ACTIONS(2783),
    [sym__power_operator] = ACTIONS(2783),
    [sym__bitshift_operator] = ACTIONS(2783),
    [sym__rational_operator] = ACTIONS(2783),
    [sym__times_operator] = ACTIONS(2783),
    [sym__plus_operator] = ACTIONS(2783),
    [sym__dotty_operator] = ACTIONS(2783),
    [sym__comparison_operator] = ACTIONS(2783),
    [sym__arrow_operator] = ACTIONS(2783),
    [sym__assign_operator] = ACTIONS(2783),
    [anon_sym_LF] = ACTIONS(2785),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2785),
    [sym__command_start] = ACTIONS(2785),
  },
  [1524] = {
    [aux_sym_selected_import_repeat1] = STATE(1525),
    [ts_builtin_sym_end] = ACTIONS(2910),
    [sym_identifier] = ACTIONS(2908),
    [anon_sym_function] = ACTIONS(2908),
    [anon_sym_abstract] = ACTIONS(2908),
    [anon_sym_primitive] = ACTIONS(2908),
    [aux_sym_primitive_definition_token1] = ACTIONS(2908),
    [anon_sym_mutable] = ACTIONS(2908),
    [anon_sym_struct] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2908),
    [anon_sym_macro] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_COMMA] = ACTIONS(3536),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_EQ] = ACTIONS(2908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2908),
    [anon_sym_COLON_COLON] = ACTIONS(2908),
    [anon_sym_LT_COLON] = ACTIONS(2908),
    [anon_sym_if] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2908),
    [anon_sym_while] = ACTIONS(2908),
    [sym_break_statement] = ACTIONS(2908),
    [sym_continue_statement] = ACTIONS(2908),
    [anon_sym_return] = ACTIONS(2908),
    [anon_sym_let] = ACTIONS(2908),
    [anon_sym_const] = ACTIONS(2908),
    [anon_sym_quote] = ACTIONS(2908),
    [anon_sym_using] = ACTIONS(2908),
    [anon_sym_import] = ACTIONS(2908),
    [anon_sym_export] = ACTIONS(2908),
    [anon_sym_COLON2] = ACTIONS(2908),
    [anon_sym_begin] = ACTIONS(2908),
    [anon_sym_SQUOTE] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2908),
    [anon_sym_LT_PIPE] = ACTIONS(2908),
    [anon_sym_PIPE_GT] = ACTIONS(2908),
    [anon_sym_in] = ACTIONS(2908),
    [anon_sym_isa] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_EQ_GT] = ACTIONS(2908),
    [anon_sym_LBRACK2] = ACTIONS(2908),
    [anon_sym_DOLLAR] = ACTIONS(2908),
    [anon_sym_AT] = ACTIONS(2908),
    [aux_sym_integer_literal_token1] = ACTIONS(2908),
    [aux_sym_integer_literal_token2] = ACTIONS(2908),
    [aux_sym_integer_literal_token3] = ACTIONS(2908),
    [sym_float_literal] = ACTIONS(2908),
    [sym__unary_operator] = ACTIONS(2908),
    [sym__power_operator] = ACTIONS(2908),
    [sym__bitshift_operator] = ACTIONS(2908),
    [sym__rational_operator] = ACTIONS(2908),
    [sym__times_operator] = ACTIONS(2908),
    [sym__plus_operator] = ACTIONS(2908),
    [sym__dotty_operator] = ACTIONS(2908),
    [sym__comparison_operator] = ACTIONS(2908),
    [sym__arrow_operator] = ACTIONS(2908),
    [sym__assign_operator] = ACTIONS(2908),
    [anon_sym_LF] = ACTIONS(2910),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2910),
    [sym__command_start] = ACTIONS(2910),
  },
  [1525] = {
    [aux_sym_selected_import_repeat1] = STATE(1525),
    [ts_builtin_sym_end] = ACTIONS(2894),
    [sym_identifier] = ACTIONS(2889),
    [anon_sym_function] = ACTIONS(2889),
    [anon_sym_abstract] = ACTIONS(2889),
    [anon_sym_primitive] = ACTIONS(2889),
    [aux_sym_primitive_definition_token1] = ACTIONS(2889),
    [anon_sym_mutable] = ACTIONS(2889),
    [anon_sym_struct] = ACTIONS(2889),
    [anon_sym_module] = ACTIONS(2889),
    [anon_sym_macro] = ACTIONS(2889),
    [anon_sym_LPAREN] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(3544),
    [anon_sym_SEMI] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2889),
    [anon_sym_COLON_COLON] = ACTIONS(2889),
    [anon_sym_LT_COLON] = ACTIONS(2889),
    [anon_sym_if] = ACTIONS(2889),
    [anon_sym_try] = ACTIONS(2889),
    [anon_sym_for] = ACTIONS(2889),
    [anon_sym_while] = ACTIONS(2889),
    [sym_break_statement] = ACTIONS(2889),
    [sym_continue_statement] = ACTIONS(2889),
    [anon_sym_return] = ACTIONS(2889),
    [anon_sym_let] = ACTIONS(2889),
    [anon_sym_const] = ACTIONS(2889),
    [anon_sym_quote] = ACTIONS(2889),
    [anon_sym_using] = ACTIONS(2889),
    [anon_sym_import] = ACTIONS(2889),
    [anon_sym_export] = ACTIONS(2889),
    [anon_sym_COLON2] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(2889),
    [anon_sym_SQUOTE] = ACTIONS(2889),
    [anon_sym_PLUS] = ACTIONS(2889),
    [anon_sym_LT_PIPE] = ACTIONS(2889),
    [anon_sym_PIPE_GT] = ACTIONS(2889),
    [anon_sym_in] = ACTIONS(2889),
    [anon_sym_isa] = ACTIONS(2889),
    [anon_sym_PIPE_PIPE] = ACTIONS(2889),
    [anon_sym_AMP_AMP] = ACTIONS(2889),
    [anon_sym_QMARK] = ACTIONS(2889),
    [anon_sym_EQ_GT] = ACTIONS(2889),
    [anon_sym_LBRACK2] = ACTIONS(2889),
    [anon_sym_DOLLAR] = ACTIONS(2889),
    [anon_sym_AT] = ACTIONS(2889),
    [aux_sym_integer_literal_token1] = ACTIONS(2889),
    [aux_sym_integer_literal_token2] = ACTIONS(2889),
    [aux_sym_integer_literal_token3] = ACTIONS(2889),
    [sym_float_literal] = ACTIONS(2889),
    [sym__unary_operator] = ACTIONS(2889),
    [sym__power_operator] = ACTIONS(2889),
    [sym__bitshift_operator] = ACTIONS(2889),
    [sym__rational_operator] = ACTIONS(2889),
    [sym__times_operator] = ACTIONS(2889),
    [sym__plus_operator] = ACTIONS(2889),
    [sym__dotty_operator] = ACTIONS(2889),
    [sym__comparison_operator] = ACTIONS(2889),
    [sym__arrow_operator] = ACTIONS(2889),
    [sym__assign_operator] = ACTIONS(2889),
    [anon_sym_LF] = ACTIONS(2894),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(2894),
    [sym__command_start] = ACTIONS(2894),
  },
  [1526] = {
    [ts_builtin_sym_end] = ACTIONS(306),
    [sym_identifier] = ACTIONS(304),
    [anon_sym_function] = ACTIONS(304),
    [anon_sym_abstract] = ACTIONS(304),
    [anon_sym_primitive] = ACTIONS(304),
    [aux_sym_primitive_definition_token1] = ACTIONS(304),
    [anon_sym_mutable] = ACTIONS(304),
    [anon_sym_struct] = ACTIONS(304),
    [anon_sym_module] = ACTIONS(304),
    [anon_sym_macro] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_COMMA] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_EQ] = ACTIONS(304),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(304),
    [anon_sym_COLON_COLON] = ACTIONS(304),
    [anon_sym_LT_COLON] = ACTIONS(304),
    [anon_sym_if] = ACTIONS(304),
    [anon_sym_try] = ACTIONS(304),
    [anon_sym_for] = ACTIONS(304),
    [anon_sym_while] = ACTIONS(304),
    [sym_break_statement] = ACTIONS(304),
    [sym_continue_statement] = ACTIONS(304),
    [anon_sym_return] = ACTIONS(304),
    [anon_sym_let] = ACTIONS(304),
    [anon_sym_const] = ACTIONS(304),
    [anon_sym_quote] = ACTIONS(304),
    [anon_sym_using] = ACTIONS(304),
    [anon_sym_import] = ACTIONS(304),
    [anon_sym_export] = ACTIONS(304),
    [anon_sym_COLON2] = ACTIONS(304),
    [anon_sym_begin] = ACTIONS(304),
    [anon_sym_SQUOTE] = ACTIONS(304),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_LT_PIPE] = ACTIONS(304),
    [anon_sym_PIPE_GT] = ACTIONS(304),
    [anon_sym_in] = ACTIONS(304),
    [anon_sym_isa] = ACTIONS(304),
    [anon_sym_PIPE_PIPE] = ACTIONS(304),
    [anon_sym_AMP_AMP] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_EQ_GT] = ACTIONS(304),
    [anon_sym_LBRACK2] = ACTIONS(304),
    [anon_sym_DOLLAR] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(304),
    [aux_sym_integer_literal_token1] = ACTIONS(304),
    [aux_sym_integer_literal_token2] = ACTIONS(304),
    [aux_sym_integer_literal_token3] = ACTIONS(304),
    [sym_float_literal] = ACTIONS(304),
    [sym__unary_operator] = ACTIONS(304),
    [sym__power_operator] = ACTIONS(304),
    [sym__bitshift_operator] = ACTIONS(304),
    [sym__rational_operator] = ACTIONS(304),
    [sym__times_operator] = ACTIONS(304),
    [sym__plus_operator] = ACTIONS(304),
    [sym__dotty_operator] = ACTIONS(304),
    [sym__comparison_operator] = ACTIONS(304),
    [sym__arrow_operator] = ACTIONS(304),
    [sym__assign_operator] = ACTIONS(304),
    [anon_sym_LF] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(115),
    [sym_block_comment] = ACTIONS(3),
    [sym__immediate_paren] = ACTIONS(306),
    [sym__string_start] = ACTIONS(306),
    [sym__command_start] = ACTIONS(306),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2871), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [73] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2556), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2554), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [144] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2672), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2670), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [215] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2914), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2912), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [288] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2528), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2526), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [361] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2564), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2562), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [434] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2556), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2554), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [507] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2544), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2542), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [580] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2500), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2498), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [653] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2536), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2534), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [726] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2492), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2490), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [799] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2512), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2510), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [872] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2516), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2514), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [945] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2764), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2762), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [1018] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2520), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2518), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1091] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2524), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2522), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1164] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2532), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2530), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1237] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2540), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2538), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1310] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2496), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2494), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1383] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2548), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2546), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1456] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2552), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2550), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1529] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3069), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3067), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [1602] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3057), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3055), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [1675] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3053), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3051), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [1748] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2560), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2558), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1821] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2568), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2566), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1894] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2572), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2570), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [1967] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2702), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [2040] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2584), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2582), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [2111] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3043), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3041), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2184] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3039), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3037), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2257] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3035), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3033), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2330] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3031), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3029), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2403] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3027), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3025), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2476] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3023), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3021), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2549] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3015), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3013), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2622] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3009), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3007), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2695] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3005), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3003), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2768] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3001), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2999), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2841] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2993), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2991), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2914] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2989), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2987), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [2987] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2576), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2574), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [3060] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 53,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [3143] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2580), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2578), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [3216] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 5,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3191), 7,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
    ACTIONS(3121), 13,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3117), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [3307] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 54,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [3388] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2965), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2963), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3461] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2925), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2923), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3534] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2957), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2955), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3607] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2949), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2947), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3680] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2945), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2943), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3753] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2941), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2939), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3826] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2933), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2931), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3899] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3019), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3017), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [3972] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3049), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3047), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4045] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2580), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2578), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [4116] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2576), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2574), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [4187] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3061), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3059), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4260] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3073), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3071), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4333] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3083), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3081), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4406] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2929), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2927), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4479] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3087), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3085), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4552] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3091), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3089), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4625] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3095), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3093), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4698] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3111), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3109), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4771] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2584), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2582), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [4844] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2528), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2526), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4917] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2564), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2562), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [4990] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2556), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2554), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [5063] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2822), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2817), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [5136] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2544), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2542), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [5209] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2500), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2498), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [5282] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2572), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2570), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [5353] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2568), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2566), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [5424] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2560), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2558), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [5495] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2746), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2744), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [5568] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3547), 1,
      anon_sym_EQ,
    ACTIONS(3211), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3207), 57,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [5643] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3133), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3131), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [5716] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2921), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2916), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [5787] = 21,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2937), 13,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2935), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [5894] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2552), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2550), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [5965] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2548), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2546), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6036] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2496), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2494), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6107] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2540), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2538), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6178] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2532), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2530), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6249] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2524), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2522), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6320] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2520), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2518), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6391] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2516), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2514), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6462] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2512), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2510), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6533] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2492), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2490), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6604] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2536), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2534), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6675] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2500), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2498), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6746] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2544), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2542), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6817] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2894), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2889), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6888] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2564), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2562), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [6959] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2528), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2526), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [7030] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3141), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3139), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7103] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3145), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3143), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7176] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3153), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3151), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7249] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3157), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3155), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7322] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3165), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3163), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7395] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2536), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2534), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7468] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2508), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2506), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7541] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3173), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3171), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7614] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3177), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3175), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7687] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3181), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3179), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7760] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 52,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [7845] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3185), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3183), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7918] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2492), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2490), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [7991] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3205), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3203), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [8064] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3215), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3213), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [8137] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3219), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3217), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [8210] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3229), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3227), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [8283] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2933), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2931), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [8356] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2961), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2959), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [8429] = 17,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 17,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2983), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [8528] = 11,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 32,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [8615] = 9,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [8698] = 8,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 21,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2983), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [8779] = 7,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 22,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2983), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [8858] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3549), 1,
      anon_sym_COMMA,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3553), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3351), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(4269), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [8977] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 54,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [9056] = 21,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2997), 13,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2995), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [9163] = 17,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 17,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2983), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [9262] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2512), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2510), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [9335] = 18,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 16,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2983), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [9436] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2764), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2762), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [9509] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2914), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2912), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [9582] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3344), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2883), 21,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2871), 39,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOLLAR,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [9655] = 15,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [9750] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [9841] = 15,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [9936] = 10,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 34,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [10021] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3191), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3119), 48,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10110] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2883), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2871), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [10181] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3382), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3384), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_EQ_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2777), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2772), 37,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [10290] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2867), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2837), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10363] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2516), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2514), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10436] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2520), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2518), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10509] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2524), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2522), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10582] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3137), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3135), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10655] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2532), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2530), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10728] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2540), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2538), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10801] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3125), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3123), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [10874] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3555), 1,
      anon_sym_COMMA,
    ACTIONS(3557), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3153), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(3981), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [10993] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3077), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3075), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11066] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3065), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3063), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11139] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2496), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2494), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11212] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2953), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2951), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11285] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2981), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2979), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11358] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2977), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2975), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11431] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2973), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2971), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11504] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2969), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2967), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11577] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3559), 1,
      anon_sym_COMMA,
    ACTIONS(3561), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3298), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(3922), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [11696] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2548), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2546), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11769] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2552), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2550), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [11842] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3563), 1,
      anon_sym_COMMA,
    ACTIONS(3565), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3113), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(4043), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [11961] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3189), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3187), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [12034] = 21,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 13,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [12141] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3099), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3097), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [12214] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3103), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3101), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [12287] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3107), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3105), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [12360] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3169), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3167), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [12433] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2894), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2889), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [12506] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3115), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3113), 46,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [12599] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3129), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3127), 46,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [12692] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 51,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [12779] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3043), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3041), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [12852] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2902), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2900), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [12925] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3039), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3037), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [12996] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3149), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3147), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [13069] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2560), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2558), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [13142] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2568), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2566), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [13215] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2902), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2900), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [13288] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3439), 1,
      anon_sym_QMARK,
    ACTIONS(3441), 1,
      anon_sym_EQ_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3453), 1,
      sym__arrow_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3433), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2777), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2772), 36,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [13397] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3169), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3167), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [13470] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3189), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3187), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [13543] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2572), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2570), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [13616] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3149), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3147), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [13689] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2941), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2939), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [13762] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3191), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3119), 49,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [13851] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3417), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2883), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2871), 56,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [13926] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3107), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3105), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [13999] = 21,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2777), 13,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2772), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [14106] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3103), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3101), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [14179] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3099), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3097), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [14252] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2702), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [14325] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3069), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3067), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [14396] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3057), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3055), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [14467] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3053), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3051), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [14538] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2961), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2959), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [14609] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3567), 1,
      anon_sym_COMMA,
    ACTIONS(3569), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3575), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(3808), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [14728] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3571), 1,
      anon_sym_COMMA,
    ACTIONS(3573), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3131), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(3995), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [14847] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3035), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3033), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [14918] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3195), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3193), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [14989] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3019), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3017), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [15062] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3575), 1,
      anon_sym_COMMA,
    ACTIONS(3577), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3464), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(3854), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [15181] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(306), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(304), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [15254] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3031), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3029), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15325] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3027), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3025), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15396] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3023), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3021), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15467] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3015), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3013), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15538] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3009), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3007), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15609] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3005), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3003), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15680] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3001), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2999), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15751] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2993), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2991), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15822] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2989), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2987), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [15893] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3195), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3193), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [15966] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2969), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2967), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [16039] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2965), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2963), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16110] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2925), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2923), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16181] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2957), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2955), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16252] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2949), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2947), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16323] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2945), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2943), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16394] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2941), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2939), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16465] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2933), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2931), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16536] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3043), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3041), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16607] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3049), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3047), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16678] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3061), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3059), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16749] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3073), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3071), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16820] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3083), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3081), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16891] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2929), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2927), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [16962] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3087), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3085), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [17033] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3091), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3089), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [17104] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3095), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3093), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [17175] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2973), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2971), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [17248] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2576), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2574), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [17321] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2580), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2578), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [17394] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3111), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3109), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [17465] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 50,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [17552] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2977), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2975), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [17625] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 44,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [17722] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 46,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [17815] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2981), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2979), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [17888] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2953), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2951), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [17961] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3065), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3063), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [18034] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2822), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2817), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [18105] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 44,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [18202] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3077), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3075), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [18275] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2746), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2744), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [18346] = 19,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3453), 1,
      sym__arrow_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3433), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 39,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [18449] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3133), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3131), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [18520] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2921), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2916), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [18593] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3121), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3119), 12,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
    ACTIONS(3117), 36,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [18684] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3125), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3123), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [18757] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3579), 1,
      anon_sym_COMMA,
    ACTIONS(3581), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3224), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(4136), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [18876] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3141), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3139), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [18947] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3145), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3143), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19018] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3153), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3151), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19089] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3157), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3155), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19160] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3165), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3163), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19231] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2508), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2506), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19302] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3173), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3171), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19373] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3177), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3175), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19444] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3181), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3179), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19515] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3137), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3135), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [19588] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2867), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2837), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [19661] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3121), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3119), 12,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
    ACTIONS(3117), 37,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [19752] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3185), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3183), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19823] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3205), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3203), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19894] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3215), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3213), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [19965] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2584), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2582), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [20038] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 55,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [20117] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3219), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3217), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [20188] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3229), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3227), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [20259] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3453), 1,
      sym__arrow_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3433), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 40,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [20360] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2945), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2943), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [20433] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2949), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2947), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [20506] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2957), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2955), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [20579] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2925), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2923), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [20652] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2965), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2963), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [20725] = 6,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 23,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2983), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [20802] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3049), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3047), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [20875] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3382), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3384), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_EQ_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3161), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3159), 37,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [20984] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3061), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3059), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21057] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 45,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21154] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3073), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3071), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21227] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2989), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2987), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21300] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2993), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2991), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21373] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3382), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3384), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_EQ_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2937), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2935), 37,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [21482] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2961), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2959), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21555] = 11,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3191), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(3119), 32,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [21642] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2871), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21715] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2867), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2837), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [21786] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3439), 1,
      anon_sym_QMARK,
    ACTIONS(3441), 1,
      anon_sym_EQ_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3453), 1,
      sym__arrow_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3433), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2997), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2995), 36,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [21895] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3057), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3055), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [21968] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 53,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [22049] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3137), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3135), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22120] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 52,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [22203] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 51,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [22288] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3125), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3123), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22359] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3229), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3227), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [22432] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3077), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3075), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22503] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3065), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3063), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22574] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2953), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2951), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22645] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2981), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2979), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22716] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2977), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2975), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22787] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2973), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2971), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22858] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2969), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2967), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [22929] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3219), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3217), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [23002] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3215), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3213), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [23075] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 48,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [23164] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3019), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3017), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [23235] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3001), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2999), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [23308] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3195), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3193), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [23381] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3099), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3097), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [23452] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3103), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3101), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [23523] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3205), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3203), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [23596] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3107), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3105), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [23667] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3453), 1,
      sym__arrow_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3433), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2983), 40,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [23768] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3185), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3183), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [23841] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3115), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(3113), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [23932] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3129), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(3127), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [24023] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3181), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3179), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [24096] = 27,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3469), 1,
      anon_sym_COLON2,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3475), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3477), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3481), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3483), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3485), 1,
      anon_sym_QMARK,
    ACTIONS(3487), 1,
      anon_sym_EQ_GT,
    ACTIONS(3489), 1,
      sym__power_operator,
    ACTIONS(3491), 1,
      sym__bitshift_operator,
    ACTIONS(3493), 1,
      sym__rational_operator,
    ACTIONS(3495), 1,
      sym__times_operator,
    ACTIONS(3497), 1,
      sym__dotty_operator,
    ACTIONS(3499), 1,
      sym__arrow_operator,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3583), 1,
      anon_sym_COMMA,
    ACTIONS(3585), 1,
      anon_sym_RBRACK,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3325), 1,
      aux_sym_subscript_expression_repeat1,
    STATE(4214), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3473), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3479), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 9,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 25,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [24215] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3149), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3147), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [24286] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3177), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3175), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [24359] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3439), 1,
      anon_sym_QMARK,
    ACTIONS(3441), 1,
      anon_sym_EQ_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3453), 1,
      sym__arrow_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3433), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2937), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2935), 36,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [24468] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2902), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2900), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [24539] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2921), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2916), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [24612] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3169), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3167), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [24683] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3189), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(3187), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [24754] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3173), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3171), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [24827] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2508), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2506), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [24900] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(306), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(304), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [24973] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3157), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3155), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25046] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3153), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3151), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25119] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3145), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3143), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25192] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2708), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2702), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [25263] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3141), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3139), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25336] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2764), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2762), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [25407] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2914), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2912), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [25478] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3133), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3131), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25551] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3419), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3423), 1,
      anon_sym_COLON2,
    ACTIONS(3425), 1,
      anon_sym_SQUOTE,
    ACTIONS(3429), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3431), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3435), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3437), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3439), 1,
      anon_sym_QMARK,
    ACTIONS(3441), 1,
      anon_sym_EQ_GT,
    ACTIONS(3443), 1,
      sym__power_operator,
    ACTIONS(3445), 1,
      sym__bitshift_operator,
    ACTIONS(3447), 1,
      sym__rational_operator,
    ACTIONS(3449), 1,
      sym__times_operator,
    ACTIONS(3451), 1,
      sym__dotty_operator,
    ACTIONS(3453), 1,
      sym__arrow_operator,
    ACTIONS(3421), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3427), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3433), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3159), 36,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__assign_operator,
  [25660] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2746), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2744), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25733] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3115), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3113), 47,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25826] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2822), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2817), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [25899] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2672), 4,
      sym__string_start,
      sym__command_start,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2670), 58,
      anon_sym_function,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [25972] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3129), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3127), 47,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [26065] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 41,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [26166] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(306), 27,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(304), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [26237] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 49,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [26326] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3382), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3384), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_EQ_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2997), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2995), 37,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [26435] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 41,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [26536] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3111), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3109), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [26609] = 19,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3384), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 40,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [26712] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3095), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3093), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [26785] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3069), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3067), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [26858] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3165), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3163), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [26931] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3053), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3051), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27004] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3091), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3089), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27077] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3087), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3085), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27150] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 45,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27247] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2929), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2927), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27320] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3083), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3081), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27393] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2894), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2889), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27466] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3039), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3037), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27539] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 47,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27632] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2672), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2670), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27705] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3035), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3033), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27778] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3031), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3029), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27851] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3027), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3025), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27924] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3023), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3021), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [27997] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3015), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3013), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [28070] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3009), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3007), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [28143] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3005), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3003), 59,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [28216] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(326), 1,
      anon_sym_LT_PIPE,
    ACTIONS(328), 1,
      anon_sym_PIPE_GT,
    ACTIONS(332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(334), 1,
      anon_sym_AMP_AMP,
    ACTIONS(336), 1,
      anon_sym_QMARK,
    ACTIONS(338), 1,
      anon_sym_EQ_GT,
    ACTIONS(354), 1,
      sym__arrow_operator,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(330), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3159), 36,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [28324] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 50,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [28410] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(326), 1,
      anon_sym_LT_PIPE,
    ACTIONS(328), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 44,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [28506] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 46,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [28598] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(326), 1,
      anon_sym_LT_PIPE,
    ACTIONS(328), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 44,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [28694] = 19,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(326), 1,
      anon_sym_LT_PIPE,
    ACTIONS(328), 1,
      anon_sym_PIPE_GT,
    ACTIONS(334), 1,
      anon_sym_AMP_AMP,
    ACTIONS(354), 1,
      sym__arrow_operator,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(330), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 39,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [28796] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(326), 1,
      anon_sym_LT_PIPE,
    ACTIONS(328), 1,
      anon_sym_PIPE_GT,
    ACTIONS(354), 1,
      sym__arrow_operator,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(330), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 40,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [28896] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(326), 1,
      anon_sym_LT_PIPE,
    ACTIONS(328), 1,
      anon_sym_PIPE_GT,
    ACTIONS(332), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(334), 1,
      anon_sym_AMP_AMP,
    ACTIONS(336), 1,
      anon_sym_QMARK,
    ACTIONS(338), 1,
      anon_sym_EQ_GT,
    ACTIONS(354), 1,
      sym__arrow_operator,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(330), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2997), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2995), 36,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [29004] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 53,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [29084] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 52,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [29166] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 51,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [29250] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 48,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [29338] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(326), 1,
      anon_sym_LT_PIPE,
    ACTIONS(328), 1,
      anon_sym_PIPE_GT,
    ACTIONS(354), 1,
      sym__arrow_operator,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(330), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2983), 40,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [29438] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3121), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3119), 12,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
    ACTIONS(3117), 36,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [29528] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3115), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3113), 46,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [29620] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3587), 1,
      anon_sym_COLON2,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(3597), 1,
      sym__dotty_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3129), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3127), 46,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [29712] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3589), 1,
      sym__power_operator,
    ACTIONS(3591), 1,
      sym__bitshift_operator,
    ACTIONS(3593), 1,
      sym__rational_operator,
    ACTIONS(3595), 1,
      sym__times_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(324), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3191), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3119), 48,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [29800] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(312), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3370), 1,
      anon_sym_COLON2,
    ACTIONS(3372), 1,
      anon_sym_SQUOTE,
    ACTIONS(3376), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3378), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3382), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3384), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3386), 1,
      anon_sym_QMARK,
    ACTIONS(3388), 1,
      anon_sym_EQ_GT,
    ACTIONS(3390), 1,
      sym__power_operator,
    ACTIONS(3392), 1,
      sym__bitshift_operator,
    ACTIONS(3394), 1,
      sym__rational_operator,
    ACTIONS(3396), 1,
      sym__times_operator,
    ACTIONS(3398), 1,
      sym__dotty_operator,
    ACTIONS(3400), 1,
      sym__arrow_operator,
    ACTIONS(314), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3374), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3380), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3601), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3599), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [29907] = 17,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3623), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3611), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 15,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2983), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [30004] = 9,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [30085] = 21,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3623), 1,
      sym__arrow_operator,
    ACTIONS(3625), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3627), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3629), 1,
      anon_sym_QMARK,
    ACTIONS(3631), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3611), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2997), 11,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2995), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [30190] = 11,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3191), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(3119), 32,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [30275] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3129), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(3127), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [30364] = 7,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 20,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2983), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [30441] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [30530] = 15,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 16,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [30623] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3115), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(3113), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [30712] = 21,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3623), 1,
      sym__arrow_operator,
    ACTIONS(3625), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3627), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3629), 1,
      anon_sym_QMARK,
    ACTIONS(3631), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3611), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3161), 11,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3159), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [30817] = 11,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 32,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [30902] = 17,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3623), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3611), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 15,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2983), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [30999] = 18,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3623), 1,
      sym__arrow_operator,
    ACTIONS(3627), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3611), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2985), 14,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(2983), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [31098] = 13,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 5,
      anon_sym_COLON2,
      anon_sym_in,
      anon_sym_isa,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3191), 7,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
    ACTIONS(3121), 11,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3117), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [31187] = 8,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 19,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__rational_operator,
      sym__arrow_operator,
    ACTIONS(2983), 35,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [31266] = 15,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 16,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__comparison_operator,
  [31359] = 10,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2985), 18,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__arrow_operator,
    ACTIONS(2983), 34,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [31442] = 21,
    ACTIONS(3465), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3471), 1,
      anon_sym_SQUOTE,
    ACTIONS(3603), 1,
      anon_sym_COLON2,
    ACTIONS(3607), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3609), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3613), 1,
      sym__power_operator,
    ACTIONS(3615), 1,
      sym__bitshift_operator,
    ACTIONS(3617), 1,
      sym__rational_operator,
    ACTIONS(3619), 1,
      sym__times_operator,
    ACTIONS(3621), 1,
      sym__dotty_operator,
    ACTIONS(3623), 1,
      sym__arrow_operator,
    ACTIONS(3625), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3627), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3629), 1,
      anon_sym_QMARK,
    ACTIONS(3631), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3467), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3605), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3611), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3635), 8,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(3633), 27,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
  [31544] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3501), 1,
      anon_sym_EQ,
    ACTIONS(3211), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3207), 44,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [31605] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3639), 1,
      anon_sym_COMMA,
    STATE(1930), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3642), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3637), 43,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [31668] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3644), 1,
      anon_sym_COMMA,
    STATE(1931), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(2921), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2916), 43,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [31731] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3642), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(3637), 44,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [31789] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2921), 3,
      sym__string_start,
      sym__command_start,
      anon_sym_LF,
    ACTIONS(2916), 44,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_COLON2,
      anon_sym_begin,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      sym_identifier,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
  [31847] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3649), 15,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    ACTIONS(3647), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
  [31901] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3653), 15,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    ACTIONS(3651), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
  [31955] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3657), 14,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    ACTIONS(3655), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
  [32008] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2805), 14,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    ACTIONS(2590), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
  [32061] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3661), 14,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    ACTIONS(3659), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
  [32114] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3665), 14,
      sym__string_start,
      sym__command_start,
      anon_sym_LPAREN,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_LBRACK2,
      anon_sym_DOLLAR,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    ACTIONS(3663), 30,
      anon_sym_function,
      anon_sym_end,
      anon_sym_abstract,
      anon_sym_primitive,
      aux_sym_primitive_definition_token1,
      anon_sym_mutable,
      anon_sym_struct,
      anon_sym_module,
      anon_sym_macro,
      anon_sym_if,
      anon_sym_try,
      anon_sym_for,
      anon_sym_while,
      sym_break_statement,
      sym_continue_statement,
      anon_sym_return,
      anon_sym_let,
      anon_sym_const,
      anon_sym_quote,
      anon_sym_using,
      anon_sym_import,
      anon_sym_export,
      anon_sym_begin,
      sym_identifier,
      aux_sym_integer_literal_token3,
      sym_float_literal,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
  [32167] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(89), 1,
      anon_sym_LBRACE,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2468), 1,
      sym__immediate_string_start,
    ACTIONS(2470), 1,
      sym__immediate_command_start,
    STATE(1975), 1,
      sym_type_argument_list,
    ACTIONS(97), 2,
      sym__immediate_paren,
      anon_sym_LBRACK,
    ACTIONS(2466), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2464), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32232] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(89), 1,
      anon_sym_LBRACE,
    ACTIONS(103), 1,
      anon_sym_DASH_GT,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(117), 1,
      sym__immediate_string_start,
    ACTIONS(119), 1,
      sym__immediate_command_start,
    STATE(1975), 1,
      sym_type_argument_list,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(85), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32295] = 8,
    ACTIONS(2468), 1,
      sym__immediate_string_start,
    ACTIONS(2470), 1,
      sym__immediate_command_start,
    ACTIONS(3667), 1,
      anon_sym_LBRACE,
    ACTIONS(3669), 1,
      anon_sym_DASH_GT,
    STATE(2092), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(85), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(97), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [32355] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3671), 1,
      anon_sym_do,
    STATE(1992), 1,
      sym_do_clause,
    ACTIONS(2488), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2486), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32410] = 9,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(2468), 1,
      sym__immediate_string_start,
    ACTIONS(2470), 1,
      sym__immediate_command_start,
    ACTIONS(3667), 1,
      anon_sym_LBRACE,
    STATE(2092), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 2,
      sym__immediate_paren,
      anon_sym_LBRACK,
    ACTIONS(2464), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2466), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [32471] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3671), 1,
      anon_sym_do,
    STATE(1987), 1,
      sym_do_clause,
    ACTIONS(2482), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2480), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32526] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(89), 1,
      anon_sym_LBRACE,
    ACTIONS(115), 1,
      sym_line_comment,
    STATE(1975), 1,
      sym_type_argument_list,
    ACTIONS(97), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(85), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32581] = 17,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(89), 1,
      anon_sym_LBRACE,
    ACTIONS(103), 1,
      anon_sym_DASH_GT,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(117), 1,
      sym__immediate_string_start,
    ACTIONS(119), 1,
      sym__immediate_command_start,
    ACTIONS(3673), 1,
      anon_sym_COMMA,
    ACTIONS(3676), 1,
      anon_sym_RPAREN,
    ACTIONS(3679), 1,
      anon_sym_SEMI,
    ACTIONS(3682), 1,
      anon_sym_EQ,
    ACTIONS(3685), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3688), 1,
      anon_sym_COLON_COLON,
    STATE(1975), 1,
      sym_type_argument_list,
    STATE(2880), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4006), 1,
      sym_keyword_parameters,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(85), 23,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32657] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2590), 1,
      anon_sym_DASH_GT,
    ACTIONS(2588), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2586), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32709] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2580), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2578), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32759] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2576), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2574), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32809] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2572), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2570), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32859] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2568), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2566), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32909] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2560), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2558), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [32959] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2552), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2550), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33009] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2548), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2546), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33059] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2496), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2494), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33109] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2508), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2506), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33159] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2540), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2538), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33209] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2532), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2530), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33259] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2524), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2522), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33309] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2520), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2518), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33359] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2516), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2514), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33409] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2512), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2510), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33459] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2492), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2490), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33509] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2536), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2534), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33559] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2500), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2498), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33609] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2544), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2542), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33659] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2556), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2554), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33709] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2564), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2562), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33759] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2528), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2526), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33809] = 8,
    ACTIONS(3691), 1,
      anon_sym_LBRACE,
    ACTIONS(3693), 1,
      anon_sym_DASH_GT,
    ACTIONS(3695), 1,
      sym__immediate_string_start,
    ACTIONS(3697), 1,
      sym__immediate_command_start,
    STATE(2257), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(85), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(97), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [33867] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2584), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2582), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33917] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2504), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2502), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [33967] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3699), 1,
      sym_identifier,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    STATE(1990), 1,
      sym_parameterized_identifier,
    STATE(2865), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [34042] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2714), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2712), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34091] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2718), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2716), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34140] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2688), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2686), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34189] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2594), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2592), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34238] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2722), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2720), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34287] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2614), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2612), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34336] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2676), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2674), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34385] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2634), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2632), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34434] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2618), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2616), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34483] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2622), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2620), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34532] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3707), 1,
      sym_identifier,
    STATE(1207), 1,
      sym_parameterized_identifier,
    STATE(2897), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [34607] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3709), 1,
      sym_identifier,
    STATE(1216), 1,
      sym_parameterized_identifier,
    STATE(2862), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [34682] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2626), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2624), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34731] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2660), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2658), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34780] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2630), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2628), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34829] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(97), 2,
      sym__immediate_paren,
      anon_sym_LBRACK,
    ACTIONS(2466), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2464), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34882] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2664), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2662), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34931] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2680), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2678), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [34980] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2602), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2600), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35029] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2638), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2636), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35078] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3711), 1,
      anon_sym_DOT,
    ACTIONS(3713), 1,
      anon_sym_LBRACK,
    ACTIONS(3715), 1,
      sym__immediate_paren,
    ACTIONS(2708), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2702), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35133] = 5,
    ACTIONS(3717), 1,
      anon_sym_do,
    STATE(2090), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2486), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2488), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [35184] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2684), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2682), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35233] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2672), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2670), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35282] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3719), 1,
      sym_identifier,
    STATE(1074), 1,
      sym_parameterized_identifier,
    STATE(2881), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [35357] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2668), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2666), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35406] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3721), 1,
      sym_identifier,
    ACTIONS(3723), 1,
      anon_sym_LPAREN,
    STATE(2139), 1,
      sym_parenthesized_expression,
    ACTIONS(2752), 2,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2750), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35461] = 5,
    ACTIONS(3667), 1,
      anon_sym_LBRACE,
    STATE(2092), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(85), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(97), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [35512] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3723), 1,
      anon_sym_LPAREN,
    ACTIONS(3725), 1,
      sym_identifier,
    STATE(2147), 1,
      sym_parenthesized_expression,
    ACTIONS(2732), 2,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2728), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35567] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2598), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2596), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35616] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3727), 1,
      sym_identifier,
    STATE(867), 1,
      sym_parameterized_identifier,
    STATE(2896), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [35691] = 5,
    ACTIONS(3717), 1,
      anon_sym_do,
    STATE(2056), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2480), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2482), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [35742] = 9,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(2468), 1,
      sym__immediate_string_start,
    ACTIONS(2470), 1,
      sym__immediate_command_start,
    ACTIONS(3691), 1,
      anon_sym_LBRACE,
    STATE(2257), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 2,
      sym__immediate_paren,
      anon_sym_LBRACK,
    ACTIONS(2464), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2466), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [35801] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3729), 1,
      sym_identifier,
    STATE(2053), 1,
      sym_parameterized_identifier,
    STATE(2877), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [35876] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2692), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2690), 34,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [35925] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3731), 1,
      sym_identifier,
    STATE(2242), 1,
      sym_parameterized_identifier,
    STATE(2888), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [36000] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3733), 1,
      sym_identifier,
    STATE(2772), 1,
      sym_parameterized_identifier,
    STATE(2900), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [36075] = 17,
    ACTIONS(728), 1,
      anon_sym_SQUOTE,
    ACTIONS(744), 1,
      sym__string_start,
    ACTIONS(746), 1,
      sym__command_start,
    ACTIONS(3701), 1,
      anon_sym_LPAREN,
    ACTIONS(3703), 1,
      anon_sym_LBRACK2,
    ACTIONS(3705), 1,
      sym_float_literal,
    ACTIONS(3735), 1,
      sym_identifier,
    STATE(1249), 1,
      sym_parameterized_identifier,
    STATE(2883), 1,
      sym_field_expression,
    STATE(3967), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(734), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(736), 2,
      aux_sym_primitive_definition_token1,
      aux_sym_integer_literal_token3,
    ACTIONS(742), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2206), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    STATE(3966), 7,
      sym__literal,
      sym_integer_literal,
      sym_character_literal,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(3178), 9,
      sym__primary_expression,
      sym_parenthesized_expression,
      sym_subscript_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym_tuple_expression,
      sym_array_expression,
      sym_matrix_expression,
      sym_array_comprehension_expression,
  [36150] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3737), 1,
      anon_sym_COMMA,
    ACTIONS(3739), 1,
      anon_sym_COLON,
    ACTIONS(3741), 1,
      anon_sym_DOT,
    STATE(2067), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(2656), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2648), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [36207] = 6,
    ACTIONS(3743), 1,
      sym_identifier,
    ACTIONS(3745), 1,
      anon_sym_LPAREN,
    STATE(2377), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2728), 16,
      anon_sym_end,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2732), 18,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36259] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3739), 1,
      anon_sym_COLON,
    ACTIONS(3741), 1,
      anon_sym_DOT,
    ACTIONS(2746), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2744), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [36311] = 6,
    ACTIONS(3745), 1,
      anon_sym_LPAREN,
    ACTIONS(3747), 1,
      sym_identifier,
    STATE(2388), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2750), 16,
      anon_sym_end,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2752), 18,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36363] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2514), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2516), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36409] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2518), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2520), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36455] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2506), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2508), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36501] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2522), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2524), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36547] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2530), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2532), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36593] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2538), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2540), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36639] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2494), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2496), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36685] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2546), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2548), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36731] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2550), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2552), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36777] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2558), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2560), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36823] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2566), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2568), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36869] = 4,
    ACTIONS(2805), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2586), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2588), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36917] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2570), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2572), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [36963] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2574), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2576), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37009] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2578), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2580), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37055] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2582), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2584), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37101] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2510), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2512), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37147] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2490), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2492), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37193] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2534), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2536), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37239] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2498), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2500), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37285] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2542), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2544), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37331] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2554), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2556), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37377] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2562), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2564), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37423] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2526), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2528), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37469] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2736), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2734), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [37517] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2502), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2504), 25,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37563] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2740), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2738), 35,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [37611] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3715), 1,
      sym__immediate_paren,
    ACTIONS(2708), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2702), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [37660] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2906), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2904), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [37707] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2628), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2630), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37752] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2781), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2779), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [37799] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3749), 1,
      anon_sym_COMMA,
    STATE(2081), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(2831), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2827), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [37850] = 6,
    ACTIONS(3751), 1,
      anon_sym_DOT,
    ACTIONS(3753), 1,
      anon_sym_LBRACK,
    ACTIONS(3755), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2708), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37901] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2670), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2672), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37946] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2666), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2668), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [37991] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3713), 1,
      anon_sym_LBRACK,
    ACTIONS(2708), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2702), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38040] = 5,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 2,
      sym__immediate_paren,
      anon_sym_LBRACK,
    ACTIONS(2464), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2466), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38089] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2760), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2758), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38136] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2596), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2598), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38181] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2624), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2626), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38226] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(306), 3,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(304), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38273] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2600), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2602), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38318] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2752), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2750), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38365] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2658), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2660), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38410] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3757), 1,
      anon_sym_COMMA,
    STATE(2061), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(2746), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2744), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38461] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2674), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2676), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38506] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2720), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2722), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38551] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2809), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2807), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38598] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2803), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2801), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38645] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2592), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2594), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38690] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3737), 1,
      anon_sym_COMMA,
    STATE(2061), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(2756), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2754), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38741] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2789), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2787), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38788] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2716), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2718), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [38833] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3760), 1,
      anon_sym_COMMA,
    STATE(2077), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2799), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2795), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38884] = 5,
    ACTIONS(3762), 1,
      anon_sym_do,
    STATE(2240), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2486), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2488), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [38933] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3764), 1,
      anon_sym_COMMA,
    STATE(2072), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(2894), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2889), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [38984] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(89), 1,
      anon_sym_LBRACE,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(117), 1,
      sym__immediate_string_start,
    ACTIONS(119), 1,
      sym__immediate_command_start,
    ACTIONS(3767), 1,
      anon_sym_DASH_GT,
    STATE(1975), 1,
      sym_type_argument_list,
    ACTIONS(97), 4,
      sym__immediate_paren,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(85), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39041] = 5,
    ACTIONS(3762), 1,
      anon_sym_do,
    STATE(2250), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2480), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2482), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [39090] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(89), 1,
      anon_sym_LBRACE,
    ACTIONS(103), 1,
      anon_sym_DASH_GT,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(117), 1,
      sym__immediate_string_start,
    ACTIONS(119), 1,
      sym__immediate_command_start,
    ACTIONS(3769), 1,
      anon_sym_EQ,
    STATE(1975), 1,
      sym_type_argument_list,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(85), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39149] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2682), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2684), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39194] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3772), 1,
      anon_sym_COMMA,
    STATE(2077), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2822), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2817), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39245] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2620), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2622), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39290] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2616), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2618), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39335] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2612), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2614), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39380] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3749), 1,
      anon_sym_COMMA,
    STATE(2072), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(2910), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2908), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39431] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2785), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2783), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39478] = 7,
    ACTIONS(3775), 1,
      anon_sym_COMMA,
    ACTIONS(3777), 1,
      anon_sym_COLON,
    ACTIONS(3779), 1,
      anon_sym_DOT,
    STATE(2294), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2648), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2656), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39531] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2636), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2638), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39576] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2632), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2634), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39621] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2686), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2688), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39666] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2793), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2791), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39713] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2898), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2896), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39760] = 5,
    ACTIONS(3691), 1,
      anon_sym_LBRACE,
    STATE(2257), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(85), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(97), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [39809] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2678), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2680), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39854] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2690), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2692), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39899] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2712), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2714), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [39944] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3760), 1,
      anon_sym_COMMA,
    STATE(2070), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2835), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2833), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [39995] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3737), 1,
      anon_sym_COMMA,
    STATE(2067), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(2656), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2648), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40046] = 8,
    ACTIONS(3691), 1,
      anon_sym_LBRACE,
    ACTIONS(3695), 1,
      sym__immediate_string_start,
    ACTIONS(3697), 1,
      sym__immediate_command_start,
    ACTIONS(3781), 1,
      anon_sym_DASH_GT,
    STATE(2257), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(85), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(97), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [40101] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2662), 12,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2664), 24,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [40146] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2560), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2558), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40192] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2902), 1,
      anon_sym_LF,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    STATE(2146), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2900), 10,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      sym__assign_operator,
  [40278] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2949), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2947), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40324] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2945), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2943), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40370] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2941), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2939), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40416] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2933), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2931), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40462] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3001), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2999), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40508] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2993), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2991), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40554] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2989), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2987), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40600] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3043), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3041), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40646] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3049), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3047), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40692] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2894), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2889), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40738] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3039), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3037), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40784] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3035), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3033), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40830] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3061), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3059), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40876] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3073), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3071), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40922] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3031), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3029), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [40968] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3027), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3025), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41014] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3023), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3021), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41060] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3015), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3013), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41106] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3009), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3007), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41152] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2764), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2762), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41198] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3005), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3003), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41244] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2965), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2963), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41290] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2925), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2923), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41336] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2914), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2912), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41382] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2702), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41428] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3053), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3051), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41474] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2734), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2736), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [41518] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3057), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3055), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41564] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3069), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3067), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41610] = 5,
    ACTIONS(3777), 1,
      anon_sym_COLON,
    ACTIONS(3779), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2744), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2746), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [41658] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(306), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(304), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41704] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3083), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3081), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41750] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2929), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2927), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41796] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3087), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3085), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41842] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3091), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3089), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41888] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2777), 1,
      anon_sym_LF,
    ACTIONS(3821), 1,
      anon_sym_COMMA,
    STATE(2134), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2772), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41938] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3095), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3093), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [41984] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3111), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3109), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42030] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    STATE(2146), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3824), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2871), 9,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
  [42116] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2921), 1,
      anon_sym_LF,
    ACTIONS(3826), 1,
      anon_sym_COMMA,
    STATE(2138), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(2916), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42166] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3189), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3187), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42212] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2672), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2670), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42258] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3169), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3167), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42304] = 19,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2867), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2837), 15,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [42380] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2902), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2900), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42426] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3149), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3147), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42472] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2738), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2740), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [42516] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2815), 1,
      anon_sym_LF,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
    STATE(2134), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2811), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42566] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3107), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3105), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42612] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2822), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2817), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42658] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3103), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3101), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42704] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3099), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3097), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42750] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3195), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3193), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42796] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2746), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2744), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42842] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3019), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3017), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42888] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2506), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2508), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [42932] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3133), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3131), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [42978] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2969), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2967), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43024] = 27,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3829), 6,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [43116] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3141), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3139), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43162] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2973), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2971), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43208] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3145), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3143), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43254] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2977), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2975), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43300] = 4,
    ACTIONS(2805), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2586), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2588), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [43346] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2516), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2514), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43392] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3153), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3151), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43438] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3157), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3155), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43484] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2510), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2512), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [43528] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3165), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3163), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43574] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2887), 1,
      anon_sym_LF,
    ACTIONS(3837), 1,
      anon_sym_COMMA,
    STATE(2170), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(2885), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43624] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2508), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2506), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43670] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2770), 1,
      anon_sym_LF,
    ACTIONS(3837), 1,
      anon_sym_COMMA,
    STATE(2138), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(2766), 32,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43720] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2981), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2979), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43766] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3173), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3171), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43812] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3177), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3175), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43858] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3181), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3179), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43904] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3185), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3183), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43950] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2921), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2916), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [43996] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3205), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3203), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44042] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3215), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3213), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44088] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3219), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3217), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44134] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2584), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2582), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44180] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3229), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3227), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44226] = 9,
    ACTIONS(3691), 1,
      anon_sym_LBRACE,
    ACTIONS(3693), 1,
      anon_sym_DASH_GT,
    ACTIONS(3695), 1,
      sym__immediate_string_start,
    ACTIONS(3697), 1,
      sym__immediate_command_start,
    ACTIONS(3839), 1,
      anon_sym_EQ,
    STATE(2257), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(85), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(97), 22,
      sym__immediate_paren,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [44282] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2580), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2578), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44328] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2961), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2959), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44374] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2576), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2574), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44420] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2953), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2951), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44466] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2572), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2570), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44512] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2568), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2566), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44558] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2552), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2550), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44604] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2548), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2546), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44650] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2496), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2494), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44696] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2540), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2538), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44742] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2532), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2530), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44788] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2524), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2522), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44834] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2520), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2518), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44880] = 6,
    ACTIONS(3841), 1,
      sym_identifier,
    ACTIONS(3843), 1,
      anon_sym_LPAREN,
    STATE(2510), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2750), 11,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2752), 21,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [44930] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 29,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [44982] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2512), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2510), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45028] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2492), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2490), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45074] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2536), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2534), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45120] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2500), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2498), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45166] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2871), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45212] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2544), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2542), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45258] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2556), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2554), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45304] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2564), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2562), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45350] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2528), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2526), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45396] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2867), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2837), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45442] = 6,
    ACTIONS(3843), 1,
      anon_sym_LPAREN,
    ACTIONS(3845), 1,
      sym_identifier,
    STATE(2506), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2728), 11,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_in,
      anon_sym_isa,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2732), 21,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45492] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3065), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3063), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45538] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2957), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2955), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45584] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3077), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3075), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45630] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2526), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2528), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45674] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2562), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2564), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45718] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2554), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2556), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45762] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2542), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2544), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45806] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2498), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2500), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45850] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2534), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2536), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45894] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2490), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2492), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [45938] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3137), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3135), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [45984] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2502), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2504), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46028] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3125), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3123), 33,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [46074] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2582), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2584), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46118] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2578), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2580), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46162] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2574), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2576), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46206] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2570), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2572), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46250] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2566), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2568), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46294] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2558), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2560), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46338] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2550), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2552), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46382] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2546), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2548), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46426] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2494), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2496), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46470] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2538), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2540), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46514] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2530), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2532), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46558] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2522), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2524), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46602] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2518), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2520), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46646] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2514), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2516), 28,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_do,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46690] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2636), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2638), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46733] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2686), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2688), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46776] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2716), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2718), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46819] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2596), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2598), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46862] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2678), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2680), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46905] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2674), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2676), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46948] = 5,
    ACTIONS(85), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 2,
      sym__immediate_paren,
      anon_sym_LBRACK,
    ACTIONS(2464), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2466), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [46995] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2592), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2594), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47038] = 5,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    STATE(2244), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2772), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2777), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [47085] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2682), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2684), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47128] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2937), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2935), 11,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      sym__assign_operator,
  [47209] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2612), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2614), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47252] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2616), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2618), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47295] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2620), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2622), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47338] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2624), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2626), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47381] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2658), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2660), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47424] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2628), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2630), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47467] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2632), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2634), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47510] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2662), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2664), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47553] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2666), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2668), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47596] = 6,
    ACTIONS(3850), 1,
      anon_sym_DOT,
    ACTIONS(3852), 1,
      anon_sym_LBRACK,
    ACTIONS(3854), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2708), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47645] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2712), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2714), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47688] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3121), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3117), 11,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      sym__assign_operator,
    ACTIONS(3119), 12,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [47751] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3115), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3113), 21,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [47816] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2690), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2692), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47859] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3129), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3127), 21,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [47924] = 7,
    ACTIONS(3856), 1,
      anon_sym_COMMA,
    ACTIONS(3858), 1,
      anon_sym_COLON,
    ACTIONS(3860), 1,
      anon_sym_DOT,
    STATE(2459), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2648), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2656), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [47975] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2600), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2602), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [48018] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3862), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3242), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(4285), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [48117] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 23,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [48178] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(304), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(306), 23,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [48221] = 5,
    ACTIONS(3864), 1,
      anon_sym_COMMA,
    STATE(2267), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2916), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2921), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [48268] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2750), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2752), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [48311] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 26,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [48368] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 27,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [48423] = 4,
    ACTIONS(3755), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2708), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [48468] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 28,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [48521] = 23,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2309), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3867), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2883), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [48604] = 4,
    ACTIONS(3753), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2708), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [48649] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2807), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2809), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [48692] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3907), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3232), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(4223), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [48791] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2801), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2803), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [48834] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2997), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2995), 11,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      sym__assign_operator,
  [48915] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 15,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [48988] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2309), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2900), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2902), 8,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [49073] = 19,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 14,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [49148] = 5,
    ACTIONS(3909), 1,
      anon_sym_COMMA,
    STATE(2292), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2885), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2887), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [49195] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 19,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [49264] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 21,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [49329] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 19,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [49398] = 5,
    ACTIONS(3775), 1,
      anon_sym_COMMA,
    STATE(2294), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2648), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2656), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [49445] = 5,
    ACTIONS(3911), 1,
      anon_sym_COMMA,
    STATE(2323), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2833), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2835), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [49492] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 25,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [49551] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2896), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2898), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [49594] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2791), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2793), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [49637] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3913), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3124), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(4148), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [49736] = 5,
    ACTIONS(3909), 1,
      anon_sym_COMMA,
    STATE(2267), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2766), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2770), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [49783] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3191), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 23,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [49844] = 5,
    ACTIONS(3775), 1,
      anon_sym_COMMA,
    STATE(2314), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2754), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2756), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [49891] = 25,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 1,
      anon_sym_LF,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2871), 7,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [49978] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2904), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2906), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [50021] = 25,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3917), 1,
      anon_sym_LF,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(3915), 7,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [50108] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3919), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3108), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(4072), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [50207] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2777), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2772), 11,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      sym__assign_operator,
  [50288] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3921), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3117), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(4003), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [50387] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3923), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3275), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(4007), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [50486] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2758), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2760), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [50529] = 19,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2837), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2867), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [50604] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2720), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2722), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [50647] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3925), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3442), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(3932), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [50746] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2779), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2781), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [50789] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(304), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(306), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [50832] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 1,
      anon_sym_LF,
    ACTIONS(3824), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2871), 31,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [50879] = 5,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    STATE(2244), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2811), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2815), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [50926] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2670), 7,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2672), 27,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [50969] = 5,
    ACTIONS(3927), 1,
      anon_sym_COMMA,
    STATE(2321), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2827), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2831), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51016] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3211), 1,
      anon_sym_LF,
    ACTIONS(3929), 1,
      anon_sym_EQ,
    ACTIONS(3207), 32,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [51063] = 31,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3551), 1,
      anon_sym_for,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(3931), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3391), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(3809), 1,
      sym__comprehension_clause,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [51162] = 5,
    ACTIONS(3933), 1,
      anon_sym_COMMA,
    STATE(2314), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2744), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2746), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51209] = 5,
    ACTIONS(3936), 1,
      anon_sym_COMMA,
    STATE(2315), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2817), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2822), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51256] = 19,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3867), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2867), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [51331] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2787), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2789), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51374] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2783), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2785), 23,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51417] = 23,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2309), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(3939), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2883), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [51500] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2985), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 15,
      anon_sym_end,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_for,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [51573] = 5,
    ACTIONS(3927), 1,
      anon_sym_COMMA,
    STATE(2322), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2908), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2910), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51620] = 5,
    ACTIONS(3941), 1,
      anon_sym_COMMA,
    STATE(2322), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2889), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2894), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51667] = 5,
    ACTIONS(3911), 1,
      anon_sym_COMMA,
    STATE(2315), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2795), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2799), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51714] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2562), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2564), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51756] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3109), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3111), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51798] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3217), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3219), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51840] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2566), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2568), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51882] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3183), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3185), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51924] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3021), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3023), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [51966] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3025), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3027), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52008] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3029), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3031), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52050] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3033), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3035), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52092] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3227), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3229), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52134] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2959), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2961), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52176] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2734), 8,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2736), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [52218] = 6,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52266] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3037), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3039), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52308] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2889), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2894), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52350] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3051), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3053), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52392] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2570), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2572), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52434] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3055), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3057), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52476] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3203), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3205), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52518] = 11,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 5,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3191), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52576] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2574), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2576), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52618] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3067), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3069), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52660] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3059), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3061), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52702] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2837), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2867), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52744] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2550), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2552), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52786] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3213), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3215), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52828] = 10,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 7,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52884] = 15,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 3,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 16,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [52950] = 13,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 3,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53012] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2923), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2925), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53054] = 15,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 3,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 16,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53120] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3175), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3177), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53162] = 19,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2983), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 12,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [53236] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2963), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2965), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53278] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3063), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3065), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53320] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3179), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3181), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53362] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3171), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3173), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53404] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3123), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3125), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53446] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2506), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2508), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53488] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3077), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53530] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2708), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53572] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2951), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2953), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53614] = 18,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2983), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [53686] = 22,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2995), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2997), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [53766] = 7,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 10,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53816] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2979), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2981), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53858] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2975), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2977), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53900] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2971), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2973), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53942] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2967), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2969), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [53984] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3017), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3019), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54026] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3097), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3099), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54068] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3163), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3165), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54110] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3101), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3103), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54152] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3105), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3107), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54194] = 8,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 9,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54246] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3155), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3157), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54288] = 13,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3113), 3,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3115), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54350] = 13,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3127), 3,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3129), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54412] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3147), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3149), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54454] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2900), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2902), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54496] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2546), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2548), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54538] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3151), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3153), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54580] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3167), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3169), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54622] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2955), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2957), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54664] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3187), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3189), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54706] = 9,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54760] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2494), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2496), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54802] = 11,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 5,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54860] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2538), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2540), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54902] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3193), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3195), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54944] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3143), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3145), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [54986] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3867), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2871), 9,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2883), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55030] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3139), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3141), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55072] = 22,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2772), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2777), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [55152] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3131), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3133), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55194] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2744), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2746), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55236] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2817), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2822), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55278] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2558), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2560), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55320] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3093), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3095), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55362] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3089), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3091), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55404] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3085), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3087), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55446] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2927), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2929), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55488] = 4,
    ACTIONS(3944), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3207), 10,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3211), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55532] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2987), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2989), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55574] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2578), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2580), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55616] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2947), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2949), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55658] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2530), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2532), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55700] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2943), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2945), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55742] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2670), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2672), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55784] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2939), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2941), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55826] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2738), 8,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2740), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [55868] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2582), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2584), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55910] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3081), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3083), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [55952] = 22,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2935), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2937), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [56032] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2912), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2914), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56074] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2522), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2524), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56116] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2762), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2764), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56158] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2991), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2993), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56200] = 18,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2983), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [56272] = 13,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3117), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 3,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3121), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
    ACTIONS(3191), 9,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56334] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2871), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2883), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56376] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3073), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56418] = 5,
    ACTIONS(3858), 1,
      anon_sym_COLON,
    ACTIONS(3860), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2744), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2746), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [56464] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2999), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3001), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56506] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2518), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2520), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56548] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2916), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2921), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56590] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2526), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2528), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56632] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3013), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3015), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56674] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2554), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2556), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56716] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2542), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2544), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56758] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3135), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3137), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56800] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2498), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2500), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56842] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2534), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2536), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56884] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2931), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2933), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56926] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2490), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2492), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [56968] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3003), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3005), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [57010] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3939), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2871), 9,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2883), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [57054] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3047), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3049), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [57096] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3007), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3009), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [57138] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2510), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2512), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [57180] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3041), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(3043), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [57222] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2514), 11,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__assign_operator,
    ACTIONS(2516), 22,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [57264] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2807), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2809), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57305] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2791), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2793), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57346] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2801), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2803), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57387] = 4,
    ACTIONS(3852), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2708), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57430] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2896), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2898), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57471] = 4,
    ACTIONS(3854), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2708), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57514] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2750), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2752), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57555] = 5,
    ACTIONS(3946), 1,
      anon_sym_COMMA,
    STATE(2458), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2811), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2815), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57600] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2309), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(3948), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2883), 6,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [57683] = 20,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(3948), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2867), 10,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [57758] = 5,
    ACTIONS(3950), 1,
      anon_sym_COMMA,
    STATE(2464), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2766), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2770), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57803] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3721), 1,
      sym_identifier,
    ACTIONS(3723), 1,
      anon_sym_LPAREN,
    STATE(2139), 1,
      sym_parenthesized_expression,
    ACTIONS(2752), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2750), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [57852] = 5,
    ACTIONS(3952), 1,
      anon_sym_COMMA,
    STATE(2458), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2772), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2777), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57897] = 5,
    ACTIONS(3856), 1,
      anon_sym_COMMA,
    STATE(2476), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2754), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2756), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57942] = 5,
    ACTIONS(3955), 1,
      anon_sym_COMMA,
    STATE(2475), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2795), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2799), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [57987] = 5,
    ACTIONS(3955), 1,
      anon_sym_COMMA,
    STATE(2460), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2833), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2835), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58032] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2904), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2906), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58073] = 5,
    ACTIONS(3856), 1,
      anon_sym_COMMA,
    STATE(2459), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2648), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2656), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58118] = 5,
    ACTIONS(3957), 1,
      anon_sym_COMMA,
    STATE(2464), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2916), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2921), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58163] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2758), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2760), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58204] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2779), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2781), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58245] = 4,
    ACTIONS(3960), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3207), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3211), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58288] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3723), 1,
      anon_sym_LPAREN,
    ACTIONS(3725), 1,
      sym_identifier,
    STATE(2147), 1,
      sym_parenthesized_expression,
    ACTIONS(2732), 3,
      ts_builtin_sym_end,
      anon_sym_LBRACK,
      anon_sym_LF,
    ACTIONS(2728), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [58337] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(304), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(306), 26,
      sym__immediate_paren,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58378] = 5,
    ACTIONS(3962), 1,
      anon_sym_COMMA,
    STATE(2470), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2889), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2894), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58423] = 5,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    STATE(2470), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2908), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2910), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58468] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2783), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2785), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58509] = 23,
    ACTIONS(3946), 1,
      anon_sym_COMMA,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    STATE(2453), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2902), 8,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [58590] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2787), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2789), 26,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58631] = 5,
    ACTIONS(4005), 1,
      anon_sym_COMMA,
    STATE(2475), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2817), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2822), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58676] = 5,
    ACTIONS(4008), 1,
      anon_sym_COMMA,
    STATE(2476), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2744), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2746), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58721] = 5,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    STATE(2471), 1,
      aux_sym_selected_import_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2827), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2831), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58766] = 5,
    ACTIONS(3950), 1,
      anon_sym_COMMA,
    STATE(2456), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2885), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2887), 24,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58811] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3063), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3065), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58851] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3021), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3023), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58891] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3109), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3111), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58931] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3093), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3095), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [58971] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2670), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2672), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59011] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3089), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3091), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59051] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3085), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3087), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59091] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(304), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(306), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59131] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2927), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2929), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59171] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3081), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3083), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59211] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3073), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59251] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3059), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3061), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59291] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3047), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3049), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59331] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3041), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3043), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59371] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3131), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3133), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59411] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2837), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2867), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59451] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3147), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3149), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59491] = 28,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3829), 1,
      anon_sym_RPAREN,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    ACTIONS(4011), 1,
      anon_sym_COMMA,
    STATE(2733), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    STATE(3571), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [59581] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2817), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2822), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59621] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2939), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2941), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59661] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2943), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2945), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59701] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2947), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2949), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59741] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2955), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2957), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59781] = 13,
    ACTIONS(3127), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3129), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [59841] = 13,
    ACTIONS(3113), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3115), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [59901] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2923), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2925), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59941] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2963), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2965), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [59981] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3105), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3107), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60021] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2526), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2528), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60061] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2562), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2564), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60101] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3167), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3169), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60141] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3187), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3189), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60181] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2554), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2556), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60221] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2744), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2746), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60261] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3101), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3103), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60301] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3097), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3099), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60341] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2987), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2989), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60381] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3193), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3195), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60421] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2991), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2993), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60461] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2999), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3001), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60501] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2542), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2544), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60541] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3003), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3005), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60581] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2931), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2933), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60621] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3013), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3015), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60661] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3139), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3141), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60701] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2498), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2500), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60741] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2534), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2536), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60781] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3143), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3145), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60821] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2762), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2764), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60861] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2510), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2512), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60901] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2967), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2969), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60941] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3151), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3153), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [60981] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2900), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2902), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61021] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2971), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2973), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61061] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3025), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3027), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61101] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2975), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2977), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61141] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3155), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3157), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61181] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2979), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2981), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61221] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2951), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2953), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61261] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3029), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3031), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61301] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3163), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3165), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61341] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3033), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3035), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61381] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3037), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3039), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61421] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2514), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2516), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61461] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2506), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2508), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61501] = 9,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [61553] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2518), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2520), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61593] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2522), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2524), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61633] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2889), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2894), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61673] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2530), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2532), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61713] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3171), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3173), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61753] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3077), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61793] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2538), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2540), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61833] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3175), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3177), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61873] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3179), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3181), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [61913] = 12,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 3,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3121), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
    ACTIONS(3191), 9,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [61971] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3051), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3053), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62011] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3055), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3057), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62051] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2702), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2708), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62091] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3067), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3069), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62131] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2494), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2496), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62171] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3183), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3185), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62211] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2546), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2548), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62251] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2550), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2552), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62291] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3123), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3125), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62331] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3203), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3205), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62371] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2777), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [62447] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3213), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3215), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62487] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2871), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2883), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62527] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2490), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2492), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62567] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3217), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3219), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62607] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3007), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3009), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62647] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2912), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2914), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62687] = 10,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 5,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [62741] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3135), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3137), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62781] = 15,
    ACTIONS(2983), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 16,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [62845] = 13,
    ACTIONS(2983), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [62905] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2582), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2584), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62945] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2578), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2580), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [62985] = 15,
    ACTIONS(2983), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 16,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [63049] = 18,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 12,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [63119] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3227), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3229), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63159] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3017), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3019), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63199] = 17,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [63267] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2916), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2921), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63307] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2558), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2560), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63347] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2574), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2576), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63387] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2997), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [63463] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2937), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [63539] = 7,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 20,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63587] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2959), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2961), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63627] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2570), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2572), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63667] = 8,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 19,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__rational_operator,
      sym__arrow_operator,
  [63717] = 11,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 3,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3191), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [63773] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2566), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2568), 25,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63813] = 11,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 3,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 18,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [63869] = 17,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [63937] = 6,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 21,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [63983] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3948), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2871), 9,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2883), 19,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_SQUOTE,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [64024] = 27,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4013), 1,
      ts_builtin_sym_end,
    ACTIONS(4015), 1,
      anon_sym_COMMA,
    ACTIONS(4017), 1,
      anon_sym_SEMI,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    ACTIONS(4051), 1,
      anon_sym_LF,
    STATE(2766), 1,
      aux_sym_bare_tuple_expression_repeat1,
    STATE(3009), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4019), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [64111] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4053), 1,
      anon_sym_COMMA,
    ACTIONS(4055), 1,
      anon_sym_RPAREN,
    ACTIONS(4057), 1,
      anon_sym_SEMI,
    ACTIONS(4059), 1,
      anon_sym_for,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3015), 1,
      aux_sym_argument_list_repeat1,
    STATE(3788), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [64197] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4061), 1,
      anon_sym_COMMA,
    ACTIONS(4063), 1,
      anon_sym_RPAREN,
    ACTIONS(4065), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(2943), 1,
      aux_sym_argument_list_repeat1,
    STATE(3857), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [64283] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4067), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [64325] = 25,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3915), 1,
      anon_sym_SEMI,
    ACTIONS(4015), 1,
      anon_sym_COMMA,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    STATE(2766), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3917), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(4019), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [64407] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4069), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [64449] = 19,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2867), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2837), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [64519] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4071), 1,
      anon_sym_COMMA,
    ACTIONS(4073), 1,
      anon_sym_RPAREN,
    ACTIONS(4075), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    STATE(3867), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [64605] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4077), 1,
      anon_sym_COMMA,
    ACTIONS(4079), 1,
      anon_sym_RPAREN,
    ACTIONS(4081), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(2983), 1,
      aux_sym_argument_list_repeat1,
    STATE(3783), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [64691] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4083), 1,
      anon_sym_COMMA,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
    ACTIONS(4087), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(2992), 1,
      aux_sym_argument_list_repeat1,
    STATE(3780), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [64777] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4089), 1,
      anon_sym_COMMA,
    ACTIONS(4091), 1,
      anon_sym_RPAREN,
    ACTIONS(4093), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(2973), 1,
      aux_sym_argument_list_repeat1,
    STATE(3826), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [64863] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4095), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [64905] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4097), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [64947] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4099), 1,
      anon_sym_COMMA,
    STATE(2611), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(2921), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2916), 25,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [64991] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4102), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65033] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4104), 1,
      anon_sym_COMMA,
    STATE(2611), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(2770), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2766), 25,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65077] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4106), 1,
      anon_sym_COMMA,
    ACTIONS(4108), 1,
      anon_sym_RPAREN,
    ACTIONS(4110), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(2964), 1,
      aux_sym_argument_list_repeat1,
    STATE(3772), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [65163] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4112), 1,
      anon_sym_COMMA,
    ACTIONS(4114), 1,
      anon_sym_RPAREN,
    ACTIONS(4116), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(2916), 1,
      aux_sym_argument_list_repeat1,
    STATE(3798), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [65249] = 27,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4118), 1,
      anon_sym_COMMA,
    ACTIONS(4120), 1,
      anon_sym_RPAREN,
    ACTIONS(4122), 1,
      anon_sym_SEMI,
    STATE(2773), 1,
      sym_for_clause,
    STATE(3014), 1,
      aux_sym_argument_list_repeat1,
    STATE(3795), 1,
      sym__comprehension_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [65335] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4015), 1,
      anon_sym_COMMA,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    STATE(2623), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2902), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2900), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [65415] = 24,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    STATE(2623), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2871), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(2883), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4124), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [65495] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4126), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65537] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4128), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65579] = 25,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2871), 1,
      anon_sym_SEMI,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4015), 1,
      anon_sym_COMMA,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    STATE(2766), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2883), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4019), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [65661] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4130), 1,
      anon_sym_COMMA,
    STATE(2622), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2777), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2772), 25,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65705] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4015), 1,
      anon_sym_COMMA,
    STATE(2622), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2815), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2811), 25,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65749] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4104), 1,
      anon_sym_COMMA,
    STATE(2613), 1,
      aux_sym_let_statement_repeat1,
    ACTIONS(2887), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2885), 25,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65793] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4133), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_for,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65835] = 8,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 16,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__rational_operator,
      sym__arrow_operator,
  [65882] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4139), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [65923] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    ACTIONS(2937), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2935), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
  [65998] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4141), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66039] = 13,
    ACTIONS(3127), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3129), 15,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [66096] = 13,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(3121), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3117), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3119), 12,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [66153] = 15,
    ACTIONS(2983), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [66214] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4157), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66255] = 18,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 9,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [66322] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    ACTIONS(2777), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2772), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
  [66397] = 17,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 10,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [66462] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2997), 6,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [66535] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(3191), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66590] = 7,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 17,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__arrow_operator,
  [66635] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4173), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66676] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4175), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66717] = 12,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 3,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3121), 6,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
    ACTIONS(3191), 9,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [66772] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(3129), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3127), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66831] = 11,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 18,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66884] = 10,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 19,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66935] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 12,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [66998] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(4124), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2871), 24,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
  [67039] = 13,
    ACTIONS(3113), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3115), 15,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [67096] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4177), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67137] = 9,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 6,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 15,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [67186] = 11,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 3,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 15,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [67239] = 9,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 20,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67288] = 8,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 21,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67335] = 12,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON2,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67390] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67449] = 16,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2983), 12,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67512] = 22,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4031), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4035), 1,
      anon_sym_QMARK,
    ACTIONS(4037), 1,
      anon_sym_EQ_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    ACTIONS(2997), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2995), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
  [67587] = 19,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4033), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [67656] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4179), 1,
      anon_sym_EQ,
    ACTIONS(3211), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3207), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67697] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4181), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67738] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [67805] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4183), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [67846] = 13,
    ACTIONS(2983), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 15,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [67903] = 23,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2777), 1,
      anon_sym_LF,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3789), 1,
      anon_sym_COLON2,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(3795), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3797), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3801), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3803), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3805), 1,
      anon_sym_QMARK,
    ACTIONS(3807), 1,
      anon_sym_EQ_GT,
    ACTIONS(3809), 1,
      sym__power_operator,
    ACTIONS(3811), 1,
      sym__bitshift_operator,
    ACTIONS(3813), 1,
      sym__rational_operator,
    ACTIONS(3815), 1,
      sym__times_operator,
    ACTIONS(3817), 1,
      sym__dotty_operator,
    ACTIONS(3819), 1,
      sym__arrow_operator,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3793), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4185), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2772), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3799), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
  [67980] = 18,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4025), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4027), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(4049), 1,
      sym__arrow_operator,
    ACTIONS(2985), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4029), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
    ACTIONS(2983), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__assign_operator,
  [68047] = 17,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(2985), 10,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
  [68112] = 14,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3785), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3791), 1,
      anon_sym_SQUOTE,
    ACTIONS(4021), 1,
      anon_sym_COLON2,
    ACTIONS(4039), 1,
      sym__power_operator,
    ACTIONS(4041), 1,
      sym__bitshift_operator,
    ACTIONS(4043), 1,
      sym__rational_operator,
    ACTIONS(4045), 1,
      sym__times_operator,
    ACTIONS(4047), 1,
      sym__dotty_operator,
    ACTIONS(3115), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3787), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4023), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3113), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [68171] = 11,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3119), 3,
      anon_sym_COLON2,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(3191), 15,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [68224] = 10,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(2983), 5,
      anon_sym_COLON2,
      anon_sym_PLUS,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
    ACTIONS(2985), 15,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [68275] = 15,
    ACTIONS(2983), 1,
      sym__comparison_operator,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(2985), 13,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__arrow_operator,
  [68336] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2708), 1,
      anon_sym_LF,
    ACTIONS(4187), 1,
      anon_sym_RPAREN,
    ACTIONS(2702), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
      anon_sym_COLON2,
      anon_sym_SQUOTE,
      anon_sym_PLUS,
      anon_sym_LT_PIPE,
      anon_sym_PIPE_GT,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_EQ_GT,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__dotty_operator,
      sym__comparison_operator,
      sym__arrow_operator,
      sym__assign_operator,
  [68377] = 24,
    ACTIONS(2883), 1,
      anon_sym_end,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [68455] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4191), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [68533] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(3601), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [68605] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4193), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [68683] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4195), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [68761] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4197), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [68839] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4199), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [68917] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4201), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [68995] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4203), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [69073] = 24,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    ACTIONS(3869), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3873), 1,
      anon_sym_COLON2,
    ACTIONS(3875), 1,
      anon_sym_SQUOTE,
    ACTIONS(3879), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3881), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3885), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3887), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3889), 1,
      anon_sym_QMARK,
    ACTIONS(3891), 1,
      anon_sym_EQ_GT,
    ACTIONS(3893), 1,
      sym__power_operator,
    ACTIONS(3895), 1,
      sym__bitshift_operator,
    ACTIONS(3897), 1,
      sym__rational_operator,
    ACTIONS(3899), 1,
      sym__times_operator,
    ACTIONS(3901), 1,
      sym__dotty_operator,
    ACTIONS(3903), 1,
      sym__comparison_operator,
    ACTIONS(3905), 1,
      sym__arrow_operator,
    ACTIONS(4205), 1,
      anon_sym_end,
    STATE(2869), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3871), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3877), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3883), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4189), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [69151] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4207), 1,
      anon_sym_COMMA,
    ACTIONS(4209), 1,
      anon_sym_RPAREN,
    ACTIONS(4211), 1,
      anon_sym_SEMI,
    STATE(2920), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69228] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4213), 1,
      anon_sym_COMMA,
    ACTIONS(4215), 1,
      anon_sym_RPAREN,
    ACTIONS(4217), 1,
      anon_sym_SEMI,
    STATE(2929), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69305] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4219), 1,
      anon_sym_COMMA,
    ACTIONS(4221), 1,
      anon_sym_RPAREN,
    ACTIONS(4223), 1,
      anon_sym_SEMI,
    STATE(2936), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69382] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4225), 1,
      anon_sym_COMMA,
    ACTIONS(4227), 1,
      anon_sym_RPAREN,
    ACTIONS(4229), 1,
      anon_sym_SEMI,
    STATE(3002), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69459] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4231), 1,
      anon_sym_COMMA,
    ACTIONS(4233), 1,
      anon_sym_RPAREN,
    ACTIONS(4235), 1,
      anon_sym_SEMI,
    STATE(3001), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69536] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4237), 1,
      anon_sym_COMMA,
    ACTIONS(4239), 1,
      anon_sym_RPAREN,
    ACTIONS(4241), 1,
      anon_sym_SEMI,
    STATE(3026), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69613] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4243), 1,
      anon_sym_COMMA,
    ACTIONS(4245), 1,
      anon_sym_RPAREN,
    ACTIONS(4247), 1,
      anon_sym_SEMI,
    STATE(2947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69690] = 24,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4249), 1,
      anon_sym_COMMA,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(4253), 1,
      anon_sym_SEMI,
    STATE(2950), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69767] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4255), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [69838] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4257), 1,
      anon_sym_COMMA,
    ACTIONS(4259), 1,
      anon_sym_RBRACK,
    STATE(3506), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69912] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4261), 1,
      anon_sym_COMMA,
    ACTIONS(4263), 1,
      anon_sym_RBRACK,
    STATE(3340), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [69986] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4267), 1,
      anon_sym_RBRACE,
    STATE(3296), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70060] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4269), 1,
      anon_sym_RBRACE,
    STATE(3168), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70134] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4271), 1,
      anon_sym_RBRACE,
    STATE(3191), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70208] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4273), 1,
      anon_sym_COMMA,
    ACTIONS(4275), 1,
      anon_sym_RBRACK,
    STATE(3173), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70282] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4277), 1,
      anon_sym_COMMA,
    ACTIONS(4279), 1,
      anon_sym_RBRACK,
    STATE(3554), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70356] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4281), 1,
      anon_sym_RBRACE,
    STATE(3335), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70430] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4283), 1,
      anon_sym_COMMA,
    ACTIONS(4285), 1,
      anon_sym_RBRACK,
    STATE(3572), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70504] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4287), 1,
      anon_sym_COMMA,
    ACTIONS(4289), 1,
      anon_sym_RBRACK,
    STATE(3187), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70578] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4291), 1,
      anon_sym_RBRACE,
    STATE(3501), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70652] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4293), 1,
      anon_sym_RBRACE,
    STATE(3561), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70726] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4295), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [70796] = 22,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4297), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4295), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [70868] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4300), 1,
      anon_sym_RBRACE,
    STATE(3564), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [70942] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4302), 1,
      anon_sym_COMMA,
    ACTIONS(4304), 1,
      anon_sym_RBRACK,
    STATE(3082), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [71016] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4306), 1,
      anon_sym_RBRACE,
    STATE(3507), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [71090] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4308), 1,
      anon_sym_COMMA,
    ACTIONS(4310), 1,
      anon_sym_RBRACK,
    STATE(3149), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [71164] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4312), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [71234] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4314), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [71304] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(4316), 1,
      anon_sym_RBRACE,
    STATE(3084), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [71378] = 23,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4318), 1,
      anon_sym_COMMA,
    ACTIONS(4320), 1,
      anon_sym_RBRACK,
    STATE(3295), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [71452] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [71521] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4324), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [71590] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3635), 2,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [71659] = 22,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(4326), 1,
      anon_sym_COMMA,
    STATE(3346), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
  [71730] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4328), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [71799] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3971), 1,
      anon_sym_COLON2,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(3977), 1,
      anon_sym_LT_PIPE,
    ACTIONS(3979), 1,
      anon_sym_PIPE_GT,
    ACTIONS(3983), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3985), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3987), 1,
      anon_sym_QMARK,
    ACTIONS(3989), 1,
      anon_sym_EQ_GT,
    ACTIONS(3991), 1,
      sym__power_operator,
    ACTIONS(3993), 1,
      sym__bitshift_operator,
    ACTIONS(3995), 1,
      sym__rational_operator,
    ACTIONS(3997), 1,
      sym__times_operator,
    ACTIONS(3999), 1,
      sym__dotty_operator,
    ACTIONS(4001), 1,
      sym__comparison_operator,
    ACTIONS(4003), 1,
      sym__arrow_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(3975), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(3981), 2,
      anon_sym_in,
      anon_sym_isa,
    ACTIONS(4330), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [71868] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4332), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [71936] = 21,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4143), 1,
      anon_sym_COLON2,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4334), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72004] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4336), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72069] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4338), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72134] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4340), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72199] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4342), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72264] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4344), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72329] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4346), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72394] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4348), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72459] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4350), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72524] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4352), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72589] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4354), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72654] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4356), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72719] = 20,
    ACTIONS(3967), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3973), 1,
      anon_sym_SQUOTE,
    ACTIONS(4135), 1,
      sym__power_operator,
    ACTIONS(4137), 1,
      sym__bitshift_operator,
    ACTIONS(4147), 1,
      sym__rational_operator,
    ACTIONS(4149), 1,
      sym__times_operator,
    ACTIONS(4151), 1,
      sym__dotty_operator,
    ACTIONS(4153), 1,
      anon_sym_LT_PIPE,
    ACTIONS(4155), 1,
      anon_sym_PIPE_GT,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      sym__comparison_operator,
    ACTIONS(4165), 1,
      sym__arrow_operator,
    ACTIONS(4167), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(4169), 1,
      anon_sym_QMARK,
    ACTIONS(4171), 1,
      anon_sym_EQ_GT,
    ACTIONS(4358), 1,
      anon_sym_COLON2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3969), 2,
      anon_sym_COLON_COLON,
      anon_sym_LT_COLON,
    ACTIONS(4145), 2,
      anon_sym_PLUS,
      sym__plus_operator,
    ACTIONS(4159), 2,
      anon_sym_in,
      anon_sym_isa,
  [72784] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2815), 1,
      anon_sym_LF,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2811), 9,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      sym__assign_operator,
  [72811] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2777), 1,
      anon_sym_LF,
    ACTIONS(3821), 1,
      anon_sym_COMMA,
    STATE(2734), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2772), 9,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      sym__assign_operator,
  [72838] = 7,
    ACTIONS(2468), 1,
      sym__immediate_string_start,
    ACTIONS(2470), 1,
      sym__immediate_command_start,
    ACTIONS(4362), 1,
      anon_sym_LBRACE,
    STATE(2769), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(4360), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [72866] = 6,
    ACTIONS(4364), 1,
      sym_identifier,
    ACTIONS(4366), 1,
      anon_sym_DOT,
    STATE(1858), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4368), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4370), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [72892] = 6,
    ACTIONS(4372), 1,
      sym_identifier,
    ACTIONS(4374), 1,
      anon_sym_DOT,
    STATE(1411), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4376), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4378), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [72918] = 6,
    ACTIONS(4380), 1,
      sym_identifier,
    ACTIONS(4382), 1,
      anon_sym_DOT,
    STATE(1654), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4384), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4386), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [72944] = 6,
    ACTIONS(4388), 1,
      sym_identifier,
    ACTIONS(4390), 1,
      anon_sym_DOT,
    STATE(1241), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(420), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2142), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [72970] = 6,
    ACTIONS(4392), 1,
      sym_identifier,
    ACTIONS(4394), 1,
      anon_sym_DOT,
    STATE(1510), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(602), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2128), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [72996] = 6,
    ACTIONS(4396), 1,
      sym_identifier,
    ACTIONS(4398), 1,
      anon_sym_DOT,
    STATE(1473), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(536), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2450), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73022] = 6,
    ACTIONS(4400), 1,
      sym_identifier,
    ACTIONS(4402), 1,
      anon_sym_DOT,
    STATE(2122), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4404), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4406), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73048] = 6,
    ACTIONS(4408), 1,
      sym_identifier,
    ACTIONS(4410), 1,
      anon_sym_DOT,
    STATE(1530), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4412), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4414), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73074] = 6,
    ACTIONS(4416), 1,
      sym_identifier,
    ACTIONS(4418), 1,
      anon_sym_DOT,
    STATE(942), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(181), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(2156), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73100] = 6,
    ACTIONS(4420), 1,
      sym_identifier,
    ACTIONS(4422), 1,
      anon_sym_DOT,
    STATE(2571), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4424), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4426), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73126] = 6,
    ACTIONS(4428), 1,
      sym_identifier,
    ACTIONS(4430), 1,
      anon_sym_DOT,
    STATE(1503), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(672), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
    ACTIONS(674), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
  [73152] = 6,
    ACTIONS(4432), 1,
      sym_identifier,
    ACTIONS(4434), 1,
      anon_sym_DOT,
    STATE(2418), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73178] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3829), 6,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [73206] = 6,
    ACTIONS(4440), 1,
      sym_identifier,
    ACTIONS(4442), 1,
      anon_sym_DOT,
    STATE(1093), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4444), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4446), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73232] = 5,
    ACTIONS(4448), 1,
      sym_identifier,
    STATE(3740), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73255] = 5,
    ACTIONS(4450), 1,
      sym_identifier,
    STATE(3708), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73278] = 5,
    ACTIONS(4452), 1,
      sym_identifier,
    STATE(3696), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73301] = 5,
    ACTIONS(4454), 1,
      sym_identifier,
    STATE(3746), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73324] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3917), 1,
      anon_sym_LF,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(3915), 7,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [73347] = 5,
    ACTIONS(4456), 1,
      sym_identifier,
    STATE(3678), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73370] = 5,
    ACTIONS(4458), 1,
      sym_identifier,
    STATE(3724), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73393] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2883), 1,
      anon_sym_LF,
    ACTIONS(3833), 2,
      anon_sym_EQ,
      sym__assign_operator,
    ACTIONS(2871), 7,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [73416] = 5,
    ACTIONS(4460), 1,
      sym_identifier,
    STATE(3649), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73439] = 5,
    ACTIONS(4462), 1,
      sym_identifier,
    STATE(3757), 1,
      sym_operator,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4436), 4,
      sym__unary_operator,
      sym__times_operator,
      sym__plus_operator,
      sym__comparison_operator,
    ACTIONS(4438), 4,
      sym__power_operator,
      sym__bitshift_operator,
      sym__rational_operator,
      sym__dotty_operator,
  [73462] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3917), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(3915), 7,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [73482] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4464), 1,
      anon_sym_SEMI,
    ACTIONS(4467), 1,
      anon_sym_LF,
    STATE(2761), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(3915), 6,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [73506] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3835), 1,
      anon_sym_LF,
    STATE(2763), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(3829), 6,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [73530] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4470), 1,
      anon_sym_SEMI,
    ACTIONS(4472), 1,
      anon_sym_LF,
    STATE(2761), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(1427), 6,
      anon_sym_end,
      anon_sym_RPAREN,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
  [73554] = 9,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(4480), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4482), 1,
      anon_sym_COLON_COLON,
    STATE(2874), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4286), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [73583] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2676), 7,
      sym__immediate_paren,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [73597] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4015), 1,
      anon_sym_COMMA,
    STATE(2767), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2815), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2811), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
  [73619] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4130), 1,
      anon_sym_COMMA,
    STATE(2767), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(2777), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(2772), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      sym__assign_operator,
  [73641] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2622), 7,
      sym__immediate_paren,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [73655] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2714), 7,
      sym__immediate_paren,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [73669] = 5,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4486), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4484), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2771), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [73689] = 5,
    ACTIONS(4490), 1,
      anon_sym_if,
    ACTIONS(4493), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4488), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2771), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [73709] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
    ACTIONS(4360), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [73725] = 5,
    ACTIONS(4059), 1,
      anon_sym_for,
    ACTIONS(4486), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4496), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(2770), 3,
      sym_if_clause,
      sym_for_clause,
      aux_sym__comprehension_clause_repeat1,
  [73745] = 7,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4498), 1,
      sym_identifier,
    ACTIONS(4500), 1,
      anon_sym_RPAREN,
    STATE(2792), 1,
      sym_typed_parameter,
    STATE(4309), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2864), 2,
      sym_optional_parameter,
      sym_spread_parameter,
  [73769] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4506), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73788] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4512), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4510), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2853), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73807] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4516), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4514), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2781), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73826] = 7,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(4480), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4482), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4518), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [73849] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4520), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73868] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4524), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73887] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4526), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73906] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4528), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73925] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4532), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4530), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2788), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73944] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4536), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4534), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2789), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73963] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4540), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4538), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2821), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [73982] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4544), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4542), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2779), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74001] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4548), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4546), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2782), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74020] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4550), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74039] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4552), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74058] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4554), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74077] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4556), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74096] = 7,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    STATE(2874), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4286), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [74119] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4558), 1,
      anon_sym_end,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    STATE(4023), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74140] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4562), 1,
      anon_sym_end,
    STATE(4125), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2822), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74161] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4564), 1,
      anon_sym_end,
    STATE(4124), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74182] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4568), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4566), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2775), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74201] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4570), 1,
      anon_sym_end,
    STATE(4259), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2808), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74222] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4572), 1,
      anon_sym_end,
    STATE(4258), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74243] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4574), 1,
      anon_sym_end,
    STATE(4031), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74264] = 7,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(4576), 1,
      anon_sym_RPAREN,
    STATE(2880), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4006), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [74287] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4578), 1,
      anon_sym_end,
    STATE(4032), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2793), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74308] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4582), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4580), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2790), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74327] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4586), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4584), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2791), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74346] = 5,
    ACTIONS(4588), 1,
      anon_sym_DOLLAR,
    ACTIONS(4594), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4591), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74365] = 4,
    ACTIONS(4596), 1,
      anon_sym_COMMA,
    STATE(2845), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4598), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [74382] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4600), 1,
      anon_sym_end,
    STATE(3821), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74403] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4602), 1,
      anon_sym_end,
    STATE(4245), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2813), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74424] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4604), 1,
      anon_sym_end,
    STATE(4244), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74445] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4606), 1,
      anon_sym_end,
    STATE(3979), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2832), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74466] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4608), 1,
      anon_sym_end,
    STATE(3978), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74487] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4610), 1,
      anon_sym_end,
    STATE(3792), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2806), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74508] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4612), 1,
      anon_sym_end,
    STATE(3901), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2844), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74529] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4614), 1,
      anon_sym_end,
    STATE(4238), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74550] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4616), 1,
      anon_sym_end,
    STATE(3818), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74571] = 5,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(4480), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4482), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4618), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [74590] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4620), 1,
      anon_sym_end,
    STATE(3767), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2831), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74611] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4622), 1,
      anon_sym_end,
    STATE(4050), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74632] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4624), 1,
      anon_sym_end,
    STATE(3911), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74653] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4626), 1,
      anon_sym_end,
    STATE(4051), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2799), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74674] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4628), 1,
      anon_sym_end,
    STATE(4105), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2848), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74695] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4630), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74714] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4632), 1,
      anon_sym_end,
    STATE(4103), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74735] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4634), 1,
      anon_sym_end,
    STATE(3893), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74756] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4636), 1,
      anon_sym_end,
    STATE(3829), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74777] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4638), 1,
      anon_sym_end,
    STATE(3844), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74798] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4640), 1,
      anon_sym_end,
    STATE(3845), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2824), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74819] = 5,
    ACTIONS(4594), 1,
      sym__command_end,
    ACTIONS(4642), 1,
      anon_sym_DOLLAR,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4645), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74838] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4650), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4648), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2835), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74857] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4652), 1,
      anon_sym_end,
    STATE(4173), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74878] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4656), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4654), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2852), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74897] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4658), 1,
      anon_sym_end,
    STATE(3892), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74918] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4660), 1,
      anon_sym_end,
    STATE(3962), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74939] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4664), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4662), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2850), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74958] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4666), 1,
      anon_sym_end,
    STATE(3963), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2840), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [74979] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4668), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [74998] = 7,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4013), 1,
      ts_builtin_sym_end,
    ACTIONS(4017), 1,
      anon_sym_SEMI,
    ACTIONS(4051), 1,
      anon_sym_LF,
    STATE(3009), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(4019), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [75021] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4670), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75040] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4672), 1,
      anon_sym_end,
    STATE(4179), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75061] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4674), 1,
      anon_sym_end,
    STATE(4201), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75082] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4676), 1,
      anon_sym_end,
    STATE(3956), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75103] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4678), 1,
      anon_sym_end,
    STATE(4181), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2829), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75124] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4680), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75143] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4682), 1,
      anon_sym_end,
    STATE(4203), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2838), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75164] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4684), 1,
      anon_sym_end,
    STATE(3797), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75185] = 4,
    ACTIONS(4686), 1,
      anon_sym_COMMA,
    STATE(2845), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3642), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [75202] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4691), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4689), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2780), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75221] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4693), 1,
      anon_sym_end,
    STATE(3830), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2814), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75242] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4695), 1,
      anon_sym_end,
    STATE(4094), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75263] = 4,
    ACTIONS(4596), 1,
      anon_sym_COMMA,
    STATE(2805), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4697), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [75280] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4699), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75299] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4701), 1,
      anon_sym_end,
    STATE(3884), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75320] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4703), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2827), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75339] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4705), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4522), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2804), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75358] = 5,
    ACTIONS(4508), 1,
      anon_sym_DOLLAR,
    ACTIONS(4709), 1,
      sym__string_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4707), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2837), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75377] = 5,
    ACTIONS(4502), 1,
      anon_sym_DOLLAR,
    ACTIONS(4713), 1,
      sym__command_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4711), 2,
      sym__string_content,
      sym_escape_sequence,
    STATE(2842), 2,
      sym_string_interpolation,
      aux_sym_string_literal_repeat1,
  [75396] = 6,
    ACTIONS(318), 1,
      anon_sym_else,
    ACTIONS(4560), 1,
      anon_sym_elseif,
    ACTIONS(4715), 1,
      anon_sym_end,
    STATE(3894), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2851), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [75417] = 5,
    ACTIONS(2772), 1,
      sym__assign_operator,
    ACTIONS(3847), 1,
      anon_sym_COMMA,
    STATE(2857), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2777), 2,
      anon_sym_end,
      anon_sym_EQ,
  [75435] = 6,
    ACTIONS(4717), 1,
      anon_sym_end,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    STATE(3448), 1,
      sym_catch_clause,
    STATE(3865), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75455] = 6,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4723), 1,
      anon_sym_end,
    STATE(3114), 1,
      sym_catch_clause,
    STATE(4004), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75475] = 6,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4725), 1,
      anon_sym_end,
    STATE(3230), 1,
      sym_catch_clause,
    STATE(4146), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75495] = 6,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4727), 1,
      anon_sym_end,
    STATE(3281), 1,
      sym_catch_clause,
    STATE(3930), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75515] = 4,
    ACTIONS(4729), 1,
      anon_sym_LBRACE,
    STATE(1229), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [75531] = 6,
    ACTIONS(4731), 1,
      anon_sym_end,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    STATE(3204), 1,
      sym_type_parameter_list,
    STATE(4133), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75551] = 6,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
    STATE(2874), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4286), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75571] = 4,
    ACTIONS(4737), 1,
      anon_sym_LBRACE,
    STATE(1975), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [75587] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4739), 1,
      aux_sym_primitive_definition_token1,
    STATE(3234), 1,
      sym_type_parameter_list,
    STATE(4150), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75607] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4741), 1,
      aux_sym_primitive_definition_token1,
    STATE(3319), 1,
      sym_type_parameter_list,
    STATE(4210), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75627] = 6,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4743), 1,
      anon_sym_end,
    STATE(3249), 1,
      sym_catch_clause,
    STATE(4277), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75647] = 5,
    ACTIONS(2811), 1,
      sym__assign_operator,
    ACTIONS(3342), 1,
      anon_sym_COMMA,
    STATE(2857), 1,
      aux_sym_bare_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2815), 2,
      anon_sym_end,
      anon_sym_EQ,
  [75665] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4745), 1,
      aux_sym_primitive_definition_token1,
    STATE(3265), 1,
      sym_type_parameter_list,
    STATE(3938), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75685] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4747), 1,
      aux_sym_primitive_definition_token1,
    STATE(3318), 1,
      sym_type_parameter_list,
    STATE(3914), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75705] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4749), 1,
      anon_sym_end,
    STATE(3390), 1,
      sym_type_parameter_list,
    STATE(4266), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75725] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(2871), 1,
      anon_sym_SEMI,
    ACTIONS(2883), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(4019), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [75743] = 6,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4751), 1,
      anon_sym_RPAREN,
    STATE(2917), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4260), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75763] = 6,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4576), 1,
      anon_sym_RPAREN,
    STATE(2880), 1,
      aux_sym_parameter_list_repeat1,
    STATE(4006), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75783] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4753), 1,
      anon_sym_end,
    STATE(3145), 1,
      sym_type_parameter_list,
    STATE(3991), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75803] = 4,
    ACTIONS(3667), 1,
      anon_sym_LBRACE,
    STATE(2092), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [75819] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4755), 1,
      anon_sym_end,
    STATE(3253), 1,
      sym_type_parameter_list,
    STATE(3941), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75839] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4757), 1,
      aux_sym_primitive_definition_token1,
    STATE(3106), 1,
      sym_type_parameter_list,
    STATE(4057), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75859] = 6,
    ACTIONS(1337), 1,
      anon_sym_SEMI,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4759), 1,
      anon_sym_RPAREN,
    STATE(2917), 1,
      aux_sym_parameter_list_repeat1,
    STATE(3925), 1,
      sym_keyword_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75879] = 4,
    ACTIONS(2472), 1,
      anon_sym_LBRACE,
    STATE(1085), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [75895] = 5,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3915), 1,
      anon_sym_SEMI,
    ACTIONS(3917), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(4019), 2,
      anon_sym_EQ,
      sym__assign_operator,
  [75913] = 4,
    ACTIONS(4761), 1,
      anon_sym_LBRACE,
    STATE(1239), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [75929] = 4,
    ACTIONS(4763), 1,
      anon_sym_do,
    STATE(3402), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2488), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [75945] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4765), 1,
      anon_sym_end,
    STATE(3311), 1,
      sym_type_parameter_list,
    STATE(4209), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75965] = 6,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4767), 1,
      anon_sym_end,
    STATE(3128), 1,
      sym_catch_clause,
    STATE(3994), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [75985] = 5,
    ACTIONS(4769), 1,
      anon_sym_end,
    ACTIONS(4771), 1,
      anon_sym_elseif,
    ACTIONS(4774), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2887), 2,
      sym_elseif_clause,
      aux_sym_if_statement_repeat1,
  [76003] = 4,
    ACTIONS(3691), 1,
      anon_sym_LBRACE,
    STATE(2257), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [76019] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4776), 1,
      aux_sym_primitive_definition_token1,
    STATE(3148), 1,
      sym_type_parameter_list,
    STATE(4090), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76039] = 4,
    ACTIONS(4763), 1,
      anon_sym_do,
    STATE(3423), 1,
      sym_do_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2482), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [76055] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4778), 1,
      aux_sym_primitive_definition_token1,
    STATE(3193), 1,
      sym_type_parameter_list,
    STATE(4120), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76075] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4780), 1,
      anon_sym_end,
    STATE(3478), 1,
      sym_type_parameter_list,
    STATE(3851), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76095] = 6,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4782), 1,
      anon_sym_end,
    STATE(3123), 1,
      sym_catch_clause,
    STATE(4070), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76115] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4784), 1,
      anon_sym_end,
    STATE(3107), 1,
      sym_type_parameter_list,
    STATE(4058), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76135] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4786), 1,
      aux_sym_primitive_definition_token1,
    STATE(3287), 1,
      sym_type_parameter_list,
    STATE(4180), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76155] = 4,
    ACTIONS(4788), 1,
      anon_sym_LBRACE,
    STATE(871), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [76171] = 4,
    ACTIONS(2694), 1,
      anon_sym_LBRACE,
    STATE(1221), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [76187] = 6,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(4790), 1,
      anon_sym_end,
    STATE(3312), 1,
      sym_type_parameter_list,
    STATE(3919), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76207] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3642), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RBRACK,
  [76219] = 4,
    ACTIONS(4362), 1,
      anon_sym_LBRACE,
    STATE(2769), 1,
      sym_type_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(97), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [76235] = 6,
    ACTIONS(4719), 1,
      anon_sym_catch,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4792), 1,
      anon_sym_end,
    STATE(3246), 1,
      sym_catch_clause,
    STATE(4221), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76255] = 4,
    ACTIONS(4797), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4794), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76270] = 5,
    ACTIONS(2250), 1,
      anon_sym_RPAREN,
    ACTIONS(4799), 1,
      anon_sym_COMMA,
    ACTIONS(4801), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76287] = 4,
    ACTIONS(4805), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76302] = 4,
    ACTIONS(4809), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76317] = 5,
    ACTIONS(2298), 1,
      anon_sym_RPAREN,
    ACTIONS(4811), 1,
      anon_sym_COMMA,
    ACTIONS(4813), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76334] = 4,
    ACTIONS(4817), 1,
      sym__command_end,
    STATE(3011), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4815), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76349] = 4,
    ACTIONS(4821), 1,
      sym__string_end,
    STATE(3006), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4819), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76364] = 4,
    ACTIONS(4797), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4823), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76379] = 5,
    ACTIONS(4826), 1,
      sym_identifier,
    ACTIONS(4828), 1,
      anon_sym_DOT,
    STATE(2015), 1,
      sym_scoped_identifier,
    STATE(2152), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76396] = 5,
    ACTIONS(4830), 1,
      sym_identifier,
    ACTIONS(4832), 1,
      anon_sym_DOT,
    STATE(2083), 1,
      sym_scoped_identifier,
    STATE(2286), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76413] = 5,
    ACTIONS(4834), 1,
      sym_identifier,
    ACTIONS(4836), 1,
      anon_sym_DOT,
    STATE(1087), 1,
      sym_scoped_identifier,
    STATE(1238), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76430] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(1932), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76447] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(127), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76464] = 5,
    ACTIONS(4842), 1,
      sym_identifier,
    ACTIONS(4844), 1,
      anon_sym_DOT,
    STATE(1226), 1,
      sym_scoped_identifier,
    STATE(1470), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76481] = 5,
    ACTIONS(2346), 1,
      anon_sym_RPAREN,
    ACTIONS(4846), 1,
      anon_sym_COMMA,
    ACTIONS(4848), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76498] = 4,
    ACTIONS(4850), 1,
      anon_sym_COMMA,
    STATE(2917), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4618), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [76513] = 4,
    ACTIONS(4855), 1,
      sym__string_end,
    STATE(2933), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4853), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76528] = 4,
    ACTIONS(4859), 1,
      sym__command_end,
    STATE(2935), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4857), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76543] = 5,
    ACTIONS(2262), 1,
      anon_sym_RPAREN,
    ACTIONS(4861), 1,
      anon_sym_COMMA,
    ACTIONS(4863), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76560] = 4,
    ACTIONS(4867), 1,
      sym__string_end,
    STATE(2905), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4865), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76575] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(288), 1,
      sym_parameter_list,
    STATE(3737), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76592] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4871), 4,
      sym__command_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [76603] = 4,
    ACTIONS(4873), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76618] = 4,
    ACTIONS(4877), 1,
      sym__string_end,
    STATE(2966), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4875), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76633] = 4,
    ACTIONS(4881), 1,
      sym__command_end,
    STATE(2967), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4879), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76648] = 4,
    ACTIONS(4883), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76663] = 5,
    ACTIONS(2320), 1,
      anon_sym_RPAREN,
    ACTIONS(4885), 1,
      anon_sym_COMMA,
    ACTIONS(4887), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76680] = 5,
    ACTIONS(2302), 1,
      anon_sym_RPAREN,
    ACTIONS(4889), 1,
      anon_sym_COMMA,
    ACTIONS(4891), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76697] = 5,
    ACTIONS(4893), 1,
      anon_sym_COMMA,
    ACTIONS(4895), 1,
      anon_sym_RPAREN,
    ACTIONS(4897), 1,
      anon_sym_SEMI,
    STATE(2928), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76714] = 5,
    ACTIONS(4836), 1,
      anon_sym_DOT,
    ACTIONS(4899), 1,
      sym_identifier,
    STATE(1136), 1,
      sym_scoped_identifier,
    STATE(1338), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76731] = 4,
    ACTIONS(4903), 1,
      sym__command_end,
    STATE(2904), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4901), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76746] = 4,
    ACTIONS(4905), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76761] = 5,
    ACTIONS(4907), 1,
      sym_identifier,
    ACTIONS(4909), 1,
      anon_sym_DOT,
    STATE(882), 1,
      sym_scoped_identifier,
    STATE(1055), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76778] = 4,
    ACTIONS(4911), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [76793] = 5,
    ACTIONS(2252), 1,
      anon_sym_RPAREN,
    ACTIONS(4913), 1,
      anon_sym_COMMA,
    ACTIONS(4915), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76810] = 5,
    ACTIONS(4917), 1,
      sym_identifier,
    ACTIONS(4919), 1,
      anon_sym_DOT,
    STATE(1233), 1,
      sym_scoped_identifier,
    STATE(1504), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76827] = 4,
    ACTIONS(4921), 1,
      anon_sym_COMMA,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4312), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [76842] = 5,
    ACTIONS(4924), 1,
      anon_sym_COMMA,
    ACTIONS(4926), 1,
      anon_sym_RPAREN,
    ACTIONS(4928), 1,
      anon_sym_SEMI,
    STATE(2951), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76859] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(117), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76876] = 5,
    ACTIONS(2158), 1,
      anon_sym_RPAREN,
    ACTIONS(4930), 1,
      anon_sym_COMMA,
    ACTIONS(4932), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76893] = 5,
    ACTIONS(2166), 1,
      anon_sym_RPAREN,
    ACTIONS(4934), 1,
      anon_sym_COMMA,
    ACTIONS(4936), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76910] = 5,
    ACTIONS(2170), 1,
      anon_sym_RPAREN,
    ACTIONS(4938), 1,
      anon_sym_COMMA,
    ACTIONS(4940), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76927] = 5,
    ACTIONS(2344), 1,
      anon_sym_RPAREN,
    ACTIONS(4942), 1,
      anon_sym_COMMA,
    ACTIONS(4944), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76944] = 5,
    ACTIONS(2110), 1,
      anon_sym_RPAREN,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(4948), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76961] = 5,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(4518), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76978] = 5,
    ACTIONS(2228), 1,
      anon_sym_RPAREN,
    ACTIONS(4950), 1,
      anon_sym_COMMA,
    ACTIONS(4952), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [76995] = 3,
    ACTIONS(4478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4618), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [77008] = 5,
    ACTIONS(4954), 1,
      anon_sym_COMMA,
    ACTIONS(4956), 1,
      anon_sym_RPAREN,
    ACTIONS(4958), 1,
      anon_sym_SEMI,
    STATE(2942), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77025] = 5,
    ACTIONS(2336), 1,
      anon_sym_RPAREN,
    ACTIONS(4960), 1,
      anon_sym_COMMA,
    ACTIONS(4962), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77042] = 5,
    ACTIONS(2334), 1,
      anon_sym_RPAREN,
    ACTIONS(4964), 1,
      anon_sym_COMMA,
    ACTIONS(4966), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77059] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4968), 4,
      sym__command_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [77070] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3653), 4,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_LPAREN,
      anon_sym_LT_COLON,
  [77081] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(4013), 1,
      ts_builtin_sym_end,
    ACTIONS(4017), 1,
      anon_sym_SEMI,
    ACTIONS(4051), 1,
      anon_sym_LF,
    STATE(3009), 1,
      aux_sym__expression_list_repeat1,
  [77100] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(139), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77117] = 5,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
    ACTIONS(4970), 1,
      anon_sym_COMMA,
    ACTIONS(4972), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77134] = 5,
    ACTIONS(4832), 1,
      anon_sym_DOT,
    ACTIONS(4974), 1,
      sym_identifier,
    STATE(2128), 1,
      sym_scoped_identifier,
    STATE(2399), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77151] = 5,
    ACTIONS(2300), 1,
      anon_sym_RPAREN,
    ACTIONS(4976), 1,
      anon_sym_COMMA,
    ACTIONS(4978), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77168] = 5,
    ACTIONS(4980), 1,
      anon_sym_COMMA,
    ACTIONS(4982), 1,
      anon_sym_RPAREN,
    ACTIONS(4984), 1,
      anon_sym_SEMI,
    STATE(2945), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77185] = 5,
    ACTIONS(4986), 1,
      sym_identifier,
    ACTIONS(4988), 1,
      anon_sym_DOT,
    STATE(2426), 1,
      sym_scoped_identifier,
    STATE(2512), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77202] = 5,
    ACTIONS(4990), 1,
      anon_sym_COMMA,
    ACTIONS(4992), 1,
      anon_sym_RPAREN,
    ACTIONS(4994), 1,
      anon_sym_SEMI,
    STATE(2969), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77219] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(121), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77236] = 5,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    ACTIONS(4996), 1,
      sym_identifier,
    STATE(2849), 1,
      sym_for_binding,
    STATE(3343), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77253] = 5,
    ACTIONS(2276), 1,
      anon_sym_RPAREN,
    ACTIONS(4998), 1,
      anon_sym_COMMA,
    ACTIONS(5000), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77270] = 4,
    ACTIONS(5004), 1,
      sym__string_end,
    STATE(3024), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5002), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77285] = 4,
    ACTIONS(5006), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77300] = 4,
    ACTIONS(5008), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77315] = 5,
    ACTIONS(5010), 1,
      anon_sym_COMMA,
    ACTIONS(5012), 1,
      anon_sym_RBRACE,
    ACTIONS(5014), 1,
      anon_sym_LT_COLON,
    STATE(3236), 1,
      aux_sym_type_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77332] = 5,
    ACTIONS(2274), 1,
      anon_sym_RPAREN,
    ACTIONS(5016), 1,
      anon_sym_COMMA,
    ACTIONS(5018), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77349] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2504), 4,
      sym__immediate_paren,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [77360] = 5,
    ACTIONS(2180), 1,
      anon_sym_RPAREN,
    ACTIONS(5020), 1,
      anon_sym_COMMA,
    ACTIONS(5022), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77377] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(209), 1,
      sym_parameter_list,
    STATE(3660), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77394] = 5,
    ACTIONS(2188), 1,
      anon_sym_RPAREN,
    ACTIONS(5024), 1,
      anon_sym_COMMA,
    ACTIONS(5026), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77411] = 5,
    ACTIONS(5028), 1,
      anon_sym_COMMA,
    ACTIONS(5030), 1,
      anon_sym_RPAREN,
    ACTIONS(5032), 1,
      anon_sym_SEMI,
    STATE(2971), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77428] = 5,
    ACTIONS(5034), 1,
      anon_sym_COMMA,
    ACTIONS(5036), 1,
      anon_sym_RPAREN,
    ACTIONS(5038), 1,
      anon_sym_SEMI,
    STATE(2941), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77445] = 4,
    ACTIONS(5042), 1,
      sym__command_end,
    STATE(3022), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5040), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77460] = 5,
    ACTIONS(5010), 1,
      anon_sym_COMMA,
    ACTIONS(5014), 1,
      anon_sym_LT_COLON,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    STATE(3576), 1,
      aux_sym_type_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77477] = 5,
    ACTIONS(5046), 1,
      anon_sym_COMMA,
    ACTIONS(5048), 1,
      anon_sym_RPAREN,
    ACTIONS(5050), 1,
      anon_sym_SEMI,
    STATE(2903), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77494] = 5,
    ACTIONS(4828), 1,
      anon_sym_DOT,
    ACTIONS(5052), 1,
      sym_identifier,
    STATE(2013), 1,
      sym_scoped_identifier,
    STATE(2094), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77511] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2508), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [77522] = 4,
    ACTIONS(5054), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77537] = 4,
    ACTIONS(5056), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77552] = 5,
    ACTIONS(2242), 1,
      anon_sym_RPAREN,
    ACTIONS(5058), 1,
      anon_sym_COMMA,
    ACTIONS(5060), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77569] = 4,
    ACTIONS(5062), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77584] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4871), 4,
      sym__string_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [77595] = 4,
    ACTIONS(5064), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77610] = 5,
    ACTIONS(5066), 1,
      sym_identifier,
    ACTIONS(5068), 1,
      anon_sym_DOT,
    STATE(1309), 1,
      sym_scoped_identifier,
    STATE(1861), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77627] = 5,
    ACTIONS(5070), 1,
      anon_sym_COMMA,
    ACTIONS(5072), 1,
      anon_sym_RPAREN,
    ACTIONS(5074), 1,
      anon_sym_SEMI,
    STATE(2906), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77644] = 4,
    ACTIONS(5076), 1,
      sym_identifier,
    STATE(2948), 1,
      sym_typed_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(3274), 2,
      sym_optional_parameter,
      sym_spread_parameter,
  [77659] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(196), 1,
      sym_parameter_list,
    STATE(3706), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77676] = 5,
    ACTIONS(5078), 1,
      anon_sym_COMMA,
    ACTIONS(5080), 1,
      anon_sym_RPAREN,
    ACTIONS(5082), 1,
      anon_sym_SEMI,
    STATE(2994), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77693] = 5,
    ACTIONS(2238), 1,
      anon_sym_RPAREN,
    ACTIONS(5084), 1,
      anon_sym_COMMA,
    ACTIONS(5086), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77710] = 5,
    ACTIONS(4844), 1,
      anon_sym_DOT,
    ACTIONS(5088), 1,
      sym_identifier,
    STATE(1429), 1,
      sym_scoped_identifier,
    STATE(1766), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77727] = 5,
    ACTIONS(2234), 1,
      anon_sym_RPAREN,
    ACTIONS(5090), 1,
      anon_sym_COMMA,
    ACTIONS(5092), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77744] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(265), 1,
      sym_parameter_list,
    STATE(3754), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77761] = 5,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    ACTIONS(4996), 1,
      sym_identifier,
    STATE(2899), 1,
      sym_for_binding,
    STATE(3343), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77778] = 5,
    ACTIONS(4919), 1,
      anon_sym_DOT,
    ACTIONS(5094), 1,
      sym_identifier,
    STATE(1378), 1,
      sym_scoped_identifier,
    STATE(1602), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77795] = 5,
    ACTIONS(2342), 1,
      anon_sym_RPAREN,
    ACTIONS(5096), 1,
      anon_sym_COMMA,
    ACTIONS(5098), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77812] = 5,
    ACTIONS(5100), 1,
      anon_sym_COMMA,
    ACTIONS(5102), 1,
      anon_sym_RPAREN,
    ACTIONS(5104), 1,
      anon_sym_SEMI,
    STATE(3003), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77829] = 5,
    ACTIONS(5106), 1,
      anon_sym_COMMA,
    ACTIONS(5108), 1,
      anon_sym_RPAREN,
    ACTIONS(5110), 1,
      anon_sym_SEMI,
    STATE(3017), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77846] = 5,
    ACTIONS(2224), 1,
      anon_sym_RPAREN,
    ACTIONS(5112), 1,
      anon_sym_COMMA,
    ACTIONS(5114), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77863] = 5,
    ACTIONS(2340), 1,
      anon_sym_RPAREN,
    ACTIONS(5116), 1,
      anon_sym_COMMA,
    ACTIONS(5118), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77880] = 5,
    ACTIONS(2222), 1,
      anon_sym_RPAREN,
    ACTIONS(5120), 1,
      anon_sym_COMMA,
    ACTIONS(5122), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77897] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(137), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77914] = 4,
    ACTIONS(5124), 1,
      sym_identifier,
    STATE(2946), 1,
      sym_typed_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(3086), 2,
      sym_optional_parameter,
      sym_spread_parameter,
  [77929] = 4,
    ACTIONS(5126), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [77944] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3649), 4,
      anon_sym_end,
      aux_sym_primitive_definition_token1,
      anon_sym_LPAREN,
      anon_sym_LT_COLON,
  [77955] = 5,
    ACTIONS(5128), 1,
      anon_sym_COMMA,
    ACTIONS(5130), 1,
      anon_sym_RPAREN,
    ACTIONS(5132), 1,
      anon_sym_SEMI,
    STATE(3018), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [77972] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(1429), 1,
      ts_builtin_sym_end,
    ACTIONS(5134), 1,
      anon_sym_SEMI,
    ACTIONS(5136), 1,
      anon_sym_LF,
    STATE(3030), 1,
      aux_sym__expression_list_repeat1,
  [77991] = 5,
    ACTIONS(4988), 1,
      anon_sym_DOT,
    ACTIONS(5138), 1,
      sym_identifier,
    STATE(2262), 1,
      sym_scoped_identifier,
    STATE(2463), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78008] = 4,
    ACTIONS(5140), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78023] = 4,
    ACTIONS(5144), 1,
      sym__command_end,
    STATE(2981), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5142), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78038] = 4,
    ACTIONS(5148), 1,
      sym__string_end,
    STATE(2982), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5146), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78053] = 5,
    ACTIONS(2214), 1,
      anon_sym_RPAREN,
    ACTIONS(5150), 1,
      anon_sym_COMMA,
    ACTIONS(5152), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78070] = 5,
    ACTIONS(2244), 1,
      anon_sym_RPAREN,
    ACTIONS(5154), 1,
      anon_sym_COMMA,
    ACTIONS(5156), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78087] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4968), 4,
      sym__string_end,
      sym__string_content,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [78098] = 5,
    ACTIONS(2240), 1,
      anon_sym_RPAREN,
    ACTIONS(5158), 1,
      anon_sym_COMMA,
    ACTIONS(5160), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78115] = 5,
    ACTIONS(2212), 1,
      anon_sym_RPAREN,
    ACTIONS(5162), 1,
      anon_sym_COMMA,
    ACTIONS(5164), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78132] = 5,
    ACTIONS(5166), 1,
      anon_sym_COMMA,
    ACTIONS(5168), 1,
      anon_sym_RPAREN,
    ACTIONS(5170), 1,
      anon_sym_SEMI,
    STATE(3031), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78149] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(157), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78166] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      sym_parameter_list,
    STATE(3719), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78183] = 4,
    ACTIONS(5172), 1,
      sym__command_end,
    STATE(2909), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4803), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78198] = 5,
    ACTIONS(5174), 1,
      anon_sym_COMMA,
    ACTIONS(5176), 1,
      anon_sym_RPAREN,
    ACTIONS(5178), 1,
      anon_sym_SEMI,
    STATE(2956), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78215] = 4,
    ACTIONS(5180), 1,
      sym__string_end,
    STATE(2902), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4807), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78230] = 4,
    ACTIONS(5184), 1,
      sym__command_end,
    STATE(2984), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5182), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78245] = 5,
    ACTIONS(2196), 1,
      anon_sym_RPAREN,
    ACTIONS(5186), 1,
      anon_sym_COMMA,
    ACTIONS(5188), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78262] = 5,
    ACTIONS(5068), 1,
      anon_sym_DOT,
    ACTIONS(5190), 1,
      sym_identifier,
    STATE(1213), 1,
      sym_scoped_identifier,
    STATE(1431), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78279] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(194), 1,
      sym_parameter_list,
    STATE(3673), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78296] = 4,
    ACTIONS(5194), 1,
      sym__string_end,
    STATE(2986), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5192), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78311] = 6,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3917), 1,
      ts_builtin_sym_end,
    ACTIONS(5196), 1,
      anon_sym_SEMI,
    ACTIONS(5199), 1,
      anon_sym_LF,
    STATE(3030), 1,
      aux_sym__expression_list_repeat1,
  [78330] = 5,
    ACTIONS(2194), 1,
      anon_sym_RPAREN,
    ACTIONS(5202), 1,
      anon_sym_COMMA,
    ACTIONS(5204), 1,
      anon_sym_SEMI,
    STATE(2938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78347] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2584), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78358] = 5,
    ACTIONS(5206), 1,
      anon_sym_COMMA,
    ACTIONS(5208), 1,
      anon_sym_RPAREN,
    ACTIONS(5210), 1,
      anon_sym_SEMI,
    STATE(2998), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78375] = 5,
    ACTIONS(4909), 1,
      anon_sym_DOT,
    ACTIONS(5212), 1,
      sym_identifier,
    STATE(858), 1,
      sym_scoped_identifier,
    STATE(929), 1,
      sym_selected_import,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78392] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(148), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78409] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2580), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78420] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2576), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78431] = 5,
    ACTIONS(4838), 1,
      sym_identifier,
    ACTIONS(4840), 1,
      anon_sym_LPAREN,
    STATE(118), 1,
      sym_for_binding,
    STATE(3186), 1,
      sym_tuple_expression,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78448] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(320), 1,
      sym_parameter_list,
    STATE(3689), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78465] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2572), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78476] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2568), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78487] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2560), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78498] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2552), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78509] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2548), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78520] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2496), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78531] = 5,
    ACTIONS(5214), 1,
      anon_sym_COMMA,
    ACTIONS(5216), 1,
      anon_sym_RPAREN,
    ACTIONS(5218), 1,
      anon_sym_SEMI,
    STATE(2944), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78548] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2540), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78559] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2532), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78570] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2524), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78581] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2520), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78592] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2516), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78603] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2512), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78614] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2492), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78625] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2536), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78636] = 5,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(231), 1,
      sym_parameter_list,
    STATE(3765), 1,
      sym_type_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78653] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2500), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78664] = 4,
    ACTIONS(5222), 1,
      sym__string_end,
    STATE(2927), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5220), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78679] = 4,
    ACTIONS(5226), 1,
      sym__command_end,
    STATE(2924), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5224), 2,
      sym__string_content_no_interp,
      sym_escape_sequence,
  [78694] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2544), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78705] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2556), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78716] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2564), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78727] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2528), 4,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_do,
  [78738] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5230), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78752] = 4,
    ACTIONS(5232), 1,
      anon_sym_COMMA,
    ACTIONS(5234), 1,
      anon_sym_RPAREN,
    STATE(3365), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78766] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5236), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78780] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5238), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78794] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5240), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78808] = 4,
    ACTIONS(5240), 1,
      anon_sym_RPAREN,
    ACTIONS(5242), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78822] = 4,
    ACTIONS(5244), 1,
      anon_sym_COMMA,
    ACTIONS(5246), 1,
      anon_sym_RPAREN,
    STATE(3075), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78836] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5248), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78850] = 4,
    ACTIONS(5248), 1,
      anon_sym_RPAREN,
    ACTIONS(5250), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78864] = 4,
    ACTIONS(5252), 1,
      anon_sym_COMMA,
    ACTIONS(5254), 1,
      anon_sym_RPAREN,
    STATE(3079), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78878] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5256), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78892] = 4,
    ACTIONS(5236), 1,
      anon_sym_RPAREN,
    ACTIONS(5258), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78906] = 4,
    ACTIONS(5230), 1,
      anon_sym_RPAREN,
    ACTIONS(5260), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78920] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4723), 1,
      anon_sym_end,
    STATE(4004), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78934] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5262), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78948] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5264), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78962] = 4,
    ACTIONS(5264), 1,
      anon_sym_RPAREN,
    ACTIONS(5266), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78976] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5268), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [78990] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5270), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79004] = 4,
    ACTIONS(2410), 1,
      anon_sym_RBRACK,
    ACTIONS(5272), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79018] = 4,
    ACTIONS(5274), 1,
      anon_sym_COMMA,
    ACTIONS(5276), 1,
      anon_sym_RPAREN,
    STATE(3315), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79032] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(5278), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79046] = 4,
    ACTIONS(5280), 1,
      sym_identifier,
    ACTIONS(5282), 1,
      anon_sym_AT,
    STATE(2338), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79060] = 4,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(4518), 1,
      anon_sym_RPAREN,
    STATE(3268), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79074] = 4,
    ACTIONS(5284), 1,
      anon_sym_COMMA,
    ACTIONS(5286), 1,
      anon_sym_RPAREN,
    STATE(3091), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79088] = 4,
    ACTIONS(5288), 1,
      anon_sym_SEMI,
    ACTIONS(5290), 1,
      anon_sym_RBRACK,
    STATE(3133), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79102] = 4,
    ACTIONS(5292), 1,
      anon_sym_COMMA,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79116] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5296), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79130] = 4,
    ACTIONS(5296), 1,
      anon_sym_RPAREN,
    ACTIONS(5298), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79144] = 3,
    ACTIONS(5300), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(819), 2,
      sym_argument_list,
      sym_generator_expression,
  [79156] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5294), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79170] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5302), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79184] = 4,
    ACTIONS(5304), 1,
      anon_sym_COMMA,
    ACTIONS(5306), 1,
      anon_sym_RPAREN,
    STATE(3074), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79198] = 4,
    ACTIONS(5308), 1,
      anon_sym_COMMA,
    ACTIONS(5310), 1,
      anon_sym_RPAREN,
    STATE(3068), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79212] = 4,
    ACTIONS(5312), 1,
      anon_sym_SEMI,
    ACTIONS(5315), 1,
      anon_sym_RBRACK,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79226] = 4,
    ACTIONS(5317), 1,
      anon_sym_COMMA,
    ACTIONS(5319), 1,
      anon_sym_RPAREN,
    STATE(3071), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79240] = 4,
    ACTIONS(5321), 1,
      anon_sym_COMMA,
    ACTIONS(5323), 1,
      anon_sym_RPAREN,
    STATE(3089), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79254] = 4,
    ACTIONS(5325), 1,
      anon_sym_COMMA,
    ACTIONS(5327), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79268] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5327), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79282] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5329), 1,
      sym_identifier,
    STATE(502), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79296] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5331), 1,
      sym_identifier,
    STATE(491), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79310] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5333), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [79320] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4743), 1,
      anon_sym_end,
    STATE(4277), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79334] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5335), 1,
      aux_sym_primitive_definition_token1,
    STATE(4060), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79348] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5337), 1,
      anon_sym_end,
    STATE(4041), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79362] = 4,
    ACTIONS(2226), 1,
      anon_sym_RPAREN,
    ACTIONS(5339), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79376] = 4,
    ACTIONS(5341), 1,
      anon_sym_COMMA,
    ACTIONS(5343), 1,
      anon_sym_RPAREN,
    STATE(3100), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79390] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5345), 1,
      sym_identifier,
    STATE(405), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79404] = 3,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2006), 2,
      sym_argument_list,
      sym_generator_expression,
  [79416] = 4,
    ACTIONS(2069), 1,
      anon_sym_RBRACK,
    ACTIONS(5349), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79430] = 4,
    ACTIONS(2420), 1,
      anon_sym_RBRACK,
    ACTIONS(5351), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79444] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(5353), 1,
      anon_sym_end,
    STATE(3977), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79458] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5355), 1,
      sym_identifier,
    STATE(495), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79472] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5357), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79486] = 4,
    ACTIONS(2200), 1,
      anon_sym_RPAREN,
    ACTIONS(5359), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79500] = 4,
    ACTIONS(5361), 1,
      anon_sym_COMMA,
    ACTIONS(5363), 1,
      anon_sym_RPAREN,
    STATE(3162), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79514] = 4,
    ACTIONS(5282), 1,
      anon_sym_AT,
    ACTIONS(5365), 1,
      sym_identifier,
    STATE(2311), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79528] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5367), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79542] = 4,
    ACTIONS(5369), 1,
      anon_sym_COMMA,
    ACTIONS(5371), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79556] = 3,
    ACTIONS(5373), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1943), 2,
      sym_argument_list,
      sym_generator_expression,
  [79568] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(5375), 1,
      anon_sym_end,
    STATE(4049), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79582] = 4,
    ACTIONS(2208), 1,
      anon_sym_RPAREN,
    ACTIONS(5377), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79596] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5371), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79610] = 4,
    ACTIONS(5379), 1,
      sym_identifier,
    ACTIONS(5381), 1,
      anon_sym_AT,
    STATE(923), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79624] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5383), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79638] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(5385), 1,
      anon_sym_end,
    STATE(3868), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79652] = 4,
    ACTIONS(5387), 1,
      anon_sym_COMMA,
    ACTIONS(5389), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79666] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2588), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_,
  [79676] = 4,
    ACTIONS(2366), 1,
      anon_sym_RBRACK,
    ACTIONS(5391), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79690] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5389), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79704] = 4,
    ACTIONS(2077), 1,
      anon_sym_RBRACK,
    ACTIONS(5393), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79718] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5395), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79732] = 3,
    ACTIONS(5347), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1996), 2,
      sym_argument_list,
      sym_generator_expression,
  [79744] = 4,
    ACTIONS(5397), 1,
      anon_sym_SEMI,
    ACTIONS(5399), 1,
      anon_sym_RBRACK,
    STATE(3112), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79758] = 4,
    ACTIONS(5401), 1,
      anon_sym_COMMA,
    ACTIONS(5403), 1,
      anon_sym_RPAREN,
    STATE(3121), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79772] = 4,
    ACTIONS(5405), 1,
      anon_sym_COMMA,
    ACTIONS(5407), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79786] = 3,
    ACTIONS(5300), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(817), 2,
      sym_argument_list,
      sym_generator_expression,
  [79798] = 4,
    ACTIONS(5409), 1,
      anon_sym_SEMI,
    ACTIONS(5411), 1,
      anon_sym_RBRACK,
    STATE(3154), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79812] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5407), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79826] = 4,
    ACTIONS(5413), 1,
      anon_sym_COMMA,
    ACTIONS(5415), 1,
      anon_sym_RPAREN,
    STATE(3129), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79840] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4782), 1,
      anon_sym_end,
    STATE(4070), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79854] = 4,
    ACTIONS(5417), 1,
      anon_sym_COMMA,
    ACTIONS(5419), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79868] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5421), 1,
      anon_sym_end,
    STATE(3971), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79882] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5419), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79896] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5423), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79910] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5425), 1,
      aux_sym_primitive_definition_token1,
    STATE(4093), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79924] = 4,
    ACTIONS(2422), 1,
      anon_sym_RBRACK,
    ACTIONS(5427), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79938] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5429), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79952] = 4,
    ACTIONS(5431), 1,
      sym_identifier,
    ACTIONS(5433), 1,
      anon_sym_AT,
    STATE(2048), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79966] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5435), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79980] = 4,
    ACTIONS(2398), 1,
      anon_sym_RBRACK,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [79994] = 4,
    ACTIONS(2083), 1,
      anon_sym_RBRACK,
    ACTIONS(5439), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80008] = 4,
    ACTIONS(5441), 1,
      anon_sym_COMMA,
    ACTIONS(5443), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80022] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5443), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80036] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5445), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80050] = 4,
    ACTIONS(5447), 1,
      anon_sym_COMMA,
    ACTIONS(5449), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80064] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5449), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80078] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5451), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80092] = 4,
    ACTIONS(5453), 1,
      anon_sym_COMMA,
    ACTIONS(5455), 1,
      anon_sym_RPAREN,
    STATE(3155), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80106] = 4,
    ACTIONS(5457), 1,
      anon_sym_COMMA,
    ACTIONS(5459), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80120] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5459), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80134] = 4,
    ACTIONS(5461), 1,
      anon_sym_COMMA,
    ACTIONS(5463), 1,
      anon_sym_RPAREN,
    STATE(3158), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80148] = 4,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    ACTIONS(5467), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80162] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5467), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80176] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5469), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80190] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(5471), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80204] = 4,
    ACTIONS(5473), 1,
      anon_sym_COMMA,
    ACTIONS(5475), 1,
      anon_sym_RPAREN,
    STATE(3138), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80218] = 4,
    ACTIONS(5477), 1,
      anon_sym_COMMA,
    ACTIONS(5479), 1,
      anon_sym_RPAREN,
    STATE(3165), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80232] = 4,
    ACTIONS(5481), 1,
      anon_sym_COMMA,
    ACTIONS(5483), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80246] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5483), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80260] = 4,
    ACTIONS(2362), 1,
      anon_sym_RBRACK,
    ACTIONS(5485), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80274] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5487), 1,
      sym_identifier,
    STATE(407), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80288] = 4,
    ACTIONS(5489), 1,
      anon_sym_COMMA,
    ACTIONS(5491), 1,
      anon_sym_RPAREN,
    STATE(3144), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80302] = 4,
    ACTIONS(5493), 1,
      anon_sym_COMMA,
    ACTIONS(5495), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80316] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5495), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80330] = 4,
    ACTIONS(5497), 1,
      anon_sym_DOT,
    ACTIONS(5499), 1,
      anon_sym_LBRACK,
    ACTIONS(5501), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80344] = 4,
    ACTIONS(5503), 1,
      anon_sym_COMMA,
    ACTIONS(5505), 1,
      anon_sym_RPAREN,
    STATE(3171), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80358] = 4,
    ACTIONS(5507), 1,
      sym_identifier,
    ACTIONS(5509), 1,
      anon_sym_AT,
    STATE(1690), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80372] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5511), 1,
      sym_identifier,
    STATE(470), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80386] = 4,
    ACTIONS(5513), 1,
      anon_sym_SEMI,
    ACTIONS(5515), 1,
      anon_sym_RBRACK,
    STATE(3357), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80400] = 3,
    ACTIONS(5517), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1017), 2,
      sym_argument_list,
      sym_generator_expression,
  [80412] = 4,
    ACTIONS(5519), 1,
      anon_sym_COMMA,
    ACTIONS(5521), 1,
      anon_sym_RPAREN,
    STATE(3176), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80426] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5523), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80440] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5525), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_,
  [80450] = 4,
    ACTIONS(2376), 1,
      anon_sym_RBRACK,
    ACTIONS(5527), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80464] = 4,
    ACTIONS(5381), 1,
      anon_sym_AT,
    ACTIONS(5529), 1,
      sym_identifier,
    STATE(995), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80478] = 4,
    ACTIONS(5531), 1,
      anon_sym_COMMA,
    ACTIONS(5533), 1,
      anon_sym_RPAREN,
    STATE(3200), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80492] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5535), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80506] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(5537), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80520] = 4,
    ACTIONS(5539), 1,
      anon_sym_COMMA,
    ACTIONS(5541), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80534] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5543), 1,
      aux_sym_primitive_definition_token1,
    STATE(4123), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80548] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5541), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80562] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4767), 1,
      anon_sym_end,
    STATE(3994), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80576] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5545), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80590] = 4,
    ACTIONS(5547), 1,
      anon_sym_COMMA,
    ACTIONS(5549), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80604] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5549), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80618] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5551), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80632] = 4,
    ACTIONS(5551), 1,
      anon_sym_RPAREN,
    ACTIONS(5553), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80646] = 4,
    ACTIONS(5555), 1,
      anon_sym_COMMA,
    ACTIONS(5557), 1,
      anon_sym_RPAREN,
    STATE(3207), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80660] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5559), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80674] = 4,
    ACTIONS(5561), 1,
      anon_sym_COMMA,
    ACTIONS(5563), 1,
      anon_sym_RPAREN,
    STATE(3210), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80688] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5565), 1,
      anon_sym_end,
    STATE(4114), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80702] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5567), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80716] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5569), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80730] = 4,
    ACTIONS(5569), 1,
      anon_sym_RPAREN,
    ACTIONS(5571), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80744] = 4,
    ACTIONS(5573), 1,
      anon_sym_COMMA,
    ACTIONS(5575), 1,
      anon_sym_RPAREN,
    STATE(3214), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80758] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5577), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80772] = 4,
    ACTIONS(5577), 1,
      anon_sym_RPAREN,
    ACTIONS(5579), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80786] = 4,
    ACTIONS(5581), 1,
      anon_sym_COMMA,
    ACTIONS(5583), 1,
      anon_sym_RPAREN,
    STATE(3217), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80800] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5585), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80814] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5587), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80828] = 4,
    ACTIONS(5587), 1,
      anon_sym_RPAREN,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80842] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5591), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80856] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5593), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80870] = 4,
    ACTIONS(5593), 1,
      anon_sym_RPAREN,
    ACTIONS(5595), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80884] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5597), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80898] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5599), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80912] = 4,
    ACTIONS(5601), 1,
      anon_sym_COMMA,
    ACTIONS(5603), 1,
      anon_sym_RPAREN,
    STATE(3192), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80926] = 4,
    ACTIONS(5605), 1,
      anon_sym_COMMA,
    ACTIONS(5607), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80940] = 3,
    ACTIONS(5609), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(987), 2,
      sym_argument_list,
      sym_generator_expression,
  [80952] = 4,
    ACTIONS(2102), 1,
      anon_sym_RBRACK,
    ACTIONS(5611), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80966] = 4,
    ACTIONS(2408), 1,
      anon_sym_RBRACK,
    ACTIONS(5613), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80980] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5607), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [80994] = 4,
    ACTIONS(5509), 1,
      anon_sym_AT,
    ACTIONS(5615), 1,
      sym_identifier,
    STATE(1519), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81008] = 4,
    ACTIONS(5617), 1,
      anon_sym_COMMA,
    ACTIONS(5619), 1,
      anon_sym_RPAREN,
    STATE(3197), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81022] = 4,
    ACTIONS(5621), 1,
      anon_sym_COMMA,
    ACTIONS(5623), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81036] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5623), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81050] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(5625), 1,
      anon_sym_end,
    STATE(4122), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81064] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5627), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81078] = 4,
    ACTIONS(2220), 1,
      anon_sym_RPAREN,
    ACTIONS(5629), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81092] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5631), 1,
      sym_identifier,
    STATE(488), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81106] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5633), 1,
      aux_sym_primitive_definition_token1,
    STATE(4153), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81120] = 4,
    ACTIONS(5635), 1,
      anon_sym_COMMA,
    ACTIONS(5637), 1,
      anon_sym_RPAREN,
    STATE(3221), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81134] = 4,
    ACTIONS(5010), 1,
      anon_sym_COMMA,
    ACTIONS(5639), 1,
      anon_sym_RBRACE,
    STATE(3553), 1,
      aux_sym_type_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81148] = 4,
    ACTIONS(5641), 1,
      anon_sym_COMMA,
    ACTIONS(5643), 1,
      anon_sym_RPAREN,
    STATE(3228), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81162] = 3,
    ACTIONS(5609), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1096), 2,
      sym_argument_list,
      sym_generator_expression,
  [81174] = 4,
    ACTIONS(5645), 1,
      anon_sym_SEMI,
    ACTIONS(5647), 1,
      anon_sym_RBRACK,
    STATE(3223), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81188] = 4,
    ACTIONS(5649), 1,
      anon_sym_COMMA,
    ACTIONS(5651), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81202] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5651), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81216] = 4,
    ACTIONS(2314), 1,
      anon_sym_RPAREN,
    ACTIONS(5653), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81230] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4727), 1,
      anon_sym_end,
    STATE(3930), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81244] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2672), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [81254] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4725), 1,
      anon_sym_end,
    STATE(4146), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81268] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(5655), 1,
      anon_sym_end,
    STATE(4196), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81282] = 4,
    ACTIONS(5657), 1,
      anon_sym_COMMA,
    ACTIONS(5659), 1,
      anon_sym_RPAREN,
    STATE(3240), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81296] = 3,
    ACTIONS(5373), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1945), 2,
      sym_argument_list,
      sym_generator_expression,
  [81308] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(5661), 1,
      anon_sym_end,
    STATE(4257), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81322] = 4,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    ACTIONS(5663), 1,
      sym_identifier,
    STATE(507), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81336] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5665), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81350] = 4,
    ACTIONS(5010), 1,
      anon_sym_COMMA,
    ACTIONS(5012), 1,
      anon_sym_RBRACE,
    STATE(3236), 1,
      aux_sym_type_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81364] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5667), 1,
      anon_sym_end,
    STATE(3774), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81378] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5669), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81392] = 4,
    ACTIONS(5671), 1,
      anon_sym_SEMI,
    ACTIONS(5673), 1,
      anon_sym_RBRACK,
    STATE(3300), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81406] = 4,
    ACTIONS(5675), 1,
      anon_sym_COMMA,
    ACTIONS(5677), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81420] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5677), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81434] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5679), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81448] = 3,
    ACTIONS(5681), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2071), 2,
      sym_argument_list,
      sym_generator_expression,
  [81460] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5683), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81474] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5685), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81488] = 4,
    ACTIONS(5687), 1,
      anon_sym_COMMA,
    ACTIONS(5689), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81502] = 4,
    ACTIONS(5691), 1,
      anon_sym_COMMA,
    ACTIONS(5693), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81516] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5693), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81530] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5695), 1,
      aux_sym_primitive_definition_token1,
    STATE(3771), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81544] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5697), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81558] = 4,
    ACTIONS(5699), 1,
      anon_sym_COMMA,
    ACTIONS(5701), 1,
      anon_sym_RPAREN,
    STATE(3256), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81572] = 4,
    ACTIONS(4474), 1,
      anon_sym_COMMA,
    ACTIONS(5703), 1,
      anon_sym_RPAREN,
    STATE(2917), 1,
      aux_sym_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81586] = 4,
    ACTIONS(5705), 1,
      anon_sym_COMMA,
    ACTIONS(5707), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81600] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5707), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81614] = 4,
    ACTIONS(5709), 1,
      anon_sym_COMMA,
    ACTIONS(5711), 1,
      anon_sym_RPAREN,
    STATE(3263), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81628] = 4,
    ACTIONS(5713), 1,
      anon_sym_COMMA,
    ACTIONS(5715), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81642] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5715), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81656] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4618), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [81666] = 4,
    ACTIONS(2168), 1,
      anon_sym_RPAREN,
    ACTIONS(5717), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81680] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5719), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81694] = 4,
    ACTIONS(5721), 1,
      anon_sym_COMMA,
    ACTIONS(5723), 1,
      anon_sym_RPAREN,
    STATE(3269), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81708] = 4,
    ACTIONS(5725), 1,
      anon_sym_COMMA,
    ACTIONS(5727), 1,
      anon_sym_RPAREN,
    STATE(3272), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81722] = 4,
    ACTIONS(5729), 1,
      anon_sym_COMMA,
    ACTIONS(5731), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81736] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5731), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81750] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(5733), 1,
      anon_sym_end,
    STATE(3910), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81764] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5689), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81778] = 4,
    ACTIONS(5735), 1,
      anon_sym_COMMA,
    ACTIONS(5737), 1,
      anon_sym_RPAREN,
    STATE(3279), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81792] = 4,
    ACTIONS(5739), 1,
      sym_identifier,
    ACTIONS(5741), 1,
      anon_sym_AT,
    STATE(1620), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81806] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5743), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81820] = 4,
    ACTIONS(5745), 1,
      anon_sym_COMMA,
    ACTIONS(5747), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81834] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5749), 1,
      aux_sym_primitive_definition_token1,
    STATE(4183), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81848] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5747), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81862] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5751), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81876] = 4,
    ACTIONS(5753), 1,
      anon_sym_COMMA,
    ACTIONS(5755), 1,
      anon_sym_RPAREN,
    STATE(3262), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81890] = 4,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(5759), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81904] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5759), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81918] = 4,
    ACTIONS(5761), 1,
      sym_identifier,
    ACTIONS(5763), 1,
      anon_sym_AT,
    STATE(2477), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81932] = 4,
    ACTIONS(5765), 1,
      anon_sym_COMMA,
    ACTIONS(5767), 1,
      anon_sym_RPAREN,
    STATE(3286), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81946] = 4,
    ACTIONS(2370), 1,
      anon_sym_RBRACK,
    ACTIONS(5769), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81960] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(5771), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81974] = 4,
    ACTIONS(5773), 1,
      anon_sym_COMMA,
    ACTIONS(5775), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [81988] = 4,
    ACTIONS(2392), 1,
      anon_sym_RBRACK,
    ACTIONS(5777), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82002] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5775), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82016] = 4,
    ACTIONS(2073), 1,
      anon_sym_RBRACK,
    ACTIONS(5779), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82030] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5781), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82044] = 4,
    ACTIONS(5783), 1,
      anon_sym_COMMA,
    ACTIONS(5785), 1,
      anon_sym_RPAREN,
    STATE(3291), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82058] = 4,
    ACTIONS(5787), 1,
      anon_sym_COMMA,
    ACTIONS(5789), 1,
      anon_sym_RPAREN,
    STATE(3297), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82072] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2692), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [82082] = 4,
    ACTIONS(5791), 1,
      anon_sym_COMMA,
    ACTIONS(5793), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82096] = 3,
    ACTIONS(5681), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2074), 2,
      sym_argument_list,
      sym_generator_expression,
  [82108] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5793), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82122] = 4,
    ACTIONS(5795), 1,
      anon_sym_COMMA,
    ACTIONS(5797), 1,
      anon_sym_RPAREN,
    STATE(3326), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82136] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5799), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82150] = 4,
    ACTIONS(5801), 1,
      anon_sym_COMMA,
    ACTIONS(5803), 1,
      anon_sym_RPAREN,
    STATE(3305), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82164] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5805), 1,
      anon_sym_end,
    STATE(4165), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82178] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5807), 1,
      anon_sym_end,
    STATE(3904), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82192] = 4,
    ACTIONS(5809), 1,
      sym_identifier,
    ACTIONS(5811), 1,
      anon_sym_AT,
    STATE(1449), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82206] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5813), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82220] = 4,
    ACTIONS(5813), 1,
      anon_sym_RPAREN,
    ACTIONS(5815), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82234] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2664), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [82244] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5817), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82258] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5819), 1,
      aux_sym_primitive_definition_token1,
    STATE(3917), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82272] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5821), 1,
      aux_sym_primitive_definition_token1,
    STATE(4213), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82286] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2660), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [82296] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5823), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82310] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2602), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_,
  [82320] = 3,
    ACTIONS(5825), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(997), 2,
      sym_argument_list,
      sym_generator_expression,
  [82332] = 4,
    ACTIONS(2108), 1,
      anon_sym_RBRACK,
    ACTIONS(5827), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82346] = 4,
    ACTIONS(2424), 1,
      anon_sym_RBRACK,
    ACTIONS(5829), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82360] = 4,
    ACTIONS(5823), 1,
      anon_sym_RPAREN,
    ACTIONS(5831), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82374] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5833), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82388] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5835), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82402] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2722), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_,
  [82412] = 4,
    ACTIONS(5837), 1,
      anon_sym_COMMA,
    ACTIONS(5839), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82426] = 4,
    ACTIONS(4328), 1,
      anon_sym_RPAREN,
    ACTIONS(5841), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82440] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5839), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82454] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5844), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82468] = 4,
    ACTIONS(2883), 1,
      anon_sym_end,
    ACTIONS(4189), 1,
      sym__assign_operator,
    ACTIONS(5846), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82482] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(5848), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82496] = 4,
    ACTIONS(5741), 1,
      anon_sym_AT,
    ACTIONS(5850), 1,
      sym_identifier,
    STATE(1432), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82510] = 4,
    ACTIONS(5852), 1,
      anon_sym_COMMA,
    ACTIONS(5854), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82524] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5854), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82538] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5856), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82552] = 4,
    ACTIONS(2364), 1,
      anon_sym_RBRACK,
    ACTIONS(5858), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82566] = 4,
    ACTIONS(5860), 1,
      anon_sym_COMMA,
    ACTIONS(5862), 1,
      anon_sym_RPAREN,
    STATE(3330), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82580] = 4,
    ACTIONS(5864), 1,
      anon_sym_COMMA,
    ACTIONS(5866), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82594] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5868), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_,
  [82604] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5866), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82618] = 4,
    ACTIONS(5870), 1,
      anon_sym_COMMA,
    ACTIONS(5872), 1,
      anon_sym_RPAREN,
    STATE(3337), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82632] = 4,
    ACTIONS(2236), 1,
      anon_sym_RPAREN,
    ACTIONS(5874), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82646] = 4,
    ACTIONS(5876), 1,
      anon_sym_COMMA,
    ACTIONS(5878), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82660] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5878), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82674] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5880), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82688] = 4,
    ACTIONS(5882), 1,
      anon_sym_COMMA,
    ACTIONS(5884), 1,
      anon_sym_RPAREN,
    STATE(3342), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82702] = 4,
    ACTIONS(2432), 1,
      anon_sym_RBRACK,
    ACTIONS(5886), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82716] = 4,
    ACTIONS(5888), 1,
      anon_sym_COMMA,
    ACTIONS(5890), 1,
      anon_sym_RPAREN,
    STATE(3347), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82730] = 4,
    ACTIONS(5892), 1,
      anon_sym_COMMA,
    ACTIONS(5894), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82744] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5894), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82758] = 4,
    ACTIONS(5763), 1,
      anon_sym_AT,
    ACTIONS(5896), 1,
      sym_identifier,
    STATE(2547), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82772] = 4,
    ACTIONS(5898), 1,
      anon_sym_COMMA,
    ACTIONS(5900), 1,
      anon_sym_RPAREN,
    STATE(3367), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82786] = 4,
    ACTIONS(2065), 1,
      anon_sym_RBRACK,
    ACTIONS(5902), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82800] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2598), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [82810] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2668), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_,
  [82820] = 3,
    ACTIONS(5517), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1046), 2,
      sym_argument_list,
      sym_generator_expression,
  [82832] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5904), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82846] = 3,
    ACTIONS(5825), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1043), 2,
      sym_argument_list,
      sym_generator_expression,
  [82858] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5906), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82872] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5908), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82886] = 4,
    ACTIONS(5910), 1,
      anon_sym_COMMA,
    ACTIONS(5912), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82900] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5914), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82914] = 4,
    ACTIONS(5914), 1,
      anon_sym_RPAREN,
    ACTIONS(5916), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82928] = 4,
    ACTIONS(5918), 1,
      anon_sym_COMMA,
    ACTIONS(5920), 1,
      anon_sym_RPAREN,
    STATE(3374), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82942] = 4,
    ACTIONS(5922), 1,
      anon_sym_SEMI,
    ACTIONS(5924), 1,
      anon_sym_RBRACK,
    STATE(3324), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82956] = 4,
    ACTIONS(5926), 1,
      anon_sym_COMMA,
    ACTIONS(5928), 1,
      anon_sym_RPAREN,
    STATE(3377), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82970] = 4,
    ACTIONS(5930), 1,
      anon_sym_COMMA,
    ACTIONS(5932), 1,
      anon_sym_RPAREN,
    STATE(3353), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82984] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5934), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [82998] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5936), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83012] = 4,
    ACTIONS(5936), 1,
      anon_sym_RPAREN,
    ACTIONS(5938), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83026] = 4,
    ACTIONS(5940), 1,
      anon_sym_COMMA,
    ACTIONS(5942), 1,
      anon_sym_RPAREN,
    STATE(3381), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83040] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5944), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83054] = 4,
    ACTIONS(5944), 1,
      anon_sym_RPAREN,
    ACTIONS(5946), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83068] = 4,
    ACTIONS(5948), 1,
      anon_sym_COMMA,
    ACTIONS(5950), 1,
      anon_sym_RPAREN,
    STATE(3384), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83082] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5952), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83096] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5954), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83110] = 4,
    ACTIONS(5954), 1,
      anon_sym_RPAREN,
    ACTIONS(5956), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83124] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5958), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83138] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5960), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83152] = 4,
    ACTIONS(5960), 1,
      anon_sym_RPAREN,
    ACTIONS(5962), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83166] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5964), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83180] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5966), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83194] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2722), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83204] = 4,
    ACTIONS(5010), 1,
      anon_sym_COMMA,
    ACTIONS(5044), 1,
      anon_sym_RBRACE,
    STATE(3576), 1,
      aux_sym_type_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83218] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5968), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83232] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(5970), 1,
      anon_sym_end,
    STATE(4251), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83246] = 4,
    ACTIONS(2256), 1,
      anon_sym_RPAREN,
    ACTIONS(5972), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83260] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2718), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83270] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2688), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83280] = 4,
    ACTIONS(5974), 1,
      anon_sym_COMMA,
    ACTIONS(5976), 1,
      anon_sym_RPAREN,
    STATE(3556), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83294] = 3,
    ACTIONS(1675), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5978), 2,
      anon_sym_end,
      anon_sym_elseif,
  [83306] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(4792), 1,
      anon_sym_end,
    STATE(4221), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83320] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5912), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83334] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2594), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83344] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5980), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83358] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5982), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83372] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5984), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83386] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2680), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83396] = 4,
    ACTIONS(5986), 1,
      anon_sym_COMMA,
    ACTIONS(5988), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83410] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2684), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83420] = 4,
    ACTIONS(5990), 1,
      anon_sym_COMMA,
    ACTIONS(5992), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83434] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5992), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83448] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2614), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83458] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5988), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83472] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2618), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83482] = 4,
    ACTIONS(4717), 1,
      anon_sym_end,
    ACTIONS(4721), 1,
      anon_sym_finally,
    STATE(3865), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83496] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5994), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83510] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(5996), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83524] = 4,
    ACTIONS(5998), 1,
      anon_sym_COMMA,
    ACTIONS(6000), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83538] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2588), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83548] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6000), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83562] = 4,
    ACTIONS(6002), 1,
      anon_sym_COMMA,
    ACTIONS(6004), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83576] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6004), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83590] = 4,
    ACTIONS(6006), 1,
      anon_sym_COMMA,
    ACTIONS(6008), 1,
      anon_sym_RPAREN,
    STATE(3405), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83604] = 4,
    ACTIONS(6010), 1,
      anon_sym_COMMA,
    ACTIONS(6012), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83618] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6012), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83632] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6014), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83646] = 4,
    ACTIONS(6016), 1,
      anon_sym_SEMI,
    ACTIONS(6018), 1,
      anon_sym_RBRACK,
    STATE(3466), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83660] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2626), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83670] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2630), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83680] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2634), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83690] = 3,
    ACTIONS(6020), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2884), 2,
      sym_argument_list,
      sym_generator_expression,
  [83702] = 4,
    ACTIONS(6022), 1,
      anon_sym_COMMA,
    ACTIONS(6024), 1,
      anon_sym_RPAREN,
    STATE(3403), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83716] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2638), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83726] = 4,
    ACTIONS(6026), 1,
      anon_sym_COMMA,
    ACTIONS(6028), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83740] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6028), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83754] = 4,
    ACTIONS(6030), 1,
      anon_sym_COMMA,
    ACTIONS(6032), 1,
      anon_sym_RPAREN,
    STATE(3413), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83768] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6034), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83782] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2602), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [83792] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6036), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83806] = 4,
    ACTIONS(6038), 1,
      anon_sym_COMMA,
    ACTIONS(6040), 1,
      anon_sym_RPAREN,
    STATE(3416), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83820] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6042), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83834] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6044), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83848] = 4,
    ACTIONS(6046), 1,
      anon_sym_COMMA,
    ACTIONS(6048), 1,
      anon_sym_RPAREN,
    STATE(3419), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83862] = 4,
    ACTIONS(6050), 1,
      anon_sym_COMMA,
    ACTIONS(6052), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83876] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6052), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83890] = 4,
    ACTIONS(6054), 1,
      anon_sym_COMMA,
    ACTIONS(6056), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83904] = 4,
    ACTIONS(2160), 1,
      anon_sym_RPAREN,
    ACTIONS(6058), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83918] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6060), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83932] = 4,
    ACTIONS(6062), 1,
      anon_sym_COMMA,
    ACTIONS(6064), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83946] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6066), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83960] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6056), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83974] = 4,
    ACTIONS(6068), 1,
      anon_sym_COMMA,
    ACTIONS(6070), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [83988] = 4,
    ACTIONS(4721), 1,
      anon_sym_finally,
    ACTIONS(6072), 1,
      anon_sym_end,
    STATE(3843), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84002] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6070), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84016] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6064), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84030] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6074), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84044] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6076), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84058] = 4,
    ACTIONS(6078), 1,
      anon_sym_COMMA,
    ACTIONS(6080), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84072] = 4,
    ACTIONS(6082), 1,
      anon_sym_COMMA,
    ACTIONS(6084), 1,
      anon_sym_RPAREN,
    STATE(3441), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84086] = 4,
    ACTIONS(6086), 1,
      anon_sym_COMMA,
    ACTIONS(6088), 1,
      anon_sym_RPAREN,
    STATE(3439), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84100] = 4,
    ACTIONS(6090), 1,
      anon_sym_COMMA,
    ACTIONS(6092), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84114] = 4,
    ACTIONS(6094), 1,
      anon_sym_COMMA,
    ACTIONS(6096), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84128] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6092), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84142] = 4,
    ACTIONS(6098), 1,
      sym_identifier,
    ACTIONS(6100), 1,
      anon_sym_AT,
    STATE(1262), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84156] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6102), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84170] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6104), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84184] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6096), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84198] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6106), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84212] = 4,
    ACTIONS(2388), 1,
      anon_sym_RBRACK,
    ACTIONS(6108), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84226] = 4,
    ACTIONS(6110), 1,
      anon_sym_COMMA,
    ACTIONS(6112), 1,
      anon_sym_RPAREN,
    STATE(3444), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84240] = 4,
    ACTIONS(2075), 1,
      anon_sym_RBRACK,
    ACTIONS(6114), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84254] = 4,
    ACTIONS(6116), 1,
      anon_sym_COMMA,
    ACTIONS(6118), 1,
      anon_sym_RPAREN,
    STATE(3447), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84268] = 4,
    ACTIONS(6120), 1,
      anon_sym_COMMA,
    ACTIONS(6122), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84282] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6122), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84296] = 4,
    ACTIONS(6124), 1,
      anon_sym_COMMA,
    ACTIONS(6126), 1,
      anon_sym_RPAREN,
    STATE(3456), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84310] = 4,
    ACTIONS(6128), 1,
      anon_sym_COMMA,
    ACTIONS(6130), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84324] = 3,
    ACTIONS(6020), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2890), 2,
      sym_argument_list,
      sym_generator_expression,
  [84336] = 4,
    ACTIONS(6132), 1,
      anon_sym_COMMA,
    ACTIONS(6134), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84350] = 4,
    ACTIONS(6136), 1,
      anon_sym_COMMA,
    ACTIONS(6138), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84364] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6130), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84378] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6134), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84392] = 4,
    ACTIONS(6140), 1,
      anon_sym_COMMA,
    ACTIONS(6143), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84406] = 4,
    ACTIONS(4735), 1,
      anon_sym_LT_COLON,
    ACTIONS(6145), 1,
      anon_sym_end,
    STATE(3806), 1,
      sym_subtype_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84420] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6147), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84434] = 4,
    ACTIONS(6149), 1,
      anon_sym_COMMA,
    ACTIONS(6151), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84448] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6151), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84462] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6153), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84476] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6080), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84490] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6155), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84504] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6157), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84518] = 4,
    ACTIONS(6159), 1,
      anon_sym_COMMA,
    ACTIONS(6161), 1,
      anon_sym_RPAREN,
    STATE(3473), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84532] = 4,
    ACTIONS(6163), 1,
      anon_sym_COMMA,
    ACTIONS(6165), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84546] = 4,
    ACTIONS(6167), 1,
      anon_sym_COMMA,
    ACTIONS(6169), 1,
      anon_sym_RPAREN,
    STATE(3457), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84560] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6138), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84574] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6165), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84588] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6171), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84602] = 4,
    ACTIONS(6173), 1,
      anon_sym_COMMA,
    ACTIONS(6175), 1,
      anon_sym_RPAREN,
    STATE(3480), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84616] = 4,
    ACTIONS(6177), 1,
      anon_sym_COMMA,
    ACTIONS(6179), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84630] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6179), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84644] = 4,
    ACTIONS(6181), 1,
      anon_sym_COMMA,
    ACTIONS(6183), 1,
      anon_sym_RPAREN,
    STATE(3468), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84658] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6185), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84672] = 4,
    ACTIONS(6187), 1,
      anon_sym_COMMA,
    ACTIONS(6189), 1,
      anon_sym_RPAREN,
    STATE(3487), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84686] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6191), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84700] = 4,
    ACTIONS(6193), 1,
      anon_sym_COMMA,
    ACTIONS(6195), 1,
      anon_sym_RPAREN,
    STATE(3471), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84714] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6197), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [84724] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(6199), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84738] = 4,
    ACTIONS(6201), 1,
      anon_sym_COMMA,
    ACTIONS(6203), 1,
      anon_sym_RPAREN,
    STATE(3429), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84752] = 4,
    ACTIONS(6205), 1,
      anon_sym_COMMA,
    ACTIONS(6207), 1,
      anon_sym_RPAREN,
    STATE(3474), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84766] = 4,
    ACTIONS(6209), 1,
      anon_sym_COMMA,
    ACTIONS(6211), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84780] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6211), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84794] = 4,
    ACTIONS(2372), 1,
      anon_sym_RBRACK,
    ACTIONS(6213), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84808] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(6215), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84822] = 4,
    ACTIONS(6217), 1,
      anon_sym_COMMA,
    ACTIONS(6219), 1,
      anon_sym_RPAREN,
    STATE(3493), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84836] = 4,
    ACTIONS(6221), 1,
      anon_sym_COMMA,
    ACTIONS(6223), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84850] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6223), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84864] = 4,
    ACTIONS(6225), 1,
      anon_sym_COMMA,
    ACTIONS(6227), 1,
      anon_sym_RPAREN,
    STATE(3453), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84878] = 4,
    ACTIONS(4324), 1,
      anon_sym_RBRACK,
    ACTIONS(6229), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84892] = 4,
    ACTIONS(6157), 1,
      anon_sym_RPAREN,
    ACTIONS(6232), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84906] = 4,
    ACTIONS(6234), 1,
      anon_sym_COMMA,
    ACTIONS(6236), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84920] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6236), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84934] = 4,
    ACTIONS(6238), 1,
      anon_sym_COMMA,
    ACTIONS(6240), 1,
      anon_sym_RPAREN,
    STATE(3509), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84948] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6242), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84962] = 4,
    ACTIONS(6244), 1,
      anon_sym_COMMA,
    ACTIONS(6246), 1,
      anon_sym_RPAREN,
    STATE(3504), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84976] = 4,
    ACTIONS(5811), 1,
      anon_sym_AT,
    ACTIONS(6248), 1,
      sym_identifier,
    STATE(1882), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [84990] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6250), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85004] = 4,
    ACTIONS(6100), 1,
      anon_sym_AT,
    ACTIONS(6252), 1,
      sym_identifier,
    STATE(1422), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85018] = 4,
    ACTIONS(6254), 1,
      anon_sym_COMMA,
    ACTIONS(6256), 1,
      anon_sym_RPAREN,
    STATE(3533), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85032] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6258), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85046] = 4,
    ACTIONS(5433), 1,
      anon_sym_AT,
    ACTIONS(6260), 1,
      sym_identifier,
    STATE(2108), 1,
      sym_macro_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85060] = 3,
    ACTIONS(6264), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6262), 2,
      anon_sym_end,
      anon_sym_elseif,
  [85072] = 4,
    ACTIONS(6266), 1,
      anon_sym_COMMA,
    ACTIONS(6268), 1,
      anon_sym_RPAREN,
    STATE(3514), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85086] = 4,
    ACTIONS(6270), 1,
      anon_sym_COMMA,
    ACTIONS(6272), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85100] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6272), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85114] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6274), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85128] = 4,
    ACTIONS(6276), 1,
      anon_sym_COMMA,
    ACTIONS(6278), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85142] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6278), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85156] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6280), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85170] = 4,
    ACTIONS(6280), 1,
      anon_sym_RPAREN,
    ACTIONS(6282), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85184] = 4,
    ACTIONS(6284), 1,
      anon_sym_COMMA,
    ACTIONS(6286), 1,
      anon_sym_RPAREN,
    STATE(3540), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85198] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6288), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85212] = 4,
    ACTIONS(6290), 1,
      anon_sym_COMMA,
    ACTIONS(6292), 1,
      anon_sym_RPAREN,
    STATE(3543), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85226] = 4,
    ACTIONS(6294), 1,
      anon_sym_COMMA,
    ACTIONS(6296), 1,
      anon_sym_RPAREN,
    STATE(3527), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85240] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6298), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85254] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6300), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85268] = 4,
    ACTIONS(6300), 1,
      anon_sym_RPAREN,
    ACTIONS(6302), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85282] = 4,
    ACTIONS(6304), 1,
      anon_sym_COMMA,
    ACTIONS(6306), 1,
      anon_sym_RPAREN,
    STATE(3547), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85296] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6308), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85310] = 4,
    ACTIONS(6308), 1,
      anon_sym_RPAREN,
    ACTIONS(6310), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85324] = 4,
    ACTIONS(6312), 1,
      anon_sym_COMMA,
    ACTIONS(6314), 1,
      anon_sym_RPAREN,
    STATE(3550), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85338] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6316), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85352] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6318), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85366] = 4,
    ACTIONS(6318), 1,
      anon_sym_RPAREN,
    ACTIONS(6320), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85380] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6322), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85394] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6324), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85408] = 4,
    ACTIONS(6324), 1,
      anon_sym_RPAREN,
    ACTIONS(6326), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85422] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6328), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85436] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6330), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85450] = 4,
    ACTIONS(6332), 1,
      anon_sym_COMMA,
    ACTIONS(6335), 1,
      anon_sym_RBRACE,
    STATE(3553), 1,
      aux_sym_type_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85464] = 4,
    ACTIONS(2382), 1,
      anon_sym_RBRACK,
    ACTIONS(6337), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85478] = 4,
    ACTIONS(4330), 1,
      anon_sym_RBRACE,
    ACTIONS(6339), 1,
      anon_sym_COMMA,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85492] = 4,
    ACTIONS(6242), 1,
      anon_sym_RPAREN,
    ACTIONS(6342), 1,
      anon_sym_COMMA,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85506] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2668), 3,
      sym__immediate_paren,
      anon_sym_DOT,
      anon_sym_LBRACK,
  [85516] = 4,
    ACTIONS(6344), 1,
      anon_sym_COMMA,
    ACTIONS(6346), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85530] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6346), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85544] = 4,
    ACTIONS(6348), 1,
      anon_sym_COMMA,
    ACTIONS(6350), 1,
      anon_sym_RPAREN,
    STATE(3530), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85558] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(6352), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85572] = 4,
    ACTIONS(6354), 1,
      anon_sym_COMMA,
    ACTIONS(6356), 1,
      anon_sym_RPAREN,
    STATE(3477), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85586] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6356), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85600] = 4,
    ACTIONS(4265), 1,
      anon_sym_COMMA,
    ACTIONS(6358), 1,
      anon_sym_RBRACE,
    STATE(3555), 1,
      aux_sym_type_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85614] = 4,
    ACTIONS(6360), 1,
      anon_sym_SEMI,
    ACTIONS(6362), 1,
      anon_sym_RBRACK,
    STATE(3577), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85628] = 3,
    ACTIONS(6364), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(881), 2,
      sym_argument_list,
      sym_generator_expression,
  [85640] = 4,
    ACTIONS(6366), 1,
      anon_sym_COMMA,
    ACTIONS(6368), 1,
      anon_sym_RPAREN,
    STATE(3562), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85654] = 3,
    ACTIONS(5014), 1,
      anon_sym_LT_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6335), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [85666] = 4,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(6370), 1,
      anon_sym_RPAREN,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85680] = 4,
    ACTIONS(6372), 1,
      anon_sym_COMMA,
    ACTIONS(6374), 1,
      anon_sym_RPAREN,
    STATE(3513), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85694] = 4,
    ACTIONS(2266), 1,
      anon_sym_RPAREN,
    ACTIONS(6376), 1,
      anon_sym_COMMA,
    STATE(3331), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85708] = 4,
    ACTIONS(2426), 1,
      anon_sym_RBRACK,
    ACTIONS(6378), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85722] = 3,
    ACTIONS(6364), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(884), 2,
      sym_argument_list,
      sym_generator_expression,
  [85734] = 4,
    ACTIONS(6380), 1,
      anon_sym_COMMA,
    ACTIONS(6382), 1,
      anon_sym_RPAREN,
    STATE(3558), 1,
      aux_sym_argument_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85748] = 4,
    ACTIONS(2390), 1,
      anon_sym_RBRACK,
    ACTIONS(6384), 1,
      anon_sym_COMMA,
    STATE(3512), 1,
      aux_sym_subscript_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85762] = 4,
    ACTIONS(5010), 1,
      anon_sym_COMMA,
    ACTIONS(6386), 1,
      anon_sym_RBRACE,
    STATE(3553), 1,
      aux_sym_type_parameter_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85776] = 4,
    ACTIONS(2098), 1,
      anon_sym_RBRACK,
    ACTIONS(6388), 1,
      anon_sym_SEMI,
    STATE(3097), 1,
      aux_sym_matrix_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85790] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3169), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85801] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3175), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85812] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3499), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85823] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3488), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85834] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3184), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85845] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3142), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85856] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3220), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85867] = 3,
    ACTIONS(6390), 1,
      sym_identifier,
    ACTIONS(6392), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85878] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6335), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [85887] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3227), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85898] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3235), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85909] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3137), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85920] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3508), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85931] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3237), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85942] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3247), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85953] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3290), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85964] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3099), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85975] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3095), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85986] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3294), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [85997] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3083), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86008] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3302), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86019] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3308), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86030] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5315), 2,
      anon_sym_SEMI,
      anon_sym_RBRACK,
  [86039] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3303), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86050] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3310), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86061] = 3,
    ACTIONS(3268), 1,
      sym__assign_operator,
    ACTIONS(6394), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86072] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3109), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86083] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3394), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86094] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3465), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86105] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6396), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [86114] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3607), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86125] = 3,
    ACTIONS(6398), 1,
      sym_identifier,
    STATE(1315), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86136] = 3,
    ACTIONS(6400), 1,
      sym_identifier,
    STATE(2176), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86147] = 3,
    ACTIONS(6402), 1,
      anon_sym_LPAREN,
    STATE(1307), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86158] = 3,
    ACTIONS(6404), 1,
      sym_identifier,
    ACTIONS(6406), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86169] = 3,
    ACTIONS(4124), 1,
      sym__assign_operator,
    ACTIONS(6408), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86180] = 3,
    ACTIONS(6410), 1,
      sym_identifier,
    STATE(2429), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86191] = 3,
    ACTIONS(6412), 1,
      sym_identifier,
    STATE(2176), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86202] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3455), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86213] = 3,
    ACTIONS(6414), 1,
      sym_identifier,
    STATE(1468), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86224] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3341), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86235] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3345), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86246] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3350), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86257] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6416), 2,
      anon_sym_end,
      anon_sym_finally,
  [86266] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3352), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86277] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3567), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86288] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3574), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86299] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3560), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86310] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3537), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86321] = 3,
    ACTIONS(6398), 1,
      sym_identifier,
    STATE(1235), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86332] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3516), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86343] = 3,
    ACTIONS(6418), 1,
      sym_identifier,
    STATE(1439), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86354] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3371), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86365] = 3,
    ACTIONS(3948), 1,
      sym__assign_operator,
    ACTIONS(6420), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86376] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3497), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86387] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(122), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86398] = 3,
    ACTIONS(6424), 1,
      anon_sym_COMMA,
    STATE(3391), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86409] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3431), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86420] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6426), 2,
      anon_sym_end,
      anon_sym_finally,
  [86429] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3492), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86440] = 3,
    ACTIONS(6428), 1,
      sym_identifier,
    ACTIONS(6430), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86451] = 3,
    ACTIONS(6418), 1,
      sym_identifier,
    STATE(1769), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86462] = 3,
    ACTIONS(6432), 1,
      anon_sym_LPAREN,
    STATE(1717), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86473] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3502), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86484] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(134), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86495] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3511), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86506] = 3,
    ACTIONS(6400), 1,
      sym_identifier,
    STATE(2168), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86517] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3486), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86528] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(6434), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [86539] = 3,
    ACTIONS(6412), 1,
      sym_identifier,
    STATE(2624), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86550] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3526), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86561] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(318), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86572] = 3,
    ACTIONS(6436), 1,
      anon_sym_COMMA,
    STATE(3242), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86583] = 3,
    ACTIONS(3344), 1,
      sym__assign_operator,
    ACTIONS(6438), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86594] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3427), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86605] = 3,
    ACTIONS(6440), 1,
      anon_sym_COMMA,
    STATE(3571), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86616] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3544), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86627] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3541), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86638] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3536), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86649] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3534), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86660] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(3528), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [86671] = 3,
    ACTIONS(6442), 1,
      sym_identifier,
    STATE(3388), 1,
      sym_constrained_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86682] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(297), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86693] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3570), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86704] = 3,
    ACTIONS(3286), 1,
      sym__assign_operator,
    ACTIONS(6444), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86715] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3454), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86726] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3522), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86737] = 3,
    ACTIONS(6414), 1,
      sym_identifier,
    STATE(1605), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86748] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3438), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86759] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3518), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86770] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4328), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [86779] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3503), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86790] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3495), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86801] = 3,
    ACTIONS(3867), 1,
      sym__assign_operator,
    ACTIONS(6446), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86812] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3435), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86823] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(237), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86834] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3418), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86845] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3470), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86856] = 3,
    ACTIONS(6448), 1,
      sym_identifier,
    STATE(2583), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86867] = 3,
    ACTIONS(6450), 1,
      anon_sym_COMMA,
    STATE(3442), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86878] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(207), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86889] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(6452), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [86900] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(120), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86911] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3467), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86922] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3378), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86933] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3375), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86944] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3370), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86955] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3368), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86966] = 3,
    ACTIONS(6454), 1,
      sym_identifier,
    ACTIONS(6456), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86977] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3356), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86988] = 3,
    ACTIONS(3307), 1,
      sym__assign_operator,
    ACTIONS(6458), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [86999] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(200), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87010] = 3,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    STATE(3275), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87021] = 3,
    ACTIONS(6462), 1,
      anon_sym_LPAREN,
    STATE(2589), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87032] = 3,
    ACTIONS(6464), 1,
      sym_identifier,
    ACTIONS(6466), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87043] = 3,
    ACTIONS(6468), 1,
      sym_identifier,
    STATE(1846), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87054] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3064), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87065] = 3,
    ACTIONS(6468), 1,
      sym_identifier,
    STATE(1500), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87076] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(299), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87087] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(6470), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [87098] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3211), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87109] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3208), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87120] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3203), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87131] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3201), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87142] = 3,
    ACTIONS(6472), 1,
      sym_identifier,
    ACTIONS(6474), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87153] = 3,
    ACTIONS(6476), 1,
      anon_sym_LPAREN,
    STATE(1641), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87164] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3189), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87175] = 3,
    ACTIONS(2873), 1,
      sym__assign_operator,
    ACTIONS(6478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87186] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(246), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87197] = 3,
    ACTIONS(6480), 1,
      anon_sym_COMMA,
    STATE(3108), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87208] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(199), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87219] = 3,
    ACTIONS(6448), 1,
      sym_identifier,
    STATE(2478), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87230] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(6482), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [87241] = 3,
    ACTIONS(6484), 1,
      anon_sym_COMMA,
    STATE(3117), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87252] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(124), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87263] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3072), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87274] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3069), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87285] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3098), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87296] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3096), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87307] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3087), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87318] = 3,
    ACTIONS(3939), 1,
      sym__assign_operator,
    ACTIONS(6486), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87329] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(220), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87340] = 3,
    ACTIONS(6488), 1,
      anon_sym_COMMA,
    STATE(3124), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87351] = 3,
    ACTIONS(3824), 1,
      sym__assign_operator,
    ACTIONS(6490), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87362] = 3,
    ACTIONS(6492), 1,
      anon_sym_LPAREN,
    STATE(1807), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87373] = 3,
    ACTIONS(6494), 1,
      sym_identifier,
    ACTIONS(6496), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87384] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(201), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87395] = 3,
    ACTIONS(6498), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_constrained_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87406] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(6500), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [87417] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(158), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87428] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3161), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87439] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3164), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87450] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3118), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87461] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3170), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87472] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3179), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87483] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(106), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87494] = 3,
    ACTIONS(6410), 1,
      sym_identifier,
    STATE(2282), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87505] = 3,
    ACTIONS(3417), 1,
      sym__assign_operator,
    ACTIONS(6502), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87516] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(1933), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87527] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(263), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87538] = 3,
    ACTIONS(6504), 1,
      anon_sym_COMMA,
    STATE(3232), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87549] = 3,
    ACTIONS(6506), 1,
      sym_identifier,
    STATE(1021), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87560] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(282), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87571] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(6508), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [87582] = 3,
    ACTIONS(6510), 1,
      sym_identifier,
    ACTIONS(6512), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87593] = 3,
    ACTIONS(6514), 1,
      anon_sym_LPAREN,
    STATE(2334), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87604] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(103), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87615] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6516), 2,
      anon_sym_end,
      anon_sym_finally,
  [87624] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(219), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87635] = 3,
    ACTIONS(6518), 1,
      sym_identifier,
    ACTIONS(6520), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87646] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3267), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87657] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3277), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87668] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3278), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87679] = 3,
    ACTIONS(6522), 1,
      anon_sym_LPAREN,
    STATE(2184), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87690] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3283), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87701] = 3,
    ACTIONS(3297), 1,
      sym__assign_operator,
    ACTIONS(6524), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87712] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(289), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87723] = 3,
    ACTIONS(6526), 1,
      sym_identifier,
    ACTIONS(6528), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87734] = 3,
    ACTIONS(4326), 1,
      anon_sym_COMMA,
    STATE(3346), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87745] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(275), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87756] = 3,
    ACTIONS(6530), 1,
      sym_identifier,
    STATE(3252), 1,
      sym_constrained_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87767] = 3,
    ACTIONS(5228), 1,
      sym_identifier,
    STATE(3271), 1,
      sym_named_field,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87778] = 3,
    ACTIONS(4189), 1,
      sym__assign_operator,
    ACTIONS(5846), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87789] = 3,
    ACTIONS(6532), 1,
      anon_sym_LPAREN,
    STATE(956), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87800] = 3,
    ACTIONS(6506), 1,
      sym_identifier,
    STATE(933), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87811] = 3,
    ACTIONS(6534), 1,
      sym_identifier,
    ACTIONS(6536), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87822] = 3,
    ACTIONS(6422), 1,
      sym_identifier,
    STATE(160), 1,
      sym_variable_declaration,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87833] = 3,
    ACTIONS(4869), 1,
      anon_sym_LPAREN,
    STATE(300), 1,
      sym_parameter_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87844] = 3,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(115), 1,
      sym_line_comment,
    ACTIONS(6538), 2,
      sym_escape_sequence,
      aux_sym_character_literal_token1,
  [87855] = 2,
    ACTIONS(4658), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87863] = 2,
    ACTIONS(4233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87871] = 2,
    ACTIONS(6540), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87879] = 2,
    ACTIONS(6542), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87887] = 2,
    ACTIONS(6544), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87895] = 2,
    ACTIONS(6546), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87903] = 2,
    ACTIONS(4120), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87911] = 2,
    ACTIONS(6548), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87919] = 2,
    ACTIONS(2474), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87927] = 2,
    ACTIONS(6550), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87935] = 2,
    ACTIONS(4073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87943] = 2,
    ACTIONS(6552), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87951] = 2,
    ACTIONS(6554), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87959] = 2,
    ACTIONS(6556), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87967] = 2,
    ACTIONS(4239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87975] = 2,
    ACTIONS(6558), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87983] = 2,
    ACTIONS(6560), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87991] = 2,
    ACTIONS(6562), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [87999] = 2,
    ACTIONS(6564), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88007] = 2,
    ACTIONS(6566), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88015] = 2,
    ACTIONS(4085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88023] = 2,
    ACTIONS(6568), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88031] = 2,
    ACTIONS(6570), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88039] = 2,
    ACTIONS(3781), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88047] = 2,
    ACTIONS(6572), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88055] = 2,
    ACTIONS(4600), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88063] = 2,
    ACTIONS(6574), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88071] = 2,
    ACTIONS(4221), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88079] = 2,
    ACTIONS(6576), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88087] = 2,
    ACTIONS(4091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88095] = 2,
    ACTIONS(6578), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88103] = 2,
    ACTIONS(6580), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88111] = 2,
    ACTIONS(6582), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88119] = 2,
    ACTIONS(6584), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88127] = 2,
    ACTIONS(2869), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88135] = 2,
    ACTIONS(6586), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88143] = 2,
    ACTIONS(6588), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88151] = 2,
    ACTIONS(6590), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88159] = 2,
    ACTIONS(4108), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88167] = 2,
    ACTIONS(6592), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88175] = 2,
    ACTIONS(4279), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88183] = 2,
    ACTIONS(6594), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88191] = 2,
    ACTIONS(6596), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88199] = 2,
    ACTIONS(6598), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88207] = 2,
    ACTIONS(6362), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88215] = 2,
    ACTIONS(3569), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88223] = 2,
    ACTIONS(6600), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88231] = 2,
    ACTIONS(6602), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88239] = 2,
    ACTIONS(3693), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88247] = 2,
    ACTIONS(6604), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88255] = 2,
    ACTIONS(6606), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88263] = 2,
    ACTIONS(6608), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88271] = 2,
    ACTIONS(6610), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88279] = 2,
    ACTIONS(6612), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88287] = 2,
    ACTIONS(6614), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88295] = 2,
    ACTIONS(6616), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88303] = 2,
    ACTIONS(3657), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88311] = 2,
    ACTIONS(6618), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88319] = 2,
    ACTIONS(6620), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88327] = 2,
    ACTIONS(6622), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88335] = 2,
    ACTIONS(4063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88343] = 2,
    ACTIONS(6624), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88351] = 2,
    ACTIONS(6626), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88359] = 2,
    ACTIONS(4616), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88367] = 2,
    ACTIONS(6628), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88375] = 2,
    ACTIONS(6630), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88383] = 2,
    ACTIONS(6632), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88391] = 2,
    ACTIONS(6634), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88399] = 2,
    ACTIONS(6636), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88407] = 2,
    ACTIONS(6638), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88415] = 2,
    ACTIONS(6640), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88423] = 2,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88431] = 2,
    ACTIONS(6642), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88439] = 2,
    ACTIONS(6644), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88447] = 2,
    ACTIONS(6646), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88455] = 2,
    ACTIONS(6648), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88463] = 2,
    ACTIONS(6650), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88471] = 2,
    ACTIONS(6652), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88479] = 2,
    ACTIONS(4636), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88487] = 2,
    ACTIONS(6654), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88495] = 2,
    ACTIONS(6656), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88503] = 2,
    ACTIONS(6658), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88511] = 2,
    ACTIONS(6660), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88519] = 2,
    ACTIONS(6662), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88527] = 2,
    ACTIONS(6664), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88535] = 2,
    ACTIONS(6666), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88543] = 2,
    ACTIONS(4259), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88551] = 2,
    ACTIONS(6668), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88559] = 2,
    ACTIONS(6670), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88567] = 2,
    ACTIONS(6672), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88575] = 2,
    ACTIONS(6674), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88583] = 2,
    ACTIONS(4215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88591] = 2,
    ACTIONS(6676), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88599] = 2,
    ACTIONS(6678), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88607] = 2,
    ACTIONS(6680), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88615] = 2,
    ACTIONS(6682), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88623] = 2,
    ACTIONS(6684), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88631] = 2,
    ACTIONS(6686), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88639] = 2,
    ACTIONS(6072), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88647] = 2,
    ACTIONS(4638), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88655] = 2,
    ACTIONS(6688), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88663] = 2,
    ACTIONS(6690), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88671] = 2,
    ACTIONS(6692), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88679] = 2,
    ACTIONS(6694), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88687] = 2,
    ACTIONS(6696), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88695] = 2,
    ACTIONS(4203), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88703] = 2,
    ACTIONS(6018), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88711] = 2,
    ACTIONS(3577), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88719] = 2,
    ACTIONS(6698), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88727] = 2,
    ACTIONS(6700), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88735] = 2,
    ACTIONS(6702), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88743] = 2,
    ACTIONS(6704), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88751] = 2,
    ACTIONS(4717), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88759] = 2,
    ACTIONS(6706), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88767] = 2,
    ACTIONS(6708), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88775] = 2,
    ACTIONS(6710), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88783] = 2,
    ACTIONS(6712), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88791] = 2,
    ACTIONS(6714), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88799] = 2,
    ACTIONS(6716), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88807] = 2,
    ACTIONS(6718), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88815] = 2,
    ACTIONS(6720), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88823] = 2,
    ACTIONS(6722), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88831] = 2,
    ACTIONS(6724), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88839] = 2,
    ACTIONS(6726), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88847] = 2,
    ACTIONS(6728), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88855] = 2,
    ACTIONS(6730), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88863] = 2,
    ACTIONS(6732), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88871] = 2,
    ACTIONS(4701), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88879] = 2,
    ACTIONS(6734), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88887] = 2,
    ACTIONS(6736), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88895] = 2,
    ACTIONS(6738), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88903] = 2,
    ACTIONS(6740), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88911] = 2,
    ACTIONS(6742), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88919] = 2,
    ACTIONS(6744), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88927] = 2,
    ACTIONS(4684), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88935] = 2,
    ACTIONS(6746), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88943] = 2,
    ACTIONS(6748), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88951] = 2,
    ACTIONS(6750), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88959] = 2,
    ACTIONS(6752), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88967] = 2,
    ACTIONS(4079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88975] = 2,
    ACTIONS(6754), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88983] = 2,
    ACTIONS(6756), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88991] = 2,
    ACTIONS(6758), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [88999] = 2,
    ACTIONS(6760), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89007] = 2,
    ACTIONS(6762), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89015] = 2,
    ACTIONS(6764), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89023] = 2,
    ACTIONS(6766), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89031] = 2,
    ACTIONS(6768), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89039] = 2,
    ACTIONS(6770), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89047] = 2,
    ACTIONS(6772), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89055] = 2,
    ACTIONS(6774), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89063] = 2,
    ACTIONS(6776), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89071] = 2,
    ACTIONS(6778), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89079] = 2,
    ACTIONS(6780), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89087] = 2,
    ACTIONS(4263), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89095] = 2,
    ACTIONS(6782), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89103] = 2,
    ACTIONS(6784), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89111] = 2,
    ACTIONS(6786), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89119] = 2,
    ACTIONS(6788), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89127] = 2,
    ACTIONS(3661), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89135] = 2,
    ACTIONS(6790), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89143] = 2,
    ACTIONS(6792), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89151] = 2,
    ACTIONS(6794), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89159] = 2,
    ACTIONS(5733), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89167] = 2,
    ACTIONS(4624), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89175] = 2,
    ACTIONS(6796), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89183] = 2,
    ACTIONS(6798), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89191] = 2,
    ACTIONS(6800), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89199] = 2,
    ACTIONS(6802), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89207] = 2,
    ACTIONS(6804), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89215] = 2,
    ACTIONS(6806), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89223] = 2,
    ACTIONS(6808), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89231] = 2,
    ACTIONS(5673), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89239] = 2,
    ACTIONS(6810), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89247] = 2,
    ACTIONS(6812), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89255] = 2,
    ACTIONS(4199), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89263] = 2,
    ACTIONS(6814), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89271] = 2,
    ACTIONS(6816), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89279] = 2,
    ACTIONS(3561), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89287] = 2,
    ACTIONS(6818), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89295] = 2,
    ACTIONS(6820), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89303] = 2,
    ACTIONS(4310), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89311] = 2,
    ACTIONS(6822), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89319] = 2,
    ACTIONS(6824), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89327] = 2,
    ACTIONS(4727), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89335] = 2,
    ACTIONS(6826), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89343] = 2,
    ACTIONS(6828), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89351] = 2,
    ACTIONS(6830), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89359] = 2,
    ACTIONS(6832), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89367] = 2,
    ACTIONS(6834), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89375] = 2,
    ACTIONS(6836), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89383] = 2,
    ACTIONS(6838), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89391] = 2,
    ACTIONS(6840), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89399] = 2,
    ACTIONS(6842), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89407] = 2,
    ACTIONS(6844), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89415] = 2,
    ACTIONS(6846), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89423] = 2,
    ACTIONS(4676), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89431] = 2,
    ACTIONS(6848), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89439] = 2,
    ACTIONS(6850), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89447] = 2,
    ACTIONS(5499), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89455] = 2,
    ACTIONS(5501), 1,
      sym__immediate_paren,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89463] = 2,
    ACTIONS(6852), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89471] = 2,
    ACTIONS(6854), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89479] = 2,
    ACTIONS(6856), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89487] = 2,
    ACTIONS(6858), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89495] = 2,
    ACTIONS(6860), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89503] = 2,
    ACTIONS(4209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89511] = 2,
    ACTIONS(6862), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89519] = 2,
    ACTIONS(6864), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89527] = 2,
    ACTIONS(6866), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89535] = 2,
    ACTIONS(6868), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89543] = 2,
    ACTIONS(6870), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89551] = 2,
    ACTIONS(4660), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89559] = 2,
    ACTIONS(6872), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89567] = 2,
    ACTIONS(6874), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89575] = 2,
    ACTIONS(6876), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89583] = 2,
    ACTIONS(6878), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89591] = 2,
    ACTIONS(6880), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89599] = 2,
    ACTIONS(6882), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89607] = 2,
    ACTIONS(6884), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89615] = 2,
    ACTIONS(6886), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89623] = 2,
    ACTIONS(6888), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89631] = 2,
    ACTIONS(6890), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89639] = 2,
    ACTIONS(6892), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89647] = 2,
    ACTIONS(6894), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89655] = 2,
    ACTIONS(6896), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89663] = 2,
    ACTIONS(4275), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89671] = 2,
    ACTIONS(5385), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89679] = 2,
    ACTIONS(6898), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89687] = 2,
    ACTIONS(6900), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89695] = 2,
    ACTIONS(6902), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89703] = 2,
    ACTIONS(4055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89711] = 2,
    ACTIONS(4634), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89719] = 2,
    ACTIONS(6904), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89727] = 2,
    ACTIONS(6906), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89735] = 2,
    ACTIONS(6908), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89743] = 2,
    ACTIONS(6910), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89751] = 2,
    ACTIONS(5353), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89759] = 2,
    ACTIONS(4608), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89767] = 2,
    ACTIONS(4759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89775] = 2,
    ACTIONS(6912), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89783] = 2,
    ACTIONS(3665), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89791] = 2,
    ACTIONS(6914), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89799] = 2,
    ACTIONS(6916), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89807] = 2,
    ACTIONS(4191), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89815] = 2,
    ACTIONS(5290), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89823] = 2,
    ACTIONS(3573), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89831] = 2,
    ACTIONS(6918), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89839] = 2,
    ACTIONS(6920), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89847] = 2,
    ACTIONS(6922), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89855] = 2,
    ACTIONS(6924), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89863] = 2,
    ACTIONS(4723), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89871] = 2,
    ACTIONS(6926), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89879] = 2,
    ACTIONS(6928), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89887] = 2,
    ACTIONS(3669), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89895] = 2,
    ACTIONS(6930), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89903] = 2,
    ACTIONS(6932), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89911] = 2,
    ACTIONS(6934), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89919] = 2,
    ACTIONS(6936), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89927] = 2,
    ACTIONS(6938), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89935] = 2,
    ACTIONS(6940), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89943] = 2,
    ACTIONS(6942), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89951] = 2,
    ACTIONS(6944), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89959] = 2,
    ACTIONS(6946), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89967] = 2,
    ACTIONS(6948), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89975] = 2,
    ACTIONS(4558), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89983] = 2,
    ACTIONS(6950), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89991] = 2,
    ACTIONS(6952), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [89999] = 2,
    ACTIONS(6954), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90007] = 2,
    ACTIONS(6956), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90015] = 2,
    ACTIONS(4195), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90023] = 2,
    ACTIONS(6958), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90031] = 2,
    ACTIONS(6960), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90039] = 2,
    ACTIONS(6962), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90047] = 2,
    ACTIONS(6964), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90055] = 2,
    ACTIONS(6966), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90063] = 2,
    ACTIONS(6968), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90071] = 2,
    ACTIONS(6970), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90079] = 2,
    ACTIONS(6972), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90087] = 2,
    ACTIONS(6974), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90095] = 2,
    ACTIONS(6976), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90103] = 2,
    ACTIONS(6978), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90111] = 2,
    ACTIONS(6980), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90119] = 2,
    ACTIONS(6982), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90127] = 2,
    ACTIONS(4574), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90135] = 2,
    ACTIONS(6984), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90143] = 2,
    ACTIONS(6986), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90151] = 2,
    ACTIONS(6988), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90159] = 2,
    ACTIONS(6990), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90167] = 2,
    ACTIONS(6992), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90175] = 2,
    ACTIONS(6994), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90183] = 2,
    ACTIONS(6996), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90191] = 2,
    ACTIONS(6998), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90199] = 2,
    ACTIONS(7000), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90207] = 2,
    ACTIONS(4304), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90215] = 2,
    ACTIONS(7002), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90223] = 2,
    ACTIONS(7004), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90231] = 2,
    ACTIONS(7006), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90239] = 2,
    ACTIONS(7008), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90247] = 2,
    ACTIONS(7010), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90255] = 2,
    ACTIONS(7012), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90263] = 2,
    ACTIONS(7014), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90271] = 2,
    ACTIONS(7016), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90279] = 2,
    ACTIONS(5375), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90287] = 2,
    ACTIONS(4622), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90295] = 2,
    ACTIONS(7018), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90303] = 2,
    ACTIONS(7020), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90311] = 2,
    ACTIONS(7022), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90319] = 2,
    ACTIONS(4201), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90327] = 2,
    ACTIONS(5399), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90335] = 2,
    ACTIONS(3565), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90343] = 2,
    ACTIONS(7024), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90351] = 2,
    ACTIONS(7026), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90359] = 2,
    ACTIONS(7028), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90367] = 2,
    ACTIONS(7030), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90375] = 2,
    ACTIONS(7032), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90383] = 2,
    ACTIONS(7034), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90391] = 2,
    ACTIONS(5411), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90399] = 2,
    ACTIONS(3557), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90407] = 2,
    ACTIONS(4782), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90415] = 2,
    ACTIONS(7036), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90423] = 2,
    ACTIONS(7038), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90431] = 2,
    ACTIONS(7040), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90439] = 2,
    ACTIONS(7042), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90447] = 2,
    ACTIONS(4725), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90455] = 2,
    ACTIONS(7044), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90463] = 2,
    ACTIONS(7046), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90471] = 2,
    ACTIONS(7048), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90479] = 2,
    ACTIONS(7050), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90487] = 2,
    ACTIONS(7052), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90495] = 2,
    ACTIONS(7054), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90503] = 2,
    ACTIONS(7056), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90511] = 2,
    ACTIONS(7058), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90519] = 2,
    ACTIONS(7060), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90527] = 2,
    ACTIONS(7062), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90535] = 2,
    ACTIONS(7064), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90543] = 2,
    ACTIONS(7066), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90551] = 2,
    ACTIONS(7068), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90559] = 2,
    ACTIONS(4695), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90567] = 2,
    ACTIONS(7070), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90575] = 2,
    ACTIONS(7072), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90583] = 2,
    ACTIONS(7074), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90591] = 2,
    ACTIONS(7076), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90599] = 2,
    ACTIONS(7078), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90607] = 2,
    ACTIONS(7080), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90615] = 2,
    ACTIONS(7082), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90623] = 2,
    ACTIONS(7084), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90631] = 2,
    ACTIONS(7086), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90639] = 2,
    ACTIONS(4767), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90647] = 2,
    ACTIONS(7088), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90655] = 2,
    ACTIONS(4227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90663] = 2,
    ACTIONS(7090), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90671] = 2,
    ACTIONS(7092), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90679] = 2,
    ACTIONS(7094), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90687] = 2,
    ACTIONS(7096), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90695] = 2,
    ACTIONS(7098), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90703] = 2,
    ACTIONS(7100), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90711] = 2,
    ACTIONS(7102), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90719] = 2,
    ACTIONS(4632), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90727] = 2,
    ACTIONS(7104), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90735] = 2,
    ACTIONS(7106), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90743] = 2,
    ACTIONS(7108), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90751] = 2,
    ACTIONS(7110), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90759] = 2,
    ACTIONS(7112), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90767] = 2,
    ACTIONS(7114), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90775] = 2,
    ACTIONS(7116), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90783] = 2,
    ACTIONS(7118), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90791] = 2,
    ACTIONS(7120), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90799] = 2,
    ACTIONS(4289), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90807] = 2,
    ACTIONS(7122), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90815] = 2,
    ACTIONS(7124), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90823] = 2,
    ACTIONS(7126), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90831] = 2,
    ACTIONS(7128), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90839] = 2,
    ACTIONS(7130), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90847] = 2,
    ACTIONS(7132), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90855] = 2,
    ACTIONS(4576), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90863] = 2,
    ACTIONS(7134), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90871] = 2,
    ACTIONS(7136), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90879] = 2,
    ACTIONS(7138), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90887] = 2,
    ACTIONS(5625), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90895] = 2,
    ACTIONS(4564), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90903] = 2,
    ACTIONS(7140), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90911] = 2,
    ACTIONS(7142), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90919] = 2,
    ACTIONS(7144), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90927] = 2,
    ACTIONS(7146), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90935] = 2,
    ACTIONS(7148), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90943] = 2,
    ACTIONS(7150), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90951] = 2,
    ACTIONS(4205), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90959] = 2,
    ACTIONS(5647), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90967] = 2,
    ACTIONS(3581), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90975] = 2,
    ACTIONS(7152), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90983] = 2,
    ACTIONS(7154), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90991] = 2,
    ACTIONS(7156), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [90999] = 2,
    ACTIONS(7158), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91007] = 2,
    ACTIONS(7160), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91015] = 2,
    ACTIONS(7162), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91023] = 2,
    ACTIONS(7164), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91031] = 2,
    ACTIONS(7166), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91039] = 2,
    ACTIONS(7168), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91047] = 2,
    ACTIONS(7170), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91055] = 2,
    ACTIONS(7172), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91063] = 2,
    ACTIONS(7174), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91071] = 2,
    ACTIONS(7176), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91079] = 2,
    ACTIONS(7178), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91087] = 2,
    ACTIONS(2696), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91095] = 2,
    ACTIONS(7180), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91103] = 2,
    ACTIONS(7182), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91111] = 2,
    ACTIONS(7184), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91119] = 2,
    ACTIONS(7186), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91127] = 2,
    ACTIONS(7188), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91135] = 2,
    ACTIONS(7190), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91143] = 2,
    ACTIONS(7192), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91151] = 2,
    ACTIONS(7194), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91159] = 2,
    ACTIONS(7196), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91167] = 2,
    ACTIONS(4652), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91175] = 2,
    ACTIONS(7198), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91183] = 2,
    ACTIONS(7200), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91191] = 2,
    ACTIONS(7202), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91199] = 2,
    ACTIONS(7204), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91207] = 2,
    ACTIONS(7206), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91215] = 2,
    ACTIONS(7208), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91223] = 2,
    ACTIONS(7210), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91231] = 2,
    ACTIONS(7212), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91239] = 2,
    ACTIONS(7214), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91247] = 2,
    ACTIONS(7216), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91255] = 2,
    ACTIONS(4114), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91263] = 2,
    ACTIONS(7218), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91271] = 2,
    ACTIONS(7220), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91279] = 2,
    ACTIONS(7222), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91287] = 2,
    ACTIONS(7224), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91295] = 2,
    ACTIONS(7226), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91303] = 2,
    ACTIONS(7228), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91311] = 2,
    ACTIONS(7230), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91319] = 2,
    ACTIONS(7232), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91327] = 2,
    ACTIONS(7234), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91335] = 2,
    ACTIONS(7236), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91343] = 2,
    ACTIONS(4672), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91351] = 2,
    ACTIONS(7238), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91359] = 2,
    ACTIONS(7240), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91367] = 2,
    ACTIONS(7242), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91375] = 2,
    ACTIONS(7244), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91383] = 2,
    ACTIONS(7246), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91391] = 2,
    ACTIONS(7248), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91399] = 2,
    ACTIONS(7250), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91407] = 2,
    ACTIONS(7252), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91415] = 2,
    ACTIONS(4320), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91423] = 2,
    ACTIONS(7254), 1,
      aux_sym_primitive_definition_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91431] = 2,
    ACTIONS(7256), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91439] = 2,
    ACTIONS(7258), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91447] = 2,
    ACTIONS(7260), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91455] = 2,
    ACTIONS(7262), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91463] = 2,
    ACTIONS(7264), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91471] = 2,
    ACTIONS(7266), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91479] = 2,
    ACTIONS(4245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91487] = 2,
    ACTIONS(5655), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91495] = 2,
    ACTIONS(4674), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91503] = 2,
    ACTIONS(7268), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91511] = 2,
    ACTIONS(7270), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91519] = 2,
    ACTIONS(7272), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91527] = 2,
    ACTIONS(4193), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91535] = 2,
    ACTIONS(5924), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91543] = 2,
    ACTIONS(3585), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91551] = 2,
    ACTIONS(7274), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91559] = 2,
    ACTIONS(7276), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91567] = 2,
    ACTIONS(7278), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91575] = 2,
    ACTIONS(7280), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91583] = 2,
    ACTIONS(4792), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91591] = 2,
    ACTIONS(7282), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91599] = 2,
    ACTIONS(7284), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91607] = 2,
    ACTIONS(7286), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91615] = 2,
    ACTIONS(7288), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91623] = 2,
    ACTIONS(7290), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91631] = 2,
    ACTIONS(7292), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91639] = 2,
    ACTIONS(7294), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91647] = 2,
    ACTIONS(7296), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91655] = 2,
    ACTIONS(7298), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91663] = 2,
    ACTIONS(7300), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91671] = 2,
    ACTIONS(7302), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91679] = 2,
    ACTIONS(4614), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91687] = 2,
    ACTIONS(7304), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91695] = 2,
    ACTIONS(7306), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91703] = 2,
    ACTIONS(7308), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91711] = 2,
    ACTIONS(7310), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91719] = 2,
    ACTIONS(7312), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91727] = 2,
    ACTIONS(7314), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91735] = 2,
    ACTIONS(7316), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91743] = 2,
    ACTIONS(7318), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91751] = 2,
    ACTIONS(7320), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91759] = 2,
    ACTIONS(7322), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91767] = 2,
    ACTIONS(7324), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91775] = 2,
    ACTIONS(7326), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91783] = 2,
    ACTIONS(7328), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91791] = 2,
    ACTIONS(4604), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91799] = 2,
    ACTIONS(7330), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91807] = 2,
    ACTIONS(7332), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91815] = 2,
    ACTIONS(7334), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91823] = 2,
    ACTIONS(7336), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91831] = 2,
    ACTIONS(7338), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91839] = 2,
    ACTIONS(7340), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91847] = 2,
    ACTIONS(7342), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91855] = 2,
    ACTIONS(7344), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91863] = 2,
    ACTIONS(4285), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91871] = 2,
    ACTIONS(7346), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91879] = 2,
    ACTIONS(7348), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91887] = 2,
    ACTIONS(7350), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91895] = 2,
    ACTIONS(7352), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91903] = 2,
    ACTIONS(7354), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91911] = 2,
    ACTIONS(7356), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91919] = 2,
    ACTIONS(7358), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91927] = 2,
    ACTIONS(7360), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91935] = 2,
    ACTIONS(5661), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91943] = 2,
    ACTIONS(7362), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91951] = 2,
    ACTIONS(7364), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91959] = 2,
    ACTIONS(7366), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91967] = 2,
    ACTIONS(7368), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91975] = 2,
    ACTIONS(4572), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91983] = 2,
    ACTIONS(7370), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91991] = 2,
    ACTIONS(7372), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [91999] = 2,
    ACTIONS(7374), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92007] = 2,
    ACTIONS(4751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92015] = 2,
    ACTIONS(7376), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92023] = 2,
    ACTIONS(7378), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92031] = 2,
    ACTIONS(4197), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92039] = 2,
    ACTIONS(7380), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92047] = 2,
    ACTIONS(7382), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92055] = 2,
    ACTIONS(5515), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92063] = 2,
    ACTIONS(7384), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92071] = 2,
    ACTIONS(3553), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92079] = 2,
    ACTIONS(7386), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92087] = 2,
    ACTIONS(7388), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92095] = 2,
    ACTIONS(7390), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92103] = 2,
    ACTIONS(7392), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92111] = 2,
    ACTIONS(7394), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92119] = 2,
    ACTIONS(7396), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92127] = 2,
    ACTIONS(7398), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92135] = 2,
    ACTIONS(7400), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92143] = 2,
    ACTIONS(7402), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92151] = 2,
    ACTIONS(7404), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92159] = 2,
    ACTIONS(7406), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92167] = 2,
    ACTIONS(7408), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92175] = 2,
    ACTIONS(4743), 1,
      anon_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92183] = 2,
    ACTIONS(7410), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92191] = 2,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92199] = 2,
    ACTIONS(7412), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92207] = 2,
    ACTIONS(7414), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92215] = 2,
    ACTIONS(7416), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92223] = 2,
    ACTIONS(7418), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92231] = 2,
    ACTIONS(7420), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92239] = 2,
    ACTIONS(7422), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92247] = 2,
    ACTIONS(7424), 1,
      anon_sym_struct,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92255] = 2,
    ACTIONS(7426), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92263] = 2,
    ACTIONS(7428), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92271] = 2,
    ACTIONS(7430), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92279] = 2,
    ACTIONS(7432), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92287] = 2,
    ACTIONS(7434), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92295] = 2,
    ACTIONS(7436), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92303] = 2,
    ACTIONS(7438), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92311] = 2,
    ACTIONS(7440), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [92319] = 2,
    ACTIONS(7442), 1,
      anon_sym_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1527)] = 0,
  [SMALL_STATE(1528)] = 73,
  [SMALL_STATE(1529)] = 144,
  [SMALL_STATE(1530)] = 215,
  [SMALL_STATE(1531)] = 288,
  [SMALL_STATE(1532)] = 361,
  [SMALL_STATE(1533)] = 434,
  [SMALL_STATE(1534)] = 507,
  [SMALL_STATE(1535)] = 580,
  [SMALL_STATE(1536)] = 653,
  [SMALL_STATE(1537)] = 726,
  [SMALL_STATE(1538)] = 799,
  [SMALL_STATE(1539)] = 872,
  [SMALL_STATE(1540)] = 945,
  [SMALL_STATE(1541)] = 1018,
  [SMALL_STATE(1542)] = 1091,
  [SMALL_STATE(1543)] = 1164,
  [SMALL_STATE(1544)] = 1237,
  [SMALL_STATE(1545)] = 1310,
  [SMALL_STATE(1546)] = 1383,
  [SMALL_STATE(1547)] = 1456,
  [SMALL_STATE(1548)] = 1529,
  [SMALL_STATE(1549)] = 1602,
  [SMALL_STATE(1550)] = 1675,
  [SMALL_STATE(1551)] = 1748,
  [SMALL_STATE(1552)] = 1821,
  [SMALL_STATE(1553)] = 1894,
  [SMALL_STATE(1554)] = 1967,
  [SMALL_STATE(1555)] = 2040,
  [SMALL_STATE(1556)] = 2111,
  [SMALL_STATE(1557)] = 2184,
  [SMALL_STATE(1558)] = 2257,
  [SMALL_STATE(1559)] = 2330,
  [SMALL_STATE(1560)] = 2403,
  [SMALL_STATE(1561)] = 2476,
  [SMALL_STATE(1562)] = 2549,
  [SMALL_STATE(1563)] = 2622,
  [SMALL_STATE(1564)] = 2695,
  [SMALL_STATE(1565)] = 2768,
  [SMALL_STATE(1566)] = 2841,
  [SMALL_STATE(1567)] = 2914,
  [SMALL_STATE(1568)] = 2987,
  [SMALL_STATE(1569)] = 3060,
  [SMALL_STATE(1570)] = 3143,
  [SMALL_STATE(1571)] = 3216,
  [SMALL_STATE(1572)] = 3307,
  [SMALL_STATE(1573)] = 3388,
  [SMALL_STATE(1574)] = 3461,
  [SMALL_STATE(1575)] = 3534,
  [SMALL_STATE(1576)] = 3607,
  [SMALL_STATE(1577)] = 3680,
  [SMALL_STATE(1578)] = 3753,
  [SMALL_STATE(1579)] = 3826,
  [SMALL_STATE(1580)] = 3899,
  [SMALL_STATE(1581)] = 3972,
  [SMALL_STATE(1582)] = 4045,
  [SMALL_STATE(1583)] = 4116,
  [SMALL_STATE(1584)] = 4187,
  [SMALL_STATE(1585)] = 4260,
  [SMALL_STATE(1586)] = 4333,
  [SMALL_STATE(1587)] = 4406,
  [SMALL_STATE(1588)] = 4479,
  [SMALL_STATE(1589)] = 4552,
  [SMALL_STATE(1590)] = 4625,
  [SMALL_STATE(1591)] = 4698,
  [SMALL_STATE(1592)] = 4771,
  [SMALL_STATE(1593)] = 4844,
  [SMALL_STATE(1594)] = 4917,
  [SMALL_STATE(1595)] = 4990,
  [SMALL_STATE(1596)] = 5063,
  [SMALL_STATE(1597)] = 5136,
  [SMALL_STATE(1598)] = 5209,
  [SMALL_STATE(1599)] = 5282,
  [SMALL_STATE(1600)] = 5353,
  [SMALL_STATE(1601)] = 5424,
  [SMALL_STATE(1602)] = 5495,
  [SMALL_STATE(1603)] = 5568,
  [SMALL_STATE(1604)] = 5643,
  [SMALL_STATE(1605)] = 5716,
  [SMALL_STATE(1606)] = 5787,
  [SMALL_STATE(1607)] = 5894,
  [SMALL_STATE(1608)] = 5965,
  [SMALL_STATE(1609)] = 6036,
  [SMALL_STATE(1610)] = 6107,
  [SMALL_STATE(1611)] = 6178,
  [SMALL_STATE(1612)] = 6249,
  [SMALL_STATE(1613)] = 6320,
  [SMALL_STATE(1614)] = 6391,
  [SMALL_STATE(1615)] = 6462,
  [SMALL_STATE(1616)] = 6533,
  [SMALL_STATE(1617)] = 6604,
  [SMALL_STATE(1618)] = 6675,
  [SMALL_STATE(1619)] = 6746,
  [SMALL_STATE(1620)] = 6817,
  [SMALL_STATE(1621)] = 6888,
  [SMALL_STATE(1622)] = 6959,
  [SMALL_STATE(1623)] = 7030,
  [SMALL_STATE(1624)] = 7103,
  [SMALL_STATE(1625)] = 7176,
  [SMALL_STATE(1626)] = 7249,
  [SMALL_STATE(1627)] = 7322,
  [SMALL_STATE(1628)] = 7395,
  [SMALL_STATE(1629)] = 7468,
  [SMALL_STATE(1630)] = 7541,
  [SMALL_STATE(1631)] = 7614,
  [SMALL_STATE(1632)] = 7687,
  [SMALL_STATE(1633)] = 7760,
  [SMALL_STATE(1634)] = 7845,
  [SMALL_STATE(1635)] = 7918,
  [SMALL_STATE(1636)] = 7991,
  [SMALL_STATE(1637)] = 8064,
  [SMALL_STATE(1638)] = 8137,
  [SMALL_STATE(1639)] = 8210,
  [SMALL_STATE(1640)] = 8283,
  [SMALL_STATE(1641)] = 8356,
  [SMALL_STATE(1642)] = 8429,
  [SMALL_STATE(1643)] = 8528,
  [SMALL_STATE(1644)] = 8615,
  [SMALL_STATE(1645)] = 8698,
  [SMALL_STATE(1646)] = 8779,
  [SMALL_STATE(1647)] = 8858,
  [SMALL_STATE(1648)] = 8977,
  [SMALL_STATE(1649)] = 9056,
  [SMALL_STATE(1650)] = 9163,
  [SMALL_STATE(1651)] = 9262,
  [SMALL_STATE(1652)] = 9335,
  [SMALL_STATE(1653)] = 9436,
  [SMALL_STATE(1654)] = 9509,
  [SMALL_STATE(1655)] = 9582,
  [SMALL_STATE(1656)] = 9655,
  [SMALL_STATE(1657)] = 9750,
  [SMALL_STATE(1658)] = 9841,
  [SMALL_STATE(1659)] = 9936,
  [SMALL_STATE(1660)] = 10021,
  [SMALL_STATE(1661)] = 10110,
  [SMALL_STATE(1662)] = 10181,
  [SMALL_STATE(1663)] = 10290,
  [SMALL_STATE(1664)] = 10363,
  [SMALL_STATE(1665)] = 10436,
  [SMALL_STATE(1666)] = 10509,
  [SMALL_STATE(1667)] = 10582,
  [SMALL_STATE(1668)] = 10655,
  [SMALL_STATE(1669)] = 10728,
  [SMALL_STATE(1670)] = 10801,
  [SMALL_STATE(1671)] = 10874,
  [SMALL_STATE(1672)] = 10993,
  [SMALL_STATE(1673)] = 11066,
  [SMALL_STATE(1674)] = 11139,
  [SMALL_STATE(1675)] = 11212,
  [SMALL_STATE(1676)] = 11285,
  [SMALL_STATE(1677)] = 11358,
  [SMALL_STATE(1678)] = 11431,
  [SMALL_STATE(1679)] = 11504,
  [SMALL_STATE(1680)] = 11577,
  [SMALL_STATE(1681)] = 11696,
  [SMALL_STATE(1682)] = 11769,
  [SMALL_STATE(1683)] = 11842,
  [SMALL_STATE(1684)] = 11961,
  [SMALL_STATE(1685)] = 12034,
  [SMALL_STATE(1686)] = 12141,
  [SMALL_STATE(1687)] = 12214,
  [SMALL_STATE(1688)] = 12287,
  [SMALL_STATE(1689)] = 12360,
  [SMALL_STATE(1690)] = 12433,
  [SMALL_STATE(1691)] = 12506,
  [SMALL_STATE(1692)] = 12599,
  [SMALL_STATE(1693)] = 12692,
  [SMALL_STATE(1694)] = 12779,
  [SMALL_STATE(1695)] = 12852,
  [SMALL_STATE(1696)] = 12925,
  [SMALL_STATE(1697)] = 12996,
  [SMALL_STATE(1698)] = 13069,
  [SMALL_STATE(1699)] = 13142,
  [SMALL_STATE(1700)] = 13215,
  [SMALL_STATE(1701)] = 13288,
  [SMALL_STATE(1702)] = 13397,
  [SMALL_STATE(1703)] = 13470,
  [SMALL_STATE(1704)] = 13543,
  [SMALL_STATE(1705)] = 13616,
  [SMALL_STATE(1706)] = 13689,
  [SMALL_STATE(1707)] = 13762,
  [SMALL_STATE(1708)] = 13851,
  [SMALL_STATE(1709)] = 13926,
  [SMALL_STATE(1710)] = 13999,
  [SMALL_STATE(1711)] = 14106,
  [SMALL_STATE(1712)] = 14179,
  [SMALL_STATE(1713)] = 14252,
  [SMALL_STATE(1714)] = 14325,
  [SMALL_STATE(1715)] = 14396,
  [SMALL_STATE(1716)] = 14467,
  [SMALL_STATE(1717)] = 14538,
  [SMALL_STATE(1718)] = 14609,
  [SMALL_STATE(1719)] = 14728,
  [SMALL_STATE(1720)] = 14847,
  [SMALL_STATE(1721)] = 14918,
  [SMALL_STATE(1722)] = 14989,
  [SMALL_STATE(1723)] = 15062,
  [SMALL_STATE(1724)] = 15181,
  [SMALL_STATE(1725)] = 15254,
  [SMALL_STATE(1726)] = 15325,
  [SMALL_STATE(1727)] = 15396,
  [SMALL_STATE(1728)] = 15467,
  [SMALL_STATE(1729)] = 15538,
  [SMALL_STATE(1730)] = 15609,
  [SMALL_STATE(1731)] = 15680,
  [SMALL_STATE(1732)] = 15751,
  [SMALL_STATE(1733)] = 15822,
  [SMALL_STATE(1734)] = 15893,
  [SMALL_STATE(1735)] = 15966,
  [SMALL_STATE(1736)] = 16039,
  [SMALL_STATE(1737)] = 16110,
  [SMALL_STATE(1738)] = 16181,
  [SMALL_STATE(1739)] = 16252,
  [SMALL_STATE(1740)] = 16323,
  [SMALL_STATE(1741)] = 16394,
  [SMALL_STATE(1742)] = 16465,
  [SMALL_STATE(1743)] = 16536,
  [SMALL_STATE(1744)] = 16607,
  [SMALL_STATE(1745)] = 16678,
  [SMALL_STATE(1746)] = 16749,
  [SMALL_STATE(1747)] = 16820,
  [SMALL_STATE(1748)] = 16891,
  [SMALL_STATE(1749)] = 16962,
  [SMALL_STATE(1750)] = 17033,
  [SMALL_STATE(1751)] = 17104,
  [SMALL_STATE(1752)] = 17175,
  [SMALL_STATE(1753)] = 17248,
  [SMALL_STATE(1754)] = 17321,
  [SMALL_STATE(1755)] = 17394,
  [SMALL_STATE(1756)] = 17465,
  [SMALL_STATE(1757)] = 17552,
  [SMALL_STATE(1758)] = 17625,
  [SMALL_STATE(1759)] = 17722,
  [SMALL_STATE(1760)] = 17815,
  [SMALL_STATE(1761)] = 17888,
  [SMALL_STATE(1762)] = 17961,
  [SMALL_STATE(1763)] = 18034,
  [SMALL_STATE(1764)] = 18105,
  [SMALL_STATE(1765)] = 18202,
  [SMALL_STATE(1766)] = 18275,
  [SMALL_STATE(1767)] = 18346,
  [SMALL_STATE(1768)] = 18449,
  [SMALL_STATE(1769)] = 18520,
  [SMALL_STATE(1770)] = 18593,
  [SMALL_STATE(1771)] = 18684,
  [SMALL_STATE(1772)] = 18757,
  [SMALL_STATE(1773)] = 18876,
  [SMALL_STATE(1774)] = 18947,
  [SMALL_STATE(1775)] = 19018,
  [SMALL_STATE(1776)] = 19089,
  [SMALL_STATE(1777)] = 19160,
  [SMALL_STATE(1778)] = 19231,
  [SMALL_STATE(1779)] = 19302,
  [SMALL_STATE(1780)] = 19373,
  [SMALL_STATE(1781)] = 19444,
  [SMALL_STATE(1782)] = 19515,
  [SMALL_STATE(1783)] = 19588,
  [SMALL_STATE(1784)] = 19661,
  [SMALL_STATE(1785)] = 19752,
  [SMALL_STATE(1786)] = 19823,
  [SMALL_STATE(1787)] = 19894,
  [SMALL_STATE(1788)] = 19965,
  [SMALL_STATE(1789)] = 20038,
  [SMALL_STATE(1790)] = 20117,
  [SMALL_STATE(1791)] = 20188,
  [SMALL_STATE(1792)] = 20259,
  [SMALL_STATE(1793)] = 20360,
  [SMALL_STATE(1794)] = 20433,
  [SMALL_STATE(1795)] = 20506,
  [SMALL_STATE(1796)] = 20579,
  [SMALL_STATE(1797)] = 20652,
  [SMALL_STATE(1798)] = 20725,
  [SMALL_STATE(1799)] = 20802,
  [SMALL_STATE(1800)] = 20875,
  [SMALL_STATE(1801)] = 20984,
  [SMALL_STATE(1802)] = 21057,
  [SMALL_STATE(1803)] = 21154,
  [SMALL_STATE(1804)] = 21227,
  [SMALL_STATE(1805)] = 21300,
  [SMALL_STATE(1806)] = 21373,
  [SMALL_STATE(1807)] = 21482,
  [SMALL_STATE(1808)] = 21555,
  [SMALL_STATE(1809)] = 21642,
  [SMALL_STATE(1810)] = 21715,
  [SMALL_STATE(1811)] = 21786,
  [SMALL_STATE(1812)] = 21895,
  [SMALL_STATE(1813)] = 21968,
  [SMALL_STATE(1814)] = 22049,
  [SMALL_STATE(1815)] = 22120,
  [SMALL_STATE(1816)] = 22203,
  [SMALL_STATE(1817)] = 22288,
  [SMALL_STATE(1818)] = 22359,
  [SMALL_STATE(1819)] = 22432,
  [SMALL_STATE(1820)] = 22503,
  [SMALL_STATE(1821)] = 22574,
  [SMALL_STATE(1822)] = 22645,
  [SMALL_STATE(1823)] = 22716,
  [SMALL_STATE(1824)] = 22787,
  [SMALL_STATE(1825)] = 22858,
  [SMALL_STATE(1826)] = 22929,
  [SMALL_STATE(1827)] = 23002,
  [SMALL_STATE(1828)] = 23075,
  [SMALL_STATE(1829)] = 23164,
  [SMALL_STATE(1830)] = 23235,
  [SMALL_STATE(1831)] = 23308,
  [SMALL_STATE(1832)] = 23381,
  [SMALL_STATE(1833)] = 23452,
  [SMALL_STATE(1834)] = 23523,
  [SMALL_STATE(1835)] = 23596,
  [SMALL_STATE(1836)] = 23667,
  [SMALL_STATE(1837)] = 23768,
  [SMALL_STATE(1838)] = 23841,
  [SMALL_STATE(1839)] = 23932,
  [SMALL_STATE(1840)] = 24023,
  [SMALL_STATE(1841)] = 24096,
  [SMALL_STATE(1842)] = 24215,
  [SMALL_STATE(1843)] = 24286,
  [SMALL_STATE(1844)] = 24359,
  [SMALL_STATE(1845)] = 24468,
  [SMALL_STATE(1846)] = 24539,
  [SMALL_STATE(1847)] = 24612,
  [SMALL_STATE(1848)] = 24683,
  [SMALL_STATE(1849)] = 24754,
  [SMALL_STATE(1850)] = 24827,
  [SMALL_STATE(1851)] = 24900,
  [SMALL_STATE(1852)] = 24973,
  [SMALL_STATE(1853)] = 25046,
  [SMALL_STATE(1854)] = 25119,
  [SMALL_STATE(1855)] = 25192,
  [SMALL_STATE(1856)] = 25263,
  [SMALL_STATE(1857)] = 25336,
  [SMALL_STATE(1858)] = 25407,
  [SMALL_STATE(1859)] = 25478,
  [SMALL_STATE(1860)] = 25551,
  [SMALL_STATE(1861)] = 25660,
  [SMALL_STATE(1862)] = 25733,
  [SMALL_STATE(1863)] = 25826,
  [SMALL_STATE(1864)] = 25899,
  [SMALL_STATE(1865)] = 25972,
  [SMALL_STATE(1866)] = 26065,
  [SMALL_STATE(1867)] = 26166,
  [SMALL_STATE(1868)] = 26237,
  [SMALL_STATE(1869)] = 26326,
  [SMALL_STATE(1870)] = 26435,
  [SMALL_STATE(1871)] = 26536,
  [SMALL_STATE(1872)] = 26609,
  [SMALL_STATE(1873)] = 26712,
  [SMALL_STATE(1874)] = 26785,
  [SMALL_STATE(1875)] = 26858,
  [SMALL_STATE(1876)] = 26931,
  [SMALL_STATE(1877)] = 27004,
  [SMALL_STATE(1878)] = 27077,
  [SMALL_STATE(1879)] = 27150,
  [SMALL_STATE(1880)] = 27247,
  [SMALL_STATE(1881)] = 27320,
  [SMALL_STATE(1882)] = 27393,
  [SMALL_STATE(1883)] = 27466,
  [SMALL_STATE(1884)] = 27539,
  [SMALL_STATE(1885)] = 27632,
  [SMALL_STATE(1886)] = 27705,
  [SMALL_STATE(1887)] = 27778,
  [SMALL_STATE(1888)] = 27851,
  [SMALL_STATE(1889)] = 27924,
  [SMALL_STATE(1890)] = 27997,
  [SMALL_STATE(1891)] = 28070,
  [SMALL_STATE(1892)] = 28143,
  [SMALL_STATE(1893)] = 28216,
  [SMALL_STATE(1894)] = 28324,
  [SMALL_STATE(1895)] = 28410,
  [SMALL_STATE(1896)] = 28506,
  [SMALL_STATE(1897)] = 28598,
  [SMALL_STATE(1898)] = 28694,
  [SMALL_STATE(1899)] = 28796,
  [SMALL_STATE(1900)] = 28896,
  [SMALL_STATE(1901)] = 29004,
  [SMALL_STATE(1902)] = 29084,
  [SMALL_STATE(1903)] = 29166,
  [SMALL_STATE(1904)] = 29250,
  [SMALL_STATE(1905)] = 29338,
  [SMALL_STATE(1906)] = 29438,
  [SMALL_STATE(1907)] = 29528,
  [SMALL_STATE(1908)] = 29620,
  [SMALL_STATE(1909)] = 29712,
  [SMALL_STATE(1910)] = 29800,
  [SMALL_STATE(1911)] = 29907,
  [SMALL_STATE(1912)] = 30004,
  [SMALL_STATE(1913)] = 30085,
  [SMALL_STATE(1914)] = 30190,
  [SMALL_STATE(1915)] = 30275,
  [SMALL_STATE(1916)] = 30364,
  [SMALL_STATE(1917)] = 30441,
  [SMALL_STATE(1918)] = 30530,
  [SMALL_STATE(1919)] = 30623,
  [SMALL_STATE(1920)] = 30712,
  [SMALL_STATE(1921)] = 30817,
  [SMALL_STATE(1922)] = 30902,
  [SMALL_STATE(1923)] = 30999,
  [SMALL_STATE(1924)] = 31098,
  [SMALL_STATE(1925)] = 31187,
  [SMALL_STATE(1926)] = 31266,
  [SMALL_STATE(1927)] = 31359,
  [SMALL_STATE(1928)] = 31442,
  [SMALL_STATE(1929)] = 31544,
  [SMALL_STATE(1930)] = 31605,
  [SMALL_STATE(1931)] = 31668,
  [SMALL_STATE(1932)] = 31731,
  [SMALL_STATE(1933)] = 31789,
  [SMALL_STATE(1934)] = 31847,
  [SMALL_STATE(1935)] = 31901,
  [SMALL_STATE(1936)] = 31955,
  [SMALL_STATE(1937)] = 32008,
  [SMALL_STATE(1938)] = 32061,
  [SMALL_STATE(1939)] = 32114,
  [SMALL_STATE(1940)] = 32167,
  [SMALL_STATE(1941)] = 32232,
  [SMALL_STATE(1942)] = 32295,
  [SMALL_STATE(1943)] = 32355,
  [SMALL_STATE(1944)] = 32410,
  [SMALL_STATE(1945)] = 32471,
  [SMALL_STATE(1946)] = 32526,
  [SMALL_STATE(1947)] = 32581,
  [SMALL_STATE(1948)] = 32657,
  [SMALL_STATE(1949)] = 32709,
  [SMALL_STATE(1950)] = 32759,
  [SMALL_STATE(1951)] = 32809,
  [SMALL_STATE(1952)] = 32859,
  [SMALL_STATE(1953)] = 32909,
  [SMALL_STATE(1954)] = 32959,
  [SMALL_STATE(1955)] = 33009,
  [SMALL_STATE(1956)] = 33059,
  [SMALL_STATE(1957)] = 33109,
  [SMALL_STATE(1958)] = 33159,
  [SMALL_STATE(1959)] = 33209,
  [SMALL_STATE(1960)] = 33259,
  [SMALL_STATE(1961)] = 33309,
  [SMALL_STATE(1962)] = 33359,
  [SMALL_STATE(1963)] = 33409,
  [SMALL_STATE(1964)] = 33459,
  [SMALL_STATE(1965)] = 33509,
  [SMALL_STATE(1966)] = 33559,
  [SMALL_STATE(1967)] = 33609,
  [SMALL_STATE(1968)] = 33659,
  [SMALL_STATE(1969)] = 33709,
  [SMALL_STATE(1970)] = 33759,
  [SMALL_STATE(1971)] = 33809,
  [SMALL_STATE(1972)] = 33867,
  [SMALL_STATE(1973)] = 33917,
  [SMALL_STATE(1974)] = 33967,
  [SMALL_STATE(1975)] = 34042,
  [SMALL_STATE(1976)] = 34091,
  [SMALL_STATE(1977)] = 34140,
  [SMALL_STATE(1978)] = 34189,
  [SMALL_STATE(1979)] = 34238,
  [SMALL_STATE(1980)] = 34287,
  [SMALL_STATE(1981)] = 34336,
  [SMALL_STATE(1982)] = 34385,
  [SMALL_STATE(1983)] = 34434,
  [SMALL_STATE(1984)] = 34483,
  [SMALL_STATE(1985)] = 34532,
  [SMALL_STATE(1986)] = 34607,
  [SMALL_STATE(1987)] = 34682,
  [SMALL_STATE(1988)] = 34731,
  [SMALL_STATE(1989)] = 34780,
  [SMALL_STATE(1990)] = 34829,
  [SMALL_STATE(1991)] = 34882,
  [SMALL_STATE(1992)] = 34931,
  [SMALL_STATE(1993)] = 34980,
  [SMALL_STATE(1994)] = 35029,
  [SMALL_STATE(1995)] = 35078,
  [SMALL_STATE(1996)] = 35133,
  [SMALL_STATE(1997)] = 35184,
  [SMALL_STATE(1998)] = 35233,
  [SMALL_STATE(1999)] = 35282,
  [SMALL_STATE(2000)] = 35357,
  [SMALL_STATE(2001)] = 35406,
  [SMALL_STATE(2002)] = 35461,
  [SMALL_STATE(2003)] = 35512,
  [SMALL_STATE(2004)] = 35567,
  [SMALL_STATE(2005)] = 35616,
  [SMALL_STATE(2006)] = 35691,
  [SMALL_STATE(2007)] = 35742,
  [SMALL_STATE(2008)] = 35801,
  [SMALL_STATE(2009)] = 35876,
  [SMALL_STATE(2010)] = 35925,
  [SMALL_STATE(2011)] = 36000,
  [SMALL_STATE(2012)] = 36075,
  [SMALL_STATE(2013)] = 36150,
  [SMALL_STATE(2014)] = 36207,
  [SMALL_STATE(2015)] = 36259,
  [SMALL_STATE(2016)] = 36311,
  [SMALL_STATE(2017)] = 36363,
  [SMALL_STATE(2018)] = 36409,
  [SMALL_STATE(2019)] = 36455,
  [SMALL_STATE(2020)] = 36501,
  [SMALL_STATE(2021)] = 36547,
  [SMALL_STATE(2022)] = 36593,
  [SMALL_STATE(2023)] = 36639,
  [SMALL_STATE(2024)] = 36685,
  [SMALL_STATE(2025)] = 36731,
  [SMALL_STATE(2026)] = 36777,
  [SMALL_STATE(2027)] = 36823,
  [SMALL_STATE(2028)] = 36869,
  [SMALL_STATE(2029)] = 36917,
  [SMALL_STATE(2030)] = 36963,
  [SMALL_STATE(2031)] = 37009,
  [SMALL_STATE(2032)] = 37055,
  [SMALL_STATE(2033)] = 37101,
  [SMALL_STATE(2034)] = 37147,
  [SMALL_STATE(2035)] = 37193,
  [SMALL_STATE(2036)] = 37239,
  [SMALL_STATE(2037)] = 37285,
  [SMALL_STATE(2038)] = 37331,
  [SMALL_STATE(2039)] = 37377,
  [SMALL_STATE(2040)] = 37423,
  [SMALL_STATE(2041)] = 37469,
  [SMALL_STATE(2042)] = 37517,
  [SMALL_STATE(2043)] = 37563,
  [SMALL_STATE(2044)] = 37611,
  [SMALL_STATE(2045)] = 37660,
  [SMALL_STATE(2046)] = 37707,
  [SMALL_STATE(2047)] = 37752,
  [SMALL_STATE(2048)] = 37799,
  [SMALL_STATE(2049)] = 37850,
  [SMALL_STATE(2050)] = 37901,
  [SMALL_STATE(2051)] = 37946,
  [SMALL_STATE(2052)] = 37991,
  [SMALL_STATE(2053)] = 38040,
  [SMALL_STATE(2054)] = 38089,
  [SMALL_STATE(2055)] = 38136,
  [SMALL_STATE(2056)] = 38181,
  [SMALL_STATE(2057)] = 38226,
  [SMALL_STATE(2058)] = 38273,
  [SMALL_STATE(2059)] = 38318,
  [SMALL_STATE(2060)] = 38365,
  [SMALL_STATE(2061)] = 38410,
  [SMALL_STATE(2062)] = 38461,
  [SMALL_STATE(2063)] = 38506,
  [SMALL_STATE(2064)] = 38551,
  [SMALL_STATE(2065)] = 38598,
  [SMALL_STATE(2066)] = 38645,
  [SMALL_STATE(2067)] = 38690,
  [SMALL_STATE(2068)] = 38741,
  [SMALL_STATE(2069)] = 38788,
  [SMALL_STATE(2070)] = 38833,
  [SMALL_STATE(2071)] = 38884,
  [SMALL_STATE(2072)] = 38933,
  [SMALL_STATE(2073)] = 38984,
  [SMALL_STATE(2074)] = 39041,
  [SMALL_STATE(2075)] = 39090,
  [SMALL_STATE(2076)] = 39149,
  [SMALL_STATE(2077)] = 39194,
  [SMALL_STATE(2078)] = 39245,
  [SMALL_STATE(2079)] = 39290,
  [SMALL_STATE(2080)] = 39335,
  [SMALL_STATE(2081)] = 39380,
  [SMALL_STATE(2082)] = 39431,
  [SMALL_STATE(2083)] = 39478,
  [SMALL_STATE(2084)] = 39531,
  [SMALL_STATE(2085)] = 39576,
  [SMALL_STATE(2086)] = 39621,
  [SMALL_STATE(2087)] = 39666,
  [SMALL_STATE(2088)] = 39713,
  [SMALL_STATE(2089)] = 39760,
  [SMALL_STATE(2090)] = 39809,
  [SMALL_STATE(2091)] = 39854,
  [SMALL_STATE(2092)] = 39899,
  [SMALL_STATE(2093)] = 39944,
  [SMALL_STATE(2094)] = 39995,
  [SMALL_STATE(2095)] = 40046,
  [SMALL_STATE(2096)] = 40101,
  [SMALL_STATE(2097)] = 40146,
  [SMALL_STATE(2098)] = 40192,
  [SMALL_STATE(2099)] = 40278,
  [SMALL_STATE(2100)] = 40324,
  [SMALL_STATE(2101)] = 40370,
  [SMALL_STATE(2102)] = 40416,
  [SMALL_STATE(2103)] = 40462,
  [SMALL_STATE(2104)] = 40508,
  [SMALL_STATE(2105)] = 40554,
  [SMALL_STATE(2106)] = 40600,
  [SMALL_STATE(2107)] = 40646,
  [SMALL_STATE(2108)] = 40692,
  [SMALL_STATE(2109)] = 40738,
  [SMALL_STATE(2110)] = 40784,
  [SMALL_STATE(2111)] = 40830,
  [SMALL_STATE(2112)] = 40876,
  [SMALL_STATE(2113)] = 40922,
  [SMALL_STATE(2114)] = 40968,
  [SMALL_STATE(2115)] = 41014,
  [SMALL_STATE(2116)] = 41060,
  [SMALL_STATE(2117)] = 41106,
  [SMALL_STATE(2118)] = 41152,
  [SMALL_STATE(2119)] = 41198,
  [SMALL_STATE(2120)] = 41244,
  [SMALL_STATE(2121)] = 41290,
  [SMALL_STATE(2122)] = 41336,
  [SMALL_STATE(2123)] = 41382,
  [SMALL_STATE(2124)] = 41428,
  [SMALL_STATE(2125)] = 41474,
  [SMALL_STATE(2126)] = 41518,
  [SMALL_STATE(2127)] = 41564,
  [SMALL_STATE(2128)] = 41610,
  [SMALL_STATE(2129)] = 41658,
  [SMALL_STATE(2130)] = 41704,
  [SMALL_STATE(2131)] = 41750,
  [SMALL_STATE(2132)] = 41796,
  [SMALL_STATE(2133)] = 41842,
  [SMALL_STATE(2134)] = 41888,
  [SMALL_STATE(2135)] = 41938,
  [SMALL_STATE(2136)] = 41984,
  [SMALL_STATE(2137)] = 42030,
  [SMALL_STATE(2138)] = 42116,
  [SMALL_STATE(2139)] = 42166,
  [SMALL_STATE(2140)] = 42212,
  [SMALL_STATE(2141)] = 42258,
  [SMALL_STATE(2142)] = 42304,
  [SMALL_STATE(2143)] = 42380,
  [SMALL_STATE(2144)] = 42426,
  [SMALL_STATE(2145)] = 42472,
  [SMALL_STATE(2146)] = 42516,
  [SMALL_STATE(2147)] = 42566,
  [SMALL_STATE(2148)] = 42612,
  [SMALL_STATE(2149)] = 42658,
  [SMALL_STATE(2150)] = 42704,
  [SMALL_STATE(2151)] = 42750,
  [SMALL_STATE(2152)] = 42796,
  [SMALL_STATE(2153)] = 42842,
  [SMALL_STATE(2154)] = 42888,
  [SMALL_STATE(2155)] = 42932,
  [SMALL_STATE(2156)] = 42978,
  [SMALL_STATE(2157)] = 43024,
  [SMALL_STATE(2158)] = 43116,
  [SMALL_STATE(2159)] = 43162,
  [SMALL_STATE(2160)] = 43208,
  [SMALL_STATE(2161)] = 43254,
  [SMALL_STATE(2162)] = 43300,
  [SMALL_STATE(2163)] = 43346,
  [SMALL_STATE(2164)] = 43392,
  [SMALL_STATE(2165)] = 43438,
  [SMALL_STATE(2166)] = 43484,
  [SMALL_STATE(2167)] = 43528,
  [SMALL_STATE(2168)] = 43574,
  [SMALL_STATE(2169)] = 43624,
  [SMALL_STATE(2170)] = 43670,
  [SMALL_STATE(2171)] = 43720,
  [SMALL_STATE(2172)] = 43766,
  [SMALL_STATE(2173)] = 43812,
  [SMALL_STATE(2174)] = 43858,
  [SMALL_STATE(2175)] = 43904,
  [SMALL_STATE(2176)] = 43950,
  [SMALL_STATE(2177)] = 43996,
  [SMALL_STATE(2178)] = 44042,
  [SMALL_STATE(2179)] = 44088,
  [SMALL_STATE(2180)] = 44134,
  [SMALL_STATE(2181)] = 44180,
  [SMALL_STATE(2182)] = 44226,
  [SMALL_STATE(2183)] = 44282,
  [SMALL_STATE(2184)] = 44328,
  [SMALL_STATE(2185)] = 44374,
  [SMALL_STATE(2186)] = 44420,
  [SMALL_STATE(2187)] = 44466,
  [SMALL_STATE(2188)] = 44512,
  [SMALL_STATE(2189)] = 44558,
  [SMALL_STATE(2190)] = 44604,
  [SMALL_STATE(2191)] = 44650,
  [SMALL_STATE(2192)] = 44696,
  [SMALL_STATE(2193)] = 44742,
  [SMALL_STATE(2194)] = 44788,
  [SMALL_STATE(2195)] = 44834,
  [SMALL_STATE(2196)] = 44880,
  [SMALL_STATE(2197)] = 44930,
  [SMALL_STATE(2198)] = 44982,
  [SMALL_STATE(2199)] = 45028,
  [SMALL_STATE(2200)] = 45074,
  [SMALL_STATE(2201)] = 45120,
  [SMALL_STATE(2202)] = 45166,
  [SMALL_STATE(2203)] = 45212,
  [SMALL_STATE(2204)] = 45258,
  [SMALL_STATE(2205)] = 45304,
  [SMALL_STATE(2206)] = 45350,
  [SMALL_STATE(2207)] = 45396,
  [SMALL_STATE(2208)] = 45442,
  [SMALL_STATE(2209)] = 45492,
  [SMALL_STATE(2210)] = 45538,
  [SMALL_STATE(2211)] = 45584,
  [SMALL_STATE(2212)] = 45630,
  [SMALL_STATE(2213)] = 45674,
  [SMALL_STATE(2214)] = 45718,
  [SMALL_STATE(2215)] = 45762,
  [SMALL_STATE(2216)] = 45806,
  [SMALL_STATE(2217)] = 45850,
  [SMALL_STATE(2218)] = 45894,
  [SMALL_STATE(2219)] = 45938,
  [SMALL_STATE(2220)] = 45984,
  [SMALL_STATE(2221)] = 46028,
  [SMALL_STATE(2222)] = 46074,
  [SMALL_STATE(2223)] = 46118,
  [SMALL_STATE(2224)] = 46162,
  [SMALL_STATE(2225)] = 46206,
  [SMALL_STATE(2226)] = 46250,
  [SMALL_STATE(2227)] = 46294,
  [SMALL_STATE(2228)] = 46338,
  [SMALL_STATE(2229)] = 46382,
  [SMALL_STATE(2230)] = 46426,
  [SMALL_STATE(2231)] = 46470,
  [SMALL_STATE(2232)] = 46514,
  [SMALL_STATE(2233)] = 46558,
  [SMALL_STATE(2234)] = 46602,
  [SMALL_STATE(2235)] = 46646,
  [SMALL_STATE(2236)] = 46690,
  [SMALL_STATE(2237)] = 46733,
  [SMALL_STATE(2238)] = 46776,
  [SMALL_STATE(2239)] = 46819,
  [SMALL_STATE(2240)] = 46862,
  [SMALL_STATE(2241)] = 46905,
  [SMALL_STATE(2242)] = 46948,
  [SMALL_STATE(2243)] = 46995,
  [SMALL_STATE(2244)] = 47038,
  [SMALL_STATE(2245)] = 47085,
  [SMALL_STATE(2246)] = 47128,
  [SMALL_STATE(2247)] = 47209,
  [SMALL_STATE(2248)] = 47252,
  [SMALL_STATE(2249)] = 47295,
  [SMALL_STATE(2250)] = 47338,
  [SMALL_STATE(2251)] = 47381,
  [SMALL_STATE(2252)] = 47424,
  [SMALL_STATE(2253)] = 47467,
  [SMALL_STATE(2254)] = 47510,
  [SMALL_STATE(2255)] = 47553,
  [SMALL_STATE(2256)] = 47596,
  [SMALL_STATE(2257)] = 47645,
  [SMALL_STATE(2258)] = 47688,
  [SMALL_STATE(2259)] = 47751,
  [SMALL_STATE(2260)] = 47816,
  [SMALL_STATE(2261)] = 47859,
  [SMALL_STATE(2262)] = 47924,
  [SMALL_STATE(2263)] = 47975,
  [SMALL_STATE(2264)] = 48018,
  [SMALL_STATE(2265)] = 48117,
  [SMALL_STATE(2266)] = 48178,
  [SMALL_STATE(2267)] = 48221,
  [SMALL_STATE(2268)] = 48268,
  [SMALL_STATE(2269)] = 48311,
  [SMALL_STATE(2270)] = 48368,
  [SMALL_STATE(2271)] = 48423,
  [SMALL_STATE(2272)] = 48468,
  [SMALL_STATE(2273)] = 48521,
  [SMALL_STATE(2274)] = 48604,
  [SMALL_STATE(2275)] = 48649,
  [SMALL_STATE(2276)] = 48692,
  [SMALL_STATE(2277)] = 48791,
  [SMALL_STATE(2278)] = 48834,
  [SMALL_STATE(2279)] = 48915,
  [SMALL_STATE(2280)] = 48988,
  [SMALL_STATE(2281)] = 49073,
  [SMALL_STATE(2282)] = 49148,
  [SMALL_STATE(2283)] = 49195,
  [SMALL_STATE(2284)] = 49264,
  [SMALL_STATE(2285)] = 49329,
  [SMALL_STATE(2286)] = 49398,
  [SMALL_STATE(2287)] = 49445,
  [SMALL_STATE(2288)] = 49492,
  [SMALL_STATE(2289)] = 49551,
  [SMALL_STATE(2290)] = 49594,
  [SMALL_STATE(2291)] = 49637,
  [SMALL_STATE(2292)] = 49736,
  [SMALL_STATE(2293)] = 49783,
  [SMALL_STATE(2294)] = 49844,
  [SMALL_STATE(2295)] = 49891,
  [SMALL_STATE(2296)] = 49978,
  [SMALL_STATE(2297)] = 50021,
  [SMALL_STATE(2298)] = 50108,
  [SMALL_STATE(2299)] = 50207,
  [SMALL_STATE(2300)] = 50288,
  [SMALL_STATE(2301)] = 50387,
  [SMALL_STATE(2302)] = 50486,
  [SMALL_STATE(2303)] = 50529,
  [SMALL_STATE(2304)] = 50604,
  [SMALL_STATE(2305)] = 50647,
  [SMALL_STATE(2306)] = 50746,
  [SMALL_STATE(2307)] = 50789,
  [SMALL_STATE(2308)] = 50832,
  [SMALL_STATE(2309)] = 50879,
  [SMALL_STATE(2310)] = 50926,
  [SMALL_STATE(2311)] = 50969,
  [SMALL_STATE(2312)] = 51016,
  [SMALL_STATE(2313)] = 51063,
  [SMALL_STATE(2314)] = 51162,
  [SMALL_STATE(2315)] = 51209,
  [SMALL_STATE(2316)] = 51256,
  [SMALL_STATE(2317)] = 51331,
  [SMALL_STATE(2318)] = 51374,
  [SMALL_STATE(2319)] = 51417,
  [SMALL_STATE(2320)] = 51500,
  [SMALL_STATE(2321)] = 51573,
  [SMALL_STATE(2322)] = 51620,
  [SMALL_STATE(2323)] = 51667,
  [SMALL_STATE(2324)] = 51714,
  [SMALL_STATE(2325)] = 51756,
  [SMALL_STATE(2326)] = 51798,
  [SMALL_STATE(2327)] = 51840,
  [SMALL_STATE(2328)] = 51882,
  [SMALL_STATE(2329)] = 51924,
  [SMALL_STATE(2330)] = 51966,
  [SMALL_STATE(2331)] = 52008,
  [SMALL_STATE(2332)] = 52050,
  [SMALL_STATE(2333)] = 52092,
  [SMALL_STATE(2334)] = 52134,
  [SMALL_STATE(2335)] = 52176,
  [SMALL_STATE(2336)] = 52218,
  [SMALL_STATE(2337)] = 52266,
  [SMALL_STATE(2338)] = 52308,
  [SMALL_STATE(2339)] = 52350,
  [SMALL_STATE(2340)] = 52392,
  [SMALL_STATE(2341)] = 52434,
  [SMALL_STATE(2342)] = 52476,
  [SMALL_STATE(2343)] = 52518,
  [SMALL_STATE(2344)] = 52576,
  [SMALL_STATE(2345)] = 52618,
  [SMALL_STATE(2346)] = 52660,
  [SMALL_STATE(2347)] = 52702,
  [SMALL_STATE(2348)] = 52744,
  [SMALL_STATE(2349)] = 52786,
  [SMALL_STATE(2350)] = 52828,
  [SMALL_STATE(2351)] = 52884,
  [SMALL_STATE(2352)] = 52950,
  [SMALL_STATE(2353)] = 53012,
  [SMALL_STATE(2354)] = 53054,
  [SMALL_STATE(2355)] = 53120,
  [SMALL_STATE(2356)] = 53162,
  [SMALL_STATE(2357)] = 53236,
  [SMALL_STATE(2358)] = 53278,
  [SMALL_STATE(2359)] = 53320,
  [SMALL_STATE(2360)] = 53362,
  [SMALL_STATE(2361)] = 53404,
  [SMALL_STATE(2362)] = 53446,
  [SMALL_STATE(2363)] = 53488,
  [SMALL_STATE(2364)] = 53530,
  [SMALL_STATE(2365)] = 53572,
  [SMALL_STATE(2366)] = 53614,
  [SMALL_STATE(2367)] = 53686,
  [SMALL_STATE(2368)] = 53766,
  [SMALL_STATE(2369)] = 53816,
  [SMALL_STATE(2370)] = 53858,
  [SMALL_STATE(2371)] = 53900,
  [SMALL_STATE(2372)] = 53942,
  [SMALL_STATE(2373)] = 53984,
  [SMALL_STATE(2374)] = 54026,
  [SMALL_STATE(2375)] = 54068,
  [SMALL_STATE(2376)] = 54110,
  [SMALL_STATE(2377)] = 54152,
  [SMALL_STATE(2378)] = 54194,
  [SMALL_STATE(2379)] = 54246,
  [SMALL_STATE(2380)] = 54288,
  [SMALL_STATE(2381)] = 54350,
  [SMALL_STATE(2382)] = 54412,
  [SMALL_STATE(2383)] = 54454,
  [SMALL_STATE(2384)] = 54496,
  [SMALL_STATE(2385)] = 54538,
  [SMALL_STATE(2386)] = 54580,
  [SMALL_STATE(2387)] = 54622,
  [SMALL_STATE(2388)] = 54664,
  [SMALL_STATE(2389)] = 54706,
  [SMALL_STATE(2390)] = 54760,
  [SMALL_STATE(2391)] = 54802,
  [SMALL_STATE(2392)] = 54860,
  [SMALL_STATE(2393)] = 54902,
  [SMALL_STATE(2394)] = 54944,
  [SMALL_STATE(2395)] = 54986,
  [SMALL_STATE(2396)] = 55030,
  [SMALL_STATE(2397)] = 55072,
  [SMALL_STATE(2398)] = 55152,
  [SMALL_STATE(2399)] = 55194,
  [SMALL_STATE(2400)] = 55236,
  [SMALL_STATE(2401)] = 55278,
  [SMALL_STATE(2402)] = 55320,
  [SMALL_STATE(2403)] = 55362,
  [SMALL_STATE(2404)] = 55404,
  [SMALL_STATE(2405)] = 55446,
  [SMALL_STATE(2406)] = 55488,
  [SMALL_STATE(2407)] = 55532,
  [SMALL_STATE(2408)] = 55574,
  [SMALL_STATE(2409)] = 55616,
  [SMALL_STATE(2410)] = 55658,
  [SMALL_STATE(2411)] = 55700,
  [SMALL_STATE(2412)] = 55742,
  [SMALL_STATE(2413)] = 55784,
  [SMALL_STATE(2414)] = 55826,
  [SMALL_STATE(2415)] = 55868,
  [SMALL_STATE(2416)] = 55910,
  [SMALL_STATE(2417)] = 55952,
  [SMALL_STATE(2418)] = 56032,
  [SMALL_STATE(2419)] = 56074,
  [SMALL_STATE(2420)] = 56116,
  [SMALL_STATE(2421)] = 56158,
  [SMALL_STATE(2422)] = 56200,
  [SMALL_STATE(2423)] = 56272,
  [SMALL_STATE(2424)] = 56334,
  [SMALL_STATE(2425)] = 56376,
  [SMALL_STATE(2426)] = 56418,
  [SMALL_STATE(2427)] = 56464,
  [SMALL_STATE(2428)] = 56506,
  [SMALL_STATE(2429)] = 56548,
  [SMALL_STATE(2430)] = 56590,
  [SMALL_STATE(2431)] = 56632,
  [SMALL_STATE(2432)] = 56674,
  [SMALL_STATE(2433)] = 56716,
  [SMALL_STATE(2434)] = 56758,
  [SMALL_STATE(2435)] = 56800,
  [SMALL_STATE(2436)] = 56842,
  [SMALL_STATE(2437)] = 56884,
  [SMALL_STATE(2438)] = 56926,
  [SMALL_STATE(2439)] = 56968,
  [SMALL_STATE(2440)] = 57010,
  [SMALL_STATE(2441)] = 57054,
  [SMALL_STATE(2442)] = 57096,
  [SMALL_STATE(2443)] = 57138,
  [SMALL_STATE(2444)] = 57180,
  [SMALL_STATE(2445)] = 57222,
  [SMALL_STATE(2446)] = 57264,
  [SMALL_STATE(2447)] = 57305,
  [SMALL_STATE(2448)] = 57346,
  [SMALL_STATE(2449)] = 57387,
  [SMALL_STATE(2450)] = 57430,
  [SMALL_STATE(2451)] = 57471,
  [SMALL_STATE(2452)] = 57514,
  [SMALL_STATE(2453)] = 57555,
  [SMALL_STATE(2454)] = 57600,
  [SMALL_STATE(2455)] = 57683,
  [SMALL_STATE(2456)] = 57758,
  [SMALL_STATE(2457)] = 57803,
  [SMALL_STATE(2458)] = 57852,
  [SMALL_STATE(2459)] = 57897,
  [SMALL_STATE(2460)] = 57942,
  [SMALL_STATE(2461)] = 57987,
  [SMALL_STATE(2462)] = 58032,
  [SMALL_STATE(2463)] = 58073,
  [SMALL_STATE(2464)] = 58118,
  [SMALL_STATE(2465)] = 58163,
  [SMALL_STATE(2466)] = 58204,
  [SMALL_STATE(2467)] = 58245,
  [SMALL_STATE(2468)] = 58288,
  [SMALL_STATE(2469)] = 58337,
  [SMALL_STATE(2470)] = 58378,
  [SMALL_STATE(2471)] = 58423,
  [SMALL_STATE(2472)] = 58468,
  [SMALL_STATE(2473)] = 58509,
  [SMALL_STATE(2474)] = 58590,
  [SMALL_STATE(2475)] = 58631,
  [SMALL_STATE(2476)] = 58676,
  [SMALL_STATE(2477)] = 58721,
  [SMALL_STATE(2478)] = 58766,
  [SMALL_STATE(2479)] = 58811,
  [SMALL_STATE(2480)] = 58851,
  [SMALL_STATE(2481)] = 58891,
  [SMALL_STATE(2482)] = 58931,
  [SMALL_STATE(2483)] = 58971,
  [SMALL_STATE(2484)] = 59011,
  [SMALL_STATE(2485)] = 59051,
  [SMALL_STATE(2486)] = 59091,
  [SMALL_STATE(2487)] = 59131,
  [SMALL_STATE(2488)] = 59171,
  [SMALL_STATE(2489)] = 59211,
  [SMALL_STATE(2490)] = 59251,
  [SMALL_STATE(2491)] = 59291,
  [SMALL_STATE(2492)] = 59331,
  [SMALL_STATE(2493)] = 59371,
  [SMALL_STATE(2494)] = 59411,
  [SMALL_STATE(2495)] = 59451,
  [SMALL_STATE(2496)] = 59491,
  [SMALL_STATE(2497)] = 59581,
  [SMALL_STATE(2498)] = 59621,
  [SMALL_STATE(2499)] = 59661,
  [SMALL_STATE(2500)] = 59701,
  [SMALL_STATE(2501)] = 59741,
  [SMALL_STATE(2502)] = 59781,
  [SMALL_STATE(2503)] = 59841,
  [SMALL_STATE(2504)] = 59901,
  [SMALL_STATE(2505)] = 59941,
  [SMALL_STATE(2506)] = 59981,
  [SMALL_STATE(2507)] = 60021,
  [SMALL_STATE(2508)] = 60061,
  [SMALL_STATE(2509)] = 60101,
  [SMALL_STATE(2510)] = 60141,
  [SMALL_STATE(2511)] = 60181,
  [SMALL_STATE(2512)] = 60221,
  [SMALL_STATE(2513)] = 60261,
  [SMALL_STATE(2514)] = 60301,
  [SMALL_STATE(2515)] = 60341,
  [SMALL_STATE(2516)] = 60381,
  [SMALL_STATE(2517)] = 60421,
  [SMALL_STATE(2518)] = 60461,
  [SMALL_STATE(2519)] = 60501,
  [SMALL_STATE(2520)] = 60541,
  [SMALL_STATE(2521)] = 60581,
  [SMALL_STATE(2522)] = 60621,
  [SMALL_STATE(2523)] = 60661,
  [SMALL_STATE(2524)] = 60701,
  [SMALL_STATE(2525)] = 60741,
  [SMALL_STATE(2526)] = 60781,
  [SMALL_STATE(2527)] = 60821,
  [SMALL_STATE(2528)] = 60861,
  [SMALL_STATE(2529)] = 60901,
  [SMALL_STATE(2530)] = 60941,
  [SMALL_STATE(2531)] = 60981,
  [SMALL_STATE(2532)] = 61021,
  [SMALL_STATE(2533)] = 61061,
  [SMALL_STATE(2534)] = 61101,
  [SMALL_STATE(2535)] = 61141,
  [SMALL_STATE(2536)] = 61181,
  [SMALL_STATE(2537)] = 61221,
  [SMALL_STATE(2538)] = 61261,
  [SMALL_STATE(2539)] = 61301,
  [SMALL_STATE(2540)] = 61341,
  [SMALL_STATE(2541)] = 61381,
  [SMALL_STATE(2542)] = 61421,
  [SMALL_STATE(2543)] = 61461,
  [SMALL_STATE(2544)] = 61501,
  [SMALL_STATE(2545)] = 61553,
  [SMALL_STATE(2546)] = 61593,
  [SMALL_STATE(2547)] = 61633,
  [SMALL_STATE(2548)] = 61673,
  [SMALL_STATE(2549)] = 61713,
  [SMALL_STATE(2550)] = 61753,
  [SMALL_STATE(2551)] = 61793,
  [SMALL_STATE(2552)] = 61833,
  [SMALL_STATE(2553)] = 61873,
  [SMALL_STATE(2554)] = 61913,
  [SMALL_STATE(2555)] = 61971,
  [SMALL_STATE(2556)] = 62011,
  [SMALL_STATE(2557)] = 62051,
  [SMALL_STATE(2558)] = 62091,
  [SMALL_STATE(2559)] = 62131,
  [SMALL_STATE(2560)] = 62171,
  [SMALL_STATE(2561)] = 62211,
  [SMALL_STATE(2562)] = 62251,
  [SMALL_STATE(2563)] = 62291,
  [SMALL_STATE(2564)] = 62331,
  [SMALL_STATE(2565)] = 62371,
  [SMALL_STATE(2566)] = 62447,
  [SMALL_STATE(2567)] = 62487,
  [SMALL_STATE(2568)] = 62527,
  [SMALL_STATE(2569)] = 62567,
  [SMALL_STATE(2570)] = 62607,
  [SMALL_STATE(2571)] = 62647,
  [SMALL_STATE(2572)] = 62687,
  [SMALL_STATE(2573)] = 62741,
  [SMALL_STATE(2574)] = 62781,
  [SMALL_STATE(2575)] = 62845,
  [SMALL_STATE(2576)] = 62905,
  [SMALL_STATE(2577)] = 62945,
  [SMALL_STATE(2578)] = 62985,
  [SMALL_STATE(2579)] = 63049,
  [SMALL_STATE(2580)] = 63119,
  [SMALL_STATE(2581)] = 63159,
  [SMALL_STATE(2582)] = 63199,
  [SMALL_STATE(2583)] = 63267,
  [SMALL_STATE(2584)] = 63307,
  [SMALL_STATE(2585)] = 63347,
  [SMALL_STATE(2586)] = 63387,
  [SMALL_STATE(2587)] = 63463,
  [SMALL_STATE(2588)] = 63539,
  [SMALL_STATE(2589)] = 63587,
  [SMALL_STATE(2590)] = 63627,
  [SMALL_STATE(2591)] = 63667,
  [SMALL_STATE(2592)] = 63717,
  [SMALL_STATE(2593)] = 63773,
  [SMALL_STATE(2594)] = 63813,
  [SMALL_STATE(2595)] = 63869,
  [SMALL_STATE(2596)] = 63937,
  [SMALL_STATE(2597)] = 63983,
  [SMALL_STATE(2598)] = 64024,
  [SMALL_STATE(2599)] = 64111,
  [SMALL_STATE(2600)] = 64197,
  [SMALL_STATE(2601)] = 64283,
  [SMALL_STATE(2602)] = 64325,
  [SMALL_STATE(2603)] = 64407,
  [SMALL_STATE(2604)] = 64449,
  [SMALL_STATE(2605)] = 64519,
  [SMALL_STATE(2606)] = 64605,
  [SMALL_STATE(2607)] = 64691,
  [SMALL_STATE(2608)] = 64777,
  [SMALL_STATE(2609)] = 64863,
  [SMALL_STATE(2610)] = 64905,
  [SMALL_STATE(2611)] = 64947,
  [SMALL_STATE(2612)] = 64991,
  [SMALL_STATE(2613)] = 65033,
  [SMALL_STATE(2614)] = 65077,
  [SMALL_STATE(2615)] = 65163,
  [SMALL_STATE(2616)] = 65249,
  [SMALL_STATE(2617)] = 65335,
  [SMALL_STATE(2618)] = 65415,
  [SMALL_STATE(2619)] = 65495,
  [SMALL_STATE(2620)] = 65537,
  [SMALL_STATE(2621)] = 65579,
  [SMALL_STATE(2622)] = 65661,
  [SMALL_STATE(2623)] = 65705,
  [SMALL_STATE(2624)] = 65749,
  [SMALL_STATE(2625)] = 65793,
  [SMALL_STATE(2626)] = 65835,
  [SMALL_STATE(2627)] = 65882,
  [SMALL_STATE(2628)] = 65923,
  [SMALL_STATE(2629)] = 65998,
  [SMALL_STATE(2630)] = 66039,
  [SMALL_STATE(2631)] = 66096,
  [SMALL_STATE(2632)] = 66153,
  [SMALL_STATE(2633)] = 66214,
  [SMALL_STATE(2634)] = 66255,
  [SMALL_STATE(2635)] = 66322,
  [SMALL_STATE(2636)] = 66397,
  [SMALL_STATE(2637)] = 66462,
  [SMALL_STATE(2638)] = 66535,
  [SMALL_STATE(2639)] = 66590,
  [SMALL_STATE(2640)] = 66635,
  [SMALL_STATE(2641)] = 66676,
  [SMALL_STATE(2642)] = 66717,
  [SMALL_STATE(2643)] = 66772,
  [SMALL_STATE(2644)] = 66831,
  [SMALL_STATE(2645)] = 66884,
  [SMALL_STATE(2646)] = 66935,
  [SMALL_STATE(2647)] = 66998,
  [SMALL_STATE(2648)] = 67039,
  [SMALL_STATE(2649)] = 67096,
  [SMALL_STATE(2650)] = 67137,
  [SMALL_STATE(2651)] = 67186,
  [SMALL_STATE(2652)] = 67239,
  [SMALL_STATE(2653)] = 67288,
  [SMALL_STATE(2654)] = 67335,
  [SMALL_STATE(2655)] = 67390,
  [SMALL_STATE(2656)] = 67449,
  [SMALL_STATE(2657)] = 67512,
  [SMALL_STATE(2658)] = 67587,
  [SMALL_STATE(2659)] = 67656,
  [SMALL_STATE(2660)] = 67697,
  [SMALL_STATE(2661)] = 67738,
  [SMALL_STATE(2662)] = 67805,
  [SMALL_STATE(2663)] = 67846,
  [SMALL_STATE(2664)] = 67903,
  [SMALL_STATE(2665)] = 67980,
  [SMALL_STATE(2666)] = 68047,
  [SMALL_STATE(2667)] = 68112,
  [SMALL_STATE(2668)] = 68171,
  [SMALL_STATE(2669)] = 68224,
  [SMALL_STATE(2670)] = 68275,
  [SMALL_STATE(2671)] = 68336,
  [SMALL_STATE(2672)] = 68377,
  [SMALL_STATE(2673)] = 68455,
  [SMALL_STATE(2674)] = 68533,
  [SMALL_STATE(2675)] = 68605,
  [SMALL_STATE(2676)] = 68683,
  [SMALL_STATE(2677)] = 68761,
  [SMALL_STATE(2678)] = 68839,
  [SMALL_STATE(2679)] = 68917,
  [SMALL_STATE(2680)] = 68995,
  [SMALL_STATE(2681)] = 69073,
  [SMALL_STATE(2682)] = 69151,
  [SMALL_STATE(2683)] = 69228,
  [SMALL_STATE(2684)] = 69305,
  [SMALL_STATE(2685)] = 69382,
  [SMALL_STATE(2686)] = 69459,
  [SMALL_STATE(2687)] = 69536,
  [SMALL_STATE(2688)] = 69613,
  [SMALL_STATE(2689)] = 69690,
  [SMALL_STATE(2690)] = 69767,
  [SMALL_STATE(2691)] = 69838,
  [SMALL_STATE(2692)] = 69912,
  [SMALL_STATE(2693)] = 69986,
  [SMALL_STATE(2694)] = 70060,
  [SMALL_STATE(2695)] = 70134,
  [SMALL_STATE(2696)] = 70208,
  [SMALL_STATE(2697)] = 70282,
  [SMALL_STATE(2698)] = 70356,
  [SMALL_STATE(2699)] = 70430,
  [SMALL_STATE(2700)] = 70504,
  [SMALL_STATE(2701)] = 70578,
  [SMALL_STATE(2702)] = 70652,
  [SMALL_STATE(2703)] = 70726,
  [SMALL_STATE(2704)] = 70796,
  [SMALL_STATE(2705)] = 70868,
  [SMALL_STATE(2706)] = 70942,
  [SMALL_STATE(2707)] = 71016,
  [SMALL_STATE(2708)] = 71090,
  [SMALL_STATE(2709)] = 71164,
  [SMALL_STATE(2710)] = 71234,
  [SMALL_STATE(2711)] = 71304,
  [SMALL_STATE(2712)] = 71378,
  [SMALL_STATE(2713)] = 71452,
  [SMALL_STATE(2714)] = 71521,
  [SMALL_STATE(2715)] = 71590,
  [SMALL_STATE(2716)] = 71659,
  [SMALL_STATE(2717)] = 71730,
  [SMALL_STATE(2718)] = 71799,
  [SMALL_STATE(2719)] = 71868,
  [SMALL_STATE(2720)] = 71936,
  [SMALL_STATE(2721)] = 72004,
  [SMALL_STATE(2722)] = 72069,
  [SMALL_STATE(2723)] = 72134,
  [SMALL_STATE(2724)] = 72199,
  [SMALL_STATE(2725)] = 72264,
  [SMALL_STATE(2726)] = 72329,
  [SMALL_STATE(2727)] = 72394,
  [SMALL_STATE(2728)] = 72459,
  [SMALL_STATE(2729)] = 72524,
  [SMALL_STATE(2730)] = 72589,
  [SMALL_STATE(2731)] = 72654,
  [SMALL_STATE(2732)] = 72719,
  [SMALL_STATE(2733)] = 72784,
  [SMALL_STATE(2734)] = 72811,
  [SMALL_STATE(2735)] = 72838,
  [SMALL_STATE(2736)] = 72866,
  [SMALL_STATE(2737)] = 72892,
  [SMALL_STATE(2738)] = 72918,
  [SMALL_STATE(2739)] = 72944,
  [SMALL_STATE(2740)] = 72970,
  [SMALL_STATE(2741)] = 72996,
  [SMALL_STATE(2742)] = 73022,
  [SMALL_STATE(2743)] = 73048,
  [SMALL_STATE(2744)] = 73074,
  [SMALL_STATE(2745)] = 73100,
  [SMALL_STATE(2746)] = 73126,
  [SMALL_STATE(2747)] = 73152,
  [SMALL_STATE(2748)] = 73178,
  [SMALL_STATE(2749)] = 73206,
  [SMALL_STATE(2750)] = 73232,
  [SMALL_STATE(2751)] = 73255,
  [SMALL_STATE(2752)] = 73278,
  [SMALL_STATE(2753)] = 73301,
  [SMALL_STATE(2754)] = 73324,
  [SMALL_STATE(2755)] = 73347,
  [SMALL_STATE(2756)] = 73370,
  [SMALL_STATE(2757)] = 73393,
  [SMALL_STATE(2758)] = 73416,
  [SMALL_STATE(2759)] = 73439,
  [SMALL_STATE(2760)] = 73462,
  [SMALL_STATE(2761)] = 73482,
  [SMALL_STATE(2762)] = 73506,
  [SMALL_STATE(2763)] = 73530,
  [SMALL_STATE(2764)] = 73554,
  [SMALL_STATE(2765)] = 73583,
  [SMALL_STATE(2766)] = 73597,
  [SMALL_STATE(2767)] = 73619,
  [SMALL_STATE(2768)] = 73641,
  [SMALL_STATE(2769)] = 73655,
  [SMALL_STATE(2770)] = 73669,
  [SMALL_STATE(2771)] = 73689,
  [SMALL_STATE(2772)] = 73709,
  [SMALL_STATE(2773)] = 73725,
  [SMALL_STATE(2774)] = 73745,
  [SMALL_STATE(2775)] = 73769,
  [SMALL_STATE(2776)] = 73788,
  [SMALL_STATE(2777)] = 73807,
  [SMALL_STATE(2778)] = 73826,
  [SMALL_STATE(2779)] = 73849,
  [SMALL_STATE(2780)] = 73868,
  [SMALL_STATE(2781)] = 73887,
  [SMALL_STATE(2782)] = 73906,
  [SMALL_STATE(2783)] = 73925,
  [SMALL_STATE(2784)] = 73944,
  [SMALL_STATE(2785)] = 73963,
  [SMALL_STATE(2786)] = 73982,
  [SMALL_STATE(2787)] = 74001,
  [SMALL_STATE(2788)] = 74020,
  [SMALL_STATE(2789)] = 74039,
  [SMALL_STATE(2790)] = 74058,
  [SMALL_STATE(2791)] = 74077,
  [SMALL_STATE(2792)] = 74096,
  [SMALL_STATE(2793)] = 74119,
  [SMALL_STATE(2794)] = 74140,
  [SMALL_STATE(2795)] = 74161,
  [SMALL_STATE(2796)] = 74182,
  [SMALL_STATE(2797)] = 74201,
  [SMALL_STATE(2798)] = 74222,
  [SMALL_STATE(2799)] = 74243,
  [SMALL_STATE(2800)] = 74264,
  [SMALL_STATE(2801)] = 74287,
  [SMALL_STATE(2802)] = 74308,
  [SMALL_STATE(2803)] = 74327,
  [SMALL_STATE(2804)] = 74346,
  [SMALL_STATE(2805)] = 74365,
  [SMALL_STATE(2806)] = 74382,
  [SMALL_STATE(2807)] = 74403,
  [SMALL_STATE(2808)] = 74424,
  [SMALL_STATE(2809)] = 74445,
  [SMALL_STATE(2810)] = 74466,
  [SMALL_STATE(2811)] = 74487,
  [SMALL_STATE(2812)] = 74508,
  [SMALL_STATE(2813)] = 74529,
  [SMALL_STATE(2814)] = 74550,
  [SMALL_STATE(2815)] = 74571,
  [SMALL_STATE(2816)] = 74590,
  [SMALL_STATE(2817)] = 74611,
  [SMALL_STATE(2818)] = 74632,
  [SMALL_STATE(2819)] = 74653,
  [SMALL_STATE(2820)] = 74674,
  [SMALL_STATE(2821)] = 74695,
  [SMALL_STATE(2822)] = 74714,
  [SMALL_STATE(2823)] = 74735,
  [SMALL_STATE(2824)] = 74756,
  [SMALL_STATE(2825)] = 74777,
  [SMALL_STATE(2826)] = 74798,
  [SMALL_STATE(2827)] = 74819,
  [SMALL_STATE(2828)] = 74838,
  [SMALL_STATE(2829)] = 74857,
  [SMALL_STATE(2830)] = 74878,
  [SMALL_STATE(2831)] = 74897,
  [SMALL_STATE(2832)] = 74918,
  [SMALL_STATE(2833)] = 74939,
  [SMALL_STATE(2834)] = 74958,
  [SMALL_STATE(2835)] = 74979,
  [SMALL_STATE(2836)] = 74998,
  [SMALL_STATE(2837)] = 75021,
  [SMALL_STATE(2838)] = 75040,
  [SMALL_STATE(2839)] = 75061,
  [SMALL_STATE(2840)] = 75082,
  [SMALL_STATE(2841)] = 75103,
  [SMALL_STATE(2842)] = 75124,
  [SMALL_STATE(2843)] = 75143,
  [SMALL_STATE(2844)] = 75164,
  [SMALL_STATE(2845)] = 75185,
  [SMALL_STATE(2846)] = 75202,
  [SMALL_STATE(2847)] = 75221,
  [SMALL_STATE(2848)] = 75242,
  [SMALL_STATE(2849)] = 75263,
  [SMALL_STATE(2850)] = 75280,
  [SMALL_STATE(2851)] = 75299,
  [SMALL_STATE(2852)] = 75320,
  [SMALL_STATE(2853)] = 75339,
  [SMALL_STATE(2854)] = 75358,
  [SMALL_STATE(2855)] = 75377,
  [SMALL_STATE(2856)] = 75396,
  [SMALL_STATE(2857)] = 75417,
  [SMALL_STATE(2858)] = 75435,
  [SMALL_STATE(2859)] = 75455,
  [SMALL_STATE(2860)] = 75475,
  [SMALL_STATE(2861)] = 75495,
  [SMALL_STATE(2862)] = 75515,
  [SMALL_STATE(2863)] = 75531,
  [SMALL_STATE(2864)] = 75551,
  [SMALL_STATE(2865)] = 75571,
  [SMALL_STATE(2866)] = 75587,
  [SMALL_STATE(2867)] = 75607,
  [SMALL_STATE(2868)] = 75627,
  [SMALL_STATE(2869)] = 75647,
  [SMALL_STATE(2870)] = 75665,
  [SMALL_STATE(2871)] = 75685,
  [SMALL_STATE(2872)] = 75705,
  [SMALL_STATE(2873)] = 75725,
  [SMALL_STATE(2874)] = 75743,
  [SMALL_STATE(2875)] = 75763,
  [SMALL_STATE(2876)] = 75783,
  [SMALL_STATE(2877)] = 75803,
  [SMALL_STATE(2878)] = 75819,
  [SMALL_STATE(2879)] = 75839,
  [SMALL_STATE(2880)] = 75859,
  [SMALL_STATE(2881)] = 75879,
  [SMALL_STATE(2882)] = 75895,
  [SMALL_STATE(2883)] = 75913,
  [SMALL_STATE(2884)] = 75929,
  [SMALL_STATE(2885)] = 75945,
  [SMALL_STATE(2886)] = 75965,
  [SMALL_STATE(2887)] = 75985,
  [SMALL_STATE(2888)] = 76003,
  [SMALL_STATE(2889)] = 76019,
  [SMALL_STATE(2890)] = 76039,
  [SMALL_STATE(2891)] = 76055,
  [SMALL_STATE(2892)] = 76075,
  [SMALL_STATE(2893)] = 76095,
  [SMALL_STATE(2894)] = 76115,
  [SMALL_STATE(2895)] = 76135,
  [SMALL_STATE(2896)] = 76155,
  [SMALL_STATE(2897)] = 76171,
  [SMALL_STATE(2898)] = 76187,
  [SMALL_STATE(2899)] = 76207,
  [SMALL_STATE(2900)] = 76219,
  [SMALL_STATE(2901)] = 76235,
  [SMALL_STATE(2902)] = 76255,
  [SMALL_STATE(2903)] = 76270,
  [SMALL_STATE(2904)] = 76287,
  [SMALL_STATE(2905)] = 76302,
  [SMALL_STATE(2906)] = 76317,
  [SMALL_STATE(2907)] = 76334,
  [SMALL_STATE(2908)] = 76349,
  [SMALL_STATE(2909)] = 76364,
  [SMALL_STATE(2910)] = 76379,
  [SMALL_STATE(2911)] = 76396,
  [SMALL_STATE(2912)] = 76413,
  [SMALL_STATE(2913)] = 76430,
  [SMALL_STATE(2914)] = 76447,
  [SMALL_STATE(2915)] = 76464,
  [SMALL_STATE(2916)] = 76481,
  [SMALL_STATE(2917)] = 76498,
  [SMALL_STATE(2918)] = 76513,
  [SMALL_STATE(2919)] = 76528,
  [SMALL_STATE(2920)] = 76543,
  [SMALL_STATE(2921)] = 76560,
  [SMALL_STATE(2922)] = 76575,
  [SMALL_STATE(2923)] = 76592,
  [SMALL_STATE(2924)] = 76603,
  [SMALL_STATE(2925)] = 76618,
  [SMALL_STATE(2926)] = 76633,
  [SMALL_STATE(2927)] = 76648,
  [SMALL_STATE(2928)] = 76663,
  [SMALL_STATE(2929)] = 76680,
  [SMALL_STATE(2930)] = 76697,
  [SMALL_STATE(2931)] = 76714,
  [SMALL_STATE(2932)] = 76731,
  [SMALL_STATE(2933)] = 76746,
  [SMALL_STATE(2934)] = 76761,
  [SMALL_STATE(2935)] = 76778,
  [SMALL_STATE(2936)] = 76793,
  [SMALL_STATE(2937)] = 76810,
  [SMALL_STATE(2938)] = 76827,
  [SMALL_STATE(2939)] = 76842,
  [SMALL_STATE(2940)] = 76859,
  [SMALL_STATE(2941)] = 76876,
  [SMALL_STATE(2942)] = 76893,
  [SMALL_STATE(2943)] = 76910,
  [SMALL_STATE(2944)] = 76927,
  [SMALL_STATE(2945)] = 76944,
  [SMALL_STATE(2946)] = 76961,
  [SMALL_STATE(2947)] = 76978,
  [SMALL_STATE(2948)] = 76995,
  [SMALL_STATE(2949)] = 77008,
  [SMALL_STATE(2950)] = 77025,
  [SMALL_STATE(2951)] = 77042,
  [SMALL_STATE(2952)] = 77059,
  [SMALL_STATE(2953)] = 77070,
  [SMALL_STATE(2954)] = 77081,
  [SMALL_STATE(2955)] = 77100,
  [SMALL_STATE(2956)] = 77117,
  [SMALL_STATE(2957)] = 77134,
  [SMALL_STATE(2958)] = 77151,
  [SMALL_STATE(2959)] = 77168,
  [SMALL_STATE(2960)] = 77185,
  [SMALL_STATE(2961)] = 77202,
  [SMALL_STATE(2962)] = 77219,
  [SMALL_STATE(2963)] = 77236,
  [SMALL_STATE(2964)] = 77253,
  [SMALL_STATE(2965)] = 77270,
  [SMALL_STATE(2966)] = 77285,
  [SMALL_STATE(2967)] = 77300,
  [SMALL_STATE(2968)] = 77315,
  [SMALL_STATE(2969)] = 77332,
  [SMALL_STATE(2970)] = 77349,
  [SMALL_STATE(2971)] = 77360,
  [SMALL_STATE(2972)] = 77377,
  [SMALL_STATE(2973)] = 77394,
  [SMALL_STATE(2974)] = 77411,
  [SMALL_STATE(2975)] = 77428,
  [SMALL_STATE(2976)] = 77445,
  [SMALL_STATE(2977)] = 77460,
  [SMALL_STATE(2978)] = 77477,
  [SMALL_STATE(2979)] = 77494,
  [SMALL_STATE(2980)] = 77511,
  [SMALL_STATE(2981)] = 77522,
  [SMALL_STATE(2982)] = 77537,
  [SMALL_STATE(2983)] = 77552,
  [SMALL_STATE(2984)] = 77569,
  [SMALL_STATE(2985)] = 77584,
  [SMALL_STATE(2986)] = 77595,
  [SMALL_STATE(2987)] = 77610,
  [SMALL_STATE(2988)] = 77627,
  [SMALL_STATE(2989)] = 77644,
  [SMALL_STATE(2990)] = 77659,
  [SMALL_STATE(2991)] = 77676,
  [SMALL_STATE(2992)] = 77693,
  [SMALL_STATE(2993)] = 77710,
  [SMALL_STATE(2994)] = 77727,
  [SMALL_STATE(2995)] = 77744,
  [SMALL_STATE(2996)] = 77761,
  [SMALL_STATE(2997)] = 77778,
  [SMALL_STATE(2998)] = 77795,
  [SMALL_STATE(2999)] = 77812,
  [SMALL_STATE(3000)] = 77829,
  [SMALL_STATE(3001)] = 77846,
  [SMALL_STATE(3002)] = 77863,
  [SMALL_STATE(3003)] = 77880,
  [SMALL_STATE(3004)] = 77897,
  [SMALL_STATE(3005)] = 77914,
  [SMALL_STATE(3006)] = 77929,
  [SMALL_STATE(3007)] = 77944,
  [SMALL_STATE(3008)] = 77955,
  [SMALL_STATE(3009)] = 77972,
  [SMALL_STATE(3010)] = 77991,
  [SMALL_STATE(3011)] = 78008,
  [SMALL_STATE(3012)] = 78023,
  [SMALL_STATE(3013)] = 78038,
  [SMALL_STATE(3014)] = 78053,
  [SMALL_STATE(3015)] = 78070,
  [SMALL_STATE(3016)] = 78087,
  [SMALL_STATE(3017)] = 78098,
  [SMALL_STATE(3018)] = 78115,
  [SMALL_STATE(3019)] = 78132,
  [SMALL_STATE(3020)] = 78149,
  [SMALL_STATE(3021)] = 78166,
  [SMALL_STATE(3022)] = 78183,
  [SMALL_STATE(3023)] = 78198,
  [SMALL_STATE(3024)] = 78215,
  [SMALL_STATE(3025)] = 78230,
  [SMALL_STATE(3026)] = 78245,
  [SMALL_STATE(3027)] = 78262,
  [SMALL_STATE(3028)] = 78279,
  [SMALL_STATE(3029)] = 78296,
  [SMALL_STATE(3030)] = 78311,
  [SMALL_STATE(3031)] = 78330,
  [SMALL_STATE(3032)] = 78347,
  [SMALL_STATE(3033)] = 78358,
  [SMALL_STATE(3034)] = 78375,
  [SMALL_STATE(3035)] = 78392,
  [SMALL_STATE(3036)] = 78409,
  [SMALL_STATE(3037)] = 78420,
  [SMALL_STATE(3038)] = 78431,
  [SMALL_STATE(3039)] = 78448,
  [SMALL_STATE(3040)] = 78465,
  [SMALL_STATE(3041)] = 78476,
  [SMALL_STATE(3042)] = 78487,
  [SMALL_STATE(3043)] = 78498,
  [SMALL_STATE(3044)] = 78509,
  [SMALL_STATE(3045)] = 78520,
  [SMALL_STATE(3046)] = 78531,
  [SMALL_STATE(3047)] = 78548,
  [SMALL_STATE(3048)] = 78559,
  [SMALL_STATE(3049)] = 78570,
  [SMALL_STATE(3050)] = 78581,
  [SMALL_STATE(3051)] = 78592,
  [SMALL_STATE(3052)] = 78603,
  [SMALL_STATE(3053)] = 78614,
  [SMALL_STATE(3054)] = 78625,
  [SMALL_STATE(3055)] = 78636,
  [SMALL_STATE(3056)] = 78653,
  [SMALL_STATE(3057)] = 78664,
  [SMALL_STATE(3058)] = 78679,
  [SMALL_STATE(3059)] = 78694,
  [SMALL_STATE(3060)] = 78705,
  [SMALL_STATE(3061)] = 78716,
  [SMALL_STATE(3062)] = 78727,
  [SMALL_STATE(3063)] = 78738,
  [SMALL_STATE(3064)] = 78752,
  [SMALL_STATE(3065)] = 78766,
  [SMALL_STATE(3066)] = 78780,
  [SMALL_STATE(3067)] = 78794,
  [SMALL_STATE(3068)] = 78808,
  [SMALL_STATE(3069)] = 78822,
  [SMALL_STATE(3070)] = 78836,
  [SMALL_STATE(3071)] = 78850,
  [SMALL_STATE(3072)] = 78864,
  [SMALL_STATE(3073)] = 78878,
  [SMALL_STATE(3074)] = 78892,
  [SMALL_STATE(3075)] = 78906,
  [SMALL_STATE(3076)] = 78920,
  [SMALL_STATE(3077)] = 78934,
  [SMALL_STATE(3078)] = 78948,
  [SMALL_STATE(3079)] = 78962,
  [SMALL_STATE(3080)] = 78976,
  [SMALL_STATE(3081)] = 78990,
  [SMALL_STATE(3082)] = 79004,
  [SMALL_STATE(3083)] = 79018,
  [SMALL_STATE(3084)] = 79032,
  [SMALL_STATE(3085)] = 79046,
  [SMALL_STATE(3086)] = 79060,
  [SMALL_STATE(3087)] = 79074,
  [SMALL_STATE(3088)] = 79088,
  [SMALL_STATE(3089)] = 79102,
  [SMALL_STATE(3090)] = 79116,
  [SMALL_STATE(3091)] = 79130,
  [SMALL_STATE(3092)] = 79144,
  [SMALL_STATE(3093)] = 79156,
  [SMALL_STATE(3094)] = 79170,
  [SMALL_STATE(3095)] = 79184,
  [SMALL_STATE(3096)] = 79198,
  [SMALL_STATE(3097)] = 79212,
  [SMALL_STATE(3098)] = 79226,
  [SMALL_STATE(3099)] = 79240,
  [SMALL_STATE(3100)] = 79254,
  [SMALL_STATE(3101)] = 79268,
  [SMALL_STATE(3102)] = 79282,
  [SMALL_STATE(3103)] = 79296,
  [SMALL_STATE(3104)] = 79310,
  [SMALL_STATE(3105)] = 79320,
  [SMALL_STATE(3106)] = 79334,
  [SMALL_STATE(3107)] = 79348,
  [SMALL_STATE(3108)] = 79362,
  [SMALL_STATE(3109)] = 79376,
  [SMALL_STATE(3110)] = 79390,
  [SMALL_STATE(3111)] = 79404,
  [SMALL_STATE(3112)] = 79416,
  [SMALL_STATE(3113)] = 79430,
  [SMALL_STATE(3114)] = 79444,
  [SMALL_STATE(3115)] = 79458,
  [SMALL_STATE(3116)] = 79472,
  [SMALL_STATE(3117)] = 79486,
  [SMALL_STATE(3118)] = 79500,
  [SMALL_STATE(3119)] = 79514,
  [SMALL_STATE(3120)] = 79528,
  [SMALL_STATE(3121)] = 79542,
  [SMALL_STATE(3122)] = 79556,
  [SMALL_STATE(3123)] = 79568,
  [SMALL_STATE(3124)] = 79582,
  [SMALL_STATE(3125)] = 79596,
  [SMALL_STATE(3126)] = 79610,
  [SMALL_STATE(3127)] = 79624,
  [SMALL_STATE(3128)] = 79638,
  [SMALL_STATE(3129)] = 79652,
  [SMALL_STATE(3130)] = 79666,
  [SMALL_STATE(3131)] = 79676,
  [SMALL_STATE(3132)] = 79690,
  [SMALL_STATE(3133)] = 79704,
  [SMALL_STATE(3134)] = 79718,
  [SMALL_STATE(3135)] = 79732,
  [SMALL_STATE(3136)] = 79744,
  [SMALL_STATE(3137)] = 79758,
  [SMALL_STATE(3138)] = 79772,
  [SMALL_STATE(3139)] = 79786,
  [SMALL_STATE(3140)] = 79798,
  [SMALL_STATE(3141)] = 79812,
  [SMALL_STATE(3142)] = 79826,
  [SMALL_STATE(3143)] = 79840,
  [SMALL_STATE(3144)] = 79854,
  [SMALL_STATE(3145)] = 79868,
  [SMALL_STATE(3146)] = 79882,
  [SMALL_STATE(3147)] = 79896,
  [SMALL_STATE(3148)] = 79910,
  [SMALL_STATE(3149)] = 79924,
  [SMALL_STATE(3150)] = 79938,
  [SMALL_STATE(3151)] = 79952,
  [SMALL_STATE(3152)] = 79966,
  [SMALL_STATE(3153)] = 79980,
  [SMALL_STATE(3154)] = 79994,
  [SMALL_STATE(3155)] = 80008,
  [SMALL_STATE(3156)] = 80022,
  [SMALL_STATE(3157)] = 80036,
  [SMALL_STATE(3158)] = 80050,
  [SMALL_STATE(3159)] = 80064,
  [SMALL_STATE(3160)] = 80078,
  [SMALL_STATE(3161)] = 80092,
  [SMALL_STATE(3162)] = 80106,
  [SMALL_STATE(3163)] = 80120,
  [SMALL_STATE(3164)] = 80134,
  [SMALL_STATE(3165)] = 80148,
  [SMALL_STATE(3166)] = 80162,
  [SMALL_STATE(3167)] = 80176,
  [SMALL_STATE(3168)] = 80190,
  [SMALL_STATE(3169)] = 80204,
  [SMALL_STATE(3170)] = 80218,
  [SMALL_STATE(3171)] = 80232,
  [SMALL_STATE(3172)] = 80246,
  [SMALL_STATE(3173)] = 80260,
  [SMALL_STATE(3174)] = 80274,
  [SMALL_STATE(3175)] = 80288,
  [SMALL_STATE(3176)] = 80302,
  [SMALL_STATE(3177)] = 80316,
  [SMALL_STATE(3178)] = 80330,
  [SMALL_STATE(3179)] = 80344,
  [SMALL_STATE(3180)] = 80358,
  [SMALL_STATE(3181)] = 80372,
  [SMALL_STATE(3182)] = 80386,
  [SMALL_STATE(3183)] = 80400,
  [SMALL_STATE(3184)] = 80412,
  [SMALL_STATE(3185)] = 80426,
  [SMALL_STATE(3186)] = 80440,
  [SMALL_STATE(3187)] = 80450,
  [SMALL_STATE(3188)] = 80464,
  [SMALL_STATE(3189)] = 80478,
  [SMALL_STATE(3190)] = 80492,
  [SMALL_STATE(3191)] = 80506,
  [SMALL_STATE(3192)] = 80520,
  [SMALL_STATE(3193)] = 80534,
  [SMALL_STATE(3194)] = 80548,
  [SMALL_STATE(3195)] = 80562,
  [SMALL_STATE(3196)] = 80576,
  [SMALL_STATE(3197)] = 80590,
  [SMALL_STATE(3198)] = 80604,
  [SMALL_STATE(3199)] = 80618,
  [SMALL_STATE(3200)] = 80632,
  [SMALL_STATE(3201)] = 80646,
  [SMALL_STATE(3202)] = 80660,
  [SMALL_STATE(3203)] = 80674,
  [SMALL_STATE(3204)] = 80688,
  [SMALL_STATE(3205)] = 80702,
  [SMALL_STATE(3206)] = 80716,
  [SMALL_STATE(3207)] = 80730,
  [SMALL_STATE(3208)] = 80744,
  [SMALL_STATE(3209)] = 80758,
  [SMALL_STATE(3210)] = 80772,
  [SMALL_STATE(3211)] = 80786,
  [SMALL_STATE(3212)] = 80800,
  [SMALL_STATE(3213)] = 80814,
  [SMALL_STATE(3214)] = 80828,
  [SMALL_STATE(3215)] = 80842,
  [SMALL_STATE(3216)] = 80856,
  [SMALL_STATE(3217)] = 80870,
  [SMALL_STATE(3218)] = 80884,
  [SMALL_STATE(3219)] = 80898,
  [SMALL_STATE(3220)] = 80912,
  [SMALL_STATE(3221)] = 80926,
  [SMALL_STATE(3222)] = 80940,
  [SMALL_STATE(3223)] = 80952,
  [SMALL_STATE(3224)] = 80966,
  [SMALL_STATE(3225)] = 80980,
  [SMALL_STATE(3226)] = 80994,
  [SMALL_STATE(3227)] = 81008,
  [SMALL_STATE(3228)] = 81022,
  [SMALL_STATE(3229)] = 81036,
  [SMALL_STATE(3230)] = 81050,
  [SMALL_STATE(3231)] = 81064,
  [SMALL_STATE(3232)] = 81078,
  [SMALL_STATE(3233)] = 81092,
  [SMALL_STATE(3234)] = 81106,
  [SMALL_STATE(3235)] = 81120,
  [SMALL_STATE(3236)] = 81134,
  [SMALL_STATE(3237)] = 81148,
  [SMALL_STATE(3238)] = 81162,
  [SMALL_STATE(3239)] = 81174,
  [SMALL_STATE(3240)] = 81188,
  [SMALL_STATE(3241)] = 81202,
  [SMALL_STATE(3242)] = 81216,
  [SMALL_STATE(3243)] = 81230,
  [SMALL_STATE(3244)] = 81244,
  [SMALL_STATE(3245)] = 81254,
  [SMALL_STATE(3246)] = 81268,
  [SMALL_STATE(3247)] = 81282,
  [SMALL_STATE(3248)] = 81296,
  [SMALL_STATE(3249)] = 81308,
  [SMALL_STATE(3250)] = 81322,
  [SMALL_STATE(3251)] = 81336,
  [SMALL_STATE(3252)] = 81350,
  [SMALL_STATE(3253)] = 81364,
  [SMALL_STATE(3254)] = 81378,
  [SMALL_STATE(3255)] = 81392,
  [SMALL_STATE(3256)] = 81406,
  [SMALL_STATE(3257)] = 81420,
  [SMALL_STATE(3258)] = 81434,
  [SMALL_STATE(3259)] = 81448,
  [SMALL_STATE(3260)] = 81460,
  [SMALL_STATE(3261)] = 81474,
  [SMALL_STATE(3262)] = 81488,
  [SMALL_STATE(3263)] = 81502,
  [SMALL_STATE(3264)] = 81516,
  [SMALL_STATE(3265)] = 81530,
  [SMALL_STATE(3266)] = 81544,
  [SMALL_STATE(3267)] = 81558,
  [SMALL_STATE(3268)] = 81572,
  [SMALL_STATE(3269)] = 81586,
  [SMALL_STATE(3270)] = 81600,
  [SMALL_STATE(3271)] = 81614,
  [SMALL_STATE(3272)] = 81628,
  [SMALL_STATE(3273)] = 81642,
  [SMALL_STATE(3274)] = 81656,
  [SMALL_STATE(3275)] = 81666,
  [SMALL_STATE(3276)] = 81680,
  [SMALL_STATE(3277)] = 81694,
  [SMALL_STATE(3278)] = 81708,
  [SMALL_STATE(3279)] = 81722,
  [SMALL_STATE(3280)] = 81736,
  [SMALL_STATE(3281)] = 81750,
  [SMALL_STATE(3282)] = 81764,
  [SMALL_STATE(3283)] = 81778,
  [SMALL_STATE(3284)] = 81792,
  [SMALL_STATE(3285)] = 81806,
  [SMALL_STATE(3286)] = 81820,
  [SMALL_STATE(3287)] = 81834,
  [SMALL_STATE(3288)] = 81848,
  [SMALL_STATE(3289)] = 81862,
  [SMALL_STATE(3290)] = 81876,
  [SMALL_STATE(3291)] = 81890,
  [SMALL_STATE(3292)] = 81904,
  [SMALL_STATE(3293)] = 81918,
  [SMALL_STATE(3294)] = 81932,
  [SMALL_STATE(3295)] = 81946,
  [SMALL_STATE(3296)] = 81960,
  [SMALL_STATE(3297)] = 81974,
  [SMALL_STATE(3298)] = 81988,
  [SMALL_STATE(3299)] = 82002,
  [SMALL_STATE(3300)] = 82016,
  [SMALL_STATE(3301)] = 82030,
  [SMALL_STATE(3302)] = 82044,
  [SMALL_STATE(3303)] = 82058,
  [SMALL_STATE(3304)] = 82072,
  [SMALL_STATE(3305)] = 82082,
  [SMALL_STATE(3306)] = 82096,
  [SMALL_STATE(3307)] = 82108,
  [SMALL_STATE(3308)] = 82122,
  [SMALL_STATE(3309)] = 82136,
  [SMALL_STATE(3310)] = 82150,
  [SMALL_STATE(3311)] = 82164,
  [SMALL_STATE(3312)] = 82178,
  [SMALL_STATE(3313)] = 82192,
  [SMALL_STATE(3314)] = 82206,
  [SMALL_STATE(3315)] = 82220,
  [SMALL_STATE(3316)] = 82234,
  [SMALL_STATE(3317)] = 82244,
  [SMALL_STATE(3318)] = 82258,
  [SMALL_STATE(3319)] = 82272,
  [SMALL_STATE(3320)] = 82286,
  [SMALL_STATE(3321)] = 82296,
  [SMALL_STATE(3322)] = 82310,
  [SMALL_STATE(3323)] = 82320,
  [SMALL_STATE(3324)] = 82332,
  [SMALL_STATE(3325)] = 82346,
  [SMALL_STATE(3326)] = 82360,
  [SMALL_STATE(3327)] = 82374,
  [SMALL_STATE(3328)] = 82388,
  [SMALL_STATE(3329)] = 82402,
  [SMALL_STATE(3330)] = 82412,
  [SMALL_STATE(3331)] = 82426,
  [SMALL_STATE(3332)] = 82440,
  [SMALL_STATE(3333)] = 82454,
  [SMALL_STATE(3334)] = 82468,
  [SMALL_STATE(3335)] = 82482,
  [SMALL_STATE(3336)] = 82496,
  [SMALL_STATE(3337)] = 82510,
  [SMALL_STATE(3338)] = 82524,
  [SMALL_STATE(3339)] = 82538,
  [SMALL_STATE(3340)] = 82552,
  [SMALL_STATE(3341)] = 82566,
  [SMALL_STATE(3342)] = 82580,
  [SMALL_STATE(3343)] = 82594,
  [SMALL_STATE(3344)] = 82604,
  [SMALL_STATE(3345)] = 82618,
  [SMALL_STATE(3346)] = 82632,
  [SMALL_STATE(3347)] = 82646,
  [SMALL_STATE(3348)] = 82660,
  [SMALL_STATE(3349)] = 82674,
  [SMALL_STATE(3350)] = 82688,
  [SMALL_STATE(3351)] = 82702,
  [SMALL_STATE(3352)] = 82716,
  [SMALL_STATE(3353)] = 82730,
  [SMALL_STATE(3354)] = 82744,
  [SMALL_STATE(3355)] = 82758,
  [SMALL_STATE(3356)] = 82772,
  [SMALL_STATE(3357)] = 82786,
  [SMALL_STATE(3358)] = 82800,
  [SMALL_STATE(3359)] = 82810,
  [SMALL_STATE(3360)] = 82820,
  [SMALL_STATE(3361)] = 82832,
  [SMALL_STATE(3362)] = 82846,
  [SMALL_STATE(3363)] = 82858,
  [SMALL_STATE(3364)] = 82872,
  [SMALL_STATE(3365)] = 82886,
  [SMALL_STATE(3366)] = 82900,
  [SMALL_STATE(3367)] = 82914,
  [SMALL_STATE(3368)] = 82928,
  [SMALL_STATE(3369)] = 82942,
  [SMALL_STATE(3370)] = 82956,
  [SMALL_STATE(3371)] = 82970,
  [SMALL_STATE(3372)] = 82984,
  [SMALL_STATE(3373)] = 82998,
  [SMALL_STATE(3374)] = 83012,
  [SMALL_STATE(3375)] = 83026,
  [SMALL_STATE(3376)] = 83040,
  [SMALL_STATE(3377)] = 83054,
  [SMALL_STATE(3378)] = 83068,
  [SMALL_STATE(3379)] = 83082,
  [SMALL_STATE(3380)] = 83096,
  [SMALL_STATE(3381)] = 83110,
  [SMALL_STATE(3382)] = 83124,
  [SMALL_STATE(3383)] = 83138,
  [SMALL_STATE(3384)] = 83152,
  [SMALL_STATE(3385)] = 83166,
  [SMALL_STATE(3386)] = 83180,
  [SMALL_STATE(3387)] = 83194,
  [SMALL_STATE(3388)] = 83204,
  [SMALL_STATE(3389)] = 83218,
  [SMALL_STATE(3390)] = 83232,
  [SMALL_STATE(3391)] = 83246,
  [SMALL_STATE(3392)] = 83260,
  [SMALL_STATE(3393)] = 83270,
  [SMALL_STATE(3394)] = 83280,
  [SMALL_STATE(3395)] = 83294,
  [SMALL_STATE(3396)] = 83306,
  [SMALL_STATE(3397)] = 83320,
  [SMALL_STATE(3398)] = 83334,
  [SMALL_STATE(3399)] = 83344,
  [SMALL_STATE(3400)] = 83358,
  [SMALL_STATE(3401)] = 83372,
  [SMALL_STATE(3402)] = 83386,
  [SMALL_STATE(3403)] = 83396,
  [SMALL_STATE(3404)] = 83410,
  [SMALL_STATE(3405)] = 83420,
  [SMALL_STATE(3406)] = 83434,
  [SMALL_STATE(3407)] = 83448,
  [SMALL_STATE(3408)] = 83458,
  [SMALL_STATE(3409)] = 83472,
  [SMALL_STATE(3410)] = 83482,
  [SMALL_STATE(3411)] = 83496,
  [SMALL_STATE(3412)] = 83510,
  [SMALL_STATE(3413)] = 83524,
  [SMALL_STATE(3414)] = 83538,
  [SMALL_STATE(3415)] = 83548,
  [SMALL_STATE(3416)] = 83562,
  [SMALL_STATE(3417)] = 83576,
  [SMALL_STATE(3418)] = 83590,
  [SMALL_STATE(3419)] = 83604,
  [SMALL_STATE(3420)] = 83618,
  [SMALL_STATE(3421)] = 83632,
  [SMALL_STATE(3422)] = 83646,
  [SMALL_STATE(3423)] = 83660,
  [SMALL_STATE(3424)] = 83670,
  [SMALL_STATE(3425)] = 83680,
  [SMALL_STATE(3426)] = 83690,
  [SMALL_STATE(3427)] = 83702,
  [SMALL_STATE(3428)] = 83716,
  [SMALL_STATE(3429)] = 83726,
  [SMALL_STATE(3430)] = 83740,
  [SMALL_STATE(3431)] = 83754,
  [SMALL_STATE(3432)] = 83768,
  [SMALL_STATE(3433)] = 83782,
  [SMALL_STATE(3434)] = 83792,
  [SMALL_STATE(3435)] = 83806,
  [SMALL_STATE(3436)] = 83820,
  [SMALL_STATE(3437)] = 83834,
  [SMALL_STATE(3438)] = 83848,
  [SMALL_STATE(3439)] = 83862,
  [SMALL_STATE(3440)] = 83876,
  [SMALL_STATE(3441)] = 83890,
  [SMALL_STATE(3442)] = 83904,
  [SMALL_STATE(3443)] = 83918,
  [SMALL_STATE(3444)] = 83932,
  [SMALL_STATE(3445)] = 83946,
  [SMALL_STATE(3446)] = 83960,
  [SMALL_STATE(3447)] = 83974,
  [SMALL_STATE(3448)] = 83988,
  [SMALL_STATE(3449)] = 84002,
  [SMALL_STATE(3450)] = 84016,
  [SMALL_STATE(3451)] = 84030,
  [SMALL_STATE(3452)] = 84044,
  [SMALL_STATE(3453)] = 84058,
  [SMALL_STATE(3454)] = 84072,
  [SMALL_STATE(3455)] = 84086,
  [SMALL_STATE(3456)] = 84100,
  [SMALL_STATE(3457)] = 84114,
  [SMALL_STATE(3458)] = 84128,
  [SMALL_STATE(3459)] = 84142,
  [SMALL_STATE(3460)] = 84156,
  [SMALL_STATE(3461)] = 84170,
  [SMALL_STATE(3462)] = 84184,
  [SMALL_STATE(3463)] = 84198,
  [SMALL_STATE(3464)] = 84212,
  [SMALL_STATE(3465)] = 84226,
  [SMALL_STATE(3466)] = 84240,
  [SMALL_STATE(3467)] = 84254,
  [SMALL_STATE(3468)] = 84268,
  [SMALL_STATE(3469)] = 84282,
  [SMALL_STATE(3470)] = 84296,
  [SMALL_STATE(3471)] = 84310,
  [SMALL_STATE(3472)] = 84324,
  [SMALL_STATE(3473)] = 84336,
  [SMALL_STATE(3474)] = 84350,
  [SMALL_STATE(3475)] = 84364,
  [SMALL_STATE(3476)] = 84378,
  [SMALL_STATE(3477)] = 84392,
  [SMALL_STATE(3478)] = 84406,
  [SMALL_STATE(3479)] = 84420,
  [SMALL_STATE(3480)] = 84434,
  [SMALL_STATE(3481)] = 84448,
  [SMALL_STATE(3482)] = 84462,
  [SMALL_STATE(3483)] = 84476,
  [SMALL_STATE(3484)] = 84490,
  [SMALL_STATE(3485)] = 84504,
  [SMALL_STATE(3486)] = 84518,
  [SMALL_STATE(3487)] = 84532,
  [SMALL_STATE(3488)] = 84546,
  [SMALL_STATE(3489)] = 84560,
  [SMALL_STATE(3490)] = 84574,
  [SMALL_STATE(3491)] = 84588,
  [SMALL_STATE(3492)] = 84602,
  [SMALL_STATE(3493)] = 84616,
  [SMALL_STATE(3494)] = 84630,
  [SMALL_STATE(3495)] = 84644,
  [SMALL_STATE(3496)] = 84658,
  [SMALL_STATE(3497)] = 84672,
  [SMALL_STATE(3498)] = 84686,
  [SMALL_STATE(3499)] = 84700,
  [SMALL_STATE(3500)] = 84714,
  [SMALL_STATE(3501)] = 84724,
  [SMALL_STATE(3502)] = 84738,
  [SMALL_STATE(3503)] = 84752,
  [SMALL_STATE(3504)] = 84766,
  [SMALL_STATE(3505)] = 84780,
  [SMALL_STATE(3506)] = 84794,
  [SMALL_STATE(3507)] = 84808,
  [SMALL_STATE(3508)] = 84822,
  [SMALL_STATE(3509)] = 84836,
  [SMALL_STATE(3510)] = 84850,
  [SMALL_STATE(3511)] = 84864,
  [SMALL_STATE(3512)] = 84878,
  [SMALL_STATE(3513)] = 84892,
  [SMALL_STATE(3514)] = 84906,
  [SMALL_STATE(3515)] = 84920,
  [SMALL_STATE(3516)] = 84934,
  [SMALL_STATE(3517)] = 84948,
  [SMALL_STATE(3518)] = 84962,
  [SMALL_STATE(3519)] = 84976,
  [SMALL_STATE(3520)] = 84990,
  [SMALL_STATE(3521)] = 85004,
  [SMALL_STATE(3522)] = 85018,
  [SMALL_STATE(3523)] = 85032,
  [SMALL_STATE(3524)] = 85046,
  [SMALL_STATE(3525)] = 85060,
  [SMALL_STATE(3526)] = 85072,
  [SMALL_STATE(3527)] = 85086,
  [SMALL_STATE(3528)] = 85100,
  [SMALL_STATE(3529)] = 85114,
  [SMALL_STATE(3530)] = 85128,
  [SMALL_STATE(3531)] = 85142,
  [SMALL_STATE(3532)] = 85156,
  [SMALL_STATE(3533)] = 85170,
  [SMALL_STATE(3534)] = 85184,
  [SMALL_STATE(3535)] = 85198,
  [SMALL_STATE(3536)] = 85212,
  [SMALL_STATE(3537)] = 85226,
  [SMALL_STATE(3538)] = 85240,
  [SMALL_STATE(3539)] = 85254,
  [SMALL_STATE(3540)] = 85268,
  [SMALL_STATE(3541)] = 85282,
  [SMALL_STATE(3542)] = 85296,
  [SMALL_STATE(3543)] = 85310,
  [SMALL_STATE(3544)] = 85324,
  [SMALL_STATE(3545)] = 85338,
  [SMALL_STATE(3546)] = 85352,
  [SMALL_STATE(3547)] = 85366,
  [SMALL_STATE(3548)] = 85380,
  [SMALL_STATE(3549)] = 85394,
  [SMALL_STATE(3550)] = 85408,
  [SMALL_STATE(3551)] = 85422,
  [SMALL_STATE(3552)] = 85436,
  [SMALL_STATE(3553)] = 85450,
  [SMALL_STATE(3554)] = 85464,
  [SMALL_STATE(3555)] = 85478,
  [SMALL_STATE(3556)] = 85492,
  [SMALL_STATE(3557)] = 85506,
  [SMALL_STATE(3558)] = 85516,
  [SMALL_STATE(3559)] = 85530,
  [SMALL_STATE(3560)] = 85544,
  [SMALL_STATE(3561)] = 85558,
  [SMALL_STATE(3562)] = 85572,
  [SMALL_STATE(3563)] = 85586,
  [SMALL_STATE(3564)] = 85600,
  [SMALL_STATE(3565)] = 85614,
  [SMALL_STATE(3566)] = 85628,
  [SMALL_STATE(3567)] = 85640,
  [SMALL_STATE(3568)] = 85654,
  [SMALL_STATE(3569)] = 85666,
  [SMALL_STATE(3570)] = 85680,
  [SMALL_STATE(3571)] = 85694,
  [SMALL_STATE(3572)] = 85708,
  [SMALL_STATE(3573)] = 85722,
  [SMALL_STATE(3574)] = 85734,
  [SMALL_STATE(3575)] = 85748,
  [SMALL_STATE(3576)] = 85762,
  [SMALL_STATE(3577)] = 85776,
  [SMALL_STATE(3578)] = 85790,
  [SMALL_STATE(3579)] = 85801,
  [SMALL_STATE(3580)] = 85812,
  [SMALL_STATE(3581)] = 85823,
  [SMALL_STATE(3582)] = 85834,
  [SMALL_STATE(3583)] = 85845,
  [SMALL_STATE(3584)] = 85856,
  [SMALL_STATE(3585)] = 85867,
  [SMALL_STATE(3586)] = 85878,
  [SMALL_STATE(3587)] = 85887,
  [SMALL_STATE(3588)] = 85898,
  [SMALL_STATE(3589)] = 85909,
  [SMALL_STATE(3590)] = 85920,
  [SMALL_STATE(3591)] = 85931,
  [SMALL_STATE(3592)] = 85942,
  [SMALL_STATE(3593)] = 85953,
  [SMALL_STATE(3594)] = 85964,
  [SMALL_STATE(3595)] = 85975,
  [SMALL_STATE(3596)] = 85986,
  [SMALL_STATE(3597)] = 85997,
  [SMALL_STATE(3598)] = 86008,
  [SMALL_STATE(3599)] = 86019,
  [SMALL_STATE(3600)] = 86030,
  [SMALL_STATE(3601)] = 86039,
  [SMALL_STATE(3602)] = 86050,
  [SMALL_STATE(3603)] = 86061,
  [SMALL_STATE(3604)] = 86072,
  [SMALL_STATE(3605)] = 86083,
  [SMALL_STATE(3606)] = 86094,
  [SMALL_STATE(3607)] = 86105,
  [SMALL_STATE(3608)] = 86114,
  [SMALL_STATE(3609)] = 86125,
  [SMALL_STATE(3610)] = 86136,
  [SMALL_STATE(3611)] = 86147,
  [SMALL_STATE(3612)] = 86158,
  [SMALL_STATE(3613)] = 86169,
  [SMALL_STATE(3614)] = 86180,
  [SMALL_STATE(3615)] = 86191,
  [SMALL_STATE(3616)] = 86202,
  [SMALL_STATE(3617)] = 86213,
  [SMALL_STATE(3618)] = 86224,
  [SMALL_STATE(3619)] = 86235,
  [SMALL_STATE(3620)] = 86246,
  [SMALL_STATE(3621)] = 86257,
  [SMALL_STATE(3622)] = 86266,
  [SMALL_STATE(3623)] = 86277,
  [SMALL_STATE(3624)] = 86288,
  [SMALL_STATE(3625)] = 86299,
  [SMALL_STATE(3626)] = 86310,
  [SMALL_STATE(3627)] = 86321,
  [SMALL_STATE(3628)] = 86332,
  [SMALL_STATE(3629)] = 86343,
  [SMALL_STATE(3630)] = 86354,
  [SMALL_STATE(3631)] = 86365,
  [SMALL_STATE(3632)] = 86376,
  [SMALL_STATE(3633)] = 86387,
  [SMALL_STATE(3634)] = 86398,
  [SMALL_STATE(3635)] = 86409,
  [SMALL_STATE(3636)] = 86420,
  [SMALL_STATE(3637)] = 86429,
  [SMALL_STATE(3638)] = 86440,
  [SMALL_STATE(3639)] = 86451,
  [SMALL_STATE(3640)] = 86462,
  [SMALL_STATE(3641)] = 86473,
  [SMALL_STATE(3642)] = 86484,
  [SMALL_STATE(3643)] = 86495,
  [SMALL_STATE(3644)] = 86506,
  [SMALL_STATE(3645)] = 86517,
  [SMALL_STATE(3646)] = 86528,
  [SMALL_STATE(3647)] = 86539,
  [SMALL_STATE(3648)] = 86550,
  [SMALL_STATE(3649)] = 86561,
  [SMALL_STATE(3650)] = 86572,
  [SMALL_STATE(3651)] = 86583,
  [SMALL_STATE(3652)] = 86594,
  [SMALL_STATE(3653)] = 86605,
  [SMALL_STATE(3654)] = 86616,
  [SMALL_STATE(3655)] = 86627,
  [SMALL_STATE(3656)] = 86638,
  [SMALL_STATE(3657)] = 86649,
  [SMALL_STATE(3658)] = 86660,
  [SMALL_STATE(3659)] = 86671,
  [SMALL_STATE(3660)] = 86682,
  [SMALL_STATE(3661)] = 86693,
  [SMALL_STATE(3662)] = 86704,
  [SMALL_STATE(3663)] = 86715,
  [SMALL_STATE(3664)] = 86726,
  [SMALL_STATE(3665)] = 86737,
  [SMALL_STATE(3666)] = 86748,
  [SMALL_STATE(3667)] = 86759,
  [SMALL_STATE(3668)] = 86770,
  [SMALL_STATE(3669)] = 86779,
  [SMALL_STATE(3670)] = 86790,
  [SMALL_STATE(3671)] = 86801,
  [SMALL_STATE(3672)] = 86812,
  [SMALL_STATE(3673)] = 86823,
  [SMALL_STATE(3674)] = 86834,
  [SMALL_STATE(3675)] = 86845,
  [SMALL_STATE(3676)] = 86856,
  [SMALL_STATE(3677)] = 86867,
  [SMALL_STATE(3678)] = 86878,
  [SMALL_STATE(3679)] = 86889,
  [SMALL_STATE(3680)] = 86900,
  [SMALL_STATE(3681)] = 86911,
  [SMALL_STATE(3682)] = 86922,
  [SMALL_STATE(3683)] = 86933,
  [SMALL_STATE(3684)] = 86944,
  [SMALL_STATE(3685)] = 86955,
  [SMALL_STATE(3686)] = 86966,
  [SMALL_STATE(3687)] = 86977,
  [SMALL_STATE(3688)] = 86988,
  [SMALL_STATE(3689)] = 86999,
  [SMALL_STATE(3690)] = 87010,
  [SMALL_STATE(3691)] = 87021,
  [SMALL_STATE(3692)] = 87032,
  [SMALL_STATE(3693)] = 87043,
  [SMALL_STATE(3694)] = 87054,
  [SMALL_STATE(3695)] = 87065,
  [SMALL_STATE(3696)] = 87076,
  [SMALL_STATE(3697)] = 87087,
  [SMALL_STATE(3698)] = 87098,
  [SMALL_STATE(3699)] = 87109,
  [SMALL_STATE(3700)] = 87120,
  [SMALL_STATE(3701)] = 87131,
  [SMALL_STATE(3702)] = 87142,
  [SMALL_STATE(3703)] = 87153,
  [SMALL_STATE(3704)] = 87164,
  [SMALL_STATE(3705)] = 87175,
  [SMALL_STATE(3706)] = 87186,
  [SMALL_STATE(3707)] = 87197,
  [SMALL_STATE(3708)] = 87208,
  [SMALL_STATE(3709)] = 87219,
  [SMALL_STATE(3710)] = 87230,
  [SMALL_STATE(3711)] = 87241,
  [SMALL_STATE(3712)] = 87252,
  [SMALL_STATE(3713)] = 87263,
  [SMALL_STATE(3714)] = 87274,
  [SMALL_STATE(3715)] = 87285,
  [SMALL_STATE(3716)] = 87296,
  [SMALL_STATE(3717)] = 87307,
  [SMALL_STATE(3718)] = 87318,
  [SMALL_STATE(3719)] = 87329,
  [SMALL_STATE(3720)] = 87340,
  [SMALL_STATE(3721)] = 87351,
  [SMALL_STATE(3722)] = 87362,
  [SMALL_STATE(3723)] = 87373,
  [SMALL_STATE(3724)] = 87384,
  [SMALL_STATE(3725)] = 87395,
  [SMALL_STATE(3726)] = 87406,
  [SMALL_STATE(3727)] = 87417,
  [SMALL_STATE(3728)] = 87428,
  [SMALL_STATE(3729)] = 87439,
  [SMALL_STATE(3730)] = 87450,
  [SMALL_STATE(3731)] = 87461,
  [SMALL_STATE(3732)] = 87472,
  [SMALL_STATE(3733)] = 87483,
  [SMALL_STATE(3734)] = 87494,
  [SMALL_STATE(3735)] = 87505,
  [SMALL_STATE(3736)] = 87516,
  [SMALL_STATE(3737)] = 87527,
  [SMALL_STATE(3738)] = 87538,
  [SMALL_STATE(3739)] = 87549,
  [SMALL_STATE(3740)] = 87560,
  [SMALL_STATE(3741)] = 87571,
  [SMALL_STATE(3742)] = 87582,
  [SMALL_STATE(3743)] = 87593,
  [SMALL_STATE(3744)] = 87604,
  [SMALL_STATE(3745)] = 87615,
  [SMALL_STATE(3746)] = 87624,
  [SMALL_STATE(3747)] = 87635,
  [SMALL_STATE(3748)] = 87646,
  [SMALL_STATE(3749)] = 87657,
  [SMALL_STATE(3750)] = 87668,
  [SMALL_STATE(3751)] = 87679,
  [SMALL_STATE(3752)] = 87690,
  [SMALL_STATE(3753)] = 87701,
  [SMALL_STATE(3754)] = 87712,
  [SMALL_STATE(3755)] = 87723,
  [SMALL_STATE(3756)] = 87734,
  [SMALL_STATE(3757)] = 87745,
  [SMALL_STATE(3758)] = 87756,
  [SMALL_STATE(3759)] = 87767,
  [SMALL_STATE(3760)] = 87778,
  [SMALL_STATE(3761)] = 87789,
  [SMALL_STATE(3762)] = 87800,
  [SMALL_STATE(3763)] = 87811,
  [SMALL_STATE(3764)] = 87822,
  [SMALL_STATE(3765)] = 87833,
  [SMALL_STATE(3766)] = 87844,
  [SMALL_STATE(3767)] = 87855,
  [SMALL_STATE(3768)] = 87863,
  [SMALL_STATE(3769)] = 87871,
  [SMALL_STATE(3770)] = 87879,
  [SMALL_STATE(3771)] = 87887,
  [SMALL_STATE(3772)] = 87895,
  [SMALL_STATE(3773)] = 87903,
  [SMALL_STATE(3774)] = 87911,
  [SMALL_STATE(3775)] = 87919,
  [SMALL_STATE(3776)] = 87927,
  [SMALL_STATE(3777)] = 87935,
  [SMALL_STATE(3778)] = 87943,
  [SMALL_STATE(3779)] = 87951,
  [SMALL_STATE(3780)] = 87959,
  [SMALL_STATE(3781)] = 87967,
  [SMALL_STATE(3782)] = 87975,
  [SMALL_STATE(3783)] = 87983,
  [SMALL_STATE(3784)] = 87991,
  [SMALL_STATE(3785)] = 87999,
  [SMALL_STATE(3786)] = 88007,
  [SMALL_STATE(3787)] = 88015,
  [SMALL_STATE(3788)] = 88023,
  [SMALL_STATE(3789)] = 88031,
  [SMALL_STATE(3790)] = 88039,
  [SMALL_STATE(3791)] = 88047,
  [SMALL_STATE(3792)] = 88055,
  [SMALL_STATE(3793)] = 88063,
  [SMALL_STATE(3794)] = 88071,
  [SMALL_STATE(3795)] = 88079,
  [SMALL_STATE(3796)] = 88087,
  [SMALL_STATE(3797)] = 88095,
  [SMALL_STATE(3798)] = 88103,
  [SMALL_STATE(3799)] = 88111,
  [SMALL_STATE(3800)] = 88119,
  [SMALL_STATE(3801)] = 88127,
  [SMALL_STATE(3802)] = 88135,
  [SMALL_STATE(3803)] = 88143,
  [SMALL_STATE(3804)] = 88151,
  [SMALL_STATE(3805)] = 88159,
  [SMALL_STATE(3806)] = 88167,
  [SMALL_STATE(3807)] = 88175,
  [SMALL_STATE(3808)] = 88183,
  [SMALL_STATE(3809)] = 88191,
  [SMALL_STATE(3810)] = 88199,
  [SMALL_STATE(3811)] = 88207,
  [SMALL_STATE(3812)] = 88215,
  [SMALL_STATE(3813)] = 88223,
  [SMALL_STATE(3814)] = 88231,
  [SMALL_STATE(3815)] = 88239,
  [SMALL_STATE(3816)] = 88247,
  [SMALL_STATE(3817)] = 88255,
  [SMALL_STATE(3818)] = 88263,
  [SMALL_STATE(3819)] = 88271,
  [SMALL_STATE(3820)] = 88279,
  [SMALL_STATE(3821)] = 88287,
  [SMALL_STATE(3822)] = 88295,
  [SMALL_STATE(3823)] = 88303,
  [SMALL_STATE(3824)] = 88311,
  [SMALL_STATE(3825)] = 88319,
  [SMALL_STATE(3826)] = 88327,
  [SMALL_STATE(3827)] = 88335,
  [SMALL_STATE(3828)] = 88343,
  [SMALL_STATE(3829)] = 88351,
  [SMALL_STATE(3830)] = 88359,
  [SMALL_STATE(3831)] = 88367,
  [SMALL_STATE(3832)] = 88375,
  [SMALL_STATE(3833)] = 88383,
  [SMALL_STATE(3834)] = 88391,
  [SMALL_STATE(3835)] = 88399,
  [SMALL_STATE(3836)] = 88407,
  [SMALL_STATE(3837)] = 88415,
  [SMALL_STATE(3838)] = 88423,
  [SMALL_STATE(3839)] = 88431,
  [SMALL_STATE(3840)] = 88439,
  [SMALL_STATE(3841)] = 88447,
  [SMALL_STATE(3842)] = 88455,
  [SMALL_STATE(3843)] = 88463,
  [SMALL_STATE(3844)] = 88471,
  [SMALL_STATE(3845)] = 88479,
  [SMALL_STATE(3846)] = 88487,
  [SMALL_STATE(3847)] = 88495,
  [SMALL_STATE(3848)] = 88503,
  [SMALL_STATE(3849)] = 88511,
  [SMALL_STATE(3850)] = 88519,
  [SMALL_STATE(3851)] = 88527,
  [SMALL_STATE(3852)] = 88535,
  [SMALL_STATE(3853)] = 88543,
  [SMALL_STATE(3854)] = 88551,
  [SMALL_STATE(3855)] = 88559,
  [SMALL_STATE(3856)] = 88567,
  [SMALL_STATE(3857)] = 88575,
  [SMALL_STATE(3858)] = 88583,
  [SMALL_STATE(3859)] = 88591,
  [SMALL_STATE(3860)] = 88599,
  [SMALL_STATE(3861)] = 88607,
  [SMALL_STATE(3862)] = 88615,
  [SMALL_STATE(3863)] = 88623,
  [SMALL_STATE(3864)] = 88631,
  [SMALL_STATE(3865)] = 88639,
  [SMALL_STATE(3866)] = 88647,
  [SMALL_STATE(3867)] = 88655,
  [SMALL_STATE(3868)] = 88663,
  [SMALL_STATE(3869)] = 88671,
  [SMALL_STATE(3870)] = 88679,
  [SMALL_STATE(3871)] = 88687,
  [SMALL_STATE(3872)] = 88695,
  [SMALL_STATE(3873)] = 88703,
  [SMALL_STATE(3874)] = 88711,
  [SMALL_STATE(3875)] = 88719,
  [SMALL_STATE(3876)] = 88727,
  [SMALL_STATE(3877)] = 88735,
  [SMALL_STATE(3878)] = 88743,
  [SMALL_STATE(3879)] = 88751,
  [SMALL_STATE(3880)] = 88759,
  [SMALL_STATE(3881)] = 88767,
  [SMALL_STATE(3882)] = 88775,
  [SMALL_STATE(3883)] = 88783,
  [SMALL_STATE(3884)] = 88791,
  [SMALL_STATE(3885)] = 88799,
  [SMALL_STATE(3886)] = 88807,
  [SMALL_STATE(3887)] = 88815,
  [SMALL_STATE(3888)] = 88823,
  [SMALL_STATE(3889)] = 88831,
  [SMALL_STATE(3890)] = 88839,
  [SMALL_STATE(3891)] = 88847,
  [SMALL_STATE(3892)] = 88855,
  [SMALL_STATE(3893)] = 88863,
  [SMALL_STATE(3894)] = 88871,
  [SMALL_STATE(3895)] = 88879,
  [SMALL_STATE(3896)] = 88887,
  [SMALL_STATE(3897)] = 88895,
  [SMALL_STATE(3898)] = 88903,
  [SMALL_STATE(3899)] = 88911,
  [SMALL_STATE(3900)] = 88919,
  [SMALL_STATE(3901)] = 88927,
  [SMALL_STATE(3902)] = 88935,
  [SMALL_STATE(3903)] = 88943,
  [SMALL_STATE(3904)] = 88951,
  [SMALL_STATE(3905)] = 88959,
  [SMALL_STATE(3906)] = 88967,
  [SMALL_STATE(3907)] = 88975,
  [SMALL_STATE(3908)] = 88983,
  [SMALL_STATE(3909)] = 88991,
  [SMALL_STATE(3910)] = 88999,
  [SMALL_STATE(3911)] = 89007,
  [SMALL_STATE(3912)] = 89015,
  [SMALL_STATE(3913)] = 89023,
  [SMALL_STATE(3914)] = 89031,
  [SMALL_STATE(3915)] = 89039,
  [SMALL_STATE(3916)] = 89047,
  [SMALL_STATE(3917)] = 89055,
  [SMALL_STATE(3918)] = 89063,
  [SMALL_STATE(3919)] = 89071,
  [SMALL_STATE(3920)] = 89079,
  [SMALL_STATE(3921)] = 89087,
  [SMALL_STATE(3922)] = 89095,
  [SMALL_STATE(3923)] = 89103,
  [SMALL_STATE(3924)] = 89111,
  [SMALL_STATE(3925)] = 89119,
  [SMALL_STATE(3926)] = 89127,
  [SMALL_STATE(3927)] = 89135,
  [SMALL_STATE(3928)] = 89143,
  [SMALL_STATE(3929)] = 89151,
  [SMALL_STATE(3930)] = 89159,
  [SMALL_STATE(3931)] = 89167,
  [SMALL_STATE(3932)] = 89175,
  [SMALL_STATE(3933)] = 89183,
  [SMALL_STATE(3934)] = 89191,
  [SMALL_STATE(3935)] = 89199,
  [SMALL_STATE(3936)] = 89207,
  [SMALL_STATE(3937)] = 89215,
  [SMALL_STATE(3938)] = 89223,
  [SMALL_STATE(3939)] = 89231,
  [SMALL_STATE(3940)] = 89239,
  [SMALL_STATE(3941)] = 89247,
  [SMALL_STATE(3942)] = 89255,
  [SMALL_STATE(3943)] = 89263,
  [SMALL_STATE(3944)] = 89271,
  [SMALL_STATE(3945)] = 89279,
  [SMALL_STATE(3946)] = 89287,
  [SMALL_STATE(3947)] = 89295,
  [SMALL_STATE(3948)] = 89303,
  [SMALL_STATE(3949)] = 89311,
  [SMALL_STATE(3950)] = 89319,
  [SMALL_STATE(3951)] = 89327,
  [SMALL_STATE(3952)] = 89335,
  [SMALL_STATE(3953)] = 89343,
  [SMALL_STATE(3954)] = 89351,
  [SMALL_STATE(3955)] = 89359,
  [SMALL_STATE(3956)] = 89367,
  [SMALL_STATE(3957)] = 89375,
  [SMALL_STATE(3958)] = 89383,
  [SMALL_STATE(3959)] = 89391,
  [SMALL_STATE(3960)] = 89399,
  [SMALL_STATE(3961)] = 89407,
  [SMALL_STATE(3962)] = 89415,
  [SMALL_STATE(3963)] = 89423,
  [SMALL_STATE(3964)] = 89431,
  [SMALL_STATE(3965)] = 89439,
  [SMALL_STATE(3966)] = 89447,
  [SMALL_STATE(3967)] = 89455,
  [SMALL_STATE(3968)] = 89463,
  [SMALL_STATE(3969)] = 89471,
  [SMALL_STATE(3970)] = 89479,
  [SMALL_STATE(3971)] = 89487,
  [SMALL_STATE(3972)] = 89495,
  [SMALL_STATE(3973)] = 89503,
  [SMALL_STATE(3974)] = 89511,
  [SMALL_STATE(3975)] = 89519,
  [SMALL_STATE(3976)] = 89527,
  [SMALL_STATE(3977)] = 89535,
  [SMALL_STATE(3978)] = 89543,
  [SMALL_STATE(3979)] = 89551,
  [SMALL_STATE(3980)] = 89559,
  [SMALL_STATE(3981)] = 89567,
  [SMALL_STATE(3982)] = 89575,
  [SMALL_STATE(3983)] = 89583,
  [SMALL_STATE(3984)] = 89591,
  [SMALL_STATE(3985)] = 89599,
  [SMALL_STATE(3986)] = 89607,
  [SMALL_STATE(3987)] = 89615,
  [SMALL_STATE(3988)] = 89623,
  [SMALL_STATE(3989)] = 89631,
  [SMALL_STATE(3990)] = 89639,
  [SMALL_STATE(3991)] = 89647,
  [SMALL_STATE(3992)] = 89655,
  [SMALL_STATE(3993)] = 89663,
  [SMALL_STATE(3994)] = 89671,
  [SMALL_STATE(3995)] = 89679,
  [SMALL_STATE(3996)] = 89687,
  [SMALL_STATE(3997)] = 89695,
  [SMALL_STATE(3998)] = 89703,
  [SMALL_STATE(3999)] = 89711,
  [SMALL_STATE(4000)] = 89719,
  [SMALL_STATE(4001)] = 89727,
  [SMALL_STATE(4002)] = 89735,
  [SMALL_STATE(4003)] = 89743,
  [SMALL_STATE(4004)] = 89751,
  [SMALL_STATE(4005)] = 89759,
  [SMALL_STATE(4006)] = 89767,
  [SMALL_STATE(4007)] = 89775,
  [SMALL_STATE(4008)] = 89783,
  [SMALL_STATE(4009)] = 89791,
  [SMALL_STATE(4010)] = 89799,
  [SMALL_STATE(4011)] = 89807,
  [SMALL_STATE(4012)] = 89815,
  [SMALL_STATE(4013)] = 89823,
  [SMALL_STATE(4014)] = 89831,
  [SMALL_STATE(4015)] = 89839,
  [SMALL_STATE(4016)] = 89847,
  [SMALL_STATE(4017)] = 89855,
  [SMALL_STATE(4018)] = 89863,
  [SMALL_STATE(4019)] = 89871,
  [SMALL_STATE(4020)] = 89879,
  [SMALL_STATE(4021)] = 89887,
  [SMALL_STATE(4022)] = 89895,
  [SMALL_STATE(4023)] = 89903,
  [SMALL_STATE(4024)] = 89911,
  [SMALL_STATE(4025)] = 89919,
  [SMALL_STATE(4026)] = 89927,
  [SMALL_STATE(4027)] = 89935,
  [SMALL_STATE(4028)] = 89943,
  [SMALL_STATE(4029)] = 89951,
  [SMALL_STATE(4030)] = 89959,
  [SMALL_STATE(4031)] = 89967,
  [SMALL_STATE(4032)] = 89975,
  [SMALL_STATE(4033)] = 89983,
  [SMALL_STATE(4034)] = 89991,
  [SMALL_STATE(4035)] = 89999,
  [SMALL_STATE(4036)] = 90007,
  [SMALL_STATE(4037)] = 90015,
  [SMALL_STATE(4038)] = 90023,
  [SMALL_STATE(4039)] = 90031,
  [SMALL_STATE(4040)] = 90039,
  [SMALL_STATE(4041)] = 90047,
  [SMALL_STATE(4042)] = 90055,
  [SMALL_STATE(4043)] = 90063,
  [SMALL_STATE(4044)] = 90071,
  [SMALL_STATE(4045)] = 90079,
  [SMALL_STATE(4046)] = 90087,
  [SMALL_STATE(4047)] = 90095,
  [SMALL_STATE(4048)] = 90103,
  [SMALL_STATE(4049)] = 90111,
  [SMALL_STATE(4050)] = 90119,
  [SMALL_STATE(4051)] = 90127,
  [SMALL_STATE(4052)] = 90135,
  [SMALL_STATE(4053)] = 90143,
  [SMALL_STATE(4054)] = 90151,
  [SMALL_STATE(4055)] = 90159,
  [SMALL_STATE(4056)] = 90167,
  [SMALL_STATE(4057)] = 90175,
  [SMALL_STATE(4058)] = 90183,
  [SMALL_STATE(4059)] = 90191,
  [SMALL_STATE(4060)] = 90199,
  [SMALL_STATE(4061)] = 90207,
  [SMALL_STATE(4062)] = 90215,
  [SMALL_STATE(4063)] = 90223,
  [SMALL_STATE(4064)] = 90231,
  [SMALL_STATE(4065)] = 90239,
  [SMALL_STATE(4066)] = 90247,
  [SMALL_STATE(4067)] = 90255,
  [SMALL_STATE(4068)] = 90263,
  [SMALL_STATE(4069)] = 90271,
  [SMALL_STATE(4070)] = 90279,
  [SMALL_STATE(4071)] = 90287,
  [SMALL_STATE(4072)] = 90295,
  [SMALL_STATE(4073)] = 90303,
  [SMALL_STATE(4074)] = 90311,
  [SMALL_STATE(4075)] = 90319,
  [SMALL_STATE(4076)] = 90327,
  [SMALL_STATE(4077)] = 90335,
  [SMALL_STATE(4078)] = 90343,
  [SMALL_STATE(4079)] = 90351,
  [SMALL_STATE(4080)] = 90359,
  [SMALL_STATE(4081)] = 90367,
  [SMALL_STATE(4082)] = 90375,
  [SMALL_STATE(4083)] = 90383,
  [SMALL_STATE(4084)] = 90391,
  [SMALL_STATE(4085)] = 90399,
  [SMALL_STATE(4086)] = 90407,
  [SMALL_STATE(4087)] = 90415,
  [SMALL_STATE(4088)] = 90423,
  [SMALL_STATE(4089)] = 90431,
  [SMALL_STATE(4090)] = 90439,
  [SMALL_STATE(4091)] = 90447,
  [SMALL_STATE(4092)] = 90455,
  [SMALL_STATE(4093)] = 90463,
  [SMALL_STATE(4094)] = 90471,
  [SMALL_STATE(4095)] = 90479,
  [SMALL_STATE(4096)] = 90487,
  [SMALL_STATE(4097)] = 90495,
  [SMALL_STATE(4098)] = 90503,
  [SMALL_STATE(4099)] = 90511,
  [SMALL_STATE(4100)] = 90519,
  [SMALL_STATE(4101)] = 90527,
  [SMALL_STATE(4102)] = 90535,
  [SMALL_STATE(4103)] = 90543,
  [SMALL_STATE(4104)] = 90551,
  [SMALL_STATE(4105)] = 90559,
  [SMALL_STATE(4106)] = 90567,
  [SMALL_STATE(4107)] = 90575,
  [SMALL_STATE(4108)] = 90583,
  [SMALL_STATE(4109)] = 90591,
  [SMALL_STATE(4110)] = 90599,
  [SMALL_STATE(4111)] = 90607,
  [SMALL_STATE(4112)] = 90615,
  [SMALL_STATE(4113)] = 90623,
  [SMALL_STATE(4114)] = 90631,
  [SMALL_STATE(4115)] = 90639,
  [SMALL_STATE(4116)] = 90647,
  [SMALL_STATE(4117)] = 90655,
  [SMALL_STATE(4118)] = 90663,
  [SMALL_STATE(4119)] = 90671,
  [SMALL_STATE(4120)] = 90679,
  [SMALL_STATE(4121)] = 90687,
  [SMALL_STATE(4122)] = 90695,
  [SMALL_STATE(4123)] = 90703,
  [SMALL_STATE(4124)] = 90711,
  [SMALL_STATE(4125)] = 90719,
  [SMALL_STATE(4126)] = 90727,
  [SMALL_STATE(4127)] = 90735,
  [SMALL_STATE(4128)] = 90743,
  [SMALL_STATE(4129)] = 90751,
  [SMALL_STATE(4130)] = 90759,
  [SMALL_STATE(4131)] = 90767,
  [SMALL_STATE(4132)] = 90775,
  [SMALL_STATE(4133)] = 90783,
  [SMALL_STATE(4134)] = 90791,
  [SMALL_STATE(4135)] = 90799,
  [SMALL_STATE(4136)] = 90807,
  [SMALL_STATE(4137)] = 90815,
  [SMALL_STATE(4138)] = 90823,
  [SMALL_STATE(4139)] = 90831,
  [SMALL_STATE(4140)] = 90839,
  [SMALL_STATE(4141)] = 90847,
  [SMALL_STATE(4142)] = 90855,
  [SMALL_STATE(4143)] = 90863,
  [SMALL_STATE(4144)] = 90871,
  [SMALL_STATE(4145)] = 90879,
  [SMALL_STATE(4146)] = 90887,
  [SMALL_STATE(4147)] = 90895,
  [SMALL_STATE(4148)] = 90903,
  [SMALL_STATE(4149)] = 90911,
  [SMALL_STATE(4150)] = 90919,
  [SMALL_STATE(4151)] = 90927,
  [SMALL_STATE(4152)] = 90935,
  [SMALL_STATE(4153)] = 90943,
  [SMALL_STATE(4154)] = 90951,
  [SMALL_STATE(4155)] = 90959,
  [SMALL_STATE(4156)] = 90967,
  [SMALL_STATE(4157)] = 90975,
  [SMALL_STATE(4158)] = 90983,
  [SMALL_STATE(4159)] = 90991,
  [SMALL_STATE(4160)] = 90999,
  [SMALL_STATE(4161)] = 91007,
  [SMALL_STATE(4162)] = 91015,
  [SMALL_STATE(4163)] = 91023,
  [SMALL_STATE(4164)] = 91031,
  [SMALL_STATE(4165)] = 91039,
  [SMALL_STATE(4166)] = 91047,
  [SMALL_STATE(4167)] = 91055,
  [SMALL_STATE(4168)] = 91063,
  [SMALL_STATE(4169)] = 91071,
  [SMALL_STATE(4170)] = 91079,
  [SMALL_STATE(4171)] = 91087,
  [SMALL_STATE(4172)] = 91095,
  [SMALL_STATE(4173)] = 91103,
  [SMALL_STATE(4174)] = 91111,
  [SMALL_STATE(4175)] = 91119,
  [SMALL_STATE(4176)] = 91127,
  [SMALL_STATE(4177)] = 91135,
  [SMALL_STATE(4178)] = 91143,
  [SMALL_STATE(4179)] = 91151,
  [SMALL_STATE(4180)] = 91159,
  [SMALL_STATE(4181)] = 91167,
  [SMALL_STATE(4182)] = 91175,
  [SMALL_STATE(4183)] = 91183,
  [SMALL_STATE(4184)] = 91191,
  [SMALL_STATE(4185)] = 91199,
  [SMALL_STATE(4186)] = 91207,
  [SMALL_STATE(4187)] = 91215,
  [SMALL_STATE(4188)] = 91223,
  [SMALL_STATE(4189)] = 91231,
  [SMALL_STATE(4190)] = 91239,
  [SMALL_STATE(4191)] = 91247,
  [SMALL_STATE(4192)] = 91255,
  [SMALL_STATE(4193)] = 91263,
  [SMALL_STATE(4194)] = 91271,
  [SMALL_STATE(4195)] = 91279,
  [SMALL_STATE(4196)] = 91287,
  [SMALL_STATE(4197)] = 91295,
  [SMALL_STATE(4198)] = 91303,
  [SMALL_STATE(4199)] = 91311,
  [SMALL_STATE(4200)] = 91319,
  [SMALL_STATE(4201)] = 91327,
  [SMALL_STATE(4202)] = 91335,
  [SMALL_STATE(4203)] = 91343,
  [SMALL_STATE(4204)] = 91351,
  [SMALL_STATE(4205)] = 91359,
  [SMALL_STATE(4206)] = 91367,
  [SMALL_STATE(4207)] = 91375,
  [SMALL_STATE(4208)] = 91383,
  [SMALL_STATE(4209)] = 91391,
  [SMALL_STATE(4210)] = 91399,
  [SMALL_STATE(4211)] = 91407,
  [SMALL_STATE(4212)] = 91415,
  [SMALL_STATE(4213)] = 91423,
  [SMALL_STATE(4214)] = 91431,
  [SMALL_STATE(4215)] = 91439,
  [SMALL_STATE(4216)] = 91447,
  [SMALL_STATE(4217)] = 91455,
  [SMALL_STATE(4218)] = 91463,
  [SMALL_STATE(4219)] = 91471,
  [SMALL_STATE(4220)] = 91479,
  [SMALL_STATE(4221)] = 91487,
  [SMALL_STATE(4222)] = 91495,
  [SMALL_STATE(4223)] = 91503,
  [SMALL_STATE(4224)] = 91511,
  [SMALL_STATE(4225)] = 91519,
  [SMALL_STATE(4226)] = 91527,
  [SMALL_STATE(4227)] = 91535,
  [SMALL_STATE(4228)] = 91543,
  [SMALL_STATE(4229)] = 91551,
  [SMALL_STATE(4230)] = 91559,
  [SMALL_STATE(4231)] = 91567,
  [SMALL_STATE(4232)] = 91575,
  [SMALL_STATE(4233)] = 91583,
  [SMALL_STATE(4234)] = 91591,
  [SMALL_STATE(4235)] = 91599,
  [SMALL_STATE(4236)] = 91607,
  [SMALL_STATE(4237)] = 91615,
  [SMALL_STATE(4238)] = 91623,
  [SMALL_STATE(4239)] = 91631,
  [SMALL_STATE(4240)] = 91639,
  [SMALL_STATE(4241)] = 91647,
  [SMALL_STATE(4242)] = 91655,
  [SMALL_STATE(4243)] = 91663,
  [SMALL_STATE(4244)] = 91671,
  [SMALL_STATE(4245)] = 91679,
  [SMALL_STATE(4246)] = 91687,
  [SMALL_STATE(4247)] = 91695,
  [SMALL_STATE(4248)] = 91703,
  [SMALL_STATE(4249)] = 91711,
  [SMALL_STATE(4250)] = 91719,
  [SMALL_STATE(4251)] = 91727,
  [SMALL_STATE(4252)] = 91735,
  [SMALL_STATE(4253)] = 91743,
  [SMALL_STATE(4254)] = 91751,
  [SMALL_STATE(4255)] = 91759,
  [SMALL_STATE(4256)] = 91767,
  [SMALL_STATE(4257)] = 91775,
  [SMALL_STATE(4258)] = 91783,
  [SMALL_STATE(4259)] = 91791,
  [SMALL_STATE(4260)] = 91799,
  [SMALL_STATE(4261)] = 91807,
  [SMALL_STATE(4262)] = 91815,
  [SMALL_STATE(4263)] = 91823,
  [SMALL_STATE(4264)] = 91831,
  [SMALL_STATE(4265)] = 91839,
  [SMALL_STATE(4266)] = 91847,
  [SMALL_STATE(4267)] = 91855,
  [SMALL_STATE(4268)] = 91863,
  [SMALL_STATE(4269)] = 91871,
  [SMALL_STATE(4270)] = 91879,
  [SMALL_STATE(4271)] = 91887,
  [SMALL_STATE(4272)] = 91895,
  [SMALL_STATE(4273)] = 91903,
  [SMALL_STATE(4274)] = 91911,
  [SMALL_STATE(4275)] = 91919,
  [SMALL_STATE(4276)] = 91927,
  [SMALL_STATE(4277)] = 91935,
  [SMALL_STATE(4278)] = 91943,
  [SMALL_STATE(4279)] = 91951,
  [SMALL_STATE(4280)] = 91959,
  [SMALL_STATE(4281)] = 91967,
  [SMALL_STATE(4282)] = 91975,
  [SMALL_STATE(4283)] = 91983,
  [SMALL_STATE(4284)] = 91991,
  [SMALL_STATE(4285)] = 91999,
  [SMALL_STATE(4286)] = 92007,
  [SMALL_STATE(4287)] = 92015,
  [SMALL_STATE(4288)] = 92023,
  [SMALL_STATE(4289)] = 92031,
  [SMALL_STATE(4290)] = 92039,
  [SMALL_STATE(4291)] = 92047,
  [SMALL_STATE(4292)] = 92055,
  [SMALL_STATE(4293)] = 92063,
  [SMALL_STATE(4294)] = 92071,
  [SMALL_STATE(4295)] = 92079,
  [SMALL_STATE(4296)] = 92087,
  [SMALL_STATE(4297)] = 92095,
  [SMALL_STATE(4298)] = 92103,
  [SMALL_STATE(4299)] = 92111,
  [SMALL_STATE(4300)] = 92119,
  [SMALL_STATE(4301)] = 92127,
  [SMALL_STATE(4302)] = 92135,
  [SMALL_STATE(4303)] = 92143,
  [SMALL_STATE(4304)] = 92151,
  [SMALL_STATE(4305)] = 92159,
  [SMALL_STATE(4306)] = 92167,
  [SMALL_STATE(4307)] = 92175,
  [SMALL_STATE(4308)] = 92183,
  [SMALL_STATE(4309)] = 92191,
  [SMALL_STATE(4310)] = 92199,
  [SMALL_STATE(4311)] = 92207,
  [SMALL_STATE(4312)] = 92215,
  [SMALL_STATE(4313)] = 92223,
  [SMALL_STATE(4314)] = 92231,
  [SMALL_STATE(4315)] = 92239,
  [SMALL_STATE(4316)] = 92247,
  [SMALL_STATE(4317)] = 92255,
  [SMALL_STATE(4318)] = 92263,
  [SMALL_STATE(4319)] = 92271,
  [SMALL_STATE(4320)] = 92279,
  [SMALL_STATE(4321)] = 92287,
  [SMALL_STATE(4322)] = 92295,
  [SMALL_STATE(4323)] = 92303,
  [SMALL_STATE(4324)] = 92311,
  [SMALL_STATE(4325)] = 92319,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4284),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4283),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4281),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2753),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2123),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3633),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3647),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4219),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [79] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [85] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3644),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_expression, 1),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4323),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4306),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4129),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3712),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_expression, 1),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_argument_list, 1),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_argument_list, 1),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(814),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3110),
  [203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4305),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4323),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(885),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4306),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4128),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4129),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2751),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(93),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(687),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(107),
  [235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2962),
  [238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(686),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1081),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(8),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3712),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3762),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(317),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3034),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4022),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(20),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(367),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3710),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(183),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(672),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2744),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(910),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(875),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(10),
  [289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(918),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2),
  [294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2787),
  [297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2786),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3102),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4315),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4325),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4316),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4188),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4189),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2755),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3680),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3627),
  [394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2912),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1823),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2370),
  [472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4275),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4319),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3886),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3887),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2955),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3629),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4253),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2741),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3174),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4321),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4296),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3741),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4290),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4320),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3617),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2915),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1942),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4300),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4322),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3727),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3734),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4062),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(816),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3102),
  [766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4315),
  [769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4325),
  [772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1101),
  [775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4316),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4188),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4189),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2755),
  [787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(94),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(645),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(150),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3038),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(643),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1415),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(32),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3680),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3627),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(260),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2912),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3836),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(44),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(338),
  [829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3679),
  [832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(189),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(564),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2739),
  [841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1220),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1220),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1100),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(25),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1264),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2776),
  [859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2833),
  [862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 2, .production_id = 5),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4310),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4324),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4311),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4159),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(869),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3181),
  [946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4290),
  [949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4320),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1394),
  [955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4291),
  [958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4035),
  [961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4036),
  [964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2759),
  [967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(90),
  [970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(671),
  [973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(113),
  [976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3004),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(676),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1855),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(58),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3764),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3617),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(253),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2915),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4237),
  [1003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(64),
  [1006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(332),
  [1009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3766),
  [1012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(188),
  [1015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(685),
  [1018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2746),
  [1021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1459),
  [1024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1459),
  [1027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1395),
  [1030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(62),
  [1033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1491),
  [1036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1491),
  [1039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2828),
  [1042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2830),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(857),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3174),
  [1059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4295),
  [1062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4321),
  [1065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1421),
  [1068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4296),
  [1071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4068),
  [1074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4069),
  [1077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2750),
  [1080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(92),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(734),
  [1086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(112),
  [1089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2940),
  [1092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(749),
  [1095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1713),
  [1098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(54),
  [1101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3744),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3695),
  [1107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(301),
  [1110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2937),
  [1113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4172),
  [1116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(77),
  [1119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(353),
  [1122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3741),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(186),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(733),
  [1131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2740),
  [1134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1490),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1416),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(53),
  [1143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1526),
  [1146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2846),
  [1149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2777),
  [1152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(849),
  [1155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3250),
  [1158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4275),
  [1161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4319),
  [1164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1387),
  [1167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4276),
  [1170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3886),
  [1173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3887),
  [1176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2758),
  [1179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(88),
  [1182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(801),
  [1185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(104),
  [1188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2955),
  [1191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(804),
  [1194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1554),
  [1197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(56),
  [1200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3642),
  [1203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3629),
  [1206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(235),
  [1209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3027),
  [1212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(4253),
  [1215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(68),
  [1218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(347),
  [1221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(3646),
  [1224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(184),
  [1227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(731),
  [1230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2741),
  [1233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1433),
  [1236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1400),
  [1239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(61),
  [1242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(1460),
  [1245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2783),
  [1248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(2784),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(874),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(81),
  [1263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(792),
  [1266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(66),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1820),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(930),
  [1314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(84),
  [1317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(708),
  [1320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(83),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [1389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2564),
  [1427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 2),
  [1429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 2),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1847),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [1459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2529),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2493),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2394),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 3),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 3),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2537),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [1625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2363),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 1),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2489),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1781),
  [1675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 3, .production_id = 5),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 1),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2075),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1840),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1818),
  [1805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 1),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2488),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2490),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2416),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2387),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1563),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [1909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1791),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1623),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1891),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1773),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1630),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1634),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1678),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2120),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1849),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2580),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [2071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_row, 1),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [2087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2), SHIFT_REPEAT(84),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 3),
  [2466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 3),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [2480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_broadcast_call_expression, 4),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_broadcast_call_expression, 4),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, .production_id = 28),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, .production_id = 28),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [2498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 7, .production_id = 27),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 7, .production_id = 27),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3),
  [2504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3),
  [2506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, .production_id = 26),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, .production_id = 26),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, .production_id = 27),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, .production_id = 27),
  [2518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, .production_id = 25),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, .production_id = 25),
  [2522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, .production_id = 22),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, .production_id = 22),
  [2526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 8, .production_id = 28),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 8, .production_id = 28),
  [2530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 16),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 16),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 7, .production_id = 25),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 7, .production_id = 25),
  [2538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 26),
  [2540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 26),
  [2542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 7, .production_id = 26),
  [2544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 7, .production_id = 26),
  [2546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 25),
  [2548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 25),
  [2550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 22),
  [2552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 22),
  [2554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 7, .production_id = 28),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 7, .production_id = 28),
  [2558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 16),
  [2560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 16),
  [2562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 8, .production_id = 27),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 8, .production_id = 27),
  [2566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [2570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 22),
  [2572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 22),
  [2574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, .production_id = 16),
  [2576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, .production_id = 16),
  [2578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [2580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [2582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [2584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [2586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 2),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 2),
  [2590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [2592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 4),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 4),
  [2596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 3),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 3),
  [2600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [2612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5),
  [2616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 5),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 5),
  [2620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 4),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 4),
  [2624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_broadcast_call_expression, 5),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_broadcast_call_expression, 5),
  [2628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 5),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 5),
  [2632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 3),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 3),
  [2636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 6),
  [2638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 6),
  [2640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [2642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [2648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 2),
  [2650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [2652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [2654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2),
  [2658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 3),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 3),
  [2662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3),
  [2664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3),
  [2666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3),
  [2668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3),
  [2670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 3),
  [2676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 3),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4),
  [2682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4),
  [2686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_comprehension_expression, 4),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_comprehension_expression, 4),
  [2690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2),
  [2692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [2702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [2704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [2712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameterized_identifier, 2),
  [2714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameterized_identifier, 2),
  [2716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 4),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 4),
  [2720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5),
  [2722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [2734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3),
  [2738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 2),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 2),
  [2742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [2744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_statement_repeat1, 2),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [2750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_literal, 1),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_literal, 1),
  [2754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3),
  [2756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3),
  [2758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 3, .production_id = 6),
  [2760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 3, .production_id = 6),
  [2762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_identifier, 2, .production_id = 3),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_identifier, 2, .production_id = 3),
  [2766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_statement, 3),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [2770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_statement, 3),
  [2772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2),
  [2774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(716),
  [2777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2),
  [2779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 3, .production_id = 6),
  [2781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 3, .production_id = 6),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 4, .production_id = 6),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 4, .production_id = 6),
  [2787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 4, .production_id = 6),
  [2789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 4, .production_id = 6),
  [2791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_literal, 3),
  [2793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_literal, 3),
  [2795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [2797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3997),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [2801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_literal, 2),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_literal, 2),
  [2805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [2807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [2811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bare_tuple_expression, 2),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bare_tuple_expression, 2),
  [2817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [2819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(3997),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [2824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2934),
  [2827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selected_import, 3),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selected_import, 3),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2),
  [2837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 3),
  [2839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [2845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 3),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [2879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [2881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [2883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 3),
  [2885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_statement, 2),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_statement, 2),
  [2889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_selected_import_repeat1, 2),
  [2891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3188),
  [2894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_selected_import_repeat1, 2),
  [2896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [2898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [2900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_literal, 3),
  [2906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_literal, 3),
  [2908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selected_import, 4),
  [2910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selected_import, 4),
  [2912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_identifier, 2),
  [2914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_identifier, 2),
  [2916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2),
  [2918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3739),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2),
  [2923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 5),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 5),
  [2927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 5, .production_id = 13),
  [2929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 5, .production_id = 13),
  [2931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 5),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 5),
  [2935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [2937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [2939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 14),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 14),
  [2943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 15),
  [2945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 15),
  [2947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5),
  [2951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3),
  [2955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5),
  [2957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5),
  [2959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_expression, 3),
  [2961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_expression, 3),
  [2963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 5),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 5),
  [2967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 3, .production_id = 4),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 3, .production_id = 4),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 3, .production_id = 4),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 3, .production_id = 4),
  [2975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 5),
  [2977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 5),
  [2979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3),
  [2983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 3),
  [2985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 3),
  [2987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 11),
  [2989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 11),
  [2991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 6, .production_id = 12),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 6, .production_id = 12),
  [2995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pair_expression, 3),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair_expression, 3),
  [2999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 6, .production_id = 18),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 6, .production_id = 18),
  [3003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 6, .production_id = 19),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 6, .production_id = 19),
  [3007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, .production_id = 12),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, .production_id = 12),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, .production_id = 8),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, .production_id = 8),
  [3017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_expression, 2),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_expression, 2),
  [3021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, .production_id = 9),
  [3023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, .production_id = 9),
  [3025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 20),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 20),
  [3029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 21),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 21),
  [3033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6),
  [3035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6),
  [3037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 6),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 6),
  [3041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, .production_id = 7),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, .production_id = 7),
  [3045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, .production_id = 4),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, .production_id = 4),
  [3051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 7, .production_id = 23),
  [3053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 7, .production_id = 23),
  [3055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 7, .production_id = 12),
  [3057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 7, .production_id = 12),
  [3059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, .production_id = 9),
  [3061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, .production_id = 9),
  [3063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 5),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 5),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 24),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 24),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, .production_id = 12),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, .production_id = 12),
  [3075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 3),
  [3077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 3),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [3081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, .production_id = 8),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, .production_id = 8),
  [3085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 5, .production_id = 8),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 5, .production_id = 8),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 5, .production_id = 12),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 5, .production_id = 12),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 11),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 11),
  [3097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_spread_expression, 2),
  [3099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_expression, 2),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 1),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 1),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_coefficient_expression, 2),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_coefficient_expression, 2),
  [3109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 7),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 7),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation_expression, 2),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_expression, 2),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5),
  [3119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3),
  [3121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5),
  [3123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 3),
  [3125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 3),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_expression, 2),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_expression, 2),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 4),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 4),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_expression, 3),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_expression, 3),
  [3139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 5),
  [3141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 5),
  [3143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4),
  [3145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4),
  [3147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 2),
  [3149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 2),
  [3151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4),
  [3153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4),
  [3155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 10),
  [3157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 10),
  [3159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 1),
  [3161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 1),
  [3163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 5),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 5),
  [3167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2),
  [3169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2),
  [3171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, .production_id = 7),
  [3173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, .production_id = 7),
  [3175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 4, .production_id = 4),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 4, .production_id = 4),
  [3179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 4, .production_id = 9),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, .production_id = 9),
  [3183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 4, .production_id = 4),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, .production_id = 4),
  [3187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_coefficient_expression, 2, .production_id = 2),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_coefficient_expression, 2, .production_id = 2),
  [3191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3),
  [3193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 3),
  [3195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 3),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [3199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 4, .production_id = 8),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, .production_id = 8),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 1),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [3211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 1),
  [3213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 4, .production_id = 8),
  [3215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 4, .production_id = 8),
  [3217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_expression, 4),
  [3219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 4),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3585),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [3227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, .production_id = 7),
  [3229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, .production_id = 7),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [3237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(751),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [3244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [3256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [3260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [3262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3723),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [3284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [3286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [3288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3521),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4271),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4216),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3638),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [3333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(3856),
  [3336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2931),
  [3339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3609),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [3348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1848),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1835),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1709),
  [3358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [3362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [3368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [3370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [3374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [3376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [3378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [3380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [3382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [3384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [3386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [3388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [3390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [3392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [3396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [3398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [3400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3639),
  [3404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4270),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [3408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2987),
  [3411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(4270),
  [3414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(576),
  [3417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [3421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [3423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [3425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [3429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [3437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [3443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [3447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [3455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3519),
  [3458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [3460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3693),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [3507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3639),
  [3510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2993),
  [3513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(4215),
  [3516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(784),
  [3519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3284),
  [3522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [3524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3693),
  [3526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4137),
  [3528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4092),
  [3530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(656),
  [3533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3665),
  [3536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3180),
  [3538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2997),
  [3541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(4137),
  [3544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3180),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [3587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [3593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [3595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [3597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [3599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_binding, 3),
  [3601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_binding, 3),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [3605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [3621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subtype_clause, 2),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subtype_clause, 2),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2913),
  [3642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [3644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3736),
  [3647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 3),
  [3649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3),
  [3651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 4),
  [3653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4),
  [3655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 5),
  [3657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5),
  [3659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [3661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [3663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [3665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [3673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), SHIFT(2989),
  [3676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), SHIFT(4008),
  [3679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), SHIFT(3005),
  [3682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), SHIFT(565),
  [3685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), SHIFT(3104),
  [3688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), SHIFT(2011),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [3705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [3707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [3713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [3723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [3725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [3737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [3739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [3741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3983),
  [3743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [3751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [3755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [3757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2910),
  [3760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3982),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3524),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(379),
  [3769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1), SHIFT(791),
  [3772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(3982),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [3777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4064),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [3785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [3787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [3789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [3793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [3797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [3807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [3809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [3813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [3821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(592),
  [3824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [3826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3610),
  [3829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 1),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [3833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [3837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3610),
  [3839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [3841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [3847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(809),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3293),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3924),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [3864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3614),
  [3867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [3873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [3877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [3893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [3895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [3899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [3901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [3903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [3907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [3913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [3915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2),
  [3917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2),
  [3919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [3921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [3923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [3925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [3929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [3931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [3933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2957),
  [3936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(4063),
  [3939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [3941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3085),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [3952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(670),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [3957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3676),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [3962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_selected_import_repeat1, 2), SHIFT_REPEAT(3355),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [3971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [3975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [3997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [4001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [4005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(3923),
  [4008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_statement_repeat1, 2), SHIFT_REPEAT(2960),
  [4011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [4013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 1),
  [4015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [4017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [4019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [4021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [4023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [4025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [4027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [4029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [4031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [4033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [4035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [4037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [4039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [4041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [4043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [4045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [4047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [4097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [4099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2), SHIFT_REPEAT(3615),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3615),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [4118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [4122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [4124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [4128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [4130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_bare_tuple_expression_repeat1, 2), SHIFT_REPEAT(752),
  [4133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [4139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [4141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2412),
  [4143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [4145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [4173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [4177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [4181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [4183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [4185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [4187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [4189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [4245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [4255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [4295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter, 3),
  [4297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_optional_parameter, 3), REDUCE(sym_named_field, 3),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [4308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field, 3),
  [4316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_parameter, 3, .production_id = 17),
  [4324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_expression_repeat1, 2),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [4328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [4336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [4338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [4348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [4354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [4360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [4384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [4390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [4402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2118),
  [4404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2527),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2486),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2420),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [4444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [4464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2), SHIFT_REPEAT(432),
  [4467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2), SHIFT_REPEAT(432),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [4484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clause, 2),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2),
  [4490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2), SHIFT_REPEAT(795),
  [4493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2), SHIFT_REPEAT(2963),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clause, 1),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [4514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [4516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameters, 2),
  [4520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [4576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [4588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(3686),
  [4591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(2804),
  [4594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [4598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3),
  [4600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [4604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [4606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [4618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [4642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(3755),
  [4645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(2827),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [4658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [4686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2996),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [4697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [4769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [4771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(583),
  [4774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [4794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2), SHIFT_REPEAT(2902),
  [4797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [4823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2), SHIFT_REPEAT(2909),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [4850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(2989),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [4871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 2),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [4921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(529),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [4968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 4),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [5134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [5196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2), SHIFT_REPEAT(399),
  [5199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2), SHIFT_REPEAT(399),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [5312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_expression_repeat1, 2), SHIFT_REPEAT(460),
  [5315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_expression_repeat1, 2),
  [5317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [5319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [5321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [5329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [5331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [5333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 2),
  [5335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [5343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [5345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [5347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [5349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [5703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_parameters, 3),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [5739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [5741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [5743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [5753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [5755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [5763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [5769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [5771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [5793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [5829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [5835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [5839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [5841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(541),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [5870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [5978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 3, .production_id = 5),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [6140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat2, 2), SHIFT_REPEAT(3608),
  [6143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat2, 2),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [6149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [6157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [6167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [6171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [6177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [6185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [6195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [6197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 16),
  [6199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [6213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [6215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [6223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [6225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [6229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_expression_repeat1, 2), SHIFT_REPEAT(699),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [6262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 4, .production_id = 5),
  [6264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, .production_id = 5),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [6286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [6332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2), SHIFT_REPEAT(3725),
  [6335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2),
  [6337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [6339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2), SHIFT_REPEAT(754),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [6396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat2, 2, .production_id = 16),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [6416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [6426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [6434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4297),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [6452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [6470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [6482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4014),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [6500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4079),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4157),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [6516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [6538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4229),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [6552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [6584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [6588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [6694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [6736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [6900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [6954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [7024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [7230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [7236] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_julia_external_scanner_create(void);
void tree_sitter_julia_external_scanner_destroy(void *);
bool tree_sitter_julia_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_julia_external_scanner_serialize(void *, char *);
void tree_sitter_julia_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_julia(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_julia_external_scanner_create,
      tree_sitter_julia_external_scanner_destroy,
      tree_sitter_julia_external_scanner_scan,
      tree_sitter_julia_external_scanner_serialize,
      tree_sitter_julia_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
